var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 119936;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 119976;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(120803);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,83,105,110,103,108,101,80,104,97,115,101,46,109,111,0,0,96,3,0,0,175,1,0,0,7,0,0,0,175,1,0,0,116,0,0,0,0,0,0,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,46,77,117,108,116,105,80,104,97,115,101,46,69,120,97,109,112,108,101,115,46,66,97,108,97,110,99,105,110,103,83,116,97,114,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,69,108,101,99,116,114,105,99,97,108,46,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,46,77,117,108,116,105,80,104,97,115,101,46,69,120,97,109,112,108,101,115,46,66,97,108,97,110,99,105,110,103,83,116,97,114,95,105,110,102,111,46,120,109,108,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,0,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,50,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,0,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,51,93,46,112,105,110,95,112,46,114,101,102,101,114,101,110,99,101,46,103,97,109,109,97,0,0,0,0,56,7,0,0,112,7,0,0,168,7,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,19,0,0,0,102,32,42,32,82,32,42,32,49,48,46,56,56,50,55,57,54,49,56,53,52,48,53,51,49,0,0,0,0,0,0,0,1,0,0,0,21,0,0,0,102,0,0,0,0,0,0,0,1,0,0,0,35,0,0,0,105,110,100,117,99,116,111,114,46,76,32,42,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,111,109,101,103,97,0,0,0,0,0,0,0,1,0,0,0,36,0,0,0,40,45,105,110,100,117,99,116,111,114,46,76,41,32,42,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,111,109,101,103,97,0,0,0,0,1,0,0,0,37,0,0,0,114,101,115,105,115,116,111,114,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,1,0,0,0,38,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,73,2,0,0,102,0,0,0,0,0,0,0,1,0,0,0,74,2,0,0,102,32,42,32,82,32,42,32,49,48,46,56,56,50,55,57,54,49,56,53,52,48,53,51,49,0,0,0,0,0,0,0,1,0,0,0,103,2,0,0,114,101,115,105,115,116,111,114,46,82,95,97,99,116,117,97,108,0,0,0,0,0,0,0,1,0,0,0,104,2,0,0,1,0,0,0,110,2,0,0,105,110,100,117,99,116,111,114,46,76,32,42,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,111,109,101,103,97,0,0,0,0,0,0,0,1,0,0,0,111,2,0,0,40,45,105,110,100,117,99,116,111,114,46,76,41,32,42,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,118,111,108,116,97,103,101,83,111,117,114,99,101,91,49,93,46,111,109,101,103,97,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,51,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,51,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,110,51,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,77,117,108,116,105,80,104,97,115,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,51,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,50,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,50,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,110,50,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,50,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,49,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,49,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,110,49,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,110,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,110,49,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,50,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,97,112,97,99,105,116,111,114,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,97,112,97,99,105,116,111,114,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,47,83,105,110,103,108,101,80,104,97,115,101,46,109,111,0,0,8,18,0,0,23,2,0,0,7,0,0,0,23,2,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,105,115,116,111,114,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,105,115,116,111,114,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,216,18,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,105,115,116,111,114,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,105,115,116,111,114,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,8,18,0,0,167,1,0,0,7,0,0,0,168,1,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,117,114,114,101,110,116,83,101,110,115,111,114,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,78,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,86,111,108,116,97,103,101,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,112,108,117,103,84,111,80,105,110,115,67,117,114,114,101,110,116,80,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,111,119,101,114,83,101,110,115,111,114,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,111,119,101,114,83,101,110,115,111,114,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,192,10,0,0,248,6,0,0,7,0,0,0,248,6,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,51,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,51,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,112,51,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,51,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,50,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,50,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,112,50,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,50,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,49,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,49,46,107,32,62,61,32,49,32,97,110,100,32,112,108,117,103,84,111,80,105,110,95,112,49,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,108,117,103,84,111,80,105,110,95,112,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,108,117,103,84,111,80,105,110,95,112,49,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,116,97,114,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,116,97,114,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,192,10,0,0,18,1,0,0,7,0,0,0,18,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,192,10,0,0,174,1,0,0,7,0,0,0,176,1,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,112,108,117,103,84,111,80,105,110,95,110,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,192,10,0,0,173,1,0,0,7,0,0,0,173,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,110,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,192,10,0,0,14,2,0,0,7,0,0,0,14,2,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,51,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,50,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,62,61,32,49,32,97,110,100,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,107,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,192,10,0,0,124,1,0,0,7,0,0,0,126,1,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,112,108,117,103,84,111,80,105,110,95,112,91,49,93,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,192,10,0,0,123,1,0,0,7,0,0,0,123,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,112,108,117,103,84,111,80,105,110,115,95,112,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,192,10,0,0,223,1,0,0,7,0,0,0,223,1,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,116,97,103,101,83,111,117,114,99,101,46,109,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,192,10,0,0,188,8,0,0,7,0,0,0,188,8,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,192,10,0,0,16,0,0,0,7,0,0,0,17,0,0,0,27,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,95,77,117,108,116,105,80,104,97,115,101,95,69,120,97,109,112,108,101,115,95,66,97,108,97,110,99,105,110,103,83,116,97,114,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,44,51,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,93,32,61,32,122,101,114,111,115,40,48,44,51,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,118,111,108,116,97,103,101,83,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,49,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,116,97,103,101,83,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,51,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,116,97,103,101,83,111,117,114,99,101,80,118,111,108,116,97,103,101,83,111,117,114,99,101,108,66,50,114,66,80,112,105,110,95,112,80,114,101,102,101,114,101,110,99,101,80,103,97,109,109,97,32,61,32,120,91,51,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,69,108,101,99,116,114,105,99,97,108,95,81,117,97,115,105,83,116,97,116,105,111,110,97,114,121,95,77,117,108,116,105,80,104,97,115,101,95,69,120,97,109,112,108,101,115,95,66,97,108,97,110,99,105,110,103,83,116,97,114,59,10,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,73,0,0,248,73,0,0,8,74,0,0,32,74,0,0,64,74,0,0,80,74,0,0,104,74,0,0,120,74,0,0,144,74,0,0,176,74,0,0,216,74,0,0,240,74,0,0,16,75,0,0,40,75,0,0,80,75,0,0,112,75,0,0,160,75,0,0,208,75,0,0,232,75,0,0,32,76,0,0,56,76,0,0,104,76,0,0,136,76,0,0,192,76,0,0,232,76,0,0,32,77,0,0,80,77,0,0,96,77,0,0,128,77,0,0,168,77,0,0,200,77,0,0,240,77,0,0,24,78,0,0,48,78,0,0,72,78,0,0,88,78,0,0,112,78,0,0,160,78,0,0,240,78,0,0,48,79,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,96,93,0,0,240,91,0,0,120,90,0,0,0,89,0,0,0,89,0,0,136,87,0,0,120,90,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,40,104,0,0,176,100,0,0,64,99,0,0,208,97,0,0,208,97,0,0,96,96,0,0,64,99,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,112,102,0,0,128,102,0,0,144,102,0,0,96,87,0,0,152,102,0,0,168,102,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,8,106,0,0,16,106,0,0,24,106,0,0,32,106,0,0,152,105,0,0,40,106,0,0,56,106,0,0,64,106,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115,32,97,110,100,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,100,111,32,110,111,116,32,97,103,114,101,101,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,115,99,97,108,97,114,32,115,45,62,105,110,100,101,120,91,37,100,93,91,48,93,32,61,61,32,37,100,32,105,110,99,111,114,114,101,99,116,44,32,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,61,61,32,37,100,10,0,0,97,114,114,97,121,32,115,45,62,105,110,100,101,120,91,37,100,93,91,37,100,93,32,61,61,32,37,100,32,105,110,99,111,114,114,101,99,116,44,32,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,61,61,32,37,100,10,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,114,114,41,0,0,0,0,0,0,99,97,108,99,95,98,97,115,101,95,105,110,100,101,120,95,115,112,101,99,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,40,115,112,101,99,41,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,102,105,116,95,98,97,115,101,95,97,114,114,97,121,40,115,112,101,99,44,32,97,114,114,41,0,0,0,0,40,110,100,105,109,115,32,61,61,32,97,114,114,45,62,110,100,105,109,115,41,32,38,38,32,40,110,100,105,109,115,32,61,61,32,115,112,101,99,45,62,110,100,105,109,115,41,0,0,0,0,0,0,0,0,0,112,109,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,40,110,0,0,56,110,0,0,64,110,0,0,72,110,0,0,88,110,0,0,104,110,0,0,112,110,0,0,128,110,0,0,144,110,0,0,160,110,0,0,176,110,0,0,192,110,0,0,208,110,0,0,224,110,0,0,240,110,0,0,248,110,0,0,0,111,0,0,16,111,0,0,24,111,0,0,40,111,0,0,56,111,0,0,72,111,0,0,88,111,0,0,104,111,0,0,120,111,0,0,136,111,0,0,152,111,0,0,168,111,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,48,112,0,0,56,112,0,0,56,112,0,0,88,112,0,0,136,112,0,0,168,112,0,0,224,112,0,0,16,113,0,0,64,113,0,0,96,113,0,0,144,113,0,0,168,113,0,0,200,113,0,0,240,113,0,0,16,114,0,0,64,114,0,0,96,114,0,0,136,114,0,0,168,114,0,0,208,114,0,0,0,115,0,0,56,115,0,0,96,115,0,0,144,115,0,0,192,115,0,0,232,115,0,0,24,116,0,0,32,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,48,112,0,0,32,119,0,0,40,119,0,0,48,119,0,0,64,110,0,0,56,119,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,105,115,32,78,85,76,76,33,10,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([32,97,114,101,32,110,101,103,97,116,105,118,101,58,32,37,100,33,10,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,105,115,32,78,85,76,76,33,10,0,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,105,110,100,101,120,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,58,32,116,104,101,32,105,110,100,101,120,32,115,112,101,99,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,110,101,103,97,116,105,118,101,58,32,37,100,33,10,0,105,110,100,101,120,91,37,100,93,32,61,61,32,48,44,32,115,105,122,101,32,61,61,32,37,100,10,0,0,0,0,0,117,116,105,108,47,105,110,116,101,103,101,114,95,97,114,114,97,121,46,99,0,0,0,0,115,116,101,112,32,33,61,32,48,0,0,0,0,0,0,0,99,114,101,97,116,101,95,105,110,116,101,103,101,114,95,97,114,114,97,121,95,102,114,111,109,95,114,97,110,103,101,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,40,122,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,64,122,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,88,122,0,0,96,122,0,0,104,122,0,0,120,122,0,0,136,122,0,0,144,122,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,105,110,100,101,120,101,100,95,97,115,115,105,103,110,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,111,107,40,100,101,115,116,95,115,112,101,99,41,0,0,0,0,0,0,0,0,105,110,100,101,120,95,115,112,101,99,95,102,105,116,95,98,97,115,101,95,97,114,114,97,121,40,100,101,115,116,95,115,112,101,99,44,32,100,101,115,116,41,0,0,0,0,0,0,106,32,61,61,32,115,111,117,114,99,101,45,62,110,100,105,109,115,0,0,0,0,0,0,106,32,61,61,32,98,97,115,101,95,97,114,114,97,121,95,110,114,95,111,102,95,101,108,101,109,101,110,116,115,40,115,111,117,114,99,101,41,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,160,134,0,0,0,0,0,0,24,134,0,0,0,0,0,0,144,133,0,0,0,0,0,0,8,133,0,0,0,0,0,0,0,132,0,0,0,0,0,0,248,130,0,0,0,0,0,0,240,129,0,0,0,0,0,0,232,128,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,136,0,0,152,136,0,0,160,136,0,0,168,136,0,0,184,136,0,0,192,136,0,0,200,136,0,0,208,136,0,0,216,136,0,0,224,136,0,0,232,136,0,0,248,136,0,0,0,137,0,0,16,137,0,0,32,137,0,0,48,137,0,0,56,137,0,0,72,137,0,0,80,137,0,0,96,137,0,0,104,137,0,0,128,137,0,0,136,137,0,0,144,137,0,0,160,137,0,0,168,137,0,0,184,137,0,0,200,137,0,0,208,137,0,0,216,137,0,0,224,137,0,0,232,137,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,138,0,0,128,138,0,0,200,138,0,0,248,138,0,0,40,139,0,0,112,139,0,0,176,139,0,0,248,139,0,0,40,140,0,0,112,140,0,0,136,140,0,0,168,140,0,0,224,140,0,0,8,141,0,0,48,141,0,0,104,141,0,0,184,141,0,0,24,142,0,0,72,142,0,0,128,142,0,0,176,142,0,0,248,142,0,0,32,143,0,0,80,143,0,0,128,143,0,0,216,143,0,0,32,144,0,0,144,144,0,0,192,144,0,0,8,145,0,0,40,145,0,0,232,137,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,138,0,0,232,145,0,0,144,146,0,0,248,138,0,0,40,139,0,0,248,146,0,0,176,139,0,0,248,139,0,0,128,147,0,0,192,147,0,0,136,140,0,0,168,140,0,0,96,148,0,0,160,148,0,0,224,148,0,0,104,141,0,0,184,141,0,0,32,149,0,0,88,149,0,0,224,149,0,0,8,150,0,0,248,142,0,0,32,143,0,0,80,143,0,0,112,150,0,0,248,150,0,0,248,151,0,0,144,144,0,0,192,144,0,0,8,145,0,0,40,145,0,0,232,137,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,157,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,157,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+34592);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,175,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+44936);
/* memory initializer */ allocate([16,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,182,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,183,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,185,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,220,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,221,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,222,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,223,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,235,0,0,184,236,0,0,192,236,0,0,208,236,0,0,224,236,0,0,240,236,0,0,8,237,0,0,32,237,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,235,0,0,160,235,0,0,232,235,0,0,16,236,0,0,48,236,0,0,80,236,0,0,120,236,0,0,160,236,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,0,244,0,0,16,244,0,0,24,244,0,0,32,244,0,0,40,244,0,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,72,244,0,0,80,244,0,0,96,244,0,0,112,244,0,0,40,244,0,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+55620);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,48,15,1,0,248,16,1,0,0,17,1,0,8,17,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,48,15,1,0,56,16,1,0,136,16,1,0,184,16,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,48,15,1,0,248,15,1,0,0,16,1,0,8,16,1,0,24,16,1,0,32,16,1,0,48,16,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,48,15,1,0,56,15,1,0,80,15,1,0,96,15,1,0,168,15,1,0,184,15,1,0,216,15,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,224,26,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,224,26,1,0,10,0,0,0,11,0,0,0,132,26,1,0,252,26,1,0,16,27,1,0,152,26,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,176,212,1,0,176,26,1,0,56,144,1,0,0,0,0,0,104,0,0,0,0,0,0,0,56,144,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,56,144,1,0,14,0,0,0,15,0,0,0,0,0,0,0,136,27,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,176,212,1,0,88,27,1,0,48,143,1,0,0,0,0,0,0,0,0,0,16,28,1,0,24,28,1,0,8,28,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,232,27,1,0,248,27,1,0,8,28,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+65864);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,104,44,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,104,44,1,0,20,0,0,0,21,0,0,0,12,44,1,0,132,44,1,0,152,44,1,0,32,44,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,176,212,1,0,56,44,1,0,168,143,1,0,0,0,0,0,108,0,0,0,0,0,0,0,168,143,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,168,143,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,96,54,1,0,72,56,1,0,80,56,1,0,152,58,1,0,176,56,1,0,192,56,1,0,160,58,1,0,168,58,1,0,176,58,1,0,184,58,1,0,200,58,1,0,216,58,1,0,232,58,1,0,248,58,1,0,8,59,1,0,24,59,1,0,40,59,1,0,64,59,1,0,120,58,1,0,144,58,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,96,54,1,0,72,56,1,0,80,56,1,0,96,56,1,0,176,56,1,0,192,56,1,0,208,56,1,0,240,56,1,0,16,57,1,0,48,57,1,0,88,57,1,0,128,57,1,0,168,57,1,0,208,57,1,0,232,57,1,0,8,58,1,0,40,58,1,0,80,58,1,0,120,58,1,0,144,58,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,96,54,1,0,40,56,1,0,48,56,1,0,56,56,1,0,96,54,1,0,104,55,1,0,184,55,1,0,232,55,1,0,96,54,1,0,40,55,1,0,48,55,1,0,56,55,1,0,72,55,1,0,80,55,1,0,96,55,1,0,0,0,0,0,96,54,1,0,104,54,1,0,128,54,1,0,144,54,1,0,216,54,1,0,232,54,1,0,8,55,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,128,61,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,128,61,1,0,28,0,0,0,29,0,0,0,12,61,1,0,156,61,1,0,176,61,1,0,32,61,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,176,212,1,0,56,61,1,0,56,144,1,0,0,0,0,0,56,0,0,0,0,0,0,0,56,144,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,56,144,1,0,14,0,0,0,15,0,0,0,0,0,0,0,64,62,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,176,212,1,0,248,61,1,0,48,143,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+76104);
/* memory initializer */ allocate([32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,208,82,1,0,208,82,1,0,208,82,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,120,85,1,0,136,85,1,0,160,85,1,0,192,85,1,0,224,85,1,0,248,85,1,0,24,86,1,0,48,86,1,0,64,86,1,0,80,86,1,0,104,86,1,0,128,86,1,0,160,86,1,0,192,86,1,0,80,86,1,0,216,86,1,0,248,86,1,0,16,87,1,0,40,87,1,0,64,87,1,0,96,87,1,0,112,87,1,0,144,87,1,0,176,87,1,0,200,87,1,0,224,87,1,0,248,87,1,0,8,88,1,0,32,88,1,0,56,88,1,0,80,88,1,0,112,88,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+86344);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+93216);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,120,129,1,0,128,129,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,144,129,1,0,152,129,1,0,160,129,1,0,168,129,1,0,144,1,0,0,0,0,0,0,24,130,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+98440);
/* memory initializer */ allocate([240,136,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,176,212,1,0,208,136,1,0,112,143,1,0,0,0,0,0,0,0,0,0,88,137,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,176,212,1,0,64,137,1,0,112,143,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,240,137,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,176,212,1,0,208,137,1,0,48,143,1,0,0,0,0,0,0,0,0,0,88,138,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,176,212,1,0,64,138,1,0,48,143,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,136,212,1,0,104,138,1,0,0,0,0,0,208,138,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,120,139,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,176,212,1,0,192,138,1,0,0,0,0,0,0,0,0,0,0,0,0,0,16,139,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,176,212,1,0,248,138,1,0,208,138,1,0,0,0,0,0,0,0,0,0,80,139,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,176,212,1,0,56,139,1,0,208,138,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,176,212,1,0,96,139,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,192,139,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,176,212,1,0,168,139,1,0,120,139,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,136,212,1,0,208,139,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,176,212,1,0,248,139,1,0,240,139,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,168,142,1,0,48,0,0,0,49,0,0,0,0,0,0,0,48,143,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,112,143,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,168,143,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,168,143,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,240,143,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,240,143,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,56,144,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,56,144,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,128,144,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,128,144,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,142,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,112,142,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,176,212,1,0,40,142,1,0,192,139,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,136,212,1,0,88,142,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,176,212,1,0,120,142,1,0,112,142,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,176,212,1,0,184,142,1,0,112,142,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,136,212,1,0,248,142,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,136,212,1,0,56,143,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,16,213,1,0,120,143,1,0,0,0,0,0,1,0,0,0,168,142,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,16,213,1,0,192,143,1,0,0,0,0,0,1,0,0,0,232,142,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,16,213,1,0,8,144,1,0,0,0,0,0,1,0,0,0,168,142,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,16,213,1,0,80,144,1,0,0,0,0,0,1,0,0,0,232,142,1,0,3,244,255,255,0,0,0,0,224,144,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,176,212,1,0,192,144,1,0,16,140,1,0,0,0,0,0,0,0,0,0,8,159,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,159,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,163,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,120,164,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,165,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,165,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,248,160,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,248,160,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,152,161,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,152,161,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,40,162,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,162,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,159,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,159,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,160,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,166,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,240,166,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,128,167,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,16,168,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,162,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,163,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,224,158,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,155,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,156,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,158,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,184,158,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,240,154,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,176,212,1,0,216,154,1,0,136,138,1,0,0,0,0,0,0,0,0,0,128,155,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,136,212,1,0,96,155,1,0,16,213,1,0,72,155,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,155,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,16,213,1,0,160,155,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,155,1,0,2,0,0,0,0,0,0,0,80,156,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,136,212,1,0,48,156,1,0,16,213,1,0,8,156,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,72,156,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,16,213,1,0,112,156,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,72,156,1,0,2,0,0,0,0,0,0,0,16,157,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,16,213,1,0,232,156,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,72,156,1,0,2,0,0,0,0,0,0,0,136,157,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,16,213,1,0,96,157,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,72,156,1,0,2,0,0,0,0,0,0,0,0,158,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,176,212,1,0,216,157,1,0,136,157,1,0,0,0,0,0,0,0,0,0,104,158,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,176,212,1,0,64,158,1,0,136,157,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,176,212,1,0,120,158,1,0,240,154,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,176,212,1,0,160,158,1,0,240,154,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,176,212,1,0,200,158,1,0,240,154,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,176,212,1,0,240,158,1,0,240,154,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,176,212,1,0,24,159,1,0,240,154,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,136,212,1,0,96,159,1,0,16,213,1,0,64,159,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,159,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,16,213,1,0,160,159,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,159,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,16,213,1,0,224,159,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,159,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,16,213,1,0,32,160,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,159,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,136,212,1,0,168,160,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,136,212,1,0,200,160,1,0,16,213,1,0,96,160,1,0,0,0,0,0,3,0,0,0,240,154,1,0,2,0,0,0,192,160,1,0,2,0,0,0,240,160,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,136,212,1,0,104,161,1,0,16,213,1,0,32,161,1,0,0,0,0,0,3,0,0,0,240,154,1,0,2,0,0,0,192,160,1,0,2,0,0,0,144,161,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,136,212,1,0,8,162,1,0,16,213,1,0,192,161,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,32,162,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,16,213,1,0,72,162,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,32,162,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,136,212,1,0,200,162,1,0,16,213,1,0,176,162,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,224,162,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,16,213,1,0,8,163,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,224,162,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,136,212,1,0,160,163,1,0,16,213,1,0,136,163,1,0,0,0,0,0,1,0,0,0,192,163,1,0,0,0,0,0,16,213,1,0,64,163,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,200,163,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,16,213,1,0,72,164,1,0,0,0,0,0,1,0,0,0,192,163,1,0,0,0,0,0,16,213,1,0,0,164,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,96,164,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,136,212,1,0,248,164,1,0,16,213,1,0,224,164,1,0,0,0,0,0,1,0,0,0,24,165,1,0,0,0,0,0,16,213,1,0,152,164,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,32,165,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,16,213,1,0,160,165,1,0,0,0,0,0,1,0,0,0,24,165,1,0,0,0,0,0,16,213,1,0,88,165,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,184,165,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,136,212,1,0,56,166,1,0,16,213,1,0,240,165,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,88,166,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,136,212,1,0,200,166,1,0,16,213,1,0,128,166,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,232,166,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,136,212,1,0,88,167,1,0,16,213,1,0,16,167,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,120,167,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,136,212,1,0,232,167,1,0,16,213,1,0,160,167,1,0,0,0,0,0,2,0,0,0,240,154,1,0,2,0,0,0,8,168,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+100492);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,248,209,1,0,110,0,0,0,0,210,1,0,114,0,0,0,8,210,1,0,102,0,0,0,16,210,1,0,97,0,0,0,24,210,1,0,101,0,0,0,32,210,1,0,119,0,0,0,40,210,1,0,87,0,0,0,56,210,1,0,115,0,0,0,72,210,1,0,83,0,0,0,88,210,1,0,100,0,0,0,104,210,1,0,68,0,0,0,120,210,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,0,212,1,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,136,212,1,0,216,211,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,176,212,1,0,240,211,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,176,212,1,0,16,212,1,0,232,211,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,176,212,1,0,72,212,1,0,56,212,1,0,0,0,0,0,0,0,0,0,112,212,1,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,248,212,1,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,176,212,1,0,208,212,1,0,112,212,1,0,0,0,0,0,0,0,0,0,88,213,1,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,176,212,1,0,48,213,1,0,112,212,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,215,1,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,176,212,1,0,136,215,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+110832);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vidii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_vidii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_iiiiiiiiiiiiii;var ua=env.invoke_vidii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._strrchr;var Va=env._pthread_key_create;var Wa=env._vsscanf;var Xa=env.__ZSt9terminatev;var Ya=env.___cxa_guard_acquire;var Za=env.__reallyNegative;var _a=env._fstat;var $a=env._pclose;var ab=env._lis_solver_create;var bb=env.___assert_fail;var cb=env.__ZSt18uncaught_exceptionv;var db=env._longjmp;var eb=env.__isLeapYear;var fb=env._clock_gettime;var gb=env._fsync;var hb=env._signal;var ib=env._GC_collect_a_little;var jb=env._sbrk;var kb=env._strtoull;var lb=env._emscripten_memcpy_big;var mb=env.__parseInt64;var nb=env._close;var ob=env._rewind;var pb=env._cos;var qb=env._fileno;var rb=env._fread;var sb=env._puts;var tb=env._isatty;var ub=env._lis_matrix_set_value;var vb=env._write;var wb=env._isblank;var xb=env._ftell;var yb=env.__ZNSt9exceptionD2Ev;var zb=env._xerbla_;var Ab=env._round;var Bb=env.___cxa_does_inherit;var Cb=env._strtoll_l;var Db=env._strstr;var Eb=env.___cxa_rethrow;var Fb=env._llvm_lifetime_end;var Gb=env._catclose;var Hb=env._tmpnam;var Ib=env._lis_vector_destroy;var Jb=env._lis_solver_set_option;var Kb=env._tmpfile;var Lb=env._send;var Mb=env._pow;var Nb=env.___cxa_is_number_type;var Ob=env.___cxa_free_exception;var Pb=env.___cxa_find_matching_catch;var Qb=env._isxdigit_l;var Rb=env.___cxa_guard_release;var Sb=env._truncate;var Tb=env._strtol;var Ub=env._sin;var Vb=env._strtok;var Wb=env.___setErrNo;var Xb=env._newlocale;var Yb=env._isdigit_l;var Zb=env.___resumeException;var _b=env._freelocale;var $b=env._srand;var ac=env._fscanf;var bc=env._qsort;var cc=env._putchar;var dc=env._floor;var ec=env._pthread_mutex_unlock;var fc=env._printf;var gc=env._sprintf;var hc=env._fopen;var ic=env._vasprintf;var jc=env._emscripten_get_now;var kc=env._stat;var lc=env._vsnprintf;var mc=env._strtoull_l;var nc=env._read;var oc=env.__addDays;var pc=env._fwrite;var qc=env._time;var rc=env._pthread_mutex_lock;var sc=env._catopen;var tc=env._exit;var uc=env._GC_strdup;var vc=env._freopen;var wc=env.___ctype_b_loc;var xc=env._fmod;var yc=env._strtok_r;var zc=env._lseek;var Ac=env._access;var Bc=env._vfprintf;var Cc=env.___cxa_allocate_exception;var Dc=env._atoi;var Ec=env._strtoll;var Fc=env._pwrite;var Gc=env._localtime_r;var Hc=env._tzset;var Ic=env._open;var Jc=env._uselocale;var Kc=env._snprintf;var Lc=env.___errno_location;var Mc=env._GC_malloc;var Nc=env.___cxa_end_catch;var Oc=env._perror;var Pc=env.___cxa_begin_catch;var Qc=env._strftime;var Rc=env._ftruncate;var Sc=env._GC_init;var Tc=env._fseek;var Uc=env._isxdigit;var Vc=env._fclose;var Wc=env.__parseInt;var Xc=env._log;var Yc=env._pthread_cond_broadcast;var Zc=env._popen;var _c=env._recv;var $c=env._fgetc;var ad=env._sysconf;var bd=env.__getFloat;var cd=env._abort;var dd=env._ceil;var ed=env._isspace;var fd=env._localtime;var gd=env._pthread_getspecific;var hd=env._pthread_cond_wait;var id=env._llvm_lifetime_start;var jd=env._ungetc;var kd=env._system;var ld=env._fmax;var md=env._fflush;var nd=env._strftime_l;var od=env._fprintf;var pd=env._sscanf;var qd=env._catgets;var rd=env._strdup;var sd=env._asprintf;var td=env.__exit;var ud=env.___ctype_toupper_loc;var vd=env._bsearch;var wd=env.__arraySum;var xd=env.__formatString;var yd=env._htonl;var zd=env.___ctype_tolower_loc;var Ad=env._unlink;var Bd=env._fputs;var Cd=env._GC_malloc_atomic;var Dd=env._pread;var Ed=env._lis_vector_set_size;var Fd=env._mkport;var Gd=env.__scanString;var Hd=env._pthread_setspecific;var Id=env._copysign;var Jd=env._fputc;var Kd=env.___cxa_throw;var Ld=env._lis_solver_destroy;var Md=env._isdigit;var Nd=env._strerror;var Od=env._emscripten_longjmp;var Pd=env._lis_vector_create;var Qd=env._atexit;var Rd=env._sqrt;var Sd=env._strerror_r;var Td=0.0;
// EMSCRIPTEN_START_FUNCS
function sv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Ku(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=tv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=uv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=vv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=wv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Ku(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 7:{o=45;break b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 10:case 9:case 21:{o=69;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Ku(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 24:case 22:{break};case 7:{o=65;break b;break};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Ku(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 17:{break c;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=xv(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function tv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Ku(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function uv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[23152+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function vv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Ku(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Ku(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 7:{p=34;break b;break};case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((yv(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Ku(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((yv(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function wv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Ku(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Ku(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function xv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Ku(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Ku(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=Ku(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 7:{l=36;break a;break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 29:{if((c[20832+((d[20576+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 29:{if((c[20832+((d[22112+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Ku(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=Ku(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 3:{t=ov(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=Ku(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=Ku(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 29:{l=94;break d;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 24:case 22:{break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[20832+((d[20576+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function yv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function zv(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Ku(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Ku(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Av(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=tv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Ku(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Ku(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Bv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Ku(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Cv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 12:{k=kw(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{m=15;break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((oe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((oe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 19:{k=mw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((oe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((oe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((oe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((oe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 13:{k=kw(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=gw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=lw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};case 30:{k=aw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 33:{m=113;break b;break};case 5:{if((e-b|0)<2){m=72;break b}p=b;if((oe[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=p+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=77;break b}q=b;if((oe[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=q+3|0;continue b;break};case 7:{if((e-b|0)<4){m=82;break b}r=b;if((oe[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=r+4|0;continue b;break};case 29:{m=69;break b;break};case 34:{m=110;break b;break};case 15:{m=116;break b;break};case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=94;break b}s=b;if((oe[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=s+2|0;continue b;break};case 6:{if((e-b|0)<3){m=99;break b}t=b;if((oe[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=t+3|0;continue b;break};case 7:{if((e-b|0)<4){m=104;break b}u=b;if((oe[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=u+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=91;break b;break};default:{n=19;continue b}}break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==110){u=b;if((n|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){u=b;if((n|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){u=b;if((n|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function Dv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=dw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=$v(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((oe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((oe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((oe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Ev(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((oe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((oe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((oe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Fv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((oe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((oe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((oe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 2:{o=b+1|0;b=o;if((o|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 4:{o=b+1|0;b=o;if((o|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function Gv(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 21:{m=23;break a;break};case 9:{m=16;break a;break};case 10:{m=13;break a;break};case 7:{a=a+4|0;continue a;break};case 3:{m=9;break a;break};case 2:{m=12;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=$v(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Hv(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 9:{m=18;break a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 10:{m=15;break a;break};case 3:{m=9;break a;break};case 30:{m=12;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=$v(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=aw(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Iv(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Jv(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Kv(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Lv(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Mv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Nv(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Yt(c)|0;g=f;i=b;return g|0}function Ov(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function Pv(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Qv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Rv(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Sv(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}o=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;o=o-65536|0;b[j>>1]=o>>>10|55296;b[j+2>>1]=o&1023|56320;j=j+4|0;m=m+4|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Tv(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[20832+(((d[22112+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Uv(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[20832+(((d[22112+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Vv(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Wv(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[20832+(((d[20576+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Xv(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[20832+(((d[20576+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Yv(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Zv(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function _v(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function $v(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=bw(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((oe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((oe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((oe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function aw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((oe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((oe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((oe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function bw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=cw(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function cw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function dw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:{k=hw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=gw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=ew(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=fw(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{m=73;break b;break};case 29:{m=33;break b;break};case 5:{if((e-b|0)<2){m=36;break b}n=b;if((oe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=n+2|0;continue b;break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}o=b;if((oe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=o+4|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}p=b;if((oe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((oe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}r=b;if((oe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=r+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((oe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 11:{m=97;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=76;break d;break};case 5:{m=78;break d;break};case 24:case 22:{m=77;break d;break};case 17:{break c;break};case 7:{m=88;break d;break};case 10:case 9:case 21:{break};case 11:{m=97;break c;break};case 6:{m=83;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((oe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=iw(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function ew(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 5:{if((e-b|0)<2){m=8;break b}n=b;if((oe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((oe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((oe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function fw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[23528+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function gw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((oe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((oe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((oe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=32;break b}p=b;if((oe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 29:{o=24;break b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((oe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((oe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((jw(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=57;break c}s=b;if((oe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((oe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((oe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((jw(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function hw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((oe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((oe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((oe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function iw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=4;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}m=b;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=48;break a}}break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 14:{break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}m=(oe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!m){l=9;break a}c[j>>2]=n+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}m=(oe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!m){l=14;break a}c[j>>2]=o+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}m=(oe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!m){l=19;break a}c[j>>2]=p+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}m=(oe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!m){l=36;break a}c[j>>2]=q+3;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}m=(oe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!m){l=41;break a}c[j>>2]=r+4;continue a;break};case 29:{l=26;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}m=(oe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!m){l=31;break a}c[j>>2]=s+2;continue a;break};default:{l=43;break a}}break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}m=t;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}m=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((m|0)==(t|0)){break}switch(m|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}m=(oe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(m){l=68;break a}c[j>>2]=u+3;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}m=(oe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(m){l=73;break a}c[j>>2]=v+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}m=(oe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(m){l=63;break a}c[j>>2]=w+2;continue c;break};case 2:{l=80;break a;break};case 3:{x=$v(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};case 7:{l=101;break d;break};case 5:{l=91;break d;break};case 29:{l=89;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}m=(oe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!m){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}m=(oe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!m){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}m=(oe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!m){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function jw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function kw(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((oe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((oe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((oe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function lw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=ew(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{l=10;break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a+1|0]|0)|0]|0;if(!((f|0)==30|(f|0)==10|(f|0)==9|(f|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function mw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((oe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((oe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((oe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((oe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function nw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function ow(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function pw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function qw(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=ye[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=ye[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=ye[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=ye[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function rw(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((tw(sw(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((tw(sw(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=sw(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((tw(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=sw(k,a,b)|0;n=h;}while((tw(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=sw(k,a,b)|0;while(1){if((tw(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=sw(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=sw(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function sw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function tw(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function uw(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function vw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((ye[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,27272)|0)==0){j=10;break a}c[h>>2]=15;k=3;break};case 13:{c[h>>2]=14;k=56;break};case 11:{c[h>>2]=14;k=55;break};case 14:{k=0;break};case 12:{c[h>>2]=14;k=1;break};case 29:{c[h>>2]=16;k=2;break};case 15:{c[h>>2]=14;k=0;break};default:{j=10}}}while(0);if((j|0)==10){k=zw(h,a)|0}i=g;return k|0}function ww(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};default:{k=yw(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=zw(h,a)|0}i=g;return k|0}function xw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((ye[c[e+28>>2]&63](e,b,d,27256)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27264)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function yw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 11:{j=55;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 16:{if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,27032)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,27040)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,27048)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,27056)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function zw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function Aw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function Bw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else{g=zw(e,a)|0}i=f;return g|0}function Cw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=zw(e,a)|0}i=f;return g|0}function Dw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else if((b|0)==15){g=39}else{g=zw(e,a)|0}i=f;return g|0}function Ew(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=zw(e,a)|0}i=f;return g|0}function Fw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=zw(e,a)|0}i=f;return g|0}function Gw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==15){g=0}else if((b|0)==11){g=55}else if((b|0)==13){g=56}else{g=zw(e,a)|0}i=f;return g|0}function Hw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((ye[c[e+28>>2]&63](e,b,d,27072)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27080)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function Iw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=zw(e,a)|0}i=f;return g|0}function Jw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=zw(e,a)|0}i=f;return g|0}function Kw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else{g=zw(e,a)|0}i=f;return g|0}function Lw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=zw(e,a)|0;h=g;i=f;return h|0}return 0}function Mw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((ye[c[e+28>>2]&63](e,b,d,27088)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27096)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function Nw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 20:{if((ye[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,27104)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 31:{c[h>>2]=40;j=52;break};case 32:{c[h>>2]=40;j=54;break};case 30:{c[h>>2]=40;j=53;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};default:{k=10}}}while(0);if((k|0)==10){j=zw(h,a)|0}i=g;return j|0}function Ow(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==21){c[e>>2]=41;g=39}else{g=zw(e,a)|0}i=f;return g|0}function Pw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 30:{c[e>>2]=40;g=53;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 32:{c[e>>2]=40;g=54;break};case 41:case 18:{c[e>>2]=40;g=51;break};default:{g=zw(e,a)|0}}i=f;return g|0}function Qw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=zw(e,a)|0;h=g;i=f;return h|0}}return 0}function Rw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=zw(e,a)|0}i=f;return g|0}function Sw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=zw(e,a)|0}i=f;return g|0}function Tw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=zw(e,a)|0}i=f;return g|0}function Uw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((ye[m&63](n,o,p,c[27112+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((ye[m&63](n,o,p,27056)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function Vw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,27216)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,27224)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,27240)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function Ww(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=zw(e,a)|0}i=f;return g|0}function Xw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=zw(e,a)|0}i=f;return g|0}function Yw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=zw(e,a)|0}i=f;return g|0}function Zw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=zw(e,a)|0}i=f;return g|0}function _w(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=zw(e,a)|0}i=f;return g|0}function $w(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=zw(e,a)|0}i=f;return g|0}function ax(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=zw(e,a)|0}i=f;return g|0}function bx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((ye[c[e+28>>2]&63](e,b,d,27072)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27080)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function cx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=zw(e,a)|0}i=f;return g|0}function dx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=zw(e,a)|0}i=f;return g|0}function ex(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((ye[c[e+28>>2]&63](e,b,d,27248)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function fx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=zw(e,a)|0}i=f;return g|0}function gx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((ye[c[e+28>>2]&63](e,b,d,27072)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27080)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function hx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=zw(e,a)|0}i=f;return g|0}function ix(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=zw(e,a)|0}i=f;return g|0}function jx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=zw(e,a)|0;h=g;i=f;return h|0}return 0}function kx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=zw(e,a)|0;h=g;i=f;return h|0}return 0}function lx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=zw(e,a)|0}i=f;return g|0}function mx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 11:{j=55;break};case 29:{c[h>>2]=16;j=2;break};case 13:{j=56;break};case 15:{j=0;break};case 16:{if((ye[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,27272)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};default:{k=9}}}while(0);if((k|0)==9){j=zw(h,a)|0}i=g;return j|0}function nx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=zw(e,a)|0}i=f;return g|0}function ox(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==18){if((ye[c[e+28>>2]&63](e,b,d,27072)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((ye[c[e+28>>2]&63](e,b,d,27080)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=zw(h,a)|0;k=j;i=g;return k|0}function px(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=zw(e,a)|0}i=f;return g|0}function qx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=zw(e,a)|0}i=f;return g|0}function rx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else{g=zw(e,a)|0}i=f;return g|0}function sx(){i=i;return}function tx(){i=i;return}function ux(){var a=0;a=i;Va(27280,0)|0;i=a;return}function vx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;pc(27288,29,1,e|0)|0;md(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;pc(27320,54,1,g|0)|0;md(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;pc(27376,47,1,a|0)|0;md(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;od(k|0,27424,d|0)|0;md(k|0)|0;f=0;i=b;return f|0}function wx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;od(j|0,27512,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;od(n|0,27544,e|0)|0;k=0;i=d;return k|0}function xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=c[a>>2]|0;j=c[b>>2]|0;if((h|0)!=(j|0)){k=c[r>>2]|0;c[g>>2]=h;c[g+4>>2]=j;od(k|0,27592,g|0)|0;md(k|0)|0;l=0;i=d;return l|0}if((h|0)<=0){l=1;i=d;return l|0}k=c[a+4>>2]|0;g=a+12|0;a=b+4|0;b=0;a:while(1){j=c[k+(b<<2)>>2]|0;m=c[(c[g>>2]|0)+(b<<2)>>2]|0;if((j|0)==0){n=c[m>>2]|0;o=c[(c[a>>2]|0)+(b<<2)>>2]|0;if((n|0)<1|(n|0)>(o|0)){p=7;break}}if((m|0)!=0&(j|0)>0){q=0;while(1){s=c[m+(q<<2)>>2]|0;t=c[(c[a>>2]|0)+(b<<2)>>2]|0;if((s|0)<1){p=12;break a}u=q+1|0;if((s|0)>(t|0)){p=12;break a}if((u|0)<(j|0)){q=u}else{break}}}j=b+1|0;if((j|0)<(h|0)){b=j}else{l=1;p=14;break}}if((p|0)==7){h=c[r>>2]|0;c[f>>2]=b;c[f+4>>2]=n;c[f+8>>2]=b;c[f+12>>2]=o;od(h|0,27664,f|0)|0;md(h|0)|0;l=0;i=d;return l|0}else if((p|0)==12){h=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=q;c[e+8>>2]=s;c[e+12>>2]=b;c[e+16>>2]=t;od(h|0,27728,e|0)|0;md(h|0)|0;l=0;i=d;return l|0}else if((p|0)==14){i=d;return l|0}return 0}function yx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function zx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=wy(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function Ax(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=wy(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function Bx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((vx(a)|0)==0){bb(27792,27488,262,27816)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=wy(e)|0;c[b+4>>2]=g;if((g|0)==0){bb(27840,27488,266,27816)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function Cx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;if((vx(d)|0)==0){bb(27856,27488,286,27880)}if((Yx(e)|0)==0){bb(27904,27488,287,27880)}if((xx(e,d)|0)==0){bb(27928,27488,288,27880)}if((c[d>>2]|0)!=(a|0)){g=27968;h=g;j=27488;k=j;l=27880;m=l;bb(h|0,k|0,289,m|0)}if((c[e>>2]|0)!=(a|0)){g=27968;h=g;j=27488;k=j;l=27880;m=l;bb(h|0,k|0,289,m|0)}if((a|0)<=0){n=0;i=f;return n|0}m=c[e+12>>2]|0;e=c[d+4>>2]|0;d=0;k=0;while(1){h=c[b+(d<<2)>>2]|0;l=c[m+(d<<2)>>2]|0;if((l|0)==0){o=h}else{o=(c[l+(h<<2)>>2]|0)+ -1|0}h=(fa(c[e+(d<<2)>>2]|0,k)|0)+o|0;l=d+1|0;if((l|0)<(a|0)){d=l;k=h}else{n=h;break}}i=f;return n|0}function Dx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[19846]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=28024;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];ze[p&31](0,f,28048,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function Ex(a,b){a=a|0;b=b|0;var d=0;d=i;if((vx(a)|0)==0){bb(28104,27488,347,28128)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);bb(28160,27488,348,28128);return 0}function Fx(){var a=0,b=0,d=0;a=i;b=29904|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=30016|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=30128|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[29908>>2]=1;c[29912>>2]=1;i=a;return}function Gx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?30264:30280;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;od(a|0,30240,e|0)|0;i=d;return}function Hx(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=30128+(d<<2)|0;o=30016+(d<<2)|0;p=30328+(b<<2)|0;q=28608+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=30312;fc(30296,l|0)|0;s=30312}else{if((c[7472]|0)==(d|0)){if((c[o>>2]|0)>0){t=30312}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;fc(30296,m|0)|0;do{if((c[7472]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=30312;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;fc(30320,k|0)|0;c[n>>2]=b;c[7472]=d;if((c[o>>2]|0)>0){g=0;while(1){fc(30352,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;sb(e|0)|0;r=0;e=e+(w+1)|0;f=1}sb(e|0)|0;md(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function Ix(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[30328+(a<<2)>>2]|0;c[j>>2]=c[28608+(b<<2)>>2];c[j+4>>2]=k;fc(30360,j|0)|0;Jx(e);if((g|0)==0){Bd(((d|0)!=0?30400:30448)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}sb(30528)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];fc(30408,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}pc(30432,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=md(m|0)|0;i=f;return}function Jx(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){pc(30488,4,1,e|0)|0}else if(b<<24>>24==60){pc(30480,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){pc(30472,5,1,e|0)|0}else{Jd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function Kx(a){a=a|0;var b=0;b=30016+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function Lx(a){a=a|0;var b=0;b=(a|0)==0;c[7616]=b?1:19;c[7614]=b?7:353;i=i;return}function Mx(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;pc(30432,11,1,b|0)|0;md(b|0)|0;i=a;return}function Nx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[29904+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;lc(j|0,2048,e|0,h|0)|0;ie[c[7616]&31](1,a,b,j,0,d);i=g;return}function Ox(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[29904+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;lc(h|0,2048,d|0,g|0)|0;ie[c[7616]&31](1,a,b,h,0,0);i=f;return}function Px(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[7474]|0)==0){if((c[29904+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;lc(k|0,2048,e|0,j|0)|0;ie[c[7616]&31](2,a,b,k,0,d);i=g;return}function Qx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[7474]|0)==0){if((c[29904+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;lc(j|0,2048,d|0,h|0)|0;ie[c[7616]&31](2,a,b,j,0,0);i=f;return}function Rx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;lc(b|0,2048,d|0,g|0)|0;ie[c[7616]&31](4,2,0,b,0,0);if((a|0)==0){h=gd(c[6820]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function Sx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;lc(g|0,2048,b|0,f|0)|0;ie[c[7616]&31](5,2,0,g,0,0);if((a|0)==0){h=gd(c[6820]|0)|0}else{h=a}db(c[h+76>>2]|0,1)}function Tx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;lc(h|0,2048,d|0,g|0)|0;ie[c[7616]&31](5,2,0,h,0,b);if((a|0)==0){j=gd(c[6820]|0)|0}else{j=a}db(c[j+76>>2]|0,1)}function Ux(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;Tx(a,e,30600,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;Px(26,0,e,30536,m);i=j;return+b}return 0.0}



function RP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=hc(c[o>>2]|0,85368)|0;if((p|0)!=0){q=p;break}p=Nd(c[(Lc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Sx(0,85376,g)}else{q=0}}while(0);g=Fs(0)|0;if((g|0)==0){Sx(0,85408,f)}f=a+8|0;c[a+20>>2]=E0(c[f>>2]|0,32)|0;p=a+12|0;o=E0((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=85440;c[o+12>>2]=0;c[o+16>>2]=0;Qs(g,h);Rs(g,10,69);h=c[n>>2]|0;do{if((h|0)==0){o=j;i1(o|0,0,1024)|0;while(1){r=rb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Ss(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=_s(Xs(g)|0)|0;s=Ys(g)|0;Vc(q|0)|0;Ms(g);r=c[a>>2]|0;c[e>>2]=85544;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Sx(0,85480,e)}else if((t|0)==11){Vc(q|0)|0;break}}else{if((Ss(g,h,e1(h|0)|0,1)|0)!=0){break}s=_s(Xs(g)|0)|0;o=Ys(g)|0;Ms(g);r=c[n>>2]|0;c[d>>2]=85544;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Sx(0,85584,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){bb(85648,85544,295,85688)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{bb(85712,85544,297,85688)}}function SP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((a1(86120,b)|0)==0){if((a1(c[d>>2]|0,86128)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Rx(0,p,86136,l);l=c[21494]|0;p=c[21548]|0;do{if((l|0)==0|(p|0)==0){c[21548]=32;a=C0(1152)|0;c[21494]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[21548]=p<<1;a=F0(l,p*72|0)|0;c[21494]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(YP(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((a1(86200,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((a1(86208,u)|0)==0){c[21554]=rd(c[t+4>>2]|0)|0}else{if((a1(86240,u)|0)==0){c[86220>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((a1(86256,u)|0)==0){c[86228>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((a1(86264,u)|0)==0){c[86224>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((a1(86280,u)|0)==0){c[86232>>2]=Tb(c[t+4>>2]|0,0,10)|0;break}if((a1(86288,u)|0)!=0){v=23;break a}c[86236>>2]=(a1(c[t+4>>2]|0,86304)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Sx(0,86312,k)}else if((v|0)==45){i=e;return}}if((a1(85960,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=85544;c[j+4>>2]=k;c[j+8>>2]=v;Sx(0,86344,j)}if((a1(86408,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=85544;c[h+4>>2]=j;Sx(0,86416,h)}h=Tb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=85544;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Sx(0,86472,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=86536;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((a1(85904,b)|0)!=0){if((a1(86096,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=86640;m=rd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=86648;i=e;return}c[85924>>2]=0;c[85928>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((a1(m,86128)|0)==0){c[85924>>2]=rd(c[b+4>>2]|0)|0}else{if((a1(m,86592)|0)!=0){break}c[85928>>2]=rd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[85924>>2]|0)==0){w=0;break}w=(c[85928>>2]|0)!=0|0}}while(0);Rx(0,w,86600,f);c[21480]=-1;f=85932|0;w=86216;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function TP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((a1(85904,b)|0)==0){o=e+0|0;p=85920|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));XP(e);i=d;return}if((a1(85960,b)|0)==0){e=h+24|0;r=C0((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=C0(36)|0;t=s;o=s+0|0;p=(c[21494]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((a1(85984,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;sd(e+(k*20|0)+8|0,85992,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((a1(86032,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;sd(h+(k*20|0)+8|0,86048,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((a1(86096,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function UP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){RP(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function VP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){RP(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Sx(0,85752,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=85832;p=o;Sx(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=85832;p=o;Sx(0,p,f)}}function WP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){D0(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){D0(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}D0(k);c[d>>2]=0;i=b;return}function XP(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=C0(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=e1(f|0)|0;c[e+64>>2]=k;k=c[21528]|0;do{if((k|0)==0){c[21528]=e;c[e+44>>2]=0;l=C0(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){tc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=C0(384)|0;c[l>>2]=n;if((n|0)==0){tc(-1)}else{i1(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[21528]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[21528]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=e1(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(e1(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 9:{B=o;C=14;break};case 4:{D=o;E=y;C=19;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;F=z;C=13;break};case 10:{F=o;C=13;break};case 7:{G=o;H=y;C=16;break};case 5:{I=o;J=y;C=18;break};case 6:{K=o;L=y;C=17;break};case 3:{M=o;N=x;O=y;C=20;break};case 8:{P=o;C=15;break};case 1:{Q=o;R=x;S=y;C=22;break};case 2:{T=o;U=x;V=y;C=21;break};default:{W=o;X=x;Y=y}}if((C|0)==13){o=((d[A+9|0]|0)<<16)+F|0;c[p>>2]=o;B=o;C=14}if((C|0)==14){o=((d[A+8|0]|0)<<8)+B|0;c[p>>2]=o;P=o;C=15}if((C|0)==15){G=P;H=((d[A+7|0]|0)<<24)+y|0;C=16}if((C|0)==16){K=G;L=((d[A+6|0]|0)<<16)+H|0;C=17}if((C|0)==17){I=K;J=((d[A+5|0]|0)<<8)+L|0;C=18}if((C|0)==18){D=I;E=(d[A+4|0]|0)+J|0;C=19}if((C|0)==19){M=D;N=((d[A+3|0]|0)<<24)+x|0;O=E;C=20}if((C|0)==20){T=M;U=((d[A+2|0]|0)<<16)+N|0;V=O;C=21}if((C|0)==21){Q=T;R=((d[A+1|0]|0)<<8)+U|0;S=V;C=22}if((C|0)==22){W=Q;X=(d[A]|0)+R|0;Y=S}S=X-Y-W^W>>>13;X=Y-W-S^S<<8;Y=W-S-X^X>>>13;W=S-X-Y^Y>>>12;S=X-Y-W^W<<16;X=Y-W-S^S>>>5;Y=W-S-X^X>>>3;W=S-X-Y^Y<<10;S=X-Y-W^W>>>15;c[p>>2]=S;p=(c[21528]|0)+40|0;W=c[p>>2]|0;Y=S&(c[W+4>>2]|0)+ -1;S=c[W>>2]|0;W=S+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[S+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[21528]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[21528]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=C0((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){tc(-1)}i1(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;S=c[j>>2]|0;c[Y+24>>2]=(((S<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((S|0)==0){_=e}else{S=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=S}else{W=S;X=j;while(1){j=X+16|0;R=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];Q=Z+(A*12|0)+4|0;C=(c[Q>>2]|0)+1|0;c[Q>>2]=C;V=c[W+24>>2]|0;if(C>>>0>V>>>0){C=W+28|0;c[C>>2]=(c[C>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[Q>>2]|0)>>>0)/(V>>>0)|0}c[X+12>>2]=0;V=Z+(A*12|0)|0;c[j>>2]=c[V>>2];j=c[V>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[V>>2]=X;V=c[h>>2]|0;if((R|0)==0){$=V;break}else{W=V;X=R}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){S=$;Y=W;e=X}else{_=W;break}}}D0(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function YP(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[21528]|0)==0){f=24}else{g=e1(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(e1(a|0)|0)+s|0;switch(v|0){case 4:{x=h;y=u;f=12;break};case 7:{z=h;A=u;f=9;break};case 2:{B=h;C=t;D=u;f=14;break};case 3:{E=h;F=t;G=u;f=13;break};case 1:{H=h;I=t;J=u;f=15;break};case 6:{K=h;L=u;f=10;break};case 8:{M=h;f=8;break};case 9:{N=h;f=7;break};case 10:{O=h;f=6;break};case 5:{P=h;Q=u;f=11;break};case 11:{O=((d[w+10|0]|0)<<24)+h|0;f=6;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+O|0;f=7}if((f|0)==7){M=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){z=M;A=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){K=z;L=((d[w+6|0]|0)<<16)+A|0;f=10}if((f|0)==10){P=K;Q=((d[w+5|0]|0)<<8)+L|0;f=11}if((f|0)==11){x=P;y=(d[w+4|0]|0)+Q|0;f=12}if((f|0)==12){E=x;F=((d[w+3|0]|0)<<24)+t|0;G=y;f=13}if((f|0)==13){B=E;C=((d[w+2|0]|0)<<16)+F|0;D=G;f=14}if((f|0)==14){H=B;I=((d[w+1|0]|0)<<8)+C|0;J=D;f=15}if((f|0)==15){R=H;S=(d[w]|0)+I|0;T=J}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[21528]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=e1(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if(($0(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Db(a|0,86672)|0)==0){V=0;break}else{W=86696}i=b;return W|0}}while(0);c[e>>2]=a;Rx(0,(V|0)!=0|0,86744,e);W=V+4|0;i=b;return W|0}function ZP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((_P(86800,a,b)|0)!=0){d=1;i=c;return d|0}d=(_P(86808,a,b)|0)!=0|0;i=c;return d|0}function _P(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((a1(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function $P(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(a1(c[35444>>2]|0,86816)|0)==0|0;Rx(0,m,86832,l);l=(a1(c[37348>>2]|0,86816)|0)==0|0;Rx(0,l,86888,k);k=(a1(c[39340>>2]|0,86816)|0)==0|0;Rx(0,k,86944,j);j=87008|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=87136|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[39344+(k<<2)>>2]|0;if((l|0)==1){if((_P(c[35320+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[35320+(k<<2)>>2]|0;if(!((_P(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[35320+(k<<2)>>2]|0;if((bQ(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=87008+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=87008+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[87136+(k<<2)>>2]=aQ(r,p)|0;t=j}else if((q|0)==13){q=0;l=87008+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[87136+(k<<2)>>2]=cQ(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];Qx(1,0,87264,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];Qx(1,0,87264,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];Qx(1,0,87264,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];Qx(1,0,87320,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function aQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((a1(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function bQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(cQ(a,b)|0)!=0|0;i=c;return d|0}function cQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=e1(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((b1(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function dQ(){i=i;return}function eQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){tc(0)}e=c[r>>2]|0;pc(87352,5,1,e|0)|0;f=b;b=0;while(1){Jd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}pc(87360,20,1,e|0)|0;tc(0);return 0}function fQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;od(d|0,87384,e|0)|0;if((b|0)==0){tc(1)}else{md(d|0)|0;nQ();md(d|0)|0;hb(6,0)|0;cd()}}function gQ(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function hQ(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function iQ(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function jQ(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function kQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function lQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}i1(p|0,32,b+(d-p)|0)|0;i=f;return}function mQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=88424+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[88468+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[88464+(e*48|0)>>2]|0)==1){oQ(b)|0}k=88428+(e*48|0)|0;if((c[k>>2]|0)==0){break}Vc(c[f>>2]|0)|0;D0(c[k>>2]|0)}}while(0);do{if((h|0)==10){Vc(g|0)|0;b=88428+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ad(k|0)|0;D0(c[b>>2]|0)}}while(0);c[f>>2]=0}c[88460+(e*48|0)>>2]=0;c[88428+(e*48|0)>>2]=0;i=d;return 0}function nQ(){var a=0,b=0;a=i;if((c[21848]|0)!=0){i=a;return}c[21848]=1;c[87400>>2]=0;b=0;do{c[87396>>2]=b;mQ(87392)|0;b=b+1|0;}while((b|0)<100);i=a;return}function oQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[88440+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=88424+(d*48|0)|0;g=c[f>>2]|0;h=xb(g|0)|0;Tc(g|0,0,2)|0;if((h|0)>=(xb(g|0)|0)){e=0;i=b;return e|0}if((c[88444+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[88452+(d*48|0)>>2]&2|0)!=0){md(c[f>>2]|0)|0}d=Rc(qb(c[f>>2]|0)|0,h|0)|0;Tc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){qQ(111,87408);e=111;i=b;return e|0}else{c[(Lc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function pQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((_a(qb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(tb(qb(a|0)|0)|0)==0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function qQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Oc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;od(m|0,88320,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;od(m|0,88352,j|0)|0;l=m;break}else{n=c[88192+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;od(m|0,88376,h|0)|0;l=m;break}}}while(0);h=c[22096]|0;do{if((h|0)==0){pc(93256,29,1,l|0)|0}else{c[g>>2]=(h-88424|0)/48|0;od(l|0,88392,g|0)|0;b=c[(c[22096]|0)+4>>2]|0;if((b|0)==0){pc(93240,10,1,l|0)|0;break}else{c[f>>2]=b;od(l|0,93224,f|0)|0;break}}}while(0);f=c[23322]|0;if((f|0)!=0){c[d>>2]=f;od(l|0,93296,d|0)|0}d=(c[23342]|0)!=0?93376:93392;f=(c[23350]|0)!=0?93408:93424;g=(c[23360]|0)!=0?93448:93464;c[e>>2]=(c[23336]|0)!=0?93352:93360;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;od(l|0,93320,e|0)|0;fQ(93480,1)}function rQ(){var a=0,b=0;a=i;c[23372]=1;b=c[r>>2]|0;c[22106]=b;c[88444>>2]=pQ(b)|0;c[88448>>2]=1;c[88464>>2]=1;b=c[s>>2]|0;c[88664>>2]=b;c[88684>>2]=pQ(b)|0;c[88688>>2]=1;c[88704>>2]=0;b=c[t>>2]|0;c[88712>>2]=b;c[88732>>2]=pQ(b)|0;c[88736>>2]=1;c[88752>>2]=1;i=a;return}function sQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=vc(g|0,c[98736+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[23374]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=xb(c[k>>2]|0)|0;l=vc(c[f>>2]|0,c[98736+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[23374]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Tc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Lc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Tc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function tQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){qQ(b,d)}d=c[23376]|0;if((d|0)!=0){te[d&7]()|0}c[(Lc()|0)>>2]=b;i=e;return b|0}function uQ(a){a=a|0;var b=0,d=0;b=i;c[23406]=0;c[23408]=0;c[23410]=0;d=((vQ(a,0)|0)==0)<<31>>31;i=b;return d|0}function vQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[23410]|0;c[23410]=j+1;if((j|0)==1){c[23408]=d}if((AQ(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=BQ(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function wQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[23406]|0;l=93648+(k<<4)|0;m=c[l>>2]|0;switch(xQ(m)|0){case 9:{n=($d[c[23390]&127](l)|0)==0;c[23406]=(c[23406]|0)+1;if(n){break b}else{continue b}break};case 16:{if(b){o=28;break a}c[23406]=k+1;continue b;break};case 1:{n=c[93652+(k<<4)>>2]|0;p=(c[24638]|0)+1|0;c[24638]=p;c[98560+(p<<2)>>2]=n;c[23406]=k+1;continue b;break};case 22:{c[23384]=1;c[23406]=k+1;continue b;break};case 20:{c[23402]=c[93652+(k<<4)>>2];c[23406]=k+1;continue b;break};case 3:{n=c[24622]|0;p=98496+(n<<2)|0;q=c[p>>2]|0;c[p>>2]=q+ -1;if((q|0)<2){c[24622]=n+ -1;c[24638]=(c[24638]|0)+ -1;c[23406]=k+1;continue b}else{n=c[24638]|0;c[24638]=n+ -1;c[23406]=(c[98560+(n<<2)>>2]|0)+1;continue b}break};case 21:{c[23384]=0;c[23406]=k+1;continue b;break};case 33:{c[24650]=1;c[23406]=k+1;continue b;break};case 19:case 17:{c[23382]=0;c[23406]=k+1;continue b;break};case 18:{c[23382]=1;c[23406]=k+1;continue b;break};case 2:{c[24622]=0;c[24638]=0;c[23406]=c[93652+(k<<4)>>2];if(b){o=24;break a}if((c[24634]|0)==0){j=0;o=37;break a}n=te[c[23392]&7]()|0;if((n|0)==0){continue b}else{j=n;o=37;break a}break};case 8:{n=c[24622]|0;s=98496+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){o=10;break b}c[24622]=n+ -1;c[23406]=k+1;continue b;break};case 6:{n=c[93652+(k<<4)>>2]|0;q=(c[24622]|0)+1|0;c[24622]=q;c[98496+(q<<2)>>2]=n;c[23406]=k+1;continue b;break};default:{o=4;break a}}}if((o|0)==10){o=0;if(b){o=11;break}c[s>>2]=t+ -1;c[24634]=1;k=ce[c[23388]&63](l,g,d)|0;if((k|0)>0){o=13;break}if((k|0)<0){o=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;o=37;break}}if((o|0)==4){h=c[r>>2]|0;d=c[23322]|0;c[f>>2]=m;c[f+4>>2]=d;od(h|0,98448,f|0)|0;if((c[c[23378]>>2]|0)==0){qQ(100,98480);j=100;i=e;return j|0}else{c[(Lc()|0)>>2]=100;j=100;i=e;return j|0}}else if((o|0)==11){j=te[c[23376]&7]()|0;i=e;return j|0}else if((o|0)==13){f=c[c[23378]>>2]|0;j=tQ(f,c[(Lc()|0)>>2]|0,98544)|0;i=e;return j|0}else if((o|0)==15){if((c[(c[23378]|0)+8>>2]|0)==0){qQ(-1,98544);j=-1;i=e;return j|0}else{c[(Lc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((o|0)==24){j=te[c[23376]&7]()|0;i=e;return j|0}else if((o|0)==28){j=te[c[23376]&7]()|0;i=e;return j|0}else if((o|0)==37){i=e;return j|0}return 0}function xQ(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function yQ(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=wQ(b,0,0)|0;i=a;return d|0}function zQ(){c[23398]=0;c[23406]=0;c[24638]=0;c[24622]=0;c[24634]=0;c[24640]=0;c[24624]=0;i=i;return}function AQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[23406]|0;if((g|0)>299){pc(98624,24,1,c[r>>2]|0)|0;fQ(c[23322]|0,1)}else{c[93648+(g<<4)>>2]=a;c[93652+(g<<4)>>2]=b;c[93656+(g<<4)>>2]=d;c[93660+(g<<4)>>2]=e;c[23406]=g+1;i=f;return g|0}return 0}function BQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=CQ(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[23410]|0)+ -1|0;c[23410]=h;if((h|0)==0){AQ(2,c[23408]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{AQ(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function CQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((DQ(b,e)|0)!=0){g=c[e>>2]|0;break}if((EQ(b,e)|0)!=0){g=c[e>>2]|0;break}h=FQ(b,f,1)|0;j=AQ(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=vQ(h,j)|0}}while(0);i=d;return g|0}function DQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 36:{AQ(33,0,0,0)|0;g=b;h=30;break};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){AQ(22,0,0,0)|0;g=j;h=30;break a}else{AQ(21,0,0,0)|0;g=j;h=30;break a}break};case 112:case 80:{AQ(20,1,0,0)|0;g=b;h=30;break};case 120:case 88:{AQ(4,1,0,0)|0;g=b;h=30;break};case 47:{AQ(5,0,0,0)|0;g=b;h=30;break};case 45:{l=1;h=13;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{m=b;n=0;h=14;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==80|k<<24>>24==112){o=j;p=18}else if(k<<24>>24==83|k<<24>>24==115){o=j;p=19}else{o=b;p=17}AQ(p,0,0,0)|0;g=o;h=30;break};case 43:{l=0;h=13;break};case 58:{AQ(16,0,0,0)|0;g=b;h=30;break};case 39:case 34:case 2:{c[93656+((AQ(11,0,0,0)|0)<<4)>>2]=b;j=GQ(b)|0;c[d>>2]=j;q=(j|0)!=0|0;i=e;return q|0};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==82|k<<24>>24==114){r=j;s=14}else if(k<<24>>24==76|k<<24>>24==108){r=j;s=13}else{r=b;s=15}j=FQ(r+1|0,f,0)|0;if((j|0)==0){h=15;break a}AQ(s,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};default:{q=0;i=e;return q|0}}}while(0);if((h|0)==13){m=b+1|0;n=l;h=14}b:do{if((h|0)==14){l=FQ(m,f,0)|0;if((l|0)==0){h=15;break}switch(a[l]|0){case 104:case 72:{b=c[f>>2]|0;c[93656+((AQ(12,b,0,0)|0)<<4)>>2]=l+1;g=l+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((n|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}AQ(20,t,0,0)|0;g=l;h=30;break b;break};case 120:case 88:{AQ(4,c[f>>2]|0,0,0)|0;g=l;h=30;break b;break};default:{q=0;i=e;return q|0}}}}while(0);if((h|0)==15){c[d>>2]=0;q=1;i=e;return q|0}else if((h|0)==30){c[d>>2]=g+1;q=1;i=e;return q|0}return 0}function EQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=FQ(b,f,1)|0;AQ(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=FQ(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=FQ(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}AQ(23,n,r,0)|0;o=q;m=45;break};case 97:case 65:{n=f;while(1){s=a[n]|0;if(s<<24>>24==32){n=n+1|0}else{break}}if(!((s+ -48<<24>>24&255)<10)){AQ(30,0,0,0)|0;o=n;m=45;break a}l=FQ(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}AQ(31,p,0,0)|0;o=l;m=45;break};case 101:case 69:{t=1;m=3;break};case 103:case 71:{t=0;m=3;break};case 111:case 79:{u=32;v=34;m=38;break};case 122:case 90:{u=35;v=36;m=38;break};case 108:case 76:{l=FQ(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}AQ(29,p,0,0)|0;o=l;m=45;break};case 105:case 73:{u=7;v=10;m=38;break};case 100:case 68:{l=FQ(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=FQ(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}AQ(26,p,y,0)|0;o=x;m=45;break};default:{c[23406]=(c[23406]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=FQ(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){s=FQ(b+1|0,h,0)|0;if((s|0)==0){m=4;break}A=s;B=a[s]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){AQ((t|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=FQ(A+1|0,j,0)|0;if((y|0)==0){m=4;break}AQ((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=FQ(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){AQ(u,x,0,0)|0;o=y;m=45;break}b=FQ(y+1|0,h,0)|0;if((b|0)==0){m=4;break}AQ(v,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function FQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function GQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[23378]>>2]|0)==0){qQ(100,98608);n=0;i=d;return n|0}else{c[(Lc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function HQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[98678|0]=48;k=98678|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=98656+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function IQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[23400]|0;f=c[23396]|0;if((e|0)>(f|0)){c[23396]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[24688]|0)){h=g}else{JQ(f,g);h=c[23396]|0}g=c[24690]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Bd(g|0,c[23374]|0)|0;h=e1(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Jd(a[k]|0,c[23374]|0)|0;Bd(h|0,c[23374]|0)|0;b=e1(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function JQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[24690]|0;if((f|0)==98840){c[24688]=1024;g=1024}else{g=c[24688]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[24688]=j;h=j}j=C0(h)|0;if((j|0)==0){qQ(113,99240);k=c[24690]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[24690]|0}else{l=k}if((l|0)==98840){m=98760;c[24690]=j;i=e;return}D0(l);m=98760;c[24690]=j;i=e;return}function KQ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[23396]|0;f=c[24688]|0;if((e|0)<(f|0)){g=e}else{JQ(e,f);g=c[23396]|0}c[23396]=g+1;a[(c[24690]|0)+g|0]=b;i=d;return}function LQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[23360]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){qQ(101,98768);l=101;i=d;return l|0}else{c[(Lc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[23372]|0)==0){rQ();m=c[f>>2]|0}else{m=k}k=88424+(m*48|0)|0;c[22096]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){QQ(k,c[b+12>>2]|0,j);o=RQ(j,h)|0;if((o|0)==(c[88432+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[88436+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=mQ(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[88456+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=88440+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[88456+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=88448+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[88448+(m*48|0)>>2]=1;r=1;break}else{c[88448+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];gc(j|0,98776,e|0)|0}else{QQ(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){MQ(107,98768,b);l=107;i=d;return l|0}else{c[(Lc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=88468+(m*48|0)|0;c[q>>2]=0;c[88460+(m*48|0)>>2]=0;e=88464+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=88452+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 83:case 115:{c[q>>2]=1;o=Kb()|0;c[n>>2]=o;if((o|0)!=0){c[88428+(m*48|0)>>2]=0;c[88436+(m*48|0)>>2]=-1;c[88432+(m*48|0)>>2]=-1;c[88444+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Lc()|0;s=c[k>>2]|0;if(o){MQ(s,98768,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Ac(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Lc()|0;o=c[k>>2]|0;if(s){MQ(o,98768,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Ac(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){MQ(128,98768,b);l=128;i=d;return l|0}else{c[(Lc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=hc(j|0,c[24684]|0)|0;if((o|0)==0){break}Vc(o|0)|0}}while(0);q=C0((e1(j|0)|0)+1|0)|0;c[88428+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){MQ(113,98792,b);l=113;i=d;return l|0}else{c[(Lc()|0)>>2]=113;l=113;i=d;return l|0}}k1(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=hc(j|0,c[98736+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=hc(j|0,c[98696+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=hc(j|0,c[98736+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Lc()|0;o=c[g>>2]|0;if(h){qQ(o,98768);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=88444+(m*48|0)|0;c[r>>2]=pQ(u)|0;u=RQ(j,88436+(m*48|0)|0)|0;c[88432+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){MQ(108,98768,b);l=108;i=d;return l|0}else{c[(Lc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){ob(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Tc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){MQ(129,98768,b);l=129;i=d;return l|0}else{c[(Lc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function MQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){qQ(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[24688]|0)){j=d;k=g}else{JQ(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[24690]|0;c[(c[22096]|0)+4>>2]=f;QQ(k,j,f);qQ(a,b);i=e;return}function NQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;gc(j|0,98776,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=e1(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?98808:98816;c[h+24>>2]=(b|0)==5?98824:98832;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=LQ(h)|0;i=e;return a|0}function OQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=88424+(d*48|0)|0;c[22096]=e;if(d>>>0>99){if((c[a>>2]|0)==0){qQ(101,99256);f=101;i=b;return f|0}else{c[(Lc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((NQ(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){qQ(114,99264);f=114;i=b;return f|0}else{c[(Lc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[88448+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){qQ(102,99264);f=102;i=b;return f|0}else{c[(Lc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function PQ(){var a=0,b=0;a=i;b=yQ()|0;c[23322]=0;i=a;return b|0}function QQ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function RQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((kc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function SQ(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[23402]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[23382]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];gc(p|0,99272,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(e1(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Yd[c[23386]&511](32);}while((A|0)>0)}if((D|0)!=0){Yd[c[23386]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Yd[c[23386]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Dc(A|0)|0)+1|0;c[m>>2]=t-(c[23402]|0);gc(A|0,99280,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Yd[c[23386]&511](32);}while((z|0)>0)}if((x|0)!=0){Yd[c[23386]&511]((w|0)!=0?45:43)}z=c[23402]|0;do{if((z|0)<1){Yd[c[23386]&511](46);y=c[23386]|0;if((z|0)<0){G=y;J=z;while(1){Yd[G&511](48);I=J+1|0;K=c[23386]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Yd[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Yd[c[23386]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[23386]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Yd[P&511](a[J]|0);R=Q+ -1|0;S=c[23386]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Yd[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Yd[c[23386]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Yd[c[23386]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Yd[c[23386]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Yd[c[23386]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Yd[c[23386]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Yd[c[23386]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Yd[c[23386]&511](42);}while((_|0)>0);i=l;return 0}function TQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[23402]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(gc(n|0,99288,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[23382]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Yd[c[23386]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Yd[c[23386]&511](32);}while((b|0)>0)}do{if(q){if((c[23382]|0)==0){break}Yd[c[23386]&511](43)}else{Yd[c[23386]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Yd[c[23386]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Yd[c[23386]&511](48);}while((z|0)>0);i=j;return 0}function UQ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Yd[c[23386]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[23386]|0;if((h|0)==0){Yd[d&511](70);i=g;return 0}else{Yd[d&511](84);i=g;return 0}return 0}function VQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[23398]|0)!=0){g=WQ()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 36:{aR(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 31:{_Q(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 30:{ZQ(b,d);h=0;i=e;return h|0};case 10:{YQ(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 35:{aR(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=SQ(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 7:{XQ(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 29:{UQ(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 32:{XQ(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 28:case 27:{h=$Q(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 34:{YQ(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 23:{h=TQ(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;od(h|0,99296,f|0)|0;fQ(c[23322]|0,1)}}return 0}function WQ(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[23398]|0;c[23398]=0;if((c[23360]|0)!=0){if((b|0)>0){d=c[23400]|0;e=c[23396]|0;if((d|0)<=(e|0)){f=b;while(1){Yd[c[23386]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[23396]=f;h=0;i=a;return h|0}f=b-d+e|0;c[23396]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Yd[c[23386]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[23396]|0;f=j+b|0;if((f|0)>=0){if((c[23400]|0)<(j|0)){c[23400]=j}c[23396]=f;h=0;i=a;return h|0}if((c[c[23378]>>2]|0)==0){qQ(110,99384);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[23396]|0;if((c[23400]|0)<(f|0)){c[23400]=f}j=f+b|0;c[23396]=j;c[23404]=(c[23404]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[23378]>>2]|0)==0){qQ(110,99384);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[23396]|0;f=j+b|0;if((f|0)>=(c[(c[23380]|0)+16>>2]|0)){if((c[c[23378]>>2]|0)==0){qQ(110,99400);h=110;i=a;return h|0}else{c[(Lc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[23400]|0;if((d|0)<=(j|0)){e=b;while(1){Yd[c[23386]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[23404]=(c[23404]|0)+b;c[23396]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[23404]=(c[23404]|0)+f;c[23396]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Yd[c[23386]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function XQ(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=HQ(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[23382]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Yd[c[23386]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Yd[c[23386]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[23382]|0)==0){break}Yd[c[23386]&511](43)}else{Yd[c[23386]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Yd[c[23386]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function YQ(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=HQ(m,k,l,h)|0;h=c[l>>2]|0;g=(c[23382]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Yd[c[23386]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Yd[c[23386]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[23382]|0)==0){break}Yd[c[23386]&511](43)}else{Yd[c[23386]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Yd[c[23386]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Yd[c[23386]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Yd[c[23386]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function ZQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Yd[c[23386]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function _Q(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Yd[c[23386]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Yd[c[23386]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function $Q(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=SQ(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=SQ(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[23402]|0;c[23402]=0;p=(e|0)==0?4:e+2|0;e=TQ(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Yd[c[23386]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[23402]=o;n=e;i=j;return n|0}function aR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Yd[c[23386]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Yd[c[23386]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Yd[c[23386]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Yd[c[23386]&511](a[99360+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Yd[c[23386]&511](a[99360+((d[p]|0)>>>4)|0]|0);Yd[c[23386]&511](a[99360+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function bR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 12:{f=dR(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[23398]|0)-(c[a+4>>2]|0)|0;h=0-(c[23396]|0)|0;c[23398]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 15:{c[23398]=(c[a+4>>2]|0)+ -1-(c[23396]|0);f=1;i=b;return f|0};case 4:case 14:{c[23398]=(c[23398]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 5:{f=te[c[23394]&7]()|0;i=b;return f|0};case 11:{f=cR(c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;od(f|0,99328,d|0)|0;fQ(c[23322]|0,1)}}return 0}function cR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[23398]|0)!=0){e=WQ()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Yd[c[23386]&511](e<<24>>24);n=b}else{Yd[c[23386]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function dR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[23398]|0)!=0){f=WQ()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Yd[c[23386]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function eR(){var a=0,b=0;a=i;b=IQ(10)|0;c[23398]=0;c[23396]=0;c[23400]=0;i=a;return(b|0)==0|0}function fR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[23372]|0)==0){rQ()}c[23336]=0;c[23342]=1;c[23350]=1;c[23360]=1;d=OQ(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[23378]=a;c[23396]=0;c[23398]=0;c[23400]=0;c[24650]=0;c[23402]=0;d=c[a+12>>2]|0;c[23322]=d;c[23374]=c[c[22096]>>2];if((uQ(d)|0)<0){if((c[a>>2]|0)==0){qQ(100,99408);e=100;i=b;return e|0}else{c[(Lc()|0)>>2]=100;e=100;i=b;return e|0}}c[23386]=373;c[23388]=44;c[23390]=111;c[23376]=4;c[23392]=5;c[23394]=6;zQ();c[23382]=0;d=c[22096]|0;c[23384]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((sQ(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Lc()|0;f=c[a>>2]|0;if(d){qQ(f,99416);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function gR(){var a=0,b=0;a=i;if((c[24650]|0)==0){b=IQ(10)|0}else{IQ(0)|0;md(c[23374]|0)|0;b=0}c[23398]=0;c[23396]=0;c[23400]=0;i=a;return b|0}function hR(){var a=0,b=0,d=0;a=i;if((c[24634]|0)==0){b=0}else{d=IQ(10)|0;c[24634]=0;b=d}c[23398]=0;c[23396]=0;c[23400]=0;i=a;return b|0}function iR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;ER(100144,h,100200);c[24858]=101652;c[99440>>2]=101672;c[99436>>2]=0;vT(99440|0,100144);c[99512>>2]=0;c[99516>>2]=-1;j=c[t>>2]|0;c[25062]=101520;dZ(100252|0);k=100256|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25062]=100760;c[100280>>2]=j;eZ(g,100252|0);k=hZ(g,104312)|0;l=k;fZ(g);c[100284>>2]=l;c[100288>>2]=100208;a[100292|0]=($d[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[24880]=101732;c[99524>>2]=101752;vT(99524|0,100248);c[99596>>2]=0;c[99600>>2]=-1;l=c[r>>2]|0;c[25074]=101520;dZ(100300|0);k=100304|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[25074]=100760;c[100328>>2]=l;eZ(f,100300|0);k=hZ(f,104312)|0;g=k;fZ(f);c[100332>>2]=g;c[100336>>2]=100216;a[100340|0]=($d[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[24902]=101732;c[99612>>2]=101752;vT(99612|0,100296);c[99684>>2]=0;c[99688>>2]=-1;g=c[(c[(c[24902]|0)+ -12>>2]|0)+99632>>2]|0;c[24924]=101732;c[99700>>2]=101752;vT(99700|0,g);c[99772>>2]=0;c[99776>>2]=-1;c[(c[(c[24858]|0)+ -12>>2]|0)+99504>>2]=99520;g=(c[(c[24902]|0)+ -12>>2]|0)+99612|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[24902]|0)+ -12>>2]|0)+99680>>2]=99520;qR(100344,h,100224|0);c[24946]=101692;c[99792>>2]=101712;c[99788>>2]=0;vT(99792|0,100344);c[99864>>2]=0;c[99868>>2]=-1;c[25100]=101584;dZ(100404|0);h=100408|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25100]=100504;c[100432>>2]=j;eZ(e,100404|0);j=hZ(e,104320)|0;h=j;fZ(e);c[100436>>2]=h;c[100440>>2]=100232;a[100444|0]=($d[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[24968]=101772;c[99876>>2]=101792;vT(99876|0,100400);c[99948>>2]=0;c[99952>>2]=-1;c[25112]=101584;dZ(100452|0);h=100456|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[25112]=100504;c[100480>>2]=l;eZ(d,100452|0);l=hZ(d,104320)|0;h=l;fZ(d);c[100484>>2]=h;c[100488>>2]=100240;a[100492|0]=($d[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[24990]=101772;c[99964>>2]=101792;vT(99964|0,100448);c[100036>>2]=0;c[100040>>2]=-1;h=c[(c[(c[24990]|0)+ -12>>2]|0)+99984>>2]|0;c[25012]=101772;c[100052>>2]=101792;vT(100052|0,h);c[100124>>2]=0;c[100128>>2]=-1;c[(c[(c[24946]|0)+ -12>>2]|0)+99856>>2]=99872;h=(c[(c[24990]|0)+ -12>>2]|0)+99964|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[24990]|0)+ -12>>2]|0)+100032>>2]=99872;i=b;return}function jR(a){a=a|0;a=i;tU(99520)|0;tU(99696)|0;AU(99872)|0;AU(100048)|0;i=a;return}function kR(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);i=b;return}function lR(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);K0(a);i=b;return}function mR(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=hZ(d,104320)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function nR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=pe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function oR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=pc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((oe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function pR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=xe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function qR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=101584;j=b+4|0;dZ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=100616;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;eZ(g,j);j=hZ(g,104320)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){pY(100712)}else{fZ(g);i=f;return}}function rR(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);i=b;return}function sR(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);K0(a);i=b;return}function tR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=hZ(d,104320)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){pY(100712)}else{i=e;return}}function uR(a){a=a|0;var b=0,c=0;b=i;c=xR(a,0)|0;i=b;return c|0}function vR(a){a=a|0;var b=0,c=0;b=i;c=xR(a,1)|0;i=b;return c|0}function wR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=xe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((jd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function xR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=$c(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=xe[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=$c(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((jd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function yR(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);i=b;return}function zR(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);K0(a);i=b;return}function AR(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=hZ(d,104312)|0;d=f;c[b+36>>2]=d;a[b+44|0]=($d[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function BR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=pe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((pc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((md(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function CR(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=pc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((oe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function DR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((pc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=xe[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((pc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((pc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function ER(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=101520;j=b+4|0;dZ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=100872;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;eZ(g,j);j=hZ(g,104312)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=$d[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=($d[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){pY(100712)}else{fZ(g);i=f;return}}function FR(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);i=b;return}function GR(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);K0(a);i=b;return}function HR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=hZ(d,104312)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=$d[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=($d[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){pY(100712)}else{i=e;return}}function IR(a){a=a|0;var b=0,c=0;b=i;c=LR(a,0)|0;i=b;return c|0}function JR(a){a=a|0;var b=0,c=0;b=i;c=LR(a,1)|0;i=b;return c|0}function KR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=xe[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((jd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function LR(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=$c(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=xe[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=$c(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((jd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function MR(){var a=0;a=i;iR(0);Qd(374,100136,q|0)|0;i=a;return}function NR(a){a=a|0;i=i;return}function OR(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function PR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Yd[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function QR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=101016;e=e1(b|0)|0;f=J0(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;g1(g|0,b|0,e+1|0)|0;i=d;return}function RR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=101016;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}function SR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=101016;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function TR(a){a=a|0;i=i;return c[a+4>>2]|0}function UR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=101040;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=e1(f|0)|0;g=J0(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;g1(h|0,f|0,d+1|0)|0;i=e;return}function VR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=101040;e=e1(b|0)|0;f=J0(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;g1(g|0,b|0,e+1|0)|0;i=d;return}function WR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=101040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}function XR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=101040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);i=b;return}function YR(a){a=a|0;i=i;return c[a+4>>2]|0}function ZR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=101016;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}function _R(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=101016;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}L0((c[d>>2]|0)+ -12|0);g=a;h=g;yb(h|0);j=a;K0(j);i=b;return}function $R(a){a=a|0;i=i;return}function aS(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function bS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ve[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function cS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function dS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Nd(e|0)|0;e=e1(f|0)|0;if(e>>>0>4294967279){jS(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;g1(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=I0(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;g1(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function eS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{QS(e,101256,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ve[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}QS(e,o,p)|0;if((a[g]&1)==0){break}K0(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function fS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=e1(e|0)|0;if(j>>>0>4294967279){jS(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=I0(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}g1(k|0,e|0,j|0)|0;a[k+j|0]=0;eS(g,d,h);UR(b,g);if(!((a[g]&1)==0)){K0(c[g+8>>2]|0)}if(!((a[h]&1)==0)){K0(c[h+8>>2]|0)}c[b>>2]=101272;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function gS(a){a=a|0;var b=0;b=i;XR(a);K0(a);i=b;return}function hS(a){a=a|0;var b=0;b=i;XR(a);i=b;return}function iS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;rc(101408)|0;if((c[a>>2]|0)==1){do{hd(101432,101408)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;ec(101408)|0;Yd[d&511](b);rc(101408)|0;c[a>>2]=-1;ec(101408)|0;Yc(101432)|0;i=e;return}else{ec(101408)|0;i=e;return}}function jS(a){a=a|0;a=Cc(8)|0;QR(a,101480);c[a>>2]=101096;Kd(a|0,101136,40)}function kS(a){a=a|0;a=Cc(8)|0;QR(a,101480);c[a>>2]=101160;Kd(a|0,101200,40)}function lS(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mS(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){jS(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=I0(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}g1(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function oS(b){b=b|0;i=i;return(a[b]&1)!=0|0}function pS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){jS(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=I0(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}g1(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function qS(a){a=a|0;i=i;return a|0}function rS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=e1(d|0)|0;if(f>>>0>4294967279){jS(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;g1(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=I0(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;g1(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function sS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){jS(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=I0(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}i1(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function tS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){jS(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;i1(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=I0(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;i1(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function uS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){kS(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){jS(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;g1(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=I0(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;g1(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function vS(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function wS(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function xS(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}K0(c[b+8>>2]|0);i=d;return}function yS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}RS(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}h1(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function zS(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=AS(a,b)|0;i=c;return d|0}function AS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=e1(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}RS(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}h1(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function BS(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function CS(a){a=a|0;i=i;return a+1|0}function DS(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function ES(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function FS(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function GS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){HS(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function HS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){SS(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}i1(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function IS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){HS(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function JS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){jS(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=I0(f)|0}else{p=I0(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}g1(l|0,n|0,q+1|0)|0;if(o){K0(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function KS(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function LS(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function MS(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function NS(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function OS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=QS(b,g,h)|0;i=e;return d|0}function PS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){SS(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function QS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){RS(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}g1(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function RS(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){jS(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=I0(q)|0;if((g|0)!=0){g1(e|0,m|0,g|0)|0}if((j|0)!=0){g1(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){g1(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){K0(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function SS(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){jS(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=I0(p)|0;if((g|0)!=0){g1(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){g1(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}K0(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function TS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;uS(a,b,c,d,0);i=e;return}function US(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function VS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=e1(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function WS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=$0(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function XS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=e1(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){kS(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=$0(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function YS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){jS(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;g1(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=I0(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;g1(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function ZS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){jS(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=I0(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}d0(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function _S(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){jS(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=I0(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}f0(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function $S(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}K0(c[b+8>>2]|0);i=d;return}function aT(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=bT(a,b,c0(b)|0)|0;i=c;return d|0}function bT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}eT(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}e0(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function cT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){jS(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=I0(f)|0}else{p=I0(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}d0(l,n,q+1|0)|0;if(o){K0(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function dT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){fT(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function eT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){jS(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=I0(q<<2)|0;p=e;if((g|0)!=0){d0(p,m,g)|0}if((j|0)!=0){d0(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){d0(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){K0(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function fT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){jS(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=I0(p<<2)|0;o=e;if((g|0)!=0){d0(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){d0(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}K0(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function gT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=e1(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){jS(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=I0(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}g1(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=QS(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=QS(b,m,j)|0;i=f;return}}function hT(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function iT(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function jT(a,b){a=a|0;b=b|0;var c=0;c=i;kT(a,b);i=c;return}function kT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Cc(16)|0;do{if((a[101864]|0)==0){if((Ya(101864)|0)==0){break}c[25464]=102560;Qd(66,101856,q|0)|0;Rb(101864)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=101856;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];fS(b,f,101912);c[e>>2]=101880;Kd(e|0,101960,62)}function lT(a,b){a=a|0;b=b|0;var d=0;d=i;kT(a,c[a+16>>2]|b);i=d;return}function mT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=101904;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ve[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}fZ(a+28|0);D0(c[e>>2]|0);D0(c[f>>2]|0);D0(c[a+48>>2]|0);D0(c[a+60>>2]|0);i=b;return}function nT(a){a=a|0;var b=0;b=i;mT(a);K0(a);i=b;return}function oT(a){a=a|0;var b=0;b=i;mT(a);i=b;return}function pT(a){a=a|0;var b=0;b=i;mT(a);i=b;return}function qT(a){a=a|0;i=i;return c[a+24>>2]|0}function rT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}eZ(d,a+28|0);a=hZ(d,104248)|0;f=oe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;fZ(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function sT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;eZ(e,a+28|0);a=hZ(e,104248)|0;f=oe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;fZ(e);i=d;return f|0}function tT(a,b){a=a|0;b=b|0;var c=0;c=i;eZ(a,b+28|0);i=c;return}function uT(a){a=a|0;c[a>>2]=101504;i=i;return}function vT(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));dZ(b);i=d;return}function wT(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);K0(a);i=b;return}function xT(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);i=b;return}function yT(a){a=a|0;var b=0;b=i;c[a>>2]=101520;fZ(a+4|0);i=b;return}function zT(a,b){a=a|0;b=b|0;var c=0;c=i;eZ(a,b+4|0);i=c;return}function AT(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function BT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=oe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function CT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ce[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function DT(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=101520;dZ(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function ET(a){a=a|0;i=i;return c[a+8>>2]|0}function FT(a){a=a|0;i=i;return c[a+12>>2]|0}function GT(a){a=a|0;i=i;return c[a+16>>2]|0}function HT(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function IT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function JT(a){a=a|0;i=i;return c[a+20>>2]|0}function KT(a){a=a|0;i=i;return c[a+24>>2]|0}function LT(a){a=a|0;i=i;return c[a+28>>2]|0}function MT(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function NT(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function OT(a,b){a=a|0;b=b|0;i=i;return}function PT(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function QT(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function RT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function ST(a){a=a|0;i=i;return 0}function TT(a){a=a|0;i=i;return 0}function UT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=$d[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function VT(a){a=a|0;i=i;return-1}function WT(a){a=a|0;var b=0,e=0,f=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function XT(a,b){a=a|0;b=b|0;i=i;return-1}function YT(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((oe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function ZT(a,b){a=a|0;b=b|0;i=i;return-1}function _T(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);K0(a);i=b;return}function $T(a){a=a|0;var b=0;b=i;c[a>>2]=101584;fZ(a+4|0);i=b;return}function aU(a,b){a=a|0;b=b|0;i=i;return}function bU(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function cU(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function dU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function eU(a){a=a|0;i=i;return 0}function fU(a){a=a|0;i=i;return 0}function gU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=$d[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function hU(a){a=a|0;i=i;return-1}function iU(a){a=a|0;var b=0,d=0,e=0;b=i;if(($d[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function jU(a,b){a=a|0;b=b|0;i=i;return-1}function kU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((oe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function lU(a,b){a=a|0;b=b|0;i=i;return-1}function mU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));dZ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function nU(a){a=a|0;var b=0;b=i;mT(a+8|0);K0(a);i=b;return}function oU(a){a=a|0;var b=0;b=i;mT(a+8|0);i=b;return}function pU(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;mT(a+(d+8)|0);K0(a+d|0);i=b;return}function qU(a){a=a|0;var b=0;b=i;mT(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function rU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;sU(a,b,c);i=d;return}function sU(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){kT(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){tU(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}eZ(h,e+(k+28)|0);k=hZ(h,104248)|0;fZ(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){$d[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;kT(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function tU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{tU(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;kT(b+h|0,c[b+(h+16)>>2]|1)}}while(0);IU(e);i=d;return b|0}function uU(b){b=b|0;i=i;return(a[b]|0)!=0|0}function vU(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Eb()}}function wU(a){a=a|0;var b=0;b=i;mT(a+8|0);K0(a);i=b;return}function xU(a){a=a|0;var b=0;b=i;mT(a+8|0);i=b;return}function yU(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;mT(a+(d+8)|0);K0(a+d|0);i=b;return}function zU(a){a=a|0;var b=0;b=i;mT(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function AU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{AU(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!(($d[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;kT(b+h|0,c[b+(h+16)>>2]|1)}}while(0);UU(e);i=d;return b|0}function BU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));dZ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function CU(a){a=a|0;var b=0;b=i;mT(a+4|0);K0(a);i=b;return}function DU(a){a=a|0;var b=0;b=i;mT(a+4|0);i=b;return}function EU(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;mT(a+(d+4)|0);K0(a+d|0);i=b;return}function FU(a){a=a|0;var b=0;b=i;mT(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function GU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){tU(g)|0}a[f]=1;i=e;return}function HU(a){a=a|0;var b=0;b=i;IU(a);i=b;return}function IU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;kT(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function JU(b){b=b|0;i=i;return(a[b]|0)!=0|0}function KU(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=$d[b&127](a)|0;i=c;return d|0}function LU(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){IU(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{tU(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;eZ(k,b+(p+28)|0);p=hZ(k,102968)|0;m=p;fZ(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){eZ(h,b+(k+28)|0);r=hZ(h,104248)|0;s=oe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;fZ(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];fe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){IU(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;kT(b+l|0,c[b+(l+16)>>2]|5);IU(j);i=e;return b|0}function MU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){IU(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{tU(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;IU(f);i=e;return b|0}if((oe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{IU(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;kT(b+d|0,c[b+(d+16)>>2]|1);IU(f);i=e;return b|0}



function NU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){IU(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){tU(k)|0}a[h]=1;if((e|0)==0){IU(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ce[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){IU(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;kT(b+e|0,c[b+(e+16)>>2]|1);IU(g);i=f;return b|0}function OU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;ie[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function PU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){IU(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{tU(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];ze[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){IU(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;kT(b+f|0,c[b+(f+16)>>2]|4);IU(h);i=e;return b|0}function QU(a){a=a|0;var b=0;b=i;mT(a+4|0);K0(a);i=b;return}function RU(a){a=a|0;var b=0;b=i;mT(a+4|0);i=b;return}function SU(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;mT(a+(d+4)|0);K0(a+d|0);i=b;return}function TU(a){a=a|0;var b=0;b=i;mT(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function UU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(cb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!(($d[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;kT(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function VU(a){a=a|0;i=i;return 101800}function WU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){pS(a,101816,35);i=d;return}else{dS(a,b,c);i=d;return}}function XU(a){a=a|0;i=i;return}function YU(a){a=a|0;var b=0;b=i;hS(a);K0(a);i=b;return}function ZU(a){a=a|0;var b=0;b=i;hS(a);i=b;return}function _U(a){a=a|0;var b=0;b=i;mT(a);K0(a);i=b;return}function $U(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function aV(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function bV(a){a=a|0;i=i;return}function cV(a){a=a|0;i=i;return}function dV(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function eV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){jS(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=I0(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function fV(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function gV(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function hV(a){a=a|0;i=i;return}function iV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function jV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){jS(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=I0(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function kV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function lV(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function mV(a){a=a|0;i=i;return}function nV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];le[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}tT(u,g);m=u;u=c[m>>2]|0;if(!((c[26062]|0)==-1)){c[p>>2]=104248;c[p+4>>2]=375;c[p+8>>2]=0;iS(104248,p,376)}p=(c[104252>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}F=u;PR(c[m>>2]|0)|0;tT(v,g);g=v;v=c[g>>2]|0;if(!((c[26098]|0)==-1)){c[o>>2]=104392;c[o+4>>2]=375;c[o+8>>2]=0;iS(104392,o,376)}o=(c[104396>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}J=v;PR(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&127](g,J);Zd[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=oV(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];xS(w+12|0);xS(w);i=k;return}function oV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=C0(l)|0;if((n|0)!=0){o=n;p=n;break}P0()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if(($d[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!(($d[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=oe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(oe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){$d[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}D0(o);i=k;return _|0}function pV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];qV(a,0,k,j,f,g,h);i=b;return}function qV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;gW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}GS(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}GS(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((IV(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=c$(F,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}function rV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sV(a,0,k,j,f,g,h);i=b;return}function sV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;gW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}GS(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}GS(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((IV(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=b$(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}function tV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uV(a,0,k,j,f,g,h);i=b;return}function uV(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;gW(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if(($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}GS(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}GS(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((IV(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=a$(G,c[p>>2]|0,j,u)|0;tY(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;xS(o);xS(n);i=e;return}if(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;xS(o);xS(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;xS(o);xS(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;xS(o);xS(n);i=e;return}function vV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wV(a,0,k,j,f,g,h);i=b;return}function wV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;gW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}GS(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}GS(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((IV(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=$_(F,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}function xV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];yV(a,0,k,j,f,g,h);i=b;return}function yV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;gW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}GS(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}GS(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((IV(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=__(F,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;xS(n);xS(m);i=d;return}function zV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];AV(a,0,k,j,f,g,h);i=b;return}function AV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;gW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}GS(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}GS(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((IV(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Z_(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!(($d[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;xS(n);xS(m);i=d;return}function BV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CV(a,0,k,j,f,g,h);i=b;return}function CV(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;hW(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}GS(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}GS(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((iW(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+Y_(I,c[p>>2]|0,j);tY(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}function DV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EV(a,0,k,j,f,g,h);i=b;return}function EV(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;hW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}GS(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}GS(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((iW(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+X_(I,c[p>>2]|0,j);tY(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}function FV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GV(a,0,k,j,f,g,h);i=b;return}function GV(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;hW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}GS(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}GS(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((iW(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+W_(I,c[p>>2]|0,j);tY(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!(($d[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}if(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;xS(o);xS(n);i=d;return}function HV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;tT(o,g);g=o;o=c[g>>2]|0;if(!((c[26062]|0)==-1)){c[l>>2]=104248;c[l+4>>2]=375;c[l+8>>2]=0;iS(104248,l,376)}l=(c[104252>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}y=m;ye[c[(c[o>>2]|0)+32>>2]&63](o,102792,102818|0,y)|0;PR(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!(($d[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}GS(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}GS(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=($d[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((IV(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);K=c[26034]|0;c[k>>2]=j;if((JV(E,K,102832,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;xS(p);xS(n);i=d;return}if(($d[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;xS(p);xS(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;xS(p);xS(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;xS(p);xS(n);i=d;return}function IV(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[102792+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[102792+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function JV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=Wa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function KV(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function LV(a){a=a|0;i=i;return}function MV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];le[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}tT(u,g);m=u;u=c[m>>2]|0;if(!((c[26060]|0)==-1)){c[p>>2]=104240;c[p+4>>2]=375;c[p+8>>2]=0;iS(104240,p,376)}p=(c[104244>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}F=u;PR(c[m>>2]|0)|0;tT(v,g);g=v;v=c[g>>2]|0;if(!((c[26100]|0)==-1)){c[o>>2]=104400;c[o+4>>2]=375;c[o+8>>2]=0;iS(104400,o,376)}o=(c[104404>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}J=v;PR(c[g>>2]|0)|0;g=w;Zd[c[(c[v>>2]|0)+24>>2]&127](g,J);Zd[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=NV(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];$S(w+12|0);$S(w);i=k;return}function NV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=C0(l)|0;if((n|0)!=0){o=n;p=n;break}P0()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=oe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(oe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){$d[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}D0(o);i=k;return ba|0}function OV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];PV(a,0,k,j,f,g,h);i=b;return}function PV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;jW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}GS(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}GS(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((fW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=c$(I,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}function QV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];RV(a,0,k,j,f,g,h);i=b;return}function RV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;jW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}GS(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}GS(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((fW(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=b$(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}function SV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];TV(a,0,k,j,f,g,h);i=b;return}function TV(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;jW(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=$d[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}GS(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}GS(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((fW(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){$d[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=a$(J,c[p>>2]|0,j,u)|0;tY(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=$d[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;xS(o);xS(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;xS(o);xS(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;xS(o);xS(n);i=e;return}function UV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];VV(a,0,k,j,f,g,h);i=b;return}function VV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;jW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}GS(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}GS(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((fW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=$_(I,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}function WV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XV(a,0,k,j,f,g,h);i=b;return}function XV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;jW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}GS(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}GS(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((fW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=__(I,c[o>>2]|0,h,t)|0;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;xS(n);xS(m);i=d;return}function YV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZV(a,0,k,j,f,g,h);i=b;return}function ZV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;jW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=$d[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=$d[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}GS(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}GS(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((fW(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){$d[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Z_(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;tY(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=$d[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=$d[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;xS(n);xS(m);i=d;return}function _V(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$V(a,0,k,j,f,g,h);i=b;return}function $V(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;kW(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}GS(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}GS(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((lW(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+Y_(L,c[p>>2]|0,j);tY(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}function aW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];bW(a,0,k,j,f,g,h);i=b;return}function bW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;kW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}GS(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}GS(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((lW(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+X_(L,c[p>>2]|0,j);tY(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}function cW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dW(a,0,k,j,f,g,h);i=b;return}function dW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;kW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}GS(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}GS(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((lW(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+W_(L,c[p>>2]|0,j);tY(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=$d[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;xS(o);xS(n);i=d;return}function eW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;tT(o,g);g=o;o=c[g>>2]|0;if(!((c[26060]|0)==-1)){c[l>>2]=104240;c[l+4>>2]=375;c[l+8>>2]=0;iS(104240,l,376)}l=(c[104244>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}y=m;ye[c[(c[o>>2]|0)+48>>2]&63](o,102792,102818|0,y)|0;PR(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;GS(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=$d[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=$d[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}GS(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}GS(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((fW(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){$d[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);N=c[26034]|0;c[k>>2]=j;if((JV(H,N,102832,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=$d[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=$d[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;xS(p);xS(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;xS(p);xS(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;xS(p);xS(n);i=d;return}function fW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[102792+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[102792+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function gW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;tT(k,d);d=k;k=c[d>>2]|0;if(!((c[26062]|0)==-1)){c[j>>2]=104248;c[j+4>>2]=375;c[j+8>>2]=0;iS(104248,j,376)}j=(c[104252>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;h0(n);o=119808;p=127;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;h0(n);o=119808;p=127;Kd(m|0,o|0,p|0)}ye[c[(c[k>>2]|0)+32>>2]&63](k,102792,102818|0,e)|0;e=c[d>>2]|0;if(!((c[26098]|0)==-1)){c[h>>2]=104392;c[h+4>>2]=375;c[h+8>>2]=0;iS(104392,h,376)}h=(c[104396>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}else{t=e;a[f]=$d[c[(c[e>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[e>>2]|0)+20>>2]&127](b,t);PR(c[d>>2]|0)|0;i=g;return}}function hW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;tT(l,d);d=l;l=c[d>>2]|0;if(!((c[26062]|0)==-1)){c[k>>2]=104248;c[k+4>>2]=375;c[k+8>>2]=0;iS(104248,k,376)}k=(c[104252>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Cc(4)|0;o=n;h0(o);p=119808;q=127;Kd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Cc(4)|0;o=n;h0(o);p=119808;q=127;Kd(n|0,p|0,q|0)}ye[c[(c[l>>2]|0)+32>>2]&63](l,102792,102824|0,e)|0;e=c[d>>2]|0;if(!((c[26098]|0)==-1)){c[j>>2]=104392;c[j+4>>2]=375;c[j+8>>2]=0;iS(104392,j,376)}j=(c[104396>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Cc(4)|0;s=r;h0(s);t=119808;u=127;Kd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Cc(4)|0;s=r;h0(s);t=119808;u=127;Kd(r|0,t|0,u|0)}else{u=e;a[f]=$d[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=$d[c[(c[e>>2]|0)+16>>2]&127](u)|0;Zd[c[(c[e>>2]|0)+20>>2]&127](b,u);PR(c[d>>2]|0)|0;i=h;return}}function iW(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[102792+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function jW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;tT(j,b);b=j;j=c[b>>2]|0;if(!((c[26060]|0)==-1)){c[h>>2]=104240;c[h+4>>2]=375;c[h+8>>2]=0;iS(104240,h,376)}h=(c[104244>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Cc(4)|0;m=l;h0(m);n=119808;o=127;Kd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Cc(4)|0;m=l;h0(m);n=119808;o=127;Kd(l|0,n|0,o|0)}ye[c[(c[j>>2]|0)+48>>2]&63](j,102792,102818|0,d)|0;d=c[b>>2]|0;if(!((c[26100]|0)==-1)){c[g>>2]=104400;c[g+4>>2]=375;c[g+8>>2]=0;iS(104400,g,376)}g=(c[104404>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}else{s=d;c[e>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](s)|0;Zd[c[(c[d>>2]|0)+20>>2]&127](a,s);PR(c[b>>2]|0)|0;i=f;return}}function kW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;tT(k,b);b=k;k=c[b>>2]|0;if(!((c[26060]|0)==-1)){c[j>>2]=104240;c[j+4>>2]=375;c[j+8>>2]=0;iS(104240,j,376)}j=(c[104244>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Cc(4)|0;n=m;h0(n);o=119808;p=127;Kd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Cc(4)|0;n=m;h0(n);o=119808;p=127;Kd(m|0,o|0,p|0)}ye[c[(c[k>>2]|0)+48>>2]&63](k,102792,102824|0,d)|0;d=c[b>>2]|0;if(!((c[26100]|0)==-1)){c[h>>2]=104400;c[h+4>>2]=375;c[h+8>>2]=0;iS(104400,h,376)}h=(c[104404>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}else{t=d;c[e>>2]=$d[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=$d[c[(c[d>>2]|0)+16>>2]&127](t)|0;Zd[c[(c[d>>2]|0)+20>>2]&127](a,t);PR(c[b>>2]|0)|0;i=g;return}}function lW(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[102792+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function mW(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function nW(a){a=a|0;i=i;return}function oW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ie[p&31](b,d,k,f,g,q);i=j;return}tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26098]|0)==-1)){c[l>>2]=104392;c[l+4>>2]=375;c[l+8>>2]=0;iS(104392,l,376)}l=(c[104396>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}w=n;PR(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&127](o,w)}else{Zd[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((oe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];xS(o);i=j;return}function pW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=103040;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);v=c[26034]|0;c[k>>2]=h;h=qW(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;tT(q,f);rW(w,y,k,z,o,p,q);PR(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];WO(b,j,z,e,o,f,g);i=d;return}function qW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Jc(d|0)|0;d=lc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Jc(f|0)|0;i=g;return d|0}function rW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26062]|0)==-1)){c[m>>2]=104248;c[m+4>>2]=375;c[m+8>>2]=0;iS(104248,m,376)}m=(c[104252>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26098]|0)==-1)){c[l>>2]=104392;c[l+4>>2]=375;c[l+8>>2]=0;iS(104392,l,376)}l=(c[104396>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ye[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=oe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=oe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=oe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=oe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;xS(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;xS(n);i=k;return}}function sW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);y=c[26034]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=qW(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;tT(r,f);rW(x,z,l,A,p,q,r);PR(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];WO(b,k,A,e,p,f,g);i=d;return}function tW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=103040;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);v=c[26034]|0;c[k>>2]=h;h=qW(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;tT(q,f);rW(w,y,k,z,o,p,q);PR(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];WO(b,j,z,e,o,f,g);i=d;return}function uW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);w=c[26034]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=qW(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;tT(r,f);rW(x,z,l,A,p,q,r);PR(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];WO(b,k,A,e,p,f,g);i=d;return}function vW(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=qW(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=qW(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[104144]|0)==0;if(F){do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=wW(s,r,z,n)|0}else{do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=wW(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}P0()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=C0(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}P0()}}while(0);tT(w,f);xW(N,L,G,P,u,v,w);PR(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];WO(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){D0(O)}if((J|0)==0){i=d;return}D0(J);i=d;return}function wW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Jc(b|0)|0;b=ic(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Jc(e|0)|0;i=f;return b|0}function xW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26062]|0)==-1)){c[m>>2]=104248;c[m+4>>2]=375;c[m+8>>2]=0;iS(104248,m,376)}m=(c[104252>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26098]|0)==-1)){c[l>>2]=104392;c[l+4>>2]=375;c[l+8>>2]=0;iS(104392,l,376)}l=(c[104396>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=oe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=oe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=oe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[26034]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[26034]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ye[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=oe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=oe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);ye[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;xS(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;xS(n);i=k;return}



function yW(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=qW(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=qW(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[104144]|0)==0;if(F){do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=wW(s,r,z,n)|0}else{do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=wW(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}P0()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=C0(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}P0()}}while(0);tT(w,f);xW(N,L,G,P,u,v,w);PR(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];WO(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){D0(O)}if((J|0)==0){i=d;return}D0(J);i=d;return}function zW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=103048;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);s=c[26034]|0;c[k>>2]=h;h=qW(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;tT(p,f);r=p;p=c[r>>2]|0;if(!((c[26062]|0)==-1)){c[l>>2]=104248;c[l+4>>2]=375;c[l+8>>2]=0;iS(104248,l,376)}l=(c[104252>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}PR(c[r>>2]|0)|0;ye[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];WO(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];WO(b,j,u,z,m,f,g);I=j;i=d;return}function AW(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function BW(a){a=a|0;i=i;return}function CW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ie[p&31](b,d,k,f,g,q);i=j;return}tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26100]|0)==-1)){c[l>>2]=104400;c[l+4>>2]=375;c[l+8>>2]=0;iS(104400,l,376)}l=(c[104404>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}w=n;PR(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Zd[c[f+24>>2]&127](o,w)}else{Zd[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=oe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];$S(o);i=j;return}function DW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=103040;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);x=c[26034]|0;c[k>>2]=h;h=qW(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;tT(q,f);EW(w,y,k,z,o,p,q);PR(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];FW(b,j,z,e,o,f,g);i=d;return}function EW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26060]|0)==-1)){c[m>>2]=104240;c[m+4>>2]=375;c[m+8>>2]=0;iS(104240,m,376)}m=(c[104244>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26100]|0)==-1)){c[l>>2]=104400;c[l+4>>2]=375;c[l+8>>2]=0;iS(104400,l,376)}l=(c[104404>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){ye[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=oe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=oe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=oe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=oe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;xS(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;xS(n);i=k;return}function FW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ce[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){_S(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ce[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){$S(l);break}c[m>>2]=0;c[b>>2]=0;$S(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ce[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function GW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);w=c[26034]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=qW(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;tT(r,f);EW(x,z,l,A,p,q,r);PR(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];FW(b,k,A,e,p,f,g);i=d;return}function HW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=103040;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);v=c[26034]|0;c[k>>2]=h;h=qW(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;tT(q,f);EW(w,y,k,z,o,p,q);PR(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];FW(b,j,z,e,o,f,g);i=d;return}function IW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);w=c[26034]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=qW(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;tT(r,f);EW(x,z,l,A,p,q,r);PR(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];FW(b,k,A,e,p,f,g);i=d;return}function JW(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=qW(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=qW(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[104144]|0)==0;if(F){do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=wW(s,r,z,n)|0}else{do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=wW(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}P0()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=C0(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}P0()}}while(0);tT(w,f);KW(N,L,G,P,u,v,w);PR(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];FW(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){D0(O)}if((J|0)==0){i=d;return}D0(J);i=d;return}function KW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[26060]|0)==-1)){c[m>>2]=104240;c[m+4>>2]=375;c[m+8>>2]=0;iS(104240,m,376)}m=(c[104244>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Cc(4)|0;r=q;h0(r);s=119808;t=127;Kd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[26100]|0)==-1)){c[l>>2]=104400;c[l+4>>2]=375;c[l+8>>2]=0;iS(104400,l,376)}l=(c[104404>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Cc(4)|0;v=u;h0(v);w=119808;x=127;Kd(u|0,w|0,x|0)}x=s;Zd[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=oe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=oe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=oe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);w=A+1|0;if((Uc(l<<24>>24|0,c[26034]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);l=D+1|0;if((Md(A<<24>>24|0,c[26034]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){ye[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=$d[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=oe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=oe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=$d[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);ye[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;xS(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;xS(n);i=k;return}function LW(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=qW(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=qW(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[104144]|0)==0;if(F){do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);r=c[26034]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=wW(s,r,z,n)|0}else{do{if(o){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=wW(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}P0()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=C0(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}P0()}}while(0);tT(w,f);KW(N,L,G,P,u,v,w);PR(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];FW(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){D0(O)}if((J|0)==0){i=d;return}D0(J);i=d;return}function MW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=103048;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);s=c[26034]|0;c[k>>2]=h;h=qW(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}tT(p,f);u=p;p=c[u>>2]|0;if(!((c[26060]|0)==-1)){c[l>>2]=104240;c[l+4>>2]=375;c[l+8>>2]=0;iS(104240,l,376)}l=(c[104244>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}PR(c[u>>2]|0)|0;u=o;ye[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];FW(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];FW(b,j,u,z,m,f,g);I=j;i=d;return}function NW(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;tT(r,h);v=r;r=c[v>>2]|0;if(!((c[26062]|0)==-1)){c[q>>2]=104248;c[q+4>>2]=375;c[q+8>>2]=0;iS(104248,q,376)}q=(c[104252>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Cc(4)|0;y=x;h0(y);z=119808;A=127;Kd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Cc(4)|0;y=x;h0(y);z=119808;A=127;Kd(x|0,z|0,A|0)}A=r;PR(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!(($d[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ce[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=($d[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=oe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(oe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ce[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ce[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];ne[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!(($d[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if(($d[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){$d[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!(($d[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!(($d[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function OW(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function PW(a){a=a|0;i=i;return}function QW(a){a=a|0;i=i;return 2}function RW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];NW(a,b,l,k,f,g,h,103152,103160|0);i=j;return}function SW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];NW(b,d,m,l,g,h,j,s,q);i=k;return}function TW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26062]|0)==-1)){c[m>>2]=104248;c[m+4>>2]=375;c[m+8>>2]=0;iS(104248,m,376)}m=(c[104252>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}s=n;PR(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=oV(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function UW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26062]|0)==-1)){c[m>>2]=104248;c[m+4>>2]=375;c[m+8>>2]=0;iS(104248,m,376)}m=(c[104252>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}s=n;PR(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=oV(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function VW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;tT(m,f);f=m;m=c[f>>2]|0;if(!((c[26062]|0)==-1)){c[l>>2]=104248;c[l+4>>2]=375;c[l+8>>2]=0;iS(104248,l,376)}l=(c[104252>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;h0(p);q=119808;r=127;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;h0(p);q=119808;r=127;Kd(o|0,q|0,r|0)}r=m;PR(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=_W(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function WW(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;tT(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26062]|0)==-1)){c[ba>>2]=104248;c[ba+4>>2]=375;c[ba+8>>2]=0;iS(104248,ba,376)}ba=(c[104252>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;h0(Ga);Ha=119808;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;h0(Ga);Ha=119808;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;PR(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=_W(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=_W(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];le[Da&63](b,d,s,r,g,h,j);i=l;return};case 99:{Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+1|0;Ka=ca+1|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];NW(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[da>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=_W(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=_W(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=_W(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];NW(ra,d,y,x,g,h,j,103192,103197|0);c[ca>>2]=c[ra>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];YW(d,j+8|0,e,B,h,Ia);break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];NW(ua,d,v,u,g,h,j,103200,103208|0);c[ca>>2]=c[ua>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=_W(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=_W(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];XW(0,e,C,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=_W(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ma=ca+2e3|0}else{Ma=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ma+ -1900;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=_W(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+1|0;Oa=ca+1|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];NW(za,d,q,p,g,h,j,Oa,Na+Pa|0);c[Da>>2]=c[za>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=_W(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];ZW(0,e,m,h,Ia);break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];NW(ga,d,L,K,g,h,j,103160,103168|0);c[Da>>2]=c[ga>>2];break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=$d[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(oV(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];NW(ja,d,J,I,g,h,j,103168,103176|0);c[Da>>2]=c[ja>>2];break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=$d[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(oV(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];NW(oa,d,A,z,g,h,j,103176,103187|0);c[Da>>2]=c[oa>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function XW(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if(($d[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){$d[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if(($d[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!(($d[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function YW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=oV(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function ZW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ce[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){$d[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!(($d[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function _W(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if(($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=($d[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ce[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if(($d[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!(($d[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ce[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if(($d[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!(($d[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function $W(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;tT(p,f);t=p;p=c[t>>2]|0;if(!((c[26060]|0)==-1)){c[o>>2]=104240;c[o+4>>2]=375;c[o+8>>2]=0;iS(104240,o,376)}o=(c[104244>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Cc(4)|0;w=v;h0(w);x=119808;y=127;Kd(v|0,x|0,y|0)}y=p;PR(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ce[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ce[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=$d[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=oe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(oe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ce[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ce[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];ne[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ce[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=$d[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=$d[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ce[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){$d[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){$d[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function aX(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function bX(a){a=a|0;i=i;return}function cX(a){a=a|0;i=i;return 2}function dX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];$W(a,b,l,k,f,g,h,103304,103336|0);i=j;return}function eX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=$d[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];$W(b,d,m,l,g,h,j,s,q);i=k;return}function fX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26060]|0)==-1)){c[m>>2]=104240;c[m+4>>2]=375;c[m+8>>2]=0;iS(104240,m,376)}m=(c[104244>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}s=n;PR(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=NV(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function gX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;tT(n,f);f=n;n=c[f>>2]|0;if(!((c[26060]|0)==-1)){c[m>>2]=104240;c[m+4>>2]=375;c[m+8>>2]=0;iS(104240,m,376)}m=(c[104244>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Cc(4)|0;q=p;h0(q);r=119808;s=127;Kd(p|0,r|0,s|0)}s=n;PR(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=$d[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=NV(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function hX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;tT(m,f);f=m;m=c[f>>2]|0;if(!((c[26060]|0)==-1)){c[l>>2]=104240;c[l+4>>2]=375;c[l+8>>2]=0;iS(104240,l,376)}l=(c[104244>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Cc(4)|0;p=o;h0(p);q=119808;r=127;Kd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Cc(4)|0;p=o;h0(p);q=119808;r=127;Kd(o|0,q|0,r|0)}r=m;PR(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=mX(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function iX(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;tT(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[26060]|0)==-1)){c[ba>>2]=104240;c[ba+4>>2]=375;c[ba+8>>2]=0;iS(104240,ba,376)}ba=(c[104244>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Cc(4)|0;Ga=Fa;h0(Ga);Ha=119808;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Cc(4)|0;Ga=Fa;h0(Ga);Ha=119808;Ia=127;Kd(Fa|0,Ha|0,Ia|0)}Ia=ca;PR(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=mX(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];le[ca&63](b,d,s,r,g,h,j);i=l;return};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=mX(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];$W(ra,d,y,x,g,h,j,103448,103468|0);c[Da>>2]=c[ra>>2];break};case 99:{Da=d+8|0;ca=$d[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ja=Fa;Ka=Fa;La=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];$W(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[da>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=mX(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];kX(d,j+8|0,e,B,h,Ia);break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];$W(ua,d,v,u,g,h,j,103472,103504|0);c[ca>>2]=c[ua>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=mX(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=mX(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ma=Da+2e3|0}else{Ma=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ma+ -1900;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=mX(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];lX(0,e,m,h,Ia);break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];jX(0,e,C,h,Ia);break};case 88:{ca=d+8|0;Da=$d[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];$W(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[za>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=mX(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];$W(ga,d,L,K,g,h,j,103336,103368|0);c[Da>>2]=c[ga>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=mX(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=mX(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];$W(ja,d,J,I,g,h,j,103368,103400|0);c[ca>>2]=c[ja>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];$W(oa,d,A,z,g,h,j,103400,103444|0);c[ca>>2]=c[oa>>2];break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=$d[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(NV(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 104:case 66:case 98:{ca=c[f>>2]|0;Ha=d+8|0;Da=$d[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(NV(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=mX(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function jX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ce[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){$d[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function kX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=$d[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=NV(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function lX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=$d[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ce[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){$d[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=$d[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=$d[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function mX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=$d[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=$d[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=$d[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ce[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ce[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){$d[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=$d[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=$d[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ce[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ce[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){$d[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=$d[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=$d[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function nX(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);if((f|0)==(c[26034]|0)){g=b;K0(g);i=d;return}_b(c[e>>2]|0);g=b;K0(g);i=d;return}function oX(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);if((b|0)==(c[26034]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function pX(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Qc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(oe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function qX(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);if((f|0)==(c[26034]|0)){g=b;K0(g);i=d;return}_b(c[e>>2]|0);g=b;K0(g);i=d;return}function rX(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);if((b|0)==(c[26034]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function sX(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;tX(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=oe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function tX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Qc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Jc(c[g>>2]|0)|0;g=F$(d,m,n,l)|0;if((f|0)!=0){Jc(f|0)|0}if((g|0)==-1){pY(105128)}else{c[e>>2]=d+(g<<2);i=j;return}}function uX(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function vX(a){a=a|0;i=i;return}function wX(a){a=a|0;i=i;return 127}function xX(a){a=a|0;i=i;return 127}function yX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function AX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function BX(a,b){a=a|0;b=b|0;b=i;tS(a,1,45);i=b;return}function CX(a){a=a|0;i=i;return 0}function DX(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function EX(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function FX(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function GX(a){a=a|0;i=i;return}function HX(a){a=a|0;i=i;return 127}function IX(a){a=a|0;i=i;return 127}function JX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function KX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function LX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function MX(a,b){a=a|0;b=b|0;b=i;tS(a,1,45);i=b;return}function NX(a){a=a|0;i=i;return 0}function OX(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function PX(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function QX(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function RX(a){a=a|0;i=i;return}function SX(a){a=a|0;i=i;return 2147483647}function TX(a){a=a|0;i=i;return 2147483647}function UX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function VX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function WX(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function XX(a,b){a=a|0;b=b|0;b=i;_S(a,1,45);i=b;return}function YX(a){a=a|0;i=i;return 0}function ZX(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function _X(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function $X(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function aY(a){a=a|0;i=i;return}function bY(a){a=a|0;i=i;return 2147483647}function cY(a){a=a|0;i=i;return 2147483647}function dY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function eY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function fY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function gY(a,b){a=a|0;b=b|0;b=i;_S(a,1,45);i=b;return}function hY(a){a=a|0;i=i;return 0}function iY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function jY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function kY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function lY(a){a=a|0;i=i;return}function mY(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=377;y=o+100|0;tT(r,h);o=r;z=c[o>>2]|0;if(!((c[26062]|0)==-1)){c[n>>2]=104248;c[n+4>>2]=375;c[n+8>>2]=0;iS(104248,n,376)}n=(c[104252>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=oY(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ye[c[(c[z>>2]|0)+32>>2]&63](E,103864,103874|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=C0(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}P0()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[103864+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,103880,m|0)|0)!=1){t=Cc(8)|0;VR(t,103888);Kd(t|0,101240,42)}if((F|0)==0){break}D0(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;PR(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&511](o);i=d;return}function nY(a){a=a|0;i=i;return}function oY(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;sY(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=377;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if(($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=($d[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){$d[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=($d[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){$d[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=($d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){$d[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=($d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){$d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 0:{X=26;break};case 4:{ea=D;oa=R;qa=r;ra=Q;sa=0;pa=T;c:while(1){Ia=c[h>>2]|0;do{if((Ia|0)==0){Ja=0}else{if((c[Ia+12>>2]|0)!=(c[Ia+16>>2]|0)){Ja=Ia;break}if(($d[c[(c[Ia>>2]|0)+36>>2]&127](Ia)|0)==-1){c[h>>2]=0;Ja=0;break}else{Ja=c[h>>2]|0;break}}}while(0);Ia=(Ja|0)==0;Ka=c[e>>2]|0;do{if((Ka|0)==0){X=173}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){if(Ia){break}else{break c}}if(($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ia){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ia){break}}Ka=c[h>>2]|0;La=c[Ka+12>>2]|0;if((La|0)==(c[Ka+16>>2]|0)){Ma=($d[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)&255}else{Ma=a[La]|0}do{if(Ma<<24>>24>-1){if((b[(c[f>>2]|0)+(Ma<<24>>24<<1)>>1]&2048)==0){X=189;break}La=c[o>>2]|0;if((La|0)==(ea|0)){Ka=(c[P>>2]|0)!=377;Na=c[t>>2]|0;Oa=ea-Na|0;Pa=Oa>>>0<2147483647?Oa<<1:-1;Qa=F0(Ka?Na:0,Pa)|0;if((Qa|0)==0){X=182;break a}do{if(Ka){c[t>>2]=Qa;Ra=Qa}else{Na=c[t>>2]|0;c[t>>2]=Qa;if((Na|0)==0){Ra=Qa;break}Yd[c[P>>2]&511](Na);Ra=c[t>>2]|0}}while(0);c[P>>2]=352;Qa=Ra+Oa|0;c[o>>2]=Qa;Sa=Qa;Ta=(c[t>>2]|0)+Pa|0}else{Sa=La;Ta=ea}c[o>>2]=Sa+1;a[Sa]=Ma;Ua=Ta;Va=oa;Wa=qa;Xa=ra;Ya=sa+1|0;Za=pa}else{X=189}}while(0);if((X|0)==189){X=0;Ia=a[w]|0;if((Ia&1)==0){_a=(Ia&255)>>>1}else{_a=c[n>>2]|0}if((_a|0)==0|(sa|0)==0){break}if(!(Ma<<24>>24==(a[v]|0))){break}if((qa|0)==(ra|0)){Ia=qa-oa|0;Qa=Ia>>>0<2147483647?Ia<<1:-1;if((pa|0)==377){$a=0}else{$a=oa}Ka=F0($a,Qa)|0;if((Ka|0)==0){X=198;break a}ab=Ka;bb=Ka+(Ia>>2<<2)|0;cb=Ka+(Qa>>>2<<2)|0;db=352}else{ab=oa;bb=qa;cb=ra;db=pa}c[bb>>2]=sa;Ua=ea;Va=ab;Wa=bb+4|0;Xa=cb;Ya=0;Za=db}Qa=c[h>>2]|0;Ka=Qa+12|0;Ia=c[Ka>>2]|0;if((Ia|0)==(c[Qa+16>>2]|0)){$d[c[(c[Qa>>2]|0)+40>>2]&127](Qa)|0;ea=Ua;oa=Va;qa=Wa;ra=Xa;sa=Ya;pa=Za;continue}else{c[Ka>>2]=Ia+1;ea=Ua;oa=Va;qa=Wa;ra=Xa;sa=Ya;pa=Za;continue}}if((oa|0)==(qa|0)|(sa|0)==0){eb=oa;fb=qa;gb=ra;hb=pa}else{if((qa|0)==(ra|0)){W=qa-oa|0;da=W>>>0<2147483647?W<<1:-1;if((pa|0)==377){ib=0}else{ib=oa}ba=F0(ib,da)|0;if((ba|0)==0){X=209;break a}jb=ba;kb=ba+(W>>2<<2)|0;lb=ba+(da>>>2<<2)|0;mb=352}else{jb=oa;kb=qa;lb=ra;mb=pa}c[kb>>2]=sa;eb=jb;fb=kb+4|0;gb=lb;hb=mb}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){nb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){nb=da;break}if(($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;nb=0;break}else{nb=c[h>>2]|0;break}}}while(0);da=(nb|0)==0;sa=c[e>>2]|0;do{if((sa|0)==0){X=223}else{if((c[sa+12>>2]|0)!=(c[sa+16>>2]|0)){if(da){ob=sa;break}else{X=229;break a}}if(($d[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){ob=sa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{ob=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){pb=($d[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{pb=a[pa]|0}if(!(pb<<24>>24==(a[u]|0))){X=229;break a}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){$d[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;qb=ob;rb=ob;sb=ea}else{c[sa>>2]=ra+1;qb=ob;rb=ob;sb=ea}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){tb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){tb=ra;break}if(($d[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;tb=0;break}else{tb=c[h>>2]|0;break}}}while(0);ra=(tb|0)==0;do{if((rb|0)==0){ub=qb;X=243}else{if((c[rb+12>>2]|0)!=(c[rb+16>>2]|0)){if(ra){vb=qb;wb=rb;break}else{X=250;break a}}if(($d[c[(c[rb>>2]|0)+36>>2]&127](rb)|0)==-1){c[e>>2]=0;ub=0;X=243;break}else{if(ra^(qb|0)==0){vb=qb;wb=qb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{vb=ub;wb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){xb=($d[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{xb=a[pa]|0}if(!(xb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(xb<<24>>24<<1)>>1]&2048)==0){X=250;break a}pa=c[o>>2]|0;if((pa|0)==(sb|0)){sa=(c[P>>2]|0)!=377;qa=c[t>>2]|0;oa=sb-qa|0;ba=oa>>>0<2147483647?oa<<1:-1;W=F0(sa?qa:0,ba)|0;if((W|0)==0){X=253;break a}do{if(sa){c[t>>2]=W;yb=W}else{qa=c[t>>2]|0;c[t>>2]=W;if((qa|0)==0){yb=W;break}Yd[c[P>>2]&511](qa);yb=c[t>>2]|0}}while(0);c[P>>2]=352;W=yb+oa|0;c[o>>2]=W;zb=W;Ab=(c[t>>2]|0)+ba|0}else{zb=pa;Ab=sb}W=c[h>>2]|0;sa=c[W+12>>2]|0;if((sa|0)==(c[W+16>>2]|0)){ra=($d[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255;Bb=ra;Cb=c[o>>2]|0}else{Bb=a[sa]|0;Cb=zb}c[o>>2]=Cb+1;a[Cb]=Bb;sa=(c[B>>2]|0)+ -1|0;c[B>>2]=sa;ra=c[h>>2]|0;W=ra+12|0;qa=c[W>>2]|0;if((qa|0)==(c[ra+16>>2]|0)){$d[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[W>>2]=qa+1}if((sa|0)>0){qb=vb;rb=wb;sb=Ab}else{Db=Ab;break}}}else{Db=ea}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Db;ha=eb;ia=fb;ja=gb;ka=S;la=hb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Eb=(a[O]|0)!=0}else{Eb=0}if(!(I|Eb)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;sa=(da&1)==0;qa=sa?j:c[J>>2]|0;d:do{if((p|0)==0){Fb=Y;Gb=Y;Hb=da;Ib=qa}else{if((d[s+(p+ -1)|0]|0)>=2){Fb=Y;Gb=Y;Hb=da;Ib=qa;break}W=qa+(sa?(da&255)>>>1:c[K>>2]|0)|0;ra=qa;while(1){if((ra|0)==(W|0)){Jb=W;break}Ia=a[ra]|0;if(!(Ia<<24>>24>-1)){Jb=ra;break}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){Jb=ra;break}else{ra=ra+1|0}}ra=Jb-qa|0;W=a[A]|0;pa=(W&1)==0;if(pa){Kb=(W&255)>>>1}else{Kb=c[N>>2]|0}if(ra>>>0>Kb>>>0){Fb=Y;Gb=Y;Hb=da;Ib=qa;break}if(pa){pa=(W&255)>>>1;Lb=A+1+(pa-ra)|0;Mb=L;Nb=pa}else{pa=c[M>>2]|0;W=c[N>>2]|0;Lb=pa+(W-ra)|0;Mb=pa;Nb=W}W=Mb+Nb|0;if((Lb|0)==(W|0)){Fb=Y;Gb=Y;Hb=da;Ib=Jb;break}else{Ob=qa;Pb=Lb}while(1){if((a[Pb]|0)!=(a[Ob]|0)){Fb=Y;Gb=Y;Hb=da;Ib=qa;break d}pa=Pb+1|0;if((pa|0)==(W|0)){Fb=Y;Gb=Y;Hb=da;Ib=Jb;break}else{Ob=Ob+1|0;Pb=pa}}}}while(0);e:while(1){if((Hb&1)==0){Qb=j;Rb=(Hb&255)>>>1}else{Qb=c[J>>2]|0;Rb=c[K>>2]|0}if((Ib|0)==(Qb+Rb|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Sb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Sb=da;break}if(($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Sb=0;break}else{Sb=c[h>>2]|0;break}}}while(0);da=(Sb|0)==0;do{if((Gb|0)==0){Tb=Fb;X=147}else{if((c[Gb+12>>2]|0)!=(c[Gb+16>>2]|0)){if(da){Ub=Fb;Vb=Gb;break}else{break e}}if(($d[c[(c[Gb>>2]|0)+36>>2]&127](Gb)|0)==-1){c[e>>2]=0;Tb=0;X=147;break}else{if(da^(Fb|0)==0){Ub=Fb;Vb=Fb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Ub=Tb;Vb=0}}qa=c[h>>2]|0;sa=c[qa+12>>2]|0;if((sa|0)==(c[qa+16>>2]|0)){Wb=($d[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255}else{Wb=a[sa]|0}if(!(Wb<<24>>24==(a[Ib]|0))){break}sa=c[h>>2]|0;qa=sa+12|0;ea=c[qa>>2]|0;if((ea|0)==(c[sa+16>>2]|0)){$d[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ea+1}Fb=Ub;Gb=Vb;Hb=a[x]|0;Ib=Ib+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}ea=a[x]|0;if((ea&1)==0){Xb=j;Yb=(ea&255)>>>1}else{Xb=c[J>>2]|0;Yb=c[K>>2]|0}if((Ib|0)==(Xb+Yb|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;if((qa|0)==(c[ea+16>>2]|0)){Zb=($d[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Zb=a[qa]|0}if(!(Zb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Zb<<24>>24<<1)>>1]&8192)==0){X=25;break a}qa=c[h>>2]|0;ea=qa+12|0;sa=c[ea>>2]|0;if((sa|0)==(c[qa+16>>2]|0)){_b=($d[c[(c[qa>>2]|0)+40>>2]&127](qa)|0)&255}else{c[ea>>2]=sa+1;_b=a[sa]|0}PS(A,_b);X=26;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if(($d[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}da=c[h>>2]|0;sa=c[da+12>>2]|0;if((sa|0)==(c[da+16>>2]|0)){fc=($d[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{fc=a[sa]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}sa=c[h>>2]|0;da=sa+12|0;ea=c[da>>2]|0;if((ea|0)==(c[sa+16>>2]|0)){gc=($d[c[(c[sa>>2]|0)+40>>2]&127](sa)|0)&255}else{c[da>>2]=ea+1;gc=a[ea]|0}PS(A,gc);$b=dc;ac=ec}}}while(0);ea=p+1|0;if(ea>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=ea;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){P0()}else if((X|0)==198){P0()}else if((X|0)==209){P0()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==253){P0()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=eb;jc=hb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if(($d[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if(($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=($d[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){$d[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;tY(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);xS(A);xS(z);xS(y);xS(x);xS(w);if((ic|0)==0){i=q;return hc|0}Yd[jc&511](ic);i=q;return hc|0}function pY(a){a=a|0;var b=0;b=Cc(8)|0;VR(b,a);Kd(b|0,101240,42)}function qY(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=377;v=n+100|0;tT(q,h);n=q;w=c[n>>2]|0;if(!((c[26062]|0)==-1)){c[m>>2]=104248;c[m+4>>2]=375;c[m+8>>2]=0;iS(104248,m,376)}m=(c[104252>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;h0(z);A=119808;B=127;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;h0(z);A=119808;B=127;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=oY(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){PS(k,oe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=oe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);rY(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!(($d[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if(($d[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;PR(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&511](n);i=d;return}function rY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){SS(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function sY(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[25922]|0)==-1)){c[p>>2]=103688;c[p+4>>2]=375;c[p+8>>2]=0;iS(103688,p,376)}p=(c[103692>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xS(r);Zd[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}JS(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xS(s);a[f]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}JS(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xS(t);Zd[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xS(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[25906]|0)==-1)){c[o>>2]=103624;c[o+4>>2]=375;c[o+8>>2]=0;iS(103624,o,376)}o=(c[103628>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;xS(w);Zd[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}JS(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xS(x);a[f]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}JS(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;xS(y);Zd[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;xS(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function tY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function uY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function vY(a){a=a|0;i=i;return}function wY(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=377;y=o+400|0;tT(r,h);o=r;z=c[o>>2]|0;if(!((c[26060]|0)==-1)){c[n>>2]=104240;c[n+4>>2]=375;c[n+8>>2]=0;iS(104240,n,376)}n=(c[104244>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=xY(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;ye[c[(c[z>>2]|0)+48>>2]&63](E,103944,103954|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=C0((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}P0()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[103944+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((pd(p|0,103880,m|0)|0)!=1){t=Cc(8)|0;VR(t,103888);Kd(t|0,101240,42)}if((F|0)==0){break}D0(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=$d[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];PR(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Yd[c[x>>2]&511](o);i=d;return}



function xY(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;AY(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=377;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(ce[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=$d[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}dT(A,aa);T=28;break};case 0:{T=28;break};case 4:{$=M;P=r;R=L;ba=0;ca=O;c:while(1){da=c[g>>2]|0;do{if((da|0)==0){ea=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ga=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ga=c[fa>>2]|0}if((ga|0)==-1){c[g>>2]=0;ea=1;break}else{ea=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=188}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ha=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ha=c[fa>>2]|0}if((ha|0)==-1){c[b>>2]=0;T=188;break}else{if(ea){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ea){break}}da=c[g>>2]|0;fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ia=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ia=c[fa>>2]|0}if(ce[c[(c[l>>2]|0)+12>>2]&63](l,2048,ia)|0){fa=c[n>>2]|0;if((fa|0)==(c[q>>2]|0)){BY(m,n,q);ja=c[n>>2]|0}else{ja=fa}c[n>>2]=ja+4;c[ja>>2]=ia;ka=$;la=P;ma=R;na=ba+1|0;oa=ca}else{fa=a[w]|0;if((fa&1)==0){pa=(fa&255)>>>1}else{pa=c[K>>2]|0}if((pa|0)==0|(ba|0)==0){break}if((ia|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){fa=P-$|0;da=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=377){qa=$}else{qa=0}ra=F0(qa,da)|0;if((ra|0)==0){T=206;break a}sa=ra;ta=ra+(fa>>2<<2)|0;ua=ra+(da>>>2<<2)|0;va=352}else{sa=$;ta=P;ua=R;va=ca}c[ta>>2]=ba;ka=sa;la=ta+4|0;ma=ua;na=0;oa=va}da=c[g>>2]|0;ra=da+12|0;fa=c[ra>>2]|0;if((fa|0)==(c[da+16>>2]|0)){$d[c[(c[da>>2]|0)+40>>2]&127](da)|0;$=ka;P=la;R=ma;ba=na;ca=oa;continue}else{c[ra>>2]=fa+4;$=ka;P=la;R=ma;ba=na;ca=oa;continue}}if(($|0)==(P|0)|(ba|0)==0){wa=$;xa=P;ya=R;za=ca}else{if((P|0)==(R|0)){fa=P-$|0;ra=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=377){Aa=$}else{Aa=0}da=F0(Aa,ra)|0;if((da|0)==0){T=217;break a}Ba=da;Ca=da+(fa>>2<<2)|0;Da=da+(ra>>>2<<2)|0;Ea=352}else{Ba=$;Ca=P;Da=R;Ea=ca}c[Ca>>2]=ba;wa=Ba;xa=Ca+4|0;ya=Da;za=Ea}ra=c[B>>2]|0;if((ra|0)>0){da=c[g>>2]|0;do{if((da|0)==0){Fa=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Ga=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ga=c[fa>>2]|0}if((Ga|0)==-1){c[g>>2]=0;Fa=1;break}else{Fa=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=234}else{ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ha=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ha=c[ba>>2]|0}if((Ha|0)==-1){c[b>>2]=0;T=234;break}else{if(Fa){Ia=da;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Fa){T=240;break a}else{Ia=0}}da=c[g>>2]|0;ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ja=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ja=c[ba>>2]|0}if((Ja|0)!=(c[u>>2]|0)){T=240;break a}ba=c[g>>2]|0;da=ba+12|0;ca=c[da>>2]|0;if((ca|0)==(c[ba+16>>2]|0)){$d[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;Ka=Ia;La=ra;Ma=Ia}else{c[da>>2]=ca+4;Ka=Ia;La=ra;Ma=Ia}while(1){ca=c[g>>2]|0;do{if((ca|0)==0){Na=1}else{da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Oa=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Oa=c[da>>2]|0}if((Oa|0)==-1){c[g>>2]=0;Na=1;break}else{Na=(c[g>>2]|0)==0;break}}}while(0);do{if((Ma|0)==0){Pa=Ka;T=257}else{ca=c[Ma+12>>2]|0;if((ca|0)==(c[Ma+16>>2]|0)){Qa=$d[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0}else{Qa=c[ca>>2]|0}if((Qa|0)==-1){c[b>>2]=0;Pa=0;T=257;break}else{if(Na^(Ka|0)==0){Ra=Ka;Sa=Ka;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Na){T=263;break a}else{Ra=Pa;Sa=0}}ca=c[g>>2]|0;da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Ta=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Ta=c[da>>2]|0}if(!(ce[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ta)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){BY(m,n,q)}da=c[g>>2]|0;ca=c[da+12>>2]|0;if((ca|0)==(c[da+16>>2]|0)){Ua=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ua=c[ca>>2]|0}ca=c[n>>2]|0;c[n>>2]=ca+4;c[ca>>2]=Ua;ca=La+ -1|0;c[B>>2]=ca;da=c[g>>2]|0;ba=da+12|0;R=c[ba>>2]|0;if((R|0)==(c[da+16>>2]|0)){$d[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ba>>2]=R+4}if((ca|0)>0){Ka=Ra;La=ca;Ma=Sa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Va=wa;Wa=xa;Xa=ya;Ya=N;Za=za}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_a=(a[J]|0)!=0}else{_a=0}if(!(F|_a)){Va=M;Wa=r;Xa=L;Ya=0;Za=O;break b}}ra=a[x]|0;ca=(ra&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){$a=V;ab=V;bb=ra;cb=ca}else{if((d[s+(o+ -1)|0]|0)<2){db=ra;eb=ca}else{$a=V;ab=V;bb=ra;cb=ca;break}while(1){if((db&1)==0){fb=h;gb=(db&255)>>>1}else{fb=c[G>>2]|0;gb=c[h>>2]|0}if((eb|0)==(fb+(gb<<2)|0)){hb=db;break}if(!(ce[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[eb>>2]|0)|0)){T=129;break}db=a[x]|0;eb=eb+4|0}if((T|0)==129){T=0;hb=a[x]|0}R=(hb&1)==0;ba=eb-(R?h:c[G>>2]|0)>>2;da=a[A]|0;P=(da&1)==0;if(P){ib=(da&255)>>>1}else{ib=c[H>>2]|0}e:do{if(!(ba>>>0>ib>>>0)){if(P){jb=H+(((da&255)>>>1)-ba<<2)|0;kb=H;lb=(da&255)>>>1}else{$=c[I>>2]|0;fa=c[H>>2]|0;jb=$+(fa-ba<<2)|0;kb=$;lb=fa}fa=kb+(lb<<2)|0;if((jb|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}else{mb=R?h:c[G>>2]|0;nb=jb}while(1){if((c[nb>>2]|0)!=(c[mb>>2]|0)){break e}$=nb+4|0;if(($|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}mb=mb+4|0;nb=$}}}while(0);$a=V;ab=V;bb=hb;cb=R?h:c[G>>2]|0}}while(0);f:while(1){if((bb&1)==0){ob=h;pb=(bb&255)>>>1}else{ob=c[G>>2]|0;pb=c[h>>2]|0}if((cb|0)==(ob+(pb<<2)|0)){break}ca=c[g>>2]|0;do{if((ca|0)==0){qb=1}else{ra=c[ca+12>>2]|0;if((ra|0)==(c[ca+16>>2]|0)){rb=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{rb=c[ra>>2]|0}if((rb|0)==-1){c[g>>2]=0;qb=1;break}else{qb=(c[g>>2]|0)==0;break}}}while(0);do{if((ab|0)==0){sb=$a;T=159}else{ca=c[ab+12>>2]|0;if((ca|0)==(c[ab+16>>2]|0)){tb=$d[c[(c[ab>>2]|0)+36>>2]&127](ab)|0}else{tb=c[ca>>2]|0}if((tb|0)==-1){c[b>>2]=0;sb=0;T=159;break}else{if(qb^($a|0)==0){ub=$a;vb=$a;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(qb){break}else{ub=sb;vb=0}}ca=c[g>>2]|0;R=c[ca+12>>2]|0;if((R|0)==(c[ca+16>>2]|0)){wb=$d[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{wb=c[R>>2]|0}if((wb|0)!=(c[cb>>2]|0)){break}R=c[g>>2]|0;ca=R+12|0;ra=c[ca>>2]|0;if((ra|0)==(c[R+16>>2]|0)){$d[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[ca>>2]=ra+4}$a=ub;ab=vb;bb=a[x]|0;cb=cb+4|0}if(!F){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}ra=a[x]|0;if((ra&1)==0){xb=h;yb=(ra&255)>>>1}else{xb=c[G>>2]|0;yb=c[h>>2]|0}if((cb|0)==(xb+(yb<<2)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O}else{T=174;break a}break};case 3:{ra=a[y]|0;ca=(ra&1)==0;if(ca){zb=(ra&255)>>>1}else{zb=c[D>>2]|0}R=a[z]|0;ba=(R&1)==0;if(ba){Ab=(R&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}if(ca){Bb=(ra&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(ba){Cb=(R&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}da=c[g>>2]|0;P=c[da+12>>2]|0;if((P|0)==(c[da+16>>2]|0)){fa=$d[c[(c[da>>2]|0)+36>>2]&127](da)|0;Db=fa;Eb=a[y]|0}else{Db=c[P>>2]|0;Eb=ra}P=c[g>>2]|0;fa=P+12|0;da=c[fa>>2]|0;$=(da|0)==(c[P+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if($){$d[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[fa>>2]=da+4}fa=a[y]|0;if((fa&1)==0){Fb=(fa&255)>>>1}else{Fb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Fb>>>0>1?y:N;Za=O;break b}if($){Gb=$d[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Gb=c[da>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}da=c[g>>2]|0;P=da+12|0;$=c[P>>2]|0;if(($|0)==(c[da+16>>2]|0)){$d[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[P>>2]=$+4}a[k]=1;$=a[z]|0;if(($&1)==0){Hb=($&255)>>>1}else{Hb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Hb>>>0>1?z:N;Za=O;break b}}while(0);if(ca){Ib=(ra&255)>>>1}else{Ib=c[D>>2]|0}ba=c[g>>2]|0;$=c[ba+12>>2]|0;P=($|0)==(c[ba+16>>2]|0);if((Ib|0)==0){if(P){da=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Jb=da;Kb=a[z]|0}else{Jb=c[$>>2]|0;Kb=R}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}da=c[g>>2]|0;fa=da+12|0;Lb=c[fa>>2]|0;if((Lb|0)==(c[da+16>>2]|0)){$d[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[fa>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Mb>>>0>1?z:N;Za=O;break b}if(P){P=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Nb=P;Ob=a[y]|0}else{Nb=c[$>>2]|0;Ob=ra}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}$=c[g>>2]|0;P=$+12|0;ba=c[P>>2]|0;if((ba|0)==(c[$+16>>2]|0)){$d[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[P>>2]=ba+4}ba=a[y]|0;if((ba&1)==0){Pb=(ba&255)>>>1}else{Pb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Pb>>>0>1?y:N;Za=O;break};default:{Va=M;Wa=r;Xa=L;Ya=N;Za=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){ba=c[g>>2]|0;do{if((ba|0)==0){Sb=1}else{P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Tb=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Tb=c[P>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{ba=c[Rb+12>>2]|0;if((ba|0)==(c[Rb+16>>2]|0)){Vb=$d[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[ba>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}else{Wb=Ub;Xb=0}}ba=c[g>>2]|0;P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Yb=$d[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Yb=c[P>>2]|0}if(!(ce[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}P=c[g>>2]|0;ba=P+12|0;$=c[ba>>2]|0;if(($|0)==(c[P+16>>2]|0)){Zb=$d[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[ba>>2]=$+4;Zb=c[$>>2]|0}dT(A,Zb);Qb=Wb;Rb=Xb}}}while(0);ra=o+1|0;if(ra>>>0<4){L=Xa;r=Wa;M=Va;o=ra;N=Ya;O=Za}else{W=Va;X=Wa;Y=Ya;Z=Za;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){P0()}else if((T|0)==217){P0()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==276){i:do{if((Y|0)!=0){Za=Y+4|0;Ya=Y+8|0;Wa=1;j:while(1){Va=a[Y]|0;if((Va&1)==0){bc=(Va&255)>>>1}else{bc=c[Za>>2]|0}if(!(Wa>>>0<bc>>>0)){break i}Va=c[g>>2]|0;do{if((Va|0)==0){cc=1}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){dc=$d[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);Va=c[b>>2]|0;do{if((Va|0)==0){T=295}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){ec=$d[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}Va=c[g>>2]|0;N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){fc=$d[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=Za}else{gc=c[Ya>>2]|0}if((fc|0)!=(c[gc+(Wa<<2)>>2]|0)){break}N=Wa+1|0;Va=c[g>>2]|0;o=Va+12|0;r=c[o>>2]|0;if((r|0)==(c[Va+16>>2]|0)){$d[c[(c[Va>>2]|0)+40>>2]&127](Va)|0;Wa=N;continue}else{c[o>>2]=r+4;Wa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;tY(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);$S(A);$S(z);$S(y);$S(x);xS(w);if(($b|0)==0){i=p;return _b|0}Yd[ac&511]($b);i=p;return _b|0}function yY(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=377;v=n+400|0;tT(q,h);n=q;w=c[n>>2]|0;if(!((c[26060]|0)==-1)){c[m>>2]=104240;c[m+4>>2]=375;c[m+8>>2]=0;iS(104240,m,376)}m=(c[104244>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Cc(4)|0;z=y;h0(z);A=119808;B=127;Kd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Cc(4)|0;z=y;h0(z);A=119808;B=127;Kd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=xY(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){dT(k,oe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=oe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);zY(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=$d[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=$d[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];PR(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Yd[c[u>>2]&511](n);i=d;return}function zY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){fT(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function AY(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[25954]|0)==-1)){c[p>>2]=103816;c[p+4>>2]=375;c[p+8>>2]=0;iS(103816,p,376)}p=(c[103820>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Cc(4)|0;C=B;h0(C);D=119808;E=127;Kd(B|0,D|0,E|0)}E=b;Zd[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Zd[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;$S(r);Zd[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}cT(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;$S(s);c[f>>2]=$d[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=$d[c[(c[b>>2]|0)+16>>2]&127](E)|0;Zd[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}JS(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;xS(t);Zd[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}cT(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;$S(u);F=$d[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[25938]|0)==-1)){c[o>>2]=103752;c[o+4>>2]=375;c[o+8>>2]=0;iS(103752,o,376)}o=(c[103756>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Cc(4)|0;H=G;h0(H);I=119808;J=127;Kd(G|0,I|0,J|0)}J=E;Zd[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Zd[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;$S(w);Zd[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}cT(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$S(x);c[f>>2]=$d[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=$d[c[(c[E>>2]|0)+16>>2]&127](J)|0;Zd[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}JS(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;xS(y);Zd[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}cT(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;$S(z);F=$d[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function BY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=377;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=F0(m,l)|0;m=a;if((a|0)==0){P0()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Yd[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=352;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function CY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function DY(a){a=a|0;i=i;return}function EY(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,104e3,o|0)|0;do{if(s>>>0>99){do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=wW(r,o,104e3,n)|0;o=c[r>>2]|0;if((o|0)==0){P0()}H=C0(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}P0()}else{I=0;J=0;K=q;L=s}}while(0);tT(t,g);s=t;q=c[s>>2]|0;if(!((c[26062]|0)==-1)){c[p>>2]=104248;c[p+4>>2]=375;c[p+8>>2]=0;iS(104248,p,376)}p=(c[104252>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;ye[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FY(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=C0(V)|0;if((T|0)!=0){W=T;X=T;break}P0()}else{W=0;X=t}}while(0);GY(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];WO(b,m,X,e,D,g,j);if((W|0)!=0){D0(W)}xS(A);xS(z);xS(y);PR(c[s>>2]|0)|0;if((J|0)!=0){D0(J)}if((I|0)==0){i=d;return}D0(I);i=d;return}function FY(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[25922]|0)==-1)){c[p>>2]=103688;c[p+4>>2]=375;c[p+8>>2]=0;iS(103688,p,376)}p=(c[103692>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;h0(I);J=119808;K=127;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;h0(I);J=119808;K=127;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;xS(s)}else{Zd[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xS(v)}a[g]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xS(w);Zd[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}JS(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xS(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[25906]|0)==-1)){c[o>>2]=103624;c[o+4>>2]=375;c[o+8>>2]=0;iS(103624,o,376)}o=(c[103628>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;xS(A)}else{Zd[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}JS(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;xS(D)}a[g]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;xS(E);Zd[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}JS(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;xS(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function GY(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 1:{c[e>>2]=c[f>>2];I=oe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){L=(I&255)>>>1}else{L=c[A>>2]|0}if((L|0)==0|x){K=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;K=H;break};case 0:{c[e>>2]=c[f>>2];K=H;break};case 4:{P=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){I=J;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){S=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){S=I;break b}if(Q>>>0<j>>>0){I=Q}else{S=Q;break}}}else{S=J}}while(0);I=S;if(B){if(S>>>0>J>>>0){Q=J+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=P;T=S;U=s;while(1){V=T+ -1|0;W=a[V]|0;c[f>>2]=R+1;a[R]=W;W=U+ -1|0;X=(W|0)>0;if(!(V>>>0>J>>>0&X)){break}R=c[f>>2]|0;U=W;T=V}T=S+I|0;if(X){Y=T;Z=Q;_=32}else{$=0;aa=T;ba=Q}}else{Y=S;Z=s;_=32}if((_|0)==32){_=0;$=oe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;aa=Y;ba=Z}T=c[f>>2]|0;c[f>>2]=T+1;if((ba|0)>0){U=T;R=ba;while(1){a[U]=$;V=R+ -1|0;W=c[f>>2]|0;c[f>>2]=W+1;if((V|0)>0){R=V;U=W}else{ca=W;break}}}else{ca=T}a[ca]=n;da=aa}else{da=S}if((da|0)==(J|0)){U=oe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=U}else{U=a[p]|0;R=(U&1)==0;if(R){ea=(U&255)>>>1}else{ea=c[E>>2]|0}if((ea|0)==0){fa=da;ga=-1;ha=0;ia=0}else{if(R){ja=C}else{ja=c[D>>2]|0}fa=da;ga=a[ja]|0;ha=0;ia=0}while(1){do{if((ia|0)==(ga|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ha+1|0;U=a[p]|0;Q=(U&1)==0;if(Q){ka=(U&255)>>>1}else{ka=c[E>>2]|0}if(!(R>>>0<ka>>>0)){la=ga;ma=R;na=0;break}if(Q){oa=C}else{oa=c[D>>2]|0}if((a[oa+R|0]|0)==127){la=-1;ma=R;na=0;break}if(Q){pa=C}else{pa=c[D>>2]|0}la=a[pa+R|0]|0;ma=R;na=0}else{la=ga;ma=ha;na=ia}}while(0);R=fa+ -1|0;Q=a[R]|0;U=c[f>>2]|0;c[f>>2]=U+1;a[U]=Q;if((R|0)==(J|0)){break}else{fa=R;ga=la;ha=ma;ia=na+1|0}}}T=c[f>>2]|0;if((P|0)==(T|0)){K=J;break a}R=T+ -1|0;if(R>>>0>P>>>0){qa=P;ra=R}else{K=J;break a}while(1){R=a[qa]|0;a[qa]=a[ra]|0;a[ra]=R;R=qa+1|0;T=ra+ -1|0;if(R>>>0<T>>>0){ra=T;qa=R}else{K=J;break}}break};case 3:{J=a[r]|0;P=(J&1)==0;if(P){sa=(J&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){K=H;break a}if(P){ta=u}else{ta=c[v>>2]|0}P=a[ta]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;K=H;break};default:{K=H}}}while(0);P=h+1|0;if(P>>>0<4){H=K;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function HY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;tT(m,g);z=m;A=c[z>>2]|0;if(!((c[26062]|0)==-1)){c[l>>2]=104248;c[l+4>>2]=375;c[l+8>>2]=0;iS(104248,l,376)}l=(c[104252>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(oe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;FY(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=C0(P)|0;if((N|0)!=0){Q=N;R=N;break}P0()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}GY(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];WO(b,k,R,e,w,g,h);if((Q|0)==0){xS(t);xS(s);xS(r);U=c[z>>2]|0;V=U;W=V;X=PR(W)|0;i=d;return}D0(Q);xS(t);xS(s);xS(r);U=c[z>>2]|0;V=U;W=V;X=PR(W)|0;i=d;return}function IY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function JY(a){a=a|0;i=i;return}function KY(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Kc(G|0,100,104e3,o|0)|0;do{if(s>>>0>99){do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);o=c[26034]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=wW(r,o,104e3,n)|0;o=c[r>>2]|0;if((o|0)==0){P0()}H=C0(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}P0()}else{J=0;K=0;L=q;M=s}}while(0);tT(t,g);s=t;q=c[s>>2]|0;if(!((c[26060]|0)==-1)){c[p>>2]=104240;c[p+4>>2]=375;c[p+8>>2]=0;iS(104240,p,376)}p=(c[104244>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Cc(4)|0;O=N;h0(O);P=119808;Q=127;Kd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Cc(4)|0;O=N;h0(O);P=119808;Q=127;Kd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;ye[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;LY(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=C0(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}P0()}else{X=0;Y=t}}while(0);MY(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];FW(b,m,Y,e,D,g,j);if((X|0)!=0){D0(X)}$S(A);$S(z);xS(y);PR(c[s>>2]|0)|0;if((K|0)!=0){D0(K)}if((J|0)==0){i=d;return}D0(J);i=d;return}function LY(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[25954]|0)==-1)){c[p>>2]=103816;c[p+4>>2]=375;c[p+8>>2]=0;iS(103816,p,376)}p=(c[103820>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Cc(4)|0;I=H;h0(I);J=119808;K=127;Kd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Cc(4)|0;I=H;h0(I);J=119808;K=127;Kd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Zd[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Zd[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;$S(s)}else{Zd[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Zd[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;$S(v)}c[g>>2]=$d[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=$d[c[(c[e>>2]|0)+16>>2]&127](K)|0;Zd[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;xS(w);Zd[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}cT(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;$S(x);L=$d[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[25938]|0)==-1)){c[o>>2]=103752;c[o+4>>2]=375;c[o+8>>2]=0;iS(103752,o,376)}o=(c[103756>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Cc(4)|0;N=M;h0(N);O=119808;P=127;Kd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Zd[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Zd[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;$S(A)}else{Zd[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Zd[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}cT(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;$S(D)}c[g>>2]=$d[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=$d[c[(c[G>>2]|0)+16>>2]&127](P)|0;Zd[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}JS(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;xS(E);Zd[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}cT(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;$S(F);L=$d[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function MY(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 1:{c[d>>2]=c[e>>2];D=oe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 2:{D=a[p]|0;E=(D&1)==0;if(E){G=(D&255)>>>1}else{G=c[w>>2]|0}if((G|0)==0|v){F=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;F=C;break};case 0:{c[d>>2]=c[e>>2];F=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){F=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;F=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){D=M;while(1){N=D+4|0;if(!(ce[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){Q=D;break b}if(N>>>0<h>>>0){D=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;E=Q;D=r;while(1){R=E+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=D+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){D=T;E=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=oe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((W|0)>0){_=D;$=E;aa=W}else{Y=E;Z=V;break}while(1){c[$>>2]=K;D=aa+ -1|0;if((D|0)>0){aa=D;$=_;_=_+4|0}else{break}}c[e>>2]=E+(W+1<<2);Y=E+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=oe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(D>>>0<la>>>0)){ma=N;na=fa;oa=D;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+D|0]|0)==127){ma=N;na=-1;oa=D;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+D|0]|0;oa=D;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;E=c[K>>2]|0;D=ma+4|0;c[e>>2]=D;c[ma>>2]=E;if((K|0)==(M|0)){ca=D;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){F=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{F=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;D=ta+ -4|0;if(K>>>0<D>>>0){ta=D;sa=K}else{F=M;break}}break};default:{F=C}}}while(0);M=g+1|0;if(M>>>0<4){C=F;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function NY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;tT(m,g);z=m;A=c[z>>2]|0;if(!((c[26060]|0)==-1)){c[l>>2]=104240;c[l+4>>2]=375;c[l+8>>2]=0;iS(104240,l,376)}l=(c[104244>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Cc(4)|0;D=C;h0(D);E=119808;F=127;Kd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(oe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;LY(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=C0(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}P0()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}MY(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];FW(b,k,R,e,w,g,h);if((Q|0)==0){$S(t);$S(s);xS(r);U=c[z>>2]|0;V=U;W=V;X=PR(W)|0;i=d;return}D0(Q);$S(t);$S(s);xS(r);U=c[z>>2]|0;V=U;W=V;X=PR(W)|0;i=d;return}function OY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function PY(a){a=a|0;i=i;return}function QY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function RY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{PS(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=qd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=e1(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{xS(j);i=d;return}do{PS(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);xS(j);i=d;return}function SY(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function TY(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function UY(a){a=a|0;i=i;return}function VY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=sc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function WY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=105904;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=105904|0;while(1){c[m>>2]=y;A=(xe[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{PS(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}pY(105128)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=qd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=106008;D=e1(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){xS(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=106008|0;while(1){c[q>>2]=o;h=(xe[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{dT(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){pY(105128)}else if((E|0)==25){xS(r);i=d;return}}function XY(a,b){a=a|0;b=b|0;a=i;Gb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function YY(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=104336;e=b+8|0;b=c[e>>2]|0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);if((b|0)==(c[26034]|0)){i=d;return}_b(c[e>>2]|0);i=d;return}function ZY(a){a=a|0;a=Cc(8)|0;QR(a,104128);c[a>>2]=101096;Kd(a|0,101136,40)}function _Y(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=104168;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);pS(b+144|0,104152,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[109060>>2]=0;c[27264]=102648;if(!((c[25668]|0)==-1)){c[G>>2]=102672;c[G+4>>2]=375;c[G+8>>2]=0;iS(102672,G,376)}$Y(b,109056,(c[102676>>2]|0)+ -1|0);c[109052>>2]=0;c[27262]=102688;if(!((c[25678]|0)==-1)){c[F>>2]=102712;c[F+4>>2]=375;c[F+8>>2]=0;iS(102712,F,376)}$Y(b,109048,(c[102716>>2]|0)+ -1|0);c[109036>>2]=0;c[27258]=104264;c[109040>>2]=0;a[109044|0]=0;F=c[(wc()|0)>>2]|0;c[109040>>2]=F;if(!((c[26062]|0)==-1)){c[E>>2]=104248;c[E+4>>2]=375;c[E+8>>2]=0;iS(104248,E,376)}$Y(b,109032,(c[104252>>2]|0)+ -1|0);c[109028>>2]=0;c[27256]=105224;if(!((c[26060]|0)==-1)){c[D>>2]=104240;c[D+4>>2]=375;c[D+8>>2]=0;iS(104240,D,376)}$Y(b,109024,(c[104244>>2]|0)+ -1|0);c[109020>>2]=0;c[27254]=105440;if(!((c[26078]|0)==-1)){c[C>>2]=104312;c[C+4>>2]=375;c[C+8>>2]=0;iS(104312,C,376)}$Y(b,109016,(c[104316>>2]|0)+ -1|0);c[109004>>2]=0;c[27250]=104336;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);c[109008>>2]=c[26034];if(!((c[26080]|0)==-1)){c[B>>2]=104320;c[B+4>>2]=375;c[B+8>>2]=0;iS(104320,B,376)}$Y(b,109e3,(c[104324>>2]|0)+ -1|0);c[108996>>2]=0;c[27248]=105664;if(!((c[26094]|0)==-1)){c[A>>2]=104376;c[A+4>>2]=375;c[A+8>>2]=0;iS(104376,A,376)}$Y(b,108992,(c[104380>>2]|0)+ -1|0);c[108988>>2]=0;c[27246]=105784;if(!((c[26096]|0)==-1)){c[z>>2]=104384;c[z+4>>2]=375;c[z+8>>2]=0;iS(104384,z,376)}$Y(b,108984,(c[104388>>2]|0)+ -1|0);c[108964>>2]=0;c[27240]=104416;a[108968|0]=46;a[108969|0]=44;z=108972|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[26098]|0)==-1)){c[y>>2]=104392;c[y+4>>2]=375;c[y+8>>2]=0;iS(104392,y,376)}$Y(b,108960,(c[104396>>2]|0)+ -1|0);c[108932>>2]=0;c[27232]=104456;c[108936>>2]=46;c[108940>>2]=44;y=108944|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[26100]|0)==-1)){c[x>>2]=104400;c[x+4>>2]=375;c[x+8>>2]=0;iS(104400,x,376)}$Y(b,108928,(c[104404>>2]|0)+ -1|0);c[108924>>2]=0;c[27230]=102728;if(!((c[25696]|0)==-1)){c[w>>2]=102784;c[w+4>>2]=375;c[w+8>>2]=0;iS(102784,w,376)}$Y(b,108920,(c[102788>>2]|0)+ -1|0);c[108916>>2]=0;c[27228]=102848;if(!((c[25726]|0)==-1)){c[v>>2]=102904;c[v+4>>2]=375;c[v+8>>2]=0;iS(102904,v,376)}$Y(b,108912,(c[102908>>2]|0)+ -1|0);c[108908>>2]=0;c[27226]=102920;if(!((c[25742]|0)==-1)){c[u>>2]=102968;c[u+4>>2]=375;c[u+8>>2]=0;iS(102968,u,376)}$Y(b,108904,(c[102972>>2]|0)+ -1|0);c[108900>>2]=0;c[27224]=102984;if(!((c[25758]|0)==-1)){c[t>>2]=103032;c[t+4>>2]=375;c[t+8>>2]=0;iS(103032,t,376)}$Y(b,108896,(c[103036>>2]|0)+ -1|0);c[108892>>2]=0;c[27222]=103576;if(!((c[25906]|0)==-1)){c[s>>2]=103624;c[s+4>>2]=375;c[s+8>>2]=0;iS(103624,s,376)}$Y(b,108888,(c[103628>>2]|0)+ -1|0);c[108884>>2]=0;c[27220]=103640;if(!((c[25922]|0)==-1)){c[r>>2]=103688;c[r+4>>2]=375;c[r+8>>2]=0;iS(103688,r,376)}$Y(b,108880,(c[103692>>2]|0)+ -1|0);c[108876>>2]=0;c[27218]=103704;if(!((c[25938]|0)==-1)){c[q>>2]=103752;c[q+4>>2]=375;c[q+8>>2]=0;iS(103752,q,376)}$Y(b,108872,(c[103756>>2]|0)+ -1|0);c[108868>>2]=0;c[27216]=103768;if(!((c[25954]|0)==-1)){c[p>>2]=103816;c[p+4>>2]=375;c[p+8>>2]=0;iS(103816,p,376)}$Y(b,108864,(c[103820>>2]|0)+ -1|0);c[108860>>2]=0;c[27214]=103832;if(!((c[25964]|0)==-1)){c[o>>2]=103856;c[o+4>>2]=375;c[o+8>>2]=0;iS(103856,o,376)}$Y(b,108856,(c[103860>>2]|0)+ -1|0);c[108852>>2]=0;c[27212]=103912;if(!((c[25984]|0)==-1)){c[n>>2]=103936;c[n+4>>2]=375;c[n+8>>2]=0;iS(103936,n,376)}$Y(b,108848,(c[103940>>2]|0)+ -1|0);c[108844>>2]=0;c[27210]=103968;if(!((c[25998]|0)==-1)){c[m>>2]=103992;c[m+4>>2]=375;c[m+8>>2]=0;iS(103992,m,376)}$Y(b,108840,(c[103996>>2]|0)+ -1|0);c[108836>>2]=0;c[27208]=104016;if(!((c[26010]|0)==-1)){c[l>>2]=104040;c[l+4>>2]=375;c[l+8>>2]=0;iS(104040,l,376)}$Y(b,108832,(c[104044>>2]|0)+ -1|0);c[108820>>2]=0;c[27204]=103064;c[108824>>2]=103112;if(!((c[25786]|0)==-1)){c[k>>2]=103144;c[k+4>>2]=375;c[k+8>>2]=0;iS(103144,k,376)}$Y(b,108816,(c[103148>>2]|0)+ -1|0);c[108804>>2]=0;c[27200]=103216;c[108808>>2]=103264;if(!((c[25824]|0)==-1)){c[j>>2]=103296;c[j+4>>2]=375;c[j+8>>2]=0;iS(103296,j,376)}$Y(b,108800,(c[103300>>2]|0)+ -1|0);c[108788>>2]=0;c[27196]=105160;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);c[108792>>2]=c[26034];c[27196]=103512;if(!((c[25882]|0)==-1)){c[h>>2]=103528;c[h+4>>2]=375;c[h+8>>2]=0;iS(103528,h,376)}$Y(b,108784,(c[103532>>2]|0)+ -1|0);c[108772>>2]=0;c[27192]=105160;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);c[108776>>2]=c[26034];c[27192]=103544;if(!((c[25890]|0)==-1)){c[g>>2]=103560;c[g+4>>2]=375;c[g+8>>2]=0;iS(103560,g,376)}$Y(b,108768,(c[103564>>2]|0)+ -1|0);c[108764>>2]=0;c[27190]=104056;if(!((c[26020]|0)==-1)){c[f>>2]=104080;c[f+4>>2]=375;c[f+8>>2]=0;iS(104080,f,376)}$Y(b,108760,(c[104084>>2]|0)+ -1|0);c[108756>>2]=0;c[27188]=104096;if((c[26030]|0)==-1){N=104120;O=104120;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=108752;$Y(b,T,S);i=e;return}c[H>>2]=104120;c[H+4>>2]=375;c[H+8>>2]=0;iS(104120,H,376);N=104120;O=104120;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=108752;$Y(b,T,S);i=e;return}function $Y(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;OR(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){e$(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}PR(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function aZ(a){a=a|0;var b=0;b=i;bZ(a);K0(a);i=b;return}function bZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=104168;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{PR(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}xS(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{K0(h);i=d;return}}function cZ(){var b=0,d=0,e=0,f=0;b=i;if((a[104224]|0)!=0){d=104216;e=c[26054]|0;i=b;return e|0}if((Ya(104224)|0)==0){d=104216;e=c[26054]|0;i=b;return e|0}do{if((a[104200]|0)==0){if((Ya(104200)|0)==0){break}_Y(108592,1);c[26046]=108592;c[26048]=104184;Rb(104200)}}while(0);f=c[c[26048]>>2]|0;c[26052]=f;OR(f);c[26054]=104208;Rb(104224);d=104216;e=c[26054]|0;i=b;return e|0}function dZ(a){a=a|0;var b=0,d=0;b=i;d=c[(cZ()|0)>>2]|0;c[a>>2]=d;OR(d);i=b;return}function eZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;OR(e);i=d;return}function fZ(a){a=a|0;var b=0;b=i;PR(c[a>>2]|0)|0;i=b;return}function gZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=375;c[e+8>>2]=0;iS(a,e,376)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function hZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=375;c[e+8>>2]=0;iS(a,e,376)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Cc(4)|0;h=g;h0(h);j=119808;k=127;Kd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Cc(4)|0;h=g;h0(h);j=119808;k=127;Kd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function iZ(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function jZ(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Yd[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function kZ(a){a=a|0;var b=0;b=c[26058]|0;c[26058]=1+b;c[a+4>>2]=b+1;i=i;return}function lZ(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function mZ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function nZ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(wc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function oZ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(wc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function pZ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(wc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function qZ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function rZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function sZ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function tZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(zd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function uZ(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function vZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function wZ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function xZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function yZ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=104264;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}L0(e)}}while(0);K0(b);i=d;return}function zZ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=104264;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}L0(e);i=d;return}function AZ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function BZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(ud()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function CZ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(zd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function DZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(zd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function EZ(a,b){a=a|0;b=b|0;i=i;return b|0}function FZ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function GZ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function HZ(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function IZ(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function JZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function KZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function LZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function MZ(a){a=a|0;i=i;return 1}function NZ(a){a=a|0;i=i;return 1}function OZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function PZ(a){a=a|0;i=i;return 1}function QZ(a){a=a|0;var b=0;b=i;YY(a);K0(a);i=b;return}function RZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Jc(c[s>>2]|0)|0;A=I$(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Jc(c[s>>2]|0)|0;A=H$(u,0,d)|0;if((z|0)!=0){Jc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Jc(c[s>>2]|0)|0;G=H$(u,r,n)|0;if((z|0)!=0){Jc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function SZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Jc(c[r>>2]|0)|0;y=E$(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Jc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Jc(c[r>>2]|0)|0;F=D$(x,y,1,d)|0;if((w|0)!=0){Jc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Jc(c[r>>2]|0)|0;y=D$(q,v,z-v|0,n)|0;if((w|0)!=0){Jc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function TZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Jc(c[b+8>>2]|0)|0;b=H$(e,0,d)|0;if((j|0)!=0){Jc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function UZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Jc(c[d>>2]|0)|0;e=G$(0,0,4)|0;if((a|0)!=0){Jc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Jc(a|0)|0;if((g|0)==0){f=0;break}Jc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function VZ(a){a=a|0;i=i;return 0}function WZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Jc(c[k>>2]|0)|0;n=C$(a,j-a|0,b)|0;if((m|0)!=0){Jc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function XZ(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Jc(d|0)|0;if((a|0)==0){e=4;break}Jc(a|0)|0;e=4}}while(0);i=b;return e|0}function YZ(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function ZZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=_Z(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function _Z(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function $Z(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=a_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function a_(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function b_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function c_(a){a=a|0;i=i;return 0}function d_(a){a=a|0;i=i;return 0}function e_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=f_(c,d,e,1114111,0)|0;i=b;return a|0}function f_(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function g_(a){a=a|0;i=i;return 4}function h_(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function i_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=j_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function j_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function k_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=l_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function l_(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function m_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function n_(a){a=a|0;i=i;return 0}function o_(a){a=a|0;i=i;return 0}function p_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=q_(c,d,e,1114111,0)|0;i=b;return a|0}function q_(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function r_(a){a=a|0;i=i;return 4}function s_(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function t_(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function u_(a){a=a|0;var b=0;b=i;c[a>>2]=104416;xS(a+12|0);K0(a);i=b;return}function v_(a){a=a|0;var b=0;b=i;c[a>>2]=104416;xS(a+12|0);i=b;return}function w_(a){a=a|0;var b=0;b=i;c[a>>2]=104456;xS(a+16|0);K0(a);i=b;return}function x_(a){a=a|0;var b=0;b=i;c[a>>2]=104456;xS(a+16|0);i=b;return}function y_(b){b=b|0;i=i;return a[b+8|0]|0}function z_(a){a=a|0;i=i;return c[a+8>>2]|0}function A_(b){b=b|0;i=i;return a[b+9|0]|0}function B_(a){a=a|0;i=i;return c[a+12>>2]|0}function C_(a,b){a=a|0;b=b|0;var c=0;c=i;nS(a,b+12|0);i=c;return}function D_(a,b){a=a|0;b=b|0;var c=0;c=i;nS(a,b+16|0);i=c;return}function E_(a,b){a=a|0;b=b|0;b=i;pS(a,104488,4);i=b;return}function F_(a,b){a=a|0;b=b|0;b=i;ZS(a,104496,c0(104496)|0);i=b;return}function G_(a,b){a=a|0;b=b|0;b=i;pS(a,104520,5);i=b;return}function H_(a,b){a=a|0;b=b|0;b=i;ZS(a,104528,c0(104528)|0);i=b;return}function I_(b){b=b|0;var d=0,e=0;b=i;if((a[104560]|0)!=0){d=104552;e=c[26138]|0;i=b;return e|0}if((Ya(104560)|0)==0){d=104552;e=c[26138]|0;i=b;return e|0}do{if((a[111760]|0)==0){if((Ya(111760)|0)==0){break}i1(111592,0,168)|0;Qd(378,0,q|0)|0;Rb(111760)}}while(0);AS(111592,111768)|0;AS(111604|0,111776)|0;AS(111616|0,111784)|0;AS(111628|0,111792)|0;AS(111640|0,111808)|0;AS(111652|0,111824)|0;AS(111664|0,111832)|0;AS(111676|0,111848)|0;AS(111688|0,111856)|0;AS(111700|0,111864)|0;AS(111712|0,111872)|0;AS(111724|0,111880)|0;AS(111736|0,111888)|0;AS(111748|0,111896)|0;c[26138]=111592;Rb(104560);d=104552;e=c[26138]|0;i=b;return e|0}function J_(b){b=b|0;var d=0,e=0;b=i;if((a[104576]|0)!=0){d=104568;e=c[26142]|0;i=b;return e|0}if((Ya(104576)|0)==0){d=104568;e=c[26142]|0;i=b;return e|0}do{if((a[111224]|0)==0){if((Ya(111224)|0)==0){break}i1(111056,0,168)|0;Qd(379,0,q|0)|0;Rb(111224)}}while(0);aT(111056,111232)|0;aT(111068|0,111264)|0;aT(111080|0,111296)|0;aT(111092|0,111328)|0;aT(111104|0,111368)|0;aT(111116|0,111408)|0;aT(111128|0,111440)|0;aT(111140|0,111480)|0;aT(111152|0,111496)|0;aT(111164|0,111512)|0;aT(111176|0,111528)|0;aT(111188|0,111544)|0;aT(111200|0,111560)|0;aT(111212|0,111576)|0;c[26142]=111056;Rb(104576);d=104568;e=c[26142]|0;i=b;return e|0}function K_(b){b=b|0;var d=0,e=0;b=i;if((a[104592]|0)!=0){d=104584;e=c[26146]|0;i=b;return e|0}if((Ya(104592)|0)==0){d=104584;e=c[26146]|0;i=b;return e|0}do{if((a[110832]|0)==0){if((Ya(110832)|0)==0){break}i1(110544,0,288)|0;Qd(380,0,q|0)|0;Rb(110832)}}while(0);AS(110544,110840)|0;AS(110556|0,110848)|0;AS(110568|0,110864)|0;AS(110580|0,110872)|0;AS(110592|0,110880)|0;AS(110604|0,110888)|0;AS(110616|0,110896)|0;AS(110628|0,110904)|0;AS(110640|0,110912)|0;AS(110652|0,110928)|0;AS(110664|0,110936)|0;AS(110676|0,110952)|0;AS(110688|0,110968)|0;AS(110700|0,110976)|0;AS(110712|0,110984)|0;AS(110724|0,110992)|0;AS(110736|0,110880)|0;AS(110748|0,111e3)|0;AS(110760|0,111008)|0;AS(110772|0,111016)|0;AS(110784|0,111024)|0;AS(110796|0,111032)|0;AS(110808|0,111040)|0;AS(110820|0,111048)|0;c[26146]=110544;Rb(104592);d=104584;e=c[26146]|0;i=b;return e|0}function L_(b){b=b|0;var d=0,e=0;b=i;if((a[104608]|0)!=0){d=104600;e=c[26150]|0;i=b;return e|0}if((Ya(104608)|0)==0){d=104600;e=c[26150]|0;i=b;return e|0}do{if((a[109992]|0)==0){if((Ya(109992)|0)==0){break}i1(109704,0,288)|0;Qd(381,0,q|0)|0;Rb(109992)}}while(0);aT(109704,11e4)|0;aT(109716|0,110032)|0;aT(109728|0,110072)|0;aT(109740|0,110096)|0;aT(109752|0,110416)|0;aT(109764|0,110120)|0;aT(109776|0,110144)|0;aT(109788|0,110168)|0;aT(109800|0,110200)|0;aT(109812|0,110240)|0;aT(109824|0,110272)|0;aT(109836|0,110312)|0;aT(109848|0,110352)|0;aT(109860|0,110368)|0;aT(109872|0,110384)|0;aT(109884|0,110400)|0;aT(109896|0,110416)|0;aT(109908|0,110432)|0;aT(109920|0,110448)|0;aT(109932|0,110464)|0;aT(109944|0,110480)|0;aT(109956|0,110496)|0;aT(109968|0,110512)|0;aT(109980|0,110528)|0;c[26150]=109704;Rb(104608);d=104600;e=c[26150]|0;i=b;return e|0}function M_(b){b=b|0;var d=0,e=0;b=i;if((a[104624]|0)!=0){d=104616;e=c[26154]|0;i=b;return e|0}if((Ya(104624)|0)==0){d=104616;e=c[26154]|0;i=b;return e|0}do{if((a[109680]|0)==0){if((Ya(109680)|0)==0){break}i1(109392,0,288)|0;Qd(382,0,q|0)|0;Rb(109680)}}while(0);AS(109392,109688)|0;AS(109404|0,109696)|0;c[26154]=109392;Rb(104624);d=104616;e=c[26154]|0;i=b;return e|0}function N_(b){b=b|0;var d=0,e=0;b=i;if((a[104640]|0)!=0){d=104632;e=c[26158]|0;i=b;return e|0}if((Ya(104640)|0)==0){d=104632;e=c[26158]|0;i=b;return e|0}do{if((a[109352]|0)==0){if((Ya(109352)|0)==0){break}i1(109064,0,288)|0;Qd(383,0,q|0)|0;Rb(109352)}}while(0);aT(109064,109360)|0;aT(109076|0,109376)|0;c[26158]=109064;Rb(104640);d=104632;e=c[26158]|0;i=b;return e|0}function O_(b){b=b|0;var c=0;b=i;if((a[104664]|0)!=0){c=104648;i=b;return c|0}if((Ya(104664)|0)==0){c=104648;i=b;return c|0}pS(104648,104672,8);Qd(384,104648,q|0)|0;Rb(104664);c=104648;i=b;return c|0}function P_(b){b=b|0;var c=0;b=i;if((a[104704]|0)!=0){c=104688;i=b;return c|0}if((Ya(104704)|0)==0){c=104688;i=b;return c|0}ZS(104688,104712,c0(104712)|0);Qd(385,104688,q|0)|0;Rb(104704);c=104688;i=b;return c|0}function Q_(b){b=b|0;var c=0;b=i;if((a[104768]|0)!=0){c=104752;i=b;return c|0}if((Ya(104768)|0)==0){c=104752;i=b;return c|0}pS(104752,104776,8);Qd(384,104752,q|0)|0;Rb(104768);c=104752;i=b;return c|0}function R_(b){b=b|0;var c=0;b=i;if((a[104808]|0)!=0){c=104792;i=b;return c|0}if((Ya(104808)|0)==0){c=104792;i=b;return c|0}ZS(104792,104816,c0(104816)|0);Qd(385,104792,q|0)|0;Rb(104808);c=104792;i=b;return c|0}function S_(b){b=b|0;var c=0;b=i;if((a[104872]|0)!=0){c=104856;i=b;return c|0}if((Ya(104872)|0)==0){c=104856;i=b;return c|0}pS(104856,104880,20);Qd(384,104856,q|0)|0;Rb(104872);c=104856;i=b;return c|0}function T_(b){b=b|0;var c=0;b=i;if((a[104920]|0)!=0){c=104904;i=b;return c|0}if((Ya(104920)|0)==0){c=104904;i=b;return c|0}ZS(104904,104928,c0(104928)|0);Qd(385,104904,q|0)|0;Rb(104920);c=104904;i=b;return c|0}function U_(b){b=b|0;var c=0;b=i;if((a[105032]|0)!=0){c=105016;i=b;return c|0}if((Ya(105032)|0)==0){c=105016;i=b;return c|0}pS(105016,105040,11);Qd(384,105016,q|0)|0;Rb(105032);c=105016;i=b;return c|0}function V_(b){b=b|0;var c=0;b=i;if((a[105072]|0)!=0){c=105056;i=b;return c|0}if((Ya(105072)|0)==0){c=105056;i=b;return c|0}ZS(105056,105080,c0(105080)|0);Qd(385,105056,q|0)|0;Rb(105072);c=105056;i=b;return c|0}function W_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);l=+_0(b,g,c[26034]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function X_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);l=+_0(b,g,c[26034]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function Y_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Lc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);l=+_0(b,g,c[26034]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function Z_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);n=kb(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function __(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);m=kb(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function $_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);m=kb(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function a$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);m=kb(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function b$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Lc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);n=Ec(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function c$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Lc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[104144]|0)==0){if((Ya(104144)|0)==0){break}c[26034]=Xb(2147483647,104152,0)|0;Rb(104144)}}while(0);m=Ec(b|0,h|0,f|0,c[26034]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function d$(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Yd[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Yd[h&511](a);i=b;return}}function e$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){ZY(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=I0(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;g1(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{K0(h);i=e;return}}function f$(a){a=a|0;a=i;$S(109340|0);$S(109328|0);$S(109316|0);$S(109304|0);$S(109292|0);$S(109280|0);$S(109268|0);$S(109256|0);$S(109244|0);$S(109232|0);$S(109220|0);$S(109208|0);$S(109196|0);$S(109184|0);$S(109172|0);$S(109160|0);$S(109148|0);$S(109136|0);$S(109124|0);$S(109112|0);$S(109100|0);$S(109088|0);$S(109076|0);$S(109064);i=a;return}function g$(a){a=a|0;a=i;xS(109668|0);xS(109656|0);xS(109644|0);xS(109632|0);xS(109620|0);xS(109608|0);xS(109596|0);xS(109584|0);xS(109572|0);xS(109560|0);xS(109548|0);xS(109536|0);xS(109524|0);xS(109512|0);xS(109500|0);xS(109488|0);xS(109476|0);xS(109464|0);xS(109452|0);xS(109440|0);xS(109428|0);xS(109416|0);xS(109404|0);xS(109392);i=a;return}



function Xt(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[26664+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[26740+l|0]|0|0)!=28){if((d[26740+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[26740+q|0]|0|0)!=28){if((d[26740+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[26740+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Yt(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[20832+(((d[20576+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[20832+(((d[22112+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Vt(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function Yt(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[26740+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Zt(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=oe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[20832+(((d[22112+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function _t(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=oe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[20832+(((d[20576+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function $t(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=oe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Yt(a)|0)<0;g=f&1;i=d;return g|0}function au(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Vt(oe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function bu(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(oe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function cu(){i=i;return 26296}function du(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=eu(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=30;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((su(d,c[26200+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function fu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=qw(24640,a,0,b,c,d)|0;i=e;return f|0}function gu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=qw(24640,a,1,b,c,d)|0;i=e;return f|0}function hu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Pv(25408,b,c,d);i=a;return}function iu(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=ju(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function ju(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(rw(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((ye[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,26144)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((rw(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((ye[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,26152)|0)!=0){h=sw(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ce[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((rw(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((ye[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,26168)|0)!=0){if((a|0)!=0){break}do{if((ye[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,26184)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((ye[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,26192)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((tw(sw(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function ku(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((su(h,22368)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=eu(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[24640+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function lu(){i=i;return 24272}function mu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=eu(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=30;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function nu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=qw(22376,a,0,b,c,d)|0;i=e;return f|0}function ou(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=qw(22376,a,1,b,c,d)|0;i=e;return f|0}function pu(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=ju(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function qu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Vd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((su(h,22368)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=eu(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[22376+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function ru(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Xt(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function su(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function tu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=Mu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Ku(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 15:{k=Su(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=Xu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=Ku(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{q=18;b=b+2|0;n=77;break};case 13:{k=Wu(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;n=77;break};case 12:{k=Wu(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;q=18;n=77;break a}if((c[20832+((d[22112+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;q=19;n=77;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 19:{k=Yu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}p=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[p]|0)|0]|0}else{s=Ku(a[p+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Ku(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 33:{n=119;break b;break};case 6:{n=88;break b;break};case 34:{n=116;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}q=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Ku(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{q=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 7:{n=91;break b;break};case 15:{n=122;break b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=85;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function uu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=Pu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=Lu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Ku(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Ku(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function vu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Ku(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Ku(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function wu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Ku(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function xu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Ku(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=16;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 2:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Lu(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Ku(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function yu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Ku(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=21;break a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Lu(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Mu(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Ku(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function zu(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Ku(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=Ku(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Au(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Bu(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Ku(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Cu(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Ku(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Du(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Ku(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Ku(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Eu(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Yt(c)|0;k=j;i=b;return k|0}function Fu(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==103){g=62;h=g;i=b;return h|0}else if((j|0)==108){g=60;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function Gu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Ku(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Ku(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Hu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Ku(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Iu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Ju(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Ku(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function Lu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 19:{k=Nu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Ku(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Mu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Ku(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Nu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Ou(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Ku(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Ou(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Ku(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Ku(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Pu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Su(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Ku(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=Ru(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=Qu(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Tu(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Ku(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 5:{o=39;break b;break};case 17:{break b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Ku(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 24:case 22:{break};case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Ku(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 17:{break c;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 7:{o=84;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Uu(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Qu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Ku(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Ru(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[22776+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Su(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Ku(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Ku(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=31;break b;break};case 5:{p=28;break b;break};case 7:{p=34;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Vu(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Ku(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Vu(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Tu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Ku(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 23:{b=b+2|0;continue b;break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Ku(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Uu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Ku(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 14:{break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Ku(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 29:{if((c[20832+((d[20576+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};case 29:{if((c[20832+((d[22112+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=Ku(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=Ku(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=Ku(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 3:{t=Lu(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=Ku(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=Ku(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[20832+((d[20576+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Vu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Wu(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Ku(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Ku(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Xu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Ku(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Ku(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=Qu(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Yu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Ku(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[20832+((d[20576+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Ku(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 29:{if((c[20832+((d[22112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Zu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 13:{k=zv(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Ku(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=Av(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=vv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 19:{k=Bv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Ku(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=zv(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{q=18;b=b+2|0;n=77;break};case 29:{g=b;if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;n=77;break a}if((c[20832+((d[22112+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;q=19;n=77;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=pv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}p=b;if((a[r]|0)==0){s=d[j+76+(d[p+1|0]|0)|0]|0}else{s=Ku(a[p]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Ku(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 5:{n=85;break b;break};case 6:{n=88;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=91;break b;break};case 34:{n=116;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 33:{n=119;break b;break};case 15:{n=122;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Ku(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=108;break b;break};case 5:{n=105;break b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};default:{q=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function _u(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=ov(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Ku(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=sv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Ku(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function $u(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Ku(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Ku(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function av(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Ku(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function bv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Ku(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 21:{n=29;break a;break};case 2:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ov(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Ku(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function cv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Ku(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ov(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=pv(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Ku(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function dv(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Ku(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{break};case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=Ku(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function ev(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function fv(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Ku(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function gv(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Ku(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function hv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Ku(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Ku(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function iv(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Yt(c)|0;k=j;i=b;return k|0}function jv(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==103){g=62;h=g;i=b;return h|0}else if((j|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function kv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Ku(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Ku(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function lv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Ku(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function mv(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function nv(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function ov(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 19:{k=qv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Ku(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function pv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[20832+((d[20576+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Ku(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[20832+((d[22112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function qv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=rv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Ku(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Ku(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function rv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Ku(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Ku(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}



function BC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;QA(b,+h[b+240>>3]);dB(b);iB(b);nC(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=E0(c[y>>2]|0,8)|0;A=b+124|0;B=E0(c[A>>2]|0,4)|0;C=b+128|0;D=E0(c[C>>2]|0,1)|0;E=b+132|0;F=E0(c[E>>2]|0,4)|0;G=b+536|0;Rx(c[G>>2]|0,(z|0)!=0|0,68784,t);Rx(c[G>>2]|0,(B|0)!=0|0,68784,s);Rx(c[G>>2]|0,(D|0)!=0|0,68784,r);Rx(c[G>>2]|0,(F|0)!=0|0,68784,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[29940>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];gc(x|0,68800,p|0)|0;p=hc(x|0,68816)|0;c[o>>2]=68832;od(p|0,68824,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];od(p|0,68824,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Jd(10,p|0)|0;H=p}Ox(9,1,68840,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(9,0,68864,l);if((c[29940>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(H|0,68888,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];od(H|0,68888,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Jd(10,H|0)|0}if((MB(b,0)|0)!=0){break a}if((EB(b,0)|0)!=0){break a}if((uB(b,0)|0)!=0){break a}lB(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Yd[c[7614]&511](9);if((c[29940>>2]|0)!=0){Vc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}D0(z);D0(B);D0(D);D0(F)}else{h[b+304>>3]=1.0;$d[c[w+80>>2]&127](b)|0}aB(b);if((nC(b,1,1)|0)!=1){i=e;return}$d[c[(c[v>>2]|0)+80>>2]&127](b)|0;aB(b);if((nC(b,1,1)|0)!=1){i=e;return}Qx(1,0,68896,f);i=e;return}function CC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=FC(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){Ox(9,0,69e3,u);if((c[b+184>>2]|0)==0){oe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}D0(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){Ox(9,0,69032,t);oe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;D0(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){Ox(9,1,69104,s);t=C0(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+vC(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+vC(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}Ox(9,1,69128,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Ox(9,0,69152,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Ox(9,0,69152,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];Ox(9,0,69152,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[29940>>2]|0)!=0){Yd[c[7614]&511](9);Yd[c[7614]&511](9)}D0(t);GC(v);H=FC(b)|0;if((c[H>>2]|0)!=0){$=H;break}Ox(9,0,69176,n);D0(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}Ox(9,0,69208,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){Ox(9,0,69224,l);DC($,d,1,e);wC(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+vC($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){D0(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){D0(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){D0(v);c[l>>2]=0}DC($,d,0,e);wC(b,$);+vC($,1.0)}else{Ox(9,0,69248,j)}Ox(9,1,69272,g);wC(b,$);b=uC($)|0;if((c[29940>>2]|0)!=0){Yd[c[7614]&511](9)}GC($);y=b;i=f;return y|0}function DC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=C0(c[p>>2]<<3)|0;r=q;s=+vC(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;IC(a,r);D0(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=69400;F=E;Ox(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;Ox(9,0,69312,m);if(!t){HC(a)}switch(b|0){case 2:{G=NC(a)|0;break};case 5:{H=13;break a;break};case 1:{G=PC(a)|0;break};case 6:{H=14;break a;break};case 4:{H=12;break a;break};case 3:{G=RC(a,n,e)|0;break};default:{H=15;break a}}iB(o);_A(o);eB(o);iB(o);s=+vC(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}Ox(9,0,69360,k);wC(o,a);K=s}else{Ox(9,0,69376,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){MC(a)|0}else if((H|0)==13){MC(a)|0}else if((H|0)==14){LC(o,a,0)|0}else if((H|0)==15){Sx(c[o+536>>2]|0,69336,l)}else if((H|0)==23){IC(a,r);D0(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=69400;F=E;Ox(9,0,F,g);i=f;return}}function EC(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=e1(b|0)|0;do{if((d|0)==0){e=C0(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=C0(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if(($0(e,70416,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;g1(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if(($0(e,70416,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function FC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=C0(64)|0;z=y;Rx(0,(y|0)!=0|0,70424,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=E0(Z,8)|0;c[E>>2]=y;Rx(0,(y|0)!=0|0,70424,w);w=E0(Z,8)|0;c[F>>2]=w;Rx(0,(w|0)!=0|0,70424,v);v=E0(Z,8)|0;c[G>>2]=v;Rx(0,(v|0)!=0|0,70424,u);u=E0(Z,8)|0;c[H>>2]=u;Rx(0,(u|0)!=0|0,70424,t);t=E0(Z,8)|0;c[I>>2]=t;Rx(0,(t|0)!=0|0,70424,s);s=E0(Z,4)|0;t=s;c[J>>2]=t;Rx(0,(s|0)!=0|0,70424,r);Ox(9,0,70440,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;Ox(9,0,70464,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ox(9,0,70552,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Ox(9,0,70600,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Ox(9,0,70656,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;Ox(9,0,70712,l);c[j>>2]=ya;Ox(9,0,70784,j);j=E0(sa,8)|0;c[K>>2]=j;Rx(0,(j|0)!=0|0,70424,g);g=C0(sa<<3)|0;c[L>>2]=g;Rx(0,(g|0)!=0|0,70424,f);f=C0(ya<<3)|0;c[M>>2]=f;Rx(0,(f|0)!=0|0,70424,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function GC(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){D0(d)}d=c[a+28>>2]|0;if((d|0)!=0){D0(d)}d=c[a+32>>2]|0;if((d|0)!=0){D0(d)}d=c[a+36>>2]|0;if((d|0)!=0){D0(d)}d=c[a+40>>2]|0;if((d|0)!=0){D0(d)}d=c[a+44>>2]|0;if((d|0)!=0){D0(d)}d=c[a+48>>2]|0;if((d|0)!=0){D0(d)}d=c[a+52>>2]|0;if((d|0)!=0){D0(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;D0(e);i=b;return}D0(d);e=a;D0(e);i=b;return}function HC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=E0(o,8)|0;q=E0(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=E0(s,8)|0;u=E0(s,8)|0;v=E0(o,8)|0;w=E0(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+vC(b,1.0);s=c[n>>2]|0;if((s|0)>0){g1(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+vC(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){g1(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;Ox(9,0,70824,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}D0(p);D0(q);D0(t);D0(u);D0(v);D0(w);i=d;return}function IC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function JC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function KC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function LC(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Sx(c[a+536>>2]|0,70896,d);return 0}function MC(a){a=a|0;a=i;i=i+8|0;Sx(0,70928,a);return 0}function NC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[29940>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=E0((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Rx(0,(n|0)!=0|0,70968,b);c[17746]=c[a+60>>2];c[17748]=c[a+48>>2];qA(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;D0(n);c[17746]=0;c[17748]=0;n=uC(a)|0;i=b;return n|0}function OC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[17748];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[17746];h[d>>3]=+vC(f,1.0);i=e;return}function PC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=C0(x)|0;z=y;A=C0(x)|0;x=A;Rx(0,(y|0)!=0|0,71e3,n);Rx(0,(A|0)!=0|0,71e3,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[29940>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+vC(a,1.0);h[o>>3]=D;if(D!=0.0){c[17754]=c[a+60>>2];c[17756]=c[a+48>>2];nA(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[17754]=0;c[17756]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Ox(9,0,71032,l)}D=+vC(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Ox(9,0,71136,j);j=c[u>>2]|0;do{if((j|0)==2){Qx(9,0,71232,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Qx(9,0,71152,g);F=-1;i=b;return F|0}else if((j|0)==3){Qx(9,0,71296,e);F=-3;i=b;return F|0}else if((j|0)==4){Qx(9,0,71368,d);F=-4;i=b;return F|0}}while(0);F=uC(a)|0;i=b;return F|0}function QC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[17756];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[17754];h[d>>3]=+vC(f,1.0);i=e;return}function RC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;Ox(9,1,71424,g);if((c[29940>>2]|0)==0){l=0}else{l=(k|0)/10|0}SC(a,d,k,l,b,j);c[f>>2]=c[j>>2];Ox(9,0,71448,f);Yd[c[7614]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=uC(a)|0;if((b|0)==0){m=0;i=e;return m|0}Qx(9,0,71464,e);m=b;i=e;return m|0}function SC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=C0(fa(N,M)|0)|0;P=C0(M<<3)|0;Q=C0(N)|0;R=Q;S=C0(N)|0;T=S;V=C0(N)|0;W=V;X=C0(N)|0;Y=+h[f>>3];if((c[29940>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];gc(N|0,71512,I|0)|0;I=hc(N|0,71528)|0;c[H>>2]=71544;od(I|0,71536,H|0)|0;c[G>>2]=71560;od(I|0,71536,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];od(I|0,71536,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Jd(10,I|0)|0;c[E>>2]=0;od(I|0,71568,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(I|0,71576,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];od(I|0,71576,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Jd(10,I|0)|0;Z=I}else{Z=0}Rx(0,(O|0)!=0|0,71584,B);Rx(0,(P|0)!=0|0,71584,A);Rx(0,(Q|0)!=0|0,71584,z);Rx(0,(S|0)!=0|0,71584,y);Rx(0,(V|0)!=0|0,71584,x);Rx(0,(X|0)!=0|0,71584,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{JC(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+vC(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;JC(a,la);+vC(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Ox(9,0,71600,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){i1(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);JC(a,R);za=+vC(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}g1(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}JC(a,T);if(+vC(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}g1(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}g1(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}JC(a,W);Ba=+vC(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}JC(a,W);Ba=+vC(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}g1(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ox(9,0,71640,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;od(Z|0,71568,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];od(Z|0,71576,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];od(Z|0,71576,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Qx(9,0,71688,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Qx(9,0,71704,p);Sx(0,71720,o)}JC(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){D0(S);D0(Q);D0(V);D0(X);D0(P);D0(O);i=j;return}c[n>>2]=ia;od(Z|0,71568,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,71576,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];od(Z|0,71576,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Jd(10,Z|0)|0;Vc(Z|0)|0;D0(S);D0(Q);D0(V);D0(X);D0(P);D0(O);i=j;return}function TC(a,b){a=a|0;b=b|0;i=i;return}function UC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Az(3);Dz(0);w=+vz(0);Az(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(v|0,71800,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];od(v|0,71800,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(v|0,71800,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];od(v|0,71808,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;od(v|0,71808,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];od(v|0,71816,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,71800,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];od(v|0,71800,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;od(v|0,71808,l|0)|0;break}else{c[m>>2]=0-E;od(v|0,71808,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;od(v|0,71808,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;od(v|0,71808,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Jd(10,v|0)|0;Dz(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];od(v|0,71816,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Jd(10,v|0)|0;Dz(3);i=e;return}function VC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=hc(c[r>>2]|0,71824)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Nd(c[(Lc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Rx(t,(s|0)!=0|0,71832,q);c[p>>2]=71888;od(s|0,71816,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=71896;od(s|0,71816,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];od(s|0,71816,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];od(s|0,71816,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];od(s|0,71816,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];od(s|0,71816,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];od(s|0,71816,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];od(s|0,71816,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];od(s|0,71816,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];od(s|0,71816,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Jd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function WC(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Az(3);Vc(d|0)|0;Dz(3);i=b;return}function XC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;OU(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];PU(p,f)|0;YC(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;ZC(a,b,71912,c[j>>2]|0,c[g>>2]|0,o,8);D0(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];PU(p,e)|0;i=d;return}function YC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=E0(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Rx(c[b+536>>2]|0,(p|0)!=0|0,72192,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function ZC(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;iD(a,b,d,e,f,h);NU(l,g,fa(fa(f,e)|0,h)|0)|0;if(iT(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Sx(l,72144,k)}else{i=j;return}}function _C(a){a=a|0;var b=0;b=i;if((aE(a+4|0)|0)!=0){i=b;return}lT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function $C(a){a=a|0;Pc(a|0)|0;Xa()}function aD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=I0(320)|0;i1(q|0,0,320)|0;bD(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Az(3);t=a+8|0;u=cD(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=dD(a,b,u+s|0)|0;u=q+184|0;eD(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;eD(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;fD(q,c[x>>2]|0,36);if(iT(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Sx(y,71968,e)}else{ZC(a,b,72e3,4,11,71920,1);gD((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;ZC(a,b,72008,c[g>>2]|0,c[j>>2]|0,e,1);D0(e);c[f>>2]=0;gD((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;ZC(a,b,72016,c[g>>2]|0,c[j>>2]|0,e,1);D0(e);c[f>>2]=0;hD(a,b,k,g,j,c[r>>2]|0,s);ZC(a,b,72032,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;OU(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];YC(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;ZC(a,b,71912,c[j>>2]|0,c[g>>2]|0,n,8);OU(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=jD(q+240|0)|0;w=jD(q+264|0)|0;p=jD(q+288|0)|0;iD(a,b,72048,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);D0(n);D0(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;tU(s)|0;D0(v);Dz(3);i=d;return}}function bD(a){a=a|0;var b=0;b=i;kG(a);i=b;return}function cD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(oF(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(oF(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(oF(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function dD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=C0(e<<2)|0;e=l;c[l>>2]=72600;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=72640;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(oF(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(oF(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(oF(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function eD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$D(a,b,c);i=d;return}function fD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_D(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){lT(d,4);i=e;return}else{jT(d,0);i=e;return}}function gD(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=e1(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=E0((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Rx(0,(o|0)!=0|0,72120,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;p1(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;nD(q,e1(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=E0(1,1)|0;c[d>>2]=q;Rx(0,(q|0)!=0|0,72120,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function hD(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=E0(c[f>>2]<<2,4)|0;c[e>>2]=g;Rx(c[d+536>>2]|0,(g|0)!=0|0,72168,k);g=s+240|0;f=jD(g)|0;h=s+264|0;t=jD(h)|0;u=s+288|0;v=jD(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=jD(g)|0;D=jD(h)|0;E=jD(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){oD(l,g,A+(v*52|0)+4|0);qD(m,g);if(!(pD(l,m)|0)){F=w;break}G=(c[(rD(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==1){oD(l,b,A+(v*52|0)+4|0);qD(n,b);if(!(pD(l,n)|0)){F=w;break}G=(c[(rD(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){oD(l,h,G+(t*52|0)+4|0);qD(o,h);H=pD(l,o)|0;J=H?2:0}else if(f<<24>>24==1){oD(l,v,G+(t*52|0)+4|0);qD(p,v);J=(pD(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(rD(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){oD(l,u,y+(t*52|0)+4|0);qD(q,u);F=pD(l,q)|0;M=F?2:0}else if(x<<24>>24==1){oD(l,d,y+(t*52|0)+4|0);qD(r,d);M=(pD(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(rD(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function iD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(e1(d|0)|0)+1;e=m;NU(e,l,20)|0;if(iT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Sx(l,72144,k)}NU(e,d,c[f>>2]|0)|0;if(iT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Sx(m,72144,j)}else{i=h;return}}function jD(a){a=a|0;var b=0,d=0;b=i;d=c[(XD(a)|0)>>2]|0;i=b;return d|0}function kD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Az(3);do{if(hT(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];PU(k,e)|0;k=jD(h+240|0)|0;m=jD(h+264|0)|0;l=jD(h+288|0)|0;iD(a,b,72048,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);_C(h)}else{if((h|0)!=0){break}c[g>>2]=0;Dz(3);i=d;return}}while(0);lD(j);K0(h);c[g>>2]=0;Dz(3);i=d;return}function lD(a){a=a|0;var b=0;b=i;tE(a);i=b;return}function mD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Az(3);Dz(0);h[j>>3]=+vz(0);Az(0);l=k;m=d+4|0;NU(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){NU(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){NU(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);NU(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);NU(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);NU(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(iT(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Sx(t,72088,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Dz(3);i=e;return}}function nD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((b1(b,72304,4)|0)!=0){i=d;return}c=b;while(1){e=Ua(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((b1(b,72304,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function oD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;JD(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];zD(a,f);i=e;return}function pD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xD(a,b)|0;i=c;return d|0}function qD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;AD(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];zD(a,e);i=d;return}function rD(a){a=a|0;var b=0,c=0;b=i;c=sD(tD(a)|0)|0;i=b;return c|0}function sD(a){a=a|0;var b=0,c=0;b=i;c=wD(a)|0;i=b;return c|0}function tD(a){a=a|0;var b=0,d=0;b=i;d=uD((c[a>>2]|0)+16|0)|0;i=b;return d|0}function uD(a){a=a|0;var b=0,c=0;b=i;c=vD(a)|0;i=b;return c|0}function vD(a){a=a|0;i=i;return a|0}function wD(a){a=a|0;i=i;return a|0}function xD(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yD(a,b)|0)^1;i=c;return d|0}function yD(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function zD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];ID(a,e);i=d;return}function AD(a,b){a=a|0;b=b|0;var c=0;c=i;BD(a,CD(b)|0);i=c;return}function BD(a,b){a=a|0;b=b|0;var c=0;c=i;HD(a,b);i=c;return}function CD(a){a=a|0;var b=0,c=0;b=i;c=DD(ED(a+4|0)|0)|0;i=b;return c|0}function DD(a){a=a|0;var b=0,c=0;b=i;c=GD(a)|0;i=b;return c|0}function ED(a){a=a|0;var b=0,c=0;b=i;c=FD(a)|0;i=b;return c|0}function FD(a){a=a|0;i=i;return a|0}function GD(a){a=a|0;i=i;return a|0}function HD(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function ID(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function JD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=LD(b)|0;KD(f,b,d,h,CD(b)|0);AD(g,b);do{if(xD(f,g)|0){h=MD(b)|0;if(ND(h,d,OD(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);AD(a,b);i=e;return}function KD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;SD(h);a:do{if((e|0)==0){j=f}else{k=MD(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(TD(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;SD(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;SD(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);BD(a,j);i=g;return}function LD(a){a=a|0;var b=0,d=0;b=i;d=c[(CD(a)|0)>>2]|0;i=b;return d|0}function MD(a){a=a|0;var b=0,c=0;b=i;c=QD(a+8|0)|0;i=b;return c|0}function ND(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=PD(0,b,c)|0;i=a;return d|0}function OD(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function PD(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function QD(a){a=a|0;var b=0,c=0;b=i;c=RD(a)|0;i=b;return c|0}function RD(a){a=a|0;i=i;return a|0}function SD(a){a=a|0;var b=0;b=i;UD(a,-1);i=b;return}function TD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=PD(0,b,c)|0;i=a;return d|0}function UD(a,b){a=a|0;b=b|0;b=i;VD(a,0);i=b;return}function VD(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function WD(a){a=a|0;i=i;return c[a+4>>2]|0}function XD(a){a=a|0;var b=0,c=0;b=i;c=YD(a+8|0)|0;i=b;return c|0}function YD(a){a=a|0;var b=0,c=0;b=i;c=ZD(a)|0;i=b;return c|0}function ZD(a){a=a|0;i=i;return a|0}function _D(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 9:case 25:{h=72248;break};case 24:{h=72232;break};case 1:case 17:{h=72216;break};case 28:{h=72280;break};case 12:{h=72272;break};case 48:case 16:{h=72208;break};case 60:{h=72288;break};case 56:{h=72240;break};case 8:{h=72224;break};case 13:case 29:{h=72296;break};case 52:case 20:{h=72256;break};case 5:case 21:{h=72264;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=hc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Tc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Vc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function $D(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function aE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}bE(d,f,102);f=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Vc(cE(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}dE(d);g=h;i=b;return g|0}function bE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;kE(a,b,c);i=d;return}function cE(a){a=a|0;var b=0,d=0;b=i;d=gE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function dE(a){a=a|0;var b=0;b=i;eE(a);i=b;return}function eE(a){a=a|0;var b=0;b=i;fE(a,0);i=b;return}function fE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=gE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$d[c[(hE(e)|0)>>2]&127](f)|0;i=d;return}function gE(a){a=a|0;var b=0,c=0;b=i;c=jE(a)|0;i=b;return c|0}function hE(a){a=a|0;var b=0,c=0;b=i;c=iE(a)|0;i=b;return c|0}function iE(a){a=a|0;i=i;return a+4|0}function jE(a){a=a|0;i=i;return a|0}function kE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(mE(f)|0)>>2]|0;lE(a,d,c[(nE(g)|0)>>2]|0);i=e;return}function lE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;oE(a,b,c);i=d;return}function mE(a){a=a|0;i=i;return a|0}function nE(a){a=a|0;i=i;return a|0}function oE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(qE(f)|0)>>2]|0;pE(a,d,c[(rE(g)|0)>>2]|0);i=e;return}function pE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(qE(f)|0)>>2];c[a+4>>2]=c[(rE(g)|0)>>2];i=e;return}function qE(a){a=a|0;i=i;return a|0}function rE(a){a=a|0;i=i;return a|0}function sE(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function tE(a){a=a|0;var b=0;b=i;uE(a+300|0);uE(a+288|0);uE(a+276|0);uE(a+264|0);uE(a+252|0);uE(a+240|0);vE(a);i=b;return}function uE(a){a=a|0;var b=0;b=i;fF(a);i=b;return}function vE(a){a=a|0;var b=0;b=i;wE(a,72352);pT(a+104|0);i=b;return}function wE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];AE(a+4|0);i=d;return}function xE(a){a=a|0;var b=0;b=i;vE(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function yE(a){a=a|0;var b=0;b=i;vE(a);K0(a);i=b;return}function zE(a){a=a|0;var b=0;b=i;yE(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function AE(a){a=a|0;var b=0;b=i;BE(a);i=b;return}function BE(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=72480;aE(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}L0(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}L0(e)}}while(0);yT(b);i=d;return}function CE(a){a=a|0;var b=0;b=i;AE(a);K0(a);i=b;return}function DE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;$d[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=dF(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=eF(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;IT(h,0,0,0);NT(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}L0(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=J0(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=J0(h)|0;a[b+97|0]=1;i=e;return}function EE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;IT(e,0,0,0);NT(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}L0(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}L0(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=J0(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(aF(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=J0(o)|0;a[k]=1;i=f;return e|0}return 0}function FE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Cc(4)|0;h0(n);Kd(n|0,119808,127)}n=YE(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){eD(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=x1(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Tc(p|0,q|0,f|0)|0)==0){p=xb(c[m>>2]|0)|0;eD(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];$E(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{eD(a,-1,-1);i=g;return}}}while(0);eD(a,-1,-1);i=g;return}function GE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if(($d[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=sE(d)|0;if((Tc(j|0,k|0,0)|0)==0){_E(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{eD(a,-1,-1);i=e;return}}}while(0);eD(a,-1,-1);i=e;return}function HE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Cc(4)|0;h0(m);Kd(m|0,119808,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=YE(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=GT(s)|0;u=(fa(t-(FT(s)|0)|0,p)|0)+r|0;v=0;break}p=FT(s)|0;if((p|0)==(GT(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=ZE(t,g,x,o,p-(ET(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=GT(w)|0;u=q-(FT(w)|0)|0;v=0}}while(0);if((Tc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;IT(b,0,0,0);c[m>>2]=0}else{q=b;y=KT(q)|0;do{if((y|0)!=(JT(q)|0)){if((oe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=XE(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((pc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((md(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function IE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=SE(b)|0;o=b;if((FT(o)|0)==0){p=e+1|0;IT(o,e,p,p)}if(n){q=0}else{n=GT(o)|0;c[f>>2]=(n-(ET(o)|0)|0)/2|0;c[g>>2]=4;q=c[(TE(f,g)|0)>>2]|0}g=FT(o)|0;do{if((g|0)==(GT(o)|0)){h1(ET(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=GT(o)|0;n=ET(o)|0;p=rb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=ET(o)|0;IT(o,n,n+q|0,n+(p+q)|0);r=QE(a[FT(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;h1(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(TE(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=rb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Cc(4)|0;h0(t);Kd(t|0,119808,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=ET(o)|0;if((UE(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;IT(o,f,f,c[s>>2]|0);r=QE(a[FT(o)|0]|0)|0;break}s=c[k>>2]|0;f=ET(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}IT(o,f,p,s);r=QE(a[FT(o)|0]|0)|0}else{r=QE(a[g]|0)|0}}while(0);if((ET(o)|0)!=(e|0)){m=r;i=d;return m|0}IT(o,0,0,0);m=r;i=d;return m|0}function JE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=ET(g)|0;j=FT(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(ME(d,-1)|0){HT(g,-1);f=PE(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=NE(d)|0;do{if(h){if(RE(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);HT(g,-1);a[FT(g)|0]=b;f=d;i=e;return f|0}function KE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}LE(b);l=b;m=JT(l)|0;n=LT(l)|0;if(!(ME(d,-1)|0)){if((KT(l)|0)==0){NT(l,f,f+1|0)}f=NE(d)|0;a[KT(l)|0]=f;MT(l,1)}f=KT(l)|0;o=JT(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=JT(l)|0;A=KT(l)|0;B=OE(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=JT(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((pc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;NT(l,B,KT(l)|0);B=LT(l)|0;MT(l,B-(JT(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Cc(4)|0;u=t;h0(u);v=119808;w=127;Kd(t|0,v|0,w|0)}else if((D|0)==14){q=(KT(l)|0)-C|0;if((pc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((pc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);NT(l,m,n)}k=PE(d)|0;i=e;return k|0}function LE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;IT(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;NT(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;NT(f,h,h+(g+ -1)|0);break}}else{NT(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function ME(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function NE(a){a=a|0;i=i;return a&255|0}function OE(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=xe[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function PE(a){a=a|0;var b=0,c=0;b=i;c=ME(a,-1)|0;i=b;return(c?0:a)|0}function QE(a){a=a|0;i=i;return a&255|0}function RE(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function SE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;NT(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;IT(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;IT(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function TE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=VE(b,c,e)|0;i=d;return g|0}function UE(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=xe[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function VE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=WE(0,b,a)|0;i=c;return(d?b:a)|0}function WE(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function XE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=pe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function YE(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function ZE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=pe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function _E(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function $E(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function aF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=bF(b,c,e)|0;i=d;return g|0}function bF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=cF(0,a,b)|0;i=c;return(d?b:a)|0}function cF(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function dF(a){a=a|0;var b=0,c=0;b=i;c=hZ(a,104312)|0;i=b;return c|0}function eF(a){a=a|0;var b=0,d=0;b=i;d=$d[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function fF(a){a=a|0;var b=0;b=i;gF(a);i=b;return}function gF(a){a=a|0;var b=0;b=i;hF(a);i=b;return}function hF(a){a=a|0;var b=0;b=i;iF(a,LD(a)|0);i=b;return}function iF(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;SD(d);if((b|0)==0){i=d;return}iF(a,c[b>>2]|0);iF(a,c[b+4>>2]|0);kF(jF(a)|0,b,1);i=d;return}function jF(a){a=a|0;var b=0,c=0;b=i;c=mF(a+4|0)|0;i=b;return c|0}function kF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;lF(0,b,0);i=c;return}function lF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;K0(b);i=c;return}function mF(a){a=a|0;var b=0,c=0;b=i;c=nF(a)|0;i=b;return c|0}function nF(a){a=a|0;i=i;return a|0}function oF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=pF(a,f,b)|0;l=c[k>>2]|0;SD(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}rF(j,a,b);sF(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];qF(g,e);tF(j);j=c[f>>2]|0;uF(a,j,k,vF(g)|0);k=wF(g)|0;tF(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function pF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=LD(h)|0;SD(e);if((a|0)==0){j=CD(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(PD(0,d,a)|0){m=l;j=c[m>>2]|0;SD(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(PD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;SD(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];iG(a,e);i=d;return}function rF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=jF(d)|0;d=TF(n,1)|0;UF(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];SF(j,d,h);VF(0,OF((WF(j)|0)+16|0)|0,e);e=XF(j)|0;a[e+4|0]=1;YF(0,NF((WF(j)|0)+20|0)|0);a[e+5|0]=1;ZF(m,j);sF(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];qF(b,g);tF(m);tF(j);i=f;return}function sF(a,b){a=a|0;b=b|0;var c=0;c=i;QF(a,b);i=c;return}function tF(a){a=a|0;var b=0;b=i;JF(a);i=b;return}function uF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;SD(f);c[e>>2]=0;SD(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=BF(a)|0;b=c[c[e>>2]>>2]|0;SD(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(CD(a)|0)>>2]|0;CF(e,c[d>>2]|0);d=DF(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function vF(a){a=a|0;var b=0,d=0;b=i;d=c[(zF(a)|0)>>2]|0;i=b;return d|0}function wF(a){a=a|0;var b=0,d=0;b=i;d=xF(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xF(a){a=a|0;var b=0,c=0;b=i;c=yF(a)|0;i=b;return c|0}function yF(a){a=a|0;i=i;return a|0}function zF(a){a=a|0;var b=0,c=0;b=i;c=AF(a)|0;i=b;return c|0}function AF(a){a=a|0;i=i;return a|0}function BF(a){a=a|0;i=i;return a|0}function CF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=GF(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;SD(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;SD(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(GF(j)|0){p=j}else{o=c[k>>2]|0;HF(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;IF(p);i=e;return}else if((l|0)==14){if(GF(j)|0){p=c[k>>2]|0;IF(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;HF(q);i=e;return}else if((l|0)==17){i=e;return}}function DF(a){a=a|0;var b=0,c=0;b=i;c=EF(a+8|0)|0;i=b;return c|0}function EF(a){a=a|0;var b=0,c=0;b=i;c=FF(a)|0;i=b;return c|0}function FF(a){a=a|0;i=i;return a|0}function GF(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function HF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;SD(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=GF(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function IF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;SD(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=GF(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function JF(a){a=a|0;var b=0;b=i;KF(a,0);i=b;return}function KF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=xF(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}MF(LF(e)|0,f);i=d;return}function LF(a){a=a|0;var b=0,c=0;b=i;c=PF(a)|0;i=b;return c|0}function MF(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}kF(c[a>>2]|0,b,1);i=d;return}function NF(a){a=a|0;i=i;return a|0}function OF(a){a=a|0;i=i;return a|0}function PF(a){a=a|0;i=i;return a+4|0}function QF(a,b){a=a|0;b=b|0;var c=0;c=i;RF(a,b);i=c;return}function RF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function SF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];aG(a,b,f);i=e;return}function TF(a,b){a=a|0;b=b|0;var c=0;a=i;c=$F(0,b,0)|0;i=a;return c|0}function UF(a,b){a=a|0;b=b|0;var c=0;c=i;_F(a,b);i=c;return}function VF(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function WF(a){a=a|0;var b=0,d=0;b=i;d=c[(zF(a)|0)>>2]|0;i=b;return d|0}function XF(a){a=a|0;var b=0,c=0;b=i;c=LF(a)|0;i=b;return c|0}function YF(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function ZF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;QF(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];qF(h,f);sF(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];qF(a,e);tF(h);i=d;return}function _F(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function $F(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=I0(b*24|0)|0;i=c;return a|0}function aG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(cG(g)|0)>>2]|0;g=dG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];bG(b,a,f);i=e;return}function bG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];eG(a,b,f);i=e;return}function cG(a){a=a|0;i=i;return a|0}function dG(a){a=a|0;i=i;return a|0}function eG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(gG(g)|0)>>2]|0;g=hG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fG(b,a,f);i=e;return}function fG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(gG(f)|0)>>2];f=hG(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function gG(a){a=a|0;i=i;return a|0}function hG(a){a=a|0;i=i;return a|0}function iG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=wF(jG(b)|0)|0;h=hG(XF(jG(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];bG(g,a,e);i=d;return}function jG(a){a=a|0;i=i;return c[a>>2]|0}function kG(a){a=a|0;var b=0;b=i;i=i+48|0;lG(a);eD(a+184|0,0,0);eD(a+200|0,0,0);mG(a+240|0,b);mG(a+252|0,b+8|0);mG(a+264|0,b+16|0);mG(a+276|0,b+24|0);mG(a+288|0,b+32|0);mG(a+300|0,b+40|0);i=b;return}function lG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;uT(d);e=a;c[e>>2]=72324;f=d;c[f>>2]=72344;d=a+4|0;BU(a,72356|0,d);c[e>>2]=72324;c[f>>2]=72344;zG(d);i=b;return}function mG(a,b){a=a|0;b=b|0;b=i;nG(a,0);i=b;return}function nG(a,b){a=a|0;b=b|0;b=i;i=i+8|0;oG(a,b);i=b;return}function oG(a,b){a=a|0;b=b|0;b=i;pG(a,0);i=b;return}function pG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;qG(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;rG(f,0,e);e=CD(b)|0;c[(BF(b)|0)>>2]=e;i=d;return}function qG(a){a=a|0;var b=0;b=i;vG(a);i=b;return}function rG(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;sG(b,c,f);i=e;return}function sG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uG(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;tG(d,b,f);i=e;return}function tG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uG(e)|0)>>2];i=d;return}function uG(a){a=a|0;i=i;return a|0}function vG(a){a=a|0;var b=0;b=i;wG(a);i=b;return}function wG(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function xG(a){a=a|0;var b=0;b=i;yG(a);i=b;return}function yG(a){a=a|0;c[a>>2]=0;i=i;return}function zG(a){a=a|0;var b=0;b=i;AG(a);i=b;return}function AG(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;DT(j);c[d>>2]=72480;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;SD(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;zT(g,j);l=BG(g)|0;fZ(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ce[r&63](d,0,4096)|0;i=e;return}zT(h,j);c[k>>2]=dF(h)|0;fZ(h);a[f]=(eF(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ce[r&63](d,0,4096)|0;i=e;return}function BG(a){a=a|0;var b=0,c=0;b=i;c=gZ(a,104312)|0;i=b;return c|0}function CG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Az(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){DG(a,b,c[f>>2]|0,h);Dz(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=F0(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Sx(k,72752,e)}DG(a,b,l,h);Dz(3);i=d;return}function DG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Dz(0);k=+vz(0);Az(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function EG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=C0(24)|0;Az(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Rx(c[m>>2]|0,l>>>31^1,72808,f);f=b+8|0;b=c[a+8>>2]|0;l=FG(b,f)|0;c[g+20>>2]=l;l=FG(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=C0(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Sx(k,72888,e)}else{c[h>>2]=0;c[a+12>>2]=g;Dz(3);i=d;return}}function FG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}



function rA(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[7178]=.5;h[7169]=1.0;h[7209]=.1;F=(c[a>>2]|0)+1|0;c[14334]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[14326]=H;I=(c[b>>2]|0)-F|0;c[14380]=I;F=c[j>>2]|0;c[14434]=(F|0)<1?1:F;F=c[a>>2]|0;c[14318]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[14320]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[14320]=J+1}L=c[u>>2]|0;c[14316]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[14316]=L+1}K=j+1|0;c[14318]=K;if((j|0)<(F|0)){j=K}else{break}}}c[14322]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[14322]=H+1}H=c[b>>2]|0;c[14320]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[14318]=M;c[14320]=H+1}N=+h[e>>3];O=N*N;h[7214]=O;h[7200]=+h[7169]/O;h[7201]=+V(+(+h[7178]))/O;c[14324]=0;H=y;y=A;M=0;a:while(1){c[14336]=M;F=M-(c[a>>2]|0)|0;c[14360]=F;j=M+1|0;c[14324]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[14410]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[14348]=L;K=L+G|0;c[14346]=K;if((K|0)>(c[a>>2]|0)){c[14410]=L;G=K-(c[a>>2]|0)|0;c[14348]=G;c[14346]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[7191]=O;L=c[14334]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[7191]=N;R=N}else{R=O}O=+h[e>>3];h[7192]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[7192]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[7192];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[14318]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[14318]=S+1}if((M|0)>=(c[14434]|0)){T=j;U=159;break}while(1){ce[H&63](a,d,57256)|0;if((c[g>>2]|0)==3){fR(57784)|0;wQ(57952,57296,4)|0;wQ(57952,57256,8)|0;I=c[a>>2]|0;c[14316]=1;if((I|0)>=1){F=1;do{wQ(57952,d+(F+ -1<<3)|0,8)|0;L=c[14316]|0;F=L+1|0;c[14316]=F;}while((L|0)<(I|0))}PQ()|0}I=c[14324]|0;do{if((I|0)>(c[b>>2]|0)){F=c[14364]|0;if((F|0)==-1){break a}h[7210]=0.0;c[14322]=0;L=c[a>>2]|0;c[14318]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[7210]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[7183]=N;if((X|0)==(G|0)){ea=N*+h[7178];h[7183]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[7210]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[14322]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[14316]=Y;c[14318]=L+1;W=Z}J=c[b>>2]|0;c[14320]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[7210]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[14320]=J+1;ia=ja}O=+h[7157];ba=+h[7186];N=O-ba-ia;h[7177]=N;h[7196]=+h[7195];h[7195]=+h[7194];if(!(N>=0.0)){ka=-N}else{ka=N}h[7194]=ka;if(+h[7206]>+h[7172]){c[14408]=I}h[7202]=ba;do{if(O<ba){h[7186]=O;h[7219]=0.0;G=c[a>>2]|0;c[14316]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[7219]=+h[7219]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[14316]=G+1;h[A>>3]=ma}}while(0);c[14406]=F;if((F|0)<=0){O=+h[7210];if(O>=0.0){U=190;break a}ba=+h[7157];N=+h[7202];ea=(ba-N)/O;h[7207]=ea;O=+h[7209];do{if(!(ea<=O)){na=+h[7178]*+h[7199];h[A>>3]=na;oa=+h[7206];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[7199]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[7199]=qa;ra=qa;break}}else{qa=+h[7178]*+h[7206];h[7199]=qa;ra=qa}}while(0);ea=+h[7172];if(!(ra<=ea*1.5)){sa=ra}else{h[7199]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[7214]=ea;c[14422]=0;h[7215]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[14378]|0;c[14422]=J;oa=+h[7169];h[7215]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[14320]=1;if((J|0)<1){va=F}else{L=c[14380]|0;oa=ua;K=1;ca=F;while(1){h[7197]=0.0;c[14318]=1;if((L|0)<1){wa=0.0}else{X=c[14340]|0;aa=K+C|0;qa=+h[7169];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[7183]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[7197]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[14318]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[7179]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[7183]=za;h[7218]=0.0;$=c[a>>2]|0;c[14318]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[7218]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[14318]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[7183]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[7215]=Fa;c[14364]=K;Ga=Fa;Ha=K}aa=K+1|0;c[14320]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}xA(a,b,s,t,57360,u,w,57432,57456,x)|0;ca=c[14364]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[7157];c[14322]=0;J=c[a>>2]|0;c[14316]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[7183]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[7183];G=G+1|0;da=da+1|0}da=X+aa|0;c[14322]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[14318]=La;c[14316]=J+1}h[L>>3]=0.0;X=c[14380]|0;c[14318]=1;aa=(X|0)<1;if(!aa){F=c[14340]|0;K=1;while(1){da=fa(K,B)|0;O=+h[7177]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[7183]=Oa;G=c[b>>2]|0;c[14320]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[7183];$=$+1|0}c[14320]=G+1}$=K+1|0;c[14318]=$;if((K|0)<(X|0)){K=$}else{break}}}h[7188]=0.0;K=c[a>>2]|0;c[14316]=1;if((K|0)>=1){F=1;while(1){O=+h[7177]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[7188]=+h[7188]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[14316]=K+1;h[A>>3]=Pa}F=c[14406]|0;do{if((F|0)==0){if(!(+h[7199]==+h[7172])){break}O=+h[7207];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[14426]=0;break}L=c[b>>2]|0;c[14320]=1;if((L|0)>=1){J=o+((c[14378]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[14320]=L+1}h[7181]=0.0;$=c[a>>2]|0;c[14316]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[7175]=0.0;G=c[b>>2]|0;c[14320]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[7175]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[14320]=G+1;Sa=Ta}h[7181]=+h[7181]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[14316]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[7181]*100.0}J=c[14426]|0;c[14426]=J+1;if(+h[7188]<Ra){c[14426]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[14316]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[14316]=J+1}$=c[14326]|0;c[14322]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[14322]=$+1}c[14318]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[14320]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[14320]=Na+1;Ua=Wa}if((L|0)<(c[14340]|0)){h[J>>3]=-Ua}Va=L+1|0;c[14318]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[14320]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[14318]=Xa;c[14320]=L+1}c[14426]=0}}while(0);O=+h[7157];ea=+h[7202];if(O<ea){c[14378]=ca}oa=+h[7209];if(O<=ea+oa*+h[7210]|(F|0)>0){U=54;break}c[14364]=0;Ia=0;Ja=+h[7199];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[7157];oa=+h[7157];do{if((I|0)==1){h[7176]=oa;h[7186]=oa;c[14378]=1;Ya=1}else{if(!(oa<+h[7186])){Ya=I;break}h[7186]=oa;c[14378]=I;Ya=I}}while(0);F=c[14336]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[14346]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[14348]|0;Va=K+aa|0;c[14322]=Va;if(+h[7191]<0.0){aa=X+(c[a>>2]|0)|0;c[14346]=aa;Za=aa}else{Za=X}if(+h[7192]<0.0){X=K+(c[a>>2]|0)|0;c[14348]=X;_a=X}else{_a=K}K=fa(c[14360]|0,B)|0;h[t+(K-B<<3)>>3]=+h[7200];h[t+(Ya+C+K<<3)>>3]=+h[7200];h[t+(Za-B+K<<3)>>3]=-+h[7200];h[t+(_a-B+K<<3)>>3]=-+h[7200];h[q+(Va+ -1<<3)>>3]=(+h[7176]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[7157])/(+h[7191]*+h[7192])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[14360]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[7178]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[7178]/+h[e>>3];ea=+h[7201];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[7201];h[t+(X+K<<3)>>3]=+h[7201];K=(fa(Va+1|0,Va)|0)/2|0;c[14322]=K;ea=(+h[7176]- +h[7157])/+h[e>>3];h[7183]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[7178]*(+h[X>>3]+ +h[7183]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[7176])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[7169]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[7169]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[7178]*+h[7214]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[7172]=oa;h[7199]=oa;c[14340]=1;h[7194]=0.0;h[7195]=0.0;c[14426]=0;h[7219]=0.0;F=c[a>>2]|0;c[14316]=1;if((F|0)<1){U=53;break}ca=c[14378]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[7219]=+h[7219]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[14316]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[14408]=c[14324];U=54;continue}else if((U|0)==54){U=0;c[14364]=0;I=(c[14334]|0)+ -1|0;K=c[a>>2]|0;wA(a,b,l,n,p,q,r,57592,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,57728)|0;h[7171]=0.0;K=c[a>>2]|0;c[14316]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[7171]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[14316]=K+1;ab=cb}oa=+h[7199];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[7206]=O;ea=+h[7172];if(!(O<+h[7178]*ea)){db=ab;U=62;break}c[14364]=-1;O=+h[7209];N=O*oa;h[7199]=N;h[7207]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[7199]=ea;eb=ea}if((c[14324]|0)<=((c[14408]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[7216]*.125*ea;h[7183]=N;oa=+h[7194];ba=+h[7195];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[7196];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[7218]=O;I=c[b>>2]|0;c[14320]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[7175]=0.0;X=c[a>>2]|0;c[14318]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[7175]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[14318]=X+1;jb=lb}if(jb>ea){c[14364]=F;h[7218]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[14320]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[7207]>0.0){U=54;continue}ea=+h[7206];O=+h[7172];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[7178];h[7199]=O;ea=hb/+h[f>>3];h[7207]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[7172]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[7172]=na;ob=na;break}}else{na=+h[f>>3];h[7172]=na;ob=na}}while(0);h[7199]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){fR(57832)|0;PQ()|0}fR(57856)|0;wQ(57952,57376,8)|0;wQ(57952,57296,4)|0;PQ()|0;fR(57880)|0;wQ(57952,57488,8)|0;ca=c[a>>2]|0;c[14316]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];wQ(57952,y,8)|0;I=c[14316]|0;F=I+1|0;c[14316]=F;}while((I|0)<(ca|0))}PQ()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[7178]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[7172];O=na>=ea?na:ea;h[7208]=O;ea=O*O;h[7171]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[7219];if(db<=ea*.001){h[7212]=ea*.25;ca=c[b>>2]|0;c[14320]=1;if((ca|0)>=1){F=1;while(1){h[7175]=0.0;I=c[a>>2]|0;c[14316]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[7175]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[14316]=I+1;pb=qb}h[7183]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[7178]*+h[7219];h[7175]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[14316]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[7183]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[7178]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[7175]*+h[n+(F+C+Va<<3)>>3]+ +h[7212]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[14328]=aa;c[14318]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[14318]=Va;rb=Va}c[14316]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[14320]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[14380]|0;c[14320]=1;if((F|0)>=1){ca=1;while(1){h[7193]=0.0;X=c[b>>2]|0;c[14316]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[7193]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[14316]=I;if((K|0)>=(X|0)){break b}O=+h[7193];K=I}}}while(0);X=c[a>>2]|0;c[14318]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[7212]*+h[7193]*+h[l+(I<<3)>>3];h[7175]=O;Va=c[b>>2]|0;c[14316]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[7175]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[14316]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[14340]|0)){h[7175]=-+h[7175]}L=c[b>>2]|0;c[14316]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[7175]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[14316]=L+1}J=K+1|0;c[14318]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[14316]=1;if((K|0)>=1){X=c[14340]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[14328]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[7183]=ub;c[14318]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[7183];aa=aa+1|0}aa=J+1|0;c[14318]=aa;vb=aa}c[14316]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[14320]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[14322]=0;ca=c[a>>2]|0;c[14318]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[14320]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[7178]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[14320]=aa+1}c[14316]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[14322]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[14316]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[14318]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[14318]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[14318]=J+1}h[7219]=0.0}if((c[14364]|0)>0){F=(c[14334]|0)+ -1|0;Jz(a,b,l,n,s,t,57360,u,57456,57664,v,57584,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[14320]=1;if((F|0)>=1){L=1;while(1){h[7184]=0.0;h[7185]=0.0;h[7175]=0.0;ca=c[a>>2]|0;c[14318]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[7184]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[7185]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[7175]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[14318]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[7178]+Ab);h[w+(K<<3)>>3]=+h[7175];K=L+1|0;c[14320]=K;if((L|0)<(F|0)){L=K}else{break}}}h[7179]=0.0;L=c[14380]|0;c[14320]=1;if((L|0)>=1){F=1;while(1){h[7175]=0.0;J=c[b>>2]|0;c[14316]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[7175]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[14316]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[7179];if((F|0)<(c[14340]|0)){h[7179]=O+ea;na=-Eb;h[7175]=na;Gb=na}else{h[7179]=O-ea;Gb=Eb}K=c[b>>2]|0;c[14316]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[7175];X=X+1|0}c[14316]=K+1}X=F+1|0;c[14320]=X;if((F|0)<(L|0)){F=X}else{break}}}h[7187]=0.0;h[7166]=0.0;F=c[a>>2]|0;c[14318]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[7175]=0.0;X=c[b>>2]|0;c[14316]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[7175]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[14316]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[7187]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[14330]=K;Va=c[a>>2]|0;c[14320]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[7175]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[14320]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[7187]+ +h[7175]*+h[ca>>3];h[7187]=O;na=+h[7166]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[7166]=na;aa=L+1|0;c[14318]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[7171];h[7179]=+h[7179]+(Ib*Ib+ea*(Ib+(Ib+ +h[7219])+ea*+h[7178]))-Hb;L=w+((c[14378]|0)+ -1<<3)|0;h[L>>3]=+h[7169]+ +h[L>>3];L=c[14364]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[7169]+ +h[7198]*+h[7179]/(ea*ea);h[7183]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;Iz(a,b,l,n,s,t,57360,u,57512,57456,v,x,w,57432,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[14316]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[14316]=L+1}F=c[14324]|0;aa=F+1|0;c[14324]=aa;if((F|0)>=(c[14434]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[14324]=T+ -1;if((c[g>>2]|0)<=0){break}fR(57760)|0;PQ()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}fR(57808)|0;PQ()|0}}while(0);Nb=+h[7186];if(Nb<=+h[7157]){U=c[a>>2]|0;c[14316]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[14316]=U+1;Ob=+h[7186]}h[7157]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}fR(57904)|0;wQ(57952,57296,4)|0;PQ()|0;fR(57928)|0;wQ(57952,57256,8)|0;g=c[a>>2]|0;c[14316]=1;if((g|0)>=1){a=1;do{wQ(57952,d+(a+ -1<<3)|0,8)|0;U=c[14316]|0;a=U+1|0;c[14316]=a;}while((U|0)<(g|0))}PQ()|0;i=z;return 0}function sA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){i1(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){i1(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function tA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+jA(57960);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+kA(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+kA(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+kA(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function uA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function vA(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+jA(57968);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=x1(u|0,0,t+ -2|0,0)|0;t=q1(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function wA(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[7266]=.5;h[7284]=6.283185307179586;v=+h[l>>3];h[7279]=v*v;c[14554]=0;l=c[b>>2]|0;c[14572]=l;c[14570]=l;w=c[b>>2]|0;c[14494]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[14494]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[14494]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[14494]=w+1}z=c[d>>2]|0;c[14498]=1;if((z|0)>=1){e=1;while(1){h[7270]=0.0;A=c[b>>2]|0;c[14496]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[7270]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[14496]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[7270]=v;C=c[b>>2]|0;c[14494]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[7270];F=F+1|0}c[14494]=C+1}F=e+1|0;c[14498]=F;if((e|0)<(z|0)){e=F}else{break}}}c[14508]=0;e=c[b>>2]|0;c[14496]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[14508]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[14494]=H;c[14496]=e+1}do{if((y|0)==0){h[7268]=0.0;h[7250]=0.0;w=c[b>>2]|0;c[14494]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[7250]=+h[7250]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[14494]=w+1}h[r>>3]=0.0;D=+h[7250];if(D==0.0){O=55;break a}h[7255]=0.0;h[7258]=0.0;h[7253]=D;h[7273]=D;P=D;Q=0.0;R=0.0;S=+h[7279];T=0}else{if((y|0)>(x|0)){h[7252]=0.0;h[7259]=0.0;h[7260]=0.0;z=c[b>>2]|0;c[14494]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7252]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[7259]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[7260]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[14494]=z+1;U=ba;W=$;Z=aa}D=+h[7266];v=D*(+h[7263]-Z);h[7251]=v;_=+h[7256];ca=_+v;h[7267]=ca;h[7271]=ca;h[7269]=ca;c[14564]=0;a[58056]=1;da=+h[7284]/50.0;h[7270]=da;c[14494]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[7269]=ka;c[14564]=w;h[7280]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[7281]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[7275]=ha;h[7261]=ia;h[7264]=ja;h[7272]=ka;c[14494]=50;h[7271]=ka;if((la|0)==49){h[7281]=ca;na=ca}else if((la|0)==0){h[7280]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[7281]}h[7275]=0.0;ga=+h[7280];if(ga!=na){ea=ga-ma;h[7280]=ea;ga=na-ma;h[7281]=ga;oa=D*(ea-ga)/(ea+ga);h[7275]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[7275]=oa;ga=+X(+oa);h[7261]=ga;ea=+Y(+oa);h[7264]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[7276]=oa;h[7253]=0.0;w=c[b>>2]|0;c[14494]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[7261]*+h[J>>3]+ +h[7264]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[7253]+sa*sa;h[7253]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[7264];ea=+h[7261];F=F+1|0;z=K}c[14494]=w+1;qa=ta;ra=+h[7276]}ea=ra+ +h[7268];h[7268]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[7259]=0.0;z=c[b>>2]|0;c[14496]=1;do{if((z|0)<1){ea=+h[7283];h[7274]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[7259]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[14496]=z+1;ea=+h[7283];h[7274]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[7250];h[7270]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[7270]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[7274];oa=+h[7253];v=+h[7259];_=oa/v;ca=ea<=_?ea:_;h[7274]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[7253];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[7266]*Ca);h[7265]=ca;h[7268]=+h[7268]+ca;h[7278]=Ba;h[7253]=0.0;z=c[b>>2]|0;c[14494]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[7274]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[7253]+oa*oa;h[7253]=Ga;Ha=+h[7274];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[14494]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[7283]){if(+h[7265]<=+h[7268]*.01){O=55;break a}if(Fa<=+h[7273]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[7278];h[7270]=ca;h[7250]=0.0;h[7255]=0.0;h[7258]=0.0;w=c[b>>2]|0;c[14494]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[7250]+ca*ca;h[7250]=La;J=m+(F<<3)|0;Ma=+h[7255]+ +h[K>>3]*+h[J>>3];h[7255]=Ma;ca=+h[J>>3];Na=+h[7258]+ca*ca;h[7258]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[7270];Ja=Ja+1|0;Ka=J}c[14494]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[7279];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[14570]=y;ua=+h[7253];va=y}if(ua<=+h[7273]*1.0e-4){O=55;break a}h[7256]=0.0;h[7263]=0.0;z=c[b>>2]|0;c[14494]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7256]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[7263]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[14494]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[7262]=ca;oa=+h[7279];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[14554]=J;_=+V(+(v-ca*ca));h[7270]=_;v=oa/_;h[7280]=v;oa=ca/_;h[7281]=oa;w=c[b>>2]|0;c[14494]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[7281];Ta=+h[7280];Ua=Ua+1|0;Va=K}c[14494]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[14554]=e;v=S-R;h[7270]=v;h[7283]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function xA(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[7293]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[14592]=t;c[14582]=1;c[14576]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[14582]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[7295]=D;C=+h[x>>3]/D;h[7302]=C;z=+h[f+(B+y<<3)>>3]/D;h[7303]=z;B=c[d>>2]|0;c[14574]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[7295]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[7295];if((x|0)>=(B|0)){break}D=+h[7303];z=+h[7302];x=x+1|0}c[14574]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[14576]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[7302]=z;if((c[g>>2]|0)>1){D=-z;h[7302]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[7303]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[14574]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[7303]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[7302];t=t+1|0;x=A}c[14574]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[7300]=z;x=k+(w<<3)|0;H=+h[x>>3];h[7294]=H;D=H*H;h[7304]=D;h[7301]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[7293];a[58376]=0;do{if((u|0)==1){z=+h[7301];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[7295]=z;D=+h[7302]/z;h[7303]=D;H=+h[7294]/z;h[7302]=H;x=c[d>>2]|0;c[14574]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[7303];D=+h[7302];w=w+1|0;t=s}c[14574]=x+1;J=+h[7295]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[14578]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[14578]=u;M=u}t=u+1-M|0;c[14580]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[7301];z=+h[f+(t+w<<3)>>3]/D;h[7295]=z;h[7302]=z*+h[l>>3];H=+h[7294];h[7303]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[7295]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[7293]/+V(+(+h[7304]+z*N*z));h[7298]=C;if(!(D>=0.0)){O=-D}else{O=D}h[7299]=C*+V(+O);t=c[d>>2]|0;c[14574]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[7299]*(+h[A>>3]- +h[7302]*+h[n+(G<<3)>>3]- +h[7303]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[7295];z=+h[7294];H=+h[7298];v=v+1|0}c[14574]=t+1;P=+h[7301]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[58376]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[14574]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[7295]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[7295];K=Q+1|0;c[14574]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[14576]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[14584]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[7294];N=+h[7301];J=(+h[7300]*+h[f>>3]-O*P)/N;h[7302]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[7303]=P;c[14574]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[14574]=q;if((f|0)>=(b|0)){break a}N=+h[7303];O=+h[7302];f=q}}}while(0);b=R+1|0;c[14576]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function yA(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function zA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((yA(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){bb(58440,58456,116,58480)}else if((s|0)==14){i=g;return o|0}return 0}function AA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((a1(w,c[58488+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[58592+(x<<2)>>2]|0;c[q>>2]=c[58488+(x<<2)>>2];c[q+4>>2]=y;Ox(23,0,58664,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=E0(D,8)|0;c[e+40>>2]=B;D=b+536|0;Rx(c[D>>2]|0,(B|0)!=0|0,58704,p);B=E0(c[A>>2]|0,4)|0;c[e+36>>2]=B;Rx(c[D>>2]|0,(B|0)!=0|0,58704,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=E0(c[C>>2]|0,4)|0;c[e+24>>2]=C0(8)|0;C=C0(4)|0;c[e+20>>2]=C;c[C>>2]=c[29960>>2];Rx(c[D>>2]|0,(C|0)!=0|0,58704,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=C0(C)|0;A=e+44|0;c[A>>2]=C0(C)|0;C=E0(15,4)|0;E=e+12|0;c[E>>2]=C;Rx(c[D>>2]|0,(C|0)!=0|0,58704,m);C=E0(5,4)|0;c[e+4>>2]=C;Rx(c[D>>2]|0,(C|0)!=0|0,58704,l);C=E0(5,4)|0;c[e+8>>2]=C;Rx(c[D>>2]|0,(C|0)!=0|0,58704,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=C0(C)|0;c[e+76>>2]=C0(C)|0;c[e+80>>2]=C0(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if(($d[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){Ox(23,0,58720,j)}else{Ox(1,0,58792,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[29996>>2]|c[7474]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=58624;W=V;Sx(Q,W,r)}c[t>>2]=w;Qx(23,1,58520,t);t=1;do{w=c[58592+(t<<2)>>2]|0;c[s>>2]=c[58488+(t<<2)>>2];c[s+4>>2]=w;Qx(23,0,58576,s);t=t+1|0;}while((t|0)<8);Yd[c[7614]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=58624;W=V;Sx(Q,W,r);return 0}function BA(a){a=a|0;var b=0;b=i;D0(c[a+40>>2]|0);D0(c[a+36>>2]|0);D0(c[a+20>>2]|0);D0(c[a+12>>2]|0);D0(c[a+4>>2]|0);D0(c[a+8>>2]|0);D0(a);i=b;return 0}function CA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Rx(c[N>>2]|0,(c[M>>2]|0)!=0|0,58888,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){Ox(3,0,58920,B);Ox(3,0,58960,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];$d[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(3,0,58984,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];Ox(23,0,59024,y);if((c[z>>2]|0)==1){pz(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){tC(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 4:{Lz(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 5:{Lz(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 3:{Lz(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 7:{Lz(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 6:{Lz(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){Lz(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{Lz(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){md(_|0)|0;md($|0)|0;Qx(3,0,59056,x);Ox(3,0,59144,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){md(_|0)|0;md($|0)|0;$=LA(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){tC(a)|0;$d[c[(c[ba>>2]|0)+40>>2]&127](a)|0}$d[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Qx(1,0,59168,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[29916>>2]|0)!=0){Ox(3,1,59200,u);c[s>>2]=c[z>>2];Ox(3,0,59224,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Ox(3,0,59248,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Ox(3,0,59280,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Ox(3,0,59320,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Ox(3,0,59368,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];Ox(3,0,59416,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];Ox(3,0,59456,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];Ox(3,0,59496,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];Ox(3,0,59536,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];Ox(3,0,59584,f);Yd[c[7614]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){bb(59624,59656,410,59688)}Ox(3,0,59704,e);S=0;i=d;return S|0}function DA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;tC(g)|0;a=f+540|0;$d[c[(c[a>>2]|0)+40>>2]&127](g)|0;$d[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function EA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;tC(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;NA(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function FA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];tC(g)|0;l=e+540|0;$d[c[(c[l>>2]|0)+40>>2]&127](g)|0;$d[c[(c[l>>2]|0)+28>>2]&127](g)|0;$d[c[(c[l>>2]|0)+32>>2]&127](g)|0;ce[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function GA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;OA(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function HA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;tC(l)|0;b=k+540|0;$d[c[(c[b>>2]|0)+40>>2]&127](l)|0;$d[c[(c[b>>2]|0)+28>>2]&127](l)|0;MA(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function IA(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function JA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;PA(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function KA(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function LA(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-11:{Qx(1,0,60112,d);m=-11;i=b;return m|0};case-9:{Qx(1,0,59928,f);m=-9;i=b;return m|0};case-12:{Qx(1,0,60200,c);m=-12;i=b;return m|0};case-8:{Qx(1,0,59880,g);m=-8;i=b;return m|0};case-7:{Qx(1,0,59840,h);m=-7;i=b;return m|0};case-2:{Qx(1,0,59728,k);m=-2;i=b;return m|0};case-10:{Qx(1,0,60016,e);m=-10;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-1:{Qx(3,0,59056,l);m=1;i=b;return m|0};case-33:{Qx(1,0,60248,b);m=-33;i=b;return m|0};case-6:{Qx(1,0,59768,j);m=-6;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function MA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}$d[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function NA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;$d[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function OA(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+ld(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+ld(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;DA(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function PA(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+ld(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+ld(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}DA(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function QA(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function RA(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Yd[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function SA(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function TA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=ly(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{oe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;jy(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=ly(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function UA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((TA(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}VA(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(ly(d)|0)>0;h=b?2:0;i=e;return h|0}function VA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=C0(q)|0;s=r;t=C0(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[15252]=hy(4)|0;if((r|0)==0){bb(61016,61032,308,61064)}if((t|0)==0){bb(61080,61032,309,61064)}v=oy(b)|0;if((v|0)!=0){w=v;do{v=qy(w)|0;c[l>>2]=c[v>>2];Ox(27,0,61096,l);w=py(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;g1(t|0,c[a+384>>2]|0,v|0)|0;g1(r|0,l|0,v|0)|0}h[d>>3]=+YA(a,n,o,q,s,c[15252]|0,b);do{if((ly(c[15252]|0)|0)==0){s=my(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=oy(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=qy(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=py(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Ox(27,0,61144,j);v=oy(b)|0;if((v|0)==0){break}else{B=v}do{v=qy(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[15252]|0;ky(v,qy(B)|0);v=qy(B)|0;c[g>>2]=c[v>>2];Ox(27,0,61168,g)}B=py(B)|0;}while((B|0)!=0)}}while(0);iy(b);if((c[29932>>2]|0)!=0){ly(c[15252]|0)|0}if((ly(c[15252]|0)|0)>0){B=m;do{g=my(c[15252]|0)|0;c[m>>2]=c[g>>2];ny(c[15252]|0);c[f>>2]=c[m>>2];Ox(7,0,61192,f);jy(b,B);}while((ly(c[15252]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){g1(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Qe(a);$A(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){D0(t);D0(r);i=e;return}g1(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;D0(t);D0(r);i=e;return}function WA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){dB(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(7,0,60736,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((ly(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[29932>>2]|0)!=0){e=oy(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=qy(s)|0;x=c[e>>2]|0;e=oe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;Nx(7,0,w,60760,l);s=py(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=qy(oy(d)|0)|0;x=oe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;Nx(1,0,e,60776,j);c[s>>2]=1}}while(0);iy(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;_A(b);XA(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function XA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;Ox(27,0,61384,b);d=a+344|0;ce[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function YA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=C0(p<<3)|0;if((q|0)==0){bb(61200,61032,409,61216)}if((p|0)>0){g1(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Ox(27,0,61232,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(27,0,61280,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){D0(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}tC(a)|0;$d[c[(c[p>>2]|0)+40>>2]&127](a)|0;$d[c[(c[p>>2]|0)+28>>2]&127](a)|0;$d[c[(c[p>>2]|0)+32>>2]&127](a)|0;ce[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(ZA(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}g1(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}D0(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function ZA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;iy(b);Ox(27,0,61304,g);g=oy(d)|0;if((g|0)==0){j=ly(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=qy(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=qy(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=qy(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=qy(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=qy(a)|0;o=c[g>>2]|0;g=qy(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?60720:60728;g=qy(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?60720:60728;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;Ox(27,0,61344,f);jy(b,qy(a)|0)}a=py(a)|0;}while((a|0)!=0);j=ly(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function _A(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;oe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;$A(b);aB(b);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;bB(b,8);h=cB(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{aB(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}dB(b);$A(b);bB(b,8);$d[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=cB(b)|0;j=$d[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Sx(c[b+536>>2]|0,61424,e)}else if((o|0)==7){aB(b);i=d;return}}function $A(a){a=a|0;var b=0;b=i;g1(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function aB(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function bB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[29904+(d<<2)>>2]|0)==0){i=e;return}Ox(d,1,61848,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=$d[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;Ox(d,0,61872,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Yd[c[7614]&511](d);i=e;return}function cB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function dB(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;g1(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;g1(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;g1(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;g1(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function eB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ce[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function fB(a){a=a|0;var b=0;b=i;gB(a);hB(a);dB(a);iB(a);i=b;return}function gB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function hB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function iB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((oz(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];g1(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;g1(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;g1(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;g1(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(oz(c[d>>2]|0)|0));i=b;return}function jB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[29904+(d<<2)>>2]|0)==0){i=e;return}Ox(d,1,61520,q);q=b+136|0;if((c[q>>2]|0)>0){Ox(d,1,61544,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?61504:61512;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Ox(d,0,61560,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Yd[c[7614]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){Ox(d,1,61616,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?61504:61512;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;Ox(d,0,61640,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Yd[c[7614]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){Ox(d,1,61696,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?61504:61512;v=(a[n+(m*48|0)+40|0]|0)!=0?61504:61512;n=(a[(c[s>>2]|0)+m|0]|0)!=0?61504:61512;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;Ox(d,0,61720,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Yd[c[7614]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){Ox(d,1,61776,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;Ox(d,0,61800,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Yd[c[7614]&511](d)}Yd[c[7614]&511](d);i=e;return}function kB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((oz(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];g1(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;g1(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;g1(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;g1(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(oz(c[d>>2]|0)|0));i=b;return}function lB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function mB(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];g1(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;g1(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;g1(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;g1(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function nB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=jz(3,32)|0;c[o>>2]=p;if((p|0)==0){Sx(c[b+536>>2]|0,61904,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=E0(c[p>>2]|0,8)|0;c[q>>2]=z;Rx(c[r>>2]|0,(z|0)!=0|0,61960,l);z=E0(c[s>>2]|0,4)|0;c[t>>2]=z;Rx(c[r>>2]|0,(z|0)!=0|0,61960,k);z=E0(c[u>>2]|0,1)|0;c[v>>2]=z;Rx(c[r>>2]|0,(z|0)!=0|0,61960,j);z=E0(c[w>>2]|0,4)|0;c[x>>2]=z;Rx(c[r>>2]|0,(z|0)!=0|0,61960,g);nz(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=E0(3,4)|0;c[b+4>>2]=n;pz(c[o>>2]|0,0,n);c[b+8>>2]=E0(c[p>>2]|0,112)|0;c[b+12>>2]=E0(c[s>>2]|0,60)|0;c[b+16>>2]=E0(c[u>>2]|0,48)|0;c[b+20>>2]=E0(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=E0(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=E0(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=E0(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=E0(g,52)|0;c[b+40>>2]=E0(c[b+216>>2]|0,52)|0;c[b+44>>2]=E0(c[b+220>>2]|0,52)|0;c[b+48>>2]=E0(c[b+224>>2]|0,52)|0;c[b+52>>2]=E0(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=E0(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=E0(x,8)|0;c[b+340>>2]=E0(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=E0(x,8)|0;c[b+348>>2]=E0(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=E0(j,1)|0;c[b+356>>2]=E0(j,1)|0;c[b+360>>2]=E0(j,1)|0;j=C0(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=C0(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=E0(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=E0(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=E0(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=E0(u,4)|0;c[b+400>>2]=E0(x,8)|0;c[b+404>>2]=E0(p,4)|0;c[b+408>>2]=E0(s,1)|0;c[b+412>>2]=E0(u,4)|0;c[b+416>>2]=E0(c[n>>2]|0,8)|0;c[b+420>>2]=E0(o,4)|0;c[b+424>>2]=E0(y,1)|0;c[b+428>>2]=E0(g,4)|0;c[b+432>>2]=E0(c[b+152>>2]|0,8)|0;c[b+436>>2]=E0(c[b+156>>2]|0,8)|0;g=C0((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Yd[c[(c[y>>2]|0)+20>>2]&511](g);g=C0((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Yd[c[(c[y>>2]|0)+16>>2]&511](g);g=C0((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Yd[c[(c[y>>2]|0)+12>>2]&511](g);g=C0((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;Zd[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=C0((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=E0(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Rx(c[r>>2]|0,(g|0)!=0|0,61976,f);c[b+512>>2]=100;c[b+516>>2]=E0(100,4)|0;c[b+520>>2]=E0(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=C0(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Rx(c[r>>2]|0,(g|0)!=0|0,61960,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=jz(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function oB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;D0(c[g+8>>2]|0);D0(c[g+12>>2]|0);D0(c[g+16>>2]|0);D0(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);D0(e);kz(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Hz(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}D0(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Hz(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}D0(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Hz(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}D0(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Hz(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}D0(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Hz(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}D0(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Hz(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}D0(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Hz(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}D0(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Hz(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}D0(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Hz(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}D0(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Hz(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}D0(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Hz(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}D0(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Hz(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}D0(v);D0(c[a+108>>2]|0);D0(c[a+336>>2]|0);D0(c[a+340>>2]|0);D0(c[a+344>>2]|0);D0(c[a+348>>2]|0);D0(c[a+352>>2]|0);D0(c[a+356>>2]|0);D0(c[a+360>>2]|0);D0(c[a+368>>2]|0);D0(c[a+384>>2]|0);D0(c[a+388>>2]|0);D0(c[a+392>>2]|0);D0(c[a+396>>2]|0);D0(c[a+400>>2]|0);D0(c[a+404>>2]|0);D0(c[a+408>>2]|0);D0(c[a+412>>2]|0);D0(c[a+416>>2]|0);D0(c[a+420>>2]|0);D0(c[a+424>>2]|0);D0(c[a+428>>2]|0);D0(c[a+488>>2]|0);D0(c[a+484>>2]|0);D0(c[a+476>>2]|0);D0(c[a+468>>2]|0);D0(c[a+464>>2]|0);D0(c[a+432>>2]|0);D0(c[a+436>>2]|0);D0(c[a+320>>2]|0);D0(c[a+516>>2]|0);D0(c[a+520>>2]|0);WP(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;D0(x);i=b;return}else{y=a;z=0}while(1){kz(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;D0(x);i=b;return}function pB(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[7752]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Ox(8,0,62024,d);i=b;return}function qB(a,b){a=+a;b=+b;i=i;return a<=b|0}function rB(a,b){a=+a;b=+b;i=i;return a>=b|0}function sB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=C0(k)|0;c[e+(h*40|0)+24>>2]=C0(k)|0;if((c[g>>2]|0)!=1){l=5;break}vB(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Sx(c[a+536>>2]|0,62080,d)}else if((l|0)==6){i=b;return 0}return 0}



function Vx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(c[a+8>>2]|0)+(fa(d,b)|0)|0;i=i;return e|0}function Wx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;c[a+8>>2]=yy(Ax(a,d,g)|0,b)|0;i=f;return}function Xx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Vx(a,Dx(a,d,g)|0,b)|0;i=f;return e|0}function Yx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;if((a|0)==0){g=c[r>>2]|0;pc(30648,39,1,g|0)|0;md(g|0)|0;h=0;i=b;return h|0}g=c[a>>2]|0;if((g|0)<0){j=c[r>>2]|0;c[f>>2]=g;od(j|0,30688,f|0)|0;md(j|0)|0;h=0;i=b;return h|0}j=c[a+4>>2]|0;if((j|0)==0){f=c[r>>2]|0;pc(30752,56,1,f|0)|0;md(f|0)|0;h=0;i=b;return h|0}f=c[a+12>>2]|0;if((f|0)==0){a=c[r>>2]|0;pc(30816,51,1,a|0)|0;md(a|0)|0;h=0;i=b;return h|0}if((g|0)>0){k=0}else{h=1;i=b;return h|0}while(1){l=c[j+(k<<2)>>2]|0;if((l|0)<0){m=12;break}a=k+1|0;if(!((c[f+(k<<2)>>2]|0)!=0|(l|0)==1)){m=14;break}if((a|0)<(g|0)){k=a}else{h=1;m=15;break}}if((m|0)==12){g=c[r>>2]|0;c[e>>2]=k;c[e+4>>2]=l;od(g|0,30872,e|0)|0;md(g|0)|0;h=0;i=b;return h|0}else if((m|0)==14){g=c[r>>2]|0;c[d>>2]=k;c[d+4>>2]=l;od(g|0,30952,d|0)|0;md(g|0)|0;h=0;i=b;return h|0}else if((m|0)==15){i=b;return h|0}return 0}function Zx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=g;c[g>>2]=e;c[b>>2]=d;e=b+4|0;c[e>>2]=wy(d)|0;g=b+12|0;c[g>>2]=xy(d)|0;j=b+8|0;c[j>>2]=yy(d+1|0,1)|0;if((d|0)>0){k=0}else{i=f;return}do{b=c[h>>2]|0;l=c[b>>2]|0;c[h>>2]=b+4;c[(c[e>>2]|0)+(k<<2)>>2]=l;l=c[h>>2]|0;b=c[l>>2]|0;c[h>>2]=l+4;c[(c[g>>2]|0)+(k<<2)>>2]=b;b=c[h>>2]|0;l=c[b>>2]|0;c[h>>2]=b+4;a[(c[j>>2]|0)+k|0]=l;k=k+1|0;}while((k|0)<(d|0));i=f;return}function _x(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=a+ -1|0;a=b+(f<<2)|0;g=(c[a>>2]|0)+1|0;c[a>>2]=g;if((g|0)<(c[d+(f<<2)>>2]|0)){h=0;i=e;return h|0}else{j=f}while(1){c[b+(j<<2)>>2]=0;if((j|0)==0){h=1;k=4;break}f=j+ -1|0;g=b+(f<<2)|0;a=(c[g>>2]|0)+1|0;c[g>>2]=a;if((a|0)<(c[d+(f<<2)>>2]|0)){h=0;k=4;break}else{j=f}}if((k|0)==4){i=e;return h|0}return 0}function $x(a,b){a=a|0;b=b|0;var c=0;c=i;zx(a,b,vy(b)|0);i=c;return}function ay(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function by(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;if((d|0)==0){bb(31008,30984,176,31024)}if((oe[((d|0)>0?53:54)&63](b,e)|0)==0){$x(a,0);i=f;return}g=((e-b|0)/(d|0)|0)+1|0;$x(a,g);if((g|0)==0){i=f;return}e=a+8|0;a=b;b=0;while(1){ay(c[e>>2]|0,b,a);h=b+1|0;if(h>>>0<g>>>0){b=h;a=a+d|0}else{break}}i=f;return}function cy(a,b){a=a|0;b=b|0;i=i;return(a|0)<=(b|0)|0}function dy(a,b){a=a|0;b=b|0;i=i;return(a|0)>=(b|0)|0}function ey(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function fy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;e=ey(c[a+8>>2]|0,d+ -1|0)|0;i=b;return e|0}function gy(a){a=a|0;i=i;return c[a+8>>2]|0}function hy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=C0(16)|0;Rx(0,(d|0)!=0|0,31056,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function iy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;D0(c[f>>2]|0);D0(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function jy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Rx(0,(a|0)!=0|0,31072,f);f=C0(8)|0;g=f;Rx(0,(f|0)!=0|0,31056,e);e=a+8|0;h=C0(c[e>>2]|0)|0;c[f>>2]=h;Rx(0,(h|0)!=0|0,31056,d);g1(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function ky(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Rx(0,(a|0)!=0|0,31072,f);f=C0(8)|0;g=f;Rx(0,(f|0)!=0|0,31056,e);e=a+8|0;h=C0(c[e>>2]|0)|0;c[f>>2]=h;Rx(0,(h|0)!=0|0,31056,d);g1(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function ly(a){a=a|0;var b=0;b=i;i=i+8|0;Rx(0,(a|0)!=0|0,31072,b);i=b;return c[a+12>>2]|0}function my(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Rx(0,(a|0)!=0|0,31072,d);d=a;Rx(0,(c[d>>2]|0)!=0|0,31096,b);i=b;return c[c[d>>2]>>2]|0}function ny(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;D0(c[e>>2]|0);D0(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function oy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Rx(0,(a|0)!=0|0,31072,d);d=a;Rx(0,(c[d>>2]|0)!=0|0,31112,b);i=b;return c[d>>2]|0}function py(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Rx(0,d&1,31144,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function qy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Rx(0,(a|0)!=0|0,31144,d);d=a;Rx(0,(c[d>>2]|0)!=0|0,31168,b);i=b;return c[d>>2]|0}function ry(){var a=0,b=0,d=0;a=i;b=C0(16)|0;c[7810]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=C0(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=zy(a)|0;rc(31248)|0;Ay(d);a=c[7810]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;ec(31248)|0;i1(g|0,0,d|0)|0;i=b;return g|0}function ty(){var a=0,b=0,d=0,e=0;a=i;b=c[7810]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;D0(c[b>>2]|0);D0(b);if((d|0)==0){break}else{b=d}}e=c[7810]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function uy(a){a=a|0;var b=0,d=0;b=i;d=$d[c[31200>>2]&127](a<<3)|0;i=b;return d|0}function vy(a){a=a|0;var b=0,d=0;b=i;d=$d[c[31200>>2]&127](a<<2)|0;i=b;return d|0}function wy(a){a=a|0;var b=0,d=0;b=i;d=$d[c[31200>>2]&127](a<<2)|0;i=b;return d|0}function xy(a){a=a|0;var b=0,d=0;b=i;d=$d[c[31196>>2]&127](a<<2)|0;i=b;return d|0}function yy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=fa(b,a)|0;a=$d[c[31196>>2]&127](e)|0;i=d;return a|0}function zy(a){a=a|0;i=i;return a+7&-8|0}function Ay(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[7810]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=C0(16)|0;c[f+12>>2]=d;c[7810]=f;c[f+4>>2]=0;d=By((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=C0(d)|0;c[f>>2]=a;i=b;return}function By(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function Cy(a){a=a|0;var b=0,c=0;b=i;c=e1(a|0)|0;i=b;return c|0}function Dy(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;k1(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(m|0,l|0,f|0)|0;f=Ey(m)|0;i=e;return f|0}function Ey(a){a=a|0;var b=0,c=0,d=0;b=i;c=e1(a|0)|0;d=Gy(c)|0;g1(d|0,a|0,c|0)|0;i=b;return d|0}function Fy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;k1(g+1|0,d|0)|0;c[f>>2]=b;gc(k|0,j|0,f|0)|0;f=Ey(k)|0;i=e;return f|0}function Gy(b){b=b|0;var d=0,e=0;d=i;e=$d[c[31204>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function Hy(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=Cy(a)|0;e=Cy(b)|0;f=Gy(e+d|0)|0;g1(f|0,a|0,d|0)|0;g1(f+d|0,b|0,e|0)|0;i=c;return f|0}function Iy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=a1(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function Jy(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 3:{f=2;break a;break};case 4:{f=2;break a;break};case 0:{f=8;break a;break};case 2:{f=4;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function Ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Vc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){D0(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{D0(c[(c[f>>2]|0)+(g<<4)>>2]|0);D0(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;D0(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){D0(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{D0(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}D0(d);c[g>>2]=0;i=b;return}function Ly(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(e1(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function My(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=hc(b|0,31432)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Nd(c[(Lc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=rd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=rb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=31440;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[31408+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=31464;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=31488;E=131;break}G=Jy(D)|0;if((G|0)==-1){n=31520;E=131;break}D=c[q>>2]|0;H=C0(D)|0;if((rb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=31568;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=31592;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((a1(H,c[31384+(C<<2)>>2]|0)|0)!=0){n=31616;E=131;break}D0(H);H=32192;b:do{switch(C|0){case 0:{if((D|0)!=4){n=31640;E=131;break a}if((I|0)!=11){n=31680;E=131;break a}if((rb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=31720;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((b1(t,c[7822]|0,8)|0)==0){L=1;E=130;break b}if((b1(t,c[7828]|0,9)|0)==0){L=0;E=130}else{n=31752;E=131;break a}break};case 3:{F=fa(I<<2,D)|0;M=C0(F)|0;if((rb(M|0,F|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}F=c[v>>2]|0;G=0;do{c[F+(G<<4)+8>>2]=(c[M+(G<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[M+(D+G<<2)>>2];G=G+1|0;}while(G>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}G=c[v>>2]|0;F=0;do{N=fa(D,F)|0;c[G+(F<<4)+8>>2]=(c[M+(N<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[M+(N+1<<2)>>2];F=F+1|0;}while(F>>>0<I>>>0)}}while(0);D0(M);bc(c[v>>2]|0,c[u>>2]|0,16,55);L=d;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){O=1;E=129;break b}F=D+1|0;G=0;while(1){N=C0(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=N;if((rb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=31816;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;N=G+1|0;if(N>>>0<I>>>0){G=N}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}G=fa(D,I)|0;P=C0(G+1|0)|0;if((rb(P|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;N=0;do{Q=C0(G)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=Q;if(!F){Q=0;do{R=a[P+((fa(D,Q)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+Q|0]=R;Q=Q+1|0;}while(Q>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+I|0]=0;N=N+1|0;}while(N>>>0<D>>>0)}D0(P);L=0;E=130;break};case 1:{N=d<<24>>24==0;c[u>>2]=N?D:I;F=C0((N?D:I)<<4)|0;c[v>>2]=F;c:do{if(d<<24>>24==1){if((I|0)==0){S=0;break}G=D+1|0;Q=F;R=0;while(1){c[Q+(R<<4)>>2]=C0(G)|0;if((rb(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=31816;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;T=c[v>>2]|0;c[T+(R<<4)+8>>2]=-1;c[T+(R<<4)+12>>2]=-1;Ly(c[T+(R<<4)>>2]|0);T=R+1|0;if(!(T>>>0<I>>>0)){S=I;break c}Q=c[v>>2]|0;R=T}}else{S=I}}while(0);if(!N){L=d;E=130;break b}F=fa(D,S)|0;U=C0(F+1|0)|0;if((rb(U|0,F|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){F=S+1|0;R=(S|0)==0;Q=0;do{G=C0(F)|0;c[(c[v>>2]|0)+(Q<<4)>>2]=G;if(!R){G=0;do{T=a[U+((fa(D,G)|0)+Q)|0]|0;a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+G|0]=T;G=G+1|0;}while(G>>>0<S>>>0)}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+S|0]=0;G=c[v>>2]|0;c[G+(Q<<4)+8>>2]=-1;c[G+(Q<<4)+12>>2]=-1;Ly(c[G+(Q<<4)>>2]|0);Q=Q+1|0;}while(Q>>>0<D>>>0)}D0(U);L=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=31880;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=31936;E=131;break a}c[w>>2]=D;Q=fa(I,D)|0;if((a[l]|0)==1){R=C0(Q<<3)|0;c[x>>2]=R;if((rb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=31976;E=131;break a}}else{R=C0(Q<<2)|0;c[x>>2]=C0(fa(D<<3,I)|0)|0;if((rb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=31976;E=131;break a}if((Q|0)!=0){F=c[x>>2]|0;N=0;do{h[F+(N<<3)>>3]=+g[R+(N<<2)>>2];N=N+1|0;}while(N>>>0<Q>>>0)}D0(R)}Q=c[w>>2]|0;if(!(Q>>>0>1)){L=1;E=130;break b}N=(I|0)==2;F=1;while(1){if(N){G=c[x>>2]|0;if(+h[G+(F<<3)>>3]!=+h[G+(Q+F<<3)>>3]){n=32008;E=131;break a}}G=F+1|0;if(G>>>0<Q>>>0){F=G}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}if((I|0)==0){n=31880;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=32088;E=131;break a}c[w>>2]=I;F=fa(I,D)|0;if((a[l]|0)==1){Q=C0(F<<3)|0;c[x>>2]=C0(fa(D<<3,I)|0)|0;if((rb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=31976;E=131;break a}if((D|0)!=0){N=0;do{R=c[x>>2]|0;G=0;do{h[R+((fa(I,N)|0)+G<<3)>>3]=+h[Q+((fa(D,G)|0)+N<<3)>>3];G=G+1|0;}while(G>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}D0(Q)}else{N=C0(F<<2)|0;c[x>>2]=C0(fa(D<<3,I)|0)|0;if((rb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=31976;E=131;break a}if((D|0)!=0){G=0;do{R=c[x>>2]|0;T=0;do{h[R+((fa(I,G)|0)+T<<3)>>3]=+g[N+((fa(D,T)|0)+G<<2)>>2];T=T+1|0;}while(T>>>0<I>>>0);G=G+1|0;}while(G>>>0<D>>>0)}D0(N)}G=c[w>>2]|0;if(!(G>>>0>1)){L=d;E=130;break b}F=(D|0)==2;Q=1;while(1){if(F){T=c[x>>2]|0;if(+h[T+(Q<<3)>>3]!=+h[T+(G+Q<<3)>>3]){n=32008;E=131;break a}}T=Q+1|0;if(T>>>0<G>>>0){Q=T}else{L=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=32128;E=131;break a}c[z>>2]=D;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=E0(c[z>>2]<<1,4)|0;if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=32160;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=32128;E=131;break a}c[z>>2]=I;c[A>>2]=xb(c[m>>2]|0)|0;c[B>>2]=E0(c[z>>2]<<1,4)|0;Q=fa(I,D)|0;if((a[l]|0)==1){G=C0(Q<<3)|0;if((rb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=32160;E=131;break a}if((I|0)!=0){F=D<<3;N=(D|0)==0;T=D<<3;R=0;do{V=C0(F)|0;c[(c[B>>2]|0)+(R<<2)>>2]=V;if(!N){V=G+(fa(T,R)|0)|0;g1(c[(c[B>>2]|0)+(R<<2)>>2]|0,V|0,T|0)|0}R=R+1|0;}while(R>>>0<I>>>0)}R=c[z>>2]|0;T=R<<1;if(R>>>0<T>>>0){N=D<<3;F=(D|0)==0;V=R;do{W=C0(N)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!F){W=c[B>>2]|0;X=c[W+(V-R<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<T>>>0)}D0(G)}else{T=C0(Q<<2)|0;if((rb(T|0,J|0,1,c[m>>2]|0)|0)!=1){n=32160;E=131;break a}if((I|0)!=0){V=D<<3;R=(D|0)==0;F=0;do{N=C0(V)|0;c[(c[B>>2]|0)+(F<<2)>>2]=N;if(!R){N=c[(c[B>>2]|0)+(F<<2)>>2]|0;W=0;do{h[N+(W<<3)>>3]=+g[T+((fa(D,F)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;R=F<<1;if(F>>>0<R>>>0){V=D<<3;Q=(D|0)==0;G=F;do{W=C0(V)|0;c[(c[B>>2]|0)+(G<<2)>>2]=W;if(!Q){W=c[B>>2]|0;N=c[W+(G-F<<2)>>2]|0;X=c[W+(G<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[N+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}G=G+1|0;}while(G>>>0<R>>>0)}D0(T)}if((Tc(c[m>>2]|0,J|0,1)|0)==-1){n=32160;E=131;break a}else{L=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=O;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){D0(U);n=31816;i=e;return n|0}else if((E|0)==46){D0(P);n=31816;i=e;return n|0}else if((E|0)==52){D0(M);n=31848;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function Ny(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=vd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,55)|0;i=d;return b|0}function Oy(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=32232;o=n;p=32280;q=p;r=32304;s=r;bb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=32232;o=n;p=32280;q=p;r=32304;s=r;bb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=C0(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((rb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}D0(r);t=0;i=e;return t|0}else{k=C0(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Tc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((rb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}D0(k);D0(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);D0(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function Py(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=32232;r=q;s=32280;t=s;u=32328;v=u;bb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=32232;r=q;s=32280;t=s;u=32328;v=u;bb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Tc(o|0,t+(r<<3)|0,0)|0;f=(rb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Tc(o|0,t+(r<<2)|0,0)|0;if((rb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function Qy(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function Ry(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function Sy(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function Ty(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+Sy(b)<e){q=1;i=f;return q|0}if(+Ry(b)>e){q=1;i=f;return q|0}if((Oy(b,1)|0)==0){q=1;i=f;return q|0}Qy(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+Py(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+Py(a,b,d,o);i=f;return q|0}if(+Py(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+Py(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function Uy(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function Vy(a,b){a=a|0;b=b|0;var c=0;c=i;zx(a,b,uy(b)|0);i=c;return}function Wy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=uy(Ax(a,b,f)|0)|0;i=e;return}function Xy(a){a=a|0;var b=0;b=i;c[a+8>>2]=uy(yx(a)|0)|0;i=b;return}function Yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((vx(a)|0)==0){bb(32360,32384,127,32408)}if((vx(b)|0)==0){bb(32432,32384,128,32408)}if((wx(a,b)|0)==0){bb(32456,32384,129,32408)}e=yx(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+Uy(a,b);Zy(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function Zy(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function _y(a,b){a=a|0;b=b|0;var c=0;c=i;Bx(a,b);Xy(b);Yy(a,b);i=c;return}function $y(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function az(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;if((vx(a)|0)==0){bb(32360,32384,317,32496)}if((vx(b)|0)==0){bb(32432,32384,318,32496)}if((Yx(d)|0)==0){bb(32528,32384,319,32496)}if((xx(d,b)|0)==0){bb(32560,32384,320,32496)}f=d;g=c[f>>2]|0;if((g|0)>0){h=c[d+4>>2]|0;j=0;k=0;while(1){l=((c[h+(j<<2)>>2]|0)!=0)+k|0;m=j+1|0;if((m|0)<(g|0)){k=l;j=m}else{n=l;break}}}else{n=0}if((n|0)!=(c[a>>2]|0)){bb(32608,32384,326,32496)}n=b;j=wy(c[n>>2]|0)|0;k=wy(c[f>>2]|0)|0;if((c[f>>2]|0)>0){g=c[d+12>>2]|0;h=b+4|0;l=d+4|0;m=0;do{c[j+(m<<2)>>2]=0;if((c[g+(m<<2)>>2]|0)==0){c[k+(m<<2)>>2]=c[(c[h>>2]|0)+(m<<2)>>2]}else{c[k+(m<<2)>>2]=bz(c[(c[l>>2]|0)+(m<<2)>>2]|0)|0}m=m+1|0;}while((m|0)<(c[f>>2]|0))}m=b+8|0;l=0;do{h=Cx(c[n>>2]|0,j,b,d)|0;o=+Uy(a,l);Zy(c[m>>2]|0,h,o);l=l+1|0;}while((_x(c[f>>2]|0,j,k)|0)==0);if((l|0)==(yx(a)|0)){i=e;return}else{bb(32632,32384,367,32496)}}function bz(a){a=a|0;i=i;return((a|0)<1?1:a)|0}function cz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=i;e=$y(c[a+8>>2]|0,d+ -1|0)|0;i=b;return e|0}function dz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=Dx(a,b,f)|0;f=$y(c[a+8>>2]|0,d)|0;i=e;return f|0}function ez(a,b){a=a|0;b=b|0;var c=0;c=i;Bx(a,b);i=c;return}function fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;ez(a,b);Xy(b);e=yx(b)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=-+Uy(a,b);Zy(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function gz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0.0;e=i;f=yx(a)|0;if((f|0)==0){i=e;return}g=d+8|0;d=0;do{h=+Uy(a,d);j=h- +Uy(b,d);Zy(c[g>>2]|0,d,j);d=d+1|0;}while(d>>>0<f>>>0);i=e;return}function hz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;ez(a,c);Xy(c);gz(a,b,c);i=d;return}function iz(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Ax(a,d,g)|0;g=uy(e)|0;d=a+8|0;c[d>>2]=g;if((e|0)==0){i=f;return}else{h=g;j=0}while(1){Zy(h,j,b);g=j+1|0;if(!(g>>>0<e>>>0)){break}h=c[d>>2]|0;j=g}i=f;return}function jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=C0(20)|0;Rx(0,(f|0)!=0|0,32672,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=E0(e,b)|0;c[f>>2]=a;Rx(0,(a|0)!=0|0,32672,d);i=d;return f|0}function kz(a){a=a|0;var b=0;b=i;D0(c[a>>2]|0);D0(a);i=b;return}function lz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Rx(0,(c[h>>2]|0)>0|0,32688,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Rx(0,(g|0)>(b|0)|0,32712,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Rx(0,(0-f|0)<(b|0)|0,32712,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function mz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=E0(c[d>>2]<<1,c[e>>2]|0)|0;Rx(0,(f|0)!=0|0,32672,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=lz(a,j)|0;h=c[e>>2]|0;g1(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;D0(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function nz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){mz(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;g1((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function oz(a){a=a|0;i=i;return c[a+12>>2]|0}function pz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Rx(0,(c[j>>2]|0)>0|0,32688,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Rx(0,(h|0)>(b|0)|0,32712,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Rx(0,b>>>31^1,32712,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=lz(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function qz(a){a=a|0;i=i;return c[(c[8186]|0)+(a<<2)>>2]|0}function rz(a){a=a|0;i=i;return c[(c[8188]|0)+(a<<2)>>2]|0}function sz(a){a=a|0;i=i;return c[(c[8190]|0)+(a<<2)>>2]|0}function tz(a){a=a|0;i=i;return c[(c[8192]|0)+(a<<2)>>2]|0}function uz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[8188]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[8190]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[8186]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function vz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8194]|0;e=+wz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function wz(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function xz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8196]|0;e=+wz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function yz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[8198]|0;e=+wz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function zz(a){a=a|0;i=i;return 0}function Az(a){a=a|0;var b=0,d=0;b=i;fb(4,(c[8200]|0)+(a<<3)|0)|0;d=(c[8186]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Bz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[8194]|0;f=e+(a<<3)|0;g=c[8198]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[8192]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[8186]|0)+(a<<2)>>2]|0);e=c[8196]|0;g=e+(a<<3)|0;Cz(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;uz(a);d=c[8194]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[8186]|0)+(a<<2)>>2]=0;i=b;return}function Cz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Fz(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Dz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;fb(4,d|0)|0;e=c[8200]|0;f=c[8194]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Ez(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=E0(a,8)|0;c[8194]=d;e=E0(a,8)|0;c[8196]=e;f=E0(a,8)|0;c[8198]=f;g=E0(a,8)|0;c[8200]=g;h=E0(a,4)|0;c[8186]=h;j=E0(a,4)|0;c[8192]=j;k=a<<2;l=C0(k)|0;c[8188]=l;m=E0(a,4)|0;c[8190]=m;i1(l|0,-1,k|0)|0;if((d|0)==0){bb(32808,32824,393,32840)}if((e|0)==0){bb(32848,32824,394,32840)}if((f|0)==0){bb(32864,32824,395,32840)}if((g|0)==0){bb(32880,32824,396,32840)}if((h|0)==0){bb(32896,32824,397,32840)}if((l|0)==0){bb(32920,32824,398,32840)}if((m|0)==0){bb(32944,32824,399,32840)}if((j|0)==0){bb(32968,32824,400,32840)}else{i=b;return}}function Fz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Gz(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Px(17,0,o,34752,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Px(17,0,o,34600,m);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];m=l+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Px(17,0,o,34648,l);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];l=g+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Px(17,0,o,34848,g);i=e;return}else{g=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=g;g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Px(17,0,o,34912,f);i=e;return}}function Hz(a){a=a|0;var b=0;b=i;D0(c[a+12>>2]|0);D0(c[a+4>>2]|0);D0(c[a+8>>2]|0);i=b;return}function Iz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[4967]=.5;h[4953]=1.0;h[4990]=.25;h[4965]=2.0;h[4992]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[9942]=A;B=c[d>>2]|0;c[9872]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[9872]=D;if((C|0)<(B|0)){C=D}else{break}}}c[9870]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[4968]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[4968]=F;G=F}else{G=E}D=c[d>>2]|0;c[9872]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[9872]=I;if((H|0)>=(D|0)){break a}E=+h[4968];H=I}}}while(0);D=C+1|0;c[9870]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[4972]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[4937]=0.0;h[4939]=0.0;h[4943]=0.0;h[5e3]=0.0;c[9868]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[4937]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[4939]+ +h[B>>3]*F;h[4939]=E;F=+h[I>>3];M=+h[4943]+F*F;h[4943]=M;F=+h[H>>3];h[5e3]=+h[5e3]+F*F;H=A+1|0;c[9868]=H;F=+h[4937];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[9938]=A;E=G/J;h[4989]=E;C=c[d>>2]|0;c[9872]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[4997]=0.0;h[4999]=0.0;I=c[b>>2]|0;c[9868]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[4966]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[4997]=ba;ca=E+aa*aa;h[4999]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[9868]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[9938]=A;h[4989]=E;h[4939]=Z;h[4943]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[9872]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[9868]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[9868]=A+1;da=+h[4939];ea=+h[4943];ga=+h[4937]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[4988]=K;c[9966]=0;h[4996]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[9966]=C;K=+h[4953]/+V(+ga);h[4968]=K;h[4991]=0.0;h[4993]=0.0;B=c[b>>2]|0;c[9868]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[4991]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[4991]=oa;pa=+h[4993]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[4993]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[4939];L=+h[4937];N=+h[4968];D=D+1|0;la=ma}c[9868]=B+1;ia=+h[4937];ja=pa;ka=oa}N=+h[4967];L=ka*N*ka;h[4984]=L;J=ja*N*ja;h[4985]=J;h[4944]=J+(L+ia*(+h[5e3]+ia*N));N=+h[4965];h[39560>>3]=N*ka*ia;h[39568>>3]=N*ja*ia;h[39576>>3]=L-J;h[39584>>3]=ka*ja;la=39592|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[9868]=10;la=c[d>>2]|0;c[9872]=1;if((la|0)>=1){D=1;while(1){h[4984]=0.0;h[4985]=0.0;h[4986]=0.0;A=c[b>>2]|0;c[9868]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[4984]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[4985]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[4986]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[9868]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[4990]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[4984]*+h[4986];h[t+(U+D<<3)>>3]=+h[4985]*+h[4986];J=+h[4984];L=+h[4985];h[t+(P+D<<3)>>3]=+h[4990]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[4967]*+h[4984]*+h[4985];na=D+1|0;c[9872]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[9868]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[9880]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[9868]=B;if((la|0)<(D|0)){la=B}else{break}}}c[9876]=1;la=1;do{D=c[d>>2]|0;c[9884]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[9884]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[9872]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[9872]=D+1}na=c[9942]|0;c[9870]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[4964]=0.0;ma=c[d>>2]|0;c[9872]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[4964]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[9872]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[4964]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[9872]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[4964];Ca=Ca+1|0}c[9872]=ta+1}Ca=B+1|0;c[9870]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[9872]=1;if((A|0)<1){break}else{Ea=1}while(1){h[4964]=0.0;B=c[b>>2]|0;c[9870]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[4964]=N;Ca=na+1|0;c[9870]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[9872]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[9870]=1;if((A|0)>=1){ta=1;while(1){h[4964]=0.0;c[9868]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[4964]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[9868]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[9870]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[9876]=la;}while((la|0)<6);la=c[l>>2]|0;c[9872]=1;h[4964]=0.0;c[9868]=1;L=+h[4967];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[39632+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[39632+(A+ -1<<3)>>3]+L;h[4964]=L;A=A+1|0;}while((A|0)<6);h[4944]=+h[4944]- +h[4954]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[4984]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[4985]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[4986]=O;h[39560>>3]=+h[39560>>3]-J-N*(O+K);h[39592>>3]=+h[39592>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[4984]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[4985]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[4986]=J;h[39568>>3]=+h[39568>>3]-O-N*(K-J);h[39600>>3]=+h[39600>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[4984]=J;h[39576>>3]=+h[39648>>3]+(+h[39576>>3]-J- +h[39640>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[4984]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[4985]=K;Oa=+h[4967];h[39584>>3]=+h[39584>>3]-J-K*Oa;h[39608>>3]=+h[39608>>3]- +h[39656>>3]+ +h[39664>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[4984]=K;h[39616>>3]=+h[39616>>3]-Oa*K;h[4964]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[9872]=la+1;c[9868]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[39632+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[39632+(ta+ -1<<3)>>3]+N;h[4964]=N;ta=ta+1|0;c[9868]=ta;}while((ta|0)<6);K=+h[4972];h[4974]=K*+h[4944]+ +h[4954]+N;J=+h[4965];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[4984]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[4985]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[4986]=R;T=R+(K*+h[39560>>3]+O+S);h[39800>>3]=T;O=K*+h[39592>>3]+S-R;h[39832>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[4984]=R;S=+h[I>>3]*+h[ma>>3];h[4985]=S;Z=+h[Ma>>3]*+h[Na>>3];h[4986]=Z;h[39808>>3]=K*+h[39568>>3]+R+S-Z;h[39840>>3]=K*+h[39600>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[4984]=Z;R=+h[39640>>3]+(Z+K*+h[39576>>3])- +h[39648>>3];h[39816>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[4984]=Z;h[39824>>3]=Z+K*+h[39584>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[39608>>3]+ +h[39656>>3]- +h[39664>>3];h[39848>>3]=J;h[39856>>3]=+h[4972]*+h[39616>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[4974]+T+R+O+J;h[4964]=K;h[4994]=K;h[4995]=K;c[9974]=0;J=+h[4992]/50.0;h[4968]=J;h[4954]=+h[4953];c[9868]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[39640>>3]=Z;W=+Y(+Pa);h[39648>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[39632+(Ma+ -1<<3)>>3]=Z;Q=+h[39640>>3]*G+ +h[39648>>3]*W;h[39632+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[39648>>3];ca=+h[39640>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[39792+(Ma<<3)>>3]*+h[39632+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[4995]=Ra;c[9974]=Na;h[4984]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[4985]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[9870]=10;h[4964]=Ra;h[4973]=Pa;h[4998]=O;c[9868]=50;if((Xa|0)==49){h[4985]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[4984]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[4970]=0.0;if(Ya!=Za){S=Ya-Ua;h[4984]=S;T=Za-Ua;h[4985]=T;R=+h[4967]*(S-T)/(S+T);h[4970]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[4973]=R;T=+X(+R);h[39640>>3]=T;S=+Y(+R);h[39648>>3]=S;c[9870]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[39632+(Na+ -1<<3)>>3]=T;W=+h[39640>>3]*G+ +h[39648>>3]*S;h[39632+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[39648>>3];N=+h[39640>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[4995]=0.0;c[9870]=1;Na=1;do{ma=Na+ -1|0;Ma=39632+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[39552+(ma<<3)>>3]*+h[Ma>>3];h[4995]=+h[4995]+ +h[39792+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[9870]=10;Na=c[l>>2]|0;c[9872]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[39632+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[9870]=6;c[9872]=Na+1}h[4963]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[4937]=0.0;h[4984]=0.0;h[4985]=0.0;Ma=c[b>>2]|0;c[9868]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[39640>>3]*+h[la>>3]+ +h[39648>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[4937]=+h[4937]+G*G;bb=+h[4984]+ +h[la>>3]*+h[ta>>3];h[4984]=bb;G=+h[ta>>3];cb=+h[4985]+G*G;h[4985]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[9868]=Ma+1;$a=cb;ab=bb}ma=c[9966]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[4996];S=+h[4994];h[4996]=G>=S?G:S}S=+h[4995];if(!(S>=0.0)){db=-S}else{db=S}G=+h[4996];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[4996]=S;c[9868]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[4968]=N;R=+h[4963]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[4972];la=ta+1|0;c[9868]=la;if((ta|0)>=(Na|0)){break b}S=+h[4985];G=+h[4984];ta=la}}}while(0);Na=c[d>>2]|0;c[9872]=1;if((Na|0)>=1){Ma=1;while(1){h[4964]=0.0;ta=c[b>>2]|0;c[9870]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[4964]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[9870]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[4963]*+h[p+(la+ -1+Ma<<3)>>3]- +h[4972]*+h[q+(Ma+ -1<<3)>>3]);h[4968]=G;c[9868]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[4968];I=I+1|0}c[9868]=la+1}I=Ma+1|0;c[9872]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[4943]=0.0;h[4939]=0.0;Ma=c[b>>2]|0;c[9868]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[4943]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[4939]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[9868]=Ma+1;hb=kb;ib=jb}S=+h[4937];G=S*ib-hb*hb;h[4988]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[39528]=1;C=c[l>>2]|0;c[9872]=1;if((C|0)<1){lb=39624;mb=+h[4953];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[39632+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[9870]=6;c[9872]=C+1;lb=39624;mb=+h[4953];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function Jz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[5020]=.5;h[5016]=1.0;h[5032]=6.283185307179586;z=+h[n>>3];h[5029]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[10046]=A;c[10054]=0;B=c[d>>2]|0;c[10006]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[10006]=B+1}c[10004]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[5021]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[5021]=F;G=F}else{G=z}H=c[d>>2]|0;c[10006]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[5021];I=I+1|0}c[10006]=H+1}I=B+1|0;c[10004]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[5004]=0.0;D=c[b>>2]|0;c[10002]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[5004]=+h[5004]+G*G;A=p+1|0;c[10002]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[10006]=1;if((p|0)>=1){D=1;while(1){h[5021]=0.0;h[5019]=0.0;y=c[b>>2]|0;c[10004]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[5021]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[5019]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[10004]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[5021]=G;h[5019]=+h[g>>3]*L;g=c[b>>2]|0;c[10002]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[5019]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[5021];H=H+1|0}c[10002]=g+1}H=D+1|0;c[10006]=H;if((D|0)<(p|0)){D=H}else{break}}}h[5005]=0.0;h[5007]=0.0;h[5014]=0.0;D=c[b>>2]|0;c[10002]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[5005]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[5007]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[5014]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[10002]=D+1;O=R;P=T;Q=S}S=+h[5004];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[5025]=U;h[5021]=0.0;if(Q*Q>S*.99*O){h[5021]=+h[5016]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[5020]*U*Z);h[5017]=P;if(O*+h[5029]<P*P*.01){h[5021]=+h[5016]}n=c[b>>2]|0;c[10002]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[5025]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[5021]*U;if((D|0)>=(n|0)){break}e=D;P=+h[5025];D=D+1|0;p=e}c[10002]=n+1;_=0}while(1){n=_+1|0;c[10054]=n;h[5004]=0.0;h[5007]=0.0;h[5008]=0.0;p=c[b>>2]|0;c[10002]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[5004]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[5007]=da;Z=+h[H>>3];ea=P+Z*Z;h[5008]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[10002]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[5021]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[5026]=U;D=c[b>>2]|0;c[10002]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[5026];U=+h[5007];O=+h[5004];g=g+1|0;H=e}c[10002]=D+1}H=c[d>>2]|0;c[10006]=1;if((H|0)>=1){g=1;while(1){h[5019]=0.0;p=c[b>>2]|0;c[10004]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[5019]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[10004]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[5019]=O;e=c[b>>2]|0;c[10002]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[5019];l=l+1|0}c[10002]=e+1}l=g+1|0;c[10006]=l;if((g|0)<(H|0)){g=l}else{break}}}h[5009]=0.0;h[5010]=0.0;h[5011]=0.0;h[5012]=0.0;h[5013]=0.0;g=c[b>>2]|0;c[10002]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[5009]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[5010]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[5011]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[5012]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[5013]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[10002]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[5020];O=U*na;h[5009]=O;P=U*ma-O;h[5012]=P;Z=O+la+P;h[5033]=Z;h[5035]=Z;h[5034]=Z;c[10056]=0;a[40048]=1;W=+h[5032]/50.0;h[5021]=W;c[10002]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[5035]=wa;c[10056]=p;h[5030]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[5031]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[5024]=ta;h[5015]=ua;h[5018]=va;h[5017]=wa;c[10002]=50;h[5034]=wa;if((za|0)==49){h[5031]=Z;Ba=Z}else if((za|0)==0){h[5030]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[5031]}h[5022]=0.0;S=+h[5030];if(S!=Ba){Q=S-Aa;h[5030]=Q;S=Ba-Aa;h[5031]=S;T=U*(Q-S)/(Q+S);h[5022]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[5024]=T;S=+X(+T);h[5015]=S;Q=+Y(+T);h[5018]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[5017]=T;p=c[b>>2]|0;c[10002]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[5015]*+h[y>>3]+ +h[5018]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[5018];Q=+h[5015];H=H+1|0;g=e}c[10002]=p+1;Da=+h[5017]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[5033];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function Kz(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[40504]=1;a[40496]=1;c[40516>>2]=6;fR(40512)|0;e=c[d>>2]|0;c[10122]=1;if((e|0)>=1){d=1;do{wQ(40632,b+(d+ -1)|0,1)|0;o=c[10122]|0;d=o+1|0;c[10122]=d;}while((o|0)<(e|0))}PQ()|0;e=c[g>>2]|0;if((e|0)==1){c[40540>>2]=a[40496]&1?6:0;fR(40536)|0;wQ(40632,h,4)|0;PQ()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[40564>>2]=a[40496]&1?6:0;fR(40560)|0;wQ(40632,h,4)|0;wQ(40632,j,4)|0;PQ()|0}j=c[k>>2]|0;if((j|0)==1){c[40588>>2]=a[40496]&1?6:0;fR(40584)|0;wQ(40632,l,8)|0;PQ()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[40612>>2]=a[40496]&1?6:0;fR(40608)|0;wQ(40632,l,8)|0;wQ(40632,m,8)|0;PQ()|0}if((c[f>>2]|0)==2){eQ(40640,0)|0}else{i=n;return 0}return 0}function Lz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[10164]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[10164]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){lQ(40712,42408,80,25);B=41016;C=41024;Kz(40712,42440,41192,B,41096,d,B,B,C,C,80)|0;break}c[10228]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[10228]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}lQ(40712,42448,80,34);B=41016;F=41024;Kz(40712,42488,41184,B,41096,40912,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[10214]=B;c[10226]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){lQ(40712,43272,80,52);I=41016;J=41024;Kz(40712,43256,43328,I,41096,G,I,I,J,J,80)|0;break a}c[10214]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[10226]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[10214]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[10226]=F+(c[10214]|0);break b}}}while(0);lQ(40712,43200,80,52);B=41016;F=41024;Kz(40712,43256,43264,B,41096,q,B,B,F,F,80)|0;break a}}while(0);c[10218]=(c[d>>2]|0)+20;c[q+64>>2]=c[10214];if((c[p>>2]|0)<(c[10226]|0)){lQ(40712,42496,80,60);C=41016;F=41024;Kz(40712,42560,42568,C,41192,40904,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[10218]|0)){lQ(40712,42576,80,60);F=41016;C=41024;Kz(40712,42560,42640,F,41192,40872,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){lQ(40712,43384,80,24);C=41096;F=41016;B=41024;Kz(40712,43416,43424,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[5104]=K;if(!(K<=0.0)){break}lQ(40712,42880,80,28);B=41016;Kz(40712,41592,42912,B,B,B,B,41096,40832,41024,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==-1){lQ(40712,40944,80,49);B=41016;F=41024;Kz(40712,41e3,41008,B,B,B,B,B,F,F,80)|0;lQ(40712,41032,80,47);F=41016;B=41024;Kz(40712,41080,41088,F,41096,n,F,F,B,B,80)|0;lQ(40712,41104,80,41);B=41016;F=41024;Kz(40712,41152,41160,41096,B,B,B,B,F,F,80)|0;i=y;return 0}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else{D=210}}while(0);c:do{if((D|0)==27){a[40888]=0;K=+h[l>>3];h[5115]=K;L=+h[m>>3];h[5108]=L;A=c[d>>2]|0;c[10164]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[5115]=O;P=+h[m+(F<<3)>>3];h[5108]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[40888]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[10164]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[10174]=p;r=p+(c[w>>2]|0)|0;c[10176]=r;p=r+(c[w>>2]|0)|0;c[10198]=p;F=p+(c[w>>2]|0)|0;c[10168]=F;B=F+(c[d>>2]|0)|0;c[10204]=B;C=B+(c[d>>2]|0)|0;c[10210]=C;c[10200]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[10224]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[5117]=+h[B>>3];a[40824]=0;h[5086]=+h[o+24>>3];J=o+16|0;h[5081]=+h[J>>3];do{if((c[w>>2]|0)!=0){Mz(41192,v,w,d,40688,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,40808,B,0,o,q,s,t)|0;if((c[10294]|0)>0){i=y;return 0}if((c[10202]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=41096;hA(d,o+((c[10168]|0)+ -1<<3)|0,G,g,G)|0;a[40824]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[5081];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[5081]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[5081];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[5116]=O;U=+h[5086];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[10210]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){Rz(40688,j,f,g,d,H,I,X)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[40824]=1;D=197;break d}}else{Y=40688;Rz(Y,Y,f,g,d,H,I,X)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[5086];c[n>>2]=1;a[40824]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[40824]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[5117]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[5081]=W;h[J>>3]=W;break}Rz(40688,40928,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[5116];a[40824]=1;D=197;break d}}else{W=+h[5086];if(!B){if(P*(W-N)<0.0){break}Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[40824]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[10210]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){Rz(40688,j,f,g,d,G,X,I)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[40824]=1;D=197;break d}}else{H=40688;Rz(H,H,f,g,d,G,X,I)|0;if((c[10294]|0)>0){i=y;return 0}else{h[e>>3]=+h[5086];c[n>>2]=1;a[40824]=1;D=197;break d}}}}while(0);if(a[40824]&1){D=197}else{D=128}}else{h[5086]=+h[e>>3];c[n>>2]=1;Oz(d,k+4|0,l,m,f,o+((c[10204]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[10164]=1;e:do{if((B|0)>=1){J=c[10204]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[10164]=X;if((I|0)<(B|0)){I=X}else{break e}}lQ(40712,43016,80,39);I=41016;J=41024;Kz(40712,42688,43056,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+Vz(41168,1);h[5117]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[5117]*4.0*(aa>=ba?aa:ba);h[5106]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){lQ(40712,43064,80,60);J=41016;Kz(40712,42560,43128,J,J,J,J,41192,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[5085]=ca*.001;U=+Pz(d,g,o+((c[10204]|0)+ -1<<3)|0,s,t);if(U>.5/+h[5085]){h[5085]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+iQ(40680,z);h[5085]=U;da=U}else{U=+h[o+16>>3];h[5085]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}lQ(40712,42968,80,29);J=41016;I=41024;Kz(40712,43e3,43008,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[5085]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[5116]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[5085]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{Qz(40688,f,g,d,b,u,40680,o+((c[10204]|0)+ -1<<3)|0,n,s,t,o+((c[10210]|0)+ -1<<3)|0,o+400|0,o+((c[10168]|0)+ -1<<3)|0,o+((c[10200]|0)+ -1<<3)|0,q,40848,B,k+36|0,40896)|0;if((c[10294]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[5085]}h[5081]=ja;h[o+16>>3]=ja;J=c[10210]|0;X=(c[d>>2]|0)+J|0;c[10220]=X;G=c[d>>2]|0;c[10164]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[5081]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[10164]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[5081];h[o+232>>3]=+h[5081]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}Mz(41096,v,w,d,e,j,f,o+((c[10168]|0)+ -1<<3)|0,o+((c[10210]|0)+ -1<<3)|0,J,Y,o+((c[10174]|0)+ -1<<3)|0,o+((c[10176]|0)+ -1<<3)|0,o+((c[10198]|0)+ -1<<3)|0,x,40808,B,0,o,q,s,t)|0;if((c[10294]|0)>0){i=y;return 0}if((c[10202]|0)!=0){lQ(40712,43432,80,47);la=41016;ma=41024;Kz(40712,41080,43480,41096,la,la,la,la,ma,ma,80)|0;lQ(40712,43488,80,38);ma=41016;la=41024;Kz(40712,41240,43480,41096,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}Mz(41184,v,w,d,40688,j,f,o+((c[10168]|0)+ -1<<3)|0,o+((c[10210]|0)+ -1<<3)|0,J,Y,o+((c[10174]|0)+ -1<<3)|0,o+((c[10176]|0)+ -1<<3)|0,o+((c[10198]|0)+ -1<<3)|0,x,40808,B,0,o,q,s,t)|0;if((c[10294]|0)>0){i=y;return 0}if((c[10202]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=41096;hA(d,o+((c[10168]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){lQ(40712,42808,80,54);p=41016;Kz(40712,42864,42872,p,p,p,p,41192,40928,j,80)|0;break c}else if((D|0)==220){lQ(40712,42920,80,34);p=41016;Kz(40712,42488,42960,p,p,p,p,41192,j,e,80)|0;break c}else if((D|0)==224){lQ(40712,43136,80,49);p=41016;Kz(40712,41e3,43192,p,p,p,p,41192,40928,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;Oz(d,oa,l,m,o+((c[10210]|0)+ -1<<3)|0,o+((c[10204]|0)+ -1<<3)|0,s,t)|0;if((c[10294]|0)>0){D=233;break}p=c[d>>2]|0;c[10164]=1;r=c[10204]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[10164]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+Pz(d,o+((c[10210]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[5117];pa=O*V;h[5083]=pa;if(!(pa<=1.0)){D=138;break}O=+h[5086];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[5106]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[5081];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[5081]=V/O}}while(0);Sz(40688,f,g,d,b,u,40648,o+((c[10204]|0)+ -1<<3)|0,k,n,s,t,o+((c[10210]|0)+ -1<<3)|0,o+400|0,o+((c[10168]|0)+ -1<<3)|0,o+((c[10200]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,40848,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,40896)|0;if((c[10294]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){Mz(41184,v,w,d,40688,j,f,o+((c[10168]|0)+ -1<<3)|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[10174]|0)+ -1<<3)|0,o+((c[10176]|0)+ -1<<3)|0,o+((c[10198]|0)+ -1<<3)|0,x,40808,o+64|0,0,o,q,s,t)|0;if((c[10294]|0)>0){D=233;break f}if((c[10202]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=41096;hA(d,o+((c[10168]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[5086];V=+h[5081];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[5116];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[5117]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}Rz(40688,40928,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5116];D=197;continue}if(!(U<0.0)){Rz(40688,j,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[5116];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[5117]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[5081]=U-O;D=128;continue}else{Rz(40688,40928,f,g,d,q+28|0,o+((c[10210]|0)+ -1<<3)|0,o+224|0)|0;if((c[10294]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[5116];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[5086];h[o+16>>3]=+h[5081];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[5083]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[10164]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[5083]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[5083];E=E+1|0;p=B}c[10164]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[10220]=p;switch(p|0){case 2:{lQ(40712,41328,80,47);p=41016;Kz(40712,41080,41376,p,p,p,p,41096,40688,41024,80)|0;lQ(40712,41384,80,48);p=41016;E=41024;Kz(40712,41312,41440,p,p,p,p,p,E,E,80)|0;lQ(40712,41448,80,45);E=41016;p=41024;Kz(40712,41496,41504,E,E,E,E,E,p,p,80)|0;break};case 3:{lQ(40712,41512,80,38);p=41016;Kz(40712,41240,41552,p,p,p,p,41096,40688,41024,80)|0;lQ(40712,41560,80,28);p=41016;E=41024;Kz(40712,41592,41600,p,p,p,p,p,E,E,80)|0;break};case 6:{lQ(40712,41608,80,44);E=41016;Kz(40712,41656,41664,E,E,E,E,41192,40688,40648,80)|0;lQ(40712,41672,80,57);E=41016;p=41024;Kz(40712,41736,41744,E,E,E,E,E,p,p,80)|0;break};case 7:{lQ(40712,41608,80,44);p=41016;Kz(40712,41656,41752,p,p,p,p,41192,40688,40648,80)|0;lQ(40712,41760,80,48);p=41016;E=41024;Kz(40712,41312,41816,p,p,p,p,p,E,E,80)|0;lQ(40712,41824,80,28);E=41016;p=41024;Kz(40712,41592,41856,E,E,E,E,E,p,p,80)|0;break};case 8:{lQ(40712,41608,80,44);p=41016;Kz(40712,41656,41864,p,p,p,p,41192,40688,40648,80)|0;lQ(40712,41872,80,37);p=41016;E=41024;Kz(40712,41912,41920,p,p,p,p,p,E,E,80)|0;break};case 9:{lQ(40712,41608,80,44);E=41016;Kz(40712,41656,41928,E,E,E,E,41192,40688,40648,80)|0;lQ(40712,41936,80,49);E=41016;p=41024;Kz(40712,41e3,41992,E,E,E,E,E,p,p,80)|0;lQ(40712,42e3,80,38);p=41016;E=41024;Kz(40712,41240,42040,p,p,p,p,p,E,E,80)|0;break};case 10:{lQ(40712,41608,80,44);E=41016;Kz(40712,41656,42048,E,E,E,E,41192,40688,40648,80)|0;lQ(40712,42056,80,45);E=41016;p=41024;Kz(40712,41496,42104,E,E,E,E,E,p,p,80)|0;lQ(40712,42112,80,36);p=41016;E=41024;Kz(40712,42152,42160,p,p,p,p,p,E,E,80)|0;break};case 11:{lQ(40712,42168,80,40);E=41016;Kz(40712,42216,42224,E,E,E,E,41192,40688,40648,80)|0;lQ(40712,42232,80,36);E=41016;p=41024;Kz(40712,42152,42272,E,E,E,E,E,p,p,80)|0;break};case 12:{lQ(40712,41608,80,44);p=41016;Kz(40712,41656,42280,p,p,p,p,41192,40688,40680,80)|0;lQ(40712,42288,80,45);p=41016;E=41024;Kz(40712,41496,42336,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{lQ(40712,41200,80,38);E=41016;Kz(40712,41240,41248,E,E,E,E,41096,40688,41024,80)|0;lQ(40712,41256,80,48);E=41016;p=41024;Kz(40712,41312,41320,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[5086];h[o+24>>3]=+h[5086];h[o+16>>3]=+h[5081];i=y;return 0}else if((D|0)==215){lQ(40712,42648,80,39);p=41016;E=41024;Kz(40712,42688,42696,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){lQ(40712,42704,80,39);E=41016;p=41024;Kz(40712,42688,42744,E,E,E,E,E,p,p,80)|0;break c}}}while(0);lQ(40712,42752,80,47);A=41016;p=41024;Kz(40712,41080,42800,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){lQ(40712,42344,80,55);p=41016;A=41024;Kz(40712,42400,41096,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){lQ(40712,43336,80,39);D=41016;Kz(40712,42688,43376,D,D,D,D,41192,j,e,80)|0}if((c[k>>2]|0)==-1){lQ(40712,43528,80,46);e=41016;j=41024;Kz(40712,43576,43584,e,e,e,e,e,j,j,80)|0;lQ(40712,43592,80,47);j=41016;e=41024;Kz(40712,41080,43640,41096,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function Mz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[5456]=C;c[t>>2]=0;D=c[e>>2]|0;c[10914]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[10914]|0;E=F+1|0;c[10914]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[5463]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;Rz(g,b,k,l,f,o,m,n)|0;if((c[10294]|0)>0){i=v;return 0}D=d;Ud[D&7](f,b,k,e,p,y,z)|0;if((c[10294]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[43712]=0;F=c[e>>2]|0;c[10914]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[43712]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[10914]=F+1;if(!M){break}I=+iQ(43704,43648);h[5460]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[5456];do{if((H- +h[g>>3])*I<0.0){Rz(g,b,k,l,f,o,m,n)|0;if((c[10294]|0)<=0){break}i=v;return 0}else{G=+h[5460]/I;h[5461]=G;N=c[f>>2]|0;c[10914]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[5461];Q=Q+1|0}c[10914]=N+1}}while(0);Ud[D&7](f,b,k,e,p,y,z)|0;if((c[10294]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[43712]=0;F=c[e>>2]|0;c[10914]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[43712]=1;V=1;W=c[10914]|0}Q=W+1|0;c[10914]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[5456];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;Rz(g,F,k,l,f,o,m,n)|0;if((c[10294]|0)>0){i=v;return 0}E=d;Ud[E&7](f,F,k,e,p,y,z)|0;if((c[10294]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[43712]=0;D=c[e>>2]|0;c[10914]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[43712]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[10914]=D+1;if(!aa){i=v;return 0}I=+iQ(43704,43648);h[5460]=I;h[F>>3]=I+ +h[F>>3];I=+h[5460]/+h[5456];h[5461]=I;Q=c[f>>2]|0;c[10914]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[5461];R=R+1|0}c[10914]=Q+1}Ud[E&7](f,F,k,e,p,y,z)|0;if((c[10294]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[43712]=0;R=c[e>>2]|0;c[10914]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[43712]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[10914]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[5459]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}Rz(g,43672,k,l,f,o,m,n)|0;if((c[10294]|0)<=0){break}i=v;return 0}else{h[5459]=Y;j=c[f>>2]|0;c[10914]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[10914]=j+1}}while(0);ga=d;Ud[ga&7](f,43672,k,e,q,y,z)|0;if((c[10294]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[10924]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){Nz(e,43704,43696,R,43672,p,q,r,43664,s,fa,da,x,ca)|0;if((c[10294]|0)>0){ha=76;break}if((c[10924]|0)>1){ha=73;break}Rz(g,43664,k,l,f,o,m,n)|0;if((c[10294]|0)>0){ha=76;break}Ud[ga&7](f,43664,k,e,r,y,z)|0;if((c[10294]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[5458];R=41096;hA(e,r,R,p,R)|0;if((c[10924]|0)==4){i=v;return 0}Rz(g,43664,k,l,f,o,m,n)|0;if((c[10294]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function Nz(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[10940]=c[o>>2];c[o>>2]=0;h[5466]=0.0;a[43744]=0;t=c[b>>2]|0;c[10930]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+iQ(43776,j+(v<<3)|0);if(w==+iQ(43776,l+((c[10930]|0)+ -1<<3)|0)){break}y=c[10930]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[5466]){break}h[5466]=B;c[o>>2]=y}else{a[43744]=1}}while(0);v=c[10930]|0;u=v+1|0;c[10930]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[43752]=1;c[10942]=c[p>>2];h[g>>3]=+h[r>>3];t=41096;hA(b,l,t,k,t)|0;c[p>>2]=1;a[43736]=0;C=0}else{a[43752]=0;c[o>>2]=c[10940];c[10942]=c[p>>2];if(a[43744]&1){h[g>>3]=+h[r>>3];t=41096;hA(b,l,t,k,t)|0;a[43736]=1;C=1;break}else{t=41096;hA(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[43736]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[43736]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=41096;hA(b,k,t,l,t)|0;t=c[b>>2]|0;c[10930]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[10930]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+iQ(43776,j+(u<<3)|0);if(!(A!=+iQ(43776,k+((c[10930]|0)+ -1<<3)|0))){break}c[n+((c[10930]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[10930]|0;F=u+1|0;c[10930]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[5466]=0.0;a[43744]=0;t=c[b>>2]|0;c[10930]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+iQ(43776,j+(v<<3)|0);if(A==+iQ(43776,k+((c[10930]|0)+ -1<<3)|0)){break}y=c[10930]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[5466]){break}h[5466]=I;c[o>>2]=y}else{a[43744]=1}}while(0);v=c[10930]|0;u=v+1|0;c[10930]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[43752]=t&1;if(t){a[43736]=0;c[10942]=0;c[p>>2]=1;break}if(!(a[43744]&1)){t=41096;hA(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=41096;hA(b,k,t,l,t)|0;t=c[b>>2]|0;c[10930]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[10930]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[10930]|0}u=K+1|0;c[10930]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[10942]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function Oz(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[5475]=+h[d>>3];h[5474]=+h[e>>3];j=c[a>>2]|0;c[10946]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[5475]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[5475]=o;h[5474]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[5474];a=l+1|0;c[10946]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function Pz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[5478]=0.0;e=c[a>>2]|0;c[10952]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[5478]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[10952]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[5477]=0.0;e=c[a>>2]|0;c[10952]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[5477]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[10952]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function Qz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[10970]=0;c[10968]=0;c[10974]=0;h[5490]=+h[b>>3];h[5492]=+Pz(f,d,l,0,0);C=c[f>>2]|0;c[10958]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[10958]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[5483]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[10958]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[10958]=G+1}a[43928]=1;c[10960]=0;a[43944]=1;c[C>>2]=(c[C>>2]|0)+1;c[10978]=0;Ud[B&7](b,d,e,q,43912,n,o)|0;b:do{if((c[10978]|0)<0){K=35}else{while(1){if(a[43928]&1){c[E>>2]=(c[E>>2]|0)+1;a[43928]=0;Tz(f,b,d,e,q,43864,k,43888,l,r,s,t,g,43912,v,j,n,o,x)|0;h[5482]=1.0e6;if((c[10978]|0)<0|(c[10972]|0)!=0){K=35;break b}c[10974]=0}H=c[f>>2]|0;c[10958]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[10958]=H+1}Uz(f,q,s,t)|0;I=c[f>>2]|0;c[10958]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[5483]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[10958]=I+1}N=+Pz(f,q,l,0,0);h[5494]=N;if(N<=+h[v>>3]*100.0*+h[5492]){break}J=c[10960]|0;if((J|0)>0){h[z>>3]=N/+h[5495];h[A>>3]=1.0/+(J|0);O=+gQ(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[5482]=P;Q=+h[5494];R=P}else{h[5495]=N;Q=N;R=+h[5482]}if(R*Q<=.33){break}J=c[10960]|0;H=J+1|0;c[10960]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[43928]=1}c[C>>2]=(c[C>>2]|0)+1;c[10978]=0;Ud[B&7](b,d,e,q,43912,n,o)|0;if((c[10978]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[10958]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[10958]=H+1}N=+Pz(f,q,l,0,0);h[5494]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[10958]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[5483]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[10958]=J+1}}while(0);if(!(a[43944]&1)){break}H=c[f>>2]|0;c[10958]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[10958]=H+1}N=+Pz(f,r,l,0,0);h[5488]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[43944]=0}h[b>>3]=+h[5490];G=c[f>>2]|0;c[10958]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[10958]=G+1}if(a[43944]&1){I=(c[10970]|0)+1|0;c[10970]=I;N=.9/(+h[5488]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[5481]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[10972]|0)!=0){I=(c[10974]|0)+1|0;c[10974]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[10978]|0)>-2)){K=53;break}I=(c[10968]|0)+1|0;c[10968]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function Rz(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[11004]=o;p=+h[b>>3]- +h[a>>3];h[5500]=p;a=c[f>>2]|0;c[10996]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[10996]=a+1;q=+h[5500]}h[5496]=1.0;h[5497]=0.0;p=q/+h[k>>3];h[5501]=p;c[10998]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[5497]=u*t+s/+h[a>>3];p=t*s;h[5496]=p;h[5501]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[10996]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[5497]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[5496];g=g+1|0}c[10996]=a+1}g=v+1|0;c[10998]=g;if((v|0)>=(o|0)){break}r=+h[5500];s=+h[5496];t=+h[5501];u=+h[5497];v=g}i=l;return 0}



function tB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){D0(c[e+(h*40|0)+20>>2]|0);D0(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;wB(k)|0;D0(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Sx(c[a+536>>2]|0,62080,d)}else if((j|0)==6){i=b;return 0}return 0}function uB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[29972>>2]|c[7474]|0)==0){z=w;A=1;break}UP(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Qx(17,1,62112,g);UP(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;UP(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Qx(17,0,62144,f);UP(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[7614]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function vB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=C0(20)|0;c[b>>2]=f;Rx(0,(f|0)!=0|0,62152,e);e=C0(a)|0;c[f>>2]=e;e=C0(a)|0;c[f+4>>2]=e;e=C0(a)|0;c[f+8>>2]=e;e=C0(a)|0;c[f+16>>2]=e;Rx(0,(c[b>>2]|0)!=0|0,62184,d);i=d;return 0}function wB(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;D0(c[d>>2]|0);D0(c[d+4>>2]|0);D0(c[d+8>>2]|0);D0(c[d+16>>2]|0);i=b;return 0}function xB(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Sx(c[a+536>>2]|0,62232,b);return 0}function yB(a){a=a|0;a=i;i=i+8|0;Sx(0,62232,a);return 0}function zB(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Sx(c[a+536>>2]|0,62232,b);return 0}function AB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=C0(l)|0;c[e+(h<<6)+36>>2]=C0(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;HB(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=C0(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;FB(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){Sx(c[a+536>>2]|0,62272,d)}else if((n|0)==8){i=b;return 0}return 0}function BB(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function CB(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;ub(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function DB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){D0(c[e+(h<<6)+28>>2]|0);D0(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){IB(e+(h<<6)+24|0)|0}else if((j|0)==1){GB(e+(h<<6)+24|0)|0;D0(c[e+(h<<6)+32>>2]|0)}else{k=6;break}D0(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Sx(c[a+536>>2]|0,62272,d)}else if((k|0)==8){i=b;return 0}return 0}function EB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[29964>>2]|c[7474]|0)==0){z=w;A=1;break}UP(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Qx(15,1,62304,g);UP(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;UP(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Qx(15,0,62336,f);UP(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Yd[c[7614]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function FB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=C0(12)|0;f=C0(a<<2)|0;c[e>>2]=f;Rx(0,(f|0)!=0|0,62344,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function GB(a){a=a|0;var b=0;b=i;D0(c[c[a>>2]>>2]|0);i=b;return 0}function HB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=C0(32)|0;Rx(0,(g|0)!=0|0,62400,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Pd(0,d|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;Pd(0,g+4|0)|0;Ed(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;ab(b|0)|0;Jb(62448,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function IB(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ld(c[d+12>>2]|0)|0;Ib(c[d+8>>2]|0)|0;Ib(c[d+4>>2]|0)|0;i=b;return 0}function JB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Rx(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,62616,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Rx(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,62656,e);if(($d[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=C0(p)|0;c[g+(m*80|0)+52>>2]=C0(p)|0;c[g+(m*80|0)+48>>2]=C0(p)|0;c[g+(m*80|0)+16>>2]=C0(p)|0;c[g+(m*80|0)+8>>2]=C0(p)|0;c[g+(m*80|0)+12>>2]=C0(p)|0;Zd[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){WB(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){OB(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){WB(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){xB(a,n)|0;break}else{q=12;break a}}}while(0);n=m+1|0;if((n|0)<(c[h>>2]|0)){m=n}else{q=14;break}}if((q|0)==12){Sx(c[j>>2]|0,62696,d)}else if((q|0)==14){i=b;return 0}return 0}function KB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;D0(c[e+(h*80|0)+44>>2]|0);D0(c[e+(h*80|0)+52>>2]|0);D0(c[e+(h*80|0)+48>>2]|0);D0(c[e+(h*80|0)+16>>2]|0);D0(c[e+(h*80|0)+8>>2]|0);D0(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;XB(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;XB(m)|0;l=m;break}else if((k|0)==1){m=e+(h*80|0)+40|0;PB(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);D0(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){yB(j)|0}else if((n|0)==9){Sx(c[a+536>>2]|0,62696,d)}else if((n|0)==11){i=b;return 0}return 0}function LB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(ZB(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==3){j=(ZB(b,d)|0)&255;break}else if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=QB(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==2){j=(zB(b,d)|0)&255;break}else{Sx(c[b+536>>2]|0,62696,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function MB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;UP(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Px(17,1,u,62728,m);do{if((a[b+312|0]|0)==0){UP(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;UP(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Qx(17,0,62928,f);UP(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Qx(17,1,62768,l);UP(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;UP(q,d,c[v>>2]|0);if((a1(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Qx(17,0,62848,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;UP(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Qx(17,0,62888,g);G=E}UP(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[29972>>2]|c[7474]|0)==0){break}Yd[c[7614]&511](17)}}while(0);if((c[29972>>2]|c[7474]|0)==0){x=1;i=e;return x|0}Yd[c[7614]&511](17);x=1;i=e;return x|0}function NB(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function OB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=C0(144)|0;c[b>>2]=f;Rx(0,(f|0)!=0|0,62944,e);c[f>>2]=0;e=a<<3;g=C0(e)|0;c[f+4>>2]=g;g=C0(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=C0(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=C0(e)|0;c[f+24>>2]=g;g=E0(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=C0(e)|0;c[f+64>>2]=g;g=C0(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=E0(g,8)|0;c[f+104>>2]=j;j=E0(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=C0(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=C0(e)|0;c[f+124>>2]=j;j=C0(e)|0;c[f+128>>2]=j;j=C0(e)|0;c[f+132>>2]=j;j=C0(e)|0;c[f+136>>2]=j;j=C0(e)|0;c[f+140>>2]=j;Rx(0,(c[b>>2]|0)!=0|0,62976,d);i=d;return 0}function PB(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;D0(c[d+4>>2]|0);D0(c[d+16>>2]|0);D0(c[d+12>>2]|0);D0(c[d+24>>2]|0);D0(c[d+28>>2]|0);D0(c[d+64>>2]|0);D0(c[d+68>>2]|0);D0(c[d+104>>2]|0);D0(c[d+108>>2]|0);D0(c[d+116>>2]|0);D0(c[d+124>>2]|0);D0(c[d+128>>2]|0);D0(c[d+132>>2]|0);D0(c[d+136>>2]|0);D0(c[d+140>>2]|0);i=b;return 0}function QB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=C0(c[Y>>2]|0)|0;if((c[29972>>2]|0)!=0){UP(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];Ox(17,1,63016,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Ox(17,1,63072,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Ox(17,0,63088,F);Yd[c[7614]&511](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}Yd[c[7614]&511](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){g1(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{g1(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+ld(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;RB($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+ld(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[29976>>2]|0)!=0){SB(c[Q>>2]|0,$,18,63128);SB(c[ca>>2]|0,$,18,63160)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[29976>>2]|0)!=0){SB(c[ca>>2]|0,$,18,63192)}a[da]=R;lA(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){UP(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];Gz(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;RB($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;RB($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}$A(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[29976>>2]|0)!=0){Ox(18,1,63232,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Ox(18,1,63272,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Ox(18,0,63304,C);Yd[c[7614]&511](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Yd[c[7614]&511](18)}if((c[29980>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;Ox(19,1,63336,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];gc(Ja|0,63360,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;Ox(19,0,63368,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}Yd[c[7614]&511](19)}h[K>>3]=+kA($,c[Ia>>2]|0);h[J>>3]=+kA($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}g1(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Ox(17,0,63416,w);TB(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Ox(17,0,63488,v);TB(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+ld(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Ox(17,0,63552,u);TB(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+ld(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Ox(17,0,63624,t);TB(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}g1(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;g1(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}Ox(17,0,63688,s);TB(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){g1(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}Ox(17,0,63760,r);TB(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Ox(17,0,63832,q);TB(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Ox(17,0,63904,p);TB(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){g1(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Ox(17,0,63968,o);TB(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Ox(17,0,64040,n);TB(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];Ox(17,0,64176,l);TB(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){g1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{g1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}Ox(17,0,64104,m);TB(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[29972>>2]|0)!=0){Ox(17,1,63376,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;Ox(17,0,63392,x);Yd[c[7614]&511](17);TB(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}g1(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;RB($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;D0(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;D0(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;D0(Z);i=e;return kb|0}if((a[Ha]|0)==0){UP(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];Gz(0,f,hb);}if((c[29972>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;Ox(17,0,64248,j);TB(S,L,J,K,17)}g1(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;D0(Z);i=e;return kb|0}return 0}function RB(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[29984>>2]|0)!=0){Ox(20,0,64600,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){VB(w,f,d,e,m)}else{UB(w,f,m)}do{if((c[29984>>2]|0)!=0){Ox(20,0,64640,r);if((c[29980>>2]|0)==0){break}w=v;s=c[b>>2]|0;c[q>>2]=s;c[q+4>>2]=s;Ox(19,1,63336,q);s=c[b>>2]|0;if((s|0)>0){C=y+20|0;D=s;s=0;do{a[w]=0;if((D|0)>0){E=0;do{F=+h[f+((fa(c[C>>2]|0,s)|0)+E<<3)>>3];c[p>>2]=w;G=p+4|0;h[k>>3]=F;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];gc(w|0,64672,p|0)|0;E=E+1|0;}while((E|0)<(c[b>>2]|0))}c[o>>2]=w;Ox(19,0,63368,o);s=s+1|0;D=c[b>>2]|0;}while((s|0)<(D|0))}Yd[c[7614]&511](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else if((A|0)==1){z=y+8|0;do{if((c[z>>2]|0)!=0){B=c[b>>2]|0;if((B|0)<=0){break}o=c[y+12>>2]|0;p=0;do{f=d+(p<<3)|0;h[f>>3]=+h[f>>3]*+h[o+(p<<3)>>3];p=p+1|0;}while((p|0)<(B|0))}}while(0);if((c[29984>>2]|0)!=0){c[u>>2]=c[y+96>>2];Ox(20,0,64496,u);SB(d,b,20,64528)}ze[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[29984>>2]|0)!=0){SB(e,b,20,64544);c[t>>2]=c[y+96>>2];Ox(20,0,64560,t)}if((c[z>>2]|0)==0){i=g;return 0}z=c[b>>2]|0;if((z|0)<=0){i=g;return 0}b=c[y+12>>2]|0;y=0;do{t=d+(y<<3)|0;h[t>>3]=1.0/+h[b+(y<<3)>>3]*+h[t>>3];y=y+1|0;}while((y|0)<(z|0));i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;Sx(g,64688,n)}return 0}function SB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[29904+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;Ox(d,1,63368,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Ox(d,0,64480,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}Yd[c[7614]&511](d);i=f;return}function TB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[29904+(f<<2)>>2]|0)==0){i=g;return}Ox(f,1,64288,q);Ox(f,1,64304,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Ox(f,0,64320,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}Yd[c[7614]&511](f);Ox(f,1,64360,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Ox(f,0,64376,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}Yd[c[7614]&511](f);Ox(f,1,64416,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Ox(f,0,64432,j);Yd[c[7614]&511](f);Yd[c[7614]&511](f);i=g;return}function UB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;i1(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;i1(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}$d[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function VB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+ld(+(n*+ld(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;RB(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function WB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=C0(80)|0;c[b>>2]=f;Rx(0,(f|0)!=0|0,64768,e);c[f>>2]=0;e=a<<3;g=C0(e)|0;c[f+4>>2]=g;g=C0(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=C0(e)|0;c[f+16>>2]=g;g=E0(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=C0(fa(e,a)|0)|0;c[f+64>>2]=g;g=C0(e)|0;c[f+68>>2]=g;g=C0(a<<2)|0;c[f+72>>2]=g;Rx(0,(c[b>>2]|0)!=0|0,64800,d);i=d;return 0}function XB(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;D0(c[d+4>>2]|0);D0(c[d+8>>2]|0);D0(c[d+16>>2]|0);D0(c[d+20>>2]|0);D0(c[d+64>>2]|0);D0(c[d+68>>2]|0);D0(c[d+72>>2]|0);i=b;return 0}function YB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;i1(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}$d[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function ZB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;g1(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[29972>>2]|0)==0){J=b+4|0}else{UP(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ox(17,1,64840,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Ox(17,1,64912,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Ox(17,0,64928,t);Yd[c[7614]&511](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}Yd[c[7614]&511](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];_B(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){UP(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];Gz(3,g,P);}$=+kA(H,c[b>>2]|0);aa=+kA(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){g1(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;Ox(17,0,65104,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;Ox(17,0,65160,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;Ox(17,0,65224,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[29972>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;Ox(17,0,64976,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Ox(17,0,65016,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Ox(17,0,65072,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){UP(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];Gz(0,f,L);if((c[29972>>2]|0)==0){da=0;break}c[m>>2]=V;Ox(17,0,65304,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(17,0,65016,l);if((c[29972>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(17,0,65072,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[29972>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;g1(ma|0,oa|0,qa|0)|0;i=e;return da|0}Yd[c[7614]&511](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;g1(ma|0,oa|0,qa|0)|0;i=e;return da|0}function _B(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[29976>>2]|0)!=0){c[z>>2]=j;Ox(18,0,65344,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Ox(18,0,65392,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){$B(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){aC(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{YB(E,m,r)|0}if((c[29980>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;Ox(19,1,65408,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];gc(F|0,65432,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;Ox(19,0,65440,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}Yd[c[7614]&511](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+kA(b,_);if(!(!(J<=H)&!(+kA(b,e)<=H))){$=31;break}xs(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;Qx(17,0,65448,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;Qx(17,0,65480,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+kA(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function $B(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;ze[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function aC(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+ld(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;$B(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function bC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){cC(a,b);f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;dC(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==4){ke[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==3){f=CA(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function cC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[65512+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[65512+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];$d[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function dC(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function eC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=hy(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=C0(88)|0;Ox(23,0,65544,e);j=AA(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[258]|0;g=C0(j<<2)|0;c[16392]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=E0(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[16392]|0;g=n}}else if((f|0)==2){g=C0(8)|0;c[g+4>>2]=4;m=C0(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=E0(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);rC(b)|0;if((c[2]|0)==0){i=e;return k|0}Dz(6);Az(1);i=e;return k|0}function fC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[258]|0;g=c[16392]|0;if((f|0)>0){h=g;j=0;while(1){D0(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[16392]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}D0(m)}else if((e|0)==3){BA(c[b+48>>2]|0)|0}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){D0(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}D0(n);D0(c[e>>2]|0)}sC(a)|0;mC(a);i=d;return 0}function gC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(359,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=r1(c[s>>2]|0,o)|0;if((t|0)==0){db(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=r1(c[s>>2]|0,o)|0;if((B|0)==0){db(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=r1(c[C>>2]|0,o)|0;if((D|0)==0){db(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=r1(c[C>>2]|0,o)|0;if((E|0)==0){db(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=r1(c[s>>2]|0,o)|0;if((F|0)==0){db(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(360,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=r1(c[s>>2]|0,o)|0;if((G|0)==0){db(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=r1(c[s>>2]|0,o)|0;if((H|0)==0){db(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;d1(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=r1(c[L>>2]|0,o)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=r1(c[p>>2]|0,o)|0;if((N|0)==0){db(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,65576,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=r1(c[M>>2]|0,o)|0;if((U|0)==0){db(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=r1(c[M>>2]|0,o)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,65672,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=r1(c[M>>2]|0,o)|0;if((X|0)==0){db(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[71792>>2]|0,71768,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=r1(c[M>>2]|0,o)|0;if((Y|0)==0){db(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,65728,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=r1(c[M>>2]|0,o)|0;if((Z|0)==0){db(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(361,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=r1(c[M>>2]|0,o)|0;if(($|0)==0){db(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function hC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Ox(8,0,65824,G);I=b+313|0;a[I]=1;_A(b);if((c[87100>>2]|0)==0){Zd[c[71788>>2]&127](71768,b)}a[I]=0}}while(0);if((e|0)!=0){iC(rd(e|0)|0,b)}if((c[30004>>2]|0)==0){i=f;return 0}Dz(0);Ox(25,0,65872,F);Ox(25,1,65896,E);H=+vz(6);J=+vz(6);K=J/+vz(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Ox(25,0,65904,D);K=+vz(1);H=+vz(1);J=H/+vz(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Ox(25,0,65944,C);J=+vz(2);K=+vz(2);H=K/+vz(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ox(25,0,65976,B);H=+vz(3);J=+vz(3);K=J/+vz(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Ox(25,0,66e3,A);K=+vz(4);H=+vz(4);J=H/+vz(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(25,0,66040,z);J=+vz(7);K=+vz(7);H=K/+vz(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(25,0,66072,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+vz(0);J=H- +vz(7);H=J- +vz(4);J=H- +vz(3);H=J- +vz(2);J=H- +vz(1);H=J- +vz(6);J=+vz(0);K=J- +vz(7);J=K- +vz(4);K=J- +vz(3);J=K- +vz(2);K=J- +vz(1);J=K- +vz(6);K=J/+vz(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(25,0,66136,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ox(25,0,66104,x)}K=+vz(0);H=+vz(0);J=H/+vz(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Ox(25,0,66168,v);Yd[c[7614]&511](25);Ox(25,1,66192,u);c[t>>2]=c[d+40>>2];Ox(25,0,66200,t);c[s>>2]=c[d+44>>2];Ox(25,0,66224,s);Yd[c[7614]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);Ox(25,1,66248,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];Ox(25,0,66264,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];Ox(25,0,66280,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];Ox(25,0,66312,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];Ox(25,0,66344,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];Ox(25,0,66368,m);Yd[c[7614]&511](25)}else if((s|0)!=5){Ox(25,1,66400,l);Ox(25,0,66408,j);Yd[c[7614]&511](25)}Ox(25,0,66472,g);Az(0);i=f;return 0}function iC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Vb(b|0,66944)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(b|0,66952,y|0)|0;if((z|0)==0){C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,66968,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;od(b|0,66984,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;od(b|0,66992,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;od(b|0,67e3,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((a1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,66968,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];od(b|0,66968,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((a1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;od(b|0,66984,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;od(b|0,66984,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((a1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;od(b|0,66992,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;od(b|0,66992,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((a1(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;od(b|0,67e3,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];od(b|0,66968,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;od(b|0,66984,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;od(b|0,66992,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((a1(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;od(b|0,67e3,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Vb(0,66944)|0;}while((d|0)!=0);C=Jd(10,b|0)|0;D=md(b|0)|0;i=e;return}function jC(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 5:{Qx(1,0,66568,q);v=1;i=m;return v|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{Qx(1,0,66496,r);v=1;i=m;return v|0};case 18:{w=c[256]|0;do{if((w|0)!=0){if((a1(w,66752)|0)!=0){break}c[u>>2]=4;break a}}while(0);Ox(23,0,66776,o);v=1;i=m;return v|0};case 4:{w=c[256]|0;if((w|0)!=0){if((a1(w,66608)|0)==0){break a}}Ox(23,0,66624,p);v=1;i=m;return v|0};default:{}}}while(0);p=eC(a,s)|0;te[c[31212>>2]&7]()|0;do{if((p|0)==0){o=gC(a,b,d,e,f,g)|0;te[c[31212>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){Zd[c[71788>>2]&127](71768,a);iB(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Ox(23,0,66904,n);o=oe[c[c[a+540>>2]>>2]&63](a,t)|0;te[c[31212>>2]&7]()|0;hC(a,s,l)|0;te[c[31212>>2]&7]()|0;x=o}else{te[c[31212>>2]&7]()|0;x=p}}while(0);fC(a,s)|0;v=x;i=m;return v|0}function kC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){lC(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if(($d[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Sx(c[a+536>>2]|0,67016,d)}else if((k|0)==6){lC(a);i=b;return}}function lC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;i1(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;D0(c[f+(a*48|0)+28>>2]|0);D0(c[f+(a*48|0)+32>>2]|0);D0(c[f+(a*48|0)+16>>2]|0);D0(c[f+(a*48|0)+20>>2]|0);D0(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function nC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=C0(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=C0(c[y>>2]<<2)|0;oC(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;g1(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;g1(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((zA(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=pC(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){g1(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;g1(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;D0(x);D0(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Qx(5,1,67072,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];gc(q|0,67104,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Qx(5,0,67112,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=30456;K=c[7614]|0;Yd[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=67120;aa=$;Sx(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Qx(5,0,67112,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=30456;K=c[7614]|0;Yd[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=67120;aa=$;Sx(O,aa,g);return 0}function oC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;i1(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}$d[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function pC(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=E0(d,4)|0;r=E0(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;D0(q);D0(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;D0(q);D0(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){D0(q);D0(r);i=o;return v|0}if((n|0)==0){v=-1;D0(q);D0(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(5,1,67224,p);qC(s,d,f,c[g>>2]|0,j,l,m);if((c[29924>>2]|0)==0){v=-1;D0(q);D0(r);i=o;return v|0}Yd[c[7614]&511](5);v=-1;D0(q);D0(r);i=o;return v|0}function qC(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;i1(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];Ox(5,0,67256,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function rC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=hc(67272,67296)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=$c(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;ob(n|0);do{}while(($c(n|0)|0)!=10);q=c[b+152>>2]|0;r=E0(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=E0(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=E0(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=ac(n|0,67304,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=ac(n|0,67304,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=E0(s,8)|0;x=v}}while(0);fc(67312,j|0)|0;fc(67368,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];fc(67328,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];fc(67352,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}sb(67368)|0;Vc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function sC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}D0(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){D0(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}D0(l);i=d;return 0}function tC(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function uC(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+vC(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[29940>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Ox(9,1,67432,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ox(9,0,67544,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Yd[c[7614]&511](9);g=1;i=b;return g|0}function vC(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;KC(b);g=f+540|0;$d[c[(c[g>>2]|0)+84>>2]&127](f)|0;$d[c[(c[g>>2]|0)+36>>2]&127](f)|0;$d[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;oe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function wC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+vC(b,1.0);if((c[29940>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}Ox(9,1,67568,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(9,0,67632,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(9,0,67592,s)}Ox(9,1,67656,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;Ox(9,0,67728,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Ox(9,0,67680,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;Ox(9,0,67816,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(9,0,67752,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;Ox(9,0,67904,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Ox(9,0,67848,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Yd[c[7614]&511](9);Ox(9,1,67936,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=$d[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;Ox(9,0,67728,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Ox(9,0,67680,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Yd[c[7614]&511](9);Yd[c[7614]&511](9);i=d;return}function xC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[29940>>2]|0)!=0){jB(b,9)}if((c[3e4>>2]|0)==0){i=d;return}Ox(24,1,67960,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){Ox(24,1,68e3,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ox(24,0,68024,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Yd[c[7614]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}Ox(24,1,68080,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ox(24,0,68104,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Yd[c[7614]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){Ox(24,1,68136,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(24,0,68024,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Yd[c[7614]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){Ox(24,1,68160,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;Ox(24,0,68184,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Yd[c[7614]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){Ox(24,1,68232,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?68304:68312;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?68304:68312;t=(a[(c[l>>2]|0)+n|0]|0)!=0?68304:68312;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;Ox(24,0,68256,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Yd[c[7614]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){Ox(24,1,68320,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;Ox(24,0,68344,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Yd[c[7614]&511](24)}Yd[c[7614]&511](24);i=d;return}function yC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;Ox(9,0,68392,z);if((f|0)==0){gB(b);hB(b);C=6}else{if((a[f]|0)!=0){zC(b,f,g)}gB(b);hB(b);if((a[f]|0)==0){C=6}}if((C|0)==6){$d[c[(c[A>>2]|0)+84>>2]&127](b)|0;$d[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(a1(d,69880)|0)==0|0;f=(a1(d,69888)|0)==0;z=(a1(d,69896)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Qx(1,0,68440,y);Qx(1,0,68472,x);c[w>>2]=69880;c[w+4>>2]=69688;Qx(1,0,68496,w);c[v>>2]=69888;c[v+4>>2]=69768;Qx(1,0,68496,v);c[u>>2]=69896;c[u+4>>2]=69816;Qx(1,0,68496,u);Sx(c[b+536>>2]|0,68528,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(a1(e,c[68552+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Qx(1,0,68584,s);Qx(1,0,68472,r);t=1;do{u=c[68616+(t<<2)>>2]|0;c[q>>2]=c[68552+(t<<2)>>2];c[q+4>>2]=u;Qx(1,0,68496,q);t=t+1|0;}while((t|0)<7);Sx(c[b+536>>2]|0,68528,p)}}while(0);p=c[68512+(D<<2)>>2]|0;c[o>>2]=c[68424+(D<<2)>>2];c[o+4>>2]=p;Ox(9,0,68648,o);o=(D|0)==2;if(o){p=c[68616+(F<<2)>>2]|0;c[n>>2]=c[68552+(F<<2)>>2];c[n+4>>2]=p;Ox(9,0,68688,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=AC(b,F,j)|0;break}if((D|0)==3){BC(b,j);I=0;break}else{Sx(c[b+536>>2]|0,68728,m)}}}while(0);if((MB(b,1)|0)!=0){J=-2;xC(b);K=15;L=K;M=68752;N=M;Ox(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];RA(b,R,V);W=356;dB(b);X=362;iB(b);Y=357;_A(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=oe[ha&63](b,1)|0;ja=365;eB(b);i=k;return J|0}if((EB(b,1)|0)!=0){J=-3;xC(b);K=15;L=K;M=68752;N=M;Ox(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];RA(b,R,V);W=356;dB(b);X=362;iB(b);Y=357;_A(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=oe[ha&63](b,1)|0;ja=365;eB(b);i=k;return J|0}m=(uB(b,1)|0)==0;J=m?I:-4;xC(b);K=15;L=K;M=68752;N=M;Ox(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];RA(b,R,V);W=356;dB(b);X=362;iB(b);Y=357;_A(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=$d[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=oe[ha&63](b,1)|0;ja=365;eB(b);i=k;return J|0}function zC(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ox(9,0,69912,z);z=My(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Sx(C,69952,y)}Ox(9,0,69992,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=Ny(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=EC(c[d+(C*112|0)+4>>2]|0)|0;E=Ny(A,D)|0;D0(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((b1(E,70032,6)|0)==0){if((c[29940>>2]|0)==0){break}}else{D=b1(E,70040,6)|0;if((c[29940>>2]|D|0)==0){break}}c[v>>2]=E;Qx(9,0,70048,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;Ty(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(9,0,70016,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}Ox(9,0,70104,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=Ny(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=EC(c[G+(w*112|0)+4>>2]|0)|0;v=Ny(A,F)|0;D0(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Qx(9,0,70128,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;Ty(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Ox(9,0,70016,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}Ox(9,0,70184,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=Ny(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=EC(c[t+(x*112|0)+4>>2]|0)|0;K=Ny(A,C)|0;D0(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Qx(9,0,70128,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;Ty(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ox(9,0,70016,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}Ox(9,0,70208,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=Ny(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=EC(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=Ny(A,u)|0;D0(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Qx(9,0,70256,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;Ty(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;Ox(9,0,70240,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}Ox(9,0,70312,l);l=b+144|0;if((c[l>>2]|0)<=0){Ky(A);i=f;return}o=b+32|0;b=0;do{x=Ny(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=EC(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=Ny(A,n)|0;D0(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Qx(9,0,70360,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;Ty(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?68304:68312;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;Ox(9,0,70344,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));Ky(A);i=f;return}function AC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;QA(a,+h[a+240>>3]);dB(a);iB(a);_A(a);kB(a);lC(a);$A(a);dB(a);e=CC(a,b,c)|0;iB(a);_A(a);eB(a);iB(a);i=d;return e|0}



function Ae(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Be(){return i|0}function Ce(a){a=a|0;i=a}function De(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ee(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Fe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ge(a){a=a|0;J=a}function He(a){a=a|0;K=a}function Ie(a){a=a|0;L=a}function Je(a){a=a|0;M=a}function Ke(a){a=a|0;N=a}function Le(a){a=a|0;O=a}function Me(a){a=a|0;P=a}function Ne(a){a=a|0;Q=a}function Oe(a){a=a|0;R=a}function Pe(a){a=a|0;S=a}function Qe(a){a=a|0;var b=0,d=0;b=i;tC(a)|0;d=a+540|0;$d[c[(c[d>>2]|0)+40>>2]&127](a)|0;$d[c[(c[d>>2]|0)+28>>2]&127](a)|0;$d[c[(c[d>>2]|0)+32>>2]&127](a)|0;$d[c[(c[d>>2]|0)+48>>2]&127](a)|0;$d[c[(c[d>>2]|0)+52>>2]&127](a)|0;dB(a);i=b;return}function Re(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=e1(B|0)|0;D=C0(C+11|0)|0;p1(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=hc(D|0,32)|0;if((C|0)==0){B=Nd(c[(Lc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Qx(23,0,40,u);Vc(0)|0;F=0}else{F=C}D0(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}te[c[31212>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Bz(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Bz(2);Az(2)}pz(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];SA(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(23,1,144,r);Z=bC(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Qe(b);eB(b);if((c[29996>>2]|0)!=0){Yd[c[7614]&511](23)}if((c[2]|0)!=0){Az(4)}A=UA(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ox(7,1,200,q);if((c[87100>>2]|0)==0){Zd[c[71788>>2]&127](71768,b)}WA(b,c[J>>2]|0,z,d);if((c[29932>>2]|0)!=0){Yd[c[7614]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;iB(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Dz(4)}if((nC(b,1,1)|0)!=0){c[B>>2]=1;iB(b)}$d[c[(c[K>>2]|0)+88>>2]&127](b)|0;dB(b);mB(b);eB(b);do{if((T|0)==0){_=0}else{Az(7);Dz(2);A=(pc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(pc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+vz(2);if(!$){aa=0;break}aa=(pc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+vz(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=qz(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(pc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+vz(ba+9|0);if((ca|0)==0){ka=0}else{ka=(pc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Dz(7);if((la|0)!=0){_=T;break}c[p>>2]=Nd(c[(Lc()|0)>>2]|0)|0;Qx(23,0,240,p);Vc(T|0)|0;_=0}}while(0);if((c[87100>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;Zd[c[71788>>2]&127](71768,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[19342]|0)!=0){ca=f;ba=77376;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];Gx(M,f);Jd(10,M|0)|0;ba=c[19350]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;Ox(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((MB(b,0)|0)!=0){ma=58;break}if((EB(b,0)|0)!=0){ma=58;break}if((uB(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Ox(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((MB(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Ox(1,0,448,m);U=_;V=-2;break}if((EB(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Ox(1,0,536,l);U=_;V=-3;break}T=(uB(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Ox(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Ox(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Vc(U|0)|0;i=e;return V|0}function Se(a){a=a|0;i=i;return 0}function Te(a){a=a|0;i=i;return 0}function Ue(a){a=a|0;i=i;return 0}function Ve(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1816>>3]=l;h[e+1808>>3]=m;i=b;return}function We(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1800>>3]=l;h[e+1792>>3]=m;i=b;return}function Xe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1784>>3]=l;h[e+1776>>3]=m;i=b;return}function Ye(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1768>>3]=l;h[e+1760>>3]=m;i=b;return}function Ze(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1752>>3]=l;h[e+1744>>3]=m;i=b;return}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1736>>3]=l;h[e+1728>>3]=m;i=b;return}function $e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1720>>3]=l;h[e+1712>>3]=m;i=b;return}function af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-+h[b+1768>>3]- +h[b+1720>>3]- +h[b+1816>>3];i=i;return}function bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=-+h[b+1760>>3]- +h[b+1712>>3]- +h[b+1808>>3];i=i;return}function cf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1704>>3]=l;h[e+1696>>3]=m;i=b;return}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=-+h[b+1744>>3]- +h[b+1696>>3]- +h[b+1792>>3];i=i;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=-+h[b+1752>>3]- +h[b+1704>>3]- +h[b+1800>>3];i=i;return}function ff(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1688>>3]=l;h[e+1680>>3]=m;i=b;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+768>>3]=-+h[b+1728>>3]- +h[b+1680>>3]- +h[b+1776>>3];i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=-+h[b+1736>>3]- +h[b+1688>>3]- +h[b+1784>>3];i=i;return}function jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+464>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+464|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+464>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+440>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+440|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+440>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+472>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+472|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+472>>3]);g=c[f>>2]|0;h[(c[g+452>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+444>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+456>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+456|0;h[(c[g+448>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+456>>3]);e=c[f>>2]|0;h[(c[e+452>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+448>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+448|0;h[(c[e+448>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+448>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+432>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+432|0;h[(c[j+448>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+432>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+40>>3]=k;LB(a,5)|0;g=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+464>>3]=+h[g>>3];h[f+440>>3]=+h[g+8>>3];h[f+472>>3]=+h[g+16>>3];h[f+456>>3]=+h[g+24>>3];h[f+448>>3]=+h[g+32>>3];h[f+432>>3]=+h[g+40>>3];xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Lj(a);i=b;return}function kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+760>>3]=l;h[e+752>>3]=m;i=b;return}function lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=l;h[e+736>>3]=m;i=b;return}function mf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+728>>3]=l;h[e+720>>3]=m;i=b;return}function nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+712>>3]=l;h[e+704>>3]=m;i=b;return}function of(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+696>>3]=l;h[e+688>>3]=m;i=b;return}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+680>>3]=l;h[e+672>>3]=m;i=b;return}function qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+664>>3]=l;h[e+656>>3]=m;i=b;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+760>>3]+(+h[b+664>>3]+ +h[b+712>>3]);i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+752>>3]+(+h[b+656>>3]+ +h[b+704>>3]);i=i;return}function tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+648>>3]=l;h[e+640>>3]=m;i=b;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+736>>3]+(+h[b+640>>3]+ +h[b+688>>3]);i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+744>>3]+(+h[b+648>>3]+ +h[b+696>>3]);i=i;return}function wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+632>>3]=l;h[e+624>>3]=m;i=b;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+728>>3]+(+h[b+632>>3]+ +h[b+680>>3]);i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+720>>3]+(+h[b+624>>3]+ +h[b+672>>3]);i=i;return}function zf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+944>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+944|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+944>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+952>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+952|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+952>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+888>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+888|0;h[(c[j+528>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+888>>3]);g=c[f>>2]|0;h[(c[g+532>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+524>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+880>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+880|0;h[(c[g+528>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+880>>3]);e=c[f>>2]|0;h[(c[e+532>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+920>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+920|0;h[(c[e+528>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+920>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+912>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+912|0;h[(c[j+528>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+912>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+40>>3]=k;LB(a,6)|0;g=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+944>>3]=+h[g>>3];h[f+952>>3]=+h[g+8>>3];h[f+888>>3]=+h[g+16>>3];h[f+880>>3]=+h[g+24>>3];h[f+920>>3]=+h[g+32>>3];h[f+912>>3]=+h[g+40>>3];Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);i=b;return}function Af(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1528>>3]=l;h[e+1520>>3]=m;i=b;return}function Bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1512>>3]=l;h[e+1504>>3]=m;i=b;return}function Cf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=l;h[e+1488>>3]=m;i=b;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+2624>>3]*+h[b+952>>3]- +h[b+2616>>3]*+h[b+944>>3];i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+2616>>3]*+h[b+952>>3]+ +h[b+2624>>3]*+h[b+944>>3];i=i;return}function Ff(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1432>>3]=l;h[e+1424>>3]=m;i=b;return}function Gf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1416>>3]=l;h[e+1408>>3]=m;i=b;return}function Hf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1400>>3]=l;h[e+1392>>3]=m;i=b;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+2656>>3]*+h[b+888>>3]- +h[b+2648>>3]*+h[b+880>>3];i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+2648>>3]*+h[b+888>>3]+ +h[b+2656>>3]*+h[b+880>>3];i=i;return}function Kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1480>>3]=l;h[e+1472>>3]=m;i=b;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+1520>>3]+(+h[b+1424>>3]+ +h[b+1472>>3]);i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1672>>3]=+h[b+1528>>3]+(+h[b+1432>>3]+ +h[b+1480>>3]);i=i;return}function Nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1464>>3]=l;h[e+1456>>3]=m;i=b;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+1512>>3]+(+h[b+1416>>3]+ +h[b+1464>>3]);i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=+h[b+1504>>3]+(+h[b+1408>>3]+ +h[b+1456>>3]);i=i;return}function Qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1448>>3]=l;h[e+1440>>3]=m;i=b;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+1496>>3]+(+h[b+1400>>3]+ +h[b+1448>>3]);i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=+h[b+1488>>3]+(+h[b+1392>>3]+ +h[b+1440>>3]);i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+2640>>3]*+h[b+920>>3]- +h[b+2632>>3]*+h[b+912>>3];i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+2632>>3]*+h[b+920>>3]+ +h[b+2640>>3]*+h[b+912>>3];i=i;return}function Vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;Wx(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Mh(q,c[o>>2]|0,+h[z+120>>3],+h[z+128>>3]);z=q;q=c[y>>2]|0;Mh(r,c[o>>2]|0,+h[q+136>>3],+h[q+144>>3]);q=r;r=c[y>>2]|0;Mh(s,c[o>>2]|0,+h[r+152>>3],+h[r+160>>3]);r=s;c[n>>2]=1;s=Xx(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=Xx(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=Xx(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;Wx(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(u,c[o>>2]|0,+h[a+936>>3],+h[a+928>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(v,c[o>>2]|0,+h[u+904>>3],+h[u+896>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(w,c[o>>2]|0,+h[v+872>>3],+h[v+864>>3]);v=w;c[j>>2]=1;w=Xx(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=Xx(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=Xx(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Ih(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+3040>>3]=+h[x>>3];h[d+3032>>3]=A;i=b;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+3040>>3];i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+3032>>3];i=i;return}function Yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1384>>3]=g;h[e+1376>>3]=j;i=b;return}function Zf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1368>>3]=g;h[e+1360>>3]=j;i=b;return}function _f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1352>>3]=g;h[e+1344>>3]=j;i=b;return}function $f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1336>>3]=g;h[e+1328>>3]=j;i=b;return}function ag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1320>>3]=g;h[e+1312>>3]=j;i=b;return}function bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1304>>3]=g;h[e+1296>>3]=j;i=b;return}function cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1288>>3]=g;h[e+1280>>3]=j;i=b;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+1376>>3]+(+h[b+1280>>3]+ +h[b+1328>>3]);i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=-+h[b+1664>>3]- +h[b+1616>>3];i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[b+1384>>3]+(+h[b+1288>>3]+ +h[b+1336>>3]);i=i;return}function gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2488>>3]=-+h[b+1672>>3]- +h[b+1624>>3];i=i;return}function hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1272>>3]=g;h[e+1264>>3]=j;i=b;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+1360>>3]+(+h[b+1264>>3]+ +h[b+1312>>3]);i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-+h[b+1648>>3]- +h[b+1600>>3];i=i;return}function kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+1368>>3]+(+h[b+1272>>3]+ +h[b+1320>>3]);i=i;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=-+h[b+1656>>3]- +h[b+1608>>3];i=i;return}function mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1256>>3]=g;h[e+1248>>3]=j;i=b;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+1344>>3]+(+h[b+1248>>3]+ +h[b+1296>>3]);i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2448>>3]=-+h[b+1632>>3]- +h[b+1584>>3];i=i;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1352>>3]+(+h[b+1256>>3]+ +h[b+1304>>3]);i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2456>>3]=-+h[b+1640>>3]- +h[b+1592>>3];i=i;return}function rg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2096>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2096|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2096>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2104|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2104>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2072>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2072|0;h[(c[j+608>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2072>>3]);g=c[f>>2]|0;h[(c[g+612>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+604>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2088>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2088|0;h[(c[g+608>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2088>>3]);e=c[f>>2]|0;h[(c[e+612>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2080>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2080|0;h[(c[e+608>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2080>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2064>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2064|0;h[(c[j+608>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2064>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+40>>3]=k;LB(a,7)|0;g=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2096>>3]=+h[g>>3];h[f+2104>>3]=+h[g+8>>3];h[f+2072>>3]=+h[g+16>>3];h[f+2088>>3]=+h[g+24>>3];h[f+2080>>3]=+h[g+32>>3];h[f+2064>>3]=+h[g+40>>3];dk(a);ek(a);fk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);nk(a);ok(a);pk(a);qk(a);rk(a);i=b;return}function sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2248>>3]=l;h[e+2240>>3]=m;i=b;return}function tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=l;h[e+2224>>3]=m;i=b;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2216>>3]=l;h[e+2208>>3]=m;i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2200>>3]=l;h[e+2192>>3]=m;i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2184>>3]=l;h[e+2176>>3]=m;i=b;return}function xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2168>>3]=l;h[e+2160>>3]=m;i=b;return}function yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2152>>3]=l;h[e+2144>>3]=m;i=b;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2432>>3]=+h[b+2240>>3]+(+h[b+2144>>3]+ +h[b+2192>>3]);i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+2248>>3]+(+h[b+2152>>3]+ +h[b+2200>>3]);i=i;return}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2136>>3]=l;h[e+2128>>3]=m;i=b;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+2232>>3]+(+h[b+2136>>3]+ +h[b+2184>>3]);i=i;return}function Dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=+h[b+2224>>3]+(+h[b+2128>>3]+ +h[b+2176>>3]);i=i;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2120>>3]=l;h[e+2112>>3]=m;i=b;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2408>>3]=+h[b+2216>>3]+(+h[b+2120>>3]+ +h[b+2168>>3]);i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=+h[b+2208>>3]+(+h[b+2112>>3]+ +h[b+2160>>3]);i=i;return}function Hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1096>>3]=g;h[e+1088>>3]=j;i=b;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1080>>3]=g;h[e+1072>>3]=j;i=b;return}function Jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1064>>3]=g;h[e+1056>>3]=j;i=b;return}function Kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1048>>3]=g;h[e+1040>>3]=j;i=b;return}function Lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1032>>3]=g;h[e+1024>>3]=j;i=b;return}function Mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1016>>3]=g;h[e+1008>>3]=j;i=b;return}function Ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1e3>>3]=g;h[e+992>>3]=j;i=b;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=+h[b+1088>>3]+(+h[b+992>>3]+ +h[b+1040>>3]);i=i;return}function Pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=-+h[b+1568>>3]- +h[b+2432>>3];i=i;return}function Qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+1096>>3]+(+h[b+1e3>>3]+ +h[b+1048>>3]);i=i;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=-+h[b+1576>>3]- +h[b+2440>>3];i=i;return}function Sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+984>>3]=g;h[e+976>>3]=j;i=b;return}function Tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1072>>3]+(+h[b+976>>3]+ +h[b+1024>>3]);i=i;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=-+h[b+1552>>3]- +h[b+2416>>3];i=i;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1080>>3]+(+h[b+984>>3]+ +h[b+1032>>3]);i=i;return}function Wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=-+h[b+1560>>3]- +h[b+2424>>3];i=i;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+968>>3]=g;h[e+960>>3]=j;i=b;return}function Yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+1056>>3]+(+h[b+960>>3]+ +h[b+1008>>3]);i=i;return}function Zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=-+h[b+1536>>3]- +h[b+2400>>3];i=i;return}function _g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1064>>3]+(+h[b+968>>3]+ +h[b+1016>>3]);i=i;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=-+h[b+1544>>3]- +h[b+2408>>3];i=i;return}function ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1968>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1968|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1968>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1976>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1976|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1976>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2e3>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2e3|0;h[(c[j+688>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2e3>>3]);g=c[f>>2]|0;h[(c[g+692>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+684>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1984>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1984|0;h[(c[g+688>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1984>>3]);e=c[f>>2]|0;h[(c[e+692>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1992>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1992|0;h[(c[e+688>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1992>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2008>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2008|0;h[(c[j+688>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2008>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+40>>3]=k;LB(a,8)|0;g=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1968>>3]=+h[g>>3];h[f+1976>>3]=+h[g+8>>3];h[f+2e3>>3]=+h[g+16>>3];h[f+1984>>3]=+h[g+24>>3];h[f+1992>>3]=+h[g+32>>3];h[f+2008>>3]=+h[g+40>>3];uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);Hk(a);Ik(a);i=b;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+2e3>>3]+(+h[b+1968>>3]+ +h[b+1984>>3]);i=i;return}function ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+2008>>3]+(+h[b+1976>>3]+ +h[b+1992>>3]);i=i;return}function dh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+184>>3]=l;h[e+176>>3]=m;i=b;return}function eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+168>>3]=l;h[e+160>>3]=m;i=b;return}function fh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+152>>3]=l;h[e+144>>3]=m;i=b;return}function gh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+136>>3]=l;h[e+128>>3]=m;i=b;return}function hh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+120>>3]=l;h[e+112>>3]=m;i=b;return}function ih(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+104>>3]=l;h[e+96>>3]=m;i=b;return}function jh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+88>>3]=l;h[e+80>>3]=m;i=b;return}function kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=-+h[b+136>>3]- +h[b+88>>3]- +h[b+184>>3];i=i;return}function lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=-+h[b+128>>3]- +h[b+80>>3]- +h[b+176>>3];i=i;return}function mh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+72>>3]=l;h[e+64>>3]=m;i=b;return}function nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=-+h[b+112>>3]- +h[b+64>>3]- +h[b+160>>3];i=i;return}function oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=-+h[b+120>>3]- +h[b+72>>3]- +h[b+168>>3];i=i;return}function ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+56>>3]=l;h[e+48>>3]=m;i=b;return}function qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=-+h[b+96>>3]- +h[b+48>>3]- +h[b+144>>3];i=i;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-+h[b+104>>3]- +h[b+56>>3]- +h[b+152>>3];i=i;return}function sh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+336>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+336|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+336>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+368>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+368|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+368>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+344>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+344|0;h[(c[j+768>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+344>>3]);g=c[f>>2]|0;h[(c[g+772>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+764>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+360>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+360|0;h[(c[g+768>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+360>>3]);e=c[f>>2]|0;h[(c[e+772>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+352|0;h[(c[e+768>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+352>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+376>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+376|0;h[(c[j+768>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+376>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+40>>3]=k;LB(a,9)|0;g=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+336>>3]=+h[g>>3];h[f+368>>3]=+h[g+8>>3];h[f+344>>3]=+h[g+16>>3];h[f+360>>3]=+h[g+24>>3];h[f+352>>3]=+h[g+32>>3];h[f+376>>3]=+h[g+40>>3];Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);i=b;return}function th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=-+h[b+352>>3]- +h[b+336>>3]- +h[b+368>>3];i=i;return}function uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+2712>>3]- +h[b+2760>>3];i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=-+h[b+360>>3]- +h[b+344>>3]- +h[b+376>>3];i=i;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+2720>>3]- +h[b+2768>>3];i=i;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=+h[b+2608>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+2504>>3];i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b+2496>>3];i=i;return}function Ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((rB(+h[f+232>>3]*(+h[f+240>>3]- +h[f+224>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[19846]|0;g=d;j=960;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];ze[a&31](f,d,984,e);i=b;return}function Bh(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ve(b);We(b);Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);i=c;return 0}function Ch(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Dh(b);i=c;return 0}function Dh(a){a=a|0;var b=0;b=i;zh(a);yh(a);xh(a);i=b;return}function Eh(a,b){a=a|0;b=+b;i=i;return 0}function Fh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;Rx(c[a+536>>2]|0,(a|0)!=0|0,1232,b);c[a+540>>2]=1040;c[a+84>>2]=1264;c[a+88>>2]=1264;c[a+92>>2]=1336;c[a+96>>2]=1416;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=3;c[a+116>>2]=425;d=a+136|0;e=a+120|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=33;c[a+140>>2]=145;c[a+144>>2]=1;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=997;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=3;c[a+180>>2]=0;c[a+184>>2]=3;c[a+188>>2]=0;c[a+56>>2]=1456;c[a+64>>2]=11;c[a+72>>2]=0;c[a+68>>2]=715;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=10;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Gh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=r1(c[k>>2]|0,e)|0;if((l|0)==0){db(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=31192;F=31216;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[7798]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=r1(c[F>>2]|0,e)|0;if((G|0)==0){db(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[6820]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=r1(c[H>>2]|0,e)|0;if((I|0)==0){db(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(47,c[6820]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=r1(c[H>>2]|0,e)|0;if((K|0)==0){db(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;d1(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=r1(c[L>>2]|0,e)|0;if((M|0)==0){db(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;d1(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=r1(c[I>>2]|0,e)|0;if((N|0)==0){db(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(47,c[6820]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=r1(c[M>>2]|0,e)|0;if((R|0)==0){db(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=r1(c[M>>2]|0,e)|0;if((V|0)==0){db(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=r1(c[M>>2]|0,e)|0;if((W|0)==0){db(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(35,1536,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=r1(c[M>>2]|0,e)|0;if((ba|0)==0){db(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=r1(c[M>>2]|0,e)|0;if((ca|0)==0){db(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=r1(c[M>>2]|0,e)|0;if((da|0)==0){db(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=r1(c[M>>2]|0,e)|0;if((ea|0)==0){db(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=r1(c[h>>2]|0,e)|0;if((fa|0)==0){db(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=r1(c[h>>2]|0,e)|0;if((ga|0)==0){db(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(47,c[6820]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=r1(c[h>>2]|0,e)|0;if((ha|0)==0){db(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=r1(c[h>>2]|0,e)|0;if((ia|0)==0){db(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=r1(c[h>>2]|0,e)|0;if((ja|0)==0){db(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=r1(c[M>>2]|0,e)|0;if((ka|0)==0){db(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Hh(){var a=0;a=i;md(0)|0;pc(1696,18,1,c[r>>2]|0)|0;md(0)|0;i=a;return}function Ih(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;f=i;i=i+72|0;g=f;j=f+16|0;k=f+32|0;l=f+48|0;m=f+64|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=o;s=o+8|0;t=o;c[t+0>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;t=Ex(d,1)|0;if((t|0)<1){u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}if((Jh(1,t)|0)==0){u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}w=p;x=q;y=q+8|0;z=1;do{c[n>>2]=z;A=Xx(d,16,1,n)|0;c[m>>2]=z;B=Xx(e,16,1,m)|0;C=l;D=A;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];D=k;C=B;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2];Kh(p,b,l,k);C=j;D=o;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];D=g;C=w;c[D+0>>2]=c[C+0>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2];Lh(q,b,j,g);E=+h[y>>3];h[r>>3]=+h[x>>3];h[s>>3]=E;z=z+1|0;}while((Jh(z,t)|0)!=0);u=o;v=a;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];i=f;return}function Jh(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((b|0)>0){if((a|0)<1|(a|0)>(b|0)){d=4}else{e=1}}else{if((a|0)>=(b|0)&(a|0)<2){e=1}else{d=4}}if((d|0)==4){e=0}i=c;return e|0}function Kh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;e=b;f=+h[c>>3];g=+h[d>>3];j=+h[c+8>>3];k=+h[d+8>>3];Mh(e,0,f*g-j*k,g*j+f*k);k=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=k;i=b;return}function Lh(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0;b=i;i=i+16|0;e=b;Mh(e,0,+h[c>>3]+ +h[d>>3],+h[c+8>>3]+ +h[d+8>>3]);f=+h[e+8>>3];h[a>>3]=+h[e>>3];h[a+8>>3]=f;i=b;return}function Mh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Nh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;b=i;Mh(a,0,c,d);i=b;return}function Oh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=o;c[n>>2]=d;Wy(C,1,n);c[m>>2]=d;Wy(p,1,m);if((Ph(d)|0)==0){if((d|0)==2){c[l>>2]=1;h[(dz(p,1,l)|0)>>3]=0.0;c[k>>2]=2;h[(dz(p,1,k)|0)>>3]=1.570796326794897;Yy(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}else{F=+(d|0);k=~~+T(+(F*.5));Oh(q,b,k);by(r,1,1,k);l=Qh(r)|0;m=gy(r)|0;c[j>>2]=l;c[j+4>>2]=m;c[j+8>>2]=65;Zx(s,1,j);az(q,p,s);Oh(t,b,k);c[g>>2]=k;iz(u,3.141592653589793/F,1,g);hz(t,u,v);by(w,k+1|0,1,d);k=Qh(w)|0;u=gy(w)|0;c[f>>2]=k;c[f+4>>2]=u;c[f+8>>2]=65;Zx(x,1,f);az(v,p,x);Yy(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}}else{by(A,1,1,d);x=z;v=A;c[x+0>>2]=c[v+0>>2];c[x+4>>2]=c[v+4>>2];c[x+8>>2]=c[v+8>>2];Vy(B,Ex(z,1)|0);if((Qh(z)|0)>=1){F=+(d|0);d=1;while(1){G=+((c[(fy(z,1,d)|0)>>2]<<1)+ -2|0)/F*3.141592653589793;h[(cz(B,1,d)|0)>>3]=G;if((d|0)<(Qh(z)|0)){d=d+1|0}else{break}}}d=y;z=B;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];_y(y,p);Yy(p,C);D=a;E=o;c[D+0>>2]=c[E+0>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];i=e;return}}function Ph(a){a=a|0;i=i;return(a|0)%2|0|0}function Qh(a){a=a|0;var b=0,c=0;b=i;c=Ex(a,1)|0;i=b;return c|0}function Rh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c;h[a+8>>3]=d;i=i;return}function Sh(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;Ox(4,0,1720,b);Ox(4,0,1760,a);i=a;return}function Th(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}D0(a);c[d>>2]=0;i=b;return}function Uh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+248>>3]=l;h[e+240>>3]=m;i=b;return}function Vh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+216>>3]=l;h[e+208>>3]=m;i=b;return}function Wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+232>>3]=l;h[e+224>>3]=m;i=b;return}function Xh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+280>>3]=l;h[e+272>>3]=m;i=b;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+424>>3]- +h[b+232>>3]- +h[b+280>>3];i=i;return}function Zh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+264>>3]=l;h[e+256>>3]=m;i=b;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[b+400>>3]- +h[b+208>>3]- +h[b+256>>3];i=i;return}function $h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+408>>3]- +h[b+216>>3]- +h[b+264>>3];i=i;return}function ai(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+200>>3]=l;h[e+192>>3]=m;i=b;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+384>>3]- +h[b+192>>3]- +h[b+240>>3];i=i;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+392>>3]- +h[b+200>>3]- +h[b+248>>3];i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+416>>3]- +h[b+224>>3]- +h[b+272>>3];i=i;return}function ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3392>>3]=l;h[e+3384>>3]=m;i=b;return}function fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3376>>3]=l;h[e+3368>>3]=m;i=b;return}function gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3360>>3]=l;h[e+3352>>3]=m;i=b;return}function hi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5344>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5320>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5328>>3];h[a+8>>3]=+h[d+5008>>3];h[e+8>>3]=+h[d+4984>>3];h[f+8>>3]=+h[d+4992>>3];h[a+16>>3]=+h[d+4784>>3];h[e+16>>3]=+h[d+4760>>3];h[f+16>>3]=+h[d+4768>>3];h[a+24>>3]=+h[d+5120>>3];h[e+24>>3]=+h[d+5096>>3];h[f+24>>3]=+h[d+5104>>3];h[a+32>>3]=+h[d+4896>>3];h[e+32>>3]=+h[d+4872>>3];h[f+32>>3]=+h[d+4880>>3];h[a+40>>3]=+h[d+5232>>3];h[e+40>>3]=+h[d+5208>>3];h[f+40>>3]=+h[d+5216>>3];i=i;return}function ii(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+376>>3]=+h[b>>3];h[a+352>>3]=+h[b+8>>3];h[a+336>>3]=+h[b+16>>3];h[a+360>>3]=+h[b+24>>3];h[a+344>>3]=+h[b+32>>3];h[a+368>>3]=+h[b+40>>3];Uh(f);Vh(f);Wh(f);Xh(f);Yh(f);Zh(f);_h(f);$h(f);ai(f);bi(f);ci(f);di(f);ei(f);fi(f);gi(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+312>>3]- +h[f+3392>>3];h[d+8>>3]=+h[f+304>>3]- +h[f+3384>>3];h[d+16>>3]=+h[f+296>>3]- +h[f+3376>>3];h[d+24>>3]=+h[f+288>>3]- +h[f+3368>>3];h[d+32>>3]=+h[f+328>>3]- +h[f+3360>>3];h[d+40>>3]=+h[f+320>>3]- +h[f+3352>>3];i=e;return}function ji(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+600>>3]=l;h[e+592>>3]=m;i=b;return}function ki(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+616>>3]=l;h[e+608>>3]=m;i=b;return}function li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+568>>3]=l;h[e+560>>3]=m;i=b;return}function mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+520>>3]=+h[b+808>>3]- +h[b+568>>3]- +h[b+616>>3];i=i;return}function ni(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+552>>3]=l;h[e+544>>3]=m;i=b;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+784>>3]- +h[b+544>>3]- +h[b+592>>3];i=i;return}function pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+792>>3]- +h[b+552>>3]- +h[b+600>>3];i=i;return}function qi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+584>>3]=l;h[e+576>>3]=m;i=b;return}function ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+536>>3]=l;h[e+528>>3]=m;i=b;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+776>>3]- +h[b+536>>3]- +h[b+584>>3];i=i;return}function ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+768>>3]- +h[b+528>>3]- +h[b+576>>3];i=i;return}function ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+800>>3]- +h[b+560>>3]- +h[b+608>>3];i=i;return}function vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3344>>3]=l;h[e+3336>>3]=m;i=b;return}function wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3328>>3]=l;h[e+3320>>3]=m;i=b;return}function xi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3312>>3]=l;h[e+3304>>3]=m;i=b;return}function yi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6112>>3];h[a+8>>3]=+h[d+6576>>3];h[e+8>>3]=+h[d+6552>>3];h[f+8>>3]=+h[d+6560>>3];h[a+16>>3]=+h[d+6464>>3];h[e+16>>3]=+h[d+6440>>3];h[f+16>>3]=+h[d+6448>>3];h[a+24>>3]=+h[d+6688>>3];h[e+24>>3]=+h[d+6664>>3];h[f+24>>3]=+h[d+6672>>3];h[a+32>>3]=+h[d+6352>>3];h[e+32>>3]=+h[d+6328>>3];h[f+32>>3]=+h[d+6336>>3];h[a+40>>3]=+h[d+6240>>3];h[e+40>>3]=+h[d+6216>>3];h[f+40>>3]=+h[d+6224>>3];i=i;return}function zi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+432>>3]=+h[b>>3];h[a+464>>3]=+h[b+8>>3];h[a+456>>3]=+h[b+16>>3];h[a+472>>3]=+h[b+24>>3];h[a+448>>3]=+h[b+32>>3];h[a+440>>3]=+h[b+40>>3];ji(f);ki(f);li(f);mi(f);ni(f);oi(f);pi(f);qi(f);ri(f);si(f);ti(f);ui(f);vi(f);wi(f);xi(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+520>>3]- +h[f+3344>>3];h[d+8>>3]=+h[f+512>>3]- +h[f+3336>>3];h[d+16>>3]=+h[f+504>>3]- +h[f+3328>>3];h[d+24>>3]=+h[f+496>>3]- +h[f+3320>>3];h[d+32>>3]=+h[f+488>>3]- +h[f+3312>>3];h[d+40>>3]=+h[f+480>>3]- +h[f+3304>>3];i=e;return}function Ai(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1128>>3]=l;h[e+1120>>3]=m;i=b;return}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1224>>3]=l;h[e+1216>>3]=m;i=b;return}function Ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=-+h[b+1128>>3]- +h[b+840>>3]- +h[b+1224>>3];i=i;return}function Di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1168>>3]=-+h[b+1120>>3]- +h[b+832>>3]- +h[b+1216>>3];i=i;return}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1240>>3]=l;h[e+1232>>3]=m;i=b;return}



function kK(a){a=a|0;var b=0,d=0;b=i;d=c[(oK(a)|0)>>2]|0;i=b;return d|0}function lK(a){a=a|0;var b=0,d=0;b=i;d=mK(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function mK(a){a=a|0;var b=0,c=0;b=i;c=nK(a)|0;i=b;return c|0}function nK(a){a=a|0;i=i;return a|0}function oK(a){a=a|0;var b=0,c=0;b=i;c=pK(a)|0;i=b;return c|0}function pK(a){a=a|0;i=i;return a|0}function qK(a){a=a|0;i=i;return a|0}function rK(a){a=a|0;var b=0,c=0;b=i;c=DD(vK(a+4|0)|0)|0;i=b;return c|0}function sK(a){a=a|0;var b=0,c=0;b=i;c=tK(a+8|0)|0;i=b;return c|0}function tK(a){a=a|0;var b=0,c=0;b=i;c=uK(a)|0;i=b;return c|0}function uK(a){a=a|0;i=i;return a|0}function vK(a){a=a|0;var b=0,c=0;b=i;c=wK(a)|0;i=b;return c|0}function wK(a){a=a|0;i=i;return a|0}function xK(a){a=a|0;var b=0;b=i;yK(a,0);i=b;return}function yK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=mK(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}AK(zK(e)|0,f);i=d;return}function zK(a){a=a|0;var b=0,c=0;b=i;c=GK(a)|0;i=b;return c|0}function AK(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;BK(f,CK(d+20|0)|0)}if((d|0)==0){i=e;return}DK(c[b>>2]|0,d,1);i=e;return}function BK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;FK(d,0,c);i=b;return}function CK(a){a=a|0;i=i;return a|0}function DK(a,b,c){a=a|0;b=b|0;c=c|0;c=i;EK(0,b,0);i=c;return}function EK(a,b,c){a=a|0;b=b|0;c=c|0;c=i;K0(b);i=c;return}function FK(a,b,c){a=a|0;b=b|0;c=c|0;b=i;QH(c);i=b;return}function GK(a){a=a|0;i=i;return a+4|0}function HK(a,b){a=a|0;b=b|0;var c=0;c=i;IK(a,b);i=c;return}function IK(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function JK(a){a=a|0;var b=0,c=0;b=i;c=aL(a+4|0)|0;i=b;return c|0}function KK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];UK(a,b,f);i=e;return}function LK(a,b){a=a|0;b=b|0;var c=0;a=i;c=TK(0,b,0)|0;i=a;return c|0}function MK(a,b){a=a|0;b=b|0;var c=0;c=i;SK(a,b);i=c;return}function NK(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function OK(a){a=a|0;var b=0,d=0;b=i;d=c[(oK(a)|0)>>2]|0;i=b;return d|0}function PK(a){a=a|0;var b=0,c=0;b=i;c=zK(a)|0;i=b;return c|0}function QK(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}IH(b,a);i=a;return}function RK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;HK(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];fK(h,f);hK(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];fK(a,e);iK(h);i=d;return}function SK(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function TK(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=I0(b<<5)|0;i=c;return a|0}function UK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(WK(g)|0)>>2]|0;g=XK(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];VK(b,a,f);i=e;return}function VK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];YK(a,b,f);i=e;return}function WK(a){a=a|0;i=i;return a|0}function XK(a){a=a|0;i=i;return a|0}function YK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(_K(g)|0)>>2]|0;g=$K(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];ZK(b,a,f);i=e;return}function ZK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(_K(f)|0)>>2];f=$K(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function _K(a){a=a|0;i=i;return a|0}function $K(a){a=a|0;i=i;return a|0}function aL(a){a=a|0;var b=0,c=0;b=i;c=bL(a)|0;i=b;return c|0}function bL(a){a=a|0;i=i;return a|0}function cL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=lK(dL(b)|0)|0;h=$K(PK(dL(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];VK(g,a,e);i=d;return}function dL(a){a=a|0;i=i;return c[a>>2]|0}function eL(a){a=a|0;var b=0,d=0;b=i;d=c[(rK(a)|0)>>2]|0;i=b;return d|0}function fL(a,b){a=a|0;b=b|0;b=i;i=i+8|0;gL(a,b);i=b;return}function gL(a,b){a=a|0;b=b|0;b=i;hL(a,0);i=b;return}function hL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;iL(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;jL(f,0,e);e=KJ(b)|0;c[(kL(b)|0)>>2]=e;i=d;return}function iL(a){a=a|0;var b=0;b=i;nL(a);i=b;return}function jL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;lL(b,c,f);i=e;return}function kL(a){a=a|0;i=i;return a|0}function lL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uG(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;mL(d,b,f);i=e;return}function mL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uG(e)|0)>>2];i=d;return}function nL(a){a=a|0;var b=0;b=i;oL(a);i=b;return}function oL(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function pL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=RJ(h)|0;SD(e);if((a|0)==0){j=KJ(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XH(0,d,a)|0){m=l;j=c[m>>2]|0;SD(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XH(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;SD(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];lM(a,e);i=d;return}function rL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=SL(d)|0;d=UL(n,1)|0;VL(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];TL(j,d,h);WL(0,cJ((XL(j)|0)+16|0)|0,e);e=YL(j)|0;a[e+4|0]=1;ZL(0,JL((XL(j)|0)+28|0)|0);a[e+5|0]=1;_L(m,j);sL(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];qL(b,g);tL(m);tL(j);i=f;return}function sL(a,b){a=a|0;b=b|0;var c=0;c=i;QL(a,b);i=c;return}function tL(a){a=a|0;var b=0;b=i;EL(a);i=b;return}function uL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;SD(f);c[e>>2]=0;SD(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=kL(a)|0;b=c[c[e>>2]>>2]|0;SD(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(KJ(a)|0)>>2]|0;CF(e,c[d>>2]|0);d=BL(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function vL(a){a=a|0;var b=0,d=0;b=i;d=c[(zL(a)|0)>>2]|0;i=b;return d|0}function wL(a){a=a|0;var b=0,d=0;b=i;d=xL(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xL(a){a=a|0;var b=0,c=0;b=i;c=yL(a)|0;i=b;return c|0}function yL(a){a=a|0;i=i;return a|0}function zL(a){a=a|0;var b=0,c=0;b=i;c=AL(a)|0;i=b;return c|0}function AL(a){a=a|0;i=i;return a|0}function BL(a){a=a|0;var b=0,c=0;b=i;c=CL(a+8|0)|0;i=b;return c|0}function CL(a){a=a|0;var b=0,c=0;b=i;c=DL(a)|0;i=b;return c|0}function DL(a){a=a|0;i=i;return a|0}function EL(a){a=a|0;var b=0;b=i;FL(a,0);i=b;return}function FL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=xL(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}HL(GL(e)|0,f);i=d;return}function GL(a){a=a|0;var b=0,c=0;b=i;c=PL(a)|0;i=b;return c|0}function HL(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;IL(f,JL(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;KL(f,cJ(d+16|0)|0)}if((d|0)==0){i=e;return}LL(c[b>>2]|0,d,1);i=e;return}function IL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;OL(d,0,c);i=b;return}function JL(a){a=a|0;i=i;return a|0}function KL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;NL(d,0,c);i=b;return}function LL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;ML(0,b,0);i=c;return}function ML(a,b,c){a=a|0;b=b|0;c=c|0;c=i;K0(b);i=c;return}function NL(a,b,c){a=a|0;b=b|0;c=c|0;b=i;xS(c);i=b;return}function OL(a,b,c){a=a|0;b=b|0;c=c|0;b=i;xS(c);i=b;return}function PL(a){a=a|0;i=i;return a+4|0}function QL(a,b){a=a|0;b=b|0;var c=0;c=i;RL(a,b);i=c;return}function RL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function SL(a){a=a|0;var b=0,c=0;b=i;c=jM(a+4|0)|0;i=b;return c|0}function TL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];bM(a,b,f);i=e;return}function UL(a,b){a=a|0;b=b|0;var c=0;a=i;c=aM(0,b,0)|0;i=a;return c|0}function VL(a,b){a=a|0;b=b|0;var c=0;c=i;$L(a,b);i=c;return}function WL(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}nS(b,c);i=a;return}function XL(a){a=a|0;var b=0,d=0;b=i;d=c[(zL(a)|0)>>2]|0;i=b;return d|0}function YL(a){a=a|0;var b=0,c=0;b=i;c=GL(a)|0;i=b;return c|0}function ZL(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}lS(b);i=a;return}function _L(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;QL(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];qL(h,f);sL(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];qL(a,e);tL(h);i=d;return}function $L(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function aM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=I0(b*40|0)|0;i=c;return a|0}function bM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(dM(g)|0)>>2]|0;g=eM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];cM(b,a,f);i=e;return}function cM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];fM(a,b,f);i=e;return}function dM(a){a=a|0;i=i;return a|0}function eM(a){a=a|0;i=i;return a|0}function fM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(hM(g)|0)>>2]|0;g=iM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];gM(b,a,f);i=e;return}function gM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(hM(f)|0)>>2];f=iM(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function hM(a){a=a|0;i=i;return a|0}function iM(a){a=a|0;i=i;return a|0}function jM(a){a=a|0;var b=0,c=0;b=i;c=kM(a)|0;i=b;return c|0}function kM(a){a=a|0;i=i;return a|0}function lM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=wL(mM(b)|0)|0;h=iM(YL(mM(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];cM(g,a,e);i=d;return}function mM(a){a=a|0;i=i;return c[a>>2]|0}function nM(a){a=a|0;var b=0;b=i;oM(a);i=b;return}function oM(a){a=a|0;var b=0;b=i;pM(a);i=b;return}function pM(a){a=a|0;var b=0;b=i;qM(a,RJ(a)|0);i=b;return}function qM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;SD(d);if((b|0)==0){i=d;return}qM(a,c[b>>2]|0);qM(a,c[b+4>>2]|0);e=SL(a)|0;rM(e,sM(b+16|0)|0);LL(e,b,1);i=d;return}function rM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;tM(d,0,c);i=b;return}function sM(a){a=a|0;i=i;return a|0}function tM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;uM(c);i=b;return}function uM(a){a=a|0;var b=0;b=i;vM(a);i=b;return}function vM(a){a=a|0;var b=0;b=i;wM(a);i=b;return}function wM(a){a=a|0;var b=0;b=i;xM(a);i=b;return}function xM(a){a=a|0;var b=0;b=i;xS(a+12|0);xS(a);i=b;return}function yM(a){a=a|0;var b=0;b=i;zM(a+180|0);zM(a+168|0);zM(a+156|0);zM(a+144|0);zM(a+132|0);zM(a+120|0);zM(a+108|0);zM(a+96|0);zM(a+84|0);zM(a+72|0);zM(a+60|0);zM(a+48|0);zM(a+36|0);zM(a+24|0);QH(a+12|0);QH(a);i=b;return}function zM(a){a=a|0;var b=0;b=i;AM(a);i=b;return}function AM(a){a=a|0;var b=0;b=i;BM(a);i=b;return}function BM(a){a=a|0;var b=0;b=i;CM(a);i=b;return}function CM(a){a=a|0;var b=0;b=i;DM(a,eL(a)|0);i=b;return}function DM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;SD(d);if((b|0)==0){i=d;return}DM(a,c[b>>2]|0);DM(a,c[b+4>>2]|0);e=JK(a)|0;EM(e,FM(b+16|0)|0);DK(e,b,1);i=d;return}function EM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;GM(d,0,c);i=b;return}function FM(a){a=a|0;i=i;return a|0}function GM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;HM(c);i=b;return}function HM(a){a=a|0;var b=0;b=i;IM(a);i=b;return}function IM(a){a=a|0;var b=0;b=i;JM(a);i=b;return}function JM(a){a=a|0;var b=0;b=i;KM(a);i=b;return}function KM(a){a=a|0;var b=0;b=i;QH(a+4|0);i=b;return}function LM(a){a=a|0;var b=0;b=i;MM(a);i=b;return}function MM(a){a=a|0;var b=0;b=i;NM(a);i=b;return}function NM(a){a=a|0;var b=0;b=i;OM(a,BI(a)|0);i=b;return}function OM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;SD(d);if((b|0)==0){i=d;return}OM(a,c[b>>2]|0);OM(a,c[b+4>>2]|0);e=jJ(a)|0;PM(e,oI(b+16|0)|0);dJ(e,b,1);i=d;return}function PM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;QM(d,0,c);i=b;return}function QM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;RM(c);i=b;return}function RM(a){a=a|0;var b=0;b=i;SM(a);i=b;return}function SM(a){a=a|0;var b=0;b=i;TM(a);i=b;return}function TM(a){a=a|0;var b=0;b=i;UM(a);i=b;return}function UM(a){a=a|0;var b=0;b=i;xS(a);i=b;return}function VM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;WM(a);YM(g,b);ZM(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];XM(a,f,e);i=d;return a|0}function WM(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;qM(a,RJ(a)|0);c[(BL(a)|0)>>2]=0;d=KJ(a)|0;c[(kL(a)|0)>>2]=d;SD(b);c[d>>2]=0;i=b;return}function XM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;fN(h,a);if(!(gN(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];_M(j,g);o=iN(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];hN(l,a,f,o);jN(b)|0;}while(gN(b,d)|0);i=e;return}function YM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;dN(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];_M(a,e);i=d;return}function ZM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;$M(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];_M(a,e);i=d;return}function _M(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cN(a,e);i=d;return}function $M(a,b){a=a|0;b=b|0;var c=0;c=i;aN(a,SH(b)|0);i=c;return}function aN(a,b){a=a|0;b=b|0;var c=0;c=i;bN(a,b);i=c;return}function bN(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function cN(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function dN(a,b){a=a|0;b=b|0;var d=0;d=i;aN(a,c[(eN(b)|0)>>2]|0);i=d;return}function eN(a){a=a|0;i=i;return a|0}function fN(a,b){a=a|0;b=b|0;var c=0;c=i;ZM(a,b);i=c;return}function gN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pO(a,b)|0;i=c;return d|0}function hN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];rN(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];qN(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];HJ(a,g);uM(l);i=f;return}function iN(a){a=a|0;var b=0,c=0;b=i;c=nN(a)|0;i=b;return c|0}function jN(a){a=a|0;var b=0;b=i;kN(a)|0;i=b;return a|0}function kN(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=lN(c[d>>2]|0)|0;i=b;return a|0}function lN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;SD(b);if((e|0)==0){e=a;while(1){a=GF(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=mN(c[d>>2]|0)|0;i=b;return g|0}return 0}function mN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;SD(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;SD(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function nN(a){a=a|0;var b=0,d=0;b=i;d=oN((c[a>>2]|0)+16|0)|0;i=b;return d|0}function oN(a){a=a|0;var b=0,c=0;b=i;c=pN(a)|0;i=b;return c|0}function pN(a){a=a|0;i=i;return a|0}function qN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=vN(b,h,j,e)|0;h=c[p>>2]|0;SD(l);if((h|0)!=0){q=h;JJ(a,q);i=f;return}xN(o,b,e);yN(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];wN(m,g);zN(o);o=c[j>>2]|0;uL(b,o,p,AN(m)|0);p=BN(m)|0;zN(m);q=p;JJ(a,q);i=f;return}function rN(a,b){a=a|0;b=b|0;var c=0;c=i;sN(a,b);i=c;return}function sN(a,b){a=a|0;b=b|0;var c=0;c=i;tN(a,b);i=c;return}function tN(a,b){a=a|0;b=b|0;var c=0;c=i;uN(a,b);i=c;return}function uN(a,b){a=a|0;b=b|0;var c=0;c=i;nS(a,b);nS(a+12|0,b+12|0);i=c;return}function vN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;IJ(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];dO(l,k);do{if(!(cO(b,l)|0)){k=TJ(a)|0;x=fO(b)|0;if(eO(k,e,x)|0){break}w=eO(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];jO(r,h,1,0);IJ(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];dO(t,g);do{if(!(cO(r,t)|0)){if(eO(k,e,fO(r)|0)|0){break}y=iO(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;SD(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;gO(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];dO(o,j);do{if(!(cO(n,o)|0)){j=TJ(a)|0;if(eO(j,fO(hO(n)|0)|0,e)|0){break}y=iO(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;SD(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function wN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];aO(a,e);i=d;return}function xN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=SL(d)|0;d=UL(n,1)|0;ON(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];NN(j,d,h);PN(0,sM((QN(j)|0)+16|0)|0,e);a[(RN(j)|0)+4|0]=1;SN(m,j);yN(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];wN(b,g);zN(m);zN(j);i=f;return}function yN(a,b){a=a|0;b=b|0;var c=0;c=i;LN(a,b);i=c;return}function zN(a){a=a|0;var b=0;b=i;GN(a);i=b;return}function AN(a){a=a|0;var b=0,d=0;b=i;d=c[(EN(a)|0)>>2]|0;i=b;return d|0}function BN(a){a=a|0;var b=0,d=0;b=i;d=CN(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function CN(a){a=a|0;var b=0,c=0;b=i;c=DN(a)|0;i=b;return c|0}function DN(a){a=a|0;i=i;return a|0}function EN(a){a=a|0;var b=0,c=0;b=i;c=FN(a)|0;i=b;return c|0}function FN(a){a=a|0;i=i;return a|0}function GN(a){a=a|0;var b=0;b=i;HN(a,0);i=b;return}function HN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=CN(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}JN(IN(e)|0,f);i=d;return}function IN(a){a=a|0;var b=0,c=0;b=i;c=KN(a)|0;i=b;return c|0}function JN(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;rM(f,sM(d+16|0)|0)}if((d|0)==0){i=e;return}LL(c[b>>2]|0,d,1);i=e;return}function KN(a){a=a|0;i=i;return a+4|0}function LN(a,b){a=a|0;b=b|0;var c=0;c=i;MN(a,b);i=c;return}function MN(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function NN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];WN(a,b,f);i=e;return}function ON(a,b){a=a|0;b=b|0;var c=0;c=i;VN(a,b);i=c;return}function PN(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}TN(b,c);i=a;return}function QN(a){a=a|0;var b=0,d=0;b=i;d=c[(EN(a)|0)>>2]|0;i=b;return d|0}function RN(a){a=a|0;var b=0,c=0;b=i;c=IN(a)|0;i=b;return c|0}function SN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;LN(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];wN(h,f);yN(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];wN(a,e);zN(h);i=d;return}function TN(a,b){a=a|0;b=b|0;var c=0;c=i;UN(a,b);i=c;return}function UN(a,b){a=a|0;b=b|0;var c=0;c=i;tN(a,b);i=c;return}function VN(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function WN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(dM(g)|0)>>2]|0;g=YN(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];XN(b,a,f);i=e;return}function XN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ZN(a,b,f);i=e;return}function YN(a){a=a|0;i=i;return a|0}function ZN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(hM(g)|0)>>2]|0;g=$N(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];_N(b,a,f);i=e;return}function _N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(hM(f)|0)>>2];f=$N(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function $N(a){a=a|0;i=i;return a|0}function aO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=BN(bO(b)|0)|0;h=$N(RN(bO(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];XN(g,a,e);i=d;return}function bO(a){a=a|0;i=i;return c[a>>2]|0}function cO(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function dO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];oO(a,e);i=d;return}function eO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XH(0,b,c)|0;i=a;return d|0}function fO(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function gO(a,b){a=a|0;b=b|0;var d=0;d=i;JJ(a,c[(kL(b)|0)>>2]|0);i=d;return}function hO(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=mO(c[d>>2]|0)|0;i=b;return a|0}function iO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=RJ(a)|0;SD(e);if((h|0)==0){j=KJ(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=TJ(a)|0;a=h;while(1){h=a+16|0;if(eO(j,d,h)|0){l=a;m=c[l>>2]|0;SD(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(eO(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;SD(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function jO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;kO(b,d);c[a>>2]=c[b>>2];i=e;return}function kO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;lO(b,c,e);i=d;return}function lO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{hO(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{kN(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function mO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;SD(b);if((e|0)==0){e=a;while(1){a=GF(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=nO(c[d>>2]|0)|0;i=b;return g|0}return 0}function nO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;SD(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;SD(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function oO(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function pO(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(cO(a,b)|0)^1;i=c;return d|0}function qO(a){a=a|0;var b=0;b=i;i=i+128|0;IH(a,b);IH(a+12|0,b+8|0);rO(a+24|0,b+16|0);rO(a+36|0,b+24|0);rO(a+48|0,b+32|0);rO(a+60|0,b+40|0);rO(a+72|0,b+48|0);rO(a+84|0,b+56|0);rO(a+96|0,b+64|0);rO(a+108|0,b+72|0);rO(a+120|0,b+80|0);rO(a+132|0,b+88|0);rO(a+144|0,b+96|0);rO(a+156|0,b+104|0);rO(a+168|0,b+112|0);rO(a+180|0,b+120|0);i=b;return}function rO(a,b){a=a|0;b=b|0;b=i;sO(a,0);i=b;return}function sO(a,b){a=a|0;b=b|0;b=i;i=i+8|0;tO(a,b);i=b;return}function tO(a,b){a=a|0;b=b|0;b=i;uO(a,0);i=b;return}function uO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;vO(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;wO(f,0,e);e=rK(b)|0;c[(qK(b)|0)>>2]=e;i=d;return}function vO(a){a=a|0;var b=0;b=i;zO(a);i=b;return}function wO(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;xO(b,c,f);i=e;return}function xO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uG(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;yO(d,b,f);i=e;return}function yO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uG(e)|0)>>2];i=d;return}function zO(a){a=a|0;var b=0;b=i;AO(a);i=b;return}function AO(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function BO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[87212>>2]|0;if((m|0)==0){n=0}else{o=I0(12)|0;rS(o,m);n=o}if((c[87128>>2]|0)!=0){c[7474]=1}if((n|0)==0){c[29908>>2]=1;c[29912>>2]=1;i=b;return}do{if((VS(n,77416,0)|0)==-1){nS(g,n);lS(h);o=c[7048]|0;m=(o|0)<28;while(1){p=VS(g,77424,0)|0;q=(p|0)!=-1;if(q){TS(j,g,0,p);yS(h,j)|0;xS(j);TS(k,g,p+1|0,-1);yS(g,k)|0;xS(k)}else{yS(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){rS(l,c[28608+(s<<2)>>2]|0);p=CO(h,l)|0;xS(l);if(p){c[29904+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Qx(1,1,77432,f);if(m){v=o}else{w=30456;x=c[7614]|0;Yd[x&511](1);y=US(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=77472;E=D;Sx(0,E,a)}do{p=c[29776+(v<<2)>>2]|0;c[e>>2]=c[28608+(v<<2)>>2];c[e+4>>2]=p;Qx(1,0,77456,e);v=v+1|0;}while((v|0)<28);w=30456;x=c[7614]|0;Yd[x&511](1);y=US(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=77472;E=D;Sx(0,E,a)}else if((t|0)==20){Qx(1,1,77432,d);w=30456;x=c[7614]|0;Yd[x&511](1);y=US(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=77472;E=D;Sx(0,E,a)}else if((t|0)==23){xS(h);xS(g);break}}else{o=1;do{c[29904+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[29908>>2]=1;c[29912>>2]=1;if((c[29940>>2]|0)!=0){c[3e4>>2]=1}if((c[29996>>2]|0)==1){c[30004>>2]=1}if((c[29976>>2]|0)!=0){c[29972>>2]=1}if((c[29984>>2]|0)!=0){c[29972>>2]=1}if((c[29936>>2]|0)!=0){c[29932>>2]=1}if((c[29980>>2]|0)!=0){c[29972>>2]=1}if((c[29928>>2]|0)!=0){c[29924>>2]=1}xS(n);K0(n);i=b;return}function CO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=vS(b)|0;if((e|0)!=(vS(c)|0)){f=0;i=d;return f|0}g=wS(b)|0;h=wS(c)|0;if(oS(b)|0){f=(ZH(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function DO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[87220>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=I0(12)|0;l=k;rS(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(EO(l,c[62512+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=US(l)|0;Qx(1,1,77504,g);g=c[62596>>2]|0;c[f>>2]=c[62516>>2];c[f+4>>2]=g;Qx(1,0,77456,f);f=c[62600>>2]|0;c[e>>2]=c[62520>>2];c[e+4>>2]=f;Qx(1,0,77456,e);e=c[62604>>2]|0;c[d>>2]=c[62524>>2];c[d+4>>2]=e;Qx(1,0,77456,d);Yd[c[7614]&511](1);Sx(0,77560,a)}else if((n|0)==6){i=b;return j|0}return 0}function EO(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(XS(a,b)|0)==0;i=c;return d|0}function FO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[87204>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=I0(12)|0;l=k;rS(l,h);if((k|0)==0){j=1;i=b;return j|0}rS(f,77584);k=CO(l,f)|0;xS(f);if(k){j=1;i=b;return j|0}rS(g,77592);k=CO(l,g)|0;xS(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=US(l)|0;Qx(1,1,77600,e);c[d>>2]=77584;c[d+4>>2]=77656;Qx(1,0,77456,d);c[a>>2]=77592;c[a+4>>2]=77672;Qx(1,0,77456,a);Yd[c[7614]&511](1);Sx(0,77560,b)}return 0}function GO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;GU(f,a);if(!(JU(f)|0)){HU(f);i=d;return a|0}j=fI(b)|0;TO(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((WD(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=rT(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];WO(h,e,b,m,k,l,n);if(!(UO(h)|0)){HU(f);i=d;return a|0}lT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);HU(f);i=d;return a|0}function HO(a){a=a|0;var b=0;b=i;MU(a,sT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;tU(a)|0;i=b;return a|0}function IO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;rS(h,d);gT(k,77680,h);sH(j,k,77688);xS(k);k=US(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((a1(c[n+4>>2]|0,77696)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((a1(k,77704)|0)==0){xS(j);xS(h);i=f;return}d=K$(g,k,1)|0;if((d|0)!=0){m=l;i1(m|0,0,2048)|0;X$(d,g,m,2048)|0;KU(GO(GO(GO(GO(GO(99608,77712)|0,k)|0,77752)|0,m)|0,77768)|0,103)|0;xS(j);xS(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(Y$(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(Y$(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(Y$(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(Y$(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==0){q=(Y$(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(Y$(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){d=b+8|0;k=l;l=0;while(1){s=c[d>>2]|0;if((a[s+(l*48|0)+44|0]|0)==0){m=(Y$(g,c[s+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(l*48|0)+44|0]=m;t=c[o>>2]|0}else{t=k}m=l+1|0;if((m|0)<(t|0)){k=t;l=m}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;d=b+24|0;m=0;do{s=c[t>>2]|0;do{if((a[s+(m*52|0)+48|0]|0)==0){p=a[s+(m*52|0)+8|0]|0;if(p<<24>>24==0){n=(Y$(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==1){p=(Y$(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(m*52|0)+48|0]|0)!=0|o){break}a[(c[d>>2]|0)+((c[p+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[l>>2]|0))}l=b+124|0;m=c[l>>2]|0;if((m|0)>0){d=b+12|0;o=m;m=0;while(1){t=c[d>>2]|0;if((a[t+(m*52|0)+48|0]|0)==0){k=(Y$(g,c[t+(m*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(m*52|0)+48|0]=k;u=c[l>>2]|0}else{u=o}k=m+1|0;if((k|0)<(u|0)){o=u;m=k}else{break}}}m=b+220|0;if((c[m>>2]|0)>0){u=b+44|0;o=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{d=c[u>>2]|0;do{if((a[d+(b*52|0)+48|0]|0)==0){k=a[d+(b*52|0)+8|0]|0;if(k<<24>>24==1){t=(Y$(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==0){k=(Y$(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[m>>2]|0))}O$(g);xS(j);xS(h);i=f;return}function JO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[87068>>2]|0;H=c[87196>>2]|0;I=c[2]|0;if((c[30004>>2]|0)==0){if(!((c[87016>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Ab(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;Ox(23,0,77816,l);l=c[87140>>2]|0;do{if((l|0)==0){M=0}else{if((a1(l,77840)|0)==0){M=1;break}if((a1(l,77848)|0)==0){M=0;break}if((a1(l,77856)|0)==0){M=2;break}c[j>>2]=l;Qx(1,0,77864,j);M=0}}while(0);if((zz(M)|0)!=0){c[g>>2]=l;Qx(1,0,77936,g)}if((c[2]|0)!=0){RP(d+56|0);Ez((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Az(0);Az(6);Bz(3);Bz(4);Bz(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+Y0(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Ox(1,0,78024,f)}do{if((c[87124>>2]|0)!=0){f=I0(12)|0;J=f;rS(J,c[87252>>2]|0);if((f|0)==0){break}f=US(J)|0;c[d+280>>2]=f;c[e>>2]=f;Ox(23,0,78080,e)}}while(0);e=c[87248>>2]|0;lS(m);if((e|0)==0){rS(p,c[d+88>>2]|0);rS(q,78128);KO(o,p,q);sH(n,o,c[d+284>>2]|0);yS(m,n)|0;xS(n);xS(o);xS(q);xS(p)}else{zS(m,e)|0}rS(r,78136);rS(s,78136);rS(t,78136);rS(u,78136);rS(v,78136);rS(w,78136);e=c[87016>>2]|0;if((c[87036>>2]|0)!=0){zS(r,c[87164>>2]|0)|0}if((c[87052>>2]|0)!=0){zS(s,c[87180>>2]|0)|0}if((c[87032>>2]|0)!=0){zS(t,c[87160>>2]|0)|0}if((c[87040>>2]|0)==0){O=0.0}else{zS(u,c[87168>>2]|0)|0;O=+Y0(US(u)|0)}if((c[87044>>2]|0)==0){P=1}else{zS(v,c[87172>>2]|0)|0;P=Dc(US(v)|0)|0}if((c[87104>>2]|0)!=0){zS(w,c[87232>>2]|0)|0}nS(x,m);nS(y,r);nS(z,s);nS(A,t);nS(B,w);p=LO(d,x,y,z,A,O,P,B,e)|0;xS(B);xS(A);xS(z);xS(y);xS(x);if((p|0)!=0|g^1){Q=p}else{Az(5);p=gP(d)|0;Dz(5);Ox(1,0,78144,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;xS(w);xS(v);xS(u);xS(t);xS(s);xS(r);xS(m);i=b;return R|0}Q=d+88|0;rS(D,c[Q>>2]|0);sH(C,D,78176);xS(D);rS(F,c[Q>>2]|0);sH(E,F,78192);xS(F);Dz(0);F=c[87216>>2]|0;Q=US(C)|0;D=US(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;FP(d,Q,D,(F|0)!=0?F:78208,I,p,US(m)|0)|0;xS(E);xS(C);R=0;xS(w);xS(v);xS(u);xS(t);xS(s);xS(r);xS(m);i=b;return R|0}function KO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;mS(a,d);e=vS(b)|0;f=vS(c)|0;YS(a,wS(b)|0,e,f+e|0);QS(a,wS(c)|0,f)|0;i=d;return}function LO(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((vS(j)|0)==0){u=0}else{u=US(j)|0}nS(r,b);b=(MO(a,r,k)|0)==0;xS(r);if(!b){v=-1;i=l;return v|0}rS(s,78136);b=a+280|0;r=EO(s,c[b>>2]|0)|0;xS(s);do{if(r){w=3}else{s=1;k=0;do{rS(t,c[78352+(s<<2)>>2]|0);j=EO(t,c[b>>2]|0)|0;xS(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Qx(1,0,78432,q);Qx(1,0,77432,p);s=1;do{j=c[78464+(s<<2)>>2]|0;c[o>>2]=c[78352+(s<<2)>>2];c[o+4>>2]=j;Qx(1,0,77456,o);s=s+1|0;}while((s|0)<20);Sx(c[a+536>>2]|0,77560,n)}}while(0);c[m>>2]=c[78352+(w<<2)>>2];Ox(23,0,78544,m);m=US(d)|0;d=US(e)|0;e=jC(a,m,d,US(f)|0,g,h,w,u)|0;Zd[c[71796>>2]&127](71768,a);v=e;i=l;return v|0}function MO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[17942]=rd(US(b)|0)|0;c[71772>>2]=g;c[71776>>2]=d;d=a+284|0;do{if((c[19352]|0)==0){g=c[d>>2]|0;if((a1(78216,g)|0)==0){h=0;break}if((a1(78224,g)|0)==0){c[71784>>2]=55;c[71788>>2]=56;c[71796>>2]=57;h=0;break}if((a1(78232,g)|0)==0){c[71784>>2]=58;c[71788>>2]=59;c[71792>>2]=60;c[71796>>2]=61;h=1;break}if((a1(78240,g)|0)==0){c[71784>>2]=62;c[71788>>2]=63;c[71792>>2]=64;c[71796>>2]=65;h=1;break}if((a1(78248,g)|0)==0){c[71784>>2]=66;c[71788>>2]=67;c[71796>>2]=68;h=0;break}g=GO(99608,78256)|0;KU(GO(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);IO(a+8|0,c[a+288>>2]|0,h);Zd[c[71784>>2]&127](71768,a);a=c[17942]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;Ox(23,0,78280,f);j=0;i=e;return j|0}function NO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;Fx();do{if((ZP(a,b)|0)==0){if(($P(a,b)|0)!=0){break}do{if((c[87072>>2]|0)!=0){w=c[87200>>2]|0;if((a1(w,78664)|0)==0){Lx(1);break}if((a1(w,78672)|0)==0){Lx(0);break}else{c[p>>2]=w;Qx(1,0,78680,p);md(0)|0;td(0)}}}while(0);if((c[87028>>2]|0)==0){BO(0,0);nB(d);if((d|0)==0){KU(GO(99608,79048)|0,103)|0}c[d+300>>2]=DO(0,0)|0;c[d+292>>2]=FO(0,0)|0;pH(d+8|0,d+240|0);sB(d)|0;AB(d)|0;JB(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}KU(GO(99608,79112)|0,103)|0;x=1;i=e;return x|0}}while(0);c[19352]=c[87096>>2];x=0;i=e;return x|0}rS(u,c[87156>>2]|0);w=1;while(1){y=35320+(w<<2)|0;rS(v,c[y>>2]|0);z=CO(u,v)|0;xS(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=US(u)|0;Qx(1,0,78952,g);c[f>>2]=c[b>>2];Qx(1,0,78992,f);md(0)|0;td(0)}A=c[39344+(w<<2)>>2]|0;do{if((A|0)==1){z=c[39216+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;Ox(1,1,78752,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[39216+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;Ox(1,1,78792,n);break}else{c[m>>2]=z;Qx(1,1,78632,m);break}}}while(0);if((w|0)==19){A=c[7048]|0;if((A|0)<28){D=A}else{E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}do{A=c[29776+(D<<2)>>2]|0;c[l>>2]=c[28608+(D<<2)>>2];c[l+4>>2]=A;Ox(1,0,77456,l);D=D+1|0;}while((D|0)<28);E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}else if((w|0)==29){A=1;do{z=c[78464+(A<<2)>>2]|0;c[h>>2]=c[78352+(A<<2)>>2];c[h+4>>2]=z;Ox(1,0,77456,h);A=A+1|0;}while((A|0)<20);E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}else if((w|0)==7){A=1;do{z=c[78872+(A<<2)>>2]|0;c[k>>2]=c[78856+(A<<2)>>2];c[k+4>>2]=z;Ox(1,0,77456,k);A=A+1|0;}while((A|0)<4);E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}else if((w|0)==11){A=1;do{z=c[78920+(A<<2)>>2]|0;c[j>>2]=c[78888+(A<<2)>>2];c[j+4>>2]=z;Ox(1,0,77456,j);A=A+1|0;}while((A|0)<7);E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}else{E=30456;F=c[7614]|0;Yd[F&511](1);G=md(0)|0;td(0)}}}while(0);c[t>>2]=c[b>>2];Ox(1,1,78568,t);t=1;do{b=c[39344+(t<<2)>>2]|0;do{if((b|0)==1){G=c[37224+(t<<2)>>2]|0;c[s>>2]=c[35320+(t<<2)>>2];c[s+4>>2]=G;Ox(1,0,78584,s)}else{G=c[35320+(t<<2)>>2]|0;if((b|0)==2){F=c[37224+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;Ox(1,0,78600,r);break}else{c[q>>2]=G;Qx(1,0,78632,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Yd[c[7614]&511](1);md(0)|0;td(0);return 0}function OO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[19786]|0;sb(80728)|0;c[l>>2]=c[m+88>>2];fc(79152,l|0)|0;sb(80744)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];fc(79176,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];fc(79216,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(79248,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];fc(79280,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];fc(79312,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];fc(79344,b|0)|0;sb(80768)|0;i=a;return}function PO(a,b){a=a|0;b=+b;i=i;return}function QO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;d1(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=r1(c[g>>2]|0,f)|0;if((k|0)==0){db(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=r1(c[g>>2]|0,f)|0;if((m|0)==0){db(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[19786]=d;u=0;Ha(60,10,371)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=r1(c[k>>2]|0,f)|0;if((p|0)==0){db(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=r1(c[g>>2]|0,f)|0;if((q|0)==0){db(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=r1(c[g>>2]|0,f)|0;if((r|0)==0){db(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=r1(c[g>>2]|0,f)|0;if((s|0)==0){db(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=r1(c[g>>2]|0,f)|0;if((t|0)==0){db(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=r1(c[g>>2]|0,f)|0;if((w|0)==0){db(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(372,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=r1(c[g>>2]|0,f)|0;if((x|0)==0){db(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=r1(c[g>>2]|0,f)|0;if((y|0)==0){db(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=r1(c[k>>2]|0,f)|0;if((A|0)==0){db(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function RO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=gd(c[6820]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;pc(79416,7,1,a|0)|0;Bc(a|0,d|0,f|0)|0;Jd(10,a|0)|0;md(0)|0;db(c[g+80>>2]|0,1);break};case 2:{if((c[29916>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;pc(79416,7,1,a|0)|0;Bc(a|0,d|0,f|0)|0;Jd(10,a|0)|0;md(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;db(n|0,1);break};case 5:case 4:{i=b;return};case 3:{if((c[29972>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;pc(79416,7,1,e|0)|0;Bc(e|0,d|0,f|0)|0;Jd(10,e|0)|0;md(0)|0;i=b;return};default:{Sx(g,79424,b)}}}function SO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;pc(79400,9,1,d|0)|0;Bc(d|0,b|0,e|0)|0;Jd(10,d|0)|0;md(0)|0;i=a;return}function TO(a,b){a=a|0;b=b|0;var c=0;c=i;VO(a,b);i=c;return}function UO(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function VO(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=qT(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function WO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;SD(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=XO(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((CT(b,d,r)|0)==(r|0)){break}SD(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){sS(l,s,h);if((CT(b,wS(l)|0,s)|0)==(s|0)){xS(l);break}SD(m);c[o>>2]=0;c[a>>2]=0;xS(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((CT(b,e,l)|0)==(l|0)){break}SD(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);YO(g,0)|0;c[a>>2]=b;i=j;return}function XO(a){a=a|0;i=i;return c[a+12>>2]|0}function YO(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function ZO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;_O(g,16);$O(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){aP(a,g);bP(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){GO(LU(m,+h[b+(p<<3)>>3])|0,80784)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){LU(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){GO(m,80792)|0}}while((e|0)<(d|0));aP(a,g);bP(g);i=f;return}function _O(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;uT(e);f=a;c[f>>2]=81164;g=e;c[g>>2]=81184;e=a+4|0;BU(a,81196|0,e);c[f>>2]=81164;c[g>>2]=81184;nP(e,b|16);i=d;return}function $O(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function aP(a,b){a=a|0;b=b|0;var c=0;c=i;hP(a,b+4|0);i=c;return}function bP(a){a=a|0;var b=0;b=i;rP(a,81192);pT(a+56|0);i=b;return}function cP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[29960>>2]|0)!=0){sb(81488)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(14,0,80800,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(14,0,80872,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[29960>>2]|0)==0){i=d;return 0}Ox(14,0,80920,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(80936,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function dP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[29960>>2]|0)!=0){sb(81488)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(14,0,80800,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(14,0,80872,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[29960>>2]|0)==0){i=d;return 0}Ox(14,0,80920,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(80936,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function eP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[29960>>2]|0)!=0){sb(81488)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(14,0,80800,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(14,0,80872,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[29960>>2]|0)==0){i=d;return 0}Ox(14,0,80920,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(80936,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function fP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[29960>>2]|0)!=0){sb(81488)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ox(14,0,80800,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);$d[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ox(14,0,80872,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[29960>>2]|0)==0){i=d;return 0}Ox(14,0,80920,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];fc(80936,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}cc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function gP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=E0(fa(F,F)|0,8)|0;J=I;K=E0(fa(G,F)|0,8)|0;L=K;M=E0(fa(H,F)|0,8)|0;N=M;O=E0(fa(H,G)|0,8)|0;P=O;lS(p);lS(q);lS(r);lS(s);lS(t);lS(u);lS(v);Q=a+536|0;Rx(c[Q>>2]|0,(I|0)!=0|0,80944,o);Rx(c[Q>>2]|0,(K|0)!=0|0,80944,n);Rx(c[Q>>2]|0,(M|0)!=0|0,80944,m);Rx(c[Q>>2]|0,(O|0)!=0|0,80944,l);l=a+540|0;m=a;if(($d[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;cP(a,J)|0;Rx(n,1,80960,k)}ZO(w,J,F,F);yS(p,w)|0;xS(w);if(($d[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;dP(a,L)|0;Rx(w,1,80992,j)}ZO(x,L,F,G);yS(q,x)|0;xS(x);if(($d[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;eP(a,N)|0;Rx(x,1,81024,h)}ZO(y,N,H,F);yS(r,y)|0;xS(y);if(($d[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;fP(a,P)|0;Rx(m,1,81056,g)}ZO(z,P,H,G);yS(s,z)|0;xS(z);if((F|0)==0){zS(t,81088)|0}else{ZO(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);yS(t,A)|0;xS(A)}if((G|0)==0){zS(u,81088)|0}else{ZO(B,c[a+432>>2]|0,1,G);yS(u,B)|0;xS(B)}D0(I);D0(K);D0(M);D0(O);rS(E,c[a+84>>2]|0);gT(D,81104,E);sH(C,D,81112);yS(v,C)|0;xS(C);xS(D);xS(E);E=hc(US(v)|0,81120)|0;D=c[Q>>2]|0;c[f>>2]=US(v)|0;Rx(D,(E|0)!=0|0,81128,f);f=te[c[(c[l>>2]|0)+176>>2]&7]()|0;D=US(t)|0;Q=US(u)|0;C=US(p)|0;a=US(q)|0;O=US(r)|0;M=US(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;od(E|0,f|0,e|0)|0;if((c[30004>>2]|0)==0){R=md(E|0)|0;S=Vc(E|0)|0;xS(v);xS(u);xS(t);xS(s);xS(r);xS(q);xS(p);i=b;return 0}e=te[c[(c[l>>2]|0)+176>>2]&7]()|0;l=US(t)|0;f=US(u)|0;M=US(p)|0;O=US(q)|0;a=US(r)|0;C=US(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;Ox(25,0,e,d);R=md(E|0)|0;S=Vc(E|0)|0;xS(v);xS(u);xS(t);xS(s);xS(r);xS(q);xS(p);i=b;return 0}function hP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=KT(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}iP(a,JT(l)|0,n,e);i=d;return}if((h&8|0)==0){mS(a,g);i=d;return}else{g=b;b=ET(g)|0;iP(a,b,GT(g)|0,f);i=d;return}}function iP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;jP(a,b,c,0);i=d;return}function jP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;kP(a,b,c);i=d;return}function kP(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=lP(c,d)|0;if(g>>>0>4294967279){jS(0)}if(g>>>0<11){DS(b,g);h=CS(b)|0}else{j=KS(g)|0;k=j+1|0;j=cI(qS(b)|0,k)|0;MS(b,j);LS(b,k);BS(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;dI(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){dI(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;dI(l,f);i=e;return}function lP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=mP(b,c,e)|0;i=d;return g|0}function mP(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function nP(a,b){a=a|0;b=b|0;var c=0;c=i;DP(a,b);i=c;return}function oP(a){a=a|0;var b=0;b=i;bP(a);K0(a);i=b;return}function pP(a){a=a|0;var b=0;b=i;bP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function qP(a){a=a|0;var b=0;b=i;oP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function rP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];sP(a+4|0);i=d;return}function sP(a){a=a|0;var b=0;b=i;tP(a);i=b;return}function tP(a){a=a|0;var b=0;b=i;c[a>>2]=81344;xS(a+32|0);yT(a);i=b;return}function uP(a){a=a|0;var b=0;b=i;sP(a);K0(a);i=b;return}function vP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=KT(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}eD(a,-1,-1);i=h;return}else if((k|0)==0){eD(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=KT(l)|0;j=m-(JT(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=FT(l)|0;m=j-(ET(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(wS(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){eD(a,-1,-1);i=h;return}o=o1(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(wS(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((FT(l)|0)!=0){break}eD(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((KT(l)|0)!=0){break}eD(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=ET(l)|0;IT(l,q,q+o|0,n)}if((g&16|0)!=0){q=JT(l)|0;NT(l,q,LT(l)|0);MT(l,o)}eD(a,o,e);i=h;return}}while(0);eD(a,-1,-1);i=h;return}function wP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=sE(d)|0;ie[g&31](a,b,h,J,0,e);i=f;return}function xP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=KT(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((GT(g)|0)>>>0<j>>>0){b=ET(g)|0;IT(g,b,FT(g)|0,j)}j=FT(g)|0;if(!(j>>>0<(GT(g)|0)>>>0)){k=-1;i=d;return k|0}k=QE(a[j]|0)|0;i=d;return k|0}function yP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=KT(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=ET(h)|0;j=FT(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(ME(d,-1)|0){IT(h,g,j+ -1|0,k);l=PE(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=NE(d)|0;do{if(g){if(RE(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=ET(h)|0;IT(h,j,(FT(h)|0)+ -1|0,k);a[FT(h)|0]=b;l=d;i=e;return l|0}function zP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(ME(b,-1)|0){f=PE(b)|0;i=d;return f|0}g=a;h=FT(g)|0;j=h-(ET(g)|0)|0;h=KT(g)|0;do{if((h|0)==(LT(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=JT(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;PS(o,0);IS(o,FS(o)|0);p=wS(o)|0;NT(g,p,p+(vS(o)|0)|0);MT(g,h-l|0);c[m>>2]=(JT(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(KT(g)|0)+1;h=c[(AP(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=wS(a+32|0)|0;IT(g,q,q+j|0,h)}f=BT(g,b&255)|0;i=d;return f|0}function AP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=BP(b,c,e)|0;i=d;return g|0}function BP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=CP(0,a,b)|0;i=c;return(d?b:a)|0}function CP(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function DP(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;DT(a);c[a>>2]=81344;lS(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;lS(e);EP(a,e);xS(e);i=d;return}function EP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;yS(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=wS(e)|0;j=g+(vS(e)|0)|0;c[b>>2]=j;g=wS(e)|0;IT(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=vS(e)|0;c[b>>2]=(wS(e)|0)+h;IS(e,FS(e)|0);b=a;a=wS(e)|0;NT(b,a,a+(vS(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}MT(b,h);i=d;return}function FP(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=hc(d|0,81768)|0;J=Zc(81776,81768)|0;K=(J|0)!=0;L=Lc()|0;if(K){M=c[b+536>>2]|0;N=Nd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Rx(M,(I|0)!=0|0,81832,E);pc(81856,17,1,J|0)|0;pc(81880,10,1,J|0)|0;pc(81896,18,1,J|0)|0;GP(J,f,81920,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,81952)}else{c[G>>2]=Nd(c[L>>2]|0)|0;Qx(26,0,81784,G);G=c[b+536>>2]|0;E=Nd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Rx(G,(I|0)!=0|0,81832,F)}pc(81960,348,1,I|0)|0;if((qc(H|0)|0)<0){c[D>>2]=Nd(c[L>>2]|0)|0;Qx(26,0,82312,D);Vc(I|0)|0;$a(J|0)|0;O=1;i=j;return O|0}if((Qc(81512,250,82336,fd(H|0)|0)|0)==0){Qx(26,0,82360,C);Vc(I|0)|0;O=1;i=j;return O|0}pc(82384,13,1,I|0)|0;pc(82400,12,1,I|0)|0;HP(I,2);pc(82416,6,1,I|0)|0;IP(I,c[b+84>>2]|0);pc(82424,8,1,I|0)|0;HP(I,2);pc(82440,8,1,I|0)|0;C=b+88|0;IP(I,c[C>>2]|0);pc(82456,10,1,I|0)|0;HP(I,2);pc(82472,6,1,I|0)|0;IP(I,81512);pc(82480,8,1,I|0)|0;HP(I,2);pc(82496,8,1,I|0)|0;IP(I,c[b+280>>2]|0);pc(82512,10,1,I|0)|0;HP(I,2);pc(82528,14,1,I|0)|0;IP(I,c[b+284>>2]|0);pc(82544,16,1,I|0)|0;HP(I,2);pc(82568,16,1,I|0)|0;IP(I,l);pc(82592,18,1,I|0)|0;HP(I,2);c[B>>2]=JP(l)|0;od(I|0,82616,B|0)|0;HP(I,2);P=+vz(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(I|0,82656,A|0)|0;HP(I,2);P=+vz(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];od(I|0,82696,z|0)|0;HP(I,2);P=+vz(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];od(I|0,82728,y|0)|0;HP(I,2);P=+vz(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(I|0,82760,x|0)|0;HP(I,2);P=+vz(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(I|0,82792,w|0)|0;HP(I,2);P=+vz(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(I|0,82824,v|0)|0;HP(I,2);P=+vz(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(I|0,82864,u|0)|0;HP(I,2);P=+yz(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];od(I|0,82896,t|0)|0;HP(I,2);c[s>>2]=tz(2)|0;od(I|0,82936,s|0)|0;HP(I,2);P=+xz(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];od(I|0,82960,r|0)|0;pc(82992,13,1,I|0)|0;pc(83008,16,1,I|0)|0;HP(I,2);P=+vz(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];od(I|0,83032,q|0)|0;HP(I,2);c[p>>2]=qz(8)|0;od(I|0,83056,p|0)|0;pc(83096,17,1,I|0)|0;pc(83120,22,1,I|0)|0;KP(I,b);pc(83144,23,1,I|0)|0;pc(83168,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{LP(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{LP(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{LP(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{LP(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{LP(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{LP(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{LP(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{LP(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}pc(83184,13,1,I|0)|0;pc(83200,12,1,I|0)|0;MP(I,J,f,c[C>>2]|0,b);pc(83216,13,1,I|0)|0;pc(83232,12,1,I|0)|0;NP(I,c[b+68>>2]|0,b+56|0);pc(83248,13,1,I|0)|0;pc(83264,16,1,I|0)|0;OP(I,J,f,b);pc(83288,17,1,I|0)|0;pc(83312,14,1,I|0)|0;Vc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((e1(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(e1(K|0)|0)<<1}else{Q=0}I=C0(b+Q|0)|0;if((I|0)==0){bb(83328,83336,404,83360)}if(($a(J|0)|0)!=0){Qx(26,0,83376,o)}if(e){e=c[C>>2]|0;c[n>>2]=83408;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;gc(I|0,83424,n|0)|0;if((kd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=83504|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Qx(1,0,83536,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;Ox(1,0,83600,g);D0(I);O=0;i=j;return O|0}function GP(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=rz(F)|0;H=sz(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+xz(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}pc(81856,17,1,a|0)|0;pc(84768,12,1,a|0)|0;pc(84784,12,1,a|0)|0;pc(84800,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;od(a|0,84816,D|0)|0;pc(84856,10,1,a|0)|0;pc(84872,11,1,a|0)|0;pc(84888,11,1,a|0)|0;pc(84904,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];od(a|0,84920,C|0)|0}else{pc(84944,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;od(a|0,84544,B|0)|0;pc(84968,13,1,a|0)|0;if(E){pc(84784,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];od(a|0,84984,A|0)|0}else{pc(84944,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;od(a|0,85008,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;od(a|0,84664,y|0)|0;pc(85056,10,1,a|0)|0;pc(85072,10,1,a|0)|0;pc(85056,10,1,a|0)|0;pc(85088,11,1,a|0)|0;c[x>>2]=b;od(a|0,85104,x|0)|0;c[w>>2]=d;od(a|0,85128,w|0)|0;pc(85144,33,1,a|0)|0;pc(85184,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;od(a|0,85224,v|0)|0;pc(84904,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];od(a|0,84920,u|0)|0}else{pc(85072,10,1,a|0)|0;pc(85056,10,1,a|0)|0;pc(85088,11,1,a|0)|0;c[t>>2]=b;od(a|0,85104,t|0)|0;c[s>>2]=d;od(a|0,85128,s|0)|0;pc(85144,33,1,a|0)|0;pc(85184,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;od(a|0,85224,r|0)|0;pc(84904,10,1,a|0)|0;pc(84944,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;od(a|0,84544,q|0)|0;pc(84968,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];od(a|0,84984,p|0)|0}else{pc(84944,17,1,a|0)|0}pc(85256,32,1,a|0)|0;pc(85296,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;od(a|0,85328,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;od(a|0,84664,n|0)|0;i=m;return}function HP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Jd(32,a|0)|0;}while((d|0)!=0);i=c;return}function IP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==34){pc(84536,6,1,b|0)|0}else if((e|0)==62){pc(84520,4,1,b|0)|0}else if((e|0)==39){pc(84528,6,1,b|0)|0}else if((e|0)==60){pc(84512,4,1,b|0)|0}else{Jd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function JP(a){a=a|0;var b=0,c=0,d=0;b=i;c=hc(a|0,84504)|0;if((c|0)==0){d=-1;i=b;return d|0}Tc(c|0,0,2)|0;a=xb(c|0)|0;Vc(c|0)|0;d=a;i=b;return d|0}function KP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=C0((e1(l|0)|0)+15|0)|0;c[f>>2]=l;gc(m|0,84232,f|0)|0;HP(a,2);pc(84248,10,1,a|0)|0;IP(a,m);pc(84264,12,1,a|0)|0;HP(a,2);c[e>>2]=JP(m)|0;od(a|0,84280,e|0)|0;D0(m);HP(a,2);pc(84312,9,1,a|0)|0;HP(a,4);pc(84328,22,1,a|0)|0;HP(a,4);pc(84352,22,1,a|0)|0;HP(a,4);pc(84376,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){QP(g,m,n);o=c[l>>2]|0;HP(a,4);pc(84408,8,1,a|0)|0;IP(a,o);pc(84424,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{VP(h,m,l);g=c[n>>2]|0;HP(a,4);pc(84408,8,1,a|0)|0;IP(a,g);pc(84424,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{QP(j,m,q);b=c[t>>2]|0;HP(a,4);pc(84448,8,1,a|0)|0;IP(a,b);pc(84464,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){HP(a,2);v=84488;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{VP(k,m,s);e=c[u>>2]|0;HP(a,4);pc(84448,8,1,a|0)|0;IP(a,e);pc(84464,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));HP(a,2);v=84488;w=v;x=pc(w|0,10,1,a|0)|0;i=d;return}function LP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;HP(a,2);c[f>>2]=c[b>>2];od(a|0,84168,f|0)|0;IP(a,c[b+4>>2]|0);pc(84200,11,1,a|0)|0;IP(a,c[b+8>>2]|0);pc(83872,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];PP(a,4,e);HP(a,2);pc(84216,12,1,a|0)|0;i=d;return}function MP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{QP(p,r,v);GP(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,83984);w=v+9|0;Bz(w);HP(a,2);c[o>>2]=c[f>>2];od(a|0,83992,o|0)|0;HP(a,4);pc(82416,6,1,a|0)|0;IP(a,c[s>>2]|0);pc(82424,8,1,a|0)|0;HP(a,4);c[n>>2]=tz(w)|0;od(a|0,83768,n|0)|0;HP(a,4);x=+yz(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];od(a|0,83792,m|0)|0;HP(a,4);x=+xz(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];od(a|0,82960,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];PP(a,6,j);HP(a,2);pc(84016,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function NP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{HP(a,2);UP(l,d,x);c[j>>2]=c[q>>2];od(a|0,83840,j|0)|0;UP(m,d,x);IP(a,c[r>>2]|0);pc(83872,3,1,a|0)|0;HP(a,4);pc(83880,7,1,a|0)|0;UP(n,d,x);if((c[s>>2]|0)>0){y=0;do{HP(a,6);c[g>>2]=0;od(a|0,83888,g|0)|0;y=y+1|0;UP(n,d,x);}while((y|0)<(c[s>>2]|0))}HP(a,4);pc(83912,8,1,a|0)|0;HP(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;UP(o,d,x);z=+vz(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;UP(p,d,x);A=qz(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;od(a|0,83928,f|0)|0;HP(a,2);pc(83968,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function OP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{VP(n,o,v-u|0);GP(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,83720);q=v+9|0;Bz(q);HP(a,2);pc(83728,15,1,a|0)|0;HP(a,4);c[m>>2]=c[e>>2];od(a|0,83744,m|0)|0;HP(a,4);c[l>>2]=tz(q)|0;od(a|0,83768,l|0)|0;HP(a,4);w=+yz(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];od(a|0,83792,j|0)|0;HP(a,4);w=+xz(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];od(a|0,82960,g|0)|0;HP(a,2);pc(83816,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function PP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;HP(a,b);pc(84032,16,1,a|0)|0;IP(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?84136:84152;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;od(a|0,84056,f|0)|0;i=e;return}function QP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){RP(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}



function Sz(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[5523]=+h[b>>3];c[11024]=0;c[11032]=0;c[11026]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[5535]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[11020]=(c[I>>2]|0)+1;c[11022]=(c[I>>2]|0)+2;c[11018]=(c[I>>2]|0)+ -1;h[5523]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[11036]=$+1;$=c[11020]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[5526]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[11006]=2;if(($|0)>=2){Y=2;while(1){h[5527]=+h[y+(Y+ -2<<3)>>3];U=+h[5526];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[5527];U=+h[5527]+ +h[k>>3];h[5526]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[11006]=$+1}h[y+($+ -1<<3)>>3]=+h[5526]}h[5533]=0.0;h[5531]=0.0;Y=c[I>>2]|0;c[11006]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[5533]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[5531]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[11006]=Y+1;da=ea}h[5534]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[5533]- +h[5531];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[5508]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[5508]=ha>=ca?ha:ca;h[5526]=.6;h[5527]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[5534]){h[D>>3]=100.0}aa=c[11020]|0;ba=c[11036]|0;if((aa|0)>=(ba|0)){c[11008]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[11006]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[11006]=ba+1}ja=ia+1|0;c[11008]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[11006]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[11006]=ia+1}aa=c[11020]|0;c[11008]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[11006]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[11006]=$+1}la=ba+1|0;c[11008]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[5530]=+Pz(f,d,l,0,0);a[44288]=1;c[11010]=0;c[T>>2]=(c[T>>2]|0)+1;c[11040]=0;Ud[m&7](b,d,e,r,44160,o,p)|0;if((c[11040]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;Tz(f,b,d,e,r,A,k,44112,l,s,t,u,g,44160,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[11040]|0)<0|(c[11028]|0)!=0){X=70;break}c[11032]=0}ba=c[f>>2]|0;c[11006]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[11006]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[5526]=ca;aa=c[f>>2]|0;c[11006]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[5526];ia=ia+1|0;la=ka}c[11006]=aa+1}Uz(f,r,t,u)|0;la=c[f>>2]|0;c[11006]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[11006]=la+1}U=+Pz(f,r,l,0,0);h[5535]=U;if(U<=+h[F>>3]*100.0*+h[5530]){X=63;break a}ia=c[11010]|0;if((ia|0)>0){h[O>>3]=U/+h[5537];h[P>>3]=1.0/+(ia|0);ca=+gQ(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[5535];oa=ga}else{h[5537]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[11010]|0;c[11010]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[11040]=0;Ud[m&7](b,d,e,r,44160,o,p)|0;if((c[11040]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[11006]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[11006]=ba+1}U=+Pz(f,r,l,0,0);h[5535]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[11006]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[11006]=ia+1}}while(0);if((X|0)==70){X=0;a[44288]=0}c[H>>2]=1;if(a[44288]&1){U=+Pz(f,s,l,0,0);h[5529]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[5515]=ga;h[5522]=ga*+(ba+1|0);h[5517]=ga;c[11042]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[11006]=1;if((ba|0)>=1){aa=fa(c[11020]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[11006]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+Pz(f,r,l,0,0);h[5524]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[5532]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[11006]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[11006]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+Pz(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[5532];if((sa>=ca?sa:ca)>+h[5522]){break}ta=+h[5524];ua=Y}else{if(!(ga<=+h[5522]*.5)){break}else{ta=U;ua=ka}}c[11042]=ua+ -1;h[5517]=ta}}while(0);if(!(+h[5508]*+h[5529]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[5523];Y=c[11020]|0;ia=c[11036]|0;if((Y|0)>=(ia|0)){c[11008]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[5526]=ca;ia=c[f>>2]|0;c[11006]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[5526];ja=ja+1|0}c[11006]=ia+1}ja=aa+1|0;c[11008]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[11006]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[11006]=Y+1}if(!(a[44288]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[11028]|0)!=0){aa=(c[11032]|0)+1|0;c[11032]=aa;h[5506]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[11040]|0)>-2)){X=146;break}aa=(c[11024]|0)+1|0;c[11024]=aa;h[5506]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[11026]=(c[11026]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[11026]|0;if((aa|0)<=1){ja=c[11042]|0;c[I>>2]=ja;sa=+(ja+1|0);h[5527]=sa;h[O>>3]=+h[5517]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+gQ(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[5506]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[11042];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[11056]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[11042]|0;E=c[11018]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[11020];za=+h[k>>3]*2.0;h[5519]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[11018]|0;Ba=c[11042]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[11020]|0)>=(c[K>>2]|0)|(c[11056]|0)==1){Fa=G;break}G=c[f>>2]|0;c[11006]=1;if((G|0)>=1){E=fa(c[11022]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[11006]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+Pz(f,r,l,0,0);h[5525]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[5522];E=xa<=za;if(+h[5532]<=(E?xa:za)){Ea=c[11018]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[5522]*.5){Fa=S;break}}S=c[11020]|0;c[I>>2]=S;h[5517]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[5517]=+h[5524];Fa=Ea}h[5519]=+h[k>>3];ya=+(Fa+1|0);h[5527]=ya;h[O>>3]=+h[5517]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+gQ(O,P);h[5506]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[5519];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[5506]=xa;za=+h[k>>3]*xa;h[5519]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[5519]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[11006]=1;if((k|0)<1){break}u=fa(c[11022]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[11006]=k+1}}while(0);Ca=c[f>>2]|0;c[11006]=1;if((Ca|0)>=1){J=fa(c[11020]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[11006]=Ca+1}Ca=c[11020]|0;c[11014]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[11008]=P;s=c[f>>2]|0;c[11006]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[11006]=s+1}P=Ha+1|0;c[11014]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[11040]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[11026]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}Rz(b,b,d,e,f,I,q,y)|0;i=N;return 0}function Tz(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[11098]=0;h[5550]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[11076]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[5547]=+h[5550]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+iQ(44376,N);h[5547]=T;W=(c[11076]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[5547]=_;h[5554]=+h[S>>3];$=f+(W<<3)|0;h[5558]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[5547]+ +h[$>>3];Ud[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[5547];h[5556]=_;$=c[b>>2]|0;c[11082]=1;S=c[11098]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[5556];W=W+1|0;aa=ba}c[11082]=$+1}c[11098]=S+(c[b>>2]|0);aa=c[11076]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[5554];h[f+(W<<3)>>3]=+h[5558];R=aa+1|0;c[11076]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[11098]=0;P=c[b>>2]|0;if((c[29960>>2]|0)==0){ca=42;break}R=C0(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Ox(14,1,44472,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];Ox(14,0,44496,E);Ox(14,1,44504,D);c[11080]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];Ox(14,0,44512,C);Q=(c[11080]|0)+1|0;c[11080]=Q;}while((Q|0)<(c[b>>2]|0))}Yd[c[7614]&511](14);Ox(14,1,44568,B);c[11076]=1;if((P|0)>=1){Q=R+1|0;aa=c[11098]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[11082]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];gc(R|0,44552,A|0)|0;ea=c[11082]|0;c[11082]=ea+1;if((ea|0)>=(P|0)){break}ba=c[11098]|0;da=ea}c[z>>2]=R;Ox(14,0,44560,z);da=c[11098]|0;ba=c[11076]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[11098]=aa;W=ba+1|0;c[11076]=W;}while((ba|0)<(P|0))}Yd[c[7614]&511](14);Yd[c[7614]&511](14);D0(R);ca=42}else if((O|0)==4){P=c[q>>2]|0;W=q+4|0;aa=c[W>>2]|0;Q=c[b>>2]|0;ba=fa(aa+1+(P<<1)|0,Q)|0;c[11076]=1;if((ba|0)>=1){da=fa(Q,aa+(P<<1)+1|0)|0;P=(da|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[11076]=P?2:da+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[11110]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else if((O|0)==3){i=y;return 0}else if((O|0)==5){aa=q+4|0;ba=(c[aa>>2]|0)+(c[q>>2]|0)|0;R=ba+1|0;c[11102]=R;Q=c[b>>2]|0;c[11092]=(ba|0)<(Q|0)?R:Q;Q=c[q>>2]|0;c[11110]=R+Q;c[11096]=Q+ba;ba=(c[b>>2]|0)/(R|0)|0;c[11106]=ba+1;R=c[x>>2]|0;c[11104]=R+ -1;c[11114]=R+ba;c[s>>2]=0;h[5550]=+V(+(+h[t>>3]));ba=c[11092]|0;c[11078]=1;if((ba|0)<1){ca=75;break}R=r;Q=1;while(1){ea=c[b>>2]|0;ga=c[11102]|0;c[11084]=Q;ha=(ga|0)<0;c:do{if(ha?(Q|0)>=(ea|0):(Q|0)<=(ea|0)){ia=ga;ja=Q;ka=Q;while(1){la=(ka-ja|0)/(ia|0)|0;c[11080]=la+1;ma=ka+ -1|0;na=e+(ma<<3)|0;h[p+((c[11104]|0)+la<<3)>>3]=+h[na>>3];oa=f+(ma<<3)|0;h[p+((c[11114]|0)+la<<3)>>3]=+h[oa>>3];Y=+h[na>>3];h[N>>3]=Y;if(!(Y>=0.0)){pa=-Y}else{pa=Y}Y=+h[l>>3]*+h[oa>>3];if(!(Y>=0.0)){qa=-Y}else{qa=Y}Y=pa>=qa?pa:qa;_=+h[n+(ma<<3)>>3];if(!(_>=0.0)){ra=-_}else{ra=_}h[5547]=+h[5550]*(Y>=ra?Y:ra);h[N>>3]=+h[l>>3]*+h[oa>>3];Y=+iQ(44376,N);h[5547]=Y;oa=c[11084]|0;ma=oa+ -1|0;na=e+(ma<<3)|0;_=+h[na>>3];T=Y+_-_;h[5547]=T;h[na>>3]=+h[na>>3]+T;na=f+(ma<<3)|0;h[na>>3]=+h[j>>3]*+h[5547]+ +h[na>>3];na=oa+ga|0;c[11084]=na;if(!(ha?(na|0)>=(ea|0):(na|0)<=(ea|0))){break c}ia=c[11102]|0;ja=c[11078]|0;ka=na}}}while(0);Ud[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ea=c[b>>2]|0;ha=c[11102]|0;ga=c[11078]|0;c[11084]=ga;ka=(ha|0)<0;d:do{if(ka?(ga|0)>=(ea|0):(ga|0)<=(ea|0)){ja=ha;ia=ga;S=ga;while(1){$=(S-ia|0)/(ja|0)|0;c[11080]=$+1;na=S+ -1|0;oa=e+(na<<3)|0;h[oa>>3]=+h[p+((c[11104]|0)+$<<3)>>3];T=+h[p+((c[11114]|0)+$<<3)>>3];$=f+(na<<3)|0;h[$>>3]=T;_=+h[oa>>3];h[N>>3]=_;if(!(_>=0.0)){sa=-_}else{sa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ta=-_}else{ta=_}_=sa>=ta?sa:ta;T=+h[n+(na<<3)>>3];if(!(T>=0.0)){ua=-T}else{ua=T}h[5547]=+h[5550]*(_>=ua?_:ua);h[N>>3]=+h[l>>3]*+h[$>>3];_=+iQ(44376,N);h[5547]=_;$=c[11084]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[5547]=Y;T=1.0/Y;h[5556]=T;na=$-(c[aa>>2]|0)|0;oa=(na|0)>1?na:1;c[11086]=oa;na=c[b>>2]|0;ma=(c[q>>2]|0)+$|0;la=(na|0)<=(ma|0)?na:ma;c[11088]=la;va=fa(c[11096]|0,$)|0;wa=va-(c[q>>2]|0)|0;c[11090]=wa;c[11076]=oa;if((oa|0)<=(la|0)){va=~na;na=~ma;ma=~((va|0)>(na|0)?va:na);na=(oa|0)>(ma|0)?oa:ma;Y=T;ma=oa;while(1){oa=ma+ -1|0;h[p+(oa+wa<<3)>>3]=(+h[o+(oa<<3)>>3]- +h[g+(oa<<3)>>3])*Y;if((ma|0)>=(la|0)){break}Y=+h[5556];ma=ma+1|0}c[11076]=na+1}ma=$+ha|0;c[11084]=ma;la=c[11078]|0;if(!(ka?(ma|0)>=(ea|0):(ma|0)<=(ea|0))){xa=la;break d}ja=c[11102]|0;ia=la;S=ma}}else{xa=ga}}while(0);ga=xa+1|0;c[11078]=ga;if((xa|0)<(ba|0)){Q=ga}else{ca=75;break a}}i=y;return 0}else{Q=c[b>>2]|0;ba=fa(Q,Q)|0;c[11076]=1;if((ba|0)!=0){Q=(ba|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[11076]=Q?2:ba+1|0}_d[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[11098]=0;aa=c[b>>2]|0;if((c[29960>>2]|0)==0){ca=42;break}R=C0(aa*20|0)|0;W=M;h[k>>3]=+h[d>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];Ox(14,1,44472,M);W=L;h[k>>3]=+h[j>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];Ox(14,0,44496,L);Ox(14,1,44504,K);c[11080]=0;if((c[b>>2]|0)>0){W=0;do{Y=+h[e+(W<<3)>>3];c[J>>2]=W+1;da=J+4|0;h[k>>3]=Y;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Ox(14,0,44512,J);W=(c[11080]|0)+1|0;c[11080]=W;}while((W|0)<(c[b>>2]|0))}Yd[c[7614]&511](14);Ox(14,1,44528,I);c[11076]=1;if((aa|0)>=1){W=R+1|0;ba=c[11098]|0;Q=1;do{da=p+(Q+ -1+ba<<3)|0;h[da>>3]=+h[j>>3]+ +h[da>>3];a[R]=0;a[W]=0;c[11082]=1;da=ba;P=0;while(1){Y=+h[p+(P+da<<3)>>3];c[H>>2]=R;ga=H+4|0;h[k>>3]=Y;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];gc(R|0,44552,H|0)|0;ga=c[11082]|0;c[11082]=ga+1;if((ga|0)>=(aa|0)){break}da=c[11098]|0;P=ga}c[G>>2]=R;Ox(14,0,44560,G);P=c[11098]|0;da=c[11076]|0;ga=p+(P+ -1+da<<3)|0;h[ga>>3]=+h[ga>>3]- +h[j>>3];ba=P+(c[b>>2]|0)|0;c[11098]=ba;Q=da+1|0;c[11076]=Q;}while((da|0)<(aa|0))}Yd[c[7614]&511](14);Yd[c[7614]&511](14);D0(R);ca=42}}while(0);if((ca|0)==42){$z(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){fA(p,44440,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function Uz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[11148]=(c[h>>2]|0)+1+(c[e>>2]<<1);gA(d,44592,a,e,h,e+80|0,b,44600)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{dA(d,a,a,e+80|0,b,44600)|0;i=f;return 0}return 0}function Vz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[44608]&1)){a[44608]=1;Wz(44656,44624,44704,44640,44688,44712,44696,44720)|0;h[5581]=+(c[11164]|0);f=c[11156]|0;h[5577]=+(f|0);if((c[11176]|0)==0){h[5579]=0.0;c[e>>2]=1-f;g=+hQ(44648,e)}else{h[5579]=1.0;c[e>>2]=1-f;g=+hQ(44648,e)*.5}h[5580]=g;h[5584]=g*+h[5581];h[5583]=+(c[11172]|0);h[5585]=+(c[11174]|0);j=+h[5589];h[5592]=j;k=1.0/+h[5590];if(!(k>=j)){break}h[5592]=k*(g+1.0)}}while(0);if((mA(b,44744,1,1)|0)!=0){g=+h[5580];h[5591]=g;l=g;i=d;return+l}if((mA(b,44752,1,1)|0)!=0){g=+h[5592];h[5591]=g;l=g;i=d;return+l}if((mA(b,44760,1,1)|0)!=0){g=+h[5581];h[5591]=g;l=g;i=d;return+l}if((mA(b,44768,1,1)|0)!=0){g=+h[5584];h[5591]=g;l=g;i=d;return+l}if((mA(b,44776,1,1)|0)!=0){g=+h[5577];h[5591]=g;l=g;i=d;return+l}if((mA(b,44784,1,1)|0)!=0){g=+h[5579];h[5591]=g;l=g;i=d;return+l}if((mA(b,44792,1,1)|0)!=0){g=+h[5583];h[5591]=g;l=g;i=d;return+l}if((mA(b,44800,1,1)|0)!=0){g=+h[5589];h[5591]=g;l=g;i=d;return+l}if((mA(b,44808,1,1)|0)!=0){g=+h[5585];h[5591]=g;l=g;i=d;return+l}if((mA(b,44816,1,1)|0)==0){l=+h[5591];i=d;return+l}else{g=+h[5590];h[5591]=g;l=g;i=d;return+l}return 0.0}function Wz(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[44928]&1){q=45296;r=c[11324]|0;c[b>>2]=r;s=45232;t=c[11308]|0;c[d>>2]=t;u=45272;v=c[11318]|0;c[e>>2]=v;w=45280;x=+h[5660];h[f>>3]=x;y=45312;z=c[11328]|0;c[g>>2]=z;A=45360;B=+h[5670];h[j>>3]=B;C=45320;D=c[11330]|0;c[k>>2]=D;E=45368;F=+h[5671];h[l>>3]=F;i=m;return 0}a[44928]=1;h[5661]=0.0;h[5655]=1.0;h[5656]=2.0;Xz(45296,45232,45272,45384)|0;h[5651]=+(c[11324]|0);c[n>>2]=0-(c[11308]|0);G=+hQ(45208,n);h[5650]=G;h[5660]=G;H=+h[5656];h[5651]=H/3.0;I=+h[5655];J=I*.5;h[5658]=J;K=-J;h[o>>3]=K;h[5672]=+Yz(45208,o);L=45376;h[5669]=+Yz(L,L);h[o>>3]=K;h[5651]=+Yz(45352,o);K=+Yz(45208,45376);h[5651]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[5651]=K;h[5660]=1.0;M=+h[5661];if(K<1.0&K>M){N=K;while(1){h[5660]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+Yz(o,p);h[5652]=K;h[o>>3]=-K;h[5652]=+Yz(45264,o);K=+Yz(45264,45216);h[5651]=K;h[o>>3]=-K;h[5652]=+Yz(45264,o);K=+Yz(45264,45216);h[5651]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[5660]=G}G=I/+(c[11324]|0);h[5663]=G;h[5667]=I;c[11306]=1;p=1;O=I;do{h[o>>3]=O*G;O=+Yz(o,45288);h[5667]=O;p=p+1|0;c[11306]=p;}while((p|0)<4);h[5650]=+Yz(45240,45336);Zz(45400,45240,45296)|0;h[o>>3]=-+h[5655];Zz(45392,o,45296)|0;Zz(45344,45200,45296)|0;h[o>>3]=-+h[5650];Zz(45328,o,45296)|0;c[11314]=0;p=c[11350]|0;L=c[11348]|0;P=c[11336]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[11332]|0)){if(Q){c[11328]=p;R=0;S=25;break}if((P-p|0)==3){c[11328]=p+ -1+(c[11308]|0);c[11314]=1;R=1;S=25;break}else{c[11328]=(p|0)<=(P|0)?p:P;a[44936]=1;S=26;break}}else{T=Q&(L|0)==(c[11332]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[11328]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[11328]=(p|0)<=(L|0)?p:L;a[44936]=1;S=26;break}}T=c[11332]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[11328]=(V|0)<=(T|0)?V:T;a[44936]=1;S=26;break}if((P-U|0)==3){c[11328]=((p|0)>=(L|0)?p:L)+ -1+(c[11308]|0);R=0;S=25;break}else{c[11328]=U;a[44936]=1;S=26;break}}}while(0);if((S|0)==25){if(a[44936]&1){S=26}else{W=R}}if((S|0)==26){a[44928]=0;fR(45408)|0;wQ(45432,45312,4)|0;PQ()|0;W=c[11314]|0}if((W|0)==0){X=(c[11346]|0)!=0|0}else{X=1}c[11314]=X;h[5670]=1.0;X=c[11328]|0;W=1-X|0;c[n>>2]=W;c[11306]=1;if((X|0)<=0){O=+h[5663];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+Yz(o,45288);h[5670]=I;n=X+1|0;c[11306]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}_z(45296,45232,45312,45256,45320,45368)|0;q=45296;r=c[11324]|0;c[b>>2]=r;s=45232;t=c[11308]|0;c[d>>2]=t;u=45272;v=c[11318]|0;c[e>>2]=v;w=45280;x=+h[5660];h[f>>3]=x;y=45312;z=c[11328]|0;c[g>>2]=z;A=45360;B=+h[5670];h[j>>3]=B;C=45320;D=c[11330]|0;c[k>>2]=D;E=45368;F=+h[5671];h[l>>3]=F;i=m;return 0}function Xz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[44824]&1){l=a[44896]&1;m=c[11226]|0;c[b>>2]=m;n=44872;o=c[11218]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=44920;r=c[11230]|0;c[f>>2]=r;i=g;return 0}a[44824]=1;h[5610]=1.0;h[5604]=1.0;h[5606]=1.0;s=1.0;do{s=s*2.0;h[5604]=s;h[5606]=+Yz(44832,44880);h[j>>3]=-s;t=+Yz(44848,j);h[5606]=t;}while(t==1.0);h[5605]=1.0;t=+Yz(44832,44840);h[5606]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[5605]=v;w=+Yz(44832,44840);h[5606]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[5611]=.25;h[5614]=x;h[j>>3]=-s;t=+Yz(44848,j);h[5606]=t;y=~~(t+.25);c[11226]=y;t=+(y|0);h[5605]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[5607]=+Yz(j,k);w=+Yz(44856,44832);h[5606]=w;z=w==s;a[44896]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[5607]=+Yz(j,k);w=+Yz(44856,44832);h[5606]=w;if(z&w==s){a[44896]=0;A=0}else{A=z}h[j>>3]=u;w=+Yz(j,44832);h[5608]=w;h[j>>3]=u;z=w==s&+Yz(j,44912)>x;c[11230]=z?A&1:0;c[11218]=0;h[5604]=1.0;h[5606]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[11218]=k;s=x*t;h[5604]=s;h[5606]=+Yz(44832,44880);h[j>>3]=-s;w=+Yz(44848,j);h[5606]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=44872;o=c[11218]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=44920;r=c[11230]|0;c[f>>2]=r;i=g;return 0}function Yz(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function Zz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[5680]=g;j=1.0/+(c[d>>2]|0);h[5689]=j;h[5688]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+Yz(f,45504);h[5682]=k;h[5684]=g;h[5685]=g;h[5686]=g;h[5687]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[5680]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+Yz(f,45504);h[5682]=g;h[f>>3]=g*k;k=+Yz(f,45504);h[5684]=k;h[5686]=0.0;c[11362]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[5686]=q;c[11362]=b+1;n=q}h[f>>3]=m*j;p=+Yz(f,45504);h[5683]=p;h[f>>3]=p/j;r=+Yz(f,45504);h[5685]=r;h[5687]=0.0;o=c[d>>2]|0;c[11362]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[5687]=v;c[11362]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function _z(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[11386]=1;c[11394]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[11386]=q;r=l+1|0;c[11394]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[11390]=n;u=n}else{c[11390]=m;c[11394]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[11396]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[11394]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[5696]=x;y=w+-1.0;h[5692]=y;h[5691]=0.0;v=c[b>>2]|0;c[11380]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[5692]=B;if(w<1.0){h[5694]=w}C=+Yz(45528,45536);h[5691]=C;e=b+1|0;c[11380]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[5694];h[5691]=A;z=A}}while(0);v=c[f>>2]|0;c[11380]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+Yz(k,45592);h[5691]=z;f=E+1|0;c[11380]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function $z(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[11402]=1;m=1;do{c[11408]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=aA(j,a+(m+b+(fa(m,l)|0)<<3)|0,45640)|0;q=c[11402]|0;r=p+ -1+q|0;c[11404]=r;c[e+(q+ -1<<2)>>2]=r;r=c[11404]|0;q=c[11402]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[5703]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[5703];t=q}u=fa(t,l)|0;h[5703]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;bA(j,45624,a+(t-l+u<<3)|0,45640)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[11408]|0;c[11400]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[11404]|0;x=fa(w,l)|0;h[5703]=+h[a+(x+b+v<<3)>>3];y=c[11402]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[5703];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=45640;cA(k,45624,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[11400]|0;w=A+1|0;c[11400]=w;}while((A|0)<(u|0))}}while(0);q=c[11402]|0;m=q+1|0;c[11402]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function aA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[11500]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[5751]=k;l=(c[d>>2]|0)+1|0;c[11500]=l;m=c[a>>2]|0;c[11498]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[5751]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[11500]=l;a=n+1|0;c[11498]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[5751]=v;c[11498]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[5751]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[11498]=f+1;g=C;i=e;return g|0}function bA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[11484]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[11484]=l;i=f;return 0}l=(g|0)%5|0;c[11486]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[11484]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[11484]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[11484]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[11484]=o;i=f;return 0}function cA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[11470]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[11468]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[11468]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[11468]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[11468]=s;i=j;return 0}}while(0);c[11472]=1;c[11474]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[11472]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[11474]=s;u=s}else{u=1}s=c[a>>2]|0;c[11468]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[11472]=t;u=x+(c[g>>2]|0)|0;c[11474]=u;a=w+1|0;c[11468]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function dA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[11420]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[11412]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[11414]=o;p=f+(o+ -1<<3)|0;h[5708]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[5708]}c[k>>2]=(c[d>>2]|0)-m;o=45640;cA(k,45664,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[11412]|0;m=o+1|0;c[11412]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[11418]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[11412]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[5708]=-s;c[k>>2]=g;g=45640;cA(k,45664,a+(p-l<<3)|0,g,f,g)|0;g=c[11418]|0;q=g+1|0;c[11418]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[11412]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=45640;s=+eA(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[5708]=s;q=c[11412]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[11412]=n;}while((q|0)<(m|0));t=c[11420]|0}if((t|0)<1){i=j;return 0}c[11418]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[11412]=n;c[k>>2]=(c[d>>2]|0)-n;b=45640;s=+eA(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[11412]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[11414]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[5708]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[5708]}q=c[11418]|0;m=q+1|0;c[11418]=m;}while((q|0)<(t|0));i=j;return 0}function eA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[5748]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[11490]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[11488]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[5748]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[11488]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[11488]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[5748]=t;u=u+5|0;}while((u|0)<=(m|0));c[11488]=u;k=t;i=g;return+k}}while(0);c[11492]=1;c[11494]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[11492]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[11494]=u;y=u}else{y=1}u=c[a>>2]|0;c[11488]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[5748]=t;x=C+(c[d>>2]|0)|0;c[11492]=x;y=B+(c[f>>2]|0)|0;c[11494]=y;a=z+1|0;c[11488]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function fA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[11430]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[11436]=n;o=c[d>>2]|0;p=c[11430]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[11438]=o;do{if((q|0)>(n|0)){c[11446]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[11434]=s;t=c[e>>2]|0;c[11422]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[11422]=t+1}u=r+1|0;c[11446]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[11446]=o;c[11444]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[11426]=1;t=o;o=1;while(1){c[11448]=o+1;p=t+1|0;c[11446]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[11422]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[11422]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[11440]=s;c[l>>2]=s+1;s=aA(l,a+((c[11430]|0)+b+(fa(o,m)|0)<<3)|0,45640)|0;p=s+ -1|0;c[11428]=p+(c[11430]|0);s=c[11426]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[11428]|0;p=c[11426]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[11430]|0;if((s|0)==(u|0)){y=s}else{h[5716]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[5716];y=u}h[5716]=-1.0/+h[a+(y+b+n<<3)>>3];bA(45760,45728,a+(y-m+n<<3)|0,45640)|0;u=c[11444]|0;z=(c[g+((c[11426]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[11444]=u;A=c[11430]|0;c[11442]=A;z=c[11448]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[11424]=z;B=z;z=A;while(1){A=(c[11428]|0)+ -1|0;c[11428]=A;C=z+ -1|0;c[11442]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[5716]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[5716];F=C}C=45640;cA(45760,45728,a+((c[11430]|0)-m+(fa(c[11426]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[11424]|0;D=C+1|0;c[11424]=D;if((C|0)>=(u|0)){break a}B=D;z=c[11442]|0}}}while(0);n=c[11426]|0;s=n+1|0;c[11426]=s;if((n|0)>=(r|0)){break}t=c[11446]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[11430]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function gA(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[11454]=n;f=c[d>>2]|0;o=f+ -1|0;c[11466]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[11450]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[11464]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[11452]=k;q=j+(k+ -1<<3)|0;h[5728]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[5728]}k=45640;cA(45856,45824,a+((c[11454]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[11450]|0;f=k+1|0;c[11450]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[11458]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[11450]=k;q=c[11454]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[11464]=s;u=q-s|0;c[11460]=u;q=k-s|0;c[11462]=q;h[5728]=-t;s=45640;cA(45856,45824,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[11458]|0;r=s+1|0;c[11458]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[11450]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[11464]=r;s=o-r|0;c[11460]=s;q=n-r|0;c[11462]=q;r=45640;t=+eA(45856,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[5728]=t;r=c[11450]|0;q=j+(r+ -1<<3)|0;o=c[11454]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[11450]=n;}while((r|0)<(f|0));v=o;w=c[11466]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[11458]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[11450]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[11464]=(n|0)<=(b|0)?n:b;b=45640;t=+eA(45856,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[11450]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[11452]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[5728]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[5728]}n=c[11458]|0;b=n+1|0;c[11458]=b;if((n|0)>=(w|0)){break}o=c[11454]|0;v=b}i=l;return 0}function hA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[11478]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[11476]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[11476]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[11476]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[11476]=o;i=g;return 0}}while(0);c[11480]=1;c[11482]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[11480]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[11482]=o;q=o}else{q=1}o=c[a>>2]|0;c[11476]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[11480]=p;q=s+(c[f>>2]|0)|0;c[11482]=q;a=r+1|0;c[11476]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function iA(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+jA(46016);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+kA(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+kA(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+kA(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+kA(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function jA(a){a=a|0;i=i;return+(+h[46024+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function kA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function lA(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+jA(46056);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;xe[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+kA(b,e);c[E>>2]=2;xe[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){tA(b,b,f,g,46064,N,46056,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+kA(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=x1(ga|0,0,Z+ -2|0,0)|0;Z=q1(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}sA(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}xe[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);iA(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+kA(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;xe[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+kA(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+kA(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+kA(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}vA(b,b,s,t,v,w,x,D)|0;uA(b,b,f,g,w,x)|0;W=46056;uA(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;xe[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}xe[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function mA(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[46088]=1;f=d[b]|0;c[11518]=f;b=d[e]|0;c[11520]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[11518]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[11520]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function nA(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[55620>>2]=6;fR(55616)|0;wQ(56360,j,4)|0;PQ()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[13206]=0;c[13812]=0;c[13800]=0;a[55224]=0;t=c[e>>2]|0;c[12760]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[13206]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[12760]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[12760]=1;if((v|0)>=1){x=1;while(1){h[47512+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[12760]=v+1}c[13804]=2;x=c[e>>2]|0;c[12760]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[12762]=1;if((E|0)<1){F=C}else{G=1;while(1){h[47512+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[12762]=E+1;F=+h[B>>3]}h[47512+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[13804]=G;D=G}G=z+1|0;c[12760]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[13206]|0;y=z+1|0;c[13202]=y;c[12760]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[12762]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[47512+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[12762]=x+1}ce[u&63](e,b,50872+(z+ -1<<3)|0)|0;c[13812]=(c[13812]|0)+1;if((c[j>>2]|0)>=1){c[55644>>2]=6;fR(55640)|0;wQ(56360,55248,4)|0;wQ(56360,50872+((c[12760]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[12762]=1;if((v|0)>=1){A=1;do{wQ(56360,b+(A+ -1<<3)|0,8)|0;B=c[12762]|0;A=B+1|0;c[12762]=A;}while((B|0)<(v|0))}PQ()|0}v=c[12760]|0;z=v+1|0;c[12760]=z;}while((v|0)<(y|0))}y=c[13800]|0;b:while(1){c[13800]=y+1;c[13712]=1;c[13708]=1;C=+h[6359];h[6855]=C;h[6857]=C;z=c[13202]|0;c[12760]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[50872+(A+ -1<<3)>>3];do{if(!(C<=K)){c[13712]=A;L=+h[50872+(A+ -1<<3)>>3];h[6855]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[13708]=A;L=+h[50872+(A+ -1<<3)>>3];h[6857]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[12760]=z+1;H=O}A=c[e>>2]|0;c[12760]=1;if((A|0)>=1){v=1;while(1){h[52992+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[12760]=A+1}c[12760]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[12762]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=52992+(Q+ -1<<3)|0;h[B>>3]=+h[47512+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[12762]=x+1;P=v}}while(0);v=P+1|0;c[12760]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[12762]=1;if((z|0)>=1){K=+(c[13206]|0);v=1;while(1){A=52992+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[12762]=z+1}v=c[e>>2]|0;c[12760]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[52992+(B<<3)>>3];h[55272+(B<<3)>>3]=K+(K- +h[47512+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[12760]=v+1}ce[u&63](e,55272,55264)|0;A=(c[13812]|0)+1|0;c[13812]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[55668>>2]=6;fR(55664)|0;wQ(56360,55248,4)|0;wQ(56360,55264,8)|0;B=c[e>>2]|0;c[12762]=1;if((B|0)>=1){E=1;do{wQ(56360,55272+(E+ -1<<3)|0,8)|0;G=c[12762]|0;E=G+1|0;c[12762]=E;}while((G|0)<(B|0))}PQ()|0}}while(0);K=+h[6908];c:do{if(!(K>=+h[6857])){z=c[e>>2]|0;c[12760]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[52992+(v<<3)>>3];h[55440+(v<<3)>>3]=I+(+h[55272+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[12760]=z+1}ce[u&63](e,55440,55432)|0;A=(c[13812]|0)+1|0;c[13812]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[55692>>2]=6;fR(55688)|0;wQ(56360,55248,4)|0;wQ(56360,55432,8)|0;B=c[e>>2]|0;c[12762]=1;if((B|0)>=1){E=1;do{wQ(56360,55440+(E+ -1<<3)|0,8)|0;G=c[12762]|0;E=G+1|0;c[12762]=E;}while((G|0)<(B|0))}PQ()|0}}while(0);I=+h[6929];if(I>=+h[6857]){R=118;break}v=c[e>>2]|0;c[12760]=1;A=c[13712]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[47512+((z*21|0)+ -22+A<<3)>>3]=+h[55440+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[12760]=v+1}h[50872+(A+ -1<<3)>>3]=I}else{z=c[13202]|0;c[12760]=1;if((z|0)>=1){B=c[13712]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[50872+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[12760]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[6855])){E=c[e>>2]|0;c[12760]=1;z=c[13712]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[47512+((B*21|0)+ -22+z<<3)>>3]=+h[55272+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[12760]=E+1}h[6855]=K;h[50872+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[12760]=1;if((B|0)>=1){A=c[13712]|0;v=1;while(1){x=v+ -1|0;h[55440+(x<<3)>>3]=+h[47512+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[52992+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[12760]=B+1}ce[u&63](e,55440,55432)|0;v=(c[13812]|0)+1|0;c[13812]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[55716>>2]=6;fR(55712)|0;wQ(56360,55248,4)|0;wQ(56360,55432,8)|0;z=c[e>>2]|0;c[12762]=1;if((z|0)>=1){E=1;do{wQ(56360,55440+(E+ -1<<3)|0,8)|0;x=c[12762]|0;E=x+1|0;c[12762]=E;}while((x|0)<(z|0))}PQ()|0}}while(0);I=+h[6929];if(!(I>+h[6855])){A=c[e>>2]|0;c[12760]=1;v=c[13712]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[47512+((B*21|0)+ -22+v<<3)>>3]=+h[55440+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[12760]=A+1}h[50872+(v+ -1<<3)>>3]=I;break}B=c[13202]|0;c[12760]=1;if((B|0)<1){break}else{S=1}do{z=c[13708]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[12762]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=47512+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[47512+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[47512+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[12762]=E+1}ce[u&63](e,b,50872+(S+ -1<<3)|0)|0;G=(c[13812]|0)+1|0;c[13812]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[55740>>2]=6;fR(55736)|0;wQ(56360,55248,4)|0;wQ(56360,50872+((c[12760]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[12762]=1;if((x|0)>=1){G=1;do{wQ(56360,b+(G+ -1<<3)|0,8)|0;T=c[12762]|0;G=T+1|0;c[12762]=G;}while((T|0)<(x|0))}PQ()|0}}while(0);z=c[12760]|0;S=z+1|0;c[12760]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[12760]=1;v=c[13712]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[47512+((A*21|0)+ -22+v<<3)>>3]=+h[55272+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[12760]=B+1}h[50872+(v+ -1<<3)>>3]=+h[6908]}A=c[13800]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[6858]=0.0;h[6904]=0.0;A=c[13202]|0;c[12760]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[6904]=0.0/K;c[12760]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[50872+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[6904]=I;c[12760]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[50872+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[6858]=$;c[12760]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[6858]=I;do{if(!(I<=+h[k>>3])){if((c[13812]|0)>(c[g>>2]|0)){break}a[55224]=0;c[13800]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[12760]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[12762]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[47512+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[12762]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[12760]=v+1}ce[u&63](e,b,f)|0;B=(c[13812]|0)+1|0;c[13812]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[55764>>2]=6;fR(55760)|0;wQ(56360,55248,4)|0;wQ(56360,s,8)|0;z=c[e>>2]|0;c[12762]=1;if((z|0)>=1){E=1;do{wQ(56360,b+(E+ -1<<3)|0,8)|0;x=c[12762]|0;E=x+1|0;c[12762]=E;}while((x|0)<(z|0))}PQ()|0;ba=c[13812]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[55884>>2]=6;fR(55880)|0;PQ()|0;c[55908>>2]=6;fR(55904)|0;B=c[e>>2]|0;c[12760]=1;if((B|0)>=1){A=1;do{wQ(56360,b+(A+ -1<<3)|0,8)|0;v=c[12760]|0;A=v+1|0;c[12760]=A;}while((v|0)<(B|0))}PQ()|0;c[55932>>2]=6;fR(55928)|0;wQ(56360,s,8)|0;PQ()|0}if(a[55224]&1){I=+h[6904];K=+h[6950]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[55224]=1;da=+h[6904]}h[6950]=da;c[13800]=0;y=0}if((c[j>>2]|0)>=0){c[55956>>2]=6;fR(55952)|0;wQ(56360,55248,4)|0;PQ()|0;c[55980>>2]=6;fR(55976)|0;y=c[e>>2]|0;c[12760]=1;if((y|0)>=1){B=1;do{wQ(56360,b+(B+ -1<<3)|0,8)|0;A=c[12760]|0;B=A+1|0;c[12760]=B;}while((A|0)<(y|0))}PQ()|0;c[56004>>2]=6;fR(56e3)|0;wQ(56360,s,8)|0;PQ()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[56028>>2]=6;fR(56024)|0;PQ()|0}h[6857]=+h[f>>3];c[13814]=0;y=c[13202]|0;c[12760]=1;if((y|0)>=1){B=1;while(1){A=50872+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[12760]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[12762]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=47512+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[55440+(E+ -1<<3)>>3]=+h[47512+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[12762]=v+1}ce[u&63](e,55440,A)|0;c[13814]=(c[13814]|0)+1;c[13812]=(c[13812]|0)+1;E=c[12760]|0;I=+h[50872+(E+ -1<<3)>>3];if(I>=+h[6857]){B=E;continue}h[6857]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[56052>>2]=6;fR(56048)|0;wQ(56360,55248,4)|0;wQ(56360,54856,8)|0;E=c[e>>2]|0;c[12762]=1;if((E|0)>=1){z=1;do{wQ(56360,55440+(z+ -1<<3)|0,8)|0;G=c[12762]|0;z=G+1|0;c[12762]=z;}while((G|0)<(E|0))}PQ()|0;B=c[12760]|0}}B=c[13206]|0;c[12760]=1;do{if((B|0)<1){h[6384]=+h[6359];c[12760]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[12770]=E;z=c[e>>2]|0;c[12762]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[55272+(A+ -1<<3)>>3]=(+h[47512+(v+ -21<<3)>>3]+ +h[47512+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[12762]=z+1}ce[u&63](e,55272,52832+(y+ -1<<3)|0)|0;c[13814]=(c[13814]|0)+1;c[13812]=(c[13812]|0)+1;A=c[12760]|0;y=A+1|0;c[12760]=y;}while((A|0)<(B|0));y=c[13206]|0;I=+h[6359];h[6384]=I;c[12760]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[12770]=A;c[12772]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[12762]=1;E=1;while(1){v=E+1|0;c[12774]=v;G=c[e>>2]|0;c[12764]=1;if((G|0)>=1){x=c[12772]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[55440+(T+ -1<<3)>>3]=(+h[47512+(U+x<<3)>>3]+ +h[47512+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[12764]=G+1}ce[u&63](e,55440,55432)|0;c[13814]=(c[13814]|0)+1;c[13812]=(c[13812]|0)+1;T=c[12760]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[12762]|0;la=U+x|0;c[12766]=la;I=+h[6384];h[53152+(la+ -1<<3)>>3]=(+h[6929]+I- +h[52832+(v<<3)>>3]- +h[52832+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[12762]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[12760]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[13206]|0;c[12766]=0;c[12760]=1;E=(y|0)<1;if(E){c[12760]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=x1(A|0,0,y+ -2|0,0)|0;A=q1(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[53152+(U+ -1<<3)>>3]=(+h[50872+(v<<3)>>3]+ka- +h[52832+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[12770]=v+1;c[12766]=(z|1)+A;c[12760]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=52832+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[50872+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[12770]=T+1;c[12760]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[12766]=0;c[12760]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[12760]=1;if((B|0)>=1){A=1;while(1){h[54872+(A+ -1<<3)>>3]=+h[47512+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[12760]=B+1}c[12760]=1;do{if(ma){c[12760]=1}else{A=1;while(1){z=A+1|0;c[12770]=z;v=c[e>>2]|0;c[12762]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=47512+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[47512+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[12762]=v+1}c[12760]=z;if((A|0)<(na|0)){A=z}else{break}}c[12760]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[12770]=A;y=c[e>>2]|0;c[12762]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[47512+(T+oa<<3)>>3]=+h[47512+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[12762]=y+1}c[12760]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=53152;oA(B,52824,B,55032,55608,q,55192)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[56076>>2]=6;fR(56072)|0;PQ()|0}c[q>>2]=2;if((c[13812]|0)>(c[g>>2]|0)){R=312;break}c[56100>>2]=6;fR(56096)|0;PQ()|0;B=c[e>>2]|0;c[12760]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[12760]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[55788>>2]=6;fR(55784)|0;wQ(56360,g,4)|0;PQ()|0;c[55812>>2]=6;fR(55808)|0;wQ(56360,54864,8)|0;PQ()|0;c[55836>>2]=6;fR(55832)|0;u=c[e>>2]|0;c[12760]=1;if((u|0)>=1){E=1;do{wQ(56360,b+(E+ -1<<3)|0,8)|0;z=c[12760]|0;E=z+1|0;c[12760]=E;}while((z|0)<(u|0))}PQ()|0;c[55860>>2]=6;fR(55856)|0;wQ(56360,s,8)|0;PQ()|0;i=r;return 0}else if((R|0)==226){u=c[13206]|0;c[13810]=u-(c[13902]|0);c[12760]=1;E=(u|0)<1;do{if(E){h[6901]=0.0;c[12760]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[50872+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=50872+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[53152+(sa+ -1<<3)>>3]*+h[52832+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[12766]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[12762]=z;h[6901]=0.0;c[12760]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[50872+(v<<3)>>3]*+h[52832+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[6901]=wa;c[12760]=u+1;qa=wa}}while(0);h[6901]=+h[6384]-qa;s=c[e>>2]|0;c[12760]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[55440+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=55440+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[50872+(T+ -1<<3)>>3]*+h[47512+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[12760]=s+1;c[12762]=xa}v=c[e>>2]|0;c[12760]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=54872+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[55440+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[12760]=v+1}if((c[j>>2]|0)>=0){c[56124>>2]=6;fR(56120)|0;wQ(56360,55208,8)|0;z=c[e>>2]|0;c[12760]=1;if((z|0)>=1){s=1;do{wQ(56360,54872+(s+ -1<<3)|0,8)|0;u=c[12760]|0;s=u+1|0;c[12760]=s;}while((u|0)<(z|0))}PQ()|0;c[56148>>2]=6;fR(56144)|0;PQ()|0}z=c[e>>2]|0;c[12760]=1;if((z|0)>=1){s=c[13206]|0;v=1;while(1){c[12762]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[50872+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=50872+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[53152+(Aa+ -1<<3)>>3]*+h[47512+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[12766]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[12764]=E;c[12762]=s+1}T=c[e>>2]|0;c[12762]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=51128+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[50872+(Ea+ -1<<3)>>3]*+h[47512+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[12762]=T+1;c[12766]=Ca;c[12764]=Da}za=v+1|0;c[12760]=za;if((v|0)<(z|0)){v=za}else{break}}}c[12762]=0;v=c[e>>2]|0;c[12760]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[51128+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[12762]=Ga;c[12760]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[56172>>2]=6;fR(56168)|0;wQ(56360,55240,4)|0;PQ()|0;c[13204]=1;z=1;d:while(1){c[12766]=z;do{if((z|0)>(c[e>>2]|0)){s=c[13204]|0;if((s|0)==1){c[56196>>2]=6;fR(56192)|0;PQ()|0;oA(51128,52824,53152,55032,55608,q,55192)|0;c[56220>>2]=6;fR(56216)|0;PQ()|0;c[13204]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[13204]=2;c[12776]=0;c[12778]=0;s=c[e>>2]|0;c[12760]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=x1(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=q1(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=51128+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=51128+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[51128+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[12780]=Na;c[12778]=Ta;c[12776]=Ia;c[12762]=Ma;c[12760]=s+1}c[56244>>2]=6;fR(56240)|0;PQ()|0;c[12776]=0;u=c[e>>2]|0;c[12760]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=51128+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[12776]=Wa;c[12760]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[12776]=T;s=c[e>>2]|0;c[12760]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[12770]=B;Qa=za+la|0;c[12776]=Qa;Pa=B+5|0;c[12772]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[13204]|0)==3){c[56316>>2]=6;fR(56312)|0;Pa=c[12772]|0;Qa=c[12770]|0;c[12762]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{wQ(56360,53152+(B+ -1<<3)|0,8)|0;Qa=c[12762]|0;B=Qa+1|0;c[12762]=B;}while((Qa|0)<(Pa|0))}PQ()|0}else{c[56292>>2]=6;fR(56288)|0;Pa=c[12772]|0;B=c[12770]|0;c[12762]=B;if((B|0)<=(Pa|0)){x=B;do{wQ(56360,51128+(x+ -1<<3)|0,8)|0;B=c[12762]|0;x=B+1|0;c[12762]=x;}while((B|0)<(Pa|0))}PQ()|0}Pa=c[12760]|0;x=Pa+1|0;c[12760]=x;if((Pa|0)>=(s|0)){break e}E=c[12766]|0;la=c[12776]|0;za=x}}}while(0);c[56340>>2]=6;fR(56336)|0;PQ()|0;z=(c[12766]|0)+6|0}c[56268>>2]=6;fR(56264)|0;wQ(56360,55256,4)|0;PQ()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ce[p&63](e,b,f)|0;i=r;return 0}function oA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[14110]=c[b>>2];c[g>>2]=1;if((c[14110]|0)<1){i=k;return 0}c[g>>2]=0;pA(a,56440,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[14110]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[14102]=f;c[14108]=g;c[14114]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=x1(a|0,0,g+ -2|0,0)|0;m=q1(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[14094]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=x1(p|0,0,a-n|0,0)|0;p=q1(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[14094]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[14092]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[14092]=j}c[14104]=g;c[14106]=f;c[14112]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[7050]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[7050]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[7050]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[14112]=D;E=v+ -1|0;c[14104]=E;F=w+ -1|0;c[14106]=F;q=D;v=E;w=F}c[14096]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[14098]=t;c[14108]=0;c[14114]=l-g;i=k;return 0}function pA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[7064]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[7064]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[7064];c[14118]=1;c[14120]=0;n=c[b>>2]|0;c[14132]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[14122]=0;c[14134]=1;do{if((o|0)>=1){p=1;q=c[14120]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[7063]=m;u=(p|0)==(o|0);if(u){l=m*+h[7064];h[7065]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[7063]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[7065]=+h[7065]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[14122]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[14122]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[7063];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[14134]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[14116]=y;c[14124]=x;c[14120]=s;break}else if((D|0)==26){D=0;c[14116]=y;c[14124]=x;c[14120]=s;break}}}while(0);m=+V(+(+h[7065]));h[7065]=m;H=+h[7063];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[14120]|0)+ -1<<3)>>3]=G;G=+h[7065]/+h[7063];h[j+((c[14116]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[14120]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[14118]|0;O=c[14132]|0}}while(0);b=N+O|0;c[14118]=b;o=O+1|0;c[14132]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[14116]=y;c[14124]=x;c[14120]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function qA(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[14158]=n;o=(c[d>>2]|0)-n|0;c[14180]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[14178]=s;a[56656]=1;t=c[b>>2]|0;u=t+1|0;c[14174]=u;v=c[b>>2]|0;w=u+v|0;c[14172]=w;u=w+(c[b>>2]|0)|0;c[14176]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[14166]=w;x=w+(c[d>>2]|0)|0;c[14160]=x;y=x+(c[b>>2]|0)|0;c[14162]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[14168]=z;A=z+(c[d>>2]|0)|0;c[14182]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[14184]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[14156]=C;D=C+(c[b>>2]|0)|0;c[14170]=D;rA(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,56712,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);fR(56744)|0;PQ()|0;i=m;return 0}



function fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1816>>3]=l;h[e+1808>>3]=m;i=b;return}function gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-+h[b+1768>>3]- +h[b+1720>>3]- +h[b+1816>>3];i=i;return}function hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=-+h[b+1760>>3]- +h[b+1712>>3]- +h[b+1808>>3];i=i;return}function jn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+432|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+432>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+464>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+464|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+464>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+456>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+456|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+456>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+472>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+472|0;h[(c[g+128>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+472>>3]);e=c[f>>2]|0;h[(c[e+132>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+448>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+448|0;h[(c[e+128>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+448>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+440>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+440|0;h[(c[j+128>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+440>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+40>>3]=k;LB(a,1)|0;g=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+432>>3]=+h[g>>3];h[f+464>>3]=+h[g+8>>3];h[f+456>>3]=+h[g+16>>3];h[f+472>>3]=+h[g+24>>3];h[f+448>>3]=+h[g+32>>3];h[f+440>>3]=+h[g+40>>3];ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);i=b;return}function kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+712>>3]=l;h[e+704>>3]=m;i=b;return}function ln(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+696>>3]=l;h[e+688>>3]=m;i=b;return}function mn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+268>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+456>>3],+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+680>>3]=l;h[e+672>>3]=m;i=b;return}function nn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+664>>3]=l;h[e+656>>3]=m;i=b;return}function on(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+648>>3]=l;h[e+640>>3]=m;i=b;return}function pn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+280>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+440>>3],+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+632>>3]=l;h[e+624>>3]=m;i=b;return}function qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+760>>3]=l;h[e+752>>3]=m;i=b;return}function rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+752>>3]+(+h[b+656>>3]+ +h[b+704>>3]);i=i;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+760>>3]+(+h[b+664>>3]+ +h[b+712>>3]);i=i;return}function tn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=l;h[e+736>>3]=m;i=b;return}function un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+736>>3]+(+h[b+640>>3]+ +h[b+688>>3]);i=i;return}function vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+744>>3]+(+h[b+648>>3]+ +h[b+696>>3]);i=i;return}function wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+256>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+472>>3],+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+728>>3]=l;h[e+720>>3]=m;i=b;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+728>>3]+(+h[b+632>>3]+ +h[b+680>>3]);i=i;return}function yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+720>>3]+(+h[b+624>>3]+ +h[b+672>>3]);i=i;return}function zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+920>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+920|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+920>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+944>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+944|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+944>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+952>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+952|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+952>>3]);g=c[f>>2]|0;h[(c[g+212>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+204>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+912>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+912|0;h[(c[g+208>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+912>>3]);e=c[f>>2]|0;h[(c[e+212>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+888>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+888|0;h[(c[e+208>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+888>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+880>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+880|0;h[(c[j+208>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+880>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+40>>3]=k;LB(a,2)|0;g=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+920>>3]=+h[g>>3];h[f+944>>3]=+h[g+8>>3];h[f+952>>3]=+h[g+16>>3];h[f+912>>3]=+h[g+24>>3];h[f+888>>3]=+h[g+32>>3];h[f+880>>3]=+h[g+40>>3];Ai(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);i=b;return}function An(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1480>>3]=l;h[e+1472>>3]=m;i=b;return}function Bn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1464>>3]=l;h[e+1456>>3]=m;i=b;return}function Cn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+124>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+920>>3],+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1448>>3]=l;h[e+1440>>3]=m;i=b;return}function Dn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1528>>3]=l;h[e+1520>>3]=m;i=b;return}function En(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1512>>3]=l;h[e+1504>>3]=m;i=b;return}function Fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+112>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+952>>3],+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=l;h[e+1488>>3]=m;i=b;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+2624>>3]*+h[b+952>>3]- +h[b+2616>>3]*+h[b+944>>3];i=i;return}function Hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+2616>>3]*+h[b+952>>3]+ +h[b+2624>>3]*+h[b+944>>3];i=i;return}function In(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1432>>3]=l;h[e+1424>>3]=m;i=b;return}function Jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[b+1520>>3]+(+h[b+1424>>3]+ +h[b+1472>>3]);i=i;return}function Kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=-+h[b+1664>>3]- +h[b+1616>>3];i=i;return}function Ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1672>>3]=+h[b+1528>>3]+(+h[b+1432>>3]+ +h[b+1480>>3]);i=i;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2488>>3]=-+h[b+1672>>3]- +h[b+1624>>3];i=i;return}function Nn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1416>>3]=l;h[e+1408>>3]=m;i=b;return}function On(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1656>>3]=+h[b+1512>>3]+(+h[b+1416>>3]+ +h[b+1464>>3]);i=i;return}function Pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=-+h[b+1656>>3]- +h[b+1608>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1648>>3]=+h[b+1504>>3]+(+h[b+1408>>3]+ +h[b+1456>>3]);i=i;return}function Rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-+h[b+1648>>3]- +h[b+1600>>3];i=i;return}function Sn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+136>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+888>>3],+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1400>>3]=l;h[e+1392>>3]=m;i=b;return}function Tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+1496>>3]+(+h[b+1400>>3]+ +h[b+1448>>3]);i=i;return}function Un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2456>>3]=-+h[b+1640>>3]- +h[b+1592>>3];i=i;return}function Vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=+h[b+1488>>3]+(+h[b+1392>>3]+ +h[b+1440>>3]);i=i;return}function Wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2448>>3]=-+h[b+1632>>3]- +h[b+1584>>3];i=i;return}function Xn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2080>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2080|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2080>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2088>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2088|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2088>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2064>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2064|0;h[(c[j+288>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2064>>3]);g=c[f>>2]|0;h[(c[g+292>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+284>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2072>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2072|0;h[(c[g+288>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2072>>3]);e=c[f>>2]|0;h[(c[e+292>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2096>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2096|0;h[(c[e+288>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2096>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2104>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2104|0;h[(c[j+288>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2104>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+40>>3]=k;LB(a,3)|0;g=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2080>>3]=+h[g>>3];h[f+2088>>3]=+h[g+8>>3];h[f+2064>>3]=+h[g+16>>3];h[f+2072>>3]=+h[g+24>>3];h[f+2096>>3]=+h[g+32>>3];h[f+2104>>3]=+h[g+40>>3];Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);i=b;return}function Yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2200>>3]=l;h[e+2192>>3]=m;i=b;return}function Zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2184>>3]=l;h[e+2176>>3]=m;i=b;return}function _n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+52>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2088>>3],-+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2168>>3]=l;h[e+2160>>3]=m;i=b;return}function $n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2152>>3]=l;h[e+2144>>3]=m;i=b;return}function ao(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2136>>3]=l;h[e+2128>>3]=m;i=b;return}function bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+64>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2072>>3],-+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2120>>3]=l;h[e+2112>>3]=m;i=b;return}function co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2248>>3]=l;h[e+2240>>3]=m;i=b;return}function eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+2248>>3]+(+h[b+2152>>3]+ +h[b+2200>>3]);i=i;return}function fo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=-+h[b+1576>>3]- +h[b+2440>>3];i=i;return}function go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2432>>3]=+h[b+2240>>3]+(+h[b+2144>>3]+ +h[b+2192>>3]);i=i;return}function ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=-+h[b+1568>>3]- +h[b+2432>>3];i=i;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=l;h[e+2224>>3]=m;i=b;return}function jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+2232>>3]+(+h[b+2136>>3]+ +h[b+2184>>3]);i=i;return}function ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=-+h[b+1560>>3]- +h[b+2424>>3];i=i;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=+h[b+2224>>3]+(+h[b+2128>>3]+ +h[b+2176>>3]);i=i;return}function mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=-+h[b+1552>>3]- +h[b+2416>>3];i=i;return}function no(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+40>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2104>>3],-+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2216>>3]=l;h[e+2208>>3]=m;i=b;return}function oo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2408>>3]=+h[b+2216>>3]+(+h[b+2120>>3]+ +h[b+2168>>3]);i=i;return}function po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=-+h[b+1544>>3]- +h[b+2408>>3];i=i;return}function qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=+h[b+2208>>3]+(+h[b+2112>>3]+ +h[b+2160>>3]);i=i;return}function ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2016>>3]=-+h[b+1536>>3]- +h[b+2400>>3];i=i;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+2640>>3]*+h[b+920>>3]- +h[b+2632>>3]*+h[b+912>>3];i=i;return}function to(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+2632>>3]*+h[b+920>>3]+ +h[b+2640>>3]*+h[b+912>>3];i=i;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+2656>>3]*+h[b+888>>3]- +h[b+2648>>3]*+h[b+880>>3];i=i;return}function vo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+2648>>3]*+h[b+888>>3]+ +h[b+2656>>3]*+h[b+880>>3];i=i;return}function wo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;c[o>>2]=3;Wx(p,16,1,o);o=a+536|0;y=a+416|0;z=c[y>>2]|0;Mh(q,c[o>>2]|0,+h[z+120>>3],+h[z+128>>3]);z=q;q=c[y>>2]|0;Mh(r,c[o>>2]|0,+h[q+136>>3],+h[q+144>>3]);q=r;r=c[y>>2]|0;Mh(s,c[o>>2]|0,+h[r+152>>3],+h[r+160>>3]);r=s;c[n>>2]=1;s=Xx(p,16,1,n)|0;c[s+0>>2]=c[z+0>>2];c[s+4>>2]=c[z+4>>2];c[s+8>>2]=c[z+8>>2];c[s+12>>2]=c[z+12>>2];c[m>>2]=2;z=Xx(p,16,1,m)|0;c[z+0>>2]=c[q+0>>2];c[z+4>>2]=c[q+4>>2];c[z+8>>2]=c[q+8>>2];c[z+12>>2]=c[q+12>>2];c[l>>2]=3;q=Xx(p,16,1,l)|0;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[k>>2]=3;Wx(t,16,1,k);k=a+4|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(u,c[o>>2]|0,+h[a+936>>3],+h[a+928>>3]);a=u;u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(v,c[o>>2]|0,+h[u+904>>3],+h[u+896>>3]);u=v;v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Mh(w,c[o>>2]|0,+h[v+872>>3],+h[v+864>>3]);v=w;c[j>>2]=1;w=Xx(t,16,1,j)|0;c[w+0>>2]=c[a+0>>2];c[w+4>>2]=c[a+4>>2];c[w+8>>2]=c[a+8>>2];c[w+12>>2]=c[a+12>>2];c[g>>2]=2;a=Xx(t,16,1,g)|0;c[a+0>>2]=c[u+0>>2];c[a+4>>2]=c[u+4>>2];c[a+8>>2]=c[u+8>>2];c[a+12>>2]=c[u+12>>2];c[f>>2]=3;u=Xx(t,16,1,f)|0;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];v=c[o>>2]|0;o=e;u=p;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];u=d;o=t;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];Ih(x,v,e,d);A=+h[x+8>>3];d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[d+3200>>3]=+h[x>>3];h[d+3192>>3]=A;i=b;return}function xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=+h[b+3200>>3];i=i;return}function yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2728>>3]=+h[b+3192>>3];i=i;return}function zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1984>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1984|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1984>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2008>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2008|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2008>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1992>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1992|0;h[(c[j+368>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1992>>3]);g=c[f>>2]|0;h[(c[g+372>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+364>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1968>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1968|0;h[(c[g+368>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1968>>3]);e=c[f>>2]|0;h[(c[e+372>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1976>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1976|0;h[(c[e+368>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1976>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2e3>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2e3|0;h[(c[j+368>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2e3>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+40>>3]=k;LB(a,4)|0;g=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1984>>3]=+h[g>>3];h[f+2008>>3]=+h[g+8>>3];h[f+1992>>3]=+h[g+16>>3];h[f+1968>>3]=+h[g+24>>3];h[f+1976>>3]=+h[g+32>>3];h[f+2e3>>3]=+h[g+40>>3];gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);i=b;return}function Ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2768>>3]=+h[b+2008>>3]+(+h[b+1976>>3]+ +h[b+1992>>3]);i=i;return}function Bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2752>>3]=+h[b+2720>>3]- +h[b+2768>>3];i=i;return}function Co(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2760>>3]=+h[b+2e3>>3]+(+h[b+1968>>3]+ +h[b+1984>>3]);i=i;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=+h[b+2712>>3]- +h[b+2760>>3];i=i;return}function Eo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function Fo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function Go(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=0.0;i=i;return}function Ho(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=0.0;i=i;return}function Io(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=0.0;i=i;return}function Jo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function Ko(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function Lo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function Mo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=0.0;i=i;return}function No(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=0.0;i=i;return}function Oo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function Po(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function Qo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function Ro(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=0.0;i=i;return}function So(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function To(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function Uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function Vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function Wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=0.0;i=i;return}function Xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function Yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function Zo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=0.0;i=i;return}function _o(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function $o(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function ap(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function bp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=0.0;i=i;return}function cp(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=0.0;i=i;return}function dp(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);a[d]=0;i=c;return 0}function ep(a){a=a|0;i=i;return}function fp(a){a=a|0;i=i;return 0}function gp(a){a=a|0;var b=0,d=0,e=0;a=i;i=i+8|0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;Ox(9,1,2304,e);if((c[29940>>2]|0)!=0){Yd[c[7614]&511](9)}Ox(9,1,2328,d);if((c[29940>>2]|0)!=0){Yd[c[7614]&511](9)}Ox(9,1,2352,b);if((c[29940>>2]|0)!=0){Yd[c[7614]&511](9)}Ox(9,1,2376,a);if((c[29940>>2]|0)==0){i=a;return 0}Yd[c[7614]&511](9);i=a;return 0}function hp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function ip(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function jp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=0.0;i=i;return}function kp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function lp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function mp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=0.0;i=i;return}function np(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function op(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function pp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function qp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function rp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=0.0;i=i;return}function sp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function tp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function up(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function vp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=0.0;i=i;return}function wp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=0.0;i=i;return}function xp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function yp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function zp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function Ap(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=0.0;i=i;return}function Bp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=0.0;i=i;return}function Cp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=0.0;i=i;return}function Dp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function Ep(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+176>>3];j=+h[f+184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Ux(c[b+536>>2]|0,g,2408,2400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+192>>3]=l*.275664447710896;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+176>>3]*+h[f+184>>3]*10.88279618540531;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+200|0;o=n;h[o>>3]=l;i=d;return}p=+Ux(c[b+536>>2]|0,g,2424,2416,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+200|0;o=n;h[o>>3]=l;i=d;return}function Hp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+176>>3];i=i;return}function Ip(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+168>>3];i=i;return}function Jp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b+168>>3];i=i;return}function Kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+168>>3];i=i;return}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,0);h[(c[a+416>>2]|0)+24>>3]=f;i=b;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,1);h[(c[a+416>>2]|0)+32>>3]=f;i=b;return}function Np(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,2);h[(c[a+416>>2]|0)+40>>3]=f;i=b;return}function Op(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+208>>3];i=i;return}function Pp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=+h[(c[a+416>>2]|0)+48>>3]*6.283185307179586;i=i;return}function Qp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b>>3];i=i;return}function Rp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+24>>3];i=i;return}function Sp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+64>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=d*+h[b+56>>3];i=i;return}function Tp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+64>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=d*+h[b+56>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+208>>3];i=i;return}function Vp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=+h[(c[a+416>>2]|0)+72>>3]*6.283185307179586;i=i;return}function Wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+8>>3];i=i;return}function Xp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+32>>3];i=i;return}function Yp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=d*+h[b+80>>3];i=i;return}function Zp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=d*+h[b+80>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+208>>3];i=i;return}function $p(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=+h[(c[a+416>>2]|0)+96>>3]*6.283185307179586;i=i;return}function aq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+16>>3];i=i;return}function bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+40>>3];i=i;return}function cq(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=d*+h[b+104>>3];i=i;return}function dq(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=d*+h[b+104>>3];i=i;return}function eq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+216>>3]=+h[b+184>>3];i=i;return}function fq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+224>>3];i=i;return}function gq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=+h[b+216>>3]*(+h[b+232>>3]*(+h[b+240>>3]- +h[b+224>>3])+1.0);i=i;return}function hq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2648>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ux(c[b+536>>2]|0,j,2464,2456,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2656>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ux(c[b+536>>2]|0,j,2464,2488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}function jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+2648>>3]*+h[b+2792>>3]+ +h[b+2656>>3]*+h[b+2784>>3];i=i;return}function kq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+200>>3];i=i;return}function lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=-(+h[b+2608>>3]*+h[(c[a+416>>2]|0)+248>>3]*+h[b+2640>>3]);i=i;return}function mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+2608>>3]*+h[(c[a+416>>2]|0)+248>>3]*+h[b+2632>>3];i=i;return}function nq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+192>>3];i=i;return}function oq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+256>>3]*+h[g+2608>>3];k=+h[g+2616>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ux(c[b+536>>2]|0,j,2504,2496,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}function pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+256>>3]*+h[g+2608>>3];k=-j;l=+h[g+2624>>3];m=-l;if(j!=-0.0){n=g;o=m/k;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=g;o=m;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}l=m/+Ux(c[b+536>>2]|0,k,2568,2560,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}function qq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[2624]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+572>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+572>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(2640,Fy(c[(c[g>>2]|0)+572>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[2624]=1;i=d;return}function rq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[2848]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+568>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(2856,Fy(c[(c[g>>2]|0)+568>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[2848]=1;i=d;return}function sq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[2944]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+560>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+560>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(2952,Fy(c[(c[g>>2]|0)+560>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[2944]=1;i=d;return}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3064]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(3072,Fy(c[(c[g>>2]|0)+556>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3064]=1;i=d;return}function uq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3160]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+548>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(3168,Fy(c[(c[g>>2]|0)+548>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3160]=1;i=d;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3280]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+544>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(3288,Fy(c[(c[g>>2]|0)+544>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3280]=1;i=d;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3376]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(3384,Fy(c[(c[g>>2]|0)+352>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3376]=1;i=d;return}function xq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3560]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+348>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(3568,Fy(c[(c[g>>2]|0)+348>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3560]=1;i=d;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3696]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(3704,Fy(c[(c[g>>2]|0)+340>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3696]=1;i=d;return}function zq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[3880]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(3888,Fy(c[(c[g>>2]|0)+336>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[3880]=1;i=d;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4016]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(4024,Fy(c[(c[g>>2]|0)+328>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[4016]=1;i=d;return}function Bq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4200]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+324>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(4208,Fy(c[(c[g>>2]|0)+324>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[4200]=1;i=d;return}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4336]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+536>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(4344,Fy(c[(c[g>>2]|0)+536>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[4336]=1;i=d;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4440]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(4448,Fy(c[(c[g>>2]|0)+528>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=14464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[4440]=1;i=d;return}function Eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4520]&1){i=d;return}g=b+416|0;if(!((rB(+h[(c[g>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hy(4536,Dy(+h[(c[g>>2]|0)+248>>3],4528)|0)|0;g=c[19848]|0;j=e;k=4712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ve[g&15](e,b,f);a[4520]=1;i=d;return}function Fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4736]&1){i=d;return}g=b+416|0;if(!((rB(+h[(c[g>>2]|0)+240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hy(4744,Dy(+h[(c[g>>2]|0)+240>>3],4528)|0)|0;g=c[19848]|0;j=e;k=4912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ve[g&15](e,b,f);a[4736]=1;i=d;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4936]&1){i=d;return}g=b+416|0;if(!((rB(+h[(c[g>>2]|0)+224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hy(4944,Dy(+h[(c[g>>2]|0)+224>>3],4528)|0)|0;g=c[19848]|0;j=e;k=5032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ve[g&15](e,b,f);a[4936]=1;i=d;return}function Hq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5056]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(5064,Fy(c[(c[g>>2]|0)+316>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5056]=1;i=d;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5264]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(5272,Fy(c[(c[g>>2]|0)+312>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5264]=1;i=d;return}function Jq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5416]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(5424,Fy(c[(c[g>>2]|0)+304>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5416]=1;i=d;return}function Kq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5624]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(5632,Fy(c[(c[g>>2]|0)+300>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5624]=1;i=d;return}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5776]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(5784,Fy(c[(c[g>>2]|0)+292>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5776]=1;i=d;return}function Mq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5984]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(5992,Fy(c[(c[g>>2]|0)+288>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[5984]=1;i=d;return}function Nq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6136]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+520>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(6144,Fy(c[(c[g>>2]|0)+520>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6136]=1;i=d;return}function Oq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6256]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(6264,Fy(c[(c[g>>2]|0)+280>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6256]=1;i=d;return}function Pq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6464]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(6472,Fy(c[(c[g>>2]|0)+276>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6464]=1;i=d;return}function Qq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6616]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(6624,Fy(c[(c[g>>2]|0)+268>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6616]=1;i=d;return}function Rq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6824]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(6832,Fy(c[(c[g>>2]|0)+264>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6824]=1;i=d;return}function Sq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6976]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(6984,Fy(c[(c[g>>2]|0)+256>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[6976]=1;i=d;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7184]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(7192,Fy(c[(c[g>>2]|0)+252>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7184]=1;i=d;return}function Uq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7336]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+512>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(7344,Fy(c[(c[g>>2]|0)+512>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7336]=1;i=d;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7456]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+500>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(7464,Fy(c[(c[g>>2]|0)+500>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7456]=1;i=d;return}function Wq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7552]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(7560,Fy(c[(c[g>>2]|0)+244>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7552]=1;i=d;return}function Xq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7768]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(7776,Fy(c[(c[g>>2]|0)+240>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7768]=1;i=d;return}function Yq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7928]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(7936,Fy(c[(c[g>>2]|0)+232>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[7928]=1;i=d;return}function Zq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8144]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(8152,Fy(c[(c[g>>2]|0)+228>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[8144]=1;i=d;return}function _q(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8304]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(8312,Fy(c[(c[g>>2]|0)+220>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[8304]=1;i=d;return}function $q(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8520]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+216>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(8528,Fy(c[(c[g>>2]|0)+216>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[8520]=1;i=d;return}function ar(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8680]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+488>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(8688,Fy(c[(c[g>>2]|0)+488>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[8680]=1;i=d;return}function br(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8808]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(8816,Fy(c[(c[g>>2]|0)+208>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[8808]=1;i=d;return}function cr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9024]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(9032,Fy(c[(c[g>>2]|0)+204>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9024]=1;i=d;return}function dr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9184]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(9192,Fy(c[(c[g>>2]|0)+196>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9184]=1;i=d;return}function er(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9400]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(9408,Fy(c[(c[g>>2]|0)+192>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9400]=1;i=d;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9560]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(9568,Fy(c[(c[g>>2]|0)+184>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9560]=1;i=d;return}function gr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9776]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(9784,Fy(c[(c[g>>2]|0)+180>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9776]=1;i=d;return}function hr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9936]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+480>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(9944,Fy(c[(c[g>>2]|0)+480>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[9936]=1;i=d;return}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10064]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(10072,Fy(c[(c[g>>2]|0)+172>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[10064]=1;i=d;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10280]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(10288,Fy(c[(c[g>>2]|0)+168>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[10280]=1;i=d;return}function kr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10440]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(10448,Fy(c[(c[g>>2]|0)+160>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[10440]=1;i=d;return}function lr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10656]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(10664,Fy(c[(c[g>>2]|0)+156>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[10656]=1;i=d;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10816]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(10824,Fy(c[(c[g>>2]|0)+148>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[10816]=1;i=d;return}function nr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11032]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(11040,Fy(c[(c[g>>2]|0)+144>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11032]=1;i=d;return}function or(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11192]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+472>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(11200,Fy(c[(c[g>>2]|0)+472>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11192]=1;i=d;return}function pr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11320]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(11328,Fy(c[(c[g>>2]|0)+136>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11320]=1;i=d;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11536]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(11544,Fy(c[(c[g>>2]|0)+132>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11536]=1;i=d;return}function rr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11696]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(11704,Fy(c[(c[g>>2]|0)+124>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11696]=1;i=d;return}function sr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11912]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(11920,Fy(c[(c[g>>2]|0)+120>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[11912]=1;i=d;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12072]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(12080,Fy(c[(c[g>>2]|0)+112>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12072]=1;i=d;return}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12288]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(12296,Fy(c[(c[g>>2]|0)+108>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12288]=1;i=d;return}function vr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12448]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+464>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(12456,Fy(c[(c[g>>2]|0)+464>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12448]=1;i=d;return}function wr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12576]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+444>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(12584,Fy(c[(c[g>>2]|0)+444>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=12672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12576]=1;i=d;return}function xr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12696]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+436>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(12704,Fy(c[(c[g>>2]|0)+436>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12696]=1;i=d;return}function yr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12816]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+432>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(12824,Fy(c[(c[g>>2]|0)+432>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12816]=1;i=d;return}function zr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12912]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+424>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(12920,Fy(c[(c[g>>2]|0)+424>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[12912]=1;i=d;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13032]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+420>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(13040,Fy(c[(c[g>>2]|0)+420>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13032]=1;i=d;return}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13128]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(13136,Fy(c[(c[g>>2]|0)+412>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13128]=1;i=d;return}function Cr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13248]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(13256,Fy(c[(c[g>>2]|0)+408>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13248]=1;i=d;return}function Dr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13344]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(13352,Fy(c[(c[g>>2]|0)+100>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13344]=1;i=d;return}function Er(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13520]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(13528,Fy(c[(c[g>>2]|0)+96>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13520]=1;i=d;return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13656]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(13664,Fy(c[(c[g>>2]|0)+88>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13656]=1;i=d;return}function Gr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13832]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(13840,Fy(c[(c[g>>2]|0)+84>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13832]=1;i=d;return}



function h$(a){a=a|0;a=i;$S(109980|0);$S(109968|0);$S(109956|0);$S(109944|0);$S(109932|0);$S(109920|0);$S(109908|0);$S(109896|0);$S(109884|0);$S(109872|0);$S(109860|0);$S(109848|0);$S(109836|0);$S(109824|0);$S(109812|0);$S(109800|0);$S(109788|0);$S(109776|0);$S(109764|0);$S(109752|0);$S(109740|0);$S(109728|0);$S(109716|0);$S(109704);i=a;return}function i$(a){a=a|0;a=i;xS(110820|0);xS(110808|0);xS(110796|0);xS(110784|0);xS(110772|0);xS(110760|0);xS(110748|0);xS(110736|0);xS(110724|0);xS(110712|0);xS(110700|0);xS(110688|0);xS(110676|0);xS(110664|0);xS(110652|0);xS(110640|0);xS(110628|0);xS(110616|0);xS(110604|0);xS(110592|0);xS(110580|0);xS(110568|0);xS(110556|0);xS(110544);i=a;return}function j$(a){a=a|0;a=i;$S(111212|0);$S(111200|0);$S(111188|0);$S(111176|0);$S(111164|0);$S(111152|0);$S(111140|0);$S(111128|0);$S(111116|0);$S(111104|0);$S(111092|0);$S(111080|0);$S(111068|0);$S(111056);i=a;return}function k$(a){a=a|0;a=i;xS(111748|0);xS(111736|0);xS(111724|0);xS(111712|0);xS(111700|0);xS(111688|0);xS(111676|0);xS(111664|0);xS(111652|0);xS(111640|0);xS(111628|0);xS(111616|0);xS(111604|0);xS(111592);i=a;return}function l$(a){a=a|0;var b=0,c=0;b=i;if((r$(a)|0)==0){c=(m$(a)|0)!=0|0}else{c=1}i=b;return c|0}function m$(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[111904+((d[111904+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function n$(a){a=a|0;var b=0,c=0;b=i;c=wb(a|0)|0;i=b;return c|0}function o$(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function p$(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 2:{d=m$(a)|0;break};case 11:{d=x$(a)|0;break};case 5:{d=r$(a)|0;break};case 9:{d=v$(a)|0;break};case 4:{d=o$(a)|0;break};case 7:{d=t$(a)|0;break};case 6:{d=s$(a)|0;break};case 8:{d=u$(a)|0;break};case 10:{d=w$(a)|0;break};case 12:{d=y$(a)|0;break};case 1:{d=l$(a)|0;break};case 3:{d=n$(a)|0;break};default:{d=0}}i=c;return d|0}function q$(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=114880;while(1){if(d<<24>>24==e<<24>>24){if((a1(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function r$(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function s$(a){a=a|0;var b=0,c=0;b=i;if((w$(a)|0)==0){c=(u$(a)|0)!=0|0}else{c=0}i=b;return c|0}function t$(a){a=a|0;var b=0,c=0;b=i;if((z$(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function u$(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function v$(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[114960+((d[114960+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function w$(a){a=a|0;var b=0,c=0;b=i;c=(b0(118128,a)|0)!=0|0;i=b;return c|0}function x$(a){a=a|0;var b=0,c=0;b=i;c=(B$(a)|0)!=(a|0)|0;i=b;return c|0}function y$(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function z$(a){a=a|0;var b=0,c=0;b=i;c=A$(a,0)|0;i=b;return c|0}function A$(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((m$(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[118218+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[118216+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[118219+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[118464+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[118464+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[118464+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function B$(a){a=a|0;var b=0,c=0;b=i;c=A$(a,1)|0;i=b;return c|0}function C$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=D$(0,a,b,(c|0)!=0?c:119168)|0;i=d;return e|0}function D$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?119176:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[118960+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Lc()|0)>>2]=84;k=-1;i=g;return k|0}function E$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=F$(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=D$(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function F$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[118960+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[118960+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Lc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function G$(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[118960+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Lc()|0)>>2]=84;j=-1;i=g;return j|0}function H$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Lc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function I$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=J$(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=H$(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function J$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=H$(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=H$(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=H$(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}H$(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function K$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=C0(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=C0(2048)|0;c[p+16>>2]=s;if((s|0)==0){D0(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=_$(0,0)|0;if((s|0)==0){D0(c[p+16>>2]|0);D0(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=L$(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=E0(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=M$(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=C0(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;i1(y|0,-1,v|0)|0;I=H}else{I=0}H=E0(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=E0(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=M$(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=S$(q,x)|0;b:do{if((v|0)==0){y=S$(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=T$(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=a0(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=a0(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=T$(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=a0(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=a0(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=T$(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=a0(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=a0(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=a0(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=a0(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=a0(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=a0(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=a0(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=a0(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==3){U=c[S+4>>2]|0;W=S$(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=S$(q,0)|0}else if((T|0)==1){W=c[S+4>>2]|0;U=S$(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=S$(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=S$(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=S$(q,0)|0}else if((T|0)==2){U=c[S+4>>2]|0;W=S$(q,L)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,S)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,1)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=S$(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else if((T|0)==0){T=c[S+4>>2]|0;U=c[T>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=T+8|0;T=(c[U>>2]|0)+L|0;c[U>>2]=T;if((T|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=T;ra=L;sa=M;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=a0(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=a0(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=a0(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=a0(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=S$(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=S$(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;Q=L+8|0;T=c[Q>>2]|0;U=a0(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}W=U;c[U>>2]=T;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;T=U+28|0;U=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;W=c[Q>>2]|0;Q=c[L+4>>2]|0;U=a0(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=W;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=Q;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((R|0)<0){c[U>>2]=1;Q=a0(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=a0(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[U>>2]=0;U=L+8|0;Q=c[U>>2]|0;W=L+4|0;T=c[W>>2]|0;ea=a0(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=R;c[ea+8>>2]=T;c[ea+20>>2]=0;c[ea+24>>2]=0;T=ea+28|0;ea=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ea>>2]=fa;fa=c[U>>2]|0;U=c[L>>2]|0;ea=c[W>>2]|0;W=c[L+12>>2]|0;T=c[L+16>>2]|0;L=a0(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=fa;c[L+4>>2]=U;c[L+8>>2]=ea;c[L+20>>2]=W;c[L+24>>2]=T;T=L+28|0;L=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[L>>2]=R;break}}else if((M|0)==2){R=S$(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=S$(q,3)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=S$(q,c[c[ya+4>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=S$(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==3){R=S$(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=S$(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=S$(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==1){M=S$(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=S$(q,2)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;L=S$(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,c[c[M>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=S$(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else{break}}else if((S|0)==3){L=c[ya+4>>2]|0;M=c[L>>2]|0;do{if((c[L+4>>2]|0)==0){F=141}else{if((c[M+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[M+24>>2];c[ya+28>>2]=c[(c[L>>2]|0)+28>>2]}else if((S|0)==2){R=c[ya+4>>2]|0;T=c[R>>2]|0;W=T+8|0;if((c[W>>2]|0)==0){za=0}else{za=(c[(c[R+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[W>>2]|0)==0){c[ya+24>>2]=c[T+24>>2];Aa=R+4|0}else{W=R$(q,T,0,0,g)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}Ba=C0((c[g>>2]<<2)+4|0)|0;W=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=R$(q,c[R>>2]|0,W,h,0)|0;if((Ca|0)!=0){F=150;break g}T=R+4|0;ea=Q$(s,c[(c[T>>2]|0)+24>>2]|0,c[(c[R>>2]|0)+24>>2]|0,W,c[h>>2]|0)|0;W=ya+24|0;c[W>>2]=ea;D0(Ba);if((c[W>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=T}}T=c[Aa>>2]|0;if((c[T+8>>2]|0)==0){c[ya+28>>2]=c[T+28>>2];break}W=R$(q,T,0,0,g)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}Da=C0((c[g>>2]<<2)+4|0)|0;W=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=R$(q,c[Aa>>2]|0,W,h,0)|0;if((Ea|0)!=0){F=157;break g}T=Q$(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,W,c[h>>2]|0)|0;W=ya+28|0;c[W>>2]=T;D0(Da);if((c[W>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){W=c[ya+4>>2]|0;T=c[W>>2]|0;R=W+4|0;ea=c[R>>2]|0;if((c[T+8>>2]|0)==0){Fa=(c[ea+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;U=Q$(s,c[T+24>>2]|0,c[ea+24>>2]|0,0,0)|0;c[ya+24>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}U=Q$(s,c[(c[W>>2]|0)+28>>2]|0,c[(c[R>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){D0(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){D0(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=C0(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=C0(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){i1(O|0,0,((E|0)>1?E<<2:4)|0)|0}N$(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;U=O+(S<<2)|0;R=K+1+(c[U>>2]|0)|0;c[U>>2]=0;U=S+1|0;if((U|0)<(E|0)){S=U;K=R}else{Ga=R;break}}}else{Ga=0}K=E0(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;R=N$(y,S,x,u)|0;if((R|0)!=0){z=x;A=R;B=u;C=D;break}c[w+20>>2]=0;R=v+24|0;S=c[R>>2]|0;if((c[S>>2]|0)>-1){U=1;W=S;while(1){S=W+32|0;ea=U+1|0;if((c[S>>2]|0)>-1){W=S;U=ea}else{Ha=ea;break}}}else{Ha=1}U=E0(Ha,32)|0;if((U|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=U;W=c[R>>2]|0;y=c[W>>2]|0;if((y|0)>-1){ea=y;y=W;W=0;while(1){c[U+(W<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[U+(W<<5)+12>>2]=ea;S=U+(W<<5)+16|0;c[S>>2]=0;T=y+12|0;fa=c[T>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=C0(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}g1(fa|0,c[T>>2]|0,Q|0)|0}c[U+(W<<5)+20>>2]=c[y+16>>2];Q=W+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;W=Q}else{Ja=Q;break}}}else{Ja=0}c[U+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;$$(s);D0(c[p+16>>2]|0);D0(p);D0(O);D0(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);$$(s);D0(c[p+16>>2]|0);D0(p);if((z|0)!=0){D0(z)}if((B|0)!=0){D0(B)}c[b+4>>2]=C;O$(b);r=A;i=f;return r|0}function L$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;S$(m,c[p>>2]|0)|0;S$(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=S$(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=S$(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=S$(m,3)|0;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 91:{X=Q+1|0;c[q>>2]=X;Y=C0(128)|0;if((Y|0)==0){Z=12;T=294;break b}if((a[X]|0)==94){_=Q+2|0;c[q>>2]=_;$=_;aa=1}else{$=X;aa=0}X=(aa|0)==0;_=Y;Y=0;ba=0;ca=32;da=$;e:while(1){ea=a[da]|0;if(ea<<24>>24==0){fa=_;ga=da;ha=7;T=140;break}else if(ea<<24>>24==93){if(da>>>0>(c[q>>2]|0)>>>0){T=85;break}}ea=G$(e,da,-1)|0;if((ea|0)<0){c[e>>2]=-1;ia=1}else{ia=ea}ea=da+ia|0;do{if((a[ea]|0)==45){ja=ia+1|0;ka=da+ja|0;if((a[ka]|0)==93){T=94;break}la=c[e>>2]|0;ma=G$(e,ka,-1)|0;if((ma|0)<0){c[e>>2]=-1;na=-1;oa=1}else{na=c[e>>2]|0;oa=ma}pa=0;qa=na;ra=la;sa=da+(oa+ja)|0;ta=la>>>0>na>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;la=a[da]|0;do{if(la<<24>>24==45){if((a[da+1|0]|0)==93){ua=0;break}ua=(c[q>>2]|0)==(da|0)?0:11}else if(la<<24>>24==91){ja=a[da+1|0]|0;if(ja<<24>>24==61|ja<<24>>24==46){fa=_;ga=da;ha=3;T=140;break e}else if(!(ja<<24>>24==58)){ua=0;break}ja=da+2|0;ma=ja;while(1){ka=a[ma]|0;va=ka<<24>>24==0;if(ka<<24>>24!=58&(va^1)){ma=ma+1|0}else{break}}if(va){fa=_;ga=da;ha=4;T=140;break e}ka=ma-da+ -2|0;wa=(ka|0)>63?63:ka;p1(A|0,ja|0,wa|0)|0;a[f+wa|0]=0;wa=q$(A)|0;pa=wa;qa=1114111;ra=0;sa=ma+2|0;ta=(wa|0)==0?4:0;break f}else{ua=0}}while(0);la=c[e>>2]|0;pa=0;qa=la;ra=la;sa=ea;ta=ua}}while(0);if((ta|0)!=0){fa=_;ga=sa;ha=ta;T=140;break}ea=(pa|0)!=0;do{if(X|ea^1){la=c[w>>2]|0;if((ba|0)<(ca|0)){xa=_;ya=ca}else{if((ca|0)>1024){fa=_;ga=sa;ha=12;T=140;break e}wa=F0(_,ca<<3)|0;if((wa|0)==0){fa=_;ga=sa;ha=12;T=140;break e}else{xa=wa;ya=ca<<1}}wa=a0(la,0,0,1,32)|0;if((wa|0)==0){T=112;break e}ka=a0(la,0,0,1,20)|0;la=wa+4|0;c[la>>2]=ka;if((ka|0)==0){T=112;break e}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[ka>>2]=ra;c[ka+4>>2]=qa;c[ka+8>>2]=-1;c[xa+(ba<<2)>>2]=wa;c[(c[la>>2]|0)+12>>2]=pa;za=xa;Aa=Y;Ba=ba+1|0;Ca=ya;Da=0}else{if((Y|0)>63){za=_;Aa=Y;Ba=ba;Ca=ca;Da=12;break}c[g+(Y<<2)>>2]=pa;za=_;Aa=Y+1|0;Ba=ba;Ca=ca;Da=0}}while(0);la=(Da|0)==0;if(la&(((c[v>>2]&2|0)==0|ea)^1)){Ea=za;Fa=Ba;Ga=Ca;Ha=ra}else{if(la){_=za;Y=Aa;ba=Ba;ca=Ca;da=sa;continue}else{fa=za;ga=sa;ha=Da;T=140;break}}while(1){la=Ha;while(1){if(la>>>0>qa>>>0){_=Ea;Y=Aa;ba=Fa;ca=Ga;da=sa;continue e}if((t$(la)|0)!=0){T=118;break}Ia=la+1|0;if((x$(la)|0)==0){la=Ia}else{T=129;break}}if((T|0)==118){T=0;wa=z$(la)|0;ka=la+1|0;g:do{if((t$(ka)|0)==0){Ja=wa;Ka=ka}else{La=wa;Ma=ka;while(1){if((z$(Ma)|0)!=(La+1|0)|Ma>>>0>qa>>>0){Ja=La;Ka=Ma;break g}Na=z$(Ma)|0;Oa=Ma+1|0;if((t$(Oa)|0)==0){Ja=Na;Ka=Oa;break}else{La=Na;Ma=Oa}}}}while(0);ka=c[w>>2]|0;if((Fa|0)<(Ga|0)){Pa=Ea;Qa=Ga}else{if((Ga|0)>1024){fa=Ea;ga=sa;ha=12;T=140;break e}Ma=F0(Ea,Ga<<3)|0;if((Ma|0)==0){fa=Ea;ga=sa;ha=12;T=140;break e}else{Pa=Ma;Qa=Ga<<1}}Ma=a0(ka,0,0,1,32)|0;La=Ma;do{if((Ma|0)==0){Ra=0}else{ma=a0(ka,0,0,1,20)|0;c[Ma+4>>2]=ma;if((ma|0)==0){Ra=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[ma>>2]=wa;c[ma+4>>2]=Ja;c[ma+8>>2]=-1;Ra=La}}while(0);c[Pa+(Fa<<2)>>2]=Ra;Sa=Ra;Ta=Pa;Ua=Qa;Va=Ka}else if((T|0)==129){T=0;La=B$(la)|0;h:do{if((x$(Ia)|0)==0){Wa=La;Xa=Ia}else{wa=La;Ma=Ia;while(1){if((B$(Ma)|0)!=(wa+1|0)|Ma>>>0>qa>>>0){Wa=wa;Xa=Ma;break h}ka=Ma+1|0;ma=B$(Ma)|0;if((x$(ka)|0)==0){Wa=ma;Xa=ka;break}else{wa=ma;Ma=ka}}}}while(0);la=c[w>>2]|0;if((Fa|0)<(Ga|0)){Ya=Ea;Za=Ga}else{if((Ga|0)>1024){fa=Ea;ga=sa;ha=12;T=140;break e}Ma=F0(Ea,Ga<<3)|0;if((Ma|0)==0){fa=Ea;ga=sa;ha=12;T=140;break e}else{Ya=Ma;Za=Ga<<1}}Ma=a0(la,0,0,1,32)|0;wa=Ma;do{if((Ma|0)==0){_a=0}else{ka=a0(la,0,0,1,20)|0;c[Ma+4>>2]=ka;if((ka|0)==0){_a=0;break}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[ka>>2]=La;c[ka+4>>2]=Wa;c[ka+8>>2]=-1;_a=wa}}while(0);c[Ya+(Fa<<2)>>2]=_a;Sa=_a;Ta=Ya;Ua=Za;Va=Xa}if((Sa|0)==0){T=141;break e}else{Ea=Ta;Fa=Fa+1|0;Ga=Ua;Ha=Va}}}i:do{if((T|0)==85){T=0;c[q>>2]=da+1;ca=(aa|0)!=0;if(ca){bc(_|0,ba|0,4,61)}j:do{if((ba|0)>0){X=(Y|0)>0;ea=Y<<2;wa=ea+4|0;if(ca){$a=0;ab=0;bb=0;cb=0}else{La=0;Ma=0;while(1){la=_+(La<<2)|0;ka=c[(c[la>>2]|0)+4>>2]|0;do{if((ka|0)==0){db=Ma;eb=0}else{c[ka+8>>2]=c[x>>2];if(X){ma=a0(c[w>>2]|0,0,0,0,wa)|0;ja=ka+16|0;c[ja>>2]=ma;if((ma|0)==0){fb=_;gb=Ma;hb=12;break i}g1(ma|0,z|0,ea|0)|0;c[(c[ja>>2]|0)+(Y<<2)>>2]=0}else{c[ka+16>>2]=0}if((Ma|0)==0){db=c[la>>2]|0;eb=0;break}ja=c[w>>2]|0;ma=c[la>>2]|0;Oa=a0(ja,0,0,1,32)|0;Na=Oa;do{if((Oa|0)==0){ib=0}else{jb=a0(ja,0,0,1,8)|0;kb=Oa+4|0;c[kb>>2]=jb;if((jb|0)==0){ib=0;break}c[Oa>>2]=3;c[Oa+8>>2]=-1;c[Oa+12>>2]=-1;c[jb>>2]=Ma;c[(c[kb>>2]|0)+4>>2]=ma;c[Oa+16>>2]=(c[ma+16>>2]|0)+(c[Ma+16>>2]|0);ib=Na}}while(0);db=ib;eb=(ib|0)==0?12:0}}while(0);la=La+1|0;if((la|0)<(ba|0)&(eb|0)==0){La=la;Ma=db}else{lb=0;mb=db;nb=eb;break j}}}while(1){Ma=_+(bb<<2)|0;La=c[(c[Ma>>2]|0)+4>>2]|0;la=c[La>>2]|0;ka=La+4|0;Na=c[ka>>2]|0;do{if((la|0)<($a|0)){ma=Na+1|0;ob=(ma|0)<($a|0)?$a:ma;pb=ab;qb=cb;rb=0}else{if((la|0)<=(ab|0)){ma=Na+1|0;ob=ma;pb=ma;qb=cb;rb=0;break}c[La>>2]=ab;c[ka>>2]=la+ -1;ma=Na+1|0;if((La|0)==0){ob=ma;pb=ma;qb=cb;rb=0;break}c[La+8>>2]=c[x>>2];if(X){Oa=a0(c[w>>2]|0,0,0,0,wa)|0;ja=La+16|0;c[ja>>2]=Oa;if((Oa|0)==0){fb=_;gb=cb;hb=12;break i}g1(Oa|0,z|0,ea|0)|0;c[(c[ja>>2]|0)+(Y<<2)>>2]=0}else{c[La+16>>2]=0}if((cb|0)==0){ob=ma;pb=ma;qb=c[Ma>>2]|0;rb=0;break}ja=c[w>>2]|0;Oa=c[Ma>>2]|0;kb=a0(ja,0,0,1,32)|0;jb=kb;do{if((kb|0)==0){sb=0}else{tb=a0(ja,0,0,1,8)|0;ub=kb+4|0;c[ub>>2]=tb;if((tb|0)==0){sb=0;break}c[kb>>2]=3;c[kb+8>>2]=-1;c[kb+12>>2]=-1;c[tb>>2]=cb;c[(c[ub>>2]|0)+4>>2]=Oa;c[kb+16>>2]=(c[Oa+16>>2]|0)+(c[cb+16>>2]|0);sb=jb}}while(0);ob=ma;pb=ma;qb=sb;rb=(sb|0)==0?12:0}}while(0);Ma=bb+1|0;if((Ma|0)<(ba|0)&(rb|0)==0){$a=ob;ab=pb;bb=Ma;cb=qb}else{lb=pb;mb=qb;nb=rb;break}}}else{lb=0;mb=0;nb=0}}while(0);if((nb|0)!=0|ca^1){fb=_;gb=mb;hb=nb;break}ea=c[w>>2]|0;wa=c[x>>2]|0;X=a0(ea,0,0,1,32)|0;Ma=X;if((X|0)==0){fb=_;gb=mb;hb=12;break}La=a0(ea,0,0,1,20)|0;c[X+4>>2]=La;if((La|0)==0){fb=_;gb=mb;hb=12;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[La>>2]=lb;c[La+4>>2]=1114111;c[La+8>>2]=wa;if((Y|0)>0){wa=Y<<2;ea=a0(c[w>>2]|0,0,0,0,wa+4|0)|0;Na=La+16|0;c[Na>>2]=ea;if((ea|0)==0){fb=_;gb=mb;hb=12;break}g1(ea|0,z|0,wa|0)|0;c[(c[Na>>2]|0)+(Y<<2)>>2]=0}else{c[La+16>>2]=0}if((mb|0)==0){fb=_;gb=Ma;hb=0;break}La=c[w>>2]|0;Na=a0(La,0,0,1,32)|0;wa=Na;do{if((Na|0)==0){vb=0}else{ea=a0(La,0,0,1,8)|0;la=Na+4|0;c[la>>2]=ea;if((ea|0)==0){vb=0;break}c[Na>>2]=3;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[ea>>2]=mb;c[(c[la>>2]|0)+4>>2]=Ma;c[Na+16>>2]=(c[X+16>>2]|0)+(c[mb+16>>2]|0);vb=wa}}while(0);fb=_;gb=vb;hb=(vb|0)==0?12:0}else if((T|0)==112){T=0;c[xa+(ba<<2)>>2]=0;fa=xa;ga=sa;ha=12;T=140}else if((T|0)==141){T=0;c[q>>2]=sa;fb=Ta;gb=0;hb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=ga;fb=fa;gb=0;hb=ha}D0(fb);c[x>>2]=(c[x>>2]|0)+1;if((hb|0)==0){U=M;V=gb;W=0;break c}else{Z=hb;T=294;break b}break};case 92:{ba=Q+1|0;_=a[ba]|0;do{if((c[v>>2]&1|0)==0){if(_<<24>>24==40){c[q>>2]=ba;wb=ba;T=74;break d}else{Y=a[Q+1|0]|0;if(Y<<24>>24==41){T=265;break d}else{xb=Y;break}}}else{xb=_}}while(0);_=Q+1|0;ba=xb<<24>>24==0;if(ba){Z=5;T=294;break b}else{yb=119188|0;zb=0}while(1){Y=zb+1|0;if((a[119184+(zb<<3)|0]|0)==xb<<24>>24){Ab=yb;break}da=119188+(Y<<3)|0;if((Y|0)==12){Ab=da;break}else{yb=da;zb=Y}}Y=c[Ab>>2]|0;if((Y|0)!=0){da=F+0|0;wa=G+0|0;X=da+40|0;do{c[da>>2]=c[wa>>2];da=da+4|0;wa=wa+4|0}while((da|0)<(X|0));c[H>>2]=Y;c[I>>2]=1;wa=L$(j)|0;if((wa|0)!=0){Z=wa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(ba){Z=5;T=294;break b}c[q>>2]=_;wa=a[_]|0;k:do{switch(wa|0){case 66:{da=c[w>>2]|0;X=a0(da,0,0,1,32)|0;Na=X;do{if((X|0)==0){Bb=0}else{Ma=a0(da,0,0,1,20)|0;c[X+4>>2]=Ma;if((Ma|0)==0){Bb=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=128;c[Ma+8>>2]=-1;Bb=Na}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Bb;break};case 60:{Na=c[w>>2]|0;X=a0(Na,0,0,1,32)|0;da=X;do{if((X|0)==0){Db=0}else{Ma=a0(Na,0,0,1,20)|0;c[X+4>>2]=Ma;if((Ma|0)==0){Db=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=16;c[Ma+8>>2]=-1;Db=da}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Db;break};case 98:{da=c[w>>2]|0;X=a0(da,0,0,1,32)|0;Na=X;do{if((X|0)==0){Eb=0}else{Ma=a0(da,0,0,1,20)|0;c[X+4>>2]=Ma;if((Ma|0)==0){Eb=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=64;c[Ma+8>>2]=-1;Eb=Na}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Eb;break};case 62:{Na=c[w>>2]|0;X=a0(Na,0,0,1,32)|0;da=X;do{if((X|0)==0){Fb=0}else{Ma=a0(Na,0,0,1,20)|0;c[X+4>>2]=Ma;if((Ma|0)==0){Fb=0;break}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ma>>2]=-2;c[Ma+4>>2]=32;c[Ma+8>>2]=-1;Fb=da}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Fb;break};case 120:{da=Q+2|0;c[q>>2]=da;X=a[da]|0;if(X<<24>>24==123){da=Q+3|0;c[q>>2]=da;Na=da;da=0;while(1){Ma=a[Na]|0;if(Ma<<24>>24==0|Ma<<24>>24==125){Gb=da;Hb=Na;break}if((y$(Ma<<24>>24)|0)==0){Z=9;T=294;break b}Ma=c[q>>2]|0;a[l+da|0]=a[Ma]|0;La=da+1|0;ca=Ma+1|0;c[q>>2]=ca;if(La>>>0>31){Gb=La;Hb=ca;break}else{Na=ca;da=La}}c[q>>2]=Hb+1;a[l+Gb|0]=0;da=Tb(C|0,0,16)|0;Na=c[w>>2]|0;La=c[x>>2]|0;ca=a0(Na,0,0,1,32)|0;Ma=ca;do{if((ca|0)==0){Ib=0}else{la=a0(Na,0,0,1,20)|0;c[ca+4>>2]=la;if((la|0)==0){Ib=0;break}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[la>>2]=da;c[la+4>>2]=da;c[la+8>>2]=La;Ib=Ma}}while(0);c[x>>2]=(c[x>>2]|0)+1;Cb=Ib;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ma=(y$(X<<24>>24)|0)==0;La=c[q>>2]|0;if(Ma){Jb=La}else{a[D]=a[La]|0;Ma=La+1|0;c[q>>2]=Ma;Jb=Ma}if((y$(a[Jb]|0)|0)!=0){Ma=c[q>>2]|0;a[E]=a[Ma]|0;c[q>>2]=Ma+1}Ma=Tb(D|0,0,16)|0;La=c[w>>2]|0;da=c[x>>2]|0;ca=a0(La,0,0,1,32)|0;Na=ca;do{if((ca|0)==0){Kb=0}else{la=a0(La,0,0,1,20)|0;c[ca+4>>2]=la;if((la|0)==0){Kb=0;break}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[la>>2]=Ma;c[la+4>>2]=Ma;c[la+8>>2]=da;Kb=Na}}while(0);c[x>>2]=(c[x>>2]|0)+1;Cb=Kb;break k}break};default:{if((r$(wa)|0)!=0){Na=(a[c[q>>2]|0]|0)+ -48|0;da=c[w>>2]|0;Ma=c[x>>2]|0;ca=a0(da,0,0,1,32)|0;if((ca|0)==0){Z=12;T=294;break b}La=a0(da,0,0,1,20)|0;c[ca+4>>2]=La;if((La|0)==0){Z=12;T=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[La>>2]=-4;c[La+4>>2]=Na;c[La+8>>2]=Ma;c[x>>2]=(c[x>>2]|0)+1;Ma=c[B>>2]|0;c[B>>2]=(Na|0)<(Ma|0)?Ma:Na;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ca;W=0;break c}ca=c[w>>2]|0;Na=a[c[q>>2]|0]|0;Ma=c[x>>2]|0;La=a0(ca,0,0,1,32)|0;da=La;do{if((La|0)==0){Lb=0}else{X=a0(ca,0,0,1,20)|0;c[La+4>>2]=X;if((X|0)==0){Lb=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[X>>2]=Na;c[X+4>>2]=Na;c[X+8>>2]=Ma;Lb=da}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Cb=Lb}}}while(0);if((Cb|0)==0){Z=12;T=294;break b}else{U=M;V=Cb;W=0;break c}break};case 40:{if((c[v>>2]&1|0)!=0){wb=Q;T=74}break};case 46:{wa=(c[v>>2]&4|0)==0;_=c[w>>2]|0;ba=c[x>>2]|0;Y=a0(_,0,0,1,32)|0;da=Y;Ma=(Y|0)==0;if(wa){if(Ma){Z=12;T=294;break b}wa=a0(_,0,0,1,20)|0;c[Y+4>>2]=wa;if((wa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[wa>>2]=0;c[wa+4>>2]=1114111;c[wa+8>>2]=ba;Mb=da;Nb=(c[x>>2]|0)+1|0}else{if(Ma){Z=12;T=294;break b}Ma=a0(_,0,0,1,20)|0;c[Y+4>>2]=Ma;if((Ma|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ma>>2]=0;c[Ma+4>>2]=9;c[Ma+8>>2]=ba;ba=c[w>>2]|0;Ma=(c[x>>2]|0)+1|0;_=a0(ba,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}wa=a0(ba,0,0,1,20)|0;c[_+4>>2]=wa;if((wa|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[wa>>2]=11;c[wa+4>>2]=1114111;c[wa+8>>2]=Ma;Ma=c[w>>2]|0;wa=a0(Ma,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}ba=a0(Ma,0,0,1,8)|0;Ma=wa+4|0;c[Ma>>2]=ba;if((ba|0)==0){Z=12;T=294;break b}c[wa>>2]=3;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[ba>>2]=da;c[(c[Ma>>2]|0)+4>>2]=_;c[wa+16>>2]=(c[_+16>>2]|0)+(c[Y+16>>2]|0);Mb=wa;Nb=(c[x>>2]|0)+2|0}c[x>>2]=Nb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Mb;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}wa=S$(m,5)|0;if((wa|0)!=0){R=M;S=wa;T=6;break b}}wa=c[w>>2]|0;Y=a0(wa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=a0(wa,0,0,1,20)|0;c[Y+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=-2;c[_+4>>2]=1;c[_+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Y;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}Y=c[w>>2]|0;_=a0(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}wa=a0(Y,0,0,1,20)|0;c[_+4>>2]=wa;if((wa|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[wa>>2]=-2;c[wa+4>>2]=2;c[wa+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=_;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};default:{}}}while(0);if((T|0)==74){T=0;_=M+1|0;c[q>>2]=wb+1;wa=S$(m,c[y>>2]|0)|0;if((wa|0)!=0){R=_;S=wa;T=6;break b}wa=S$(m,2)|0;if((wa|0)!=0){R=_;S=wa;T=6;break b}wa=S$(m,0)|0;if((wa|0)!=0){R=_;S=wa;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=_;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;_=c[w>>2]|0;wa=a0(_,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}Y=a0(_,0,0,1,20)|0;c[wa+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;U=M;V=wa;W=0;break c}wa=G$(h,Q,-1)|0;if((wa|0)<0){c[h>>2]=-1;Ob=1}else{Ob=wa}do{if((c[v>>2]&2|0)==0){T=280}else{if((x$(c[h>>2]|0)|0)==0){if((t$(c[h>>2]|0)|0)==0){T=280;break}}wa=c[w>>2]|0;Y=z$(c[h>>2]|0)|0;_=z$(c[h>>2]|0)|0;Ma=c[x>>2]|0;da=a0(wa,0,0,1,32)|0;if((da|0)==0){Z=12;T=294;break b}ba=a0(wa,0,0,1,20)|0;c[da+4>>2]=ba;if((ba|0)==0){Z=12;T=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ba>>2]=Y;c[ba+4>>2]=_;c[ba+8>>2]=Ma;Ma=c[w>>2]|0;ba=B$(c[h>>2]|0)|0;_=B$(c[h>>2]|0)|0;Y=c[x>>2]|0;wa=a0(Ma,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}Na=a0(Ma,0,0,1,20)|0;c[wa+4>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Na>>2]=ba;c[Na+4>>2]=_;c[Na+8>>2]=Y;Y=c[w>>2]|0;Na=a0(Y,0,0,1,32)|0;if((Na|0)==0){Z=12;T=294;break b}_=a0(Y,0,0,1,8)|0;Y=Na+4|0;c[Y>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Na>>2]=3;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[_>>2]=da;c[(c[Y>>2]|0)+4>>2]=wa;c[Na+16>>2]=(c[wa+16>>2]|0)+(c[da+16>>2]|0);Pb=Na}}while(0);if((T|0)==280){T=0;Q=c[w>>2]|0;Na=c[h>>2]|0;da=c[x>>2]|0;wa=a0(Q,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}Y=a0(Q,0,0,1,20)|0;c[wa+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Y>>2]=Na;c[Y+4>>2]=Na;c[Y+8>>2]=da;Pb=wa}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Ob;U=M;V=Pb;W=0;break};case 6:{wa=L+ -2|0;c[n>>2]=wa;da=c[P+(wa<<2)>>2]|0;wa=c[w>>2]|0;Y=a0(wa,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Na=a0(wa,0,0,1,8)|0;wa=Y+4|0;c[wa>>2]=Na;if((Na|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Na>>2]=da;c[(c[wa>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[da+16>>2]|0);U=M;V=Y;W=0;break};case 9:{Y=c[q>>2]|0;da=a[Y]|0;switch(da<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 123:{wa=c[v>>2]|0;if((wa&1|0)==0){U=M;V=N;W=0;break c}else{Qb=wa;Rb=Y}break};case 92:{wa=c[v>>2]|0;if((wa&1|0)!=0){U=M;V=N;W=0;break c}Na=Y+1|0;if((a[Na]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=Na;Qb=wa;Rb=Na;break};case 42:{T=41;break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Y+1;Y=c[w>>2]|0;Na=a0(Y,0,0,1,32)|0;if((Na|0)==0){Z=12;T=294;break b}wa=a0(Y,0,0,1,16)|0;c[Na+4>>2]=wa;if((wa|0)==0){Z=12;T=294;break b}c[Na>>2]=2;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[wa>>2]=N;c[wa+4>>2]=da<<24>>24==43;c[wa+8>>2]=da<<24>>24==63?1:-1;da=wa+12|0;a[da]=a[da]&-2;c[Na+16>>2]=c[N+16>>2];U=M;V=Na;W=S$(m,9)|0;break c}Na=Rb+1|0;c[q>>2]=Na;da=a[Na]|0;if((da+ -48<<24>>24&255)<10){wa=da<<24>>24;if((wa+ -48|0)>>>0<10){Sb=wa;Ub=-1;Vb=Na}else{Z=10;T=294;break b}while(1){wa=((Ub|0)<0?-48:(Ub*10|0)+ -48|0)+Sb|0;Y=Vb+1|0;Q=a[Y]|0;_=Q<<24>>24;if((_+ -48|0)>>>0<10){Vb=Y;Ub=wa;Sb=_}else{Wb=Q;Xb=wa;Yb=Y;break}}}else{Wb=da;Xb=-1;Yb=Na}do{if(Wb<<24>>24==44){Y=Yb+1|0;wa=a[Y]|0;Q=wa<<24>>24;if((Q+ -48|0)>>>0<10){Zb=Q;_b=-1;$b=Y}else{ac=wa;cc=-1;dc=Y;break}while(1){Y=((_b|0)<0?-48:(_b*10|0)+ -48|0)+Zb|0;wa=$b+1|0;Q=a[wa]|0;_=Q<<24>>24;if((_+ -48|0)>>>0<10){$b=wa;_b=Y;Zb=_}else{ec=Q;fc=Y;gc=wa;T=54;break}}}else{ec=Wb;fc=Xb;gc=Yb;T=54}}while(0);do{if((T|0)==54){T=0;if(!((fc|0)>-1)){ac=ec;cc=fc;dc=gc;break}if((Xb|0)>(fc|0)|(fc|0)>255){Z=10;T=294;break b}else{ac=ec;cc=fc;dc=gc}}}while(0);if(ac<<24>>24==0){Z=9;T=294;break b}if((dc|0)==(Na|0)){Z=10;T=294;break b}if((Qb&1|0)==0){if(!(ac<<24>>24==92)){Z=10;T=294;break b}if((a[dc+1|0]|0)!=125){Z=10;T=294;break b}hc=dc+2|0}else{if(!(ac<<24>>24==125)){Z=10;T=294;break b}hc=dc+1|0}if((cc|Xb|0)==0){da=c[w>>2]|0;wa=a0(da,0,0,1,32)|0;if((wa|0)==0){Z=12;T=294;break b}Y=a0(da,0,0,1,20)|0;c[wa+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[wa>>2]=0;c[wa+8>>2]=-1;c[wa+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;ic=wa}else{wa=(cc&Xb|0)<0;Y=c[w>>2]|0;da=a0(Y,0,0,1,32)|0;if((da|0)==0){Z=12;T=294;break b}Q=a0(Y,0,0,1,16)|0;c[da+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[da>>2]=2;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=wa?1:Xb;c[Q+8>>2]=wa?1:cc;wa=Q+12|0;a[wa]=a[wa]&-2;c[da+16>>2]=c[N+16>>2];ic=da}c[q>>2]=hc;U=M;V=ic;W=S$(m,9)|0;break};case 5:{da=c[q>>2]|0;wa=a[da]|0;if(wa<<24>>24==0){U=M;V=N;W=0;break c}Q=c[v>>2]&1;Y=(Q|0)!=0;if(Y&wa<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Y&wa<<24>>24==41&(M|0)>0)){if((Q|0)==0&wa<<24>>24==92){if((a[da+1|0]|0)==41){break}}_=S$(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=S$(m,N)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=S$(m,6)|0;if((_|0)!=0){R=M;S=_;T=6;break b}U=M;V=N;W=S$(m,4)|0;break c}}while(0);wa=(Q|M|0)==0?8:0;Y=M+ -1|0;if((Q|0)!=0){U=Y;V=N;W=wa;break c}c[q>>2]=da+2;U=Y;V=N;W=wa;break};case 7:{wa=c[q>>2]|0;Y=a[wa]|0;if((Y|0)==41){c[q>>2]=wa+1;U=M;V=N;W=0;break c}else if((Y|0)!=124){U=M;V=N;W=0;break c}Y=S$(m,7)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=S$(m,N)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=S$(m,8)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=S$(m,3)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 4:{Y=S$(m,9)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}U=M;V=N;W=S$(m,1)|0;break};case 3:{Y=S$(m,5)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}U=M;V=N;W=S$(m,4)|0;break};case 2:{Y=L+ -2|0;c[n>>2]=Y;wa=c[P+(Y<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Y=c[w>>2]|0;Na=a0(Y,0,0,1,32)|0;if((Na|0)==0){Z=12;T=294;break b}_=a0(Y,0,0,1,20)|0;c[Na+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Na>>2]=0;c[Na+8>>2]=-1;c[Na+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;_=c[w>>2]|0;Y=a0(_,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}ba=a0(_,0,0,1,8)|0;_=Y+4|0;c[_>>2]=ba;if((ba|0)==0){Z=12;T=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[ba>>2]=Na;c[(c[_>>2]|0)+4>>2]=N;_=N+16|0;ba=Y+16|0;c[ba>>2]=(c[_>>2]|0)+(c[Na+16>>2]|0);c[ba>>2]=c[_>>2];jc=Y}else{jc=N}c[jc+12>>2]=wa;wa=jc+16|0;c[wa>>2]=(c[wa>>2]|0)+1;U=M;V=jc;W=0;break};case 10:{wa=L+ -2|0;c[n>>2]=wa;c[v>>2]=c[P+(wa<<2)>>2];U=M;V=N;W=0;break};case 8:{wa=L+ -2|0;c[n>>2]=wa;Y=c[P+(wa<<2)>>2]|0;wa=c[w>>2]|0;_=a0(wa,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}ba=a0(wa,0,0,1,8)|0;wa=_+4|0;c[wa>>2]=ba;if((ba|0)==0){Z=12;T=294;break b}c[_>>2]=3;c[_+8>>2]=-1;c[_+12>>2]=-1;c[ba>>2]=Y;c[(c[wa>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[Y+16>>2]|0);U=M;V=_;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{kc=O;lc=U;mc=V;nc=W;break a}}if((T|0)==6){kc=(S|0)==0;lc=R;mc=N;nc=S;break}else if((T|0)==294){i=d;return Z|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){Z=p?8:nc;i=d;return Z|0}c[b+8>>2]=mc;Z=0;i=d;return Z|0}function M$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=C0((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=C0((l<<2)+4|0)|0;if((p|0)==0){D0(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}S$(d,e)|0;e=S$(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;H=u+ -5|0;c[h>>2]=H;if(k){I=c[G+4>>2]|0;J=G+16|0;c[G+20>>2]=(c[(c[I>>2]|0)+20>>2]|0)+(c[D+(H<<2)>>2]|0)+(c[(c[I+4>>2]|0)+20>>2]|0)+((c[J>>2]|0)>0?2:0);K=J;L=c[h>>2]|0}else{K=G+16|0;L=H}H=c[D+(L+ -1<<2)>>2]|0;G=L+ -2|0;c[h>>2]=G;J=c[D+(G<<2)>>2]|0;G=L+ -3|0;c[h>>2]=G;I=c[D+(G<<2)>>2]|0;if((c[K>>2]|0)<=0){M=1;N=w;O=x;P=y;Q=z;R=H;S=0;T=B;break b}if(k){U=0}else{V$(b,E,J)|0;c[(c[r>>2]|0)+(J<<2)>>2]=1;J=V$(b,F,I)|0;c[(c[r>>2]|0)+(I<<2)>>2]=1;U=J}M=1;N=w;O=x;P=y;Q=z+2|0;R=H;S=U;T=B;break};case 1:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;if(k){H=c[(c[c[J+4>>2]>>2]|0)+20>>2]|0;I=u+ -3|0;c[h>>2]=I;c[J+20>>2]=(c[D+(I<<2)>>2]|0)+H;M=v;N=-1;O=x;P=y;Q=z;R=A;S=0;T=B;break b}else{H=u+ -3|0;c[h>>2]=H;I=c[D+(H<<2)>>2]|0;H=u+ -4|0;c[h>>2]=H;J=(I|0)==0;M=J&1;N=J?w:c[D+(H<<2)>>2]|0;O=x;P=y;Q=z;R=A;S=0;T=B;break b}break};case 6:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=0;do{V=A+(H<<2)|0;H=H+1|0}while((c[V>>2]|0)>-1);c[V>>2]=J<<1|1;c[A+(H<<2)>>2]=-1;I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[p+(I+ -1<<2)>>2]=-1;M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 0:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=J;F=J+12|0;E=c[F>>2]|0;if((E|0)>-1){G=0;do{W=A+(G<<2)|0;G=G+1|0}while((c[W>>2]|0)>-1);c[W>>2]=E<<1;c[A+(G<<2)>>2]=-1;do{if(!k){I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((I|0)<=0){break}X=C0((I<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=S$(d,c[F>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=S$(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[J>>2]|0;do{if((E|0)==0){G=c[c[J+4>>2]>>2]|0;if(!((G|0)>-1|(G|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[J+20>>2]=1;ra=w;sa=y;ta=0}else{G=U$(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;fa=0;while(1){ua=ea+(fa<<2)|0;va=fa+1|0;if((c[ua>>2]|0)>-1){fa=va}else{break}}c[ua>>2]=B;c[ea+(va<<2)>>2]=w;c[ea+(fa+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;X=Y;Y=0;do{I=(X|0)/2|0;if((X&1|0)==0){c[da+(I*12|0)>>2]=B}else{c[da+(I*12|0)+4>>2]=B}Y=Y+1|0;X=c[A+(Y<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=G}c[A>>2]=-1;ka=v;la=ra;ma=x+1|0;na=sa;oa=z+1|0;pa=ta;qa=x}else if((E|0)==2){X=c[J+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ya=1}else{ya=a[X+12|0]&1}Y=S$(d,ya)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=S$(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=S$(d,a[X+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=S$(d,J)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=S$(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=S$(d,c[X>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=S$(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[X+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){za=w;Aa=y;Ba=0}else{Y=U$(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[X+12|0]&1)==0?v:1;if((w|0)>-1){X=c[t>>2]|0;da=0;while(1){Ca=X+(da<<2)|0;Da=da+1|0;if((c[Ca>>2]|0)>-1){da=Da}else{break}}c[Ca>>2]=B;c[X+(Da<<2)>>2]=w;c[X+(da+2<<2)>>2]=-1;Ea=-1;Fa=y+1|0}else{Ea=w;Fa=y}G=c[A>>2]|0;if((G|0)>-1){fa=c[s>>2]|0;ea=G;G=0;do{I=(ea|0)/2|0;if((ea&1|0)==0){c[fa+(I*12|0)>>2]=B}else{c[fa+(I*12|0)+4>>2]=B}G=G+1|0;ea=c[A+(G<<2)>>2]|0;}while((ea|0)>-1)}c[A>>2]=-1;za=Ea;Aa=Fa;Ba=Y}c[A>>2]=-1;ka=0;la=za;ma=x+1|0;na=Aa;oa=z+1|0;pa=Ba;qa=x}else if((E|0)==1){ea=c[J+4>>2]|0;G=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=S$(d,J)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=S$(d,5)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=S$(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=S$(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=G+20|0;da=S$(d,(c[ea>>2]|0)+x|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if((c[ea>>2]|0)>0){ea=(c[fa+20>>2]|0)>0;Ga=(ea&1)+x|0;Ha=ea?x:-1}else{Ga=x;Ha=-1}ea=S$(d,Ha)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=S$(d,4)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=S$(d,G)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ka=v;la=w;ma=Ga;na=y;oa=z;pa=S$(d,0)|0;qa=B}else if((E|0)==3){ea=c[J+4>>2]|0;G=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=(c[A>>2]|0)>-1;da=x+1|0;X=S$(d,ea?da:x)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=S$(d,ea?x:B)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=S$(d,A)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=S$(d,(c[A>>2]|0)>>>31^1)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=S$(d,J)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=fa;fa=S$(d,X)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=G;G=S$(d,fa)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,3)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,X)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,0)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,2)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,fa)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=S$(d,0)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}if((c[A>>2]|0)>-1){if(k){Ia=w;Ja=y;Ka=0}else{G=U$(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;X=0;while(1){La=fa+(X<<2)|0;Ma=X+1|0;if((c[La>>2]|0)>-1){X=Ma}else{break}}c[La>>2]=B;c[fa+(Ma<<2)>>2]=w;c[fa+(X+2<<2)>>2]=-1;Na=-1;Oa=y+1|0}else{Na=w;Oa=y}Y=c[A>>2]|0;if((Y|0)>-1){ea=c[s>>2]|0;I=Y;Y=0;do{ia=(I|0)/2|0;if((I&1|0)==0){c[ea+(ia*12|0)>>2]=B}else{c[ea+(ia*12|0)+4>>2]=B}Y=Y+1|0;I=c[A+(Y<<2)>>2]|0;}while((I|0)>-1)}c[A>>2]=-1;Ia=Na;Ja=Oa;Ka=G}c[A>>2]=-1;Pa=Ia;Qa=da;Ra=Ja;Sa=z+1|0;Ta=Ka;Ua=x}else{Pa=w;Qa=x;Ra=y;Sa=z;Ta=0;Ua=B}if((c[J+16>>2]|0)<=0){ka=v;la=Pa;ma=Qa;na=Ra;oa=Sa;pa=Ta;qa=Ua;break}ka=v;la=Pa;ma=Qa+2|0;na=Ra;oa=Sa;pa=Ta;qa=Qa+1|0}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);J=c[F>>2]|0;if((J|0)>-1){Va=0}else{M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=J;c[p+(Va<<2)>>2]=-1;M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break};case 5:{F=u+ -2|0;c[h>>2]=F;H=c[D+(F<<2)>>2]|0;if(!k){M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break b}F=c[H+4>>2]|0;c[H+20>>2]=(c[(c[F+4>>2]|0)+20>>2]|0)+(c[(c[F>>2]|0)+20>>2]|0);M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 2:{F=A;while(1){if((c[F>>2]|0)>-1){F=F+4|0}else{M=v;N=w;O=x;P=y;Q=z;R=F;S=0;T=B;break}}break};case 4:{F=u+ -2|0;c[h>>2]=F;J=c[D+(F<<2)>>2]|0;F=u+ -3|0;c[h>>2]=F;M=v;N=w;O=c[D+(F<<2)>>2]|0;P=y;Q=z;R=A;S=0;T=(J|0)>-1?J:B;break};default:{M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(S|0)==0){u=D;v=M;w=N;x=O;y=P;z=Q;A=R;B=T}else{Z=N;_=P;$=Q;aa=R;ba=S;ca=T;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;T=e;e=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[n+(S*12|0)>>2]=ca}else{c[n+(S*12|0)+4>>2]=ca}e=e+1|0;T=c[aa+(e<<2)>>2]|0;}while((T|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}T=c[f+36>>2]|0;e=0;while(1){Ya=T+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[T+(Za<<2)>>2]=Z;c[T+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;D0(m);D0(p);o=ba;i=g;return o|0}function N$(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;k=P$(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((k|0)!=0){l=k;m=10;break a}k=N$(c[h>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==3){k=c[g+4>>2]|0;j=N$(c[k>>2]|0,b,d,e)|0;if((j|0)!=0){l=j;m=10;break a}n=k+4|0}else if((a|0)==2){k=c[g+4>>2]|0;j=k;if(!((c[k+8>>2]|0)==-1)){n=j;break}h=c[k>>2]|0;k=P$(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else{l=0;m=10;break a}}while(0);g=c[n>>2]|0}if((m|0)==10){i=f;return l|0}return 0}function O$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{D0(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}D0(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){D0(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){D0(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}D0(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{D0(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}D0(m)}m=c[d+32>>2]|0;if((m|0)!=0){D0(m)}m=c[d+20>>2]|0;if((m|0)!=0){D0(m)}m=c[d+36>>2]|0;if((m|0)!=0){D0(m)}D0(d);i=b;return}function P$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=C0(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){D0(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=C0((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function Q$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=a0(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=a0(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=a0(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function R$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=S$(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}B=S$(a,s)|0}else if((q|0)==1){s=c[o+4>>2]|0;r=S$(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=S$(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=S$(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=S$(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function S$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=F0(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;S$(a,b)|0;i=d;return 0}return 0}function T$(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;S$(d,e)|0;e=S$(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==2){y=c[u+4>>2]|0;x=S$(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=S$(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[y>>2]|0;D=c[y+4>>2]|0;E=c[y+8>>2]|0;F=a[y+12|0]|0;y=a0(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}H=a0(b,0,0,1,16)|0;I=y+4|0;c[I>>2]=H;if((H|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[H>>2]=x;c[H+4>>2]=D;c[H+8>>2]=E;E=H+12|0;a[E]=a[E]&-2|F&1;c[y+16>>2]=c[x+16>>2];c[t>>2]=y;A=s;B=r;t=c[I>>2]|0;s=A;r=B;continue b}else if((z|0)==3){I=c[u+4>>2]|0;y=c[I>>2]|0;x=I+4|0;F=c[x>>2]|0;E=a0(b,0,0,1,32)|0;if((E|0)==0){G=20;break b}H=a0(b,0,0,1,8)|0;D=E+4|0;c[D>>2]=H;if((H|0)==0){G=20;break b}c[E>>2]=3;c[E+8>>2]=-1;c[E+12>>2]=-1;c[H>>2]=y;c[(c[D>>2]|0)+4>>2]=F;c[E+16>>2]=(c[F+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=E;E=c[D>>2]|0;D=S$(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,E+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,c[I>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}J=r;K=s;L=E;M=S$(d,0)|0}else if((z|0)==1){E=c[u+4>>2]|0;D=c[E>>2]|0;I=E+4|0;x=c[I>>2]|0;y=a0(b,0,0,1,32)|0;if((y|0)==0){G=29;break b}F=a0(b,0,0,1,8)|0;H=y+4|0;c[H>>2]=F;if((F|0)==0){G=29;break b}c[y>>2]=1;c[y+8>>2]=-1;c[y+12>>2]=-1;c[F>>2]=D;c[(c[H>>2]|0)+4>>2]=x;c[y+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=y;y=c[H>>2]|0;c[y>>2]=0;H=y+4|0;c[H>>2]=0;D=S$(d,c[I>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,H)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=S$(d,c[E>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}J=r;K=s;L=y;M=S$(d,0)|0}else if((z|0)==0){y=c[u+4>>2]|0;D=c[y+8>>2]|0;E=c[y>>2]|0;H=c[y+4>>2]|0;do{if((E|0)>-1|(E|0)==-4){N=r;O=H;P=E;Q=s+1|0;R=(c[g>>2]|0)+D|0}else{if(!((E|0)==-3)){N=r;O=H;P=E;Q=s;R=D;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=H;P=-3;Q=s;R=D;break}c[h+(H<<2)>>2]=1;N=0;O=H;P=-3;Q=s;R=D}}while(0);D=a0(b,0,0,1,32)|0;H=D;do{if((D|0)==0){S=0}else{E=a0(b,0,0,1,20)|0;c[D+4>>2]=E;if((E|0)==0){S=0;break}c[D>>2]=0;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=P;c[E+4>>2]=O;c[E+8>>2]=R;S=H}}while(0);c[t>>2]=S;H=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=H;break}c[k>>2]=R;J=N;K=Q;L=t;M=H}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function U$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a0(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=a0(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=a0(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=a0(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function V$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a0(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=a0(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=a0(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=a0(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function W$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function X$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=119432}else{j=b;k=119432;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((e1(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Kc(e|0,f|0,119720,g|0)|0)+1|0;i=d;return h|0}



function Fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1208>>3]=l;h[e+1200>>3]=m;i=b;return}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1144>>3]=l;h[e+1136>>3]=m;i=b;return}function Hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=-+h[b+1144>>3]- +h[b+856>>3]- +h[b+1240>>3];i=i;return}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1112>>3]=l;h[e+1104>>3]=m;i=b;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1160>>3]=-+h[b+1112>>3]- +h[b+824>>3]- +h[b+1208>>3];i=i;return}function Ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1152>>3]=-+h[b+1104>>3]- +h[b+816>>3]- +h[b+1200>>3];i=i;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=-+h[b+1136>>3]- +h[b+848>>3]- +h[b+1232>>3];i=i;return}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3296>>3]=l;h[e+3288>>3]=m;i=b;return}function Ni(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3280>>3]=l;h[e+3272>>3]=m;i=b;return}function Oi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3264>>3]=l;h[e+3256>>3]=m;i=b;return}function Pi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+12960>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+12936>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+12944>>3];h[a+8>>3]=+h[d+13296>>3];h[e+8>>3]=+h[d+13272>>3];h[f+8>>3]=+h[d+13280>>3];h[a+16>>3]=+h[d+13408>>3];h[e+16>>3]=+h[d+13384>>3];h[f+16>>3]=+h[d+13392>>3];h[a+24>>3]=+h[d+12848>>3];h[e+24>>3]=+h[d+12824>>3];h[f+24>>3]=+h[d+12832>>3];h[a+32>>3]=+h[d+12512>>3];h[e+32>>3]=+h[d+12488>>3];h[f+32>>3]=+h[d+12496>>3];h[a+40>>3]=+h[d+12400>>3];h[e+40>>3]=+h[d+12376>>3];h[f+40>>3]=+h[d+12384>>3];i=i;return}function Qi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+920>>3]=+h[b>>3];h[a+944>>3]=+h[b+8>>3];h[a+952>>3]=+h[b+16>>3];h[a+912>>3]=+h[b+24>>3];h[a+888>>3]=+h[b+32>>3];h[a+880>>3]=+h[b+40>>3];Ai(f);Bi(f);Ci(f);Di(f);Ei(f);Fi(f);Gi(f);Hi(f);Ii(f);Ji(f);Ki(f);Li(f);Mi(f);Ni(f);Oi(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+1192>>3]- +h[f+3296>>3];h[d+8>>3]=+h[f+1184>>3]- +h[f+3288>>3];h[d+16>>3]=+h[f+1160>>3]- +h[f+3280>>3];h[d+24>>3]=+h[f+1152>>3]- +h[f+3272>>3];h[d+32>>3]=+h[f+1176>>3]- +h[f+3264>>3];h[d+40>>3]=+h[f+1168>>3]- +h[f+3256>>3];i=e;return}function Ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2376>>3]=l;h[e+2368>>3]=m;i=b;return}function Si(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2296>>3]=l;h[e+2288>>3]=m;i=b;return}function Ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2392>>3]=l;h[e+2384>>3]=m;i=b;return}function Ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+2480>>3]- +h[b+2288>>3]- +h[b+2384>>3];i=i;return}function Vi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2344>>3]=+h[b+2488>>3]- +h[b+2296>>3]- +h[b+2392>>3];i=i;return}function Wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2280>>3]=l;h[e+2272>>3]=m;i=b;return}function Xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2328>>3]=+h[b+2472>>3]- +h[b+2280>>3]- +h[b+2376>>3];i=i;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2320>>3]=+h[b+2464>>3]- +h[b+2272>>3]- +h[b+2368>>3];i=i;return}function Zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=l;h[e+2256>>3]=m;i=b;return}function _i(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2360>>3]=l;h[e+2352>>3]=m;i=b;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+2456>>3]- +h[b+2264>>3]- +h[b+2360>>3];i=i;return}function aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+2448>>3]- +h[b+2256>>3]- +h[b+2352>>3];i=i;return}function bj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3248>>3]=l;h[e+3240>>3]=m;i=b;return}function cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3232>>3]=l;h[e+3224>>3]=m;i=b;return}function dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3216>>3]=l;h[e+3208>>3]=m;i=b;return}function ej(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+29200>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+29176>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+29184>>3];h[a+8>>3]=+h[d+29312>>3];h[e+8>>3]=+h[d+29288>>3];h[f+8>>3]=+h[d+29296>>3];h[a+16>>3]=+h[d+28976>>3];h[e+16>>3]=+h[d+28952>>3];h[f+16>>3]=+h[d+28960>>3];h[a+24>>3]=+h[d+29088>>3];h[e+24>>3]=+h[d+29064>>3];h[f+24>>3]=+h[d+29072>>3];h[a+32>>3]=+h[d+29424>>3];h[e+32>>3]=+h[d+29400>>3];h[f+32>>3]=+h[d+29408>>3];h[a+40>>3]=+h[d+29536>>3];h[e+40>>3]=+h[d+29512>>3];h[f+40>>3]=+h[d+29520>>3];i=i;return}function fj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+2080>>3]=+h[b>>3];h[a+2088>>3]=+h[b+8>>3];h[a+2064>>3]=+h[b+16>>3];h[a+2072>>3]=+h[b+24>>3];h[a+2096>>3]=+h[b+32>>3];h[a+2104>>3]=+h[b+40>>3];Ri(f);Si(f);Ti(f);Ui(f);Vi(f);Wi(f);Xi(f);Yi(f);Zi(f);_i(f);$i(f);aj(f);bj(f);cj(f);dj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+2312>>3]- +h[f+3248>>3];h[d+8>>3]=+h[f+2304>>3]- +h[f+3240>>3];h[d+16>>3]=+h[f+2328>>3]- +h[f+3232>>3];h[d+24>>3]=+h[f+2320>>3]- +h[f+3224>>3];h[d+32>>3]=+h[f+2344>>3]- +h[f+3216>>3];h[d+40>>3]=+h[f+2336>>3]- +h[f+3208>>3];i=e;return}function gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1848>>3]=l;h[e+1840>>3]=m;i=b;return}function hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1944>>3]=l;h[e+1936>>3]=m;i=b;return}function ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+2040>>3]- +h[b+1848>>3]- +h[b+1944>>3];i=i;return}function jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1928>>3]=l;h[e+1920>>3]=m;i=b;return}function kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+2032>>3]- +h[b+1840>>3]- +h[b+1936>>3];i=i;return}function lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1832>>3]=l;h[e+1824>>3]=m;i=b;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=+h[b+2024>>3]- +h[b+1832>>3]- +h[b+1928>>3];i=i;return}function nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1864>>3]=l;h[e+1856>>3]=m;i=b;return}function oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1872>>3]=+h[b+2016>>3]- +h[b+1824>>3]- +h[b+1920>>3];i=i;return}function pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1960>>3]=l;h[e+1952>>3]=m;i=b;return}function qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=+h[b+2048>>3]- +h[b+1856>>3]- +h[b+1952>>3];i=i;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+2056>>3]- +h[b+1864>>3]- +h[b+1960>>3];i=i;return}function sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3184>>3]=l;h[e+3176>>3]=m;i=b;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3168>>3]=l;h[e+3160>>3]=m;i=b;return}function uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3152>>3]=l;h[e+3144>>3]=m;i=b;return}function vj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+27856>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+27832>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+27840>>3];h[a+8>>3]=+h[d+28192>>3];h[e+8>>3]=+h[d+28168>>3];h[f+8>>3]=+h[d+28176>>3];h[a+16>>3]=+h[d+27968>>3];h[e+16>>3]=+h[d+27944>>3];h[f+16>>3]=+h[d+27952>>3];h[a+24>>3]=+h[d+27632>>3];h[e+24>>3]=+h[d+27608>>3];h[f+24>>3]=+h[d+27616>>3];h[a+32>>3]=+h[d+27744>>3];h[e+32>>3]=+h[d+27720>>3];h[f+32>>3]=+h[d+27728>>3];h[a+40>>3]=+h[d+28080>>3];h[e+40>>3]=+h[d+28056>>3];h[f+40>>3]=+h[d+28064>>3];i=i;return}function wj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1984>>3]=+h[b>>3];h[a+2008>>3]=+h[b+8>>3];h[a+1992>>3]=+h[b+16>>3];h[a+1968>>3]=+h[b+24>>3];h[a+1976>>3]=+h[b+32>>3];h[a+2e3>>3]=+h[b+40>>3];gj(f);hj(f);ij(f);jj(f);kj(f);lj(f);mj(f);nj(f);oj(f);pj(f);qj(f);rj(f);sj(f);tj(f);uj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+1880>>3]- +h[f+3184>>3];h[d+8>>3]=+h[f+1872>>3]- +h[f+3176>>3];h[d+16>>3]=+h[f+1896>>3]- +h[f+3168>>3];h[d+24>>3]=+h[f+1888>>3]- +h[f+3160>>3];h[d+32>>3]=+h[f+1912>>3]- +h[f+3152>>3];h[d+40>>3]=+h[f+1904>>3]- +h[f+3144>>3];i=e;return}function xj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+536>>3]=l;h[e+528>>3]=m;i=b;return}function yj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+488>>3]=l;h[e+480>>3]=m;i=b;return}function zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+504>>3]=l;h[e+496>>3]=m;i=b;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+316>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+440>>3],-+h[j+432>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+520>>3]=l;h[e+512>>3]=m;i=b;return}function Bj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+768>>3]- +h[b+480>>3]- +h[b+528>>3];i=i;return}function Cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+552>>3]=l;h[e+544>>3]=m;i=b;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+792>>3]- +h[b+504>>3]- +h[b+552>>3];i=i;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+784>>3]- +h[b+496>>3]- +h[b+544>>3];i=i;return}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+304>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+456>>3],-+h[j+448>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+568>>3]=l;h[e+560>>3]=m;i=b;return}function Gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+800>>3]- +h[b+512>>3]- +h[b+560>>3];i=i;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+808>>3]- +h[b+520>>3]- +h[b+568>>3];i=i;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=+h[b+776>>3]- +h[b+488>>3]- +h[b+536>>3];i=i;return}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3136>>3]=l;h[e+3128>>3]=m;i=b;return}function Kj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3120>>3]=l;h[e+3112>>3]=m;i=b;return}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+292>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+472>>3],-+h[j+464>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3104>>3]=l;h[e+3096>>3]=m;i=b;return}function Mj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6576>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6552>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6560>>3];h[a+8>>3]=+h[d+6240>>3];h[e+8>>3]=+h[d+6216>>3];h[f+8>>3]=+h[d+6224>>3];h[a+16>>3]=+h[d+6688>>3];h[e+16>>3]=+h[d+6664>>3];h[f+16>>3]=+h[d+6672>>3];h[a+24>>3]=+h[d+6464>>3];h[e+24>>3]=+h[d+6440>>3];h[f+24>>3]=+h[d+6448>>3];h[a+32>>3]=+h[d+6352>>3];h[e+32>>3]=+h[d+6328>>3];h[f+32>>3]=+h[d+6336>>3];h[a+40>>3]=+h[d+6128>>3];h[e+40>>3]=+h[d+6104>>3];h[f+40>>3]=+h[d+6112>>3];i=i;return}function Nj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+464>>3]=+h[b>>3];h[a+440>>3]=+h[b+8>>3];h[a+472>>3]=+h[b+16>>3];h[a+456>>3]=+h[b+24>>3];h[a+448>>3]=+h[b+32>>3];h[a+432>>3]=+h[b+40>>3];xj(f);yj(f);zj(f);Aj(f);Bj(f);Cj(f);Dj(f);Ej(f);Fj(f);Gj(f);Hj(f);Ij(f);Jj(f);Kj(f);Lj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+600>>3]- +h[f+3136>>3];h[d+8>>3]=+h[f+592>>3]- +h[f+3128>>3];h[d+16>>3]=+h[f+616>>3]- +h[f+3120>>3];h[d+24>>3]=+h[f+608>>3]- +h[f+3112>>3];h[d+32>>3]=+h[f+584>>3]- +h[f+3104>>3];h[d+40>>3]=+h[f+576>>3]- +h[f+3096>>3];i=e;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1160>>3]=l;h[e+1152>>3]=m;i=b;return}function Pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1176>>3]=l;h[e+1168>>3]=m;i=b;return}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1112>>3]=l;h[e+1104>>3]=m;i=b;return}function Rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=-+h[b+1112>>3]- +h[b+824>>3]- +h[b+1160>>3];i=i;return}function Sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1128>>3]=l;h[e+1120>>3]=m;i=b;return}function Tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=-+h[b+1128>>3]- +h[b+840>>3]- +h[b+1176>>3];i=i;return}function Uj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=-+h[b+1120>>3]- +h[b+832>>3]- +h[b+1168>>3];i=i;return}function Vj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+208>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+888>>3],-+h[j+880>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1144>>3]=l;h[e+1136>>3]=m;i=b;return}function Wj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+196>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+920>>3],-+h[j+912>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1192>>3]=l;h[e+1184>>3]=m;i=b;return}function Xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=-+h[b+1144>>3]- +h[b+856>>3]- +h[b+1192>>3];i=i;return}function Yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=-+h[b+1136>>3]- +h[b+848>>3]- +h[b+1184>>3];i=i;return}function Zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1200>>3]=-+h[b+1104>>3]- +h[b+816>>3]- +h[b+1152>>3];i=i;return}function _j(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3088>>3]=l;h[e+3080>>3]=m;i=b;return}function $j(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3072>>3]=l;h[e+3064>>3]=m;i=b;return}function ak(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+184>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+952>>3],-+h[j+944>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3056>>3]=l;h[e+3048>>3]=m;i=b;return}function bk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+13296>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+13272>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+13280>>3];h[a+8>>3]=+h[d+13408>>3];h[e+8>>3]=+h[d+13384>>3];h[f+8>>3]=+h[d+13392>>3];h[a+16>>3]=+h[d+12512>>3];h[e+16>>3]=+h[d+12488>>3];h[f+16>>3]=+h[d+12496>>3];h[a+24>>3]=+h[d+12400>>3];h[e+24>>3]=+h[d+12376>>3];h[f+24>>3]=+h[d+12384>>3];h[a+32>>3]=+h[d+12960>>3];h[e+32>>3]=+h[d+12936>>3];h[f+32>>3]=+h[d+12944>>3];h[a+40>>3]=+h[d+12848>>3];h[e+40>>3]=+h[d+12824>>3];h[f+40>>3]=+h[d+12832>>3];i=i;return}function ck(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+944>>3]=+h[b>>3];h[a+952>>3]=+h[b+8>>3];h[a+888>>3]=+h[b+16>>3];h[a+880>>3]=+h[b+24>>3];h[a+920>>3]=+h[b+32>>3];h[a+912>>3]=+h[b+40>>3];Oj(f);Pj(f);Qj(f);Rj(f);Sj(f);Tj(f);Uj(f);Vj(f);Wj(f);Xj(f);Yj(f);Zj(f);_j(f);$j(f);ak(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+1208>>3]- +h[f+3088>>3];h[d+8>>3]=+h[f+1200>>3]- +h[f+3080>>3];h[d+16>>3]=+h[f+1224>>3]- +h[f+3072>>3];h[d+24>>3]=+h[f+1216>>3]- +h[f+3064>>3];h[d+32>>3]=+h[f+1240>>3]- +h[f+3056>>3];h[d+40>>3]=+h[f+1232>>3]- +h[f+3048>>3];i=e;return}function dk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2280>>3]=l;h[e+2272>>3]=m;i=b;return}function ek(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2296>>3]=l;h[e+2288>>3]=m;i=b;return}function fk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+28>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2072>>3],+h[j+2064>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2264>>3]=l;h[e+2256>>3]=m;i=b;return}function gk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2312>>3]=l;h[e+2304>>3]=m;i=b;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2352>>3]=+h[b+2448>>3]- +h[b+2256>>3]- +h[b+2304>>3];i=i;return}function ik(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2328>>3]=l;h[e+2320>>3]=m;i=b;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=+h[b+2472>>3]- +h[b+2280>>3]- +h[b+2328>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+2464>>3]- +h[b+2272>>3]- +h[b+2320>>3];i=i;return}function lk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+16>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2088>>3],+h[j+2080>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2344>>3]=l;h[e+2336>>3]=m;i=b;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+2480>>3]- +h[b+2288>>3]- +h[b+2336>>3];i=i;return}function nk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+2488>>3]- +h[b+2296>>3]- +h[b+2344>>3];i=i;return}function ok(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2360>>3]=+h[b+2456>>3]- +h[b+2264>>3]- +h[b+2312>>3];i=i;return}function pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3024>>3]=l;h[e+3016>>3]=m;i=b;return}function qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+3008>>3]=l;h[e+3e3>>3]=m;i=b;return}function rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+4>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2104>>3],+h[j+2096>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2992>>3]=l;h[e+2984>>3]=m;i=b;return}function sk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+29424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+29400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+29408>>3];h[a+8>>3]=+h[d+29536>>3];h[e+8>>3]=+h[d+29512>>3];h[f+8>>3]=+h[d+29520>>3];h[a+16>>3]=+h[d+29088>>3];h[e+16>>3]=+h[d+29064>>3];h[f+16>>3]=+h[d+29072>>3];h[a+24>>3]=+h[d+29312>>3];h[e+24>>3]=+h[d+29288>>3];h[f+24>>3]=+h[d+29296>>3];h[a+32>>3]=+h[d+29200>>3];h[e+32>>3]=+h[d+29176>>3];h[f+32>>3]=+h[d+29184>>3];h[a+40>>3]=+h[d+28976>>3];h[e+40>>3]=+h[d+28952>>3];h[f+40>>3]=+h[d+28960>>3];i=i;return}function tk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+2096>>3]=+h[b>>3];h[a+2104>>3]=+h[b+8>>3];h[a+2072>>3]=+h[b+16>>3];h[a+2088>>3]=+h[b+24>>3];h[a+2080>>3]=+h[b+32>>3];h[a+2064>>3]=+h[b+40>>3];dk(f);ek(f);fk(f);gk(f);hk(f);ik(f);jk(f);kk(f);lk(f);mk(f);nk(f);ok(f);pk(f);qk(f);rk(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+2376>>3]- +h[f+3024>>3];h[d+8>>3]=+h[f+2368>>3]- +h[f+3016>>3];h[d+16>>3]=+h[f+2392>>3]- +h[f+3008>>3];h[d+24>>3]=+h[f+2384>>3]- +h[f+3e3>>3];h[d+32>>3]=+h[f+2360>>3]- +h[f+2992>>3];h[d+40>>3]=+h[f+2352>>3]- +h[f+2984>>3];i=e;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1880>>3]=l;h[e+1872>>3]=m;i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1928>>3]=l;h[e+1920>>3]=m;i=b;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+2016>>3]- +h[b+1872>>3]- +h[b+1920>>3];i=i;return}function xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1944>>3]=l;h[e+1936>>3]=m;i=b;return}function yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1896>>3]=l;h[e+1888>>3]=m;i=b;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[b+2040>>3]- +h[b+1896>>3]- +h[b+1944>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=+h[b+2032>>3]- +h[b+1888>>3]- +h[b+1936>>3];i=i;return}function Bk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+88>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1992>>3],-+h[j+1984>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1912>>3]=l;h[e+1904>>3]=m;i=b;return}function Ck(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+76>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2008>>3],-+h[j+2e3>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1960>>3]=l;h[e+1952>>3]=m;i=b;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+2056>>3]- +h[b+1912>>3]- +h[b+1960>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+2048>>3]- +h[b+1904>>3]- +h[b+1952>>3];i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+2024>>3]- +h[b+1880>>3]- +h[b+1928>>3];i=i;return}function Gk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2976>>3]=l;h[e+2968>>3]=m;i=b;return}function Hk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2960>>3]=l;h[e+2952>>3]=m;i=b;return}function Ik(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+100>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+1976>>3],-+h[j+1968>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2944>>3]=l;h[e+2936>>3]=m;i=b;return}function Jk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+27632>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+27608>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+27616>>3];h[a+8>>3]=+h[d+27744>>3];h[e+8>>3]=+h[d+27720>>3];h[f+8>>3]=+h[d+27728>>3];h[a+16>>3]=+h[d+28080>>3];h[e+16>>3]=+h[d+28056>>3];h[f+16>>3]=+h[d+28064>>3];h[a+24>>3]=+h[d+27856>>3];h[e+24>>3]=+h[d+27832>>3];h[f+24>>3]=+h[d+27840>>3];h[a+32>>3]=+h[d+27968>>3];h[e+32>>3]=+h[d+27944>>3];h[f+32>>3]=+h[d+27952>>3];h[a+40>>3]=+h[d+28192>>3];h[e+40>>3]=+h[d+28168>>3];h[f+40>>3]=+h[d+28176>>3];i=i;return}function Kk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1968>>3]=+h[b>>3];h[a+1976>>3]=+h[b+8>>3];h[a+2e3>>3]=+h[b+16>>3];h[a+1984>>3]=+h[b+24>>3];h[a+1992>>3]=+h[b+32>>3];h[a+2008>>3]=+h[b+40>>3];uk(f);vk(f);wk(f);xk(f);yk(f);zk(f);Ak(f);Bk(f);Ck(f);Dk(f);Ek(f);Fk(f);Gk(f);Hk(f);Ik(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+1832>>3]- +h[f+2976>>3];h[d+8>>3]=+h[f+1824>>3]- +h[f+2968>>3];h[d+16>>3]=+h[f+1848>>3]- +h[f+2960>>3];h[d+24>>3]=+h[f+1840>>3]- +h[f+2952>>3];h[d+32>>3]=+h[f+1864>>3]- +h[f+2944>>3];h[d+40>>3]=+h[f+1856>>3]- +h[f+2936>>3];i=e;return}function Lk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+312>>3]=l;h[e+304>>3]=m;i=b;return}function Mk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+328>>3]=l;h[e+320>>3]=m;i=b;return}function Nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+248>>3]=l;h[e+240>>3]=m;i=b;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+264>>3]=l;h[e+256>>3]=m;i=b;return}function Pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+408>>3]- +h[b+264>>3]- +h[b+312>>3];i=i;return}function Qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+400>>3]- +h[b+256>>3]- +h[b+304>>3];i=i;return}function Rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+340>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+360>>3],-+h[j+352>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+280>>3]=l;h[e+272>>3]=m;i=b;return}function Sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+416>>3]- +h[b+272>>3]- +h[b+320>>3];i=i;return}function Tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+424>>3]- +h[b+280>>3]- +h[b+328>>3];i=i;return}function Uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+328>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+376>>3],-+h[j+368>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=l;h[e+288>>3]=m;i=b;return}function Vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+384>>3]- +h[b+240>>3]- +h[b+288>>3];i=i;return}function Wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+392>>3]- +h[b+248>>3]- +h[b+296>>3];i=i;return}function Xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2928>>3]=l;h[e+2920>>3]=m;i=b;return}function Yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2912>>3]=l;h[e+2904>>3]=m;i=b;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+352>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+344>>3],-+h[j+336>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+2896>>3]=l;h[e+2888>>3]=m;i=b;return}function _k(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4784>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4760>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4768>>3];h[a+8>>3]=+h[d+5232>>3];h[e+8>>3]=+h[d+5208>>3];h[f+8>>3]=+h[d+5216>>3];h[a+16>>3]=+h[d+4896>>3];h[e+16>>3]=+h[d+4872>>3];h[f+16>>3]=+h[d+4880>>3];h[a+24>>3]=+h[d+5120>>3];h[e+24>>3]=+h[d+5096>>3];h[f+24>>3]=+h[d+5104>>3];h[a+32>>3]=+h[d+5008>>3];h[e+32>>3]=+h[d+4984>>3];h[f+32>>3]=+h[d+4992>>3];h[a+40>>3]=+h[d+5344>>3];h[e+40>>3]=+h[d+5320>>3];h[f+40>>3]=+h[d+5328>>3];i=i;return}function $k(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+336>>3]=+h[b>>3];h[a+368>>3]=+h[b+8>>3];h[a+344>>3]=+h[b+16>>3];h[a+360>>3]=+h[b+24>>3];h[a+352>>3]=+h[b+32>>3];h[a+376>>3]=+h[b+40>>3];Lk(f);Mk(f);Nk(f);Ok(f);Pk(f);Qk(f);Rk(f);Sk(f);Tk(f);Uk(f);Vk(f);Wk(f);Xk(f);Yk(f);Zk(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+232>>3]- +h[f+2928>>3];h[d+8>>3]=+h[f+224>>3]- +h[f+2920>>3];h[d+16>>3]=+h[f+216>>3]- +h[f+2912>>3];h[d+24>>3]=+h[f+208>>3]- +h[f+2904>>3];h[d+32>>3]=+h[f+200>>3]- +h[f+2896>>3];h[d+40>>3]=+h[f+192>>3]- +h[f+2888>>3];i=e;return}function al(a){a=a|0;c[a+4>>2]=79;c[a>>2]=6;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=148;c[a+80>>2]=6;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=185;c[a+160>>2]=6;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=230;c[a+240>>2]=6;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=280;c[a+320>>2]=6;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=351;c[a+400>>2]=6;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=388;c[a+480>>2]=6;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=455;c[a+560>>2]=6;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=513;c[a+640>>2]=6;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=552;c[a+720>>2]=6;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;i=i;return}function bl(a){a=a|0;i=i;return}function cl(a,b){a=a|0;b=b|0;i=i;return}function dl(a){a=a|0;i=i;return}function el(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 1808}function fl(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function gl(a){a=a|0;i=i;return 1808}function hl(a,b){a=a|0;b=b|0;i=i;return 0}function il(a){a=a|0;a=i;i=i+8|0;Ox(8,1,1816,a);if((c[29936>>2]|0)==0){i=a;return 0}Yd[c[7614]&511](8);i=a;return 0}function jl(a){a=a|0;i=i;return c[2016+(a<<2)>>2]|0}function kl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+8|0;Ox(21,1,2032,j);j=a+4|0;l=+h[c[(c[c[j>>2]>>2]|0)+8>>2]>>3];h[b>>3]=l;a=jl(0)|0;c[g>>2]=1;c[g+4>>2]=a;a=g+8|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Ox(21,0,2064,g);l=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3];h[b+8>>3]=l;g=jl(1)|0;c[f>>2]=2;c[f+4>>2]=g;g=f+8|0;h[k>>3]=l;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Ox(21,0,2064,f);l=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3];h[b+16>>3]=l;b=jl(2)|0;c[e>>2]=3;c[e+4>>2]=b;b=e+8|0;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Ox(21,0,2064,e);if((c[29988>>2]|0)==0){i=d;return 0}Yd[c[7614]&511](21);i=d;return 0}function ll(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+224>>3];i=i;return}function ml(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+216>>3]=+h[b+184>>3];i=i;return}function nl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,2);h[(c[a+416>>2]|0)+40>>3]=f;i=b;return}function ol(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+40>>3];i=i;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,1);h[(c[a+416>>2]|0)+32>>3]=f;i=b;return}function ql(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+88>>3]=+h[b+32>>3];i=i;return}function rl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+32|0;d=b;e=b+16|0;Oh(d,c[a+536>>2]|0,3);fz(d,e);f=+Uy(e,0);h[(c[a+416>>2]|0)+24>>3]=f;i=b;return}function sl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+64>>3]=+h[b+24>>3];i=i;return}function tl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16>>3]=+h[b+168>>3];i=i;return}function ul(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+104>>3]=+h[b+16>>3];i=i;return}function vl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8>>3]=+h[b+168>>3];i=i;return}function wl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+80>>3]=+h[b+8>>3];i=i;return}function xl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b>>3]=+h[b+168>>3];i=i;return}function yl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+56>>3]=+h[b>>3];i=i;return}function zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+176>>3];i=i;return}function Al(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+48>>3]=+h[b+208>>3];i=i;return}function Bl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+72>>3]=+h[b+208>>3];i=i;return}function Cl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+96>>3]=+h[b+208>>3];i=i;return}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+176>>3]*+h[f+184>>3]*10.88279618540531;if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+200|0;o=n;h[o>>3]=l;i=d;return}p=+Ux(c[b+536>>2]|0,g,2088,2080,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+200|0;o=n;h[o>>3]=l;i=d;return}function El(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+200>>3];i=i;return}function Fl(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+176>>3];j=+h[f+184>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+Ux(c[b+536>>2]|0,g,2128,2120,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+192>>3]=l*.275664447710896;i=d;return}function Gl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+192>>3];i=i;return}function Hl(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=d*+h[b+104>>3];i=i;return}function Il(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+112>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=d*+h[b+104>>3];i=i;return}function Jl(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=d*+h[b+80>>3];i=i;return}function Kl(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+88>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=d*+h[b+80>>3];i=i;return}function Ll(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+Y(+(+h[b+64>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=d*+h[b+56>>3];i=i;return}function Ml(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+X(+(+h[b+64>>3]));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=d*+h[b+56>>3];i=i;return}function Nl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=+h[(c[a+416>>2]|0)+48>>3]*6.283185307179586;i=i;return}function Ol(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=+h[b+216>>3]*(+h[b+232>>3]*(+h[b+240>>3]- +h[b+224>>3])+1.0);i=i;return}function Pl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=+h[(c[a+416>>2]|0)+96>>3]*6.283185307179586;i=i;return}function Ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=+h[(c[a+416>>2]|0)+72>>3]*6.283185307179586;i=i;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=-(+h[b+2608>>3]*+h[(c[a+416>>2]|0)+248>>3]*+h[b+2640>>3]);i=i;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=+h[b+2608>>3]*+h[(c[a+416>>2]|0)+248>>3]*+h[b+2632>>3];i=i;return}function Tl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+256>>3]*+h[g+2608>>3];k=+h[g+2616>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ux(c[b+536>>2]|0,j,2144,2136,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2808|0;q=p;h[q>>3]=n;i=d;return}function Ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+256>>3]*+h[g+2608>>3];k=-j;l=+h[g+2624>>3];m=-l;if(j!=-0.0){n=g;o=m/k;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=g;o=m;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}l=m/+Ux(c[b+536>>2]|0,k,2208,2200,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+2800|0;r=q;h[r>>3]=o;i=d;return}function Vl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2648>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ux(c[b+536>>2]|0,j,2272,2264,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2792|0;p=o;h[p>>3]=m;i=d;return}function Wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2656>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ux(c[b+536>>2]|0,j,2272,2296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2784|0;p=o;h[p>>3]=m;i=d;return}function Xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2776>>3]=+h[b+2648>>3]*+h[b+2792>>3]+ +h[b+2656>>3]*+h[b+2784>>3];i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b+2496>>3];i=i;return}function Zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+2504>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=+h[b+2608>>3];i=i;return}function $l(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+56>>3]=l;h[e+48>>3]=m;i=b;return}function am(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+72>>3]=l;h[e+64>>3]=m;i=b;return}function bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+572>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2792>>3],-+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+88>>3]=l;h[e+80>>3]=m;i=b;return}function cm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+104>>3]=l;h[e+96>>3]=m;i=b;return}function dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+120>>3]=l;h[e+112>>3]=m;i=b;return}function em(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+560>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2824>>3],-+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+136>>3]=l;h[e+128>>3]=m;i=b;return}function fm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+152>>3]=l;h[e+144>>3]=m;i=b;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=-+h[b+96>>3]- +h[b+48>>3]- +h[b+144>>3];i=i;return}function hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-+h[b+104>>3]- +h[b+56>>3]- +h[b+152>>3];i=i;return}function im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+168>>3]=l;h[e+160>>3]=m;i=b;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=-+h[b+112>>3]- +h[b+64>>3]- +h[b+160>>3];i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=-+h[b+120>>3]- +h[b+72>>3]- +h[b+168>>3];i=i;return}function lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+548>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,-+h[j+2800>>3],-+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+184>>3]=l;h[e+176>>3]=m;i=b;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=-+h[b+128>>3]- +h[b+80>>3]- +h[b+176>>3];i=i;return}function nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=-+h[b+136>>3]- +h[b+88>>3]- +h[b+184>>3];i=i;return}function om(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+376>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+376|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+376>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+352|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+352>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+336>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+336|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+336>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+360>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+360|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+NB(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+360>>3]);e=c[f>>2]|0;h[(c[e+52>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+344>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+344|0;h[(c[e+48>>2]|0)+32>>3]=+h[g>>3];k=+NB(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+344>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+368>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+368|0;h[(c[j+48>>2]|0)+40>>3]=+h[e>>3];k=+NB(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+368>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+40>>3]=k;LB(a,0)|0;g=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+376>>3]=+h[g>>3];h[f+352>>3]=+h[g+8>>3];h[f+336>>3]=+h[g+16>>3];h[f+360>>3]=+h[g+24>>3];h[f+344>>3]=+h[g+32>>3];h[f+368>>3]=+h[g+40>>3];Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);i=b;return}function pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2720>>3]=-+h[b+360>>3]- +h[b+344>>3]- +h[b+376>>3];i=i;return}function qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2712>>3]=-+h[b+352>>3]- +h[b+336>>3]- +h[b+368>>3];i=i;return}function rm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+968>>3]=g;h[e+960>>3]=j;i=b;return}function sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+984>>3]=g;h[e+976>>3]=j;i=b;return}function tm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+244>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1e3>>3]=g;h[e+992>>3]=j;i=b;return}function um(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1016>>3]=g;h[e+1008>>3]=j;i=b;return}function vm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1032>>3]=g;h[e+1024>>3]=j;i=b;return}function wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+232>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1048>>3]=g;h[e+1040>>3]=j;i=b;return}function xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==3){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1064>>3]=g;h[e+1056>>3]=j;i=b;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1064>>3]+(+h[b+968>>3]+ +h[b+1016>>3]);i=i;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+1056>>3]+(+h[b+960>>3]+ +h[b+1008>>3]);i=i;return}function Am(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==2){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1080>>3]=g;h[e+1072>>3]=j;i=b;return}function Bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1080>>3]+(+h[b+984>>3]+ +h[b+1032>>3]);i=i;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1072>>3]+(+h[b+976>>3]+ +h[b+1024>>3]);i=i;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+220>>2]|0)==1){Rh(d,f,-0.0,-0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1096>>3]=g;h[e+1088>>3]=j;i=b;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[b+1096>>3]+(+h[b+1e3>>3]+ +h[b+1048>>3]);i=i;return}function Fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1568>>3]=+h[b+1088>>3]+(+h[b+992>>3]+ +h[b+1040>>3]);i=i;return}function Gm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1256>>3]=g;h[e+1248>>3]=j;i=b;return}function Hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1272>>3]=g;h[e+1264>>3]=j;i=b;return}function Im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+172>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1288>>3]=g;h[e+1280>>3]=j;i=b;return}function Jm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1304>>3]=g;h[e+1296>>3]=j;i=b;return}function Km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1320>>3]=g;h[e+1312>>3]=j;i=b;return}function Lm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+160>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1336>>3]=g;h[e+1328>>3]=j;i=b;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==3){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1352>>3]=g;h[e+1344>>3]=j;i=b;return}function Nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1352>>3]+(+h[b+1256>>3]+ +h[b+1304>>3]);i=i;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=+h[b+1344>>3]+(+h[b+1248>>3]+ +h[b+1296>>3]);i=i;return}function Pm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==2){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1368>>3]=g;h[e+1360>>3]=j;i=b;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+1360>>3]+(+h[b+1264>>3]+ +h[b+1312>>3]);i=i;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+1368>>3]+(+h[b+1272>>3]+ +h[b+1320>>3]);i=i;return}function Sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+148>>2]|0)==1){Rh(d,f,0.0,0.0);g=+h[d>>3];j=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);g=+h[e>>3];j=+h[e+8>>3]}e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1384>>3]=g;h[e+1376>>3]=j;i=b;return}function Tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[b+1384>>3]+(+h[b+1288>>3]+ +h[b+1336>>3]);i=i;return}function Um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+1376>>3]+(+h[b+1280>>3]+ +h[b+1328>>3]);i=i;return}function Vm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1688>>3]=l;h[e+1680>>3]=m;i=b;return}function Wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1704>>3]=l;h[e+1696>>3]=m;i=b;return}function Xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+436>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2792>>3],+h[j+2784>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1720>>3]=l;h[e+1712>>3]=m;i=b;return}function Ym(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1736>>3]=l;h[e+1728>>3]=m;i=b;return}function Zm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1752>>3]=l;h[e+1744>>3]=m;i=b;return}function _m(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+424>>2]|0)==1){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2824>>3],+h[j+2816>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1768>>3]=l;h[e+1760>>3]=m;i=b;return}function $m(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==3){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1784>>3]=l;h[e+1776>>3]=m;i=b;return}function an(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=-+h[b+1736>>3]- +h[b+1688>>3]- +h[b+1784>>3];i=i;return}function bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+768>>3]=-+h[b+1728>>3]- +h[b+1680>>3]- +h[b+1776>>3];i=i;return}function cn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+32|0;d=b;e=b+16|0;f=c[a+536>>2]|0;if((c[(c[a+420>>2]|0)+412>>2]|0)==2){g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;Rh(d,f,+h[j+2800>>3],+h[j+2808>>3]);k=g;l=+h[d>>3];m=+h[d+8>>3]}else{Nh(e,f,0.0,0.0);k=a+4|0;l=+h[e>>3];m=+h[e+8>>3]}e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[e+1800>>3]=l;h[e+1792>>3]=m;i=b;return}function dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=-+h[b+1744>>3]- +h[b+1696>>3]- +h[b+1792>>3];i=i;return}function en(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=-+h[b+1752>>3]- +h[b+1704>>3]- +h[b+1800>>3];i=i;return}



function GG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Az(3);u=b;v=hc(c[u>>2]|0,72952)|0;if((v|0)==0){HG(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Nd(c[(Lc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Sx(w,72960,q)}pc(73016,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];od(v|0,73064,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];od(v|0,73088,o|0)|0;pc(73112,40,1,v|0)|0;pc(73160,11,1,v|0)|0;pc(73176,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];IG(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{pc(73192,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;IG(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Jd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];od(v|0,73216,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;IG(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Jd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];od(v|0,73216,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;IG(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Jd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];od(v|0,73216,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;IG(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Jd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];od(v|0,73216,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;IG(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Jd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];od(v|0,73216,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;IG(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Jd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];od(v|0,73216,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;IG(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Jd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}HG(t);if((Vc(v|0)|0)==0){D0(c[r>>2]|0);c[r>>2]=0;Dz(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Sx(e,73232,f)}}function HG(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}D0(a);c[d>>2]=0;i=b;return}function IG(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];od(a|0,73280,f|0)|0;i=e;return}function JG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=I0(192)|0;i1(m|0,0,192)|0;KG(m);c[a+12>>2]=m;n=m;o=a;fD(n,c[o>>2]|0,36);if(iT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Sx(a,73320,g)}else{g=m;NU(g,73296,14)|0;OU(h,g);a=sE(h)|0;h=m+184|0;c[h>>2]=a;NU(g,73312,4)|0;LG(n,b+8|0);OU(j,g);b=sE(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;eD(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];PU(g,f)|0;MG(n,-4-m+b|0);b=c[j>>2]|0;eD(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];PU(g,e)|0;Dz(3);i=d;return}}function KG(a){a=a|0;var b=0;b=i;dH(a);i=b;return}function LG(a,b){a=a|0;b=b|0;var c=0;c=i;OG(a,3);PG(a,73496);OG(a,0);PG(a,73504);OG(a,2);_G(a,b);$G(a,b);PG(a,73512);OG(a,0);i=c;return}function MG(a,b){a=a|0;b=b|0;var d=0;d=i;c[18372]=yd(b|0)|0;NU(a,73488,4)|0;i=d;return}function NG(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;OU(l,q);r=sE(l)|0;MG(b,0);OU(m,q);l=sE(m)|0;OG(b,1);PG(b,73384);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;QG(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);RG(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{RG(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{SG(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{TG(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{PG(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}OU(n,q);u=sE(n)|0;n=f1(0,r|0,32)|0;eD(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];PU(q,k)|0;MG(b,u-l|0);eD(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];PU(q,j)|0;i=g;return}function OG(b,d){b=b|0;d=d|0;var e=0;e=i;a[73472]=-33;c[18370]=yd(d|0)|0;d=b;NU(d,73472,1)|0;NU(d,73480,4)|0;i=e;return}function PG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=yd(e1(d|0)|0)|0;a[73464]=-37;g=b;NU(g,73464,1)|0;NU(g,f,4)|0;NU(g,d,e1(d|0)|0)|0;i=e;return}function QG(b,d){b=b|0;d=d|0;var e=0;e=i;a[73448]=-35;c[18364]=yd(d|0)|0;d=b;NU(d,73448,1)|0;NU(d,73456,4)|0;i=e;return}function RG(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[73432]=-53;ZG(c);e=b;NU(e,73432,1)|0;NU(e,73440,8)|0;i=d;return}function SG(b,d){b=b|0;d=d|0;var e=0;e=i;a[73416]=-46;c[18356]=yd(d|0)|0;d=b;NU(d,73416,1)|0;NU(d,73424,4)|0;i=e;return}function TG(b,c){b=b|0;c=c|0;var d=0;d=i;a[73408]=c?-61:-62;NU(b,73408,1)|0;i=d;return}function UG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;NG(e,+h[f>>3],a,f);NG(e,+h[b+248>>3],a,f);i=d;return}function VG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;OU(j,p);o=sE(j)|0;MG(b,0);OU(k,p);j=sE(k)|0;OG(b,1);PG(b,73392);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;QG(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;RG(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{RG(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{SG(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{TG(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{PG(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}OU(l,p);s=sE(l)|0;l=f1(0,o|0,32)|0;eD(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];PU(p,g)|0;MG(b,s-j|0);eD(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];PU(p,f)|0;i=e;return}function WG(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;_C(a);Az(3);if((a|0)!=0){XG(a);K0(a)}c[d>>2]=0;Dz(3);i=b;return}function XG(a){a=a|0;var b=0;b=i;YG(a);i=b;return}function YG(a){a=a|0;var b=0;b=i;vE(a);i=b;return}function ZG(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((yd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=73440;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[73440+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function _G(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;PG(a,73384);OG(a,4);PG(a,73520);OG(a,0);PG(a,73528);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;QG(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);PG(a,73536);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{PG(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{PG(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{PG(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{PG(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=73624;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];aH(a,b,e);PG(a,73560);OG(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);bH(a,73536,73568);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;bH(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;bH(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;bH(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;bH(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function $G(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;PG(a,73392);OG(a,4);PG(a,73520);OG(a,0);PG(a,73528);o=g+1+j+l+n|0;QG(a,o);PG(a,73536);if((c[f>>2]|0)>0){n=b;l=0;do{PG(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{PG(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{PG(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{PG(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=73544;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];aH(a,b,e);PG(a,73560);OG(a,o);bH(a,73536,73568);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;bH(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;bH(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;bH(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;bH(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function aH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;PG(b,73592);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}OG(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?73536:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}cH(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?73536:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}cH(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?73536:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}cH(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?73536:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}cH(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function bH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;PG(a,b);OG(a,1);PG(a,73576);PG(a,c);i=d;return}function cH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;PG(a,b);OG(a,d?2:1);PG(a,73600);PG(a,c);if(!d){i=e;return}PG(a,73608);PG(a,73616);i=e;return}function dH(a){a=a|0;var b=0;b=i;lG(a);i=b;return}function eH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;rS(e,73640);nS(d,gH(a,e)|0);fH(d,b+4|0);xS(d);xS(e);rS(g,73648);nS(f,gH(a,g)|0);hH(f,b);xS(f);xS(g);rS(j,73664);nS(h,gH(a,j)|0);fH(h,b+8|0);xS(h);xS(j);rS(l,73680);nS(k,gH(a,l)|0);fH(k,b+12|0);xS(k);xS(l);rS(n,73696);nS(m,gH(a,n)|0);iH(m,b+16|0,0);xS(m);xS(n);rS(p,73712);nS(o,gH(a,p)|0);iH(o,b+20|0,0);xS(o);xS(p);rS(r,73728);nS(q,gH(a,r)|0);iH(q,b+24|0,0);xS(q);xS(r);rS(t,73736);nS(s,gH(a,t)|0);iH(s,b+28|0,0);xS(s);xS(t);rS(v,73752);nS(u,gH(a,v)|0);iH(u,b+32|0,0);xS(u);xS(v);i=c;return}function fH(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Qx(22,0,76960,d);i=d;return}else{c[b>>2]=rd(US(a)|0)|0;i=d;return}}function gH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=pL(a,f,b)|0;l=c[k>>2]|0;SD(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}rL(j,a,b);sL(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];qL(g,e);tL(j);j=c[f>>2]|0;uL(a,j,k,vL(g)|0);k=wL(g)|0;tL(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function hH(a,b){a=a|0;b=b|0;var d=0;d=i;if((XS(a,73928)|0)==0){c[b>>2]=1;i=d;return}if((XS(a,73936)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Dc(US(a)|0)|0;i=d;return}}function iH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((XS(a,73904)|0)==0){c[b>>2]=d}if((XS(a,73928)|0)==0){c[b>>2]=1;i=e;return}if((XS(a,73936)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Dc(US(a)|0)|0;i=e;return}}function jH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;rS(j,73768);nS(g,gH(b,j)|0);y=d+48|0;kH(g,y);xS(g);xS(j);rS(m,73784);nS(l,gH(b,m)|0);j=d+56|0;lH(l,j,0.0);xS(l);xS(m);rS(o,73792);nS(n,gH(b,o)|0);m=d+32|0;kH(n,m);xS(n);xS(o);rS(q,73800);nS(p,gH(b,q)|0);o=d+33|0;kH(p,o);xS(p);xS(q);rS(s,73816);nS(r,gH(b,s)|0);q=d+40|0;lH(r,q,1.0);xS(r);xS(s);rS(u,73824);nS(t,gH(b,u)|0);s=d+16|0;lH(t,s,-1.7976931348623157e+308);xS(t);xS(u);rS(w,73832);nS(v,gH(b,w)|0);u=d+24|0;lH(v,u,1.7976931348623157e+308);xS(v);xS(w);rS(x,73640);w=US(gH(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?73928:73936;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?73904:73912;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?73904:73920;c[f+20>>2]=j;c[f+24>>2]=m?73904:73912;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?73904:73920;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Ox(4,0,73840,f);xS(x);i=e;return}function kH(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(XS(b,73928)|0)==0|0;i=d;return}function lH(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((XS(a,73904)|0)==0){h[b>>3]=c;i=d;return}if((XS(a,73928)|0)==0){h[b>>3]=1.0;i=d;return}if((XS(a,73936)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+Y0(US(a)|0);i=d;return}}function mH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;rS(h,73768);nS(g,gH(b,h)|0);s=d+13|0;kH(g,s);xS(g);xS(h);rS(k,73784);nS(j,gH(b,k)|0);h=d+16|0;iH(j,h,0);xS(j);xS(k);rS(m,73792);nS(l,gH(b,m)|0);k=d+12|0;kH(l,k);xS(l);xS(m);rS(o,73824);nS(n,gH(b,o)|0);m=d+4|0;iH(n,m,-2147483648);xS(n);xS(o);rS(q,73832);nS(p,gH(b,q)|0);o=d+8|0;iH(p,o,2147483647);xS(p);xS(q);rS(r,73640);q=US(gH(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?73928:73936;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?73904:73912;c[f+8>>2]=s;c[f+12>>2]=b?73904:73920;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;Ox(4,0,73944,f);xS(r);i=e;return}function nH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;rS(h,73768);nS(g,gH(b,h)|0);o=d+5|0;kH(g,o);xS(g);xS(h);rS(k,73784);nS(j,gH(b,k)|0);h=d+6|0;kH(j,h);xS(j);xS(k);rS(m,73792);nS(l,gH(b,m)|0);k=d+4|0;kH(l,k);xS(l);xS(m);rS(n,73640);m=US(gH(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?73928:73936;h=(a[k]|0)!=0?73928:73936;c[f>>2]=m;c[f+4>>2]=b?73904:73912;c[f+8>>2]=o;c[f+12>>2]=b?73904:73920;c[f+16>>2]=h;Ox(4,0,74e3,f);xS(n);i=e;return}function oH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;rS(h,73768);nS(g,gH(b,h)|0);m=d+4|0;kH(g,m);xS(g);xS(h);rS(k,73784);nS(j,gH(b,k)|0);h=d+8|0;fH(j,h);xS(j);xS(k);rS(l,73640);k=US(gH(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?73904:73912;c[f+8>>2]=m;c[f+12>>2]=b?73904:73920;Ox(4,0,74040,f);xS(l);i=e;return}function pH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Wc=qa;qH(qa);lS(ra);rH(sa,ta);rH(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[87024>>2]|0)==0){rS(za,c[b+80>>2]|0);sH(ya,za,74064);yS(ra,ya)|0;xS(ya);xS(za)}else{zS(ra,c[87152>>2]|0)|0}ta=hc(US(ra)|0,74080)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=US(ra)|0;Sx(0,74088,pa)}else{Xc=0}}while(0);pa=Fs(0)|0;if((pa|0)==0){Vc(Xc|0)|0;Sx(0,74192,oa)}Qs(pa,Wc);Rs(pa,9,54);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;i1(oa|0,0,1024)|0;while(1){za=rb(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((Ss(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Vc(Xc|0)|0;oa=US(ra)|0;ya=_s(Xs(pa)|0)|0;za=Ys(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Qx(1,0,74272,na);Ms(pa);Sx(0,74360,ma)}else if((Yc|0)==14){Vc(Xc|0)|0;break}}else{if((Ss(pa,Wc,e1(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=_s(Xs(pa)|0)|0;ta=Ys(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;od(za|0,74384,la|0)|0;za=c[va>>2]|0;ta=_s(Xs(pa)|0)|0;oa=Ys(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Qx(1,0,74400,ka);Ms(pa);Sx(0,74360,ja)}}while(0);ja=qa;rS(Ca,74488);wH(Ba,ja,Ca);xH(Da,ja);ka=vH(Ba,Da)|0;xS(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=US(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Qx(1,0,74496,ia)}else{rS(Ea,74488);Ba=a1(Da,US(gH(ja,Ea)|0)|0)|0;xS(Ea);if((Ba|0)==0){break}Ms(pa);rS(Fa,74488);Ba=US(gH(ja,Fa)|0)|0;va=US(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Qx(1,0,74544,ha);xS(Fa);Sx(0,74360,ga)}}while(0);yH(qa,b,c[87236>>2]|0,c[87240>>2]|0);Ox(23,1,74640,fa);fa=qa+12|0;rS(Ha,74680);nS(Ga,gH(fa,Ha)|0);ga=d;lH(Ga,ga,0.0);xS(Ga);xS(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];Ox(23,0,74696,ea);rS(Ja,74712);nS(Ia,gH(fa,Ja)|0);ea=d+8|0;lH(Ia,ea,1.0);xS(Ia);xS(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];Ox(23,0,74728,da);rS(La,74744);nS(Ka,gH(fa,La)|0);da=d+24|0;lH(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);xS(Ka);xS(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];Ox(23,0,74760,ca);rS(Na,74776);nS(Ma,gH(fa,Na)|0);ca=d+32|0;lH(Ma,ca,1.0e-5);xS(Ma);xS(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];Ox(23,0,74792,ba);rS(Pa,74808);nS(Oa,gH(fa,Pa)|0);ba=d+40|0;fH(Oa,ba);xS(Oa);xS(Pa);c[aa>>2]=c[ba>>2];Ox(23,0,74816,aa);rS(Ra,74840);nS(Qa,gH(fa,Ra)|0);aa=d+44|0;fH(Qa,aa);xS(Qa);xS(Ra);c[$>>2]=c[aa>>2];Ox(23,0,74856,$);rS(Ta,74880);nS(Sa,gH(fa,Ta)|0);fa=d+48|0;fH(Sa,fa);xS(Sa);xS(Ta);c[_>>2]=c[fa>>2];Ox(23,0,74896,_);rS(Va,74920);nS(Ua,gH(ja,Va)|0);_=d+268|0;fH(Ua,_);xS(Ua);xS(Va);c[Z>>2]=c[_>>2];Ox(23,0,74944,Z);if((c[29996>>2]|0)!=0){Yd[c[7614]&511](23)}rS(eb,74968);nS(db,gH(ja,eb)|0);iH(db,Wa,0);xS(db);xS(eb);rS(gb,75e3);nS(fb,gH(ja,gb)|0);iH(fb,Xa,0);xS(fb);xS(gb);rS(ib,75032);nS(hb,gH(ja,ib)|0);iH(hb,Ya,0);xS(hb);xS(ib);rS(kb,75056);nS(jb,gH(ja,kb)|0);iH(jb,_a,0);xS(jb);xS(kb);rS(mb,75088);nS(lb,gH(ja,mb)|0);iH(lb,Za,0);xS(lb);xS(mb);rS(ob,75128);nS(nb,gH(ja,ob)|0);iH(nb,ab,0);xS(nb);xS(ob);rS(qb,75160);nS(pb,gH(ja,qb)|0);iH(pb,$a,0);xS(pb);xS(qb);rS(tb,75200);nS(sb,gH(ja,tb)|0);iH(sb,cb,0);xS(sb);xS(tb);rS(vb,75232);nS(ub,gH(ja,vb)|0);iH(ub,bb,0);xS(ub);xS(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=75776;Ox(4,1,75752,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=zH(lb,wb)|0;eH(ib,jb+(kb*112|0)|0);jH(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(xb,75792);jb=(XS(gH(ib,xb)|0,73928)|0)==0;xS(xb);if(!jb){break}c[N>>2]=c[hb>>2];Ox(4,0,75808,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);rS(yb,c[hb>>2]|0);c[(AH(sa,yb)|0)>>2]=kb;xS(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[M>>2]=75840;Ox(4,1,75752,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=zH(lb,zb)|0;eH(fb,gb+(jb*112|0)|0);jH(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Ab,75792);gb=(XS(gH(fb,Ab)|0,73928)|0)==0;xS(Ab);if(!gb){break}c[L>>2]=c[eb>>2];Ox(4,0,75808,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);rS(Bb,c[eb>>2]|0);c[(AH(sa,Bb)|0)>>2]=jb;xS(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[K>>2]=75864;Ox(4,1,75752,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=zH(mb,Cb)|0;eH(gb,hb+(fb*112|0)|0);jH(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Db,75792);hb=(XS(gH(gb,Db)|0,73928)|0)==0;xS(Db);if(!hb){break}c[J>>2]=c[db>>2];Ox(4,0,75808,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);rS(Eb,c[db>>2]|0);c[(AH(sa,Eb)|0)>>2]=fb;xS(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[I>>2]=75880;Ox(4,1,75752,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=zH(ub,Fb)|0;eH(mb,kb+(ib*60|0)|0);mH(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Gb,75792);kb=(XS(gH(mb,Gb)|0,73928)|0)==0;xS(Gb);if(!kb){break}c[H>>2]=c[gb>>2];Ox(4,0,75808,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);rS(Hb,c[gb>>2]|0);c[(AH(sa,Hb)|0)>>2]=ib;xS(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[G>>2]=75904;Ox(4,1,75752,G);if((c[pb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=zH(ib,Ib)|0;eH(mb,ub+(lb*48|0)|0);nH(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Jb,75792);ub=(XS(gH(mb,Jb)|0,73928)|0)==0;xS(Jb);if(!ub){break}c[F>>2]=c[fb>>2];Ox(4,0,75808,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);rS(Kb,c[fb>>2]|0);c[(AH(sa,Kb)|0)>>2]=lb;xS(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[E>>2]=75928;Ox(4,1,75752,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=sb;mb=zH(lb,Lb)|0;eH(mb,ib+(sb*52|0)|0);oH(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Mb,75792);ib=(XS(gH(mb,Mb)|0,73928)|0)==0;xS(Mb);if(!ib){break}c[D>>2]=c[gb>>2];Ox(4,0,75808,D);a[(c[pb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);rS(Nb,c[gb>>2]|0);c[(AH(sa,Nb)|0)>>2]=sb;xS(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[C>>2]=75952;Ox(4,1,75752,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=zH(sb,Ob)|0;eH(mb,lb+(pb*112|0)|0);jH(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Pb,75792);lb=(XS(gH(mb,Pb)|0,73928)|0)==0;xS(Pb);if(!lb){break}c[B>>2]=c[fb>>2];Ox(4,0,75808,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);rS(Qb,c[fb>>2]|0);c[(AH(ua,Qb)|0)>>2]=pb;xS(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[A>>2]=75968;Ox(4,1,75752,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=zH(pb,Rb)|0;eH(mb,sb+(nb*60|0)|0);mH(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Sb,75792);sb=(XS(gH(mb,Sb)|0,73928)|0)==0;xS(Sb);if(!sb){break}c[z>>2]=c[gb>>2];Ox(4,0,75808,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);rS(Tb,c[gb>>2]|0);c[(AH(ua,Tb)|0)>>2]=nb;xS(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[y>>2]=75992;Ox(4,1,75752,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=zH(nb,Ub)|0;eH(mb,pb+(ja*48|0)|0);nH(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Vb,75792);pb=(XS(gH(mb,Vb)|0,73928)|0)==0;xS(Vb);if(!pb){break}c[x>>2]=c[fb>>2];Ox(4,0,75808,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);rS(Wb,c[fb>>2]|0);c[(AH(ua,Wb)|0)>>2]=ja;xS(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}c[w>>2]=76016;Ox(4,1,75752,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=zH(ja,Xb)|0;eH(mb,nb+(tb*52|0)|0);oH(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[87020>>2]|0)!=0){break}rS(Yb,75792);nb=(XS(gH(mb,Yb)|0,73928)|0)==0;xS(Yb);if(!nb){break}c[v>>2]=c[gb>>2];Ox(4,0,75808,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);rS(Zb,c[gb>>2]|0);c[(AH(ua,Zb)|0)>>2]=tb;xS(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}Ox(4,1,76040,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=zH(tb,_b)|0;eH(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);lS($b);c[bc>>2]=ja;mb=zH(tb,bc)|0;rS(cc,76080);nS(ac,gH(mb,cc)|0);BH(ac,$b);xS(ac);xS(cc);mb=(XS($b,76088)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;Ox(4,0,76104,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=zH(tb,ec)|0;rS(fc,76144);nS(dc,gH(nb,fc)|0);BH(dc,$b);xS(dc);xS(fc);CH(wa,sa,$b);CH(xa,ua,$b);EH(gc,sa);do{if(DH(wa,gc)|0){nb=c[(FH(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{EH(ic,ua);if(DH(xa,ic)|0){fb=c[(FH(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((XS($b,76160)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);xS($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}gT(kc,76168,$b);sH(jc,kc,76192);xS(kc);c[s>>2]=US(jc)|0;Sx(0,76208,s)}}while(0);if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}Ox(4,1,76216,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=zH(ja,lc)|0;eH(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);lS(mc);c[oc>>2]=tb;gb=zH(ja,oc)|0;rS(pc,76080);nS(nc,gH(gb,pc)|0);BH(nc,mc);xS(nc);xS(pc);gb=(XS(mc,76088)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;Ox(4,0,76104,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=zH(ja,rc)|0;rS(sc,76144);nS(qc,gH(fb,sc)|0);BH(qc,mc);xS(qc);xS(sc);CH(wa,sa,mc);CH(xa,ua,mc);EH(tc,sa);if(DH(wa,tc)|0){fb=c[(FH(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{EH(uc,ua);if(!(DH(xa,uc)|0)){break}nb=c[(FH(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}xS(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}gT(wc,76256,mc);sH(vc,wc,76192);xS(wc);c[o>>2]=US(vc)|0;Sx(0,76208,o)}}while(0);if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}Ox(4,1,76280,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=zH(tb,xc)|0;eH(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);lS(yc);c[Ac>>2]=ja;fb=zH(tb,Ac)|0;rS(Bc,76080);nS(zc,gH(fb,Bc)|0);BH(zc,yc);xS(zc);xS(Bc);fb=(XS(yc,76088)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;Ox(4,0,76104,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=zH(tb,Dc)|0;rS(Ec,76144);nS(Cc,gH(gb,Ec)|0);BH(Cc,yc);xS(Cc);xS(Ec);CH(wa,sa,yc);CH(xa,ua,yc);EH(Fc,sa);if(DH(wa,Fc)|0){gb=c[(FH(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{EH(Gc,ua);if(!(DH(xa,Gc)|0)){break}nb=c[(FH(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}xS(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}gT(Ic,76320,yc);sH(Hc,Ic,76192);xS(Ic);c[l>>2]=US(Hc)|0;Sx(0,76208,l)}}while(0);if((c[29920>>2]|0)!=0){Yd[c[7614]&511](4)}Ox(4,1,76344,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=zH(ja,Jc)|0;eH(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);lS(Kc);c[Mc>>2]=tb;gb=zH(ja,Mc)|0;rS(Nc,76080);nS(Lc,gH(gb,Nc)|0);BH(Lc,Kc);xS(Lc);xS(Nc);gb=(XS(Kc,76088)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;Ox(4,0,76104,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=zH(ja,Pc)|0;rS(Qc,76144);nS(Oc,gH(fb,Qc)|0);BH(Oc,Kc);xS(Oc);xS(Qc);CH(wa,sa,Kc);CH(xa,ua,Kc);EH(Rc,sa);if(DH(wa,Rc)|0){fb=c[(FH(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{EH(Sc,ua);if(!(DH(xa,Sc)|0)){break}nb=c[(FH(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}xS(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}gT(Uc,76384,Kc);sH(Tc,Uc,76192);xS(Uc);c[f>>2]=US(Tc)|0;Sx(0,76208,f)}}while(0);if((c[29920>>2]|0)==0){Ms(pa);GH(ua);GH(sa);xS(ra);HH(qa);i=e;return}Yd[c[7614]&511](4);Ms(pa);GH(ua);GH(sa);xS(ra);HH(qa);i=e;return}}while(0);if((c[29992>>2]|c[7474]|0)==0){Ms(pa);Zc=md(0)|0;td(-1)}Qx(22,1,75272,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Qx(22,0,75320,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Qx(22,0,75368,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Qx(22,0,75416,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Qx(22,0,75464,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Qx(22,0,75512,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Qx(22,0,75560,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Qx(22,0,75608,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Qx(22,0,75656,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Qx(22,0,75704,P);Yd[c[7614]&511](22);Ms(pa);Zc=md(0)|0;td(-1)}function qH(a){a=a|0;var b=0;b=i;qO(a);i=b;return}function rH(a,b){a=a|0;b=b|0;b=i;XJ(a,0);i=b;return}function sH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;mS(a,d);e=vS(b)|0;f=fI(c)|0;YS(a,wS(b)|0,e,f+e|0);QS(a,c,f)|0;i=d;return}function tH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((a1(b,77016)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{rS(g,v);w=gH(u,g)|0;zS(w,c[d+((t|1)<<2)>>2]|0)|0;xS(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((a1(b,77040)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{rS(h,g);u=gH(t,h)|0;zS(u,c[d+((v|1)<<2)>>2]|0)|0;xS(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((a1(b,77064)|0)!=0){do{if((a1(b,77320)|0)!=0){if((a1(b,77328)|0)==0){break}if((a1(b,77336)|0)==0){break}if((a1(b,77344)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=zH(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){rS(r,c[t>>2]|0);w=gH(g,r)|0;zS(w,c[d+((u|1)<<2)>>2]|0)|0;xS(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=zH(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}rS(s,77352);zS(gH(x,s)|0,b)|0;xS(s);i=e;return}IH(j,k);lS(l);lS(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{rS(n,g);t=gH(j,n)|0;zS(t,c[d+((x|1)<<2)>>2]|0)|0;xS(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}rS(o,77080);yS(l,gH(j,o)|0)|0;xS(o);rS(p,77096);yS(m,gH(j,p)|0)|0;xS(p);c[k>>2]=Dc(US(l)|0)|0;if((XS(m,77112)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((XS(m,77120)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((XS(m,77128)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((XS(m,77136)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((XS(m,77144)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((XS(m,77152)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((XS(m,77160)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((XS(m,77168)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((XS(m,77176)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((XS(m,77184)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((XS(m,77192)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((XS(m,77200)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((XS(m,77208)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((XS(m,77216)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=US(m)|0;rS(q,73640);N=US(gH(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Rx(0,(O|0)!=0|0,77224,f);xS(q);VM(zH(c[b>>2]|0,s)|0,j)|0;xS(m);xS(l);QH(j);i=e;return}function uH(a,b){a=a|0;b=b|0;i=i;return}function vH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=GJ(a,b)|0;i=c;return d|0}function wH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;PJ(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];HJ(a,f);i=e;return}function xH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;IJ(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];HJ(a,e);i=d;return}function yH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;IH(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Sx(0,76408,n)}if(p){ec=rd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;Ox(23,0,76552,m);JH(q);KH(q,e,8);if(!(LH(q)|0)){c[l>>2]=e;Sx(0,76592,l)}lS(r);l=q;MH(l,r)|0;nS(s,r);while(1){e=MH(l,r)|0;if(!(hT(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}gT(t,76672,r);OS(s,t)|0;xS(t)}t=rd(US(s)|0)|0;NH(q);xS(s);xS(r);OH(q);fc=t}if((fc|0)==0){Ox(23,0,76760,g);QH(o);i=f;return}lS(u);lS(v);c[k>>2]=fc;Ox(23,0,76680,k);k=Vb(fc|0,76672)|0;if((k|0)!=0){g=k;do{k=I0(12)|0;rS(k,g);t=VS(k,76712,0)|0;TS(w,k,0,t);yS(u,w)|0;xS(w);TS(x,k,t+1|0,(ES(k)|0)+~t|0);yS(v,x)|0;xS(x);yS(gH(o,u)|0,v)|0;t=US(u)|0;k=US(v)|0;c[j>>2]=t;c[j+4>>2]=k;Ox(23,0,76720,j);g=Vb(0,76672)|0;}while((g|0)!=0)}D0(fc);fc=a+12|0;rS(y,74808);g=gH(fc,y)|0;rS(z,74808);if((PH(o,z)|0)==0){rS(B,74808);gc=1;hc=0;ic=gH(fc,B)|0}else{rS(A,74808);gc=0;hc=1;ic=gH(o,A)|0}yS(g,ic)|0;if(gc){xS(B)}if(hc){xS(A)}xS(z);xS(y);rS(C,74680);y=gH(fc,C)|0;rS(D,74680);if((PH(o,D)|0)==0){rS(F,74680);jc=1;kc=0;lc=gH(fc,F)|0}else{rS(E,74680);jc=0;kc=1;lc=gH(o,E)|0}yS(y,lc)|0;if(jc){xS(F)}if(kc){xS(E)}xS(D);xS(C);rS(G,74712);C=gH(fc,G)|0;rS(H,74712);if((PH(o,H)|0)==0){rS(J,74712);mc=1;nc=0;oc=gH(fc,J)|0}else{rS(I,74712);mc=0;nc=1;oc=gH(o,I)|0}yS(C,oc)|0;if(mc){xS(J)}if(nc){xS(I)}xS(H);xS(G);rS(K,74744);G=gH(fc,K)|0;rS(L,74744);if((PH(o,L)|0)==0){rS(N,74744);pc=0;qc=1;rc=gH(fc,N)|0}else{rS(M,74744);pc=1;qc=0;rc=gH(o,M)|0}yS(G,rc)|0;if(qc){xS(N)}if(pc){xS(M)}xS(L);xS(K);rS(O,74776);K=gH(fc,O)|0;rS(P,74776);if((PH(o,P)|0)==0){rS(R,74776);sc=1;tc=0;uc=gH(fc,R)|0}else{rS(Q,74776);sc=0;tc=1;uc=gH(o,Q)|0}yS(K,uc)|0;if(sc){xS(R)}if(tc){xS(Q)}xS(P);xS(O);rS(S,74840);O=gH(fc,S)|0;rS(T,74840);if((PH(o,T)|0)==0){rS(V,74840);vc=1;wc=0;xc=gH(fc,V)|0}else{rS(U,74840);vc=0;wc=1;xc=gH(o,U)|0}yS(O,xc)|0;if(vc){xS(V)}if(wc){xS(U)}xS(T);xS(S);rS(W,74880);S=gH(fc,W)|0;rS(X,74880);if((PH(o,X)|0)==0){rS(Z,74880);yc=1;zc=0;Ac=gH(fc,Z)|0}else{rS(Y,74880);yc=0;zc=1;Ac=gH(o,Y)|0}yS(S,Ac)|0;if(yc){xS(Z)}if(zc){xS(Y)}xS(X);xS(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=zH(Y,_)|0;rS($,73784);Ac=gH(yc,$)|0;c[aa>>2]=Z;yc=zH(Y,aa)|0;rS(ba,73640);if((PH(o,gH(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=zH(Y,ea)|0;rS(fa,73784);Bc=1;Cc=0;Dc=gH(yc,fa)|0}else{c[ca>>2]=Z;yc=zH(Y,ca)|0;rS(da,73640);Bc=0;Cc=1;Dc=gH(o,gH(yc,da)|0)|0}yS(Ac,Dc)|0;if(Bc){xS(fa)}if(Cc){xS(da)}xS(ba);xS($);c[ga>>2]=Z;Ac=zH(zc,ga)|0;rS(ha,73784);yc=gH(Ac,ha)|0;c[ia>>2]=Z;Ac=zH(zc,ia)|0;rS(ja,73640);if((PH(o,gH(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=zH(zc,ma)|0;rS(na,73784);Ec=1;Fc=0;Gc=gH(Ac,na)|0}else{c[ka>>2]=Z;Ac=zH(zc,ka)|0;rS(la,73640);Ec=0;Fc=1;Gc=gH(o,gH(Ac,la)|0)|0}yS(yc,Gc)|0;if(Ec){xS(na)}if(Fc){xS(la)}xS(ja);xS(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=zH(Hc,oa)|0;rS(pa,73784);ja=gH(ha,pa)|0;c[qa>>2]=Z;ha=zH(Hc,qa)|0;rS(ra,73640);if((PH(o,gH(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=zH(Hc,ua)|0;rS(va,73784);Ic=1;Jc=0;Kc=gH(ha,va)|0}else{c[sa>>2]=Z;ha=zH(Hc,sa)|0;rS(ta,73640);Ic=0;Jc=1;Kc=gH(o,gH(ha,ta)|0)|0}yS(ja,Kc)|0;if(Ic){xS(va)}if(Jc){xS(ta)}xS(ra);xS(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=zH(X,wa)|0;rS(xa,73784);ra=gH(pa,xa)|0;c[ya>>2]=Z;pa=zH(X,ya)|0;rS(za,73640);if((PH(o,gH(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=zH(X,Ca)|0;rS(Da,73784);Lc=1;Mc=0;Nc=gH(pa,Da)|0}else{c[Aa>>2]=Z;pa=zH(X,Aa)|0;rS(Ba,73640);Lc=0;Mc=1;Nc=gH(o,gH(pa,Ba)|0)|0}yS(ra,Nc)|0;if(Lc){xS(Da)}if(Mc){xS(Ba)}xS(za);xS(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=zH(Z,Ea)|0;rS(Fa,73784);Ba=gH(za,Fa)|0;c[Ga>>2]=xa;za=zH(Z,Ga)|0;rS(Ha,73640);if((PH(o,gH(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=zH(Z,Ka)|0;rS(La,73784);Oc=1;Pc=0;Qc=gH(za,La)|0}else{c[Ia>>2]=xa;za=zH(Z,Ia)|0;rS(Ja,73640);Oc=0;Pc=1;Qc=gH(o,gH(za,Ja)|0)|0}yS(Ba,Qc)|0;if(Oc){xS(La)}if(Pc){xS(Ja)}xS(Ha);xS(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=zH(xa,Ma)|0;rS(Na,73784);Ja=gH(Ha,Na)|0;c[Oa>>2]=Fa;Ha=zH(xa,Oa)|0;rS(Pa,73640);if((PH(o,gH(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=zH(xa,Sa)|0;rS(Ta,73784);Rc=1;Sc=0;Tc=gH(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=zH(xa,Qa)|0;rS(Ra,73640);Rc=0;Sc=1;Tc=gH(o,gH(Ha,Ra)|0)|0}yS(Ja,Tc)|0;if(Rc){xS(Ta)}if(Sc){xS(Ra)}xS(Pa);xS(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=zH(Fa,Ua)|0;rS(Va,73784);Ra=gH(Pa,Va)|0;c[Wa>>2]=Na;Pa=zH(Fa,Wa)|0;rS(Xa,73640);if((PH(o,gH(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=zH(Fa,_a)|0;rS($a,73784);Uc=1;Vc=0;Wc=gH(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=zH(Fa,Ya)|0;rS(Za,73640);Uc=0;Vc=1;Wc=gH(o,gH(Pa,Za)|0)|0}yS(Ra,Wc)|0;if(Uc){xS($a)}if(Vc){xS(Za)}xS(Xa);xS(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=zH(Na,ab)|0;rS(bb,73784);Za=gH(Xa,bb)|0;c[cb>>2]=Va;Xa=zH(Na,cb)|0;rS(db,73640);if((PH(o,gH(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=zH(Na,gb)|0;rS(hb,73784);Xc=1;Yc=0;Zc=gH(Xa,hb)|0}else{c[eb>>2]=Va;Xa=zH(Na,eb)|0;rS(fb,73640);Xc=0;Yc=1;Zc=gH(o,gH(Xa,fb)|0)|0}yS(Za,Zc)|0;if(Xc){xS(hb)}if(Yc){xS(fb)}xS(db);xS(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=zH(Va,ib)|0;rS(jb,73784);fb=gH(db,jb)|0;c[kb>>2]=bb;db=zH(Va,kb)|0;rS(lb,73640);if((PH(o,gH(db,lb)|0)|0)==0){c[ob>>2]=bb;db=zH(Va,ob)|0;rS(pb,73784);_c=1;$c=0;ad=gH(db,pb)|0}else{c[mb>>2]=bb;db=zH(Va,mb)|0;rS(nb,73640);_c=0;$c=1;ad=gH(o,gH(db,nb)|0)|0}yS(fb,ad)|0;if(_c){xS(pb)}if($c){xS(nb)}xS(lb);xS(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=zH(bb,qb)|0;rS(rb,73784);nb=gH(lb,rb)|0;c[sb>>2]=jb;lb=zH(bb,sb)|0;rS(tb,73640);if((PH(o,gH(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=zH(bb,wb)|0;rS(xb,73784);bd=1;cd=0;dd=gH(lb,xb)|0}else{c[ub>>2]=jb;lb=zH(bb,ub)|0;rS(vb,73640);bd=0;cd=1;dd=gH(o,gH(lb,vb)|0)|0}yS(nb,dd)|0;if(bd){xS(xb)}if(cd){xS(vb)}xS(tb);xS(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=zH(jb,yb)|0;rS(zb,73784);vb=gH(tb,zb)|0;c[Ab>>2]=rb;tb=zH(jb,Ab)|0;rS(Bb,73640);if((PH(o,gH(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=zH(jb,Eb)|0;rS(Fb,73784);ed=1;fd=0;gd=gH(tb,Fb)|0}else{c[Cb>>2]=rb;tb=zH(jb,Cb)|0;rS(Db,73640);ed=0;fd=1;gd=gH(o,gH(tb,Db)|0)|0}yS(vb,gd)|0;if(ed){xS(Fb)}if(fd){xS(Db)}xS(Bb);xS(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=zH(rb,Gb)|0;rS(Hb,73784);Db=gH(Bb,Hb)|0;c[Ib>>2]=zb;Bb=zH(rb,Ib)|0;rS(Jb,73640);if((PH(o,gH(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=zH(rb,Mb)|0;rS(Nb,73784);hd=0;id=1;jd=gH(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=zH(rb,Kb)|0;rS(Lb,73640);hd=1;id=0;jd=gH(o,gH(Bb,Lb)|0)|0}yS(Db,jd)|0;if(id){xS(Nb)}if(hd){xS(Lb)}xS(Jb);xS(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=zH(zb,Ob)|0;rS(Pb,73784);Lb=gH(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=zH(zb,Qb)|0;rS(Rb,73640);if((PH(o,gH(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=zH(zb,Ub)|0;rS(Wb,73784);kd=1;ld=0;md=gH(Jb,Wb)|0}else{c[Sb>>2]=Hb;Jb=zH(zb,Sb)|0;rS(Tb,73640);kd=0;ld=1;md=gH(o,gH(Jb,Tb)|0)|0}yS(Lb,md)|0;if(kd){xS(Wb)}if(ld){xS(Tb)}xS(Rb);xS(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=zH(b,Xb)|0;rS(Yb,73784);Pb=gH(Hb,Yb)|0;c[Zb>>2]=a;Hb=zH(b,Zb)|0;rS(_b,73640);if((PH(o,gH(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=zH(b,bc)|0;rS(cc,73784);nd=1;od=0;pd=gH(Hb,cc)|0}else{c[$b>>2]=a;Hb=zH(b,$b)|0;rS(ac,73640);nd=0;od=1;pd=gH(o,gH(Hb,ac)|0)|0}yS(Pb,pd)|0;if(nd){xS(cc)}if(od){xS(ac)}xS(_b);xS(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}Ox(23,0,76744,h);xS(v);xS(u);QH(o);i=f;return}function zH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=eK(a,f,b)|0;l=c[k>>2]|0;SD(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}gK(j,a,b);hK(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];fK(g,e);iK(j);j=c[f>>2]|0;jK(a,j,k,kK(g)|0);k=lK(g)|0;iK(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function AH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=II(a,f,b)|0;l=c[k>>2]|0;SD(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}KI(j,a,b);LI(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];JI(g,e);MI(j);j=c[f>>2]|0;NI(a,j,k,OI(g)|0);k=PI(g)|0;MI(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function BH(a,b){a=a|0;b=b|0;var c=0;c=i;yS(b,a)|0;i=c;return}function CH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;zI(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];rI(a,f);i=e;return}function DH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pI(a,b)|0;i=c;return d|0}function EH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;sI(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];rI(a,e);i=d;return}function FH(a){a=a|0;var b=0,c=0;b=i;c=mI(a)|0;i=b;return c|0}function GH(a){a=a|0;var b=0;b=i;LM(a);i=b;return}function HH(a){a=a|0;var b=0;b=i;yM(a);i=b;return}function IH(a,b){a=a|0;b=b|0;b=i;fL(a,0);i=b;return}function JH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;uT(d);e=a;c[e>>2]=76812;f=d;c[f>>2]=76832;d=a+8|0;mU(a,76844|0,d);c[e>>2]=76812;c[f>>2]=76832;zG(d);i=b;return}function KH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_D(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){lT(d,4);i=e;return}else{jT(d,0);i=e;return}}function LH(a){a=a|0;var b=0,c=0;b=i;c=hI(a+8|0)|0;i=b;return c|0}function MH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=gI(a,b,sT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function NH(a){a=a|0;var b=0;b=i;if((aE(a+8|0)|0)!=0){i=b;return}lT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function OH(a){a=a|0;var b=0;b=i;lI(a,76840);pT(a+108|0);i=b;return}function PH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=RH(a,b)|0;i=c;return d|0}function QH(a){a=a|0;var b=0;b=i;nM(a);i=b;return}function RH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=TH(a)|0;SD(e);if((f|0)==0){g=0;i=d;return g|0}h=UH(a)|0;a=f;while(1){f=a+16|0;if(VH(h,b,f)|0){j=a}else{if(!(WH(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;SD(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function SH(a){a=a|0;var b=0,c=0;b=i;c=DD(aI(a+4|0)|0)|0;i=b;return c|0}function TH(a){a=a|0;var b=0,d=0;b=i;d=c[(SH(a)|0)>>2]|0;i=b;return d|0}function UH(a){a=a|0;var b=0,c=0;b=i;c=_H(a+8|0)|0;i=b;return c|0}function VH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XH(0,b,c)|0;i=a;return d|0}function WH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XH(0,b,c)|0;i=a;return d|0}function XH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=YH(b,c)|0;i=a;return d|0}function YH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(WS(a,b)|0)<0;i=c;return d|0}function ZH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=$0(a,b,c)|0;i=d;return e|0}function _H(a){a=a|0;var b=0,c=0;b=i;c=$H(a)|0;i=b;return c|0}function $H(a){a=a|0;i=i;return a|0}function aI(a){a=a|0;var b=0,c=0;b=i;c=bI(a)|0;i=b;return c|0}function bI(a){a=a|0;i=i;return a|0}function cI(a,b){a=a|0;b=b|0;var c=0;a=i;c=eI(0,b,0)|0;i=a;return c|0}function dI(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function eI(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=I0(b)|0;i=c;return a|0}function fI(a){a=a|0;var b=0,c=0;b=i;c=e1(a|0)|0;i=b;return c|0}function gI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;rU(f,a,1);if(!(uU(f)|0)){i=e;return a|0}NS(b);f=0;while(1){g=AT(qT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(ME(g,-1)|0){h=2;j=f;break}k=f+1|0;l=NE(g)|0;if(RE(l,d)|0){h=0;j=k;break}PS(b,l);if((vS(b)|0)==-17){h=4;j=k;break}else{f=k}}lT(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function hI(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function iI(a){a=a|0;var b=0;b=i;OH(a);K0(a);i=b;return}function jI(a){a=a|0;var b=0;b=i;OH(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function kI(a){a=a|0;var b=0;b=i;iI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function lI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];AE(a+8|0);i=d;return}function mI(a){a=a|0;var b=0,d=0;b=i;d=nI((c[a>>2]|0)+16|0)|0;i=b;return d|0}function nI(a){a=a|0;var b=0,c=0;b=i;c=oI(a)|0;i=b;return c|0}function oI(a){a=a|0;i=i;return a|0}function pI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(qI(a,b)|0)^1;i=c;return d|0}function qI(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function rI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];yI(a,e);i=d;return}function sI(a,b){a=a|0;b=b|0;var c=0;c=i;tI(a,uI(b)|0);i=c;return}function tI(a,b){a=a|0;b=b|0;var c=0;c=i;xI(a,b);i=c;return}function uI(a){a=a|0;var b=0,c=0;b=i;c=DD(vI(a+4|0)|0)|0;i=b;return c|0}function vI(a){a=a|0;var b=0,c=0;b=i;c=wI(a)|0;i=b;return c|0}function wI(a){a=a|0;i=i;return a|0}function xI(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function yI(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function zI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=BI(b)|0;AI(f,b,d,h,uI(b)|0);sI(g,b);do{if(pI(f,g)|0){h=CI(b)|0;if(DI(h,d,EI(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);sI(a,b);i=e;return}function AI(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;SD(h);a:do{if((e|0)==0){j=f}else{k=CI(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(HI(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;SD(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;SD(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);tI(a,j);i=g;return}function BI(a){a=a|0;var b=0,d=0;b=i;d=c[(uI(a)|0)>>2]|0;i=b;return d|0}function CI(a){a=a|0;var b=0,c=0;b=i;c=FI(a+8|0)|0;i=b;return c|0}function DI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XH(0,b,c)|0;i=a;return d|0}function EI(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function FI(a){a=a|0;var b=0,c=0;b=i;c=GI(a)|0;i=b;return c|0}function GI(a){a=a|0;i=i;return a|0}function HI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XH(0,b,c)|0;i=a;return d|0}function II(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=BI(h)|0;SD(e);if((a|0)==0){j=uI(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XH(0,d,a)|0){m=l;j=c[m>>2]|0;SD(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XH(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;SD(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function JI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];EJ(a,e);i=d;return}function KI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=jJ(d)|0;d=lJ(n,1)|0;mJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kJ(j,d,h);nJ(0,cJ((oJ(j)|0)+16|0)|0,e);e=pJ(j)|0;a[e+4|0]=1;qJ(0,aJ((oJ(j)|0)+28|0)|0);a[e+5|0]=1;rJ(m,j);LI(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];JI(b,g);MI(m);MI(j);i=f;return}function LI(a,b){a=a|0;b=b|0;var c=0;c=i;hJ(a,b);i=c;return}function MI(a){a=a|0;var b=0;b=i;YI(a);i=b;return}function NI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;SD(f);c[e>>2]=0;SD(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=UI(a)|0;b=c[c[e>>2]>>2]|0;SD(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(uI(a)|0)>>2]|0;CF(e,c[d>>2]|0);d=VI(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function OI(a){a=a|0;var b=0,d=0;b=i;d=c[(SI(a)|0)>>2]|0;i=b;return d|0}function PI(a){a=a|0;var b=0,d=0;b=i;d=QI(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function QI(a){a=a|0;var b=0,c=0;b=i;c=RI(a)|0;i=b;return c|0}function RI(a){a=a|0;i=i;return a|0}function SI(a){a=a|0;var b=0,c=0;b=i;c=TI(a)|0;i=b;return c|0}function TI(a){a=a|0;i=i;return a|0}function UI(a){a=a|0;i=i;return a|0}function VI(a){a=a|0;var b=0,c=0;b=i;c=WI(a+8|0)|0;i=b;return c|0}function WI(a){a=a|0;var b=0,c=0;b=i;c=XI(a)|0;i=b;return c|0}function XI(a){a=a|0;i=i;return a|0}function YI(a){a=a|0;var b=0;b=i;ZI(a,0);i=b;return}function ZI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=QI(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}$I(_I(e)|0,f);i=d;return}function _I(a){a=a|0;var b=0,c=0;b=i;c=gJ(a)|0;i=b;return c|0}function $I(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;bJ(f,cJ(d+16|0)|0)}if((d|0)==0){i=e;return}dJ(c[b>>2]|0,d,1);i=e;return}function aJ(a){a=a|0;i=i;return a|0}function bJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;fJ(d,0,c);i=b;return}function cJ(a){a=a|0;i=i;return a|0}function dJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;eJ(0,b,0);i=c;return}function eJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;K0(b);i=c;return}function fJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;xS(c);i=b;return}function gJ(a){a=a|0;i=i;return a+4|0}function hJ(a,b){a=a|0;b=b|0;var c=0;c=i;iJ(a,b);i=c;return}function iJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function jJ(a){a=a|0;var b=0,c=0;b=i;c=CJ(a+4|0)|0;i=b;return c|0}function kJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];uJ(a,b,f);i=e;return}function lJ(a,b){a=a|0;b=b|0;var c=0;a=i;c=tJ(0,b,0)|0;i=a;return c|0}function mJ(a,b){a=a|0;b=b|0;var c=0;c=i;sJ(a,b);i=c;return}function nJ(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}nS(b,c);i=a;return}function oJ(a){a=a|0;var b=0,d=0;b=i;d=c[(SI(a)|0)>>2]|0;i=b;return d|0}function pJ(a){a=a|0;var b=0,c=0;b=i;c=_I(a)|0;i=b;return c|0}function qJ(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function rJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;hJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];JI(h,f);LI(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];JI(a,e);MI(h);i=d;return}function sJ(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function tJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=I0(b<<5)|0;i=c;return a|0}function uJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(wJ(g)|0)>>2]|0;g=xJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];vJ(b,a,f);i=e;return}function vJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];yJ(a,b,f);i=e;return}function wJ(a){a=a|0;i=i;return a|0}function xJ(a){a=a|0;i=i;return a|0}function yJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(AJ(g)|0)>>2]|0;g=BJ(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];zJ(b,a,f);i=e;return}function zJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(AJ(f)|0)>>2];f=BJ(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function AJ(a){a=a|0;i=i;return a|0}function BJ(a){a=a|0;i=i;return a|0}function CJ(a){a=a|0;var b=0,c=0;b=i;c=DJ(a)|0;i=b;return c|0}function DJ(a){a=a|0;i=i;return a|0}function EJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=PI(FJ(b)|0)|0;h=BJ(pJ(FJ(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];vJ(g,a,e);i=d;return}function FJ(a){a=a|0;i=i;return c[a>>2]|0}function GJ(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function HJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];OJ(a,e);i=d;return}function IJ(a,b){a=a|0;b=b|0;var c=0;c=i;JJ(a,KJ(b)|0);i=c;return}function JJ(a,b){a=a|0;b=b|0;var c=0;c=i;NJ(a,b);i=c;return}function KJ(a){a=a|0;var b=0,c=0;b=i;c=DD(LJ(a+4|0)|0)|0;i=b;return c|0}function LJ(a){a=a|0;var b=0,c=0;b=i;c=MJ(a)|0;i=b;return c|0}function MJ(a){a=a|0;i=i;return a|0}function NJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function OJ(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function PJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=RJ(b)|0;QJ(f,b,d,h,KJ(b)|0);IJ(g,b);do{if(SJ(f,g)|0){h=TJ(b)|0;if(VH(h,d,UJ(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);IJ(a,b);i=e;return}function QJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;SD(h);a:do{if((e|0)==0){j=f}else{k=TJ(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(WH(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;SD(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;SD(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);JJ(a,j);i=g;return}function RJ(a){a=a|0;var b=0,d=0;b=i;d=c[(KJ(a)|0)>>2]|0;i=b;return d|0}function SJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(GJ(a,b)|0)^1;i=c;return d|0}function TJ(a){a=a|0;var b=0,c=0;b=i;c=VJ(a+8|0)|0;i=b;return c|0}function UJ(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function VJ(a){a=a|0;var b=0,c=0;b=i;c=WJ(a)|0;i=b;return c|0}function WJ(a){a=a|0;i=i;return a|0}function XJ(a,b){a=a|0;b=b|0;b=i;i=i+8|0;YJ(a,b);i=b;return}function YJ(a,b){a=a|0;b=b|0;b=i;ZJ(a,0);i=b;return}function ZJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;_J(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;$J(f,0,e);e=uI(b)|0;c[(UI(b)|0)>>2]=e;i=d;return}function _J(a){a=a|0;var b=0;b=i;cK(a);i=b;return}function $J(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;aK(b,c,f);i=e;return}function aK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(uG(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;bK(d,b,f);i=e;return}function bK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(uG(e)|0)>>2];i=d;return}function cK(a){a=a|0;var b=0;b=i;dK(a);i=b;return}function dK(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function eK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=eL(h)|0;SD(e);if((a|0)==0){j=rK(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(PD(0,d,a)|0){m=l;j=c[m>>2]|0;SD(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(PD(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;SD(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function fK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cL(a,e);i=d;return}function gK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=JK(d)|0;d=LK(n,1)|0;MK(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];KK(j,d,h);NK(0,OF((OK(j)|0)+16|0)|0,e);e=PK(j)|0;a[e+4|0]=1;QK(0,CK((OK(j)|0)+20|0)|0);a[e+5|0]=1;RK(m,j);hK(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];fK(b,g);iK(m);iK(j);i=f;return}function hK(a,b){a=a|0;b=b|0;var c=0;c=i;HK(a,b);i=c;return}function iK(a){a=a|0;var b=0;b=i;xK(a);i=b;return}function jK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;SD(f);c[e>>2]=0;SD(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=qK(a)|0;b=c[c[e>>2]>>2]|0;SD(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(rK(a)|0)>>2]|0;CF(e,c[d>>2]|0);d=sK(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}



function Y$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=C0(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=C0(y)|0;if((z|0)==0){A=12;break}i1(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=G$(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((l$(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((l$(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((l$(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((l$(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(l$(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(l$(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(l$(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(l$(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){i1(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=G$(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((l$(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((l$(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((l$(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((l$(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(l$(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(l$(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(l$(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(l$(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((p$(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=B$(X)|0;qb=_a+24|0;if((p$(fb,c[qb>>2]|0)|0)!=0){break}fb=z$(X)|0;if((p$(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((p$(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=z$(X)|0;if((p$(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=B$(X)|0;if((p$(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}D0(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=_$(0,0)|0;if((S|0)==0){A=12;break}R=a0(S,0,0,0,32)|0;Q=R;if((R|0)==0){$$(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=C0(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=C0(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=C0(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){i1(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){i1(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=G$(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((l$(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((l$(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((l$(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((l$(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(l$(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(l$(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(l$(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(l$(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=a0(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=a0(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;Z$(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((b1(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=G$(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=G$(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((l$(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((l$(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((l$(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((l$(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(l$(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(l$(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(l$(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(l$(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((p$(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=B$(tc)|0;aa=Ca+24|0;if((p$(qa,c[aa>>2]|0)|0)!=0){break}qa=z$(tc)|0;if((p$(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((p$(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=z$(tc)|0;if((p$(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=B$(tc)|0;if((p$(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=a0(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=a0(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){$$(S);if((Eb|0)!=0){D0(O)}if((Kb|0)!=0){D0(Kb)}if((Lb|0)==0){A=12;break a}D0(N);A=12;break a}else if((sa|0)==67){$$(S);if((Eb|0)!=0){D0(O)}if((Kb|0)!=0){D0(Kb)}if((Lb|0)==0){A=12;break a}D0(N);A=12;break a}else if((sa|0)==169){$$(S);if((Eb|0)!=0){D0(O)}if((Kb|0)!=0){D0(Kb)}if((Lb|0)==0){A=12;break a}D0(N);A=12;break a}else if((sa|0)==176){$$(S);if((Eb|0)!=0){D0(O)}if((Kb|0)!=0){D0(Kb)}if((Lb|0)==0){A=12;break a}D0(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);$$(S);if((Jb|0)!=0){D0(Jb)}if((Gb|0)!=0){D0(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}D0(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}Z$(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}D0(m);p=A;i=g;return p|0}function Z$(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function _$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=E0(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function $$(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;D0(e);i=b;return}else{f=d}while(1){D0(c[f>>2]|0);d=c[f+4>>2]|0;D0(f);if((d|0)==0){break}else{f=d}}e=a;D0(e);i=b;return}function a0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=C0(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=C0(p)|0;c[o>>2]=r;if((r|0)==0){D0(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}i1(m|0,0,h|0)|0;j=m;i=g;return j|0}function b0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((c0(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function c0(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function d0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function e0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function f0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function g0(a){a=a|0;i=i;return}function h0(a){a=a|0;c[a>>2]=119736;i=i;return}function i0(a){a=a|0;var b=0;b=i;yb(a|0);K0(a);i=b;return}function j0(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function k0(a){a=a|0;i=i;return 119752}function l0(a){a=a|0;i=i;return}function m0(a){a=a|0;i=i;return}function n0(a){a=a|0;i=i;return}function o0(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function p0(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function q0(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function r0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=v0(b,119864,119920,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;ze[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function s0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function t0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;ze[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function u0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;ze[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;ze[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function v0(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;ie[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Vd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function w0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;ie[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Vd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Vd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Vd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function x0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Vd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;ie[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function y0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function z0(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;ie[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;ie[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function A0(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;ie[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function B0(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function C0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[30042]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=120208+(j<<2)|0;l=120208+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[30042]=f&~(1<<h)}else{if(n>>>0<(c[120184>>2]|0)>>>0){cd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{cd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[120176>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=120208+(r<<2)|0;o=120208+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[30042]=f&~(1<<t)}else{if(n>>>0<(c[120184>>2]|0)>>>0){cd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{cd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[120176>>2]|0;if((n|0)!=0){f=c[120188>>2]|0;e=n>>>3;n=e<<1;g=120208+(n<<2)|0;m=c[30042]|0;j=1<<e;do{if((m&j|0)==0){c[30042]=m|j;u=120208+(n+2<<2)|0;v=g}else{e=120208+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[120184>>2]|0)>>>0)){u=e;v=h;break}cd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[120176>>2]=o;c[120188>>2]=s;p=k;i=b;return p|0}n=c[120172>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[120472+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[120184>>2]|0;if(h>>>0<k>>>0){cd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){cd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){cd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){cd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){cd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{cd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=120472+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<h);break a}else{if(s>>>0<(c[120184>>2]|0)>>>0){cd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[120184>>2]|0)>>>0){cd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[120176>>2]|0;if((h|0)!=0){s=c[120188>>2]|0;k=h>>>3;h=k<<1;f=120208+(h<<2)|0;m=c[30042]|0;g=1<<k;do{if((m&g|0)==0){c[30042]=m|g;A=120208+(h+2<<2)|0;B=f}else{k=120208+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[120184>>2]|0)>>>0)){A=k;B=e;break}cd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[120176>>2]=t;c[120188>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[120172>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[120472+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[120472+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[120176>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[120184>>2]|0;if(t>>>0<f>>>0){cd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){cd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){cd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){cd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){cd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{cd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=120472+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<e);break c}else{if(t>>>0<(c[120184>>2]|0)>>>0){cd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[120184>>2]|0)>>>0){cd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=120208+(t<<2)|0;s=c[30042]|0;r=1<<e;do{if((s&r|0)==0){c[30042]=s|r;S=120208+(t+2<<2)|0;T=f}else{e=120208+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[120184>>2]|0)>>>0)){S=e;T=k;break}cd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=120472+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[120172>>2]|0;l=1<<U;if((f&l|0)==0){c[120172>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[120184>>2]|0;if(W>>>0<k>>>0){cd()}if(r>>>0<k>>>0){cd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[120176>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[120188>>2]|0;if(W>>>0>15){c[120188>>2]=X+q;c[120176>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[120176>>2]=0;c[120188>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[120180>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[120180>>2]=W;X=c[120192>>2]|0;c[120192>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[30160]|0)==0){X=ad(30)|0;if((X+ -1&X|0)==0){c[120648>>2]=X;c[120644>>2]=X;c[120652>>2]=-1;c[120656>>2]=-1;c[120660>>2]=0;c[120612>>2]=0;c[30160]=(qc(0)|0)&-16^1431655768;break}else{cd()}}}while(0);X=q+48|0;W=c[120648>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[120608>>2]|0;do{if((U|0)!=0){T=c[120600>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[120612>>2]&4|0)==0){U=c[120192>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=120616|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[120180>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=jb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=jb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[120644>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[120600>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[120608>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=jb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[120648>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((jb(t|0)|0)==(-1|0)){jb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[120612>>2]=c[120612>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=jb(W|0)|0;ha=jb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[120600>>2]|0)+ga|0;c[120600>>2]=ia;if(ia>>>0>(c[120604>>2]|0)>>>0){c[120604>>2]=ia}ia=c[120192>>2]|0;W=120616|0;i:do{if((ia|0)==0){aa=c[120184>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[120184>>2]=fa}c[120616>>2]=fa;c[120620>>2]=ga;c[120628>>2]=0;c[120204>>2]=c[30160];c[120200>>2]=-1;aa=0;do{ha=aa<<1;$=120208+(ha<<2)|0;c[120208+(ha+3<<2)>>2]=$;c[120208+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[120192>>2]=fa+ja;c[120180>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[120196>>2]=c[120656>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[120180>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[120192>>2]=ia+na;c[120180>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[120196>>2]=c[120656>>2];break i}}while(0);if(fa>>>0<(c[120184>>2]|0)>>>0){c[120184>>2]=fa}aa=fa+ga|0;$=120616|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[120192>>2]|0)){ca=(c[120180>>2]|0)+X|0;c[120180>>2]=ca;c[120192>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[120188>>2]|0)){ca=(c[120176>>2]|0)+X|0;c[120176>>2]=ca;c[120188>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=120208+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[120184>>2]|0)>>>0){cd()}if((c[V+12>>2]|0)==(ha|0)){break}cd()}}while(0);if((L|0)==(V|0)){c[30042]=c[30042]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[120184>>2]|0)>>>0){cd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}cd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[120184>>2]|0)>>>0){cd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){cd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{cd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=120472+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<t);break k}else{if(T>>>0<(c[120184>>2]|0)>>>0){cd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[120184>>2]|0)>>>0){cd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=120208+(Z<<2)|0;t=c[30042]|0;T=1<<ca;do{if((t&T|0)==0){c[30042]=t|T;xa=120208+(Z+2<<2)|0;ya=ea}else{ca=120208+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[120184>>2]|0)>>>0)){xa=ca;ya=V;break}cd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=120472+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[120172>>2]|0;L=1<<za;if((ea&L|0)==0){c[120172>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[120184>>2]|0;if(Ba>>>0<S>>>0){cd()}if(T>>>0<S>>>0){cd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=120616|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[120192>>2]=fa+Ha;c[120180>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[120196>>2]=c[120656>>2];c[ba+4>>2]=27;X=120616|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[120616>>2]=fa;c[120620>>2]=ga;c[120628>>2]=0;c[120624>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=120208+(da<<2)|0;aa=c[30042]|0;f=1<<M;do{if((aa&f|0)==0){c[30042]=aa|f;Ia=120208+(da+2<<2)|0;Ja=ha}else{M=120208+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[120184>>2]|0)>>>0)){Ia=M;Ja=T;break}cd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=120472+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[120172>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[120172>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[120184>>2]|0;if(Ma>>>0<f>>>0){cd()}if(M>>>0<f>>>0){cd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[120180>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[120180>>2]=W;ia=c[120192>>2]|0;c[120192>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Lc()|0)>>2]=12;p=0;i=b;return p|0}function D0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[120184>>2]|0;if(d>>>0<f>>>0){cd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){cd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){cd()}if((p|0)==(c[120188>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[120176>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=120208+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){cd()}if((c[m+12>>2]|0)==(p|0)){break}cd()}}while(0);if((u|0)==(m|0)){c[30042]=c[30042]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){cd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}cd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){cd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){cd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){cd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{cd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=120472+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[120184>>2]|0)>>>0){cd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[120184>>2]|0)>>>0){cd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){cd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){cd()}do{if((C&2|0)==0){if((l|0)==(c[120192>>2]|0)){f=(c[120180>>2]|0)+t|0;c[120180>>2]=f;c[120192>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[120188>>2]|0)){i=b;return}c[120188>>2]=0;c[120176>>2]=0;i=b;return}if((l|0)==(c[120188>>2]|0)){f=(c[120176>>2]|0)+t|0;c[120176>>2]=f;c[120188>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=120208+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[120184>>2]|0)>>>0){cd()}if((c[E+12>>2]|0)==(l|0)){break}cd()}}while(0);if((w|0)==(E|0)){c[30042]=c[30042]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[120184>>2]|0)>>>0){cd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}cd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[120184>>2]|0)>>>0){cd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){cd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{cd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=120472+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<g);break b}else{if(d>>>0<(c[120184>>2]|0)>>>0){cd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[120184>>2]|0)>>>0){cd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[120188>>2]|0)){J=f;break}c[120176>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=120208+(C<<2)|0;G=c[30042]|0;j=1<<t;do{if((G&j|0)==0){c[30042]=G|j;K=120208+(C+2<<2)|0;L=e}else{t=120208+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[120184>>2]|0)>>>0)){K=t;L=a;break}cd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=120472+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[120172>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[120172>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[120184>>2]|0;if(O>>>0<K>>>0){cd()}if(f>>>0<K>>>0){cd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[120200>>2]|0)+ -1|0;c[120200>>2]=s;if((s|0)==0){Q=120624|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[120200>>2]=-1;i=b;return}function E0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=C0(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}i1(b|0,0,e|0)|0;i=d;return b|0}function F0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=C0(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Lc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=G0(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=C0(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;g1(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;D0(a);e=g;i=d;return e|0}function G0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[120184>>2]|0;if(h>>>0<l>>>0){cd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){cd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){cd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[120648>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;H0(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[120192>>2]|0)){m=(c[120180>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[120192>>2]=a+b;c[120180>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[120188>>2]|0)){h=(c[120176>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[120176>>2]=r;c[120188>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=120208+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){cd()}if((c[h+12>>2]|0)==(k|0)){break}cd()}}while(0);if((m|0)==(h|0)){c[30042]=c[30042]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){cd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}cd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){cd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){cd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){cd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{cd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=120472+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<u);break a}else{if(t>>>0<(c[120184>>2]|0)>>>0){cd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[120184>>2]|0)>>>0){cd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;H0(a+b|0,r);o=a;i=d;return o|0}return 0}function H0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[120184>>2]|0;if(j>>>0<m>>>0){cd()}if((k|0)==(c[120188>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[120176>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=120208+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){cd()}if((c[q+12>>2]|0)==(k|0)){break}cd()}}while(0);if((r|0)==(q|0)){c[30042]=c[30042]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){cd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}cd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){cd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){cd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){cd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{cd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=120472+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[120184>>2]|0)>>>0){cd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[120184>>2]|0)>>>0){cd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[120184>>2]|0;if(e>>>0<z>>>0){cd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[120192>>2]|0)){t=(c[120180>>2]|0)+p|0;c[120180>>2]=t;c[120192>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[120188>>2]|0)){i=d;return}c[120188>>2]=0;c[120176>>2]=0;i=d;return}if((f|0)==(c[120188>>2]|0)){t=(c[120176>>2]|0)+p|0;c[120176>>2]=t;c[120188>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=120208+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){cd()}if((c[u+12>>2]|0)==(f|0)){break}cd()}}while(0);if((h|0)==(u|0)){c[30042]=c[30042]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){cd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}cd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){cd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){cd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){cd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{cd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=120472+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[120172>>2]=c[120172>>2]&~(1<<j);break b}else{if(m>>>0<(c[120184>>2]|0)>>>0){cd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[120184>>2]|0)>>>0){cd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[120184>>2]|0)>>>0){cd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[120188>>2]|0)){G=t;break}c[120176>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=120208+(B<<2)|0;D=c[30042]|0;b=1<<p;do{if((D&b|0)==0){c[30042]=D|b;H=120208+(B+2<<2)|0;I=A}else{p=120208+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[120184>>2]|0)>>>0)){H=p;I=a;break}cd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=120472+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[120172>>2]|0;B=1<<J;if((a&B|0)==0){c[120172>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[120184>>2]|0)>>>0){cd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[120184>>2]|0;if(L>>>0<B>>>0){cd()}if(G>>>0<B>>>0){cd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function I0(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=C0(d)|0;if((e|0)!=0){f=6;break}a=c[30166]|0;c[30166]=0+a;if((a|0)==0){f=5;break}we[a&7]()}if((f|0)==5){d=Cc(4)|0;c[d>>2]=120680;Kd(d|0,120728,135)}else if((f|0)==6){i=b;return e|0}return 0}function J0(a){a=a|0;var b=0,c=0;b=i;c=I0(a)|0;i=b;return c|0}function K0(a){a=a|0;var b=0;b=i;if((a|0)!=0){D0(a)}i=b;return}function L0(a){a=a|0;var b=0;b=i;K0(a);i=b;return}function M0(a){a=a|0;var b=0;b=i;yb(a|0);K0(a);i=b;return}function N0(a){a=a|0;var b=0;b=i;yb(a|0);i=b;return}function O0(a){a=a|0;i=i;return 120696}function P0(){var a=0;a=Cc(4)|0;c[a>>2]=120680;Kd(a|0,120728,135)}



function jt(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=pe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=kt(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=ct(o,l+132|0,20408,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((ye[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=lt(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}mt(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=lt(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Is(o+416|0);h=0;break};case 57:{v=kt(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=pt(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Vd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Is(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=ct(o,l+132|0,20408,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((pe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Yd[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=ot(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=20512}else{x=(s|0)==32?20496:20520}if((qt(o+416|0,x)|0)==0){r=111;break a}if((rt(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=20416;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=20424;r=102;break};case 25:{c[o+332>>2]=20432;r=102;break};case 26:{c[o+332>>2]=20440;r=102;break};case 27:{c[o+332>>2]=20448;r=102;break};case 28:{c[o+332>>2]=20456;r=102;break};case 29:{c[o+332>>2]=20472;r=102;break};case 30:{c[o+332>>2]=20480;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((st(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!(($s(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!(($s(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ie[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Is(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=lt(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=20408}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=ct(o,l+132|0,20408,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=tt(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((st(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!(($s(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!(($s(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ie[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Is(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=ut(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;ne[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ne[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=lt(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;ie[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ne[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ce[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=lt(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=ct(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=lt(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=ct(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=lt(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Zs(o,b,e,c[n>>2]|0)}h=0;D=vt(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((ye[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=lt(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}mt(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=lt(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Is(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Vd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Is(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=$d[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=oe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=oe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=xt(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=lt(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=ct(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ve[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=yt(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(pe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=ot(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=$d[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ve[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((Bt(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((At(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((ye[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=lt(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=xt(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=ot(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=zt(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ve[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=lt(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}mt(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Zs(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=ye[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((pe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=ct(o,l+132|0,20408,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((pe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if(($d[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=nt(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function kt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((_d[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=lt(n+440|0,p,b,s+(oe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=lt(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);ze[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Zs(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=lt(n+440|0,e,d,m+(oe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Pt(n,f)|0;Is(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Is(n+440|0)}q=0;r=q;i=g;return r|0}function lt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((rt(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(($s(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function mt(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function nt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Et(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Mt(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function ot(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=lt(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=ct(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Nt(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function pt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if(($s(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=lt(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=ct(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=ct(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!(($s(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if(($s(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=ct(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function qt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!(($s(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function rt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if(($s(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Vd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!(($s(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function st(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=$d[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=oe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function tt(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Ot(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if(($s(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function ut(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if(($s(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(ye[c[b+20>>2]&63](b,e,f,j)|0){case 10:{r=oe[c[b+44>>2]&63](b,e)|0;if((r|0)<0){s=33;break a}r=Vt(r,k)|0;if((r|0)==0){s=37;break a}t=0;while(1){if((t|0)>=(r|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!(($s(m)|0)<<24>>24!=0)){s=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){s=23;break a}}t=lt(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){s=8;break a}r=ct(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((r|0)==0){s=10;break a}if((a[r+32|0]|0)!=0){s=12;break a}if((c[r+16>>2]|0)==0){a[r+32|0]=1;n=ut(l,c[l+228>>2]|0,c[r+4>>2]|0,(c[r+4>>2]|0)+(c[r+8>>2]|0)|0)|0;a[r+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[r+32|0]=1;t=(pe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[r+20>>2]|0,c[r+16>>2]|0,c[r+24>>2]|0)|0)!=0;a[r+32|0]=0;if(!t){s=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case-4:{s=24;break a;break};case-1:{s=46;break a;break};case 0:{s=49;break a;break};case 6:case 9:{if((rt(m,b,e,c[j>>2]|0)|0)==0){s=26;break a}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);s=28;break};case 7:{s=28;break};default:{s=52;break a}}}while(0);if((s|0)==28){s=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!(($s(m)|0)<<24>>24!=0)){s=30;break}}t=m+12|0;r=c[t>>2]|0;c[t>>2]=r+1;a[r]=10}e=c[j>>2]|0}if((s|0)==8){n=1}else if((s|0)==10){a[g+128|0]=a[g+130|0]|0}else if((s|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((s|0)==18){n=21}else if((s|0)==23){c[l+288>>2]=e;n=10}else if((s|0)==24){n=0}else if((s|0)==26){n=1}else if((s|0)==30){n=1}else if((s|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((s|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((s|0)==44){n=1}else if((s|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((s|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((s|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function vt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=ye[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Zs(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function wt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=vt(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=it(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=$d[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=oe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=$d[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function yt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=$d[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=ye[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=jt(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=Et(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=$d[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;Dt(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function At(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Zs(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(oe[c[a+32>>2]&63](a,b)|0)|0;k=lt(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=oe[c[a+36>>2]&63](a,e)|0;e=lt(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){Ct(e);ve[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Is(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Bt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Zs(g,a,b,d)}h=1;j=h;i=f;return j|0}k=lt(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){Ct(k);Zd[c[g+68>>2]&127](c[g+4>>2]|0,k);Is(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function Ct(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function Dt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}Dt(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function Et(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=ye[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 0:{B=24;break a;break};case-4:{B=17;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;D=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;E=oe[c[e+32>>2]&63](e,D)|0;if((E|0)!=(c[C+8>>2]|0)){B=112;break a}if(($0(c[C+4>>2]|0,D,E)|0)!=0){B=112;break a}E=y+312|0;c[E>>2]=(c[E>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){E=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((E|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[E]|0)==0){break}G=E;E=G+1|0;H=F;F=H+1|0;a[H]=a[G]|0}G=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}H=F;F=H+1|0;a[H]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}H=G;G=H+1|0;I=F;F=I+1|0;a[I]=a[H]|0}}}while(0);a[F]=0}}while(0);Zd[c[y+56>>2]&127](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}E=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case-1:{B=25;break a;break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;E=1;c[t>>2]=lt(y+416|0,e,C,C+(oe[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];J=Ht(y,e,c[m>>2]|0,t,s)|0;if((J|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ve[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);E=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}Zd[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);E=0}do{if((E&255|0)!=0){if((c[y+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Is(y+416|0);while(1){if((c[s>>2]|0)==0){break}E=c[s>>2]|0;if((c[y+104>>2]|0)!=0){Zd[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 9:{a[p]=ce[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){E=y;if((c[y+60>>2]|0)!=0){ve[c[E+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[E+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break b}E=lt(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((E|0)==0){B=37;break a}C=ct(y,k,E,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((C|0)!=0){break}G=y;if((c[y+120>>2]|0)!=0){ve[c[G+120>>2]&15](c[y+4>>2]|0,E,0);break b}if((c[G+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((C|0)==0){B=41;break a}if((a[C+34|0]|0)==0){B=43;break a}}if((a[C+32|0]|0)!=0){B=50;break a}if((c[C+28>>2]|0)!=0){B=52;break a}E=y;if((c[C+4>>2]|0)!=0){G=y;if((a[E+308|0]|0)!=0){K=yt(G,C,0)|0;if((K|0)!=0){B=60;break a}else{break b}}H=y;if((c[G+120>>2]|0)!=0){ve[c[H+120>>2]&15](c[y+4>>2]|0,c[C>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[E+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[C+32|0]=1;E=Gt(y)|0;a[C+32|0]=0;if((E|0)==0){B=63;break a}if((pe[c[y+112>>2]&63](c[y+116>>2]|0,E,c[C+20>>2]|0,c[C+16>>2]|0,c[C+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ve[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{E=oe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((E|0)<0){B=135;break a}H=y;if((c[y+60>>2]|0)!=0){G=c[H+60>>2]|0;I=c[y+4>>2]|0;L=Vt(E,u)|0;ve[G&15](I,u,L);break b}if((c[H+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{H=y;do{if((c[y+72>>2]|0)!=0){Yd[c[H+72>>2]&511](c[y+4>>2]|0)}else{if((c[H+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=Jt(y,e,n,g,h,j)|0;if((M|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{H=c[y+60>>2]|0;if((H|0)==0){if((c[y+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ve[H&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Vd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ve[H&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((At(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((Bt(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 1:case 2:{H=y;if((c[y+368>>2]|0)!=0){N=c[H+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{N=$d[c[H+12>>2]&127](48)|0;if((N|0)==0){B=72;break a}c[N+36>>2]=$d[c[y+12>>2]&127](32)|0;if((c[N+36>>2]|0)==0){B=74;break a}c[N+40>>2]=(c[N+36>>2]|0)+32}c[N+44>>2]=0;c[N>>2]=c[y+364>>2];c[y+364>>2]=N;c[N+16>>2]=0;c[N+20>>2]=0;c[N+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[N+8>>2]=oe[c[e+32>>2]&63](e,c[N+4>>2]|0)|0;H=y+312|0;c[H>>2]=(c[H>>2]|0)+1;H=(c[N+4>>2]|0)+(c[N+8>>2]|0)|0;c[r>>2]=c[N+4>>2];c[q>>2]=c[N+36>>2];while(1){Vd[c[e+60>>2]&31](e,r,H,q,(c[N+40>>2]|0)+ -1|0);O=(c[q>>2]|0)-(c[N+36>>2]|0)|0;if((c[r>>2]|0)==(H|0)){break}C=(c[N+40>>2]|0)-(c[N+36>>2]|0)<<1;L=oe[c[y+16>>2]&63](c[N+36>>2]|0,C)|0;if((L|0)==0){B=80;break a}c[N+36>>2]=L;c[N+40>>2]=L+C;c[q>>2]=L+O}c[N+24>>2]=O;c[N+12>>2]=c[N+36>>2];a[c[q>>2]|0]=0;P=Ht(y,e,c[m>>2]|0,N+12|0,N+44|0)|0;if((P|0)!=0){B=82;break a}H=y;do{if((c[y+52>>2]|0)!=0){ve[c[H+52>>2]&15](c[y+4>>2]|0,c[N+12>>2]|0,c[y+392>>2]|0)}else{if((c[H+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Is(y+416|0);break};case-3:{B=6;break a;break};case-2:{B=28;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Zs(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ve[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=g;Q=0;R=Q;i=l;return R|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}if((b|0)<=0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}}else if((B|0)==24){c[z>>2]=c[n>>2];Q=4;R=Q;i=l;return R|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=5;R=Q;i=l;return R|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=6;R=Q;i=l;return R|0}}else if((B|0)==37){Q=1;R=Q;i=l;return R|0}else if((B|0)==41){Q=11;R=Q;i=l;return R|0}else if((B|0)==43){Q=24;R=Q;i=l;return R|0}else if((B|0)==50){Q=12;R=Q;i=l;return R|0}else if((B|0)==52){Q=15;R=Q;i=l;return R|0}else if((B|0)==60){Q=K;R=Q;i=l;return R|0}else if((B|0)==63){Q=1;R=Q;i=l;return R|0}else if((B|0)==65){Q=21;R=Q;i=l;return R|0}else if((B|0)==72){Q=1;R=Q;i=l;return R|0}else if((B|0)==74){Yd[c[y+20>>2]&511](N);Q=1;R=Q;i=l;return R|0}else if((B|0)==80){Q=1;R=Q;i=l;return R|0}else if((B|0)==82){Q=P;R=Q;i=l;return R|0}else if((B|0)==89){Q=1;R=Q;i=l;return R|0}else if((B|0)==91){Q=J;R=Q;i=l;return R|0}else if((B|0)==107){Q=It(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==109){Q=13;R=Q;i=l;return R|0}else if((B|0)==112){c[z>>2]=D;Q=7;R=Q;i=l;return R|0}else if((B|0)==133){Q=It(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((B|0)==135){Q=14;R=Q;i=l;return R|0}else if((B|0)==140){Q=17;R=Q;i=l;return R|0}else if((B|0)==150){Q=M;R=Q;i=l;return R|0}else if((B|0)==152){c[y+280>>2]=43;Q=M;R=Q;i=l;return R|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ve[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Vd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ve[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Zs(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;Q=3;R=Q;i=l;return R|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;Q=13;R=Q;i=l;return R|0}else{c[h>>2]=m;Q=0;R=Q;i=l;return R|0}}else if((B|0)==174){Q=1;R=Q;i=l;return R|0}else if((B|0)==176){Q=1;R=Q;i=l;return R|0}else if((B|0)==180){c[h>>2]=c[n>>2];Q=0;R=Q;i=l;return R|0}else if((B|0)==181){Q=35;R=Q;i=l;return R|0}return 0}function Ft(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=ye[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=jt(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=Et(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=ye[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=jt(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=Et(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function Gt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(($s(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);at(e,b+60|0);a:while(1){k=bt(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){at(e,b);b:while(1){b=bt(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(($s(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function Ht(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=ct(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Ks(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=ct(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Nt(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=ye[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=oe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}ye[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=pt(k,b,v,w+(oe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=lt(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=tt(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=gt(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=gt(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=oe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(ct(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!(($s(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!(($s(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!(($s(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=$d[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;g1(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Yd[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;g1(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;g1(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function It(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=ye[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-2:{k=18;break a;break};case 0:{k=14;break a;break};case-15:{k=3;break a;break};case 11:{if((At(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 13:{if((Bt(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}Zs(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-1:{k=15;break a;break};case-4:{k=7;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Zs(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Jt(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=ye[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-4:case-1:{r=28;break a;break};case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Zs(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ve[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Vd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ve[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ve[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Zs(o,b,c[k>>2]|0,c[l>>2]|0);break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){Yd[c[m+76>>2]&511](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Zs(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Kt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Jt(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=Lt(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=nt(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Lt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Et(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Mt(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=oe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}g1(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Nt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!(($s(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!(($s(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=ct(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Ot(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(ye[c[b+16>>2]&63](b,f,g,l)|0){case 6:{if((rt(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 10:{p=oe[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=Vt(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!(($s(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case-1:{o=7;break a;break};case-4:{o=3;break a;break};case 0:{o=4;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 9:{q=(ce[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!(($s(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=lt(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=ct(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=Ot(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!(($s(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Pt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ce[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Wt()|0;c[g+240>>2]=$d[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=ye[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Yd[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Yd[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Qt(){var a=0,b=0;a=i;i=i+8|0;$b(((qc(0)|0)>>>0)%4294967295|0|0);b=m1()|0;i=a;return b|0}function Rt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=ht(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=it(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function St(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=$d[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Tt(f+80|0,e);Tt(b+104|0,e);Ut(b,e);Ut(b+20|0,e);Ut(b+40|0,e);Ut(b+60|0,e);a[b+131|0]=0;Ut(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Tt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Ut(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Vt(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Wt(){i=i;return 1912}



function Hr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13968]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(13976,Fy(c[(c[g>>2]|0)+76>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[13968]=1;i=d;return}function Ir(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14144]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(14152,Fy(c[(c[g>>2]|0)+72>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14144]=1;i=d;return}function Jr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14280]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+400>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(14288,Fy(c[(c[g>>2]|0)+400>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14280]=1;i=d;return}function Kr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14384]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+392>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(14392,Fy(c[(c[g>>2]|0)+392>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=14464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14384]=1;i=d;return}function Lr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14488]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(14496,Fy(c[(c[g>>2]|0)+64>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14488]=1;i=d;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14696]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(14704,Fy(c[(c[g>>2]|0)+60>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14696]=1;i=d;return}function Nr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14848]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(14856,Fy(c[(c[g>>2]|0)+52>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[14848]=1;i=d;return}function Or(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15056]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(15064,Fy(c[(c[g>>2]|0)+48>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15056]=1;i=d;return}function Pr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15208]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(15216,Fy(c[(c[g>>2]|0)+40>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15416;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15208]=1;i=d;return}function Qr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15440]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(15448,Fy(c[(c[g>>2]|0)+36>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15440]=1;i=d;return}function Rr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15616]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(15624,Fy(c[(c[g>>2]|0)+384>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=15736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15616]=1;i=d;return}function Sr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15760]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(15768,Fy(c[(c[g>>2]|0)+28>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15760]=1;i=d;return}function Tr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15968]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(15976,Fy(c[(c[g>>2]|0)+24>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[15968]=1;i=d;return}function Ur(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16120]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(16128,Fy(c[(c[g>>2]|0)+16>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[16120]=1;i=d;return}function Vr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16328]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(16336,Fy(c[(c[g>>2]|0)+12>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[16328]=1;i=d;return}function Wr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16480]&1){i=d;return}g=b+420|0;b=rB(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qB(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=Hy(16488,Fy(c[(c[g>>2]|0)+4>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16688;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[16480]=1;i=d;return}function Xr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16712]&1){i=d;return}g=b+420|0;if(!((rB(+(c[c[g>>2]>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(16720,Fy(c[c[g>>2]>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=16864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[16712]=1;i=d;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16888]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+376>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(16896,Fy(c[(c[g>>2]|0)+376>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[16888]=1;i=d;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17032]&1){i=d;return}g=b+420|0;if(!((rB(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=Hy(17040,Fy(c[(c[g>>2]|0)+364>>2]|0,2632)|0)|0;g=c[19848]|0;h=e;j=17128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ve[g&15](e,b,f);a[17032]=1;i=d;return}function _r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17152]&1){i=d;return}g=b+416|0;if(!((rB(+h[(c[g>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=Hy(17160,Dy(+h[(c[g>>2]|0)+200>>3],4528)|0)|0;g=c[19848]|0;j=e;k=17224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ve[g&15](e,b,f);a[17152]=1;i=d;return}function $r(a){a=a|0;var b=0;b=i;hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);pq(a);qq(a);rq(a);sq(a);tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);i=b;return 0}function as(b){b=b|0;var c=0;c=i;a[b+314|0]=0;bs(b);i=c;return 0}function bs(a){a=a|0;var b=0;b=i;Ve(a);We(a);Xe(a);Ye(a);Ze(a);_e(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);Ah(a);i=b;return}function cs(a){a=a|0;i=i;return 0}function ds(a){a=a|0;i=i;return 1}function es(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=3;c[a+48>>2]=3;c[a+72>>2]=E0(3,8)|0;a=E0(3,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=E0(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=C0(12)|0;c[(c[d>>2]|0)+52>>2]=a;a=C0(0)|0;c[(c[d>>2]|0)+56>>2]=a;a=C0(12)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=1;c[a+84>>2]=0;a=c[d>>2]|0;d=a+64|0;e=c[a+52>>2]|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;e=c[d>>2]|0;c[e+8>>2]=1;c[e+4>>2]=1;c[e>>2]=1;i=b;return 0}function fs(a){a=a|0;i=i;return 1}function gs(a){a=a|0;i=i;return 1}function hs(a){a=a|0;i=i;return 1}function is(a){a=a|0;i=i;return 0}function js(a){a=a|0;i=i;return 0}function ks(a){a=a|0;i=i;return 0}function ls(a){a=a|0;i=i;return 0}function ms(a){a=a|0;i=i;return 0}function ns(a,b){a=a|0;b=b|0;i=i;return-1}function os(a,b){a=a|0;b=b|0;i=i;return-1}function ps(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function qs(){i=i;return 17248}function rs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function ss(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function ts(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function us(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);zb(18112,n|0)|0;i=m;return 0}function vs(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=mA(a,18120)|0;z=mA(b,18120)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((mA(a,18128)|0)!=0){C=5;break}if((mA(a,18136)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((mA(b,18128)|0)!=0){break}if((mA(b,18136)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){i1(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}i1(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}i1(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);zb(18144,r|0)|0;i=q;return 0}function ws(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(mA(a,18152)|0)!=0;v=c[(u?f:g)>>2]|0;w=mA(e,18160)|0;x=mA(b,18168)|0;c[p>>2]=0;do{if(u){y=4}else{if((mA(a,18176)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((mA(b,18152)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((mA(d,18160)|0)==0){if((mA(d,18184)|0)!=0){break}if((mA(d,18192)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((mA(e,18168)|0)==0){if((mA(e,18160)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){i1(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(mA(d,18160)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);zb(18200,p|0)|0;i=o;return 0}function xs(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}zs(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}As(18216,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;zb(18208,l|0)|0;i=k;return 0}function ys(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+Vz(18240);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(rs(l,z,18248)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){ts(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;ss(l,n,d+(x-o+v<<3)|0,18248)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;us(l,m,18256,d+(B+y<<3)|0,18248,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;zb(18232,k|0)|0;i=j;return 0}function zs(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=18288;u=Cs(18272,18264,18280,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;ys(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;Bs(k,d,e,m,l,f,18272)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;Bs(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,18272)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;ws(18296,18304,18312,18328,n,k,18336,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=18312;vs(H,H,k,l,n,18344,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,18336,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);ys(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;zb(18264,j|0)|0;i=h;return 0}function As(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(mA(a,18352)|0)!=0;do{if(n){o=5}else{if((mA(a,18360)|0)!=0){o=5;break}if((mA(a,18368)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=18384;Bs(d,h,j,q,b,g,q)|0;ws(18392,18400,18408,18424,b,d,18432,e,f,h,j)|0;ws(18392,18440,18408,18448,b,d,18432,e,f,h,j)|0;i=l;return 0}else{ws(18392,18440,18464,18448,b,d,18432,e,f,h,j)|0;ws(18392,18400,18464,18424,b,d,18432,e,f,h,j)|0;Bs(d,h,j,18384,b,g,18480)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;zb(18376,m|0)|0;i=l;return 0}function Bs(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function Cs(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=e1(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;lQ(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;lQ(t,o+1|0,1,2);l=m;lQ(l,o+3|0,1,3);o=n;lQ(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((kQ(t,18488,1,2)|0)==0){if((kQ(l,18504,1,3)|0)==0){v=128;i=k;return v|0}if((kQ(l,18512,1,3)|0)==0){v=128;i=k;return v|0}if((kQ(l,18520,1,3)|0)==0){v=128;i=k;return v|0}if((kQ(l,18528,1,3)|0)==0){v=128;i=k;return v|0}if((kQ(l,18536,1,3)|0)==0){v=128;i=k;return v|0}n=(kQ(l,18544,1,3)|0)==0;v=n?128:0;i=k;return v|0}if((kQ(t,18568,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}n=(kQ(l,18576,1,3)|0)==0;v=n?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((kQ(t,18592,1,2)|0)==0){n=(kQ(l,18576,1,3)|0)==0;v=n?32:0;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=141;break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((kQ(t,18600,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((kQ(t,18664,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else if((m|0)==2){if((kQ(t,18488,1,2)|0)==0){if((kQ(l,18504,1,3)|0)==0){v=2;i=k;return v|0}if((kQ(l,18512,1,3)|0)==0){v=2;i=k;return v|0}if((kQ(l,18520,1,3)|0)==0){v=2;i=k;return v|0}if((kQ(l,18528,1,3)|0)==0){v=2;i=k;return v|0}if((kQ(l,18536,1,3)|0)==0){v=2;i=k;return v|0}if((kQ(l,18544,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((kQ(t,18568,1,2)|0)==0){m=(kQ(l,18496,1,3)|0)==0;if(m|(p|q)^1){v=m?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((kQ(t,18592,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((kQ(t,18600,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}m=a[l]|0;if(m<<24>>24==71){if((kQ(o,18608,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18616,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18624,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18632,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18640,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18648,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==77){if((kQ(o,18608,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18616,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18624,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18632,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18640,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18648,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((kQ(t,18664,1,2)|0)!=0){v=2;i=k;return v|0}m=a[l]|0;if(m<<24>>24==77){if((kQ(o,18608,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18616,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18624,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18632,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18640,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18648,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==71){if((kQ(o,18608,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18616,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18624,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18632,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18640,1,2)|0)==0){v=2;i=k;return v|0}if((kQ(o,18648,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else{if((kQ(t,18488,1,2)|0)==0){if((kQ(l,18496,1,3)|0)==0){v=64;i=k;return v|0}if((kQ(l,18504,1,3)|0)==0){v=32;i=k;return v|0}if((kQ(l,18512,1,3)|0)==0){v=32;i=k;return v|0}if((kQ(l,18520,1,3)|0)==0){v=32;i=k;return v|0}if((kQ(l,18528,1,3)|0)==0){v=32;i=k;return v|0}if((kQ(l,18536,1,3)|0)==0){v=32;i=k;return v|0}if((kQ(l,18544,1,3)|0)==0){v=32;i=k;return v|0}m=(kQ(l,18552,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((kQ(t,18560,1,2)|0)==0){m=(kQ(l,18496,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((kQ(t,18568,1,2)|0)==0){m=(kQ(l,18496,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(kQ(l,18576,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(kQ(l,18584,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==67|u<<24>>24==90){if((kQ(t,18592,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((kQ(l,18496,1,3)|0)==0){v=64;i=k;return v|0}if((kQ(l,18576,1,3)|0)==0){v=32;i=k;return v|0}m=(kQ(l,18584,1,3)|0)==0;v=m?64:1;i=k;return v|0}else if(u<<24>>24==68|u<<24>>24==83){w=29}}while(0);do{if((w|0)==29){if((kQ(t,18600,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((kQ(t,18664,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((kQ(o,18608,1,2)|0)!=0){if((kQ(o,18616,1,2)|0)==0){break}if((kQ(o,18624,1,2)|0)==0){break}if((kQ(o,18632,1,2)|0)==0){break}if((kQ(o,18640,1,2)|0)==0){break}if((kQ(o,18648,1,2)|0)==0){break}if((kQ(o,18656,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((kQ(t,18672,1,2)|0)==0){if((kQ(l,18496,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((kQ(t,18680,1,2)|0)==0){if((kQ(l,18496,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((kQ(t,18648,1,2)|0)==0){o=(kQ(l,18552,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((kQ(t,18688,1,2)|0)==0){o=(kQ(l,18696,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((kQ(t,18704,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 10:{v=Ds(18720,18728,18736)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 11:{v=Ds(18744,18728,18736)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=Es(b,d,e,f,g,h,j)|0;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function Ds(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function Es(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(jQ(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 12:{p=75;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function Fs(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=Gs(a,0,0)|0;i=b;return c|0}function Gs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Hs(a,b,c,0)|0;i=d;return e|0}function Hs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=$d[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=C0(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=352}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=$d[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Yd[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=$d[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Yd[c[b+20>>2]&511](c[j+392>>2]|0);Yd[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=St(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Yd[c[j+20>>2]&511](c[j+44>>2]|0);Yd[c[j+20>>2]&511](c[j+392>>2]|0);Yd[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Tt(j+416|0,j+12|0);Tt(j+440|0,j+12|0);Js(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Ms(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=lu()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=cu()|0}k=j;l=k;i=g;return l|0}function Is(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Js(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;uw(f+256|0);if((b|0)!=0){g=Ks(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;du(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Ks(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!(($s(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Ls(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=ct(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Ks(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!(($s(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!(($s(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((gt(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!(($s(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=ct(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Ms(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Yd[c[e+20>>2]&511](c[g+36>>2]|0);Ns(c[g+44>>2]|0,e);Yd[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Yd[c[e+20>>2]&511](f)}Ns(c[h+376>>2]|0,e);Ns(c[e+372>>2]|0,e);Os(e+416|0);Os(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Ps(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Yd[c[e+20>>2]&511](c[e+392>>2]|0);Yd[c[e+20>>2]&511](c[e+464>>2]|0);Yd[c[e+20>>2]&511](c[e+8>>2]|0);Yd[c[e+20>>2]&511](c[e+44>>2]|0);Yd[c[e+20>>2]&511](c[e+396>>2]|0);Yd[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Yd[c[e+252>>2]&511](c[e+244>>2]|0)}Yd[c[e+20>>2]&511](e);i=d;return}function Ns(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Yd[c[a+20>>2]&511](c[b+16>>2]|0);Yd[c[a+20>>2]&511](b)}i=d;return}function Os(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Yd[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function Ps(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;at(f,g+20|0);while(1){d=bt(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Yd[c[b+8>>2]&511](c[d+20>>2]|0)}ft(g);ft(g+132|0);ft(g+20|0);ft(g+40|0);ft(g+60|0);Os(g+80|0);Os(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&511](o);i=e;return}Yd[c[b+8>>2]&511](c[g+184>>2]|0);Yd[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Yd[m&511](o);i=e;return}function Qs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Rs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Ss(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Ts(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Vs(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{g1(f|0,b|0,d|0)|0;j=Ws(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=ye[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){ze[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function Ts(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Qt()|0}if((a[e+236|0]|0)!=0){f=Ls(e,20528)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Us(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;h1(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=$d[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;g1(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Yd[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Ws(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Ts(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=ye[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);ze[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Xs(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Ys(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}ze[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Zs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ve[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Vd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ve[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function _s(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[18752+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function $s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;g1((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=oe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=$d[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){g1(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function at(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function ct(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=$d[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){i1(c[m>>2]|0,0,g|0)|0;g=dt(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=dt(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((et(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=$d[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}i1(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=dt(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Yd[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=$d[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){i1(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function dt(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function et(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function ft(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Yd[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Yd[e&511](c[d>>2]|0);i=b;return}function gt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[20336+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[20376+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=oe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=$d[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=$d[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Yd[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;g1(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ve[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function ht(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ce[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Pt(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function it(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=ye[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=jt(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}



function Q0(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=T0(b)|0}}while((ed(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=T0(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[120744+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=T0(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[120760+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=T0(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=T0(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=T0(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=T0(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=T0(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=T0(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=o1(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=o1(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=T0(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){S0(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=o1(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=R0(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){S0(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=j1(q|0,n|0,2)|0;o=o1(p|0,J|0,-32,-1)|0;p=o1(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=o1(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=n1(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=o1(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Id(+(+U0(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Lc()|0)>>2]=34}l=+V0(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=T0(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=T0(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=T0(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=o1(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=o1(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=T0(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=R0(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){S0(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=o1(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Lc()|0)>>2]=22;S0(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Lc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[120776+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[120776+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[120776+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=j1(c[Ra>>2]|0,0,29)|0;Qa=o1(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=y1(Qa|0,Ta|0,1e9,0)|0;pa=z1(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=j1(c[Ua>>2]|0,0,29)|0;Ra=o1(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=y1(Ra|0,Sa|0,1e9,0)|0;Pa=z1(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[120768+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Id(+(+U0(1.0,105-tc|0)),+sc);vc=+xc(+sc,+(+U0(1.0,53-tc|0)));wc=va;yc=vc;zc=va+(sc-vc)}else{wc=0.0;yc=0.0;zc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=yc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=yc;break}}Bc=la*.25+yc}else{if(na>>>0>5e8){Bc=la*.75+yc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+yc;break}else{Bc=la*.75+yc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+xc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=zc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Lc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+V0(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=T0(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=T0(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Lc()|0)>>2]=22;S0(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Lc()|0)>>2]=22;S0(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function R0(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=T0(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=T0(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=T0(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=x1(q|0,m|0,10,0)|0;b=J;g=o1(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=o1(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=T0(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=T0(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=n1(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function S0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function T0(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=X0(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function U0(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=j1(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function V0(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+U0(a,b);i=c;return+d}function W0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ce[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function X0(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((W0(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ce[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function Y0(a){a=a|0;var b=0,c=0.0;b=i;c=+Z0(a,0);i=b;return+c}function Z0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;S0(e,0);h=+Q0(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function _0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;S0(e,0);h=+Q0(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function $0(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function a1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function b1(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function c1(){c[25270]=p;c[25312]=p;c[29954]=p;c[30184]=p}function d1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}cc(116);cc(111);cc(111);cc(32);cc(109);cc(97);cc(110);cc(121);cc(32);cc(115);cc(101);cc(116);cc(106);cc(109);cc(112);cc(115);cc(32);cc(105);cc(110);cc(32);cc(97);cc(32);cc(102);cc(117);cc(110);cc(99);cc(116);cc(105);cc(111);cc(110);cc(32);cc(99);cc(97);cc(108);cc(108);cc(44);cc(32);cc(98);cc(117);cc(105);cc(108);cc(100);cc(32);cc(119);cc(105);cc(116);cc(104);cc(32);cc(97);cc(32);cc(104);cc(105);cc(103);cc(104);cc(101);cc(114);cc(32);cc(118);cc(97);cc(108);cc(117);cc(101);cc(32);cc(102);cc(111);cc(114);cc(32);cc(77);cc(65);cc(88);cc(95);cc(83);cc(69);cc(84);cc(74);cc(77);cc(80);cc(83);cc(10);ga(0);return 0}function e1(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function f1(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function g1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return lb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function h1(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{g1(b,c,d)|0}return b|0}function i1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function j1(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function k1(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function l1(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function m1(){return l1(o)|0}function n1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function o1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function p1(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function q1(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function r1(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function s1(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function t1(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function u1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function v1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=n1(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=n1((A1(i,b,n1(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function w1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=n1(h^a,j^b,h,j)|0;b=J;A1(m,b,n1(k^d,l^e,k,l)|0,J,g)|0;l=n1(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function x1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=u1(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function y1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=A1(a,b,c,d,0)|0;return(J=J,e)|0}function z1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;A1(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function A1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((t1(l|0)|0)>>>0);return(J=n,o)|0}p=(s1(l|0)|0)-(s1(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(s1(l|0)|0)-(s1(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(s1(j|0)|0)+33-(s1(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=t1(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=o1(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;n1(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=n1(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function B1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ud[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function C1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Vd[a&31](b|0,c|0,d|0,e|0,f|0)}function D1(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Wd[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function E1(a,b){a=a|0;b=+b;Xd[a&1](+b)}function F1(a,b){a=a|0;b=b|0;Yd[a&511](b|0)}function G1(a,b,c){a=a|0;b=b|0;c=c|0;Zd[a&127](b|0,c|0)}function H1(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return _d[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function I1(a,b){a=a|0;b=b|0;return $d[a&127](b|0)|0}function J1(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ae[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function K1(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;be[a&1](b|0,+c,d|0,e|0)}function L1(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ce[a&63](b|0,c|0,d|0)|0}function M1(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return de[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function N1(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ee[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function O1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;fe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function P1(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ge[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Q1(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return he[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function R1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ie[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function S1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;je[a&3](b|0,c|0,+d,e|0,f|0)}function T1(a,b,c){a=a|0;b=b|0;c=+c;return ke[a&1](b|0,+c)|0}function U1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;le[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function V1(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;me[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function W1(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ne[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function X1(a,b,c){a=a|0;b=b|0;c=c|0;return oe[a&63](b|0,c|0)|0}function Y1(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return pe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function Z1(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return qe[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function _1(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+re[a&1](b|0,+c,+d)}function $1(a,b,c){a=a|0;b=b|0;c=c|0;return+se[a&1](b|0,c|0)}function a2(a){a=a|0;return te[a&7]()|0}function b2(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ue[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function c2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ve[a&15](b|0,c|0,d|0)}function d2(a){a=a|0;we[a&7]()}function e2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return xe[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function f2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ye[a&63](b|0,c|0,d|0,e|0)|0}function g2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ze[a&31](b|0,c|0,d|0,e|0)}function h2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function i2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function j2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function k2(a){a=+a;ga(3)}function l2(a){a=a|0;ga(4)}function m2(a){a=a|0;td(a|0)}function n2(a,b){a=a|0;b=b|0;ga(5)}function o2(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function p2(a){a=a|0;ga(7);return 0}function q2(a){a=a|0;return Mc(a|0)|0}function r2(a){a=a|0;return Cd(a|0)|0}function s2(a){a=a|0;return uc(a|0)|0}function t2(a){a=a|0;return rd(a|0)|0}function u2(a){a=a|0;return gd(a|0)|0}function v2(a){a=a|0;return md(a|0)|0}function w2(a){a=a|0;return Vc(a|0)|0}function x2(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(8);return 0}function y2(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;ga(9)}function z2(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function A2(a,b,c){a=a|0;b=b|0;c=c|0;return od(a|0,b|0,c|0)|0}function B2(a,b,c){a=a|0;b=b|0;c=c|0;return gc(a|0,b|0,c|0)|0}function C2(a,b,c){a=a|0;b=b|0;c=c|0;return ac(a|0,b|0,c|0)|0}function D2(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function E2(a,b,c){a=a|0;b=b|0;c=c|0;return pd(a|0,b|0,c|0)|0}function F2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function G2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function H2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function I2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function J2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function K2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function L2(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function M2(a,b){a=a|0;b=+b;ga(18);return 0}function N2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function O2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function P2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function Q2(a,b){a=a|0;b=b|0;ga(22);return 0}function R2(a,b){a=a|0;b=b|0;return Hd(a|0,b|0)|0}function S2(a,b){a=a|0;b=b|0;return fc(a|0,b|0)|0}function T2(a,b){a=a|0;b=b|0;return hb(a|0,b|0)|0}function U2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function V2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function W2(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function X2(a,b){a=a|0;b=b|0;ga(26);return 0.0}function Y2(){ga(27);return 0}function Z2(){return ib()|0}function _2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function $2(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function a3(){ga(30)}function b3(){Sc()}function c3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function d3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function e3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pc(a|0,b|0,c|0,d|0)|0}function f3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Kc(a|0,b|0,c|0,d|0)|0}function g3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var Ud=[h2,DA,FA,KA,FP,h2,h2,h2];var Vd=[i2,Iu,Ju,mv,nv,Rv,Sv,nw,ow,pw,y0,x0,w0,au,bu,Px,Nx,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2,i2];var Wd=[j2,jC];var Xd=[k2,pB];var Yd=[l2,Sh,Th,al,bl,ep,dl,Kx,vE,yE,xE,zE,DU,CU,FU,EU,AE,CE,OH,iI,jI,kI,oU,nU,qU,pU,bP,oP,pP,qP,sP,uP,kR,lR,rR,sR,yR,zR,FR,GR,SR,RR,XR,WR,ZR,_R,hS,gS,oT,nT,xT,wT,$T,_T,xU,wU,zU,yU,RU,QU,TU,SU,ZU,YU,mT,_U,XU,$U,bV,aV,jZ,hV,gV,mV,lV,LV,KV,nW,mW,BW,AW,PW,OW,bX,aX,oX,nX,rX,qX,vX,uX,GX,FX,RX,QX,aY,$X,lY,kY,vY,uY,DY,CY,JY,IY,PY,OY,UY,TY,bZ,aZ,zZ,yZ,YY,QZ,v_,u_,x_,w_,cV,iZ,lZ,IZ,YZ,h_,s_,t_,j0,i0,l0,o0,m0,n0,p0,q0,N0,M0,Fh,m2,Uh,Vh,Wh,Xh,Yh,Zh,_h,$h,ai,bi,ci,di,ei,fi,gi,ji,ki,li,mi,ni,oi,pi,qi,ri,si,ti,ui,vi,wi,xi,Ai,Bi,Ci,Di,Ei,Fi,Gi,Hi,Ii,Ji,Ki,Li,Mi,Ni,Oi,Ri,Si,Ti,Ui,Vi,Wi,Xi,Yi,Zi,_i,$i,aj,bj,cj,dj,gj,hj,ij,jj,kj,lj,mj,nj,oj,pj,qj,rj,sj,tj,uj,Ve,We,Xe,Ye,Ze,_e,$e,af,bf,cf,df,ef,ff,gf,hf,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,ag,bg,cg,dg,eg,fg,gg,hg,ig,jg,kg,lg,mg,ng,og,pg,qg,rg,sg,tg,ug,vg,wg,xg,yg,zg,Ag,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Jg,Kg,Lg,Mg,Ng,Og,Pg,Qg,Rg,Sg,Tg,Ug,Vg,Wg,Xg,Yg,Zg,_g,$g,ah,bh,ch,dh,eh,fh,gh,hh,ih,jh,kh,lh,mh,nh,oh,ph,qh,rh,sh,th,uh,vh,wh,Ah,D0,Mx,Qe,$A,dB,_A,mC,fB,kC,Dz,iB,gB,hB,eB,kB,lC,lB,aB,nB,OO,oB,KQ,jR,kZ,d$,nY,k$,j$,i$,h$,g$,f$,xS,$S,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2,l2];var Zd=[n2,cl,TC,DE,OT,mR,tR,AR,HR,aU,yX,zX,AX,BX,DX,EX,JX,KX,LX,MX,OX,PX,UX,VX,WX,XX,ZX,_X,dY,eY,fY,gY,iY,jY,SY,XY,C_,E_,G_,D_,F_,H_,SA,hi,yi,Pi,ej,vj,Mj,bk,sk,Jk,_k,jB,uH,VC,UC,WC,aD,mD,XC,kD,JG,VG,UG,WG,EG,CG,GG,TP,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2,n2];var _d=[o2,pu,iu,EA,GA,HA,IA,JA];var $d=[p2,Ch,as,Bh,Se,Te,Ue,fp,gp,jl,dp,$r,cs,il,gl,ds,es,fs,gs,hs,is,js,ks,ls,ms,q2,r2,s2,sy,C0,t2,HE,TT,IE,WT,ST,xP,nR,fU,hU,iU,eU,uR,vR,BR,VT,IR,JR,TR,YR,VU,QW,I_,K_,M_,S_,U_,O_,Q_,cX,J_,L_,N_,T_,V_,P_,R_,wX,xX,CX,HX,IX,NX,SX,TX,YX,bY,cY,hY,UZ,VZ,XZ,y_,A_,z_,B_,MZ,NZ,PZ,c_,d_,g_,n_,o_,r_,k0,O0,tC,u2,v2,rC,sC,w2,HO,gP,sB,AB,JB,tB,DB,KB,bR,X0,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2,p2];var ae=[x2,nA];var be=[y2,iz];var ce=[z2,fl,zu,Fu,dv,jv,Iv,Ov,EE,UT,YT,PT,bU,gU,oR,kU,CR,bS,cS,fV,kV,QY,VY,BZ,DZ,GZ,mZ,rZ,tZ,wZ,r0,QO,dz,mu,du,ku,qu,A2,B2,C2,nC,NO,JO,D2,VQ,E2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2,z2];var de=[F2,rA];var ee=[G2,Lz];var fe=[H2,vW,yW,JW,LW,H2,H2,H2];var ge=[I2,pX,sX,mY,qY,wY,yY,I2];var he=[J2,lA];var ie=[K2,Hx,FE,vP,cU,QT,oW,pW,tW,zW,CW,DW,HW,MW,RY,WY,B0,A0,z0,Ix,K2,K2,K2,K2,K2,K2,K2,K2,K2,K2,K2,K2];var je=[L2,BB,CB,L2];var ke=[M2,Eh];var le=[N2,nV,pV,rV,tV,vV,xV,zV,BV,DV,FV,HV,MV,OV,QV,SV,UV,WV,YV,_V,aW,cW,eW,sW,uW,GW,IW,RW,SW,TW,UW,VW,dX,eX,fX,gX,hX,HY,NY,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2,N2];var me=[O2,EY,KY,O2];var ne=[P2,WW,iX,P2];var oe=[Q2,Re,kl,hl,el,ns,os,Bu,Cu,Eu,fv,gv,iv,Kv,Lv,Nv,Tv,Uv,Vv,Wv,Xv,Yv,Zv,_v,JE,KE,yP,zP,jU,pR,wR,lU,XT,DR,KR,ZT,AZ,CZ,EZ,qZ,sZ,uZ,bC,MB,EB,uB,LB,R2,F0,Zt,_t,$t,S2,cy,dy,Iy,xB,ZB,QB,zB,T2,W$,Q2,Q2];var pe=[U2,dV,iV,HZ,TZ,WZ,xZ,LZ,OZ,b_,e_,m_,p_,vw,mx,nx,Aw,xw,kx,lx,Bw,Cw,Dw,Ew,Fw,ax,bx,Tw,Mw,Hw,Gw,Iw,Jw,Lw,Kw,yw,ww,Nw,Ow,Pw,Qw,Rw,Sw,Uw,Vw,Ww,Xw,$w,Zw,Yw,_w,gx,cx,dx,ex,fx,hx,ix,jx,ox,px,qx,rx,qW];var qe=[V2,yC];var re=[W2,NB];var se=[X2,Vz];var te=[Y2,qs,Z2,ty,gR,hR,eR,Y2];var ue=[_2,qA];var ve=[$2,SO,aS,WU,Wy,Zx,Sx,OC,QC,tH,SP,$2,$2,$2,$2,$2];var we=[a3,b3,ry,ux,Hh,a3,a3,a3];var xe=[c3,ps,RZ,SZ,JZ,KZ,ZZ,$Z,i_,k_,RB,c3,c3,c3,c3,c3];var ye=[d3,tu,uu,vu,wu,xu,yu,Au,Du,Hu,Zu,_u,$u,av,bv,cv,ev,hv,lv,Cv,Dv,Ev,Fv,Gv,Hv,Jv,Mv,Qv,FZ,nZ,oZ,pZ,vZ,UA,Xx,e3,mA,Rt,Us,nt,wt,it,Ft,Kt,It,Lt,ru,Xt,fu,gu,nu,ou,JV,wW,f3,d3,d3,d3,d3,d3,d3,d3,d3,d3];var ze=[g3,Gu,kv,Pv,GE,RO,wP,dU,RT,eV,jV,s0,t0,u0,Qx,Ox,WA,Wx,Rx,ii,zi,Qi,fj,wj,Nj,ck,tk,Kk,$k,lQ,hu,Tx];return{_testSetjmp:r1,_saveSetjmp:d1,_free:D0,_main:Gh,_rand_r:l1,_realloc:F0,_i64Add:o1,_memmove:h1,_bitshift64Ashr:f1,_memset:i1,_malloc:C0,_strncpy:p1,_memcpy:g1,_strlen:e1,_bitshift64Lshr:q1,_bitshift64Shl:j1,_i64Subtract:n1,_strcpy:k1,_calloc:E0,_rand:m1,__GLOBAL__I_a:MR,runPostSets:c1,stackAlloc:Ae,stackSave:Be,stackRestore:Ce,setThrew:De,setTempRet0:Ge,setTempRet1:He,setTempRet2:Ie,setTempRet3:Je,setTempRet4:Ke,setTempRet5:Le,setTempRet6:Me,setTempRet7:Ne,setTempRet8:Oe,setTempRet9:Pe,dynCall_iiiiiiii:B1,dynCall_viiiii:C1,dynCall_iiiiidiii:D1,dynCall_vd:E1,dynCall_vi:F1,dynCall_vii:G1,dynCall_iiiiiiiiiii:H1,dynCall_ii:I1,dynCall_iiiiiiiiiiiiii:J1,dynCall_vidii:K1,dynCall_iiii:L1,dynCall_iiiiiiiiiiiiiiiiiiiiiii:M1,dynCall_iiiiiiiiiiiiiiiiiiiii:N1,dynCall_viiiiid:O1,dynCall_viiiiiiii:P1,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:Q1,dynCall_viiiiii:R1,dynCall_viidii:S1,dynCall_iid:T1,dynCall_viiiiiii:U1,dynCall_viiiiiid:V1,dynCall_viiiiiiiii:W1,dynCall_iii:X1,dynCall_iiiiii:Y1,dynCall_iiiiidi:Z1,dynCall_didd:_1,dynCall_dii:$1,dynCall_i:a2,dynCall_iiiiiiiiii:b2,dynCall_viii:c2,dynCall_v:d2,dynCall_iiiiiiiii:e2,dynCall_iiiii:f2,dynCall_viiii:g2}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_vidii": invoke_vidii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_vidii = Module["dynCall_vidii"] = asm["dynCall_vidii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






