var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 331960;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 332000;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(332827);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,150,6,0,0,66,53,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,53,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,202,6,0,0,66,53,46,104,95,118,32,45,32,66,53,46,104,95,108,0,1,0,0,0,226,6,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,44,32,86,49,53,46,115,116,97,116,101,95,97,46,100,44,32,86,49,53,46,115,116,97,116,101,95,98,46,100,44,32,86,49,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,1,0,0,0,241,6,0,0,109,97,120,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,51,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,1,0,0,0,244,6,0,0,109,97,120,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,51,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,248,6,0,0,109,97,120,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,0,0,0,0,1,0,0,0,254,6,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,51,46,109,95,102,108,111,119,44,32,86,51,46,115,116,97,116,101,95,97,46,100,44,32,86,51,46,115,116,97,116,101,95,98,46,100,44,32,86,51,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,13,7,0,0,80,49,95,111,110,46,114,105,115,105,110,103,0,0,0,0,80,49,95,111,110,46,102,97,108,108,105,110,103,0,0,0,1,0,0,0,14,7,0,0,80,49,95,111,110,46,114,97,116,101,0,0,0,0,0,0,1,0,0,0,40,7,0,0,109,97,120,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,54,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,1,0,0,0,43,7,0,0,109,97,120,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,54,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,1,0,0,0,47,7,0,0,109,97,120,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,55,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,54,46,109,95,102,108,111,119,44,32,86,54,46,115,116,97,116,101,95,97,46,100,44,32,86,54,46,115,116,97,116,101,95,98,46,100,44,32,86,54,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,65,7,0,0,80,50,95,111,110,46,114,105,115,105,110,103,0,0,0,0,80,50,95,111,110,46,102,97,108,108,105,110,103,0,0,0,1,0,0,0,66,7,0,0,80,50,95,111,110,46,114,97,116,101,0,0,0,0,0,0,1,0,0,0,84,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,86,50,46,115,116,97,116,101,95,97,46,100,44,32,86,50,46,115,116,97,116,101,95,98,46,100,44,32,86,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,1,0,0,0,88,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,86,52,46,115,116,97,116,101,95,97,46,100,44,32,86,52,46,115,116,97,116,101,95,98,46,100,44,32,86,52,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,1,0,0,0,94,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,86,49,46,115,116,97,116,101,95,97,46,100,44,32,86,49,46,115,116,97,116,101,95,98,46,100,44,32,86,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,1,0,0,0,102,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,49,93,44,32,86,50,50,46,115,116,97,116,101,95,97,46,100,44,32,86,50,50,46,115,116,97,116,101,95,98,46,100,44,32,86,50,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,108,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,86,53,46,115,116,97,116,101,95,97,46,100,44,32,86,53,46,115,116,97,116,101,95,98,46,100,44,32,86,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,1,0,0,0,118,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,86,50,53,46,115,116,97,116,101,95,97,46,100,44,32,86,50,53,46,115,116,97,116,101,95,98,46,100,44,32,86,50,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,133,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,49,46,109,95,102,108,111,119,44,32,86,50,49,46,115,116,97,116,101,95,97,46,100,44,32,86,50,49,46,115,116,97,116,101,95,98,46,100,44,32,86,50,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,141,7,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,67,97,118,105,116,97,116,105,111,110,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,112,117,109,112,0,0,0,1,0,0,0,152,7,0,0,80,49,46,114,104,111,0,0,1,0,0,0,162,7,0,0,80,49,46,78,0,0,0,0,1,0,0,0,163,7,0,0,80,49,46,101,116,97,0,0,67,97,118,105,116,97,116,105,111,110,32,111,99,99,117,114,115,32,97,116,32,116,104,101,32,112,117,109,112,32,105,110,108,101,116,0,0,0,0,0,1,0,0,0,170,7,0,0,115,121,115,116,101,109,46,103,32,42,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,0,1,0,0,0,171,7,0,0,47,42,82,101,97,108,42,47,40,80,49,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,176,7,0,0,80,49,46,109,0,0,0,0,1,0,0,0,177,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,51,46,109,95,102,108,111,119,44,32,86,50,51,46,115,116,97,116,101,95,97,46,100,44,32,86,50,51,46,115,116,97,116,101,95,98,46,100,44,32,86,50,51,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,190,7,0,0,80,50,46,114,104,111,0,0,1,0,0,0,200,7,0,0,80,50,46,78,0,0,0,0,1,0,0,0,201,7,0,0,80,50,46,101,116,97,0,0,1,0,0,0,208,7,0,0,115,121,115,116,101,109,46,103,32,42,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,0,1,0,0,0,209,7,0,0,47,42,82,101,97,108,42,47,40,80,50,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,214,7,0,0,80,50,46,109,0,0,0,0,1,0,0,0,215,7,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,52,46,109,95,102,108,111,119,44,32,86,50,52,46,115,116,97,116,101,95,97,46,100,44,32,86,50,52,46,115,116,97,116,101,95,98,46,100,44,32,86,50,52,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,226,7,0,0,66,49,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,49,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,232,7,0,0,66,50,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,50,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,238,7,0,0,66,51,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,51,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,244,7,0,0,66,52,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,52,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,255,7,0,0,66,55,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,55,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,11,8,0,0,66,54,46,109,101,100,105,117,109,46,100,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,54,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,19,8,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,1,0,0,0,23,8,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,29,8,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,0,0,0,1,0,0,0,38,8,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,0,0,1,0,0,0,47,8,0,0,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,51,8,0,0,112,105,112,101,66,49,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,52,8,0,0,112,105,112,101,66,49,66,50,46,109,115,91,49,93,0,0,1,0,0,0,56,8,0,0,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,60,8,0,0,112,105,112,101,66,49,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,61,8,0,0,112,105,112,101,66,49,66,50,46,109,115,91,50,93,0,0,1,0,0,0,75,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,1,0,0,0,81,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,1,0,0,0,90,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,1,0,0,0,99,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,103,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,1,0,0,0,104,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,50,93,0,0,0,0,0,0,0,1,0,0,0,105,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,109,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,1,0,0,0,110,8,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,122,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,1,0,0,0,128,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,1,0,0,0,137,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,1,0,0,0,146,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,150,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,1,0,0,0,151,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,50,93,0,0,0,0,0,0,0,1,0,0,0,152,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,156,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,1,0,0,0,157,8,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,190,8,0,0,118,111,108,117,109,101,53,46,86,0,0,0,0,0,0,0,1,0,0,0,191,8,0,0,109,97,120,40,45,86,49,57,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,195,8,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,48,46,109,95,102,108,111,119,44,32,86,50,48,46,115,116,97,116,101,95,97,46,100,44,32,86,50,48,46,115,116,97,116,101,95,98,46,100,44,32,86,50,48,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,197,8,0,0,118,111,108,117,109,101,53,46,109,0,0,0,0,0,0,0,1,0,0,0,202,8,0,0,109,97,120,40,45,86,50,48,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,206,8,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,57,46,109,95,102,108,111,119,44,32,86,49,57,46,115,116,97,116,101,95,97,46,100,44,32,86,49,57,46,115,116,97,116,101,95,98,46,100,44,32,86,49,57,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,209,8,0,0,112,105,112,101,66,54,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,210,8,0,0,112,105,112,101,66,54,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,238,8,0,0,112,105,112,101,66,55,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,239,8,0,0,112,105,112,101,66,55,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,243,8,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,56,46,109,95,102,108,111,119,44,32,86,49,56,46,115,116,97,116,101,95,97,46,100,44,32,86,49,56,46,115,116,97,116,101,95,98,46,100,44,32,86,49,56,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,11,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,44,32,86,49,50,46,115,116,97,116,101,95,97,46,100,44,32,86,49,50,46,115,116,97,116,101,95,98,46,100,44,32,86,49,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,30,9,0,0,112,105,112,101,66,49,66,49,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,34,9,0,0,118,111,108,117,109,101,52,46,86,0,0,0,0,0,0,0,1,0,0,0,35,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,56,46,109,95,102,108,111,119,41,32,43,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,48,46,109,95,102,108,111,119,41,32,43,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,57,46,109,95,102,108,111,119,41,0,0,0,0,0,0,0,1,0,0,0,37,9,0,0,118,111,108,117,109,101,52,46,109,0,0,0,0,0,0,0,1,0,0,0,44,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,48,46,109,95,102,108,111,119,44,32,86,49,48,46,115,116,97,116,101,95,97,46,100,44,32,86,49,48,46,115,116,97,116,101,95,98,46,100,44,32,86,49,48,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,46,9,0,0,112,105,112,101,66,49,66,49,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,63,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,49,46,109,95,102,108,111,119,44,32,86,49,49,46,115,116,97,116,101,95,97,46,100,44,32,86,49,49,46,115,116,97,116,101,95,98,46,100,44,32,86,49,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,86,9,0,0,112,105,112,101,66,50,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,87,9,0,0,112,105,112,101,66,50,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,94,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,57,46,109,95,102,108,111,119,44,32,86,57,46,115,116,97,116,101,95,97,46,100,44,32,86,57,46,115,116,97,116,101,95,98,46,100,44,32,86,57,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,121,9,0,0,112,105,112,101,66,49,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,122,9,0,0,112,105,112,101,66,49,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,126,9,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,56,46,109,95,102,108,111,119,44,32,86,56,46,115,116,97,116,101,95,97,46,100,44,32,86,56,46,115,116,97,116,101,95,98,46,100,44,32,86,56,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,139,9,0,0,66,54,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,150,9,0,0,66,55,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,161,9,0,0,66,52,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,172,9,0,0,66,51,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,183,9,0,0,66,50,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,194,9,0,0,66,49,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,203,9,0,0,66,53,46,99,114,111,115,115,65,114,101,97,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,87,97,116,101,114,73,70,57,55,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,109,111,0,0,0,64,31,0,0,188,3,0,0,7,0,0,0,190,3,0,0,7,0,0,0,0,0,0,0,10,32,32,32,32,84,97,110,107,32,105,115,32,111,118,101,114,102,108,111,119,105,110,103,46,10,32,32,32,32,0,0,64,31,0,0,192,3,0,0,7,0,0,0,194,3,0,0,5,0,0,0,0,0,0,0,10,32,32,32,32,65,116,116,101,109,112,116,105,110,103,32,116,111,32,104,101,97,116,32,97,110,32,101,109,112,116,121,32,116,97,110,107,10,32,32,0,0,0,0,0,0,0,0,84,97,110,107,32,115,116,97,114,116,115,32,116,111,32,111,118,101,114,102,108,111,119,32,40,108,101,118,101,108,32,61,32,104,101,105,103,104,116,32,61,32,0,0,0,0,0,0,41,0,0,0,0,0,0,0,77,97,115,115,32,105,110,32,116,97,110,107,32,105,115,32,122,101,114,111,0,0,0,0,64,31,0,0,143,6,0,0,5,0,0,0,143,6,0,0,96,0,0,0,0,0,0,0,64,31,0,0,144,6,0,0,5,0,0,0,144,6,0,0,41,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,248,30,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,152,32,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,64,31,0,0,174,3,0,0,11,0,0,0,174,3,0,0,94,0,0,0,0,0,0,0,65,116,116,101,109,112,116,32,116,111,32,102,105,108,108,32,116,97,110,107,32,119,104,105,108,101,32,101,118,97,112,111,114,97,116,105,110,103,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,66,97,116,99,104,80,108,97,110,116,95,83,116,97,110,100,97,114,100,87,97,116,101,114,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,66,97,116,99,104,80,108,97,110,116,95,83,116,97,110,100,97,114,100,87,97,116,101,114,95,105,110,102,111,46,120,109,108,0,0,0,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,48,36,0,0,32,3,0,0,9,0,0,0,32,3,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,36,0,0,119,2,0,0,7,0,0,0,121,2,0,0,43,0,0,0,0,0,0,0,87,114,111,110,103,32,112,117,109,112,32,99,117,114,118,101,32,45,45,32,104,101,97,100,95,110,111,109,105,110,97,108,32,109,117,115,116,32,98,101,32,109,111,110,111,116,111,110,105,99,97,108,108,121,32,100,101,99,114,101,97,115,105,110,103,32,119,105,116,104,32,105,110,99,114,101,97,115,105,110,103,32,86,95,102,108,111,119,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,144,41,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,144,41,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,116,104,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,232,42,0,0,177,4,0,0,5,0,0,0,179,4,0,0,51,0,0,0,0,0,0,0,83,111,108,118,105,110,103,32,97,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,119,105,116,104,32,102,117,110,99,116,105,111,110,10,34,77,97,116,114,105,99,101,115,46,115,111,108,118,101,34,32,105,115,32,110,111,116,32,112,111,115,115,105,98,108,101,44,32,98,101,99,97,117,115,101,32,116,104,101,32,115,121,115,116,101,109,32,104,97,115,32,101,105,116,104,101,114,10,110,111,32,111,114,32,105,110,102,105,110,105,116,101,108,121,32,109,97,110,121,32,115,111,108,117,116,105,111,110,115,32,40,65,32,105,115,32,115,105,110,103,117,108,97,114,41,46,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,240,43,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,200,71,0,0,208,71,0,0,0,0,0,0,1,0,0,0,184,70,0,0,192,70,0,0,0,0,0,0,1,0,0,0,168,69,0,0,176,69,0,0,0,0,0,0,1,0,0,0,168,68,0,0,176,68,0,0,0,0,0,0,1,0,0,0,168,67,0,0,176,67,0,0,0,0,0,0,1,0,0,0,168,66,0,0,176,66,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,111,91,50,53,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,240,43,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,240,43,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,240,43,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,240,43,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,240,43,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,240,43,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,240,43,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,240,43,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,240,43,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,24,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,240,43,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,112,104,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,240,43,0,0,37,10,0,0,9,0,0,0,40,10,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,240,43,0,0,19,17,0,0,9,0,0,0,22,17,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,240,43,0,0,122,16,0,0,9,0,0,0,125,16,0,0,41,0,0,0,0,0,0,0,240,43,0,0,214,19,0,0,11,0,0,0,215,19,0,0,91,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,100,116,32,102,114,111,109,32,112,104,32,99,97,108,108,101,100,32,105,110,32,50,32,112,104,97,115,101,32,114,101,103,105,111,110,58,32,116,104,105,115,32,99,97,110,32,110,111,116,32,119,111,114,107,0,0,0,0,0,240,43,0,0,246,19,0,0,9,0,0,0,247,19,0,0,65,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,116,111,102,112,104,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,1,0,0,0,176,65,0,0,184,65,0,0,0,0,0,0,1,0,0,0,184,64,0,0,192,64,0,0,0,0,0,0,1,0,0,0,192,63,0,0,200,63,0,0,0,0,0,0,1,0,0,0,184,62,0,0,192,62,0,0,0,0,0,0,1,0,0,0,176,61,0,0,184,61,0,0,0,0,0,0,1,0,0,0,168,60,0,0,176,60,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,240,43,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,240,43,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,240,43,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,240,43,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,240,43,0,0,221,20,0,0,9,0,0,0,221,20,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,116,111,102,112,104,53,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,1,0,0,0,120,60,0,0,128,60,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,240,43,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,80,1,0,0,9,0,0,0,83,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,160,1,0,0,9,0,0,0,163,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,54,1,0,0,9,0,0,0,57,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,238,0,0,0,9,0,0,0,241,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,255,0,0,0,9,0,0,0,2,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,240,43,0,0,222,1,0,0,9,0,0,0,225,1,0,0,41,0,0,0,0,0,0,0,240,43,0,0,11,25,0,0,7,0,0,0,11,25,0,0,71,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,115,116,101,97,109,32,116,97,98,108,101,115,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,104,32,61,32,0,0,41,0,0,0,0,0,0,0,240,43,0,0,22,25,0,0,7,0,0,0,23,25,0,0,58,0,0,0,0,0,0,0,1,0,0,0,32,59,0,0,40,59,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,32,102,111,114,32,118,105,115,99,111,115,105,116,121,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,100,101,110,115,105,116,121,10,100,32,61,32,0,0,0,0,32,60,61,32,0,0,0,0,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,100,101,110,115,105,116,121,41,0,240,43,0,0,87,15,0,0,9,0,0,0,90,15,0,0,37,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,58,32,118,105,115,99,111,115,105,116,121,32,99,111,109,112,117,116,101,100,32,111,117,116,115,105,100,101,32,116,104,101,32,114,97,110,103,101,10,111,102,32,118,97,108,105,100,105,116,121,32,111,102,32,116,104,101,32,73,70,57,55,32,102,111,114,109,117,108,97,116,105,111,110,58,32,112,32,61,32,0,0,0,32,80,97,44,32,84,99,32,61,32,0,0,0,0,0,0,240,43,0,0,91,15,0,0,9,0,0,0,96,15,0,0,44,0,0,0,0,0,0,0,44,32,84,32,61,32,0,0,240,43,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,102,233,84,67,44,108,224,63,94,63,14,148,37,132,212,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,146,76,152,122,231,232,191,208,196,42,148,59,34,200,63,25,161,233,54,242,138,203,63,209,13,3,76,207,106,231,63,54,90,14,244,80,219,243,63,203,158,4,54,231,160,247,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,108,10,191,47,9,210,191,8,60,48,128,240,33,241,191,149,73,13,109,0,54,244,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,203,126,130,48,92,194,198,63,252,86,235,196,229,120,221,63,107,35,67,51,244,244,205,63,137,194,29,94,198,131,223,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,181,41,195,93,98,165,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,251,55,47,78,124,196,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,193,4,234,164,41,144,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,151,88,73,198,146,187,109,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,50,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,32,64,32,0,0,0,0,0,0,0,27,82,16,195,221,180,117,63,91,241,78,159,211,197,197,191,232,255,187,127,199,67,38,64,218,1,248,99,246,5,161,192,206,136,30,128,39,149,64,191,48,128,218,26,207,206,225,63,240,4,46,183,154,223,34,192,202,136,215,255,21,16,211,191,53,217,90,128,221,123,87,64,96,90,249,145,239,193,147,63,112,55,147,142,204,253,218,63,163,49,164,161,90,37,76,193,177,214,63,238,242,53,126,191,8,53,151,241,70,180,214,191,219,168,78,20,129,246,255,191,128,189,125,5,23,121,242,63,106,24,188,51,171,51,182,64,51,132,142,203,34,141,128,63,185,137,15,26,189,17,198,63,103,2,133,8,232,174,240,63,117,149,156,29,96,13,211,191,220,149,151,95,192,238,225,63,74,192,30,215,113,157,209,63,201,162,112,86,16,253,194,191,77,228,10,220,83,171,176,191,227,251,230,96,194,101,7,192,83,250,58,253,84,5,177,63,139,233,23,51,210,47,12,64,66,43,165,221,120,248,141,191,205,57,22,215,212,245,1,192,102,59,4,98,115,175,241,63,101,90,82,13,170,237,164,191,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,30,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,30,0,0,0,0,0,0,0,125,184,117,9,34,88,35,190,173,203,40,168,167,53,78,62,229,95,204,153,121,156,195,62,254,182,180,246,203,101,1,191,18,48,47,21,9,176,81,63,201,60,7,228,82,94,209,191,146,130,40,50,1,39,241,63,80,49,160,27,129,82,235,191,246,174,159,174,28,145,246,190,144,218,49,221,87,56,73,63,102,117,23,114,203,168,113,191,17,114,159,221,142,3,221,63,83,94,100,244,123,63,224,191,136,254,137,238,104,30,89,192,254,28,203,4,207,14,204,191,58,249,102,172,225,175,9,192,18,211,236,226,138,252,130,64,231,85,151,136,54,70,66,63,249,169,122,242,247,255,199,63,70,140,135,102,188,138,130,63,249,126,253,99,70,68,210,63,125,150,168,88,97,228,160,63,230,210,248,105,245,180,206,63,138,172,175,65,105,79,19,64,104,245,29,59,110,155,39,192,119,152,47,138,217,177,197,63,81,88,2,150,187,109,146,191,36,129,254,185,99,9,163,63,224,240,16,12,61,117,171,191,96,179,24,60,39,182,249,63,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,31,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,20,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,31,0,0,0,0,0,0,0,227,139,224,185,7,240,129,190,199,167,35,43,83,31,211,62,40,114,77,59,34,174,238,190,41,130,212,196,250,47,122,63,63,226,81,247,138,76,119,64,152,254,207,52,139,18,188,192,100,178,19,129,109,128,33,65,128,60,67,165,246,105,68,193,89,239,89,2,195,131,1,191,251,187,130,30,23,35,153,191,195,72,114,66,134,231,71,64,201,118,94,97,66,9,224,62,55,111,232,94,106,7,85,63,170,153,252,205,103,136,145,63,24,215,84,75,40,5,33,192,233,234,135,170,60,245,139,191,125,151,220,87,30,32,208,190,68,241,91,70,74,164,107,63,178,108,175,52,233,166,225,191,206,12,139,3,160,85,231,63,97,97,173,126,173,83,132,191,249,173,4,9,6,139,190,191,51,14,161,48,222,103,233,63,53,239,38,140,197,18,221,63,222,108,213,220,59,225,202,63,33,203,14,111,2,77,122,191,203,46,12,82,120,20,152,191,183,35,106,48,182,169,100,63,238,50,72,229,102,84,127,191,29,139,85,18,145,227,139,63,111,231,135,7,126,62,139,191,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,33,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,33,0,0,0,0,0,0,0,77,167,246,65,166,242,0,63,149,115,198,175,185,184,32,191,108,133,64,64,120,47,63,191,140,106,98,88,202,150,89,63,223,23,144,208,200,16,187,63,239,224,44,179,125,118,85,192,164,38,97,234,30,161,134,64,31,236,239,98,140,73,104,63,166,229,119,245,35,71,120,191,219,58,64,176,10,222,137,191,178,42,1,159,147,159,189,191,158,152,86,48,155,57,85,64,166,99,70,220,226,61,134,191,170,142,33,156,255,153,143,63,106,100,216,77,47,54,179,63,132,234,73,145,175,219,153,63,193,132,70,10,49,217,174,191,171,220,81,100,26,156,8,192,247,200,6,135,176,99,173,191,219,94,228,246,139,35,20,64,58,0,51,85,69,154,237,191,184,70,117,189,181,86,15,64,193,109,7,107,34,84,83,192,97,26,42,55,139,138,194,64,245,24,97,50,133,133,53,193,210,177,220,201,81,50,96,65,11,93,150,161,24,142,235,63,150,223,73,71,181,177,212,63,181,166,108,245,236,241,235,63,67,187,199,160,31,242,219,191,232,227,2,191,153,87,210,63,178,144,147,195,28,222,192,191,63,45,198,149,134,183,123,63,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,11,2,0,0,112,105,112,101,66,49,66,49,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,16,2,0,0,66,51,46,98,111,116,116,111,109,65,114,101,97,91,50,93,0,0,0,0,0,0,0,0,66,51,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,0,0,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,141,2,0,0,112,105,112,101,66,54,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,1,0,0,0,144,2,0,0,109,97,120,40,45,86,50,48,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,49,57,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,1,0,0,0,151,2,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,66,54,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,66,54,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,176,2,0,0,80,50,46,78,0,0,0,0,1,0,0,0,177,2,0,0,80,50,46,78,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,183,2,0,0,47,42,82,101,97,108,42,47,40,80,50,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,188,2,0,0,80,50,46,114,104,111,95,110,111,109,105,110,97,108,0,0,80,50,46,114,104,111,0,0,80,50,46,101,116,97,0,0,1,0,0,0,56,3,0,0,112,105,112,101,66,55,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,1,0,0,0,63,3,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,66,55,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,66,55,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,85,3,0,0,80,49,46,78,0,0,0,0,1,0,0,0,86,3,0,0,80,49,46,78,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,89,3,0,0,47,42,82,101,97,108,42,47,40,80,49,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,94,3,0,0,80,49,46,114,104,111,95,110,111,109,105,110,97,108,0,0,80,49,46,114,104,111,0,0,80,49,46,101,116,97,0,0,1,0,0,0,252,3,0,0,66,51,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,19,4,0,0,112,105,112,101,66,50,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,20,4,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,0,0,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,24,4,0,0,66,50,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,66,50,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,38,4,0,0,66,50,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,68,4,0,0,112,105,112,101,66,49,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,69,4,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,0,0,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,73,4,0,0,66,49,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,66,49,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,83,4,0,0,66,51,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,95,4,0,0,66,49,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,150,4,0,0,66,53,46,116,111,112,95,112,105,112,101,65,114,101,97,91,49,93,0,0,0,0,0,0,66,53,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,66,52,46,98,111,116,116,111,109,65,114,101,97,91,49,93,0,0,0,0,0,0,0,0,66,52,46,109,101,100,105,117,109,46,100,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,157,4,0,0,66,52,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,180,4,0,0,66,53,46,98,111,116,116,111,109,95,112,105,112,101,65,114,101,97,91,49,93,0,0,0,1,0,0,0,185,4,0,0,66,55,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,218,4,0,0,66,54,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,221,6,0,0,1,0,0,0,155,7,0,0,1,0,0,0,161,7,0,0,1,0,0,0,193,7,0,0,1,0,0,0,199,7,0,0,1,0,0,0,175,8,0,0,1,0,0,0,181,8,0,0,1,0,0,0,187,8,0,0,1,0,0,0,226,8,0,0,1,0,0,0,232,8,0,0,1,0,0,0,254,8,0,0,1,0,0,0,20,9,0,0,1,0,0,0,28,9,0,0,1,0,0,0,56,9,0,0,1,0,0,0,74,9,0,0,1,0,0,0,75,9], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([1,0,0,0,79,9,0,0,1,0,0,0,103,9,0,0,1,0,0,0,106,9,0,0,1,0,0,0,109,9,0,0,1,0,0,0,132,9,0,0,1,0,0,0,135,9,0,0,66,54,46,112,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,143,9,0,0,1,0,0,0,146,9,0,0,66,55,46,112,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,154,9,0,0,1,0,0,0,157,9,0,0,66,52,46,112,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,165,9,0,0,1,0,0,0,168,9,0,0,66,51,46,112,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,176,9,0,0,1,0,0,0,179,9,0,0,66,50,46,112,95,97,109,98,105,101,110,116,0,0,0,0,1,0,0,0,187,9,0,0,1,0,0,0,190,9,0,0,66,49,46,112,95,97,109,98,105,101,110,116,0,0,0,0,216,81,0,0,160,83,0,0,104,85,0,0,48,87,0,0,248,88,0,0,176,90,0,0,104,92,0,0,248,93,0,0,168,94,0,0,24,96,0,0,200,96,0,0,56,98,0,0,232,98,0,0,88,100,0,0,8,101,0,0,184,101,0,0,40,103,0,0,216,103,0,0,72,105,0,0,248,105,0,0,104,107,0,0,216,108,0,0,72,110,0,0,216,111,0,0,56,112,0,0,168,112,0,0,184,112,0,0,24,113,0,0,40,113,0,0,168,113,0,0,24,114,0,0,152,114,0,0,248,114,0,0,104,115,0,0,200,115,0,0,40,116,0,0,152,116,0,0,224,116,0,0,80,118,0,0,112,118,0,0,144,118,0,0,168,118,0,0,192,118,0,0,216,118,0,0,0,119,0,0,24,119,0,0,48,119,0,0,64,119,0,0,192,119,0,0,224,119,0,0,56,120,0,0,176,120,0,0,208,120,0,0,56,121,0,0,104,121,0,0,152,121,0,0,200,121,0,0,248,121,0,0,40,122,0,0,88,122,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,32,111,114,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,32,111,114,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,66,54,46,108,101,118,101,108,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,54,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,54,46,108,101,118,101,108,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,54,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,54,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,54,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,55,46,108,101,118,101,108,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,55,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,55,46,108,101,118,101,108,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,55,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,55,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,55,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,52,46,108,101,118,101,108,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,52,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,52,46,108,101,118,101,108,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,52,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,52,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,52,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,32,43,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,32,111,114,32,112,114,101,40,66,51,46,97,98,111,118,101,76,101,118,101,108,91,50,93,41,32,97,110,100,32,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,32,45,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,0,0,0,0,0,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,51,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,51,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,51,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,51,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,50,46,108,101,118,101,108,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,50,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,50,46,108,101,118,101,108,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,50,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,50,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,50,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,49,46,108,101,118,101,108,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,114,32,112,114,101,40,66,49,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,97,110,100,32,66,49,46,108,101,118,101,108,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,0,0,0,0,0,66,49,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,49,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,49,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,80,50,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,50,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,80,50,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,80,50,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,50,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,80,50,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,80,50,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,80,49,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,49,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,80,49,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,80,49,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,49,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,80,49,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,80,49,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,114,101,40,66,51,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,50,93,41,32,97,110,100,32,110,111,116,32,66,51,46,112,111,114,116,115,91,50,93,46,112,32,62,32,66,51,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,86,49,48,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,112,114,101,40,66,54,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,54,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,54,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,60,32,45,49,101,45,48,54,0,116,105,109,101,32,60,32,80,50,95,111,110,46,84,0,0,112,114,101,40,66,55,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,55,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,55,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,86,49,56,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,116,105,109,101,32,60,32,80,49,95,111,110,46,84,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,66,55,46,108,101,118,101,108,32,60,32,48,46,48,49,0,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,101,110,97,98,108,101,70,105,114,101,32,97,110,100,32,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,119,97,105,116,84,105,109,101,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,108,111,99,97,108,65,99,116,105,118,101,32,97,110,100,32,66,53,46,108,101,118,101,108,32,60,32,48,46,48,49,0,0,112,114,101,40,66,51,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,51,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,51,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,86,49,49,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,101,110,97,98,108,101,70,105,114,101,32,97,110,100,32,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,119,97,105,116,84,105,109,101,0,0,112,114,101,40,66,50,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,50,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,50,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,86,57,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,0,112,114,101,40,66,49,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,49,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,49,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,86,56,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,0,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,101,110,97,98,108,101,70,105,114,101,32,97,110,100,32,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,119,97,105,116,84,105,109,101,0,0,105,110,116,101,103,101,114,40,99,111,110,116,114,111,108,108,101,114,46,115,116,97,116,101,71,114,97,112,104,82,111,111,116,46,115,117,98,103,114,97,112,104,83,116,97,116,101,80,111,114,116,46,97,99,116,105,118,101,83,116,101,112,115,44,32,48,41,0,0,0,0,0,66,53,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,53,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,66,53,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,50,57,56,46,48,0,0,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,50,57,56,46,48,0,0,66,55,46,108,101,118,101,108,32,60,61,32,48,46,48,49,0,0,0,0,0,0,0,0,66,54,46,108,101,118,101,108,32,60,61,32,48,46,48,49,0,0,0,0,0,0,0,0,66,53,46,108,101,118,101,108,32,60,61,32,48,46,48,49,0,0,0,0,0,0,0,0,66,53,46,108,101,118,101,108,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,53,95,98,97,116,99,104,95,108,101,118,101,108,0,0,0,66,51,46,108,101,118,101,108,32,60,61,32,48,46,48,49,0,0,0,0,0,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,48,46,49,51,0,0,0,0,0,0,0,0,116,105,109,101,32,62,32,50,53,48,48,46,48,0,0,0,112,114,101,40,66,53,46,73,110,110,101,114,84,97,110,107,66,111,116,116,111,109,91,49,93,46,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,41,32,97,110,100,32,110,111,116,32,66,53,46,66,111,116,116,111,109,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,32,111,114,32,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,60,32,45,49,101,45,48,54,0,0,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,62,32,48,46,48,0,0,112,114,101,40,66,53,46,73,110,110,101,114,84,97,110,107,83,105,100,101,91,49,93,46,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([32,97,110,100,32,110,111,116,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,0,0,0,112,114,101,40,66,53,46,73,110,110,101,114,84,97,110,107,84,111,112,91,49,93,46,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,41,32,97,110,100,32,110,111,116,32,66,53,46,84,111,112,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,32,111,114,32,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,60,32,45,49,101,45,48,54,0,0,0,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,62,32,48,46,48,0,0,0,0,0,112,114,101,40,66,52,46,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,41,32,97,110,100,32,110,111,116,32,66,52,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,52,46,112,95,97,109,98,105,101,110,116,32,111,114,32,40,45,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,41,32,60,32,45,49,101,45,48,54,0,0,0,66,49,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,66,50,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,0,0,0,0,0,0,0,66,52,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,66,55,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,66,54,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,0,0,0,0,0,1,0,0,0,132,8,0,0,1,0,0,0,123,8,0,0,1,0,0,0,85,8,0,0,1,0,0,0,76,8,0,0,1,0,0,0,33,8,0,0,1,0,0,0,24,8,0,0,1,0,0,0,14,8,0,0,1,0,0,0,169,8,0,0,1,0,0,0,2,8,0,0,1,0,0,0,218,8,0,0,1,0,0,0,246,7,0,0,1,0,0,0,248,8,0,0,1,0,0,0,240,7,0,0,1,0,0,0,14,9,0,0,1,0,0,0,51,9,0,0,1,0,0,0,234,7,0,0,1,0,0,0,68,9,0,0,1,0,0,0,228,7,0,0,1,0,0,0,98,9,0,0,1,0,0,0,222,7,0,0,1,0,0,0,184,7,0,0,1,0,0,0,146,7,0,0,1,0,0,0,136,7,0,0,1,0,0,0,49,9,0,0,1,0,0,0,208,8,0,0,1,0,0,0,67,7,0,0,1,0,0,0,237,8,0,0,1,0,0,0,15,7,0,0,1,0,0,0,7,7,0,0,1,0,0,0,33,7,0,0,1,0,0,0,214,6,0,0,1,0,0,0,60,9,0,0,1,0,0,0,184,6,0,0,1,0,0,0,95,9,0,0,1,0,0,0,117,9,0,0,1,0,0,0,168,6,0,0,1,0,0,0,73,7,0,0,1,0,0,0,144,6,0,0,1,0,0,0,250,7,0,0,1,0,0,0,6,8,0,0,1,0,0,0,133,6,0,0,1,0,0,0,132,6,0,0,1,0,0,0,131,6,0,0,1,0,0,0,130,6,0,0,1,0,0,0,129,6,0,0,1,0,0,0,128,6,0,0,1,0,0,0,127,6,0,0,1,0,0,0,227,6,0,0,1,0,0,0,229,6,0,0,1,0,0,0,153,6,0,0,1,0,0,0,2,9,0,0,1,0,0,0,4,9,0,0,1,0,0,0,12,9,0,0,1,0,0,0,67,8,0,0,1,0,0,0,34,8,0,0,1,0,0,0,38,8,0,0,1,0,0,0,39,8,0,0,1,0,0,0,25,8,0,0,1,0,0,0,29,8,0,0,1,0,0,0,23,8,0,0,136,122,0,0,144,122,0,0,152,122,0,0,160,122,0,0,168,122,0,0,176,122,0,0,184,122,0,0,192,122,0,0,200,122,0,0,208,122,0,0,216,122,0,0,224,122,0,0,232,122,0,0,240,122,0,0,248,122,0,0,0,123,0,0,8,123,0,0,16,123,0,0,24,123,0,0,32,123,0,0,40,123,0,0,48,123,0,0,56,123,0,0,64,123,0,0,72,123,0,0,80,123,0,0,88,123,0,0,96,123,0,0,104,123,0,0,112,123,0,0,120,123,0,0,128,123,0,0,136,123,0,0,144,123,0,0,152,123,0,0,160,123,0,0,168,123,0,0,176,123,0,0,184,123,0,0,192,123,0,0,200,123,0,0,208,123,0,0,216,123,0,0,224,123,0,0,232,123,0,0,240,123,0,0,248,123,0,0,0,124,0,0,8,124,0,0,16,124,0,0,24,124,0,0,32,124,0,0,40,124,0,0,48,124,0,0,56,124,0,0,64,124,0,0,72,124,0,0,80,124,0,0,88,124,0,0,96,124,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,0,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,0,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,0,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,0,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,41,41,0,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,41,41,0,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,41,41,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,41,41,0,0,0,0,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,66,54,46,108,101,118,101,108,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,54,46,108,101,118,101,108,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,54,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,54,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,54,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,55,46,108,101,118,101,108,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,55,46,108,101,118,101,108,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,55,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,55,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,55,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,52,46,108,101,118,101,108,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,52,46,108,101,118,101,108,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,52,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,52,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,52,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,32,43,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,32,45,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,51,46,108,101,118,101,108,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,51,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,51,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,51,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,50,46,108,101,118,101,108,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,50,46,108,101,118,101,108,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,50,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,50,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,50,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,49,46,108,101,118,101,108,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,43,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,49,46,108,101,118,101,108,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,32,45,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,0,0,0,66,49,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,49,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,49,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,80,50,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,50,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,80,50,46,109,101,100,105,117,109,46,112,41,41,0,80,50,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,50,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,80,50,46,109,101,100,105,117,109,46,112,41,41,0,0,0,0,0,80,50,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,80,49,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,49,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,80,49,46,109,101,100,105,117,109,46,112,41,41,0,80,49,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,80,49,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,80,49,46,109,101,100,105,117,109,46,112,41,41,0,0,0,0,0,80,49,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,41,41,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,41,41,0,0,0,0,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,66,51,46,112,111,114,116,115,91,50,93,46,112,32,62,32,66,51,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,86,49,48,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,66,54,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,54,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,66,55,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,55,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,86,49,56,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,66,55,46,108,101,118,101,108,32,60,32,48,46,48,49,0,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,119,97,105,116,84,105,109,101,0,0,0,0,0,0,0,0,66,53,46,108,101,118,101,108,32,60,32,48,46,48,49,0,66,51,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,51,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,86,49,49,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,119,97,105,116,84,105,109,101,0,0,0,0,0,0,0,0,66,50,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,50,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,86,57,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,66,49,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,49,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,86,56,46,109,95,102,108,111,119,41,32,60,32,45,49,101,45,48,54,0,0,0,116,105,109,101,32,62,61,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,116,95,115,116,97,114,116,32,43,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,119,97,105,116,84,105,109,101,0,0,0,0,0,0,0,0,66,53,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,0,66,53,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,66,53,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,66,53,46,66,111,116,116,111,109,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,0,0,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,0,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,0,0,0,0,66,53,46,84,111,112,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,32,66,53,46,112,95,97,109,98,105,101,110,116,0,0,0,0,0,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,60,32,45,49,101,45,48,54,0,0,66,52,46,112,111,114,116,115,91,49,93,46,112,32,62,32,66,52,46,112,95,97,109,98,105,101,110,116,0,0,0,0,40,45,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,41,32,60,32,45,49,101,45,48,54,0,0,0,0,0,0,0,88,125,0,0,40,126,0,0,248,126,0,0,32,127,0,0,240,127,0,0,192,128,0,0,232,128,0,0,184,129,0,0,136,130,0,0,176,130,0,0,128,131,0,0,80,132,0,0,120,132,0,0,64,133,0,0,8,134,0,0,48,134,0,0,248,134,0,0,192,135,0,0,232,135,0,0,160,136,0,0,88,137,0,0,120,137,0,0,192,137,0,0,8,138,0,0,184,138,0,0,96,139,0,0,168,139,0,0,240,139,0,0,160,140,0,0,72,141,0,0,144,141,0,0,216,141,0,0,136,142,0,0,48,143,0,0,120,143,0,0,192,143,0,0,8,144,0,0,80,144,0,0,0,145,0,0,168,145,0,0,240,145,0,0,56,146,0,0,232,146,0,0,144,147,0,0,216,147,0,0,32,148,0,0,208,148,0,0,120,149,0,0,32,150,0,0,200,150,0,0,232,150,0,0,144,151,0,0,56,152,0,0,88,152,0,0,16,153,0,0,200,153,0,0,232,153,0,0,8,154,0,0,32,154,0,0,64,154,0,0,168,112,0,0,112,154,0,0,144,154,0,0,24,113,0,0,168,154,0,0,184,154,0,0,8,155,0,0,24,155,0,0,56,155,0,0,80,155,0,0,160,155,0,0,192,155,0,0,216,155,0,0,248,155,0,0,16,156,0,0,96,156,0,0,16,157,0,0,80,118,0,0,112,118,0,0,144,118,0,0,168,118,0,0,192,118], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([216,118,0,0,0,119,0,0,24,119,0,0,48,119,0,0,184,157,0,0,224,157,0,0,192,119,0,0,8,158,0,0,48,158,0,0,88,158,0,0,176,120,0,0,120,158,0,0,152,158,0,0,56,121,0,0,104,121,0,0,152,121,0,0,200,121,0,0,248,121,0,0,40,122,0,0,88,122,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,56,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,55,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,54,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,53,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,52,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,51,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,50,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,53,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,53,46,95,73,110,110,101,114,84,97,110,107,84,111,112,91,49,93,46,95,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,53,46,95,73,110,110,101,114,84,97,110,107,83,105,100,101,91,49,93,46,95,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,53,46,95,73,110,110,101,114,84,97,110,107,66,111,116,116,111,109,91,49,93,46,95,109,95,102,108,111,119,95,110,101,103,97,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,115,116,97,116,101,71,114,97,112,104,82,111,111,116,46,95,97,99,116,105,118,101,83,116,101,112,115,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,73,110,105,116,105,97,108,83,116,101,112,49,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,73,110,105,116,105,97,108,83,116,101,112,49,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,73,110,105,116,105,97,108,83,116,101,112,49,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,73,110,105,116,105,97,108,83,116,101,112,49,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,50,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,50,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,50,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,50,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,51,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,51,46,95,102,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,51,46,95,116,95,115,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,51,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,51,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,51,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,51,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,52,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,52,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,52,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,52,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,53,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,53,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,53,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,53,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,54,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,54,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,54,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,54,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,55,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,55,46,95,102,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,55,46,95,116,95,115,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,80,97,114,97,108,108,101,108,49,46,95,105,110,80,111,114,116,46,95,111,99,99,117,112,105,101,100,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,80,97,114,97,108,108,101,108,49,46,95,111,117,116,80,111,114,116,46,95,97,118,97,105,108,97,98,108,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,55,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,55,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,55,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,55,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,56,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,56,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,56,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,56,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,57,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,57,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,57,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,57,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,48,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,48,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,48,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,48,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,49,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,49,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,49,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,49,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,50,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,50,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,50,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,50,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,51,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,51,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,51,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,51,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,52,46,95,108,111,99,97,108,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,52,46,95,110,101,119,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,52,46,95,111,108,100,65,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,83,116,101,112,49,52,46,95,97,99,116,105,118,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,53,95,105,100,108,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,55,95,105,100,108,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,87,105,116,104,83,105,103,110,97,108,49,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,66,111,111,108,101,97,110,69,120,112,114,101,115,115,105,111,110,49,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,46,95,102,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,46,95,116,95,115,116,97,114,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,50,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,50,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,52,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,52,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,54,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,54,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,57,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,57,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,51,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,51,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,49,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,49,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,50,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,50,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,48,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,49,48,46,95,108,111,99,97,108,67,111,110,100,105,116,105,111,110,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,53,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,84,114,97,110,115,105,116,105,111,110,56,46,95,101,110,97,98,108,101,70,105,114,101,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,118,111,108,117,109,101,53,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,49,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,50,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,49,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,49,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,49,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,49,95,111,110,46,95,101,110,100,86,97,108,117,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,49,95,111,110,46,95,114,97,116,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,49,95,111,110,46,95,84,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,50,95,111,110,46,95,101,110,100,86,97,108,117,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,50,95,111,110,46,95,114,97,116,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,50,95,111,110,46,95,84,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,50,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,50,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,50,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,51,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,51,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,51,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,51,46,95,97,98,111,118,101,76,101,118,101,108,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,51,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,52,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,52,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,52,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,55,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,55,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,55,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,66,49,66,50,46,95,115,116,97,116,101,115,70,77,91,49,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,66,49,66,50,46,95,115,116,97,116,101,115,70,77,91,50,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,80,117,109,112,49,66,49,46,95,115,116,97,116,101,115,70,77,91,49,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,80,117,109,112,49,66,49,46,95,115,116,97,116,101,115,70,77,91,50,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,80,117,109,112,50,66,50,46,95,115,116,97,116,101,115,70,77,91,49,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,112,105,112,101,80,117,109,112,50,66,50,46,95,115,116,97,116,101,115,70,77,91,50,93,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,54,46,95,112,111,114,116,115,95,109,95,102,108,111,119,95,111,117,116,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,54,46,95,97,98,111,118,101,76,101,118,101,108,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,66,54,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,118,111,108,117,109,101,52,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,66,53,46,108,101,118,101,108,32,45,32,66,53,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,45,50,57,51,46,49,53,32,43,32,66,53,46,109,101,100,105,117,109,46,84,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,97,99,116,105,118,101,32,61,61,32,116,114,117,101,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,108,111,99,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,116,95,115,116,97,114,116,41,32,45,32,116,105,109,101,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,116,95,115,116,97,114,116,41,32,45,32,116,105,109,101,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,97,99,116,105,118,101,32,61,61,32,102,97,108,115,101,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,110,101,119,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,111,108,100,65,99,116,105,118,101,41,32,61,61,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,108,111,99,97,108,65,99,116,105,118,101,41,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,87,105,116,104,83,105,103,110,97,108,49,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,116,95,115,116,97,114,116,41,32,45,32,116,105,109,101,0,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,50,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,52,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,54,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,57,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,51,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,49,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,50,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,48,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,53,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,56,46,101,110,97,98,108,101,70,105,114,101,41,32,61,61,32,102,97,108,115,101,0,0,0,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,45,32,118,111,108,117,109,101,53,46,104,95,115,116,97,114,116,0,0,0,0,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,53,46,112,95,115,116,97,114,116,0,0,0,0,0,0,80,49,46,109,101,100,105,117,109,46,104,32,45,32,80,49,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,80,49,46,109,101,100,105,117,109,46,112,32,45,32,80,49,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,80,50,46,109,101,100,105,117,109,46,104,32,45,32,80,50,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,80,50,46,109,101,100,105,117,109,46,112,32,45,32,80,50,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,49,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,49,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,49,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,66,49,46,108,101,118,101,108,32,45,32,66,49,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,49,46,109,101,100,105,117,109,46,104,32,45,32,66,49,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,50,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,50,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,50,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,66,50,46,108,101,118,101,108,32,45,32,66,50,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,50,46,109,101,100,105,117,109,46,104,32,45,32,66,50,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,51,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,110,111,116,32,112,114,101,40,66,51,46,97,98,111,118,101,76,101,118,101,108,91,50,93,41,32,61,61,32,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,51,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,50,93,0,0,66,51,46,108,101,118,101,108,32,45,32,66,51,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,51,46,109,101,100,105,117,109,46,104,32,45,32,66,51,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,52,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,52,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,52,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,66,52,46,108,101,118,101,108,32,45,32,66,52,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,52,46,109,101,100,105,117,109,46,104,32,45,32,66,52,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,55,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,55,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,55,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,66,55,46,108,101,118,101,108,32,45,32,66,55,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,55,46,109,101,100,105,117,109,46,104,32,45,32,66,55,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,110,111,116,32,112,114,101,40,66,54,46,97,98,111,118,101,76,101,118,101,108,91,49,93,41,32,61,61,32,66,54,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,66,54,46,112,111,114,116,115,68,97,116,97,95,104,101,105,103,104,116,50,91,49,93,0,0,66,54,46,108,101,118,101,108,32,45,32,66,54,46,108,101,118,101,108,95,115,116,97,114,116,0,0,0,0,0,0,0,66,54,46,109,101,100,105,117,109,46,104,32,45,32,66,54,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,45,32,118,111,108,117,109,101,52,46,104,95,115,116,97,114,116,0,0,0,0,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,52,46,112,95,115,116,97,114,116,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,45,32,112,105,112,101,66,49,66,50,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,45,32,112,105,112,101,66,49,66,50,46,104,95,115,116,97,114,116,0,0,0,0,0,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,0,0,0,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,45,32,112,105,112,101,80,117,109,112,49,66,49,46,104,95,115,116,97,114,116,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,45,32,112,105,112,101,80,117,109,112,49,66,49,46,104,95,115,116,97,114,116,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,45,32,112,105,112,101,80,117,109,112,50,66,50,46,104,95,115,116,97,114,116,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,45,32,112,105,112,101,80,117,109,112,50,66,50,46,104,95,115,116,97,114,116,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,56,198,0,0,88,198,0,0,112,198,0,0,160,198,0,0,248,198,0,0,80,199,0,0,120,199,0,0,200,199,0,0,24,200,0,0,64,200,0,0,144,200,0,0,224,200,0,0,16,201,0,0,72,201,0,0,112,201,0,0,192,201,0,0,16,202,0,0,56,202,0,0,136,202,0,0,216,202,0,0,0,203,0,0,80,203,0,0,160,203,0,0,200,203,0,0,24,204,0,0,104,204,0,0,152,204,0,0,208,204,0,0,248,204,0,0,72,205,0,0,152,205,0,0,192,205,0,0,16,206,0,0,96,206,0,0,136,206,0,0,216,206,0,0,40,207,0,0,80,207,0,0,160,207,0,0,240,207,0,0,24,208,0,0,104,208,0,0,184,208,0,0,224,208,0,0,48,209,0,0,128,209,0,0,168,209,0,0,248,209,0,0,72,210,0,0,112,210,0,0,192,210,0,0,16,211,0,0,80,211,0,0,128,211,0,0,184,211,0,0,240,211,0,0,40,212,0,0,96,212,0,0,152,212,0,0,208,212,0,0,8,213,0,0,64,213,0,0,120,213,0,0,176,213,0,0,232,213,0,0,16,214,0,0,56,214,0,0,88,214,0,0,120,214,0,0,152,214,0,0,184,214,0,0,0,215,0,0,32,215,0,0,64,215,0,0,136,215,0,0,168,215,0,0,200,215,0,0,16,216,0,0,88,216,0,0,120,216,0,0,152,216,0,0,224,216,0,0,0,217,0,0,32,217,0,0,104,217,0,0,136,217,0,0,168,217,0,0,240,217,0,0,16,218,0,0,48,218,0,0,88,218,0,0,128,218,0,0,200,218,0,0,248,218,0,0,40,219,0,0,88,219,0,0,128,219,0,0,168,219,0,0,240,219,0,0,32,220,0,0,104,220,0,0,152,220,0,0,224,220,0,0,16,221,0,0,96,221,0,0,144,221,0,0,224,221,0,0,16,222,0,0,96,222,0,0,152,222,0,0,200,222,0,0,248,222,0,0,32,223,0,0,72,223,0,0,152,223,0,0,208,223,0,0,0,224,0,0,48,224,0,0,88,224,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,20,0,0,0,112,105,112,101,80,117,109,112,50,66,50,46,112,101,114,105,109,101,116,101,114,0,0,0,1,0,0,0,21,0,0,0,1,0,0,0,35,0,0,0,112,105,112,101,80,117,109,112,49,66,49,46,112,101,114,105,109,101,116,101,114,0,0,0,1,0,0,0,36,0,0,0,1,0,0,0,84,0,0,0,112,105,112,101,66,49,66,50,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,85,0,0,0,1,0,0,0,184,0,1,0,192,0,1,0,0,0,0,0,1,0,0,0,152,0,1,0,160,0,1,0,0,0,0,0,1,0,0,0,208,0,0,0,112,105,112,101,66,55,80,117,109,112,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,210,0,0,0,112,105,112,101,66,54,80,117,109,112,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,211,0,0,0,1,0,0,0,212,0,0,0,112,105,112,101,66,49,66,49,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,213,0,0,0,1,0,0,0,214,0,0,0,112,105,112,101,66,50,66,51,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,215,0,0,0,1,0,0,0,216,0,0,0,112,105,112,101,66,49,66,51,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,217,0,0,0,1,0,0,0,19,1,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,20,1,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,21,1,0,0,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,22,1,0,0,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,23,1,0,0,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,24,1,0,0,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,25,1,0,0,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,26,1,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,57,1,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,1,0,0,0,64,1,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,1,0,0,0,75,1,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,1,0,0,0,83,1,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,0,1,0,0,0,94,1,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,1,0,0,0,101,1,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,1,0,0,0,112,1,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,1,0,0,0,120,1,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,0,1,0,0,0,141,1,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,148,1,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,0,0,0,0,0,0,1,0,0,0,159,1,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,0,0,0,0,0,0,1,0,0,0,167,1,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,188,1,0,0,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,1,0,0,0,198,1,0,0,66,54,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,54,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,215,1,0,0,66,55,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,55,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,232,1,0,0,66,52,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,52,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,246,1,0,0,66,51,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,51,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,21,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,48,46,109,95,102,108,111,119,44,32,86,49,48,46,115,116,97,116,101,95,97,46,100,44,32,86,49,48,46,115,116,97,116,101,95,98,46,100,44,32,86,49,48,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,24,2,0,0,112,105,112,101,66,49,66,49,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,28,2,0,0,112,105,112,101,66,49,66,49,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,35,2,0,0,66,50,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,50,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,50,2,0,0,66,49,46,109,101,100,105,117,109,46,100,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,49,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,71,2,0,0,80,50,46,114,104,111,0,0,67,97,118,105,116,97,116,105,111,110,32,111,99,99,117,114,115,32,105,110,32,116,104,101,32,112,117,109,112,0,0,0,1,0,0,0,88,2,0,0,80,49,46,114,104,111,0,0,1,0,0,0,110,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,49,46,109,95,102,108,111,119,44,32,86,50,49,46,115,116,97,116,101,95,97,46,100,44,32,86,50,49,46,115,116,97,116,101,95,98,46,100,44,32,86,50,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,113,2,0,0,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,1,0,0,0,133,2,0,0,80,50,95,111,110,46,114,105,115,105,110,103,0,0,0,0,80,50,95,111,110,46,102,97,108,108,105,110,103,0,0,0,1,0,0,0,155,2,0,0,109,97,120,40,45,86,50,48,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,158,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,57,46,109,95,102,108,111,119,44,32,86,49,57,46,115,116,97,116,101,95,97,46,100,44,32,86,49,57,46,115,116,97,116,101,95,98,46,100,44,32,86,49,57,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,161,2,0,0,109,97,120,40,45,86,49,57,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,164,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,48,46,109,95,102,108,111,119,44,32,86,50,48,46,115,116,97,116,101,95,97,46,100,44,32,86,50,48,46,115,116,97,116,101,95,98,46,100,44,32,86,50,48,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,168,2,0,0,112,105,112,101,66,54,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,171,2,0,0,112,105,112,101,66,54,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,175,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,86,50,53,46,115,116,97,116,101,95,97,46,100,44,32,86,50,53,46,115,116,97,116,101,95,98,46,100,44,32,86,50,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,67,97,118,105,116,97,116,105,111,110,32,111,99,99,117,114,115,32,97,116,32,116,104,101,32,112,117,109,112,32,105,110,108,101,116,0,0,0,0,0,1,0,0,0,192,2,0,0,115,121,115,116,101,109,46,103,32,42,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,0,1,0,0,0,197,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,52,46,109,95,102,108,111,119,44,32,86,50,52,46,115,116,97,116,101,95,97,46,100,44,32,86,50,52,46,115,116,97,116,101,95,98,46,100,44,32,86,50,52,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,199,2,0,0,80,50,46,109,0,0,0,0,1,0,0,0,206,2,0,0,118,111,108,117,109,101,53,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([109,0,0,0,0,0,0,0,1,0,0,0,207,2,0,0,118,111,108,117,109,101,53,46,86,0,0,0,0,0,0,0,1,0,0,0,211,2,0,0,47,42,82,101,97,108,42,47,40,80,50,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,221,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,1,0,0,0,222,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,225,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,231,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,1,0,0,0,232,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,234,2,0,0,109,97,120,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,54,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,1,0,0,0,241,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,86,52,46,115,116,97,116,101,95,97,46,100,44,32,86,52,46,115,116,97,116,101,95,98,46,100,44,32,86,52,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,1,0,0,0,242,2,0,0,109,97,120,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,54,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,1,0,0,0,249,2,0,0,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,50,93,0,0,0,0,0,0,0,1,0,0,0,254,2,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,86,53,46,115,116,97,116,101,95,97,46,100,44,32,86,53,46,115,116,97,116,101,95,98,46,100,44,32,86,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,1,0,0,0,1,3,0,0,109,97,120,40,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,5,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,54,46,109,95,102,108,111,119,44,32,86,54,46,115,116,97,116,101,95,97,46,100,44,32,86,54,46,115,116,97,116,101,95,98,46,100,44,32,86,54,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,11,3,0,0,112,105,112,101,66,49,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,12,3,0,0,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,15,3,0,0,112,105,112,101,66,49,66,50,46,109,115,91,49,93,0,0,1,0,0,0,49,3,0,0,80,49,95,111,110,46,114,105,115,105,110,103,0,0,0,0,80,49,95,111,110,46,102,97,108,108,105,110,103,0,0,0,1,0,0,0,66,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,56,46,109,95,102,108,111,119,41,32,43,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,48,46,109,95,102,108,111,119,41,32,43,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,70,105,116,116,105,110,103,115,46,77,117,108,116,105,80,111,114,116,46,112,111,115,105,116,105,118,101,77,97,120,40,86,49,57,46,109,95,102,108,111,119,41,0,0,0,0,0,0,0,1,0,0,0,70,3,0,0,112,105,112,101,66,55,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,73,3,0,0,112,105,112,101,66,55,80,117,109,112,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,75,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,56,46,109,95,102,108,111,119,44,32,86,49,56,46,115,116,97,116,101,95,97,46,100,44,32,86,49,56,46,115,116,97,116,101,95,98,46,100,44,32,86,49,56,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,81,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,49,93,44,32,86,50,50,46,115,116,97,116,101,95,97,46,100,44,32,86,50,50,46,115,116,97,116,101,95,98,46,100,44,32,86,50,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,98,3,0,0,118,111,108,117,109,101,52,46,109,0,0,0,0,0,0,0,1,0,0,0,99,3,0,0,118,111,108,117,109,101,52,46,86,0,0,0,0,0,0,0,1,0,0,0,104,3,0,0,80,49,46,109,0,0,0,0,1,0,0,0,109,3,0,0,47,42,82,101,97,108,42,47,40,80,49,46,110,80,97,114,97,108,108,101,108,41,0,0,1,0,0,0,113,3,0,0,115,121,115,116,101,109,46,103,32,42,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,0,1,0,0,0,115,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,50,51,46,109,95,102,108,111,119,44,32,86,50,51,46,115,116,97,116,101,95,97,46,100,44,32,86,50,51,46,115,116,97,116,101,95,98,46,100,44,32,86,50,51,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,127,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,0,0,0,1,0,0,0,128,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,131,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,137,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,1,0,0,0,138,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,140,3,0,0,109,97,120,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,0,0,0,0,1,0,0,0,142,3,0,0,112,105,112,101,66,49,66,50,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,143,3,0,0,112,105,112,101,66,49,66,50,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,149,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,51,46,109,95,102,108,111,119,44,32,86,51,46,115,116,97,116,101,95,97,46,100,44,32,86,51,46,115,116,97,116,101,95,98,46,100,44,32,86,51,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,150,3,0,0,109,97,120,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,51,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,1,0,0,0,157,3,0,0,112,105,112,101,66,49,66,50,46,109,115,91,50,93,0,0,1,0,0,0,162,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,86,50,46,115,116,97,116,101,95,97,46,100,44,32,86,50,46,115,116,97,116,101,95,98,46,100,44,32,86,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,1,0,0,0,166,3,0,0,109,97,120,40,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,45,86,51,46,109,95,102,108,111,119,44,32,49,101,45,49,53,41,0,0,0,0,0,0,0,0,1,0,0,0,169,3,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,44,32,86,49,46,115,116,97,116,101,95,97,46,100,44,32,86,49,46,115,116,97,116,101,95,98,46,100,44,32,86,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,1,0,0,0,175,3,0,0,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,50,93,0,0,0,0,0,0,0,1,0,0,0,1,4,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,49,49,46,109,95,102,108,111,119,44,32,86,49,49,46,115,116,97,116,101,95,97,46,100,44,32,86,49,49,46,115,116,97,116,101,95,98,46,100,44,32,86,49,49,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,29,4,0,0,112,105,112,101,66,50,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,42,4,0,0,66,50,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,44,4,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,57,46,109,95,102,108,111,119,44,32,86,57,46,115,116,97,116,101,95,97,46,100,44,32,86,57,46,115,116,97,116,101,95,98,46,100,44,32,86,57,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,48,4,0,0,112,105,112,101,66,50,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,78,4,0,0,112,105,112,101,66,49,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,89,4,0,0,66,51,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,101,4,0,0,66,49,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,103,4,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,86,56,46,109,95,102,108,111,119,44,32,86,56,46,115,116,97,116,101,95,97,46,100,44,32,86,56,46,115,116,97,116,101,95,98,46,100,44,32,86,56,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,107,4,0,0,112,105,112,101,66,49,66,51,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,143,4,0,0,66,53,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,161,4,0,0,66,52,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,170,4,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,44,32,86,49,50,46,115,116,97,116,101,95,97,46,100,44,32,86,49,50,46,115,116,97,116,101,95,98,46,100,44,32,86,49,50,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,0,0,0,1,0,0,0,191,4,0,0,66,55,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,198,4,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,45,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,44,32,86,49,53,46,115,116,97,116,101,95,97,46,100,44,32,86,49,53,46,115,116,97,116,101,95,98,46,100,44,32,86,49,53,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,0,16,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,66,53,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,1,0,0,0,210,4,0,0,66,53,46,104,95,118,32,45,32,66,53,46,104,95,108,0,1,0,0,0,222,4,0,0,66,54,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,234,4,0,0,66,53,46,99,114,111,115,115,65,114,101,97,0,0,0,0,1,0,0,0,144,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,67,28,235,226,54,26,63,97,50,85,48,42,169,35,63,1,0,0,0,4,10,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,1,0,0,0,5,10,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,1,0,0,0,6,10,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,0,0,1,0,0,0,7,10,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,0,0,1,0,0,0,8,10,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,0,0,1,0,0,0,32,10,0,0,47,42,82,101,97,108,42,47,40,80,50,46,110,80,97,114,97,108,108,101,108,41,32,42,32,80,50,46,114,104,111,95,110,111,109,105,110,97,108,0,1,0,0,0,38,10,0,0,47,42,82,101,97,108,42,47,40,80,49,46,110,80,97,114,97,108,108,101,108,41,32,42,32,80,49,46,114,104,111,95,110,111,109,105,110,97,108,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,37,115,40,109,105,110,61,37,103,41,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,37,115,40,109,97,120,61,37,103,41,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,88,140,2,0,0,0,0,0,0,0,0,0,1,0,0,0,56,140,2,0,64,140,2,0,0,0,0,0,1,0,0,0,24,140,2,0,32,140,2,0,0,0,0,0,1,0,0,0,228,11,0,0,112,105,112,101,66,49,66,50,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,229,11,0,0,1,0,0,0,233,11,0,0,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,241,11,0,0,112,105,112,101,66,49,66,51,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,242,11,0,0,1,0,0,0,250,11,0,0,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,1,12,0,0,112,105,112,101,66,50,66,51,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,2,12,0,0,1,0,0,0,10,12,0,0,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,17,12,0,0,112,105,112,101,66,49,66,49,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,18,12,0,0,1,0,0,0,26,12,0,0,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,33,12,0,0,112,105,112,101,66,54,80,117,109,112,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,34,12,0,0,1,0,0,0,42,12,0,0,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,49,12,0,0,112,105,112,101,66,55,80,117,109,112,46,112,101,114,105,109,101,116,101,114,0,0,0,0,1,0,0,0,50,12,0,0,1,0,0,0,58,12,0,0,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,82,12,0,0,112,105,112,101,80,117,109,112,49,66,49,46,112,101,114,105,109,101,116,101,114,0,0,0,1,0,0,0,83,12,0,0,1,0,0,0,87,12,0,0,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,1,0,0,0,112,12,0,0,112,105,112,101,80,117,109,112,50,66,50,46,112,101,114,105,109,101,116,101,114,0,0,0,1,0,0,0,113,12,0,0,1,0,0,0,117,12,0,0,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,70,105,116,116,105,110,103,115,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,54,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,54,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,54,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,54,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,54,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,54,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,54,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,14,0,0,0,5,0,0,0,16,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,26,1,0,17,0,0,0,5,0,0,0,19,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,11], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([5,0,0,0,13,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,26,1,0,68,1,0,0,7,0,0,0,70,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,87,4,0,0,13,0,0,0,91,4,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,26,1,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,26,1,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,26,1,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,26,1,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,6,1,0,73,3,0,0,3,0,0,0,75,3,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,6,1,0,70,3,0,0,3,0,0,0,72,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,80,6,1,0,62,3,0,0,3,0,0,0,64,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,80,6,1,0,59,3,0,0,3,0,0,0,61,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,80,6,1,0,92,3,0,0,3,0,0,0,94,3,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,26,1,0,83,1,0,0,7,0,0,0,85,1,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,78,1,0,0,7,0,0,0,80,1,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,6,1,0,67,3,0,0,3,0,0,0,69,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,80,6,1,0,56,3,0,0,3,0,0,0,58,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,66,49,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,6,1,0,53,3,0,0,3,0,0,0,55,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,91,1,0,0,7,0,0,0,93,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,88,1,0,0,7,0,0,0,89,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,80,6,1,0,86,3,0,0,3,0,0,0,91,3,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,6,1,0,80,3,0,0,3,0,0,0,85,3,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,26,1,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,55,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,55,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,55,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,55,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,55,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,55,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,55,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,52,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,52,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,52,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,52,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,52,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,52,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,52,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,51,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,51,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,51,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,51,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,51,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,51,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,50,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,95,111,110,46,102,97,108,108,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,95,111,110,46,102,97,108,108,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,76,111,103,105,99,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,95,111,110,46,114,105,115,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,95,111,110,46,114,105,115,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,95,111,110,46,102,97,108,108,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,95,111,110,46,102,97,108,108,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,169,1,0,208,2,0,0,5,0,0,0,209,2,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,95,111,110,46,114,105,115,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,95,111,110,46,114,105,115,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,168,169,1,0,206,2,0,0,5,0,0,0,207,2,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,32,172,1,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,172,1,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,172,1,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,172,1,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,172,1,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,172,1,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,172,1,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,172,1,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,172,1,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,32,172,1,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,172,1,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,172,1,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,88,18,1,0,43,2,0,0,7,0,0,0,44,2,0,0,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,18,1,0,41,2], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([7,0,0,0,42,2,0,0,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,88,18,1,0,40,2,0,0,7,0,0,0,40,2,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,18,1,0,38,2,0,0,7,0,0,0,39,2,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,96,20,1,0,45,6,0,0,5,0,0,0,47,6,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,96,20,1,0,113,6,0,0,5,0,0,0,115,6,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,49,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,96,20,1,0,40,6,0,0,5,0,0,0,42,6,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,96,20,1,0,37,6,0,0,5,0,0,0,39,6,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,66,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,122,101,116,97,76,97,114,103,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,122,101,116,97,76,97,114,103,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,96,20,1,0,110,6,0,0,5,0,0,0,112,6,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,104,121,115,116,101,114,101,115,105,115,70,97,99,116,111,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,96,20,1,0,104,6,0,0,5,0,0,0,106,6,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,20,1,0,32,6,0,0,5,0,0,0,32,6,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,50,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,50,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,114,104,111,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,50,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,50,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,80,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,50,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,80,50,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,192,1,0,66,1,0,0,5,0,0,0,67,1,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,49,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,49,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,192,1,0,58,1,0,0,5,0,0,0,60,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,114,104,111,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,48,192,1,0,79,1,0,0,5,0,0,0,81,1,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,49,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,80,49,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,80,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,192,1,0,61,1,0,0,5,0,0,0,63,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,48,192,1,0,55,1,0,0,5,0,0,0,57,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,49,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,80,49,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,48,192,1,0,70,1,0,0,5,0,0,0,71,1,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,56,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,97,108,118,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,53,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,80,6,1,0,40,2,0,0,7,0,0,0,42,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,53,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,6,1,0,37,2,0,0,7,0,0,0,39,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,6,1,0,59,2,0,0,7,0,0,0,61,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,80,6,1,0,45,2,0,0,7,0,0,0,47,2,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,53,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,80,6,1,0,34,2,0,0,7,0,0,0,36,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,53,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,80,6,1,0,31,2,0,0,7,0,0,0,33,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,6,1,0,55,2,0,0,7,0,0,0,58,2,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,80,6,1,0,51,2,0,0,7,0,0,0,54,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,49,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,100,112,95,110,111,109,105,110,97,108,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112640);
/* memory initializer */ allocate([111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,48,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,57,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,48,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,48,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,48,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,48,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,53,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,52,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,53,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,50,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,51,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,54,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,54,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,54,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,54,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,12,1,0,87,8,0,0,7,0,0,0,89,8,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,12,1,0,84,8,0,0,7,0,0,0,86,8,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,128,12,1,0,81,8,0,0,7,0,0,0,83,8,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,51,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,51,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,51,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,51,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,52,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,52,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122880);
/* memory initializer */ allocate([97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,52,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,52,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,50,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,57,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,57,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,57,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,57,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,56,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,56,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,56,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,56,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,49,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,49,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,49,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,49,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,56,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,56,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,83,116,97,116,101,71,114,97,112,104,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,53,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,53,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,48,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,48,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,50,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,50,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,49,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,49,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,51,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,51,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,57,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,57,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,54,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,54,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,52,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,52,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,50,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,50,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,49,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,87,105,116,104,83,105,103,110,97,108,49,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,87,105,116,104,83,105,103,110,97,108,49,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,52,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,51,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,50,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,49,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,48,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,57,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,56,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,55,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,80,97,114,97,108,108,101,108,49,46,110,66,114,97,110,99,104,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,80,97,114,97,108,108,101,108,49,46,110,66,114,97,110,99,104,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,21,2,0,11,10,0,0,3,0,0,0,12,10,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,55,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,54,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,53,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,52,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,51,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,119,97,105,116,84,105,109,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,84,114,97,110,115,105,116,105,111,110,51,46,119,97,105,116,84,105,109,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,21,2,0,94,8,0,0,5,0,0,0,96,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,50,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,83,116,101,112,49,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,110,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,110,79,117,116,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,21,2,0,0,8,0,0,5,0,0,0,0,8,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,110,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,110,116,114,111,108,108,101,114,46,73,110,105,116,105,97,108,83,116,101,112,49,46,110,73,110,32,62,61,32,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,21,2,0,255,7,0,0,5,0,0,0,255,7,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,111,108,105,110,103,66,54,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,111,108,105,110,103,66,54,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,84,104,101,114,109,97,108,47,72,101,97,116,84,114,97,110,115,102,101,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,67,111,111,108,105,110,103,66,55,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,67,111,111,108,105,110,103,66,55,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,72,101,97,116,66,53,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,72,101,97,116,66,53,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,8,43,2,0,66,6,0,0,7,0,0,0,67,6,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,53,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,53,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,53,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,53,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,50,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,6,1,0,59,1,0,0,3,0,0,0,61,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,100,112], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133120);
/* memory initializer */ allocate([95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,86,49,50,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,6,1,0,56,1,0,0,3,0,0,0,58,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,111,112,101,110,105,110,103,95,109,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,111,112,101,110,105,110,103,95,109,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,168,210,1,0,122,1,0,0,5,0,0,0,123,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,50,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,168,210,1,0,113,1,0,0,5,0,0,0,114,1,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,168,210,1,0,110,1,0,0,5,0,0,0,112,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,50,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,80,6,1,0,63,1,0,0,3,0,0,0,65,1,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,6,1,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,20,1,0,223,2,0,0,7,0,0,0,225,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,66,53,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,96,20,1,0,228,2,0,0,7,0,0,0,228,2,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,96,20,1,0,226,2,0,0,7,0,0,0,227,2,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,96,20,1,0,219,2,0,0,7,0,0,0,222,2,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,66,53,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,96,20,1,0,215,2,0,0,7,0,0,0,218,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,66,97,115,101,67,108,97,115,115,101,115,46,73,110,105,116,46,71,117,101,115,115,86,97,108,117,101,115,32,97,110,100,32,66,53,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,66,97,115,101,67,108,97,115,115,101,115,46,73,110,105,116,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,96,20,1,0,209,2,0,0,7,0,0,0,212,2,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,96,20,1,0,207,2,0,0,7,0,0,0,208,2,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,20,1,0,201,2,0,0,7,0,0,0,201,2,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,80,6,1,0,13,0,0,0,5,0,0,0,14,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,95,118,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,95,118,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,104,95,118,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,20,1,0,86,3,0,0,7,0,0,0,87,3,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,95,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,95,108,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,104,95,108,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,20,1,0,88,3,0,0,7,0,0,0,89,3,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,114,104,111,95,118,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,114,104,111,95,118,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,114,104,111,95,118,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,20,1,0,91,3,0,0,7,0,0,0,91,3,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,114,104,111,95,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,114,104,111,95,108,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,114,104,111,95,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,20,1,0,92,3,0,0,7,0,0,0,92,3,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,53,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,48,67,2,0,144,0,0,0,5,0,0,0,144,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,57,2,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,115,95,101,109,112,116,121,80,105,112,101,72,121,115,116,101,114,101,115,105,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,96,20,1,0,133,6,0,0,7,0,0,0,133,6,0,0,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,67,2,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,26,1,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,6,1,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,26,1,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,26,1,0,245,4,0,0,13,0,0,0,1,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143360);
/* memory initializer */ allocate([49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153600);
/* memory initializer */ allocate([114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,57,2,0,74,22,0,0,7,0,0,0,75,22,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,120,57,2,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,120,57,2,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,120,57,2,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,67,28,235,226,54,26,63,97,50,85,48,42,169,35,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,67,111,110,100,101,110,115,101,100,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,67,111,110,100,101,110,115,101,100,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,67,111,110,100,101,110,115,101,100,46,109,95,102,108,111,119,32,60,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,67,111,110,100,101,110,115,101,100,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,67,111,110,100,101,110,115,101,100,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,67,111,110,100,101,110,115,101,100,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,47,65,83,84,95,66,97,116,99,104,80,108,97,110,116,46,109,111,0,0,0,96,142,2,0,90,3,0,0,7,0,0,0,90,3,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,114,104,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,114,104,111,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,114,104,111,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,142,2,0,93,3,0,0,7,0,0,0,93,3,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,108,101,118,101,108,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,108,101,118,101,108,32,60,61,32,66,53,46,104,101,105,103,104,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,142,2,0,237,2,0,0,7,0,0,0,240,2,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,109,95,102,108,111,119,95,84,111,112,80,111,114,116,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,96,142,2,0,252,2,0,0,7,0,0,0,252,2,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,84,111,112,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,84,111,112,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,84,111,112,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,83,105,100,101,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,109,95,102,108,111,119,95,66,111,116,116,111,109,80,111,114,116,115,91,49,93,32,60,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,142,2,0,250,2,0,0,7,0,0,0,250,2,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,66,111,116,116,111,109,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,66,111,116,116,111,109,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,66,111,116,116,111,109,70,108,117,105,100,80,111,114,116,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,50,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,50,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,50,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,50,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,53,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,53,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,53,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,53,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,53,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,49,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,49,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,49,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,49,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,49,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,86,49,49,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,112,111,114,116,95,98,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,112,111,114,116,95,98,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,56,46,112,111,114,116,95,98,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,56,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,56,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,56,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,56,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,56,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,86,56,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,112,111,114,116,95,98,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,112,111,114,116,95,98,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,57,46,112,111,114,116,95,98,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,57,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,57,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,57,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,57,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,57,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,86,57,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,97,46,100,32,60], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163840);
/* memory initializer */ allocate([61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,52,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,52,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,52,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,52,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,52,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,51,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,51,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,51,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,51,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,51,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,51,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,48,46,48,44,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,41,32,97,110,100,32,86,51,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,50,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,50,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,50,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,54,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,54,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,54,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,54,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,54,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,54,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,48,46,48,44,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,41,32,97,110,100,32,86,54,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,56,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,56,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,56,46,112,111,114,116,95,51,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,51,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,51,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,51,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,51,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,51,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,41,32,97,110,100,32,86,50,51,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,50,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,50,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,50,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,50,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,53,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,53,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,53,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,53,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,53,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,52,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,52,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,52,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,52,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,52,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,41,32,97,110,100,32,86,50,52,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,53,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,53,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,53,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,53,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,53,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,86,50,48,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,48,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,48,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,48,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,48,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,48,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,32,97,110,100,32,86,50,48,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,49,48,48,48,48,48,46,48,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,49,57,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,86,49,57,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,97,46,84,32,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174080);
/* memory initializer */ allocate([117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,57,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,57,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,57,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,57,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,57,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,57,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,49,48,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,48,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,48,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,48,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,48,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,48,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,48,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,49,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,49,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,50,49,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,50,49,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,50,49,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,41,32,97,110,100,32,86,50,49,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,105,102,32,118,111,108,117,109,101,53,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,118,111,108,117,109,101,53,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,86,49,56,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,56,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,56,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,140,2,0,89,1,0,0,3,0,0,0,94,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,86,49,56,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,140,2,0,95,1,0,0,3,0,0,0,100,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,86,49,56,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,86,49,56,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,86,49,56,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,248,140,2,0,76,1,0,0,3,0,0,0,78,1,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,80,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,80,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,114,104,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,114,104,111,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,114,104,111,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,62,61,32,49,46,48,32,97,110,100,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,62,61,32,48,46,48,32,97,110,100,32,80,49,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,49,46,104,101,97,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,49,46,104,101,97,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,80,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,80,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,114,104,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,114,104,111,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,114,104,111,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,233,2,0,137,1,0,0,5,0,0,0,137,1,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,62,61,32,49,46,48,32,97,110,100,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,62,61,32,48,46,48,32,97,110,100,32,80,50,46,109,111,110,105,116,111,114,105,110,103,46,114,104,111,95,105,110,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,233,2,0,12,3,0,0,9,0,0,0,13,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,50,46,104,101,97,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,50,46,104,101,97,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,233,2,0,139,1,0,0,5,0,0,0,139,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,49,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,49,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,49,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,50,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,50,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184320);
/* memory initializer */ allocate([97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,50,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,72,95,102,108,111,119,95,116,111,112,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,112,111,114,116,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,51,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,51,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,52,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,52,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,52,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,55,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,55,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,55,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,55,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,109,97,120,40,45,49,48,48,48,48,48,46,48,44,32,109,97,120,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,45,49,48,48,48,48,48,46,48,41,41,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,109,105,110,40,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,105,110,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,50,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,49,48,48,48,48,48,46,48,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+194560);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,50,66,51,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,49,66,49,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,54,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,140,2,0,29,4,0,0,9,0,0,0,34,4,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,66,55,80,117,109,112,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+204800);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,105,102,32,118,111,108,117,109,101,50,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,49,48,48,48,48,48,46,48,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,49,66,49,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,149,2,0,143,0,0,0,5,0,0,0,143,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,149,2,0,144,0,0,0,5,0,0,0,144,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,149,2,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,115,116,97,116,101,115,70,77,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,152,147,2,0,74,22,0,0,7,0,0,0,75,22,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,140,2,0,102,3,0,0,3,0,0,0,102,3,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,140,2,0,118,3,0,0,3,0,0,0,118,3,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,109,97,120,40,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,109,97,120,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,41,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,109,105,110,40,49,48,48,48,48,48,46,48,44,32,109,105,110,40,105,102,32,118,111,108,117,109,101,56,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,49,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,44,32,49,48,48,48,48,48,46,48,41,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,19,3,0,144,1,0,0,7,0,0,0,147,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,19,3,0,152,1,0,0,7,0,0,0,153,1,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,19,3,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,19,3,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,19,3,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,19,3,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,49,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,109,101,100,105,117,109,115,91,50,93,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,80,117,109,112,50,66,50,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,54,46,72,95,102,108,111,119,95,116,111,112,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,96,142,2,0,119,6,0,0,5,0,0,0,120,6,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+215040);
/* memory initializer */ allocate([114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,248,140,2,0,15,0,0,0,5,0,0,0,15,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,54,46,112,111,114,116,95,98,95,72,95,102,108,111,119,95,98,111,116,116,111,109,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,142,2,0,121,6,0,0,5,0,0,0,122,6,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,96,142,2,0,28,6,0,0,5,0,0,0,29,6,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,66,54,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,66,54,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,248,140,2,0,247,1,0,0,5,0,0,0,248,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,62,61,32,109,97,120,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,76,101,97,118,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,45,49,48,48,48,48,48,46,48,41,32,97,110,100,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,60,61,32,109,105,110,40,45,40,105,102,32,118,111,108,117,109,101,52,46,112,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,95,51,32,61,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,116,104,101,110,32,48,46,48,32,101,108,115,101,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,41,44,32,49,48,48,48,48,48,46,48,41,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,140,2,0,13,0,0,0,5,0,0,0,14,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,117,108,116,105,80,111,114,116,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,248,140,2,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,140,2,0,74,2,0,0,7,0,0,0,74,2,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,147,2,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,152,147,2,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,152,147,2,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,147,2,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,152,147,2,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,152,147,2,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,118,111,108,117,109,101,52,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,149,2,0,164,0,0,0,5,0,0,0,168,0,0,0,70,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,65,83,84,95,95,66,97,116,99,104,80,108,97,110,116,95,66,97,116,99,104,80,108,97,110,116,95,95,83,116,97,110,100,97,114,100,87,97,116,101,114,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,51,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,51,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,51,52,44,51,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,51,52,44,48,93,32,61,32,122,101,114,111,115,40,51,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,51,52,93,32,61,32,122,101,114,111,115,40,48,44,51,52,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,51,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,50,66,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,104,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,50,66,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,50,66,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,104,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,50,66,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,49,66,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,104,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,49,66,49,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,49,66,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,104,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,80,117,109,112,49,66,49,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,66,49,66,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,104,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,66,49,66,50,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,66,49,66,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,104,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,112,105,112,101,66,49,66,50,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,52,80,109,101,100,105,117,109,80,104,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,52,80,109,101,100,105,117,109,80,112,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,66,54,80,109,101,100,105,117,109,80,104,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,66,54,80,108,101,118,101,108,32,61,32,120,91,49,54,93,59,10,32,32,82,101,97,108,32,120,95,80,66,55,80,109,101,100,105,117,109,80,104,32,61,32,120,91,49,55,93,59,10,32,32,82,101,97,108,32,120,95,80,66,55,80,108,101,118,101,108,32,61,32,120,91,49,56,93,59,10,32,32,82,101,97,108,32,120,95,80,66,52,80,109,101,100,105,117,109,80,104,32,61,32,120,91,49,57,93,59,10,32,32,82,101,97,108,32,120,95,80,66,52,80,108,101,118,101,108,32,61,32,120,91,50,48,93,59,10,32,32,82,101,97,108,32,120,95,80,66,51,80,109,101,100,105,117,109,80,104,32,61,32,120,91,50,49,93,59,10,32,32,82,101,97,108,32,120,95,80,66,51,80,108,101,118,101,108,32,61,32,120,91,50,50,93,59,10,32,32,82,101,97,108,32,120,95,80,66,50,80,109,101,100,105,117,109,80,104,32,61,32,120,91,50,51,93,59,10,32,32,82,101,97,108,32,120,95,80,66,50,80,108,101,118,101,108,32,61,32,120,91,50,52,93,59,10,32,32,82,101,97,108,32,120,95,80,66,49,80,109,101,100,105,117,109,80,104,32,61,32,120,91,50,53,93,59,10,32,32,82,101,97,108,32,120,95,80,66,49,80,108,101,118,101,108,32,61,32,120,91,50,54,93,59,10,32,32,82,101,97,108,32,120,95,80,80,50,80,109,101,100,105,117,109,80,104,32,61,32,120,91,50,55,93,59,10,32,32,82,101,97,108,32,120,95,80,80,50,80,109,101,100,105,117,109,80,112,32,61,32,120,91,50,56,93,59,10,32,32,82,101,97,108,32,120,95,80,80,49,80,109,101,100,105,117,109,80,104,32,61,32,120,91,50,57,93,59,10,32,32,82,101,97,108,32,120,95,80,80,49,80,109,101,100,105,117,109,80,112,32,61,32,120,91,51,48,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,53,80,109,101,100,105,117,109,80,104,32,61,32,120,91,51,49,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,53,80,109,101,100,105,117,109,80,112,32,61,32,120,91,51,50,93,59,10,32,32,82,101,97,108,32,120,95,80,66,53,80,109,101,100,105,117,109,80,104,32,61,32,120,91,51,51,93,59,10,32,32,82,101,97,108,32,120,95,80,66,53,80,108,101,118,101,108,32,61,32,120,91,51,52,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,65,83,84,95,95,66,97,116,99,104,80,108,97,110,116,95,66,97,116,99,104,80,108,97,110,116,95,95,83,116,97,110,100,97,114,100,87,97,116,101,114,59,10,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,134,3,0,56,134,3,0,72,134,3,0,96,134,3,0,128,134,3,0,144,134,3,0,168,134,3,0,184,134,3,0,208,134,3,0,240,134,3,0,24,135,3,0,48,135,3,0,80,135,3,0,104,135,3,0,144,135,3,0,176,135,3,0,224,135,3,0,16,136,3,0,40,136,3,0,96,136,3,0,120,136,3,0,168,136,3,0,200,136,3,0,0,137,3,0,40,137,3,0,96,137,3,0,144,137,3,0,160,137,3,0,192,137,3,0,232,137,3,0,8,138,3,0,48,138,3,0,88,138,3,0,112,138,3,0,136,138,3,0,152,138,3,0,176,138,3,0,224,138,3,0,48,139,3,0,112,139,3,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,160,153,3,0,48,152,3,0,184,150,3,0,64,149,3,0,64,149,3,0,200,147,3,0,184,150,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+225280);
/* memory initializer */ allocate([17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,104,164,3,0,240,160,3,0,128,159,3,0,16,158,3,0,16,158,3,0,160,156,3,0,128,159,3,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,176,162,3,0,192,162,3,0,208,162,3,0,160,147,3,0,216,162,3,0,232,162,3,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,72,166,3,0,80,166,3,0,88,166,3,0,96,166,3,0,216,165,3,0,104,166,3,0,120,166,3,0,128,166,3,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,0,0,0,0,0,0,0,0,72,168,3,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,99,108,111,110,101,95,114,101,118,101,114,115,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,32,169,3,0,48,169,3,0,56,169,3,0,64,169,3,0,80,169,3,0,96,169,3,0,104,169,3,0,120,169,3,0,136,169,3,0,152,169,3,0,168,169,3,0,184,169,3,0,200,169,3,0,216,169,3,0,232,169,3,0,240,169,3,0,248,169,3,0,8,170,3,0,16,170,3,0,32,170,3,0,48,170,3,0,64,170,3,0,80,170,3,0,96,170,3,0,112,170,3,0,128,170,3,0,144,170,3,0,160,170,3,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,40,171,3,0,48,171,3,0,48,171,3,0,80,171,3,0,128,171,3,0,160,171,3,0,216,171,3,0,8,172,3,0,56,172,3,0,88,172,3,0,136,172,3,0,160,172,3,0,192,172,3,0,232,172,3,0,8,173,3,0,56,173,3,0,88,173,3,0,128,173,3,0,160,173,3,0,200,173,3,0,248,173,3,0,48,174,3,0,88,174,3,0,136,174,3,0,184,174,3,0,224,174,3,0,16,175,3,0,24,175,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,40,171,3,0,24,178,3,0,32,178,3,0,40,178,3,0,56,169,3,0,48,178,3,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,105,110,116,101,103,101,114,95,97,114,114,97,121,46,99,0,0,0,0,99,111,112,121,95,105,110,116,101,103,101,114,95,97,114,114,97,121,95,100,97,116,97,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,61,61,50,32,38,38,32,100,101,115,116,45,62,110,100,105,109,115,61,61,50,0,0,0,116,114,97,110,115,112,111,115,101,95,105,110,116,101,103,101,114,95,97,114,114,97,121,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,48,93,32,61,61,32,109,32,38,38,32,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,49,93,32,61,61,32,110,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,144,180,3,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,168,180,3,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,192,180,3,0,200,180,3,0,208,180,3,0,224,180,3,0,240,180,3,0,248,180,3,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,61,61,50,32,38,38,32,100,101,115,116,45,62,110,100,105,109,115,61,61,50,0,0,0,116,114,97,110,115,112,111,115,101,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,48,93,32,61,61,32,109,32,38,38,32,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,49,93,32,61,61,32,110,0,0,0,0,0,0,0,0,109,97,120,95,114,101,97,108,95,97,114,114,97,121,0,0,109,105,110,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,144,193,3,0,0,0,0,0,8,193,3,0,0,0,0,0,128,192,3,0,0,0,0,0,248,191,3,0,0,0,0,0,240,190,3,0,0,0,0,0,232,189,3,0,0,0,0,0,224,188,3,0,0,0,0,0,216,187,3,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+235520);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,120,195,3,0,136,195,3,0,144,195,3,0,152,195,3,0,168,195,3,0,176,195,3,0,184,195,3,0,192,195,3,0,200,195,3,0,208,195,3,0,216,195,3,0,232,195,3,0,240,195,3,0,0,196,3,0,16,196,3,0,32,196,3,0,40,196,3,0,56,196,3,0,64,196,3,0,80,196,3,0,88,196,3,0,112,196,3,0,120,196,3,0,128,196,3,0,144,196,3,0,152,196,3,0,168,196,3,0,184,196,3,0,192,196,3,0,200,196,3,0,208,196,3,0,216,196,3,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,104,197,3,0,112,197,3,0,184,197,3,0,232,197,3,0,24,198,3,0,96,198,3,0,160,198,3,0,232,198,3,0,24,199,3,0,96,199,3,0,120,199,3,0,152,199,3,0,208,199,3,0,248,199,3,0,32,200,3,0,88,200,3,0,168,200,3,0,8,201,3,0,56,201,3,0,112,201,3,0,160,201,3,0,232,201,3,0,16,202,3,0,64,202,3,0,112,202,3,0,200,202,3,0,16,203,3,0,128,203,3,0,176,203,3,0,248,203,3,0,24,204,3,0,216,196,3,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,104,197,3,0,216,204,3,0,128,205,3,0,232,197,3,0,24,198,3,0,232,205,3,0,160,198,3,0,232,198,3,0,112,206,3,0,176,206,3,0,120,199,3,0,152,199,3,0,80,207,3,0,144,207,3,0,208,207,3,0,88,200,3,0,168,200,3,0,16,208,3,0,72,208,3,0,208,208,3,0,248,208,3,0,232,201,3,0,16,202,3,0,64,202,3,0,96,209,3,0,232,209,3,0,232,210,3,0,128,203,3,0,176,203,3,0,248,203,3,0,24,204,3,0,216,196,3,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,216,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,216,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,216,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,216,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,216,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+246288);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,128,234,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+256632);
/* memory initializer */ allocate([239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,239,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,241,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,241,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,241,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,241,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,242,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,242,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,243,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,244,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,244,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,244,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,244,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,244,3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,208,23,4,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,24,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,25,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,88,25,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,25,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,184,25,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,26,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,26,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,26,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,136,38,4,0,168,39,4,0,176,39,4,0,192,39,4,0,208,39,4,0,224,39,4,0,248,39,4,0,16,40,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,136,38,4,0,144,38,4,0,216,38,4,0,0,39,4,0,32,39,4,0,64,39,4,0,104,39,4,0,144,39,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,109,105,120,101,100,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,119,105,116,104,32,105,110,100,101,120,32,37,100,32,97,116,32,116,105,109,101,32,37,101,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,56,48,4,0,72,48,4,0,80,48,4,0,88,48,4,0,96,48,4,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,128,48,4,0,136,48,4,0,152,48,4,0,168,48,4,0,96,48,4,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+267317);
/* memory initializer */ allocate([240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,104,75,4,0,48,77,4,0,56,77,4,0,64,77,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,104,75,4,0,112,76,4,0,192,76,4,0,240,76,4,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,104,75,4,0,48,76,4,0,56,76,4,0,64,76,4,0,80,76,4,0,88,76,4,0,104,76,4,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,104,75,4,0,112,75,4,0,136,75,4,0,152,75,4,0,224,75,4,0,240,75,4,0,16,76,4,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,24,87,4,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,24,87,4,0,10,0,0,0,11,0,0,0,188,86,4,0,52,87,4,0,72,87,4,0,208,86,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,232,16,5,0,232,86,4,0,112,204,4,0,0,0,0,0,104,0,0,0,0,0,0,0,112,204,4,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,112,204,4,0,14,0,0,0,15,0,0,0,0,0,0,0,192,87,4,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,232,16,5,0,144,87,4,0,104,203,4,0,0,0,0,0,0,0,0,0,72,88,4,0,80,88,4,0,64,88,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,32,88,4,0,48,88,4,0,64,88,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+277558);
/* memory initializer */ allocate([116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,160,104,4,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,160,104,4,0,20,0,0,0,21,0,0,0,68,104,4,0,188,104,4,0,208,104,4,0,88,104,4,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,232,16,5,0,112,104,4,0,224,203,4,0,0,0,0,0,108,0,0,0,0,0,0,0,224,203,4,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,224,203,4,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,152,114,4,0,128,116,4,0,136,116,4,0,208,118,4,0,232,116,4,0,248,116,4,0,216,118,4,0,224,118,4,0,232,118,4,0,240,118,4,0,0,119,4,0,16,119,4,0,32,119,4,0,48,119,4,0,64,119,4,0,80,119,4,0,96,119,4,0,120,119,4,0,176,118,4,0,200,118,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,152,114,4,0,128,116,4,0,136,116,4,0,152,116,4,0,232,116,4,0,248,116,4,0,8,117,4,0,40,117,4,0,72,117,4,0,104,117,4,0,144,117,4,0,184,117,4,0,224,117,4,0,8,118,4,0,32,118,4,0,64,118,4,0,96,118,4,0,136,118,4,0,176,118,4,0,200,118,4,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,152,114,4,0,96,116,4,0,104,116,4,0,112,116,4,0,152,114,4,0,160,115,4,0,240,115,4,0,32,116,4,0,152,114,4,0,96,115,4,0,104,115,4,0,112,115,4,0,128,115,4,0,136,115,4,0,152,115,4,0,0,0,0,0,152,114,4,0,160,114,4,0,184,114,4,0,200,114,4,0,16,115,4,0,32,115,4,0,64,115,4,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,184,121,4,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,184,121,4,0,28,0,0,0,29,0,0,0,68,121,4,0,212,121,4,0,232,121,4,0,88,121,4,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,232,16,5,0,112,121,4,0,112,204,4,0,0,0,0,0,56,0,0,0,0,0,0,0,112,204,4,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,112,204,4,0,14,0,0,0,15,0,0,0,0,0,0,0,120,122,4,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,232,16,5,0,48,122,4,0,104,203,4,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+287798);
/* memory initializer */ allocate([122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,8,143,4,0,8,143,4,0,8,143,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,176,145,4,0,192,145,4,0,216,145,4,0,248,145,4,0,24,146,4,0,48,146,4,0,80,146,4,0,104,146,4,0,120,146,4,0,136,146,4,0,160,146,4,0,184,146,4,0,216,146,4,0,248,146,4,0,136,146,4,0,16,147,4,0,48,147,4,0,72,147,4,0,96,147,4,0,120,147,4,0,152,147,4,0,168,147,4,0,200,147,4,0,232,147,4,0,0,148,4,0,24,148,4,0,48,148,4,0,64,148,4,0,88,148,4,0,112,148,4,0,136,148,4,0,168,148,4,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+298038);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+305240);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,176,189,4,0,184,189,4,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,200,189,4,0,208,189,4,0,216,189,4,0,224,189,4,0,144,1,0,0,0,0,0,0,80,190,4,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+310464);
/* memory initializer */ allocate([40,197,4,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,232,16,5,0,8,197,4,0,168,203,4,0,0,0,0,0,0,0,0,0,144,197,4,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,232,16,5,0,120,197,4,0,168,203,4,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,40,198,4,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,232,16,5,0,8,198,4,0,104,203,4,0,0,0,0,0,0,0,0,0,144,198,4,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,232,16,5,0,120,198,4,0,104,203,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,192,16,5,0,160,198,4,0,0,0,0,0,8,199,4,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,176,199,4,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,232,16,5,0,248,198,4,0,0,0,0,0,0,0,0,0,0,0,0,0,72,199,4,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,232,16,5,0,48,199,4,0,8,199,4,0,0,0,0,0,0,0,0,0,136,199,4,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,232,16,5,0,112,199,4,0,8,199,4,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,232,16,5,0,152,199,4,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,248,199,4,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,232,16,5,0,224,199,4,0,176,199,4,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,192,16,5,0,8,200,4,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,232,16,5,0,48,200,4,0,40,200,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,224,202,4,0,48,0,0,0,49,0,0,0,0,0,0,0,104,203,4,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,168,203,4,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,224,203,4,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,224,203,4,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,40,204,4,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,40,204,4,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,112,204,4,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,112,204,4,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,184,204,4,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,184,204,4,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,202,4,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,168,202,4,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,232,16,5,0,96,202,4,0,248,199,4,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,192,16,5,0,144,202,4,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,232,16,5,0,176,202,4,0,168,202,4,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,232,16,5,0,240,202,4,0,168,202,4,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,192,16,5,0,48,203,4,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,192,16,5,0,112,203,4,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,72,17,5,0,176,203,4,0,0,0,0,0,1,0,0,0,224,202,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,72,17,5,0,248,203,4,0,0,0,0,0,1,0,0,0,32,203,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,72,17,5,0,64,204,4,0,0,0,0,0,1,0,0,0,224,202,4,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,72,17,5,0,136,204,4,0,0,0,0,0,1,0,0,0,32,203,4,0,3,244,255,255,0,0,0,0,24,205,4,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,232,16,5,0,248,204,4,0,72,200,4,0,0,0,0,0,0,0,0,0,64,219,4,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,219,4,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,224,4,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,176,224,4,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,225,4,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,226,4,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,48,221,4,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,48,221,4,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,208,221,4,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,208,221,4,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,96,222,4,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,222,4,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,219,4,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,219,4,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,220,4,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,220,4,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,226,4,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,40,227,4,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,184,227,4,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,72,228,4,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,223,4,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,223,4,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,24,219,4,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,215,4,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,216,4,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,218,4,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,240,218,4,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,40,215,4,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,232,16,5,0,16,215,4,0,192,198,4,0,0,0,0,0,0,0,0,0,184,215,4,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,192,16,5,0,152,215,4,0,72,17,5,0,128,215,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,215,4,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,72,17,5,0,216,215,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,215,4,0,2,0,0,0,0,0,0,0,136,216,4,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,192,16,5,0,104,216,4,0,72,17,5,0,64,216,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,128,216,4,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,72,17,5,0,168,216,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,128,216,4,0,2,0,0,0,0,0,0,0,72,217,4,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,72,17,5,0,32,217,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,128,216,4,0,2,0,0,0,0,0,0,0,192,217,4,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,72,17,5,0,152,217,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,128,216,4,0,2,0,0,0,0,0,0,0,56,218,4,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,232,16,5,0,16,218,4,0,192,217,4,0,0,0,0,0,0,0,0,0,160,218,4,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,232,16,5,0,120,218,4,0,192,217,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,232,16,5,0,176,218,4,0,40,215,4,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,232,16,5,0,216,218,4,0,40,215,4,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,232,16,5,0,0,219,4,0,40,215,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,232,16,5,0,40,219,4,0,40,215,4,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,232,16,5,0,80,219,4,0,40,215,4,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,192,16,5,0,152,219,4,0,72,17,5,0,120,219,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,219,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,72,17,5,0,216,219,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,219,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,72,17,5,0,24,220,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,219,4,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,72,17,5,0,88,220,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,219,4,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,192,16,5,0,224,220,4,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,192,16,5,0,0,221,4,0,72,17,5,0,152,220,4,0,0,0,0,0,3,0,0,0,40,215,4,0,2,0,0,0,248,220,4,0,2,0,0,0,40,221,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,192,16,5,0,160,221,4,0,72,17,5,0,88,221,4,0,0,0,0,0,3,0,0,0,40,215,4,0,2,0,0,0,248,220,4,0,2,0,0,0,200,221,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,192,16,5,0,64,222,4,0,72,17,5,0,248,221,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,88,222,4,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,72,17,5,0,128,222,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,88,222,4,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,192,16,5,0,0,223,4,0,72,17,5,0,232,222,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,24,223,4,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,72,17,5,0,64,223,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,24,223,4,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,192,16,5,0,216,223,4,0,72,17,5,0,192,223,4,0,0,0,0,0,1,0,0,0,248,223,4,0,0,0,0,0,72,17,5,0,120,223,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,0,224,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,72,17,5,0,128,224,4,0,0,0,0,0,1,0,0,0,248,223,4,0,0,0,0,0,72,17,5,0,56,224,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,152,224,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,192,16,5,0,48,225,4,0,72,17,5,0,24,225,4,0,0,0,0,0,1,0,0,0,80,225,4,0,0,0,0,0,72,17,5,0,208,224,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,88,225,4,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,72,17,5,0,216,225,4,0,0,0,0,0,1,0,0,0,80,225,4,0,0,0,0,0,72,17,5,0,144,225,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,240,225,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,192,16,5,0,112,226,4,0,72,17,5,0,40,226,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,144,226,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,192,16,5,0,0,227,4,0,72,17,5,0,184,226,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,32,227,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,192,16,5,0,144,227,4,0,72,17,5,0,72,227,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,176,227,4,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,192,16,5,0,32,228,4,0,72,17,5,0,216,227,4,0,0,0,0,0,2,0,0,0,40,215,4,0,2,0,0,0,64,228,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+312516);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,48,14,5,0,110,0,0,0,56,14,5,0,114,0,0,0,64,14,5,0,102,0,0,0,72,14,5,0,97,0,0,0,80,14,5,0,101,0,0,0,88,14,5,0,119,0,0,0,96,14,5,0,87,0,0,0,112,14,5,0,115,0,0,0,128,14,5,0,83,0,0,0,144,14,5,0,100,0,0,0,160,14,5,0,68,0,0,0,176,14,5,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,56,16,5,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,192,16,5,0,16,16,5,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,232,16,5,0,40,16,5,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,232,16,5,0,72,16,5,0,32,16,5,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,232,16,5,0,128,16,5,0,112,16,5,0,0,0,0,0,0,0,0,0,168,16,5,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,48,17,5,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,232,16,5,0,8,17,5,0,168,16,5,0,0,0,0,0,0,0,0,0,144,17,5,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,232,16,5,0,104,17,5,0,168,16,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,19,5,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,232,16,5,0,192,19,5,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+322856);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_idii(index,a1,a2,a3) {
  try {
    return Module["dynCall_idii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_idii;var za=env.invoke_viiiiid;var Aa=env.invoke_viiiiiiii;var Ba=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ca=env.invoke_viiiiii;var Da=env.invoke_viidii;var Ea=env.invoke_iid;var Fa=env.invoke_viiiiiii;var Ga=env.invoke_viiiiiid;var Ha=env.invoke_viiiiiiiii;var Ia=env.invoke_iii;var Ja=env.invoke_iiiiii;var Ka=env.invoke_iiiiidi;var La=env.invoke_didd;var Ma=env.invoke_dii;var Na=env.invoke_i;var Oa=env.invoke_iiiiiiiiii;var Pa=env.invoke_viii;var Qa=env.invoke_v;var Ra=env.invoke_iiiiiiiii;var Sa=env.invoke_iiiii;var Ta=env.invoke_viiii;var Ua=env._fabs;var Va=env._exp;var Wa=env._lis_matrix_assemble;var Xa=env._strrchr;var Ya=env._pthread_key_create;var Za=env._vsscanf;var _a=env.__ZSt9terminatev;var $a=env.___cxa_guard_acquire;var ab=env._log10;var bb=env._fstat;var cb=env._pclose;var db=env._lis_solver_create;var eb=env.___assert_fail;var fb=env.__ZSt18uncaught_exceptionv;var gb=env._longjmp;var hb=env.__isLeapYear;var ib=env._clock_gettime;var jb=env._fsync;var kb=env._signal;var lb=env._GC_collect_a_little;var mb=env._sbrk;var nb=env._strtoull;var ob=env._emscripten_memcpy_big;var pb=env.__parseInt64;var qb=env._close;var rb=env._rewind;var sb=env._cos;var tb=env._fileno;var ub=env._fread;var vb=env._puts;var wb=env._isatty;var xb=env._lis_matrix_set_value;var yb=env._write;var zb=env._isblank;var Ab=env._ftell;var Bb=env.__ZNSt9exceptionD2Ev;var Cb=env._xerbla_;var Db=env._round;var Eb=env.___cxa_does_inherit;var Fb=env._strtoll_l;var Gb=env._strstr;var Hb=env.___cxa_rethrow;var Ib=env._llvm_lifetime_end;var Jb=env._catclose;var Kb=env._tmpnam;var Lb=env._lis_vector_get_values;var Mb=env._lis_vector_destroy;var Nb=env._lis_solver_set_option;var Ob=env._tmpfile;var Pb=env._send;var Qb=env._pow;var Rb=env._lis_matrix_set_size;var Sb=env.___cxa_free_exception;var Tb=env.___cxa_find_matching_catch;var Ub=env._isxdigit_l;var Vb=env.___cxa_guard_release;var Wb=env._truncate;var Xb=env._strtol;var Yb=env.__reallyNegative;var Zb=env._sin;var _b=env._strtok;var $b=env.___setErrNo;var ac=env._newlocale;var bc=env._isdigit_l;var cc=env.___resumeException;var dc=env._freelocale;var ec=env._srand;var fc=env._qsort;var gc=env._putchar;var hc=env._floor;var ic=env._pthread_mutex_unlock;var jc=env._printf;var kc=env._sprintf;var lc=env._fopen;var mc=env._vasprintf;var nc=env._emscripten_get_now;var oc=env._stat;var pc=env._lis_solve;var qc=env._strtoull_l;var rc=env._mkport;var sc=env._read;var tc=env.__addDays;var uc=env._fwrite;var vc=env._time;var wc=env._pthread_mutex_lock;var xc=env._catopen;var yc=env._exit;var zc=env._GC_strdup;var Ac=env._freopen;var Bc=env.___ctype_b_loc;var Cc=env._fmod;var Dc=env._strtok_r;var Ec=env._lseek;var Fc=env._access;var Gc=env._vfprintf;var Hc=env.___cxa_allocate_exception;var Ic=env._atoi;var Jc=env._strtoll;var Kc=env._pwrite;var Lc=env._localtime_r;var Mc=env._tzset;var Nc=env._open;var Oc=env._uselocale;var Pc=env._snprintf;var Qc=env.___errno_location;var Rc=env._GC_malloc;var Sc=env.___cxa_end_catch;var Tc=env._perror;var Uc=env.___cxa_begin_catch;var Vc=env._strftime;var Wc=env._ftruncate;var Xc=env._GC_init;var Yc=env._lis_matrix_set_type;var Zc=env._fseek;var _c=env._isxdigit;var $c=env._fclose;var ad=env._vsnprintf;var bd=env.__parseInt;var cd=env._log;var dd=env._pthread_cond_broadcast;var ed=env._popen;var fd=env._recv;var gd=env._fgetc;var hd=env._sysconf;var id=env.__getFloat;var jd=env._lis_vector_set_value;var kd=env._abort;var ld=env._ceil;var md=env._isspace;var nd=env._localtime;var od=env._lis_matrix_destroy;var pd=env._pthread_getspecific;var qd=env._pthread_cond_wait;var rd=env._llvm_lifetime_start;var sd=env.___cxa_is_number_type;var td=env._acos;var ud=env._ungetc;var vd=env._system;var wd=env._fmin;var xd=env._fmax;var yd=env._fflush;var zd=env._strftime_l;var Ad=env._fprintf;var Bd=env._sscanf;var Cd=env._catgets;var Dd=env._lis_solver_destroy;var Ed=env._strdup;var Fd=env._asprintf;var Gd=env.__exit;var Hd=env.___ctype_toupper_loc;var Id=env._bsearch;var Jd=env.__arraySum;var Kd=env.__formatString;var Ld=env._htonl;var Md=env.___ctype_tolower_loc;var Nd=env._unlink;var Od=env._fputs;var Pd=env._GC_malloc_atomic;var Qd=env._pread;var Rd=env._lis_vector_set_size;var Sd=env._fscanf;var Td=env.__scanString;var Ud=env._pthread_setspecific;var Vd=env._copysign;var Wd=env._fputc;var Xd=env.___cxa_throw;var Yd=env._lis_matrix_create;var Zd=env._isdigit;var _d=env._strerror;var $d=env._emscripten_longjmp;var ae=env._lis_vector_create;var be=env._atexit;var ce=env._sqrt;var de=env._strerror_r;var ee=0.0;
// EMSCRIPTEN_START_FUNCS
function Sya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 13:{k=sza(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=iza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Dya(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=sza(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Dya(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 16:{k=tza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=oza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;n=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 29:{g=b;if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;n=77;break a}if((c[232864+((d[234144+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;q=19;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{q=18;b=b+2|0;n=77;break};case 19:{k=uza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}p=b;if((a[r]|0)==0){s=d[j+76+(d[p+1|0]|0)|0]|0}else{s=Dya(a[p]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Dya(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 6:{n=88;break b;break};case 5:{n=85;break b;break};case 33:{n=119;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 7:{n=91;break b;break};case 34:{n=116;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Dya(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};case 7:{n=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{q=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 15:{n=122;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function Tya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=hza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=lza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Dya(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Dya(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Uya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Dya(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Dya(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Vya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Dya(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Wya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Dya(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=hza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Dya(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Xya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Dya(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=hza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=iza(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Dya(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Yya(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Dya(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{break};case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=Dya(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Zya(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function _ya(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Dya(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function $ya(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Dya(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function aza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Dya(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Dya(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function bza(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Rxa(c)|0;k=j;i=b;return k|0}function cza(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function dza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Dya(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Dya(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function eza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Dya(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function fza(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function gza(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function hza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=jza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Dya(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function iza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Dya(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function jza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=kza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Dya(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function kza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Dya(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Dya(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function lza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Dya(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=mza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=nza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=oza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=pza(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Dya(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Dya(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 10:case 9:case 21:{o=69;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Dya(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 17:{break c;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=qza(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function mza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Dya(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function nza(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[235184+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function oza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Dya(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Dya(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{p=34;break b;break};case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((rza(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Dya(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((rza(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function pza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Dya(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 23:{b=b+2|0;continue b;break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Dya(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function qza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Dya(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Dya(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=Dya(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[232864+((d[232608+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 29:{if((c[232864+((d[234144+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 6:{l=13;break a;break};case 5:{l=10;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Dya(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=Dya(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=hza(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=Dya(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=Dya(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 17:{l=107;break a;break};case 5:{l=97;break a;break};case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[232864+((d[232608+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function rza(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function sza(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Dya(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Dya(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function tza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=mza(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Dya(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Dya(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function uza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Dya(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[232864+((d[232608+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Dya(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[232864+((d[234144+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function vza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=15;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((Ce[c[j+344>>2]&127](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((Ce[c[j+332>>2]&127](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((Ce[c[j+348>>2]&127](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((Ce[c[j+336>>2]&127](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((Ce[c[j+352>>2]&127](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((Ce[c[j+340>>2]&127](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 19:{k=fAa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 30:{k=Vza(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 12:{k=dAa(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=eAa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=$za(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 13:{k=dAa(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=72;break b}p=b;if((Ce[c[j+332>>2]&127](j,b)|0)==0){n=74;break b}b=p+2|0;continue b;break};case 34:{n=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=94;break b}q=b;if((Ce[c[j+332>>2]&127](j,b)|0)==0){n=96;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}r=b;if((Ce[c[j+336>>2]&127](j,b)|0)==0){n=101;break b}b=r+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}s=b;if((Ce[c[j+340>>2]&127](j,b)|0)==0){n=106;break b}b=s+4|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};case 15:{n=116;break b;break};case 33:{n=113;break b;break};case 6:{if((e-b|0)<3){n=77;break b}t=b;if((Ce[c[j+336>>2]&127](j,b)|0)==0){n=79;break b}b=t+3|0;continue b;break};case 29:{n=69;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 7:{if((e-b|0)<4){n=82;break b}u=b;if((Ce[c[j+340>>2]&127](j,b)|0)==0){n=84;break b}b=u+4|0;continue b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==110){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){s=b;if((m|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function wza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+360>>2]&127](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 2:{k=Yza(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+356>>2]&127](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=Uza(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+364>>2]&127](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((Ce[c[j+356>>2]&127](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((Ce[c[j+364>>2]&127](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((Ce[c[j+360>>2]&127](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function xza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+356>>2]&127](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+360>>2]&127](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+364>>2]&127](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((Ce[c[j+356>>2]&127](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((Ce[c[j+364>>2]&127](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((Ce[c[j+360>>2]&127](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function yza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((Ce[c[j+360>>2]&127](j,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((Ce[c[j+356>>2]&127](j,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((Ce[c[j+364>>2]&127](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function zza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 10:{m=13;break a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Uza(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Aza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 7:{a=a+4|0;continue a;break};case 10:{m=15;break a;break};case 9:{m=18;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Uza(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Vza(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Bza(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 6:{h=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){h=12;break a}else{continue a}break};case 7:{j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=4;break a}else{h=5}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Cza(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Dza(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Eza(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Fza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Gza(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Rxa(c)|0;g=f;i=b;return g|0}function Hza(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function Iza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;break};case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 5:{a=a+2|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Jza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Kza(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Lza(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Mza(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[232864+(((d[234144+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Nza(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[232864+(((d[234144+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Oza(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Pza(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[232864+(((d[232608+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Qza(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[232864+(((d[232608+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Rza(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Sza(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Tza(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Uza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 19:{j=Wza(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((Ce[c[h+336>>2]&127](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ce[c[h+340>>2]&127](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ce[c[h+332>>2]&127](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Vza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((Ce[c[h+336>>2]&127](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ce[c[h+340>>2]&127](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ce[c[h+332>>2]&127](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Wza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Xza(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Xza(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Yza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=Zza(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=_za(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+344>>2]&127](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 15:{k=$za(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=aAa(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+348>>2]&127](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+352>>2]&127](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{m=73;break b;break};case 7:{if((e-b|0)<4){m=46;break b}n=b;if((Ce[c[j+340>>2]&127](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((Ce[c[j+332>>2]&127](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 29:{m=33;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}p=b;if((Ce[c[j+348>>2]&127](j,b)|0)==0){m=65;break b}b=p+3|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((Ce[c[j+344>>2]&127](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 29:{m=55;break b;break};case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}r=b;if((Ce[c[j+352>>2]&127](j,b)|0)==0){m=70;break b}b=r+4|0;continue b;break};default:{m=72;break b}}break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 17:{break b;break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((Ce[c[j+336>>2]&127](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 11:{m=97;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{m=77;break d;break};case 5:{m=78;break d;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 7:{m=88;break d;break};case 29:{m=76;break d;break};case 11:{m=97;break c;break};case 6:{m=83;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+344>>2]&127](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+348>>2]&127](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ce[c[j+352>>2]&127](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=bAa(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Zza(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=13;break b}n=b;if((Ce[c[j+360>>2]&127](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((Ce[c[j+356>>2]&127](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((Ce[c[j+364>>2]&127](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function _za(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[235560+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function $za(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((Ce[c[k+352>>2]&127](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((Ce[c[k+348>>2]&127](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((Ce[c[k+344>>2]&127](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=37;break b}p=b;if((Ce[c[k+340>>2]&127](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{o=24;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((Ce[c[k+336>>2]&127](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 15:{o=68;break b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((Ce[c[k+332>>2]&127](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((cAa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=47;break c}s=b;if((Ce[c[k+356>>2]&127](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((Ce[c[k+364>>2]&127](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((Ce[c[k+360>>2]&127](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((cAa(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function aAa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((Ce[c[h+340>>2]&127](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 29:{l=24;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((Ce[c[h+336>>2]&127](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((Ce[c[h+332>>2]&127](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function bAa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(Ce[c[k+336>>2]&127](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}n=b;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=48;break a}}break};case 14:{break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=26;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}n=(Ce[c[k+348>>2]&127](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!n){l=36;break a}c[j>>2]=o+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}n=(Ce[c[k+344>>2]&127](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!n){l=31;break a}c[j>>2]=p+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}n=(Ce[c[k+352>>2]&127](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!n){l=41;break a}c[j>>2]=q+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=43;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}n=(Ce[c[k+340>>2]&127](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!n){l=19;break a}c[j>>2]=r+4;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=4;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}n=(Ce[c[k+332>>2]&127](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!n){l=9;break a}c[j>>2]=s+2;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}n=t;if(!((n|0)==9|(n|0)==10|(n|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}n=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((n|0)==(t|0)){break}switch(n|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}n=(Ce[c[k+364>>2]&127](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(n){l=73;break a}c[j>>2]=u+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}n=(Ce[c[k+360>>2]&127](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(n){l=68;break a}c[j>>2]=v+3;continue c;break};case 3:{w=Uza(k,(c[j>>2]|0)+1|0,e,j)|0;if((w|0)<=0){l=77;break a}else{continue c}break};case 2:{l=80;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}n=(Ce[c[k+356>>2]&127](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(n){l=63;break a}c[j>>2]=x+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{l=101;break d;break};case 11:{l=106;break a;break};case 24:case 22:{l=90;break d;break};case 10:case 9:case 21:{break};case 5:{l=91;break d;break};case 6:{l=96;break d;break};case 17:{l=107;break a;break};case 29:{l=89;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}n=(Ce[c[k+344>>2]&127](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!n){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}n=(Ce[c[k+348>>2]&127](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!n){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}n=(Ce[c[k+352>>2]&127](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!n){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((w|0)==0){c[f>>2]=c[j>>2]}B=w;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function cAa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function dAa(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((Ce[c[a+364>>2]&127](a,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((Ce[c[a+356>>2]&127](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((Ce[c[a+360>>2]&127](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function eAa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=Zza(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function fAa(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ce[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((Ce[c[h+332>>2]&127](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((Ce[c[h+336>>2]&127](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((Ce[c[h+340>>2]&127](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function gAa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function hAa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function iAa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function jAa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Me[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){q=a[b+73|0]|0;if((q|0)==0|(q|0)==4|(q|0)==5|(q|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Me[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Me[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Me[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function kAa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((mAa(lAa(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((mAa(lAa(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=lAa(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((mAa(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=lAa(k,a,b)|0;n=h;}while((mAa(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=lAa(k,a,b)|0;while(1){if((mAa(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=lAa(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=lAa(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function lAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ge[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function mAa(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function nAa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function oAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 12:{c[h>>2]=14;j=1;break};case 16:{if((Me[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,239304)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 13:{c[h>>2]=14;j=56;break};case 15:{c[h>>2]=14;j=0;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=sAa(h,a)|0}i=g;return j|0}function pAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 15:{k=0;break};case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};default:{k=rAa(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=sAa(h,a)|0}i=g;return k|0}function qAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Me[c[e+28>>2]&63](e,b,d,239288)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Me[c[e+28>>2]&63](e,b,d,239296)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=sAa(h,a)|0;l=k;i=g;return l|0}function rAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 28:{j=60;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 16:{if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,239064)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,239072)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,239080)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,239088)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function sAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function tAa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function uAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=sAa(e,a)|0}i=f;return g|0}function vAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=sAa(e,a)|0}i=f;return g|0}function wAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=sAa(e,a)|0}i=f;return g|0}function xAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=sAa(e,a)|0}i=f;return g|0}function yAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=sAa(e,a)|0}i=f;return g|0}function zAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else{g=sAa(e,a)|0}i=f;return g|0}function AAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((Me[c[e+28>>2]&63](e,b,d,239104)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((Me[c[e+28>>2]&63](e,b,d,239112)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=sAa(h,a)|0;l=k;i=g;return l|0}function BAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=sAa(e,a)|0}i=f;return g|0}function CAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=sAa(e,a)|0}i=f;return g|0}function DAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else{g=sAa(e,a)|0}i=f;return g|0}function EAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=sAa(e,a)|0;h=g;i=f;return h|0}return 0}function FAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((Me[c[e+28>>2]&63](e,b,d,239120)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b,d,239128)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function GAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=39;break};case 20:{if((Me[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,239136)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 30:{c[h>>2]=40;j=53;break};case 31:{c[h>>2]=40;j=52;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 32:{c[h>>2]=40;j=54;break};default:{k=10}}}while(0);if((k|0)==10){j=sAa(h,a)|0}i=g;return j|0}function HAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=sAa(e,a)|0}i=f;return g|0}function IAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;break};case 31:{c[e>>2]=40;g=52;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 32:{c[e>>2]=40;g=54;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 30:{c[e>>2]=40;g=53;break};default:{g=sAa(e,a)|0}}i=f;return g|0}



function oTa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=M4a(fa(F,F)|0,8)|0;J=I;K=M4a(fa(G,F)|0,8)|0;L=K;M=M4a(fa(H,F)|0,8)|0;N=M;O=M4a(fa(H,G)|0,8)|0;P=O;tWa(p);tWa(q);tWa(r);tWa(s);tWa(t);tWa(u);tWa(v);Q=a+536|0;PBa(c[Q>>2]|0,(I|0)!=0|0,292968,o);PBa(c[Q>>2]|0,(K|0)!=0|0,292968,n);PBa(c[Q>>2]|0,(M|0)!=0|0,292968,m);PBa(c[Q>>2]|0,(O|0)!=0|0,292968,l);l=a+540|0;m=a;if((me[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;kTa(a,J)|0;PBa(n,1,292984,k)}fTa(w,J,F,F);GWa(p,w)|0;FWa(w);if((me[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;lTa(a,L)|0;PBa(w,1,293016,j)}fTa(x,L,F,G);GWa(q,x)|0;FWa(x);if((me[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;mTa(a,N)|0;PBa(x,1,293048,h)}fTa(y,N,H,F);GWa(r,y)|0;FWa(y);if((me[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;nTa(a,P)|0;PBa(m,1,293080,g)}fTa(z,P,H,G);GWa(s,z)|0;FWa(z);if((F|0)==0){HWa(t,293112)|0}else{fTa(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);GWa(t,A)|0;FWa(A)}if((G|0)==0){HWa(u,293112)|0}else{fTa(B,c[a+432>>2]|0,1,G);GWa(u,B)|0;FWa(B)}L4a(I);L4a(K);L4a(M);L4a(O);zWa(E,c[a+84>>2]|0);oXa(D,293128,E);ALa(C,D,293136);GWa(v,C)|0;FWa(C);FWa(D);FWa(E);E=lc(aXa(v)|0,293144)|0;D=c[Q>>2]|0;c[f>>2]=aXa(v)|0;PBa(D,(E|0)!=0|0,293152,f);f=He[c[(c[l>>2]|0)+176>>2]&7]()|0;D=aXa(t)|0;Q=aXa(u)|0;C=aXa(p)|0;a=aXa(q)|0;O=aXa(r)|0;M=aXa(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;Ad(E|0,f|0,e|0)|0;if((c[241708>>2]|0)==0){R=yd(E|0)|0;S=$c(E|0)|0;FWa(v);FWa(u);FWa(t);FWa(s);FWa(r);FWa(q);FWa(p);i=b;return 0}e=He[c[(c[l>>2]|0)+176>>2]&7]()|0;l=aXa(t)|0;f=aXa(u)|0;M=aXa(p)|0;O=aXa(q)|0;a=aXa(r)|0;C=aXa(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;MBa(25,0,e,d);R=yd(E|0)|0;S=$c(E|0)|0;FWa(v);FWa(u);FWa(t);FWa(s);FWa(r);FWa(q);FWa(p);i=b;return 0}function pTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=SXa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}qTa(a,RXa(l)|0,n,e);i=d;return}if((h&8|0)==0){uWa(a,g);i=d;return}else{g=b;b=MXa(g)|0;qTa(a,b,OXa(g)|0,f);i=d;return}}function qTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;rTa(a,b,c,0);i=d;return}function rTa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;sTa(a,b,c);i=d;return}function sTa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=tTa(c,d)|0;if(g>>>0>4294967279){rWa(0)}if(g>>>0<11){LWa(b,g);h=KWa(b)|0}else{j=SWa(g)|0;k=j+1|0;j=kMa(yWa(b)|0,k)|0;UWa(b,j);TWa(b,k);JWa(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;lMa(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){lMa(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;lMa(l,f);i=e;return}function tTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=uTa(b,c,e)|0;i=d;return g|0}function uTa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function vTa(a,b){a=a|0;b=b|0;var c=0;c=i;LTa(a,b);i=c;return}function wTa(a){a=a|0;var b=0;b=i;jTa(a);S4a(a);i=b;return}function xTa(a){a=a|0;var b=0;b=i;jTa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function yTa(a){a=a|0;var b=0;b=i;wTa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function zTa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];ATa(a+4|0);i=d;return}function ATa(a){a=a|0;var b=0;b=i;BTa(a);i=b;return}function BTa(a){a=a|0;var b=0;b=i;c[a>>2]=293368;FWa(a+32|0);GXa(a);i=b;return}function CTa(a){a=a|0;var b=0;b=i;ATa(a);S4a(a);i=b;return}function DTa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=SXa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){mHa(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}mHa(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=SXa(l)|0;j=m-(RXa(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=NXa(l)|0;m=j-(MXa(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(EWa(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){mHa(a,-1,-1);i=h;return}q=w5a(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(EWa(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((NXa(l)|0)!=0){break}mHa(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((SXa(l)|0)!=0){break}mHa(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=MXa(l)|0;QXa(l,p,p+q|0,n)}if((g&16|0)!=0){p=RXa(l)|0;VXa(l,p,TXa(l)|0);UXa(l,q)}mHa(a,q,e);i=h;return}}while(0);mHa(a,-1,-1);i=h;return}function ETa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=AIa(d)|0;we[g&31](a,b,h,J,0,e);i=f;return}function FTa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=SXa(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((OXa(g)|0)>>>0<j>>>0){b=MXa(g)|0;QXa(g,b,NXa(g)|0,j)}j=NXa(g)|0;if(!(j>>>0<(OXa(g)|0)>>>0)){k=-1;i=d;return k|0}k=YIa(a[j]|0)|0;i=d;return k|0}function GTa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=SXa(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=MXa(h)|0;j=NXa(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(UIa(d,-1)|0){QXa(h,g,j+ -1|0,k);l=XIa(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=VIa(d)|0;do{if(g){if(ZIa(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=MXa(h)|0;QXa(h,j,(NXa(h)|0)+ -1|0,k);a[NXa(h)|0]=b;l=d;i=e;return l|0}function HTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(UIa(b,-1)|0){f=XIa(b)|0;i=d;return f|0}g=a;h=NXa(g)|0;j=h-(MXa(g)|0)|0;h=SXa(g)|0;do{if((h|0)==(TXa(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=RXa(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;XWa(o,0);QWa(o,NWa(o)|0);p=EWa(o)|0;VXa(g,p,p+(DWa(o)|0)|0);UXa(g,h-l|0);c[m>>2]=(RXa(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(SXa(g)|0)+1;h=c[(ITa(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=EWa(a+32|0)|0;QXa(g,q,q+j|0,h)}f=JXa(g,b&255)|0;i=d;return f|0}function ITa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=JTa(b,c,e)|0;i=d;return g|0}function JTa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=KTa(0,a,b)|0;i=c;return(d?b:a)|0}function KTa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function LTa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;LXa(a);c[a>>2]=293368;tWa(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;tWa(e);MTa(a,e);FWa(e);i=d;return}function MTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;GWa(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=EWa(e)|0;j=g+(DWa(e)|0)|0;c[b>>2]=j;g=EWa(e)|0;QXa(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=DWa(e)|0;c[b>>2]=(EWa(e)|0)+h;QWa(e,NWa(e)|0);b=a;a=EWa(e)|0;VXa(b,a,a+(DWa(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}UXa(b,h);i=d;return}function NTa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=lc(d|0,293792)|0;J=ed(293800,293792)|0;K=(J|0)!=0;L=Qc()|0;if(K){M=c[b+536>>2]|0;N=_d(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;PBa(M,(I|0)!=0|0,293856,E);uc(293880,17,1,J|0)|0;uc(293904,10,1,J|0)|0;uc(293920,18,1,J|0)|0;OTa(J,f,293944,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,293976)}else{c[G>>2]=_d(c[L>>2]|0)|0;OBa(26,0,293808,G);G=c[b+536>>2]|0;E=_d(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;PBa(G,(I|0)!=0|0,293856,F)}uc(293984,348,1,I|0)|0;if((vc(H|0)|0)<0){c[D>>2]=_d(c[L>>2]|0)|0;OBa(26,0,294336,D);$c(I|0)|0;cb(J|0)|0;O=1;i=j;return O|0}if((Vc(293536,250,294360,nd(H|0)|0)|0)==0){OBa(26,0,294384,C);$c(I|0)|0;O=1;i=j;return O|0}uc(294408,13,1,I|0)|0;uc(294424,12,1,I|0)|0;PTa(I,2);uc(294440,6,1,I|0)|0;QTa(I,c[b+84>>2]|0);uc(294448,8,1,I|0)|0;PTa(I,2);uc(294464,8,1,I|0)|0;C=b+88|0;QTa(I,c[C>>2]|0);uc(294480,10,1,I|0)|0;PTa(I,2);uc(294496,6,1,I|0)|0;QTa(I,293536);uc(294504,8,1,I|0)|0;PTa(I,2);uc(294520,8,1,I|0)|0;QTa(I,c[b+280>>2]|0);uc(294536,10,1,I|0)|0;PTa(I,2);uc(294552,14,1,I|0)|0;QTa(I,c[b+284>>2]|0);uc(294568,16,1,I|0)|0;PTa(I,2);uc(294592,16,1,I|0)|0;QTa(I,l);uc(294616,18,1,I|0)|0;PTa(I,2);c[B>>2]=RTa(l)|0;Ad(I|0,294640,B|0)|0;PTa(I,2);P=+pDa(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Ad(I|0,294680,A|0)|0;PTa(I,2);P=+pDa(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Ad(I|0,294720,z|0)|0;PTa(I,2);P=+pDa(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ad(I|0,294752,y|0)|0;PTa(I,2);P=+pDa(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Ad(I|0,294784,x|0)|0;PTa(I,2);P=+pDa(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Ad(I|0,294816,w|0)|0;PTa(I,2);P=+pDa(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ad(I|0,294848,v|0)|0;PTa(I,2);P=+pDa(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Ad(I|0,294888,u|0)|0;PTa(I,2);P=+sDa(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];Ad(I|0,294920,t|0)|0;PTa(I,2);c[s>>2]=nDa(2)|0;Ad(I|0,294960,s|0)|0;PTa(I,2);P=+rDa(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Ad(I|0,294984,r|0)|0;uc(295016,13,1,I|0)|0;uc(295032,16,1,I|0)|0;PTa(I,2);P=+pDa(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Ad(I|0,295056,q|0)|0;PTa(I,2);c[p>>2]=kDa(8)|0;Ad(I|0,295080,p|0)|0;uc(295120,17,1,I|0)|0;uc(295144,22,1,I|0)|0;STa(I,b);uc(295168,23,1,I|0)|0;uc(295192,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{TTa(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{TTa(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{TTa(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{TTa(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{TTa(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{TTa(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{TTa(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{TTa(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}uc(295208,13,1,I|0)|0;uc(295224,12,1,I|0)|0;UTa(I,J,f,c[C>>2]|0,b);uc(295240,13,1,I|0)|0;uc(295256,12,1,I|0)|0;VTa(I,c[b+68>>2]|0,b+56|0);uc(295272,13,1,I|0)|0;uc(295288,16,1,I|0)|0;WTa(I,J,f,b);uc(295312,17,1,I|0)|0;uc(295336,14,1,I|0)|0;$c(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((m5a(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(m5a(K|0)|0)<<1}else{Q=0}I=K4a(b+Q|0)|0;if((I|0)==0){eb(295352,295360,404,295384)}if((cb(J|0)|0)!=0){OBa(26,0,295400,o)}if(e){e=c[C>>2]|0;c[n>>2]=295432;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;kc(I|0,295448,n|0)|0;if((vd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=295528|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;OBa(1,0,295560,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;MBa(1,0,295624,g);L4a(I);O=0;i=j;return O|0}function OTa(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=lDa(F)|0;H=mDa(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+rDa(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}uc(293880,17,1,a|0)|0;uc(296792,12,1,a|0)|0;uc(296808,12,1,a|0)|0;uc(296824,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;Ad(a|0,296840,D|0)|0;uc(296880,10,1,a|0)|0;uc(296896,11,1,a|0)|0;uc(296912,11,1,a|0)|0;uc(296928,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Ad(a|0,296944,C|0)|0}else{uc(296968,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;Ad(a|0,296568,B|0)|0;uc(296992,13,1,a|0)|0;if(E){uc(296808,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Ad(a|0,297008,A|0)|0}else{uc(296968,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;Ad(a|0,297032,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;Ad(a|0,296688,y|0)|0;uc(297080,10,1,a|0)|0;uc(297096,10,1,a|0)|0;uc(297080,10,1,a|0)|0;uc(297112,11,1,a|0)|0;c[x>>2]=b;Ad(a|0,297128,x|0)|0;c[w>>2]=d;Ad(a|0,297152,w|0)|0;uc(297168,33,1,a|0)|0;uc(297208,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;Ad(a|0,297248,v|0)|0;uc(296928,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Ad(a|0,296944,u|0)|0}else{uc(297096,10,1,a|0)|0;uc(297080,10,1,a|0)|0;uc(297112,11,1,a|0)|0;c[t>>2]=b;Ad(a|0,297128,t|0)|0;c[s>>2]=d;Ad(a|0,297152,s|0)|0;uc(297168,33,1,a|0)|0;uc(297208,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;Ad(a|0,297248,r|0)|0;uc(296928,10,1,a|0)|0;uc(296968,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;Ad(a|0,296568,q|0)|0;uc(296992,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Ad(a|0,297008,p|0)|0}else{uc(296968,17,1,a|0)|0}uc(297280,32,1,a|0)|0;uc(297320,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;Ad(a|0,297352,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;Ad(a|0,296688,n|0)|0;i=m;return}function PTa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Wd(32,a|0)|0;}while((d|0)!=0);i=c;return}function QTa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==34){uc(296560,6,1,b|0)|0}else if((e|0)==39){uc(296552,6,1,b|0)|0}else if((e|0)==62){uc(296544,4,1,b|0)|0}else if((e|0)==60){uc(296536,4,1,b|0)|0}else{Wd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function RTa(a){a=a|0;var b=0,c=0,d=0;b=i;c=lc(a|0,296528)|0;if((c|0)==0){d=-1;i=b;return d|0}Zc(c|0,0,2)|0;a=Ab(c|0)|0;$c(c|0)|0;d=a;i=b;return d|0}function STa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=K4a((m5a(l|0)|0)+15|0)|0;c[f>>2]=l;kc(m|0,296256,f|0)|0;PTa(a,2);uc(296272,10,1,a|0)|0;QTa(a,m);uc(296288,12,1,a|0)|0;PTa(a,2);c[e>>2]=RTa(m)|0;Ad(a|0,296304,e|0)|0;L4a(m);PTa(a,2);uc(296336,9,1,a|0)|0;PTa(a,4);uc(296352,22,1,a|0)|0;PTa(a,4);uc(296376,22,1,a|0)|0;PTa(a,4);uc(296400,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){YTa(g,m,n);o=c[l>>2]|0;PTa(a,4);uc(296432,8,1,a|0)|0;QTa(a,o);uc(296448,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{bUa(h,m,l);g=c[n>>2]|0;PTa(a,4);uc(296432,8,1,a|0)|0;QTa(a,g);uc(296448,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{YTa(j,m,q);b=c[t>>2]|0;PTa(a,4);uc(296472,8,1,a|0)|0;QTa(a,b);uc(296488,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){PTa(a,2);v=296512;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{bUa(k,m,s);e=c[u>>2]|0;PTa(a,4);uc(296472,8,1,a|0)|0;QTa(a,e);uc(296488,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));PTa(a,2);v=296512;w=v;x=uc(w|0,10,1,a|0)|0;i=d;return}function TTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;PTa(a,2);c[f>>2]=c[b>>2];Ad(a|0,296192,f|0)|0;QTa(a,c[b+4>>2]|0);uc(296224,11,1,a|0)|0;QTa(a,c[b+8>>2]|0);uc(295896,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];XTa(a,4,e);PTa(a,2);uc(296240,12,1,a|0)|0;i=d;return}function UTa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{YTa(p,r,v);OTa(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,296008);w=v+9|0;vDa(w);PTa(a,2);c[o>>2]=c[f>>2];Ad(a|0,296016,o|0)|0;PTa(a,4);uc(294440,6,1,a|0)|0;QTa(a,c[s>>2]|0);uc(294448,8,1,a|0)|0;PTa(a,4);c[n>>2]=nDa(w)|0;Ad(a|0,295792,n|0)|0;PTa(a,4);x=+sDa(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Ad(a|0,295816,m|0)|0;PTa(a,4);x=+rDa(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Ad(a|0,294984,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];XTa(a,6,j);PTa(a,2);uc(296040,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function VTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{PTa(a,2);aUa(l,d,x);c[j>>2]=c[q>>2];Ad(a|0,295864,j|0)|0;aUa(m,d,x);QTa(a,c[r>>2]|0);uc(295896,3,1,a|0)|0;PTa(a,4);uc(295904,7,1,a|0)|0;aUa(n,d,x);if((c[s>>2]|0)>0){y=0;do{PTa(a,6);c[g>>2]=0;Ad(a|0,295912,g|0)|0;y=y+1|0;aUa(n,d,x);}while((y|0)<(c[s>>2]|0))}PTa(a,4);uc(295936,8,1,a|0)|0;PTa(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;aUa(o,d,x);z=+pDa(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;aUa(p,d,x);A=kDa(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;Ad(a|0,295952,f|0)|0;PTa(a,2);uc(295992,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function WTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{bUa(n,o,v-u|0);OTa(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,295744);q=v+9|0;vDa(q);PTa(a,2);uc(295752,15,1,a|0)|0;PTa(a,4);c[m>>2]=c[e>>2];Ad(a|0,295768,m|0)|0;PTa(a,4);c[l>>2]=nDa(q)|0;Ad(a|0,295792,l|0)|0;PTa(a,4);w=+sDa(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Ad(a|0,295816,j|0)|0;PTa(a,4);w=+rDa(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Ad(a|0,294984,g|0)|0;PTa(a,2);uc(295840,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function XTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;PTa(a,b);uc(296056,16,1,a|0)|0;QTa(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?296160:296176;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;Ad(a|0,296080,f|0)|0;i=e;return}function YTa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){ZTa(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function ZTa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=lc(c[o>>2]|0,297392)|0;if((p|0)!=0){q=p;break}p=_d(c[(Qc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;QBa(0,297400,g)}else{q=0}}while(0);g=ywa(0)|0;if((g|0)==0){QBa(0,297432,f)}f=a+8|0;c[a+20>>2]=M4a(c[f>>2]|0,32)|0;p=a+12|0;o=M4a((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=297464;c[o+12>>2]=0;c[o+16>>2]=0;Jwa(g,h);Kwa(g,11,128);h=c[n>>2]|0;do{if((h|0)==0){o=j;q5a(o|0,0,1024)|0;while(1){r=ub(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Lwa(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Twa(Qwa(g)|0)|0;s=Rwa(g)|0;$c(q|0)|0;Fwa(g);r=c[a>>2]|0;c[e>>2]=297568;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;QBa(0,297504,e)}else if((t|0)==11){$c(q|0)|0;break}}else{if((Lwa(g,h,m5a(h|0)|0,1)|0)!=0){break}s=Twa(Qwa(g)|0)|0;o=Rwa(g)|0;Fwa(g);r=c[n>>2]|0;c[d>>2]=297568;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;QBa(0,297608,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){eb(297672,297568,295,297712)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{eb(297736,297568,297,297712)}}function _Ta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((i5a(298144,b)|0)==0){if((i5a(c[d>>2]|0,298152)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}PBa(0,p,298160,l);l=c[74500]|0;p=c[74554]|0;do{if((l|0)==0|(p|0)==0){c[74554]=32;a=K4a(1152)|0;c[74500]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[74554]=p<<1;a=N4a(l,p*72|0)|0;c[74500]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(eUa(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((i5a(298224,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((i5a(298232,u)|0)==0){c[74560]=Ed(c[t+4>>2]|0)|0}else{if((i5a(298264,u)|0)==0){c[298244>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((i5a(298280,u)|0)==0){c[298252>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((i5a(298288,u)|0)==0){c[298248>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((i5a(298304,u)|0)==0){c[298256>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((i5a(298312,u)|0)!=0){v=23;break a}c[298260>>2]=(i5a(c[t+4>>2]|0,298328)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];QBa(0,298336,k)}else if((v|0)==45){i=e;return}}if((i5a(297984,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=297568;c[j+4>>2]=k;c[j+8>>2]=v;QBa(0,298368,j)}if((i5a(298432,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=297568;c[h+4>>2]=j;QBa(0,298440,h)}h=Xb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=297568;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;QBa(0,298496,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=298560;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((i5a(297928,b)|0)!=0){if((i5a(298120,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=298664;m=Ed(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=298672;i=e;return}c[297948>>2]=0;c[297952>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((i5a(m,298152)|0)==0){c[297948>>2]=Ed(c[b+4>>2]|0)|0}else{if((i5a(m,298616)|0)!=0){break}c[297952>>2]=Ed(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[297948>>2]|0)==0){w=0;break}w=(c[297952>>2]|0)!=0|0}}while(0);PBa(0,w,298624,f);c[74486]=-1;f=297956|0;w=298240;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function $Ta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((i5a(297928,b)|0)==0){o=e+0|0;p=297944|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));dUa(e);i=d;return}if((i5a(297984,b)|0)==0){e=h+24|0;r=K4a((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=K4a(36)|0;t=s;o=s+0|0;p=(c[74500]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((i5a(298008,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Fd(e+(k*20|0)+8|0,298016,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((i5a(298056,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Fd(h+(k*20|0)+8|0,298072,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((i5a(298120,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function aUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){ZTa(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function bUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){ZTa(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;QBa(0,297776,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=7;n=m;o=297856;p=o;QBa(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=7;n=m;o=297856;p=o;QBa(0,p,f)}}function cUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){L4a(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){L4a(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}L4a(k);c[d>>2]=0;i=b;return}function dUa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=K4a(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=m5a(f|0)|0;c[e+64>>2]=k;k=c[74534]|0;do{if((k|0)==0){c[74534]=e;c[e+44>>2]=0;l=K4a(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){yc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=K4a(384)|0;c[l>>2]=n;if((n|0)==0){yc(-1)}else{q5a(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[74534]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[74534]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=m5a(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(m5a(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 7:{B=o;C=y;D=16;break};case 1:{E=o;F=x;G=y;D=22;break};case 10:{H=o;D=13;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;H=z;D=13;break};case 5:{I=o;J=y;D=18;break};case 8:{K=o;D=15;break};case 3:{L=o;M=x;N=y;D=20;break};case 6:{O=o;P=y;D=17;break};case 4:{Q=o;R=y;D=19;break};case 9:{S=o;D=14;break};case 2:{T=o;U=x;V=y;D=21;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+H|0;c[p>>2]=o;S=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+S|0;c[p>>2]=o;K=o;D=15}if((D|0)==15){B=K;C=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){O=B;P=((d[A+6|0]|0)<<16)+C|0;D=17}if((D|0)==17){I=O;J=((d[A+5|0]|0)<<8)+P|0;D=18}if((D|0)==18){Q=I;R=(d[A+4|0]|0)+J|0;D=19}if((D|0)==19){L=Q;M=((d[A+3|0]|0)<<24)+x|0;N=R;D=20}if((D|0)==20){T=L;U=((d[A+2|0]|0)<<16)+M|0;V=N;D=21}if((D|0)==21){E=T;F=((d[A+1|0]|0)<<8)+U|0;G=V;D=22}if((D|0)==22){W=E;X=(d[A]|0)+F|0;Y=G}G=X-Y-W^W>>>13;X=Y-W-G^G<<8;Y=W-G-X^X>>>13;W=G-X-Y^Y>>>12;G=X-Y-W^W<<16;X=Y-W-G^G>>>5;Y=W-G-X^X>>>3;W=G-X-Y^Y<<10;G=X-Y-W^W>>>15;c[p>>2]=G;p=(c[74534]|0)+40|0;W=c[p>>2]|0;Y=G&(c[W+4>>2]|0)+ -1;G=c[W>>2]|0;W=G+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[G+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[74534]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[74534]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=K4a((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){yc(-1)}q5a(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;G=c[j>>2]|0;c[Y+24>>2]=(((G<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((G|0)==0){_=e}else{G=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=G}else{W=G;X=j;while(1){j=X+16|0;F=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];E=Z+(A*12|0)+4|0;D=(c[E>>2]|0)+1|0;c[E>>2]=D;V=c[W+24>>2]|0;if(D>>>0>V>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[E>>2]|0)>>>0)/(V>>>0)|0}c[X+12>>2]=0;V=Z+(A*12|0)|0;c[j>>2]=c[V>>2];j=c[V>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[V>>2]=X;V=c[h>>2]|0;if((F|0)==0){$=V;break}else{W=V;X=F}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){G=$;Y=W;e=X}else{_=W;break}}}L4a(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function eUa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[74534]|0)==0){f=24}else{g=m5a(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(m5a(a|0)|0)+s|0;switch(v|0){case 10:{x=h;f=6;break};case 6:{y=h;z=u;f=10;break};case 7:{A=h;B=u;f=9;break};case 1:{C=h;D=t;E=u;f=15;break};case 8:{F=h;f=8;break};case 9:{G=h;f=7;break};case 4:{H=h;I=u;f=12;break};case 2:{J=h;K=t;L=u;f=14;break};case 3:{M=h;N=t;O=u;f=13;break};case 5:{P=h;Q=u;f=11;break};case 11:{x=((d[w+10|0]|0)<<24)+h|0;f=6;break};default:{R=h;S=t;T=u}}if((f|0)==6){G=((d[w+9|0]|0)<<16)+x|0;f=7}if((f|0)==7){F=((d[w+8|0]|0)<<8)+G|0;f=8}if((f|0)==8){A=F;B=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){y=A;z=((d[w+6|0]|0)<<16)+B|0;f=10}if((f|0)==10){P=y;Q=((d[w+5|0]|0)<<8)+z|0;f=11}if((f|0)==11){H=P;I=(d[w+4|0]|0)+Q|0;f=12}if((f|0)==12){M=H;N=((d[w+3|0]|0)<<24)+t|0;O=I;f=13}if((f|0)==13){J=M;K=((d[w+2|0]|0)<<16)+N|0;L=O;f=14}if((f|0)==14){C=J;D=((d[w+1|0]|0)<<8)+K|0;E=L;f=15}if((f|0)==15){R=C;S=(d[w]|0)+D|0;T=E}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[74534]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=m5a(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((h5a(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Gb(a|0,298696)|0)==0){V=0;break}else{W=298720}i=b;return W|0}}while(0);c[e>>2]=a;PBa(0,(V|0)!=0|0,298768,e);W=V+4|0;i=b;return W|0}function fUa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((gUa(298824,a,b)|0)!=0){d=1;i=c;return d|0}d=(gUa(298832,a,b)|0)!=0|0;i=c;return d|0}function gUa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((i5a(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function hUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(i5a(c[247140>>2]|0,298840)|0)==0|0;PBa(0,m,298856,l);l=(i5a(c[249044>>2]|0,298840)|0)==0|0;PBa(0,l,298912,k);k=(i5a(c[251036>>2]|0,298840)|0)==0|0;PBa(0,k,298968,j);j=299032|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=299160|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[251040+(k<<2)>>2]|0;if((l|0)==1){if((gUa(c[247016+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[247016+(k<<2)>>2]|0;if(!((gUa(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[247016+(k<<2)>>2]|0;if((jUa(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=299032+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=299032+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[299160+(k<<2)>>2]=iUa(r,p)|0;t=j}else if((q|0)==13){q=0;l=299032+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[299160+(k<<2)>>2]=kUa(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];OBa(1,0,299288,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];OBa(1,0,299288,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];OBa(1,0,299288,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];OBa(1,0,299344,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function iUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((i5a(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function jUa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(kUa(a,b)|0)!=0|0;i=c;return d|0}function kUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=m5a(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((j5a(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function lUa(){i=i;return}function mUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){yc(0)}e=c[r>>2]|0;uc(299376,5,1,e|0)|0;f=b;b=0;while(1){Wd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}uc(299384,20,1,e|0)|0;yc(0);return 0}function nUa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;Ad(d|0,299408,e|0)|0;if((b|0)==0){yc(1)}else{yd(d|0)|0;vUa();yd(d|0)|0;kb(6,0)|0;kd()}}function oUa(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function pUa(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function qUa(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function rUa(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function sUa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function tUa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}q5a(p|0,32,b+(d-p)|0)|0;i=f;return}function uUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=300448+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[300492+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[300488+(e*48|0)>>2]|0)==1){wUa(b)|0}k=300452+(e*48|0)|0;if((c[k>>2]|0)==0){break}$c(c[f>>2]|0)|0;L4a(c[k>>2]|0)}}while(0);do{if((h|0)==10){$c(g|0)|0;b=300452+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Nd(k|0)|0;L4a(c[b>>2]|0)}}while(0);c[f>>2]=0}c[300484+(e*48|0)>>2]=0;c[300452+(e*48|0)>>2]=0;i=d;return 0}function vUa(){var a=0,b=0;a=i;if((c[74854]|0)!=0){i=a;return}c[74854]=1;c[299424>>2]=0;b=0;do{c[299420>>2]=b;uUa(299416)|0;b=b+1|0;}while((b|0)<100);i=a;return}function wUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[300464+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=300448+(d*48|0)|0;g=c[f>>2]|0;h=Ab(g|0)|0;Zc(g|0,0,2)|0;if((h|0)>=(Ab(g|0)|0)){e=0;i=b;return e|0}if((c[300468+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[300476+(d*48|0)>>2]&2|0)!=0){yd(c[f>>2]|0)|0}d=Wc(tb(c[f>>2]|0)|0,h|0)|0;Zc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){yUa(111,299432);e=111;i=b;return e|0}else{c[(Qc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function xUa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((bb(tb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(wb(tb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function yUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Tc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;Ad(m|0,300344,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;Ad(m|0,300376,j|0)|0;l=m;break}else{n=c[300216+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;Ad(m|0,300400,h|0)|0;l=m;break}}}while(0);h=c[75102]|0;do{if((h|0)==0){uc(305280,29,1,l|0)|0}else{c[g>>2]=(h-300448|0)/48|0;Ad(l|0,300416,g|0)|0;b=c[(c[75102]|0)+4>>2]|0;if((b|0)==0){uc(305264,10,1,l|0)|0;break}else{c[f>>2]=b;Ad(l|0,305248,f|0)|0;break}}}while(0);f=c[76328]|0;if((f|0)!=0){c[d>>2]=f;Ad(l|0,305320,d|0)|0}d=(c[76348]|0)!=0?305400:305416;f=(c[76356]|0)!=0?305432:305448;g=(c[76366]|0)!=0?305472:305488;c[e>>2]=(c[76342]|0)!=0?305376:305384;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;Ad(l|0,305344,e|0)|0;nUa(305504,1)}function zUa(){var a=0,b=0;a=i;c[76378]=1;b=c[r>>2]|0;c[75112]=b;c[300468>>2]=xUa(b)|0;c[300472>>2]=1;c[300488>>2]=1;b=c[s>>2]|0;c[300688>>2]=b;c[300708>>2]=xUa(b)|0;c[300712>>2]=1;c[300728>>2]=0;b=c[t>>2]|0;c[300736>>2]=b;c[300756>>2]=xUa(b)|0;c[300760>>2]=1;c[300776>>2]=1;i=a;return}function AUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=Ac(g|0,c[310760+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[76380]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=Ab(c[k>>2]|0)|0;l=Ac(c[f>>2]|0,c[310760+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[76380]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Zc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Qc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Zc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function BUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){yUa(b,d)}d=c[76382]|0;if((d|0)!=0){He[d&7]()|0}c[(Qc()|0)>>2]=b;i=e;return b|0}function CUa(a){a=a|0;var b=0,d=0;b=i;c[76412]=0;c[76414]=0;c[76416]=0;d=((DUa(a,0)|0)==0)<<31>>31;i=b;return d|0}function DUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[76416]|0;c[76416]=j+1;if((j|0)==1){c[76414]=d}if((IUa(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=JUa(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function EUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[76412]|0;l=305672+(k<<4)|0;m=c[l>>2]|0;switch(FUa(m)|0){case 21:{c[76390]=0;c[76412]=k+1;continue b;break};case 9:{n=(me[c[76396]&127](l)|0)==0;c[76412]=(c[76412]|0)+1;if(n){break b}else{continue b}break};case 3:{n=c[77628]|0;o=310520+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[77628]=n+ -1;c[77644]=(c[77644]|0)+ -1;c[76412]=k+1;continue b}else{n=c[77644]|0;c[77644]=n+ -1;c[76412]=(c[310584+(n<<2)>>2]|0)+1;continue b}break};case 8:{n=c[77628]|0;q=310520+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){t=10;break b}c[77628]=n+ -1;c[76412]=k+1;continue b;break};case 33:{c[77656]=1;c[76412]=k+1;continue b;break};case 2:{c[77628]=0;c[77644]=0;c[76412]=c[305676+(k<<4)>>2];if(b){t=24;break a}if((c[77640]|0)==0){j=0;t=37;break a}n=He[c[76398]&7]()|0;if((n|0)==0){continue b}else{j=n;t=37;break a}break};case 19:case 17:{c[76388]=0;c[76412]=k+1;continue b;break};case 18:{c[76388]=1;c[76412]=k+1;continue b;break};case 6:{n=c[305676+(k<<4)>>2]|0;p=(c[77628]|0)+1|0;c[77628]=p;c[310520+(p<<2)>>2]=n;c[76412]=k+1;continue b;break};case 16:{if(b){t=28;break a}c[76412]=k+1;continue b;break};case 22:{c[76390]=1;c[76412]=k+1;continue b;break};case 1:{n=c[305676+(k<<4)>>2]|0;p=(c[77644]|0)+1|0;c[77644]=p;c[310584+(p<<2)>>2]=n;c[76412]=k+1;continue b;break};case 20:{c[76408]=c[305676+(k<<4)>>2];c[76412]=k+1;continue b;break};default:{t=4;break a}}}if((t|0)==10){t=0;if(b){t=11;break}c[q>>2]=s+ -1;c[77640]=1;k=pe[c[76394]&63](l,g,d)|0;if((k|0)>0){t=13;break}if((k|0)<0){t=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;t=37;break}}if((t|0)==4){h=c[r>>2]|0;d=c[76328]|0;c[f>>2]=m;c[f+4>>2]=d;Ad(h|0,310472,f|0)|0;if((c[c[76384]>>2]|0)==0){yUa(100,310504);j=100;i=e;return j|0}else{c[(Qc()|0)>>2]=100;j=100;i=e;return j|0}}else if((t|0)==11){j=He[c[76382]&7]()|0;i=e;return j|0}else if((t|0)==13){f=c[c[76384]>>2]|0;j=BUa(f,c[(Qc()|0)>>2]|0,310568)|0;i=e;return j|0}else if((t|0)==15){if((c[(c[76384]|0)+8>>2]|0)==0){yUa(-1,310568);j=-1;i=e;return j|0}else{c[(Qc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((t|0)==24){j=He[c[76382]&7]()|0;i=e;return j|0}else if((t|0)==28){j=He[c[76382]&7]()|0;i=e;return j|0}else if((t|0)==37){i=e;return j|0}return 0}function FUa(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function GUa(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=EUa(b,0,0)|0;i=a;return d|0}function HUa(){c[76404]=0;c[76412]=0;c[77644]=0;c[77628]=0;c[77640]=0;c[77646]=0;c[77630]=0;i=i;return}function IUa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[76412]|0;if((g|0)>299){uc(310648,24,1,c[r>>2]|0)|0;nUa(c[76328]|0,1)}else{c[305672+(g<<4)>>2]=a;c[305676+(g<<4)>>2]=b;c[305680+(g<<4)>>2]=d;c[305684+(g<<4)>>2]=e;c[76412]=g+1;i=f;return g|0}return 0}function JUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=KUa(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[76416]|0)+ -1|0;c[76416]=h;if((h|0)==0){IUa(2,c[76414]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{IUa(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function KUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((LUa(b,e)|0)!=0){g=c[e>>2]|0;break}if((MUa(b,e)|0)!=0){g=c[e>>2]|0;break}h=NUa(b,f,1)|0;j=IUa(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=DUa(h,j)|0}}while(0);i=d;return g|0}function LUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==80|h<<24>>24==112){j=g;k=18}else if(h<<24>>24==83|h<<24>>24==115){j=g;k=19}else{j=b;k=17}IUa(k,0,0,0)|0;l=j;m=30;break};case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){IUa(22,0,0,0)|0;l=g;m=30;break a}else{IUa(21,0,0,0)|0;l=g;m=30;break a}break};case 47:{IUa(5,0,0,0)|0;l=b;m=30;break};case 43:{n=0;m=13;break};case 39:case 34:case 2:{c[305680+((IUa(11,0,0,0)|0)<<4)>>2]=b;g=OUa(b)|0;c[d>>2]=g;o=(g|0)!=0|0;i=e;return o|0};case 45:{n=1;m=13;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;m=14;break};case 120:case 88:{IUa(4,1,0,0)|0;l=b;m=30;break};case 36:{IUa(33,0,0,0)|0;l=b;m=30;break};case 58:{IUa(16,0,0,0)|0;l=b;m=30;break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==76|h<<24>>24==108){r=g;s=13}else if(h<<24>>24==82|h<<24>>24==114){r=g;s=14}else{r=b;s=15}g=NUa(r+1|0,f,0)|0;if((g|0)==0){m=15;break a}IUa(s,c[f>>2]|0,0,0)|0;l=g+ -1|0;m=30;break};case 112:case 80:{IUa(20,1,0,0)|0;l=b;m=30;break};default:{o=0;i=e;return o|0}}}while(0);if((m|0)==13){p=b+1|0;q=n;m=14}b:do{if((m|0)==14){n=NUa(p,f,0)|0;if((n|0)==0){m=15;break}switch(a[n]|0){case 120:case 88:{IUa(4,c[f>>2]|0,0,0)|0;l=n;m=30;break b;break};case 104:case 72:{b=c[f>>2]|0;c[305680+((IUa(12,b,0,0)|0)<<4)>>2]=n+1;l=n+b|0;m=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}IUa(20,t,0,0)|0;l=n;m=30;break b;break};default:{o=0;i=e;return o|0}}}}while(0);if((m|0)==15){c[d>>2]=0;o=1;i=e;return o|0}else if((m|0)==30){c[d>>2]=l+1;o=1;i=e;return o|0}return 0}function MUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=NUa(b,f,1)|0;IUa(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 103:case 71:{l=0;m=3;break};case 100:case 68:{n=NUa(f,g,0)|0;if((n|0)==0){m=4;break a}o=c[g>>2]|0;if((o|0)==0){p=n;m=45;break a}if((a[n]|0)==46){q=NUa(n+1|0,h,0)|0;if((q|0)==0){m=4;break a}r=q;s=c[h>>2]|0}else{c[h>>2]=0;r=n;s=0}IUa(26,o,s,0)|0;p=r;m=45;break};case 101:case 69:{l=1;m=3;break};case 102:case 70:{o=NUa(f,g,0)|0;if((o|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){p=o;m=45;break a}if((a[o]|0)==46){q=NUa(o+1|0,h,0)|0;if((q|0)==0){m=4;break a}t=q;u=c[h>>2]|0}else{c[h>>2]=0;t=o;u=0}IUa(23,n,u,0)|0;p=t;m=45;break};case 122:case 90:{v=35;w=36;m=38;break};case 108:case 76:{n=NUa(f,g,0)|0;if((n|0)==0){m=4;break a}o=c[g>>2]|0;if((o|0)==0){p=n;m=45;break a}IUa(29,o,0,0)|0;p=n;m=45;break};case 97:case 65:{n=f;while(1){x=a[n]|0;if(x<<24>>24==32){n=n+1|0}else{break}}if(!((x+ -48<<24>>24&255)<10)){IUa(30,0,0,0)|0;p=n;m=45;break a}o=NUa(n,g,1)|0;q=c[g>>2]|0;if((q|0)==0){p=o;m=45;break a}IUa(31,q,0,0)|0;p=o;m=45;break};case 105:case 73:{v=7;w=10;m=38;break};case 111:case 79:{v=32;w=34;m=38;break};default:{c[76412]=(c[76412]|0)+ -1;c[d>>2]=b;y=0;i=e;return y|0}}}while(0);do{if((m|0)==3){b=NUa(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){p=b;m=45;break}t=a[b]|0;if(t<<24>>24==46){u=NUa(b+1|0,h,0)|0;if((u|0)==0){m=4;break}z=u;A=a[u]|0}else{c[h>>2]=0;z=b;A=t}if(!(A<<24>>24==101|A<<24>>24==69)){IUa((l|0)==1?24:27,x,c[h>>2]|0,0)|0;p=z;m=45;break}t=NUa(z+1|0,j,0)|0;if((t|0)==0){m=4;break}IUa((l|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;p=t;m=45}else if((m|0)==38){t=NUa(f,g,0)|0;if((t|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){p=t;m=45;break}if((a[t]|0)!=46){IUa(v,x,0,0)|0;p=t;m=45;break}b=NUa(t+1|0,h,0)|0;if((b|0)==0){m=4;break}IUa(w,x,c[h>>2]|0,0)|0;p=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;y=1;i=e;return y|0}else if((m|0)==45){c[d>>2]=p;y=1;i=e;return y|0}return 0}function NUa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function OUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[76384]>>2]|0)==0){yUa(100,310632);n=0;i=d;return n|0}else{c[(Qc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function PUa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[310702|0]=48;k=310702|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=310680+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function QUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[76406]|0;f=c[76402]|0;if((e|0)>(f|0)){c[76402]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[77694]|0)){h=g}else{RUa(f,g);h=c[76402]|0}g=c[77696]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Od(g|0,c[76380]|0)|0;h=m5a(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Wd(a[k]|0,c[76380]|0)|0;Od(h|0,c[76380]|0)|0;b=m5a(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function RUa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[77696]|0;if((f|0)==310864){c[77694]=1024;g=1024}else{g=c[77694]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[77694]=j;h=j}j=K4a(h)|0;if((j|0)==0){yUa(113,311264);k=c[77696]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[77696]|0}else{l=k}if((l|0)==310864){m=310784;c[77696]=j;i=e;return}L4a(l);m=310784;c[77696]=j;i=e;return}function SUa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[76402]|0;f=c[77694]|0;if((e|0)<(f|0)){g=e}else{RUa(e,f);g=c[76402]|0}c[76402]=g+1;a[(c[77696]|0)+g|0]=b;i=d;return}function TUa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[76366]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){yUa(101,310792);l=101;i=d;return l|0}else{c[(Qc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[76378]|0)==0){zUa();m=c[f>>2]|0}else{m=k}k=300448+(m*48|0)|0;c[75102]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){YUa(k,c[b+12>>2]|0,j);o=ZUa(j,h)|0;if((o|0)==(c[300456+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[300460+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=uUa(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[300480+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=300464+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[300480+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=300472+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[300472+(m*48|0)>>2]=1;r=1;break}else{c[300472+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];kc(j|0,310800,e|0)|0}else{YUa(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){UUa(107,310792,b);l=107;i=d;return l|0}else{c[(Qc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=300492+(m*48|0)|0;c[q>>2]=0;c[300484+(m*48|0)>>2]=0;e=300488+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=300476+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((Fc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Qc()|0;s=c[k>>2]|0;if(o){UUa(s,310792,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;s=Ob()|0;c[n>>2]=s;if((s|0)!=0){c[300452+(m*48|0)>>2]=0;c[300460+(m*48|0)>>2]=-1;c[300456+(m*48|0)>>2]=-1;c[300468+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Qc()|0;o=c[k>>2]|0;if(s){UUa(o,310792,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 78:case 110:{if((Fc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){UUa(128,310792,b);l=128;i=d;return l|0}else{c[(Qc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=lc(j|0,c[77690]|0)|0;if((o|0)==0){break}$c(o|0)|0}}while(0);q=K4a((m5a(j|0)|0)+1|0)|0;c[300452+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){UUa(113,310816,b);l=113;i=d;return l|0}else{c[(Qc()|0)>>2]=113;l=113;i=d;return l|0}}s5a(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=lc(j|0,c[310760+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=lc(j|0,c[310720+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=lc(j|0,c[310760+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Qc()|0;o=c[g>>2]|0;if(h){yUa(o,310792);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=300468+(m*48|0)|0;c[r>>2]=xUa(u)|0;u=ZUa(j,300460+(m*48|0)|0)|0;c[300456+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){UUa(108,310792,b);l=108;i=d;return l|0}else{c[(Qc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){rb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Zc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){UUa(129,310792,b);l=129;i=d;return l|0}else{c[(Qc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function UUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){yUa(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[77694]|0)){j=d;k=g}else{RUa(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[77696]|0;c[(c[75102]|0)+4>>2]=f;YUa(k,j,f);yUa(a,b);i=e;return}function VUa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;kc(j|0,310800,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=m5a(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?310832:310840;c[h+24>>2]=(b|0)==5?310848:310856;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=TUa(h)|0;i=e;return a|0}function WUa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=300448+(d*48|0)|0;c[75102]=e;if(d>>>0>99){if((c[a>>2]|0)==0){yUa(101,311280);f=101;i=b;return f|0}else{c[(Qc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((VUa(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){yUa(114,311288);f=114;i=b;return f|0}else{c[(Qc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[300472+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){yUa(102,311288);f=102;i=b;return f|0}else{c[(Qc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function XUa(){var a=0,b=0;a=i;b=GUa()|0;c[76328]=0;i=a;return b|0}function YUa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function ZUa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((oc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function _Ua(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[76408]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[76388]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];kc(p|0,311296,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(m5a(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;je[c[76392]&1023](32);}while((A|0)>0)}if((D|0)!=0){je[c[76392]&1023]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{je[c[76392]&1023](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Ic(A|0)|0)+1|0;c[m>>2]=t-(c[76408]|0);kc(A|0,311304,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;je[c[76392]&1023](32);}while((z|0)>0)}if((x|0)!=0){je[c[76392]&1023]((w|0)!=0?45:43)}z=c[76408]|0;do{if((z|0)<1){je[c[76392]&1023](46);y=c[76392]|0;if((z|0)<0){G=y;J=z;while(1){je[G&1023](48);I=J+1|0;K=c[76392]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}je[N&1023](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}je[c[76392]&1023](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[76392]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){je[P&1023](a[J]|0);R=Q+ -1|0;S=c[76392]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}je[T&1023](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;je[c[76392]&1023](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){je[c[76392]&1023](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;je[c[76392]&1023](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){je[c[76392]&1023](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;je[c[76392]&1023](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;je[c[76392]&1023](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;je[c[76392]&1023](42);}while((_|0)>0);i=l;return 0}function $Ua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[76408]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(kc(n|0,311312,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[76388]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;je[c[76392]&1023](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;je[c[76392]&1023](32);}while((b|0)>0)}do{if(q){if((c[76388]|0)==0){break}je[c[76392]&1023](43)}else{je[c[76392]&1023](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;je[c[76392]&1023](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;je[c[76392]&1023](48);}while((z|0)>0);i=j;return 0}function aVa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{je[c[76392]&1023](32);e=e+1|0;}while((e|0)<(d|0))}d=c[76392]|0;if((h|0)==0){je[d&1023](70);i=g;return 0}else{je[d&1023](84);i=g;return 0}return 0}function bVa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[76404]|0)!=0){g=cVa()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 7:{dVa(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 30:{fVa(b,d);h=0;i=e;return h|0};case 35:{iVa(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 29:{aVa(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 32:{dVa(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 31:{gVa(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 23:{h=$Ua(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 34:{eVa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 36:{iVa(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 28:case 27:{h=hVa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 10:{eVa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 25:case 24:case 26:{h=_Ua(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;Ad(h|0,311320,f|0)|0;nUa(c[76328]|0,1)}}return 0}function cVa(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[76404]|0;c[76404]=0;if((c[76366]|0)!=0){if((b|0)>0){d=c[76406]|0;e=c[76402]|0;if((d|0)<=(e|0)){f=b;while(1){je[c[76392]&1023](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[76402]=f;h=0;i=a;return h|0}f=b-d+e|0;c[76402]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){je[c[76392]&1023](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[76402]|0;f=j+b|0;if((f|0)>=0){if((c[76406]|0)<(j|0)){c[76406]=j}c[76402]=f;h=0;i=a;return h|0}if((c[c[76384]>>2]|0)==0){yUa(110,311408);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[76402]|0;if((c[76406]|0)<(f|0)){c[76406]=f}j=f+b|0;c[76402]=j;c[76410]=(c[76410]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[76384]>>2]|0)==0){yUa(110,311408);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[76402]|0;f=j+b|0;if((f|0)>=(c[(c[76386]|0)+16>>2]|0)){if((c[c[76384]>>2]|0)==0){yUa(110,311424);h=110;i=a;return h|0}else{c[(Qc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[76406]|0;if((d|0)<=(j|0)){e=b;while(1){je[c[76392]&1023](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[76410]=(c[76410]|0)+b;c[76402]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[76410]=(c[76410]|0)+f;c[76402]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){je[c[76392]&1023](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function dVa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=PUa(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[76388]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{je[c[76392]&1023](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{je[c[76392]&1023](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[76388]|0)==0){break}je[c[76392]&1023](43)}else{je[c[76392]&1023](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){je[c[76392]&1023](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function eVa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=PUa(m,k,l,h)|0;h=c[l>>2]|0;g=(c[76388]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{je[c[76392]&1023](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{je[c[76392]&1023](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[76388]|0)==0){break}je[c[76392]&1023](43)}else{je[c[76392]&1023](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){je[c[76392]&1023](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){je[c[76392]&1023](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{je[c[76392]&1023](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function fVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;je[c[76392]&1023](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function gVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;je[c[76392]&1023](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;je[c[76392]&1023](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function hVa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=_Ua(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=_Ua(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[76408]|0;c[76408]=0;p=(e|0)==0?4:e+2|0;e=$Ua(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{je[c[76392]&1023](32);f=f+1|0;}while((f|0)<(p|0))}c[76408]=o;n=e;i=j;return n|0}function iVa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{je[c[76392]&1023](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;je[c[76392]&1023](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;je[c[76392]&1023](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){je[c[76392]&1023](a[311384+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){je[c[76392]&1023](a[311384+((d[p]|0)>>>4)|0]|0);je[c[76392]&1023](a[311384+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function jVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 11:{f=kVa(c[a+8>>2]|0)|0;i=b;return f|0};case 12:{f=lVa(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=He[c[76400]&7]()|0;i=b;return f|0};case 4:case 14:{c[76404]=(c[76404]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 13:{g=(c[76404]|0)-(c[a+4>>2]|0)|0;h=0-(c[76402]|0)|0;c[76404]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 15:{c[76404]=(c[a+4>>2]|0)+ -1-(c[76402]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;Ad(f|0,311352,d|0)|0;nUa(c[76328]|0,1)}}return 0}function kVa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[76404]|0)!=0){e=cVa()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}je[c[76392]&1023](e<<24>>24);n=b}else{je[c[76392]&1023](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function lVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[76404]|0)!=0){f=cVa()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;je[c[76392]&1023](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function mVa(){var a=0,b=0;a=i;b=QUa(10)|0;c[76404]=0;c[76402]=0;c[76406]=0;i=a;return(b|0)==0|0}function nVa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[76378]|0)==0){zUa()}c[76342]=0;c[76348]=1;c[76356]=1;c[76366]=1;d=WUa(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[76384]=a;c[76402]=0;c[76404]=0;c[76406]=0;c[77656]=0;c[76408]=0;d=c[a+12>>2]|0;c[76328]=d;c[76380]=c[c[75102]>>2];if((CUa(d)|0)<0){if((c[a>>2]|0)==0){yUa(100,311432);e=100;i=b;return e|0}else{c[(Qc()|0)>>2]=100;e=100;i=b;return e|0}}c[76392]=662;c[76394]=45;c[76396]=112;c[76382]=4;c[76398]=5;c[76400]=6;HUa();c[76388]=0;d=c[75102]|0;c[76390]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((AUa(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Qc()|0;f=c[a>>2]|0;if(d){yUa(f,311440);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function oVa(){var a=0,b=0;a=i;if((c[77656]|0)==0){b=QUa(10)|0}else{QUa(0)|0;yd(c[76380]|0)|0;b=0}c[76404]=0;c[76402]=0;c[76406]=0;i=a;return b|0}function pVa(){var a=0,b=0,d=0;a=i;if((c[77640]|0)==0){b=0}else{d=QUa(10)|0;c[77640]=0;b=d}c[76404]=0;c[76402]=0;c[76406]=0;i=a;return b|0}function qVa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;MVa(312168,h,312224);c[77864]=313676;c[311464>>2]=313696;c[311460>>2]=0;DXa(311464|0,312168);c[311536>>2]=0;c[311540>>2]=-1;j=c[t>>2]|0;c[78068]=313544;l1a(312276|0);k=312280|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[78068]=312784;c[312304>>2]=j;m1a(g,312276|0);k=p1a(g,316336)|0;l=k;n1a(g);c[312308>>2]=l;c[312312>>2]=312232;a[312316|0]=(me[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[77886]=313756;c[311548>>2]=313776;DXa(311548|0,312272);c[311620>>2]=0;c[311624>>2]=-1;l=c[r>>2]|0;c[78080]=313544;l1a(312324|0);k=312328|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[78080]=312784;c[312352>>2]=l;m1a(f,312324|0);k=p1a(f,316336)|0;g=k;n1a(f);c[312356>>2]=g;c[312360>>2]=312240;a[312364|0]=(me[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[77908]=313756;c[311636>>2]=313776;DXa(311636|0,312320);c[311708>>2]=0;c[311712>>2]=-1;g=c[(c[(c[77908]|0)+ -12>>2]|0)+311656>>2]|0;c[77930]=313756;c[311724>>2]=313776;DXa(311724|0,g);c[311796>>2]=0;c[311800>>2]=-1;c[(c[(c[77864]|0)+ -12>>2]|0)+311528>>2]=311544;g=(c[(c[77908]|0)+ -12>>2]|0)+311636|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[77908]|0)+ -12>>2]|0)+311704>>2]=311544;yVa(312368,h,312248|0);c[77952]=313716;c[311816>>2]=313736;c[311812>>2]=0;DXa(311816|0,312368);c[311888>>2]=0;c[311892>>2]=-1;c[78106]=313608;l1a(312428|0);h=312432|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[78106]=312528;c[312456>>2]=j;m1a(e,312428|0);j=p1a(e,316344)|0;h=j;n1a(e);c[312460>>2]=h;c[312464>>2]=312256;a[312468|0]=(me[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[77974]=313796;c[311900>>2]=313816;DXa(311900|0,312424);c[311972>>2]=0;c[311976>>2]=-1;c[78118]=313608;l1a(312476|0);h=312480|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[78118]=312528;c[312504>>2]=l;m1a(d,312476|0);l=p1a(d,316344)|0;h=l;n1a(d);c[312508>>2]=h;c[312512>>2]=312264;a[312516|0]=(me[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[77996]=313796;c[311988>>2]=313816;DXa(311988|0,312472);c[312060>>2]=0;c[312064>>2]=-1;h=c[(c[(c[77996]|0)+ -12>>2]|0)+312008>>2]|0;c[78018]=313796;c[312076>>2]=313816;DXa(312076|0,h);c[312148>>2]=0;c[312152>>2]=-1;c[(c[(c[77952]|0)+ -12>>2]|0)+311880>>2]=311896;h=(c[(c[77996]|0)+ -12>>2]|0)+311988|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[77996]|0)+ -12>>2]|0)+312056>>2]=311896;i=b;return}function rVa(a){a=a|0;a=i;BYa(311544)|0;BYa(311720)|0;IYa(311896)|0;IYa(312072)|0;i=a;return}function sVa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);i=b;return}function tVa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);S4a(a);i=b;return}function uVa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;me[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=p1a(d,316344)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(me[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function vVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=De[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((yd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function wVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=uc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((Ce[c[(c[b>>2]|0)+52>>2]&127](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function xVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Le[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function yVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=313608;j=b+4|0;l1a(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=312640;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;m1a(g,j);j=p1a(g,316344)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=me[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(me[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){x0a(312736)}else{n1a(g);i=f;return}}function zVa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);i=b;return}function AVa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);S4a(a);i=b;return}function BVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=p1a(d,316344)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=me[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(me[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){x0a(312736)}else{i=e;return}}function CVa(a){a=a|0;var b=0,c=0;b=i;c=FVa(a,0)|0;i=b;return c|0}function DVa(a){a=a|0;var b=0,c=0;b=i;c=FVa(a,1)|0;i=b;return c|0}function EVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Le[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((ud(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function FVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=gd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Le[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=gd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((ud(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function GVa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);i=b;return}function HVa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);S4a(a);i=b;return}function IVa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;me[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=p1a(d,316336)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(me[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function JVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=De[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((uc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((yd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function KVa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=uc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((Ce[c[(c[b>>2]|0)+52>>2]&127](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function LVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((uc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Le[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((uc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((uc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function MVa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=313544;j=b+4|0;l1a(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=312896;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;m1a(g,j);j=p1a(g,316336)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=me[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(me[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){x0a(312736)}else{n1a(g);i=f;return}}function NVa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);i=b;return}function OVa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);S4a(a);i=b;return}function PVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=p1a(d,316336)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=me[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(me[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){x0a(312736)}else{i=e;return}}function QVa(a){a=a|0;var b=0,c=0;b=i;c=TVa(a,0)|0;i=b;return c|0}function RVa(a){a=a|0;var b=0,c=0;b=i;c=TVa(a,1)|0;i=b;return c|0}function SVa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Le[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((ud(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function TVa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=gd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Le[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=gd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((ud(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function UVa(){var a=0;a=i;qVa(0);be(663,312160,q|0)|0;i=a;return}function VVa(a){a=a|0;i=i;return}function WVa(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function XVa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}je[c[(c[a>>2]|0)+8>>2]&1023](a);f=1;i=b;return f|0}function YVa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=313040;e=m5a(b|0)|0;f=R4a(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;o5a(g|0,b|0,e+1|0)|0;i=d;return}function ZVa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=313040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}function _Va(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=313040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);i=b;return}function $Va(a){a=a|0;i=i;return c[a+4>>2]|0}function aWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=313064;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=m5a(f|0)|0;g=R4a(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;o5a(h|0,f|0,d+1|0)|0;i=e;return}function bWa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=313064;e=m5a(b|0)|0;f=R4a(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;o5a(g|0,b|0,e+1|0)|0;i=d;return}function cWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=313064;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}function dWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=313064;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);i=b;return}function eWa(a){a=a|0;i=i;return c[a+4>>2]|0}function fWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=313040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}function gWa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=313040;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}T4a((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;S4a(j);i=b;return}function hWa(a){a=a|0;i=i;return}function iWa(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function jWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Je[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function kWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function lWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=_d(e|0)|0;e=m5a(f|0)|0;if(e>>>0>4294967279){rWa(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;o5a(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=Q4a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;o5a(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function mWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{YWa(e,313280,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Je[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}YWa(e,o,p)|0;if((a[g]&1)==0){break}S4a(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function nWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=m5a(e|0)|0;if(j>>>0>4294967279){rWa(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Q4a(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}o5a(k|0,e|0,j|0)|0;a[k+j|0]=0;mWa(g,d,h);aWa(b,g);if(!((a[g]&1)==0)){S4a(c[g+8>>2]|0)}if(!((a[h]&1)==0)){S4a(c[h+8>>2]|0)}c[b>>2]=313296;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function oWa(a){a=a|0;var b=0;b=i;dWa(a);S4a(a);i=b;return}function pWa(a){a=a|0;var b=0;b=i;dWa(a);i=b;return}function qWa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;wc(313432)|0;if((c[a>>2]|0)==1){do{qd(313456,313432)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;ic(313432)|0;je[d&1023](b);wc(313432)|0;c[a>>2]=-1;ic(313432)|0;dd(313456)|0;i=e;return}else{ic(313432)|0;i=e;return}}function rWa(a){a=a|0;a=Hc(8)|0;YVa(a,313504);c[a>>2]=313120;Xd(a|0,313160,40)}function sWa(a){a=a|0;a=Hc(8)|0;YVa(a,313504);c[a>>2]=313184;Xd(a|0,313224,40)}function tWa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uWa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function vWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){rWa(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=Q4a(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}o5a(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function wWa(b){b=b|0;i=i;return(a[b]&1)!=0|0}function xWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){rWa(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=Q4a(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}o5a(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function yWa(a){a=a|0;i=i;return a|0}function zWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=m5a(d|0)|0;if(f>>>0>4294967279){rWa(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;o5a(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=Q4a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;o5a(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function AWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){rWa(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=Q4a(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}q5a(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function BWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){rWa(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;q5a(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=Q4a(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;q5a(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function CWa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){sWa(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){rWa(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;o5a(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=Q4a(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;o5a(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function DWa(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function EWa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function FWa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}S4a(c[b+8>>2]|0);i=d;return}function GWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}ZWa(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}p5a(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function HWa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=IWa(a,b)|0;i=c;return d|0}function IWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=m5a(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}ZWa(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}p5a(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function JWa(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function KWa(a){a=a|0;i=i;return a+1|0}function LWa(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function MWa(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function NWa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function OWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){PWa(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function PWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){_Wa(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}q5a(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function QWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){PWa(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function RWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){rWa(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=Q4a(f)|0}else{p=Q4a(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}o5a(l|0,n|0,q+1|0)|0;if(o){S4a(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function SWa(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function TWa(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function UWa(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function VWa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function WWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=YWa(b,g,h)|0;i=e;return d|0}function XWa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){_Wa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function YWa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){ZWa(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}o5a(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function ZWa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){rWa(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=Q4a(q)|0;if((g|0)!=0){o5a(e|0,m|0,g|0)|0}if((j|0)!=0){o5a(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){o5a(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){S4a(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function _Wa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){rWa(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=Q4a(p)|0;if((g|0)!=0){o5a(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){o5a(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}S4a(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function $Wa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;CWa(a,b,c,d,0);i=e;return}function aXa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function bXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=m5a(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function cXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=h5a(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function dXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=m5a(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){sWa(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=h5a(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function eXa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){rWa(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;o5a(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=Q4a(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;o5a(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function fXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){rWa(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=Q4a(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}l4a(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function gXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){rWa(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=Q4a(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}n4a(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function hXa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}S4a(c[b+8>>2]|0);i=d;return}function iXa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=jXa(a,b,k4a(b)|0)|0;i=c;return d|0}function jXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}mXa(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}m4a(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function kXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){rWa(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=Q4a(f)|0}else{p=Q4a(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}l4a(l,n,q+1|0)|0;if(o){S4a(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function lXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){nXa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function mXa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){rWa(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=Q4a(q<<2)|0;p=e;if((g|0)!=0){l4a(p,m,g)|0}if((j|0)!=0){l4a(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){l4a(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){S4a(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function nXa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){rWa(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=Q4a(p<<2)|0;o=e;if((g|0)!=0){l4a(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){l4a(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}S4a(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function oXa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=m5a(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){rWa(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=Q4a(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}o5a(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=YWa(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=YWa(b,m,j)|0;i=f;return}}function pXa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function qXa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function rXa(a,b){a=a|0;b=b|0;var c=0;c=i;sXa(a,b);i=c;return}function sXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Hc(16)|0;do{if((a[313888]|0)==0){if(($a(313888)|0)==0){break}c[78470]=314584;be(66,313880,q|0)|0;Vb(313888)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=313880;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];nWa(b,f,313936);c[e>>2]=313904;Xd(e|0,313984,62)}function tXa(a,b){a=a|0;b=b|0;var d=0;d=i;sXa(a,c[a+16>>2]|b);i=d;return}function uXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=313928;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Je[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}n1a(a+28|0);L4a(c[e>>2]|0);L4a(c[f>>2]|0);L4a(c[a+48>>2]|0);L4a(c[a+60>>2]|0);i=b;return}function vXa(a){a=a|0;var b=0;b=i;uXa(a);S4a(a);i=b;return}function wXa(a){a=a|0;var b=0;b=i;uXa(a);i=b;return}function xXa(a){a=a|0;var b=0;b=i;uXa(a);i=b;return}function yXa(a){a=a|0;i=i;return c[a+24>>2]|0}function zXa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}m1a(d,a+28|0);a=p1a(d,316272)|0;f=Ce[c[(c[a>>2]|0)+28>>2]&127](a,32)|0;n1a(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function AXa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;m1a(e,a+28|0);a=p1a(e,316272)|0;f=Ce[c[(c[a>>2]|0)+28>>2]&127](a,b)|0;n1a(e);i=d;return f|0}function BXa(a,b){a=a|0;b=b|0;var c=0;c=i;m1a(a,b+28|0);i=c;return}function CXa(a){a=a|0;c[a>>2]=313528;i=i;return}function DXa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));l1a(b);i=d;return}function EXa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);S4a(a);i=b;return}function FXa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);i=b;return}function GXa(a){a=a|0;var b=0;b=i;c[a>>2]=313544;n1a(a+4|0);i=b;return}function HXa(a,b){a=a|0;b=b|0;var c=0;c=i;m1a(a,b+4|0);i=c;return}function IXa(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=me[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function JXa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=Ce[c[(c[b>>2]|0)+52>>2]&127](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function KXa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=pe[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function LXa(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=313544;l1a(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function MXa(a){a=a|0;i=i;return c[a+8>>2]|0}function NXa(a){a=a|0;i=i;return c[a+12>>2]|0}function OXa(a){a=a|0;i=i;return c[a+16>>2]|0}function PXa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function QXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function RXa(a){a=a|0;i=i;return c[a+20>>2]|0}function SXa(a){a=a|0;i=i;return c[a+24>>2]|0}function TXa(a){a=a|0;i=i;return c[a+28>>2]|0}function UXa(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function VXa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function WXa(a,b){a=a|0;b=b|0;i=i;return}function XXa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function YXa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function ZXa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function _Xa(a){a=a|0;i=i;return 0}function $Xa(a){a=a|0;i=i;return 0}function aYa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=me[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function bYa(a){a=a|0;i=i;return-1}function cYa(a){a=a|0;var b=0,e=0,f=0;b=i;if((me[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function dYa(a,b){a=a|0;b=b|0;i=i;return-1}function eYa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((Ce[c[(c[b>>2]|0)+52>>2]&127](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function fYa(a,b){a=a|0;b=b|0;i=i;return-1}function gYa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);S4a(a);i=b;return}function hYa(a){a=a|0;var b=0;b=i;c[a>>2]=313608;n1a(a+4|0);i=b;return}function iYa(a,b){a=a|0;b=b|0;i=i;return}function jYa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function kYa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function lYa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function mYa(a){a=a|0;i=i;return 0}function nYa(a){a=a|0;i=i;return 0}function oYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=me[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function pYa(a){a=a|0;i=i;return-1}



function M_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[79066]|0)==-1)){c[m>>2]=316264;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316264,m,665)}m=(c[316268>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[79106]|0)==-1)){c[l>>2]=316424;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316424,l,665)}l=(c[316428>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}x=s;ke[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Me[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ce[c[(c[j>>2]|0)+44>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=Ce[c[(c[j>>2]|0)+44>>2]&127](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=Ce[c[(c[j>>2]|0)+44>>2]&127](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=me[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=Ce[c[(c[j>>2]|0)+44>>2]&127](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;FWa(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;FWa(n);i=k;return}function N_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((pe[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){gXa(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((pe[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){hXa(l);break}c[m>>2]=0;c[b>>2]=0;hXa(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((pe[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function O_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);w=c[79040]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=y_a(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;BXa(r,f);M_a(x,z,l,A,p,q,r);XVa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];N_a(b,k,A,e,p,f,g);i=d;return}function P_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=315064;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);v=c[79040]|0;c[k>>2]=h;h=y_a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;BXa(q,f);M_a(w,y,k,z,o,p,q);XVa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];N_a(b,j,z,e,o,f,g);i=d;return}function Q_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);w=c[79040]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=y_a(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;BXa(r,f);M_a(x,z,l,A,p,q,r);XVa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];N_a(b,k,A,e,p,f,g);i=d;return}function R_a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[316168]|0)==0;if(F){do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=E_a(s,r,z,n)|0}else{do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=E_a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}X4a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=K4a(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}X4a()}}while(0);BXa(w,f);S_a(N,L,G,P,u,v,w);XVa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];N_a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){L4a(O)}if((J|0)==0){i=d;return}L4a(J);i=d;return}function S_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[79066]|0)==-1)){c[m>>2]=316264;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316264,m,665)}m=(c[316268>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[79106]|0)==-1)){c[l>>2]=316424;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316424,l,665)}l=(c[316428>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}x=s;ke[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ce[c[(c[j>>2]|0)+44>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ce[c[(c[j>>2]|0)+44>>2]&127](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=Ce[c[(c[j>>2]|0)+44>>2]&127](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);w=A+1|0;if((_c(l<<24>>24|0,c[79040]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);l=D+1|0;if((Zd(A<<24>>24|0,c[79040]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Me[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=me[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=Ce[c[(c[j>>2]|0)+44>>2]&127](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=Ce[c[(c[j>>2]|0)+44>>2]&127](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=me[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Me[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;FWa(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;FWa(n);i=k;return}function T_a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[316168]|0)==0;if(F){do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=E_a(s,r,z,n)|0}else{do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=E_a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}X4a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=K4a(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}X4a()}}while(0);BXa(w,f);S_a(N,L,G,P,u,v,w);XVa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];N_a(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){L4a(O)}if((J|0)==0){i=d;return}L4a(J);i=d;return}function U_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=315072;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);s=c[79040]|0;c[k>>2]=h;h=y_a(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}BXa(p,f);u=p;p=c[u>>2]|0;if(!((c[79066]|0)==-1)){c[l>>2]=316264;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316264,l,665)}l=(c[316268>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}XVa(c[u>>2]|0)|0;u=o;Me[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];N_a(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];N_a(b,j,u,z,m,f,g);I=j;i=d;return}function V_a(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;BXa(r,h);v=r;r=c[v>>2]|0;if(!((c[79068]|0)==-1)){c[q>>2]=316272;c[q+4>>2]=664;c[q+8>>2]=0;qWa(316272,q,665)}q=(c[316276>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Hc(4)|0;y=x;p4a(y);z=331832;A=127;Xd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Hc(4)|0;y=x;p4a(y);z=331832;A=127;Xd(x|0,z|0,A|0)}A=r;XVa(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((me[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((me[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((pe[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(me[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=Ce[c[(c[r>>2]|0)+12>>2]&127](A,N)|0;if(H<<24>>24==(Ce[c[(c[r>>2]|0)+12>>2]&127](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=pe[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=pe[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];Be[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((me[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(me[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){me[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){me[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((me[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((me[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function W_a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function X_a(a){a=a|0;i=i;return}function Y_a(a){a=a|0;i=i;return 2}function Z_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];V_a(a,b,l,k,f,g,h,315176,315184|0);i=j;return}function __a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=me[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];V_a(b,d,m,l,g,h,j,s,q);i=k;return}function $_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79068]|0)==-1)){c[m>>2]=316272;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316272,m,665)}m=(c[316276>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}s=n;XVa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=me[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=wZa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function a$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79068]|0)==-1)){c[m>>2]=316272;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316272,m,665)}m=(c[316276>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}s=n;XVa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=me[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=wZa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function b$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;BXa(m,f);f=m;m=c[f>>2]|0;if(!((c[79068]|0)==-1)){c[l>>2]=316272;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316272,l,665)}l=(c[316276>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;p4a(p);q=331832;r=127;Xd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;p4a(p);q=331832;r=127;Xd(o|0,q|0,r|0)}r=m;XVa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=g$a(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function c$a(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;BXa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[79068]|0)==-1)){c[ba>>2]=316272;c[ba+4>>2]=664;c[ba+8>>2]=0;qWa(316272,ba,665)}ba=(c[316276>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;p4a(Ga);Ha=331832;Ia=127;Xd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;p4a(Ga);Ha=331832;Ia=127;Xd(Fa|0,Ha|0,Ia|0)}Ia=ca;XVa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];V_a(ua,d,v,u,g,h,j,315224,315232|0);c[Da>>2]=c[ua>>2];break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=me[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(wZa(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];V_a(oa,d,A,z,g,h,j,315200,315211|0);c[Da>>2]=c[oa>>2];break};case 88:{Da=d+8|0;Ha=me[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];ca=a[Ha]|0;if((ca&1)==0){Ja=Ha+1|0;Ka=Ha+1|0;La=(ca&255)>>>1}else{ca=c[Ha+8>>2]|0;Ja=ca;Ka=ca;La=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];V_a(za,d,q,p,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[za>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=g$a(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=g$a(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=g$a(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];V_a(ra,d,y,x,g,h,j,315216,315221|0);c[Ha>>2]=c[ra>>2];break};case 70:{Ha=e;c[ka>>2]=c[Ha>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];V_a(ja,d,J,I,g,h,j,315192,315200|0);c[Ha>>2]=c[ja>>2];break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ze[Ha&63](b,d,s,r,g,h,j);i=l;return};case 65:case 97:{Ha=c[f>>2]|0;Da=d+8|0;ca=me[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(wZa(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=g$a(e,G,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Da|4;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=g$a(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=g$a(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];f$a(0,e,m,h,Ia);break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];V_a(ga,d,L,K,g,h,j,315184,315192|0);c[Ha>>2]=c[ga>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];d$a(0,e,C,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Ha=g$a(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Ha|0)<69){Ma=Ha+2e3|0}else{Ma=(Ha+ -69|0)>>>0<31?Ha+1900|0:Ha}c[j+20>>2]=Ma+ -1900;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=g$a(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=g$a(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 99:{Ha=d+8|0;ca=me[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Na=ca+1|0;Oa=ca+1|0;Pa=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];V_a(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[Ha>>2]=c[da>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];e$a(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=g$a(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Ha>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function d$a(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((me[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(me[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){me[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((me[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((me[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function e$a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=me[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=wZa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function f$a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((me[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(me[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((pe[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){me[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function g$a(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((me[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(me[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(pe[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){me[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((me[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((me[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(me[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((pe[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){me[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((me[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function h$a(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;BXa(p,f);t=p;p=c[t>>2]|0;if(!((c[79066]|0)==-1)){c[o>>2]=316264;c[o+4>>2]=664;c[o+8>>2]=0;qWa(316264,o,665)}o=(c[316268>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}y=p;XVa(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((pe[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(pe[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=Ce[c[(c[p>>2]|0)+28>>2]&127](y,M)|0;if((C|0)==(Ce[c[(c[p>>2]|0)+28>>2]&127](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=pe[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=pe[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];Be[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(pe[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=me[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=me[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(pe[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){me[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=me[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=me[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function i$a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function j$a(a){a=a|0;i=i;return}function k$a(a){a=a|0;i=i;return 2}function l$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];h$a(a,b,l,k,f,g,h,315328,315360|0);i=j;return}function m$a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=me[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];h$a(b,d,m,l,g,h,j,s,q);i=k;return}function n$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79066]|0)==-1)){c[m>>2]=316264;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316264,m,665)}m=(c[316268>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}s=n;XVa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=me[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=VZa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function o$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79066]|0)==-1)){c[m>>2]=316264;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316264,m,665)}m=(c[316268>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}s=n;XVa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=me[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=VZa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function p$a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;BXa(m,f);f=m;m=c[f>>2]|0;if(!((c[79066]|0)==-1)){c[l>>2]=316264;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316264,l,665)}l=(c[316268>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Hc(4)|0;p=o;p4a(p);q=331832;r=127;Xd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Hc(4)|0;p=o;p4a(p);q=331832;r=127;Xd(o|0,q|0,r|0)}r=m;XVa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=u$a(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function q$a(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;BXa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[79066]|0)==-1)){c[ba>>2]=316264;c[ba+4>>2]=664;c[ba+8>>2]=0;qWa(316264,ba,665)}ba=(c[316268>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Hc(4)|0;Ga=Fa;p4a(Ga);Ha=331832;Ia=127;Xd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Hc(4)|0;Ga=Fa;p4a(Ga);Ha=331832;Ia=127;Xd(Fa|0,Ha|0,Ia|0)}Ia=ca;XVa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=u$a(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ze[ca&63](b,d,s,r,g,h,j);i=l;return};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=u$a(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];h$a(ua,d,v,u,g,h,j,315496,315528|0);c[Da>>2]=c[ua>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];h$a(oa,d,A,z,g,h,j,315424,315468|0);c[Da>>2]=c[oa>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=u$a(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=u$a(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=u$a(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];h$a(ra,d,y,x,g,h,j,315472,315492|0);c[Da>>2]=c[ra>>2];break};case 88:{Da=d+8|0;ca=me[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ja=Fa;Ka=Fa;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];h$a(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[za>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=u$a(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Fa=me[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(VZa(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];h$a(ja,d,J,I,g,h,j,315392,315424|0);c[ca>>2]=c[ja>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=u$a(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ma=ca+2e3|0}else{Ma=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ma+ -1900;break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];h$a(ga,d,L,K,g,h,j,315360,315392|0);c[ca>>2]=c[ga>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];r$a(0,e,C,h,Ia);break};case 99:{ca=d+8|0;Fa=me[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Da=a[Fa]|0;if((Da&1)==0){Na=Fa+4|0;Oa=Fa+4|0;Pa=(Da&255)>>>1}else{Da=c[Fa+8>>2]|0;Na=Da;Oa=Da;Pa=c[Fa+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];h$a(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[da>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];t$a(0,e,m,h,Ia);break};case 65:case 97:{ca=c[f>>2]|0;Fa=d+8|0;Da=me[c[c[Fa>>2]>>2]&127](Fa)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(VZa(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=u$a(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=u$a(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];s$a(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=u$a(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function r$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=me[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=me[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=me[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(pe[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){me[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=me[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=me[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function s$a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=me[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=VZa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function t$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=me[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=me[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=me[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((pe[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){me[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=me[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=me[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function u$a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=me[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=me[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=me[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(pe[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(pe[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){me[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=me[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=me[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(pe[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((pe[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){me[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=me[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function v$a(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);if((f|0)==(c[79040]|0)){g=b;S4a(g);i=d;return}dc(c[e>>2]|0);g=b;S4a(g);i=d;return}function w$a(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);if((b|0)==(c[79040]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function x$a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Vc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(Ce[c[(c[v>>2]|0)+52>>2]&127](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function y$a(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);if((f|0)==(c[79040]|0)){g=b;S4a(g);i=d;return}dc(c[e>>2]|0);g=b;S4a(g);i=d;return}function z$a(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);if((b|0)==(c[79040]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function A$a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;B$a(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=Ce[c[(c[q>>2]|0)+52>>2]&127](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function B$a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Vc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Oc(c[g>>2]|0)|0;g=N3a(d,m,n,l)|0;if((f|0)!=0){Oc(f|0)|0}if((g|0)==-1){x0a(317152)}else{c[e>>2]=d+(g<<2);i=j;return}}function C$a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function D$a(a){a=a|0;i=i;return}function E$a(a){a=a|0;i=i;return 127}function F$a(a){a=a|0;i=i;return 127}function G$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function H$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function I$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function J$a(a,b){a=a|0;b=b|0;b=i;BWa(a,1,45);i=b;return}function K$a(a){a=a|0;i=i;return 0}function L$a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function M$a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function N$a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function O$a(a){a=a|0;i=i;return}function P$a(a){a=a|0;i=i;return 127}function Q$a(a){a=a|0;i=i;return 127}function R$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function S$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function T$a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function U$a(a,b){a=a|0;b=b|0;b=i;BWa(a,1,45);i=b;return}function V$a(a){a=a|0;i=i;return 0}function W$a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function X$a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Y$a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function Z$a(a){a=a|0;i=i;return}function _$a(a){a=a|0;i=i;return 2147483647}function $$a(a){a=a|0;i=i;return 2147483647}function a0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function b0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function c0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function d0a(a,b){a=a|0;b=b|0;b=i;gXa(a,1,45);i=b;return}function e0a(a){a=a|0;i=i;return 0}function f0a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function g0a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function h0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function i0a(a){a=a|0;i=i;return}function j0a(a){a=a|0;i=i;return 2147483647}function k0a(a){a=a|0;i=i;return 2147483647}function l0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function m0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function n0a(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function o0a(a,b){a=a|0;b=b|0;b=i;gXa(a,1,45);i=b;return}function p0a(a){a=a|0;i=i;return 0}function q0a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function r0a(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function s0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function t0a(a){a=a|0;i=i;return}function u0a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=666;y=o+100|0;BXa(r,h);o=r;z=c[o>>2]|0;if(!((c[79068]|0)==-1)){c[n>>2]=316272;c[n+4>>2]=664;c[n+8>>2]=0;qWa(316272,n,665)}n=(c[316276>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=w0a(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Me[c[(c[z>>2]|0)+32>>2]&63](E,315888,315898|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=K4a(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}X4a()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[315888+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Bd(p|0,315904,m|0)|0)!=1){t=Hc(8)|0;bWa(t,315912);Xd(t|0,313264,42)}if((F|0)==0){break}L4a(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;XVa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}je[c[x>>2]&1023](o);i=d;return}function v0a(a){a=a|0;i=i;return}function w0a(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;A0a(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=666;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((me[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((me[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){me[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(me[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){me[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(me[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){me[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(me[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;oa=c[ea+12>>2]|0;if((oa|0)==(c[ea+16>>2]|0)){Ia=(me[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Ia=a[oa]|0}if(!(Ia<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){X=25;break a}oa=c[h>>2]|0;ea=oa+12|0;qa=c[ea>>2]|0;if((qa|0)==(c[oa+16>>2]|0)){Ja=(me[c[(c[oa>>2]|0)+40>>2]&127](oa)|0)&255}else{c[ea>>2]=qa+1;Ja=a[qa]|0}XWa(A,Ja);X=26;break};case 4:{qa=D;ea=R;oa=r;ra=Q;sa=0;pa=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((me[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((me[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(me[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(qa|0)){Ma=(c[P>>2]|0)!=666;Pa=c[t>>2]|0;Qa=qa-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=N4a(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}je[c[P>>2]&1023](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=641;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=qa}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=ea;Ya=oa;Za=ra;_a=sa+1|0;$a=pa}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(sa|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((oa|0)==(ra|0)){Ka=oa-ea|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((pa|0)==666){bb=0}else{bb=ea}Ma=N4a(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=641}else{cb=ea;db=oa;eb=ra;fb=pa}c[db>>2]=sa;Wa=qa;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){me[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}else{c[Ma>>2]=Ka+1;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}}if((ea|0)==(oa|0)|(sa|0)==0){gb=ea;hb=oa;ib=ra;jb=pa}else{if((oa|0)==(ra|0)){W=oa-ea|0;da=W>>>0<2147483647?W<<1:-1;if((pa|0)==666){kb=0}else{kb=ea}ba=N4a(kb,da)|0;if((ba|0)==0){X=209;break a}lb=ba;mb=ba+(W>>2<<2)|0;nb=ba+(da>>>2<<2)|0;ob=641}else{lb=ea;mb=oa;nb=ra;ob=pa}c[mb>>2]=sa;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){pb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){pb=da;break}if((me[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);da=(pb|0)==0;sa=c[e>>2]|0;do{if((sa|0)==0){X=223}else{if((c[sa+12>>2]|0)!=(c[sa+16>>2]|0)){if(da){qb=sa;break}else{X=229;break a}}if((me[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){qb=sa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{qb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){rb=(me[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{rb=a[pa]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){me[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;sb=qb;tb=qb;ub=qa}else{c[sa>>2]=ra+1;sb=qb;tb=qb;ub=qa}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){vb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){vb=ra;break}if((me[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ra=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ra){xb=sb;yb=tb;break}else{X=250;break a}}if((me[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ra^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{xb=wb;yb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){zb=(me[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{zb=a[pa]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}pa=c[o>>2]|0;if((pa|0)==(ub|0)){sa=(c[P>>2]|0)!=666;oa=c[t>>2]|0;ea=ub-oa|0;ba=ea>>>0<2147483647?ea<<1:-1;W=N4a(sa?oa:0,ba)|0;if((W|0)==0){X=253;break a}do{if(sa){c[t>>2]=W;Ab=W}else{oa=c[t>>2]|0;c[t>>2]=W;if((oa|0)==0){Ab=W;break}je[c[P>>2]&1023](oa);Ab=c[t>>2]|0}}while(0);c[P>>2]=641;W=Ab+ea|0;c[o>>2]=W;Bb=W;Cb=(c[t>>2]|0)+ba|0}else{Bb=pa;Cb=ub}W=c[h>>2]|0;sa=c[W+12>>2]|0;if((sa|0)==(c[W+16>>2]|0)){ra=(me[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255;Db=ra;Eb=c[o>>2]|0}else{Db=a[sa]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;sa=(c[B>>2]|0)+ -1|0;c[B>>2]=sa;ra=c[h>>2]|0;W=ra+12|0;oa=c[W>>2]|0;if((oa|0)==(c[ra+16>>2]|0)){me[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[W>>2]=oa+1}if((sa|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=qa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Fb;ha=gb;ia=hb;ja=ib;ka=S;la=jb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;sa=(da&1)==0;oa=sa?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=da;Kb=oa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}W=oa+(sa?(da&255)>>>1:c[K>>2]|0)|0;ra=oa;while(1){if((ra|0)==(W|0)){Lb=W;break}Ka=a[ra]|0;if(!(Ka<<24>>24>-1)){Lb=ra;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ra;break}else{ra=ra+1|0}}ra=Lb-oa|0;W=a[A]|0;pa=(W&1)==0;if(pa){Mb=(W&255)>>>1}else{Mb=c[N>>2]|0}if(ra>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}if(pa){pa=(W&255)>>>1;Nb=A+1+(pa-ra)|0;Ob=L;Pb=pa}else{pa=c[M>>2]|0;W=c[N>>2]|0;Nb=pa+(W-ra)|0;Ob=pa;Pb=W}W=Ob+Pb|0;if((Nb|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=oa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=da;Kb=oa;break d}pa=Rb+1|0;if((pa|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=Qb+1|0;Rb=pa}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Ub=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ub=da;break}if((me[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);da=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(da){Wb=Hb;Xb=Ib;break}else{break e}}if((me[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(da^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Wb=Vb;Xb=0}}oa=c[h>>2]|0;sa=c[oa+12>>2]|0;if((sa|0)==(c[oa+16>>2]|0)){Yb=(me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255}else{Yb=a[sa]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}sa=c[h>>2]|0;oa=sa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){me[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[oa>>2]=qa+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=a[x]|0;if((qa&1)==0){Zb=j;_b=(qa&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};case 0:{X=26;break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((me[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((me[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}da=c[h>>2]|0;qa=c[da+12>>2]|0;if((qa|0)==(c[da+16>>2]|0)){fc=(me[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{fc=a[qa]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}qa=c[h>>2]|0;da=qa+12|0;oa=c[da>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){gc=(me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0)&255}else{c[da>>2]=oa+1;gc=a[oa]|0}XWa(A,gc);$b=dc;ac=ec}}}while(0);oa=p+1|0;if(oa>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=oa;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){X4a()}else if((X|0)==198){X4a()}else if((X|0)==209){X4a()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){X4a()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((me[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((me[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(me[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){me[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;B0a(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);FWa(A);FWa(z);FWa(y);FWa(x);FWa(w);if((ic|0)==0){i=q;return hc|0}je[jc&1023](ic);i=q;return hc|0}function x0a(a){a=a|0;var b=0;b=Hc(8)|0;bWa(b,a);Xd(b|0,313264,42)}function y0a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=666;v=n+100|0;BXa(q,h);n=q;w=c[n>>2]|0;if(!((c[79068]|0)==-1)){c[m>>2]=316272;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316272,m,665)}m=(c[316276>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;p4a(z);A=331832;B=127;Xd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;p4a(z);A=331832;B=127;Xd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=w0a(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){XWa(k,Ce[c[(c[w>>2]|0)+28>>2]&127](B,45)|0)}r=Ce[c[(c[w>>2]|0)+28>>2]&127](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);z0a(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((me[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((me[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;XVa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}je[c[u>>2]&1023](n);i=d;return}function z0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){_Wa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function A0a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[78928]|0)==-1)){c[p>>2]=315712;c[p+4>>2]=664;c[p+8>>2]=0;qWa(315712,p,665)}p=(c[315716>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}E=b;ke[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ke[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;FWa(r);ke[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}RWa(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;FWa(s);a[f]=me[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=me[c[(c[b>>2]|0)+16>>2]&127](E)|0;ke[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}RWa(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;FWa(t);ke[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;FWa(u);F=me[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[78912]|0)==-1)){c[o>>2]=315648;c[o+4>>2]=664;c[o+8>>2]=0;qWa(315648,o,665)}o=(c[315652>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}J=E;ke[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ke[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;FWa(w);ke[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}RWa(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;FWa(x);a[f]=me[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=me[c[(c[E>>2]|0)+16>>2]&127](J)|0;ke[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}RWa(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FWa(y);ke[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;FWa(z);F=me[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function B0a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function C0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function D0a(a){a=a|0;i=i;return}function E0a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=666;y=o+400|0;BXa(r,h);o=r;z=c[o>>2]|0;if(!((c[79066]|0)==-1)){c[n>>2]=316264;c[n+4>>2]=664;c[n+8>>2]=0;qWa(316264,n,665)}n=(c[316268>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=F0a(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Me[c[(c[z>>2]|0)+48>>2]&63](E,315968,315978|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=K4a((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}X4a()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[315968+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Bd(p|0,315904,m|0)|0)!=1){t=Hc(8)|0;bWa(t,315912);Xd(t|0,313264,42)}if((F|0)==0){break}L4a(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=me[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=me[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];XVa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}je[c[x>>2]&1023](o);i=d;return}function F0a(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;I0a(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=666;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=me[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=me[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(pe[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=me[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=me[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=me[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){me[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 4:{P=M;R=r;na=L;oa=0;pa=O;f:while(1){qa=c[g>>2]|0;do{if((qa|0)==0){Ka=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){La=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{La=c[wa>>2]|0}if((La|0)==-1){c[g>>2]=0;Ka=1;break}else{Ka=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=188}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Ma=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ma=c[wa>>2]|0}if((Ma|0)==-1){c[b>>2]=0;T=188;break}else{if(Ka){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(Ka){break}}qa=c[g>>2]|0;wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Na=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Na=c[wa>>2]|0}if(pe[c[(c[l>>2]|0)+12>>2]&63](l,2048,Na)|0){wa=c[n>>2]|0;if((wa|0)==(c[q>>2]|0)){J0a(m,n,q);Oa=c[n>>2]|0}else{Oa=wa}c[n>>2]=Oa+4;c[Oa>>2]=Na;Pa=P;Qa=R;Ra=na;Sa=oa+1|0;Ta=pa}else{wa=a[w]|0;if((wa&1)==0){Ua=(wa&255)>>>1}else{Ua=c[K>>2]|0}if((Ua|0)==0|(oa|0)==0){break}if((Na|0)!=(c[v>>2]|0)){break}if((R|0)==(na|0)){wa=R-P|0;qa=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=666){Va=P}else{Va=0}va=N4a(Va,qa)|0;if((va|0)==0){T=206;break a}Wa=va;Xa=va+(wa>>2<<2)|0;Ya=va+(qa>>>2<<2)|0;Za=641}else{Wa=P;Xa=R;Ya=na;Za=pa}c[Xa>>2]=oa;Pa=Wa;Qa=Xa+4|0;Ra=Ya;Sa=0;Ta=Za}qa=c[g>>2]|0;va=qa+12|0;wa=c[va>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}else{c[va>>2]=wa+4;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}}if((P|0)==(R|0)|(oa|0)==0){_a=P;$a=R;ab=na;bb=pa}else{if((R|0)==(na|0)){wa=R-P|0;va=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=666){cb=P}else{cb=0}qa=N4a(cb,va)|0;if((qa|0)==0){T=217;break a}db=qa;eb=qa+(wa>>2<<2)|0;fb=qa+(va>>>2<<2)|0;gb=641}else{db=P;eb=R;fb=na;gb=pa}c[eb>>2]=oa;_a=db;$a=eb+4|0;ab=fb;bb=gb}va=c[B>>2]|0;if((va|0)>0){qa=c[g>>2]|0;do{if((qa|0)==0){hb=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){ib=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{ib=c[wa>>2]|0}if((ib|0)==-1){c[g>>2]=0;hb=1;break}else{hb=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=234}else{oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){jb=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{jb=c[oa>>2]|0}if((jb|0)==-1){c[b>>2]=0;T=234;break}else{if(hb){kb=qa;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(hb){T=240;break a}else{kb=0}}qa=c[g>>2]|0;oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){lb=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{lb=c[oa>>2]|0}if((lb|0)!=(c[u>>2]|0)){T=240;break a}oa=c[g>>2]|0;qa=oa+12|0;pa=c[qa>>2]|0;if((pa|0)==(c[oa+16>>2]|0)){me[c[(c[oa>>2]|0)+40>>2]&127](oa)|0;mb=kb;nb=va;ob=kb}else{c[qa>>2]=pa+4;mb=kb;nb=va;ob=kb}while(1){pa=c[g>>2]|0;do{if((pa|0)==0){pb=1}else{qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){qb=me[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{qb=c[qa>>2]|0}if((qb|0)==-1){c[g>>2]=0;pb=1;break}else{pb=(c[g>>2]|0)==0;break}}}while(0);do{if((ob|0)==0){rb=mb;T=257}else{pa=c[ob+12>>2]|0;if((pa|0)==(c[ob+16>>2]|0)){sb=me[c[(c[ob>>2]|0)+36>>2]&127](ob)|0}else{sb=c[pa>>2]|0}if((sb|0)==-1){c[b>>2]=0;rb=0;T=257;break}else{if(pb^(mb|0)==0){tb=mb;ub=mb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(pb){T=263;break a}else{tb=rb;ub=0}}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){vb=me[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{vb=c[qa>>2]|0}if(!(pe[c[(c[l>>2]|0)+12>>2]&63](l,2048,vb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){J0a(m,n,q)}qa=c[g>>2]|0;pa=c[qa+12>>2]|0;if((pa|0)==(c[qa+16>>2]|0)){wb=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{wb=c[pa>>2]|0}pa=c[n>>2]|0;c[n>>2]=pa+4;c[pa>>2]=wb;pa=nb+ -1|0;c[B>>2]=pa;qa=c[g>>2]|0;oa=qa+12|0;na=c[oa>>2]|0;if((na|0)==(c[qa+16>>2]|0)){me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=na+4}if((pa|0)>0){mb=tb;nb=pa;ob=ub}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=_a;aa=$a;ba=ab;ca=N;da=bb}break};case 0:{T=28;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}va=c[g>>2]|0;pa=c[va+12>>2]|0;if((pa|0)==(c[va+16>>2]|0)){xb=me[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{xb=c[pa>>2]|0}if(!(pe[c[(c[l>>2]|0)+12>>2]&63](l,8192,xb)|0)){T=27;break a}pa=c[g>>2]|0;va=pa+12|0;na=c[va>>2]|0;if((na|0)==(c[pa+16>>2]|0)){yb=me[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[va>>2]=na+4;yb=c[na>>2]|0}lXa(A,yb);T=28;break};case 3:{na=a[y]|0;va=(na&1)==0;if(va){zb=(na&255)>>>1}else{zb=c[D>>2]|0}pa=a[z]|0;oa=(pa&1)==0;if(oa){Ab=(pa&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(va){Bb=(na&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(oa){Cb=(pa&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}qa=c[g>>2]|0;R=c[qa+12>>2]|0;if((R|0)==(c[qa+16>>2]|0)){P=me[c[(c[qa>>2]|0)+36>>2]&127](qa)|0;Db=P;Eb=a[y]|0}else{Db=c[R>>2]|0;Eb=na}R=c[g>>2]|0;P=R+12|0;qa=c[P>>2]|0;wa=(qa|0)==(c[R+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if(wa){me[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=qa+4}P=a[y]|0;if((P&1)==0){Fb=(P&255)>>>1}else{Fb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Fb>>>0>1?y:N;da=O;break b}if(wa){Gb=me[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[qa>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}qa=c[g>>2]|0;R=qa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[R>>2]=wa+4}a[k]=1;wa=a[z]|0;if((wa&1)==0){Hb=(wa&255)>>>1}else{Hb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Hb>>>0>1?z:N;da=O;break b}}while(0);if(va){Ib=(na&255)>>>1}else{Ib=c[D>>2]|0}oa=c[g>>2]|0;wa=c[oa+12>>2]|0;R=(wa|0)==(c[oa+16>>2]|0);if((Ib|0)==0){if(R){qa=me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Jb=qa;Kb=a[z]|0}else{Jb=c[wa>>2]|0;Kb=pa}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}qa=c[g>>2]|0;P=qa+12|0;Lb=c[P>>2]|0;if((Lb|0)==(c[qa+16>>2]|0)){me[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[P>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Mb>>>0>1?z:N;da=O;break b}if(R){R=me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Nb=R;Ob=a[y]|0}else{Nb=c[wa>>2]|0;Ob=na}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}wa=c[g>>2]|0;R=wa+12|0;oa=c[R>>2]|0;if((oa|0)==(c[wa+16>>2]|0)){me[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[R>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){Pb=(oa&255)>>>1}else{Pb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Pb>>>0>1?y:N;da=O;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){oa=c[g>>2]|0;do{if((oa|0)==0){Sb=1}else{R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Tb=me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Tb=c[R>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{oa=c[Rb+12>>2]|0;if((oa|0)==(c[Rb+16>>2]|0)){Vb=me[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[oa>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Wb=Ub;Xb=0}}oa=c[g>>2]|0;R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Yb=me[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Yb=c[R>>2]|0}if(!(pe[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}R=c[g>>2]|0;oa=R+12|0;wa=c[oa>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Zb=me[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[oa>>2]=wa+4;Zb=c[wa>>2]|0}lXa(A,Zb);Qb=Wb;Rb=Xb}}}while(0);na=o+1|0;if(na>>>0<4){L=ba;r=aa;M=$;o=na;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){X4a()}else if((T|0)==217){X4a()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){bc=($&255)>>>1}else{bc=c[da>>2]|0}if(!(aa>>>0<bc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){cc=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){dc=me[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){ec=me[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=me[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=da}else{gc=c[ca>>2]|0}if((fc|0)!=(c[gc+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){me[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;B0a(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);hXa(A);hXa(z);hXa(y);hXa(x);FWa(w);if(($b|0)==0){i=p;return _b|0}je[ac&1023]($b);i=p;return _b|0}function G0a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=666;v=n+400|0;BXa(q,h);n=q;w=c[n>>2]|0;if(!((c[79066]|0)==-1)){c[m>>2]=316264;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316264,m,665)}m=(c[316268>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Hc(4)|0;z=y;p4a(z);A=331832;B=127;Xd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Hc(4)|0;z=y;p4a(z);A=331832;B=127;Xd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=F0a(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){lXa(k,Ce[c[(c[w>>2]|0)+44>>2]&127](B,45)|0)}r=Ce[c[(c[w>>2]|0)+44>>2]&127](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);H0a(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=me[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=me[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];XVa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}je[c[u>>2]&1023](n);i=d;return}function H0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){nXa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function I0a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[78960]|0)==-1)){c[p>>2]=315840;c[p+4>>2]=664;c[p+8>>2]=0;qWa(315840,p,665)}p=(c[315844>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Hc(4)|0;C=B;p4a(C);D=331832;E=127;Xd(B|0,D|0,E|0)}E=b;ke[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ke[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;hXa(r);ke[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}kXa(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;hXa(s);c[f>>2]=me[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=me[c[(c[b>>2]|0)+16>>2]&127](E)|0;ke[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}RWa(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;FWa(t);ke[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}kXa(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;hXa(u);F=me[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[78944]|0)==-1)){c[o>>2]=315776;c[o+4>>2]=664;c[o+8>>2]=0;qWa(315776,o,665)}o=(c[315780>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}J=E;ke[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ke[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;hXa(w);ke[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}kXa(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;hXa(x);c[f>>2]=me[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=me[c[(c[E>>2]|0)+16>>2]&127](J)|0;ke[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}RWa(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FWa(y);ke[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}kXa(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;hXa(z);F=me[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function J0a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=666;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=N4a(m,l)|0;m=a;if((a|0)==0){X4a()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}je[c[f>>2]&1023](a);n=c[h>>2]|0}}while(0);c[f>>2]=641;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function K0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function L0a(a){a=a|0;i=i;return}function M0a(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,316024,o|0)|0;do{if(s>>>0>99){do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=E_a(r,o,316024,n)|0;o=c[r>>2]|0;if((o|0)==0){X4a()}H=K4a(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}X4a()}else{I=0;J=0;K=q;L=s}}while(0);BXa(t,g);s=t;q=c[s>>2]|0;if(!((c[79068]|0)==-1)){c[p>>2]=316272;c[p+4>>2]=664;c[p+8>>2]=0;qWa(316272,p,665)}p=(c[316276>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Me[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;N0a(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=K4a(V)|0;if((T|0)!=0){W=T;X=T;break}X4a()}else{W=0;X=t}}while(0);O0a(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];cTa(b,m,X,e,D,g,j);if((W|0)!=0){L4a(W)}FWa(A);FWa(z);FWa(y);XVa(c[s>>2]|0)|0;if((J|0)!=0){L4a(J)}if((I|0)==0){i=d;return}L4a(I);i=d;return}



function qYa(a){a=a|0;var b=0,d=0,e=0;b=i;if((me[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function rYa(a,b){a=a|0;b=b|0;i=i;return-1}function sYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((Ce[c[(c[a>>2]|0)+52>>2]&127](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function tYa(a,b){a=a|0;b=b|0;i=i;return-1}function uYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));l1a(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function vYa(a){a=a|0;var b=0;b=i;uXa(a+8|0);S4a(a);i=b;return}function wYa(a){a=a|0;var b=0;b=i;uXa(a+8|0);i=b;return}function xYa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;uXa(a+(d+8)|0);S4a(a+d|0);i=b;return}function yYa(a){a=a|0;var b=0;b=i;uXa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function zYa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;AYa(a,b,c);i=d;return}function AYa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){sXa(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){BYa(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}m1a(h,e+(k+28)|0);k=p1a(h,316272)|0;n1a(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(me[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(me[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){me[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((me[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;sXa(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function BYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{BYa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((me[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;sXa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);QYa(e);i=d;return b|0}function CYa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function DYa(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Hb()}}function EYa(a){a=a|0;var b=0;b=i;uXa(a+8|0);S4a(a);i=b;return}function FYa(a){a=a|0;var b=0;b=i;uXa(a+8|0);i=b;return}function GYa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;uXa(a+(d+8)|0);S4a(a+d|0);i=b;return}function HYa(a){a=a|0;var b=0;b=i;uXa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function IYa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{IYa(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((me[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;sXa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);aZa(e);i=d;return b|0}function JYa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));l1a(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function KYa(a){a=a|0;var b=0;b=i;uXa(a+4|0);S4a(a);i=b;return}function LYa(a){a=a|0;var b=0;b=i;uXa(a+4|0);i=b;return}function MYa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;uXa(a+(d+4)|0);S4a(a+d|0);i=b;return}function NYa(a){a=a|0;var b=0;b=i;uXa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function OYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){BYa(g)|0}a[f]=1;i=e;return}function PYa(a){a=a|0;var b=0;b=i;QYa(a);i=b;return}function QYa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(fb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((me[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;sXa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function RYa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function SYa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=me[b&127](a)|0;i=c;return d|0}function TYa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){QYa(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{BYa(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;m1a(k,b+(p+28)|0);p=p1a(k,314992)|0;m=p;n1a(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){m1a(h,b+(k+28)|0);r=p1a(h,316272)|0;s=Ce[c[(c[r>>2]|0)+28>>2]&127](r,32)|0;n1a(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];te[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){QYa(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;sXa(b+l|0,c[b+(l+16)>>2]|5);QYa(j);i=e;return b|0}function UYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){QYa(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{BYa(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;QYa(f);i=e;return b|0}if((Ce[c[(c[g>>2]|0)+52>>2]&127](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{QYa(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;sXa(b+d|0,c[b+(d+16)>>2]|1);QYa(f);i=e;return b|0}function VYa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){QYa(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){BYa(k)|0}a[h]=1;if((e|0)==0){QYa(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((pe[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){QYa(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;sXa(b+e|0,c[b+(e+16)>>2]|1);QYa(g);i=f;return b|0}function WYa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;we[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function XYa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){QYa(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{BYa(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ne[l&127](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){QYa(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;sXa(b+f|0,c[b+(f+16)>>2]|4);QYa(h);i=e;return b|0}function YYa(a){a=a|0;var b=0;b=i;uXa(a+4|0);S4a(a);i=b;return}function ZYa(a){a=a|0;var b=0;b=i;uXa(a+4|0);i=b;return}function _Ya(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;uXa(a+(d+4)|0);S4a(a+d|0);i=b;return}function $Ya(a){a=a|0;var b=0;b=i;uXa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function aZa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(fb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((me[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;sXa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function bZa(a){a=a|0;i=i;return 313824}function cZa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){xWa(a,313840,35);i=d;return}else{lWa(a,b,c);i=d;return}}function dZa(a){a=a|0;i=i;return}function eZa(a){a=a|0;var b=0;b=i;pWa(a);S4a(a);i=b;return}function fZa(a){a=a|0;var b=0;b=i;pWa(a);i=b;return}function gZa(a){a=a|0;var b=0;b=i;uXa(a);S4a(a);i=b;return}function hZa(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function iZa(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function jZa(a){a=a|0;i=i;return}function kZa(a){a=a|0;i=i;return}function lZa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function mZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){rWa(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=Q4a(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function nZa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function oZa(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function pZa(a){a=a|0;i=i;return}function qZa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function rZa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){rWa(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=Q4a(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function sZa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function tZa(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function uZa(a){a=a|0;i=i;return}function vZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ze[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}BXa(u,g);m=u;u=c[m>>2]|0;if(!((c[79068]|0)==-1)){c[p>>2]=316272;c[p+4>>2]=664;c[p+8>>2]=0;qWa(316272,p,665)}p=(c[316276>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}F=u;XVa(c[m>>2]|0)|0;BXa(v,g);g=v;v=c[g>>2]|0;if(!((c[79104]|0)==-1)){c[o>>2]=316416;c[o+4>>2]=664;c[o+8>>2]=0;qWa(316416,o,665)}o=(c[316420>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}J=v;XVa(c[g>>2]|0)|0;g=w;ke[c[(c[v>>2]|0)+24>>2]&255](g,J);ke[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=wZa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];FWa(w+12|0);FWa(w);i=k;return}function wZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=K4a(l)|0;if((n|0)!=0){o=n;p=n;break}X4a()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((me[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((me[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(me[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=Ce[c[(c[g>>2]|0)+12>>2]&127](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(Ce[c[(c[g>>2]|0)+12>>2]&127](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){me[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((me[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}L4a(o);i=k;return _|0}function xZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];yZa(a,0,k,j,f,g,h);i=b;return}function yZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;o_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}OWa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}OWa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(me[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((QZa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=k3a(F,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((me[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}function zZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];AZa(a,0,k,j,f,g,h);i=b;return}function AZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;o_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}OWa(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}OWa(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(me[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((QZa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=j3a(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((me[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}function BZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CZa(a,0,k,j,f,g,h);i=b;return}function CZa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;o_a(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((me[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((me[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}OWa(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}OWa(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(me[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((QZa(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){me[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=i3a(G,c[p>>2]|0,j,u)|0;B0a(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;FWa(o);FWa(n);i=e;return}if((me[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;FWa(o);FWa(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;FWa(o);FWa(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;FWa(o);FWa(n);i=e;return}function DZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EZa(a,0,k,j,f,g,h);i=b;return}function EZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;o_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}OWa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}OWa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(me[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((QZa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=h3a(F,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((me[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}function FZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GZa(a,0,k,j,f,g,h);i=b;return}function GZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;o_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}OWa(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}OWa(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(me[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((QZa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=g3a(F,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((me[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;FWa(n);FWa(m);i=d;return}function HZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];IZa(a,0,k,j,f,g,h);i=b;return}function IZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;o_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((me[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((me[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}OWa(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}OWa(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(me[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((QZa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=f3a(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((me[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;FWa(n);FWa(m);i=d;return}function JZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];KZa(a,0,k,j,f,g,h);i=b;return}function KZa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;p_a(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((me[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}OWa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}OWa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(me[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((q_a(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+e3a(I,c[p>>2]|0,j);B0a(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((me[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}if((me[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}function LZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];MZa(a,0,k,j,f,g,h);i=b;return}function MZa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;p_a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((me[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}OWa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}OWa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(me[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((q_a(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+d3a(I,c[p>>2]|0,j);B0a(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((me[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}if((me[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}function NZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OZa(a,0,k,j,f,g,h);i=b;return}function OZa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;p_a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((me[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((me[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}OWa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}OWa(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(me[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((q_a(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+c3a(I,c[p>>2]|0,j);B0a(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((me[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}if((me[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;FWa(o);FWa(n);i=d;return}function PZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;BXa(o,g);g=o;o=c[g>>2]|0;if(!((c[79068]|0)==-1)){c[l>>2]=316272;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316272,l,665)}l=(c[316276>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}y=m;Me[c[(c[o>>2]|0)+32>>2]&63](o,314816,314842|0,y)|0;XVa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((me[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((me[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}OWa(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}OWa(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(me[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((QZa(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){me[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);K=c[79040]|0;c[k>>2]=j;if((RZa(E,K,314856,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((me[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;FWa(p);FWa(n);i=d;return}if((me[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;FWa(p);FWa(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;FWa(p);FWa(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;FWa(p);FWa(n);i=d;return}function QZa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[314816+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[314816+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function RZa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=Za(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function SZa(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function TZa(a){a=a|0;i=i;return}function UZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ze[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}BXa(u,g);m=u;u=c[m>>2]|0;if(!((c[79066]|0)==-1)){c[p>>2]=316264;c[p+4>>2]=664;c[p+8>>2]=0;qWa(316264,p,665)}p=(c[316268>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}F=u;XVa(c[m>>2]|0)|0;BXa(v,g);g=v;v=c[g>>2]|0;if(!((c[79106]|0)==-1)){c[o>>2]=316424;c[o+4>>2]=664;c[o+8>>2]=0;qWa(316424,o,665)}o=(c[316428>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Hc(4)|0;H=G;p4a(H);I=331832;J=127;Xd(G|0,I|0,J|0)}J=v;XVa(c[g>>2]|0)|0;g=w;ke[c[(c[v>>2]|0)+24>>2]&255](g,J);ke[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=VZa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];hXa(w+12|0);hXa(w);i=k;return}function VZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=K4a(l)|0;if((n|0)!=0){o=n;p=n;break}X4a()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=me[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=me[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=Ce[c[(c[g>>2]|0)+28>>2]&127](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(Ce[c[(c[g>>2]|0)+28>>2]&127](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){me[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}L4a(o);i=k;return ba|0}function WZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XZa(a,0,k,j,f,g,h);i=b;return}function XZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;r_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=me[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=me[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}OWa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}OWa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((n_a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=k3a(I,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=me[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}function YZa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZZa(a,0,k,j,f,g,h);i=b;return}function ZZa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;r_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=me[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=me[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}OWa(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}OWa(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((n_a(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=j3a(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=me[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}function _Za(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$Za(a,0,k,j,f,g,h);i=b;return}function $Za(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;r_a(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=me[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=me[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}OWa(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}OWa(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=me[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((n_a(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){me[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=i3a(J,c[p>>2]|0,j,u)|0;B0a(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=me[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=me[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;FWa(o);FWa(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;FWa(o);FWa(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;FWa(o);FWa(n);i=e;return}function a_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];b_a(a,0,k,j,f,g,h);i=b;return}function b_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;r_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=me[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=me[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}OWa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}OWa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((n_a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=h3a(I,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=me[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}function c_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];d_a(a,0,k,j,f,g,h);i=b;return}function d_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;r_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=me[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=me[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}OWa(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}OWa(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((n_a(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=g3a(I,c[o>>2]|0,h,t)|0;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=me[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;FWa(n);FWa(m);i=d;return}function e_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];f_a(a,0,k,j,f,g,h);i=b;return}function f_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;r_a(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=me[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=me[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}OWa(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}OWa(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((n_a(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){me[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=f3a(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;B0a(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=me[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=me[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;FWa(n);FWa(m);i=d;return}function g_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];h_a(a,0,k,j,f,g,h);i=b;return}function h_a(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;s_a(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=me[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=me[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}OWa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}OWa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((t_a(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+e3a(L,c[p>>2]|0,j);B0a(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=me[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}function i_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];j_a(a,0,k,j,f,g,h);i=b;return}function j_a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;s_a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=me[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=me[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}OWa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}OWa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((t_a(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+d3a(L,c[p>>2]|0,j);B0a(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=me[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}function k_a(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];l_a(a,0,k,j,f,g,h);i=b;return}function l_a(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;s_a(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=me[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=me[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}OWa(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}OWa(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((t_a(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){me[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+c3a(L,c[p>>2]|0,j);B0a(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=me[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=me[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;FWa(o);FWa(n);i=d;return}function m_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;BXa(o,g);g=o;o=c[g>>2]|0;if(!((c[79066]|0)==-1)){c[l>>2]=316264;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316264,l,665)}l=(c[316268>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}y=m;Me[c[(c[o>>2]|0)+48>>2]&63](o,314816,314842|0,y)|0;XVa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;OWa(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=me[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=me[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}OWa(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}OWa(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=me[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((n_a(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){me[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);N=c[79040]|0;c[k>>2]=j;if((RZa(H,N,314856,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=me[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=me[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;FWa(p);FWa(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;FWa(p);FWa(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;FWa(p);FWa(n);i=d;return}function n_a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[314816+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[314816+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function o_a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;BXa(k,d);d=k;k=c[d>>2]|0;if(!((c[79068]|0)==-1)){c[j>>2]=316272;c[j+4>>2]=664;c[j+8>>2]=0;qWa(316272,j,665)}j=(c[316276>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;p4a(n);o=331832;p=127;Xd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;p4a(n);o=331832;p=127;Xd(m|0,o|0,p|0)}Me[c[(c[k>>2]|0)+32>>2]&63](k,314816,314842|0,e)|0;e=c[d>>2]|0;if(!((c[79104]|0)==-1)){c[h>>2]=316416;c[h+4>>2]=664;c[h+8>>2]=0;qWa(316416,h,665)}h=(c[316420>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}else{t=e;a[f]=me[c[(c[e>>2]|0)+16>>2]&127](t)|0;ke[c[(c[e>>2]|0)+20>>2]&255](b,t);XVa(c[d>>2]|0)|0;i=g;return}}function p_a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;BXa(l,d);d=l;l=c[d>>2]|0;if(!((c[79068]|0)==-1)){c[k>>2]=316272;c[k+4>>2]=664;c[k+8>>2]=0;qWa(316272,k,665)}k=(c[316276>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Hc(4)|0;o=n;p4a(o);p=331832;q=127;Xd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Hc(4)|0;o=n;p4a(o);p=331832;q=127;Xd(n|0,p|0,q|0)}Me[c[(c[l>>2]|0)+32>>2]&63](l,314816,314848|0,e)|0;e=c[d>>2]|0;if(!((c[79104]|0)==-1)){c[j>>2]=316416;c[j+4>>2]=664;c[j+8>>2]=0;qWa(316416,j,665)}j=(c[316420>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Hc(4)|0;s=r;p4a(s);t=331832;u=127;Xd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Hc(4)|0;s=r;p4a(s);t=331832;u=127;Xd(r|0,t|0,u|0)}else{u=e;a[f]=me[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=me[c[(c[e>>2]|0)+16>>2]&127](u)|0;ke[c[(c[e>>2]|0)+20>>2]&255](b,u);XVa(c[d>>2]|0)|0;i=h;return}}function q_a(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[314816+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function r_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;BXa(j,b);b=j;j=c[b>>2]|0;if(!((c[79066]|0)==-1)){c[h>>2]=316264;c[h+4>>2]=664;c[h+8>>2]=0;qWa(316264,h,665)}h=(c[316268>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Hc(4)|0;m=l;p4a(m);n=331832;o=127;Xd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Hc(4)|0;m=l;p4a(m);n=331832;o=127;Xd(l|0,n|0,o|0)}Me[c[(c[j>>2]|0)+48>>2]&63](j,314816,314842|0,d)|0;d=c[b>>2]|0;if(!((c[79106]|0)==-1)){c[g>>2]=316424;c[g+4>>2]=664;c[g+8>>2]=0;qWa(316424,g,665)}g=(c[316428>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Hc(4)|0;q=p;p4a(q);r=331832;s=127;Xd(p|0,r|0,s|0)}else{s=d;c[e>>2]=me[c[(c[d>>2]|0)+16>>2]&127](s)|0;ke[c[(c[d>>2]|0)+20>>2]&255](a,s);XVa(c[b>>2]|0)|0;i=f;return}}function s_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;BXa(k,b);b=k;k=c[b>>2]|0;if(!((c[79066]|0)==-1)){c[j>>2]=316264;c[j+4>>2]=664;c[j+8>>2]=0;qWa(316264,j,665)}j=(c[316268>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Hc(4)|0;n=m;p4a(n);o=331832;p=127;Xd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Hc(4)|0;n=m;p4a(n);o=331832;p=127;Xd(m|0,o|0,p|0)}Me[c[(c[k>>2]|0)+48>>2]&63](k,314816,314848|0,d)|0;d=c[b>>2]|0;if(!((c[79106]|0)==-1)){c[h>>2]=316424;c[h+4>>2]=664;c[h+8>>2]=0;qWa(316424,h,665)}h=(c[316428>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}else{t=d;c[e>>2]=me[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=me[c[(c[d>>2]|0)+16>>2]&127](t)|0;ke[c[(c[d>>2]|0)+20>>2]&255](a,t);XVa(c[b>>2]|0)|0;i=g;return}}function t_a(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[314816+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function u_a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function v_a(a){a=a|0;i=i;return}function w_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];we[p&31](b,d,k,f,g,q);i=j;return}BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79104]|0)==-1)){c[l>>2]=316416;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316416,l,665)}l=(c[316420>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}w=n;XVa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ke[c[f+24>>2]&255](o,w)}else{ke[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((Ce[c[(c[n>>2]|0)+52>>2]&127](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];FWa(o);i=j;return}function x_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=315064;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);x=c[79040]|0;c[k>>2]=h;h=y_a(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;BXa(q,f);z_a(w,y,k,z,o,p,q);XVa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];cTa(b,j,z,e,o,f,g);i=d;return}function y_a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Oc(d|0)|0;d=ad(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Oc(f|0)|0;i=g;return d|0}function z_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[79068]|0)==-1)){c[m>>2]=316272;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316272,m,665)}m=(c[316276>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[79104]|0)==-1)){c[l>>2]=316416;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316416,l,665)}l=(c[316420>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}x=s;ke[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Me[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ce[c[(c[j>>2]|0)+28>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=Ce[c[(c[j>>2]|0)+28>>2]&127](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=Ce[c[(c[j>>2]|0)+28>>2]&127](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=me[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=Ce[c[(c[j>>2]|0)+28>>2]&127](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;FWa(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;FWa(n);i=k;return}}function A_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);y=c[79040]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=y_a(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;BXa(r,f);z_a(x,z,l,A,p,q,r);XVa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];cTa(b,k,A,e,p,f,g);i=d;return}function B_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=315064;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);v=c[79040]|0;c[k>>2]=h;h=y_a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;BXa(q,f);z_a(w,y,k,z,o,p,q);XVa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];cTa(b,j,z,e,o,f,g);i=d;return}function C_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);w=c[79040]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=y_a(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;BXa(r,f);z_a(x,z,l,A,p,q,r);XVa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];cTa(b,k,A,e,p,f,g);i=d;return}function D_a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[316168]|0)==0;if(F){do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=E_a(s,r,z,n)|0}else{do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=E_a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}X4a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=K4a(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}X4a()}}while(0);BXa(w,f);F_a(N,L,G,P,u,v,w);XVa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];cTa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){L4a(O)}if((J|0)==0){i=d;return}L4a(J);i=d;return}function E_a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Oc(b|0)|0;b=mc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Oc(e|0)|0;i=f;return b|0}function F_a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[79068]|0)==-1)){c[m>>2]=316272;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316272,m,665)}m=(c[316276>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Hc(4)|0;r=q;p4a(r);s=331832;t=127;Xd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[79104]|0)==-1)){c[l>>2]=316416;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316416,l,665)}l=(c[316420>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Hc(4)|0;v=u;p4a(v);w=331832;x=127;Xd(u|0,w|0,x|0)}x=s;ke[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ce[c[(c[j>>2]|0)+28>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ce[c[(c[j>>2]|0)+28>>2]&127](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=Ce[c[(c[j>>2]|0)+28>>2]&127](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);w=A+1|0;if((_c(l<<24>>24|0,c[79040]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);l=D+1|0;if((Zd(A<<24>>24|0,c[79040]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Me[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=me[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=Ce[c[(c[j>>2]|0)+28>>2]&127](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=Ce[c[(c[j>>2]|0)+28>>2]&127](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=me[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Me[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;FWa(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;FWa(n);i=k;return}function G_a(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=y_a(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[316168]|0)==0;if(F){do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);r=c[79040]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=E_a(s,r,z,n)|0}else{do{if(o){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=E_a(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}X4a()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=K4a(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}X4a()}}while(0);BXa(w,f);F_a(N,L,G,P,u,v,w);XVa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];cTa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){L4a(O)}if((J|0)==0){i=d;return}L4a(J);i=d;return}function H_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=315072;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);s=c[79040]|0;c[k>>2]=h;h=y_a(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;BXa(p,f);r=p;p=c[r>>2]|0;if(!((c[79068]|0)==-1)){c[l>>2]=316272;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316272,l,665)}l=(c[316276>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Hc(4)|0;w=v;p4a(w);x=331832;y=127;Xd(v|0,x|0,y|0)}XVa(c[r>>2]|0)|0;Me[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];cTa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];cTa(b,j,u,z,m,f,g);I=j;i=d;return}function I_a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function J_a(a){a=a|0;i=i;return}function K_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];we[p&31](b,d,k,f,g,q);i=j;return}BXa(n,f);f=n;n=c[f>>2]|0;if(!((c[79106]|0)==-1)){c[l>>2]=316424;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316424,l,665)}l=(c[316428>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}w=n;XVa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ke[c[f+24>>2]&255](o,w)}else{ke[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=Ce[c[(c[h>>2]|0)+52>>2]&127](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];hXa(o);i=j;return}function L_a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=315064;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);v=c[79040]|0;c[k>>2]=h;h=y_a(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;BXa(q,f);M_a(w,y,k,z,o,p,q);XVa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];N_a(b,j,z,e,o,f,g);i=d;return}



function JAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=sAa(e,a)|0;h=g;i=f;return h|0}}return 0}function KAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=sAa(e,a)|0}i=f;return g|0}function LAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else{g=sAa(e,a)|0}i=f;return g|0}function MAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=sAa(e,a)|0}i=f;return g|0}function NAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((Me[k&63](l,m,n,c[239144+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((Me[k&63](l,m,n,239088)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=sAa(h,a)|0;q=p;i=g;return q|0}function OAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,239248)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,239256)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,239272)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function PAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=sAa(e,a)|0}i=f;return g|0}function QAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=sAa(e,a)|0}i=f;return g|0}function RAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=sAa(e,a)|0}i=f;return g|0}function SAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=sAa(e,a)|0}i=f;return g|0}function TAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else{g=sAa(e,a)|0}i=f;return g|0}function UAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=sAa(e,a)|0}i=f;return g|0}function VAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=sAa(e,a)|0}i=f;return g|0}function WAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Me[c[e+28>>2]&63](e,b,d,239104)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b,d,239112)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function XAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=sAa(e,a)|0}i=f;return g|0}function YAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=sAa(e,a)|0}i=f;return g|0}function ZAa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Me[c[e+28>>2]&63](e,b,d,239280)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function _Aa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=sAa(e,a)|0}i=f;return g|0}function $Aa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Me[c[e+28>>2]&63](e,b,d,239104)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b,d,239112)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function aBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=sAa(e,a)|0}i=f;return g|0}function bBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=sAa(e,a)|0}i=f;return g|0}function cBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=sAa(e,a)|0;h=g;i=f;return h|0}return 0}function dBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=sAa(e,a)|0;h=g;i=f;return h|0}return 0}function eBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=sAa(e,a)|0}i=f;return g|0}function fBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((Me[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,239304)|0)==0){j=9;break a}c[h>>2]=15;k=3;break};case 13:{k=56;break};case 11:{k=55;break};case 15:{k=0;break};case 14:{k=0;break};case 29:{c[h>>2]=16;k=2;break};default:{j=9}}}while(0);if((j|0)==9){k=sAa(h,a)|0}i=g;return k|0}function gBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=sAa(e,a)|0}i=f;return g|0}function hBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Me[c[e+28>>2]&63](e,b,d,239104)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Me[c[e+28>>2]&63](e,b,d,239112)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=sAa(h,a)|0;k=j;i=g;return k|0}function iBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=sAa(e,a)|0}i=f;return g|0}function jBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=sAa(e,a)|0}i=f;return g|0}function kBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else{g=sAa(e,a)|0}i=f;return g|0}function lBa(){i=i;return}function mBa(){i=i;return}function nBa(){var a=0;a=i;Ya(239312,0)|0;i=a;return}function oBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;uc(239320,29,1,e|0)|0;yd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;uc(239352,54,1,g|0)|0;yd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;uc(239408,47,1,a|0)|0;yd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;Ad(k|0,239456,d|0)|0;yd(k|0)|0;f=0;i=b;return f|0}function pBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;Ad(j|0,239544,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;Ad(n|0,239576,e|0)|0;k=0;i=d;return k|0}function qBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function rBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=qCa(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function sBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=qCa(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function tBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((oBa(a)|0)==0){eb(239624,239520,262,239648)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=qCa(e)|0;c[b+4>>2]=g;if((g|0)==0){eb(239672,239520,266,239648)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function uBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[72852]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=239696;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ne[p&127](0,f,239720,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function vBa(a,b){a=a|0;b=b|0;var d=0;d=i;if((oBa(a)|0)==0){eb(239776,239520,347,239800)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);eb(239832,239520,348,239800);return 0}function wBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((oBa(a)|0)==0){eb(239624,239520,355,239864)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=qCa(e)|0;c[b+4>>2]=g;if((g|0)==0){eb(239672,239520,359,239864)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(b+~a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function xBa(a,b){a=a|0;b=b|0;var c=0;c=i;rBa(a,b,pCa(b)|0);i=c;return}function yBa(b,c,d){b=b|0;c=c|0;d=d|0;a[b+c|0]=d;i=i;return}function zBa(a,b){a=a|0;b=b|0;i=i;return a+b|0}function ABa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;yBa(c[d+8>>2]|0,b,a);i=e;return}function BBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;xBa(a,b);g=f;c[f>>2]=d;if((b|0)>0){h=0}else{i=e;return}do{d=c[g>>2]|0;f=c[d>>2]|0;c[g>>2]=d+4;ABa(f&255,h,a);h=h+1|0;}while((h|0)<(b|0));i=e;return}function CBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=uBa(a,b,f)|0;f=zBa(c[a+8>>2]|0,d)|0;i=e;return f|0}function DBa(){var a=0,b=0,d=0;a=i;b=241608|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=241720|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=241832|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[241612>>2]=1;c[241616>>2]=1;i=a;return}function EBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?241968:241984;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;Ad(a|0,241944,e|0)|0;i=d;return}function FBa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=241832+(d<<2)|0;o=241720+(d<<2)|0;p=242032+(b<<2)|0;q=240312+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=242016;jc(242e3,l|0)|0;s=242016}else{if((c[60398]|0)==(d|0)){if((c[o>>2]|0)>0){t=242016}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;jc(242e3,m|0)|0;do{if((c[60398]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=242016;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;jc(242024,k|0)|0;c[n>>2]=b;c[60398]=d;if((c[o>>2]|0)>0){g=0;while(1){jc(242056,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;vb(e|0)|0;r=0;e=e+(w+1)|0;f=1}vb(e|0)|0;yd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function GBa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[242032+(a<<2)>>2]|0;c[j>>2]=c[240312+(b<<2)>>2];c[j+4>>2]=k;jc(242064,j|0)|0;HBa(e);if((g|0)==0){Od(((d|0)!=0?242104:242152)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=yd(m|0)|0;i=f;return}vb(242232)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];jc(242112,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=yd(m|0)|0;i=f;return}uc(242136,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=yd(m|0)|0;i=f;return}function HBa(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==60){uc(242184,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){uc(242176,5,1,e|0)|0}else if(b<<24>>24==62){uc(242192,4,1,e|0)|0}else{Wd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function IBa(a){a=a|0;var b=0;b=241720+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function JBa(a){a=a|0;var b=0;b=(a|0)==0;c[60542]=b?1:19;c[60540]=b?7:642;i=i;return}function KBa(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;uc(242136,11,1,b|0)|0;yd(b|0)|0;i=a;return}function LBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[241608+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;ad(j|0,2048,e|0,h|0)|0;we[c[60542]&31](1,a,b,j,0,d);i=g;return}function MBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[241608+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;ad(h|0,2048,d|0,g|0)|0;we[c[60542]&31](1,a,b,h,0,0);i=f;return}function NBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[60400]|0)==0){if((c[241608+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;ad(k|0,2048,e|0,j|0)|0;we[c[60542]&31](2,a,b,k,0,d);i=g;return}function OBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[60400]|0)==0){if((c[241608+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;ad(j|0,2048,d|0,h|0)|0;we[c[60542]&31](2,a,b,j,0,0);i=f;return}function PBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;ad(b|0,2048,d|0,g|0)|0;we[c[60542]&31](4,2,0,b,0,0);if((a|0)==0){h=pd(c[59828]|0)|0}else{h=a}gb(c[h+76>>2]|0,1)}function QBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;ad(g|0,2048,b|0,f|0)|0;we[c[60542]&31](5,2,0,g,0,0);if((a|0)==0){h=pd(c[59828]|0)|0}else{h=a}gb(c[h+76>>2]|0,1)}function RBa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;ad(h|0,2048,d|0,g|0)|0;we[c[60542]&31](5,2,0,h,0,b);if((a|0)==0){j=pd(c[59828]|0)|0}else{j=a}gb(c[j+76>>2]|0,1)}function SBa(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;RBa(a,e,242304,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;NBa(26,0,e,242240,m);i=j;return+b}return 0.0}function TBa(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function UBa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=oCa(sBa(a,b,f)|0)|0;i=e;return}function VBa(a){a=a|0;var b=0;b=i;c[a+8>>2]=oCa(qBa(a)|0)|0;i=b;return}function WBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((oBa(a)|0)==0){eb(242352,242376,126,242400)}if((oBa(b)|0)==0){eb(242424,242376,127,242400)}if((pBa(a,b)|0)==0){eb(242448,242376,128,242400)}e=XBa(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=TBa(a,b)|0;YBa(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function XBa(a){a=a|0;var b=0,c=0;b=i;c=qBa(a)|0;i=b;return c|0}function YBa(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function ZBa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=c[a>>2]|0;if((e|0)==2){if((c[b>>2]|0)!=2){f=242488;g=f;h=242376;j=h;k=242520;l=k;eb(g|0,j|0,1323,l|0)}m=c[a+4>>2]|0;n=c[m>>2]|0;o=c[m+4>>2]|0;m=c[b+4>>2]|0;if((c[m>>2]|0)!=(o|0)){p=242544;q=p;r=242376;s=r;t=242520;u=t;eb(q|0,s|0,1328,u|0)}if((c[m+4>>2]|0)!=(n|0)){p=242544;q=p;r=242376;s=r;t=242520;u=t;eb(q|0,s|0,1328,u|0)}if((n|0)==0){i=d;return}u=(o|0)==0;s=b+8|0;q=0;do{if(!u){t=fa(q,o)|0;r=0;do{p=(fa(r,n)|0)+q|0;m=TBa(a,r+t|0)|0;YBa(c[s>>2]|0,p,m);r=r+1|0;}while(r>>>0<o>>>0)}q=q+1|0;}while(q>>>0<n>>>0);i=d;return}else if((e|0)==1){WBa(a,b);i=d;return}else{f=242488;g=f;h=242376;j=h;k=242520;l=k;eb(g|0,j|0,1323,l|0)}}function _Ba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;$Ba(a,b);VBa(b);ZBa(a,b);e=c[b>>2]|0;if((e|0)<=0){i=d;return}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;do{c[a+(b<<2)>>2]=c[f+(b<<2)>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function $Ba(a,b){a=a|0;b=b|0;var c=0;c=i;wBa(a,b);i=c;return}function aCa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=K4a(16)|0;PBa(0,(d|0)!=0|0,242600,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function bCa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;L4a(c[f>>2]|0);L4a(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function cCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;PBa(0,(a|0)!=0|0,242616,f);f=K4a(8)|0;g=f;PBa(0,(f|0)!=0|0,242600,e);e=a+8|0;h=K4a(c[e>>2]|0)|0;c[f>>2]=h;PBa(0,(h|0)!=0|0,242600,d);o5a(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function dCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;PBa(0,(a|0)!=0|0,242616,f);f=K4a(8)|0;g=f;PBa(0,(f|0)!=0|0,242600,e);e=a+8|0;h=K4a(c[e>>2]|0)|0;c[f>>2]=h;PBa(0,(h|0)!=0|0,242600,d);o5a(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function eCa(a){a=a|0;var b=0;b=i;i=i+8|0;PBa(0,(a|0)!=0|0,242616,b);i=b;return c[a+12>>2]|0}function fCa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;PBa(0,(a|0)!=0|0,242616,d);d=a;PBa(0,(c[d>>2]|0)!=0|0,242640,b);i=b;return c[c[d>>2]>>2]|0}function gCa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;L4a(c[e>>2]|0);L4a(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function hCa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;PBa(0,(a|0)!=0|0,242616,d);d=a;PBa(0,(c[d>>2]|0)!=0|0,242656,b);i=b;return c[d>>2]|0}function iCa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;PBa(0,d&1,242688,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function jCa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;PBa(0,(a|0)!=0|0,242688,d);d=a;PBa(0,(c[d>>2]|0)!=0|0,242712,b);i=b;return c[d>>2]|0}function kCa(){var a=0,b=0,d=0;a=i;b=K4a(16)|0;c[60696]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=K4a(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function lCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=rCa(a)|0;wc(242792)|0;sCa(d);a=c[60696]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;ic(242792)|0;q5a(g|0,0,d|0)|0;i=b;return g|0}function mCa(){var a=0,b=0,d=0,e=0;a=i;b=c[60696]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;L4a(c[b>>2]|0);L4a(b);if((d|0)==0){break}else{b=d}}e=c[60696]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function nCa(a){a=a|0;var b=0,d=0;b=i;d=me[c[242744>>2]&127](a<<3)|0;i=b;return d|0}function oCa(a){a=a|0;var b=0,d=0;b=i;d=me[c[242744>>2]&127](a<<2)|0;i=b;return d|0}function pCa(a){a=a|0;var b=0,d=0;b=i;d=me[c[242744>>2]&127](a)|0;i=b;return d|0}function qCa(a){a=a|0;var b=0,d=0;b=i;d=me[c[242744>>2]&127](a<<2)|0;i=b;return d|0}function rCa(a){a=a|0;i=i;return a+7&-8|0}function sCa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[60696]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=K4a(16)|0;c[f+12>>2]=d;c[60696]=f;c[f+4>>2]=0;d=tCa((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=K4a(d)|0;c[f>>2]=a;i=b;return}function tCa(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function uCa(a){a=a|0;var b=0,c=0;b=i;c=m5a(a|0)|0;i=b;return c|0}function vCa(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;s5a(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];kc(m|0,l|0,f|0)|0;f=wCa(m)|0;i=e;return f|0}function wCa(a){a=a|0;var b=0,c=0,d=0;b=i;c=m5a(a|0)|0;d=zCa(c)|0;o5a(d|0,a|0,c|0)|0;i=b;return d|0}function xCa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;s5a(g+1|0,d|0)|0;c[f>>2]=b;kc(k|0,j|0,f|0)|0;f=wCa(k)|0;i=e;return f|0}function yCa(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;kc(o|0,242824,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;kc(o|0,242816,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kc(q|0,p|0,j|0)|0;j=wCa(q)|0;i=g;return j|0}function zCa(b){b=b|0;var d=0,e=0;d=i;e=me[c[242748>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function ACa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=uCa(a)|0;e=uCa(b)|0;f=zCa(e+d|0)|0;o5a(f|0,a|0,d|0)|0;o5a(f+d|0,b|0,e|0)|0;i=c;return f|0}function BCa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=i5a(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function CCa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 5:{f=1;break a;break};case 1:{f=4;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};case 4:{f=2;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function DCa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){$c(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){L4a(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{L4a(c[(c[f>>2]|0)+(g<<4)>>2]|0);L4a(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;L4a(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){L4a(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{L4a(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}L4a(d);c[g>>2]=0;i=b;return}function ECa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(m5a(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function FCa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=lc(b|0,242992)|0;m=d;c[m>>2]=l;if((l|0)==0){n=_d(c[(Qc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ed(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=ub(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=243e3;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[242968+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=243024;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=243048;E=131;break}G=CCa(D)|0;if((G|0)==-1){n=243080;E=131;break}D=c[q>>2]|0;H=K4a(D)|0;if((ub(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=243128;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=243152;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((i5a(H,c[242944+(C<<2)>>2]|0)|0)!=0){n=243176;E=131;break}L4a(H);H=243752;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=K4a(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((ub(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=243376;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=K4a(G+1|0)|0;if((ub(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=K4a(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}L4a(N);M=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=243688;E=131;break a}c[z>>2]=D;c[A>>2]=Ab(c[m>>2]|0)|0;c[B>>2]=M4a(c[z>>2]<<1,4)|0;if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=243720;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=243688;E=131;break a}c[z>>2]=I;c[A>>2]=Ab(c[m>>2]|0)|0;c[B>>2]=M4a(c[z>>2]<<1,4)|0;L=fa(I,D)|0;if((a[l]|0)==1){F=K4a(L<<3)|0;if((ub(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=243720;E=131;break a}if((I|0)!=0){G=D<<3;O=(D|0)==0;P=D<<3;Q=0;do{R=K4a(G)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=R;if(!O){R=F+(fa(P,Q)|0)|0;o5a(c[(c[B>>2]|0)+(Q<<2)>>2]|0,R|0,P|0)|0}Q=Q+1|0;}while(Q>>>0<I>>>0)}Q=c[z>>2]|0;P=Q<<1;if(Q>>>0<P>>>0){O=D<<3;G=(D|0)==0;R=Q;do{S=K4a(O)|0;c[(c[B>>2]|0)+(R<<2)>>2]=S;if(!G){S=c[B>>2]|0;T=c[S+(R-Q<<2)>>2]|0;U=c[S+(R<<2)>>2]|0;S=0;do{h[U+(S<<3)>>3]=-+h[T+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}R=R+1|0;}while(R>>>0<P>>>0)}L4a(F)}else{P=K4a(L<<2)|0;if((ub(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=243720;E=131;break a}if((I|0)!=0){R=D<<3;Q=(D|0)==0;G=0;do{O=K4a(R)|0;c[(c[B>>2]|0)+(G<<2)>>2]=O;if(!Q){O=c[(c[B>>2]|0)+(G<<2)>>2]|0;S=0;do{h[O+(S<<3)>>3]=+g[P+((fa(D,G)|0)+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;Q=G<<1;if(G>>>0<Q>>>0){R=D<<3;L=(D|0)==0;F=G;do{S=K4a(R)|0;c[(c[B>>2]|0)+(F<<2)>>2]=S;if(!L){S=c[B>>2]|0;O=c[S+(F-G<<2)>>2]|0;T=c[S+(F<<2)>>2]|0;S=0;do{h[T+(S<<3)>>3]=-+h[O+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}F=F+1|0;}while(F>>>0<Q>>>0)}L4a(P)}if((Zc(c[m>>2]|0,J|0,1)|0)==-1){n=243720;E=131;break a}else{M=d;E=130}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=243440;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=243496;E=131;break a}c[w>>2]=D;Q=fa(I,D)|0;if((a[l]|0)==1){F=K4a(Q<<3)|0;c[x>>2]=F;if((ub(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=243536;E=131;break a}}else{F=K4a(Q<<2)|0;c[x>>2]=K4a(fa(D<<3,I)|0)|0;if((ub(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=243536;E=131;break a}if((Q|0)!=0){G=c[x>>2]|0;L=0;do{h[G+(L<<3)>>3]=+g[F+(L<<2)>>2];L=L+1|0;}while(L>>>0<Q>>>0)}L4a(F)}Q=c[w>>2]|0;if(!(Q>>>0>1)){M=1;E=130;break b}L=(I|0)==2;G=1;while(1){if(L){P=c[x>>2]|0;if(+h[P+(G<<3)>>3]!=+h[P+(Q+G<<3)>>3]){n=243568;E=131;break a}}P=G+1|0;if(P>>>0<Q>>>0){G=P}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=243440;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=243648;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){Q=K4a(G<<3)|0;c[x>>2]=K4a(fa(D<<3,I)|0)|0;if((ub(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=243536;E=131;break a}if((D|0)!=0){L=0;do{F=c[x>>2]|0;P=0;do{h[F+((fa(I,L)|0)+P<<3)>>3]=+h[Q+((fa(D,P)|0)+L<<3)>>3];P=P+1|0;}while(P>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}L4a(Q)}else{L=K4a(G<<2)|0;c[x>>2]=K4a(fa(D<<3,I)|0)|0;if((ub(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=243536;E=131;break a}if((D|0)!=0){P=0;do{F=c[x>>2]|0;R=0;do{h[F+((fa(I,P)|0)+R<<3)>>3]=+g[L+((fa(D,R)|0)+P<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);P=P+1|0;}while(P>>>0<D>>>0)}L4a(L)}P=c[w>>2]|0;if(!(P>>>0>1)){M=d;E=130;break b}G=(D|0)==2;Q=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(Q<<3)>>3]!=+h[R+(P+Q<<3)>>3]){n=243568;E=131;break a}}R=Q+1|0;if(R>>>0<P>>>0){Q=R}else{M=d;E=130;break}}break};case 3:{Q=fa(I<<2,D)|0;V=K4a(Q)|0;if((ub(V|0,Q|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}Q=c[v>>2]|0;P=0;do{c[Q+(P<<4)+8>>2]=(c[V+(P<<2)>>2]|0)==1;c[Q+(P<<4)+12>>2]=c[V+(D+P<<2)>>2];P=P+1|0;}while(P>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}P=c[v>>2]|0;Q=0;do{G=fa(D,Q)|0;c[P+(Q<<4)+8>>2]=(c[V+(G<<2)>>2]|0)==1;c[P+(Q<<4)+12>>2]=c[V+(G+1<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0)}}while(0);L4a(V);fc(c[v>>2]|0,c[u>>2]|0,16,55);M=d;E=130;break};case 0:{if((D|0)!=4){n=243200;E=131;break a}if((I|0)!=11){n=243240;E=131;break a}if((ub(f|0,44,1,c[m>>2]|0)|0)==1){W=0}else{n=243280;E=131;break a}while(1){Q=0;do{a[k+Q|0]=a[j+((Q<<2)+W)|0]|0;Q=Q+1|0;}while(Q>>>0<11);a[k+11|0]=0;if((W|0)==3){break}Q=W+1|0;if(Q>>>0<4){W=Q}else{M=d;E=130;break b}}if((j5a(t,c[60712]|0,8)|0)==0){M=1;E=130;break b}if((j5a(t,c[60718]|0,9)|0)==0){M=0;E=130}else{n=243312;E=131;break a}break};case 1:{Q=d<<24>>24==0;c[u>>2]=Q?D:I;P=K4a((Q?D:I)<<4)|0;c[v>>2]=P;c:do{if(d<<24>>24==1){if((I|0)==0){X=0;break}G=D+1|0;L=P;R=0;while(1){c[L+(R<<4)>>2]=K4a(G)|0;if((ub(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=243376;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;F=c[v>>2]|0;c[F+(R<<4)+8>>2]=-1;c[F+(R<<4)+12>>2]=-1;ECa(c[F+(R<<4)>>2]|0);F=R+1|0;if(!(F>>>0<I>>>0)){X=I;break c}L=c[v>>2]|0;R=F}}else{X=I}}while(0);if(!Q){M=d;E=130;break b}P=fa(D,X)|0;Y=K4a(P+1|0)|0;if((ub(Y|0,P|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){P=X+1|0;R=(X|0)==0;L=0;do{G=K4a(P)|0;c[(c[v>>2]|0)+(L<<4)>>2]=G;if(!R){G=0;do{F=a[Y+((fa(D,G)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<X>>>0)}a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+X|0]=0;G=c[v>>2]|0;c[G+(L<<4)+8>>2]=-1;c[G+(L<<4)+12>>2]=-1;ECa(c[G+(L<<4)>>2]|0);L=L+1|0;}while(L>>>0<D>>>0)}L4a(Y);M=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){L4a(Y);n=243376;i=e;return n|0}else if((E|0)==46){L4a(N);n=243376;i=e;return n|0}else if((E|0)==52){L4a(V);n=243408;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function GCa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Id(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,55)|0;i=d;return b|0}function HCa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=243792;o=n;p=243840;q=p;r=243864;s=r;eb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=243792;o=n;p=243840;q=p;r=243864;s=r;eb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=K4a(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((ub(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}L4a(r);t=0;i=e;return t|0}else{k=K4a(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Zc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((ub(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}L4a(k);L4a(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);L4a(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function ICa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=243792;r=q;s=243840;t=s;u=243888;v=u;eb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=243792;r=q;s=243840;t=s;u=243888;v=u;eb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Zc(o|0,t+(r<<3)|0,0)|0;f=(ub(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Zc(o|0,t+(r<<2)|0,0)|0;if((ub(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function JCa(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function KCa(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function LCa(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function MCa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+LCa(b)<e){q=1;i=f;return q|0}if(+KCa(b)>e){q=1;i=f;return q|0}if((HCa(b,1)|0)==0){q=1;i=f;return q|0}JCa(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+ICa(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+ICa(a,b,d,o);i=f;return q|0}if(+ICa(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+ICa(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function NCa(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function OCa(a,b){a=a|0;b=b|0;var c=0;c=i;rBa(a,b,nCa(b)|0);i=c;return}function PCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=nCa(sBa(a,b,f)|0)|0;i=e;return}function QCa(a){a=a|0;var b=0;b=i;c[a+8>>2]=nCa(qBa(a)|0)|0;i=b;return}function RCa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((oBa(a)|0)==0){eb(243920,243944,127,243968)}if((oBa(b)|0)==0){eb(243992,243944,128,243968)}if((pBa(a,b)|0)==0){eb(244016,243944,129,243968)}e=qBa(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+NCa(a,b);SCa(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function SCa(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function TCa(a,b){a=a|0;b=b|0;var c=0;c=i;tBa(a,b);QCa(b);RCa(a,b);i=c;return}function UCa(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function VCa(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;SCa(c[d+8>>2]|0,b,a);i=e;return}function WCa(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;OCa(a,b);j=g;c[g>>2]=e;VCa(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;VCa(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function XCa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=uBa(a,b,f)|0;f=UCa(c[a+8>>2]|0,d)|0;i=e;return f|0}function YCa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=K4a(d<<2)|0;if((j|0)==0){eb(244056,243944,784,244088)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){eb(244064,243944,795,244088)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){eb(244112,243944,798,244088)}else if((s|0)==17){eb(244152,243944,800,244088)}else if((s|0)==22){eb(244152,243944,804,244088)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=nCa(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=qCa(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){L4a(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+NCa(a,k+s|0);SCa(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}L4a(j);i=g;return}function ZCa(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=d+4|0;c[f>>2]=qCa(b)|0;g=nCa(1)|0;c[d+8>>2]=g;c[d>>2]=b;SCa(g,0,a);if((b|0)<=0){i=e;return}g=c[f>>2]|0;f=0;do{c[g+(f<<2)>>2]=1;f=f+1|0;}while((f|0)<(b|0));i=e;return}function _Ca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0;d=i;e=c[a>>2]|0;if((e|0)==1){RCa(a,b);i=d;return}else if((e|0)==2){if((c[b>>2]|0)!=2){f=244224;g=f;h=243944;j=h;k=244256;l=k;eb(g|0,j|0,1383,l|0)}e=c[a+4>>2]|0;m=c[e>>2]|0;n=c[e+4>>2]|0;e=c[b+4>>2]|0;if((c[e>>2]|0)!=(n|0)){o=244280;p=o;q=243944;r=q;s=244256;t=s;eb(p|0,r|0,1388,t|0)}if((c[e+4>>2]|0)!=(m|0)){o=244280;p=o;q=243944;r=q;s=244256;t=s;eb(p|0,r|0,1388,t|0)}if((m|0)==0){i=d;return}t=(n|0)==0;r=b+8|0;b=0;do{if(!t){p=fa(b,n)|0;s=0;do{q=(fa(s,m)|0)+b|0;u=+NCa(a,s+p|0);SCa(c[r>>2]|0,q,u);s=s+1|0;}while(s>>>0<n>>>0)}b=b+1|0;}while(b>>>0<m>>>0);i=d;return}else{f=244224;g=f;h=243944;j=h;k=244256;l=k;eb(g|0,j|0,1383,l|0)}}function $Ca(a){a=a|0;var b=0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0.0,j=0;b=i;if((oBa(a)|0)==0){eb(244200,243944,1502,244336)}c=qBa(a)|0;if((c|0)==0){d=0.0;i=b;return+d}e=+NCa(a,0);if(c>>>0>1){f=1;g=e}else{d=e;i=b;return+d}while(1){e=+NCa(a,f);h=g<e?e:g;j=f+1|0;if(j>>>0<c>>>0){g=h;f=j}else{d=h;break}}i=b;return+d}function aDa(a){a=a|0;var b=0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0.0,j=0;b=i;if((oBa(a)|0)==0){eb(244200,243944,1524,244352)}c=qBa(a)|0;if((c|0)==0){d=0.0;i=b;return+d}e=+NCa(a,0);if(c>>>0>1){f=1;g=e}else{d=e;i=b;return+d}while(1){e=+NCa(a,f);h=g>e?e:g;j=f+1|0;if(j>>>0<c>>>0){g=h;f=j}else{d=h;break}}i=b;return+d}function bDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;wBa(a,b);QCa(b);_Ca(a,b);e=c[b>>2]|0;if((e|0)<=0){i=d;return}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;do{c[a+(b<<2)>>2]=c[f+(b<<2)>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function cDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;wBa(a,b);QCa(b);e=c[b>>2]|0;if((e|0)<=0){_Ca(a,b);i=d;return}f=c[b+4>>2]|0;g=c[a+4>>2]|0;h=0;do{j=f+(h<<2)|0;k=c[j>>2]|0;l=g+(h<<2)|0;c[j>>2]=c[l>>2];c[l>>2]=k;h=h+1|0;}while((h|0)<(e|0));_Ca(a,b);i=d;return}function dDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=K4a(20)|0;PBa(0,(f|0)!=0|0,244368,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=M4a(e,b)|0;c[f>>2]=a;PBa(0,(a|0)!=0|0,244368,d);i=d;return f|0}function eDa(a){a=a|0;var b=0;b=i;L4a(c[a>>2]|0);L4a(a);i=b;return}function fDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;PBa(0,(c[h>>2]|0)>0|0,244384,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;PBa(0,(g|0)>(b|0)|0,244408,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;PBa(0,(0-f|0)<(b|0)|0,244408,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function gDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=M4a(c[d>>2]<<1,c[e>>2]|0)|0;PBa(0,(f|0)!=0|0,244368,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=fDa(a,j)|0;h=c[e>>2]|0;o5a(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;L4a(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function hDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){gDa(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;o5a((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function iDa(a){a=a|0;i=i;return c[a+12>>2]|0}function jDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;PBa(0,(c[j>>2]|0)>0|0,244384,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;PBa(0,(h|0)>(b|0)|0,244408,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;PBa(0,b>>>31^1,244408,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=fDa(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function kDa(a){a=a|0;i=i;return c[(c[61110]|0)+(a<<2)>>2]|0}function lDa(a){a=a|0;i=i;return c[(c[61112]|0)+(a<<2)>>2]|0}function mDa(a){a=a|0;i=i;return c[(c[61114]|0)+(a<<2)>>2]|0}function nDa(a){a=a|0;i=i;return c[(c[61116]|0)+(a<<2)>>2]|0}function oDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[61112]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[61114]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[61110]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function pDa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[61118]|0;e=+qDa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function qDa(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function rDa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[61120]|0;e=+qDa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function sDa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[61122]|0;e=+qDa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function tDa(a){a=a|0;i=i;return 0}function uDa(a){a=a|0;var b=0,d=0;b=i;ib(4,(c[61124]|0)+(a<<3)|0)|0;d=(c[61110]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function vDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[61118]|0;f=e+(a<<3)|0;g=c[61122]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[61116]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[61110]|0)+(a<<2)>>2]|0);e=c[61120]|0;g=e+(a<<3)|0;wDa(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;oDa(a);d=c[61118]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[61110]|0)+(a<<2)>>2]=0;i=b;return}function wDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(zDa(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function xDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;ib(4,d|0)|0;e=c[61124]|0;f=c[61118]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function yDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=M4a(a,8)|0;c[61118]=d;e=M4a(a,8)|0;c[61120]=e;f=M4a(a,8)|0;c[61122]=f;g=M4a(a,8)|0;c[61124]=g;h=M4a(a,4)|0;c[61110]=h;j=M4a(a,4)|0;c[61116]=j;k=a<<2;l=K4a(k)|0;c[61112]=l;m=M4a(a,4)|0;c[61114]=m;q5a(l|0,-1,k|0)|0;if((d|0)==0){eb(244504,244520,393,244536)}if((e|0)==0){eb(244544,244520,394,244536)}if((f|0)==0){eb(244560,244520,395,244536)}if((g|0)==0){eb(244576,244520,396,244536)}if((h|0)==0){eb(244592,244520,397,244536)}if((l|0)==0){eb(244616,244520,398,244536)}if((m|0)==0){eb(244640,244520,399,244536)}if((j|0)==0){eb(244664,244520,400,244536)}else{i=b;return}}function zDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function ADa(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function BDa(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==0){c[m>>2]=c[b+8>>2];n=m+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];NBa(17,0,o,246296,m);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];m=j+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];NBa(17,0,o,246448,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];NBa(17,0,o,246544,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];NBa(17,0,o,246344,l);i=e;return}else{l=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=l;l=f+8|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];NBa(17,0,o,246608,f);i=e;return}}function CDa(a){a=a|0;var b=0;b=i;L4a(c[a+12>>2]|0);L4a(c[a+4>>2]|0);L4a(c[a+8>>2]|0);i=b;return}function DDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[31429]=.5;h[31415]=1.0;h[31452]=.25;h[31427]=2.0;h[31454]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[62866]=A;B=c[d>>2]|0;c[62796]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[62796]=D;if((C|0)<(B|0)){C=D}else{break}}}c[62794]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[31430]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[31430]=F;G=F}else{G=E}D=c[d>>2]|0;c[62796]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[62796]=I;if((H|0)>=(D|0)){break a}E=+h[31430];H=I}}}while(0);D=C+1|0;c[62794]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[31434]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[31399]=0.0;h[31401]=0.0;h[31405]=0.0;h[31462]=0.0;c[62792]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[31399]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[31401]+ +h[B>>3]*F;h[31401]=E;F=+h[I>>3];M=+h[31405]+F*F;h[31405]=M;F=+h[H>>3];h[31462]=+h[31462]+F*F;H=A+1|0;c[62792]=H;F=+h[31399];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[62862]=A;E=G/J;h[31451]=E;C=c[d>>2]|0;c[62796]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[31459]=0.0;h[31461]=0.0;I=c[b>>2]|0;c[62792]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[31428]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[31459]=ba;ca=E+aa*aa;h[31461]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[62792]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[62862]=A;h[31451]=E;h[31401]=Z;h[31405]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[62796]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[62792]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[62792]=A+1;da=+h[31401];ea=+h[31405];ga=+h[31399]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[31450]=K;c[62890]=0;h[31458]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[62890]=C;K=+h[31415]/+V(+ga);h[31430]=K;h[31453]=0.0;h[31455]=0.0;B=c[b>>2]|0;c[62792]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[31453]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[31453]=oa;pa=+h[31455]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[31455]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[31401];L=+h[31399];N=+h[31430];D=D+1|0;la=ma}c[62792]=B+1;ia=+h[31399];ja=pa;ka=oa}N=+h[31429];L=ka*N*ka;h[31446]=L;J=ja*N*ja;h[31447]=J;h[31406]=J+(L+ia*(+h[31462]+ia*N));N=+h[31427];h[251256>>3]=N*ka*ia;h[251264>>3]=N*ja*ia;h[251272>>3]=L-J;h[251280>>3]=ka*ja;la=251288|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[62792]=10;la=c[d>>2]|0;c[62796]=1;if((la|0)>=1){D=1;while(1){h[31446]=0.0;h[31447]=0.0;h[31448]=0.0;A=c[b>>2]|0;c[62792]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[31446]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[31447]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[31448]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[62792]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[31452]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[31446]*+h[31448];h[t+(U+D<<3)>>3]=+h[31447]*+h[31448];J=+h[31446];L=+h[31447];h[t+(P+D<<3)>>3]=+h[31452]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[31429]*+h[31446]*+h[31447];na=D+1|0;c[62796]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[62792]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[62804]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[62792]=B;if((la|0)<(D|0)){la=B}else{break}}}c[62800]=1;la=1;do{D=c[d>>2]|0;c[62808]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[62808]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[62796]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[62796]=D+1}na=c[62866]|0;c[62794]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[31426]=0.0;ma=c[d>>2]|0;c[62796]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[31426]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[62796]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[31426]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[62796]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[31426];Ca=Ca+1|0}c[62796]=ta+1}Ca=B+1|0;c[62794]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[62796]=1;if((A|0)<1){break}else{Ea=1}while(1){h[31426]=0.0;B=c[b>>2]|0;c[62794]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[31426]=N;Ca=na+1|0;c[62794]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[62796]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[62794]=1;if((A|0)>=1){ta=1;while(1){h[31426]=0.0;c[62792]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[31426]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[62792]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[62794]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[62800]=la;}while((la|0)<6);la=c[l>>2]|0;c[62796]=1;h[31426]=0.0;c[62792]=1;L=+h[31429];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[251328+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[251328+(A+ -1<<3)>>3]+L;h[31426]=L;A=A+1|0;}while((A|0)<6);h[31406]=+h[31406]- +h[31416]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[31446]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[31447]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[31448]=O;h[251256>>3]=+h[251256>>3]-J-N*(O+K);h[251288>>3]=+h[251288>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[31446]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[31447]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[31448]=J;h[251264>>3]=+h[251264>>3]-O-N*(K-J);h[251296>>3]=+h[251296>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[31446]=J;h[251272>>3]=+h[251344>>3]+(+h[251272>>3]-J- +h[251336>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[31446]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[31447]=K;Oa=+h[31429];h[251280>>3]=+h[251280>>3]-J-K*Oa;h[251304>>3]=+h[251304>>3]- +h[251352>>3]+ +h[251360>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[31446]=K;h[251312>>3]=+h[251312>>3]-Oa*K;h[31426]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[62796]=la+1;c[62792]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[251328+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[251328+(ta+ -1<<3)>>3]+N;h[31426]=N;ta=ta+1|0;c[62792]=ta;}while((ta|0)<6);K=+h[31434];h[31436]=K*+h[31406]+ +h[31416]+N;J=+h[31427];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[31446]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[31447]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[31448]=R;T=R+(K*+h[251256>>3]+O+S);h[251496>>3]=T;O=K*+h[251288>>3]+S-R;h[251528>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[31446]=R;S=+h[I>>3]*+h[ma>>3];h[31447]=S;Z=+h[Ma>>3]*+h[Na>>3];h[31448]=Z;h[251504>>3]=K*+h[251264>>3]+R+S-Z;h[251536>>3]=K*+h[251296>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[31446]=Z;R=+h[251336>>3]+(Z+K*+h[251272>>3])- +h[251344>>3];h[251512>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[31446]=Z;h[251520>>3]=Z+K*+h[251280>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[251304>>3]+ +h[251352>>3]- +h[251360>>3];h[251544>>3]=J;h[251552>>3]=+h[31434]*+h[251312>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[31436]+T+R+O+J;h[31426]=K;h[31456]=K;h[31457]=K;c[62898]=0;J=+h[31454]/50.0;h[31430]=J;h[31416]=+h[31415];c[62792]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[251336>>3]=Z;W=+Y(+Pa);h[251344>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[251328+(Ma+ -1<<3)>>3]=Z;Q=+h[251336>>3]*G+ +h[251344>>3]*W;h[251328+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[251344>>3];ca=+h[251336>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[251488+(Ma<<3)>>3]*+h[251328+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[31457]=Ra;c[62898]=Na;h[31446]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[31447]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[62794]=10;h[31426]=Ra;h[31435]=Pa;h[31460]=O;c[62792]=50;if((Xa|0)==0){h[31446]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[31447]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[31432]=0.0;if(Ya!=Za){S=Ya-Ua;h[31446]=S;T=Za-Ua;h[31447]=T;R=+h[31429]*(S-T)/(S+T);h[31432]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[31435]=R;T=+X(+R);h[251336>>3]=T;S=+Y(+R);h[251344>>3]=S;c[62794]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[251328+(Na+ -1<<3)>>3]=T;W=+h[251336>>3]*G+ +h[251344>>3]*S;h[251328+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[251344>>3];N=+h[251336>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[31457]=0.0;c[62794]=1;Na=1;do{ma=Na+ -1|0;Ma=251328+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[251248+(ma<<3)>>3]*+h[Ma>>3];h[31457]=+h[31457]+ +h[251488+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[62794]=10;Na=c[l>>2]|0;c[62796]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[251328+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[62794]=6;c[62796]=Na+1}h[31425]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[31399]=0.0;h[31446]=0.0;h[31447]=0.0;Ma=c[b>>2]|0;c[62792]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[251336>>3]*+h[la>>3]+ +h[251344>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[31399]=+h[31399]+G*G;bb=+h[31446]+ +h[la>>3]*+h[ta>>3];h[31446]=bb;G=+h[ta>>3];cb=+h[31447]+G*G;h[31447]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[62792]=Ma+1;$a=cb;ab=bb}ma=c[62890]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[31458];S=+h[31456];h[31458]=G>=S?G:S}S=+h[31457];if(!(S>=0.0)){db=-S}else{db=S}G=+h[31458];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[31458]=S;c[62792]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[31430]=N;R=+h[31425]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[31434];la=ta+1|0;c[62792]=la;if((ta|0)>=(Na|0)){break b}S=+h[31447];G=+h[31446];ta=la}}}while(0);Na=c[d>>2]|0;c[62796]=1;if((Na|0)>=1){Ma=1;while(1){h[31426]=0.0;ta=c[b>>2]|0;c[62794]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[31426]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[62794]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[31425]*+h[p+(la+ -1+Ma<<3)>>3]- +h[31434]*+h[q+(Ma+ -1<<3)>>3]);h[31430]=G;c[62792]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[31430];I=I+1|0}c[62792]=la+1}I=Ma+1|0;c[62796]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[31405]=0.0;h[31401]=0.0;Ma=c[b>>2]|0;c[62792]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[31405]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[31401]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[62792]=Ma+1;hb=kb;ib=jb}S=+h[31399];G=S*ib-hb*hb;h[31450]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[251224]=1;C=c[l>>2]|0;c[62796]=1;if((C|0)<1){lb=251320;mb=+h[31415];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[251328+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[62794]=6;c[62796]=C+1;lb=251320;mb=+h[31415];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function EDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[31482]=.5;h[31478]=1.0;h[31494]=6.283185307179586;z=+h[n>>3];h[31491]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[62970]=A;c[62978]=0;B=c[d>>2]|0;c[62930]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[62930]=B+1}c[62928]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[31483]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[31483]=F;G=F}else{G=z}H=c[d>>2]|0;c[62930]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[31483];I=I+1|0}c[62930]=H+1}I=B+1|0;c[62928]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[31466]=0.0;D=c[b>>2]|0;c[62926]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[31466]=+h[31466]+G*G;A=p+1|0;c[62926]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[62930]=1;if((p|0)>=1){D=1;while(1){h[31483]=0.0;h[31481]=0.0;y=c[b>>2]|0;c[62928]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[31483]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[31481]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[62928]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[31483]=G;h[31481]=+h[g>>3]*L;g=c[b>>2]|0;c[62926]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[31481]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[31483];H=H+1|0}c[62926]=g+1}H=D+1|0;c[62930]=H;if((D|0)<(p|0)){D=H}else{break}}}h[31467]=0.0;h[31469]=0.0;h[31476]=0.0;D=c[b>>2]|0;c[62926]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[31467]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[31469]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[31476]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[62926]=D+1;O=R;P=T;Q=S}S=+h[31466];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[31487]=U;h[31483]=0.0;if(Q*Q>S*.99*O){h[31483]=+h[31478]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[31482]*U*Z);h[31479]=P;if(O*+h[31491]<P*P*.01){h[31483]=+h[31478]}n=c[b>>2]|0;c[62926]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[31487]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[31483]*U;if((D|0)>=(n|0)){break}e=D;P=+h[31487];D=D+1|0;p=e}c[62926]=n+1;_=0}while(1){n=_+1|0;c[62978]=n;h[31466]=0.0;h[31469]=0.0;h[31470]=0.0;p=c[b>>2]|0;c[62926]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[31466]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[31469]=da;Z=+h[H>>3];ea=P+Z*Z;h[31470]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[62926]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[31483]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[31488]=U;D=c[b>>2]|0;c[62926]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[31488];U=+h[31469];O=+h[31466];g=g+1|0;H=e}c[62926]=D+1}H=c[d>>2]|0;c[62930]=1;if((H|0)>=1){g=1;while(1){h[31481]=0.0;p=c[b>>2]|0;c[62928]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[31481]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[62928]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[31481]=O;e=c[b>>2]|0;c[62926]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[31481];l=l+1|0}c[62926]=e+1}l=g+1|0;c[62930]=l;if((g|0)<(H|0)){g=l}else{break}}}h[31471]=0.0;h[31472]=0.0;h[31473]=0.0;h[31474]=0.0;h[31475]=0.0;g=c[b>>2]|0;c[62926]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[31471]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[31472]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[31473]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[31474]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[31475]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[62926]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[31482];O=U*na;h[31471]=O;P=U*ma-O;h[31474]=P;Z=O+la+P;h[31495]=Z;h[31497]=Z;h[31496]=Z;c[62980]=0;a[251744]=1;W=+h[31494]/50.0;h[31483]=W;c[62926]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[31497]=wa;c[62980]=p;h[31492]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[31493]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[31486]=ta;h[31477]=ua;h[31480]=va;h[31479]=wa;c[62926]=50;h[31496]=wa;if((za|0)==49){h[31493]=Z;Ba=Z}else if((za|0)==0){h[31492]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[31493]}h[31484]=0.0;S=+h[31492];if(S!=Ba){Q=S-Aa;h[31492]=Q;S=Ba-Aa;h[31493]=S;T=U*(Q-S)/(Q+S);h[31484]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[31486]=T;S=+X(+T);h[31477]=S;Q=+Y(+T);h[31480]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[31479]=T;p=c[b>>2]|0;c[62926]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[31477]*+h[y>>3]+ +h[31480]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[31480];Q=+h[31477];H=H+1|0;g=e}c[62926]=p+1;Da=+h[31479]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[31495];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function FDa(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[252200]=1;a[252192]=1;c[252212>>2]=6;nVa(252208)|0;e=c[d>>2]|0;c[63046]=1;if((e|0)>=1){d=1;do{EUa(252328,b+(d+ -1)|0,1)|0;o=c[63046]|0;d=o+1|0;c[63046]=d;}while((o|0)<(e|0))}XUa()|0;e=c[g>>2]|0;if((e|0)==1){c[252236>>2]=a[252192]&1?6:0;nVa(252232)|0;EUa(252328,h,4)|0;XUa()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[252260>>2]=a[252192]&1?6:0;nVa(252256)|0;EUa(252328,h,4)|0;EUa(252328,j,4)|0;XUa()|0}j=c[k>>2]|0;if((j|0)==1){c[252284>>2]=a[252192]&1?6:0;nVa(252280)|0;EUa(252328,l,8)|0;XUa()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[252308>>2]=a[252192]&1?6:0;nVa(252304)|0;EUa(252328,l,8)|0;EUa(252328,m,8)|0;XUa()|0}if((c[f>>2]|0)==2){mUa(252336,0)|0}else{i=n;return 0}return 0}function GDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==-1){tUa(252408,252640,80,49);C=252712;D=252720;FDa(252408,252696,252704,C,C,C,C,C,D,D,80)|0;tUa(252408,252728,80,47);D=252712;C=252720;FDa(252408,252776,252784,D,252792,n,D,D,C,C,80)|0;tUa(252408,252800,80,41);C=252712;D=252720;FDa(252408,252848,252856,252792,C,C,C,C,D,D,80)|0;i=y;return 0}else if((A|0)==0){c[63088]=2;D=2;while(1){C=D+1|0;if(!((c[k+(D+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[63088]=C;if((C|0)<12){D=C}else{break}}if((c[d>>2]|0)<1){tUa(252408,254104,80,25);D=252712;C=252720;FDa(252408,254136,252888,D,252792,d,D,D,C,C,80)|0;break}c[63152]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{D=c[C>>2]|0;c[63152]=D;if(!((D+ -1|0)>>>0>4)){E=D;break}tUa(252408,254144,80,34);D=252712;F=252720;FDa(252408,254184,252880,D,252792,252608,D,D,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;D=fa(F,F)|0;c[63138]=D;c[63150]=D+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);D=q+12|0;if((c[k+16>>2]|0)==0){c[D>>2]=2;break}else{c[D>>2]=1;break}}else{D=c[q>>2]|0;do{if((D|0)>=0){F=c[d>>2]|0;if((D|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){tUa(252408,254968,80,52);I=252712;J=252720;FDa(252408,254952,255024,I,252792,G,I,I,J,J,80)|0;break a}c[63138]=fa((D<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[63150]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[63138]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[63150]=F+(c[63138]|0);break b}}}while(0);tUa(252408,254896,80,52);D=252712;F=252720;FDa(252408,254952,254960,D,252792,q,D,D,F,F,80)|0;break a}}while(0);c[63142]=(c[d>>2]|0)+20;c[q+64>>2]=c[63138];if((c[p>>2]|0)<(c[63150]|0)){tUa(252408,254192,80,60);C=252712;F=252720;FDa(252408,254256,254264,C,252888,252600,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[63142]|0)){tUa(252408,254272,80,60);F=252712;C=252720;FDa(252408,254256,254336,F,252888,252568,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){tUa(252408,255080,80,24);C=252792;F=252712;D=252720;FDa(252408,255112,255120,C,C,w,F,F,D,D,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[31566]=K;if(!(K<=0.0)){break}tUa(252408,254576,80,28);D=252712;FDa(252408,253288,254608,D,D,D,D,252792,252528,252720,80)|0;break a}}while(0);c[q+60>>2]=0;D=q+36|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[n>>2]=1;B=27}else{B=210}}while(0);c:do{if((B|0)==27){a[252584]=0;K=+h[l>>3];h[31577]=K;L=+h[m>>3];h[31570]=L;r=c[d>>2]|0;c[63088]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){D=A+ -1|0;O=+h[l+(D<<3)>>3];h[31577]=O;P=+h[m+(D<<3)>>3];h[31570]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[252584]=1;S=1}else{S=E}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}D=A+1|0;c[63088]=D;if((A|0)<(r|0)){E=S;A=D;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[63098]=E;p=E+(c[w>>2]|0)|0;c[63100]=p;E=p+(c[w>>2]|0)|0;c[63122]=E;D=E+(c[w>>2]|0)|0;c[63092]=D;F=D+(c[d>>2]|0)|0;c[63128]=F;C=F+(c[d>>2]|0)|0;c[63134]=C;c[63124]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[63148]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[31579]=+h[F>>3];a[252520]=0;h[31548]=+h[o+24>>3];J=o+16|0;h[31543]=+h[J>>3];do{if((c[w>>2]|0)!=0){HDa(252888,v,w,d,252384,j,f,o+(D+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,252504,F,0,o,q,s,t)|0;if((c[63218]|0)>0){i=y;return 0}if((c[63126]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=252792;cEa(d,o+((c[63092]|0)+ -1<<3)|0,G,g,G)|0;a[252520]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[31543];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[31543]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[31543];if((M-N)*P>0.0){B=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[31578]=O;U=+h[31548];V=U-O;G=V*P>0.0;do{if(F){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[63134]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){MDa(252384,j,f,g,d,H,I,X)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[252520]=1;B=197;break d}}else{Y=252384;MDa(Y,Y,f,g,d,H,I,X)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[31548];c[n>>2]=1;a[252520]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[252520]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[31579]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[31543]=W;h[J>>3]=W;break}MDa(252384,252624,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[31578];a[252520]=1;B=197;break d}}else{W=+h[31548];if(!F){if(P*(W-N)<0.0){break}MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[252520]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[63134]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){MDa(252384,j,f,g,d,G,X,I)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[252520]=1;B=197;break d}}else{H=252384;MDa(H,H,f,g,d,G,X,I)|0;if((c[63218]|0)>0){i=y;return 0}else{h[e>>3]=+h[31548];c[n>>2]=1;a[252520]=1;B=197;break d}}}}while(0);if(a[252520]&1){B=197}else{B=128}}else{h[31548]=+h[e>>3];c[n>>2]=1;JDa(d,k+4|0,l,m,f,o+((c[63128]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[63088]=1;e:do{if((F|0)>=1){J=c[63128]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[63088]=X;if((I|0)<(F|0)){I=X}else{break e}}tUa(252408,254712,80,39);I=252712;J=252720;FDa(252408,254384,254752,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+QDa(252864,1);h[31579]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[31579]*4.0*(aa>=ba?aa:ba);h[31568]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){tUa(252408,254760,80,60);J=252712;FDa(252408,254256,254824,J,J,J,J,252888,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[31547]=ca*.001;U=+KDa(d,g,o+((c[63128]|0)+ -1<<3)|0,s,t);if(U>.5/+h[31547]){h[31547]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+qUa(252376,z);h[31547]=U;da=U}else{U=+h[o+16>>3];h[31547]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}tUa(252408,254664,80,29);J=252712;I=252720;FDa(252408,254696,254704,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[31547]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[31578]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[31547]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{LDa(252384,f,g,d,b,u,252376,o+((c[63128]|0)+ -1<<3)|0,n,s,t,o+((c[63134]|0)+ -1<<3)|0,o+400|0,o+((c[63092]|0)+ -1<<3)|0,o+((c[63124]|0)+ -1<<3)|0,q,252544,F,k+36|0,252592)|0;if((c[63218]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[31547]}h[31543]=ja;h[o+16>>3]=ja;J=c[63134]|0;X=(c[d>>2]|0)+J|0;c[63144]=X;G=c[d>>2]|0;c[63088]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[31543]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[63088]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[31543];h[o+232>>3]=+h[31543]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}HDa(252792,v,w,d,e,j,f,o+((c[63092]|0)+ -1<<3)|0,o+((c[63134]|0)+ -1<<3)|0,J,Y,o+((c[63098]|0)+ -1<<3)|0,o+((c[63100]|0)+ -1<<3)|0,o+((c[63122]|0)+ -1<<3)|0,x,252504,F,0,o,q,s,t)|0;if((c[63218]|0)>0){i=y;return 0}if((c[63126]|0)!=0){tUa(252408,255128,80,47);la=252712;ma=252720;FDa(252408,252776,255176,252792,la,la,la,la,ma,ma,80)|0;tUa(252408,255184,80,38);ma=252712;la=252720;FDa(252408,252936,255176,252792,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}HDa(252880,v,w,d,252384,j,f,o+((c[63092]|0)+ -1<<3)|0,o+((c[63134]|0)+ -1<<3)|0,J,Y,o+((c[63098]|0)+ -1<<3)|0,o+((c[63100]|0)+ -1<<3)|0,o+((c[63122]|0)+ -1<<3)|0,x,252504,F,0,o,q,s,t)|0;if((c[63218]|0)>0){i=y;return 0}if((c[63126]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=252792;cEa(d,o+((c[63092]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){tUa(252408,254504,80,54);E=252712;FDa(252408,254560,254568,E,E,E,E,252888,252624,j,80)|0;break c}else if((B|0)==220){tUa(252408,254616,80,34);E=252712;FDa(252408,254184,254656,E,E,E,E,252888,j,e,80)|0;break c}else if((B|0)==224){tUa(252408,254832,80,49);E=252712;FDa(252408,252696,254888,E,E,E,E,252888,252624,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;JDa(d,oa,l,m,o+((c[63134]|0)+ -1<<3)|0,o+((c[63128]|0)+ -1<<3)|0,s,t)|0;if((c[63218]|0)>0){B=233;break}E=c[d>>2]|0;c[63088]=1;p=c[63128]|0;if((E|0)>=1){A=1;while(1){C=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){B=136;break f}c[63088]=C;if((A|0)<(E|0)){A=C}else{break}}}O=+KDa(d,o+((c[63134]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[31579];pa=O*V;h[31545]=pa;if(!(pa<=1.0)){B=138;break}O=+h[31548];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[31568]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[31543];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[31543]=V/O}}while(0);NDa(252384,f,g,d,b,u,252344,o+((c[63128]|0)+ -1<<3)|0,k,n,s,t,o+((c[63134]|0)+ -1<<3)|0,o+400|0,o+((c[63092]|0)+ -1<<3)|0,o+((c[63124]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,252544,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,252592)|0;if((c[63218]|0)>0){B=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){HDa(252880,v,w,d,252384,j,f,o+((c[63092]|0)+ -1<<3)|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[63098]|0)+ -1<<3)|0,o+((c[63100]|0)+ -1<<3)|0,o+((c[63122]|0)+ -1<<3)|0,x,252504,o+64|0,0,o,q,s,t)|0;if((c[63218]|0)>0){B=233;break f}if((c[63126]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=252792;cEa(d,o+((c[63092]|0)+ -1<<3)|0,p,g,p)|0;B=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[31548];V=+h[31543];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){B=128;continue}MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(p){if(U>=0.0){MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[31578];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[31579]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}MDa(252384,252624,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[31578];B=197;continue}if(!(U<0.0)){MDa(252384,j,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[31578];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[31579]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[31543]=U-O;B=128;continue}else{MDa(252384,252624,f,g,d,q+28|0,o+((c[63134]|0)+ -1<<3)|0,o+224|0)|0;if((c[63218]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[31578];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[31548];h[o+16>>3]=+h[31543];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[31545]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[63088]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[31545]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[31545];A=A+1|0;E=F}c[63088]=p+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);E=0-na|0;c[63144]=E;switch(E|0){case 2:{tUa(252408,253024,80,47);E=252712;FDa(252408,252776,253072,E,E,E,E,252792,252384,252720,80)|0;tUa(252408,253080,80,48);E=252712;A=252720;FDa(252408,253008,253136,E,E,E,E,E,A,A,80)|0;tUa(252408,253144,80,45);A=252712;E=252720;FDa(252408,253192,253200,A,A,A,A,A,E,E,80)|0;break};case 3:{tUa(252408,253208,80,38);E=252712;FDa(252408,252936,253248,E,E,E,E,252792,252384,252720,80)|0;tUa(252408,253256,80,28);E=252712;A=252720;FDa(252408,253288,253296,E,E,E,E,E,A,A,80)|0;break};case 6:{tUa(252408,253304,80,44);A=252712;FDa(252408,253352,253360,A,A,A,A,252888,252384,252344,80)|0;tUa(252408,253368,80,57);A=252712;E=252720;FDa(252408,253432,253440,A,A,A,A,A,E,E,80)|0;break};case 7:{tUa(252408,253304,80,44);E=252712;FDa(252408,253352,253448,E,E,E,E,252888,252384,252344,80)|0;tUa(252408,253456,80,48);E=252712;A=252720;FDa(252408,253008,253512,E,E,E,E,E,A,A,80)|0;tUa(252408,253520,80,28);A=252712;E=252720;FDa(252408,253288,253552,A,A,A,A,A,E,E,80)|0;break};case 8:{tUa(252408,253304,80,44);E=252712;FDa(252408,253352,253560,E,E,E,E,252888,252384,252344,80)|0;tUa(252408,253568,80,37);E=252712;A=252720;FDa(252408,253608,253616,E,E,E,E,E,A,A,80)|0;break};case 9:{tUa(252408,253304,80,44);A=252712;FDa(252408,253352,253624,A,A,A,A,252888,252384,252344,80)|0;tUa(252408,253632,80,49);A=252712;E=252720;FDa(252408,252696,253688,A,A,A,A,A,E,E,80)|0;tUa(252408,253696,80,38);E=252712;A=252720;FDa(252408,252936,253736,E,E,E,E,E,A,A,80)|0;break};case 10:{tUa(252408,253304,80,44);A=252712;FDa(252408,253352,253744,A,A,A,A,252888,252384,252344,80)|0;tUa(252408,253752,80,45);A=252712;E=252720;FDa(252408,253192,253800,A,A,A,A,A,E,E,80)|0;tUa(252408,253808,80,36);E=252712;A=252720;FDa(252408,253848,253856,E,E,E,E,E,A,A,80)|0;break};case 11:{tUa(252408,253864,80,40);A=252712;FDa(252408,253912,253920,A,A,A,A,252888,252384,252344,80)|0;tUa(252408,253928,80,36);A=252712;E=252720;FDa(252408,253848,253968,A,A,A,A,A,E,E,80)|0;break};case 12:{tUa(252408,253304,80,44);E=252712;FDa(252408,253352,253976,E,E,E,E,252888,252384,252376,80)|0;tUa(252408,253984,80,45);E=252712;A=252720;FDa(252408,253192,254032,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};default:{tUa(252408,252896,80,38);A=252712;FDa(252408,252936,252944,A,A,A,A,252792,252384,252720,80)|0;tUa(252408,252952,80,48);A=252712;E=252720;FDa(252408,253008,253016,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[31548];h[o+24>>3]=+h[31548];h[o+16>>3]=+h[31543];i=y;return 0}else if((B|0)==215){tUa(252408,254344,80,39);E=252712;A=252720;FDa(252408,254384,254392,E,E,E,E,E,A,A,80)|0;break c}else if((B|0)==216){tUa(252408,254400,80,39);A=252712;E=252720;FDa(252408,254384,254440,A,A,A,A,A,E,E,80)|0;break c}}}while(0);tUa(252408,254448,80,47);r=252712;E=252720;FDa(252408,252776,254496,r,r,r,r,r,E,E,80)|0}else if((B|0)==210){tUa(252408,254040,80,55);E=252712;r=252720;FDa(252408,254096,252792,E,E,E,E,E,r,r,80)|0}}while(0);if((B|0)==227){tUa(252408,255032,80,39);B=252712;FDa(252408,254384,255072,B,B,B,B,252888,j,e,80)|0}if((c[k>>2]|0)==-1){tUa(252408,255224,80,46);e=252712;j=252720;FDa(252408,255272,255280,e,e,e,e,e,j,j,80)|0;tUa(252408,255288,80,47);j=252712;e=252720;FDa(252408,252776,255336,252792,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function HDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[31918]=C;c[t>>2]=0;D=c[e>>2]|0;c[63838]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[63838]|0;E=F+1|0;c[63838]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[31925]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;MDa(g,b,k,l,f,o,m,n)|0;if((c[63218]|0)>0){i=v;return 0}D=d;fe[D&7](f,b,k,e,p,y,z)|0;if((c[63218]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[255408]=0;F=c[e>>2]|0;c[63838]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[255408]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[63838]=F+1;if(!O){break}I=+qUa(255400,255344);h[31922]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[31918];do{if((H- +h[g>>3])*I<0.0){MDa(g,b,k,l,f,o,m,n)|0;if((c[63218]|0)<=0){break}i=v;return 0}else{G=+h[31922]/I;h[31923]=G;P=c[f>>2]|0;c[63838]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[31923];S=S+1|0}c[63838]=P+1}}while(0);fe[D&7](f,b,k,e,p,y,z)|0;if((c[63218]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[255408]=0;F=c[e>>2]|0;c[63838]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[255408]=1;X=1;Y=c[63838]|0}S=Y+1|0;c[63838]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[31918];K=I;break}}else{F=w+320|0;MDa(g,F,k,l,f,o,m,n)|0;if((c[63218]|0)>0){i=v;return 0}E=d;fe[E&7](f,F,k,e,p,y,z)|0;if((c[63218]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[255408]=0;D=c[e>>2]|0;c[63838]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[255408]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[63838]=D+1;if(!aa){i=v;return 0}I=+qUa(255400,255344);h[31922]=I;h[F>>3]=I+ +h[F>>3];I=+h[31922]/+h[31918];h[31923]=I;S=c[f>>2]|0;c[63838]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[31923];T=T+1|0}c[63838]=S+1}fe[E&7](f,F,k,e,p,y,z)|0;if((c[63218]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[255408]=0;T=c[e>>2]|0;c[63838]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[255408]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[63838]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[31921]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}MDa(g,255368,k,l,f,o,m,n)|0;if((c[63218]|0)<=0){break}i=v;return 0}else{h[31921]=K;j=c[f>>2]|0;c[63838]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[63838]=j+1}}while(0);ga=d;fe[ga&7](f,255368,k,e,q,y,z)|0;if((c[63218]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[63848]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){IDa(e,255400,255392,T,255368,p,q,r,255360,s,fa,da,x,ca)|0;if((c[63218]|0)>0){ha=76;break}if((c[63848]|0)>1){ha=73;break}MDa(g,255360,k,l,f,o,m,n)|0;if((c[63218]|0)>0){ha=76;break}fe[ga&7](f,255360,k,e,r,y,z)|0;if((c[63218]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[31920];T=252792;cEa(e,r,T,p,T)|0;if((c[63848]|0)==4){i=v;return 0}MDa(g,255360,k,l,f,o,m,n)|0;if((c[63218]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function IDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[63864]=c[o>>2];c[o>>2]=0;h[31928]=0.0;a[255440]=0;t=c[b>>2]|0;c[63854]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+qUa(255472,j+(v<<3)|0);if(w==+qUa(255472,l+((c[63854]|0)+ -1<<3)|0)){break}y=c[63854]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[31928]){break}h[31928]=B;c[o>>2]=y}else{a[255440]=1}}while(0);v=c[63854]|0;u=v+1|0;c[63854]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[255448]=1;c[63866]=c[p>>2];h[g>>3]=+h[r>>3];t=252792;cEa(b,l,t,k,t)|0;c[p>>2]=1;a[255432]=0;C=0}else{a[255448]=0;c[o>>2]=c[63864];c[63866]=c[p>>2];if(a[255440]&1){h[g>>3]=+h[r>>3];t=252792;cEa(b,l,t,k,t)|0;a[255432]=1;C=1;break}else{t=252792;cEa(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[255432]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[255432]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=252792;cEa(b,k,t,l,t)|0;t=c[b>>2]|0;c[63854]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[63854]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+qUa(255472,j+(u<<3)|0);if(!(A!=+qUa(255472,k+((c[63854]|0)+ -1<<3)|0))){break}c[n+((c[63854]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[63854]|0;F=u+1|0;c[63854]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[31928]=0.0;a[255440]=0;t=c[b>>2]|0;c[63854]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+qUa(255472,j+(v<<3)|0);if(A==+qUa(255472,k+((c[63854]|0)+ -1<<3)|0)){break}y=c[63854]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[31928]){break}h[31928]=I;c[o>>2]=y}else{a[255440]=1}}while(0);v=c[63854]|0;u=v+1|0;c[63854]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[255448]=t&1;if(t){a[255432]=0;c[63866]=0;c[p>>2]=1;break}if(!(a[255440]&1)){t=252792;cEa(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=252792;cEa(b,k,t,l,t)|0;t=c[b>>2]|0;c[63854]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[63854]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[63854]|0}u=K+1|0;c[63854]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[63866]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function JDa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[31937]=+h[d>>3];h[31936]=+h[e>>3];j=c[a>>2]|0;c[63870]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[31937]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[31937]=o;h[31936]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[31936];a=l+1|0;c[63870]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function KDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[31940]=0.0;e=c[a>>2]|0;c[63876]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[31940]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[63876]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[31939]=0.0;e=c[a>>2]|0;c[63876]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[31939]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[63876]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function LDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[63894]=0;c[63892]=0;c[63898]=0;h[31952]=+h[b>>3];h[31954]=+KDa(f,d,l,0,0);C=c[f>>2]|0;c[63882]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[63882]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[31945]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[63882]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[63882]=G+1}a[255624]=1;c[63884]=0;a[255640]=1;c[C>>2]=(c[C>>2]|0)+1;c[63902]=0;fe[B&7](b,d,e,q,255608,n,o)|0;b:do{if((c[63902]|0)<0){K=35}else{while(1){if(a[255624]&1){c[E>>2]=(c[E>>2]|0)+1;a[255624]=0;ODa(f,b,d,e,q,255560,k,255584,l,r,s,t,g,255608,v,j,n,o,x)|0;h[31944]=1.0e6;if((c[63902]|0)<0|(c[63896]|0)!=0){K=35;break b}c[63898]=0}H=c[f>>2]|0;c[63882]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[63882]=H+1}PDa(f,q,s,t)|0;I=c[f>>2]|0;c[63882]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[31945]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[63882]=I+1}N=+KDa(f,q,l,0,0);h[31956]=N;if(N<=+h[v>>3]*100.0*+h[31954]){break}J=c[63884]|0;if((J|0)>0){h[z>>3]=N/+h[31957];h[A>>3]=1.0/+(J|0);O=+oUa(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[31944]=P;Q=+h[31956];R=P}else{h[31957]=N;Q=N;R=+h[31944]}if(R*Q<=.33){break}J=c[63884]|0;H=J+1|0;c[63884]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[255624]=1}c[C>>2]=(c[C>>2]|0)+1;c[63902]=0;fe[B&7](b,d,e,q,255608,n,o)|0;if((c[63902]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[63882]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[63882]=H+1}N=+KDa(f,q,l,0,0);h[31956]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[63882]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[31945]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[63882]=J+1}}while(0);if(!(a[255640]&1)){break}H=c[f>>2]|0;c[63882]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[63882]=H+1}N=+KDa(f,r,l,0,0);h[31950]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[255640]=0}h[b>>3]=+h[31952];G=c[f>>2]|0;c[63882]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[63882]=G+1}if(a[255640]&1){I=(c[63894]|0)+1|0;c[63894]=I;N=.9/(+h[31950]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[31943]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[63896]|0)!=0){I=(c[63898]|0)+1|0;c[63898]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[63902]|0)>-2)){K=53;break}I=(c[63892]|0)+1|0;c[63892]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function MDa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[63928]=o;p=+h[b>>3]- +h[a>>3];h[31962]=p;a=c[f>>2]|0;c[63920]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[63920]=a+1;q=+h[31962]}h[31958]=1.0;h[31959]=0.0;p=q/+h[k>>3];h[31963]=p;c[63922]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[31959]=u*t+s/+h[a>>3];p=t*s;h[31958]=p;h[31963]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[63920]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[31959]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[31958];g=g+1|0}c[63920]=a+1}g=v+1|0;c[63922]=g;if((v|0)>=(o|0)){break}r=+h[31962];s=+h[31958];t=+h[31963];u=+h[31959];v=g}i=l;return 0}



function oEa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+eEa(269656);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+fEa(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+fEa(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+fEa(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function pEa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function qEa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+eEa(269664);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=F5a(u|0,0,t+ -2|0,0)|0;t=y5a(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function rEa(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[33728]=.5;h[33746]=6.283185307179586;v=+h[l>>3];h[33741]=v*v;c[67478]=0;l=c[b>>2]|0;c[67496]=l;c[67494]=l;w=c[b>>2]|0;c[67418]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[67418]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[67418]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[67418]=w+1}z=c[d>>2]|0;c[67422]=1;if((z|0)>=1){e=1;while(1){h[33732]=0.0;A=c[b>>2]|0;c[67420]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[33732]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[67420]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[33732]=v;C=c[b>>2]|0;c[67418]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[33732];F=F+1|0}c[67418]=C+1}F=e+1|0;c[67422]=F;if((e|0)<(z|0)){e=F}else{break}}}c[67432]=0;e=c[b>>2]|0;c[67420]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[67432]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[67418]=H;c[67420]=e+1}do{if((y|0)==0){h[33730]=0.0;h[33712]=0.0;w=c[b>>2]|0;c[67418]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[33712]=+h[33712]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[67418]=w+1}h[r>>3]=0.0;D=+h[33712];if(D==0.0){O=55;break a}h[33717]=0.0;h[33720]=0.0;h[33715]=D;h[33735]=D;P=D;Q=0.0;R=0.0;S=+h[33741];T=0}else{if((y|0)>(x|0)){h[33714]=0.0;h[33721]=0.0;h[33722]=0.0;z=c[b>>2]|0;c[67418]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[33714]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[33721]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[33722]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[67418]=z+1;U=ba;W=$;Z=aa}D=+h[33728];v=D*(+h[33725]-Z);h[33713]=v;_=+h[33718];ca=_+v;h[33729]=ca;h[33733]=ca;h[33731]=ca;c[67488]=0;a[269752]=1;da=+h[33746]/50.0;h[33732]=da;c[67418]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[33731]=ka;c[67488]=w;h[33742]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[33743]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[33737]=ha;h[33723]=ia;h[33726]=ja;h[33734]=ka;c[67418]=50;h[33733]=ka;if((la|0)==0){h[33742]=ka;O=46}else if((la|0)==49){h[33743]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[33743]}h[33737]=0.0;ga=+h[33742];if(ga!=na){ea=ga-ma;h[33742]=ea;ga=na-ma;h[33743]=ga;oa=D*(ea-ga)/(ea+ga);h[33737]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[33737]=oa;ga=+X(+oa);h[33723]=ga;ea=+Y(+oa);h[33726]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[33738]=oa;h[33715]=0.0;w=c[b>>2]|0;c[67418]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[33723]*+h[J>>3]+ +h[33726]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[33715]+sa*sa;h[33715]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[33726];ea=+h[33723];F=F+1|0;z=K}c[67418]=w+1;qa=ta;ra=+h[33738]}ea=ra+ +h[33730];h[33730]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[33721]=0.0;z=c[b>>2]|0;c[67420]=1;do{if((z|0)<1){ea=+h[33745];h[33736]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[33721]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[67420]=z+1;ea=+h[33745];h[33736]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[33712];h[33732]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[33732]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[33736];oa=+h[33715];v=+h[33721];_=oa/v;ca=ea<=_?ea:_;h[33736]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[33715];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[33728]*Ca);h[33727]=ca;h[33730]=+h[33730]+ca;h[33740]=Ba;h[33715]=0.0;z=c[b>>2]|0;c[67418]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[33736]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[33715]+oa*oa;h[33715]=Ga;Ha=+h[33736];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[67418]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[33745]){if(+h[33727]<=+h[33730]*.01){O=55;break a}if(Fa<=+h[33735]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[33740];h[33732]=ca;h[33712]=0.0;h[33717]=0.0;h[33720]=0.0;w=c[b>>2]|0;c[67418]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[33712]+ca*ca;h[33712]=La;J=m+(F<<3)|0;Ma=+h[33717]+ +h[K>>3]*+h[J>>3];h[33717]=Ma;ca=+h[J>>3];Na=+h[33720]+ca*ca;h[33720]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[33732];Ja=Ja+1|0;Ka=J}c[67418]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[33741];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[67494]=y;ua=+h[33715];va=y}if(ua<=+h[33735]*1.0e-4){O=55;break a}h[33718]=0.0;h[33725]=0.0;z=c[b>>2]|0;c[67418]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[33718]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[33725]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[67418]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[33724]=ca;oa=+h[33741];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[67478]=J;_=+V(+(v-ca*ca));h[33732]=_;v=oa/_;h[33742]=v;oa=ca/_;h[33743]=oa;w=c[b>>2]|0;c[67418]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[33743];Ta=+h[33742];Ua=Ua+1|0;Va=K}c[67418]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[67478]=e;v=S-R;h[33732]=v;h[33745]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function sEa(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[33755]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[67516]=t;c[67506]=1;c[67500]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[67506]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[33757]=D;C=+h[x>>3]/D;h[33764]=C;z=+h[f+(B+y<<3)>>3]/D;h[33765]=z;B=c[d>>2]|0;c[67498]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[33757]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[33757];if((x|0)>=(B|0)){break}D=+h[33765];z=+h[33764];x=x+1|0}c[67498]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[67500]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[33764]=z;if((c[g>>2]|0)>1){D=-z;h[33764]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[33765]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[67498]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[33765]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[33764];t=t+1|0;x=A}c[67498]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[33762]=z;x=k+(w<<3)|0;H=+h[x>>3];h[33756]=H;D=H*H;h[33766]=D;h[33763]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[33755];a[270072]=0;do{if((u|0)==1){z=+h[33763];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[33757]=z;D=+h[33764]/z;h[33765]=D;H=+h[33756]/z;h[33764]=H;x=c[d>>2]|0;c[67498]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[33765];D=+h[33764];w=w+1|0;t=s}c[67498]=x+1;J=+h[33757]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[67502]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[67502]=u;M=u}t=u+1-M|0;c[67504]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[33763];z=+h[f+(t+w<<3)>>3]/D;h[33757]=z;h[33764]=z*+h[l>>3];H=+h[33756];h[33765]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[33757]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[33755]/+V(+(+h[33766]+z*N*z));h[33760]=C;if(!(D>=0.0)){O=-D}else{O=D}h[33761]=C*+V(+O);t=c[d>>2]|0;c[67498]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[33761]*(+h[A>>3]- +h[33764]*+h[n+(G<<3)>>3]- +h[33765]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[33757];z=+h[33756];H=+h[33760];v=v+1|0}c[67498]=t+1;P=+h[33763]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[270072]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[67498]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[33757]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[33757];K=Q+1|0;c[67498]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[67500]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[67508]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[33756];N=+h[33763];J=(+h[33762]*+h[f>>3]-O*P)/N;h[33764]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[33765]=P;c[67498]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[67498]=q;if((f|0)>=(b|0)){break a}N=+h[33765];O=+h[33764];f=q}}}while(0);b=R+1|0;c[67500]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function tEa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function uEa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((tEa(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){eb(270136,270152,116,270176)}else if((s|0)==14){i=g;return o|0}return 0}function vEa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((i5a(w,c[270184+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[270288+(x<<2)>>2]|0;c[q>>2]=c[270184+(x<<2)>>2];c[q+4>>2]=y;MBa(23,0,270360,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=M4a(D,8)|0;c[e+40>>2]=B;D=b+536|0;PBa(c[D>>2]|0,(B|0)!=0|0,270400,p);B=M4a(c[A>>2]|0,4)|0;c[e+36>>2]=B;PBa(c[D>>2]|0,(B|0)!=0|0,270400,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=M4a(c[C>>2]|0,4)|0;c[e+24>>2]=K4a(8)|0;C=K4a(4)|0;c[e+20>>2]=C;c[C>>2]=c[241664>>2];PBa(c[D>>2]|0,(C|0)!=0|0,270400,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=K4a(C)|0;A=e+44|0;c[A>>2]=K4a(C)|0;C=M4a(15,4)|0;E=e+12|0;c[E>>2]=C;PBa(c[D>>2]|0,(C|0)!=0|0,270400,m);C=M4a(5,4)|0;c[e+4>>2]=C;PBa(c[D>>2]|0,(C|0)!=0|0,270400,l);C=M4a(5,4)|0;c[e+8>>2]=C;PBa(c[D>>2]|0,(C|0)!=0|0,270400,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=K4a(C)|0;c[e+76>>2]=K4a(C)|0;c[e+80>>2]=K4a(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((me[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){MBa(23,0,270416,j)}else{MBa(1,0,270488,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[241700>>2]|c[60400]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=7;U=T;V=270320;W=V;QBa(Q,W,r)}c[t>>2]=w;OBa(23,1,270216,t);t=1;do{w=c[270288+(t<<2)>>2]|0;c[s>>2]=c[270184+(t<<2)>>2];c[s+4>>2]=w;OBa(23,0,270272,s);t=t+1|0;}while((t|0)<8);je[c[60540]&1023](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=7;U=T;V=270320;W=V;QBa(Q,W,r);return 0}function wEa(a){a=a|0;var b=0;b=i;L4a(c[a+40>>2]|0);L4a(c[a+36>>2]|0);L4a(c[a+20>>2]|0);L4a(c[a+12>>2]|0);L4a(c[a+4>>2]|0);L4a(c[a+8>>2]|0);L4a(a);i=b;return 0}function xEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;PBa(c[N>>2]|0,(c[M>>2]|0)!=0|0,270584,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){MBa(3,0,270616,B);MBa(3,0,270656,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];me[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(3,0,270680,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];MBa(23,0,270720,y);if((c[z>>2]|0)==1){jDa(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){BGa(a)|0;me[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 6:{GDa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 4:{GDa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 7:{GDa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{GDa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 5:{GDa(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){GDa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{GDa(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){yd(_|0)|0;yd($|0)|0;OBa(3,0,270752,x);MBa(3,0,270840,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){yd(_|0)|0;yd($|0)|0;$=GEa(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){BGa(a)|0;me[c[(c[ba>>2]|0)+40>>2]&127](a)|0}me[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];OBa(1,0,270864,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[241620>>2]|0)!=0){MBa(3,1,270896,u);c[s>>2]=c[z>>2];MBa(3,0,270920,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];MBa(3,0,270944,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];MBa(3,0,270976,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];MBa(3,0,271016,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];MBa(3,0,271064,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];MBa(3,0,271112,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];MBa(3,0,271152,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];MBa(3,0,271192,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];MBa(3,0,271232,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];MBa(3,0,271280,f);je[c[60540]&1023](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){eb(271320,271352,410,271384)}MBa(3,0,271400,e);S=0;i=d;return S|0}function yEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;BGa(g)|0;a=f+540|0;me[c[(c[a>>2]|0)+40>>2]&127](g)|0;me[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function zEa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;BGa(l)|0;b=k+540|0;me[c[(c[b>>2]|0)+40>>2]&127](l)|0;me[c[(c[b>>2]|0)+28>>2]&127](l)|0;IEa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function AEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];BGa(g)|0;l=e+540|0;me[c[(c[l>>2]|0)+40>>2]&127](g)|0;me[c[(c[l>>2]|0)+28>>2]&127](g)|0;me[c[(c[l>>2]|0)+32>>2]&127](g)|0;pe[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function BEa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;JEa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function CEa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;BGa(l)|0;b=k+540|0;me[c[(c[b>>2]|0)+40>>2]&127](l)|0;me[c[(c[b>>2]|0)+28>>2]&127](l)|0;HEa(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function DEa(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function EEa(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;KEa(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function FEa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function GEa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-2:{OBa(1,0,271424,k);m=-2;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-1:{OBa(3,0,270752,l);m=1;i=b;return m|0};case-9:{OBa(1,0,271624,f);m=-9;i=b;return m|0};case-12:{OBa(1,0,271896,c);m=-12;i=b;return m|0};case-33:{OBa(1,0,271944,b);m=-33;i=b;return m|0};case-11:{OBa(1,0,271808,d);m=-11;i=b;return m|0};case-8:{OBa(1,0,271576,g);m=-8;i=b;return m|0};case-10:{OBa(1,0,271712,e);m=-10;i=b;return m|0};case-6:{OBa(1,0,271464,j);m=-6;i=b;return m|0};case-7:{OBa(1,0,271536,h);m=-7;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function HEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}me[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function IEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;me[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function JEa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+xd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+xd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;yEa(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function KEa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+xd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+xd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}yEa(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function LEa(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function MEa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;je[c[(c[a+540>>2]|0)+112>>2]&1023](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function NEa(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function OEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=eCa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{Ce[c[(c[l>>2]|0)+104>>2]&127](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;cCa(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=eCa(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function PEa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((OEa(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}QEa(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(eCa(d)|0)>0;h=b?2:0;i=e;return h|0}function QEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=K4a(q)|0;s=r;t=K4a(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[68176]=aCa(4)|0;if((r|0)==0){eb(272712,272728,308,272760)}if((t|0)==0){eb(272776,272728,309,272760)}v=hCa(b)|0;if((v|0)!=0){w=v;do{v=jCa(w)|0;c[l>>2]=c[v>>2];MBa(27,0,272792,l);w=iCa(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;o5a(t|0,c[a+384>>2]|0,v|0)|0;o5a(r|0,l|0,v|0)|0}h[d>>3]=+TEa(a,n,o,q,s,c[68176]|0,b);do{if((eCa(c[68176]|0)|0)==0){s=fCa(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=hCa(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=jCa(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=iCa(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];MBa(27,0,272840,j);v=hCa(b)|0;if((v|0)==0){break}else{B=v}do{v=jCa(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[68176]|0;dCa(v,jCa(B)|0);v=jCa(B)|0;c[g>>2]=c[v>>2];MBa(27,0,272864,g)}B=iCa(B)|0;}while((B|0)!=0)}}while(0);bCa(b);if((c[241636>>2]|0)!=0){eCa(c[68176]|0)|0}if((eCa(c[68176]|0)|0)>0){B=m;do{g=fCa(c[68176]|0)|0;c[m>>2]=c[g>>2];gCa(c[68176]|0);c[f>>2]=c[m>>2];MBa(7,0,272888,f);cCa(b,B);}while((eCa(c[68176]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){o5a(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}cf(a);WEa(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){L4a(t);L4a(r);i=e;return}o5a(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;L4a(t);L4a(r);i=e;return}function REa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){_Ea(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(7,0,272432,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((eCa(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[241636>>2]|0)!=0){e=hCa(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=jCa(s)|0;x=c[e>>2]|0;e=Ce[c[(c[p>>2]|0)+104>>2]&127](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;LBa(7,0,w,272456,l);s=iCa(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=jCa(hCa(d)|0)|0;x=Ce[c[(c[b+540>>2]|0)+104>>2]&127](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;LBa(1,0,e,272472,j);c[s>>2]=1}}while(0);bCa(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;VEa(b);SEa(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function SEa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;MBa(27,0,273080,b);d=a+344|0;pe[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function TEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=K4a(p<<3)|0;if((q|0)==0){eb(272896,272728,409,272912)}if((p|0)>0){o5a(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];MBa(27,0,272928,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(27,0,272976,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){L4a(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}BGa(a)|0;me[c[(c[p>>2]|0)+40>>2]&127](a)|0;me[c[(c[p>>2]|0)+28>>2]&127](a)|0;me[c[(c[p>>2]|0)+32>>2]&127](a)|0;pe[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(UEa(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}o5a(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}L4a(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function UEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;bCa(b);MBa(27,0,273e3,g);g=hCa(d)|0;if((g|0)==0){j=eCa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=jCa(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=jCa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=jCa(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=jCa(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=jCa(a)|0;o=c[g>>2]|0;g=jCa(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?272416:272424;g=jCa(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?272416:272424;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;MBa(27,0,273040,f);cCa(b,jCa(a)|0)}a=iCa(a)|0;}while((a|0)!=0);j=eCa(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function VEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;Ce[c[(c[g>>2]|0)+96>>2]&127](b,1)|0;WEa(b);XEa(b);me[c[(c[g>>2]|0)+36>>2]&127](b)|0;YEa(b,8);h=ZEa(b)|0;j=me[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{XEa(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}_Ea(b);WEa(b);YEa(b,8);me[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=ZEa(b)|0;j=me[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){QBa(c[b+536>>2]|0,273120,e)}else if((o|0)==7){XEa(b);i=d;return}}function WEa(a){a=a|0;var b=0;b=i;o5a(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function XEa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function YEa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[241608+(d<<2)>>2]|0)==0){i=e;return}MBa(d,1,273544,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=me[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=me[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;MBa(d,0,273568,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}je[c[60540]&1023](d);i=e;return}function ZEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function _Ea(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;o5a(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;o5a(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;o5a(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;o5a(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function $Ea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}pe[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function aFa(a){a=a|0;var b=0;b=i;bFa(a);cFa(a);_Ea(a);dFa(a);i=b;return}function bFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function cFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function dFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((iDa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];o5a(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;o5a(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;o5a(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;o5a(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(iDa(c[d>>2]|0)|0));i=b;return}function eFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[241608+(d<<2)>>2]|0)==0){i=e;return}MBa(d,1,273216,q);q=b+136|0;if((c[q>>2]|0)>0){MBa(d,1,273240,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?273200:273208;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];MBa(d,0,273256,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}je[c[60540]&1023](d)}s=b+140|0;if((c[s>>2]|0)>0){MBa(d,1,273312,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?273200:273208;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;MBa(d,0,273336,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}je[c[60540]&1023](d)}o=b+144|0;if((c[o>>2]|0)>0){MBa(d,1,273392,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?273200:273208;v=(a[n+(m*48|0)+40|0]|0)!=0?273200:273208;n=(a[(c[s>>2]|0)+m|0]|0)!=0?273200:273208;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;MBa(d,0,273416,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}je[c[60540]&1023](d)}m=b+148|0;if((c[m>>2]|0)>0){MBa(d,1,273472,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;MBa(d,0,273496,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}je[c[60540]&1023](d)}je[c[60540]&1023](d);i=e;return}function fFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((iDa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];o5a(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;o5a(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;o5a(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;o5a(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(iDa(c[d>>2]|0)|0));i=b;return}function gFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function hFa(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];o5a(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;o5a(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;o5a(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;o5a(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function iFa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=dDa(3,32)|0;c[o>>2]=p;if((p|0)==0){QBa(c[b+536>>2]|0,273600,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=M4a(c[p>>2]|0,8)|0;c[q>>2]=z;PBa(c[r>>2]|0,(z|0)!=0|0,273656,l);z=M4a(c[s>>2]|0,4)|0;c[t>>2]=z;PBa(c[r>>2]|0,(z|0)!=0|0,273656,k);z=M4a(c[u>>2]|0,1)|0;c[v>>2]=z;PBa(c[r>>2]|0,(z|0)!=0|0,273656,j);z=M4a(c[w>>2]|0,4)|0;c[x>>2]=z;PBa(c[r>>2]|0,(z|0)!=0|0,273656,g);hDa(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=M4a(3,4)|0;c[b+4>>2]=n;jDa(c[o>>2]|0,0,n);c[b+8>>2]=M4a(c[p>>2]|0,112)|0;c[b+12>>2]=M4a(c[s>>2]|0,60)|0;c[b+16>>2]=M4a(c[u>>2]|0,48)|0;c[b+20>>2]=M4a(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=M4a(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=M4a(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=M4a(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=M4a(g,52)|0;c[b+40>>2]=M4a(c[b+216>>2]|0,52)|0;c[b+44>>2]=M4a(c[b+220>>2]|0,52)|0;c[b+48>>2]=M4a(c[b+224>>2]|0,52)|0;c[b+52>>2]=M4a(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=M4a(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=M4a(x,8)|0;c[b+340>>2]=M4a(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=M4a(x,8)|0;c[b+348>>2]=M4a(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=M4a(j,1)|0;c[b+356>>2]=M4a(j,1)|0;c[b+360>>2]=M4a(j,1)|0;j=K4a(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=K4a(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=M4a(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=M4a(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=M4a(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=M4a(u,4)|0;c[b+400>>2]=M4a(x,8)|0;c[b+404>>2]=M4a(p,4)|0;c[b+408>>2]=M4a(s,1)|0;c[b+412>>2]=M4a(u,4)|0;c[b+416>>2]=M4a(c[n>>2]|0,8)|0;c[b+420>>2]=M4a(o,4)|0;c[b+424>>2]=M4a(y,1)|0;c[b+428>>2]=M4a(g,4)|0;c[b+432>>2]=M4a(c[b+152>>2]|0,8)|0;c[b+436>>2]=M4a(c[b+156>>2]|0,8)|0;g=K4a((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;je[c[(c[y>>2]|0)+20>>2]&1023](g);g=K4a((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;je[c[(c[y>>2]|0)+16>>2]&1023](g);g=K4a((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;je[c[(c[y>>2]|0)+12>>2]&1023](g);g=K4a((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ke[c[(c[y>>2]|0)+24>>2]&255](g,b);c[b+464>>2]=K4a((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=M4a(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;PBa(c[r>>2]|0,(g|0)!=0|0,273672,f);c[b+512>>2]=100;c[b+516>>2]=M4a(100,4)|0;c[b+520>>2]=M4a(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=K4a(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;PBa(c[r>>2]|0,(g|0)!=0|0,273656,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=dDa(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function jFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;L4a(c[g+8>>2]|0);L4a(c[g+12>>2]|0);L4a(c[g+16>>2]|0);L4a(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);L4a(e);eDa(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){CDa(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}L4a(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){CDa(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}L4a(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){CDa(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}L4a(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){CDa(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}L4a(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){CDa(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}L4a(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){CDa(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}L4a(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){CDa(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}L4a(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){CDa(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}L4a(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){CDa(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}L4a(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){CDa(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}L4a(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){CDa(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}L4a(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){CDa(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}L4a(v);L4a(c[a+108>>2]|0);L4a(c[a+336>>2]|0);L4a(c[a+340>>2]|0);L4a(c[a+344>>2]|0);L4a(c[a+348>>2]|0);L4a(c[a+352>>2]|0);L4a(c[a+356>>2]|0);L4a(c[a+360>>2]|0);L4a(c[a+368>>2]|0);L4a(c[a+384>>2]|0);L4a(c[a+388>>2]|0);L4a(c[a+392>>2]|0);L4a(c[a+396>>2]|0);L4a(c[a+400>>2]|0);L4a(c[a+404>>2]|0);L4a(c[a+408>>2]|0);L4a(c[a+412>>2]|0);L4a(c[a+416>>2]|0);L4a(c[a+420>>2]|0);L4a(c[a+424>>2]|0);L4a(c[a+428>>2]|0);L4a(c[a+488>>2]|0);L4a(c[a+484>>2]|0);L4a(c[a+476>>2]|0);L4a(c[a+468>>2]|0);L4a(c[a+464>>2]|0);L4a(c[a+432>>2]|0);L4a(c[a+436>>2]|0);L4a(c[a+320>>2]|0);L4a(c[a+516>>2]|0);L4a(c[a+520>>2]|0);cUa(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;L4a(x);i=b;return}else{y=a;z=0}while(1){eDa(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;L4a(x);i=b;return}function kFa(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[34214]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];MBa(8,0,273720,d);i=b;return}function lFa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[34214];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function mFa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(nFa(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function nFa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[34214];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function oFa(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(lFa(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function pFa(a,b){a=+a;b=+b;i=i;return a<b|0}function qFa(a,b){a=+a;b=+b;i=i;return a<=b|0}function rFa(a,b){a=+a;b=+b;i=i;return a>b|0}function sFa(a,b){a=+a;b=+b;i=i;return a>=b|0}function tFa(b,d,e){b=+b;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0,l=0;f=i;do{if((a[e+314|0]|0)==0){g=3}else{if((a[e+318|0]|0)!=0){g=3;break}j=+(~~+T(+b)|0);k=e+364|0;h[(c[k>>2]|0)+(d<<3)>>3]=j;l=k}}while(0);if((g|0)==3){l=e+364|0}i=f;return~~+h[(c[l>>2]|0)+(d<<3)>>3]|0}function uFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=K4a(k)|0;c[e+(h*40|0)+24>>2]=K4a(k)|0;if((c[g>>2]|0)!=1){l=5;break}yFa(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){QBa(c[a+536>>2]|0,273776,d)}else if((l|0)==6){i=b;return 0}return 0}function vFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){L4a(c[e+(h*40|0)+20>>2]|0);L4a(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;zFa(k)|0;L4a(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){QBa(c[a+536>>2]|0,273776,d)}else if((j|0)==6){i=b;return 0}return 0}function wFa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;if((c[b+296>>2]|0)==1){f=c[b+484>>2]|0;a[f+(d*40|0)+36|0]=BFa(b,d)|0;i=e;return 0}else{QBa(c[b+536>>2]|0,273776,e)}return 0}function xFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[241676>>2]|c[60400]|0)==0){z=w;A=1;break}aUa(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];OBa(17,1,273808,g);aUa(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;aUa(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;OBa(17,0,273840,f);aUa(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}je[c[60540]&1023](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function yFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=K4a(20)|0;c[b>>2]=f;PBa(0,(f|0)!=0|0,273848,e);e=K4a(a)|0;c[f>>2]=e;e=K4a(a)|0;c[f+4>>2]=e;e=K4a(a)|0;c[f+8>>2]=e;e=K4a(a)|0;c[f+16>>2]=e;PBa(0,(c[b>>2]|0)!=0|0,273880,d);i=d;return 0}function zFa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;L4a(c[d>>2]|0);L4a(c[d+4>>2]|0);L4a(c[d+8>>2]|0);L4a(c[d+16>>2]|0);i=b;return 0}function AFa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=(c|0)>0;a:do{if(e){f=0;g=0;do{g=((a[b+f|0]|0)==1)+g|0;f=f+1|0;}while((f|0)<(c|0));f=c+ -1|0;if(e){h=f}else{j=f;k=f;l=g;break}while(1){m=h+ -1|0;if((a[b+h|0]|0)!=0){j=f;k=h;l=g;break a}if((h|0)>0){h=m}else{j=f;k=m;l=g;break}}}else{g=c+ -1|0;j=g;k=g;l=0}}while(0);if((l|0)==(c|0)){n=0;i=d;return n|0}if((k|0)==-1){a[b]=1;n=1;i=d;return n|0}if((k|0)<(j|0)){a[b+k|0]=0;a[b+(k+1)|0]=1;n=1;i=d;return n|0}k=c+ -2|0;b:do{if((k|0)>-1){h=0;e=k;g=1;while(1){o=0;p=e;while(1){q=b+p|0;if((a[q]|0)!=0){break}if((p|0)>0){o=o+1|0;p=p+ -1|0}else{break b}}r=p+1|0;if((a[b+r|0]|0)==0){break}if((p|0)>0){h=h+1|0;e=p+ -1|0;g=g+1|0}else{break b}}f=r+g|0;a[q]=0;if((p|0)<(f|0)){q5a(b+(e+1-o)|0,1,h+2|0)|0}if((f|0)>=(j|0)){n=1;i=d;return n|0}q5a(b+(h+3+e-o)|0,0,c+ -3-h-e+o|0)|0;n=1;i=d;return n|0}}while(0);if((l|0)>=0){q5a(b|0,1,l+1|0)|0}if((l|0)>=(j|0)){n=1;i=d;return n|0}q5a(b+(l+1)|0,0,j-l|0)|0;n=1;i=d;return n|0}function BFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0;e=i;i=i+16|0;f=e;g=c[b+484>>2]|0;j=c[g+(d*40|0)+28>>2]|0;l=c[g+(d*40|0)+4>>2]|0;m=b+4|0;n=j+16|0;o=g+(d*40|0)|0;q5a(c[n>>2]|0,0,c[o>>2]|0)|0;p=c[o>>2]|0;q=g+(d*40|0)+20|0;if((p|0)>0){r=j+8|0;s=0;while(1){a[(c[r>>2]|0)+s|0]=a[c[(c[q>>2]|0)+(s<<2)>>2]|0]|0;t=s+1|0;u=c[o>>2]|0;if((t|0)<(u|0)){s=t}else{v=u;break}}}else{v=p}p=g+(d*40|0)+12|0;s=b;r=g+(d*40|0)+16|0;u=g+(d*40|0)+8|0;t=j+4|0;w=g+(d*40|0)+24|0;d=v;v=0;a:while(1){if((d|0)>0){g=0;do{a[(c[j>>2]|0)+g|0]=a[c[(c[q>>2]|0)+(g<<2)>>2]|0]|0;g=g+1|0;}while((g|0)<(c[o>>2]|0))}je[c[p>>2]&1023](s);je[c[r>>2]&1023](s);if((c[o>>2]|0)>0){g=0;do{a[(c[t>>2]|0)+g|0]=a[c[(c[q>>2]|0)+(g<<2)>>2]|0]|0;g=g+1|0;}while((g|0)<(c[o>>2]|0))}g=a[u]|0;if((ZEa(b)|0)<<24>>24==0){x=g;y=v}else{WEa(b);je[c[r>>2]&1023](s);x=(v|0)>200?-4:g;y=v+1|0}if((x|0)==-1){z=24;break}g=c[o>>2]|0;if((g|0)<=0){z=21;break}A=c[j>>2]|0;B=c[t>>2]|0;C=0;while(1){D=C+1|0;if((a[A+C|0]|0)!=(a[B+C|0]|0)){break}if((D|0)<(g|0)){C=D}else{z=21;break a}}if((AFa(c[n>>2]|0,g)|0)<<24>>24==0){z=19;break}C=c[o>>2]|0;if((C|0)>0){B=0;while(1){a[c[(c[q>>2]|0)+(B<<2)>>2]|0]=(a[c[(c[w>>2]|0)+(B<<2)>>2]|0]|0)!=(a[(c[n>>2]|0)+B|0]|0)|0;A=B+1|0;D=c[o>>2]|0;if((A|0)<(D|0)){B=A}else{E=D;break}}}else{E=C}d=E;v=y+1|0}do{if((z|0)==19){if((a[b+312|0]|0)==0){F=+h[c[c[m>>2]>>2]>>3];c[f>>2]=l;y=f+4|0;h[k>>3]=F;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];OBa(1,0,273928,f)}a[b+315|0]=1;z=24}else if((z|0)==21){if((c[241676>>2]|0)==0){G=1}else{H=1;break}i=e;return G|0}}while(0);do{if((z|0)==24){if((c[241676>>2]|0)==0){G=0}else{H=0;break}i=e;return G|0}}while(0);je[c[60540]&1023](17);G=H;i=e;return G|0}function CFa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;QBa(c[a+536>>2]|0,273992,b);return 0}function DFa(a){a=a|0;a=i;i=i+8|0;QBa(0,273992,a);return 0}function EFa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;QBa(c[a+536>>2]|0,273992,b);return 0}function FFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=K4a(l)|0;c[e+(h<<6)+36>>2]=K4a(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;OFa(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=K4a(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;LFa(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){QBa(c[a+536>>2]|0,274032,d)}else if((n|0)==8){i=b;return 0}return 0}function GFa(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function HFa(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;xb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function IFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){L4a(c[e+(h<<6)+28>>2]|0);L4a(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){MFa(e+(h<<6)+24|0)|0;L4a(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){PFa(e+(h<<6)+24|0)|0}else{k=6;break}L4a(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){QBa(c[a+536>>2]|0,274032,d)}else if((k|0)==8){i=b;return 0}return 0}function JFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=QFa(b,d)|0}else if((h|0)==1){j=NFa(b,d)|0}else{QBa(c[b+536>>2]|0,274032,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function KFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[241668>>2]|c[60400]|0)==0){z=w;A=1;break}aUa(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];OBa(15,1,274064,g);aUa(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;aUa(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;OBa(15,0,274096,f);aUa(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}je[c[60540]&1023](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function LFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=K4a(12)|0;f=K4a(a<<2)|0;c[e>>2]=f;PBa(0,(f|0)!=0|0,274104,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function MFa(a){a=a|0;var b=0;b=i;L4a(c[c[a>>2]>>2]|0);i=b;return 0}function NFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;q5a(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ke[c[x>>2]&255](C,D);ke[c[w+(d<<6)+4>>2]&255](C,D);if((c[241672>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;MBa(16,1,274160,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kc(D|0,274184,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;MBa(16,0,274200,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;MBa(16,1,274208,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];kc(D|0,274184,o|0)|0;c[n>>2]=D;MBa(16,0,274200,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;MBa(16,1,274208,s)}}while(0);je[c[60540]&1023](16)}s=w+(d<<6)+36|0;A=y+8|0;qwa(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;OBa(1,0,274224,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;o5a(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;o5a(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;OBa(1,0,274312,l);if((c[241668>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;o5a(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];kc(l|0,274416,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];kc(l|0,274416,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;o5a(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];kc(l|0,274416,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;o5a(M|0,O|0,Q|0)|0;i=e;return F|0}function OFa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=K4a(32)|0;PBa(0,(g|0)!=0|0,274424,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;ae(0,d|0)|0;Rd(c[d>>2]|0,c[b>>2]|0,0)|0;ae(0,g+4|0)|0;Rd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;db(b|0)|0;Nb(274472,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function PFa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Dd(c[d+12>>2]|0)|0;Mb(c[d+8>>2]|0)|0;Mb(c[d+4>>2]|0)|0;i=b;return 0}function QFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;od(c[g>>2]|0)|0;Yd(0,g|0)|0;j=g+24|0;Rb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ke[c[f>>2]&255](k,a);Yc(c[g>>2]|0,1)|0;Wa(c[g>>2]|0)|0;ke[c[e+(b<<6)+4>>2]&255](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){jd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(pc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Lb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;od(c[g>>2]|0)|0;i=d;return l|0}function RFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;PBa(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,274640,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){PBa(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,274680,e);if((me[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=K4a(p)|0;c[g+(m*80|0)+52>>2]=K4a(p)|0;c[g+(m*80|0)+48>>2]=K4a(p)|0;c[g+(m*80|0)+16>>2]=K4a(p)|0;c[g+(m*80|0)+8>>2]=K4a(p)|0;c[g+(m*80|0)+12>>2]=K4a(p)|0;ke[c[g+(m*80|0)+36>>2]&255](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){cGa(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){cGa(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){WFa(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){CFa(a,n)|0;break}else{q=12;break a}}}while(0);n=m+1|0;if((n|0)<(c[h>>2]|0)){m=n}else{q=14;break}}if((q|0)==12){QBa(c[j>>2]|0,274720,d)}else if((q|0)==14){i=b;return 0}return 0}function SFa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;L4a(c[e+(h*80|0)+44>>2]|0);L4a(c[e+(h*80|0)+52>>2]|0);L4a(c[e+(h*80|0)+48>>2]|0);L4a(c[e+(h*80|0)+16>>2]|0);L4a(c[e+(h*80|0)+8>>2]|0);L4a(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;dGa(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==1){n=e+(h*80|0)+40|0;XFa(n)|0;l=n;break}else if((k|0)==3){k=e+(h*80|0)+40|0;dGa(k)|0;l=k;break}else{m=9;break a}}}while(0);L4a(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){DFa(j)|0}else if((m|0)==9){QBa(c[a+536>>2]|0,274720,d)}else if((m|0)==11){i=b;return 0}return 0}function TFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(fGa(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(EFa(b,d)|0)&255;break}else if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=YFa(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(fGa(b,d)|0)&255;break}else{QBa(c[b+536>>2]|0,274720,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function UFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;aUa(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];NBa(17,1,u,274752,m);do{if((a[b+312|0]|0)==0){aUa(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;aUa(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;OBa(17,0,274952,f);aUa(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{OBa(17,1,274792,l);aUa(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;aUa(q,d,c[v>>2]|0);if((i5a(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];OBa(17,0,274872,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;aUa(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;OBa(17,0,274912,g);G=E}aUa(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[241676>>2]|c[60400]|0)==0){break}je[c[60540]&1023](17)}}while(0);if((c[241676>>2]|c[60400]|0)==0){x=1;i=e;return x|0}je[c[60540]&1023](17);x=1;i=e;return x|0}function VFa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function WFa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=K4a(144)|0;c[b>>2]=f;PBa(0,(f|0)!=0|0,274968,e);c[f>>2]=0;e=a<<3;g=K4a(e)|0;c[f+4>>2]=g;g=K4a(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=K4a(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=K4a(e)|0;c[f+24>>2]=g;g=M4a(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=K4a(e)|0;c[f+64>>2]=g;g=K4a(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=M4a(g,8)|0;c[f+104>>2]=j;j=M4a(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=K4a(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=K4a(e)|0;c[f+124>>2]=j;j=K4a(e)|0;c[f+128>>2]=j;j=K4a(e)|0;c[f+132>>2]=j;j=K4a(e)|0;c[f+136>>2]=j;j=K4a(e)|0;c[f+140>>2]=j;PBa(0,(c[b>>2]|0)!=0|0,275e3,d);i=d;return 0}function XFa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;L4a(c[d+4>>2]|0);L4a(c[d+16>>2]|0);L4a(c[d+12>>2]|0);L4a(c[d+24>>2]|0);L4a(c[d+28>>2]|0);L4a(c[d+64>>2]|0);L4a(c[d+68>>2]|0);L4a(c[d+104>>2]|0);L4a(c[d+108>>2]|0);L4a(c[d+116>>2]|0);L4a(c[d+124>>2]|0);L4a(c[d+128>>2]|0);L4a(c[d+132>>2]|0);L4a(c[d+136>>2]|0);L4a(c[d+140>>2]|0);i=b;return 0}function YFa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=K4a(c[Y>>2]|0)|0;if((c[241676>>2]|0)!=0){aUa(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];MBa(17,1,275040,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];MBa(17,1,275096,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];MBa(17,0,275112,F);je[c[60540]&1023](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}je[c[60540]&1023](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){o5a(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{o5a(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+xd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;ZFa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+xd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[241680>>2]|0)!=0){_Fa(c[Q>>2]|0,$,18,275152);_Fa(c[ca>>2]|0,$,18,275184)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[241680>>2]|0)!=0){_Fa(c[ca>>2]|0,$,18,275216)}a[da]=R;gEa(11,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){aUa(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];BDa(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;ZFa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;ZFa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}WEa(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[241680>>2]|0)!=0){MBa(18,1,275256,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];MBa(18,1,275296,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];MBa(18,0,275328,C);je[c[60540]&1023](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}je[c[60540]&1023](18)}if((c[241684>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;MBa(19,1,275360,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];kc(Ja|0,275384,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;MBa(19,0,275392,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}je[c[60540]&1023](19)}h[K>>3]=+fEa($,c[Ia>>2]|0);h[J>>3]=+fEa($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}o5a(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];MBa(17,0,275440,w);$Fa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}MBa(17,0,275512,v);$Fa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+xd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}MBa(17,0,275576,u);$Fa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+xd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}MBa(17,0,275648,t);$Fa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}o5a(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;o5a(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}MBa(17,0,275712,s);$Fa(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){o5a(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}MBa(17,0,275784,r);$Fa(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}MBa(17,0,275856,q);$Fa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}MBa(17,0,275928,p);$Fa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){o5a(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}MBa(17,0,275992,o);$Fa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}MBa(17,0,276064,n);$Fa(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];MBa(17,0,276200,l);$Fa(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){o5a(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{o5a(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}MBa(17,0,276128,m);$Fa(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[241676>>2]|0)!=0){MBa(17,1,275400,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;MBa(17,0,275416,x);je[c[60540]&1023](17);$Fa(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}o5a(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;ZFa($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;L4a(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;L4a(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;L4a(Z);i=e;return kb|0}if((a[Ha]|0)==0){aUa(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];BDa(0,f,hb);}if((c[241676>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;MBa(17,0,276272,j);$Fa(S,L,J,K,17)}o5a(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;L4a(Z);i=e;return kb|0}return 0}function ZFa(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[241688>>2]|0)!=0){c[u>>2]=c[y+96>>2];MBa(20,0,276520,u);_Fa(d,b,20,276552)}Ne[c[x+(m*80|0)+32>>2]&127](l,d,e,j);if((c[241688>>2]|0)!=0){_Fa(e,b,20,276568);c[t>>2]=c[y+96>>2];MBa(20,0,276584,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[241688>>2]|0)!=0){MBa(20,0,276624,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){bGa(w,f,d,e,m)}else{aGa(w,f,m)}do{if((c[241688>>2]|0)!=0){MBa(20,0,276664,r);if((c[241684>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;MBa(19,1,275360,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kc(m|0,276696,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;MBa(19,0,275392,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}je[c[60540]&1023](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;QBa(g,276712,n)}return 0}function _Fa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[241608+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;MBa(d,1,275392,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];MBa(d,0,276504,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}je[c[60540]&1023](d);i=f;return}function $Fa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[241608+(f<<2)>>2]|0)==0){i=g;return}MBa(f,1,276312,q);MBa(f,1,276328,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];MBa(f,0,276344,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}je[c[60540]&1023](f);MBa(f,1,276384,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];MBa(f,0,276400,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}je[c[60540]&1023](f);MBa(f,1,276440,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];MBa(f,0,276456,j);je[c[60540]&1023](f);je[c[60540]&1023](f);i=g;return}function aGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;q5a(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;q5a(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}me[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function bGa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+xd(+(n*+xd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;ZFa(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function cGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=K4a(80)|0;c[b>>2]=f;PBa(0,(f|0)!=0|0,276792,e);c[f>>2]=0;e=a<<3;g=K4a(e)|0;c[f+4>>2]=g;g=K4a(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=K4a(e)|0;c[f+16>>2]=g;g=M4a(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=K4a(fa(e,a)|0)|0;c[f+64>>2]=g;g=K4a(e)|0;c[f+68>>2]=g;g=K4a(a<<2)|0;c[f+72>>2]=g;PBa(0,(c[b>>2]|0)!=0|0,276824,d);i=d;return 0}function dGa(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;L4a(c[d+4>>2]|0);L4a(c[d+8>>2]|0);L4a(c[d+16>>2]|0);L4a(c[d+20>>2]|0);L4a(c[d+64>>2]|0);L4a(c[d+68>>2]|0);L4a(c[d+72>>2]|0);i=b;return 0}function eGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;q5a(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}me[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}



function NDa(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[31985]=+h[b>>3];c[63948]=0;c[63956]=0;c[63950]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[31997]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[63944]=(c[I>>2]|0)+1;c[63946]=(c[I>>2]|0)+2;c[63942]=(c[I>>2]|0)+ -1;h[31985]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[63960]=$+1;$=c[63944]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[31988]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[63930]=2;if(($|0)>=2){Y=2;while(1){h[31989]=+h[y+(Y+ -2<<3)>>3];U=+h[31988];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[31989];U=+h[31989]+ +h[k>>3];h[31988]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[63930]=$+1}h[y+($+ -1<<3)>>3]=+h[31988]}h[31995]=0.0;h[31993]=0.0;Y=c[I>>2]|0;c[63930]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[31995]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[31993]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[63930]=Y+1;da=ea}h[31996]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[31995]- +h[31993];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[31970]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[31970]=ha>=ca?ha:ca;h[31988]=.6;h[31989]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[31996]){h[D>>3]=100.0}aa=c[63944]|0;ba=c[63960]|0;if((aa|0)>=(ba|0)){c[63932]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[63930]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[63930]=ba+1}ja=ia+1|0;c[63932]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[63930]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[63930]=ia+1}aa=c[63944]|0;c[63932]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[63930]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[63930]=$+1}la=ba+1|0;c[63932]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[31992]=+KDa(f,d,l,0,0);a[255984]=1;c[63934]=0;c[T>>2]=(c[T>>2]|0)+1;c[63964]=0;fe[m&7](b,d,e,r,255856,o,p)|0;if((c[63964]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;ODa(f,b,d,e,r,A,k,255808,l,s,t,u,g,255856,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[63964]|0)<0|(c[63952]|0)!=0){X=70;break}c[63956]=0}ba=c[f>>2]|0;c[63930]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[63930]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[31988]=ca;aa=c[f>>2]|0;c[63930]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[31988];ia=ia+1|0;la=ka}c[63930]=aa+1}PDa(f,r,t,u)|0;la=c[f>>2]|0;c[63930]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[63930]=la+1}U=+KDa(f,r,l,0,0);h[31997]=U;if(U<=+h[F>>3]*100.0*+h[31992]){X=63;break a}ia=c[63934]|0;if((ia|0)>0){h[O>>3]=U/+h[31999];h[P>>3]=1.0/+(ia|0);ca=+oUa(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[31997];oa=ga}else{h[31999]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[63934]|0;c[63934]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[63964]=0;fe[m&7](b,d,e,r,255856,o,p)|0;if((c[63964]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[63930]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[63930]=ba+1}U=+KDa(f,r,l,0,0);h[31997]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[63930]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[63930]=ia+1}}while(0);if((X|0)==70){X=0;a[255984]=0}c[H>>2]=1;if(a[255984]&1){U=+KDa(f,s,l,0,0);h[31991]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[31977]=ga;h[31984]=ga*+(ba+1|0);h[31979]=ga;c[63966]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[63930]=1;if((ba|0)>=1){aa=fa(c[63944]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[63930]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+KDa(f,r,l,0,0);h[31986]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[31994]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[63930]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[63930]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+KDa(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[31994];if((sa>=ca?sa:ca)>+h[31984]){break}ta=+h[31986];ua=Y}else{if(!(ga<=+h[31984]*.5)){break}else{ta=U;ua=ka}}c[63966]=ua+ -1;h[31979]=ta}}while(0);if(!(+h[31970]*+h[31991]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[31985];Y=c[63944]|0;ia=c[63960]|0;if((Y|0)>=(ia|0)){c[63932]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[31988]=ca;ia=c[f>>2]|0;c[63930]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[31988];ja=ja+1|0}c[63930]=ia+1}ja=aa+1|0;c[63932]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[63930]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[63930]=Y+1}if(!(a[255984]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[63952]|0)!=0){aa=(c[63956]|0)+1|0;c[63956]=aa;h[31968]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[63964]|0)>-2)){X=146;break}aa=(c[63948]|0)+1|0;c[63948]=aa;h[31968]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[63950]=(c[63950]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[63950]|0;if((aa|0)<=1){ja=c[63966]|0;c[I>>2]=ja;sa=+(ja+1|0);h[31989]=sa;h[O>>3]=+h[31979]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+oUa(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[31968]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[63966];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[63980]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[63966]|0;E=c[63942]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[63944];za=+h[k>>3]*2.0;h[31981]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[63942]|0;Ba=c[63966]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[63944]|0)>=(c[K>>2]|0)|(c[63980]|0)==1){Fa=G;break}G=c[f>>2]|0;c[63930]=1;if((G|0)>=1){E=fa(c[63946]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[63930]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+KDa(f,r,l,0,0);h[31987]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[31984];E=xa<=za;if(+h[31994]<=(E?xa:za)){Ea=c[63942]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[31984]*.5){Fa=S;break}}S=c[63944]|0;c[I>>2]=S;h[31979]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[31979]=+h[31986];Fa=Ea}h[31981]=+h[k>>3];ya=+(Fa+1|0);h[31989]=ya;h[O>>3]=+h[31979]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+oUa(O,P);h[31968]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[31981];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[31968]=xa;za=+h[k>>3]*xa;h[31981]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[31981]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[63930]=1;if((k|0)<1){break}u=fa(c[63946]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[63930]=k+1}}while(0);Ca=c[f>>2]|0;c[63930]=1;if((Ca|0)>=1){J=fa(c[63944]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[63930]=Ca+1}Ca=c[63944]|0;c[63938]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[63932]=P;s=c[f>>2]|0;c[63930]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[63930]=s+1}P=Ha+1|0;c[63938]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[63964]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[63950]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}MDa(b,b,d,e,f,I,q,y)|0;i=N;return 0}function ODa(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[64e3]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[64e3]=P?2:U+1|0}le[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[64034]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==5){R=q+4|0;T=(c[R>>2]|0)+(c[q>>2]|0)|0;S=T+1|0;c[64026]=S;X=c[b>>2]|0;c[64016]=(T|0)<(X|0)?S:X;X=c[q>>2]|0;c[64034]=S+X;c[64020]=X+T;T=(c[b>>2]|0)/(S|0)|0;c[64030]=T+1;S=c[x>>2]|0;c[64028]=S+ -1;c[64038]=S+T;c[s>>2]=0;h[32012]=+V(+(+h[t>>3]));T=c[64016]|0;c[64002]=1;if((T|0)<1){W=75;break}S=r;X=1;while(1){Y=c[b>>2]|0;Z=c[64026]|0;c[64008]=X;_=(Z|0)<0;b:do{if(_?(X|0)>=(Y|0):(X|0)<=(Y|0)){$=Z;aa=X;ba=X;while(1){ca=(ba-aa|0)/($|0)|0;c[64004]=ca+1;da=ba+ -1|0;ea=e+(da<<3)|0;h[p+((c[64028]|0)+ca<<3)>>3]=+h[ea>>3];ga=f+(da<<3)|0;h[p+((c[64038]|0)+ca<<3)>>3]=+h[ga>>3];ha=+h[ea>>3];h[N>>3]=ha;if(!(ha>=0.0)){ia=-ha}else{ia=ha}ha=+h[l>>3]*+h[ga>>3];if(!(ha>=0.0)){ja=-ha}else{ja=ha}ha=ia>=ja?ia:ja;ka=+h[n+(da<<3)>>3];if(!(ka>=0.0)){la=-ka}else{la=ka}h[32009]=+h[32012]*(ha>=la?ha:la);h[N>>3]=+h[l>>3]*+h[ga>>3];ha=+qUa(256072,N);h[32009]=ha;ga=c[64008]|0;da=ga+ -1|0;ea=e+(da<<3)|0;ka=+h[ea>>3];ma=ha+ka-ka;h[32009]=ma;h[ea>>3]=+h[ea>>3]+ma;ea=f+(da<<3)|0;h[ea>>3]=+h[j>>3]*+h[32009]+ +h[ea>>3];ea=ga+Z|0;c[64008]=ea;if(!(_?(ea|0)>=(Y|0):(ea|0)<=(Y|0))){break b}$=c[64026]|0;aa=c[64002]|0;ba=ea}}}while(0);fe[S&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}Y=c[b>>2]|0;_=c[64026]|0;Z=c[64002]|0;c[64008]=Z;ba=(_|0)<0;c:do{if(ba?(Z|0)>=(Y|0):(Z|0)<=(Y|0)){aa=_;$=Z;ea=Z;while(1){ga=(ea-$|0)/(aa|0)|0;c[64004]=ga+1;da=ea+ -1|0;ca=e+(da<<3)|0;h[ca>>3]=+h[p+((c[64028]|0)+ga<<3)>>3];ma=+h[p+((c[64038]|0)+ga<<3)>>3];ga=f+(da<<3)|0;h[ga>>3]=ma;ka=+h[ca>>3];h[N>>3]=ka;if(!(ka>=0.0)){na=-ka}else{na=ka}ka=+h[l>>3]*ma;if(!(ka>=0.0)){oa=-ka}else{oa=ka}ka=na>=oa?na:oa;ma=+h[n+(da<<3)>>3];if(!(ma>=0.0)){pa=-ma}else{pa=ma}h[32009]=+h[32012]*(ka>=pa?ka:pa);h[N>>3]=+h[l>>3]*+h[ga>>3];ka=+qUa(256072,N);h[32009]=ka;ga=c[64008]|0;ma=+h[e+(ga+ -1<<3)>>3];ha=ka+ma-ma;h[32009]=ha;ma=1.0/ha;h[32018]=ma;da=ga-(c[R>>2]|0)|0;ca=(da|0)>1?da:1;c[64010]=ca;da=c[b>>2]|0;qa=(c[q>>2]|0)+ga|0;ra=(da|0)<=(qa|0)?da:qa;c[64012]=ra;sa=fa(c[64020]|0,ga)|0;ta=sa-(c[q>>2]|0)|0;c[64014]=ta;c[64e3]=ca;if((ca|0)<=(ra|0)){sa=~da;da=~qa;qa=~((sa|0)>(da|0)?sa:da);da=(ca|0)>(qa|0)?ca:qa;ha=ma;qa=ca;while(1){ca=qa+ -1|0;h[p+(ca+ta<<3)>>3]=(+h[o+(ca<<3)>>3]- +h[g+(ca<<3)>>3])*ha;if((qa|0)>=(ra|0)){break}ha=+h[32018];qa=qa+1|0}c[64e3]=da+1}qa=ga+_|0;c[64008]=qa;ra=c[64002]|0;if(!(ba?(qa|0)>=(Y|0):(qa|0)<=(Y|0))){ua=ra;break c}aa=c[64026]|0;$=ra;ea=qa}}else{ua=Z}}while(0);Z=ua+1|0;c[64002]=Z;if((ua|0)<(T|0)){X=Z}else{W=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[64022]=0;h[32012]=+V(+(+h[t>>3]));X=c[b>>2]|0;c[64e3]=1;d:do{if((X|0)>=1){T=r;R=1;while(1){S=R+ -1|0;ha=+h[e+(S<<3)>>3];h[N>>3]=ha;if(!(ha>=0.0)){va=-ha}else{va=ha}Q=f+(S<<3)|0;ha=+h[l>>3]*+h[Q>>3];if(!(ha>=0.0)){wa=-ha}else{wa=ha}ha=va>=wa?va:wa;ma=+h[n+(S<<3)>>3];if(!(ma>=0.0)){xa=-ma}else{xa=ma}h[32009]=+h[32012]*(ha>=xa?ha:xa);h[N>>3]=+h[l>>3]*+h[Q>>3];ha=+qUa(256072,N);h[32009]=ha;Q=(c[64e3]|0)+ -1|0;S=e+(Q<<3)|0;ma=+h[S>>3];ka=ha+ma-ma;h[32009]=ka;h[32016]=+h[S>>3];U=f+(Q<<3)|0;h[32020]=+h[U>>3];h[S>>3]=ka+ +h[S>>3];h[U>>3]=+h[j>>3]*+h[32009]+ +h[U>>3];fe[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ka=1.0/+h[32009];h[32018]=ka;U=c[b>>2]|0;c[64006]=1;S=c[64022]|0;if((U|0)>=1){ma=ka;Q=1;P=0;while(1){h[p+(P+S<<3)>>3]=(+h[o+(P<<3)>>3]- +h[g+(P<<3)>>3])*ma;if((Q|0)>=(U|0)){break}Z=Q;ma=+h[32018];Q=Q+1|0;P=Z}c[64006]=U+1}c[64022]=S+(c[b>>2]|0);P=c[64e3]|0;Q=P+ -1|0;h[e+(Q<<3)>>3]=+h[32016];h[f+(Q<<3)>>3]=+h[32020];R=P+1|0;c[64e3]=R;if((P|0)>=(X|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[64022]=0;X=c[b>>2]|0;if((c[241664>>2]|0)==0){W=42;break}R=K4a(X*20|0)|0;T=F;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(14,1,256168,F);T=E;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(14,0,256192,E);MBa(14,1,256200,D);c[64004]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[C>>2]=T+1;P=C+4|0;h[k>>3]=ma;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];MBa(14,0,256208,C);T=(c[64004]|0)+1|0;c[64004]=T;}while((T|0)<(c[b>>2]|0))}je[c[60540]&1023](14);MBa(14,1,256264,B);c[64e3]=1;if((X|0)>=1){T=R+1|0;P=c[64022]|0;Q=1;do{Z=p+(Q+ -1+P<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[64006]=1;Z=P;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[A>>2]=R;ba=A+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];kc(R|0,256248,A|0)|0;ba=c[64006]|0;c[64006]=ba+1;if((ba|0)>=(X|0)){break}Z=c[64022]|0;Y=ba}c[z>>2]=R;MBa(14,0,256256,z);Y=c[64022]|0;Z=c[64e3]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];P=Y+(c[b>>2]|0)|0;c[64022]=P;Q=Z+1|0;c[64e3]=Q;}while((Z|0)<(X|0))}je[c[60540]&1023](14);je[c[60540]&1023](14);L4a(R);W=42}else if((O|0)==3){i=y;return 0}else{X=c[b>>2]|0;Q=fa(X,X)|0;c[64e3]=1;if((Q|0)!=0){X=(Q|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(Q|0)){P=P+1|0}else{break}}c[64e3]=X?2:Q+1|0}le[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[64022]=0;P=c[b>>2]|0;if((c[241664>>2]|0)==0){W=42;break}R=K4a(P*20|0)|0;T=M;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(14,1,256168,M);T=L;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(14,0,256192,L);MBa(14,1,256200,K);c[64004]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[J>>2]=T+1;Z=J+4|0;h[k>>3]=ma;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];MBa(14,0,256208,J);T=(c[64004]|0)+1|0;c[64004]=T;}while((T|0)<(c[b>>2]|0))}je[c[60540]&1023](14);MBa(14,1,256224,I);c[64e3]=1;if((P|0)>=1){T=R+1|0;Q=c[64022]|0;X=1;do{Z=p+(X+ -1+Q<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[64006]=1;Z=Q;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[H>>2]=R;ba=H+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];kc(R|0,256248,H|0)|0;ba=c[64006]|0;c[64006]=ba+1;if((ba|0)>=(P|0)){break}Z=c[64022]|0;Y=ba}c[G>>2]=R;MBa(14,0,256256,G);Y=c[64022]|0;Z=c[64e3]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];Q=Y+(c[b>>2]|0)|0;c[64022]=Q;X=Z+1|0;c[64e3]=X;}while((Z|0)<(P|0))}je[c[60540]&1023](14);je[c[60540]&1023](14);L4a(R);W=42}}while(0);if((W|0)==42){WDa(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){aEa(p,256136,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function PDa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[64072]=(c[g>>2]|0)+1+(c[e>>2]<<1);bEa(d,256288,a,e,g,e+80|0,b,256296)|0;i=f;return 0}else{_Da(d,a,a,e+80|0,b,256296)|0;i=f;return 0}return 0}function QDa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[256304]&1)){a[256304]=1;RDa(256352,256320,256400,256336,256384,256408,256392,256416)|0;h[32043]=+(c[64088]|0);f=c[64080]|0;h[32039]=+(f|0);if((c[64100]|0)==0){h[32041]=0.0;c[e>>2]=1-f;g=+pUa(256344,e)}else{h[32041]=1.0;c[e>>2]=1-f;g=+pUa(256344,e)*.5}h[32042]=g;h[32046]=g*+h[32043];h[32045]=+(c[64096]|0);h[32047]=+(c[64098]|0);j=+h[32051];h[32054]=j;k=1.0/+h[32052];if(!(k>=j)){break}h[32054]=k*(g+1.0)}}while(0);if((hEa(b,256440,1,1)|0)!=0){g=+h[32042];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256448,1,1)|0)!=0){g=+h[32054];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256456,1,1)|0)!=0){g=+h[32043];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256464,1,1)|0)!=0){g=+h[32046];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256472,1,1)|0)!=0){g=+h[32039];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256480,1,1)|0)!=0){g=+h[32041];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256488,1,1)|0)!=0){g=+h[32045];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256496,1,1)|0)!=0){g=+h[32051];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256504,1,1)|0)!=0){g=+h[32047];h[32053]=g;l=g;i=d;return+l}if((hEa(b,256512,1,1)|0)==0){l=+h[32053];i=d;return+l}else{g=+h[32052];h[32053]=g;l=g;i=d;return+l}return 0.0}function RDa(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[256624]&1){q=256992;r=c[64248]|0;c[b>>2]=r;s=256928;t=c[64232]|0;c[d>>2]=t;u=256968;v=c[64242]|0;c[e>>2]=v;w=256976;x=+h[32122];h[f>>3]=x;y=257008;z=c[64252]|0;c[g>>2]=z;A=257056;B=+h[32132];h[j>>3]=B;C=257016;D=c[64254]|0;c[k>>2]=D;E=257064;F=+h[32133];h[l>>3]=F;i=m;return 0}a[256624]=1;h[32123]=0.0;h[32117]=1.0;h[32118]=2.0;SDa(256992,256928,256968,257080)|0;h[32113]=+(c[64248]|0);c[n>>2]=0-(c[64232]|0);G=+pUa(256904,n);h[32112]=G;h[32122]=G;H=+h[32118];h[32113]=H/3.0;I=+h[32117];J=I*.5;h[32120]=J;K=-J;h[o>>3]=K;h[32134]=+TDa(256904,o);L=257072;h[32131]=+TDa(L,L);h[o>>3]=K;h[32113]=+TDa(257048,o);K=+TDa(256904,257072);h[32113]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[32113]=K;h[32122]=1.0;M=+h[32123];if(K<1.0&K>M){N=K;while(1){h[32122]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+TDa(o,p);h[32114]=K;h[o>>3]=-K;h[32114]=+TDa(256960,o);K=+TDa(256960,256912);h[32113]=K;h[o>>3]=-K;h[32114]=+TDa(256960,o);K=+TDa(256960,256912);h[32113]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[32122]=G}G=I/+(c[64248]|0);h[32125]=G;h[32129]=I;c[64230]=1;p=1;O=I;do{h[o>>3]=O*G;O=+TDa(o,256984);h[32129]=O;p=p+1|0;c[64230]=p;}while((p|0)<4);h[32112]=+TDa(256936,257032);UDa(257096,256936,256992)|0;h[o>>3]=-+h[32117];UDa(257088,o,256992)|0;UDa(257040,256896,256992)|0;h[o>>3]=-+h[32112];UDa(257024,o,256992)|0;c[64238]=0;p=c[64274]|0;L=c[64272]|0;P=c[64260]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[64256]|0)){if(Q){c[64252]=p;R=0;S=25;break}if((P-p|0)==3){c[64252]=p+ -1+(c[64232]|0);c[64238]=1;R=1;S=25;break}else{c[64252]=(p|0)<=(P|0)?p:P;a[256632]=1;S=26;break}}else{T=Q&(L|0)==(c[64256]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[64252]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[64252]=(p|0)<=(L|0)?p:L;a[256632]=1;S=26;break}}T=c[64256]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[64252]=(V|0)<=(T|0)?V:T;a[256632]=1;S=26;break}if((P-U|0)==3){c[64252]=((p|0)>=(L|0)?p:L)+ -1+(c[64232]|0);R=0;S=25;break}else{c[64252]=U;a[256632]=1;S=26;break}}}while(0);if((S|0)==25){if(a[256632]&1){S=26}else{W=R}}if((S|0)==26){a[256624]=0;nVa(257104)|0;EUa(257128,257008,4)|0;XUa()|0;W=c[64238]|0}if((W|0)==0){X=(c[64270]|0)!=0|0}else{X=1}c[64238]=X;h[32132]=1.0;X=c[64252]|0;W=1-X|0;c[n>>2]=W;c[64230]=1;if((X|0)<=0){O=+h[32125];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+TDa(o,256984);h[32132]=I;n=X+1|0;c[64230]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}VDa(256992,256928,257008,256952,257016,257064)|0;q=256992;r=c[64248]|0;c[b>>2]=r;s=256928;t=c[64232]|0;c[d>>2]=t;u=256968;v=c[64242]|0;c[e>>2]=v;w=256976;x=+h[32122];h[f>>3]=x;y=257008;z=c[64252]|0;c[g>>2]=z;A=257056;B=+h[32132];h[j>>3]=B;C=257016;D=c[64254]|0;c[k>>2]=D;E=257064;F=+h[32133];h[l>>3]=F;i=m;return 0}function SDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[256520]&1){l=a[256592]&1;m=c[64150]|0;c[b>>2]=m;n=256568;o=c[64142]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=256616;r=c[64154]|0;c[f>>2]=r;i=g;return 0}a[256520]=1;h[32072]=1.0;h[32066]=1.0;h[32068]=1.0;s=1.0;do{s=s*2.0;h[32066]=s;h[32068]=+TDa(256528,256576);h[j>>3]=-s;t=+TDa(256544,j);h[32068]=t;}while(t==1.0);h[32067]=1.0;t=+TDa(256528,256536);h[32068]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[32067]=v;w=+TDa(256528,256536);h[32068]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[32073]=.25;h[32076]=x;h[j>>3]=-s;t=+TDa(256544,j);h[32068]=t;y=~~(t+.25);c[64150]=y;t=+(y|0);h[32067]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[32069]=+TDa(j,k);w=+TDa(256552,256528);h[32068]=w;z=w==s;a[256592]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[32069]=+TDa(j,k);w=+TDa(256552,256528);h[32068]=w;if(z&w==s){a[256592]=0;A=0}else{A=z}h[j>>3]=u;w=+TDa(j,256528);h[32070]=w;h[j>>3]=u;z=w==s&+TDa(j,256608)>x;c[64154]=z?A&1:0;c[64142]=0;h[32066]=1.0;h[32068]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[64142]=k;s=x*t;h[32066]=s;h[32068]=+TDa(256528,256576);h[j>>3]=-s;w=+TDa(256544,j);h[32068]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=256568;o=c[64142]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=256616;r=c[64154]|0;c[f>>2]=r;i=g;return 0}function TDa(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function UDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[32142]=g;j=1.0/+(c[d>>2]|0);h[32151]=j;h[32150]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+TDa(f,257200);h[32144]=k;h[32146]=g;h[32147]=g;h[32148]=g;h[32149]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[32142]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+TDa(f,257200);h[32144]=g;h[f>>3]=g*k;k=+TDa(f,257200);h[32146]=k;h[32148]=0.0;c[64286]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[32148]=q;c[64286]=b+1;n=q}h[f>>3]=m*j;p=+TDa(f,257200);h[32145]=p;h[f>>3]=p/j;r=+TDa(f,257200);h[32147]=r;h[32149]=0.0;o=c[d>>2]|0;c[64286]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[32149]=v;c[64286]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function VDa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[64310]=1;c[64318]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[64310]=q;r=l+1|0;c[64318]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[64314]=n;u=n}else{c[64314]=m;c[64318]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[64320]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[64318]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[32158]=x;y=w+-1.0;h[32154]=y;h[32153]=0.0;v=c[b>>2]|0;c[64304]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[32154]=B;if(w<1.0){h[32156]=w}C=+TDa(257224,257232);h[32153]=C;e=b+1|0;c[64304]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[32156];h[32153]=A;z=A}}while(0);v=c[f>>2]|0;c[64304]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+TDa(k,257288);h[32153]=z;f=E+1|0;c[64304]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function WDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[64326]=1;m=1;do{c[64332]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=XDa(j,a+(m+b+(fa(m,l)|0)<<3)|0,257336)|0;q=c[64326]|0;r=p+ -1+q|0;c[64328]=r;c[e+(q+ -1<<2)>>2]=r;r=c[64328]|0;q=c[64326]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[32165]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[32165];t=q}u=fa(t,l)|0;h[32165]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;YDa(j,257320,a+(t-l+u<<3)|0,257336)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[64332]|0;c[64324]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[64328]|0;x=fa(w,l)|0;h[32165]=+h[a+(x+b+v<<3)>>3];y=c[64326]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[32165];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=257336;ZDa(k,257320,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[64324]|0;w=A+1|0;c[64324]=w;}while((A|0)<(u|0))}}while(0);q=c[64326]|0;m=q+1|0;c[64326]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function XDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[64424]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[32213]=k;l=(c[d>>2]|0)+1|0;c[64424]=l;m=c[a>>2]|0;c[64422]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[32213]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[64424]=l;a=n+1|0;c[64422]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[32213]=v;c[64422]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[32213]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[64422]=f+1;g=C;i=e;return g|0}function YDa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[64408]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[64408]=l;i=f;return 0}l=(g|0)%5|0;c[64410]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[64408]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[64408]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[64408]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[64408]=o;i=f;return 0}function ZDa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[64394]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[64392]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[64392]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[64392]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[64392]=s;i=j;return 0}}while(0);c[64396]=1;c[64398]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[64396]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[64398]=s;u=s}else{u=1}s=c[a>>2]|0;c[64392]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[64396]=t;u=x+(c[g>>2]|0)|0;c[64398]=u;a=w+1|0;c[64392]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function _Da(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[64344]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[64336]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[64338]=o;p=f+(o+ -1<<3)|0;h[32170]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[32170]}c[k>>2]=(c[d>>2]|0)-m;o=257336;ZDa(k,257360,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[64336]|0;m=o+1|0;c[64336]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[64342]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[64336]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[32170]=-s;c[k>>2]=g;g=257336;ZDa(k,257360,a+(p-l<<3)|0,g,f,g)|0;g=c[64342]|0;q=g+1|0;c[64342]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[64336]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=257336;s=+$Da(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[32170]=s;q=c[64336]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[64336]=n;}while((q|0)<(m|0));t=c[64344]|0}if((t|0)<1){i=j;return 0}c[64342]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[64336]=n;c[k>>2]=(c[d>>2]|0)-n;b=257336;s=+$Da(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[64336]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[64338]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[32170]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[32170]}q=c[64342]|0;m=q+1|0;c[64342]=m;}while((q|0)<(t|0));i=j;return 0}function $Da(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[32210]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[64414]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[64412]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[32210]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[64412]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[64412]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[32210]=t;u=u+5|0;}while((u|0)<=(m|0));c[64412]=u;k=t;i=g;return+k}}while(0);c[64416]=1;c[64418]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[64416]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[64418]=u;y=u}else{y=1}u=c[a>>2]|0;c[64412]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[32210]=t;x=C+(c[d>>2]|0)|0;c[64416]=x;y=B+(c[f>>2]|0)|0;c[64418]=y;a=z+1|0;c[64412]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function aEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[64354]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[64360]=n;o=c[d>>2]|0;p=c[64354]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[64362]=o;do{if((q|0)>(n|0)){c[64370]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[64358]=s;t=c[e>>2]|0;c[64346]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[64346]=t+1}u=r+1|0;c[64370]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[64370]=o;c[64368]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[64350]=1;t=o;o=1;while(1){c[64372]=o+1;p=t+1|0;c[64370]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[64346]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[64346]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[64364]=s;c[l>>2]=s+1;s=XDa(l,a+((c[64354]|0)+b+(fa(o,m)|0)<<3)|0,257336)|0;p=s+ -1|0;c[64352]=p+(c[64354]|0);s=c[64350]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[64352]|0;p=c[64350]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[64354]|0;if((s|0)==(u|0)){y=s}else{h[32178]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[32178];y=u}h[32178]=-1.0/+h[a+(y+b+n<<3)>>3];YDa(257456,257424,a+(y-m+n<<3)|0,257336)|0;u=c[64368]|0;z=(c[g+((c[64350]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[64368]=u;A=c[64354]|0;c[64366]=A;z=c[64372]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[64348]=z;B=z;z=A;while(1){A=(c[64352]|0)+ -1|0;c[64352]=A;C=z+ -1|0;c[64366]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[32178]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[32178];F=C}C=257336;ZDa(257456,257424,a+((c[64354]|0)-m+(fa(c[64350]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[64348]|0;D=C+1|0;c[64348]=D;if((C|0)>=(u|0)){break a}B=D;z=c[64366]|0}}}while(0);n=c[64350]|0;s=n+1|0;c[64350]=s;if((n|0)>=(r|0)){break}t=c[64370]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[64354]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function bEa(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[64378]=n;f=c[d>>2]|0;o=f+ -1|0;c[64390]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[64374]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[64388]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[64376]=k;q=j+(k+ -1<<3)|0;h[32190]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[32190]}k=257336;ZDa(257552,257520,a+((c[64378]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[64374]|0;f=k+1|0;c[64374]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[64382]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[64374]=k;q=c[64378]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[64388]=s;u=q-s|0;c[64384]=u;q=k-s|0;c[64386]=q;h[32190]=-t;s=257336;ZDa(257552,257520,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[64382]|0;r=s+1|0;c[64382]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[64374]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[64388]=r;s=o-r|0;c[64384]=s;q=n-r|0;c[64386]=q;r=257336;t=+$Da(257552,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[32190]=t;r=c[64374]|0;q=j+(r+ -1<<3)|0;o=c[64378]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[64374]=n;}while((r|0)<(f|0));v=o;w=c[64390]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[64382]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[64374]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[64388]=(n|0)<=(b|0)?n:b;b=257336;t=+$Da(257552,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[64374]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[64376]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[32190]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[32190]}n=c[64382]|0;b=n+1|0;c[64382]=b;if((n|0)>=(w|0)){break}o=c[64378]|0;v=b}i=l;return 0}function cEa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[64402]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[64400]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[64400]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[64400]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[64400]=o;i=g;return 0}}while(0);c[64404]=1;c[64406]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[64404]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[64406]=o;q=o}else{q=1}o=c[a>>2]|0;c[64400]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[64404]=p;q=s+(c[f>>2]|0)|0;c[64406]=q;a=r+1|0;c[64400]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function dEa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+eEa(257712);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+fEa(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+fEa(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+fEa(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+fEa(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function eEa(a){a=a|0;i=i;return+(+h[257720+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function fEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function gEa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+eEa(257752);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Le[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+fEa(b,e);c[E>>2]=2;Le[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){oEa(b,b,f,g,257760,N,257752,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+fEa(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=F5a(ga|0,0,Z+ -2|0,0)|0;Z=y5a(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}nEa(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Le[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);dEa(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+fEa(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Le[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+fEa(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+fEa(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+fEa(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}qEa(b,b,s,t,v,w,x,D)|0;pEa(b,b,f,g,w,x)|0;W=257752;pEa(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Le[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Le[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function hEa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[257784]=1;f=d[b]|0;c[64442]=f;b=d[e]|0;c[64444]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[64442]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[64444]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function iEa(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[267316>>2]=6;nVa(267312)|0;EUa(268056,j,4)|0;XUa()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[66130]=0;c[66736]=0;c[66724]=0;a[266920]=0;t=c[e>>2]|0;c[65684]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[66130]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[65684]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[65684]=1;if((v|0)>=1){x=1;while(1){h[259208+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[65684]=v+1}c[66728]=2;x=c[e>>2]|0;c[65684]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[65686]=1;if((E|0)<1){F=C}else{G=1;while(1){h[259208+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[65686]=E+1;F=+h[B>>3]}h[259208+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[66728]=G;D=G}G=z+1|0;c[65684]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[66130]|0;y=z+1|0;c[66126]=y;c[65684]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[65686]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[259208+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[65686]=x+1}pe[u&63](e,b,262568+(z+ -1<<3)|0)|0;c[66736]=(c[66736]|0)+1;if((c[j>>2]|0)>=1){c[267340>>2]=6;nVa(267336)|0;EUa(268056,266944,4)|0;EUa(268056,262568+((c[65684]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[65686]=1;if((v|0)>=1){A=1;do{EUa(268056,b+(A+ -1<<3)|0,8)|0;B=c[65686]|0;A=B+1|0;c[65686]=A;}while((B|0)<(v|0))}XUa()|0}v=c[65684]|0;z=v+1|0;c[65684]=z;}while((v|0)<(y|0))}y=c[66724]|0;b:while(1){c[66724]=y+1;c[66636]=1;c[66632]=1;C=+h[32821];h[33317]=C;h[33319]=C;z=c[66126]|0;c[65684]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[262568+(A+ -1<<3)>>3];do{if(!(C<=K)){c[66636]=A;L=+h[262568+(A+ -1<<3)>>3];h[33317]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[66632]=A;L=+h[262568+(A+ -1<<3)>>3];h[33319]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[65684]=z+1;H=O}A=c[e>>2]|0;c[65684]=1;if((A|0)>=1){v=1;while(1){h[264688+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[65684]=A+1}c[65684]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[65686]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=264688+(Q+ -1<<3)|0;h[B>>3]=+h[259208+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[65686]=x+1;P=v}}while(0);v=P+1|0;c[65684]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[65686]=1;if((z|0)>=1){K=+(c[66130]|0);v=1;while(1){A=264688+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[65686]=z+1}v=c[e>>2]|0;c[65684]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[264688+(B<<3)>>3];h[266968+(B<<3)>>3]=K+(K- +h[259208+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[65684]=v+1}pe[u&63](e,266968,266960)|0;A=(c[66736]|0)+1|0;c[66736]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[267364>>2]=6;nVa(267360)|0;EUa(268056,266944,4)|0;EUa(268056,266960,8)|0;B=c[e>>2]|0;c[65686]=1;if((B|0)>=1){E=1;do{EUa(268056,266968+(E+ -1<<3)|0,8)|0;G=c[65686]|0;E=G+1|0;c[65686]=E;}while((G|0)<(B|0))}XUa()|0}}while(0);K=+h[33370];c:do{if(!(K>=+h[33319])){z=c[e>>2]|0;c[65684]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[264688+(v<<3)>>3];h[267136+(v<<3)>>3]=I+(+h[266968+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[65684]=z+1}pe[u&63](e,267136,267128)|0;A=(c[66736]|0)+1|0;c[66736]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[267388>>2]=6;nVa(267384)|0;EUa(268056,266944,4)|0;EUa(268056,267128,8)|0;B=c[e>>2]|0;c[65686]=1;if((B|0)>=1){E=1;do{EUa(268056,267136+(E+ -1<<3)|0,8)|0;G=c[65686]|0;E=G+1|0;c[65686]=E;}while((G|0)<(B|0))}XUa()|0}}while(0);I=+h[33391];if(I>=+h[33319]){R=118;break}v=c[e>>2]|0;c[65684]=1;A=c[66636]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[259208+((z*21|0)+ -22+A<<3)>>3]=+h[267136+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[65684]=v+1}h[262568+(A+ -1<<3)>>3]=I}else{z=c[66126]|0;c[65684]=1;if((z|0)>=1){B=c[66636]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[262568+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[65684]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[33317])){E=c[e>>2]|0;c[65684]=1;z=c[66636]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[259208+((B*21|0)+ -22+z<<3)>>3]=+h[266968+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[65684]=E+1}h[33317]=K;h[262568+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[65684]=1;if((B|0)>=1){A=c[66636]|0;v=1;while(1){x=v+ -1|0;h[267136+(x<<3)>>3]=+h[259208+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[264688+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[65684]=B+1}pe[u&63](e,267136,267128)|0;v=(c[66736]|0)+1|0;c[66736]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[267412>>2]=6;nVa(267408)|0;EUa(268056,266944,4)|0;EUa(268056,267128,8)|0;z=c[e>>2]|0;c[65686]=1;if((z|0)>=1){E=1;do{EUa(268056,267136+(E+ -1<<3)|0,8)|0;x=c[65686]|0;E=x+1|0;c[65686]=E;}while((x|0)<(z|0))}XUa()|0}}while(0);I=+h[33391];if(!(I>+h[33317])){A=c[e>>2]|0;c[65684]=1;v=c[66636]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[259208+((B*21|0)+ -22+v<<3)>>3]=+h[267136+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[65684]=A+1}h[262568+(v+ -1<<3)>>3]=I;break}B=c[66126]|0;c[65684]=1;if((B|0)<1){break}else{S=1}do{z=c[66632]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[65686]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=259208+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[259208+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[259208+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[65686]=E+1}pe[u&63](e,b,262568+(S+ -1<<3)|0)|0;G=(c[66736]|0)+1|0;c[66736]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[267436>>2]=6;nVa(267432)|0;EUa(268056,266944,4)|0;EUa(268056,262568+((c[65684]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[65686]=1;if((x|0)>=1){G=1;do{EUa(268056,b+(G+ -1<<3)|0,8)|0;T=c[65686]|0;G=T+1|0;c[65686]=G;}while((T|0)<(x|0))}XUa()|0}}while(0);z=c[65684]|0;S=z+1|0;c[65684]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[65684]=1;v=c[66636]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[259208+((A*21|0)+ -22+v<<3)>>3]=+h[266968+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[65684]=B+1}h[262568+(v+ -1<<3)>>3]=+h[33370]}A=c[66724]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[33320]=0.0;h[33366]=0.0;A=c[66126]|0;c[65684]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[33366]=0.0/K;c[65684]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[262568+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[33366]=I;c[65684]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[262568+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[33320]=$;c[65684]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[33320]=I;do{if(!(I<=+h[k>>3])){if((c[66736]|0)>(c[g>>2]|0)){break}a[266920]=0;c[66724]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[65684]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[65686]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[259208+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[65686]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[65684]=v+1}pe[u&63](e,b,f)|0;B=(c[66736]|0)+1|0;c[66736]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[267460>>2]=6;nVa(267456)|0;EUa(268056,266944,4)|0;EUa(268056,s,8)|0;z=c[e>>2]|0;c[65686]=1;if((z|0)>=1){E=1;do{EUa(268056,b+(E+ -1<<3)|0,8)|0;x=c[65686]|0;E=x+1|0;c[65686]=E;}while((x|0)<(z|0))}XUa()|0;ba=c[66736]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[267580>>2]=6;nVa(267576)|0;XUa()|0;c[267604>>2]=6;nVa(267600)|0;B=c[e>>2]|0;c[65684]=1;if((B|0)>=1){A=1;do{EUa(268056,b+(A+ -1<<3)|0,8)|0;v=c[65684]|0;A=v+1|0;c[65684]=A;}while((v|0)<(B|0))}XUa()|0;c[267628>>2]=6;nVa(267624)|0;EUa(268056,s,8)|0;XUa()|0}if(a[266920]&1){I=+h[33366];K=+h[33412]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[266920]=1;da=+h[33366]}h[33412]=da;c[66724]=0;y=0}if((c[j>>2]|0)>=0){c[267652>>2]=6;nVa(267648)|0;EUa(268056,266944,4)|0;XUa()|0;c[267676>>2]=6;nVa(267672)|0;y=c[e>>2]|0;c[65684]=1;if((y|0)>=1){B=1;do{EUa(268056,b+(B+ -1<<3)|0,8)|0;A=c[65684]|0;B=A+1|0;c[65684]=B;}while((A|0)<(y|0))}XUa()|0;c[267700>>2]=6;nVa(267696)|0;EUa(268056,s,8)|0;XUa()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[267724>>2]=6;nVa(267720)|0;XUa()|0}h[33319]=+h[f>>3];c[66738]=0;y=c[66126]|0;c[65684]=1;if((y|0)>=1){B=1;while(1){A=262568+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[65684]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[65686]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=259208+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[267136+(E+ -1<<3)>>3]=+h[259208+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[65686]=v+1}pe[u&63](e,267136,A)|0;c[66738]=(c[66738]|0)+1;c[66736]=(c[66736]|0)+1;E=c[65684]|0;I=+h[262568+(E+ -1<<3)>>3];if(I>=+h[33319]){B=E;continue}h[33319]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[267748>>2]=6;nVa(267744)|0;EUa(268056,266944,4)|0;EUa(268056,266552,8)|0;E=c[e>>2]|0;c[65686]=1;if((E|0)>=1){z=1;do{EUa(268056,267136+(z+ -1<<3)|0,8)|0;G=c[65686]|0;z=G+1|0;c[65686]=z;}while((G|0)<(E|0))}XUa()|0;B=c[65684]|0}}B=c[66130]|0;c[65684]=1;do{if((B|0)<1){h[32846]=+h[32821];c[65684]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[65694]=E;z=c[e>>2]|0;c[65686]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[266968+(A+ -1<<3)>>3]=(+h[259208+(v+ -21<<3)>>3]+ +h[259208+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[65686]=z+1}pe[u&63](e,266968,264528+(y+ -1<<3)|0)|0;c[66738]=(c[66738]|0)+1;c[66736]=(c[66736]|0)+1;A=c[65684]|0;y=A+1|0;c[65684]=y;}while((A|0)<(B|0));y=c[66130]|0;I=+h[32821];h[32846]=I;c[65684]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[65694]=A;c[65696]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[65686]=1;E=1;while(1){v=E+1|0;c[65698]=v;G=c[e>>2]|0;c[65688]=1;if((G|0)>=1){x=c[65696]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[267136+(T+ -1<<3)>>3]=(+h[259208+(U+x<<3)>>3]+ +h[259208+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[65688]=G+1}pe[u&63](e,267136,267128)|0;c[66738]=(c[66738]|0)+1;c[66736]=(c[66736]|0)+1;T=c[65684]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[65686]|0;la=U+x|0;c[65690]=la;I=+h[32846];h[264848+(la+ -1<<3)>>3]=(+h[33391]+I- +h[264528+(v<<3)>>3]- +h[264528+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[65686]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[65684]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[66130]|0;c[65690]=0;c[65684]=1;E=(y|0)<1;if(E){c[65684]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=F5a(A|0,0,y+ -2|0,0)|0;A=y5a(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[264848+(U+ -1<<3)>>3]=(+h[262568+(v<<3)>>3]+ka- +h[264528+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[65694]=v+1;c[65690]=(z|1)+A;c[65684]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=264528+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[262568+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[65694]=T+1;c[65684]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[65690]=0;c[65684]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[65684]=1;if((B|0)>=1){A=1;while(1){h[266568+(A+ -1<<3)>>3]=+h[259208+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[65684]=B+1}c[65684]=1;do{if(ma){c[65684]=1}else{A=1;while(1){z=A+1|0;c[65694]=z;v=c[e>>2]|0;c[65686]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=259208+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[259208+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[65686]=v+1}c[65684]=z;if((A|0)<(na|0)){A=z}else{break}}c[65684]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[65694]=A;y=c[e>>2]|0;c[65686]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[259208+(T+oa<<3)>>3]=+h[259208+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[65686]=y+1}c[65684]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=264848;jEa(B,264520,B,266728,267304,q,266888)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[267772>>2]=6;nVa(267768)|0;XUa()|0}c[q>>2]=2;if((c[66736]|0)>(c[g>>2]|0)){R=312;break}c[267796>>2]=6;nVa(267792)|0;XUa()|0;B=c[e>>2]|0;c[65684]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[65684]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[267484>>2]=6;nVa(267480)|0;EUa(268056,g,4)|0;XUa()|0;c[267508>>2]=6;nVa(267504)|0;EUa(268056,266560,8)|0;XUa()|0;c[267532>>2]=6;nVa(267528)|0;u=c[e>>2]|0;c[65684]=1;if((u|0)>=1){E=1;do{EUa(268056,b+(E+ -1<<3)|0,8)|0;z=c[65684]|0;E=z+1|0;c[65684]=E;}while((z|0)<(u|0))}XUa()|0;c[267556>>2]=6;nVa(267552)|0;EUa(268056,s,8)|0;XUa()|0;i=r;return 0}else if((R|0)==226){u=c[66130]|0;c[66734]=u-(c[66826]|0);c[65684]=1;E=(u|0)<1;do{if(E){h[33363]=0.0;c[65684]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[262568+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=262568+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[264848+(sa+ -1<<3)>>3]*+h[264528+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[65690]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[65686]=z;h[33363]=0.0;c[65684]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[262568+(v<<3)>>3]*+h[264528+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[33363]=wa;c[65684]=u+1;qa=wa}}while(0);h[33363]=+h[32846]-qa;s=c[e>>2]|0;c[65684]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[267136+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=267136+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[262568+(T+ -1<<3)>>3]*+h[259208+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[65684]=s+1;c[65686]=xa}v=c[e>>2]|0;c[65684]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=266568+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[267136+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[65684]=v+1}if((c[j>>2]|0)>=0){c[267820>>2]=6;nVa(267816)|0;EUa(268056,266904,8)|0;z=c[e>>2]|0;c[65684]=1;if((z|0)>=1){s=1;do{EUa(268056,266568+(s+ -1<<3)|0,8)|0;u=c[65684]|0;s=u+1|0;c[65684]=s;}while((u|0)<(z|0))}XUa()|0;c[267844>>2]=6;nVa(267840)|0;XUa()|0}z=c[e>>2]|0;c[65684]=1;if((z|0)>=1){s=c[66130]|0;v=1;while(1){c[65686]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[262568+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=262568+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[264848+(Aa+ -1<<3)>>3]*+h[259208+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[65690]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[65688]=E;c[65686]=s+1}T=c[e>>2]|0;c[65686]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=262824+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[262568+(Ea+ -1<<3)>>3]*+h[259208+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[65686]=T+1;c[65690]=Ca;c[65688]=Da}za=v+1|0;c[65684]=za;if((v|0)<(z|0)){v=za}else{break}}}c[65686]=0;v=c[e>>2]|0;c[65684]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[262824+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[65686]=Ga;c[65684]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[267868>>2]=6;nVa(267864)|0;EUa(268056,266936,4)|0;XUa()|0;c[66128]=1;z=1;d:while(1){c[65690]=z;do{if((z|0)>(c[e>>2]|0)){s=c[66128]|0;if((s|0)==1){c[267892>>2]=6;nVa(267888)|0;XUa()|0;jEa(262824,264520,264848,266728,267304,q,266888)|0;c[267916>>2]=6;nVa(267912)|0;XUa()|0;c[66128]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[66128]=2;c[65700]=0;c[65702]=0;s=c[e>>2]|0;c[65684]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=F5a(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=y5a(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=262824+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=262824+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[262824+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[65704]=Na;c[65702]=Ta;c[65700]=Ia;c[65686]=Ma;c[65684]=s+1}c[267940>>2]=6;nVa(267936)|0;XUa()|0;c[65700]=0;u=c[e>>2]|0;c[65684]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=262824+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[65700]=Wa;c[65684]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[65700]=T;s=c[e>>2]|0;c[65684]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[65694]=B;Qa=za+la|0;c[65700]=Qa;Pa=B+5|0;c[65696]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[66128]|0)==3){c[268012>>2]=6;nVa(268008)|0;Pa=c[65696]|0;Qa=c[65694]|0;c[65686]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{EUa(268056,264848+(B+ -1<<3)|0,8)|0;Qa=c[65686]|0;B=Qa+1|0;c[65686]=B;}while((Qa|0)<(Pa|0))}XUa()|0}else{c[267988>>2]=6;nVa(267984)|0;Pa=c[65696]|0;B=c[65694]|0;c[65686]=B;if((B|0)<=(Pa|0)){x=B;do{EUa(268056,262824+(x+ -1<<3)|0,8)|0;B=c[65686]|0;x=B+1|0;c[65686]=x;}while((B|0)<(Pa|0))}XUa()|0}Pa=c[65684]|0;x=Pa+1|0;c[65684]=x;if((Pa|0)>=(s|0)){break e}E=c[65690]|0;la=c[65700]|0;za=x}}}while(0);c[268036>>2]=6;nVa(268032)|0;XUa()|0;z=(c[65690]|0)+6|0}c[267964>>2]=6;nVa(267960)|0;EUa(268056,266952,4)|0;XUa()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);pe[p&63](e,b,f)|0;i=r;return 0}function jEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[67034]=c[b>>2];c[g>>2]=1;if((c[67034]|0)<1){i=k;return 0}c[g>>2]=0;kEa(a,268136,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[67034]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[67026]=f;c[67032]=g;c[67038]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=F5a(a|0,0,g+ -2|0,0)|0;m=y5a(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[67018]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=F5a(p|0,0,a-n|0,0)|0;p=y5a(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[67018]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[67016]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[67016]=j}c[67028]=g;c[67030]=f;c[67036]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[33512]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[33512]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[33512]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[67036]=D;E=v+ -1|0;c[67028]=E;F=w+ -1|0;c[67030]=F;q=D;v=E;w=F}c[67020]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[67022]=t;c[67032]=0;c[67038]=l-g;i=k;return 0}function kEa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[33526]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[33526]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[33526];c[67042]=1;c[67044]=0;n=c[b>>2]|0;c[67056]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[67046]=0;c[67058]=1;do{if((o|0)>=1){p=1;q=c[67044]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[33525]=m;u=(p|0)==(o|0);if(u){l=m*+h[33526];h[33527]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[33525]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[33527]=+h[33527]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[67046]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[67046]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[33525];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[67058]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[67040]=y;c[67048]=x;c[67044]=s;break}else if((D|0)==26){D=0;c[67040]=y;c[67048]=x;c[67044]=s;break}}}while(0);m=+V(+(+h[33527]));h[33527]=m;H=+h[33525];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[67044]|0)+ -1<<3)>>3]=G;G=+h[33527]/+h[33525];h[j+((c[67040]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[67044]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[67042]|0;O=c[67056]|0}}while(0);b=N+O|0;c[67042]=b;o=O+1|0;c[67056]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[67040]=y;c[67048]=x;c[67044]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function lEa(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[67082]=n;o=(c[d>>2]|0)-n|0;c[67104]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[67102]=s;a[268352]=1;t=c[b>>2]|0;u=t+1|0;c[67098]=u;v=c[b>>2]|0;w=u+v|0;c[67096]=w;u=w+(c[b>>2]|0)|0;c[67100]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[67090]=w;x=w+(c[d>>2]|0)|0;c[67084]=x;y=x+(c[b>>2]|0)|0;c[67086]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[67092]=z;A=z+(c[d>>2]|0)|0;c[67106]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[67108]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[67080]=C;D=C+(c[b>>2]|0)|0;c[67094]=D;mEa(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,268408,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);nVa(268440)|0;XUa()|0;i=m;return 0}function mEa(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[33640]=.5;h[33631]=1.0;h[33671]=.1;F=(c[a>>2]|0)+1|0;c[67258]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[67250]=H;I=(c[b>>2]|0)-F|0;c[67304]=I;F=c[j>>2]|0;c[67358]=(F|0)<1?1:F;F=c[a>>2]|0;c[67242]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[67244]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[67244]=J+1}L=c[u>>2]|0;c[67240]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[67240]=L+1}K=j+1|0;c[67242]=K;if((j|0)<(F|0)){j=K}else{break}}}c[67246]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[67246]=H+1}H=c[b>>2]|0;c[67244]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[67242]=M;c[67244]=H+1}N=+h[e>>3];O=N*N;h[33676]=O;h[33662]=+h[33631]/O;h[33663]=+V(+(+h[33640]))/O;c[67248]=0;H=y;y=A;M=0;a:while(1){c[67260]=M;F=M-(c[a>>2]|0)|0;c[67284]=F;j=M+1|0;c[67248]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[67334]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[67272]=L;K=L+G|0;c[67270]=K;if((K|0)>(c[a>>2]|0)){c[67334]=L;G=K-(c[a>>2]|0)|0;c[67272]=G;c[67270]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[33653]=O;L=c[67258]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[33653]=N;R=N}else{R=O}O=+h[e>>3];h[33654]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[33654]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[33654];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[67242]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[67242]=S+1}if((M|0)>=(c[67358]|0)){T=j;U=159;break}while(1){pe[H&63](a,d,268952)|0;if((c[g>>2]|0)==3){nVa(269480)|0;EUa(269648,268992,4)|0;EUa(269648,268952,8)|0;I=c[a>>2]|0;c[67240]=1;if((I|0)>=1){F=1;do{EUa(269648,d+(F+ -1<<3)|0,8)|0;L=c[67240]|0;F=L+1|0;c[67240]=F;}while((L|0)<(I|0))}XUa()|0}I=c[67248]|0;do{if((I|0)>(c[b>>2]|0)){F=c[67288]|0;if((F|0)==-1){break a}h[33672]=0.0;c[67246]=0;L=c[a>>2]|0;c[67242]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[33672]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[33645]=N;if((X|0)==(G|0)){ea=N*+h[33640];h[33645]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[33672]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[67246]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[67240]=Y;c[67242]=L+1;W=Z}J=c[b>>2]|0;c[67244]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[33672]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[67244]=J+1;ia=ja}O=+h[33619];ba=+h[33648];N=O-ba-ia;h[33639]=N;h[33658]=+h[33657];h[33657]=+h[33656];if(!(N>=0.0)){ka=-N}else{ka=N}h[33656]=ka;if(+h[33668]>+h[33634]){c[67332]=I}h[33664]=ba;do{if(O<ba){h[33648]=O;h[33681]=0.0;G=c[a>>2]|0;c[67240]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[33681]=+h[33681]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[67240]=G+1;h[A>>3]=ma}}while(0);c[67330]=F;if((F|0)<=0){O=+h[33672];if(O>=0.0){U=190;break a}ba=+h[33619];N=+h[33664];ea=(ba-N)/O;h[33669]=ea;O=+h[33671];do{if(!(ea<=O)){na=+h[33640]*+h[33661];h[A>>3]=na;oa=+h[33668];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[33661]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[33661]=qa;ra=qa;break}}else{qa=+h[33640]*+h[33668];h[33661]=qa;ra=qa}}while(0);ea=+h[33634];if(!(ra<=ea*1.5)){sa=ra}else{h[33661]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[33676]=ea;c[67346]=0;h[33677]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[67302]|0;c[67346]=J;oa=+h[33631];h[33677]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[67244]=1;if((J|0)<1){va=F}else{L=c[67304]|0;oa=ua;K=1;ca=F;while(1){h[33659]=0.0;c[67242]=1;if((L|0)<1){wa=0.0}else{X=c[67264]|0;aa=K+C|0;qa=+h[33631];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[33645]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[33659]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[67242]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[33641]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[33645]=za;h[33680]=0.0;$=c[a>>2]|0;c[67242]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[33680]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[67242]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[33645]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[33677]=Fa;c[67288]=K;Ga=Fa;Ha=K}aa=K+1|0;c[67244]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}sEa(a,b,s,t,269056,u,w,269128,269152,x)|0;ca=c[67288]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[33619];c[67246]=0;J=c[a>>2]|0;c[67240]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[33645]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[33645];G=G+1|0;da=da+1|0}da=X+aa|0;c[67246]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[67242]=La;c[67240]=J+1}h[L>>3]=0.0;X=c[67304]|0;c[67242]=1;aa=(X|0)<1;if(!aa){F=c[67264]|0;K=1;while(1){da=fa(K,B)|0;O=+h[33639]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[33645]=Oa;G=c[b>>2]|0;c[67244]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[33645];$=$+1|0}c[67244]=G+1}$=K+1|0;c[67242]=$;if((K|0)<(X|0)){K=$}else{break}}}h[33650]=0.0;K=c[a>>2]|0;c[67240]=1;if((K|0)>=1){F=1;while(1){O=+h[33639]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[33650]=+h[33650]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[67240]=K+1;h[A>>3]=Pa}F=c[67330]|0;do{if((F|0)==0){if(!(+h[33661]==+h[33634])){break}O=+h[33669];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[67350]=0;break}L=c[b>>2]|0;c[67244]=1;if((L|0)>=1){J=o+((c[67302]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[67244]=L+1}h[33643]=0.0;$=c[a>>2]|0;c[67240]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[33637]=0.0;G=c[b>>2]|0;c[67244]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[33637]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[67244]=G+1;Sa=Ta}h[33643]=+h[33643]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[67240]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[33643]*100.0}J=c[67350]|0;c[67350]=J+1;if(+h[33650]<Ra){c[67350]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[67240]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[67240]=J+1}$=c[67250]|0;c[67246]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[67246]=$+1}c[67242]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[67244]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[67244]=Na+1;Ua=Wa}if((L|0)<(c[67264]|0)){h[J>>3]=-Ua}Va=L+1|0;c[67242]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[67244]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[67242]=Xa;c[67244]=L+1}c[67350]=0}}while(0);O=+h[33619];ea=+h[33664];if(O<ea){c[67302]=ca}oa=+h[33671];if(O<=ea+oa*+h[33672]|(F|0)>0){U=54;break}c[67288]=0;Ia=0;Ja=+h[33661];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[33619];oa=+h[33619];do{if((I|0)==1){h[33638]=oa;h[33648]=oa;c[67302]=1;Ya=1}else{if(!(oa<+h[33648])){Ya=I;break}h[33648]=oa;c[67302]=I;Ya=I}}while(0);F=c[67260]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[67270]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[67272]|0;Va=K+aa|0;c[67246]=Va;if(+h[33653]<0.0){aa=X+(c[a>>2]|0)|0;c[67270]=aa;Za=aa}else{Za=X}if(+h[33654]<0.0){X=K+(c[a>>2]|0)|0;c[67272]=X;_a=X}else{_a=K}K=fa(c[67284]|0,B)|0;h[t+(K-B<<3)>>3]=+h[33662];h[t+(Ya+C+K<<3)>>3]=+h[33662];h[t+(Za-B+K<<3)>>3]=-+h[33662];h[t+(_a-B+K<<3)>>3]=-+h[33662];h[q+(Va+ -1<<3)>>3]=(+h[33638]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[33619])/(+h[33653]*+h[33654])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[67284]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[33640]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[33640]/+h[e>>3];ea=+h[33663];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[33663];h[t+(X+K<<3)>>3]=+h[33663];K=(fa(Va+1|0,Va)|0)/2|0;c[67246]=K;ea=(+h[33638]- +h[33619])/+h[e>>3];h[33645]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[33640]*(+h[X>>3]+ +h[33645]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[33638])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[33631]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[33631]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[33640]*+h[33676]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[33634]=oa;h[33661]=oa;c[67264]=1;h[33656]=0.0;h[33657]=0.0;c[67350]=0;h[33681]=0.0;F=c[a>>2]|0;c[67240]=1;if((F|0)<1){U=53;break}ca=c[67302]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[33681]=+h[33681]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[67240]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[67332]=c[67248];U=54;continue}else if((U|0)==54){U=0;c[67288]=0;I=(c[67258]|0)+ -1|0;K=c[a>>2]|0;rEa(a,b,l,n,p,q,r,269288,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,269424)|0;h[33633]=0.0;K=c[a>>2]|0;c[67240]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[33633]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[67240]=K+1;ab=cb}oa=+h[33661];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[33668]=O;ea=+h[33634];if(!(O<+h[33640]*ea)){db=ab;U=62;break}c[67288]=-1;O=+h[33671];N=O*oa;h[33661]=N;h[33669]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[33661]=ea;eb=ea}if((c[67248]|0)<=((c[67332]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[33678]*.125*ea;h[33645]=N;oa=+h[33656];ba=+h[33657];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[33658];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[33680]=O;I=c[b>>2]|0;c[67244]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[33637]=0.0;X=c[a>>2]|0;c[67242]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[33637]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[67242]=X+1;jb=lb}if(jb>ea){c[67288]=F;h[33680]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[67244]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[33669]>0.0){U=54;continue}ea=+h[33668];O=+h[33634];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[33640];h[33661]=O;ea=hb/+h[f>>3];h[33669]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[33634]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[33634]=na;ob=na;break}}else{na=+h[f>>3];h[33634]=na;ob=na}}while(0);h[33661]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){nVa(269528)|0;XUa()|0}nVa(269552)|0;EUa(269648,269072,8)|0;EUa(269648,268992,4)|0;XUa()|0;nVa(269576)|0;EUa(269648,269184,8)|0;ca=c[a>>2]|0;c[67240]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];EUa(269648,y,8)|0;I=c[67240]|0;F=I+1|0;c[67240]=F;}while((I|0)<(ca|0))}XUa()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[33640]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[33634];O=na>=ea?na:ea;h[33670]=O;ea=O*O;h[33633]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[33681];if(db<=ea*.001){h[33674]=ea*.25;ca=c[b>>2]|0;c[67244]=1;if((ca|0)>=1){F=1;while(1){h[33637]=0.0;I=c[a>>2]|0;c[67240]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[33637]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[67240]=I+1;pb=qb}h[33645]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[33640]*+h[33681];h[33637]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[67240]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[33645]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[33640]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[33637]*+h[n+(F+C+Va<<3)>>3]+ +h[33674]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[67252]=aa;c[67242]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[67242]=Va;rb=Va}c[67240]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[67244]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[67304]|0;c[67244]=1;if((F|0)>=1){ca=1;while(1){h[33655]=0.0;X=c[b>>2]|0;c[67240]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[33655]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[67240]=I;if((K|0)>=(X|0)){break b}O=+h[33655];K=I}}}while(0);X=c[a>>2]|0;c[67242]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[33674]*+h[33655]*+h[l+(I<<3)>>3];h[33637]=O;Va=c[b>>2]|0;c[67240]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[33637]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[67240]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[67264]|0)){h[33637]=-+h[33637]}L=c[b>>2]|0;c[67240]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[33637]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[67240]=L+1}J=K+1|0;c[67242]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[67240]=1;if((K|0)>=1){X=c[67264]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[67252]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[33645]=ub;c[67242]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[33645];aa=aa+1|0}aa=J+1|0;c[67242]=aa;vb=aa}c[67240]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[67244]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[67246]=0;ca=c[a>>2]|0;c[67242]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[67244]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[33640]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[67244]=aa+1}c[67240]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[67246]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[67240]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[67242]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[67242]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[67242]=J+1}h[33681]=0.0}if((c[67288]|0)>0){F=(c[67258]|0)+ -1|0;EDa(a,b,l,n,s,t,269056,u,269152,269360,v,269280,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[67244]=1;if((F|0)>=1){L=1;while(1){h[33646]=0.0;h[33647]=0.0;h[33637]=0.0;ca=c[a>>2]|0;c[67242]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[33646]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[33647]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[33637]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[67242]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[33640]+Ab);h[w+(K<<3)>>3]=+h[33637];K=L+1|0;c[67244]=K;if((L|0)<(F|0)){L=K}else{break}}}h[33641]=0.0;L=c[67304]|0;c[67244]=1;if((L|0)>=1){F=1;while(1){h[33637]=0.0;J=c[b>>2]|0;c[67240]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[33637]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[67240]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[33641];if((F|0)<(c[67264]|0)){h[33641]=O+ea;na=-Eb;h[33637]=na;Gb=na}else{h[33641]=O-ea;Gb=Eb}K=c[b>>2]|0;c[67240]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[33637];X=X+1|0}c[67240]=K+1}X=F+1|0;c[67244]=X;if((F|0)<(L|0)){F=X}else{break}}}h[33649]=0.0;h[33628]=0.0;F=c[a>>2]|0;c[67242]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[33637]=0.0;X=c[b>>2]|0;c[67240]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[33637]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[67240]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[33649]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[67254]=K;Va=c[a>>2]|0;c[67244]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[33637]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[67244]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[33649]+ +h[33637]*+h[ca>>3];h[33649]=O;na=+h[33628]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[33628]=na;aa=L+1|0;c[67242]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[33633];h[33641]=+h[33641]+(Ib*Ib+ea*(Ib+(Ib+ +h[33681])+ea*+h[33640]))-Hb;L=w+((c[67302]|0)+ -1<<3)|0;h[L>>3]=+h[33631]+ +h[L>>3];L=c[67288]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[33631]+ +h[33660]*+h[33641]/(ea*ea);h[33645]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;DDa(a,b,l,n,s,t,269056,u,269208,269152,v,x,w,269128,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[67240]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[67240]=L+1}F=c[67248]|0;aa=F+1|0;c[67248]=aa;if((F|0)>=(c[67358]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[67248]=T+ -1;if((c[g>>2]|0)<=0){break}nVa(269456)|0;XUa()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}nVa(269504)|0;XUa()|0}}while(0);Nb=+h[33648];if(Nb<=+h[33619]){U=c[a>>2]|0;c[67240]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[67240]=U+1;Ob=+h[33648]}h[33619]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}nVa(269600)|0;EUa(269648,268992,4)|0;XUa()|0;nVa(269624)|0;EUa(269648,268952,8)|0;g=c[a>>2]|0;c[67240]=1;if((g|0)>=1){a=1;do{EUa(269648,d+(a+ -1<<3)|0,8)|0;U=c[67240]|0;a=U+1|0;c[67240]=a;}while((U|0)<(g|0))}XUa()|0;i=z;return 0}function nEa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){q5a(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){q5a(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}



function TO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3168>>3];k=+h[g+1896>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,62408,62400,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}function UO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+352>>3]*+h[j+1800>>3]*+h[e+3104>>3];l=+h[j+1840>>3]+ +h[j+1848>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,62448,62440,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}function VO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1864>>3]=+h[b+1664>>3]*+h[d+352>>3]*+h[d+3104>>3]*(+h[b+72>>3]*.5+(+h[b+88>>3]*-.5+ +h[b+1744>>3]*.5));i=i;return}function WO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+1880>>3]+ +h[b+1864>>3];i=i;return}function XO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1912>>3];k=+h[g+2440>>3]- +h[g+1896>>3]*+h[g+1736>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,62536,62528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}function YO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+360>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+360|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+360>>3]);e=c[f>>2]|0;h[c[e+852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+352|0;h[(c[e+848>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+352>>3]);h[(c[(c[f>>2]|0)+852>>2]|0)+8>>3]=k;TFa(a,10)|0;a=c[(c[f>>2]|0)+844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+360>>3]=+h[a>>3];h[f+352>>3]=+h[a+8>>3];i=b;return}function ZO(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6104>>3]=(a[(c[d+16>>2]|0)+48|0]|0)!=0?1.0:0.0;i=i;return}function _O(b){b=b|0;a[(c[b+408>>2]|0)+47|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+48|0]|0;i=i;return}function $O(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+48|0]=a[d+47|0]|0;i=i;return}function aP(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+46|0]=a[d+48|0]|0;i=i;return}function bP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+46|0]=a[(c[b+408>>2]|0)+46|0]|0;i=i;return}function cP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+49|0]=0;i=i;return}function dP(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+52|0]=a[d+49|0]|0;i=i;return}function eP(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+21|0]|0)==0){f=0}else{if((a[e+52|0]|0)==0){f=0;break}f=(a[e+48|0]|0)==0|0}}while(0);a[e+22|0]=f;i=d;return}function fP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+22|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+26|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}if((a[m+48|0]|0)==0){q=0;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}function gP(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6272>>3]=(a[(c[d+16>>2]|0)+52|0]|0)!=0?-2.0e3:0.0;i=i;return}function hP(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3624>>3]=+h[b+6272>>3]*(+h[d+968>>3]*(+h[b+544>>3]- +h[d+960>>3])+1.0);i=i;return}function iP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=+h[b+3624>>3]+ +h[b+552>>3]*(+h[(c[a+416>>2]|0)+4800>>3]- +h[b+544>>3])*4.9;i=i;return}function jP(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6112>>3]=(a[(c[d+16>>2]|0)+52|0]|0)!=0?1.0:0.0;i=i;return}function kP(b){b=b|0;a[(c[b+408>>2]|0)+51|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+52|0]|0;i=i;return}function lP(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+52|0]=a[d+51|0]|0;i=i;return}function mP(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+50|0]=a[d+52|0]|0;i=i;return}function nP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+50|0]=a[(c[b+408>>2]|0)+50|0]|0;i=i;return}function oP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+53|0]=0;i=i;return}function pP(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+56|0]=a[d+53|0]|0;i=i;return}function qP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+24|0;e=d;f=d+16|0;g=i;i=i+16|0;h=i;i=i+8|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+16>>2]|0;l=a[k+56|0]|0;c[f>>2]=a[k+44|0]|0;c[f+4>>2]=l;BBa(g,2,f);f=c[b+536>>2]|0;b=e;l=g;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];uv(h,f,e);a[(c[(c[c[j>>2]>>2]|0)+16>>2]|0)+73|0]=a[h]|0;i=d;return}function rP(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6120>>3]=(a[(c[d+16>>2]|0)+56|0]|0)!=0?1.0:0.0;i=i;return}function sP(b){b=b|0;a[(c[b+408>>2]|0)+55|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+56|0]|0;i=i;return}function tP(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+56|0]=a[d+55|0]|0;i=i;return}function uP(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+54|0]=a[d+56|0]|0;i=i;return}function vP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+54|0]=a[(c[b+408>>2]|0)+54|0]|0;i=i;return}function wP(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+57|0]=0;i=i;return}function xP(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+60|0]=a[d+57|0]|0;i=i;return}function yP(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+111|0]=(a[d+60|0]|0)==0|0;i=i;return}function zP(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+110|0]=a[d+60|0]|0;i=i;return}function AP(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+23|0]|0)==0){f=0}else{if((a[e+60|0]|0)==0){f=0;break}f=(a[e+56|0]|0)==0|0}}while(0);a[e+24|0]=f;i=d;return}function BP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0;d=i;e=b+416|0;f=rFa(+h[(c[e>>2]|0)+2600>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+60|0]|0)!=0){l=+h[k+2600>>3];m=+h[k+2592>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,l,62560,62552,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=rFa(+h[k+2616>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+60|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+2616>>3];m=+h[o+2592>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+SBa(c[b+536>>2]|0,l,62576,62552,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3]=n;i=d;return}function CP(b){b=b|0;var d=0,e=0,f=0.0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[b+416>>2]|0;f=+h[e+2608>>3];if((a[(c[d+16>>2]|0)+60|0]|0)==0){g=f}else{g=f+ +h[e+2592>>3]}h[(c[d+8>>2]|0)+4232>>3]=g;i=i;return}function DP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4776>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4776|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4776>>3]);e=c[f>>2]|0;h[c[e+932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1984>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1984|0;h[(c[e+928>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1984>>3]);h[(c[(c[f>>2]|0)+932>>2]|0)+8>>3]=k;TFa(a,11)|0;j=c[(c[f>>2]|0)+924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4776>>3]=+h[j>>3];h[f+1984>>3]=+h[j+8>>3];xw(a);yw(a);zw(a);Aw(a);Bw(a);Cw(a);Dw(a);Ew(a);Fw(a);Gw(a);i=b;return}function EP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+3768>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+3768>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4712>>3],+h[d+4744>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2104>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[g>>3];i=b;return}function FP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=+h[b+4712>>3]*+h[(c[a+416>>2]|0)+4072>>3];i=i;return}function GP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=b+4|0;wt(e,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4712>>3]);o=+h[e>>3];wt(f,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4944>>3]);p=+h[f>>3];wt(g,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+5024>>3]);q=+h[g>>3];wt(j,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4712>>3]);r=+h[j>>3];wt(k,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4944>>3]);s=+h[k>>3];wt(l,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+5024>>3]);t=r+(s+ +h[l>>3]);l=c[c[n>>2]>>2]|0;k=c[l+8>>2]|0;s=o*+h[k+3768>>3]+(p*+h[k+3800>>3]+q*+h[k+5088>>3]);if(t!=0.0){u=k;v=s/t;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}if(s==0.0){u=k;v=s;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}q=s/+SBa(c[m>>2]|0,t,62600,62592,+h[l>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[n>>2]>>2]|0)+8>>2]|0;v=q;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}function HP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=-+h[b+4944>>3]-(+h[b+5024>>3]+ +h[b+4712>>3]);i=i;return}function IP(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1976>>3]=-(+h[e+4712>>3]*+h[(a<<24>>24==0?e+128|0:e+3776|0)>>3]);i=b;return}function JP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1984>>3],+h[(c[b+416>>2]|0)+3048>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+62|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+62|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[b+360>>2]|0)+62|0]|0)|0;a[(c[b+352>>2]|0)+62|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[b+360>>2]|0)+62|0]|0)|0;a[(c[b+352>>2]|0)+62|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+62|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+62|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+62|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+3|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+3|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+3|0;v=u;a[v]=m;i=d;return}function KP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+4120>>3]*+h[j+1280>>3]*+h[e+4064>>3];l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,62792,62784,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}function LP(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1248>>3]=+h[(a?e+1264|0:e+1256|0)>>3];i=b;return}function MP(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1272>>3]=+h[(a?e+1288|0:e+1280|0)>>3];i=b;return}function NP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+4120>>3]*+h[j+1288>>3]*+h[e+4064>>3];l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,62880,62872,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}function OP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+3768>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+3768>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[f>>3];i=b;return}function PP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4712>>3],+h[j+4768>>3],+h[j+4752>>3],+h[(c[b+416>>2]|0)+2104>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,62968,62960,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}function QP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+3768>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+3768>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[f>>3];i=b;return}function RP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4776>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4776>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4712>>3],+h[d+4760>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2104>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[g>>3];i=b;return}function SP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+60|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1648>>3]*+h[f+5392>>3]*.01;k=g;l=k+1088|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5392>>3]*.01;k=g;l=k+1088|0;m=l;h[m>>3]=j;i=d;return}}function TP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+232>>3],+h[l+48>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+232>>3];o=+h[m+48>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1088>>3],+h[d+5432>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5408>>3]=+h[g>>3];i=b;return}function UP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+56>>3],+h[l+224>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+56>>3];o=+h[m+224>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1088>>3],+h[d+5416>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5400>>3]=+h[g>>3];i=b;return}function VP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1088>>3],+h[j+5440>>3],+h[j+5424>>3],+h[(c[b+416>>2]|0)+1624>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1088>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,63072,63064,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}function WP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4624>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4624|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4624>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5520>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5520|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5520>>3]);j=c[f>>2]|0;h[(c[j+1012>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1004>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4600|0;h[(c[j+1008>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4600>>3]);g=c[f>>2]|0;h[(c[g+1012>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+1004>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4616>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4616|0;h[(c[g+1008>>2]|0)+24>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4616>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+24>>3]=k;TFa(a,12)|0;e=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4624>>3]=+h[e>>3];h[f+5520>>3]=+h[e+8>>3];h[f+4600>>3]=+h[e+16>>3];h[f+4616>>3]=+h[e+24>>3];Jw(a);Kw(a);Lw(a);Mw(a);Nw(a);Ow(a);Pw(a);Qw(a);i=b;return}function XP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+224>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+224>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5520>>3],+h[d+5568>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[g>>3];i=b;return}function YP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4872>>3],0.0)|0;f=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3592>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=g+96|0;h[g+3552>>3]=-(+h[g+3592>>3]*+h[(f<<24>>24==0?d:g+3584|0)>>3])- +h[g+4872>>3]*+h[(e<<24>>24==0?d:g+240|0)>>3]- +h[g+5520>>3]*+h[(a<<24>>24==0?d:g+224|0)>>3];i=b;return}function ZP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+5520>>3]- +h[b+4872>>3]- +h[b+3592>>3];i=i;return}function _P(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3568>>3];k=+h[g+3552>>3]- +h[g+3560>>3]*+h[g+3528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63192,63184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}function $P(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+4824>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,63216,63208,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}function aQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+368>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+368|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+368>>3]);e=c[f>>2]|0;h[c[e+1092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+376>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+376|0;h[(c[e+1088>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+376>>3]);h[(c[(c[f>>2]|0)+1092>>2]|0)+8>>3]=k;TFa(a,13)|0;a=c[(c[f>>2]|0)+1084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+368>>3]=+h[a>>3];h[f+376>>3]=+h[a+8>>3];i=b;return}function bQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+5520>>3]- +h[b+1088>>3];i=i;return}function cQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4680>>3];k=+h[g+6664>>3]- +h[g+4672>>3]*+h[g+4592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63240,63232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}function dQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6800>>3]=-+h[b+4672>>3]/-1.0e-4;i=i;return}function eQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+504>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+504|0;h[c[g+1168>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+504>>3]);e=c[f>>2]|0;h[c[e+1172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+496>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+496|0;h[(c[e+1168>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+496>>3]);h[(c[(c[f>>2]|0)+1172>>2]|0)+8>>3]=k;TFa(a,14)|0;a=c[(c[f>>2]|0)+1164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+504>>3]=+h[a>>3];h[f+496>>3]=+h[a+8>>3];i=b;return}function fQ(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+196>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+5520>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,63256,63248,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}function gQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[f>>3];i=b;return}function hQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[f>>3];i=b;return}function iQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4696>>3],+h[d>>3],61232);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[e>>3];i=b;return}function jQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+2528>>3]*+h[g+4536>>3];k=+h[g+4528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63288,63280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}function kQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[f>>3];i=b;return}function lQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5520>>3],+h[j+5576>>3],+h[j+5560>>3],+h[(c[b+416>>2]|0)+1512>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5520>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,63328,63320,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}function mQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[f>>3];i=b;return}function nQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4696>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4696>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5520>>3],+h[d+5552>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5536>>3]=+h[g>>3];i=b;return}function oQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4240>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4240|0;h[c[g+1248>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4240>>3]);h[c[(c[f>>2]|0)+1252>>2]>>3]=k;TFa(a,15)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4240>>3]=+h[c[(c[f>>2]|0)+1244>>2]>>3];i=b;return}function pQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4216>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4216|0;h[c[g+1328>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4216>>3]);h[c[(c[f>>2]|0)+1332>>2]>>3]=k;TFa(a,16)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4216>>3]=+h[c[(c[f>>2]|0)+1324>>2]>>3];i=b;return}function qQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0;b=i;d=a+400|0;e=(c[d>>2]|0)+4240|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1404>>2]>>3]=+h[e>>3];h[c[g+1408>>2]>>3]=+h[e>>3];j=+h[e>>3];k=+VFa(a,j,j);h[c[(c[f>>2]|0)+1412>>2]>>3]=k;TFa(a,17)|0;h[(c[d>>2]|0)+4240>>3]=+h[c[(c[f>>2]|0)+1404>>2]>>3];i=b;return}function rQ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1088>>3];h[b+1064>>3]=d*+h[(!(d>=0.0)?b+48|0:b+224|0)>>3];i=i;return}function sQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+1064>>3]- +h[b+1072>>3];i=i;return}function tQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=+h[b+1088>>3]- +h[b+1096>>3];i=i;return}function uQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3328>>3];k=+h[g+1144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63432,63424,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}function vQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+472>>3]*+h[j+1048>>3]*+h[e+4248>>3];l=+h[j+1088>>3]+ +h[j+1096>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,63472,63464,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}function wQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1112>>3]=+h[b+912>>3]*+h[d+472>>3]*+h[d+4248>>3]*(+h[b+40>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+992>>3]*.5+ +h[d+2528>>3]*+h[b+1048>>3]*-1.5)));i=i;return}function xQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2456>>3]=+h[b+1128>>3]+ +h[b+1112>>3];i=i;return}function yQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1160>>3];k=+h[g+2456>>3]- +h[g+1144>>3]*+h[g+984>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63568,63560,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+328>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+328|0;h[c[g+1488>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+328>>3]);e=c[f>>2]|0;h[c[e+1492>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1484>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+320>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+320|0;h[(c[e+1488>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+320>>3]);h[(c[(c[f>>2]|0)+1492>>2]|0)+8>>3]=k;TFa(a,18)|0;a=c[(c[f>>2]|0)+1484>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+328>>3]=+h[a>>3];h[f+320>>3]=+h[a+8>>3];i=b;return}function AQ(a){a=a|0;var b=0,d=0,e=0;b=i;JFa(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5672>>3]=+h[d>>3];h[e+5680>>3]=+h[d+8>>3];h[e+5456>>3]=+h[d+16>>3];h[e+5720>>3]=+h[d+24>>3];h[e+5800>>3]=+h[d+32>>3];h[e+1856>>3]=+h[d+40>>3];h[e+1104>>3]=+h[d+48>>3];i=b;return}function BQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1152>>3]=+h[b+1096>>3]- +h[b+1104>>3];i=i;return}function CQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+h[g+1152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63600,63592,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}function DQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+480>>3]*+h[j+1056>>3]*+h[e+4248>>3];l=+h[j+1096>>3]+ +h[j+1104>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,63640,63632,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}function EQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1120>>3]=+h[b+920>>3]*+h[d+480>>3]*+h[d+4248>>3]*(+h[b+40>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+992>>3]*.5+ +h[d+2528>>3]*+h[b+1056>>3]*-1.5)));i=i;return}function FQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1104>>3]),1.0e-15);k=+xd(+(+h[g+1856>>3]),1.0e-15);l=j+k;m=j*+h[g+32>>3]+k*+h[g+64>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,63736,63728,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}function GQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=+h[b+1848>>3]- +h[b+1856>>3];i=i;return}function HQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3176>>3];k=+h[g+1904>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,63816,63808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}function IQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+360>>3]*+h[j+1808>>3]*+h[e+3104>>3];l=+h[j+1848>>3]+ +h[j+1856>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,63856,63848,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}function JQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1872>>3]=+h[b+1672>>3]*+h[d+360>>3]*+h[d+3104>>3]*(+h[b+72>>3]*.5+(+h[b+88>>3]*-.5+ +h[b+1744>>3]*.5));i=i;return}function KQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+5656>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+5656>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5712>>3]=+h[f>>3];i=b;return}function LQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+5656>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+5656>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5704>>3]=+h[f>>3];i=b;return}function MQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5720>>3],+h[(c[l>>2]|0)+2408>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5720>>3];n=+h[(c[l>>2]|0)+2408>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5672>>3],+h[d+5704>>3],+h[f>>3],+h[(c[l>>2]|0)+1400>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5696>>3]=+h[g>>3];i=b;return}function NQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2456>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5656>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2456>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5656>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5672>>3],+h[d+7440>>3],+h[f>>3],+h[(c[k>>2]|0)+1400>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5688>>3]=+h[g>>3];i=b;return}function OQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5672>>3],+h[j+5712>>3],+h[j+7432>>3],+h[(c[b+416>>2]|0)+1400>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5672>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,63944,63936,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}function PQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1104>>3]),1.0e-15);k=+xd(+-+h[g+5672>>3],1.0e-15);l=j+k;m=j*+h[g+32>>3]+k*+h[(c[b+416>>2]|0)+2408>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,64048,64040,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}function QQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+72>>3],+h[l+3848>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+72>>3];o=+h[m+3848>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1856>>3],+h[d+5824>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1288>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[g>>3];i=b;return}function RQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3840>>3]=+h[f>>3];i=b;return}function SQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3832>>3]=+h[f>>3];i=b;return}function TQ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1856>>3];h[b+1832>>3]=d*+h[(!(d>=0.0)?b+3848|0:b+64|0)>>3];i=i;return}function UQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+1824>>3]- +h[b+1832>>3];i=i;return}function VQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2448>>3]=+h[b+1888>>3]+ +h[b+1872>>3];i=i;return}function WQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1920>>3];k=+h[g+2448>>3]- +h[g+1904>>3]*+h[g+1704>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,64120,64112,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}function XQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+344>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+344|0;h[c[g+1568>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+344>>3]);e=c[f>>2]|0;h[c[e+1572>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1564>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+336>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+336|0;h[(c[e+1568>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+336>>3]);h[(c[(c[f>>2]|0)+1572>>2]|0)+8>>3]=k;TFa(a,19)|0;a=c[(c[f>>2]|0)+1564>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+344>>3]=+h[a>>3];h[f+336>>3]=+h[a+8>>3];i=b;return}function YQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[f>>3];i=b;return}function ZQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+1856>>3],+h[j+5848>>3],+h[j+5832>>3],+h[(c[b+416>>2]|0)+1288>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1856>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,64144,64136,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}function _Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[f>>3];i=b;return}function $Q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5720>>3],+h[l+64>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5720>>3];o=+h[m+64>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1856>>3],+h[d+5840>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1288>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[g>>3];i=b;return}function aR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5672>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5672>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2408|0;k=+h[j>>3];l=g*k;m=f;n=m+2256|0;o=n;h[o>>3]=l;i=b;return}else{j=f+5656|0;k=+h[j>>3];l=g*k;m=f;n=m+2256|0;o=n;h[o>>3]=l;i=b;return}}function bR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1856>>3]),1.0e-15);k=+xd(+-+h[g+5672>>3],1.0e-15);l=j+k;m=j*+h[g+64>>3]+k*+h[(c[b+416>>2]|0)+2408>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,64256,64248,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}function cR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+40>>3],+h[l+3744>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+40>>3];o=+h[m+3744>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1104>>3],+h[d+5496>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1568>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5472>>3]=+h[g>>3];i=b;return}function dR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5488>>3]=+h[f>>3];i=b;return}function eR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1104>>3],+h[j+5504>>3],+h[j+5488>>3],+h[(c[b+416>>2]|0)+1568>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1104>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,64328,64320,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}function fR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5480>>3]=+h[f>>3];i=b;return}function gR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5720>>3],+h[l+32>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5720>>3];o=+h[m+32>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1104>>3],+h[d+5480>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1568>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5464>>3]=+h[g>>3];i=b;return}function hR(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1104>>3];h[b+1080>>3]=d*+h[(!(d>=0.0)?b+3744|0:b+32|0)>>3];i=i;return}function iR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+1072>>3]- +h[b+1080>>3];i=i;return}function jR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=+h[b+1136>>3]+ +h[b+1120>>3];i=i;return}function kR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1168>>3];k=+h[g+2464>>3]- +h[g+1152>>3]*+h[g+952>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,64440,64432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}function lR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+312>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+312|0;h[c[g+1648>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+312>>3]);e=c[f>>2]|0;h[c[e+1652>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1644>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+304>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+304|0;h[(c[e+1648>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+304>>3]);h[(c[(c[f>>2]|0)+1652>>2]|0)+8>>3]=k;TFa(a,20)|0;a=c[(c[f>>2]|0)+1644>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+312>>3]=+h[a>>3];h[f+304>>3]=+h[a+8>>3];i=b;return}function mR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3736>>3]=+h[f>>3];i=b;return}function nR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3728>>3]=+h[f>>3];i=b;return}function oR(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6128>>3]=(a[(c[d+16>>2]|0)+60|0]|0)!=0?1.0:0.0;i=i;return}function pR(b){b=b|0;a[(c[b+408>>2]|0)+59|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+60|0]|0;i=i;return}function qR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+60|0]=a[d+59|0]|0;i=i;return}function rR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+58|0]=a[d+60|0]|0;i=i;return}function sR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+58|0]=a[(c[b+408>>2]|0)+58|0]|0;i=i;return}function tR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+61|0]=0;i=i;return}function uR(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+64|0]=a[d+61|0]|0;i=i;return}function vR(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+19|0]|0)==0){f=0}else{if((a[e+64|0]|0)==0){f=0;break}f=(a[e+60|0]|0)==0|0}}while(0);a[e+20|0]=f;i=d;return}function wR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+20|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+24|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}if((a[m+60|0]|0)==0){q=0;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}function xR(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6280>>3]=(a[(c[d+16>>2]|0)+64|0]|0)!=0?-2.0e3:0.0;i=i;return}function yR(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3904>>3]=+h[b+6280>>3]*(+h[d+952>>3]*(+h[b+1944>>3]- +h[d+944>>3])+1.0);i=i;return}function zR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+3904>>3]+ +h[b+1952>>3]*(+h[(c[a+416>>2]|0)+3096>>3]- +h[b+1944>>3])*4.9;i=i;return}function AR(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6136>>3]=(a[(c[d+16>>2]|0)+64|0]|0)!=0?1.0:0.0;i=i;return}function BR(b){b=b|0;a[(c[b+408>>2]|0)+63|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+64|0]|0;i=i;return}function CR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+64|0]=a[d+63|0]|0;i=i;return}function DR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+62|0]=a[d+64|0]|0;i=i;return}function ER(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+62|0]=a[(c[b+408>>2]|0)+62|0]|0;i=i;return}function FR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+65|0]=0;i=i;return}function GR(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+68|0]=a[d+65|0]|0;i=i;return}function HR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+64|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+64|0]|0;k=b+4|0;l=lFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+64|0]|0)|0;a[(c[b+352>>2]|0)+64|0]=l;e=k;f=j;break}else{j=b+4|0;k=lFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+64|0]|0)|0;a[(c[b+352>>2]|0)+64|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+64|0]|0;k=b+4|0;j=pFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+64|0]=j;e=k;f=g;break}else{g=b+4|0;k=pFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+64|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+68|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}if((a[b+60|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}if((a[b+64|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}m=f<<24>>24!=0|0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}function IR(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6144>>3]=(a[(c[d+16>>2]|0)+68|0]|0)!=0?1.0:0.0;i=i;return}function JR(b){b=b|0;a[(c[b+408>>2]|0)+67|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+68|0]|0;i=i;return}function KR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+68|0]=a[d+67|0]|0;i=i;return}function LR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+66|0]=a[d+68|0]|0;i=i;return}function MR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+66|0]=a[(c[b+408>>2]|0)+66|0]|0;i=i;return}function NR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+69|0]=0;i=i;return}function OR(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+72|0]=a[d+69|0]|0;i=i;return}function PR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+24|0;e=d;f=d+16|0;g=i;i=i+16|0;h=i;i=i+8|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+16>>2]|0;l=a[k+72|0]|0;c[f>>2]=a[k+52|0]|0;c[f+4>>2]=l;BBa(g,2,f);f=c[b+536>>2]|0;b=e;l=g;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];tv(h,f,e);a[(c[(c[c[j>>2]>>2]|0)+16>>2]|0)+74|0]=a[h]|0;i=d;return}function QR(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+39|0]|0)==0){f=0}else{if((a[e+72|0]|0)==0){f=0;break}f=(a[e+68|0]|0)==0|0}}while(0);a[e+17|0]=f;i=d;return}function RR(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6152>>3]=(a[(c[d+16>>2]|0)+72|0]|0)!=0?1.0:0.0;i=i;return}function SR(b){b=b|0;a[(c[b+408>>2]|0)+71|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+72|0]|0;i=i;return}function TR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+72|0]=a[d+71|0]|0;i=i;return}function UR(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+70|0]=a[d+72|0]|0;i=i;return}function VR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+70|0]=a[(c[b+408>>2]|0)+70|0]|0;i=i;return}function WR(a){a=a|0;h[(c[a+400>>2]|0)+6168>>3]=+h[c[c[a+4>>2]>>2]>>3];i=i;return}function XR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[(c[a+400>>2]|0)+6168>>3];i=i;return}function YR(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6160>>3]=+h[b>>3]- +h[a+6168>>3];i=i;return}function ZR(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+77|0]=0;i=i;return}function _R(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+80|0]=a[d+77|0]|0;i=i;return}function $R(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6288>>3]=(a[(c[d+16>>2]|0)+80|0]|0)!=0?2.0e4:0.0;i=i;return}function aS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+80|0]|0)==0){f=0;g=e;h=g+76|0;j=h;a[j]=f;i=d;return}f=(a[e+74|0]|0)==0|0;g=e;h=g+76|0;j=h;a[j]=f;i=d;return}function bS(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+112|0]=a[d+76|0]|0;i=i;return}function cS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+65|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+65|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3],a[(c[b+360>>2]|0)+65|0]|0)|0;a[(c[b+352>>2]|0)+65|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3],a[(c[b+360>>2]|0)+65|0]|0)|0;a[(c[b+352>>2]|0)+65|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+65|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3])|0;a[(c[b+352>>2]|0)+65|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3])|0;a[(c[b+352>>2]|0)+65|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+76|0]|0)==0){n=0;o=b;p=o+75|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+75|0;q=p;a[q]=n;i=d;return}function dS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+22|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}if((a[m+52|0]|0)==0){q=0;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}function eS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+17|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}if((a[m+72|0]|0)==0){q=0;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}function fS(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+76|0]|0)==0){f=0.0;g=b;j=g+6176|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6160>>3];g=b;j=g+6176|0;k=j;h[k>>3]=f;i=d;return}function gS(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6184>>3]=(a[(c[d+16>>2]|0)+80|0]|0)!=0?1.0:0.0;i=i;return}function hS(b){b=b|0;a[(c[b+408>>2]|0)+79|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+80|0]|0;i=i;return}function iS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+80|0]=a[d+79|0]|0;i=i;return}function jS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+78|0]=a[d+80|0]|0;i=i;return}function kS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+78|0]=a[(c[b+408>>2]|0)+78|0]|0;i=i;return}function lS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+81|0]=0;i=i;return}function mS(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+84|0]=a[d+81|0]|0;i=i;return}function nS(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6192>>3]=(a[(c[d+16>>2]|0)+84|0]|0)!=0?1.0:0.0;i=i;return}function oS(b){b=b|0;a[(c[b+408>>2]|0)+83|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+84|0]|0;i=i;return}function pS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+84|0]=a[d+83|0]|0;i=i;return}function qS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+82|0]=a[d+84|0]|0;i=i;return}function rS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+82|0]=a[(c[b+408>>2]|0)+82|0]|0;i=i;return}function sS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+85|0]=0;i=i;return}function tS(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+88|0]=a[d+85|0]|0;i=i;return}function uS(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6200>>3]=(a[(c[d+16>>2]|0)+88|0]|0)!=0?1.0:0.0;i=i;return}function vS(b){b=b|0;a[(c[b+408>>2]|0)+87|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+88|0]|0;i=i;return}function wS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+88|0]=a[d+87|0]|0;i=i;return}function xS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+86|0]=a[d+88|0]|0;i=i;return}function yS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+86|0]=a[(c[b+408>>2]|0)+86|0]|0;i=i;return}function zS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+89|0]=0;i=i;return}function AS(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+92|0]=a[d+89|0]|0;i=i;return}function BS(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+31|0]|0)==0){f=0}else{if((a[e+92|0]|0)==0){f=0;break}f=(a[e+88|0]|0)==0|0}}while(0);a[e+32|0]=f;i=d;return}function CS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2128>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2128|0;h[c[g+1728>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2128>>3]);h[c[(c[f>>2]|0)+1732>>2]>>3]=k;TFa(a,21)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[c[(c[f>>2]|0)+1724>>2]>>3];hx(a);ix(a);i=b;return}function DS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2128>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2128>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6064>>3]=+h[f>>3];i=b;return}function ES(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2128>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2128>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6056>>3]=+h[f>>3];i=b;return}function FS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2128>>3],+h[(c[l>>2]|0)+2888>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2128>>3];n=+h[(c[l>>2]|0)+2888>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+6024>>3],+h[d+6056>>3],+h[f>>3],+h[(c[l>>2]|0)+1120>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[g>>3];i=b;return}function GS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2936>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2936>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+6024>>3],+h[d+7456>>3],+h[f>>3],+h[(c[k>>2]|0)+1120>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6040>>3]=+h[g>>3];i=b;return}function HS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+6024>>3],+h[j+6064>>3],+h[j+7448>>3],+h[(c[b+416>>2]|0)+1120>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+6024>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,64472,64464,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}function IS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6024>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6024>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2888|0;k=+h[j>>3];l=g*k;m=f;n=m+2048|0;o=n;h[o>>3]=l;i=b;return}else{j=f+160|0;k=+h[j>>3];l=g*k;m=f;n=m+2048|0;o=n;h[o>>3]=l;i=b;return}}function JS(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2128>>3],+h[(c[b+416>>2]|0)+2824>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+68|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+68|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[b+360>>2]|0)+68|0]|0)|0;a[(c[b+352>>2]|0)+68|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[b+360>>2]|0)+68|0]|0)|0;a[(c[b+352>>2]|0)+68|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+68|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+68|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+68|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+8|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+8|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+8|0;v=u;a[v]=m;i=d;return}function KS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6024>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6024>>3];if(e<<24>>24==0){j=f+160|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+2104|0;p=o;h[p>>3]=m;i=b;return}else{j=(c[a+416>>2]|0)+2888|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+2104|0;p=o;h[p>>3]=m;i=b;return}}function LS(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6208>>3]=(a[(c[d+16>>2]|0)+92|0]|0)!=0?1.0:0.0;i=i;return}function MS(b){b=b|0;a[(c[b+408>>2]|0)+91|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+92|0]|0;i=i;return}function NS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+92|0]=a[d+91|0]|0;i=i;return}function OS(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+90|0]=a[d+92|0]|0;i=i;return}function PS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+90|0]=a[(c[b+408>>2]|0)+90|0]|0;i=i;return}function QS(a){a=a|0;h[(c[a+400>>2]|0)+6224>>3]=+h[c[c[a+4>>2]>>2]>>3];i=i;return}function RS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=+h[(c[a+400>>2]|0)+6224>>3];i=i;return}function SS(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6216>>3]=+h[b>>3]- +h[a+6224>>3];i=i;return}function TS(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+95|0]=0;i=i;return}function US(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+98|0]=a[d+95|0]|0;i=i;return}function VS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2192|0;h[c[g+1808>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2192>>3]);e=c[f>>2]|0;h[c[e+1812>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1804>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5928>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5928|0;h[(c[e+1808>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5928>>3]);h[(c[(c[f>>2]|0)+1812>>2]|0)+8>>3]=k;TFa(a,22)|0;j=c[(c[f>>2]|0)+1804>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2192>>3]=+h[j>>3];h[f+5928>>3]=+h[j+8>>3];lx(a);mx(a);nx(a);ox(a);px(a);qx(a);rx(a);i=b;return}function WS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2192>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2192>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5920>>3]=+h[f>>3];i=b;return}function XS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2192>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2192>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5912>>3]=+h[f>>3];i=b;return}function YS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2192>>3],+h[l+7352>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2192>>3];o=+h[m+7352>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5864>>3],+h[d+5912>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5888>>3]=+h[g>>3];i=b;return}function ZS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+5864>>3]*+h[(c[a+416>>2]|0)+3520>>3];i=i;return}function _S(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3568>>3]*+h[j+2976>>3]*+h[e+3512>>3];l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,64576,64568,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}function $S(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5864>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2776|0;k=+h[j>>3];l=g*k;m=f;n=m+2144|0;o=n;h[o>>3]=l;i=b;return}else{j=f+3816|0;k=+h[j>>3];l=g*k;m=f;n=m+2144|0;o=n;h[o>>3]=l;i=b;return}}function aT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2192>>3],+h[(c[b+416>>2]|0)+2712>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+71|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+71|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[b+360>>2]|0)+71|0]|0)|0;a[(c[b+352>>2]|0)+71|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[b+360>>2]|0)+71|0]|0)|0;a[(c[b+352>>2]|0)+71|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+71|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+71|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+71|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+11|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+11|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+11|0;v=u;a[v]=m;i=d;return}function bT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2184>>3]=-(+h[e+5864>>3]*+h[(a<<24>>24==0?e+176|0:e+7352|0)>>3]);i=b;return}function cT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+2200>>3]+ +h[b+2184>>3];i=i;return}function dT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+5600>>3]- +h[b+5864>>3];i=i;return}function eT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1884>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+448>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+448|0;h[c[g+1888>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+448>>3]);e=c[f>>2]|0;h[c[e+1892>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1884>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6520>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6520|0;h[(c[e+1888>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6520>>3]);h[(c[(c[f>>2]|0)+1892>>2]|0)+8>>3]=k;TFa(a,23)|0;j=c[(c[f>>2]|0)+1884>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+448>>3]=+h[j>>3];h[f+6520>>3]=+h[j+8>>3];ux(a);vx(a);wx(a);xx(a);i=b;return}function fT(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2680>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6520>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,64656,64648,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function gT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+7352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+7352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5904>>3]=+h[f>>3];i=b;return}function hT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5864>>3],+h[j+5920>>3],+h[j+5904>>3],+h[(c[b+416>>2]|0)+1232>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,64680,64672,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}function iT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+7352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+7352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5896>>3]=+h[f>>3];i=b;return}function jT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5928>>3],+h[l+176>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5928>>3];o=+h[m+176>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5864>>3],+h[d+5896>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5880>>3]=+h[g>>3];i=b;return}function kT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1576>>3]=+h[(a?e+2976|0:e+2968|0)>>3];i=b;return}function lT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3568>>3]*+h[j+2968>>3]*+h[e+3512>>3];l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,64784,64776,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}function mT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1568>>3]=+h[(a?e+2912|0:e+2904|0)>>3];i=b;return}function nT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+98|0]|0)==0){f=0;g=e;h=g+94|0;j=h;a[j]=f;i=d;return}f=(a[e+92|0]|0)==0|0;g=e;h=g+94|0;j=h;a[j]=f;i=d;return}function oT(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+113|0]=a[d+94|0]|0;i=i;return}function pT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+69|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+69|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3],a[(c[b+360>>2]|0)+69|0]|0)|0;a[(c[b+352>>2]|0)+69|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3],a[(c[b+360>>2]|0)+69|0]|0)|0;a[(c[b+352>>2]|0)+69|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+69|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3])|0;a[(c[b+352>>2]|0)+69|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3])|0;a[(c[b+352>>2]|0)+69|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+94|0]|0)==0){n=0;o=b;p=o+93|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+93|0;q=p;a[q]=n;i=d;return}function qT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+93|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+32|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}if((a[m+92|0]|0)==0){q=0;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}function rT(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+94|0]|0)==0){f=0.0;g=b;j=g+6232|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6216>>3];g=b;j=g+6232|0;k=j;h[k>>3]=f;i=d;return}function sT(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6240>>3]=(a[(c[d+16>>2]|0)+98|0]|0)!=0?1.0:0.0;i=i;return}function tT(b){b=b|0;a[(c[b+408>>2]|0)+97|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+98|0]|0;i=i;return}function uT(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+98|0]=a[d+97|0]|0;i=i;return}function vT(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+96|0]=a[d+98|0]|0;i=i;return}function wT(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+96|0]=a[(c[b+408>>2]|0)+96|0]|0;i=i;return}function xT(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+99|0]=0;i=i;return}function yT(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+102|0]=a[d+99|0]|0;i=i;return}function zT(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+33|0]|0)==0){f=0}else{if((a[e+102|0]|0)==0){f=0;break}f=(a[e+98|0]|0)==0|0}}while(0);a[e+34|0]=f;i=d;return}function AT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+34|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+93|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}if((a[m+98|0]|0)==0){q=0;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}function BT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1964>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2248>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2248|0;h[c[g+1968>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2248>>3]);e=c[f>>2]|0;h[c[e+1972>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1964>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6008>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6008|0;h[(c[e+1968>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6008>>3]);h[(c[(c[f>>2]|0)+1972>>2]|0)+8>>3]=k;TFa(a,24)|0;j=c[(c[f>>2]|0)+1964>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2248>>3]=+h[j>>3];h[f+6008>>3]=+h[j+8>>3];Ax(a);Bx(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);i=b;return}function CT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2248>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2248>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6e3>>3]=+h[f>>3];i=b;return}function DT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2248>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2248>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5992>>3]=+h[f>>3];i=b;return}function ET(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2248>>3],+h[l+7360>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2248>>3];o=+h[m+7360>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5944>>3],+h[d+5992>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5968>>3]=+h[g>>3];i=b;return}function FT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+5944>>3]*+h[(c[a+416>>2]|0)+3336>>3];i=i;return}function GT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3384>>3]*+h[j+3008>>3]*+h[e+3328>>3];l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,64864,64856,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}function HT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5944>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2776|0;k=+h[j>>3];l=g*k;m=f;n=m+2136|0;o=n;h[o>>3]=l;i=b;return}else{j=f+3824|0;k=+h[j>>3];l=g*k;m=f;n=m+2136|0;o=n;h[o>>3]=l;i=b;return}}function IT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+2136>>3]+(+h[b+2144>>3]+(+h[b+2104>>3]+ +h[b+2112>>3]));i=i;return}function JT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+5944>>3]+(+h[b+5864>>3]+(-+h[b+6024>>3]- +h[b+4944>>3]));i=i;return}function KT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2044>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+432|0;h[c[g+2048>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+432>>3]);e=c[f>>2]|0;h[c[e+2052>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2044>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6528|0;h[(c[e+2048>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6528>>3]);h[(c[(c[f>>2]|0)+2052>>2]|0)+8>>3]=k;TFa(a,25)|0;j=c[(c[f>>2]|0)+2044>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+432>>3]=+h[j>>3];h[f+6528>>3]=+h[j+8>>3];Jx(a);Kx(a);Lx(a);Mx(a);i=b;return}function LT(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2792>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6528>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,64944,64936,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}function MT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2248>>3],+h[(c[b+416>>2]|0)+2456>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+73|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+73|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[b+360>>2]|0)+73|0]|0)|0;a[(c[b+352>>2]|0)+73|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[b+360>>2]|0)+73|0]|0)|0;a[(c[b+352>>2]|0)+73|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+73|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+73|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+73|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+13|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+13|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+13|0;v=u;a[v]=m;i=d;return}function NT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2240>>3]=-(+h[e+5944>>3]*+h[(a<<24>>24==0?e+192|0:e+7360|0)>>3]);i=b;return}function OT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+2256>>3]+ +h[b+2240>>3];i=i;return}function PT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+5672>>3]- +h[b+5944>>3];i=i;return}function QT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+464>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+464|0;h[c[g+2128>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+464>>3]);e=c[f>>2]|0;h[c[e+2132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6512>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6512|0;h[(c[e+2128>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6512>>3]);h[(c[(c[f>>2]|0)+2132>>2]|0)+8>>3]=k;TFa(a,26)|0;j=c[(c[f>>2]|0)+2124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+464>>3]=+h[j>>3];h[f+6512>>3]=+h[j+8>>3];Px(a);Qx(a);Rx(a);Sx(a);i=b;return}function RT(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2424>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,64968,64960,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}function ST(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+7360>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+7360>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5984>>3]=+h[f>>3];i=b;return}function TT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5944>>3],+h[j+6e3>>3],+h[j+5984>>3],+h[(c[b+416>>2]|0)+1176>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,64992,64984,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}function UT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+7360>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+7360>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5976>>3]=+h[f>>3];i=b;return}function VT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+6008>>3],+h[l+192>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+6008>>3];o=+h[m+192>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5944>>3],+h[d+5976>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5960>>3]=+h[g>>3];i=b;return}function WT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1640>>3]=+h[(a?e+3008|0:e+3e3|0)>>3];i=b;return}function XT(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3384>>3]*+h[j+3e3>>3]*+h[e+3328>>3];l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,65096,65088,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}function YT(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1632>>3]=+h[(a?e+2896|0:e+2888|0)>>3];i=b;return}function ZT(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6248>>3]=(a[(c[d+16>>2]|0)+102|0]|0)!=0?1.0:0.0;i=i;return}function _T(b){b=b|0;a[(c[b+408>>2]|0)+101|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+102|0]|0;i=i;return}function $T(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+102|0]=a[d+101|0]|0;i=i;return}function aU(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+100|0]=a[d+102|0]|0;i=i;return}function bU(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+100|0]=a[(c[b+408>>2]|0)+100|0]|0;i=i;return}function cU(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+103|0]=1;i=i;return}function dU(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+106|0]=a[d+103|0]|0;i=i;return}function eU(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+37|0]|0)==0){f=0}else{if((a[e+73|0]|0)==0){f=0;break}f=(a[e+106|0]|0)==0|0}}while(0);a[e+38|0]=f;i=d;return}function fU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+26|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}if((a[m+44|0]|0)==0){q=0;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}function gU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+24|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}if((a[m+56|0]|0)==0){q=0;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}function hU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+106|0]|0)==0){f=0;g=e;h=g+36|0;j=h;a[j]=f;i=d;return}f=(a[e+102|0]|0)==0|0;g=e;h=g+36|0;j=h;a[j]=f;i=d;return}function iU(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+114|0]=a[d+36|0]|0;i=i;return}function jU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+74|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+74|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3],a[(c[b+360>>2]|0)+74|0]|0)|0;a[(c[b+352>>2]|0)+74|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3],a[(c[b+360>>2]|0)+74|0]|0)|0;a[(c[b+352>>2]|0)+74|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+74|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3])|0;a[(c[b+352>>2]|0)+74|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3])|0;a[(c[b+352>>2]|0)+74|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+36|0]|0)==0){n=0;o=b;p=o+35|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+35|0;q=p;a[q]=n;i=d;return}function kU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+35|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}if((a[m+106|0]|0)==0){q=0;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}function lU(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+35|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+34|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}if((a[m+102|0]|0)==0){q=0;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}



function rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[f>>3];i=b;return}function sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5440>>3]=+h[f>>3];i=b;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5416>>3]=+h[f>>3];i=b;return}function uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5424>>3]=+h[f>>3];i=b;return}function vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5392>>3]=+h[b+232>>3]- +h[b+56>>3];i=i;return}function wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+60|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1648>>3]*+h[f+5392>>3]*.01;k=g;l=k+1088|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5392>>3]*.01;k=g;l=k+1088|0;m=l;h[m>>3]=j;i=d;return}}function xj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1088>>3];h[b+1064>>3]=d*+h[(!(d>=0.0)?b+48|0:b+224|0)>>3];i=i;return}function yj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1088>>3],+h[j+5440>>3],+h[j+5424>>3],+h[(c[b+416>>2]|0)+1624>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1088>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2256,2248,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5384|0;q=p;h[q>>3]=n;i=d;return}function zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+56>>3],+h[l+224>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+56>>3];o=+h[m+224>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1088>>3],+h[d+5416>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5400>>3]=+h[g>>3];i=b;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+232>>3],+h[l+48>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+232>>3];o=+h[m+48>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1088>>3],+h[d+5432>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5408>>3]=+h[g>>3];i=b;return}function Bj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5368>>3]=+h[f>>3];i=b;return}function Cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+8>>3],+h[l+3704>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+8>>3];o=+h[m+3704>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+808>>3],+h[d+5368>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1680>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5344>>3]=+h[g>>3];i=b;return}function Dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5376>>3]=+h[f>>3];i=b;return}function Ej(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+808>>3],+h[j+5376>>3],+h[j+5360>>3],+h[(c[b+416>>2]|0)+1680>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+808>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2376,2368,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5304>>3]=+h[f>>3];i=b;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5312>>3]=+h[f>>3];i=b;return}function Hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5232>>3]=+h[f>>3];i=b;return}function Ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5240>>3]=+h[f>>3];i=b;return}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5216>>3]=+h[f>>3];i=b;return}function Kj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5224>>3]=+h[f>>3];i=b;return}function Lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5192>>3]=+h[b+216>>3]- +h[b+24>>3];i=i;return}function Mj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+48|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1816>>3]*+h[f+5192>>3]*.01;k=g;l=k+792|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5192>>3]*.01;k=g;l=k+792|0;m=l;h[m>>3]=j;i=d;return}}function Nj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+792>>3];h[b+768>>3]=d*+h[(!(d>=0.0)?b+16|0:b+208|0)>>3];i=i;return}function Oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+792>>3],+h[j+5240>>3],+h[j+5224>>3],+h[(c[b+416>>2]|0)+1792>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+792>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2488,2480,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}function Pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+24>>3],+h[l+208>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+24>>3];o=+h[m+208>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+792>>3],+h[d+5216>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1792>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5200>>3]=+h[g>>3];i=b;return}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+216>>3],+h[l+16>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+216>>3];o=+h[m+16>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+792>>3],+h[d+5232>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1792>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5208>>3]=+h[g>>3];i=b;return}function Rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5144>>3]=+h[f>>3];i=b;return}function Sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5152>>3]=+h[f>>3];i=b;return}function Tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5056>>3]=+h[f>>3];i=b;return}function Uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5064>>3]=+h[f>>3];i=b;return}function Vj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4976>>3]=+h[f>>3];i=b;return}function Wj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4984>>3]=+h[f>>3];i=b;return}function Xj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4920>>3]=+h[f>>3];i=b;return}function Yj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4928>>3]=+h[f>>3];i=b;return}function Zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4904>>3]=+h[f>>3];i=b;return}function _j(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4912>>3]=+h[f>>3];i=b;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4880>>3]=+h[b+104>>3]- +h[b+248>>3];i=i;return}function ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+h[(c[a+416>>2]|0)+2040>>3]*+h[b+4880>>3]*.01;i=i;return}function bk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4872>>3],+h[j+4928>>3],+h[j+4912>>3],+h[(c[b+416>>2]|0)+2016>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4872>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2608,2600,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}function ck(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4872>>3],+h[d+4904>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2016>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4888>>3]=+h[g>>3];i=b;return}function dk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4872>>3],+h[d+4920>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2016>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4896>>3]=+h[g>>3];i=b;return}function ek(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+53|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+53|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+53|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+53|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+53|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+54|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+54|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+54|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+54|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+54|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+55|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+55|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[b+360>>2]|0)+55|0]|0)|0;a[(c[b+352>>2]|0)+55|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[b+360>>2]|0)+55|0]|0)|0;a[(c[b+352>>2]|0)+55|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+55|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+55|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+55|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+100|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+100|0;H=G;c[H>>2]=y;i=d;return}function fk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+248>>3],+h[k+240>>3],c[(c[a+12>>2]|0)+100>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+248>>3];m=+h[g+240>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4816>>3]=+h[f>>3];i=b;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4784>>3]=+h[b+4816>>3]+-273.15;i=i;return}function hk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+248>>3],+h[k+240>>3],c[(c[a+12>>2]|0)+100>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+248>>3];m=+h[g+240>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4824>>3]=+h[f>>3];i=b;return}function ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=+h[(c[a+416>>2]|0)+2088>>3]*+h[b+4824>>3];i=i;return}function jk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+4824>>3];l=+h[g+248>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,2712,2704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4808>>3]=j-n;i=d;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4856>>3]=+h[b+4848>>3]*+h[b+4808>>3];i=i;return}function lk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4800>>3]=+h[d>>3];i=b;return}function mk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[f>>3];i=b;return}function nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[f>>3];i=b;return}function ok(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+50|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+50|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+50|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+50|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+50|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+51|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+51|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+51|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+51|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+51|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+52|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+52|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+52|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+52|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+52|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+96|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+96|0;H=G;c[H>>2]=y;i=d;return}function pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+232>>3],+h[k+224>>3],c[(c[a+12>>2]|0)+96>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+232>>3];m=+h[g+224>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2272>>3]=+h[f>>3];i=b;return}function qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],+h[d>>3],2736);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[e>>3];i=b;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4568>>3]=+h[b+2272>>3]+-273.15;i=i;return}function sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+232>>3],+h[k+224>>3],c[(c[a+12>>2]|0)+96>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+232>>3];m=+h[g+224>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4560>>3]=+h[f>>3];i=b;return}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+4560>>3]*1.0e-4;i=i;return}function uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=+h[g+4560>>3];l=+h[g+232>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,2776,2768,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4592>>3]=j-n;i=d;return}function vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+4680>>3]*+h[b+4592>>3];i=i;return}function wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4624>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4624|0;h[c[g+2848>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4624>>3]);e=c[f>>2]|0;h[c[e+2852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5520>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5520|0;h[(c[e+2848>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5520>>3]);j=c[f>>2]|0;h[(c[j+2852>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2844>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4600>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4600|0;h[(c[j+2848>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4600>>3]);h[(c[(c[f>>2]|0)+2852>>2]|0)+16>>3]=k;TFa(a,35)|0;g=c[(c[f>>2]|0)+2844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4624>>3]=+h[g>>3];h[f+5520>>3]=+h[g+8>>3];h[f+4600>>3]=+h[g+16>>3];By(a);Cy(a);Dy(a);Ey(a);i=b;return}function xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+536|0;j=c[g>>2]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+4600>>3];o=+h[m+4616>>3];p=+h[(c[b+416>>2]|0)+2160>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+SBa(j,o,2792,2784,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);Nt(e,j,n*q,.8);q=+h[e>>3];Nt(f,c[g>>2]|0,.0001001797131419643,.8);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4632>>3]=q;i=d;return}function yk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4624>>3];k=+h[g+4632>>3];l=+h[g+4600>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,2808,2800,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4640>>3]=j*n;i=d;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+4640>>3]*+(c[(c[a+420>>2]|0)+196>>2]|0);i=i;return}function Ak(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5552>>3]=+h[f>>3];i=b;return}function Bk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5560>>3]=+h[f>>3];i=b;return}function Ck(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[f>>3];i=b;return}function Dk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4696>>3],+h[d>>3],2816);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4528>>3]=+h[e>>3];i=b;return}function Ek(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4696>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4696>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4536>>3]=+h[f>>3];i=b;return}function Fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+2528>>3]*+h[g+4536>>3];k=+h[g+4528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,2864,2856,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+4520|0;p=o;h[p>>3]=m;i=d;return}function Gk(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+196>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+5520>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,2904,2896,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4608|0;q=p;h[q>>3]=n;i=d;return}function Hk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1088>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+224|0;h[f+4664>>3]=+h[f+5520>>3]*+h[(a<<24>>24==0?d:f+96|0)>>3]- +h[f+1088>>3]*+h[(e<<24>>24==0?d:f+48|0)>>3];i=b;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6664>>3]=+h[b+4664>>3]+ +h[b+4656>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+5520>>3]- +h[b+1088>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6800>>3]=-+h[b+4672>>3]/-1.0e-4;i=i;return}function Lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4680>>3];k=+h[g+6664>>3]- +h[g+4672>>3]*+h[g+4592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,2936,2928,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6576|0;p=o;h[p>>3]=m;i=d;return}function Mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5520>>3],+h[j+5576>>3],+h[j+5560>>3],+h[(c[b+416>>2]|0)+1512>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5520>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2952,2944,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5512|0;q=p;h[q>>3]=n;i=d;return}function Nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4696>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4696>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5520>>3],+h[d+5552>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5536>>3]=+h[g>>3];i=b;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+224>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+224>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5520>>3],+h[d+5568>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5544>>3]=+h[g>>3];i=b;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+496>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+496|0;h[c[g+2928>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+496>>3]);e=c[f>>2]|0;h[c[e+2932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+504>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+504|0;h[(c[e+2928>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+504>>3]);h[(c[(c[f>>2]|0)+2932>>2]|0)+8>>3]=k;TFa(a,36)|0;a=c[(c[f>>2]|0)+2924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+496>>3]=+h[a>>3];h[f+504>>3]=+h[a+8>>3];i=b;return}function Qk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4584>>3]=+h[d>>3];i=b;return}function Rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+47|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+47|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+47|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+47|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+47|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+48|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+48|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+48|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+48|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+48|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+49|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+49|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+49|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+49|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+49|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+92|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+92|0;H=G;c[H>>2]=y;i=d;return}function Sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+216>>3],+h[k+208>>3],c[(c[a+12>>2]|0)+92>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+216>>3];m=+h[g+208>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2264>>3]=+h[f>>3];i=b;return}function Tk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],+h[d>>3],2736);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4352>>3]=+h[e>>3];i=b;return}function Uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+2264>>3]+-273.15;i=i;return}function Vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+216>>3],+h[k+208>>3],c[(c[a+12>>2]|0)+92>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+216>>3];m=+h[g+208>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4368>>3]=+h[f>>3];i=b;return}function Wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+4368>>3]*1.0e-4;i=i;return}function Xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=+h[g+4368>>3];l=+h[g+216>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,3056,3048,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4400>>3]=j-n;i=d;return}function Yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4496>>3]=+h[b+4488>>3]*+h[b+4400>>3];i=i;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4432|0;h[c[g+3008>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4432>>3]);e=c[f>>2]|0;h[c[e+3012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5256>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5256|0;h[(c[e+3008>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5256>>3]);j=c[f>>2]|0;h[(c[j+3012>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3004>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4408>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4408|0;h[(c[j+3008>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4408>>3]);h[(c[(c[f>>2]|0)+3012>>2]|0)+16>>3]=k;TFa(a,37)|0;g=c[(c[f>>2]|0)+3004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4432>>3]=+h[g>>3];h[f+5256>>3]=+h[g+8>>3];h[f+4408>>3]=+h[g+16>>3];Jy(a);Ky(a);Ly(a);My(a);i=b;return}function _k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+536|0;j=c[g>>2]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+4408>>3];o=+h[m+4424>>3];p=+h[(c[b+416>>2]|0)+2280>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+SBa(j,o,3072,3064,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);Nt(e,j,n*q,.8);q=+h[e>>3];Nt(f,c[g>>2]|0,.0001001797131419643,.8);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4440>>3]=q;i=d;return}function $k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4432>>3];k=+h[g+4440>>3];l=+h[g+4408>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,3088,3080,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4448>>3]=j*n;i=d;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+4448>>3]*+(c[(c[a+420>>2]|0)+220>>2]|0);i=i;return}function bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5288>>3]=+h[f>>3];i=b;return}function cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5296>>3]=+h[f>>3];i=b;return}function dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4360>>3]=+h[f>>3];i=b;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4360>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],+h[d>>3],2816);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4336>>3]=+h[e>>3];i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4344>>3]=+h[f>>3];i=b;return}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+2528>>3]*+h[g+4344>>3];k=+h[g+4336>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,3104,3096,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}function hl(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+220>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+5256>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,3144,3136,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}function il(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5256>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+792>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+208|0;h[f+4472>>3]=+h[f+5256>>3]*+h[(a<<24>>24==0?d:f+240|0)>>3]- +h[f+792>>3]*+h[(e<<24>>24==0?d:f+16|0)>>3];i=b;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6672>>3]=+h[b+4472>>3]+ +h[b+4464>>3];i=i;return}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+5256>>3]- +h[b+792>>3];i=i;return}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6808>>3]=-+h[b+4480>>3]/-1.0e-4;i=i;return}function ml(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4488>>3];k=+h[g+6672>>3]- +h[g+4480>>3]*+h[g+4400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,3176,3168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5256>>3],+h[j+5312>>3],+h[j+5296>>3],+h[(c[b+416>>2]|0)+1736>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5256>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,3192,3184,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}function ol(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4504>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4504>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5256>>3],+h[d+5288>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1736>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5272>>3]=+h[g>>3];i=b;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+208>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+208>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5256>>3],+h[d+5304>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1736>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5280>>3]=+h[g>>3];i=b;return}function ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+480>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+480|0;h[c[g+3088>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+480>>3]);e=c[f>>2]|0;h[c[e+3092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+488>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+488|0;h[(c[e+3088>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+488>>3]);h[(c[(c[f>>2]|0)+3092>>2]|0)+8>>3]=k;TFa(a,38)|0;a=c[(c[f>>2]|0)+3084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+480>>3]=+h[a>>3];h[f+488>>3]=+h[a+8>>3];i=b;return}function rl(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4392>>3]=+h[d>>3];i=b;return}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2456>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2456>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+45|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+45|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+45|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+45|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+45|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2456>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2456>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+46|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+46|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+46|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+46|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+46|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2456>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+88|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+88|0;J=I;c[J>>2]=x;i=d;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2456>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2208>>3]=+h[f>>3];i=b;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+2208>>3]+-273.15;i=i;return}function vl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2456>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4264>>3]=+h[f>>3];i=b;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=+h[g+4264>>3];l=+h[(c[b+416>>2]|0)+2456>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3296,3288,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2424>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3312,e);p=+h[(c[f>>2]|0)+2424>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2216>>3]=p+g*+h[f+200>>3]*2.0;i=b;return}function yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2712>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2712>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+41|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+41|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+41|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+41|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+41|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2712>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2712>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+42|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+42|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+42|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+42|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+42|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2712>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+84|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+84|0;J=I;c[J>>2]=x;i=d;return}function zl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2712>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2152>>3]=+h[f>>3];i=b;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+2152>>3]+-273.15;i=i;return}function Bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2712>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4128>>3]=+h[f>>3];i=b;return}function Cl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+176>>3];k=+h[g+4128>>3];l=+h[(c[b+416>>2]|0)+2712>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3408,3400,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}function Dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2680>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3424,e);p=+h[(c[f>>2]|0)+2680>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2160>>3]=p+g*+h[f+184>>3]*2.0;i=b;return}function El(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2824>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2824>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+37|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+37|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+37|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+37|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+37|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2824>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2824>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+38|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+38|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+38|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+38|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+38|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2824>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+80|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+80|0;J=I;c[J>>2]=x;i=d;return}function Fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2824>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+160>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2056>>3]=+h[f>>3];i=b;return}function Gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+2056>>3]+-273.15;i=i;return}function Hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2824>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+160>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4056>>3]=+h[f>>3];i=b;return}function Il(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+4056>>3];l=+h[(c[b+416>>2]|0)+2824>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3520,3512,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2792>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3536,e);p=+h[(c[f>>2]|0)+2792>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2064>>3]=p+g*+h[f+168>>3]*2.0;i=b;return}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2936>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2936>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+31|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+31|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+31|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+31|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+31|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2936>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2936>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+32|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+32|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+32|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+32|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+32|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2936>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+76|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+76|0;J=I;c[J>>2]=x;i=d;return}function Ll(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2936>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+144>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[f>>3];i=b;return}function Ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+2e3>>3]+-273.15;i=i;return}function Nl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2936>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+144>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3984>>3]=+h[f>>3];i=b;return}function Ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+3984>>3];l=+h[(c[b+416>>2]|0)+2936>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3632,3624,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}function Pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2904>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3648,e);p=+h[(c[f>>2]|0)+2904>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2008>>3]=p+g*+h[f+152>>3]*2.0;i=b;return}function Ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+3048>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+3048>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+27|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+27|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+27|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+27|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+27|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+3048>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+3048>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+28|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+28|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+28|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+28|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+28|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+3048>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+72|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+72|0;J=I;c[J>>2]=x;i=d;return}function Rl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+3048>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3]=+h[f>>3];i=b;return}function Sl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3904>>3]=+h[b+6280>>3]*(+h[d+952>>3]*(+h[b+1944>>3]- +h[d+944>>3])+1.0);i=i;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+1944>>3]+-273.15;i=i;return}function Ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+77|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+77|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[b+360>>2]|0)+77|0]|0)|0;a[(c[b+352>>2]|0)+77|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[b+360>>2]|0)+77|0]|0)|0;a[(c[b+352>>2]|0)+77|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+77|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0)|0;a[(c[b+352>>2]|0)+77|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0)|0;a[(c[b+352>>2]|0)+77|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+19|0]=f;i=d;return}function Vl(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+19|0]|0)==0){f=0}else{if((a[e+64|0]|0)==0){f=0;break}f=(a[e+60|0]|0)==0|0}}while(0);a[e+20|0]=f;i=d;return}function Wl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+20|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+24|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}if((a[m+60|0]|0)==0){q=0;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+59|0;t=s;a[t]=q;i=d;return}function Xl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+28|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+20|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}if((a[m+64|0]|0)==0){q=0;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}function Yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+3048>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3896>>3]=+h[f>>3];i=b;return}function Zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+128>>3];k=+h[g+3896>>3];l=+h[(c[b+416>>2]|0)+3048>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3744,3736,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}function _l(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+3016>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3760,e);p=+h[(c[f>>2]|0)+3016>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+1952>>3]=p+g*+h[f+136>>3]*2.0;i=b;return}function $l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+3904>>3]+ +h[b+1952>>3]*(+h[(c[a+416>>2]|0)+3096>>3]- +h[b+1944>>3])*4.9;i=i;return}function am(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+4752>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+4752>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+23|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+23|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+23|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+23|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+23|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+4752>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+4752>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+24|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+24|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+24|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+24|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+24|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+4752>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+68|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+68|0;J=I;c[J>>2]=x;i=d;return}function bm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+4752>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[f>>3];i=b;return}function cm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3624>>3]=+h[b+6272>>3]*(+h[d+968>>3]*(+h[b+544>>3]- +h[d+960>>3])+1.0);i=i;return}function dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=+h[b+544>>3]+-273.15;i=i;return}function em(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+78|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+78|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[b+360>>2]|0)+78|0]|0)|0;a[(c[b+352>>2]|0)+78|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[b+360>>2]|0)+78|0]|0)|0;a[(c[b+352>>2]|0)+78|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+78|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],298.0)|0;a[(c[b+352>>2]|0)+78|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],298.0)|0;a[(c[b+352>>2]|0)+78|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+21|0]=f;i=d;return}function fm(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+21|0]|0)==0){f=0}else{if((a[e+52|0]|0)==0){f=0;break}f=(a[e+48|0]|0)==0|0}}while(0);a[e+22|0]=f;i=d;return}function gm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+22|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}if((a[m+52|0]|0)==0){q=0;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+51|0;t=s;a[t]=q;i=d;return}function hm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+22|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+26|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}if((a[m+48|0]|0)==0){q=0;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+47|0;t=s;a[t]=q;i=d;return}function im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+4752>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3616>>3]=+h[f>>3];i=b;return}function jm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+112>>3];k=+h[g+3616>>3];l=+h[(c[b+416>>2]|0)+4752>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,3856,3848,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}function km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+4720>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,3896,e);p=+h[(c[f>>2]|0)+4720>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+552>>3]=p+g*+h[f+120>>3]*2.0;i=b;return}function lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=+h[b+3624>>3]+ +h[b+552>>3]*(+h[(c[a+416>>2]|0)+4800>>3]- +h[b+544>>3])*4.9;i=i;return}function mm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+18|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+18|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+18|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+18|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+18|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+19|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+19|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+19|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+19|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+19|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+20|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+20|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+20|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+20|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+20|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+64|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+64|0;H=G;c[H>>2]=y;i=d;return}function nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+104>>3],+h[k+96>>3],c[(c[a+12>>2]|0)+64>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+104>>3];m=+h[g+96>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[f>>3];i=b;return}function om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3504>>3]=+h[b+3536>>3]+-273.15;i=i;return}function pm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+104>>3],+h[k+96>>3],c[(c[a+12>>2]|0)+64>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+104>>3];m=+h[g+96>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3544>>3]=+h[f>>3];i=b;return}function qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[(c[a+416>>2]|0)+4824>>3]*+h[b+3544>>3];i=i;return}function rm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3];k=+h[g+3544>>3];l=+h[g+104>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,3992,3984,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3528>>3]=j-n;i=d;return}function sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+3568>>3]*+h[b+3528>>3];i=i;return}function tm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+104>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3520>>3]=+h[d>>3];i=b;return}function um(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1752>>3]=(+h[b+352>>3]+ +h[b+360>>3])*(+h[d+72>>3]- +h[d+88>>3])*+h[b+3208>>3]*.5;i=i;return}function vm(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3208>>3]*(+h[e+352>>3]+ +h[e+360>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1752>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,4024,4016,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}function wm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+15|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+15|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+15|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+16|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+16|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+16|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+16|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+16|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+17|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+17|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+17|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+17|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+17|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}function xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+88>>3],+h[k+80>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+88>>3];m=+h[g+80>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[f>>3];i=b;return}function ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1712>>3]=+h[b+1648>>3]+-273.15;i=i;return}function zm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+88>>3],+h[k+80>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+88>>3];m=+h[g+80>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1800>>3]=+h[f>>3];i=b;return}function Am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+3168>>3]*+h[b+1800>>3];i=i;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=+h[g+1800>>3];l=+h[g+88>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,4120,4112,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1736>>3]=j-n;i=d;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+1912>>3]*+h[b+1736>>3];i=i;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1800>>3],+h[g+1648>>3],+h[g+88>>3],c[(c[f+12>>2]|0)+20>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3]=+h[d>>3];i=b;return}function Em(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1728>>3]=+h[d>>3];i=b;return}



function N0a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[78928]|0)==-1)){c[p>>2]=315712;c[p+4>>2]=664;c[p+8>>2]=0;qWa(315712,p,665)}p=(c[315716>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;p4a(I);J=331832;K=127;Xd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;p4a(I);J=331832;K=127;Xd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ke[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ke[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;FWa(s)}else{ke[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ke[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FWa(v)}a[g]=me[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=me[c[(c[e>>2]|0)+16>>2]&127](K)|0;ke[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FWa(w);ke[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}RWa(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FWa(x);L=me[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[78912]|0)==-1)){c[o>>2]=315648;c[o+4>>2]=664;c[o+8>>2]=0;qWa(315648,o,665)}o=(c[315652>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ke[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ke[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;FWa(A)}else{ke[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ke[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}RWa(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;FWa(D)}a[g]=me[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=me[c[(c[G>>2]|0)+16>>2]&127](P)|0;ke[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;FWa(E);ke[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}RWa(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;FWa(F);L=me[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function O0a(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 0:{c[e>>2]=c[f>>2];I=H;break};case 3:{J=a[r]|0;K=(J&1)==0;if(K){L=(J&255)>>>1}else{L=c[w>>2]|0}if((L|0)==0){I=H;break a}if(K){M=u}else{M=c[v>>2]|0}K=a[M]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=K;I=H;break};case 1:{c[e>>2]=c[f>>2];K=Ce[c[(c[k>>2]|0)+28>>2]&127](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=K;I=H;break};case 2:{K=a[q]|0;J=(K&1)==0;if(J){N=(K&255)>>>1}else{N=c[A>>2]|0}if((N|0)==0|x){I=H;break a}if(J){O=y;P=(K&255)>>>1}else{O=c[z>>2]|0;P=c[A>>2]|0}K=O+P|0;J=c[f>>2]|0;if((O|0)==(K|0)){Q=J}else{R=J;J=O;while(1){a[R]=a[J]|0;S=J+1|0;T=R+1|0;if((S|0)==(K|0)){Q=T;break}else{J=S;R=T}}}c[f>>2]=Q;I=H;break};case 4:{R=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){K=J;while(1){T=a[K]|0;if(!(T<<24>>24>-1)){U=K;break b}S=K+1|0;if((b[(c[F>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=K;break b}if(S>>>0<j>>>0){K=S}else{U=S;break}}}else{U=J}}while(0);K=U;if(B){if(U>>>0>J>>>0){S=J+(0-K)|0;K=S>>>0<G>>>0?G:S;S=K+s|0;T=R;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=T+1;a[T]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>J>>>0&Z)){break}T=c[f>>2]|0;W=Y;V=X}V=U+K|0;if(Z){_=V;$=S;aa=32}else{ba=0;ca=V;da=S}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=Ce[c[(c[k>>2]|0)+28>>2]&127](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;T=da;while(1){a[W]=ba;X=T+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){T=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(J|0)){W=Ce[c[(c[k>>2]|0)+28>>2]&127](k,48)|0;T=c[f>>2]|0;c[f>>2]=T+1;a[T]=W}else{W=a[p]|0;T=(W&1)==0;if(T){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(T){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=o;T=ja+1|0;W=a[p]|0;S=(W&1)==0;if(S){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(T>>>0<ma>>>0)){na=ia;oa=T;pa=0;break}if(S){qa=C}else{qa=c[D>>2]|0}if((a[qa+T|0]|0)==127){na=-1;oa=T;pa=0;break}if(S){ra=C}else{ra=c[D>>2]|0}na=a[ra+T|0]|0;oa=T;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);T=ha+ -1|0;S=a[T]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=S;if((T|0)==(J|0)){break}else{ha=T;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((R|0)==(V|0)){I=J;break a}T=V+ -1|0;if(T>>>0>R>>>0){sa=R;ta=T}else{I=J;break a}while(1){T=a[sa]|0;a[sa]=a[ta]|0;a[ta]=T;T=sa+1|0;V=ta+ -1|0;if(T>>>0<V>>>0){ta=V;sa=T}else{I=J;break}}break};default:{I=H}}}while(0);J=h+1|0;if(J>>>0<4){H=I;h=J}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function P0a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;BXa(m,g);z=m;A=c[z>>2]|0;if(!((c[79068]|0)==-1)){c[l>>2]=316272;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316272,l,665)}l=(c[316276>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(Ce[c[(c[A>>2]|0)+28>>2]&127](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;N0a(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=K4a(P)|0;if((N|0)!=0){Q=N;R=N;break}X4a()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}O0a(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];cTa(b,k,R,e,w,g,h);if((Q|0)==0){FWa(t);FWa(s);FWa(r);U=c[z>>2]|0;V=U;W=V;X=XVa(W)|0;i=d;return}L4a(Q);FWa(t);FWa(s);FWa(r);U=c[z>>2]|0;V=U;W=V;X=XVa(W)|0;i=d;return}function Q0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function R0a(a){a=a|0;i=i;return}function S0a(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Pc(G|0,100,316024,o|0)|0;do{if(s>>>0>99){do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);o=c[79040]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=E_a(r,o,316024,n)|0;o=c[r>>2]|0;if((o|0)==0){X4a()}H=K4a(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}X4a()}else{J=0;K=0;L=q;M=s}}while(0);BXa(t,g);s=t;q=c[s>>2]|0;if(!((c[79066]|0)==-1)){c[p>>2]=316264;c[p+4>>2]=664;c[p+8>>2]=0;qWa(316264,p,665)}p=(c[316268>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Hc(4)|0;O=N;p4a(O);P=331832;Q=127;Xd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Hc(4)|0;O=N;p4a(O);P=331832;Q=127;Xd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Me[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;T0a(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=K4a(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}X4a()}else{X=0;Y=t}}while(0);U0a(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];N_a(b,m,Y,e,D,g,j);if((X|0)!=0){L4a(X)}hXa(A);hXa(z);FWa(y);XVa(c[s>>2]|0)|0;if((K|0)!=0){L4a(K)}if((J|0)==0){i=d;return}L4a(J);i=d;return}function T0a(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[78960]|0)==-1)){c[p>>2]=315840;c[p+4>>2]=664;c[p+8>>2]=0;qWa(315840,p,665)}p=(c[315844>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Hc(4)|0;I=H;p4a(I);J=331832;K=127;Xd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Hc(4)|0;I=H;p4a(I);J=331832;K=127;Xd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ke[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ke[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;hXa(s)}else{ke[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ke[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;hXa(v)}c[g>>2]=me[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=me[c[(c[e>>2]|0)+16>>2]&127](K)|0;ke[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;FWa(w);ke[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}kXa(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;hXa(x);L=me[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[78944]|0)==-1)){c[o>>2]=315776;c[o+4>>2]=664;c[o+8>>2]=0;qWa(315776,o,665)}o=(c[315780>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Hc(4)|0;N=M;p4a(N);O=331832;P=127;Xd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ke[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ke[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;hXa(A)}else{ke[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ke[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}kXa(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;hXa(D)}c[g>>2]=me[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=me[c[(c[G>>2]|0)+16>>2]&127](P)|0;ke[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}RWa(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;FWa(E);ke[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}kXa(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;hXa(F);L=me[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function U0a(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 4:{E=c[e>>2]|0;F=k?C+4|0:C;b:do{if(F>>>0<h>>>0){G=F;while(1){H=G+4|0;if(!(pe[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[G>>2]|0)|0)){I=G;break b}if(H>>>0<h>>>0){G=H}else{I=H;break}}}else{I=F}}while(0);if(y){do{if(I>>>0>F>>>0){G=c[e>>2]|0;H=I;J=r;while(1){K=H+ -4|0;L=G+4|0;c[G>>2]=c[K>>2];M=J+ -1|0;N=(M|0)>0;if(K>>>0>F>>>0&N){J=M;H=K;G=L}else{break}}c[e>>2]=L;if(N){O=K;P=M;Q=34;break}G=c[e>>2]|0;c[e>>2]=G+4;R=G;S=K}else{O=I;P=r;Q=34}}while(0);do{if((Q|0)==34){Q=0;G=Ce[c[(c[j>>2]|0)+44>>2]&127](j,48)|0;H=c[e>>2]|0;J=H+4|0;c[e>>2]=J;if((P|0)>0){T=J;U=H;V=P}else{R=H;S=O;break}while(1){c[U>>2]=G;J=V+ -1|0;if((J|0)>0){V=J;U=T;T=T+4|0}else{break}}c[e>>2]=H+(P+1<<2);R=H+(P<<2)|0;S=O}}while(0);c[R>>2]=m;W=S}else{W=I}if((W|0)==(F|0)){G=Ce[c[(c[j>>2]|0)+44>>2]&127](j,48)|0;J=c[e>>2]|0;X=J+4|0;c[e>>2]=X;c[J>>2]=G;Y=X}else{X=a[o]|0;G=(X&1)==0;if(G){Z=(X&255)>>>1}else{Z=c[B>>2]|0}if((Z|0)==0){_=W;$=-1;aa=0;ba=0}else{if(G){ca=z}else{ca=c[A>>2]|0}_=W;$=a[ca]|0;aa=0;ba=0}while(1){G=c[e>>2]|0;do{if((ba|0)==($|0)){X=G+4|0;c[e>>2]=X;c[G>>2]=n;J=aa+1|0;da=a[o]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[B>>2]|0}if(!(J>>>0<fa>>>0)){ga=X;ha=$;ia=J;ja=0;break}if(ea){ka=z}else{ka=c[A>>2]|0}if((a[ka+J|0]|0)==127){ga=X;ha=-1;ia=J;ja=0;break}if(ea){la=z}else{la=c[A>>2]|0}ga=X;ha=a[la+J|0]|0;ia=J;ja=0}else{ga=G;ha=$;ia=aa;ja=ba}}while(0);G=_+ -4|0;H=c[G>>2]|0;J=ga+4|0;c[e>>2]=J;c[ga>>2]=H;if((G|0)==(F|0)){Y=J;break}else{_=G;$=ha;aa=ia;ba=ja+1|0}}}if((E|0)==(Y|0)){D=F;break a}G=Y+ -4|0;if(G>>>0>E>>>0){ma=E;na=G}else{D=F;break a}while(1){G=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=G;G=ma+4|0;J=na+ -4|0;if(G>>>0<J>>>0){na=J;ma=G}else{D=F;break}}break};case 1:{c[d>>2]=c[e>>2];F=Ce[c[(c[j>>2]|0)+44>>2]&127](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=F;D=C;break};case 3:{F=a[q]|0;E=(F&1)==0;if(E){oa=(F&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){D=C;break a}if(E){pa=t}else{pa=c[u>>2]|0}E=c[pa>>2]|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 2:{E=a[p]|0;F=(E&1)==0;if(F){qa=(E&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){D=C;break a}if(F){ra=w;sa=(E&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}E=ra+(sa<<2)|0;F=c[e>>2]|0;if((ra|0)==(E|0)){ta=F}else{G=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;J=F;H=ra;while(1){c[J>>2]=c[H>>2];X=H+4|0;if((X|0)==(E|0)){break}J=J+4|0;H=X}ta=F+(G+1<<2)|0}c[e>>2]=ta;D=C;break};default:{D=C}}}while(0);H=g+1|0;if(H>>>0<4){C=D;g=H}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function V0a(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;BXa(m,g);z=m;A=c[z>>2]|0;if(!((c[79066]|0)==-1)){c[l>>2]=316264;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316264,l,665)}l=(c[316268>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Hc(4)|0;D=C;p4a(D);E=331832;F=127;Xd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(Ce[c[(c[A>>2]|0)+44>>2]&127](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;T0a(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=K4a(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}X4a()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}U0a(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];N_a(b,k,R,e,w,g,h);if((Q|0)==0){hXa(t);hXa(s);FWa(r);U=c[z>>2]|0;V=U;W=V;X=XVa(W)|0;i=d;return}L4a(Q);hXa(t);hXa(s);FWa(r);U=c[z>>2]|0;V=U;W=V;X=XVa(W)|0;i=d;return}function W0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function X0a(a){a=a|0;i=i;return}function Y0a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function Z0a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{XWa(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Cd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=m5a(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{FWa(j);i=d;return}do{XWa(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);FWa(j);i=d;return}function _0a(a,b){a=a|0;b=b|0;a=i;Jb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function $0a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function a1a(a){a=a|0;i=i;return}function b1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=xc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function c1a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=317928;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=317928|0;while(1){c[m>>2]=y;A=(Le[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{XWa(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}x0a(317152)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Cd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=318032;D=m5a(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){FWa(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=318032|0;while(1){c[q>>2]=o;h=(Le[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{lXa(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){x0a(317152)}else if((E|0)==25){FWa(r);i=d;return}}function d1a(a,b){a=a|0;b=b|0;a=i;Jb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function e1a(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=316360;e=b+8|0;b=c[e>>2]|0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);if((b|0)==(c[79040]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function f1a(a){a=a|0;a=Hc(8)|0;YVa(a,316152);c[a>>2]=313120;Xd(a|0,313160,40)}function g1a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=316192;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);xWa(b+144|0,316176,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[321084>>2]=0;c[80270]=314672;if(!((c[78674]|0)==-1)){c[G>>2]=314696;c[G+4>>2]=664;c[G+8>>2]=0;qWa(314696,G,665)}h1a(b,321080,(c[314700>>2]|0)+ -1|0);c[321076>>2]=0;c[80268]=314712;if(!((c[78684]|0)==-1)){c[F>>2]=314736;c[F+4>>2]=664;c[F+8>>2]=0;qWa(314736,F,665)}h1a(b,321072,(c[314740>>2]|0)+ -1|0);c[321060>>2]=0;c[80264]=316288;c[321064>>2]=0;a[321068|0]=0;F=c[(Bc()|0)>>2]|0;c[321064>>2]=F;if(!((c[79068]|0)==-1)){c[E>>2]=316272;c[E+4>>2]=664;c[E+8>>2]=0;qWa(316272,E,665)}h1a(b,321056,(c[316276>>2]|0)+ -1|0);c[321052>>2]=0;c[80262]=317248;if(!((c[79066]|0)==-1)){c[D>>2]=316264;c[D+4>>2]=664;c[D+8>>2]=0;qWa(316264,D,665)}h1a(b,321048,(c[316268>>2]|0)+ -1|0);c[321044>>2]=0;c[80260]=317464;if(!((c[79084]|0)==-1)){c[C>>2]=316336;c[C+4>>2]=664;c[C+8>>2]=0;qWa(316336,C,665)}h1a(b,321040,(c[316340>>2]|0)+ -1|0);c[321028>>2]=0;c[80256]=316360;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);c[321032>>2]=c[79040];if(!((c[79086]|0)==-1)){c[B>>2]=316344;c[B+4>>2]=664;c[B+8>>2]=0;qWa(316344,B,665)}h1a(b,321024,(c[316348>>2]|0)+ -1|0);c[321020>>2]=0;c[80254]=317688;if(!((c[79100]|0)==-1)){c[A>>2]=316400;c[A+4>>2]=664;c[A+8>>2]=0;qWa(316400,A,665)}h1a(b,321016,(c[316404>>2]|0)+ -1|0);c[321012>>2]=0;c[80252]=317808;if(!((c[79102]|0)==-1)){c[z>>2]=316408;c[z+4>>2]=664;c[z+8>>2]=0;qWa(316408,z,665)}h1a(b,321008,(c[316412>>2]|0)+ -1|0);c[320988>>2]=0;c[80246]=316440;a[320992|0]=46;a[320993|0]=44;z=320996|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[79104]|0)==-1)){c[y>>2]=316416;c[y+4>>2]=664;c[y+8>>2]=0;qWa(316416,y,665)}h1a(b,320984,(c[316420>>2]|0)+ -1|0);c[320956>>2]=0;c[80238]=316480;c[320960>>2]=46;c[320964>>2]=44;y=320968|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[79106]|0)==-1)){c[x>>2]=316424;c[x+4>>2]=664;c[x+8>>2]=0;qWa(316424,x,665)}h1a(b,320952,(c[316428>>2]|0)+ -1|0);c[320948>>2]=0;c[80236]=314752;if(!((c[78702]|0)==-1)){c[w>>2]=314808;c[w+4>>2]=664;c[w+8>>2]=0;qWa(314808,w,665)}h1a(b,320944,(c[314812>>2]|0)+ -1|0);c[320940>>2]=0;c[80234]=314872;if(!((c[78732]|0)==-1)){c[v>>2]=314928;c[v+4>>2]=664;c[v+8>>2]=0;qWa(314928,v,665)}h1a(b,320936,(c[314932>>2]|0)+ -1|0);c[320932>>2]=0;c[80232]=314944;if(!((c[78748]|0)==-1)){c[u>>2]=314992;c[u+4>>2]=664;c[u+8>>2]=0;qWa(314992,u,665)}h1a(b,320928,(c[314996>>2]|0)+ -1|0);c[320924>>2]=0;c[80230]=315008;if(!((c[78764]|0)==-1)){c[t>>2]=315056;c[t+4>>2]=664;c[t+8>>2]=0;qWa(315056,t,665)}h1a(b,320920,(c[315060>>2]|0)+ -1|0);c[320916>>2]=0;c[80228]=315600;if(!((c[78912]|0)==-1)){c[s>>2]=315648;c[s+4>>2]=664;c[s+8>>2]=0;qWa(315648,s,665)}h1a(b,320912,(c[315652>>2]|0)+ -1|0);c[320908>>2]=0;c[80226]=315664;if(!((c[78928]|0)==-1)){c[r>>2]=315712;c[r+4>>2]=664;c[r+8>>2]=0;qWa(315712,r,665)}h1a(b,320904,(c[315716>>2]|0)+ -1|0);c[320900>>2]=0;c[80224]=315728;if(!((c[78944]|0)==-1)){c[q>>2]=315776;c[q+4>>2]=664;c[q+8>>2]=0;qWa(315776,q,665)}h1a(b,320896,(c[315780>>2]|0)+ -1|0);c[320892>>2]=0;c[80222]=315792;if(!((c[78960]|0)==-1)){c[p>>2]=315840;c[p+4>>2]=664;c[p+8>>2]=0;qWa(315840,p,665)}h1a(b,320888,(c[315844>>2]|0)+ -1|0);c[320884>>2]=0;c[80220]=315856;if(!((c[78970]|0)==-1)){c[o>>2]=315880;c[o+4>>2]=664;c[o+8>>2]=0;qWa(315880,o,665)}h1a(b,320880,(c[315884>>2]|0)+ -1|0);c[320876>>2]=0;c[80218]=315936;if(!((c[78990]|0)==-1)){c[n>>2]=315960;c[n+4>>2]=664;c[n+8>>2]=0;qWa(315960,n,665)}h1a(b,320872,(c[315964>>2]|0)+ -1|0);c[320868>>2]=0;c[80216]=315992;if(!((c[79004]|0)==-1)){c[m>>2]=316016;c[m+4>>2]=664;c[m+8>>2]=0;qWa(316016,m,665)}h1a(b,320864,(c[316020>>2]|0)+ -1|0);c[320860>>2]=0;c[80214]=316040;if(!((c[79016]|0)==-1)){c[l>>2]=316064;c[l+4>>2]=664;c[l+8>>2]=0;qWa(316064,l,665)}h1a(b,320856,(c[316068>>2]|0)+ -1|0);c[320844>>2]=0;c[80210]=315088;c[320848>>2]=315136;if(!((c[78792]|0)==-1)){c[k>>2]=315168;c[k+4>>2]=664;c[k+8>>2]=0;qWa(315168,k,665)}h1a(b,320840,(c[315172>>2]|0)+ -1|0);c[320828>>2]=0;c[80206]=315240;c[320832>>2]=315288;if(!((c[78830]|0)==-1)){c[j>>2]=315320;c[j+4>>2]=664;c[j+8>>2]=0;qWa(315320,j,665)}h1a(b,320824,(c[315324>>2]|0)+ -1|0);c[320812>>2]=0;c[80202]=317184;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);c[320816>>2]=c[79040];c[80202]=315536;if(!((c[78888]|0)==-1)){c[h>>2]=315552;c[h+4>>2]=664;c[h+8>>2]=0;qWa(315552,h,665)}h1a(b,320808,(c[315556>>2]|0)+ -1|0);c[320796>>2]=0;c[80198]=317184;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);c[320800>>2]=c[79040];c[80198]=315568;if(!((c[78896]|0)==-1)){c[g>>2]=315584;c[g+4>>2]=664;c[g+8>>2]=0;qWa(315584,g,665)}h1a(b,320792,(c[315588>>2]|0)+ -1|0);c[320788>>2]=0;c[80196]=316080;if(!((c[79026]|0)==-1)){c[f>>2]=316104;c[f+4>>2]=664;c[f+8>>2]=0;qWa(316104,f,665)}h1a(b,320784,(c[316108>>2]|0)+ -1|0);c[320780>>2]=0;c[80194]=316120;if((c[79036]|0)==-1){N=316144;O=316144;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=320776;h1a(b,T,S);i=e;return}c[H>>2]=316144;c[H+4>>2]=664;c[H+8>>2]=0;qWa(316144,H,665);N=316144;O=316144;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=320776;h1a(b,T,S);i=e;return}function h1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;WVa(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){m3a(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}XVa(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function i1a(a){a=a|0;var b=0;b=i;j1a(a);S4a(a);i=b;return}function j1a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=316192;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{XVa(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}FWa(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{S4a(h);i=d;return}}function k1a(){var b=0,d=0,e=0,f=0;b=i;if((a[316248]|0)!=0){d=316240;e=c[79060]|0;i=b;return e|0}if(($a(316248)|0)==0){d=316240;e=c[79060]|0;i=b;return e|0}do{if((a[316224]|0)==0){if(($a(316224)|0)==0){break}g1a(320616,1);c[79052]=320616;c[79054]=316208;Vb(316224)}}while(0);f=c[c[79054]>>2]|0;c[79058]=f;WVa(f);c[79060]=316232;Vb(316248);d=316240;e=c[79060]|0;i=b;return e|0}function l1a(a){a=a|0;var b=0,d=0;b=i;d=c[(k1a()|0)>>2]|0;c[a>>2]=d;WVa(d);i=b;return}function m1a(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;WVa(e);i=d;return}function n1a(a){a=a|0;var b=0;b=i;XVa(c[a>>2]|0)|0;i=b;return}function o1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=664;c[e+8>>2]=0;qWa(a,e,665)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function p1a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=664;c[e+8>>2]=0;qWa(a,e,665)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Hc(4)|0;h=g;p4a(h);j=331832;k=127;Xd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Hc(4)|0;h=g;p4a(h);j=331832;k=127;Xd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function q1a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function r1a(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}je[c[(c[a>>2]|0)+4>>2]&1023](a);i=b;return}function s1a(a){a=a|0;var b=0;b=c[79064]|0;c[79064]=1+b;c[a+4>>2]=b+1;i=i;return}function t1a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function u1a(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function v1a(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Bc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function w1a(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Bc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function x1a(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Bc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function y1a(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Hd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function z1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Hd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function A1a(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Md()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function B1a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Md()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function C1a(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function D1a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function E1a(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function F1a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function G1a(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=316288;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}T4a(e)}}while(0);S4a(b);i=d;return}function H1a(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=316288;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}T4a(e);i=d;return}function I1a(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Hd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function J1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Hd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function K1a(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Md()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function L1a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Md()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function M1a(a,b){a=a|0;b=b|0;i=i;return b|0}function N1a(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function O1a(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function P1a(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function Q1a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function R1a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function S1a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function T1a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function U1a(a){a=a|0;i=i;return 1}function V1a(a){a=a|0;i=i;return 1}function W1a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function X1a(a){a=a|0;i=i;return 1}function Y1a(a){a=a|0;var b=0;b=i;e1a(a);S4a(a);i=b;return}function Z1a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Oc(c[s>>2]|0)|0;A=Q3a(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Oc(c[s>>2]|0)|0;A=P3a(u,0,d)|0;if((z|0)!=0){Oc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Oc(c[s>>2]|0)|0;G=P3a(u,r,n)|0;if((z|0)!=0){Oc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function _1a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Oc(c[r>>2]|0)|0;y=M3a(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Oc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Oc(c[r>>2]|0)|0;F=L3a(x,y,1,d)|0;if((w|0)!=0){Oc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Oc(c[r>>2]|0)|0;y=L3a(q,v,z-v|0,n)|0;if((w|0)!=0){Oc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function $1a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Oc(c[b+8>>2]|0)|0;b=P3a(e,0,d)|0;if((j|0)!=0){Oc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function a2a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Oc(c[d>>2]|0)|0;e=O3a(0,0,4)|0;if((a|0)!=0){Oc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Oc(a|0)|0;if((g|0)==0){f=0;break}Oc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function b2a(a){a=a|0;i=i;return 0}function c2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Oc(c[k>>2]|0)|0;n=K3a(a,j-a|0,b)|0;if((m|0)!=0){Oc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function d2a(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Oc(d|0)|0;if((a|0)==0){e=4;break}Oc(a|0)|0;e=4}}while(0);i=b;return e|0}function e2a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function f2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=g2a(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function g2a(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function h2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=i2a(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function i2a(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function j2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function k2a(a){a=a|0;i=i;return 0}function l2a(a){a=a|0;i=i;return 0}function m2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=n2a(c,d,e,1114111,0)|0;i=b;return a|0}function n2a(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function o2a(a){a=a|0;i=i;return 4}function p2a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function q2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=r2a(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function r2a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function s2a(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=t2a(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function t2a(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function u2a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function v2a(a){a=a|0;i=i;return 0}function w2a(a){a=a|0;i=i;return 0}function x2a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=y2a(c,d,e,1114111,0)|0;i=b;return a|0}function y2a(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function z2a(a){a=a|0;i=i;return 4}function A2a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function B2a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function C2a(a){a=a|0;var b=0;b=i;c[a>>2]=316440;FWa(a+12|0);S4a(a);i=b;return}function D2a(a){a=a|0;var b=0;b=i;c[a>>2]=316440;FWa(a+12|0);i=b;return}function E2a(a){a=a|0;var b=0;b=i;c[a>>2]=316480;FWa(a+16|0);S4a(a);i=b;return}function F2a(a){a=a|0;var b=0;b=i;c[a>>2]=316480;FWa(a+16|0);i=b;return}function G2a(b){b=b|0;i=i;return a[b+8|0]|0}function H2a(a){a=a|0;i=i;return c[a+8>>2]|0}function I2a(b){b=b|0;i=i;return a[b+9|0]|0}function J2a(a){a=a|0;i=i;return c[a+12>>2]|0}function K2a(a,b){a=a|0;b=b|0;var c=0;c=i;vWa(a,b+12|0);i=c;return}function L2a(a,b){a=a|0;b=b|0;var c=0;c=i;vWa(a,b+16|0);i=c;return}function M2a(a,b){a=a|0;b=b|0;b=i;xWa(a,316512,4);i=b;return}function N2a(a,b){a=a|0;b=b|0;b=i;fXa(a,316520,k4a(316520)|0);i=b;return}function O2a(a,b){a=a|0;b=b|0;b=i;xWa(a,316544,5);i=b;return}function P2a(a,b){a=a|0;b=b|0;b=i;fXa(a,316552,k4a(316552)|0);i=b;return}function Q2a(b){b=b|0;var d=0,e=0;b=i;if((a[316584]|0)!=0){d=316576;e=c[79144]|0;i=b;return e|0}if(($a(316584)|0)==0){d=316576;e=c[79144]|0;i=b;return e|0}do{if((a[323784]|0)==0){if(($a(323784)|0)==0){break}q5a(323616,0,168)|0;be(667,0,q|0)|0;Vb(323784)}}while(0);IWa(323616,323792)|0;IWa(323628|0,323800)|0;IWa(323640|0,323808)|0;IWa(323652|0,323816)|0;IWa(323664|0,323832)|0;IWa(323676|0,323848)|0;IWa(323688|0,323856)|0;IWa(323700|0,323872)|0;IWa(323712|0,323880)|0;IWa(323724|0,323888)|0;IWa(323736|0,323896)|0;IWa(323748|0,323904)|0;IWa(323760|0,323912)|0;IWa(323772|0,323920)|0;c[79144]=323616;Vb(316584);d=316576;e=c[79144]|0;i=b;return e|0}function R2a(b){b=b|0;var d=0,e=0;b=i;if((a[316600]|0)!=0){d=316592;e=c[79148]|0;i=b;return e|0}if(($a(316600)|0)==0){d=316592;e=c[79148]|0;i=b;return e|0}do{if((a[323248]|0)==0){if(($a(323248)|0)==0){break}q5a(323080,0,168)|0;be(668,0,q|0)|0;Vb(323248)}}while(0);iXa(323080,323256)|0;iXa(323092|0,323288)|0;iXa(323104|0,323320)|0;iXa(323116|0,323352)|0;iXa(323128|0,323392)|0;iXa(323140|0,323432)|0;iXa(323152|0,323464)|0;iXa(323164|0,323504)|0;iXa(323176|0,323520)|0;iXa(323188|0,323536)|0;iXa(323200|0,323552)|0;iXa(323212|0,323568)|0;iXa(323224|0,323584)|0;iXa(323236|0,323600)|0;c[79148]=323080;Vb(316600);d=316592;e=c[79148]|0;i=b;return e|0}function S2a(b){b=b|0;var d=0,e=0;b=i;if((a[316616]|0)!=0){d=316608;e=c[79152]|0;i=b;return e|0}if(($a(316616)|0)==0){d=316608;e=c[79152]|0;i=b;return e|0}do{if((a[322856]|0)==0){if(($a(322856)|0)==0){break}q5a(322568,0,288)|0;be(669,0,q|0)|0;Vb(322856)}}while(0);IWa(322568,322864)|0;IWa(322580|0,322872)|0;IWa(322592|0,322888)|0;IWa(322604|0,322896)|0;IWa(322616|0,322904)|0;IWa(322628|0,322912)|0;IWa(322640|0,322920)|0;IWa(322652|0,322928)|0;IWa(322664|0,322936)|0;IWa(322676|0,322952)|0;IWa(322688|0,322960)|0;IWa(322700|0,322976)|0;IWa(322712|0,322992)|0;IWa(322724|0,323e3)|0;IWa(322736|0,323008)|0;IWa(322748|0,323016)|0;IWa(322760|0,322904)|0;IWa(322772|0,323024)|0;IWa(322784|0,323032)|0;IWa(322796|0,323040)|0;IWa(322808|0,323048)|0;IWa(322820|0,323056)|0;IWa(322832|0,323064)|0;IWa(322844|0,323072)|0;c[79152]=322568;Vb(316616);d=316608;e=c[79152]|0;i=b;return e|0}function T2a(b){b=b|0;var d=0,e=0;b=i;if((a[316632]|0)!=0){d=316624;e=c[79156]|0;i=b;return e|0}if(($a(316632)|0)==0){d=316624;e=c[79156]|0;i=b;return e|0}do{if((a[322016]|0)==0){if(($a(322016)|0)==0){break}q5a(321728,0,288)|0;be(670,0,q|0)|0;Vb(322016)}}while(0);iXa(321728,322024)|0;iXa(321740|0,322056)|0;iXa(321752|0,322096)|0;iXa(321764|0,322120)|0;iXa(321776|0,322440)|0;iXa(321788|0,322144)|0;iXa(321800|0,322168)|0;iXa(321812|0,322192)|0;iXa(321824|0,322224)|0;iXa(321836|0,322264)|0;iXa(321848|0,322296)|0;iXa(321860|0,322336)|0;iXa(321872|0,322376)|0;iXa(321884|0,322392)|0;iXa(321896|0,322408)|0;iXa(321908|0,322424)|0;iXa(321920|0,322440)|0;iXa(321932|0,322456)|0;iXa(321944|0,322472)|0;iXa(321956|0,322488)|0;iXa(321968|0,322504)|0;iXa(321980|0,322520)|0;iXa(321992|0,322536)|0;iXa(322004|0,322552)|0;c[79156]=321728;Vb(316632);d=316624;e=c[79156]|0;i=b;return e|0}function U2a(b){b=b|0;var d=0,e=0;b=i;if((a[316648]|0)!=0){d=316640;e=c[79160]|0;i=b;return e|0}if(($a(316648)|0)==0){d=316640;e=c[79160]|0;i=b;return e|0}do{if((a[321704]|0)==0){if(($a(321704)|0)==0){break}q5a(321416,0,288)|0;be(671,0,q|0)|0;Vb(321704)}}while(0);IWa(321416,321712)|0;IWa(321428|0,321720)|0;c[79160]=321416;Vb(316648);d=316640;e=c[79160]|0;i=b;return e|0}function V2a(b){b=b|0;var d=0,e=0;b=i;if((a[316664]|0)!=0){d=316656;e=c[79164]|0;i=b;return e|0}if(($a(316664)|0)==0){d=316656;e=c[79164]|0;i=b;return e|0}do{if((a[321376]|0)==0){if(($a(321376)|0)==0){break}q5a(321088,0,288)|0;be(672,0,q|0)|0;Vb(321376)}}while(0);iXa(321088,321384)|0;iXa(321100|0,321400)|0;c[79164]=321088;Vb(316664);d=316656;e=c[79164]|0;i=b;return e|0}function W2a(b){b=b|0;var c=0;b=i;if((a[316688]|0)!=0){c=316672;i=b;return c|0}if(($a(316688)|0)==0){c=316672;i=b;return c|0}xWa(316672,316696,8);be(673,316672,q|0)|0;Vb(316688);c=316672;i=b;return c|0}function X2a(b){b=b|0;var c=0;b=i;if((a[316728]|0)!=0){c=316712;i=b;return c|0}if(($a(316728)|0)==0){c=316712;i=b;return c|0}fXa(316712,316736,k4a(316736)|0);be(674,316712,q|0)|0;Vb(316728);c=316712;i=b;return c|0}function Y2a(b){b=b|0;var c=0;b=i;if((a[316792]|0)!=0){c=316776;i=b;return c|0}if(($a(316792)|0)==0){c=316776;i=b;return c|0}xWa(316776,316800,8);be(673,316776,q|0)|0;Vb(316792);c=316776;i=b;return c|0}function Z2a(b){b=b|0;var c=0;b=i;if((a[316832]|0)!=0){c=316816;i=b;return c|0}if(($a(316832)|0)==0){c=316816;i=b;return c|0}fXa(316816,316840,k4a(316840)|0);be(674,316816,q|0)|0;Vb(316832);c=316816;i=b;return c|0}function _2a(b){b=b|0;var c=0;b=i;if((a[316896]|0)!=0){c=316880;i=b;return c|0}if(($a(316896)|0)==0){c=316880;i=b;return c|0}xWa(316880,316904,20);be(673,316880,q|0)|0;Vb(316896);c=316880;i=b;return c|0}function $2a(b){b=b|0;var c=0;b=i;if((a[316944]|0)!=0){c=316928;i=b;return c|0}if(($a(316944)|0)==0){c=316928;i=b;return c|0}fXa(316928,316952,k4a(316952)|0);be(674,316928,q|0)|0;Vb(316944);c=316928;i=b;return c|0}function a3a(b){b=b|0;var c=0;b=i;if((a[317056]|0)!=0){c=317040;i=b;return c|0}if(($a(317056)|0)==0){c=317040;i=b;return c|0}xWa(317040,317064,11);be(673,317040,q|0)|0;Vb(317056);c=317040;i=b;return c|0}function b3a(b){b=b|0;var c=0;b=i;if((a[317096]|0)!=0){c=317080;i=b;return c|0}if(($a(317096)|0)==0){c=317080;i=b;return c|0}fXa(317080,317104,k4a(317104)|0);be(674,317080,q|0)|0;Vb(317096);c=317080;i=b;return c|0}function c3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);l=+g5a(b,g,c[79040]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function d3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);l=+g5a(b,g,c[79040]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function e3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Qc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);l=+g5a(b,g,c[79040]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function f3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);n=nb(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function g3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);m=nb(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function h3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);m=nb(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function i3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);m=nb(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function j3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Qc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);n=Jc(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function k3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Qc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[316168]|0)==0){if(($a(316168)|0)==0){break}c[79040]=ac(2147483647,316176,0)|0;Vb(316168)}}while(0);m=Jc(b|0,h|0,f|0,c[79040]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function l3a(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;je[h&1023](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;je[h&1023](a);i=b;return}}function m3a(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){f1a(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=Q4a(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;o5a(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{S4a(h);i=e;return}}function n3a(a){a=a|0;a=i;hXa(321364|0);hXa(321352|0);hXa(321340|0);hXa(321328|0);hXa(321316|0);hXa(321304|0);hXa(321292|0);hXa(321280|0);hXa(321268|0);hXa(321256|0);hXa(321244|0);hXa(321232|0);hXa(321220|0);hXa(321208|0);hXa(321196|0);hXa(321184|0);hXa(321172|0);hXa(321160|0);hXa(321148|0);hXa(321136|0);hXa(321124|0);hXa(321112|0);hXa(321100|0);hXa(321088);i=a;return}function o3a(a){a=a|0;a=i;FWa(321692|0);FWa(321680|0);FWa(321668|0);FWa(321656|0);FWa(321644|0);FWa(321632|0);FWa(321620|0);FWa(321608|0);FWa(321596|0);FWa(321584|0);FWa(321572|0);FWa(321560|0);FWa(321548|0);FWa(321536|0);FWa(321524|0);FWa(321512|0);FWa(321500|0);FWa(321488|0);FWa(321476|0);FWa(321464|0);FWa(321452|0);FWa(321440|0);FWa(321428|0);FWa(321416);i=a;return}function p3a(a){a=a|0;a=i;hXa(322004|0);hXa(321992|0);hXa(321980|0);hXa(321968|0);hXa(321956|0);hXa(321944|0);hXa(321932|0);hXa(321920|0);hXa(321908|0);hXa(321896|0);hXa(321884|0);hXa(321872|0);hXa(321860|0);hXa(321848|0);hXa(321836|0);hXa(321824|0);hXa(321812|0);hXa(321800|0);hXa(321788|0);hXa(321776|0);hXa(321764|0);hXa(321752|0);hXa(321740|0);hXa(321728);i=a;return}function q3a(a){a=a|0;a=i;FWa(322844|0);FWa(322832|0);FWa(322820|0);FWa(322808|0);FWa(322796|0);FWa(322784|0);FWa(322772|0);FWa(322760|0);FWa(322748|0);FWa(322736|0);FWa(322724|0);FWa(322712|0);FWa(322700|0);FWa(322688|0);FWa(322676|0);FWa(322664|0);FWa(322652|0);FWa(322640|0);FWa(322628|0);FWa(322616|0);FWa(322604|0);FWa(322592|0);FWa(322580|0);FWa(322568);i=a;return}function r3a(a){a=a|0;a=i;hXa(323236|0);hXa(323224|0);hXa(323212|0);hXa(323200|0);hXa(323188|0);hXa(323176|0);hXa(323164|0);hXa(323152|0);hXa(323140|0);hXa(323128|0);hXa(323116|0);hXa(323104|0);hXa(323092|0);hXa(323080);i=a;return}function s3a(a){a=a|0;a=i;FWa(323772|0);FWa(323760|0);FWa(323748|0);FWa(323736|0);FWa(323724|0);FWa(323712|0);FWa(323700|0);FWa(323688|0);FWa(323676|0);FWa(323664|0);FWa(323652|0);FWa(323640|0);FWa(323628|0);FWa(323616);i=a;return}function t3a(a){a=a|0;var b=0,c=0;b=i;if((z3a(a)|0)==0){c=(u3a(a)|0)!=0|0}else{c=1}i=b;return c|0}function u3a(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[323928+((d[323928+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function v3a(a){a=a|0;var b=0,c=0;b=i;c=zb(a|0)|0;i=b;return c|0}function w3a(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function x3a(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 1:{d=t3a(a)|0;break};case 5:{d=z3a(a)|0;break};case 8:{d=C3a(a)|0;break};case 3:{d=v3a(a)|0;break};case 7:{d=B3a(a)|0;break};case 11:{d=F3a(a)|0;break};case 12:{d=G3a(a)|0;break};case 10:{d=E3a(a)|0;break};case 2:{d=u3a(a)|0;break};case 4:{d=w3a(a)|0;break};case 9:{d=D3a(a)|0;break};case 6:{d=A3a(a)|0;break};default:{d=0}}i=c;return d|0}function y3a(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=326904;while(1){if(d<<24>>24==e<<24>>24){if((i5a(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function z3a(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function A3a(a){a=a|0;var b=0,c=0;b=i;if((E3a(a)|0)==0){c=(C3a(a)|0)!=0|0}else{c=0}i=b;return c|0}function B3a(a){a=a|0;var b=0,c=0;b=i;if((H3a(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function C3a(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function D3a(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[326984+((d[326984+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function E3a(a){a=a|0;var b=0,c=0;b=i;c=(j4a(330152,a)|0)!=0|0;i=b;return c|0}function F3a(a){a=a|0;var b=0,c=0;b=i;c=(J3a(a)|0)!=(a|0)|0;i=b;return c|0}function G3a(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function H3a(a){a=a|0;var b=0,c=0;b=i;c=I3a(a,0)|0;i=b;return c|0}function I3a(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((u3a(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[330242+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[330240+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[330243+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[330488+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[330488+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[330488+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function J3a(a){a=a|0;var b=0,c=0;b=i;c=I3a(a,1)|0;i=b;return c|0}function K3a(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=L3a(0,a,b,(c|0)!=0?c:331192)|0;i=d;return e|0}function L3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?331200:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[330984+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Qc()|0)>>2]=84;k=-1;i=g;return k|0}function M3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=N3a(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=L3a(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function N3a(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[330984+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[330984+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Qc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function O3a(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[330984+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Qc()|0)>>2]=84;j=-1;i=g;return j|0}function P3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Qc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function Q3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=R3a(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=P3a(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function R3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=P3a(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=P3a(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=P3a(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}P3a(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function S3a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=K4a(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=K4a(2048)|0;c[p+16>>2]=s;if((s|0)==0){L4a(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=g4a(0,0)|0;if((s|0)==0){L4a(c[p+16>>2]|0);L4a(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=T3a(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=M4a(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=U3a(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=K4a(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;q5a(y|0,-1,v|0)|0;I=H}else{I=0}H=M4a(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=M4a(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=U3a(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=_3a(q,x)|0;b:do{if((v|0)==0){y=_3a(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=$3a(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=i4a(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=i4a(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=$3a(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=i4a(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=i4a(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=$3a(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=i4a(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=i4a(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=i4a(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=i4a(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=i4a(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=i4a(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=i4a(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=i4a(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==2){U=c[S+4>>2]|0;W=_3a(q,L)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,S)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,1)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{wa=L}}if((F|0)==45){F=0;c[j>>2]=0;wa=0}ra=wa;sa=M+1|0;ta=N;break}else if((T|0)==3){U=c[S+4>>2]|0;W=_3a(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=_3a(q,0)|0}else if((T|0)==0){W=c[S+4>>2]|0;U=c[W>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=W+8|0;W=(c[U>>2]|0)+L|0;c[U>>2]=W;if((W|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=W;ra=L;sa=M;ta=N;break}else if((T|0)==1){T=c[S+4>>2]|0;W=_3a(q,c[T+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=_3a(q,c[T>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}xa=_3a(q,0)|0}else{ra=L;sa=M;ta=N;break}if((xa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=xa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=i4a(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=i4a(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=i4a(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=i4a(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=_3a(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=_3a(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==2){M=c[ya+4>>2]|0;L=c[M>>2]|0;R=L+8|0;if((c[R>>2]|0)==0){za=0}else{za=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[R>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Aa=M+4|0}else{R=Z3a(q,L,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ba=K4a((c[g>>2]<<2)+4|0)|0;R=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=Z3a(q,c[M>>2]|0,R,h,0)|0;if((Ca|0)!=0){F=150;break g}L=M+4|0;Q=Y3a(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=Q;L4a(Ba);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=L}}L=c[Aa>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}R=Z3a(q,L,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Da=K4a((c[g>>2]<<2)+4|0)|0;R=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=Z3a(q,c[Aa>>2]|0,R,h,0)|0;if((Ea|0)!=0){F=157;break g}L=Y3a(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=L;L4a(Da);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){R=c[ya+4>>2]|0;L=c[R>>2]|0;do{if((c[R+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[R>>2]|0)+28>>2]}else if((S|0)==1){M=c[ya+4>>2]|0;Q=c[M>>2]|0;W=M+4|0;T=c[W>>2]|0;if((c[Q+8>>2]|0)==0){Fa=(c[T+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;U=Y3a(s,c[Q+24>>2]|0,c[T+24>>2]|0,0,0)|0;c[ya+24>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}U=Y3a(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[W>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=U;if((U|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){U=c[ya>>2]|0;if((U|0)==1){W=_3a(q,ya)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=_3a(q,2)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=ya+4|0;M=_3a(q,c[(c[W>>2]|0)+4>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,c[c[W>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((U|0)==2){M=_3a(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((U|0)==3){M=_3a(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=_3a(q,1)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;W=_3a(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=_3a(q,0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=_3a(q,c[c[M>>2]>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=_3a(q,0)|0;if((W|0)==0){break}else{z=0;A=W;B=0;C=D;break a}}else if((U|0)==0){U=c[ya+4>>2]|0;W=c[U>>2]|0;if((W|0)==-4){c[ya+8>>2]=0;M=U+8|0;T=c[M>>2]|0;Q=i4a(s,0,0,1,64)|0;if((Q|0)==0){F=104;break g}ea=Q;c[Q>>2]=T;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;T=Q+28|0;Q=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[Q>>2]=ea;ea=c[M>>2]|0;M=c[U+4>>2]|0;Q=i4a(s,0,0,1,64)|0;if((Q|0)==0){F=106;break g}c[Q>>2]=ea;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;c[Q+28>>2]=M;c[Q+32>>2]=-1;c[Q+36>>2]=-1;c[Q+40>>2]=-1;c[ya+28>>2]=Q;break}Q=ya+8|0;if((W|0)<0){c[Q>>2]=1;M=i4a(s,0,0,1,32)|0;if((M|0)==0){F=110;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+24>>2]=M;M=i4a(s,0,0,1,32)|0;if((M|0)==0){F=112;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+28>>2]=M;break}else{c[Q>>2]=0;Q=U+8|0;M=c[Q>>2]|0;ea=U+4|0;T=c[ea>>2]|0;fa=i4a(s,0,0,1,64)|0;if((fa|0)==0){F=115;break g}da=fa;c[fa>>2]=M;c[fa+4>>2]=W;c[fa+8>>2]=T;c[fa+20>>2]=0;c[fa+24>>2]=0;T=fa+28|0;fa=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[fa>>2]=da;da=c[Q>>2]|0;Q=c[U>>2]|0;fa=c[ea>>2]|0;ea=c[U+12>>2]|0;T=c[U+16>>2]|0;U=i4a(s,0,0,1,64)|0;if((U|0)==0){F=117;break g}W=U;c[U>>2]=da;c[U+4>>2]=Q;c[U+8>>2]=fa;c[U+20>>2]=ea;c[U+24>>2]=T;T=U+28|0;U=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[U>>2]=W;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){L4a(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){L4a(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=K4a(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=K4a(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){q5a(O|0,0,((E|0)>1?E<<2:4)|0)|0}V3a(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;W=O+(S<<2)|0;U=K+1+(c[W>>2]|0)|0;c[W>>2]=0;W=S+1|0;if((W|0)<(E|0)){S=W;K=U}else{Ga=U;break}}}else{Ga=0}K=M4a(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;U=V3a(y,S,x,u)|0;if((U|0)!=0){z=x;A=U;B=u;C=D;break}c[w+20>>2]=0;U=v+24|0;S=c[U>>2]|0;if((c[S>>2]|0)>-1){W=1;T=S;while(1){S=T+32|0;ea=W+1|0;if((c[S>>2]|0)>-1){T=S;W=ea}else{Ha=ea;break}}}else{Ha=1}W=M4a(Ha,32)|0;if((W|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=W;T=c[U>>2]|0;y=c[T>>2]|0;if((y|0)>-1){ea=y;y=T;T=0;while(1){c[W+(T<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[W+(T<<5)+12>>2]=ea;S=W+(T<<5)+16|0;c[S>>2]=0;fa=y+12|0;Q=c[fa>>2]|0;if((Q|0)!=0){da=0;while(1){Ia=da+1|0;if((c[Q+(da<<2)>>2]|0)>-1){da=Ia}else{break}}da=Ia<<2;Q=K4a(da)|0;c[S>>2]=Q;if((Q|0)==0){z=x;A=12;B=u;C=D;break a}o5a(Q|0,c[fa>>2]|0,da|0)|0}c[W+(T<<5)+20>>2]=c[y+16>>2];da=T+1|0;Q=y+32|0;M=c[Q>>2]|0;if((M|0)>-1){ea=M;y=Q;T=da}else{Ja=da;break}}}else{Ja=0}c[W+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;h4a(s);L4a(c[p+16>>2]|0);L4a(p);L4a(O);L4a(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);h4a(s);L4a(c[p+16>>2]|0);L4a(p);if((z|0)!=0){L4a(z)}if((B|0)!=0){L4a(B)}c[b+4>>2]=C;W3a(b);r=A;i=f;return r|0}



function Oe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Pe(){return i|0}function Qe(a){a=a|0;i=a}function Re(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Se(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Te(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ue(a){a=a|0;J=a}function Ve(a){a=a|0;K=a}function We(a){a=a|0;L=a}function Xe(a){a=a|0;M=a}function Ye(a){a=a|0;N=a}function Ze(a){a=a|0;O=a}function _e(a){a=a|0;P=a}function $e(a){a=a|0;Q=a}function af(a){a=a|0;R=a}function bf(a){a=a|0;S=a}function cf(a){a=a|0;var b=0,d=0;b=i;BGa(a)|0;d=a+540|0;me[c[(c[d>>2]|0)+40>>2]&127](a)|0;me[c[(c[d>>2]|0)+28>>2]&127](a)|0;me[c[(c[d>>2]|0)+32>>2]&127](a)|0;me[c[(c[d>>2]|0)+48>>2]&127](a)|0;me[c[(c[d>>2]|0)+52>>2]&127](a)|0;_Ea(a);i=b;return}function df(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=m5a(B|0)|0;D=K4a(C+11|0)|0;x5a(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=lc(D|0,32)|0;if((C|0)==0){B=_d(c[(Qc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;OBa(23,0,40,u);$c(0)|0;F=0}else{F=C}L4a(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}He[c[242756>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{vDa(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}vDa(2);uDa(2)}jDa(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];NEa(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(23,1,144,r);Z=jGa(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}cf(b);$Ea(b);if((c[241700>>2]|0)!=0){je[c[60540]&1023](23)}if((c[2]|0)!=0){uDa(4)}A=PEa(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(7,1,200,q);if((c[299124>>2]|0)==0){ke[c[283812>>2]&255](283792,b)}REa(b,c[J>>2]|0,z,d);if((c[241636>>2]|0)!=0){je[c[60540]&1023](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;dFa(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){xDa(4)}if((vGa(b,1,1)|0)!=0){c[B>>2]=1;dFa(b)}me[c[(c[K>>2]|0)+88>>2]&127](b)|0;_Ea(b);hFa(b);$Ea(b);do{if((T|0)==0){_=0}else{uDa(7);xDa(2);A=(uc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(uc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+pDa(2);if(!$){aa=0;break}aa=(uc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+pDa(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=kDa(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(uc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+pDa(ba+9|0);if((ca|0)==0){ka=0}else{ka=(uc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}xDa(7);if((la|0)!=0){_=T;break}c[p>>2]=_d(c[(Qc()|0)>>2]|0)|0;OBa(23,0,240,p);$c(T|0)|0;_=0}}while(0);if((c[299124>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ke[c[283812>>2]&255](283792,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[72348]|0)!=0){ca=f;ba=289400;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];EBa(M,f);Wd(10,M|0)|0;ba=c[72356]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;MBa(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((UFa(b,0)|0)!=0){ma=58;break}if((KFa(b,0)|0)!=0){ma=58;break}if((xFa(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((UFa(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(1,0,448,m);U=_;V=-2;break}if((KFa(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(1,0,536,l);U=_;V=-3;break}T=(xFa(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}$c(U|0)|0;i=e;return V|0}function ef(a){a=a|0;i=i;return 0}function ff(a){a=a|0;i=i;return 0}function gf(a){a=a|0;i=i;return 0}function hf(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+107|0]=0;i=i;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+40>>3];i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+24>>3];i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+85|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+85|0]|0;k=b+4|0;l=nFa(+h[c[c[k>>2]>>2]>>3],2500.0,a[(c[b+360>>2]|0)+85|0]|0)|0;a[(c[b+352>>2]|0)+85|0]=l;e=k;f=j;break}else{j=b+4|0;k=nFa(+h[c[c[j>>2]>>2]>>3],2500.0,a[(c[b+360>>2]|0)+85|0]|0)|0;a[(c[b+352>>2]|0)+85|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+85|0]|0;k=b+4|0;j=rFa(+h[c[c[k>>2]>>2]>>3],2500.0)|0;a[(c[b+352>>2]|0)+85|0]=j;e=k;f=g;break}else{g=b+4|0;k=rFa(+h[c[c[g>>2]>>2]>>3],2500.0)|0;a[(c[b+352>>2]|0)+85|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+37|0]=f;i=d;return}function nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+84|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+84|0]|0;k=b+4|0;l=oFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[b+360>>2]|0)+84|0]|0)|0;a[(c[b+352>>2]|0)+84|0]=l;e=k;f=j;break}else{j=b+4|0;k=oFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[b+360>>2]|0)+84|0]|0)|0;a[(c[b+352>>2]|0)+84|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+84|0]|0;k=b+4|0;j=sFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.13)|0;a[(c[b+352>>2]|0)+84|0]=j;e=k;f=g;break}else{g=b+4|0;k=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],.13)|0;a[(c[b+352>>2]|0)+84|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+33|0]=f;i=d;return}function of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+83|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+83|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[b+360>>2]|0)+83|0]|0)|0;a[(c[b+352>>2]|0)+83|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[b+360>>2]|0)+83|0]|0)|0;a[(c[b+352>>2]|0)+83|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+83|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.01)|0;a[(c[b+352>>2]|0)+83|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],.01)|0;a[(c[b+352>>2]|0)+83|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+31|0]=f;i=d;return}function pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+82|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+82|0]|0;k=b+4|0;l=oFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3],a[(c[b+360>>2]|0)+82|0]|0)|0;a[(c[b+352>>2]|0)+82|0]=l;e=k;f=j;break}else{j=b+4|0;k=oFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3],a[(c[b+360>>2]|0)+82|0]|0)|0;a[(c[b+352>>2]|0)+82|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+82|0]|0;k=b+4|0;j=sFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3])|0;a[(c[b+352>>2]|0)+82|0]=j;e=k;f=g;break}else{g=b+4|0;k=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3])|0;a[(c[b+352>>2]|0)+82|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+29|0]=f;i=d;return}function qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+81|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+81|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+81|0]|0)|0;a[(c[b+352>>2]|0)+81|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+81|0]|0)|0;a[(c[b+352>>2]|0)+81|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+81|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+81|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+81|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+27|0]=f;i=d;return}function rf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+80|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+80|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[b+360>>2]|0)+80|0]|0)|0;a[(c[b+352>>2]|0)+80|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[b+360>>2]|0)+80|0]|0)|0;a[(c[b+352>>2]|0)+80|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+80|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+120>>3],.01)|0;a[(c[b+352>>2]|0)+80|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],.01)|0;a[(c[b+352>>2]|0)+80|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+25|0]=f;i=d;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+79|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+79|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+79|0]|0)|0;a[(c[b+352>>2]|0)+79|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+79|0]|0)|0;a[(c[b+352>>2]|0)+79|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+79|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+79|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+79|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+23|0]=f;i=d;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4792>>3]=+h[b+248>>3]*1.0e-5;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4576>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+216>>3]*1.0e-5;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1720>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=+h[b+72>>3]*1.0e-5;i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+776>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+776>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+75|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+75|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+75|0]|0)|0;a[(c[b+352>>2]|0)+75|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+75|0]|0)|0;a[(c[b+352>>2]|0)+75|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+75|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+75|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+75|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+776>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+776>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+76|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+76|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+76|0]|0)|0;a[(c[b+352>>2]|0)+76|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+76|0]|0)|0;a[(c[b+352>>2]|0)+76|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+76|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+76|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+76|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+776>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+108|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+108|0;J=I;c[J>>2]=x;i=d;return}function Ef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3],+h[(c[a+8>>2]|0)+256>>3],c[(c[a+12>>2]|0)+108>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+256>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6424>>3]=+h[f>>3];i=b;return}function Ff(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(pFa(+h[a+6424>>3],+h[a+7480>>3])|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[a+6456>>3]=+h[(e?a+7560|0:a+256|0)>>3];i=b;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[b+6456>>3];i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+6424>>3]+-273.15;i=i;return}function If(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3],+h[(c[a+8>>2]|0)+256>>3],c[(c[a+12>>2]|0)+108>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+256>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6432>>3]=+h[f>>3];i=b;return}function Jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+256>>3];k=+h[g+6432>>3];l=+h[(c[b+416>>2]|0)+776>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,880,872,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}function Kf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(pFa(+h[a+6424>>3],+h[a+7480>>3])|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[a+6448>>3]=+h[(e?a+7544|0:a+6432|0)>>3];i=b;return}function Lf(b){b=b|0;var d=0,e=0,f=0.0,g=0;d=i;e=b+4|0;do{if((rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2304>>3],0.0)|0)<<24>>24==0){if((a[(c[b+408>>2]|0)+15|0]|0)!=0){f=-0.0;break}f=+h[(c[b+416>>2]|0)+776>>3]}else{g=c[(c[c[e>>2]>>2]|0)+8>>2]|0;f=+h[g+2304>>3]*+h[g+6432>>3]*9.80665+ +h[(c[b+416>>2]|0)+776>>3]}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3]=f;i=d;return}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3],+h[(c[b+416>>2]|0)+776>>3])|0;if((a[(c[b+408>>2]|0)+15|0]|0)==0){g=0}else{g=f<<24>>24==0|0}a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+15|0]=g;i=d;return}function Nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+728>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=3872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,896,e);p=+h[(c[f>>2]|0)+728>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2288>>3]=p+g*+h[f+264>>3]*2.0;i=b;return}function Of(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+106|0]=a[(c[b+408>>2]|0)+105|0]|0;i=i;return}function Pf(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+104|0]=a[(c[b+408>>2]|0)+104|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+104|0]=a[e+106|0]|0;i=d;return}}while(0);a[e+104|0]=a[f+104|0]|0;i=d;return}function Qf(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6256>>3]=(a[(c[d+16>>2]|0)+106|0]|0)!=0?1.0:0.0;i=i;return}function Rf(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+103|0]=a[d+106|0]|0;i=i;return}function Sf(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+102|0]=a[(c[b+408>>2]|0)+101|0]|0;i=i;return}function Tf(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+100|0]=a[(c[b+408>>2]|0)+100|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+100|0]=a[e+102|0]|0;i=d;return}}while(0);a[e+100|0]=a[f+100|0]|0;i=d;return}function Uf(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6248>>3]=(a[(c[d+16>>2]|0)+102|0]|0)!=0?1.0:0.0;i=i;return}function Vf(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+99|0]=a[d+102|0]|0;i=i;return}function Wf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+106|0]|0)==0){f=0;g=e;h=g+36|0;j=h;a[j]=f;i=d;return}f=(a[e+102|0]|0)==0|0;g=e;h=g+36|0;j=h;a[j]=f;i=d;return}function Xf(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+114|0]=a[d+36|0]|0;i=i;return}function Yf(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=+h[(c[b+400>>2]|0)+6080>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+114|0]|0)!=0){if((a[(c[b+408>>2]|0)+114|0]|0)!=0){break}h[(c[e+8>>2]|0)+6080>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+6080>>3]=+h[(c[b+400>>2]|0)+6080>>3];i=d;return}function Zf(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6072>>3]=+h[b>>3]- +h[a+6080>>3];i=i;return}function _f(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+36|0]|0)==0){f=0.0;g=b;j=g+6088|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6072>>3];g=b;j=g+6088|0;k=j;h[k>>3]=f;i=d;return}function $f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+74|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+74|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3],a[(c[b+360>>2]|0)+74|0]|0)|0;a[(c[b+352>>2]|0)+74|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3],a[(c[b+360>>2]|0)+74|0]|0)|0;a[(c[b+352>>2]|0)+74|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+74|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3])|0;a[(c[b+352>>2]|0)+74|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6080>>3]+ +h[(c[b+416>>2]|0)+1032>>3])|0;a[(c[b+352>>2]|0)+74|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+36|0]|0)==0){n=0;o=b;p=o+35|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+35|0;q=p;a[q]=n;i=d;return}function ag(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+98|0]=a[(c[b+408>>2]|0)+97|0]|0;i=i;return}function bg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+96|0]=a[(c[b+408>>2]|0)+96|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+96|0]=a[e+98|0]|0;i=d;return}}while(0);a[e+96|0]=a[f+96|0]|0;i=d;return}function cg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6240>>3]=(a[(c[d+16>>2]|0)+98|0]|0)!=0?1.0:0.0;i=i;return}function dg(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+95|0]=a[d+98|0]|0;i=i;return}function eg(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+33|0]|0)==0){f=0}else{if((a[e+102|0]|0)==0){f=0;break}f=(a[e+98|0]|0)==0|0}}while(0);a[e+34|0]=f;i=d;return}function fg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+35|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+34|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}if((a[m+102|0]|0)==0){q=0;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+101|0;t=s;a[t]=q;i=d;return}function gg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+92|0]=a[(c[b+408>>2]|0)+91|0]|0;i=i;return}function hg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+90|0]=a[(c[b+408>>2]|0)+90|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+90|0]=a[e+92|0]|0;i=d;return}}while(0);a[e+90|0]=a[f+90|0]|0;i=d;return}function ig(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6208>>3]=(a[(c[d+16>>2]|0)+92|0]|0)!=0?1.0:0.0;i=i;return}function jg(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+89|0]=a[d+92|0]|0;i=i;return}function kg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+98|0]|0)==0){f=0;g=e;h=g+94|0;j=h;a[j]=f;i=d;return}f=(a[e+92|0]|0)==0|0;g=e;h=g+94|0;j=h;a[j]=f;i=d;return}function lg(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+113|0]=a[d+94|0]|0;i=i;return}function mg(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=+h[(c[b+400>>2]|0)+6224>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+113|0]|0)!=0){if((a[(c[b+408>>2]|0)+113|0]|0)!=0){break}h[(c[e+8>>2]|0)+6224>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+6224>>3]=+h[(c[b+400>>2]|0)+6224>>3];i=d;return}function ng(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6216>>3]=+h[b>>3]- +h[a+6224>>3];i=i;return}function og(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+94|0]|0)==0){f=0.0;g=b;j=g+6232|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6216>>3];g=b;j=g+6232|0;k=j;h[k>>3]=f;i=d;return}function pg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+69|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+69|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3],a[(c[b+360>>2]|0)+69|0]|0)|0;a[(c[b+352>>2]|0)+69|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3],a[(c[b+360>>2]|0)+69|0]|0)|0;a[(c[b+352>>2]|0)+69|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+69|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3])|0;a[(c[b+352>>2]|0)+69|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6224>>3]+ +h[(c[b+416>>2]|0)+1008>>3])|0;a[(c[b+352>>2]|0)+69|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+94|0]|0)==0){n=0;o=b;p=o+93|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+93|0;q=p;a[q]=n;i=d;return}function qg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+34|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+93|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}if((a[m+98|0]|0)==0){q=0;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+97|0;t=s;a[t]=q;i=d;return}function rg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+88|0]=a[(c[b+408>>2]|0)+87|0]|0;i=i;return}function sg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+86|0]=a[(c[b+408>>2]|0)+86|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+86|0]=a[e+88|0]|0;i=d;return}}while(0);a[e+86|0]=a[f+86|0]|0;i=d;return}function tg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6200>>3]=(a[(c[d+16>>2]|0)+88|0]|0)!=0?1.0:0.0;i=i;return}function ug(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+85|0]=a[d+88|0]|0;i=i;return}function vg(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+31|0]|0)==0){f=0}else{if((a[e+92|0]|0)==0){f=0;break}f=(a[e+88|0]|0)==0|0}}while(0);a[e+32|0]=f;i=d;return}function wg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+93|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+32|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}if((a[m+92|0]|0)==0){q=0;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+91|0;t=s;a[t]=q;i=d;return}function xg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+84|0]=a[(c[b+408>>2]|0)+83|0]|0;i=i;return}function yg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+82|0]=a[(c[b+408>>2]|0)+82|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+82|0]=a[e+84|0]|0;i=d;return}}while(0);a[e+82|0]=a[f+82|0]|0;i=d;return}function zg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6192>>3]=(a[(c[d+16>>2]|0)+84|0]|0)!=0?1.0:0.0;i=i;return}function Ag(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+81|0]=a[d+84|0]|0;i=i;return}function Bg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+80|0]=a[(c[b+408>>2]|0)+79|0]|0;i=i;return}function Cg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+78|0]=a[(c[b+408>>2]|0)+78|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+78|0]=a[e+80|0]|0;i=d;return}}while(0);a[e+78|0]=a[f+78|0]|0;i=d;return}function Dg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6184>>3]=(a[(c[d+16>>2]|0)+80|0]|0)!=0?1.0:0.0;i=i;return}function Eg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6288>>3]=(a[(c[d+16>>2]|0)+80|0]|0)!=0?2.0e4:0.0;i=i;return}function Fg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6464>>3]=+h[b+6288>>3]*(+h[d+936>>3]*(+h[b+6424>>3]- +h[d+928>>3])+1.0);i=i;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+6464>>3]+ +h[b+2288>>3]*(+h[(c[a+416>>2]|0)+808>>3]- +h[b+6424>>3])*4.9;i=i;return}function Hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;do{if((pFa(+h[f+6424>>3],+h[f+7480>>3])|0)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7568>>3]- +h[j+7560>>3];l=+h[j+2280>>3];m=-l;if(k!=0.0){n=m/k;break}if(l==-0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,k,992,984,+h[g>>3],(a[b+319|0]|0)!=0|0)}else{n=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6480>>3]=n;i=d;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6480>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+4704|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+592|0;p=o;h[p>>3]=m;i=b;return}else{j=f+6472|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+592|0;p=o;h[p>>3]=m;i=b;return}}function Jg(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+77|0]=a[d+80|0]|0;i=i;return}function Kg(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+29|0]|0)==0){f=0}else{if((a[e+84|0]|0)==0){f=0;break}f=(a[e+80|0]|0)==0|0}}while(0);a[e+30|0]=f;i=d;return}function Lg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+72|0]=a[(c[b+408>>2]|0)+71|0]|0;i=i;return}function Mg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+70|0]=a[(c[b+408>>2]|0)+70|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+70|0]=a[e+72|0]|0;i=d;return}}while(0);a[e+70|0]=a[f+70|0]|0;i=d;return}function Ng(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6152>>3]=(a[(c[d+16>>2]|0)+72|0]|0)!=0?1.0:0.0;i=i;return}function Og(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+69|0]=a[d+72|0]|0;i=i;return}function Pg(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+68|0]=a[(c[b+408>>2]|0)+67|0]|0;i=i;return}function Qg(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+66|0]=a[(c[b+408>>2]|0)+66|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+66|0]=a[e+68|0]|0;i=d;return}}while(0);a[e+66|0]=a[f+66|0]|0;i=d;return}function Rg(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6144>>3]=(a[(c[d+16>>2]|0)+68|0]|0)!=0?1.0:0.0;i=i;return}function Sg(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+65|0]=a[d+68|0]|0;i=i;return}function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+66|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+66|0]|0;k=b+4|0;l=lFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+66|0]|0)|0;a[(c[b+352>>2]|0)+66|0]=l;e=k;f=j;break}else{j=b+4|0;k=lFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+66|0]|0)|0;a[(c[b+352>>2]|0)+66|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+66|0]|0;k=b+4|0;j=pFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+66|0]=j;e=k;f=g;break}else{g=b+4|0;k=pFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+66|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+84|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}if((a[b+68|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}if((a[b+80|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}m=f<<24>>24!=0|0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}function Ug(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+40|0]|0)==0){f=0}else{if((a[e+88|0]|0)==0){f=0;break}f=(a[e+84|0]|0)==0|0}}while(0);a[e+18|0]=f;i=d;return}function Vg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+18|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+30|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}if((a[m+84|0]|0)==0){q=0;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+32|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+18|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}if((a[m+88|0]|0)==0){q=0;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2320|0;h[c[g+2768>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2320>>3]);h[c[(c[f>>2]|0)+2772>>2]>>3]=k;TFa(a,34)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[c[(c[f>>2]|0)+2764>>2]>>3];xy(a);yy(a);i=b;return}function Yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2320>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2320>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6328>>3]=+h[f>>3];i=b;return}function Zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2320>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2320>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6336>>3]=+h[f>>3];i=b;return}function _g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[l>>2]|0)+3e3>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2320>>3];n=+h[(c[l>>2]|0)+3e3>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+2336>>3],+h[d+6328>>3],+h[f>>3],+h[(c[l>>2]|0)+872>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6320>>3]=+h[g>>3];i=b;return}function $g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+3048>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+256>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+3048>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+256>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+2336>>3],+h[d+7472>>3],+h[f>>3],+h[(c[k>>2]|0)+872>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6312>>3]=+h[g>>3];i=b;return}function ah(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+2336>>3],+h[j+6336>>3],+h[j+7464>>3],+h[(c[b+416>>2]|0)+872>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+2336>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,1016,1008,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}function bh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[b+416>>2]|0)+776>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+87|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+87|0]|0;l=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[b+360>>2]|0)+87|0]|0)|0;a[(c[b+352>>2]|0)+87|0]=l;g=k;break}else{k=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[b+360>>2]|0)+87|0]|0)|0;a[(c[b+352>>2]|0)+87|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+87|0]|0;k=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+87|0]=k;g=j;break}else{j=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+87|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+14|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+14|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+14|0;v=u;a[v]=m;i=d;return}function ch(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+2336>>3];if(e<<24>>24==0){j=f+256|0;k=+h[j>>3];l=g*k;m=f;n=m+2344|0;o=n;h[o>>3]=l;i=b;return}else{j=(c[a+416>>2]|0)+3e3|0;k=+h[j>>3];l=g*k;m=f;n=m+2344|0;o=n;h[o>>3]=l;i=b;return}}function dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+88|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+88|0]|0;j=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[b+360>>2]|0)+88|0]|0)|0;a[(c[b+352>>2]|0)+88|0]=j;e=g;break}else{g=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[b+360>>2]|0)+88|0]|0)|0;a[(c[b+352>>2]|0)+88|0]=g;e=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+88|0]|0;g=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;a[(c[b+352>>2]|0)+88|0]=g;e=f;break}else{f=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;a[(c[b+352>>2]|0)+88|0]=f;e=f;break}}}}while(0);f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;if(e<<24>>24==0){k=0.0;l=f;m=l+2328|0;n=m;h[n>>3]=k;i=d;return}k=+h[f+2336>>3];l=f;m=l+2328|0;n=m;h[n>>3]=k;i=d;return}function eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+2336>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+3e3|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+1992|0;p=o;h[p>>3]=m;i=b;return}else{j=f+256|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+1992|0;p=o;h[p>>3]=m;i=b;return}}function fh(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+64|0]=a[(c[b+408>>2]|0)+63|0]|0;i=i;return}function gh(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+62|0]=a[(c[b+408>>2]|0)+62|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+62|0]=a[e+64|0]|0;i=d;return}}while(0);a[e+62|0]=a[f+62|0]|0;i=d;return}function hh(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6136>>3]=(a[(c[d+16>>2]|0)+64|0]|0)!=0?1.0:0.0;i=i;return}function ih(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6280>>3]=(a[(c[d+16>>2]|0)+64|0]|0)!=0?-2.0e3:0.0;i=i;return}function jh(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+61|0]=a[d+64|0]|0;i=i;return}function kh(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+27|0]|0)==0){f=0}else{if((a[e+68|0]|0)==0){f=0;break}f=(a[e+64|0]|0)==0|0}}while(0);a[e+28|0]=f;i=d;return}function lh(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+60|0]=a[(c[b+408>>2]|0)+59|0]|0;i=i;return}function mh(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+58|0]=a[(c[b+408>>2]|0)+58|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+58|0]=a[e+60|0]|0;i=d;return}}while(0);a[e+58|0]=a[f+58|0]|0;i=d;return}function nh(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6128>>3]=(a[(c[d+16>>2]|0)+60|0]|0)!=0?1.0:0.0;i=i;return}function oh(a){a=a|0;var b=0,d=0,e=0;b=i;JFa(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1104>>3]=+h[d>>3];h[e+5456>>3]=+h[d+8>>3];h[e+5672>>3]=+h[d+16>>3];h[e+1856>>3]=+h[d+24>>3];h[e+5800>>3]=+h[d+32>>3];h[e+5720>>3]=+h[d+40>>3];h[e+5680>>3]=+h[d+48>>3];i=b;return}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1104>>3]),1.0e-15);k=+xd(+-+h[g+5672>>3],1.0e-15);l=j+k;m=j*+h[g+32>>3]+k*+h[(c[b+416>>2]|0)+2408>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1136,1128,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3848|0;r=q;h[r>>3]=o;i=d;return}function qh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3832>>3]=+h[f>>3];i=b;return}function rh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3840>>3]=+h[f>>3];i=b;return}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1856>>3]),1.0e-15);k=+xd(+-+h[g+5672>>3],1.0e-15);l=j+k;m=j*+h[g+64>>3]+k*+h[(c[b+416>>2]|0)+2408>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1208,1200,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3744|0;r=q;h[r>>3]=o;i=d;return}function th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3728>>3]=+h[f>>3];i=b;return}function uh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3736>>3]=+h[f>>3];i=b;return}function vh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1104>>3];h[b+1080>>3]=d*+h[(!(d>=0.0)?b+3744|0:b+32|0)>>3];i=i;return}function wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+1104>>3]),1.0e-15);k=+xd(+(+h[g+1856>>3]),1.0e-15);l=j+k;m=j*+h[g+32>>3]+k*+h[g+64>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1280,1272,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5656|0;r=q;h[r>>3]=o;i=d;return}function xh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5672>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5672>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2408|0;k=+h[j>>3];l=g*k;m=f;n=m+2256|0;o=n;h[o>>3]=l;i=b;return}else{j=f+5656|0;k=+h[j>>3];l=g*k;m=f;n=m+2256|0;o=n;h[o>>3]=l;i=b;return}}function yh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2456>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5656>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2456>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5656>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5672>>3],+h[d+7440>>3],+h[f>>3],+h[(c[k>>2]|0)+1400>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5688>>3]=+h[g>>3];i=b;return}function zh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1856>>3];h[b+1832>>3]=d*+h[(!(d>=0.0)?b+3848|0:b+64|0)>>3];i=i;return}function Ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+5656>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+5656>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5704>>3]=+h[f>>3];i=b;return}function Bh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+5656>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+5656>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5712>>3]=+h[f>>3];i=b;return}function Ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5672>>3],+h[j+5712>>3],+h[j+7432>>3],+h[(c[b+416>>2]|0)+1400>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5672>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,1360,1352,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5664|0;q=p;h[q>>3]=n;i=d;return}function Dh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5840>>3]=+h[f>>3];i=b;return}function Eh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5848>>3]=+h[f>>3];i=b;return}function Fh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5480>>3]=+h[f>>3];i=b;return}function Gh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5720>>3],+h[a+3744>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5720>>3];l=+h[g+3744>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5488>>3]=+h[f>>3];i=b;return}function Hh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5720>>3],+h[l+32>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5720>>3];o=+h[m+32>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1104>>3],+h[d+5480>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1568>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5464>>3]=+h[g>>3];i=b;return}function Ih(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5720>>3],+h[(c[l>>2]|0)+2408>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5720>>3];n=+h[(c[l>>2]|0)+2408>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5672>>3],+h[d+5704>>3],+h[f>>3],+h[(c[l>>2]|0)+1400>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5696>>3]=+h[g>>3];i=b;return}function Jh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5720>>3],+h[l+64>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5720>>3];o=+h[m+64>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1856>>3],+h[d+5840>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1288>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[g>>3];i=b;return}function Kh(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+57|0]=a[d+60|0]|0;i=i;return}function Lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+64|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+64|0]|0;k=b+4|0;l=lFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+64|0]|0)|0;a[(c[b+352>>2]|0)+64|0]=l;e=k;f=j;break}else{j=b+4|0;k=lFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+64|0]|0)|0;a[(c[b+352>>2]|0)+64|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+64|0]|0;k=b+4|0;j=pFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+64|0]=j;e=k;f=g;break}else{g=b+4|0;k=pFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+64|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+68|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}if((a[b+60|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}if((a[b+64|0]|0)!=0){m=0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}m=f<<24>>24!=0|0;n=b;o=n+39|0;p=o;a[p]=m;i=d;return}function Mh(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+39|0]|0)==0){f=0}else{if((a[e+72|0]|0)==0){f=0;break}f=(a[e+68|0]|0)==0|0}}while(0);a[e+17|0]=f;i=d;return}function Nh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+17|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+28|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}if((a[m+68|0]|0)==0){q=0;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}function Oh(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+110|0]=a[d+60|0]|0;i=i;return}function Ph(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+111|0]=(a[d+60|0]|0)==0|0;i=i;return}function Qh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;if((a[b+312|0]|0)!=0){g=c[b+416>>2]|0;j=+h[g+2608>>3];if((a[f+60|0]|0)==0){k=j}else{k=j+ +h[g+2592>>3]}h[(c[e+8>>2]|0)+4232>>3]=k;i=d;return}if((a[f+111|0]|0)==0){l=7}else{if((a[(c[b+408>>2]|0)+111|0]|0)!=0){l=7}}do{if((l|0)==7){if((a[f+110|0]|0)!=0){if((a[(c[b+408>>2]|0)+110|0]|0)==0){break}}h[(c[e+8>>2]|0)+4232>>3]=+h[(c[b+400>>2]|0)+4232>>3];i=d;return}}while(0);l=c[b+416>>2]|0;k=+h[l+2608>>3];if((a[f+60|0]|0)==0){m=k}else{m=k+ +h[l+2592>>3]}h[(c[e+8>>2]|0)+4232>>3]=m;i=d;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0,s=0.0;d=i;if((a[b+312|0]|0)!=0){e=b+416|0;f=rFa(+h[(c[e>>2]|0)+2600>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+60|0]|0)!=0){l=+h[k+2600>>3];m=+h[k+2592>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,l,1464,1456,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=rFa(+h[k+2616>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+60|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+2616>>3];m=+h[o+2592>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+SBa(c[b+536>>2]|0,l,1480,1456,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3]=n;i=d;return}g=b+4|0;e=c[c[g>>2]>>2]|0;k=c[e+16>>2]|0;if((a[k+111|0]|0)==0){r=15}else{if((a[(c[b+408>>2]|0)+111|0]|0)!=0){r=15}}do{if((r|0)==15){if((a[k+110|0]|0)!=0){if((a[(c[b+408>>2]|0)+110|0]|0)==0){break}}h[(c[e+8>>2]|0)+4224>>3]=+h[(c[b+400>>2]|0)+4224>>3];i=d;return}}while(0);e=b+416|0;k=rFa(+h[(c[e>>2]|0)+2600>>3],0.0)|0;r=c[c[g>>2]>>2]|0;j=c[e>>2]|0;do{if(k<<24>>24!=0&(a[(c[r+16>>2]|0)+60|0]|0)!=0){n=+h[j+2600>>3];l=+h[j+2592>>3];if(n!=0.0){s=l/n;break}if(l==0.0){s=l;break}s=l/+SBa(c[b+536>>2]|0,n,1464,1456,+h[r>>3],(a[b+319|0]|0)!=0|0)}else{f=rFa(+h[j+2616>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+60|0]|0)!=0|f<<24>>24==0){s=0.0;break}f=c[e>>2]|0;n=+h[f+2616>>3];l=+h[f+2592>>3];q=-l;if(n!=0.0){s=q/n;break}if(l==-0.0){s=q;break}s=q/+SBa(c[b+536>>2]|0,n,1480,1456,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4224>>3]=s;i=d;return}function Sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0.0,z=0,A=0.0;d=i;e=b+312|0;if((a[e]|0)!=0){f=b+416|0;g=rFa(+h[(c[f>>2]|0)+2600>>3],0.0)|0;j=rFa(+h[(c[f>>2]|0)+2616>>3],0.0)|0;k=rFa(+U(+(+h[(c[f>>2]|0)+2592>>3])),0.0)|0;f=b+4|0;l=c[c[f>>2]>>2]|0;m=a[(c[l+16>>2]|0)+60|0]|0;do{if(m<<24>>24!=0&g<<24>>24==0){n=4}else{if(!(k<<24>>24!=0&(m|j)<<24>>24!=0&(a[e]|0)==0)){n=4;break}o=+h[l>>3];p=c[l+8>>2]|0;q=+h[p+4224>>3];r=+h[p+4232>>3]- +h[(c[b+400>>2]|0)+4240>>3];do{if(q!=0.0){s=l;t=r/q}else{if(r==0.0){s=l;t=r;break}u=r/+SBa(c[b+536>>2]|0,q,1504,1496,o,(a[b+319|0]|0)!=0|0);s=c[c[f>>2]>>2]|0;t=u}}while(0);v=s;w=o+t}}while(0);if((n|0)==4){v=l;w=+h[l>>3]}h[(c[v+8>>2]|0)+4216>>3]=w;i=d;return}v=b+4|0;l=c[c[v>>2]>>2]|0;s=c[l+16>>2]|0;if((a[s+111|0]|0)==0){n=13}else{if((a[(c[b+408>>2]|0)+111|0]|0)!=0){n=13}}do{if((n|0)==13){if((a[s+110|0]|0)!=0){if((a[(c[b+408>>2]|0)+110|0]|0)==0){break}}h[(c[l+8>>2]|0)+4216>>3]=+h[(c[b+400>>2]|0)+4216>>3];i=d;return}}while(0);l=b+416|0;s=rFa(+h[(c[l>>2]|0)+2600>>3],0.0)|0;f=rFa(+h[(c[l>>2]|0)+2616>>3],0.0)|0;j=rFa(+U(+(+h[(c[l>>2]|0)+2592>>3])),0.0)|0;l=c[c[v>>2]>>2]|0;m=a[(c[l+16>>2]|0)+60|0]|0;do{if(m<<24>>24!=0&s<<24>>24==0){n=17}else{if(!(j<<24>>24!=0&(m|f)<<24>>24!=0&(a[e]|0)==0)){n=17;break}w=+h[l>>3];k=c[l+8>>2]|0;t=+h[k+4224>>3];q=+h[k+4232>>3]- +h[(c[b+400>>2]|0)+4240>>3];do{if(t!=0.0){x=l;y=q/t}else{if(q==0.0){x=l;y=q;break}r=q/+SBa(c[b+536>>2]|0,t,1504,1496,w,(a[b+319|0]|0)!=0|0);x=c[c[v>>2]>>2]|0;y=r}}while(0);z=x;A=w+y}}while(0);if((n|0)==17){z=l;A=+h[l>>3]}h[(c[z+8>>2]|0)+4216>>3]=A;i=d;return}function Th(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+63|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+63|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=lFa(+h[l>>3],+h[(c[l+8>>2]|0)+4216>>3],a[(c[b+360>>2]|0)+63|0]|0)|0;a[(c[b+352>>2]|0)+63|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=lFa(+h[k>>3],+h[(c[k+8>>2]|0)+4216>>3],a[(c[b+360>>2]|0)+63|0]|0)|0;a[(c[b+352>>2]|0)+63|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+63|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=pFa(+h[j>>3],+h[(c[j+8>>2]|0)+4216>>3])|0;a[(c[b+352>>2]|0)+63|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=pFa(+h[m>>3],+h[(c[m+8>>2]|0)+4216>>3])|0;a[(c[b+352>>2]|0)+63|0]=k;e=g;f=k;break}}}}while(0);b=c[c[e>>2]>>2]|0;e=c[b+8>>2]|0;n=+h[e+4232>>3];if(f<<24>>24==0){o=n;p=e;q=p+4240|0;r=q;h[r>>3]=o;i=d;return}o=n-(+h[e+4216>>3]- +h[b>>3])*+h[e+4224>>3];p=e;q=p+4240|0;r=q;h[r>>3]=o;i=d;return}function Uh(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4616>>3]=+xd(+(+h[d+4240>>3]),.001);i=b;return}function Vh(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+56|0]=a[(c[b+408>>2]|0)+55|0]|0;i=i;return}function Wh(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+54|0]=a[(c[b+408>>2]|0)+54|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+54|0]=a[e+56|0]|0;i=d;return}}while(0);a[e+54|0]=a[f+54|0]|0;i=d;return}function Xh(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6120>>3]=(a[(c[d+16>>2]|0)+56|0]|0)!=0?1.0:0.0;i=i;return}function Yh(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+53|0]=a[d+56|0]|0;i=i;return}function Zh(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+23|0]|0)==0){f=0}else{if((a[e+60|0]|0)==0){f=0;break}f=(a[e+56|0]|0)==0|0}}while(0);a[e+24|0]=f;i=d;return}function _h(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+52|0]=a[(c[b+408>>2]|0)+51|0]|0;i=i;return}function $h(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+50|0]=a[(c[b+408>>2]|0)+50|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+50|0]=a[e+52|0]|0;i=d;return}}while(0);a[e+50|0]=a[f+50|0]|0;i=d;return}function ai(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6112>>3]=(a[(c[d+16>>2]|0)+52|0]|0)!=0?1.0:0.0;i=i;return}function bi(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6272>>3]=(a[(c[d+16>>2]|0)+52|0]|0)!=0?-2.0e3:0.0;i=i;return}function ci(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+49|0]=a[d+52|0]|0;i=i;return}function di(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+24|0;e=d;f=d+16|0;g=i;i=i+16|0;h=i;i=i+8|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+16>>2]|0;l=a[k+72|0]|0;c[f>>2]=a[k+52|0]|0;c[f+4>>2]=l;BBa(g,2,f);f=c[b+536>>2]|0;b=e;l=g;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];tv(h,f,e);a[(c[(c[c[j>>2]>>2]|0)+16>>2]|0)+74|0]=a[h]|0;i=d;return}function ei(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;if((a[e+80|0]|0)==0){f=0;g=e;h=g+76|0;j=h;a[j]=f;i=d;return}f=(a[e+74|0]|0)==0|0;g=e;h=g+76|0;j=h;a[j]=f;i=d;return}function fi(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+112|0]=a[d+76|0]|0;i=i;return}function gi(b){b=b|0;var d=0,e=0;d=i;if((a[b+312|0]|0)!=0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[(c[b+400>>2]|0)+6168>>3];i=d;return}e=c[c[b+4>>2]>>2]|0;do{if((a[(c[e+16>>2]|0)+112|0]|0)!=0){if((a[(c[b+408>>2]|0)+112|0]|0)!=0){break}h[(c[e+8>>2]|0)+6168>>3]=+h[e>>3];i=d;return}}while(0);h[(c[e+8>>2]|0)+6168>>3]=+h[(c[b+400>>2]|0)+6168>>3];i=d;return}function hi(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6160>>3]=+h[b>>3]- +h[a+6168>>3];i=i;return}function ii(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+76|0]|0)==0){f=0.0;g=b;j=g+6176|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6160>>3];g=b;j=g+6176|0;k=j;h[k>>3]=f;i=d;return}function ji(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+65|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+65|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3],a[(c[b+360>>2]|0)+65|0]|0)|0;a[(c[b+352>>2]|0)+65|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=oFa(+h[k>>3],+h[(c[k+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3],a[(c[b+360>>2]|0)+65|0]|0)|0;a[(c[b+352>>2]|0)+65|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+65|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=sFa(+h[j>>3],+h[(c[j+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3])|0;a[(c[b+352>>2]|0)+65|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=sFa(+h[m>>3],+h[(c[m+8>>2]|0)+6168>>3]+ +h[(c[b+416>>2]|0)+1016>>3])|0;a[(c[b+352>>2]|0)+65|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+76|0]|0)==0){n=0;o=b;p=o+75|0;q=p;a[q]=n;i=d;return}n=f<<24>>24!=0|0;o=b;p=o+75|0;q=p;a[q]=n;i=d;return}function ki(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+17|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}if((a[m+72|0]|0)==0){q=0;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+71|0;t=s;a[t]=q;i=d;return}function li(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+30|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}if((a[m+80|0]|0)==0){q=0;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}function mi(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+48|0]=a[(c[b+408>>2]|0)+47|0]|0;i=i;return}function ni(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+46|0]=a[(c[b+408>>2]|0)+46|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+46|0]=a[e+48|0]|0;i=d;return}}while(0);a[e+46|0]=a[f+46|0]|0;i=d;return}function oi(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6104>>3]=(a[(c[d+16>>2]|0)+48|0]|0)!=0?1.0:0.0;i=i;return}function pi(a){a=a|0;var b=0,d=0,e=0;b=i;JFa(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1840>>3]=+h[d>>3];h[e+5736>>3]=+h[d+8>>3];h[e+5600>>3]=+h[d+16>>3];h[e+808>>3]=+h[d+24>>3];h[e+5328>>3]=+h[d+32>>3];h[e+5648>>3]=+h[d+40>>3];h[e+5608>>3]=+h[d+48>>3];i=b;return}function qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+1840>>3],1.0e-15);k=+xd(+-+h[g+5600>>3],1.0e-15);l=j+k;m=j*+h[g+80>>3]+k*+h[(c[b+416>>2]|0)+2664>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1528,1520,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}function ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3688>>3]=+h[f>>3];i=b;return}function si(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3696>>3]=+h[f>>3];i=b;return}function ti(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+808>>3]),1.0e-15);k=+xd(+-+h[g+5600>>3],1.0e-15);l=j+k;m=j*+h[g>>3]+k*+h[(c[b+416>>2]|0)+2664>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1600,1592,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}function ui(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[f>>3];i=b;return}function vi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3864>>3]=+h[f>>3];i=b;return}function wi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1840>>3];h[b+1816>>3]=d*+h[(!(d>=0.0)?b+80|0:b+3872|0)>>3];i=i;return}function xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+808>>3]),1.0e-15);k=+xd(+-+h[g+1840>>3],1.0e-15);l=j+k;m=j*+h[g>>3]+k*+h[g+80>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,1672,1664,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}function yi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5600>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5600>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2664|0;k=+h[j>>3];l=g*k;m=f;n=m+2200|0;o=n;h[o>>3]=l;i=b;return}else{j=f+5584|0;k=+h[j>>3];l=g*k;m=f;n=m+2200|0;o=n;h[o>>3]=l;i=b;return}}function zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2712>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5584>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2712>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5584>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5600>>3],+h[d+7424>>3],+h[f>>3],+h[(c[k>>2]|0)+1456>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5616>>3]=+h[g>>3];i=b;return}function Ai(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+808>>3];h[b+784>>3]=d*+h[(!(d>=0.0)?b+3704|0:b)>>3];i=i;return}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[f>>3];i=b;return}function Ci(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5784>>3]=+h[f>>3];i=b;return}function Di(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+5584>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+5584>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5632>>3]=+h[f>>3];i=b;return}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+5584>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+5584>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5640>>3]=+h[f>>3];i=b;return}function Fi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5600>>3],+h[j+5640>>3],+h[j+7416>>3],+h[(c[b+416>>2]|0)+1456>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5600>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,1752,1744,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5352>>3]=+h[f>>3];i=b;return}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5360>>3]=+h[f>>3];i=b;return}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5648>>3],+h[l>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5648>>3];o=+h[m>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+808>>3],+h[d+5352>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1680>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5336>>3]=+h[g>>3];i=b;return}function Ji(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5648>>3],+h[(c[l>>2]|0)+2664>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5648>>3];n=+h[(c[l>>2]|0)+2664>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5600>>3],+h[d+5632>>3],+h[f>>3],+h[(c[l>>2]|0)+1456>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5624>>3]=+h[g>>3];i=b;return}function Ki(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5648>>3],+h[l+80>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5648>>3];o=+h[m+80>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1840>>3],+h[d+5776>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1344>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[g>>3];i=b;return}function Li(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+45|0]=a[d+48|0]|0;i=i;return}function Mi(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+108|0]=a[d+48|0]|0;i=i;return}function Ni(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+109|0]=(a[d+48|0]|0)==0|0;i=i;return}function Oi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;if((a[b+312|0]|0)!=0){g=c[b+416>>2]|0;j=+h[g+2640>>3];if((a[f+48|0]|0)==0){k=j}else{k=j+ +h[g+2624>>3]}h[(c[e+8>>2]|0)+4200>>3]=k;i=d;return}if((a[f+109|0]|0)==0){l=7}else{if((a[(c[b+408>>2]|0)+109|0]|0)!=0){l=7}}do{if((l|0)==7){if((a[f+108|0]|0)!=0){if((a[(c[b+408>>2]|0)+108|0]|0)==0){break}}h[(c[e+8>>2]|0)+4200>>3]=+h[(c[b+400>>2]|0)+4200>>3];i=d;return}}while(0);l=c[b+416>>2]|0;k=+h[l+2640>>3];if((a[f+48|0]|0)==0){m=k}else{m=k+ +h[l+2624>>3]}h[(c[e+8>>2]|0)+4200>>3]=m;i=d;return}function Pi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0,s=0.0;d=i;if((a[b+312|0]|0)!=0){e=b+416|0;f=rFa(+h[(c[e>>2]|0)+2632>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+48|0]|0)!=0){l=+h[k+2632>>3];m=+h[k+2624>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,l,1856,1848,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=rFa(+h[k+2648>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+48|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+2648>>3];m=+h[o+2624>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+SBa(c[b+536>>2]|0,l,1872,1848,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3]=n;i=d;return}g=b+4|0;e=c[c[g>>2]>>2]|0;k=c[e+16>>2]|0;if((a[k+109|0]|0)==0){r=15}else{if((a[(c[b+408>>2]|0)+109|0]|0)!=0){r=15}}do{if((r|0)==15){if((a[k+108|0]|0)!=0){if((a[(c[b+408>>2]|0)+108|0]|0)==0){break}}h[(c[e+8>>2]|0)+4192>>3]=+h[(c[b+400>>2]|0)+4192>>3];i=d;return}}while(0);e=b+416|0;k=rFa(+h[(c[e>>2]|0)+2632>>3],0.0)|0;r=c[c[g>>2]>>2]|0;j=c[e>>2]|0;do{if(k<<24>>24!=0&(a[(c[r+16>>2]|0)+48|0]|0)!=0){n=+h[j+2632>>3];l=+h[j+2624>>3];if(n!=0.0){s=l/n;break}if(l==0.0){s=l;break}s=l/+SBa(c[b+536>>2]|0,n,1856,1848,+h[r>>3],(a[b+319|0]|0)!=0|0)}else{f=rFa(+h[j+2648>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+48|0]|0)!=0|f<<24>>24==0){s=0.0;break}f=c[e>>2]|0;n=+h[f+2648>>3];l=+h[f+2624>>3];q=-l;if(n!=0.0){s=q/n;break}if(l==-0.0){s=q;break}s=q/+SBa(c[b+536>>2]|0,n,1872,1848,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3]=s;i=d;return}function Qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0.0,z=0,A=0.0;d=i;e=b+312|0;if((a[e]|0)!=0){f=b+416|0;g=rFa(+h[(c[f>>2]|0)+2632>>3],0.0)|0;j=rFa(+h[(c[f>>2]|0)+2648>>3],0.0)|0;k=rFa(+U(+(+h[(c[f>>2]|0)+2624>>3])),0.0)|0;f=b+4|0;l=c[c[f>>2]>>2]|0;m=a[(c[l+16>>2]|0)+48|0]|0;do{if(m<<24>>24!=0&g<<24>>24==0){n=4}else{if(!(k<<24>>24!=0&(m|j)<<24>>24!=0&(a[e]|0)==0)){n=4;break}o=+h[l>>3];p=c[l+8>>2]|0;q=+h[p+4192>>3];r=+h[p+4200>>3]- +h[(c[b+400>>2]|0)+4208>>3];do{if(q!=0.0){s=l;t=r/q}else{if(r==0.0){s=l;t=r;break}u=r/+SBa(c[b+536>>2]|0,q,1896,1888,o,(a[b+319|0]|0)!=0|0);s=c[c[f>>2]>>2]|0;t=u}}while(0);v=s;w=o+t}}while(0);if((n|0)==4){v=l;w=+h[l>>3]}h[(c[v+8>>2]|0)+4184>>3]=w;i=d;return}v=b+4|0;l=c[c[v>>2]>>2]|0;s=c[l+16>>2]|0;if((a[s+109|0]|0)==0){n=13}else{if((a[(c[b+408>>2]|0)+109|0]|0)!=0){n=13}}do{if((n|0)==13){if((a[s+108|0]|0)!=0){if((a[(c[b+408>>2]|0)+108|0]|0)==0){break}}h[(c[l+8>>2]|0)+4184>>3]=+h[(c[b+400>>2]|0)+4184>>3];i=d;return}}while(0);l=b+416|0;s=rFa(+h[(c[l>>2]|0)+2632>>3],0.0)|0;f=rFa(+h[(c[l>>2]|0)+2648>>3],0.0)|0;j=rFa(+U(+(+h[(c[l>>2]|0)+2624>>3])),0.0)|0;l=c[c[v>>2]>>2]|0;m=a[(c[l+16>>2]|0)+48|0]|0;do{if(m<<24>>24!=0&s<<24>>24==0){n=17}else{if(!(j<<24>>24!=0&(m|f)<<24>>24!=0&(a[e]|0)==0)){n=17;break}w=+h[l>>3];k=c[l+8>>2]|0;t=+h[k+4192>>3];q=+h[k+4200>>3]- +h[(c[b+400>>2]|0)+4208>>3];do{if(t!=0.0){x=l;y=q/t}else{if(q==0.0){x=l;y=q;break}r=q/+SBa(c[b+536>>2]|0,t,1896,1888,w,(a[b+319|0]|0)!=0|0);x=c[c[v>>2]>>2]|0;y=r}}while(0);z=x;A=w+y}}while(0);if((n|0)==17){z=l;A=+h[l>>3]}h[(c[z+8>>2]|0)+4184>>3]=A;i=d;return}function Ri(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+60|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+60|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=lFa(+h[l>>3],+h[(c[l+8>>2]|0)+4184>>3],a[(c[b+360>>2]|0)+60|0]|0)|0;a[(c[b+352>>2]|0)+60|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=lFa(+h[k>>3],+h[(c[k+8>>2]|0)+4184>>3],a[(c[b+360>>2]|0)+60|0]|0)|0;a[(c[b+352>>2]|0)+60|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+60|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=pFa(+h[j>>3],+h[(c[j+8>>2]|0)+4184>>3])|0;a[(c[b+352>>2]|0)+60|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=pFa(+h[m>>3],+h[(c[m+8>>2]|0)+4184>>3])|0;a[(c[b+352>>2]|0)+60|0]=k;e=g;f=k;break}}}}while(0);b=c[c[e>>2]>>2]|0;e=c[b+8>>2]|0;n=+h[e+4200>>3];if(f<<24>>24==0){o=n;p=e;q=p+4208|0;r=q;h[r>>3]=o;i=d;return}o=n-(+h[e+4184>>3]- +h[b>>3])*+h[e+4192>>3];p=e;q=p+4208|0;r=q;h[r>>3]=o;i=d;return}function Si(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4424>>3]=+xd(+(+h[d+4208>>3]),.001);i=b;return}function Ti(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+44|0]=a[(c[b+408>>2]|0)+43|0]|0;i=i;return}function Ui(b){b=b|0;var d=0,e=0,f=0;d=i;if((a[b+312|0]|0)!=0){a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+42|0]=a[(c[b+408>>2]|0)+42|0]|0;i=d;return}e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;f=c[b+408>>2]|0;do{if((a[e+107|0]|0)!=0){if((a[f+107|0]|0)!=0){break}a[e+42|0]=a[e+44|0]|0;i=d;return}}while(0);a[e+42|0]=a[f+42|0]|0;i=d;return}function Vi(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6096>>3]=(a[(c[d+16>>2]|0)+44|0]|0)!=0?1.0:0.0;i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6264>>3]=-+h[b+6104>>3]- +h[b+6096>>3]- +h[b+6112>>3]- +h[b+6120>>3]- +h[b+6128>>3]- +h[b+6136>>3]- +h[b+6144>>3]- +h[b+6152>>3]- +h[b+6184>>3]- +h[b+6192>>3]- +h[b+6200>>3]- +h[b+6208>>3]- +h[b+6240>>3]- +h[b+6248>>3]- +h[b+6256>>3];i=i;return}function Xi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=0-(tFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6264>>3],0,a)|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+104>>2]=e;i=b;return}function Yi(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+41|0]=a[d+44|0]|0;i=i;return}function Zi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+24|0;e=d;f=d+16|0;g=i;i=i+16|0;h=i;i=i+8|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+16>>2]|0;l=a[k+56|0]|0;c[f>>2]=a[k+44|0]|0;c[f+4>>2]=l;BBa(g,2,f);f=c[b+536>>2]|0;b=e;l=g;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];uv(h,f,e);a[(c[(c[c[j>>2]>>2]|0)+16>>2]|0)+73|0]=a[h]|0;i=d;return}function _i(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+37|0]|0)==0){f=0}else{if((a[e+73|0]|0)==0){f=0;break}f=(a[e+106|0]|0)==0|0}}while(0);a[e+38|0]=f;i=d;return}function $i(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+35|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}if((a[m+106|0]|0)==0){q=0;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+105|0;t=s;a[t]=q;i=d;return}function aj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+24|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}if((a[m+56|0]|0)==0){q=0;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+55|0;t=s;a[t]=q;i=d;return}function bj(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+25|0]|0)==0){f=0}else{if((a[e+48|0]|0)==0){f=0;break}f=(a[e+44|0]|0)==0|0}}while(0);a[e+26|0]=f;i=d;return}function cj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+26|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+38|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}if((a[m+44|0]|0)==0){q=0;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+43|0;t=s;a[t]=q;i=d;return}function dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[f>>3];i=b;return}function ej(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+72>>3],+h[l+3848>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+72>>3];o=+h[m+3848>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1856>>3],+h[d+5824>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1288>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[g>>3];i=b;return}function fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[f>>3];i=b;return}function gj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+1856>>3],+h[j+5848>>3],+h[j+5832>>3],+h[(c[b+416>>2]|0)+1288>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1856>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,1920,1912,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+5792|0;r=q;h[r>>3]=o;i=d;return}function hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[f>>3];i=b;return}function ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+88>>3],+h[l+3872>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+88>>3];o=+h[m+3872>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1840>>3],+h[d+5760>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1344>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[g>>3];i=b;return}function jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[f>>3];i=b;return}function kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1840>>3],+h[j+5784>>3],+h[j+5768>>3],+h[(c[b+416>>2]|0)+1344>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1840>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2032,2024,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}function lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[f>>3];i=b;return}function mj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[f>>3];i=b;return}function nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5496>>3]=+h[f>>3];i=b;return}function oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+40>>3],+h[l+3744>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+40>>3];o=+h[m+3744>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1104>>3],+h[d+5496>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1568>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5472>>3]=+h[g>>3];i=b;return}function pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5504>>3]=+h[f>>3];i=b;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1104>>3],+h[j+5504>>3],+h[j+5488>>3],+h[(c[b+416>>2]|0)+1568>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1104>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,2144,2136,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5448|0;q=p;h[q>>3]=n;i=d;return}



function $K(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+3800>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+3800>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5e3>>3]=+h[f>>3];i=b;return}function aL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4944>>3],+h[j+5e3>>3],+h[j+4984>>3],+h[(c[b+416>>2]|0)+1960>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,59848,59840,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}function bL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+3800>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+3800>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4992>>3]=+h[f>>3];i=b;return}function cL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5008>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5008>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4944>>3],+h[d+4992>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1960>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4968>>3]=+h[g>>3];i=b;return}function dL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3752>>3]*+h[j+1512>>3]*+h[e+3696>>3];l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,59952,59944,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}function eL(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1472>>3]=+h[(a?e+1488|0:e+1480|0)>>3];i=b;return}function fL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2120>>3],+h[(c[b+416>>2]|0)+2824>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+57|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+57|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[b+360>>2]|0)+57|0]|0)|0;a[(c[b+352>>2]|0)+57|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[b+360>>2]|0)+57|0]|0)|0;a[(c[b+352>>2]|0)+57|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+57|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+57|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+57|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+9|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+9|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+9|0;v=u;a[v]=m;i=d;return}function gL(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=+h[(a?e+1512|0:e+1504|0)>>3];i=b;return}function hL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3752>>3]*+h[j+1504>>3]*+h[e+3696>>3];l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,60032,60024,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}function iL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+97|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+6|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+97|0]|0;q=oFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2072>>3],a[(c[b+360>>2]|0)+97|0]|0)|0;a[(c[b+352>>2]|0)+97|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+6|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2072>>3],a[(c[b+360>>2]|0)+97|0]|0)|0;a[(c[b+352>>2]|0)+97|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+6|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+97|0]|0;p=sFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2072>>3])|0;a[(c[b+352>>2]|0)+97|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+6|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2072>>3])|0;a[(c[b+352>>2]|0)+97|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+6|0;n=m;a[n]=e;i=d;return}}}function jL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+35|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+35|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+168>>3],+h[k+2072>>3]+ +h[k+3080>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+168>>3],+h[j+2072>>3]+ +h[j+3080>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+35|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+168>>3],+h[l+2072>>3]+ +h[l+3080>>3])|0;a[(c[b+352>>2]|0)+35|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+168>>3],+h[g+2072>>3]+ +h[g+3080>>3])|0;a[(c[b+352>>2]|0)+35|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+36|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+36|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+168>>3],+h[l+2072>>3]- +h[l+3080>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+168>>3],+h[g+2072>>3]- +h[g+3080>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+36|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+168>>3],+h[k+2072>>3]- +h[k+3080>>3])|0;a[(c[b+352>>2]|0)+36|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+168>>3],+h[j+2072>>3]- +h[j+3080>>3])|0;a[(c[b+352>>2]|0)+36|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+6|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function kL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+6|0]|0)==0){f=0.0;g=b;j=g+2088|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+168>>3]- +h[b+2072>>3];g=b;j=g+2088|0;k=j;h[k>>3]=f;i=d;return}function lL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[(c[a+416>>2]|0)+2664>>3];i=i;return}function mL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2712>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2712>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+41|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+41|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+41|0]|0)|0;a[(c[b+352>>2]|0)+41|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+41|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+41|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+41|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2712>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2712>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+42|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+42|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u,a[(c[b+360>>2]|0)+42|0]|0)|0;a[(c[b+352>>2]|0)+42|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+42|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+42|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+176>>3],u)|0;a[(c[b+352>>2]|0)+42|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2712>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+84|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+84|0;J=I;c[J>>2]=x;i=d;return}function nL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2712>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4128>>3]=+h[f>>3];i=b;return}function oL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+176>>3];k=+h[g+4128>>3];l=+h[(c[b+416>>2]|0)+2712>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,60112,60104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4120|0;r=q;h[r>>3]=o;i=d;return}function pL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2712>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2152>>3]=+h[f>>3];i=b;return}function qL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+2152>>3]+-273.15;i=i;return}function rL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3816>>3]=+h[b+176>>3]- +h[d+2528>>3]*+h[d+3544>>3];i=i;return}function sL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+184>>3]=+h[(c[a+416>>2]|0)+2736>>3];i=i;return}function tL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2680>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,60128,e);p=+h[(c[f>>2]|0)+2680>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2160>>3]=p+g*+h[f+184>>3]*2.0;i=b;return}function uL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4136>>3]=+h[b+2680>>3]*+h[d+184>>3]+ +h[b+2688>>3];i=i;return}function vL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+4136>>3]*+h[b+4128>>3];i=i;return}function wL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+4168>>3]*+h[b+4120>>3];i=i;return}function xL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+96|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+10|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+96|0]|0;q=oFa(+h[(c[b+416>>2]|0)+2736>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2168>>3],a[(c[b+360>>2]|0)+96|0]|0)|0;a[(c[b+352>>2]|0)+96|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+10|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+2736>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2168>>3],a[(c[b+360>>2]|0)+96|0]|0)|0;a[(c[b+352>>2]|0)+96|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+10|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+96|0]|0;p=sFa(+h[(c[b+416>>2]|0)+2736>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2168>>3])|0;a[(c[b+352>>2]|0)+96|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+10|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+2736>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2168>>3])|0;a[(c[b+352>>2]|0)+96|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+10|0;n=m;a[n]=e;i=d;return}}}function yL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+39|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+39|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+184>>3],+h[k+2168>>3]+ +h[k+3112>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+184>>3],+h[j+2168>>3]+ +h[j+3112>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+39|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+184>>3],+h[l+2168>>3]+ +h[l+3112>>3])|0;a[(c[b+352>>2]|0)+39|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+184>>3],+h[g+2168>>3]+ +h[g+3112>>3])|0;a[(c[b+352>>2]|0)+39|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+40|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+40|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+184>>3],+h[l+2168>>3]- +h[l+3112>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+184>>3],+h[g+2168>>3]- +h[g+3112>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+40|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+184>>3],+h[k+2168>>3]- +h[k+3112>>3])|0;a[(c[b+352>>2]|0)+40|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+184>>3],+h[j+2168>>3]- +h[j+3112>>3])|0;a[(c[b+352>>2]|0)+40|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+10|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}function zL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+10|0]|0)==0){f=0.0;g=b;j=g+2176|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+184>>3]- +h[b+2168>>3];g=b;j=g+2176|0;k=j;h[k>>3]=f;i=d;return}function AL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+192>>3]=+h[(c[a+416>>2]|0)+2408>>3];i=i;return}function BL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2456>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2456>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+45|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+45|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+45|0]|0)|0;a[(c[b+352>>2]|0)+45|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+45|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+45|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+45|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2456>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2456>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+46|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+46|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u,a[(c[b+360>>2]|0)+46|0]|0)|0;a[(c[b+352>>2]|0)+46|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+46|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+46|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+192>>3],u)|0;a[(c[b+352>>2]|0)+46|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2456>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+88|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+88|0;J=I;c[J>>2]=x;i=d;return}function CL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2456>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4264>>3]=+h[f>>3];i=b;return}function DL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=+h[g+4264>>3];l=+h[(c[b+416>>2]|0)+2456>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,60224,60216,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4256|0;r=q;h[r>>3]=o;i=d;return}function EL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2456>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2208>>3]=+h[f>>3];i=b;return}function FL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4248>>3]=+h[b+2208>>3]+-273.15;i=i;return}function GL(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3824>>3]=+h[b+192>>3]- +h[d+2528>>3]*+h[d+3360>>3];i=i;return}function HL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+200>>3]=+h[(c[a+416>>2]|0)+2480>>3];i=i;return}function IL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2424>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,60240,e);p=+h[(c[f>>2]|0)+2424>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2216>>3]=p+g*+h[f+200>>3]*2.0;i=b;return}function JL(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4272>>3]=+h[b+2424>>3]*+h[d+200>>3]+ +h[b+2432>>3];i=i;return}function KL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+4272>>3]*+h[b+4264>>3];i=i;return}function LL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+4304>>3]*+h[b+4256>>3];i=i;return}function ML(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+95|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+12|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+95|0]|0;q=oFa(+h[(c[b+416>>2]|0)+2480>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2224>>3],a[(c[b+360>>2]|0)+95|0]|0)|0;a[(c[b+352>>2]|0)+95|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+12|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+2480>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2224>>3],a[(c[b+360>>2]|0)+95|0]|0)|0;a[(c[b+352>>2]|0)+95|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+12|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+95|0]|0;p=sFa(+h[(c[b+416>>2]|0)+2480>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2224>>3])|0;a[(c[b+352>>2]|0)+95|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+12|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+2480>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2224>>3])|0;a[(c[b+352>>2]|0)+95|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+12|0;n=m;a[n]=e;i=d;return}}}function NL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+43|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+43|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+200>>3],+h[k+2224>>3]+ +h[k+3128>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+200>>3],+h[j+2224>>3]+ +h[j+3128>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+43|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+200>>3],+h[l+2224>>3]+ +h[l+3128>>3])|0;a[(c[b+352>>2]|0)+43|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+200>>3],+h[g+2224>>3]+ +h[g+3128>>3])|0;a[(c[b+352>>2]|0)+43|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+44|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+44|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+200>>3],+h[l+2224>>3]- +h[l+3128>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+200>>3],+h[g+2224>>3]- +h[g+3128>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+44|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+200>>3],+h[k+2224>>3]- +h[k+3128>>3])|0;a[(c[b+352>>2]|0)+44|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+200>>3],+h[j+2224>>3]- +h[j+3128>>3])|0;a[(c[b+352>>2]|0)+44|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+12|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}function OL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+12|0]|0)==0){f=0.0;g=b;j=g+2232|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+200>>3]- +h[b+2224>>3];g=b;j=g+2232|0;k=j;h[k>>3]=f;i=d;return}function PL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+216>>3]=+h[(c[a+416>>2]|0)+2368>>3];i=i;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+216>>3]*1.0e-5;i=i;return}function RL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5192>>3]=+h[b+216>>3]- +h[b+24>>3];i=i;return}function SL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4392>>3]=+h[d>>3];i=b;return}function TL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+208>>3]=+h[(c[a+416>>2]|0)+2304>>3];i=i;return}function UL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5232>>3]=+h[f>>3];i=b;return}function VL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+216>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5240>>3]=+h[f>>3];i=b;return}function WL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+47|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+47|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+47|0]|0)|0;a[(c[b+352>>2]|0)+47|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+47|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+47|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+47|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+48|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+48|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u,a[(c[b+360>>2]|0)+48|0]|0)|0;a[(c[b+352>>2]|0)+48|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+48|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+48|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+208>>3],u)|0;a[(c[b+352>>2]|0)+48|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+49|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+49|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[b+360>>2]|0)+49|0]|0)|0;a[(c[b+352>>2]|0)+49|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+49|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+49|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+49|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+92|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+92|0;H=G;c[H>>2]=y;i=d;return}function XL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+216>>3],+h[k+208>>3],c[(c[a+12>>2]|0)+92>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+216>>3];m=+h[g+208>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4368>>3]=+h[f>>3];i=b;return}function YL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+208>>3];k=+h[g+4368>>3];l=+h[g+216>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,60336,60328,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4400>>3]=j-n;i=d;return}function ZL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+4368>>3]*1.0e-4;i=i;return}function _L(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4496>>3]=+h[b+4488>>3]*+h[b+4400>>3];i=i;return}function $L(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+216>>3],+h[k+208>>3],c[(c[a+12>>2]|0)+92>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+216>>3];m=+h[g+208>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2264>>3]=+h[f>>3];i=b;return}function aM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4376>>3]=+h[b+2264>>3]+-273.15;i=i;return}function bM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],+h[d>>3],60344);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4352>>3]=+h[e>>3];i=b;return}function cM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3712>>3]=+h[f>>3];i=b;return}function dM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3720>>3]=+h[f>>3];i=b;return}function eM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[(c[a+416>>2]|0)+2248>>3];i=i;return}function fM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4576>>3]=+h[b+232>>3]*1.0e-5;i=i;return}function gM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5392>>3]=+h[b+232>>3]- +h[b+56>>3];i=i;return}function hM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4584>>3]=+h[d>>3];i=b;return}function iM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[(c[a+416>>2]|0)+2184>>3];i=i;return}function jM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[f>>3];i=b;return}function kM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+232>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+232>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5440>>3]=+h[f>>3];i=b;return}function lM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+50|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+50|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+50|0]|0)|0;a[(c[b+352>>2]|0)+50|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+50|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+50|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+50|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+51|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+51|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u,a[(c[b+360>>2]|0)+51|0]|0)|0;a[(c[b+352>>2]|0)+51|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+51|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+51|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+224>>3],u)|0;a[(c[b+352>>2]|0)+51|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+52|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+52|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[b+360>>2]|0)+52|0]|0)|0;a[(c[b+352>>2]|0)+52|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+52|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+52|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+52|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+96|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+96|0;H=G;c[H>>2]=y;i=d;return}function mM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+232>>3],+h[k+224>>3],c[(c[a+12>>2]|0)+96>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+232>>3];m=+h[g+224>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4560>>3]=+h[f>>3];i=b;return}function nM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+224>>3];k=+h[g+4560>>3];l=+h[g+232>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,60384,60376,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4592>>3]=j-n;i=d;return}function oM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+4560>>3]*1.0e-4;i=i;return}function pM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+4680>>3]*+h[b+4592>>3];i=i;return}function qM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+232>>3],+h[k+224>>3],c[(c[a+12>>2]|0)+96>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+232>>3];m=+h[g+224>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2272>>3]=+h[f>>3];i=b;return}function rM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4568>>3]=+h[b+2272>>3]+-273.15;i=i;return}function sM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],+h[d>>3],60344);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4544>>3]=+h[e>>3];i=b;return}function tM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3752>>3]=+h[f>>3];i=b;return}function uM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3760>>3]=+h[f>>3];i=b;return}function vM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[(c[a+416>>2]|0)+2096>>3];i=i;return}function wM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4792>>3]=+h[b+248>>3]*1.0e-5;i=i;return}function xM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4880>>3]=+h[b+104>>3]- +h[b+248>>3];i=i;return}function yM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4872>>3]=+h[(c[a+416>>2]|0)+2040>>3]*+h[b+4880>>3]*.01;i=i;return}function zM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+248>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4800>>3]=+h[d>>3];i=b;return}function AM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+240>>3]=+h[(c[a+416>>2]|0)+2080>>3];i=i;return}function BM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4872>>3],+h[d+4920>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2016>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4896>>3]=+h[g>>3];i=b;return}function CM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5304>>3]=+h[f>>3];i=b;return}function DM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5312>>3]=+h[f>>3];i=b;return}function EM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5144>>3]=+h[f>>3];i=b;return}function FM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5152>>3]=+h[f>>3];i=b;return}function GM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4904>>3]=+h[f>>3];i=b;return}function HM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4872>>3],+h[d+4904>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2016>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4888>>3]=+h[g>>3];i=b;return}function IM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+248>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+248>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4912>>3]=+h[f>>3];i=b;return}function JM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4872>>3],+h[j+4928>>3],+h[j+4912>>3],+h[(c[b+416>>2]|0)+2016>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4872>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,60400,60392,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4864|0;q=p;h[q>>3]=n;i=d;return}function KM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+53|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+53|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+53|0]|0)|0;a[(c[b+352>>2]|0)+53|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+53|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+53|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+53|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+54|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+54|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u,a[(c[b+360>>2]|0)+54|0]|0)|0;a[(c[b+352>>2]|0)+54|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+54|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+54|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+240>>3],u)|0;a[(c[b+352>>2]|0)+54|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+55|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+55|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[b+360>>2]|0)+55|0]|0)|0;a[(c[b+352>>2]|0)+55|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[b+360>>2]|0)+55|0]|0)|0;a[(c[b+352>>2]|0)+55|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+55|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+55|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+55|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+100|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+100|0;H=G;c[H>>2]=y;i=d;return}function LM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+248>>3],+h[k+240>>3],c[(c[a+12>>2]|0)+100>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+248>>3];m=+h[g+240>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4824>>3]=+h[f>>3];i=b;return}function MM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+240>>3];k=+h[g+4824>>3];l=+h[g+248>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,60504,60496,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+4808>>3]=j-n;i=d;return}function NM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4848>>3]=+h[(c[a+416>>2]|0)+2088>>3]*+h[b+4824>>3];i=i;return}function OM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4856>>3]=+h[b+4848>>3]*+h[b+4808>>3];i=i;return}function PM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+248>>3],+h[k+240>>3],c[(c[a+12>>2]|0)+100>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+248>>3];m=+h[g+240>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4816>>3]=+h[f>>3];i=b;return}function QM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4784>>3]=+h[b+4816>>3]+-273.15;i=i;return}function RM(a){a=a|0;h[(c[a+400>>2]|0)+6080>>3]=+h[c[c[a+4>>2]>>2]>>3];i=i;return}function SM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=+h[(c[a+400>>2]|0)+6080>>3];i=i;return}function TM(a){a=a|0;var b=0;b=c[c[a+4>>2]>>2]|0;a=c[b+8>>2]|0;h[a+6072>>3]=+h[b>>3]- +h[a+6080>>3];i=i;return}function UM(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+41|0]=0;i=i;return}function VM(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+44|0]=a[d+41|0]|0;i=i;return}function WM(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6096>>3]=(a[(c[d+16>>2]|0)+44|0]|0)!=0?1.0:0.0;i=i;return}function XM(b){b=b|0;a[(c[b+408>>2]|0)+43|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+44|0]|0;i=i;return}function YM(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+44|0]=a[d+43|0]|0;i=i;return}function ZM(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+42|0]=a[d+44|0]|0;i=i;return}function _M(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+42|0]=a[(c[b+408>>2]|0)+42|0]|0;i=i;return}function $M(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+45|0]=0;i=i;return}function aN(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+48|0]=a[d+45|0]|0;i=i;return}function bN(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+109|0]=(a[d+48|0]|0)==0|0;i=i;return}function cN(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+108|0]=a[d+48|0]|0;i=i;return}function dN(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+25|0]|0)==0){f=0}else{if((a[e+48|0]|0)==0){f=0;break}f=(a[e+44|0]|0)==0|0}}while(0);a[e+26|0]=f;i=d;return}function eN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0;d=i;e=b+416|0;f=rFa(+h[(c[e>>2]|0)+2632>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+48|0]|0)!=0){l=+h[k+2632>>3];m=+h[k+2624>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,l,60536,60528,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=rFa(+h[k+2648>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+48|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+2648>>3];m=+h[o+2624>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+SBa(c[b+536>>2]|0,l,60552,60528,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4192>>3]=n;i=d;return}function fN(b){b=b|0;var d=0,e=0,f=0.0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[b+416>>2]|0;f=+h[e+2640>>3];if((a[(c[d+16>>2]|0)+48|0]|0)==0){g=f}else{g=f+ +h[e+2624>>3]}h[(c[d+8>>2]|0)+4200>>3]=g;i=i;return}function gN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5096>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5096|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5096>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+584>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+584|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+584>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+8>>3]=k;TFa(a,1)|0;j=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5096>>3]=+h[j>>3];h[f+584>>3]=+h[j+8>>3];Jv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);Pv(a);Qv(a);Rv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);i=b;return}function hN(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3792>>3]=+h[b+1352>>3]+ +h[d+2528>>3]*+h[d+3912>>3];i=i;return}function iN(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+576>>3]=-(+h[e+1320>>3]*+h[(a<<24>>24==0?e+112|0:e+3792|0)>>3]);i=b;return}function jN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1320>>3]*+h[(c[a+416>>2]|0)+3888>>3];i=i;return}function kN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5112>>3],1.0e-15);k=+xd(+(+h[g+1320>>3]),1.0e-15);l=j+k;m=j*+h[g+240>>3]+k*+h[g+3784>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,60576,60568,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}function lN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+5088>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+5088>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5024>>3],+h[d+5056>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1904>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5040>>3]=+h[g>>3];i=b;return}function mN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5088>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5088>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5080>>3]=+h[f>>3];i=b;return}function nN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5024>>3],+h[j+5080>>3],+h[j+5064>>3],+h[(c[b+416>>2]|0)+1904>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5024>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,60656,60648,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}function oN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5088>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5088>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5072>>3]=+h[f>>3];i=b;return}function pN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5096>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5096>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5024>>3],+h[d+5072>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1904>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5048>>3]=+h[g>>3];i=b;return}function qN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5024>>3],1.0e-15);k=+xd(+(+h[g+1320>>3]),1.0e-15);l=j+k;m=j*+h[g+96>>3]+k*+h[g+3784>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,60760,60752,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}function rN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+5176>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+5176>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5112>>3],+h[d+5144>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5128>>3]=+h[g>>3];i=b;return}function sN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5168>>3]=+h[f>>3];i=b;return}function tN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5112>>3],+h[j+5168>>3],+h[j+5152>>3],+h[(c[b+416>>2]|0)+1848>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5112>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,60840,60832,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}function uN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5160>>3]=+h[f>>3];i=b;return}function vN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5096>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5096>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5112>>3],+h[d+5160>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5136>>3]=+h[g>>3];i=b;return}function wN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3],+h[(c[b+416>>2]|0)+4752>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+59|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+59|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[b+360>>2]|0)+59|0]|0)|0;a[(c[b+352>>2]|0)+59|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[b+360>>2]|0)+59|0]|0)|0;a[(c[b+352>>2]|0)+59|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+59|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+59|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+59|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+1|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+1|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+1|0;v=u;a[v]=m;i=d;return}function xN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3936>>3]*+h[j+1400>>3]*+h[e+3880>>3];l=+h[j+1320>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,60944,60936,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}function yN(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1368>>3]=+h[(a?e+1384|0:e+1376|0)>>3];i=b;return}function zN(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1392>>3]=+h[(a?e+1408|0:e+1400|0)>>3];i=b;return}function AN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3936>>3]*+h[j+1408>>3]*+h[e+3880>>3];l=+h[j+1320>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,61032,61024,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}function BN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+48|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1816>>3]*+h[f+5192>>3]*.01;k=g;l=k+792|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5192>>3]*.01;k=g;l=k+792|0;m=l;h[m>>3]=j;i=d;return}}function CN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+216>>3],+h[l+16>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+216>>3];o=+h[m+16>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+792>>3],+h[d+5232>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1792>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5208>>3]=+h[g>>3];i=b;return}function DN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+24>>3],+h[l+208>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+24>>3];o=+h[m+208>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+792>>3],+h[d+5216>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1792>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5200>>3]=+h[g>>3];i=b;return}function EN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+792>>3],+h[j+5240>>3],+h[j+5224>>3],+h[(c[b+416>>2]|0)+1792>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+792>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,61120,61112,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5184|0;q=p;h[q>>3]=n;i=d;return}function FN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4432|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4432>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5256>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5256|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5256>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+4408>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+4408|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+4408>>3]);g=c[f>>2]|0;h[(c[g+212>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+204>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4424>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4424|0;h[(c[g+208>>2]|0)+24>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4424>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+24>>3]=k;TFa(a,2)|0;e=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4432>>3]=+h[e>>3];h[f+5256>>3]=+h[e+8>>3];h[f+4408>>3]=+h[e+16>>3];h[f+4424>>3]=+h[e+24>>3];Zv(a);_v(a);$v(a);aw(a);bw(a);cw(a);dw(a);ew(a);i=b;return}function GN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4344>>3]=+h[f>>3];i=b;return}function HN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+240>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+240>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4360>>3]=+h[f>>3];i=b;return}function IN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;ou(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4360>>3]);Dt(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],+h[d>>3],61232);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4336>>3]=+h[e>>3];i=b;return}function JN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[(c[b+416>>2]|0)+2528>>3]*+h[g+4344>>3];k=+h[g+4336>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61280,61272,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+4328|0;p=o;h[p>>3]=m;i=d;return}function KN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5296>>3]=+h[f>>3];i=b;return}function LN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4504>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4504>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5288>>3]=+h[f>>3];i=b;return}function MN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+208>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+208>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5256>>3],+h[d+5304>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1736>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5280>>3]=+h[g>>3];i=b;return}function NN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4504>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4504>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5256>>3],+h[d+5288>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1736>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5272>>3]=+h[g>>3];i=b;return}function ON(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5256>>3],+h[j+5312>>3],+h[j+5296>>3],+h[(c[b+416>>2]|0)+1736>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5256>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,61320,61312,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5248|0;q=p;h[q>>3]=n;i=d;return}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+5256>>3]- +h[b+792>>3];i=i;return}function QN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4488>>3];k=+h[g+6672>>3]- +h[g+4480>>3]*+h[g+4400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61424,61416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6584|0;p=o;h[p>>3]=m;i=d;return}function RN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6808>>3]=-+h[b+4480>>3]/-1.0e-4;i=i;return}function SN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+488>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+488|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+488>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+480>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+480|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+480>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;TFa(a,3)|0;a=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+488>>3]=+h[a>>3];h[f+480>>3]=+h[a+8>>3];i=b;return}function TN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4872>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5256>>3],0.0)|0;f=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5112>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=g+240|0;h[g+4832>>3]=+h[g+4872>>3]*+h[(a<<24>>24==0?d:g+96|0)>>3]+(+h[g+5112>>3]*+h[(f<<24>>24==0?d:g+5176|0)>>3]- +h[g+5256>>3]*+h[(e<<24>>24==0?d:g+208|0)>>3]);i=b;return}function UN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=+h[b+4872>>3]+(+h[b+5112>>3]- +h[b+5256>>3]);i=i;return}function VN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4848>>3];k=+h[g+4832>>3]- +h[g+4840>>3]*+h[g+4808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61440,61432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}function WN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2088>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,61464,61456,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}function XN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+512>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+512|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+512>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+8>>3]=k;TFa(a,4)|0;a=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[a>>3];h[f+512>>3]=+h[a+8>>3];i=b;return}function YN(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+220>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+5256>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,61488,61480,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4416|0;q=p;h[q>>3]=n;i=d;return}function ZN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4208>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4208|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4208>>3]);h[c[(c[f>>2]|0)+452>>2]>>3]=k;TFa(a,5)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4208>>3]=+h[c[(c[f>>2]|0)+444>>2]>>3];i=b;return}function _N(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4184>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4184|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4184>>3]);h[c[(c[f>>2]|0)+532>>2]>>3]=k;TFa(a,6)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4184>>3]=+h[c[(c[f>>2]|0)+524>>2]>>3];i=b;return}function $N(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0;b=i;d=a+400|0;e=(c[d>>2]|0)+4208|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[e>>3];h[c[g+608>>2]>>3]=+h[e>>3];j=+h[e>>3];k=+VFa(a,j,j);h[c[(c[f>>2]|0)+612>>2]>>3]=k;TFa(a,7)|0;h[(c[d>>2]|0)+4208>>3]=+h[c[(c[f>>2]|0)+604>>2]>>3];i=b;return}function aO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+792>>3];h[b+768>>3]=d*+h[(!(d>=0.0)?b+16|0:b+208|0)>>3];i=i;return}function bO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+768>>3]- +h[b+776>>3];i=i;return}function cO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+792>>3]- +h[b+800>>3];i=i;return}function dO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+h[g+848>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61520,61512,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}function eO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+592>>3]*+h[j+752>>3]*+h[e+4472>>3];l=+h[j+792>>3]+ +h[j+800>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,61560,61552,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}function fO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+816>>3]=+h[b+616>>3]*+h[d+592>>3]*+h[d+4472>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+(+h[b+696>>3]*.5+ +h[d+2528>>3]*+h[b+752>>3]*-1.5)));i=i;return}function gO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=+h[b+832>>3]+ +h[b+816>>3];i=i;return}function hO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+864>>3];k=+h[g+2472>>3]- +h[g+848>>3]*+h[g+688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61656,61648,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}function iO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+296>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+296|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+296>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+288>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+288|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+288>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+8>>3]=k;TFa(a,8)|0;a=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+296>>3]=+h[a>>3];h[f+288>>3]=+h[a+8>>3];i=b;return}function jO(a){a=a|0;var b=0,d=0,e=0;b=i;JFa(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+5328>>3]=+h[d>>3];h[e+1840>>3]=+h[d+8>>3];h[e+5736>>3]=+h[d+16>>3];h[e+5648>>3]=+h[d+24>>3];h[e+5608>>3]=+h[d+32>>3];h[e+5600>>3]=+h[d+40>>3];h[e+808>>3]=+h[d+48>>3];i=b;return}function kO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+800>>3]- +h[b+808>>3];i=i;return}function lO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3376>>3];k=+h[g+856>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,61688,61680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}function mO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+600>>3]*+h[j+760>>3]*+h[e+4472>>3];l=+h[j+800>>3]+ +h[j+808>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,61728,61720,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}function nO(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+824>>3]=+h[b+624>>3]*+h[d+600>>3]*+h[d+4472>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+(+h[b+696>>3]*.5+ +h[d+2528>>3]*+h[b+760>>3]*-1.5)));i=i;return}function oO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+808>>3]),1.0e-15);k=+xd(+-+h[g+5600>>3],1.0e-15);l=j+k;m=j*+h[g>>3]+k*+h[(c[b+416>>2]|0)+2664>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,61824,61816,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3872|0;r=q;h[r>>3]=o;i=d;return}function pO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3864>>3]=+h[f>>3];i=b;return}function qO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[f>>3];i=b;return}function rO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5784>>3]=+h[f>>3];i=b;return}function sO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5776>>3]=+h[f>>3];i=b;return}function tO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5648>>3],+h[l+80>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5648>>3];o=+h[m+80>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+1840>>3],+h[d+5776>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1344>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5752>>3]=+h[g>>3];i=b;return}function uO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+88>>3],+h[l+3872>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+88>>3];o=+h[m+3872>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+1840>>3],+h[d+5760>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1344>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5744>>3]=+h[g>>3];i=b;return}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+1840>>3],+h[j+5784>>3],+h[j+5768>>3],+h[(c[b+416>>2]|0)+1344>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+1840>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,61896,61888,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5728|0;q=p;h[q>>3]=n;i=d;return}function wO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+1840>>3],1.0e-15);k=+xd(+-+h[g+5600>>3],1.0e-15);l=j+k;m=j*+h[g+80>>3]+k*+h[(c[b+416>>2]|0)+2664>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,62008,62e3,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+3704|0;r=q;h[r>>3]=o;i=d;return}function xO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+8>>3],+h[l+3704>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+8>>3];o=+h[m+3704>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+808>>3],+h[d+5368>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1680>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5344>>3]=+h[g>>3];i=b;return}function yO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3696>>3]=+h[f>>3];i=b;return}function zO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3688>>3]=+h[f>>3];i=b;return}function AO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+808>>3];h[b+784>>3]=d*+h[(!(d>=0.0)?b+3704|0:b)>>3];i=i;return}function BO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+776>>3]- +h[b+784>>3];i=i;return}function CO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=+h[b+840>>3]+ +h[b+824>>3];i=i;return}function DO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+872>>3];k=+h[g+2480>>3]- +h[g+856>>3]*+h[g+656>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,62080,62072,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}function EO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+280>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+280|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+280>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+272>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+272|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+272>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+8>>3]=k;TFa(a,9)|0;a=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+280>>3]=+h[a>>3];h[f+272>>3]=+h[a+8>>3];i=b;return}function FO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5360>>3]=+h[f>>3];i=b;return}function GO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+808>>3],+h[j+5376>>3],+h[j+5360>>3],+h[(c[b+416>>2]|0)+1680>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+808>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,62112,62104,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5320|0;q=p;h[q>>3]=n;i=d;return}function HO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+3704>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+3704>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5352>>3]=+h[f>>3];i=b;return}function IO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5648>>3],+h[l>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5648>>3];o=+h[m>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+808>>3],+h[d+5352>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1680>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5336>>3]=+h[g>>3];i=b;return}function JO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+(+h[g+808>>3]),1.0e-15);k=+xd(+-+h[g+1840>>3],1.0e-15);l=j+k;m=j*+h[g>>3]+k*+h[g+80>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,62224,62216,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5584|0;r=q;h[r>>3]=o;i=d;return}function KO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2712>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5584>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2712>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5584>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5600>>3],+h[d+7424>>3],+h[f>>3],+h[(c[k>>2]|0)+1456>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+5616>>3]=+h[g>>3];i=b;return}function LO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5600>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5600>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2664|0;k=+h[j>>3];l=g*k;m=f;n=m+2200|0;o=n;h[o>>3]=l;i=b;return}else{j=f+5584|0;k=+h[j>>3];l=g*k;m=f;n=m+2200|0;o=n;h[o>>3]=l;i=b;return}}function MO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+5584>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+5584>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5640>>3]=+h[f>>3];i=b;return}function NO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5600>>3],+h[j+5640>>3],+h[j+7416>>3],+h[(c[b+416>>2]|0)+1456>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5600>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,62304,62296,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5592|0;q=p;h[q>>3]=n;i=d;return}function OO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5648>>3],+h[a+5584>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5648>>3];l=+h[g+5584>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5632>>3]=+h[f>>3];i=b;return}function PO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5648>>3],+h[(c[l>>2]|0)+2664>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5648>>3];n=+h[(c[l>>2]|0)+2664>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5600>>3],+h[d+5632>>3],+h[f>>3],+h[(c[l>>2]|0)+1456>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5624>>3]=+h[g>>3];i=b;return}function QO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1840>>3];h[b+1816>>3]=d*+h[(!(d>=0.0)?b+80|0:b+3872|0)>>3];i=i;return}function RO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=+h[b+1816>>3]- +h[b+1824>>3];i=i;return}function SO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+1840>>3]- +h[b+1848>>3];i=i;return}



function Gu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+16|0;c[za>>2]=13;PCa(Aa,1,za);Ba=1386.0/e;Ca=7.1-d/1653.0e4;if(!(d>611.657)){za=ACa(ACa(13080,yCa(d,0,1,6)|0)|0,12256)|0;Da=ACa(ACa(za,yCa(611.657,0,1,6)|0)|0,12264)|0;za=c[72852]|0;Ea=g;Fa=13144;c[Ea+0>>2]=c[Fa+0>>2];c[Ea+4>>2]=c[Fa+4>>2];c[Ea+8>>2]=c[Fa+8>>2];c[Ea+12>>2]=c[Fa+12>>2];c[Ea+16>>2]=c[Fa+16>>2];c[Ea+20>>2]=c[Fa+20>>2];Ne[za&127](b,g,Da,ya);}d=Ba+-1.222;c[xa>>2]=1;h[(XCa(Aa,1,xa)|0)>>3]=d*d;c[wa>>2]=1;Ga=d*+h[(XCa(Aa,1,wa)|0)>>3];c[va>>2]=2;h[(XCa(Aa,1,va)|0)>>3]=Ga;c[ua>>2]=1;Ga=+h[(XCa(Aa,1,ua)|0)>>3];c[ta>>2]=3;h[(XCa(Aa,1,ta)|0)>>3]=Ga*Ga;c[sa>>2]=3;Ga=+h[(XCa(Aa,1,sa)|0)>>3];c[ra>>2]=4;h[(XCa(Aa,1,ra)|0)>>3]=Ga*Ga;c[qa>>2]=1;Ga=+h[(XCa(Aa,1,qa)|0)>>3];c[pa>>2]=4;Ha=Ga*+h[(XCa(Aa,1,pa)|0)>>3];c[oa>>2]=5;h[(XCa(Aa,1,oa)|0)>>3]=Ha;c[na>>2]=1;Ha=+h[(XCa(Aa,1,na)|0)>>3];c[ma>>2]=3;Ga=Ha*+h[(XCa(Aa,1,ma)|0)>>3];c[la>>2]=6;h[(XCa(Aa,1,la)|0)>>3]=Ga;c[ka>>2]=3;Ga=d*+h[(XCa(Aa,1,ka)|0)>>3];c[ja>>2]=7;h[(XCa(Aa,1,ja)|0)>>3]=Ga;c[ia>>2]=3;Ga=+h[(XCa(Aa,1,ia)|0)>>3];c[ha>>2]=4;Ha=Ga*+h[(XCa(Aa,1,ha)|0)>>3];c[ga>>2]=8;h[(XCa(Aa,1,ga)|0)>>3]=Ha;c[fa>>2]=9;h[(XCa(Aa,1,fa)|0)>>3]=Ca*Ca;c[ea>>2]=9;Ha=+h[(XCa(Aa,1,ea)|0)>>3];c[da>>2]=10;h[(XCa(Aa,1,da)|0)>>3]=Ha*Ha;c[ca>>2]=10;Ha=+h[(XCa(Aa,1,ca)|0)>>3];c[ba>>2]=11;h[(XCa(Aa,1,ba)|0)>>3]=Ha*Ha;c[aa>>2]=4;Ha=+h[(XCa(Aa,1,aa)|0)>>3];c[$>>2]=12;h[(XCa(Aa,1,$)|0)>>3]=Ha*Ha;c[_>>2]=12;Ha=+h[(XCa(Aa,1,_)|0)>>3];c[Z>>2]=13;h[(XCa(Aa,1,Z)|0)>>3]=Ha*Ha;c[Y>>2]=1;Ha=+h[(XCa(Aa,1,Y)|0)>>3];c[X>>2]=1;Ga=+h[(XCa(Aa,1,X)|0)>>3]*-.00015851507390979+-.021841717175414;c[W>>2]=1;Ia=Ga*+h[(XCa(Aa,1,W)|0)>>3]+.018990068218419;c[V>>2]=6;Ga=Ha*(Ia*+h[(XCa(Aa,1,V)|0)>>3]+.00424944110961118)+-.00254871721114236;c[U>>2]=5;Ia=Ga/+h[(XCa(Aa,1,U)|0)>>3];c[T>>2]=3;Ga=+h[(XCa(Aa,1,T)|0)>>3];c[S>>2]=1;Ha=+h[(XCa(Aa,1,S)|0)>>3];c[R>>2]=1;Ja=+h[(XCa(Aa,1,R)|0)>>3];c[Q>>2]=3;Ka=+h[(XCa(Aa,1,Q)|0)>>3];c[P>>2]=4;La=Ga*(Ha*(Ja*Ka*+h[(XCa(Aa,1,P)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801;c[O>>2]=3;Ka=La/+h[(XCa(Aa,1,O)|0)>>3];c[N>>2]=5;La=+h[(XCa(Aa,1,N)|0)>>3]*-5.11230768720618e-9+.000126718579380216;c[M>>2]=7;Ja=La/+h[(XCa(Aa,1,M)|0)>>3];c[L>>2]=2;La=+h[(XCa(Aa,1,L)|0)>>3];c[K>>2]=8;Ha=La*(+h[(XCa(Aa,1,K)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20)+11212640954.0e-15;c[J>>2]=6;La=Ha/+h[(XCa(Aa,1,J)|0)>>3];c[I>>2]=9;Ha=+h[(XCa(Aa,1,I)|0)>>3];c[H>>2]=7;Ga=+h[(XCa(Aa,1,H)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[G>>2]=8;Ma=Ga/+h[(XCa(Aa,1,G)|0)>>3];c[F>>2]=10;Ga=+h[(XCa(Aa,1,F)|0)>>3];c[E>>2]=11;Na=+h[(XCa(Aa,1,E)|0)>>3];c[D>>2]=4;Oa=+h[(XCa(Aa,1,D)|0)>>3];c[C>>2]=3;Pa=Oa*+h[(XCa(Aa,1,C)|0)>>3];c[B>>2]=12;Oa=Pa*+h[(XCa(Aa,1,B)|0)>>3];c[A>>2]=1;Pa=1.9941018075704e-17/(Oa*+h[(XCa(Aa,1,A)|0)>>3]);c[z>>2]=9;Oa=+h[(XCa(Aa,1,z)|0)>>3];c[y>>2]=10;Qa=+h[(XCa(Aa,1,y)|0)>>3];c[x>>2]=9;Ra=+h[(XCa(Aa,1,x)|0)>>3];c[w>>2]=4;Sa=+h[(XCa(Aa,1,w)|0)>>3];c[v>>2]=13;Ta=4.65957282962769e-22/(Sa*+h[(XCa(Aa,1,v)|0)>>3]);c[u>>2]=4;Sa=+h[(XCa(Aa,1,u)|0)>>3];c[t>>2]=13;Ua=Sa*+h[(XCa(Aa,1,t)|0)>>3];c[s>>2]=1;Sa=Ca/(Ua*+h[(XCa(Aa,1,s)|0)>>3])*3.83502057899078e-24;c[r>>2]=4;Ua=d*+h[(XCa(Aa,1,r)|0)>>3];c[q>>2]=13;Va=Ca*(Ta+Ca*(Sa+-7.2912378325616e-23/(Ua*+h[(XCa(Aa,1,q)|0)>>3])));c[p>>2]=3;Ua=d*+h[(XCa(Aa,1,p)|0)>>3];c[o>>2]=13;Sa=Ua*+h[(XCa(Aa,1,o)|0)>>3];c[n>>2]=1;Ua=Qa*Ra*(Va+-1.00075970318621e-21/(Sa*+h[(XCa(Aa,1,n)|0)>>3]));c[m>>2]=13;Sa=Ha*Ca*(Ma+Ga*Na*Ca*(Pa+Oa*(Ua+-4.48827542684151e-19/+h[(XCa(Aa,1,m)|0)>>3])));c[l>>2]=4;Ua=Ca*(Ia+Ca*(Ka+Ca*(Ja+Ca*(La+Ca*(324135974880936.0e-20/(d*+h[(XCa(Aa,1,l)|0)>>3])+Sa)))));c[k>>2]=1;Sa=d*((d*(d*(d*(d*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(XCa(Aa,1,k)|0)>>3]+.84548187169114)+-.29265942426334;c[j>>2]=2;h[a>>3]=Ba*(Sa/+h[(XCa(Aa,1,j)|0)>>3]+Ua)*e*461.526;i=f;return}function Hu(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;j=i;i=i+144|0;k=j;l=j+24|0;m=j+112|0;n=j+136|0;o=i;i=i+8|0;p=i;i=i+88|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+88|0;y=i;i=i+48|0;z=i;i=i+16|0;do{if(d<22064.0e3){lu(q,b,d);if(+h[q>>3]+10.0>e){A=6;break}Iu(r,b,d);if(+h[r>>3]+-10.0<e){A=7;break}B=c[72852]|0;C=m;D=13168;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];c[C+16>>2]=c[D+16>>2];c[C+20>>2]=c[D+20>>2];Ne[B&127](b,m,13192,o);A=7}else{zu(s,0,d);if(+h[s>>3]>e){A=6}else{A=7}}}while(0);if((A|0)==6){uu(t,0,d,e);E=+h[t>>3];Ju(v,0,d,e);F=+h[v>>3];G=E}else if((A|0)==7){tu(u,0,d,e);E=+h[u>>3];Ku(w,0,d,e);F=+h[w>>3];G=E}w=x;u=x+8|0;A=x+16|0;v=x+24|0;t=x+32|0;s=x+40|0;o=x+48|0;m=x+56|0;r=x+64|0;q=x+72|0;B=x+80|0;D=p;C=p+8|0;H=p+16|0;I=p+24|0;J=p+32|0;K=p+40|0;L=p+48|0;M=p+56|0;N=p+64|0;O=p+72|0;P=p+80|0;Q=y;R=y+8|0;S=y+16|0;T=y+24|0;V=y+32|0;W=y+40|0;X=z;Y=z+8|0;E=G;G=1.0/F;Z=0;do{pu(x,b,G,E);F=+h[u>>3];_=+h[A>>3];$=+h[v>>3];aa=+h[t>>3];ba=+h[s>>3];ca=+h[o>>3];da=+h[m>>3];ea=+h[r>>3];fa=+h[q>>3];ga=+h[B>>3];h[D>>3]=+h[w>>3];h[C>>3]=F;h[H>>3]=_;h[I>>3]=$;h[J>>3]=aa;h[K>>3]=ba;h[L>>3]=ca;h[M>>3]=da;h[N>>3]=ea;h[O>>3]=fa;h[P>>3]=ga;ha=l+0|0;ia=p+0|0;ja=ha+88|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));ju(y,0,l);ga=+h[S>>3];fa=+h[T>>3];ea=+h[V>>3];da=+h[W>>3];ca=+h[R>>3]-e;ba=+h[Q>>3]-d;do{if(!(+U(+(ca/e))<=g)){ka=1}else{if(!(+U(+(ba/d))<=f)){ka=1;break}ka=0}}while(0);aa=ga*da-fa*ea;Z=Z+1|0;Lu(z,0,G-(ba*da-ca*fa)/aa,E-(ga*ca-ba*ea)/aa);G=+h[X>>3];E=+h[Y>>3];}while((Z|0)<50&ka);Z=ka&1;if(!ka){la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}ka=c[72852]|0;Y=k;X=13272;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];c[Y+12>>2]=c[X+12>>2];c[Y+16>>2]=c[X+16>>2];c[Y+20>>2]=c[X+20>>2];Ne[ka&127](b,k,13296,n);la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}function Iu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Xu(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));nu(b,0,0.0,f);i=e;return}function Ju(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=32;PCa(k,1,j);j=k;k=13400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=32;PCa(l,1,g);g=l;l=13416;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=32;PCa(m,1,f);f=m;m=13432;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/21.0e5+-.727;e=n*n;o=d/1.0e8+.128;d=o*n;p=o*o;q=+ADa(o,-12);r=q*+ADa(n,6)*.00529944062966028;q=+ADa(o,-12);s=q*+ADa(n,8)*-.170099690234461;q=+ADa(o,-12);t=q*+ADa(n,12)*11.1323814312927;q=+ADa(o,-12);u=q*+ADa(n,18)*-2178.98123145125;q=e*e;v=q*+ADa(o,-10)*-.000506061827980875;w=+ADa(o,-10);x=w*+ADa(n,7)*.556495239685324;w=+ADa(o,-10);y=w*+ADa(n,10)*-9.43672726094016;w=+ADa(o,-8);z=w*+ADa(n,5)*-.297856807561527;w=+ADa(o,-8);A=w*+ADa(n,12)*93.9353943717186;w=n*e;B=w*+ADa(o,-6)*.0192944939465981;C=q*+ADa(o,-6)*.421740664704763;q=+ADa(o,-6);D=q*+ADa(n,22)*-3689141.2628233;q=e*+ADa(o,-4)*-.00737566847600639;E=w*+ADa(o,-4)*-.354753242424366;F=+ADa(o,-3);G=F*+ADa(n,7)*-1.99768169338727;F=w*+ADa(o,-2)*1.15456297059049;H=+ADa(o,-2);I=H*+ADa(n,16)*5683.6687581596;H=e*+ADa(o,5)*1.10533464706142;h[a>>3]=(r+(s+(t+(u+(v+(x+(y+(z+(A+(B+(C+(D+(q+(E+(G+(F+(I+(.00808169540124668/o+(n/o*.172416341519307+(e/o*1.04270175292927+(w/o*-.297691372792847+(n*.275234661176914+(o*-.148347894866012+(d*-.0651142513478515+(o*e*-2.92468715386302+(p*.0664876096952665+(d*d*3.52335014263844+(o*p*-.0146340792313332+(p*p*e*-2.24503486668184+(H+e*+ADa(o,8)*-.0408757344495612)))))))))))))))))))))))))))))+.560394465163593)*.0028;i=b;return}function Ku(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=30;PCa(k,1,j);j=k;k=13352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=30;PCa(l,1,g);g=l;l=13368;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=30;PCa(m,1,f);f=m;m=13384;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=d/1.0e8+.0661;d=n*n;o=e*n;p=-2.25196934336318e-9/+ADa(e,12);q=n*+ADa(e,-12)*1.40674363313486e-8;r=23378408528056.0e-19/+ADa(e,8);s=n*+ADa(e,-8)*-331833715229001.0e-19;t=n*d;u=t*+ADa(e,-8)*.00107956778514318;v=+ADa(e,-8);w=v*+ADa(n,6)*-.271382067378863;v=+ADa(e,-8);x=v*+ADa(n,7)*1.07202262490333;v=+ADa(e,-8);y=v*+ADa(n,8)*-.853821329075382;v=-215214194340526.0e-19/+ADa(e,6);z=n*+ADa(e,-6)*.00076965608822273;A=d*+ADa(e,-6)*-.00431136580433864;B=+ADa(e,-6);C=B*+ADa(n,5)*.453342167309331;B=+ADa(e,-6);D=B*+ADa(n,6)*-.507749535873652;B=+ADa(e,-6);E=B*+ADa(n,10)*-100.475154528389;B=t*+ADa(e,-4)*-.219201924648793;t=+ADa(e,-4);F=t*+ADa(n,6)*-3.21087965668917;t=+ADa(e,-4);G=t*+ADa(n,10)*607.567815637771;t=e*e;H=d*+ADa(e,-3)*.18749904002955;I=n*+ADa(e,-2)*.00905368030448107;J=d*+ADa(e,-2)*.285417173048685;K=+ADa(n,5)/e*-11.8035753702231;h[a>>3]=(p+(q+(r+(s+(u+(w+(x+(y+(v+(z+(A+(C+(D+(E+(B+(F+(G+(.000557686450685932/(e*t)+(H+(I+(J+(.0329924030996098/e+(n/e*.239897419685483+(d*d/e*4.82754995951394+(K+(e*-.0179967222507787+(o*.0371810116332674+(o*o*-.0536288335065096+t*+ADa(n,6)*1.6069710109252)))))))))))))))))))))))))))+.169490044091791)*.0088;i=b;return}function Lu(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0;b=i;do{if(c>765.0){e=765.0;f=4}else{g=c<110.0?110.0:c;if(!(g<390.0)){e=g;f=4;break}j=g*.809344262+554.3557377;k=g}}while(0);if((f|0)==4){j=e*-.632948717+1116.85;k=e}e=k+-322.0;c=e*e;if(k<322.0){l=c/1.0e6}else{l=c/144.0e4}c=(1.0-l)*647.096;if(c>d){m=c}else{m=j<d?j:d}h[a>>3]=k;h[a+8>>3]=m;i=b;return}function Mu(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=ACa(ACa(13448,yCa(d,0,1,6)|0)|0,13520)|0;H=ACa(ACa(G,yCa(16529200.0,0,1,6)|0)|0,13528)|0;G=c[72852]|0;I=n;J=13536;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];Ne[G&127](b,n,H,r);}if(!(e>=623.15)){r=ACa(ACa(13560,yCa(e,0,1,6)|0)|0,13632)|0;H=ACa(ACa(r,yCa(623.15,0,1,6)|0)|0,13640)|0;r=c[72852]|0;n=m;G=13648;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];Ne[r&127](b,m,H,q);}Nu(t,0,e);if(!(+h[t>>3]<=d)){t=ACa(ACa(13672,yCa(d,0,1,6)|0)|0,13744)|0;q=ACa(ACa(t,yCa(e,0,1,6)|0)|0,13640)|0;t=c[72852]|0;H=l;m=13760;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];Ne[t&127](b,l,q,p);}Ou(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];Pu(v,0,d);L=+h[v>>3];Qu(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{Au(x,b,d);if(+h[x>>3]>e){Pu(y,0,d);M=+h[y>>3];Bu(z,0,d);L=+h[z>>3];Ru(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{Su(B,0,d);L=+h[B>>3];Qu(C,0,d);M=+h[C>>3];Tu(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){pu(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));ku(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[72852]|0;S=j;R=13784;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];Ne[fa&127](b,j,13808,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function Nu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;PCa(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function Ou(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;PCa(k,1,j);j=k;k=13944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=ACa(ACa(13960,yCa(d,0,1,6)|0)|0,12256)|0;j=ACa(ACa(k,yCa(611.657,0,1,6)|0)|0,12264)|0;k=c[72852]|0;s=f;t=14032;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];Ne[k&127](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function Pu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;PCa(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(XCa(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(XCa(s,1,p)|0)>>3];c[o>>2]=2;h[(XCa(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(XCa(s,1,n)|0)>>3];c[m>>2]=3;h[(XCa(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(XCa(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(XCa(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(XCa(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(XCa(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(XCa(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(XCa(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function Qu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;PCa(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(XCa(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(XCa(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(XCa(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(XCa(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(XCa(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(XCa(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(XCa(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(XCa(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(XCa(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(XCa(La,1,Aa)|0)>>3];c[za>>2]=6;h[(XCa(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(XCa(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(XCa(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(XCa(La,1,wa)|0)>>3];c[va>>2]=7;h[(XCa(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(XCa(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(XCa(La,1,ta)|0)>>3];c[sa>>2]=8;h[(XCa(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(XCa(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(XCa(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(XCa(La,1,pa)|0)>>3];c[oa>>2]=9;h[(XCa(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(XCa(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(XCa(La,1,ma)|0)>>3];c[la>>2]=11;h[(XCa(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(XCa(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(XCa(La,1,ja)|0)>>3];c[ia>>2]=12;h[(XCa(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(XCa(La,1,ha)|0)>>3];c[ga>>2]=13;h[(XCa(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(XCa(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(XCa(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(XCa(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(XCa(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(XCa(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(XCa(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(XCa(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(XCa(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(XCa(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(XCa(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(XCa(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(XCa(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(XCa(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(XCa(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(XCa(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(XCa(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(XCa(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(XCa(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(XCa(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(XCa(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(XCa(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(XCa(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(XCa(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(XCa(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(XCa(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(XCa(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(XCa(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(XCa(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(XCa(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(XCa(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(XCa(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(XCa(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(XCa(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(XCa(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(XCa(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(XCa(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(XCa(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(XCa(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(XCa(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(XCa(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(XCa(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(XCa(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(XCa(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(XCa(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(XCa(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(XCa(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(XCa(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(XCa(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(XCa(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(XCa(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(XCa(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(XCa(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(XCa(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function Ru(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;ou(e,b,c);j=+h[e>>3];do{if(c<623.15){Wu(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Bu(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Su(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Tu(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;ou(e,b,c);j=+h[e>>3];do{if(c<623.15){Vu(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Su(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Uu(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+88|0;m=l+32|0;n=l+64|0;o=l+72|0;p=1500.0;q=0;do{yu(l,b,d,p);r=+h[m>>3];s=p*r*+h[n>>3]*461.526-e;t=+U(+(s/e))<f;p=p-s/(r*r*+h[o>>3]*-461.526);q=q+1|0;u=t^1;}while((q|0)<50&u);q=u&1;if(t){v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}t=c[72852]|0;u=j;o=13864;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];Ne[t&127](b,j,13888,k);v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}function Vu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;PCa(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(XCa(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(XCa(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(XCa(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(XCa(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(XCa(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(XCa(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(XCa(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(XCa(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(XCa(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(XCa(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(XCa(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(XCa(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(XCa(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(XCa(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(XCa(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(XCa(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(XCa(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(XCa(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(XCa(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(XCa(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(XCa(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(XCa(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(XCa(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(XCa(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(XCa(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(XCa(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(XCa(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(XCa(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(XCa(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(XCa(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(XCa(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(XCa(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(XCa(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(XCa(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(XCa(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(XCa(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(XCa(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(XCa(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(XCa(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(XCa(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(XCa(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(XCa(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(XCa(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(XCa(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(XCa(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(XCa(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(XCa(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(XCa(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(XCa(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(XCa(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(XCa(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(XCa(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(XCa(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(XCa(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(XCa(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(XCa(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(XCa(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(XCa(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(XCa(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(XCa(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(XCa(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(XCa(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(XCa(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(XCa(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(XCa(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(XCa(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(XCa(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(XCa(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(XCa(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(XCa(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(XCa(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(XCa(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(XCa(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(XCa(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(XCa(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(XCa(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(XCa(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(XCa(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(XCa(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(XCa(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(XCa(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function Wu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;PCa(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(XCa(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(XCa(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(XCa(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(XCa(ta,1,oa)|0)>>3];c[na>>2]=3;h[(XCa(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(XCa(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(XCa(ta,1,la)|0)>>3];c[ka>>2]=4;h[(XCa(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(XCa(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(XCa(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(XCa(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(XCa(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(XCa(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(XCa(ta,1,ea)|0)>>3];c[da>>2]=8;h[(XCa(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(XCa(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(XCa(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(XCa(ta,1,aa)|0)>>3];c[$>>2]=10;h[(XCa(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(XCa(ta,1,_)|0)>>3];c[Z>>2]=11;h[(XCa(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(XCa(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(XCa(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(XCa(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(XCa(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(XCa(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(XCa(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(XCa(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(XCa(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(XCa(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(XCa(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(XCa(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(XCa(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(XCa(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(XCa(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(XCa(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(XCa(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(XCa(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(XCa(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(XCa(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(XCa(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(XCa(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(XCa(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(XCa(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(XCa(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(XCa(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(XCa(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(XCa(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(XCa(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(XCa(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(XCa(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(XCa(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(XCa(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(XCa(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(XCa(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(XCa(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(XCa(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(XCa(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(XCa(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(XCa(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(XCa(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(XCa(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(XCa(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(XCa(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(XCa(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function Xu(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+wd(+d,22063999.9999999);Au(f,c,o);p=+h[f>>3];vu(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){Su(k,0,o);r=+h[k>>3];pu(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];Yu(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{wu(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+ADa(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function Yu(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*.0006616936460057692+-16.98555442961553)+45.66489164833212)+-48.38215180269516)+25.08887602293532)+-6.084122698421623)+.2079670746250689)+.4880153718655694)+1.0)*2087546.84511715;i=i;return}function Zu(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0;j=i;i=i+104|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=j+32|0;p=j+40|0;q=j+48|0;r=j+56|0;s=j+64|0;t=j+72|0;u=j+80|0;v=j+88|0;w=j+96|0;do{if((g|0)==0){lu(k,b,d);x=+h[k>>3];Iu(l,b,d);y=+h[l>>3];if((f|0)==2){z=4;break}_u(m,b,d);A=+h[m>>3];$u(n,b,d);B=+h[n>>3];av(o,b,d);if(d<611.657|d>1.0e8|A>e){z=-1;break}C=d<1.0e7;if(C&B<e){z=-1;break}if(d>=1.0e7&+h[o>>3]<e){z=-1;break}D=e<2087546.84511715;if(!(d<16529200.0)){if(D){cv(v,b,d);if(+h[v>>3]>e){z=1;break}z=x>e|d>22064.0e3?3:4;break}else{dv(w,b,d);if(+h[w>>3]<e){z=2;break}z=y<e|d>22064.0e3?3:4;break}}if(D){if((f|0)==1){z=1;break}Au(p,b,d);Gu(q,b,d,+h[p>>3]);z=+h[q>>3]>e?1:4;break}bv(r,b,d);if(!(+h[r>>3]<e)){if((f|0)==1){z=2;break}Au(t,b,d);Fu(u,b,d,+h[t>>3]);z=+h[u>>3]<e?2:4;break}$u(s,b,d);if(C){if(+h[s>>3]>e){z=5;break}}z=-2}else{z=g}}while(0);c[a>>2]=z;i=j;return}function _u(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;PCa(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=ACa(ACa(14248,yCa(d,0,1,6)|0)|0,12256)|0;x=ACa(ACa(u,yCa(611.657,0,1,6)|0)|0,12264)|0;u=c[72852]|0;y=f;z=14320;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Ne[u&127](b,f,x,t);}c[s>>2]=1;h[(XCa(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(XCa(v,1,r)|0)>>3];c[q>>2]=2;h[(XCa(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(XCa(v,1,p)|0)>>3];c[o>>2]=3;h[(XCa(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(XCa(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(XCa(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(XCa(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(XCa(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(XCa(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*9.64504638626269e-49+-7.06381628462585e-47)+1.73894459122923e-45)+-1.43870236842915e-44)*+h[(XCa(v,1,g)|0)>>3]+-8.12140581014818e-38)+5.35429206228374e-35)+8.43755552264362e-14)+1.73545618580828e-11)+-2.41630417490008e-7)+-418695814670391.0e-20)+-.00017146768241932)+-.022914084306349)+.173379420894777)*639675.036;i=e;return}function $u(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=ACa(ACa(14440,yCa(d,0,1,6)|0)|0,12256)|0;u=ACa(ACa(t,yCa(611.657,0,1,6)|0)|0,12264)|0;t=c[72852]|0;v=f;w=14512;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Ne[t&127](b,f,u,g);k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function av(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;c[p>>2]=2;PCa(q,1,p);r=d/1.0e6;if(!(d>611.657)){p=ACa(ACa(14536,yCa(d,0,1,6)|0)|0,12256)|0;s=ACa(ACa(p,yCa(611.657,0,1,6)|0)|0,12264)|0;p=c[72852]|0;t=f;u=14608;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Ne[p&127](b,f,s,o);}c[n>>2]=1;h[(XCa(q,1,n)|0)>>3]=r*r;c[m>>2]=1;d=+h[(XCa(q,1,m)|0)>>3];c[l>>2]=2;h[(XCa(q,1,l)|0)>>3]=d*d*d;c[k>>2]=1;d=+h[(XCa(q,1,k)|0)>>3];c[j>>2]=1;v=d*((r*(r*(r*(r*1.88543121025106e-84+-1.76117969553159e-103)+8.06630589170884e-129)+-3.71600586812966e-69)+1.6746290980312e-65)*+h[(XCa(q,1,j)|0)>>3]+-8.00969737237617e-134)+-7.5656940729795e-74;c[g>>2]=2;h[a>>3]=r*(r*(r*(r*(r*(r*(r*(r*(r*(r*(+h[(XCa(q,1,g)|0)>>3]*v+3.37267475986401e-21)+7.16825117265975e-32)+7.56960433802525e-23)+-3.79407294691742e-25)+-1.27295130636232e-10)+4.2261295097284e-15)+-.000172486052272327)+.109090430596056)+-8.53409968320258)+-4518.48617188327)+4160663.37647071;i=e;return}function bv(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=ACa(ACa(14344,yCa(d,0,1,6)|0)|0,12256)|0;u=ACa(ACa(t,yCa(611.657,0,1,6)|0)|0,12264)|0;t=c[72852]|0;v=f;w=14416;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Ne[t&127](b,f,u,g);k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function cv(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;PCa(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=ACa(ACa(14056,yCa(d,0,1,6)|0)|0,12256)|0;x=ACa(ACa(u,yCa(611.657,0,1,6)|0)|0,12264)|0;u=c[72852]|0;y=f;z=14128;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Ne[u&127](b,f,x,t);}c[s>>2]=1;h[(XCa(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(XCa(v,1,r)|0)>>3];c[q>>2]=2;h[(XCa(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(XCa(v,1,p)|0)>>3];c[o>>2]=3;h[(XCa(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(XCa(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(XCa(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(XCa(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(XCa(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(XCa(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*3.49930466305574e-24+-6.66749357417962e-23)+4.27026404402408e-22)+-9.19148577641497e-22)*+h[(XCa(v,1,g)|0)>>3]+-4.18568363667416e-19)+1.86779322717506e-17)+1.46754947271665e-8)+317834967400818.0e-20)+123617764767172.0e-19)+.000125338925082983)+.00143759406818289)+-.00141131225285294)+2.42896927729349)*639675.036;i=e;return}function dv(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;c[Eb>>2]=18;PCa(Fb,1,Eb);Gb=d/1.0e6;if(!(d>611.657)){Eb=ACa(ACa(14152,yCa(d,0,1,6)|0)|0,12256)|0;Hb=ACa(ACa(Eb,yCa(611.657,0,1,6)|0)|0,12264)|0;Eb=c[72852]|0;Ib=f;Jb=14224;c[Ib+0>>2]=c[Jb+0>>2];c[Ib+4>>2]=c[Jb+4>>2];c[Ib+8>>2]=c[Jb+8>>2];c[Ib+12>>2]=c[Jb+12>>2];c[Ib+16>>2]=c[Jb+16>>2];c[Ib+20>>2]=c[Jb+20>>2];Ne[Eb&127](b,f,Hb,Db);}d=+V(+(Gb+-13.91883977887))*31.3220101646784+572.54459862746;Kb=540.0/d+-.5;c[Cb>>2]=1;h[(XCa(Fb,1,Cb)|0)>>3]=d*d;c[Bb>>2]=1;Lb=+h[(XCa(Fb,1,Bb)|0)>>3];c[Ab>>2]=2;h[(XCa(Fb,1,Ab)|0)>>3]=Lb*Lb;c[zb>>2]=2;Lb=+h[(XCa(Fb,1,zb)|0)>>3];c[yb>>2]=3;h[(XCa(Fb,1,yb)|0)>>3]=Lb*Lb;c[xb>>2]=4;h[(XCa(Fb,1,xb)|0)>>3]=Gb*Gb;c[wb>>2]=4;Lb=+h[(XCa(Fb,1,wb)|0)>>3];c[vb>>2]=5;h[(XCa(Fb,1,vb)|0)>>3]=Lb*Lb;c[ub>>2]=6;h[(XCa(Fb,1,ub)|0)>>3]=Kb*Kb;c[tb>>2]=6;Lb=+h[(XCa(Fb,1,tb)|0)>>3];c[sb>>2]=7;h[(XCa(Fb,1,sb)|0)>>3]=Lb*Lb;c[rb>>2]=6;Lb=+h[(XCa(Fb,1,rb)|0)>>3];c[qb>>2]=7;Mb=Lb*+h[(XCa(Fb,1,qb)|0)>>3];c[pb>>2]=8;h[(XCa(Fb,1,pb)|0)>>3]=Mb;c[ob>>2]=5;Mb=+h[(XCa(Fb,1,ob)|0)>>3];c[nb>>2]=9;h[(XCa(Fb,1,nb)|0)>>3]=Mb*Mb;c[mb>>2]=7;Mb=+h[(XCa(Fb,1,mb)|0)>>3];c[lb>>2]=10;h[(XCa(Fb,1,lb)|0)>>3]=Mb*Mb;c[kb>>2]=9;Mb=+h[(XCa(Fb,1,kb)|0)>>3];c[jb>>2]=11;h[(XCa(Fb,1,jb)|0)>>3]=Mb*Mb;c[ib>>2]=10;Mb=+h[(XCa(Fb,1,ib)|0)>>3];c[hb>>2]=12;h[(XCa(Fb,1,hb)|0)>>3]=Mb*Mb;c[gb>>2]=12;Mb=+h[(XCa(Fb,1,gb)|0)>>3];c[fb>>2]=13;h[(XCa(Fb,1,fb)|0)>>3]=Mb*Mb;c[eb>>2]=7;Mb=Kb*+h[(XCa(Fb,1,eb)|0)>>3];c[db>>2]=14;h[(XCa(Fb,1,db)|0)>>3]=Mb;c[cb>>2]=6;Mb=Kb*+h[(XCa(Fb,1,cb)|0)>>3];c[bb>>2]=15;h[(XCa(Fb,1,bb)|0)>>3]=Mb;c[ab>>2]=10;Mb=+h[(XCa(Fb,1,ab)|0)>>3];c[$a>>2]=6;Lb=Mb*+h[(XCa(Fb,1,$a)|0)>>3];c[_a>>2]=16;h[(XCa(Fb,1,_a)|0)>>3]=Lb;c[Za>>2]=13;Lb=+h[(XCa(Fb,1,Za)|0)>>3];c[Ya>>2]=6;Mb=Lb*+h[(XCa(Fb,1,Ya)|0)>>3];c[Xa>>2]=17;h[(XCa(Fb,1,Xa)|0)>>3]=Mb;c[Wa>>2]=13;Mb=+h[(XCa(Fb,1,Wa)|0)>>3];c[Va>>2]=6;Lb=Mb*Kb*+h[(XCa(Fb,1,Va)|0)>>3];c[Ua>>2]=18;h[(XCa(Fb,1,Ua)|0)>>3]=Lb;c[Ta>>2]=2;Lb=+h[(XCa(Fb,1,Ta)|0)>>3]*3.74686560065793;c[Sa>>2]=1;Mb=+h[(XCa(Fb,1,Sa)|0)>>3];c[Ra>>2]=2;Nb=Mb*+h[(XCa(Fb,1,Ra)|0)>>3]*357966647812489.0e-20;c[Qa>>2]=3;Mb=+h[(XCa(Fb,1,Qa)|0)>>3]*2.81881548488163e-13;c[Pa>>2]=2;Ob=d*+h[(XCa(Fb,1,Pa)|0)>>3]*-.00450789338787835;c[Oa>>2]=1;Pb=+h[(XCa(Fb,1,Oa)|0)>>3];c[Na>>2]=2;Qb=Pb*d*+h[(XCa(Fb,1,Na)|0)>>3]*-1.55131504410292e-9;c[Ma>>2]=1;Pb=+h[(XCa(Fb,1,Ma)|0)>>3];c[La>>2]=10;Rb=+h[(XCa(Fb,1,La)|0)>>3];c[Ka>>2]=11;Sb=+h[(XCa(Fb,1,Ka)|0)>>3];c[Ja>>2]=12;Tb=+h[(XCa(Fb,1,Ja)|0)>>3];c[Ia>>2]=13;Ub=+h[(XCa(Fb,1,Ia)|0)>>3];c[Ha>>2]=4;Vb=Rb*Sb*Tb*Ub*+h[(XCa(Fb,1,Ha)|0)>>3]*-4781981.98764471;c[Ga>>2]=11;Ub=+h[(XCa(Fb,1,Ga)|0)>>3];c[Fa>>2]=12;Tb=+h[(XCa(Fb,1,Fa)|0)>>3];c[Ea>>2]=13;Sb=+h[(XCa(Fb,1,Ea)|0)>>3];c[Da>>2]=4;Rb=+h[(XCa(Fb,1,Da)|0)>>3];c[Ca>>2]=5;Wb=+h[(XCa(Fb,1,Ca)|0)>>3];c[Ba>>2]=7;Xb=Ub*Tb*Sb*Rb*Wb*+h[(XCa(Fb,1,Ba)|0)>>3]*49.9651389369988;c[Aa>>2]=15;Wb=+h[(XCa(Fb,1,Aa)|0)>>3];c[za>>2]=4;Rb=+h[(XCa(Fb,1,za)|0)>>3];c[ya>>2]=16;Sb=+h[(XCa(Fb,1,ya)|0)>>3]*-.00349547959376899;c[xa>>2]=8;Tb=Sb+ +h[(XCa(Fb,1,xa)|0)>>3]*-2.55074501962569e-7+1.03746636552761e-13;c[wa>>2]=9;Sb=Wb*Rb*+h[(XCa(Fb,1,wa)|0)>>3]*Tb;c[va>>2]=10;Tb=+h[(XCa(Fb,1,va)|0)>>3];c[ua>>2]=12;Rb=Tb*+h[(XCa(Fb,1,ua)|0)>>3]*-242662.235426958;c[ta>>2]=16;Tb=Rb+ +h[(XCa(Fb,1,ta)|0)>>3]*-3.46022402653609;c[sa>>2]=4;Rb=+h[(XCa(Fb,1,sa)|0)>>3];c[ra>>2]=5;Wb=Tb*Rb*Gb*+h[(XCa(Fb,1,ra)|0)>>3];c[qa>>2]=4;Rb=+h[(XCa(Fb,1,qa)|0)>>3];c[pa>>2]=14;Tb=+h[(XCa(Fb,1,pa)|0)>>3]*-2248.08924686956;c[oa>>2]=17;Ub=+h[(XCa(Fb,1,oa)|0)>>3]*-354742.725841972;c[na>>2]=6;Yb=Rb*Gb*(Tb+(Ub+ +h[(XCa(Fb,1,na)|0)>>3]*-24.1331193696374)+.109336249381227);c[ma>>2]=11;Ub=+h[(XCa(Fb,1,ma)|0)>>3];c[la>>2]=12;Tb=+h[(XCa(Fb,1,la)|0)>>3];c[ka>>2]=5;Rb=+h[(XCa(Fb,1,ka)|0)>>3];c[ja>>2]=7;Zb=Ub*Tb*Rb*Gb*+h[(XCa(Fb,1,ja)|0)>>3]*-3.09081828396912e-19;c[ia>>2]=11;Rb=+h[(XCa(Fb,1,ia)|0)>>3];c[ha>>2]=13;Tb=+h[(XCa(Fb,1,ha)|0)>>3];c[ga>>2]=4;Ub=+h[(XCa(Fb,1,ga)|0)>>3];c[fa>>2]=5;_b=+h[(XCa(Fb,1,fa)|0)>>3];c[ea>>2]=6;$b=+h[(XCa(Fb,1,ea)|0)>>3];c[da>>2]=7;ac=Rb*Tb*Ub*_b*$b*Gb*+h[(XCa(Fb,1,da)|0)>>3]*-1.24107527851371e-8;c[ca>>2]=5;$b=+h[(XCa(Fb,1,ca)|0)>>3];c[ba>>2]=8;_b=$b*Gb*+h[(XCa(Fb,1,ba)|0)>>3]*3.99891272904219;c[aa>>2]=10;$b=+h[(XCa(Fb,1,aa)|0)>>3];c[$>>2]=7;Ub=+h[(XCa(Fb,1,$)|0)>>3];c[_>>2]=9;Tb=$b*Ub*Gb*+h[(XCa(Fb,1,_)|0)>>3]*.0641817365250892;c[Z>>2]=14;Ub=+h[(XCa(Fb,1,Z)|0)>>3]*-75253.6156722047;c[Y>>2]=6;$b=Gb*(Ub+(Kb*-22926.6247146068+ +h[(XCa(Fb,1,Y)|0)>>3]*-43051.9020511789)+-4444.87643334512);c[X>>2]=4;Ub=+h[(XCa(Fb,1,X)|0)>>3];c[W>>2]=15;Gb=+h[(XCa(Fb,1,W)|0)>>3]*-3927.0508365636;c[U>>2]=18;Rb=+h[(XCa(Fb,1,U)|0)>>3]*-239.325789467604;c[T>>2]=8;bc=Ub*(Gb+(Rb+(Kb*-94.4508644545118+ +h[(XCa(Fb,1,T)|0)>>3]*-76407.3727417716))+-8.23252840892034);c[S>>2]=5;Rb=(Kb+-.0161221195808321)*(Kb+.0338039844460968)*+h[(XCa(Fb,1,S)|0)>>3]*.360567666582363;c[R>>2]=11;Gb=+h[(XCa(Fb,1,R)|0)>>3];c[Q>>2]=10;Ub=+h[(XCa(Fb,1,Q)|0)>>3];c[P>>2]=12;cc=+h[(XCa(Fb,1,P)|0)>>3];c[O>>2]=7;dc=Ub*cc*+h[(XCa(Fb,1,O)|0)>>3]*-.000584580992538624;c[N>>2]=12;cc=+h[(XCa(Fb,1,N)|0)>>3];c[M>>2]=13;Ub=Gb*(dc+cc*Kb*+h[(XCa(Fb,1,M)|0)>>3]*1332480.30241755);c[L>>2]=9;cc=+h[(XCa(Fb,1,L)|0)>>3];c[K>>2]=18;dc=+h[(XCa(Fb,1,K)|0)>>3]*-73850273.6990986;c[J>>2]=6;Gb=+h[(XCa(Fb,1,J)|0)>>3];c[I>>2]=7;ec=cc*(dc+Gb*Kb*+h[(XCa(Fb,1,I)|0)>>3]*224425477627799.0e-19);c[H>>2]=4;Gb=+h[(XCa(Fb,1,H)|0)>>3];c[G>>2]=5;dc=+h[(XCa(Fb,1,G)|0)>>3];c[F>>2]=17;cc=+h[(XCa(Fb,1,F)|0)>>3]*-208438767.026518;c[E>>2]=6;fc=+h[(XCa(Fb,1,E)|0)>>3]*-124971648677697.0e-19;c[D>>2]=10;gc=+h[(XCa(Fb,1,D)|0)>>3];c[C>>2]=6;hc=+h[(XCa(Fb,1,C)|0)>>3];c[B>>2]=7;ic=Gb*dc*(cc+(fc+gc*hc*Kb*+h[(XCa(Fb,1,B)|0)>>3]*-8442.30378348203));c[A>>2]=11;hc=+h[(XCa(Fb,1,A)|0)>>3];c[z>>2]=9;gc=+h[(XCa(Fb,1,z)|0)>>3];c[y>>2]=10;fc=+h[(XCa(Fb,1,y)|0)>>3];c[x>>2]=12;cc=fc*Kb*+h[(XCa(Fb,1,x)|0)>>3]*4.73594929247646e-22;c[w>>2]=10;fc=+h[(XCa(Fb,1,w)|0)>>3];c[v>>2]=12;dc=+h[(XCa(Fb,1,v)|0)>>3];c[u>>2]=13;Gb=fc*dc*Kb*+h[(XCa(Fb,1,u)|0)>>3]*-13.6411358215175;c[t>>2]=13;dc=+h[(XCa(Fb,1,t)|0)>>3];c[s>>2]=6;fc=+h[(XCa(Fb,1,s)|0)>>3];c[r>>2]=7;jc=gc*(cc+(Gb+dc*fc*Kb*+h[(XCa(Fb,1,r)|0)>>3]*5.52427169406836e-10));c[q>>2]=5;fc=+h[(XCa(Fb,1,q)|0)>>3];c[p>>2]=17;dc=+h[(XCa(Fb,1,p)|0)>>3]*267174673301715.0e-20;c[o>>2]=12;Gb=+h[(XCa(Fb,1,o)|0)>>3];c[n>>2]=6;cc=Gb*Kb*+h[(XCa(Fb,1,n)|0)>>3]*4.44545133805865e-18;c[m>>2]=10;Gb=+h[(XCa(Fb,1,m)|0)>>3];c[l>>2]=13;gc=+h[(XCa(Fb,1,l)|0)>>3];c[k>>2]=6;kc=+h[(XCa(Fb,1,k)|0)>>3];c[j>>2]=7;lc=Lb+(Nb+(Mb+(d*-76465233.2452145+(Ob+(Qb+Pb*(Vb+(Xb+(Sb+(Wb+(Yb+(Zb+(ac+(_b+(Tb+($b+(bc+(Rb+(Ub+(ec+(ic+hc*(jc+fc*(dc+(cc+Gb*gc*kc*Kb*+h[(XCa(Fb,1,j)|0)>>3]*-50.2465185106411)))))))))))))))))+2513837.07870341))))))+4636975733.03507;c[g>>2]=1;h[a>>3]=lc/+h[(XCa(Fb,1,g)|0)>>3];i=e;return}function ev(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}Au(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}Ou(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function fv(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0;j=i;i=i+536|0;k=j;l=j+24|0;m=j+48|0;n=j+112|0;o=j+176|0;p=j+264|0;q=j+352|0;r=j+440|0;s=j+528|0;t=i;i=i+8|0;u=i;i=i+64|0;v=i;i=i+64|0;w=i;i=i+88|0;x=i;i=i+88|0;y=i;i=i+88|0;z=i;i=i+88|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+88|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+24|0;G=i;i=i+88|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+88|0;M=i;i=i+88|0;N=i;i=i+64|0;O=i;i=i+64|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+88|0;T=i;i=i+88|0;V=i;i=i+64|0;W=i;i=i+64|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+16|0;_=i;i=i+88|0;do{if((g|0)==0){if((f|0)==2){$=+xd(+d,611.657);aa=+xd(+e,1.0e3);ba=$;ca=2;da=11;break}else{Zu(A,b,d,e,f,0);ea=c[A>>2]|0;da=5;break}}else{ea=g;da=5}}while(0);a:do{if((da|0)==5){if((f|0)==0){fa=(ea|0)==4?2:1}else{fa=f}$=+xd(+d,611.657);ga=+xd(+e,1.0e3);switch(ea|0){case 1:{Du(B,b,$,ga);ha=+h[B>>3];xu(C,b,d,ha);ia=+h[C+24>>3];ja=+h[C+32>>3];ka=+h[C+48>>3];la=+h[C+56>>3];ma=+h[C+72>>3];na=+h[C+80>>3];oa=(ja*+h[C+64>>3]- +h[C+40>>3])*461.526;pa=ia*ka;qa=(pa-ja*ia*na)/d*461.526;ra=ha*ia*ia*la*+ADa(d,-2)*461.526;ia=ja*ja*ma;ma=ka-ja*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=qa;xa=ra;ya=0.0;za=-qa/ra;Aa=ha;Ba=ga;Ca=ia*-461.526;Da=(ma*ma/la-ia)*461.526;Ea=d/(ha*pa*461.526);Fa=oa;Ga=1;break a;break};case 4:{aa=ga;ba=$;ca=fa;da=11;break a;break};case 2:{Eu(D,0,$,ga);oa=+h[D>>3];wu(E,b,d,oa);pa=+h[E+24>>3];ha=+h[E+32>>3];ia=+h[E+48>>3];la=+h[E+56>>3];ma=+h[E+72>>3];ra=+h[E+80>>3];qa=(ha*+h[E+64>>3]- +h[E+40>>3])*461.526;na=pa*ia;ja=(na-ha*pa*ra)/d*461.526;ka=oa*pa*pa*la*+ADa(d,-2)*461.526;pa=ha*ha*ma;ma=ia-ha*ra;sa=$;ta=fa;ua=0.0;va=0.0;wa=ja;xa=ka;ya=1.0;za=-ja/ka;Aa=oa;Ba=ga;Ca=pa*-461.526;Da=(ma*ma/la-pa)*461.526;Ea=d/(oa*na*461.526);Fa=qa;Ga=2;break a;break};case 3:{Hu(F,b,$,ga,1.0e-7,1.0e-6);qa=+h[F>>3];na=+h[F+8>>3];pu(G,b,qa,na);oa=+h[G+24>>3];pa=+h[G+32>>3];la=+h[G+48>>3];ma=pa*+h[G+64>>3];ka=na*oa*(la*2.0+oa*+h[G+56>>3])*461.526;ja=qa*oa*(la-pa*+h[G+80>>3])*461.526;ra=+U(+(pa*pa*+h[G+72>>3]*-461.526));pa=qa*qa;sa=$;ta=fa;ua=ja;va=ka;wa=0.0;xa=0.0;ya=0.0;za=ja;Aa=na;Ba=na*(oa*la+ma)*461.526;Ca=(pa*ra*ka+na*ja*ja)/(pa*ka);Da=ra;Ea=qa;Fa=(ma- +h[G+40>>3])*461.526;Ga=3;break a;break};case 5:{Uu(Z,b,$,ga,1.0e-7);ma=+h[Z>>3];if((c[Z+8>>2]|0)!=0){g=c[72852]|0;A=l;Ha=14632;c[A+0>>2]=c[Ha+0>>2];c[A+4>>2]=c[Ha+4>>2];c[A+8>>2]=c[Ha+8>>2];c[A+12>>2]=c[Ha+12>>2];c[A+16>>2]=c[Ha+16>>2];c[A+20>>2]=c[Ha+20>>2];Ne[g&127](b,l,14656,t);}yu(_,b,$,ma);qa=+h[_+24>>3];ra=+h[_+32>>3];ka=+h[_+48>>3];pa=+h[_+56>>3];ja=+h[_+72>>3];na=+h[_+80>>3];la=(ra*+h[_+64>>3]- +h[_+40>>3])*461.526;oa=qa*ka;ha=(oa-ra*qa*na)/d*461.526;ia=ma*qa*qa*pa*+ADa(d,-2)*461.526;qa=ra*ra*ja;ja=ka-ra*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=ha;xa=ia;ya=0.0;za=-ha/ia;Aa=ma;Ba=ga;Ca=qa*-461.526;Da=(ja*ja/pa-qa)*461.526;Ea=d/(ma*oa*461.526);Fa=la;Ga=5;break a;break};default:{g=ACa(ACa(ACa(ACa(14704,yCa(d,0,1,6)|0)|0,14760)|0,yCa(e,0,1,6)|0)|0,14768)|0;Ha=c[72852]|0;A=k;Ia=14776;c[A+0>>2]=c[Ia+0>>2];c[A+4>>2]=c[Ia+4>>2];c[A+8>>2]=c[Ia+8>>2];c[A+12>>2]=c[Ia+12>>2];c[A+16>>2]=c[Ia+16>>2];c[A+20>>2]=c[Ia+20>>2];Ne[Ha&127](b,k,g,s);sa=$;ta=fa;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0;Ba=ga;Ca=0.0;Da=0.0;Ea=0.0;Fa=0.0;Ga=ea;break a}}}}while(0);if((da|0)==11){gv(H,b,d);ga=+h[H>>3];hv(I,b,d);$=+h[I>>3];if($!=ga){Ja=(e-ga)/($-ga)}else{Ja=1.0}if(d<16529200.0){Du(J,b,ba,ga);ga=+h[J>>3];Eu(K,0,ba,$);$=+h[K>>3];xu(L,b,ba,ga);e=+h[L+8>>3];la=+h[L+16>>3];oa=+h[L+24>>3];ma=+h[L+32>>3];qa=+h[L+40>>3];pa=+h[L+48>>3];ja=+h[L+56>>3];ia=+h[L+64>>3];ha=+h[L+72>>3];na=+h[L+80>>3];h[w>>3]=+h[L>>3];h[w+8>>3]=e;h[w+16>>3]=la;h[w+24>>3]=oa;h[w+32>>3]=ma;h[w+40>>3]=qa;h[w+48>>3]=pa;h[w+56>>3]=ja;h[w+64>>3]=ia;h[w+72>>3]=ha;h[w+80>>3]=na;wu(M,b,ba,$);na=+h[M+8>>3];ha=+h[M+16>>3];ia=+h[M+24>>3];ja=+h[M+32>>3];pa=+h[M+40>>3];qa=+h[M+48>>3];ma=+h[M+56>>3];oa=+h[M+64>>3];la=+h[M+72>>3];e=+h[M+80>>3];h[x>>3]=+h[M>>3];h[x+8>>3]=na;h[x+16>>3]=ha;h[x+24>>3]=ia;h[x+32>>3]=ja;h[x+40>>3]=pa;h[x+48>>3]=qa;h[x+56>>3]=ma;h[x+64>>3]=oa;h[x+72>>3]=la;h[x+80>>3]=e;Ka=r+0|0;La=w+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));ru(N,0,r);e=+h[N+8>>3];la=+h[N+16>>3];oa=+h[N+24>>3];ma=+h[N+32>>3];qa=+h[N+40>>3];pa=+h[N+48>>3];ja=+h[N+56>>3];h[u>>3]=+h[N>>3];h[u+8>>3]=e;h[u+16>>3]=la;h[u+24>>3]=oa;h[u+32>>3]=ma;h[u+40>>3]=qa;h[u+48>>3]=pa;h[u+56>>3]=ja;Ka=q+0|0;La=x+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));ru(O,0,q);ja=+h[O>>3];pa=+h[O+8>>3];qa=+h[O+16>>3];ma=+h[O+24>>3];oa=+h[O+32>>3];la=+h[O+40>>3];e=+h[O+48>>3];ia=+h[O+56>>3];h[v>>3]=ja;h[v+8>>3]=pa;h[v+16>>3]=qa;h[v+24>>3]=ma;h[v+32>>3]=oa;h[v+40>>3]=la;h[v+48>>3]=e;h[v+56>>3]=ia;Na=ma;Oa=ja;Pa=ga+Ja*($-ga)}else{Au(P,b,ba);ga=+h[P>>3];iv(Q,b,ga);$=+h[Q>>3];jv(R,b,ga);ja=+h[R>>3];pu(S,b,$,ga);$=+h[S+8>>3];ma=+h[S+16>>3];ia=+h[S+24>>3];e=+h[S+32>>3];la=+h[S+40>>3];oa=+h[S+48>>3];qa=+h[S+56>>3];pa=+h[S+64>>3];ha=+h[S+72>>3];na=+h[S+80>>3];h[y>>3]=+h[S>>3];h[y+8>>3]=$;h[y+16>>3]=ma;h[y+24>>3]=ia;h[y+32>>3]=e;h[y+40>>3]=la;h[y+48>>3]=oa;h[y+56>>3]=qa;h[y+64>>3]=pa;h[y+72>>3]=ha;h[y+80>>3]=na;pu(T,b,ja,ga);ja=+h[T+8>>3];na=+h[T+16>>3];ha=+h[T+24>>3];pa=+h[T+32>>3];qa=+h[T+40>>3];oa=+h[T+48>>3];la=+h[T+56>>3];e=+h[T+64>>3];ia=+h[T+72>>3];ma=+h[T+80>>3];h[z>>3]=+h[T>>3];h[z+8>>3]=ja;h[z+16>>3]=na;h[z+24>>3]=ha;h[z+32>>3]=pa;h[z+40>>3]=qa;h[z+48>>3]=oa;h[z+56>>3]=la;h[z+64>>3]=e;h[z+72>>3]=ia;h[z+80>>3]=ma;Ka=p+0|0;La=y+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));qu(V,0,p);ma=+h[V+8>>3];ia=+h[V+16>>3];e=+h[V+24>>3];la=+h[V+32>>3];oa=+h[V+40>>3];qa=+h[V+48>>3];pa=+h[V+56>>3];h[u>>3]=+h[V>>3];h[u+8>>3]=ma;h[u+16>>3]=ia;h[u+24>>3]=e;h[u+32>>3]=la;h[u+40>>3]=oa;h[u+48>>3]=qa;h[u+56>>3]=pa;Ka=o+0|0;La=z+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));qu(W,0,o);pa=+h[W>>3];qa=+h[W+8>>3];oa=+h[W+16>>3];la=+h[W+24>>3];e=+h[W+32>>3];ia=+h[W+40>>3];ma=+h[W+48>>3];ha=+h[W+56>>3];h[v>>3]=pa;h[v+8>>3]=qa;h[v+16>>3]=oa;h[v+24>>3]=la;h[v+32>>3]=e;h[v+40>>3]=ia;h[v+48>>3]=ma;h[v+56>>3]=ha;Na=la;Oa=pa;Pa=ga}W=u;ga=+h[W>>3];if(ga!=Oa){pa=+h[u+24>>3];Qa=Oa;Ra=ga;Sa=Na;Ta=pa;Ua=(Na-pa)*ga*(Oa/(ga-Oa))}else{vu(X,b,Pa);Qa=+h[v>>3];Ra=+h[W>>3];Sa=+h[v+24>>3];Ta=+h[u+24>>3];Ua=+h[X>>3]}Oa=Ta+Ja*(Sa-Ta);Ta=Ra*(Qa/(Qa+Ja*(Ra-Qa)));Ka=n+0|0;La=u+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Ka=m+0|0;La=v+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));su(Y,0,n,m,Ja,Pa,d);d=+h[u+32>>3];Qa=+h[u+48>>3];Ra=+h[u+56>>3];sa=ba;ta=ca;ua=Qa+Ja*(+h[v+48>>3]-Qa);va=Ra+Ja*(+h[v+56>>3]-Ra);wa=0.0;xa=0.0;ya=Ja;za=Ua;Aa=Pa;Ba=aa;Ca=d+Ja*(+h[v+32>>3]-d);Da=+h[Y>>3];Ea=Ta;Fa=Oa;Ga=4}c[a>>2]=ta;c[a+4>>2]=Ga;h[a+8>>3]=sa;h[a+16>>3]=Aa;h[a+24>>3]=Ba;h[a+32>>3]=461.526;h[a+40>>3]=Ca;h[a+48>>3]=Da;h[a+56>>3]=Ea;h[a+64>>3]=Fa;h[a+72>>3]=ua;h[a+80>>3]=va;h[a+88>>3]=wa;h[a+96>>3]=xa;h[a+104>>3]=ya;h[a+112>>3]=za;i=j;return}function gv(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;mu(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));nu(b,0,0.0,f);i=e;return}function hv(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Xu(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));nu(b,0,0.0,f);i=e;return}function iv(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;ou(e,b,c);j=+h[e>>3];do{if(c<623.15){Wu(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Bu(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function jv(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;ou(e,b,c);j=+h[e>>3];do{if(c<623.15){Vu(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Su(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function kv(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;g=i;i=i+56|0;j=g;k=g+24|0;l=g+48|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;c[n>>2]=42;PCa(o,1,n);n=o;o=14800;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];p=e+-273.15;q=d/317.763;if(!(d>.004854575724778614)){o=ACa(ACa(14816,yCa(d,0,1,6)|0)|0,14896)|0;n=ACa(ACa(o,yCa(.004854575724778614,0,1,6)|0)|0,14904)|0;o=c[72852]|0;r=k;s=14928;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[r+16>>2]=c[s+16>>2];c[r+20>>2]=c[s+20>>2];Ne[o&127](b,k,n,m);}if(!(f<=5.0e8)){t=5}else{if(!(p>=0.0&p<=150.0)){t=5}}do{if((t|0)==5){if(f<=35.0e7){if(p>150.0&p<=600.0){break}}if(f<=3.0e8){if(p>600.0&p<=900.0){break}}m=ACa(ACa(14952,yCa(f,0,1,6)|0)|0,15064)|0;n=ACa(ACa(m,yCa(p,0,1,6)|0)|0,13640)|0;m=c[72852]|0;k=j;o=15080;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];Ne[m&127](b,j,n,l);}}while(0);p=q+-1.0;f=647.226/e;e=f+-1.0;d=+W(+f,-.5)/(f*(f*(f*-.202354+.579829)+.978197)+1.0);if((lv(1,1,6)|0)==0){u=0.0;v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}l=(lv(0,0,6)|0)==0;f=0.0;j=1;B=1.0;while(1){if((j|0)==1){C=B}else{C=e*B}if(l){D=f}else{b=j+ -1|0;E=f;t=0;F=1.0;while(1){if((t|0)==0){G=F}else{G=p*F}H=E+ +NCa(14800,b+(t*6|0)|0)*C*G;n=t+1|0;if((lv(n,0,6)|0)==0){D=H;break}else{E=H;t=n;F=G}}}t=j+1|0;if((lv(t,1,6)|0)==0){u=D;break}else{f=D;j=t;B=C}}v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}function lv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function mv(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function nv(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;h[a>>3]=+h[d+24>>3];i=i;return}function ov(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function pv(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){ev(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==3){Mu(o,b,d,e,1.0e-7);s=+h[o>>3];pu(p,b,s,e);t=+h[p+24>>3];u=+h[p+32>>3];v=+h[p+48>>3];w=u*+h[p+64>>3];x=s*t*(v-u*+h[p+80>>3])*461.526;y=x;z=t*(v*2.0+t*+h[p+56>>3])*e*461.526;A=0.0;B=0.0;C=0.0;D=x;E=(t*v+w)*e*461.526;F=0.0;G=u*u*+h[p+72>>3]*-461.526;H=s;I=(w- +h[p+40>>3])*461.526}else if((r|0)==5){yu(q,b,d,e);w=+h[q+24>>3];s=+h[q+32>>3];u=+h[q+48>>3];v=+h[q+56>>3];t=+h[q+72>>3];x=+h[q+80>>3];J=s*+h[q+64>>3];K=(J- +h[q+40>>3])*461.526;L=w*u;M=(L-s*w*x)/d*461.526;N=w*w*v*+ADa(d,-2)*e*461.526;w=s*s*t;t=u-s*x;y=0.0;z=0.0;A=M;B=N;C=1.0;D=-M/N;E=J*e*461.526;F=w*-461.526;G=(t*t/v-w)*461.526;H=d/(L*e*461.526);I=K}else if((r|0)==1){xu(m,b,d,e);K=+h[m+24>>3];L=+h[m+32>>3];w=+h[m+48>>3];v=+h[m+56>>3];t=+h[m+72>>3];J=+h[m+80>>3];N=L*+h[m+64>>3];M=(N- +h[m+40>>3])*461.526;x=K*w;s=(x-L*K*J)/d*461.526;u=K*K*v*+ADa(d,-2)*e*461.526;K=L*L*t;t=w-L*J;y=0.0;z=0.0;A=s;B=u;C=0.0;D=-s/u;E=N*e*461.526;F=K*-461.526;G=(t*t/v-K)*461.526;H=d/(x*e*461.526);I=M}else if((r|0)==2){wu(n,b,d,e);M=+h[n+24>>3];x=+h[n+32>>3];K=+h[n+48>>3];v=+h[n+56>>3];t=+h[n+72>>3];N=+h[n+80>>3];u=x*+h[n+64>>3];s=(u- +h[n+40>>3])*461.526;J=M*K;L=(J-x*M*N)/d*461.526;w=M*M*v*+ADa(d,-2)*e*461.526;M=x*x*t;t=K-x*N;y=0.0;z=0.0;A=L;B=w;C=1.0;D=-L/w;E=u*e*461.526;F=M*-461.526;G=(t*t/v-M)*461.526;H=d/(J*e*461.526);I=s}else{n=ACa(ACa(14704,yCa(d,0,1,6)|0)|0,15104)|0;m=ACa(ACa(n,yCa(e,0,1,6)|0)|0,14768)|0;n=c[72852]|0;q=j;p=15112;c[q+0>>2]=c[p+0>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];c[q+16>>2]=c[p+16>>2];c[q+20>>2]=c[p+20>>2];Ne[n&127](b,j,m,k);y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=E;h[a+32>>3]=461.526;h[a+40>>3]=F;h[a+48>>3]=G;h[a+56>>3]=H;h[a+64>>3]=I;h[a+72>>3]=y;h[a+80>>3]=z;h[a+88>>3]=A;h[a+96>>3]=B;h[a+104>>3]=C;h[a+112>>3]=D;i=g;return}function qv(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function rv(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0;b=i;k=c[f+4>>2]|0;if((k|0)==4){e=+h[f+56>>3];d=+h[f+112>>3];l=d*+h[f+16>>3];m=e*(e*(+h[f+48>>3]/d)+1.0)*(g/l)-e*e/l*j;n=a;o=n;h[o>>3]=m;i=b;return}l=+h[f+56>>3];if((k|0)==3){e=+h[f+72>>3];d=+h[f+48>>3];p=l*l;q=p*d*+h[f+80>>3]+e*e*+h[f+16>>3];m=l*(e+l*d)*(g/q)-p*e*(j/q);n=a;o=n;h[o>>3]=m;i=b;return}else{q=+h[f+88>>3];e=+h[f+40>>3];m=-(l*l*((+h[f+96>>3]+(q*q*+h[f+16>>3]-q/l)/e)*g+q*(j/e)));n=a;o=n;h[o>>3]=m;i=b;return}}function sv(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function tv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;f=d;g=vBa(e,1)|0;do{if((g|0)<1){h=0}else{if((lv(1,1,g)|0)==0){h=0;break}else{j=1;k=0}while(1){if(k<<24>>24==0){c[f>>2]=j;l=(a[CBa(e,1,f)|0]|0)!=0|0}else{l=1}m=j+1|0;if((lv(m,1,g)|0)==0){h=l;break}else{j=m;k=l}}}}while(0);a[b]=h;i=d;return}function uv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;f=d;g=vBa(e,1)|0;do{if((g|0)<1){h=1}else{if((lv(1,1,g)|0)==0){h=1;break}else{j=1;k=1}while(1){if(k<<24>>24==0){l=0}else{c[f>>2]=j;l=(a[CBa(e,1,f)|0]|0)!=0|0}m=j+1|0;if((lv(m,1,g)|0)==0){h=l;break}else{j=m;k=l}}}}while(0);a[b]=h;i=d;return}function vv(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;MBa(4,0,18648,b);MBa(4,0,18688,a);i=a;return}function wv(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}L4a(a);c[d>>2]=0;i=b;return}function xv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1456>>3]=+h[f>>3];i=b;return}function yv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1512>>3]=+h[f>>3];i=b;return}function zv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1512>>3],+h[f+1456>>3],+h[f+5008>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1488>>3]=+h[d>>3];i=b;return}function Av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2120>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2120>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1504>>3]=+h[f>>3];i=b;return}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2120>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2120>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1464>>3]=+h[f>>3];i=b;return}function Cv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1504>>3],+h[f+1464>>3],+h[f+2120>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1480>>3]=+h[d>>3];i=b;return}function Dv(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+3752>>3]*(+h[d+5008>>3]- +h[d+2120>>3])*+h[b+3784>>3];i=i;return}function Ev(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3752>>3]*+h[e+3784>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1424>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,18744,18736,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}function Fv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4952>>3]=+h[b+5008>>3]- +h[b+104>>3];i=i;return}function Gv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4944>>3]=+h[(c[a+416>>2]|0)+1984>>3]*+h[b+4952>>3]*.01;i=i;return}function Hv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+70192>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+70168>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+70176>>3];h[a+8>>3]=+h[d+29760>>3];h[e+8>>3]=+h[d+29736>>3];h[f+8>>3]=+h[d+29744>>3];i=i;return}function Iv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+5008>>3]=+h[d>>3];h[l+2120>>3]=+h[d+8>>3];xv(j);yv(j);zv(j);Av(j);Bv(j);Cv(j);Dv(j);Ev(j);Fv(j);Gv(j);j=c[c[k>>2]>>2]|0;if((a[(c[j+16>>2]|0)+7|0]|0)==0){d=c[j+8>>2]|0;if((a[(c[b+408>>2]|0)+9|0]|0)==0){l=c[b+416>>2]|0;m=l;n=+h[d+2120>>3]- +h[l+2824>>3]}else{m=c[b+416>>2]|0;n=-+h[d+4944>>3]}o=m;p=d;q=j;r=-n}else{do{if((pFa(-+h[(c[j+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[k>>2]>>2]|0;m=c[d+8>>2]|0;n=+h[m+3104>>3];t=+h[m+4944>>3];u=-t;do{if(n!=0.0){v=m;w=d;x=u/n}else{if(t==-0.0){v=m;w=d;x=u;break}y=u/+SBa(c[b+536>>2]|0,n,18808,18800,+h[d>>3],(a[b+319|0]|0)!=0|0);l=c[c[k>>2]>>2]|0;v=c[l+8>>2]|0;w=l;x=y}}while(0);n=+h[v+4056>>3]*2.0;u=x*x;if(n!=0.0){s=u/n;break}if(u==0.0){s=u;break}s=u/+SBa(c[b+536>>2]|0,n,18832,18800,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=c[c[k>>2]>>2]|0;v=c[w+8>>2]|0;j=c[b+416>>2]|0;o=j;p=v;q=w;r=+h[v+2120>>3]-(+h[j+2824>>3]+(+h[v+2096>>3]*+h[j+2528>>3]*+h[v+4056>>3]-s))}h[e>>3]=r;r=+h[b+304>>3];v=b+536|0;j=c[v>>2]|0;s=+h[p+1416>>3];x=+h[p+1504>>3];n=+h[p+1512>>3];u=+h[p+1480>>3];t=+h[p+1488>>3];w=b+416|0;y=+h[o+3704>>3];z=+h[p+2952>>3];A=+h[o+3728>>3]*+h[o+3848>>3];B=+h[o+3720>>3];C=(B+B)*.5;p=(c[(c[b+420>>2]|0)+492>>2]|0)+ -1|0;B=+(p|0);D=+h[o+3840>>3];do{if((p|0)==0){if(D==0.0){E=o;F=D;break}G=D/+SBa(j,B,18856,18800,+h[q>>3],(a[b+319|0]|0)!=0|0);E=c[w>>2]|0;F=G}else{E=o;F=D/B}}while(0);_t(g,j,s,x,n,u,t,y,z,A,C,F,+h[E+3808>>3]);F=+h[g>>3];g=c[c[k>>2]>>2]|0;k=c[g+8>>2]|0;C=+h[k+4944>>3];A=r+-1.0;E=c[w>>2]|0;z=+h[k+1416>>3]- +h[E+3728>>3]*+h[E+3848>>3]*+h[E+3864>>3];y=+h[E+3816>>3];t=+h[E+3824>>3];if(y!=0.0){H=E;I=t/y;J=z*I;K=A*J;L=H;M=L+3784|0;N=M;O=+h[N>>3];P=F*O;Q=r*P;R=K-Q;S=C+R;T=e;U=T+8|0;V=U;h[V>>3]=S;i=f;return}if(t==0.0){H=E;I=t;J=z*I;K=A*J;L=H;M=L+3784|0;N=M;O=+h[N>>3];P=F*O;Q=r*P;R=K-Q;S=C+R;T=e;U=T+8|0;V=U;h[V>>3]=S;i=f;return}u=t/+SBa(c[v>>2]|0,y,18896,18800,+h[g>>3],(a[b+319|0]|0)!=0|0);H=c[w>>2]|0;I=u;J=z*I;K=A*J;L=H;M=L+3784|0;N=M;O=+h[N>>3];P=F*O;Q=r*P;R=K-Q;S=C+R;T=e;U=T+8|0;V=U;h[V>>3]=S;i=f;return}function Jv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5032>>3]=+h[b+5096>>3]- +h[b+104>>3];i=i;return}function Kv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5024>>3]=+h[(c[a+416>>2]|0)+1928>>3]*+h[b+5032>>3]*.01;i=i;return}function Lv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+584>>3],+h[a+112>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1360>>3]=+h[f>>3];i=b;return}function Mv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+584>>3],+h[a+112>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1400>>3]=+h[f>>3];i=b;return}function Nv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1400>>3],+h[f+1360>>3],+h[f+584>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1376>>3]=+h[d>>3];i=b;return}function Ov(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1304>>3]=+h[b+3936>>3]*(+h[d+5096>>3]- +h[d+584>>3])*+h[b+3968>>3];i=i;return}function Pv(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3936>>3]*+h[e+3968>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1304>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,18936,18928,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}function Qv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5120>>3]=+h[b+5096>>3]- +h[b+248>>3];i=i;return}function Rv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+48|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1872>>3]*+h[f+5120>>3]*.01;k=g;l=k+5112|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5120>>3]*.01;k=g;l=k+5112|0;m=l;h[m>>3]=j;i=d;return}}function Sv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5112>>3],1.0e-15);k=+xd(+-+h[g+5024>>3],1.0e-15);l=j+k;m=j*+h[g+240>>3]+k*+h[g+96>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,19e3,18992,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}function Tv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+1352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+1352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1408>>3]=+h[f>>3];i=b;return}function Uv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+1352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+1352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1344>>3]=+h[f>>3];i=b;return}function Vv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1408>>3],+h[f+1344>>3],+h[f+5096>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1384>>3]=+h[d>>3];i=b;return}function Wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+5112>>3]+ +h[b+5024>>3];i=i;return}function Xv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+71424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+71400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+71408>>3];h[a+8>>3]=+h[d+8256>>3];h[e+8>>3]=+h[d+8232>>3];h[f+8>>3]=+h[d+8240>>3];i=i;return}function Yv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+5096>>3]=+h[d>>3];h[l+584>>3]=+h[d+8>>3];Jv(j);Kv(j);Lv(j);Mv(j);Nv(j);Ov(j);Pv(j);Qv(j);Rv(j);Sv(j);Tv(j);Uv(j);Vv(j);Wv(j);m=+h[b+304>>3];j=b+536|0;d=c[j>>2]|0;l=c[c[k>>2]>>2]|0;n=c[l+8>>2]|0;o=+h[n+1296>>3];p=+h[n+1400>>3];q=+h[n+1408>>3];r=+h[n+1376>>3];s=+h[n+1384>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+3888>>3];w=+h[n+2944>>3];x=+h[u+3912>>3]*+h[u+4032>>3];y=+h[u+3904>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+504>>2]|0)+ -1|0;y=+(n|0);A=+h[u+4024>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+SBa(d,y,19064,19056,+h[l>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);_t(g,d,o,p,q,r,s,v,w,x,z,C,+h[B+3992>>3]);C=+h[g>>3];g=c[c[k>>2]>>2]|0;B=c[g+8>>2]|0;z=+h[B+1320>>3];x=m+-1.0;d=c[t>>2]|0;w=+h[B+1296>>3]- +h[d+3912>>3]*+h[d+4032>>3]*+h[d+4048>>3];v=+h[d+4e3>>3];s=+h[d+4008>>3];do{if(v!=0.0){E=g;F=d;G=s/v}else{if(s==0.0){E=g;F=d;G=s;break}r=s/+SBa(c[j>>2]|0,v,19104,19056,+h[g>>3],(a[b+319|0]|0)!=0|0);E=c[c[k>>2]>>2]|0;F=c[t>>2]|0;G=r}}while(0);h[e>>3]=z+(x*w*G-m*C*+h[F+3968>>3]);if((a[c[E+16>>2]|0]|0)==0){g=c[E+8>>2]|0;if((a[(c[b+408>>2]|0)+1|0]|0)==0){H=+h[g+584>>3]- +h[F+4752>>3]}else{H=-+h[g+1320>>3]}I=-H;J=e;K=J+8|0;L=K;h[L>>3]=I;i=f;return}do{if((pFa(-+h[(c[E+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0){M=0.0}else{g=c[c[k>>2]>>2]|0;F=c[g+8>>2]|0;H=+h[F+3040>>3];C=+h[F+1320>>3];m=-C;do{if(H!=0.0){N=F;O=g;P=m/H}else{if(C==-0.0){N=F;O=g;P=m;break}G=m/+SBa(c[j>>2]|0,H,19136,19056,+h[g>>3],(a[b+319|0]|0)!=0|0);d=c[c[k>>2]>>2]|0;N=c[d+8>>2]|0;O=d;P=G}}while(0);H=+h[N+3616>>3]*2.0;m=P*P;if(H!=0.0){M=m/H;break}if(m==0.0){M=m;break}M=m/+SBa(c[j>>2]|0,H,19160,19056,+h[O>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=c[t>>2]|0;I=+h[b+584>>3]-(+h[k+4752>>3]+(+h[b+568>>3]*+h[k+2528>>3]*+h[b+3616>>3]-M));J=e;K=J+8|0;L=K;h[L>>3]=I;i=f;return}function Zv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+304|0;j=+h[g>>3];k=b+536|0;l=c[k>>2]|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+4408>>3];q=+h[o+4424>>3];r=+h[(c[b+416>>2]|0)+2280>>3];do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+SBa(l,q,19192,19184,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Nt(e,l,p*s,.8);s=+h[e>>3];p=+h[g>>3];Nt(f,c[k>>2]|0,.0001001797131419643,.8);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4440>>3]=j*s+(1.0-p)*+h[f>>3];i=d;return}function _v(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0;d=i;i=i+80|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=d+64|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=b+304|0;w=+h[v>>3];x=b+416|0;y=+h[(c[x>>2]|0)+2280>>3];z=b+4|0;A=c[c[z>>2]>>2]|0;B=+h[(c[A+8>>2]|0)+4424>>3];do{if(y!=0.0){C=B/y}else{if(B==0.0){C=B;break}C=B/+SBa(c[b+536>>2]|0,y,19208,19200,+h[A>>3],(a[b+319|0]|0)!=0|0)}}while(0);A=o;h[k>>3]=1.0e-4;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=o+8|0;h[k>>3]=15.0e-5;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];WCa(p,3,0.0,o);o=n;h[k>>3]=5.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=0.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];WCa(q,3,10.0,n);n=b+536|0;o=c[n>>2]|0;A=c[c[z>>2]>>2]|0;D=c[A+8>>2]|0;y=+h[D+4408>>3];B=+h[D+4424>>3];E=+h[(c[x>>2]|0)+2280>>3];do{if(B!=0.0){F=E/B}else{if(E==0.0){F=E;break}F=E/+SBa(o,B,19192,19200,+h[A>>3],(a[b+319|0]|0)!=0|0)}}while(0);B=y*F;A=j;D=p;c[A+0>>2]=c[D+0>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];D=g;A=q;c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];Lt(t,o,B,j,g);B=+h[t>>3];F=+h[v>>3];v=m;h[k>>3]=1.0e-4;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=m+8|0;h[k>>3]=15.0e-5;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];WCa(r,3,0.0,m);m=l;h[k>>3]=5.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=0.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];WCa(s,3,10.0,l);l=c[n>>2]|0;m=f;v=r;c[m+0>>2]=c[v+0>>2];c[m+4>>2]=c[v+4>>2];c[m+8>>2]=c[v+8>>2];v=e;m=s;c[v+0>>2]=c[m+0>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];Lt(u,l,0.0,f,e);y=w*C*C*B;B=1.0-F;e=c[c[z>>2]>>2]|0;f=c[e+8>>2]|0;F=+h[f+4424>>3];l=c[x>>2]|0;C=+h[l+2280>>3];w=+h[u>>3]+ +h[l+2376>>3]*+h[f+4408>>3];if(C!=0.0){G=f;H=w/C;I=F*H;J=B*I;K=y+J;L=G;M=L+4320|0;N=M;h[N>>3]=K;i=d;return}if(w==0.0){G=f;H=w;I=F*H;J=B*I;K=y+J;L=G;M=L+4320|0;N=M;h[N>>3]=K;i=d;return}E=w/+SBa(c[n>>2]|0,C,19208,19200,+h[e>>3],(a[b+319|0]|0)!=0|0);G=c[(c[c[z>>2]>>2]|0)+8>>2]|0;H=E;I=F*H;J=B*I;K=y+J;L=G;M=L+4320|0;N=M;h[N>>3]=K;i=d;return}function $v(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4408>>3]*+(c[(c[a+420>>2]|0)+220>>2]|0);i=i;return}function aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4504>>3]=+h[b+216>>3]- +h[b+4432>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5264>>3]=+h[b+248>>3]- +h[b+4504>>3];i=i;return}function cw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5256>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+792>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+208|0;h[f+4472>>3]=+h[f+5256>>3]*+h[(a<<24>>24==0?d:f+240|0)>>3]- +h[f+792>>3]*+h[(e<<24>>24==0?d:f+16|0)>>3];i=b;return}function dw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+6672>>3]- +h[b+4472>>3];i=i;return}function ew(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+220>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+4464>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4448|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4448|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,19232,19224,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4448|0;q=p;h[q>>3]=n;i=d;return}function fw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+62128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+62104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+62112>>3];h[a+8>>3]=+h[d+73664>>3];h[e+8>>3]=+h[d+73640>>3];h[f+8>>3]=+h[d+73648>>3];h[a+16>>3]=+h[d+61792>>3];h[e+16>>3]=+h[d+61768>>3];h[f+16>>3]=+h[d+61776>>3];h[a+24>>3]=+h[d+62016>>3];h[e+24>>3]=+h[d+61992>>3];h[f+24>>3]=+h[d+62e3>>3];i=i;return}function gw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+4432>>3]=+h[d>>3];h[k+5256>>3]=+h[d+8>>3];h[k+4408>>3]=+h[d+16>>3];h[k+4424>>3]=+h[d+24>>3];Zv(g);_v(g);$v(g);aw(g);bw(g);cw(g);dw(g);ew(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;h[e>>3]=+h[d+4320>>3]*+h[d+4368>>3]*9.80665- +h[d+4432>>3];k=b+304|0;l=+h[k>>3];m=+h[d+4456>>3];n=l+-1.0;o=b+416|0;p=+h[(c[o>>2]|0)+2344>>3];q=+h[d+5256>>3];do{if(p!=0.0){r=q;s=d;t=g;u=q/p}else{if(q==0.0){r=q;s=d;t=g;u=q;break}v=q/+SBa(c[b+536>>2]|0,p,19264,19256,+h[g>>3],(a[b+319|0]|0)!=0|0);w=c[c[j>>2]>>2]|0;x=c[w+8>>2]|0;r=+h[x+5256>>3];s=x;t=w;u=v}}while(0);p=n*u;u=+h[s+4368>>3];do{if(u!=0.0){y=s;z=t;A=r/u}else{if(r==0.0){y=s;z=t;A=r;break}n=r/+SBa(c[b+536>>2]|0,u,19280,19256,+h[t>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;y=c[g+8>>2]|0;z=g;A=n}}while(0);h[e+8>>3]=m+(p-l*A);A=+h[k>>3];l=+h[y+4448>>3];p=A+-1.0;m=+h[y+4440>>3];u=+h[y+4432>>3];do{if(m!=0.0){B=m;C=u;D=y;E=z;F=u/m}else{if(u==0.0){B=m;C=u;D=y;E=z;F=u;break}r=u/+SBa(c[b+536>>2]|0,m,19288,19256,+h[z>>3],(a[b+319|0]|0)!=0|0);k=c[c[j>>2]>>2]|0;t=c[k+8>>2]|0;B=+h[t+4440>>3];C=+h[t+4432>>3];D=t;E=k;F=r}}while(0);m=p*F*.0001001797131419643;F=+h[D+4408>>3];do{if(B!=0.0){G=D;H=E;I=F/B}else{if(F==0.0){G=D;H=E;I=F;break}p=F/+SBa(c[b+536>>2]|0,B,19288,19256,+h[E>>3],(a[b+319|0]|0)!=0|0);z=c[c[j>>2]>>2]|0;G=c[z+8>>2]|0;H=z;I=p}}while(0);h[e+16>>3]=l+(m-A*C*I);I=+h[G+5256>>3];if((a[(c[H+16>>2]|0)+48|0]|0)==0){J=+h[(c[o>>2]|0)+1760>>3]*+h[G+5264>>3]*.01;K=I-J;L=e;M=L+24|0;N=M;h[N>>3]=K;i=f;return}else{J=+h[G+5264>>3]*.01;K=I-J;L=e;M=L+24|0;N=M;h[N>>3]=K;i=f;return}}function hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6912>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6888>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6896>>3];h[a+8>>3]=+h[d+6800>>3];h[e+8>>3]=+h[d+6776>>3];h[f+8>>3]=+h[d+6784>>3];i=i;return}function iw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+488>>3]=k;o=+h[b+8>>3];h[n+480>>3]=o;p=+h[n+4368>>3];q=p*p;b=n+216|0;h[d>>3]=+h[n+6584>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+6808>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+208>>3],c[(c[m+12>>2]|0)+92>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+216>>3];q=+h[r+208>>3];k=+h[r+488>>3];p=+h[r+480>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6808>>3]- +h[j>>3];i=e;return}function jw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+7248>>3];h[e+8>>3]=+h[d+7224>>3];h[f+8>>3]=+h[d+7232>>3];i=i;return}function kw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+520>>3]=k;o=+h[b+8>>3];h[n+512>>3]=o;p=+h[n+4824>>3];q=p*p;b=n+248|0;h[d>>3]=+h[n+6568>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+6784>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+240>>3],c[(c[m+12>>2]|0)+100>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+248>>3];q=+h[r+240>>3];k=+h[r+520>>3];p=+h[r+512>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6784>>3]- +h[j>>3];i=e;return}function lw(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+58992>>3];h[c[b+8>>2]>>3]=+h[d+58968>>3];h[c[b+12>>2]>>3]=+h[d+58976>>3];i=i;return}function mw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0,g=0.0;e=i;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4208>>3]=f;g=+h[b+4424>>3];h[d>>3]=g- +xd(+f,.001);i=e;return}function nw(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+58656>>3];h[c[b+8>>2]>>3]=+h[d+58632>>3];h[c[b+12>>2]>>3]=+h[d+58640>>3];i=i;return}function ow(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0;f=i;g=+h[d>>3];d=b+4|0;j=c[c[d>>2]>>2]|0;h[(c[j+8>>2]|0)+4184>>3]=g;do{if((a[b+314|0]|0)==0){k=a[(c[b+356>>2]|0)+60|0]|0}else{l=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(l){m=a[(c[b+356>>2]|0)+60|0]|0;n=lFa(+h[j>>3],g,a[(c[b+360>>2]|0)+60|0]|0)|0;a[(c[b+352>>2]|0)+60|0]=n;k=m;break}else{m=lFa(+h[j>>3],g,a[(c[b+360>>2]|0)+60|0]|0)|0;a[(c[b+352>>2]|0)+60|0]=m;k=m;break}}else{if(l){l=a[(c[b+356>>2]|0)+60|0]|0;m=pFa(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+60|0]=m;k=l;break}else{l=pFa(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+60|0]=l;k=l;break}}}}while(0);b=c[c[d>>2]>>2]|0;d=c[b+8>>2]|0;g=+h[d+4208>>3];o=+h[d+4200>>3];if(k<<24>>24==0){p=o;q=g-p;h[e>>3]=q;i=f;return}p=o-(+h[d+4184>>3]- +h[b>>3])*+h[d+4192>>3];q=g-p;h[e>>3]=q;i=f;return}function pw(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+58992>>3];h[c[b+8>>2]>>3]=+h[d+58968>>3];h[c[b+12>>2]>>3]=+h[d+58976>>3];i=i;return}function qw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;h[(c[a+400>>2]|0)+4208>>3]=+h[b>>3];b=c[c[a+4>>2]>>2]|0;h[d>>3]=+h[(c[b+8>>2]|0)+4184>>3]- +h[b>>3];i=i;return}function rw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4224>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4200>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4208>>3];h[a+8>>3]=+h[d+4112>>3];h[e+8>>3]=+h[d+4088>>3];h[f+8>>3]=+h[d+4096>>3];i=i;return}function sw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+296>>3]=k;o=+h[b+8>>3];h[n+288>>3]=o;p=+h[n+752>>3];q=p*p;b=n+24|0;h[d>>3]=+h[n+2424>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2520>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+16>>3],c[(c[m+12>>2]|0)+4>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+24>>3];q=+h[r+16>>3];k=+h[r+296>>3];p=+h[r+288>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2520>>3]- +h[j>>3];i=e;return}



function Aea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96664]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+408>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(96672,xCa(c[(c[g>>2]|0)+408>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[96664]=1;i=d;return}function Bea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96912]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+404>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(96920,xCa(c[(c[g>>2]|0)+404>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=97008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[96912]=1;i=d;return}function Cea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97032]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3152>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3152>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(97040,vCa(+h[(c[g>>2]|0)+3152>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97032]=1;i=d;return}function Dea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3144>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3144>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(97216,vCa(+h[(c[g>>2]|0)+3144>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97208]=1;i=d;return}function Eea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97368]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(97376,vCa(+h[(c[g>>2]|0)+3128>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97368]=1;i=d;return}function Fea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97496]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(97504,vCa(+h[(c[g>>2]|0)+3120>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97496]=1;i=d;return}function Gea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97624]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(97632,vCa(+h[(c[g>>2]|0)+3104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97624]=1;i=d;return}function Hea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97752]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(97760,vCa(+h[(c[g>>2]|0)+3096>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97752]=1;i=d;return}function Iea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97872]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+304>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+304>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(97880,vCa(+h[(c[g>>2]|0)+304>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97872]=1;i=d;return}function Jea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3080>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3080>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(98e3,vCa(+h[(c[g>>2]|0)+3080>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[97992]=1;i=d;return}function Kea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98112]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+396>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+396>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(98120,xCa(c[(c[g>>2]|0)+396>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[98112]=1;i=d;return}function Lea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98328]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+392>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+392>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(98336,xCa(c[(c[g>>2]|0)+392>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[98328]=1;i=d;return}function Mea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98552]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(98560,vCa(+h[(c[g>>2]|0)+296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[98552]=1;i=d;return}function Nea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98664]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(98672,vCa(+h[(c[g>>2]|0)+288>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[98664]=1;i=d;return}function Oea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98784]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(98792,vCa(+h[(c[g>>2]|0)+280>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[98784]=1;i=d;return}function Pea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98896]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(98904,vCa(+h[(c[g>>2]|0)+272>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[98896]=1;i=d;return}function Qea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99016]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(99024,vCa(+h[(c[g>>2]|0)+3072>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99016]=1;i=d;return}function Rea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99112]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(99120,vCa(+h[(c[g>>2]|0)+3064>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99112]=1;i=d;return}function Sea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3056>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3056>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(99216,vCa(+h[(c[g>>2]|0)+3056>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99208]=1;i=d;return}function Tea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99328]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3048>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(99336,vCa(+h[(c[g>>2]|0)+3048>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99328]=1;i=d;return}function Uea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99456]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+388>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(99464,xCa(c[(c[g>>2]|0)+388>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[99456]=1;i=d;return}function Vea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99664]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+384>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(99672,xCa(c[(c[g>>2]|0)+384>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[99664]=1;i=d;return}function Wea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99880]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(99888,vCa(+h[(c[g>>2]|0)+3040>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99880]=1;i=d;return}function Xea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99976]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(99984,vCa(+h[(c[g>>2]|0)+3032>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[99976]=1;i=d;return}function Yea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100080]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(100088,vCa(+h[(c[g>>2]|0)+3008>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100080]=1;i=d;return}function Zea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100168]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3e3>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3e3>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(100176,vCa(+h[(c[g>>2]|0)+3e3>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100168]=1;i=d;return}function _ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100304]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2992>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2992>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(100312,vCa(+h[(c[g>>2]|0)+2992>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100304]=1;i=d;return}function $ea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100416]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(100424,vCa(+h[(c[g>>2]|0)+2984>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100416]=1;i=d;return}function afa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100536]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+264>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(100544,vCa(+h[(c[g>>2]|0)+264>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100536]=1;i=d;return}function bfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100656]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2968>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2968>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(100664,vCa(+h[(c[g>>2]|0)+2968>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[100656]=1;i=d;return}function cfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100776]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+368>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(100784,xCa(c[(c[g>>2]|0)+368>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[100776]=1;i=d;return}function dfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100992]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+364>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(101e3,xCa(c[(c[g>>2]|0)+364>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[100992]=1;i=d;return}function efa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101216]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101224,vCa(+h[(c[g>>2]|0)+256>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101216]=1;i=d;return}function ffa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101328]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101336,vCa(+h[(c[g>>2]|0)+248>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101328]=1;i=d;return}function gfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101448]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101456,vCa(+h[(c[g>>2]|0)+240>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101448]=1;i=d;return}function hfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101560]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101568,vCa(+h[(c[g>>2]|0)+232>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101560]=1;i=d;return}function ifa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101680]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101688,vCa(+h[(c[g>>2]|0)+2960>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101680]=1;i=d;return}function jfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101776]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(101784,vCa(+h[(c[g>>2]|0)+2952>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101776]=1;i=d;return}function kfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101872]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2944>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2944>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(101880,vCa(+h[(c[g>>2]|0)+2944>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101872]=1;i=d;return}function lfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2936>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(102e3,vCa(+h[(c[g>>2]|0)+2936>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[101992]=1;i=d;return}function mfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102120]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+360>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(102128,xCa(c[(c[g>>2]|0)+360>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[102120]=1;i=d;return}function nfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102328]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+356>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(102336,xCa(c[(c[g>>2]|0)+356>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[102328]=1;i=d;return}function ofa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102544]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(102552,vCa(+h[(c[g>>2]|0)+2928>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[102544]=1;i=d;return}function pfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102640]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(102648,vCa(+h[(c[g>>2]|0)+2920>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[102640]=1;i=d;return}function qfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102744]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(102752,vCa(+h[(c[g>>2]|0)+2896>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[102744]=1;i=d;return}function rfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102832]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2888>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2888>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(102840,vCa(+h[(c[g>>2]|0)+2888>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[102832]=1;i=d;return}function sfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102968]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2880>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2880>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(102976,vCa(+h[(c[g>>2]|0)+2880>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[102968]=1;i=d;return}function tfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103080]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(103088,vCa(+h[(c[g>>2]|0)+2872>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[103080]=1;i=d;return}function ufa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103200]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+224>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+224>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(103208,vCa(+h[(c[g>>2]|0)+224>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[103200]=1;i=d;return}function vfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103320]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2856>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(103328,vCa(+h[(c[g>>2]|0)+2856>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[103320]=1;i=d;return}function wfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103440]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+340>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(103448,xCa(c[(c[g>>2]|0)+340>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[103440]=1;i=d;return}function xfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103656]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+336>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(103664,xCa(c[(c[g>>2]|0)+336>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[103656]=1;i=d;return}function yfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103880]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(103888,vCa(+h[(c[g>>2]|0)+216>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[103880]=1;i=d;return}function zfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103992]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104e3,vCa(+h[(c[g>>2]|0)+208>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[103992]=1;i=d;return}function Afa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104112]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104120,vCa(+h[(c[g>>2]|0)+200>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104112]=1;i=d;return}function Bfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104224]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104232,vCa(+h[(c[g>>2]|0)+192>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104224]=1;i=d;return}function Cfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104344]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104352,vCa(+h[(c[g>>2]|0)+184>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104344]=1;i=d;return}function Dfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104456]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104464,vCa(+h[(c[g>>2]|0)+176>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104456]=1;i=d;return}function Efa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104576]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104584,vCa(+h[(c[g>>2]|0)+168>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104576]=1;i=d;return}function Ffa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104688]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104696,vCa(+h[(c[g>>2]|0)+160>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104688]=1;i=d;return}function Gfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104808]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104816,vCa(+h[(c[g>>2]|0)+2848>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104808]=1;i=d;return}function Hfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104904]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(104912,vCa(+h[(c[g>>2]|0)+2840>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[104904]=1;i=d;return}function Ifa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105e3]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2832>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2832>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(105008,vCa(+h[(c[g>>2]|0)+2832>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105e3]=1;i=d;return}function Jfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105120]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2824>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2824>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(105128,vCa(+h[(c[g>>2]|0)+2824>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105120]=1;i=d;return}function Kfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105248]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+332>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(105256,xCa(c[(c[g>>2]|0)+332>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[105248]=1;i=d;return}function Lfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105456]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+328>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(105464,xCa(c[(c[g>>2]|0)+328>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[105456]=1;i=d;return}function Mfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105672]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(105680,vCa(+h[(c[g>>2]|0)+2816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105672]=1;i=d;return}function Nfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105768]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(105776,vCa(+h[(c[g>>2]|0)+2808>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105768]=1;i=d;return}function Ofa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(105880,vCa(+h[(c[g>>2]|0)+2784>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105872]=1;i=d;return}function Pfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105960]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2776>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2776>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(105968,vCa(+h[(c[g>>2]|0)+2776>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[105960]=1;i=d;return}function Qfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106096]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2768>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2768>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(106104,vCa(+h[(c[g>>2]|0)+2768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[106096]=1;i=d;return}function Rfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106208]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(106216,vCa(+h[(c[g>>2]|0)+2760>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[106208]=1;i=d;return}function Sfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106328]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+152>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+152>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(106336,vCa(+h[(c[g>>2]|0)+152>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[106328]=1;i=d;return}function Tfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106448]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2744>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(106456,vCa(+h[(c[g>>2]|0)+2744>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[106448]=1;i=d;return}function Ufa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106568]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+312>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(106576,xCa(c[(c[g>>2]|0)+312>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[106568]=1;i=d;return}function Vfa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106784]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+308>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(106792,xCa(c[(c[g>>2]|0)+308>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[106784]=1;i=d;return}function Wfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107008]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107016,vCa(+h[(c[g>>2]|0)+144>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107008]=1;i=d;return}function Xfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107120]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107128,vCa(+h[(c[g>>2]|0)+136>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107120]=1;i=d;return}function Yfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107240]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107248,vCa(+h[(c[g>>2]|0)+128>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107240]=1;i=d;return}function Zfa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107352]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107360,vCa(+h[(c[g>>2]|0)+120>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107352]=1;i=d;return}function _fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107472]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107480,vCa(+h[(c[g>>2]|0)+2736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107472]=1;i=d;return}function $fa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107568]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(107576,vCa(+h[(c[g>>2]|0)+2728>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107568]=1;i=d;return}function aga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107664]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2720>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2720>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(107672,vCa(+h[(c[g>>2]|0)+2720>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107664]=1;i=d;return}function bga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107784]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2712>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(107792,vCa(+h[(c[g>>2]|0)+2712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[107784]=1;i=d;return}function cga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107912]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+304>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(107920,xCa(c[(c[g>>2]|0)+304>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[107912]=1;i=d;return}function dga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108120]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+300>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(108128,xCa(c[(c[g>>2]|0)+300>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[108120]=1;i=d;return}function ega(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108336]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(108344,vCa(+h[(c[g>>2]|0)+2704>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108336]=1;i=d;return}function fga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108432]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(108440,vCa(+h[(c[g>>2]|0)+2696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108432]=1;i=d;return}function gga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108536]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(108544,vCa(+h[(c[g>>2]|0)+2672>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108536]=1;i=d;return}function hga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108624]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2664>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2664>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(108632,vCa(+h[(c[g>>2]|0)+2664>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108624]=1;i=d;return}function iga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108760]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2656>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2656>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(108768,vCa(+h[(c[g>>2]|0)+2656>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108760]=1;i=d;return}function jga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(108880,vCa(+h[(c[g>>2]|0)+2648>>3],67480)|0)|0;g=c[72854]|0;j=e;k=109232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[108872]=1;i=d;return}function kga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109040]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(109048,vCa(+h[(c[g>>2]|0)+2632>>3],67480)|0)|0;g=c[72854]|0;j=e;k=109352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[109040]=1;i=d;return}function lga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109136]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(109144,vCa(+h[(c[g>>2]|0)+2616>>3],67480)|0)|0;g=c[72854]|0;j=e;k=109232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[109136]=1;i=d;return}function mga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109256]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(109264,vCa(+h[(c[g>>2]|0)+2600>>3],67480)|0)|0;g=c[72854]|0;j=e;k=109352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[109256]=1;i=d;return}function nga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109376]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+288>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(109384,xCa(c[(c[g>>2]|0)+288>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=109672;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[109376]=1;i=d;return}function oga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109696]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+284>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(109704,xCa(c[(c[g>>2]|0)+284>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=109936;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[109696]=1;i=d;return}function pga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109960]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+280>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(109968,xCa(c[(c[g>>2]|0)+280>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=110184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[109960]=1;i=d;return}function qga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110208]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(110216,vCa(+h[(c[g>>2]|0)+2584>>3],67480)|0)|0;g=c[72854]|0;j=e;k=110304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[110208]=1;i=d;return}function rga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110328]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(110336,vCa(+h[(c[g>>2]|0)+2576>>3],67480)|0)|0;g=c[72854]|0;j=e;k=110424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[110328]=1;i=d;return}function sga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110448]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(110456,vCa(+h[(c[g>>2]|0)+2568>>3],67480)|0)|0;g=c[72854]|0;j=e;k=110552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[110448]=1;i=d;return}function tga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110576]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(110584,vCa(+h[(c[g>>2]|0)+2560>>3],67480)|0)|0;g=c[72854]|0;j=e;k=110672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[110576]=1;i=d;return}function uga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110696]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(110704,vCa(+h[(c[g>>2]|0)+2552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=110800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[110696]=1;i=d;return}function vga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110824]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+276>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(110832,xCa(c[(c[g>>2]|0)+276>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=111056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[110824]=1;i=d;return}function wga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111080]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+272>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(111088,xCa(c[(c[g>>2]|0)+272>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=111304;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[111080]=1;i=d;return}function xga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111328]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(111336,vCa(+h[(c[g>>2]|0)+2520>>3],67480)|0)|0;g=c[72854]|0;j=e;k=111432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[111328]=1;i=d;return}function yga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111456]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(111464,vCa(+h[(c[g>>2]|0)+2512>>3],67480)|0)|0;g=c[72854]|0;j=e;k=111560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[111456]=1;i=d;return}function zga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111584]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(111592,vCa(+h[(c[g>>2]|0)+2504>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[111584]=1;i=d;return}function Aga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111704]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(111712,vCa(+h[(c[g>>2]|0)+112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[111704]=1;i=d;return}function Bga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111824]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2488>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(111832,vCa(+h[(c[g>>2]|0)+2488>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[111824]=1;i=d;return}function Cga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111944]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+264>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(111952,xCa(c[(c[g>>2]|0)+264>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[111944]=1;i=d;return}function Dga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112160]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+260>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(112168,xCa(c[(c[g>>2]|0)+260>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[112160]=1;i=d;return}function Ega(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112384]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(112392,vCa(+h[(c[g>>2]|0)+104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[112384]=1;i=d;return}function Fga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112520]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+96>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(112528,vCa(+h[(c[g>>2]|0)+96>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[112520]=1;i=d;return}function Gga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112664]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(112672,vCa(+h[(c[g>>2]|0)+88>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[112664]=1;i=d;return}function Hga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112800]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(112808,vCa(+h[(c[g>>2]|0)+80>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[112800]=1;i=d;return}function Iga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112944]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(112952,vCa(+h[(c[g>>2]|0)+2480>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[112944]=1;i=d;return}function Jga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113064]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(113072,vCa(+h[(c[g>>2]|0)+2472>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[113064]=1;i=d;return}function Kga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113184]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2464>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(113192,vCa(+h[(c[g>>2]|0)+2464>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[113184]=1;i=d;return}function Lga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113328]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2456>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(113336,vCa(+h[(c[g>>2]|0)+2456>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[113328]=1;i=d;return}function Mga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113480]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+256>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(113488,xCa(c[(c[g>>2]|0)+256>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[113480]=1;i=d;return}function Nga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113688]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+252>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(113696,xCa(c[(c[g>>2]|0)+252>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[113688]=1;i=d;return}function Oga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113904]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(113912,vCa(+h[(c[g>>2]|0)+2448>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[113904]=1;i=d;return}function Pga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114024]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(114032,vCa(+h[(c[g>>2]|0)+2440>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114024]=1;i=d;return}function Qga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114152]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(114160,vCa(+h[(c[g>>2]|0)+2416>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114152]=1;i=d;return}function Rga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114264]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2408>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2408>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(114272,vCa(+h[(c[g>>2]|0)+2408>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114264]=1;i=d;return}function Sga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114400]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2400>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2400>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(114408,vCa(+h[(c[g>>2]|0)+2400>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114400]=1;i=d;return}function Tga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114512]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(114520,vCa(+h[(c[g>>2]|0)+2392>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114512]=1;i=d;return}function Uga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114632]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(114640,vCa(+h[(c[g>>2]|0)+2376>>3],67480)|0)|0;g=c[72854]|0;j=e;k=116992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114632]=1;i=d;return}function Vga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114808]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2368>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(114816,vCa(+h[(c[g>>2]|0)+2368>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[114808]=1;i=d;return}function Wga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114928]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+236>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(114936,xCa(c[(c[g>>2]|0)+236>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[114928]=1;i=d;return}function Xga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115144]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+232>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(115152,xCa(c[(c[g>>2]|0)+232>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[115144]=1;i=d;return}function Yga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115368]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2352>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(115376,vCa(+h[(c[g>>2]|0)+2352>>3],67480)|0)|0;g=c[72854]|0;j=e;k=117704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[115368]=1;i=d;return}function Zga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115496]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+72>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(115504,vCa(+h[(c[g>>2]|0)+72>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[115496]=1;i=d;return}function _ga(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115616]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2344>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(115624,vCa(+h[(c[g>>2]|0)+2344>>3],67480)|0)|0;g=c[72854]|0;j=e;k=117976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[115616]=1;i=d;return}function $ga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115744]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+228>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(115752,xCa(c[(c[g>>2]|0)+228>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[115744]=1;i=d;return}function aha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115952]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+224>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(115960,xCa(c[(c[g>>2]|0)+224>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[115952]=1;i=d;return}function bha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116168]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2320>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(116176,vCa(+h[(c[g>>2]|0)+2320>>3],67480)|0)|0;g=c[72854]|0;j=e;k=118560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116168]=1;i=d;return}function cha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116304]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2312>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(116312,vCa(+h[(c[g>>2]|0)+2312>>3],67480)|0)|0;g=c[72854]|0;j=e;k=118712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116304]=1;i=d;return}function dha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116432]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2304>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2304>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(116440,vCa(+h[(c[g>>2]|0)+2304>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116432]=1;i=d;return}function eha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116568]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2296>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2296>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(116576,vCa(+h[(c[g>>2]|0)+2296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116568]=1;i=d;return}function fha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116680]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(116688,xCa(c[(c[g>>2]|0)+220>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=119072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[116680]=1;i=d;return}function gha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116768]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(116776,vCa(+h[(c[g>>2]|0)+2272>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116768]=1;i=d;return}function hha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116888]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(116896,vCa(+h[(c[g>>2]|0)+2256>>3],67480)|0)|0;g=c[72854]|0;j=e;k=116992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[116888]=1;i=d;return}function iha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117016]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2248>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(117024,vCa(+h[(c[g>>2]|0)+2248>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[117016]=1;i=d;return}function jha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117136]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+212>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(117144,xCa(c[(c[g>>2]|0)+212>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[117136]=1;i=d;return}function kha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117352]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+208>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(117360,xCa(c[(c[g>>2]|0)+208>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[117352]=1;i=d;return}function lha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117576]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2232>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(117584,vCa(+h[(c[g>>2]|0)+2232>>3],67480)|0)|0;g=c[72854]|0;j=e;k=117704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[117576]=1;i=d;return}function mha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117728]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+64>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+64>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(117736,vCa(+h[(c[g>>2]|0)+64>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[117728]=1;i=d;return}function nha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117848]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2224>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(117856,vCa(+h[(c[g>>2]|0)+2224>>3],67480)|0)|0;g=c[72854]|0;j=e;k=117976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[117848]=1;i=d;return}function oha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118e3]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+204>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(118008,xCa(c[(c[g>>2]|0)+204>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[118e3]=1;i=d;return}function pha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118208]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+200>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(118216,xCa(c[(c[g>>2]|0)+200>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[118208]=1;i=d;return}function qha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118424]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2200>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2200>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(118432,vCa(+h[(c[g>>2]|0)+2200>>3],67480)|0)|0;g=c[72854]|0;j=e;k=118560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[118424]=1;i=d;return}function rha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118584]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2192>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(118592,vCa(+h[(c[g>>2]|0)+2192>>3],67480)|0)|0;g=c[72854]|0;j=e;k=118712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[118584]=1;i=d;return}function sha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118736]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2184>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2184>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(118744,vCa(+h[(c[g>>2]|0)+2184>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[118736]=1;i=d;return}function tha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118872]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2176>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2176>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(118880,vCa(+h[(c[g>>2]|0)+2176>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[118872]=1;i=d;return}function uha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118984]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(118992,xCa(c[(c[g>>2]|0)+196>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=119072;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[118984]=1;i=d;return}function vha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119096]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(119104,vCa(+h[(c[g>>2]|0)+2144>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119096]=1;i=d;return}function wha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119240]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2136>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(119248,vCa(+h[(c[g>>2]|0)+2136>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119240]=1;i=d;return}function xha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119368]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(119376,vCa(+h[(c[g>>2]|0)+2128>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119368]=1;i=d;return}function yha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119536]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(119544,vCa(+h[(c[g>>2]|0)+2120>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119536]=1;i=d;return}function zha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119680]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(119688,vCa(+h[(c[g>>2]|0)+2112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119680]=1;i=d;return}function Aha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119776]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2104>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2104>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(119784,vCa(+h[(c[g>>2]|0)+2104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[119776]=1;i=d;return}function Bha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119920]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+192>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(119928,xCa(c[(c[g>>2]|0)+192>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[119920]=1;i=d;return}function Cha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120168]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+188>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(120176,xCa(c[(c[g>>2]|0)+188>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[120168]=1;i=d;return}function Dha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120432]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(120440,vCa(+h[(c[g>>2]|0)+56>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[120432]=1;i=d;return}function Eha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120592]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2096>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2096>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(120600,vCa(+h[(c[g>>2]|0)+2096>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[120592]=1;i=d;return}function Fha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120752]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+184>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(120760,xCa(c[(c[g>>2]|0)+184>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[120752]=1;i=d;return}function Gha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121e3]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+180>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(121008,xCa(c[(c[g>>2]|0)+180>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[121e3]=1;i=d;return}function Hha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121256]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2080>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2080>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(121264,vCa(+h[(c[g>>2]|0)+2080>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[121256]=1;i=d;return}function Iha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121424]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2072>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2072>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(121432,vCa(+h[(c[g>>2]|0)+2072>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[121424]=1;i=d;return}function Jha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121576]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+176>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(121584,xCa(c[(c[g>>2]|0)+176>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[121576]=1;i=d;return}function Kha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121832]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(121840,xCa(c[(c[g>>2]|0)+172>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[121832]=1;i=d;return}function Lha(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122088]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(122096,xCa(c[(c[g>>2]|0)+168>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=132128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[122088]=1;i=d;return}function Mha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122344]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2056>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(122352,vCa(+h[(c[g>>2]|0)+2056>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122344]=1;i=d;return}function Nha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122488]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2048>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(122496,vCa(+h[(c[g>>2]|0)+2048>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122488]=1;i=d;return}function Oha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122616]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(122624,vCa(+h[(c[g>>2]|0)+2040>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122616]=1;i=d;return}function Pha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122712]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2032>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2032>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(122720,vCa(+h[(c[g>>2]|0)+2032>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122712]=1;i=d;return}function Qha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122856]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+2024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(122864,vCa(+h[(c[g>>2]|0)+2024>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122856]=1;i=d;return}function Rha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122952]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2016>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2016>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(122960,vCa(+h[(c[g>>2]|0)+2016>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[122952]=1;i=d;return}function Sha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123096]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+2e3>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+2e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(123104,vCa(+h[(c[g>>2]|0)+2e3>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123096]=1;i=d;return}function Tha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123240]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1992>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1992>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(123248,vCa(+h[(c[g>>2]|0)+1992>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123240]=1;i=d;return}function Uha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123368]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(123376,vCa(+h[(c[g>>2]|0)+1984>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123368]=1;i=d;return}function Vha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123464]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1976>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1976>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(123472,vCa(+h[(c[g>>2]|0)+1976>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123464]=1;i=d;return}function Wha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123608]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(123616,vCa(+h[(c[g>>2]|0)+1968>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123608]=1;i=d;return}function Xha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123704]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1960>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1960>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(123712,vCa(+h[(c[g>>2]|0)+1960>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123704]=1;i=d;return}function Yha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123848]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1944>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(123856,vCa(+h[(c[g>>2]|0)+1944>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123848]=1;i=d;return}function Zha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1936>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1936>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(124e3,vCa(+h[(c[g>>2]|0)+1936>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[123992]=1;i=d;return}function _ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124120]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(124128,vCa(+h[(c[g>>2]|0)+1928>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124120]=1;i=d;return}function $ha(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124216]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1920>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(124224,vCa(+h[(c[g>>2]|0)+1920>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124216]=1;i=d;return}function aia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124360]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(124368,vCa(+h[(c[g>>2]|0)+1912>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124360]=1;i=d;return}function bia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124456]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1904>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(124464,vCa(+h[(c[g>>2]|0)+1904>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124456]=1;i=d;return}



function xxa(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Me[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 3:case 4:{B=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;C=1;c[t>>2]=exa(y+416|0,e,B,B+(Ce[c[e+32>>2]&127](e,B)|0)|0)|0;if((c[t>>2]|0)==0){D=89;break a}c[y+432>>2]=c[y+428>>2];E=Axa(y,e,c[m>>2]|0,t,s)|0;if((E|0)!=0){D=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Je[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);C=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ke[c[y+56>>2]&255](c[y+4>>2]|0,c[t>>2]|0);C=0}do{if((C&255|0)!=0){if((c[y+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Bwa(y+416|0);while(1){if((c[s>>2]|0)==0){break}C=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ke[c[y+104>>2]&255](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){D=107;break a}break};case-2:{D=28;break a;break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){F=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{F=me[c[C+12>>2]&127](48)|0;if((F|0)==0){D=72;break a}c[F+36>>2]=me[c[y+12>>2]&127](32)|0;if((c[F+36>>2]|0)==0){D=74;break a}c[F+40>>2]=(c[F+36>>2]|0)+32}c[F+44>>2]=0;c[F>>2]=c[y+364>>2];c[y+364>>2]=F;c[F+16>>2]=0;c[F+20>>2]=0;c[F+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[F+8>>2]=Ce[c[e+32>>2]&127](e,c[F+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[F+4>>2]|0)+(c[F+8>>2]|0)|0;c[r>>2]=c[F+4>>2];c[q>>2]=c[F+36>>2];while(1){ge[c[e+60>>2]&31](e,r,C,q,(c[F+40>>2]|0)+ -1|0);G=(c[q>>2]|0)-(c[F+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}B=(c[F+40>>2]|0)-(c[F+36>>2]|0)<<1;H=Ce[c[y+16>>2]&127](c[F+36>>2]|0,B)|0;if((H|0)==0){D=80;break a}c[F+36>>2]=H;c[F+40>>2]=H+B;c[q>>2]=H+G}c[F+24>>2]=G;c[F+12>>2]=c[F+36>>2];a[c[q>>2]|0]=0;I=Axa(y,e,c[m>>2]|0,F+12|0,F+44|0)|0;if((I|0)!=0){D=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){Je[c[C+52>>2]&15](c[y+4>>2]|0,c[F+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Bwa(y+416|0);break};case 9:{a[p]=pe[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){Je[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=exa(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){D=37;break a}H=Xwa(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){D=40;break}if((H|0)!=0){break}B=y;if((c[y+120>>2]|0)!=0){Je[c[B+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[B+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{D=40}}while(0);if((D|0)==40){D=0;if((H|0)==0){D=41;break a}if((a[H+34|0]|0)==0){D=43;break a}}if((a[H+32|0]|0)!=0){D=50;break a}if((c[H+28>>2]|0)!=0){D=52;break a}C=y;if((c[H+4>>2]|0)!=0){B=y;if((a[C+308|0]|0)!=0){J=rxa(B,H,0)|0;if((J|0)!=0){D=60;break a}else{break b}}K=y;if((c[B+120>>2]|0)!=0){Je[c[K+120>>2]&15](c[y+4>>2]|0,c[H>>2]|0,0);break b}if((c[K+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[H+32|0]=1;C=zxa(y)|0;a[H+32|0]=0;if((C|0)==0){D=63;break a}if((De[c[y+112>>2]&63](c[y+116>>2]|0,C,c[H+20>>2]|0,c[H+16>>2]|0,c[H+24>>2]|0)|0)==0){D=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{D=24;break a;break};case-1:{D=25;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){D=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;K=Ce[c[e+32>>2]&127](e,L)|0;if((K|0)!=(c[C+8>>2]|0)){D=112;break a}if((h5a(c[C+4>>2]|0,L,K)|0)!=0){D=112;break a}K=y+312|0;c[K>>2]=(c[K>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){K=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((K|0)==0){break}B=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[K]|0)==0){break}M=K;K=M+1|0;N=B;B=N+1|0;a[N]=a[M]|0}M=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((M|0)==0){break}N=B;B=N+1|0;a[N]=a[y+472|0]|0;while(1){if((a[M]|0)==0){break c}N=M;M=N+1|0;O=B;B=O+1|0;a[O]=a[N]|0}}}while(0);a[B]=0}}while(0);ke[c[y+56>>2]&255](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}H=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){ke[c[y+104>>2]&255](c[y+4>>2]|0,c[c[H>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[H+4>>2]=c[y+376>>2];c[y+376>>2]=H;c[(c[H>>2]|0)+4>>2]=c[H+8>>2]}if((c[y+312>>2]|0)==0){D=133;break a}break};case 12:{D=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Je[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{C=Ce[c[e+44>>2]&127](e,c[m>>2]|0)|0;if((C|0)<0){D=135;break a}H=y;if((c[y+60>>2]|0)!=0){K=c[H+60>>2]|0;M=c[y+4>>2]|0;N=Oxa(C,u)|0;Je[K&15](M,u,N);break b}if((c[H+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{H=y;do{if((c[y+72>>2]|0)!=0){je[c[H+72>>2]&1023](c[y+4>>2]|0)}else{if((c[H+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);P=Cxa(y,e,n,g,h,j)|0;if((P|0)!=0){D=150;break a}if((c[n>>2]|0)==0){D=152;break a}break};case-5:{D=153;break a;break};case 6:{H=c[y+60>>2]|0;if((H|0)==0){if((c[y+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Je[H&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ge[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Je[H&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((txa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=174;break a}break};case 13:{if((uxa(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=176;break a}break};case-3:{D=6;break a;break};case-4:{D=17;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Swa(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){D=180;break}else if((f|0)==2){D=181;break}}if((D|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Je[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=g;Q=0;R=Q;i=l;return R|0}}else if((D|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}if((b|0)<=0){Q=3;R=Q;i=l;return R|0}if((c[y+312>>2]|0)!=(b|0)){Q=13;R=Q;i=l;return R|0}else{c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}}else if((D|0)==24){c[z>>2]=c[n>>2];Q=4;R=Q;i=l;return R|0}else if((D|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=5;R=Q;i=l;return R|0}}else if((D|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}else{Q=6;R=Q;i=l;return R|0}}else if((D|0)==37){Q=1;R=Q;i=l;return R|0}else if((D|0)==41){Q=11;R=Q;i=l;return R|0}else if((D|0)==43){Q=24;R=Q;i=l;return R|0}else if((D|0)==50){Q=12;R=Q;i=l;return R|0}else if((D|0)==52){Q=15;R=Q;i=l;return R|0}else if((D|0)==60){Q=J;R=Q;i=l;return R|0}else if((D|0)==63){Q=1;R=Q;i=l;return R|0}else if((D|0)==65){Q=21;R=Q;i=l;return R|0}else if((D|0)==72){Q=1;R=Q;i=l;return R|0}else if((D|0)==74){je[c[y+20>>2]&1023](F);Q=1;R=Q;i=l;return R|0}else if((D|0)==80){Q=1;R=Q;i=l;return R|0}else if((D|0)==82){Q=I;R=Q;i=l;return R|0}else if((D|0)==89){Q=1;R=Q;i=l;return R|0}else if((D|0)==91){Q=E;R=Q;i=l;return R|0}else if((D|0)==107){Q=Bxa(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((D|0)==109){Q=13;R=Q;i=l;return R|0}else if((D|0)==112){c[z>>2]=L;Q=7;R=Q;i=l;return R|0}else if((D|0)==133){Q=Bxa(y,c[n>>2]|0,g,h)|0;R=Q;i=l;return R|0}else if((D|0)==135){Q=14;R=Q;i=l;return R|0}else if((D|0)==140){Q=17;R=Q;i=l;return R|0}else if((D|0)==150){Q=P;R=Q;i=l;return R|0}else if((D|0)==152){c[y+280>>2]=42;Q=P;R=Q;i=l;return R|0}else if((D|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];Q=0;R=Q;i=l;return R|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Je[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ge[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Je[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Swa(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;Q=3;R=Q;i=l;return R|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;Q=13;R=Q;i=l;return R|0}else{c[h>>2]=m;Q=0;R=Q;i=l;return R|0}}else if((D|0)==174){Q=1;R=Q;i=l;return R|0}else if((D|0)==176){Q=1;R=Q;i=l;return R|0}else if((D|0)==180){c[h>>2]=c[n>>2];Q=0;R=Q;i=l;return R|0}else if((D|0)==181){Q=35;R=Q;i=l;return R|0}return 0}function yxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Me[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=cxa(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=xxa(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Me[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=cxa(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=xxa(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function zxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Uwa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Vwa(e,b+60|0);a:while(1){k=Wwa(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Vwa(e,b);b:while(1){b=Wwa(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Uwa(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function Axa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Xwa(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Dwa(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Xwa(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Gxa(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Me[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=Ce[c[k+16>>2]&127](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Me[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=ixa(k,b,v,w+(Ce[c[b+32>>2]&127](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=exa(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=mxa(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=$wa(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=$wa(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=Ce[c[k+16>>2]&127](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Xwa(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Uwa(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Uwa(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Uwa(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=me[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;o5a(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}je[c[k+20>>2]&1023](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;o5a(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;o5a(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Bxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Me[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case 0:{k=14;break a;break};case 11:{if((txa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}Swa(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 13:{if((uxa(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-4:{k=7;break a;break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Swa(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Cxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Me[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Je[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Swa(o,b,c[k>>2]|0,c[l>>2]|0);break};case-2:{r=25;break a;break};case 0:{r=24;break a;break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Swa(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Je[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ge[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Je[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){je[c[n+76>>2]&1023](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Swa(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Dxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Cxa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=Exa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=gxa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Exa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=xxa(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Fxa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Fxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=Ce[c[d+16>>2]&127](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}o5a(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Gxa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Uwa(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Uwa(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Xwa(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Hxa(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Me[c[b+16>>2]&63](b,f,g,l)|0){case-1:{o=7;break a;break};case 10:{p=Ce[c[b+44>>2]&127](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=Oxa(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Uwa(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case-4:{o=3;break a;break};case 9:{q=(pe[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Uwa(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=exa(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=Xwa(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=Hxa(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 6:{if((kxa(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 0:{o=4;break a;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Uwa(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Ixa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((pe[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Pxa()|0;c[g+240>>2]=me[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Me[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){je[c[f+1032>>2]&1023](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}je[c[f+1032>>2]&1023](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Jxa(){var a=0,b=0;a=i;i=i+8|0;ec(((vc(0)|0)>>>0)%4294967295|0|0);b=u5a()|0;i=a;return b|0}function Kxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=axa(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=bxa(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Lxa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=me[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Mxa(f+80|0,e);Mxa(b+104|0,e);Nxa(b,e);Nxa(b+20|0,e);Nxa(b+40|0,e);Nxa(b+60|0,e);a[b+131|0]=0;Nxa(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Mxa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Nxa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Oxa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Pxa(){i=i;return 1912}function Qxa(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[238696+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[238772+l|0]|0|0)!=28){if((d[238772+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[238772+q|0]|0|0)!=28){if((d[238772+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[238772+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Rxa(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[232864+(((d[232608+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[232864+(((d[234144+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Oxa(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=51;c[h+336>>2]=51;c[h+340>>2]=51;c[h+344>>2]=52;c[h+348>>2]=52;c[h+352>>2]=52;c[h+356>>2]=53;c[h+360>>2]=53;c[h+364>>2]=53}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function Rxa(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 0:{if((d[238772+c|0]|0|0)!=0){f=7;break a}e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Sxa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ce[c[f+368>>2]&127](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[232864+(((d[234144+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Txa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ce[c[f+368>>2]&127](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[232864+(((d[232608+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Uxa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=Ce[c[e+368>>2]&127](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Rxa(a)|0)<0;g=f&1;i=d;return g|0}function Vxa(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Oxa(Ce[c[h+368>>2]&127](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Wxa(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(Ce[c[h+368>>2]&127](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Xxa(){i=i;return 238328}function Yxa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Zxa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=80;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Zxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((lya(d,c[238232+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function _xa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=jAa(236672,a,0,b,c,d)|0;i=e;return f|0}function $xa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=jAa(236672,a,1,b,c,d)|0;i=e;return f|0}function aya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Iza(237440,b,c,d);i=a;return}function bya(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=cya(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function cya(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(kAa(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Me[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,238176)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((kAa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Me[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,238184)|0)!=0){h=lAa(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=pe[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((kAa(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Me[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,238200)|0)!=0){if((a|0)!=0){break}do{if((Me[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,238216)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Me[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,238224)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((mAa(lAa(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function dya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ge[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((lya(h,234400)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Zxa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[236672+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function eya(){i=i;return 236304}function fya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Zxa(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=80;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function gya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=jAa(234408,a,0,b,c,d)|0;i=e;return f|0}function hya(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=jAa(234408,a,1,b,c,d)|0;i=e;return f|0}function iya(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=cya(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function jya(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ge[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((lya(h,234400)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Zxa(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[234408+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function kya(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Qxa(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function lya(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function mya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 12:{k=Pya(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Dya(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 16:{k=Qya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=Lya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=25;break};case 13:{k=Pya(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=Fya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{p=19;b=b+2|0;n=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 19:{k=Rya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;p=18;n=77;break a}if((c[232864+((d[234144+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;p=19;n=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{p=18;b=b+2|0;n=77;break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=Dya(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=Dya(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Dya(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 33:{n=119;break b;break};case 34:{n=116;break b;break};case 23:{b=b+2|0;r=p;if((r|0)==41){p=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}p=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Dya(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 6:{n=108;break b;break};case 7:{n=111;break b;break};case 5:{n=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{p=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 7:{n=91;break b;break};case 15:{n=122;break b;break};case 6:{n=88;break b;break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};case 5:{n=85;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=p;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-p|0;l=k;i=h;return l|0}}return 0}function nya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 3:{k=Eya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=Iya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Dya(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Dya(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function oya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Dya(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Dya(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function pya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Dya(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function qya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Dya(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 2:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Eya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Dya(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function rya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Dya(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 9:{n=21;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Eya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Fya(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Dya(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function sya(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Dya(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 5:{break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=Dya(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function tya(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function uya(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Dya(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function vya(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Dya(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function wya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Dya(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Dya(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function xya(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Rxa(c)|0;k=j;i=b;return k|0}function yya(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==108){f=60;g=f;i=b;return g|0}else if((h|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function zya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Dya(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Dya(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Aya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Dya(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Bya(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Cya(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Dya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function Eya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 19:{k=Gya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Dya(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Fya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Dya(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Gya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Hya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Dya(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Hya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Dya(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Dya(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Iya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Dya(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=Jya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Kya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Mya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Lya(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Dya(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Dya(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 24:case 22:{break};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 11:{o=90;break b;break};case 6:{o=42;break b;break};case 7:{o=45;break b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Dya(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 5:{o=78;break d;break};case 17:{break c;break};case 7:{o=84;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Nya(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Jya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Dya(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Kya(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[234808+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Lya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Dya(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Dya(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 7:{p=34;break b;break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Oya(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Dya(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Oya(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Mya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Dya(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 23:{b=b+2|0;continue b;break};case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Dya(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Nya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Dya(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[232864+((d[234144+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Dya(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 7:{l=36;break a;break};case 6:{l=33;break a;break};case 29:{if((c[232864+((d[232608+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=Dya(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=Dya(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=Dya(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 3:{t=Eya(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=Dya(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=Dya(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 7:{l=103;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[232864+((d[232608+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Oya(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Pya(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Dya(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Dya(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Qya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Dya(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Dya(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=Jya(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Rya(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Dya(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[232864+((d[232608+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Dya(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 29:{if((c[232864+((d[234144+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}



function fGa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;o5a(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[241676>>2]|0)==0){J=b+4|0}else{aUa(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];MBa(17,1,276864,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];MBa(17,1,276936,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];MBa(17,0,276952,t);je[c[60540]&1023](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}je[c[60540]&1023](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];gGa(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){aUa(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];BDa(3,g,P);}$=+fEa(H,c[b>>2]|0);aa=+fEa(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){o5a(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;MBa(17,0,277128,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;MBa(17,0,277184,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;MBa(17,0,277248,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[241676>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;MBa(17,0,277e3,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];MBa(17,0,277040,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];MBa(17,0,277096,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){aUa(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];BDa(0,f,L);if((c[241676>>2]|0)==0){da=0;break}c[m>>2]=V;MBa(17,0,277328,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(17,0,277040,l);if((c[241676>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(17,0,277096,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[241676>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;o5a(ma|0,oa|0,qa|0)|0;i=e;return da|0}je[c[60540]&1023](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;o5a(ma|0,oa|0,qa|0)|0;i=e;return da|0}function gGa(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[241680>>2]|0)!=0){c[z>>2]=j;MBa(18,0,277368,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];MBa(18,0,277416,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){hGa(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){iGa(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{eGa(E,m,r)|0}if((c[241684>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;MBa(19,1,277432,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];kc(F|0,277456,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;MBa(19,0,277464,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}je[c[60540]&1023](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+fEa(b,_);if(!(!(J<=H)&!(+fEa(b,e)<=H))){$=31;break}qwa(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;OBa(17,0,277472,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;OBa(17,0,277504,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+fEa(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function hGa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ne[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&127](e,a,b,d);i=g;return 0}function iGa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+xd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;hGa(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function jGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){f=xEa(a,b)|0;i=d;return f|0}else if((e|0)==4){ye[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;lGa(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==2){kGa(a,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function kGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[277536+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[277536+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];me[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function lGa(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function mGa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=aCa(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==4){j=c[2148]|0;k=K4a(j<<2)|0;c[69398]=k;if((j|0)<=0){l=0;break}m=c[b+116>>2]|0;n=k;k=0;while(1){c[n+(k<<2)>>2]=M4a(m,8)|0;o=k+1|0;if((o|0)>=(j|0)){l=0;break a}n=c[69398]|0;k=o}}else if((g|0)==3){k=K4a(88)|0;MBa(23,0,277568,f);n=vEa(b,d,k)|0;c[d+48>>2]=k;l=n}else if((g|0)==2){n=K4a(8)|0;c[n+4>>2]=4;k=K4a(20)|0;c[n>>2]=k;j=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=M4a(j,8)|0;if((k|0)>=4){break}m=c[n>>2]|0;k=k+1|0}c[d+48>>2]=n;l=0}else{l=0}}while(0);zGa(b)|0;if((c[2]|0)==0){i=e;return l|0}xDa(6);uDa(1);i=e;return l|0}function nGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){wEa(c[b+48>>2]|0)|0}else if((e|0)==4){f=c[2148]|0;g=c[69398]|0;if((f|0)>0){h=g;j=0;while(1){L4a(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[69398]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}L4a(m)}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){L4a(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}L4a(n);L4a(c[e>>2]|0)}AGa(a)|0;uGa(a);i=d;return 0}function oGa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(648,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=z5a(c[s>>2]|0,o)|0;if((t|0)==0){gb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=z5a(c[s>>2]|0,o)|0;if((B|0)==0){gb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=z5a(c[C>>2]|0,o)|0;if((D|0)==0){gb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=z5a(c[C>>2]|0,o)|0;if((E|0)==0){gb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=z5a(c[s>>2]|0,o)|0;if((F|0)==0){gb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(649,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=z5a(c[s>>2]|0,o)|0;if((G|0)==0){gb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=z5a(c[s>>2]|0,o)|0;if((H|0)==0){gb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;l5a(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=z5a(c[L>>2]|0,o)|0;if((M|0)==0){gb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ka(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=z5a(c[p>>2]|0,o)|0;if((N|0)==0){gb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Ta(14,1,0,277600,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=z5a(c[M>>2]|0,o)|0;if((U|0)==0){gb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=z5a(c[M>>2]|0,o)|0;if((V|0)==0){gb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Ta(15,2,0,277696,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=z5a(c[M>>2]|0,o)|0;if((X|0)==0){gb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[283816>>2]|0,283792,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=z5a(c[M>>2]|0,o)|0;if((Y|0)==0){gb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Ta(15,23,0,277752,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=z5a(c[M>>2]|0,o)|0;if((Z|0)==0){gb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(650,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=z5a(c[M>>2]|0,o)|0;if(($|0)==0){gb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function pGa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];MBa(8,0,277848,G);I=b+313|0;a[I]=1;VEa(b);if((c[299124>>2]|0)==0){ke[c[283812>>2]&255](283792,b)}a[I]=0}}while(0);if((e|0)!=0){qGa(Ed(e|0)|0,b)}if((c[241708>>2]|0)==0){i=f;return 0}xDa(0);MBa(25,0,277896,F);MBa(25,1,277920,E);H=+pDa(6);J=+pDa(6);K=J/+pDa(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];MBa(25,0,277928,D);K=+pDa(1);H=+pDa(1);J=H/+pDa(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];MBa(25,0,277968,C);J=+pDa(2);K=+pDa(2);H=K/+pDa(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(25,0,278e3,B);H=+pDa(3);J=+pDa(3);K=J/+pDa(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];MBa(25,0,278024,A);K=+pDa(4);H=+pDa(4);J=H/+pDa(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(25,0,278064,z);J=+pDa(7);K=+pDa(7);H=K/+pDa(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(25,0,278096,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+pDa(0);J=H- +pDa(7);H=J- +pDa(4);J=H- +pDa(3);H=J- +pDa(2);J=H- +pDa(1);H=J- +pDa(6);J=+pDa(0);K=J- +pDa(7);J=K- +pDa(4);K=J- +pDa(3);J=K- +pDa(2);K=J- +pDa(1);J=K- +pDa(6);K=J/+pDa(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(25,0,278160,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];MBa(25,0,278128,x)}K=+pDa(0);H=+pDa(0);J=H/+pDa(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];MBa(25,0,278192,v);je[c[60540]&1023](25);MBa(25,1,278216,u);c[t>>2]=c[d+40>>2];MBa(25,0,278224,t);c[s>>2]=c[d+44>>2];MBa(25,0,278248,s);je[c[60540]&1023](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);MBa(25,1,278272,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];MBa(25,0,278288,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];MBa(25,0,278304,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];MBa(25,0,278336,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];MBa(25,0,278368,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];MBa(25,0,278392,m);je[c[60540]&1023](25)}else if((s|0)!=5){MBa(25,1,278424,l);MBa(25,0,278432,j);je[c[60540]&1023](25)}MBa(25,0,278496,g);uDa(0);i=f;return 0}function qGa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=_b(b|0,278968)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Ad(b|0,278976,y|0)|0;if((z|0)==0){C=Wd(10,b|0)|0;D=yd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Ad(b|0,278992,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;Ad(b|0,279008,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;Ad(b|0,279016,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;Ad(b|0,279024,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((i5a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Ad(b|0,278992,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Ad(b|0,278992,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((i5a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;Ad(b|0,279008,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;Ad(b|0,279008,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((i5a(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;Ad(b|0,279016,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;Ad(b|0,279016,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((i5a(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;Ad(b|0,279024,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Ad(b|0,278992,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;Ad(b|0,279008,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;Ad(b|0,279016,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((i5a(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;Ad(b|0,279024,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=_b(0,278968)|0;}while((d|0)!=0);C=Wd(10,b|0)|0;D=yd(b|0)|0;i=e;return}function rGa(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[2146]|0;if((v|0)!=0){if((i5a(v,278632)|0)==0){break a}}MBa(23,0,278648,p);w=1;i=m;return w|0};case 5:{OBa(1,0,278592,q);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 18:{v=c[2146]|0;do{if((v|0)!=0){if((i5a(v,278776)|0)!=0){break}c[u>>2]=4;break a}}while(0);MBa(23,0,278800,o);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{OBa(1,0,278520,r);w=1;i=m;return w|0};default:{}}}while(0);r=mGa(a,s)|0;He[c[242756>>2]&7]()|0;do{if((r|0)==0){o=oGa(a,b,d,e,f,g)|0;He[c[242756>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){ke[c[283812>>2]&255](283792,a);dFa(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];MBa(23,0,278928,n);o=Ce[c[c[a+540>>2]>>2]&127](a,t)|0;He[c[242756>>2]&7]()|0;pGa(a,s,l)|0;He[c[242756>>2]&7]()|0;x=o}else{He[c[242756>>2]&7]()|0;x=r}}while(0);nGa(a,s)|0;w=x;i=m;return w|0}function sGa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){tGa(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((me[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){QBa(c[a+536>>2]|0,279040,d)}else if((k|0)==6){tGa(a);i=b;return}}function tGa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;q5a(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function uGa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;L4a(c[f+(a*48|0)+28>>2]|0);L4a(c[f+(a*48|0)+32>>2]|0);L4a(c[f+(a*48|0)+16>>2]|0);L4a(c[f+(a*48|0)+20>>2]|0);L4a(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function vGa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=K4a(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=K4a(c[y>>2]<<2)|0;wGa(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;o5a(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;o5a(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((uEa(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=xGa(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){o5a(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;o5a(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;L4a(x);L4a(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;OBa(5,1,279096,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];kc(q|0,279128,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;OBa(5,0,279136,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=242160;K=c[60540]|0;je[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=7;_=Z;$=279144;aa=$;QBa(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];OBa(5,0,279136,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=242160;K=c[60540]|0;je[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=7;_=Z;$=279144;aa=$;QBa(O,aa,g);return 0}function wGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;q5a(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}me[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function xGa(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=M4a(d,4)|0;r=M4a(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;L4a(q);L4a(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;L4a(q);L4a(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){L4a(q);L4a(r);i=o;return v|0}if((n|0)==0){v=-1;L4a(q);L4a(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(5,1,279248,p);yGa(s,d,f,c[g>>2]|0,j,l,m);if((c[241628>>2]|0)==0){v=-1;L4a(q);L4a(r);i=o;return v|0}je[c[60540]&1023](5);v=-1;L4a(q);L4a(r);i=o;return v|0}function yGa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;q5a(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];MBa(5,0,279280,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function zGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=lc(279296,279320)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=gd(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;rb(n|0);do{}while((gd(n|0)|0)!=10);q=c[b+152>>2]|0;r=M4a(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=M4a(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=M4a(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Sd(n|0,279328,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Sd(n|0,279328,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=M4a(s,8)|0;x=v}}while(0);jc(279336,j|0)|0;jc(279392,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];jc(279352,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];jc(279376,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}vb(279392)|0;$c(n|0)|0;c[b+460>>2]=0;i=d;return 0}function AGa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}L4a(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){L4a(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}L4a(l);i=d;return 0}function BGa(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function CGa(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+DGa(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[241644>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];MBa(9,1,279456,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(9,0,279568,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}je[c[60540]&1023](9);g=1;i=b;return g|0}function DGa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;SGa(b);g=f+540|0;me[c[(c[g>>2]|0)+84>>2]&127](f)|0;me[c[(c[g>>2]|0)+36>>2]&127](f)|0;me[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;Ce[c[(c[g>>2]|0)+68>>2]&127](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function EGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+DGa(b,1.0);if((c[241644>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}MBa(9,1,279592,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(9,0,279656,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(9,0,279616,s)}MBa(9,1,279680,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;MBa(9,0,279752,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];MBa(9,0,279704,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;MBa(9,0,279840,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(9,0,279776,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;MBa(9,0,279928,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];MBa(9,0,279872,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}je[c[60540]&1023](9);MBa(9,1,279960,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=me[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;MBa(9,0,279752,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];MBa(9,0,279704,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}je[c[60540]&1023](9);je[c[60540]&1023](9);i=d;return}function FGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[241644>>2]|0)!=0){eFa(b,9)}if((c[241704>>2]|0)==0){i=d;return}MBa(24,1,279984,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){MBa(24,1,280024,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(24,0,280048,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}je[c[60540]&1023](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}MBa(24,1,280104,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(24,0,280128,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}je[c[60540]&1023](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){MBa(24,1,280160,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(24,0,280048,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}je[c[60540]&1023](24)}p=b+124|0;if((c[p>>2]|0)>0){MBa(24,1,280184,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;MBa(24,0,280208,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}je[c[60540]&1023](24)}H=b+128|0;if((c[H>>2]|0)>0){MBa(24,1,280256,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?280328:280336;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?280328:280336;t=(a[(c[l>>2]|0)+n|0]|0)!=0?280328:280336;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;MBa(24,0,280280,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}je[c[60540]&1023](24)}n=b+132|0;if((c[n>>2]|0)>0){MBa(24,1,280344,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;MBa(24,0,280368,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}je[c[60540]&1023](24)}je[c[60540]&1023](24);i=d;return}function GGa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;MBa(9,0,280416,z);if((f|0)==0){bFa(b);cFa(b);C=6}else{if((a[f]|0)!=0){HGa(b,f,g)}bFa(b);cFa(b);if((a[f]|0)==0){C=6}}if((C|0)==6){me[c[(c[A>>2]|0)+84>>2]&127](b)|0;me[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(i5a(d,281904)|0)==0|0;f=(i5a(d,281912)|0)==0;z=(i5a(d,281920)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;OBa(1,0,280464,y);OBa(1,0,280496,x);c[w>>2]=281904;c[w+4>>2]=281712;OBa(1,0,280520,w);c[v>>2]=281912;c[v+4>>2]=281792;OBa(1,0,280520,v);c[u>>2]=281920;c[u+4>>2]=281840;OBa(1,0,280520,u);QBa(c[b+536>>2]|0,280552,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(i5a(e,c[280576+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;OBa(1,0,280608,s);OBa(1,0,280496,r);t=1;do{u=c[280640+(t<<2)>>2]|0;c[q>>2]=c[280576+(t<<2)>>2];c[q+4>>2]=u;OBa(1,0,280520,q);t=t+1|0;}while((t|0)<7);QBa(c[b+536>>2]|0,280552,p)}}while(0);p=c[280536+(D<<2)>>2]|0;c[o>>2]=c[280448+(D<<2)>>2];c[o+4>>2]=p;MBa(9,0,280672,o);o=(D|0)==2;if(o){p=c[280640+(F<<2)>>2]|0;c[n>>2]=c[280576+(F<<2)>>2];c[n+4>>2]=p;MBa(9,0,280712,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=IGa(b,F,j)|0;break}if((D|0)==3){JGa(b,j);I=0;break}else{QBa(c[b+536>>2]|0,280752,m)}}}while(0);if((UFa(b,1)|0)!=0){J=-2;FGa(b);K=15;L=K;M=280776;N=M;MBa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];MEa(b,R,V);W=645;_Ea(b);X=651;dFa(b);Y=646;VEa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=me[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ce[ha&127](b,1)|0;ja=654;$Ea(b);i=k;return J|0}if((KFa(b,1)|0)!=0){J=-3;FGa(b);K=15;L=K;M=280776;N=M;MBa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];MEa(b,R,V);W=645;_Ea(b);X=651;dFa(b);Y=646;VEa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=me[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ce[ha&127](b,1)|0;ja=654;$Ea(b);i=k;return J|0}m=(xFa(b,1)|0)==0;J=m?I:-4;FGa(b);K=15;L=K;M=280776;N=M;MBa(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];MEa(b,R,V);W=645;_Ea(b);X=651;dFa(b);Y=646;VEa(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=me[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ce[ha&127](b,1)|0;ja=654;$Ea(b);i=k;return J|0}function HGa(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(9,0,281936,z);z=FCa(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;QBa(C,281976,y)}MBa(9,0,282016,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=GCa(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=MGa(c[d+(C*112|0)+4>>2]|0)|0;E=GCa(A,D)|0;L4a(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((j5a(E,282056,6)|0)==0){if((c[241644>>2]|0)==0){break}}else{D=j5a(E,282064,6)|0;if((c[241644>>2]|D|0)==0){break}}c[v>>2]=E;OBa(9,0,282072,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;MCa(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(9,0,282040,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}MBa(9,0,282128,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=GCa(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=MGa(c[G+(w*112|0)+4>>2]|0)|0;v=GCa(A,F)|0;L4a(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];OBa(9,0,282152,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;MCa(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];MBa(9,0,282040,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}MBa(9,0,282208,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=GCa(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=MGa(c[t+(x*112|0)+4>>2]|0)|0;K=GCa(A,C)|0;L4a(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];OBa(9,0,282152,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;MCa(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];MBa(9,0,282040,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}MBa(9,0,282232,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=GCa(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=MGa(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=GCa(A,u)|0;L4a(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];OBa(9,0,282280,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;MCa(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;MBa(9,0,282264,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}MBa(9,0,282336,l);l=b+144|0;if((c[l>>2]|0)<=0){DCa(A);i=f;return}o=b+32|0;b=0;do{x=GCa(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=MGa(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=GCa(A,n)|0;L4a(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];OBa(9,0,282384,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;MCa(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?280328:280336;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;MBa(9,0,282368,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));DCa(A);i=f;return}function IGa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;LEa(a,+h[a+240>>3]);_Ea(a);dFa(a);VEa(a);fFa(a);tGa(a);WEa(a);_Ea(a);e=KGa(a,b,c)|0;dFa(a);VEa(a);$Ea(a);dFa(a);i=d;return e|0}function JGa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;LEa(b,+h[b+240>>3]);_Ea(b);dFa(b);vGa(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=M4a(c[y>>2]|0,8)|0;A=b+124|0;B=M4a(c[A>>2]|0,4)|0;C=b+128|0;D=M4a(c[C>>2]|0,1)|0;E=b+132|0;F=M4a(c[E>>2]|0,4)|0;G=b+536|0;PBa(c[G>>2]|0,(z|0)!=0|0,280808,t);PBa(c[G>>2]|0,(B|0)!=0|0,280808,s);PBa(c[G>>2]|0,(D|0)!=0|0,280808,r);PBa(c[G>>2]|0,(F|0)!=0|0,280808,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[241644>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];kc(x|0,280824,p|0)|0;p=lc(x|0,280840)|0;c[o>>2]=280856;Ad(p|0,280848,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];Ad(p|0,280848,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Wd(10,p|0)|0;H=p}MBa(9,1,280864,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;me[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(9,0,280888,l);if((c[241644>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ad(H|0,280912,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Ad(H|0,280912,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Wd(10,H|0)|0}if((UFa(b,0)|0)!=0){break a}if((KFa(b,0)|0)!=0){break a}if((xFa(b,0)|0)!=0){break a}gFa(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);je[c[60540]&1023](9);if((c[241644>>2]|0)!=0){$c(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}L4a(z);L4a(B);L4a(D);L4a(F)}else{h[b+304>>3]=1.0;me[c[w+80>>2]&127](b)|0}XEa(b);if((vGa(b,1,1)|0)!=1){i=e;return}me[c[(c[v>>2]|0)+80>>2]&127](b)|0;XEa(b);if((vGa(b,1,1)|0)!=1){i=e;return}OBa(1,0,280920,f);i=e;return}function KGa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=NGa(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){MBa(9,0,281024,u);if((c[b+184>>2]|0)==0){Ce[c[(c[b+540>>2]|0)+68>>2]&127](b,c[v+48>>2]|0)|0}L4a(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){MBa(9,0,281056,t);Ce[c[(c[b+540>>2]|0)+68>>2]&127](b,c[v+48>>2]|0)|0;L4a(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){MBa(9,1,281128,s);t=K4a(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+DGa(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+DGa(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}MBa(9,1,281152,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];MBa(9,0,281176,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];MBa(9,0,281176,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];MBa(9,0,281176,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[241644>>2]|0)!=0){je[c[60540]&1023](9);je[c[60540]&1023](9)}L4a(t);OGa(v);H=NGa(b)|0;if((c[H>>2]|0)!=0){$=H;break}MBa(9,0,281200,n);L4a(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}MBa(9,0,281232,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){MBa(9,0,281248,l);LGa($,d,1,e);EGa(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+DGa($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){L4a(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){L4a(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){L4a(v);c[l>>2]=0}LGa($,d,0,e);EGa(b,$);+DGa($,1.0)}else{MBa(9,0,281272,j)}MBa(9,1,281296,g);EGa(b,$);b=CGa($)|0;if((c[241644>>2]|0)!=0){je[c[60540]&1023](9)}OGa($);y=b;i=f;return y|0}function LGa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=K4a(c[p>>2]<<3)|0;r=q;s=+DGa(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;QGa(a,r);L4a(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=281424;F=E;MBa(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;MBa(9,0,281336,m);if(!t){PGa(a)}switch(b|0){case 4:{G=12;break a;break};case 2:{H=VGa(a)|0;break};case 1:{H=XGa(a)|0;break};case 6:{G=14;break a;break};case 5:{G=13;break a;break};case 3:{H=ZGa(a,n,e)|0;break};default:{G=15;break a}}dFa(o);VEa(o);$Ea(o);dFa(o);s=+DGa(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}MBa(9,0,281384,k);EGa(o,a);K=s}else{MBa(9,0,281400,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){UGa(a)|0}else if((G|0)==13){UGa(a)|0}else if((G|0)==14){TGa(o,a,0)|0}else if((G|0)==15){QBa(c[o+536>>2]|0,281360,l)}else if((G|0)==23){QGa(a,r);L4a(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=281424;F=E;MBa(9,0,F,g);i=f;return}}function MGa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=m5a(b|0)|0;do{if((d|0)==0){e=K4a(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=K4a(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==91){q=p+1|0}else if(h<<24>>24==93){q=p+ -1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((h5a(e,282440,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;o5a(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((h5a(e,282440,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function NGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=K4a(64)|0;z=y;PBa(0,(y|0)!=0|0,282448,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=M4a(Z,8)|0;c[E>>2]=y;PBa(0,(y|0)!=0|0,282448,w);w=M4a(Z,8)|0;c[F>>2]=w;PBa(0,(w|0)!=0|0,282448,v);v=M4a(Z,8)|0;c[G>>2]=v;PBa(0,(v|0)!=0|0,282448,u);u=M4a(Z,8)|0;c[H>>2]=u;PBa(0,(u|0)!=0|0,282448,t);t=M4a(Z,8)|0;c[I>>2]=t;PBa(0,(t|0)!=0|0,282448,s);s=M4a(Z,4)|0;t=s;c[J>>2]=t;PBa(0,(s|0)!=0|0,282448,r);MBa(9,0,282464,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;MBa(9,0,282488,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];MBa(9,0,282576,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];MBa(9,0,282624,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];MBa(9,0,282680,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;MBa(9,0,282736,l);c[j>>2]=ya;MBa(9,0,282808,j);j=M4a(sa,8)|0;c[K>>2]=j;PBa(0,(j|0)!=0|0,282448,g);g=K4a(sa<<3)|0;c[L>>2]=g;PBa(0,(g|0)!=0|0,282448,f);f=K4a(ya<<3)|0;c[M>>2]=f;PBa(0,(f|0)!=0|0,282448,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function OGa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+28>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+32>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+36>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+40>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+44>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+48>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+52>>2]|0;if((d|0)!=0){L4a(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;L4a(e);i=b;return}L4a(d);e=a;L4a(e);i=b;return}function PGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=M4a(o,8)|0;q=M4a(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=M4a(s,8)|0;u=M4a(s,8)|0;v=M4a(o,8)|0;w=M4a(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+DGa(b,1.0);s=c[n>>2]|0;if((s|0)>0){o5a(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+DGa(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){o5a(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;MBa(9,0,282848,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}L4a(p);L4a(q);L4a(t);L4a(u);L4a(v);L4a(w);i=d;return}function QGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function RGa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function SGa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function TGa(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;QBa(c[a+536>>2]|0,282920,d);return 0}function UGa(a){a=a|0;a=i;i=i+8|0;QBa(0,282952,a);return 0}function VGa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[241644>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=M4a((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;PBa(0,(n|0)!=0|0,282992,b);c[70752]=c[a+60>>2];c[70754]=c[a+48>>2];lEa(k,j,c[a+24>>2]|0,g,f,d,e,n,8)|0;L4a(n);c[70752]=0;c[70754]=0;n=CGa(a)|0;i=b;return n|0}function WGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[70754];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[70752];h[d>>3]=+DGa(f,1.0);i=e;return}function XGa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=K4a(x)|0;z=y;A=K4a(x)|0;x=A;PBa(0,(y|0)!=0|0,283024,n);PBa(0,(A|0)!=0|0,283024,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[241644>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+DGa(a,1.0);h[o>>3]=D;if(D!=0.0){c[70760]=c[a+60>>2];c[70762]=c[a+48>>2];iEa(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,9,u)|0;c[70760]=0;c[70762]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];MBa(9,0,283056,l)}D=+DGa(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];MBa(9,0,283160,j);j=c[u>>2]|0;do{if((j|0)==3){OBa(9,0,283320,e);F=-3;i=b;return F|0}else if((j|0)==4){OBa(9,0,283392,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];OBa(9,0,283176,g);F=-1;i=b;return F|0}else if((j|0)==2){OBa(9,0,283256,f);F=-2;i=b;return F|0}}while(0);F=CGa(a)|0;i=b;return F|0}function YGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[70762];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[70760];h[d>>3]=+DGa(f,1.0);i=e;return}function ZGa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;MBa(9,1,283448,g);if((c[241644>>2]|0)==0){l=0}else{l=(k|0)/10|0}_Ga(a,d,k,l,b,j);c[f>>2]=c[j>>2];MBa(9,0,283472,f);je[c[60540]&1023](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=CGa(a)|0;if((b|0)==0){m=0;i=e;return m|0}OBa(9,0,283488,e);m=b;i=e;return m|0}function _Ga(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=K4a(fa(N,M)|0)|0;P=K4a(M<<3)|0;Q=K4a(N)|0;R=Q;S=K4a(N)|0;T=S;V=K4a(N)|0;W=V;X=K4a(N)|0;Y=+h[f>>3];if((c[241644>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];kc(N|0,283536,I|0)|0;I=lc(N|0,283552)|0;c[H>>2]=283568;Ad(I|0,283560,H|0)|0;c[G>>2]=283584;Ad(I|0,283560,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];Ad(I|0,283560,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Wd(10,I|0)|0;c[E>>2]=0;Ad(I|0,283592,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Ad(I|0,283600,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Ad(I|0,283600,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Wd(10,I|0)|0;Z=I}else{Z=0}PBa(0,(O|0)!=0|0,283608,B);PBa(0,(P|0)!=0|0,283608,A);PBa(0,(Q|0)!=0|0,283608,z);PBa(0,(S|0)!=0|0,283608,y);PBa(0,(V|0)!=0|0,283608,x);PBa(0,(X|0)!=0|0,283608,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{RGa(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+DGa(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;RGa(a,la);+DGa(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];MBa(9,0,283624,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){q5a(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);RGa(a,R);za=+DGa(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}o5a(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}RGa(a,T);if(+DGa(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}o5a(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}o5a(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}RGa(a,W);Ba=+DGa(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}RGa(a,W);Ba=+DGa(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}o5a(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(9,0,283664,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;Ad(Z|0,283592,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ad(Z|0,283600,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Ad(Z|0,283600,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Wd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];OBa(9,0,283712,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];OBa(9,0,283728,p);QBa(0,283744,o)}RGa(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){L4a(S);L4a(Q);L4a(V);L4a(X);L4a(P);L4a(O);i=j;return}c[n>>2]=ia;Ad(Z|0,283592,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ad(Z|0,283600,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Ad(Z|0,283600,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Wd(10,Z|0)|0;$c(Z|0)|0;L4a(S);L4a(Q);L4a(V);L4a(X);L4a(P);L4a(O);i=j;return}function $Ga(a,b){a=a|0;b=b|0;i=i;return}function aHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;uDa(3);xDa(0);w=+pDa(0);uDa(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Ad(v|0,283824,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Ad(v|0,283824,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Ad(v|0,283824,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];Ad(v|0,283832,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;Ad(v|0,283832,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];Ad(v|0,283840,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Ad(v|0,283824,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Ad(v|0,283824,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;Ad(v|0,283832,l|0)|0;break}else{c[m>>2]=0-E;Ad(v|0,283832,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;Ad(v|0,283832,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;Ad(v|0,283832,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Wd(10,v|0)|0;xDa(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];Ad(v|0,283840,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Wd(10,v|0)|0;xDa(3);i=e;return}function bHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=lc(c[r>>2]|0,283848)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=_d(c[(Qc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;PBa(t,(s|0)!=0|0,283856,q);c[p>>2]=283912;Ad(s|0,283840,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=283920;Ad(s|0,283840,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];Ad(s|0,283840,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];Ad(s|0,283840,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];Ad(s|0,283840,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];Ad(s|0,283840,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];Ad(s|0,283840,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];Ad(s|0,283840,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];Ad(s|0,283840,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Wd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];Ad(s|0,283840,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Wd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function cHa(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;uDa(3);$c(d|0)|0;xDa(3);i=b;return}function dHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;WYa(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];XYa(p,f)|0;eHa(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;fHa(a,b,283936,c[j>>2]|0,c[g>>2]|0,o,8);L4a(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];XYa(p,e)|0;i=d;return}function eHa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=M4a(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;PBa(c[b+536>>2]|0,(p|0)!=0|0,284216,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function fHa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;qHa(a,b,d,e,f,h);VYa(l,g,fa(fa(f,e)|0,h)|0)|0;if(qXa(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];QBa(l,284168,k)}else{i=j;return}}function gHa(a){a=a|0;var b=0;b=i;if((iIa(a+4|0)|0)!=0){i=b;return}tXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function hHa(a){a=a|0;Uc(a|0)|0;_a()}function iHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=Q4a(320)|0;q5a(q|0,0,320)|0;jHa(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;uDa(3);t=a+8|0;u=kHa(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=lHa(a,b,u+s|0)|0;u=q+184|0;mHa(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;mHa(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;nHa(q,c[x>>2]|0,36);if(qXa(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];QBa(y,283992,e)}else{fHa(a,b,284024,4,11,283944,1);oHa((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;fHa(a,b,284032,c[g>>2]|0,c[j>>2]|0,e,1);L4a(e);c[f>>2]=0;oHa((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;fHa(a,b,284040,c[g>>2]|0,c[j>>2]|0,e,1);L4a(e);c[f>>2]=0;pHa(a,b,k,g,j,c[r>>2]|0,s);fHa(a,b,284056,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;WYa(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];eHa(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;fHa(a,b,283936,c[j>>2]|0,c[g>>2]|0,n,8);WYa(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=rHa(q+240|0)|0;w=rHa(q+264|0)|0;p=rHa(q+288|0)|0;qHa(a,b,284072,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);L4a(n);L4a(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;BYa(s)|0;L4a(v);xDa(3);i=d;return}}function jHa(a){a=a|0;var b=0;b=i;sKa(a);i=b;return}function kHa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(wJa(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(wJa(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(wJa(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}



function cia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124600]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1888>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1888>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(124608,vCa(+h[(c[g>>2]|0)+1888>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124600]=1;i=d;return}function dia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124744]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1880>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(124752,vCa(+h[(c[g>>2]|0)+1880>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124744]=1;i=d;return}function eia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(124880,vCa(+h[(c[g>>2]|0)+1872>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124872]=1;i=d;return}function fia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124968]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1864>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1864>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(124976,vCa(+h[(c[g>>2]|0)+1864>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[124968]=1;i=d;return}function gia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125112]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(125120,vCa(+h[(c[g>>2]|0)+1856>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125112]=1;i=d;return}function hia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1848>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1848>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(125216,vCa(+h[(c[g>>2]|0)+1848>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125208]=1;i=d;return}function iia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125352]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1832>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(125360,vCa(+h[(c[g>>2]|0)+1832>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125352]=1;i=d;return}function jia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125496]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1824>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1824>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(125504,vCa(+h[(c[g>>2]|0)+1824>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125496]=1;i=d;return}function kia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125624]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(125632,vCa(+h[(c[g>>2]|0)+1816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125624]=1;i=d;return}function lia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125720]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1808>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(125728,vCa(+h[(c[g>>2]|0)+1808>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125720]=1;i=d;return}function mia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125864]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(125872,vCa(+h[(c[g>>2]|0)+1800>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125864]=1;i=d;return}function nia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125960]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1792>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(125968,vCa(+h[(c[g>>2]|0)+1792>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[125960]=1;i=d;return}function oia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126104]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1776>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(126112,vCa(+h[(c[g>>2]|0)+1776>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126104]=1;i=d;return}function pia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126248]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(126256,vCa(+h[(c[g>>2]|0)+1768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126248]=1;i=d;return}function qia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126376]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(126384,vCa(+h[(c[g>>2]|0)+1760>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126376]=1;i=d;return}function ria(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126472]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1752>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(126480,vCa(+h[(c[g>>2]|0)+1752>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126472]=1;i=d;return}function sia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126616]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(126624,vCa(+h[(c[g>>2]|0)+1744>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126616]=1;i=d;return}function tia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126712]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1736>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1736>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(126720,vCa(+h[(c[g>>2]|0)+1736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126712]=1;i=d;return}function uia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126856]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1720>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1720>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(126864,vCa(+h[(c[g>>2]|0)+1720>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126856]=1;i=d;return}function via(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1712>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1712>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(127e3,vCa(+h[(c[g>>2]|0)+1712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[126992]=1;i=d;return}function wia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127112]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(127120,vCa(+h[(c[g>>2]|0)+1704>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127112]=1;i=d;return}function xia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1696>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(127216,vCa(+h[(c[g>>2]|0)+1696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127208]=1;i=d;return}function yia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127352]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(127360,vCa(+h[(c[g>>2]|0)+1688>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127352]=1;i=d;return}function zia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127448]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1680>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1680>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(127456,vCa(+h[(c[g>>2]|0)+1680>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127448]=1;i=d;return}function Aia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127584]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1664>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1664>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(127592,vCa(+h[(c[g>>2]|0)+1664>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127584]=1;i=d;return}function Bia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127728]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1656>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(127736,vCa(+h[(c[g>>2]|0)+1656>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127728]=1;i=d;return}function Cia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127856]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(127864,vCa(+h[(c[g>>2]|0)+1648>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127856]=1;i=d;return}function Dia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127952]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1640>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(127960,vCa(+h[(c[g>>2]|0)+1640>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[127952]=1;i=d;return}function Eia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128096]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(128104,vCa(+h[(c[g>>2]|0)+1632>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128096]=1;i=d;return}function Fia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128192]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1624>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1624>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(128200,vCa(+h[(c[g>>2]|0)+1624>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128192]=1;i=d;return}function Gia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128336]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1608>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1608>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(128344,vCa(+h[(c[g>>2]|0)+1608>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128336]=1;i=d;return}function Hia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128472]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1600>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(128480,vCa(+h[(c[g>>2]|0)+1600>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128472]=1;i=d;return}function Iia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128592]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(128600,vCa(+h[(c[g>>2]|0)+1592>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128592]=1;i=d;return}function Jia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128688]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1584>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(128696,vCa(+h[(c[g>>2]|0)+1584>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128688]=1;i=d;return}function Kia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128832]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(128840,vCa(+h[(c[g>>2]|0)+1576>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128832]=1;i=d;return}function Lia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128928]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1568>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1568>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(128936,vCa(+h[(c[g>>2]|0)+1568>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[128928]=1;i=d;return}function Mia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129064]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1552>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1552>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(129072,vCa(+h[(c[g>>2]|0)+1552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129064]=1;i=d;return}function Nia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1544>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1544>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(129216,vCa(+h[(c[g>>2]|0)+1544>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129208]=1;i=d;return}function Oia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129336]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(129344,vCa(+h[(c[g>>2]|0)+1536>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129336]=1;i=d;return}function Pia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129432]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1528>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1528>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(129440,vCa(+h[(c[g>>2]|0)+1528>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129432]=1;i=d;return}function Qia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129576]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(129584,vCa(+h[(c[g>>2]|0)+1520>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129576]=1;i=d;return}function Ria(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129672]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1512>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(129680,vCa(+h[(c[g>>2]|0)+1512>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[129672]=1;i=d;return}function Sia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129816]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(129824,xCa(c[(c[g>>2]|0)+164>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[129816]=1;i=d;return}function Tia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130072]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(130080,xCa(c[(c[g>>2]|0)+160>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[130072]=1;i=d;return}function Uia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130328]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(130336,xCa(c[(c[g>>2]|0)+156>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=132128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[130328]=1;i=d;return}function Via(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130584]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1496>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(130592,vCa(+h[(c[g>>2]|0)+1496>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[130584]=1;i=d;return}function Wia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130720]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1488>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(130728,vCa(+h[(c[g>>2]|0)+1488>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[130720]=1;i=d;return}function Xia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130840]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(130848,vCa(+h[(c[g>>2]|0)+1480>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[130840]=1;i=d;return}function Yia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130936]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1472>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(130944,vCa(+h[(c[g>>2]|0)+1472>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[130936]=1;i=d;return}function Zia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131080]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(131088,vCa(+h[(c[g>>2]|0)+1464>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[131080]=1;i=d;return}function _ia(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131176]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1456>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1456>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(131184,vCa(+h[(c[g>>2]|0)+1456>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[131176]=1;i=d;return}function $ia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131312]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+152>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(131320,xCa(c[(c[g>>2]|0)+152>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[131312]=1;i=d;return}function aja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131592]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(131600,xCa(c[(c[g>>2]|0)+148>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[131592]=1;i=d;return}function bja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131872]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(131880,xCa(c[(c[g>>2]|0)+144>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=132128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[131872]=1;i=d;return}function cja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132152]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1440>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(132160,vCa(+h[(c[g>>2]|0)+1440>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132152]=1;i=d;return}function dja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132288]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1432>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1432>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(132296,vCa(+h[(c[g>>2]|0)+1432>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132288]=1;i=d;return}function eja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132408]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(132416,vCa(+h[(c[g>>2]|0)+1424>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132408]=1;i=d;return}function fja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132504]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1416>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(132512,vCa(+h[(c[g>>2]|0)+1416>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132504]=1;i=d;return}function gja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132648]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(132656,vCa(+h[(c[g>>2]|0)+1408>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132648]=1;i=d;return}function hja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132744]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1400>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(132752,vCa(+h[(c[g>>2]|0)+1400>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132744]=1;i=d;return}function ija(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132880]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1384>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1384>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(132888,vCa(+h[(c[g>>2]|0)+1384>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[132880]=1;i=d;return}function jja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133016]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1376>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(133024,vCa(+h[(c[g>>2]|0)+1376>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133016]=1;i=d;return}function kja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133136]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(133144,vCa(+h[(c[g>>2]|0)+1368>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133136]=1;i=d;return}function lja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133232]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1360>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1360>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(133240,vCa(+h[(c[g>>2]|0)+1360>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133232]=1;i=d;return}function mja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133376]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(133384,vCa(+h[(c[g>>2]|0)+1352>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133376]=1;i=d;return}function nja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133472]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1344>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(133480,vCa(+h[(c[g>>2]|0)+1344>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133472]=1;i=d;return}function oja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133608]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1328>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(133616,vCa(+h[(c[g>>2]|0)+1328>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133608]=1;i=d;return}function pja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133744]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1320>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(133752,vCa(+h[(c[g>>2]|0)+1320>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133744]=1;i=d;return}function qja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133864]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(133872,vCa(+h[(c[g>>2]|0)+1312>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133864]=1;i=d;return}function rja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133960]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1304>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(133968,vCa(+h[(c[g>>2]|0)+1304>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[133960]=1;i=d;return}function sja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134104]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(134112,vCa(+h[(c[g>>2]|0)+1296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134104]=1;i=d;return}function tja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134200]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1288>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(134208,vCa(+h[(c[g>>2]|0)+1288>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134200]=1;i=d;return}function uja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134336]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1272>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1272>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(134344,vCa(+h[(c[g>>2]|0)+1272>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134336]=1;i=d;return}function vja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134472]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1264>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(134480,vCa(+h[(c[g>>2]|0)+1264>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134472]=1;i=d;return}function wja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134592]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(134600,vCa(+h[(c[g>>2]|0)+1256>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134592]=1;i=d;return}function xja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134688]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1248>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1248>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(134696,vCa(+h[(c[g>>2]|0)+1248>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134688]=1;i=d;return}function yja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134832]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(134840,vCa(+h[(c[g>>2]|0)+1240>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134832]=1;i=d;return}function zja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134928]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1232>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1232>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(134936,vCa(+h[(c[g>>2]|0)+1232>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[134928]=1;i=d;return}function Aja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135064]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1216>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1216>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(135072,vCa(+h[(c[g>>2]|0)+1216>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135064]=1;i=d;return}function Bja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135200]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1208>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(135208,vCa(+h[(c[g>>2]|0)+1208>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135200]=1;i=d;return}function Cja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135320]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(135328,vCa(+h[(c[g>>2]|0)+1200>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135320]=1;i=d;return}function Dja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135416]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1192>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1192>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(135424,vCa(+h[(c[g>>2]|0)+1192>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135416]=1;i=d;return}function Eja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135560]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(135568,vCa(+h[(c[g>>2]|0)+1184>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135560]=1;i=d;return}function Fja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135656]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1176>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1176>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(135664,vCa(+h[(c[g>>2]|0)+1176>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135656]=1;i=d;return}function Gja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135792]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1160>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(135800,vCa(+h[(c[g>>2]|0)+1160>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135792]=1;i=d;return}function Hja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135936]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1152>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1152>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(135944,vCa(+h[(c[g>>2]|0)+1152>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[135936]=1;i=d;return}function Ija(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136064]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(136072,vCa(+h[(c[g>>2]|0)+1144>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136064]=1;i=d;return}function Jja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136160]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1136>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(136168,vCa(+h[(c[g>>2]|0)+1136>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136160]=1;i=d;return}function Kja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136304]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(136312,vCa(+h[(c[g>>2]|0)+1128>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136304]=1;i=d;return}function Lja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136400]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+1120>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+1120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(136408,vCa(+h[(c[g>>2]|0)+1120>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136400]=1;i=d;return}function Mja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136544]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(136552,vCa(+h[(c[g>>2]|0)+1112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136544]=1;i=d;return}function Nja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136744]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(136752,vCa(+h[(c[g>>2]|0)+1104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136744]=1;i=d;return}function Oja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(136880,vCa(+h[(c[g>>2]|0)+1096>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[136872]=1;i=d;return}function Pja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137008]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137016,vCa(+h[(c[g>>2]|0)+1088>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137008]=1;i=d;return}function Qja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137144]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137152,vCa(+h[(c[g>>2]|0)+1080>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137144]=1;i=d;return}function Rja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137280]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137288,vCa(+h[(c[g>>2]|0)+1072>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137280]=1;i=d;return}function Sja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137416]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137424,vCa(+h[(c[g>>2]|0)+1064>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137416]=1;i=d;return}function Tja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137544]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137552,vCa(+h[(c[g>>2]|0)+1056>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137544]=1;i=d;return}function Uja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137672]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137680,vCa(+h[(c[g>>2]|0)+1048>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137672]=1;i=d;return}function Vja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137800]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137808,vCa(+h[(c[g>>2]|0)+1040>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137800]=1;i=d;return}function Wja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137928]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(137936,vCa(+h[(c[g>>2]|0)+1032>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[137928]=1;i=d;return}function Xja(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138056]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138064,vCa(+h[(c[g>>2]|0)+1024>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[138056]=1;i=d;return}function Yja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138208]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+140>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138216,xCa(c[(c[g>>2]|0)+140>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138208]=1;i=d;return}function Zja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138320]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+136>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138328,xCa(c[(c[g>>2]|0)+136>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138320]=1;i=d;return}function _ja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138432]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+132>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138440,xCa(c[(c[g>>2]|0)+132>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138432]=1;i=d;return}function $ja(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138544]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+128>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138552,xCa(c[(c[g>>2]|0)+128>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138544]=1;i=d;return}function aka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138656]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+124>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138664,xCa(c[(c[g>>2]|0)+124>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138656]=1;i=d;return}function bka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138768]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+120>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138776,xCa(c[(c[g>>2]|0)+120>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138768]=1;i=d;return}function cka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138880]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+116>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(138888,xCa(c[(c[g>>2]|0)+116>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138880]=1;i=d;return}function dka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138992]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+112>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139e3,xCa(c[(c[g>>2]|0)+112>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[138992]=1;i=d;return}function eka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139104]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+108>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139112,xCa(c[(c[g>>2]|0)+108>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139104]=1;i=d;return}function fka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139216]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+104>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139224,xCa(c[(c[g>>2]|0)+104>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139216]=1;i=d;return}function gka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139328]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+100>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139336,xCa(c[(c[g>>2]|0)+100>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139328]=1;i=d;return}function hka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139440]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+96>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139448,xCa(c[(c[g>>2]|0)+96>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139440]=1;i=d;return}function ika(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139544]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+92>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139552,xCa(c[(c[g>>2]|0)+92>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139544]=1;i=d;return}function jka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139656]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+88>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139664,xCa(c[(c[g>>2]|0)+88>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139656]=1;i=d;return}function kka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139760]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+84>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139768,xCa(c[(c[g>>2]|0)+84>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139760]=1;i=d;return}function lka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139872]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+80>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(139880,xCa(c[(c[g>>2]|0)+80>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139872]=1;i=d;return}function mka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139976]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(139984,xCa(c[(c[g>>2]|0)+76>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=140104;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[139976]=1;i=d;return}function nka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140128]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140136,vCa(+h[(c[g>>2]|0)+1016>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[140128]=1;i=d;return}function oka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140256]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+72>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140264,xCa(c[(c[g>>2]|0)+72>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140256]=1;i=d;return}function pka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140368]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+68>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140376,xCa(c[(c[g>>2]|0)+68>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140368]=1;i=d;return}function qka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140472]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+64>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140480,xCa(c[(c[g>>2]|0)+64>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140472]=1;i=d;return}function rka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140584]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+60>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140592,xCa(c[(c[g>>2]|0)+60>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140584]=1;i=d;return}function ska(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140688]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+56>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140696,xCa(c[(c[g>>2]|0)+56>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140688]=1;i=d;return}function tka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140800]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+52>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140808,xCa(c[(c[g>>2]|0)+52>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140800]=1;i=d;return}function uka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140904]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+48>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(140912,xCa(c[(c[g>>2]|0)+48>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[140904]=1;i=d;return}function vka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141016]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+44>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141024,xCa(c[(c[g>>2]|0)+44>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141016]=1;i=d;return}function wka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141120]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+1008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141128,vCa(+h[(c[g>>2]|0)+1008>>3],67480)|0)|0;g=c[72854]|0;j=e;k=141248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[141120]=1;i=d;return}function xka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141272]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+40>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141280,xCa(c[(c[g>>2]|0)+40>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141272]=1;i=d;return}function yka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141384]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+36>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141392,xCa(c[(c[g>>2]|0)+36>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141384]=1;i=d;return}function zka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141488]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+32>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141496,xCa(c[(c[g>>2]|0)+32>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141488]=1;i=d;return}function Aka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141600]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+28>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141608,xCa(c[(c[g>>2]|0)+28>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141600]=1;i=d;return}function Bka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141704]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+24>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141712,xCa(c[(c[g>>2]|0)+24>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141704]=1;i=d;return}function Cka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141848]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+20>>2]|0),0.0)|0)<<24>>24==0)){i=d;return}b=ACa(141856,xCa(c[(c[g>>2]|0)+20>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=141968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[141848]=1;i=d;return}function Dka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141992]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(142e3,vCa(+h[(c[g>>2]|0)+960>>3],67480)|0)|0;g=c[72854]|0;j=e;k=142360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[141992]=1;i=d;return}function Eka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142168]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(142176,vCa(+h[(c[g>>2]|0)+944>>3],67480)|0)|0;g=c[72854]|0;j=e;k=142360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142168]=1;i=d;return}function Fka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142264]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(142272,vCa(+h[(c[g>>2]|0)+928>>3],67480)|0)|0;g=c[72854]|0;j=e;k=142360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142264]=1;i=d;return}function Gka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142384]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+912>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(142392,vCa(+h[(c[g>>2]|0)+912>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142384]=1;i=d;return}function Hka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142528]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+904>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(142536,vCa(+h[(c[g>>2]|0)+904>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142528]=1;i=d;return}function Ika(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142656]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(142664,vCa(+h[(c[g>>2]|0)+896>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142656]=1;i=d;return}function Jka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142752]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+888>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+888>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(142760,vCa(+h[(c[g>>2]|0)+888>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142752]=1;i=d;return}function Kka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142896]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(142904,vCa(+h[(c[g>>2]|0)+880>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142896]=1;i=d;return}function Lka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+872>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+872>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(143e3,vCa(+h[(c[g>>2]|0)+872>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[142992]=1;i=d;return}function Mka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143136]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+856>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+856>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(143144,vCa(+h[(c[g>>2]|0)+856>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143136]=1;i=d;return}function Nka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143304]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+848>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(143312,vCa(+h[(c[g>>2]|0)+848>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143304]=1;i=d;return}function Oka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143456]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(143464,vCa(+h[(c[g>>2]|0)+840>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143456]=1;i=d;return}function Pka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143576]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+832>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(143584,vCa(+h[(c[g>>2]|0)+832>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143576]=1;i=d;return}function Qka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143744]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(143752,vCa(+h[(c[g>>2]|0)+824>>3],67480)|0)|0;g=c[72854]|0;j=e;k=143840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143744]=1;i=d;return}function Rka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143864]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+816>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(143872,vCa(+h[(c[g>>2]|0)+816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[143864]=1;i=d;return}function Ska(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144032]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(144040,vCa(+h[(c[g>>2]|0)+808>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144032]=1;i=d;return}function Tka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144176]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+48>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(144184,vCa(+h[(c[g>>2]|0)+48>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144176]=1;i=d;return}function Uka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144320]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+784>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+784>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(144328,vCa(+h[(c[g>>2]|0)+784>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144320]=1;i=d;return}function Vka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144464]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+776>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(144472,vCa(+h[(c[g>>2]|0)+776>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144464]=1;i=d;return}function Wka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144616]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+768>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+768>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(144624,vCa(+h[(c[g>>2]|0)+768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144616]=1;i=d;return}function Xka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144776]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+760>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+760>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(144784,vCa(+h[(c[g>>2]|0)+760>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[144776]=1;i=d;return}function Yka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144912]&1){i=d;return}g=b+420|0;b=sFa(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[c[g>>2]>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=ACa(144920,xCa(c[c[g>>2]>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=145152;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[144912]=1;i=d;return}function Zka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145176]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(145184,vCa(+h[(c[g>>2]|0)+752>>3],67480)|0)|0;g=c[72854]|0;j=e;k=145272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[145176]=1;i=d;return}function _ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145296]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(145304,vCa(+h[(c[g>>2]|0)+736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=145384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[145296]=1;i=d;return}function $ka(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145408]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(145416,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],67480)|0)|0;g=c[72854]|0;j=e;k=145576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[145408]=1;i=d;return}function ala(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145600]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(145608,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[145600]=1;i=d;return}function bla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145856]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(145864,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[145856]=1;i=d;return}function cla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146040]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146048,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146040]=1;i=d;return}function dla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146224]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146232,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146224]=1;i=d;return}function ela(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146408]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146416,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146408]=1;i=d;return}function fla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146584]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146592,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146584]=1;i=d;return}function gla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146760]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146768,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146760]=1;i=d;return}function hla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146936]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(146944,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[146936]=1;i=d;return}function ila(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147112]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(147120,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[147112]=1;i=d;return}function jla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147288]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(147296,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[147288]=1;i=d;return}function kla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147464]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(147472,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7568>>3],67480)|0)|0;g=c[72854]|0;j=e;k=147584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[147464]=1;i=d;return}function lla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147608]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(147616,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7560>>3],67480)|0)|0;g=c[72854]|0;j=e;k=147728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[147608]=1;i=d;return}function mla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(147760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=147864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[147752]=1;i=d;return}function nla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147888]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(147896,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7544>>3],67480)|0)|0;g=c[72854]|0;j=e;k=148e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[147888]=1;i=d;return}function ola(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148024]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7480>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7480>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(148032,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7480>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148024]=1;i=d;return}function pla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148144]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7472>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7472>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(148152,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7472>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148144]=1;i=d;return}function qla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7464>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7464>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(148360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7464>>3],67480)|0)|0;g=c[72854]|0;j=e;k=149216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148352]=1;i=d;return}function rla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7456>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7456>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(148488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7456>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148480]=1;i=d;return}function sla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148608]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7448>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7448>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(148616,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7448>>3],67480)|0)|0;g=c[72854]|0;j=e;k=149216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148608]=1;i=d;return}function tla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148736]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(148744,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7440>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148736]=1;i=d;return}function ula(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148856]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(148864,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7432>>3],67480)|0)|0;g=c[72854]|0;j=e;k=149216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148856]=1;i=d;return}function vla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148976]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(148984,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7424>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[148976]=1;i=d;return}function wla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149096]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(149104,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7416>>3],67480)|0)|0;g=c[72854]|0;j=e;k=149216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149096]=1;i=d;return}function xla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149240]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(149248,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7408>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149240]=1;i=d;return}function yla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149376]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(149384,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3128>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149376]=1;i=d;return}function zla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(149512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7400>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149504]=1;i=d;return}function Ala(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149640]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(149648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149640]=1;i=d;return}function Bla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149768]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(149776,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7392>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149768]=1;i=d;return}



function Baa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4592>>3]=+h[b+4560>>3];i=i;return}function Caa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4624>>3]=+h[b+2568>>3];i=i;return}function Daa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4616>>3]=+h[b+4624>>3]*100.0;i=i;return}function Eaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4640>>3]=+h[b+2528>>3];i=i;return}function Faa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+4480>>3]*.5;i=i;return}function Gaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=+h[b+576>>3]*+h[b+4552>>3];i=i;return}function Haa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+4480>>3]*.5;i=i;return}function Iaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=+h[b+576>>3]+ +h[b+584>>3];i=i;return}function Jaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=+h[b+584>>3]*+h[b+4552>>3];i=i;return}function Kaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+4544>>3];i=i;return}function Laa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=+h[b+592>>3]*+h[b+576>>3]*+h[b+4472>>3];i=i;return}function Maa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+4544>>3];i=i;return}function Naa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=+h[b+600>>3]*+h[b+584>>3]*+h[b+4472>>3];i=i;return}function Oaa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4552>>3];j=+h[f+4544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66848,66840,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+608>>3]=l*4.0;i=d;return}function Paa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4552>>3];j=+h[f+4544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66848,66872,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+616>>3]=l*4.0;i=d;return}function Qaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=(+h[b+608>>3]+ +h[b+616>>3])*.5;i=i;return}function Raa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+4496>>3];i=i;return}function Saa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+4496>>3];i=i;return}function Taa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4576>>3];m=+h[k+4616>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66888,66880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4576>>3];o=r;p=q}}while(0);l=+h[o+4656>>3];m=+h[o+4664>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3384>>3];t=+h[s+2920>>3];u=(+h[o+624>>3]+ +h[o+632>>3])*.5;v=+h[o+4624>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,66888,66880,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+4600>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7344>>3]=+h[e>>3];i=d;return}function Uaa(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+346|0]=a[d+332|0]|0;i=i;return}function Vaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4680>>3]=+h[b+4472>>3];i=i;return}function Waa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4688>>3]=+h[b+2520>>3];i=i;return}function Xaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4752>>3]=+h[b+2512>>3];i=i;return}function Yaa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=+h[(c[a+416>>2]|0)+4752>>3]*1.0e-5;i=i;return}function Zaa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+4752>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=+h[d>>3];i=b;return}function _aa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4760>>3]=+h[b+2520>>3];i=i;return}function $aa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4768>>3]=+h[b+2568>>3];i=i;return}function aba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4784>>3]=+h[b+4752>>3];i=i;return}function bba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+704>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+4784>>3];l=+h[a+4696>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+4704>>3]=+h[f>>3];i=b;return}function cba(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+353|0]=a[d+348|0]|0;i=i;return}function dba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4800>>3]=+h[b+2520>>3];i=i;return}function eba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4808>>3]=+h[b+2584>>3];i=i;return}function fba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4832>>3]=+h[b+2576>>3];i=i;return}function gba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+712>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+4832>>3];l=+h[a+4808>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Ct(f,j,k,l,d,0);h[(c[g>>2]|0)+4816>>3]=+h[f>>3];i=b;return}function hba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66920]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+712>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+712>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(66936,xCa(c[(c[g>>2]|0)+712>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[66920]=1;i=d;return}function iba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67232]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+708>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+708>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(67240,xCa(c[(c[g>>2]|0)+708>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[67232]=1;i=d;return}function jba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67472]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+712>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(67488,vCa(+h[(c[g>>2]|0)+712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[67472]=1;i=d;return}function kba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67616]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4832>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4832>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(67624,vCa(+h[(c[g>>2]|0)+4832>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[67616]=1;i=d;return}function lba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67752]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+704>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+704>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(67760,xCa(c[(c[g>>2]|0)+704>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[67752]=1;i=d;return}function mba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67976]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+700>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+700>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(67984,xCa(c[(c[g>>2]|0)+700>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[67976]=1;i=d;return}function nba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68208]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4816>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4816>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(68216,vCa(+h[(c[g>>2]|0)+4816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[68208]=1;i=d;return}function oba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68352]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4808>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4808>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(68360,vCa(+h[(c[g>>2]|0)+4808>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[68352]=1;i=d;return}function pba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68480]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+696>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+696>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(68488,xCa(c[(c[g>>2]|0)+696>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[68480]=1;i=d;return}function qba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68808]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+692>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+692>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(68816,xCa(c[(c[g>>2]|0)+692>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=131848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[68808]=1;i=d;return}function rba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69064]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+688>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+688>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=ACa(69072,xCa(c[(c[g>>2]|0)+688>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=132128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[69064]=1;i=d;return}function sba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69320]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(69328,vCa(+h[(c[g>>2]|0)+4800>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[69320]=1;i=d;return}function tba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69440]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+704>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(69448,vCa(+h[(c[g>>2]|0)+704>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[69440]=1;i=d;return}function uba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69560]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4784>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(69568,vCa(+h[(c[g>>2]|0)+4784>>3],67480)|0)|0;g=c[72854]|0;j=e;k=120728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[69560]=1;i=d;return}function vba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69680]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+676>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+676>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(69688,xCa(c[(c[g>>2]|0)+676>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[69680]=1;i=d;return}function wba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69896]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+672>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+672>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(69904,xCa(c[(c[g>>2]|0)+672>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[69896]=1;i=d;return}function xba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70120]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70128,vCa(+h[(c[g>>2]|0)+696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70120]=1;i=d;return}function yba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70304]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70312,vCa(+h[(c[g>>2]|0)+688>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70304]=1;i=d;return}function zba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70424]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70432,vCa(+h[(c[g>>2]|0)+680>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70424]=1;i=d;return}function Aba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70536]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70544,vCa(+h[(c[g>>2]|0)+672>>3],67480)|0)|0;g=c[72854]|0;j=e;k=112920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70536]=1;i=d;return}function Bba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70656]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70664,vCa(+h[(c[g>>2]|0)+4776>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70656]=1;i=d;return}function Cba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70840]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(70848,vCa(+h[(c[g>>2]|0)+4768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70840]=1;i=d;return}function Dba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70936]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4760>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4760>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(70944,vCa(+h[(c[g>>2]|0)+4760>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[70936]=1;i=d;return}function Eba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71056]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4752>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(71064,vCa(+h[(c[g>>2]|0)+4752>>3],67480)|0)|0;g=c[72854]|0;j=e;k=113456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[71056]=1;i=d;return}function Fba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71184]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+668>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+668>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(71192,xCa(c[(c[g>>2]|0)+668>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=120976;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[71184]=1;i=d;return}function Gba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71392]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+664>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+664>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(71400,xCa(c[(c[g>>2]|0)+664>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=121232;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[71392]=1;i=d;return}function Hba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71608]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(71616,vCa(+h[(c[g>>2]|0)+4744>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[71608]=1;i=d;return}function Iba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71704]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(71712,vCa(+h[(c[g>>2]|0)+4736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[71704]=1;i=d;return}function Jba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71808]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(71816,vCa(+h[(c[g>>2]|0)+4712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=114240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[71808]=1;i=d;return}function Kba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71896]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4704>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4704>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(71904,vCa(+h[(c[g>>2]|0)+4704>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[71896]=1;i=d;return}function Lba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72032]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4696>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4696>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(72040,vCa(+h[(c[g>>2]|0)+4696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=121552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72032]=1;i=d;return}function Mba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72144]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(72152,vCa(+h[(c[g>>2]|0)+4688>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72144]=1;i=d;return}function Nba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72280]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(72288,vCa(+h[(c[g>>2]|0)+632>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72280]=1;i=d;return}function Oba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72472]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(72480,vCa(+h[(c[g>>2]|0)+624>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72472]=1;i=d;return}function Pba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72592]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(72600,vCa(+h[(c[g>>2]|0)+4664>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72592]=1;i=d;return}function Qba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72728]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(72736,vCa(+h[(c[g>>2]|0)+4656>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72728]=1;i=d;return}function Rba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72864]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4648>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4648>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(72872,vCa(+h[(c[g>>2]|0)+4648>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[72864]=1;i=d;return}function Sba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73056]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+648>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+648>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(73064,xCa(c[(c[g>>2]|0)+648>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[73056]=1;i=d;return}function Tba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73336]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(73344,vCa(+h[(c[g>>2]|0)+4632>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[73336]=1;i=d;return}function Uba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73464]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(73472,vCa(+h[(c[g>>2]|0)+4608>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[73464]=1;i=d;return}function Vba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73600]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4592>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4592>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(73608,vCa(+h[(c[g>>2]|0)+4592>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[73600]=1;i=d;return}function Wba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73784]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4584>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(73792,vCa(+h[(c[g>>2]|0)+4584>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[73784]=1;i=d;return}function Xba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73968]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(73976,vCa(+h[(c[g>>2]|0)+568>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[73968]=1;i=d;return}function Yba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74128]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+560>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(74136,vCa(+h[(c[g>>2]|0)+560>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[74128]=1;i=d;return}function Zba(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74288]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4560>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(74296,vCa(+h[(c[g>>2]|0)+4560>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[74288]=1;i=d;return}function _ba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74440]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+632>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+632>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(74448,xCa(c[(c[g>>2]|0)+632>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95104;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[74440]=1;i=d;return}function $ba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74680]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+628>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+628>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(74688,xCa(c[(c[g>>2]|0)+628>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95368;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[74680]=1;i=d;return}function aca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74928]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+552>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(74936,vCa(+h[(c[g>>2]|0)+552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[74928]=1;i=d;return}function bca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75072]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4536>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(75080,vCa(+h[(c[g>>2]|0)+4536>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[75072]=1;i=d;return}function cca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75240]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+620>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+620>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(75248,xCa(c[(c[g>>2]|0)+620>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[75240]=1;i=d;return}function dca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75488]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4528>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(75496,vCa(+h[(c[g>>2]|0)+4528>>3],67480)|0)|0;g=c[72854]|0;j=e;k=96136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[75488]=1;i=d;return}function eca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75640]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+616>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+616>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(75648,xCa(c[(c[g>>2]|0)+616>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[75640]=1;i=d;return}function fca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75880]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+612>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+612>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(75888,xCa(c[(c[g>>2]|0)+612>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[75880]=1;i=d;return}function gca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76120]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+596>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+596>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(76128,xCa(c[(c[g>>2]|0)+596>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[76120]=1;i=d;return}function hca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76352]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+592>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(76360,xCa(c[(c[g>>2]|0)+592>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=97008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[76352]=1;i=d;return}function ica(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76456]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4520>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4520>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(76464,vCa(+h[(c[g>>2]|0)+4520>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[76456]=1;i=d;return}function jca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76616]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4512>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4512>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(76624,vCa(+h[(c[g>>2]|0)+4512>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[76616]=1;i=d;return}function kca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76760]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(76768,vCa(+h[(c[g>>2]|0)+4496>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[76760]=1;i=d;return}function lca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(76880,vCa(+h[(c[g>>2]|0)+4488>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[76872]=1;i=d;return}function mca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76984]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(76992,vCa(+h[(c[g>>2]|0)+4472>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[76984]=1;i=d;return}function nca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77096]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(77104,vCa(+h[(c[g>>2]|0)+4464>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77096]=1;i=d;return}function oca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77232]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(77240,vCa(+h[(c[g>>2]|0)+512>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77232]=1;i=d;return}function pca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77352]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(77360,vCa(+h[(c[g>>2]|0)+504>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77352]=1;i=d;return}function qca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77472]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(77480,vCa(+h[(c[g>>2]|0)+4440>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77472]=1;i=d;return}function rca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77608]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(77616,vCa(+h[(c[g>>2]|0)+4432>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77608]=1;i=d;return}function sca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77744]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4424>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(77752,vCa(+h[(c[g>>2]|0)+4424>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[77744]=1;i=d;return}function tca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77936]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+584>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+584>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(77944,xCa(c[(c[g>>2]|0)+584>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[77936]=1;i=d;return}function uca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78216]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(78224,vCa(+h[(c[g>>2]|0)+4408>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[78216]=1;i=d;return}function vca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78344]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(78352,vCa(+h[(c[g>>2]|0)+4384>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[78344]=1;i=d;return}function wca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78480]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4368>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(78488,vCa(+h[(c[g>>2]|0)+4368>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[78480]=1;i=d;return}function xca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78664]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4360>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(78672,vCa(+h[(c[g>>2]|0)+4360>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[78664]=1;i=d;return}function yca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78848]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+448>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(78856,vCa(+h[(c[g>>2]|0)+448>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[78848]=1;i=d;return}function zca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79008]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+440>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(79016,vCa(+h[(c[g>>2]|0)+440>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[79008]=1;i=d;return}function Aca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79168]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4336>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4336>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(79176,vCa(+h[(c[g>>2]|0)+4336>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[79168]=1;i=d;return}function Bca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79320]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+568>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+568>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(79328,xCa(c[(c[g>>2]|0)+568>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95104;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[79320]=1;i=d;return}function Cca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79560]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+564>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+564>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(79568,xCa(c[(c[g>>2]|0)+564>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95368;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[79560]=1;i=d;return}function Dca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79808]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+432>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+432>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(79816,vCa(+h[(c[g>>2]|0)+432>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[79808]=1;i=d;return}function Eca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79952]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4312>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(79960,vCa(+h[(c[g>>2]|0)+4312>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[79952]=1;i=d;return}function Fca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80120]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+556>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(80128,xCa(c[(c[g>>2]|0)+556>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[80120]=1;i=d;return}function Gca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80368]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4304>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(80376,vCa(+h[(c[g>>2]|0)+4304>>3],67480)|0)|0;g=c[72854]|0;j=e;k=96136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[80368]=1;i=d;return}function Hca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80520]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+552>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+552>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(80528,xCa(c[(c[g>>2]|0)+552>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[80520]=1;i=d;return}function Ica(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80760]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+548>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(80768,xCa(c[(c[g>>2]|0)+548>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[80760]=1;i=d;return}function Jca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81e3]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+532>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(81008,xCa(c[(c[g>>2]|0)+532>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96888;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[81e3]=1;i=d;return}function Kca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81232]&1){i=d;return}g=b+420|0;if(!((sFa(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=ACa(81240,xCa(c[(c[g>>2]|0)+528>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=97008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[81232]=1;i=d;return}function Lca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81336]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4296>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4296>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(81344,vCa(+h[(c[g>>2]|0)+4296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97184;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81336]=1;i=d;return}function Mca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81496]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4288>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4288>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(81504,vCa(+h[(c[g>>2]|0)+4288>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81496]=1;i=d;return}function Nca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81640]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(81648,vCa(+h[(c[g>>2]|0)+4272>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81640]=1;i=d;return}function Oca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81752]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(81760,vCa(+h[(c[g>>2]|0)+4264>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81752]=1;i=d;return}function Pca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81864]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(81872,vCa(+h[(c[g>>2]|0)+4248>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81864]=1;i=d;return}function Qca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81976]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(81984,vCa(+h[(c[g>>2]|0)+4240>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[81976]=1;i=d;return}function Rca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82104]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(82112,vCa(+h[(c[g>>2]|0)+4232>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[82104]=1;i=d;return}function Sca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82240]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4224>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(82248,vCa(+h[(c[g>>2]|0)+4224>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[82240]=1;i=d;return}function Tca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82432]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+524>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+524>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(82440,xCa(c[(c[g>>2]|0)+524>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[82432]=1;i=d;return}function Uca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82704]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(82712,vCa(+h[(c[g>>2]|0)+4208>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[82704]=1;i=d;return}function Vca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82832]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(82840,vCa(+h[(c[g>>2]|0)+4184>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[82832]=1;i=d;return}function Wca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82960]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4168>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4168>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(82968,vCa(+h[(c[g>>2]|0)+4168>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[82960]=1;i=d;return}function Xca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83136]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4160>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4160>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(83144,vCa(+h[(c[g>>2]|0)+4160>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83136]=1;i=d;return}function Yca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83312]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4136>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(83320,vCa(+h[(c[g>>2]|0)+4136>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83312]=1;i=d;return}function Zca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83464]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4112>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4112>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(83472,vCa(+h[(c[g>>2]|0)+4112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83464]=1;i=d;return}function _ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83624]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4104>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(83632,vCa(+h[(c[g>>2]|0)+4104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83624]=1;i=d;return}function $ca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83776]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(83784,vCa(+h[(c[g>>2]|0)+4088>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83776]=1;i=d;return}function ada(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83888]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(83896,vCa(+h[(c[g>>2]|0)+4080>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83888]=1;i=d;return}function bda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83992]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4064>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(84e3,vCa(+h[(c[g>>2]|0)+4064>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[83992]=1;i=d;return}function cda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84104]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(84112,vCa(+h[(c[g>>2]|0)+4056>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[84104]=1;i=d;return}function dda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84232]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(84240,vCa(+h[(c[g>>2]|0)+4048>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[84232]=1;i=d;return}function eda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84368]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+4040>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+4040>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(84376,vCa(+h[(c[g>>2]|0)+4040>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[84368]=1;i=d;return}function fda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84560]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+512>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+512>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(84568,xCa(c[(c[g>>2]|0)+512>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[84560]=1;i=d;return}function gda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84832]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(84840,vCa(+h[(c[g>>2]|0)+4024>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[84832]=1;i=d;return}function hda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84960]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+4e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(84968,vCa(+h[(c[g>>2]|0)+4e3>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[84960]=1;i=d;return}function ida(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85088]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3984>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(85096,vCa(+h[(c[g>>2]|0)+3984>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85088]=1;i=d;return}function jda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85264]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3976>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(85272,vCa(+h[(c[g>>2]|0)+3976>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85264]=1;i=d;return}function kda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85440]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3952>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(85448,vCa(+h[(c[g>>2]|0)+3952>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85440]=1;i=d;return}function lda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85592]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3928>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(85600,vCa(+h[(c[g>>2]|0)+3928>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85592]=1;i=d;return}function mda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85752]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3920>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3920>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(85760,vCa(+h[(c[g>>2]|0)+3920>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85752]=1;i=d;return}function nda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85904]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(85912,vCa(+h[(c[g>>2]|0)+3904>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[85904]=1;i=d;return}function oda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86016]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(86024,vCa(+h[(c[g>>2]|0)+3896>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86016]=1;i=d;return}function pda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86120]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3880>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(86128,vCa(+h[(c[g>>2]|0)+3880>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86120]=1;i=d;return}function qda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86232]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(86240,vCa(+h[(c[g>>2]|0)+3872>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86232]=1;i=d;return}function rda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86360]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(86368,vCa(+h[(c[g>>2]|0)+3864>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86360]=1;i=d;return}function sda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86488]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3856>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3856>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(86496,vCa(+h[(c[g>>2]|0)+3856>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86488]=1;i=d;return}function tda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86672]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+500>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+500>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(86680,xCa(c[(c[g>>2]|0)+500>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[86672]=1;i=d;return}function uda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86944]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(86952,vCa(+h[(c[g>>2]|0)+3840>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[86944]=1;i=d;return}function vda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87064]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(87072,vCa(+h[(c[g>>2]|0)+3816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87064]=1;i=d;return}function wda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87192]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3800>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3800>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(87200,vCa(+h[(c[g>>2]|0)+3800>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87192]=1;i=d;return}function xda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87368]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3792>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(87376,vCa(+h[(c[g>>2]|0)+3792>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87368]=1;i=d;return}function yda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87544]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(87552,vCa(+h[(c[g>>2]|0)+3768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87544]=1;i=d;return}function zda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87688]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3744>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3744>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(87696,vCa(+h[(c[g>>2]|0)+3744>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87688]=1;i=d;return}function Ada(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87840]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3736>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(87848,vCa(+h[(c[g>>2]|0)+3736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87840]=1;i=d;return}function Bda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87984]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(87992,vCa(+h[(c[g>>2]|0)+3720>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[87984]=1;i=d;return}function Cda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88088]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(88096,vCa(+h[(c[g>>2]|0)+3712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[88088]=1;i=d;return}function Dda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88192]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3696>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(88200,vCa(+h[(c[g>>2]|0)+3696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[88192]=1;i=d;return}function Eda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88296]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(88304,vCa(+h[(c[g>>2]|0)+3688>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[88296]=1;i=d;return}function Fda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88424]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(88432,vCa(+h[(c[g>>2]|0)+3680>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[88424]=1;i=d;return}function Gda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88552]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3672>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3672>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(88560,vCa(+h[(c[g>>2]|0)+3672>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[88552]=1;i=d;return}function Hda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88736]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+488>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+488>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(88744,xCa(c[(c[g>>2]|0)+488>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[88736]=1;i=d;return}function Ida(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89008]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(89016,vCa(+h[(c[g>>2]|0)+3656>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89008]=1;i=d;return}function Jda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89128]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(89136,vCa(+h[(c[g>>2]|0)+3632>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89128]=1;i=d;return}function Kda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89256]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3616>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(89264,vCa(+h[(c[g>>2]|0)+3616>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89256]=1;i=d;return}function Lda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89432]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3608>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(89440,vCa(+h[(c[g>>2]|0)+3608>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89432]=1;i=d;return}function Mda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89608]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3584>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(89616,vCa(+h[(c[g>>2]|0)+3584>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89608]=1;i=d;return}function Nda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89752]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3560>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(89760,vCa(+h[(c[g>>2]|0)+3560>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89752]=1;i=d;return}function Oda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89904]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3552>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(89912,vCa(+h[(c[g>>2]|0)+3552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[89904]=1;i=d;return}function Pda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90048]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(90056,vCa(+h[(c[g>>2]|0)+3536>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90048]=1;i=d;return}function Qda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90152]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(90160,vCa(+h[(c[g>>2]|0)+3528>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90152]=1;i=d;return}function Rda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90256]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3512>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(90264,vCa(+h[(c[g>>2]|0)+3512>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90256]=1;i=d;return}function Sda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90360]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(90368,vCa(+h[(c[g>>2]|0)+3504>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90360]=1;i=d;return}function Tda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90488]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(90496,vCa(+h[(c[g>>2]|0)+3496>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90488]=1;i=d;return}function Uda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90616]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3488>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3488>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(90624,vCa(+h[(c[g>>2]|0)+3488>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[90616]=1;i=d;return}function Vda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90800]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+476>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+476>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(90808,xCa(c[(c[g>>2]|0)+476>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[90800]=1;i=d;return}function Wda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91072]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(91080,vCa(+h[(c[g>>2]|0)+3472>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91072]=1;i=d;return}function Xda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91192]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(91200,vCa(+h[(c[g>>2]|0)+3448>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91192]=1;i=d;return}function Yda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91320]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3432>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3432>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(91328,vCa(+h[(c[g>>2]|0)+3432>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91320]=1;i=d;return}function Zda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91496]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3424>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(91504,vCa(+h[(c[g>>2]|0)+3424>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91496]=1;i=d;return}function _da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91672]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3400>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(91680,vCa(+h[(c[g>>2]|0)+3400>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91672]=1;i=d;return}function $da(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91840]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3376>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(91848,vCa(+h[(c[g>>2]|0)+3376>>3],67480)|0)|0;g=c[72854]|0;j=e;k=91992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[91840]=1;i=d;return}function aea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92016]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3368>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(92024,vCa(+h[(c[g>>2]|0)+3368>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92016]=1;i=d;return}function bea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92184]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92192,vCa(+h[(c[g>>2]|0)+3352>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92184]=1;i=d;return}function cea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92288]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92296,vCa(+h[(c[g>>2]|0)+3344>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92288]=1;i=d;return}function dea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92392]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3328>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(92400,vCa(+h[(c[g>>2]|0)+3328>>3],67480)|0)|0;g=c[72854]|0;j=e;k=97728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92392]=1;i=d;return}function eea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92496]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92504,vCa(+h[(c[g>>2]|0)+3320>>3],67480)|0)|0;g=c[72854]|0;j=e;k=144152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92496]=1;i=d;return}function fea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92624]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92632,vCa(+h[(c[g>>2]|0)+392>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92624]=1;i=d;return}function gea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92736]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92744,vCa(+h[(c[g>>2]|0)+384>>3],67480)|0)|0;g=c[72854]|0;j=e;k=92848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92736]=1;i=d;return}function hea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92872]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(92880,vCa(+h[(c[g>>2]|0)+3296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[92872]=1;i=d;return}function iea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93024]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(93032,vCa(+h[(c[g>>2]|0)+3288>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[93024]=1;i=d;return}function jea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93176]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3280>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3280>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(93184,vCa(+h[(c[g>>2]|0)+3280>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[93176]=1;i=d;return}function kea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93384]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+460>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+460>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(93392,xCa(c[(c[g>>2]|0)+460>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=93656;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[93384]=1;i=d;return}function lea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93680]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(93688,vCa(+h[(c[g>>2]|0)+3264>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[93680]=1;i=d;return}function mea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93824]&1){i=d;return}g=b+416|0;if(!((sFa(+h[(c[g>>2]|0)+3240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(93832,vCa(+h[(c[g>>2]|0)+3240>>3],67480)|0)|0;g=c[72854]|0;j=e;k=93952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[93824]=1;i=d;return}function nea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93976]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3224>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3224>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(93984,vCa(+h[(c[g>>2]|0)+3224>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[93976]=1;i=d;return}function oea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94176]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3216>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(94184,vCa(+h[(c[g>>2]|0)+3216>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[94176]=1;i=d;return}function pea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94376]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(94384,vCa(+h[(c[g>>2]|0)+328>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[94376]=1;i=d;return}function qea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94528]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+320>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(94536,vCa(+h[(c[g>>2]|0)+320>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[94528]=1;i=d;return}function rea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94704]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3192>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(94712,vCa(+h[(c[g>>2]|0)+3192>>3],67480)|0)|0;g=c[72854]|0;j=e;k=94848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[94704]=1;i=d;return}function sea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94872]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+444>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+444>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(94880,xCa(c[(c[g>>2]|0)+444>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95104;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[94872]=1;i=d;return}function tea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95128]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+440>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+440>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(95136,xCa(c[(c[g>>2]|0)+440>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95368;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[95128]=1;i=d;return}function uea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95392]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+312>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(95400,vCa(+h[(c[g>>2]|0)+312>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[95392]=1;i=d;return}function vea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95552]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3168>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(95560,vCa(+h[(c[g>>2]|0)+3168>>3],67480)|0)|0;g=c[72854]|0;j=e;k=95704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[95552]=1;i=d;return}function wea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95728]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+432>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+432>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(95736,xCa(c[(c[g>>2]|0)+432>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=95968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[95728]=1;i=d;return}function xea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95992]&1){i=d;return}g=b+416|0;b=sFa(+h[(c[g>>2]|0)+3160>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[g>>2]|0)+3160>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(96e3,vCa(+h[(c[g>>2]|0)+3160>>3],67480)|0)|0;g=c[72854]|0;j=e;k=96136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[95992]=1;i=d;return}function yea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96160]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+428>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+428>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(96168,xCa(c[(c[g>>2]|0)+428>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[96160]=1;i=d;return}function zea(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96408]&1){i=d;return}g=b+420|0;b=sFa(+(c[(c[g>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[g>>2]|0)+424>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=ACa(96416,xCa(c[(c[g>>2]|0)+424>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=96640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[96408]=1;i=d;return}



function tw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4e3>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3976>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3984>>3];h[a+8>>3]=+h[d+3888>>3];h[e+8>>3]=+h[d+3864>>3];h[f+8>>3]=+h[d+3872>>3];i=i;return}function uw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+280>>3]=k;o=+h[b+8>>3];h[n+272>>3]=o;p=+h[n+760>>3];q=p*p;b=n+8|0;h[d>>3]=+h[n+2432>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2528>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n>>3],c[c[m+12>>2]>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+8>>3];q=+h[r>>3];k=+h[r+280>>3];p=+h[r+272>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2528>>3]- +h[j>>3];i=e;return}function vw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5120>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5096>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5104>>3];h[a+8>>3]=+h[d+5008>>3];h[e+8>>3]=+h[d+4984>>3];h[f+8>>3]=+h[d+4992>>3];i=i;return}function ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+360>>3]=k;o=+h[b+8>>3];h[n+352>>3]=o;p=+h[n+1800>>3];q=p*p;b=n+88|0;h[d>>3]=+h[n+2392>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2488>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+80>>3],c[(c[m+12>>2]|0)+20>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+88>>3];q=+h[r+80>>3];k=+h[r+360>>3];p=+h[r+352>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2488>>3]- +h[j>>3];i=e;return}function xw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+1984>>3],+h[a+128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+1984>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1240>>3]=+h[f>>3];i=b;return}function yw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+1984>>3],+h[a+128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+1984>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1280>>3]=+h[f>>3];i=b;return}function zw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1280>>3],+h[f+1240>>3],+h[f+1984>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1256>>3]=+h[d>>3];i=b;return}function Aw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1232>>3]=+h[f>>3];i=b;return}function Bw(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1200>>3]=+h[b+4120>>3]*(+h[d+4776>>3]- +h[d+1984>>3])*+h[b+4152>>3];i=i;return}function Cw(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+4120>>3]*+h[e+4152>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1200>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19304,19296,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}function Dw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[b+4776>>3]- +h[b+104>>3];i=i;return}function Ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1288>>3]=+h[f>>3];i=b;return}function Fw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1288>>3],+h[f+1232>>3],+h[f+4776>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1264>>3]=+h[d>>3];i=b;return}function Gw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+60|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+2128>>3]*+h[f+4720>>3]*.01;k=g;l=k+4712|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+4720>>3]*.01;k=g;l=k+4712|0;m=l;h[m>>3]=j;i=d;return}}function Hw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+66944>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+66920>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+66928>>3];h[a+8>>3]=+h[d+27856>>3];h[e+8>>3]=+h[d+27832>>3];h[f+8>>3]=+h[d+27840>>3];i=i;return}function Iw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+4776>>3]=+h[d>>3];h[l+1984>>3]=+h[d+8>>3];xw(j);yw(j);zw(j);Aw(j);Bw(j);Cw(j);Dw(j);Ew(j);Fw(j);Gw(j);m=+h[b+304>>3];j=b+536|0;d=c[j>>2]|0;l=c[c[k>>2]>>2]|0;n=c[l+8>>2]|0;o=+h[n+1192>>3];p=+h[n+1280>>3];q=+h[n+1288>>3];r=+h[n+1256>>3];s=+h[n+1264>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+4072>>3];w=+h[n+2936>>3];x=+h[u+4096>>3]*+h[u+4216>>3];y=+h[u+4088>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+516>>2]|0)+ -1|0;y=+(n|0);A=+h[u+4208>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+SBa(d,y,19368,19360,+h[l>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);_t(g,d,o,p,q,r,s,v,w,x,z,C,+h[B+4176>>3]);C=+h[g>>3];g=c[c[k>>2]>>2]|0;B=c[g+8>>2]|0;z=+h[B+4712>>3];x=m+-1.0;d=c[t>>2]|0;w=+h[B+1192>>3]- +h[d+4096>>3]*+h[d+4216>>3]*+h[d+4232>>3];v=+h[d+4184>>3];s=+h[d+4192>>3];do{if(v!=0.0){E=g;F=d;G=s/v}else{if(s==0.0){E=g;F=d;G=s;break}r=s/+SBa(c[j>>2]|0,v,19408,19360,+h[g>>3],(a[b+319|0]|0)!=0|0);E=c[c[k>>2]>>2]|0;F=c[t>>2]|0;G=r}}while(0);h[e>>3]=z+(x*w*G-m*C*+h[F+4152>>3]);if((a[(c[E+16>>2]|0)+2|0]|0)==0){g=c[E+8>>2]|0;if((a[(c[b+408>>2]|0)+3|0]|0)==0){H=+h[g+1984>>3]- +h[F+3048>>3]}else{H=-+h[g+4712>>3]}I=-H;J=e;K=J+8|0;L=K;h[L>>3]=I;i=f;return}do{if((pFa(-+h[(c[E+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0){M=0.0}else{g=c[c[k>>2]>>2]|0;F=c[g+8>>2]|0;H=+h[F+3056>>3];C=+h[F+4712>>3];m=-C;do{if(H!=0.0){N=F;O=g;P=m/H}else{if(C==-0.0){N=F;O=g;P=m;break}G=m/+SBa(c[j>>2]|0,H,19440,19360,+h[g>>3],(a[b+319|0]|0)!=0|0);d=c[c[k>>2]>>2]|0;N=c[d+8>>2]|0;O=d;P=G}}while(0);H=+h[N+3896>>3]*2.0;m=P*P;if(H!=0.0){M=m/H;break}if(m==0.0){M=m;break}M=m/+SBa(c[j>>2]|0,H,19464,19360,+h[O>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=c[t>>2]|0;I=+h[b+1984>>3]-(+h[k+3048>>3]+(+h[b+1968>>3]*+h[k+2528>>3]*+h[b+3896>>3]-M));J=e;K=J+8|0;L=K;h[L>>3]=I;i=f;return}function Jw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+232>>3]- +h[b+4624>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+h[b+104>>3]- +h[b+4696>>3];i=i;return}function Lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4648>>3]=+h[b+4600>>3]*+(c[(c[a+420>>2]|0)+196>>2]|0);i=i;return}function Mw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+304|0;j=+h[g>>3];k=b+536|0;l=c[k>>2]|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+4600>>3];q=+h[o+4616>>3];r=+h[(c[b+416>>2]|0)+2160>>3];do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+SBa(l,q,19496,19488,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);Nt(e,l,p*s,.8);s=+h[e>>3];p=+h[g>>3];Nt(f,c[k>>2]|0,.0001001797131419643,.8);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+4632>>3]=j*s+(1.0-p)*+h[f>>3];i=d;return}function Nw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0;d=i;i=i+80|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=d+64|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=b+304|0;w=+h[v>>3];x=b+416|0;y=+h[(c[x>>2]|0)+2160>>3];z=b+4|0;A=c[c[z>>2]>>2]|0;B=+h[(c[A+8>>2]|0)+4616>>3];do{if(y!=0.0){C=B/y}else{if(B==0.0){C=B;break}C=B/+SBa(c[b+536>>2]|0,y,19512,19504,+h[A>>3],(a[b+319|0]|0)!=0|0)}}while(0);A=o;h[k>>3]=1.0e-4;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=o+8|0;h[k>>3]=15.0e-5;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];WCa(p,3,0.0,o);o=n;h[k>>3]=5.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=0.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];WCa(q,3,10.0,n);n=b+536|0;o=c[n>>2]|0;A=c[c[z>>2]>>2]|0;D=c[A+8>>2]|0;y=+h[D+4600>>3];B=+h[D+4616>>3];E=+h[(c[x>>2]|0)+2160>>3];do{if(B!=0.0){F=E/B}else{if(E==0.0){F=E;break}F=E/+SBa(o,B,19496,19504,+h[A>>3],(a[b+319|0]|0)!=0|0)}}while(0);B=y*F;A=j;D=p;c[A+0>>2]=c[D+0>>2];c[A+4>>2]=c[D+4>>2];c[A+8>>2]=c[D+8>>2];D=g;A=q;c[D+0>>2]=c[A+0>>2];c[D+4>>2]=c[A+4>>2];c[D+8>>2]=c[A+8>>2];Lt(t,o,B,j,g);B=+h[t>>3];F=+h[v>>3];v=m;h[k>>3]=1.0e-4;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=m+8|0;h[k>>3]=15.0e-5;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];WCa(r,3,0.0,m);m=l;h[k>>3]=5.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=0.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];WCa(s,3,10.0,l);l=c[n>>2]|0;m=f;v=r;c[m+0>>2]=c[v+0>>2];c[m+4>>2]=c[v+4>>2];c[m+8>>2]=c[v+8>>2];v=e;m=s;c[v+0>>2]=c[m+0>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];Lt(u,l,0.0,f,e);y=w*C*C*B;B=1.0-F;e=c[c[z>>2]>>2]|0;f=c[e+8>>2]|0;F=+h[f+4616>>3];l=c[x>>2]|0;C=+h[l+2160>>3];w=+h[u>>3]+ +h[l+2256>>3]*+h[f+4600>>3];if(C!=0.0){G=f;H=w/C;I=F*H;J=B*I;K=y+J;L=G;M=L+4512|0;N=M;h[N>>3]=K;i=d;return}if(w==0.0){G=f;H=w;I=F*H;J=B*I;K=y+J;L=G;M=L+4512|0;N=M;h[N>>3]=K;i=d;return}E=w/+SBa(c[n>>2]|0,C,19512,19504,+h[e>>3],(a[b+319|0]|0)!=0|0);G=c[(c[c[z>>2]>>2]|0)+8>>2]|0;H=E;I=F*H;J=B*I;K=y+J;L=G;M=L+4512|0;N=M;h[N>>3]=K;i=d;return}function Ow(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1088>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+224|0;h[f+4664>>3]=+h[f+5520>>3]*+h[(a<<24>>24==0?d:f+96|0)>>3]- +h[f+1088>>3]*+h[(e<<24>>24==0?d:f+48|0)>>3];i=b;return}function Pw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+6664>>3]- +h[b+4664>>3];i=i;return}function Qw(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+196>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+4656>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,f,19536,19528,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4640|0;q=p;h[q>>3]=n;i=d;return}function Rw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+64816>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+64792>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+64800>>3];h[a+8>>3]=+h[d+77360>>3];h[e+8>>3]=+h[d+77336>>3];h[f+8>>3]=+h[d+77344>>3];h[a+16>>3]=+h[d+64480>>3];h[e+16>>3]=+h[d+64456>>3];h[f+16>>3]=+h[d+64464>>3];h[a+24>>3]=+h[d+64704>>3];h[e+24>>3]=+h[d+64680>>3];h[f+24>>3]=+h[d+64688>>3];i=i;return}function Sw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+4624>>3]=+h[d>>3];h[k+5520>>3]=+h[d+8>>3];h[k+4600>>3]=+h[d+16>>3];h[k+4616>>3]=+h[d+24>>3];Jw(g);Kw(g);Lw(g);Mw(g);Nw(g);Ow(g);Pw(g);Qw(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;h[e>>3]=+h[d+4512>>3]*+h[d+4560>>3]*9.80665- +h[d+4624>>3];k=b+304|0;l=+h[k>>3];m=+h[d+4648>>3];n=l+-1.0;o=b+416|0;p=+h[(c[o>>2]|0)+2224>>3];q=+h[d+5520>>3];do{if(p!=0.0){r=q;s=d;t=g;u=q/p}else{if(q==0.0){r=q;s=d;t=g;u=q;break}v=q/+SBa(c[b+536>>2]|0,p,19568,19560,+h[g>>3],(a[b+319|0]|0)!=0|0);w=c[c[j>>2]>>2]|0;x=c[w+8>>2]|0;r=+h[x+5520>>3];s=x;t=w;u=v}}while(0);p=n*u;u=+h[s+4560>>3];do{if(u!=0.0){y=s;z=t;A=r/u}else{if(r==0.0){y=s;z=t;A=r;break}n=r/+SBa(c[b+536>>2]|0,u,19584,19560,+h[t>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;y=c[g+8>>2]|0;z=g;A=n}}while(0);h[e+8>>3]=m+(p-l*A);A=+h[k>>3];l=+h[y+4640>>3];p=A+-1.0;m=+h[y+4632>>3];u=+h[y+4624>>3];do{if(m!=0.0){B=m;C=u;D=y;E=z;F=u/m}else{if(u==0.0){B=m;C=u;D=y;E=z;F=u;break}r=u/+SBa(c[b+536>>2]|0,m,19592,19560,+h[z>>3],(a[b+319|0]|0)!=0|0);k=c[c[j>>2]>>2]|0;t=c[k+8>>2]|0;B=+h[t+4632>>3];C=+h[t+4624>>3];D=t;E=k;F=r}}while(0);m=p*F*.0001001797131419643;F=+h[D+4600>>3];do{if(B!=0.0){G=D;H=E;I=F/B}else{if(F==0.0){G=D;H=E;I=F;break}p=F/+SBa(c[b+536>>2]|0,B,19592,19560,+h[E>>3],(a[b+319|0]|0)!=0|0);z=c[c[j>>2]>>2]|0;G=c[z+8>>2]|0;H=z;I=p}}while(0);h[e+16>>3]=l+(m-A*C*I);I=+h[G+5520>>3];if((a[(c[H+16>>2]|0)+60|0]|0)==0){J=+h[(c[o>>2]|0)+1536>>3]*+h[G+5528>>3]*.01;K=I-J;L=e;M=L+24|0;N=M;h[N>>3]=K;i=f;return}else{J=+h[G+5528>>3]*.01;K=I-J;L=e;M=L+24|0;N=M;h[N>>3]=K;i=f;return}}function Tw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5232>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5208>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5216>>3];h[a+8>>3]=+h[d+5344>>3];h[e+8>>3]=+h[d+5320>>3];h[f+8>>3]=+h[d+5328>>3];i=i;return}function Uw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+368>>3]=k;o=+h[b+8>>3];h[n+376>>3]=o;p=+h[n+3544>>3];q=p*p;b=n+104|0;h[d>>3]=+h[n+6640>>3]*q+(p*o+(-(q*k)- +h[b>>3]*+h[n+6792>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+96>>3],c[(c[m+12>>2]|0)+64>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;k=+h[r+104>>3];q=+h[r+96>>3];o=+h[r+376>>3];p=+h[r+368>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,k,q,f,o,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6792>>3]- +h[j>>3];i=e;return}function Vw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7136>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7112>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7120>>3];h[a+8>>3]=+h[d+7024>>3];h[e+8>>3]=+h[d+7e3>>3];h[f+8>>3]=+h[d+7008>>3];i=i;return}function Ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+504>>3]=k;o=+h[b+8>>3];h[n+496>>3]=o;p=+h[n+4560>>3];q=p*p;b=n+232|0;h[d>>3]=+h[n+6576>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+6800>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+224>>3],c[(c[m+12>>2]|0)+96>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+232>>3];q=+h[r+224>>3];k=+h[r+504>>3];p=+h[r+496>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6800>>3]- +h[j>>3];i=e;return}function Xw(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+59440>>3];h[c[b+8>>2]>>3]=+h[d+59416>>3];h[c[b+12>>2]>>3]=+h[d+59424>>3];i=i;return}function Yw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0,g=0.0;e=i;f=+h[b>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4240>>3]=f;g=+h[b+4616>>3];h[d>>3]=g- +xd(+f,.001);i=e;return}function Zw(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+59104>>3];h[c[b+8>>2]>>3]=+h[d+59080>>3];h[c[b+12>>2]>>3]=+h[d+59088>>3];i=i;return}function _w(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0;f=i;g=+h[d>>3];d=b+4|0;j=c[c[d>>2]>>2]|0;h[(c[j+8>>2]|0)+4216>>3]=g;do{if((a[b+314|0]|0)==0){k=a[(c[b+356>>2]|0)+63|0]|0}else{l=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(l){m=a[(c[b+356>>2]|0)+63|0]|0;n=lFa(+h[j>>3],g,a[(c[b+360>>2]|0)+63|0]|0)|0;a[(c[b+352>>2]|0)+63|0]=n;k=m;break}else{m=lFa(+h[j>>3],g,a[(c[b+360>>2]|0)+63|0]|0)|0;a[(c[b+352>>2]|0)+63|0]=m;k=m;break}}else{if(l){l=a[(c[b+356>>2]|0)+63|0]|0;m=pFa(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+63|0]=m;k=l;break}else{l=pFa(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+63|0]=l;k=l;break}}}}while(0);b=c[c[d>>2]>>2]|0;d=c[b+8>>2]|0;g=+h[d+4240>>3];o=+h[d+4232>>3];if(k<<24>>24==0){p=o;q=g-p;h[e>>3]=q;i=f;return}p=o-(+h[d+4216>>3]- +h[b>>3])*+h[d+4224>>3];q=g-p;h[e>>3]=q;i=f;return}function $w(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+59440>>3];h[c[b+8>>2]>>3]=+h[d+59416>>3];h[c[b+12>>2]>>3]=+h[d+59424>>3];i=i;return}function ax(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;h[(c[a+400>>2]|0)+4240>>3]=+h[b>>3];b=c[c[a+4>>2]>>2]|0;h[d>>3]=+h[(c[b+8>>2]|0)+4216>>3]- +h[b>>3];i=i;return}function bx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4672>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4648>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4656>>3];h[a+8>>3]=+h[d+4560>>3];h[e+8>>3]=+h[d+4536>>3];h[f+8>>3]=+h[d+4544>>3];i=i;return}function cx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+328>>3]=k;o=+h[b+8>>3];h[n+320>>3]=o;p=+h[n+1048>>3];q=p*p;b=n+56|0;h[d>>3]=+h[n+2408>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2504>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+48>>3],c[(c[m+12>>2]|0)+12>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+56>>3];q=+h[r+48>>3];k=+h[r+328>>3];p=+h[r+320>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2504>>3]- +h[j>>3];i=e;return}function dx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4896>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4872>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4880>>3];h[a+8>>3]=+h[d+4784>>3];h[e+8>>3]=+h[d+4760>>3];h[f+8>>3]=+h[d+4768>>3];i=i;return}function ex(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+344>>3]=k;o=+h[b+8>>3];h[n+336>>3]=o;p=+h[n+1808>>3];q=p*p;b=n+72|0;h[d>>3]=+h[n+2400>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2496>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+64>>3],c[(c[m+12>>2]|0)+16>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+72>>3];q=+h[r+64>>3];k=+h[r+344>>3];p=+h[r+336>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2496>>3]- +h[j>>3];i=e;return}function fx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4448>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4424>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4432>>3];h[a+8>>3]=+h[d+4336>>3];h[e+8>>3]=+h[d+4312>>3];h[f+8>>3]=+h[d+4320>>3];i=i;return}function gx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+312>>3]=k;o=+h[b+8>>3];h[n+304>>3]=o;p=+h[n+1056>>3];q=p*p;b=n+40|0;h[d>>3]=+h[n+2416>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2512>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+32>>3],c[(c[m+12>>2]|0)+8>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+40>>3];q=+h[r+32>>3];k=+h[r+312>>3];p=+h[r+304>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2512>>3]- +h[j>>3];i=e;return}function hx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6032>>3]=+h[b+2128>>3]- +h[(c[a+416>>2]|0)+2936>>3];i=i;return}function ix(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+92|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1144>>3]*+h[f+6032>>3]*.01;k=g;l=k+6024|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+6032>>3]*.01;k=g;l=k+6024|0;m=l;h[m>>3]=j;i=d;return}}function jx(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+29872>>3];h[c[b+8>>2]>>3]=+h[d+29848>>3];h[c[b+12>>2]>>3]=+h[d+29856>>3];i=i;return}function kx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d>>3];hx(g);ix(g);g=c[c[j>>2]>>2]|0;if((a[(c[g+16>>2]|0)+6|0]|0)==0){d=c[g+8>>2]|0;if((a[(c[b+408>>2]|0)+8|0]|0)==0){k=+h[d+2128>>3]- +h[(c[b+416>>2]|0)+2824>>3]}else{k=-+h[d+6024>>3]}l=-k;h[e>>3]=l;i=f;return}do{if((pFa(-+h[(c[g+8>>2]|0)+6024>>3],0.0)|0)<<24>>24==0){m=0.0}else{d=c[c[j>>2]>>2]|0;n=c[d+8>>2]|0;k=+h[n+3096>>3];o=+h[n+6024>>3];p=-o;do{if(k!=0.0){q=n;r=d;s=p/k}else{if(o==-0.0){q=n;r=d;s=p;break}t=p/+SBa(c[b+536>>2]|0,k,19608,19600,+h[d>>3],(a[b+319|0]|0)!=0|0);u=c[c[j>>2]>>2]|0;q=c[u+8>>2]|0;r=u;s=t}}while(0);k=+h[q+4056>>3]*2.0;p=s*s;if(k!=0.0){m=p/k;break}if(p==0.0){m=p;break}m=p/+SBa(c[b+536>>2]|0,k,18832,19600,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;l=+h[r+2128>>3]-(+h[j+2824>>3]+(+h[r+2088>>3]*+h[j+2528>>3]*+h[r+4056>>3]-m));h[e>>3]=l;i=f;return}function lx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2968>>3]=+h[f>>3];i=b;return}function mx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1560>>3]=+h[f>>3];i=b;return}function nx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+2968>>3],+h[f+1560>>3],+h[f+5928>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2904>>3]=+h[d>>3];i=b;return}function ox(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1528>>3]=+h[b+3568>>3]*(+h[b+2824>>3]- +h[d+5928>>3])*+h[b+3600>>3];i=i;return}function px(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3568>>3]*+h[e+3600>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1528>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19640,19632,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}function qx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+1520>>3];p=+h[n+2968>>3];q=+h[n+2976>>3];r=+h[n+2904>>3];s=+h[n+2912>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+3520>>3];w=+h[n+2960>>3];x=+h[u+3544>>3]*+h[u+3664>>3];y=+h[u+3536>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+480>>2]|0)+ -1|0;y=+(n|0);A=+h[u+3656>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+SBa(k,y,19704,19696,+h[m>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);_t(e,k,o,p,q,r,s,v,w,x,z,C,+h[B+3624>>3]);B=c[t>>2]|0;C=g*+h[e>>3]*+h[B+3600>>3];g=1.0- +h[f>>3];f=c[c[l>>2]>>2]|0;e=c[f+8>>2]|0;z=+h[e+1520>>3]- +h[B+3544>>3]*+h[B+3664>>3]*+h[B+3680>>3];x=+h[B+3632>>3];w=+h[B+3640>>3];if(x!=0.0){E=w/x;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+5864|0;L=K;h[L>>3]=I;i=d;return}if(w==0.0){E=w;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+5864|0;L=K;h[L>>3]=I;i=d;return}v=w/+SBa(c[j>>2]|0,x,19744,19696,+h[f>>3],(a[b+319|0]|0)!=0|0);E=v;F=c[(c[c[l>>2]>>2]|0)+8>>2]|0;G=z*E;H=g*G;I=C+H;J=F;K=J+5864|0;L=K;h[L>>3]=I;i=d;return}function rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=+h[b+2192>>3]- +h[b+5928>>3];i=i;return}function sx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+30768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+30744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+30752>>3];h[a+8>>3]=+h[d+83072>>3];h[e+8>>3]=+h[d+83048>>3];h[f+8>>3]=+h[d+83056>>3];i=i;return}function tx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+2192>>3]=+h[d>>3];h[k+5928>>3]=+h[d+8>>3];lx(g);mx(g);nx(g);ox(g);px(g);qx(g);rx(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=d+5864|0;l=c[g+16>>2]|0;if((a[l+98|0]|0)==0){m=+h[(c[b+416>>2]|0)+1256>>3]*+h[d+5872>>3]*.01}else{m=+h[d+5872>>3]*.01}h[e>>3]=+h[k>>3]-m;if((a[l+10|0]|0)==0){if((a[(c[b+408>>2]|0)+11|0]|0)==0){n=+h[d+2192>>3]- +h[(c[b+416>>2]|0)+2712>>3]}else{n=-+h[k>>3]}o=-n;p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}do{if((pFa(-+h[k>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[j>>2]>>2]|0;l=c[d+8>>2]|0;n=+h[l+3120>>3];m=+h[l+5864>>3];t=-m;do{if(n!=0.0){u=l;v=d;w=t/n}else{if(m==-0.0){u=l;v=d;w=t;break}x=t/+SBa(c[b+536>>2]|0,n,19784,19776,+h[d>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;u=c[g+8>>2]|0;v=g;w=x}}while(0);n=+h[u+4128>>3]*2.0;t=w*w;if(n!=0.0){s=t/n;break}if(t==0.0){s=t;break}s=t/+SBa(c[b+536>>2]|0,n,19808,19776,+h[v>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;o=+h[v+2192>>3]-(+h[j+2712>>3]+(+h[v+2176>>3]*+h[j+2528>>3]*+h[v+4128>>3]-s));p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}function ux(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2712>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+176>>3];n=+h[j+448>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6744>>3]=+h[f>>3];i=b;return}function vx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=-(+h[(c[a+416>>2]|0)+2712>>3]*+h[b+6520>>3]);i=i;return}function wx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+4152>>3]+ +h[b+4144>>3];i=i;return}function xx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4128>>3];k=+h[g+448>>3];l=+h[(c[b+416>>2]|0)+2712>>3];m=j*j;j=+h[g+6744>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,19840,19832,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}function yx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6352>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6328>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6336>>3];h[a+8>>3]=+h[d+91360>>3];h[e+8>>3]=+h[d+91336>>3];h[f+8>>3]=+h[d+91344>>3];i=i;return}function zx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+448>>3]=+h[b>>3];h[a+6520>>3]=+h[b+8>>3];ux(f);vx(f);wx(f);xx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+4160|0;h[d>>3]=+h[f+6688>>3]+(-(+h[f+4168>>3]*+h[f+6600>>3])- +h[g>>3]*+h[f+4120>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+4136>>3]*+h[f+6744>>3])- +h[f+6520>>3]*+h[f+4128>>3]);i=e;return}function Ax(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1624>>3]=+h[f>>3];i=b;return}function Bx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3e3>>3]=+h[f>>3];i=b;return}function Cx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+3e3>>3],+h[f+1624>>3],+h[f+6008>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2888>>3]=+h[d>>3];i=b;return}function Dx(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1592>>3]=+h[b+3384>>3]*(+h[b+2824>>3]- +h[d+6008>>3])*+h[b+3416>>3];i=i;return}function Ex(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3384>>3]*+h[e+3416>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1592>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19872,19864,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}function Fx(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+1584>>3];p=+h[n+3e3>>3];q=+h[n+3008>>3];r=+h[n+2888>>3];s=+h[n+2896>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+3336>>3];w=+h[n+2992>>3];x=+h[u+3360>>3]*+h[u+3480>>3];y=+h[u+3352>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+468>>2]|0)+ -1|0;y=+(n|0);A=+h[u+3472>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+SBa(k,y,19936,19928,+h[m>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);_t(e,k,o,p,q,r,s,v,w,x,z,C,+h[B+3440>>3]);B=c[t>>2]|0;C=g*+h[e>>3]*+h[B+3416>>3];g=1.0- +h[f>>3];f=c[c[l>>2]>>2]|0;e=c[f+8>>2]|0;z=+h[e+1584>>3]- +h[B+3360>>3]*+h[B+3480>>3]*+h[B+3496>>3];x=+h[B+3448>>3];w=+h[B+3456>>3];if(x!=0.0){E=w/x;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+5944|0;L=K;h[L>>3]=I;i=d;return}if(w==0.0){E=w;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+5944|0;L=K;h[L>>3]=I;i=d;return}v=w/+SBa(c[j>>2]|0,x,19976,19928,+h[f>>3],(a[b+319|0]|0)!=0|0);E=v;F=c[(c[c[l>>2]>>2]|0)+8>>2]|0;G=z*E;H=g*G;I=C+H;J=F;K=J+5944|0;L=K;h[L>>3]=I;i=d;return}function Gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5952>>3]=+h[b+2248>>3]- +h[b+6008>>3];i=i;return}function Hx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+31552>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+31528>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+31536>>3];h[a+8>>3]=+h[d+84192>>3];h[e+8>>3]=+h[d+84168>>3];h[f+8>>3]=+h[d+84176>>3];i=i;return}function Ix(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+2248>>3]=+h[d>>3];h[k+6008>>3]=+h[d+8>>3];Ax(g);Bx(g);Cx(g);Dx(g);Ex(g);Fx(g);Gx(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=d+5944|0;l=c[g+16>>2]|0;if((a[l+102|0]|0)==0){m=+h[(c[b+416>>2]|0)+1200>>3]*+h[d+5952>>3]*.01}else{m=+h[d+5952>>3]*.01}h[e>>3]=+h[k>>3]-m;if((a[l+12|0]|0)==0){if((a[(c[b+408>>2]|0)+13|0]|0)==0){n=+h[d+2248>>3]- +h[(c[b+416>>2]|0)+2456>>3]}else{n=-+h[k>>3]}o=-n;p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}do{if((pFa(-+h[k>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[j>>2]>>2]|0;l=c[d+8>>2]|0;n=+h[l+3136>>3];m=+h[l+5944>>3];t=-m;do{if(n!=0.0){u=l;v=d;w=t/n}else{if(m==-0.0){u=l;v=d;w=t;break}x=t/+SBa(c[b+536>>2]|0,n,20016,20008,+h[d>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;u=c[g+8>>2]|0;v=g;w=x}}while(0);n=+h[u+4264>>3]*2.0;t=w*w;if(n!=0.0){s=t/n;break}if(t==0.0){s=t;break}s=t/+SBa(c[b+536>>2]|0,n,20040,20008,+h[v>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;o=+h[v+2248>>3]-(+h[j+2456>>3]+(+h[v+2232>>3]*+h[j+2528>>3]*+h[v+4264>>3]-s));p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}function Jx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2824>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+160>>3];n=+h[j+432>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6752>>3]=+h[f>>3];i=b;return}function Kx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4056>>3];k=+h[g+432>>3];l=+h[(c[b+416>>2]|0)+2824>>3];m=j*j;j=+h[g+6752>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20072,20064,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}function Lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=-(+h[(c[a+416>>2]|0)+2824>>3]*+h[b+6528>>3]);i=i;return}function Mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6696>>3]=+h[b+4080>>3]+ +h[b+4072>>3];i=i;return}function Nx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6112>>3];h[a+8>>3]=+h[d+91472>>3];h[e+8>>3]=+h[d+91448>>3];h[f+8>>3]=+h[d+91456>>3];i=i;return}function Ox(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+432>>3]=+h[b>>3];h[a+6528>>3]=+h[b+8>>3];Jx(f);Kx(f);Lx(f);Mx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+4088|0;h[d>>3]=+h[f+6696>>3]+(-(+h[f+4096>>3]*+h[f+6608>>3])- +h[g>>3]*+h[f+4048>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+4064>>3]*+h[f+6752>>3])- +h[f+6528>>3]*+h[f+4056>>3]);i=e;return}function Px(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2456>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+192>>3];n=+h[j+464>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6736>>3]=+h[f>>3];i=b;return}function Qx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4264>>3];k=+h[g+464>>3];l=+h[(c[b+416>>2]|0)+2456>>3];m=j*j;j=+h[g+6736>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20104,20096,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}function Rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=-(+h[(c[a+416>>2]|0)+2456>>3]*+h[b+6512>>3]);i=i;return}function Sx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=+h[b+4288>>3]+ +h[b+4280>>3];i=i;return}function Tx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6576>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6552>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6560>>3];h[a+8>>3]=+h[d+91248>>3];h[e+8>>3]=+h[d+91224>>3];h[f+8>>3]=+h[d+91232>>3];i=i;return}function Ux(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+464>>3]=+h[b>>3];h[a+6512>>3]=+h[b+8>>3];Px(f);Qx(f);Rx(f);Sx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+4296|0;h[d>>3]=+h[f+6680>>3]+(-(+h[f+4304>>3]*+h[f+6592>>3])- +h[g>>3]*+h[f+4256>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+4272>>3]*+h[f+6736>>3])- +h[f+6512>>3]*+h[f+4264>>3]);i=e;return}function Vx(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+3664>>3];h[c[b+8>>2]>>3]=+h[d+3640>>3];h[c[b+12>>2]>>3]=+h[d+3648>>3];i=i;return}function Wx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];b=a+4|0;l=c[c[b>>2]>>2]|0;h[(c[l+8>>2]|0)+256>>3]=k;m=a+536|0;n=a+416|0;fv(g,c[m>>2]|0,+h[(c[n>>2]|0)+776>>3],k,c[(c[l+12>>2]|0)+108>>2]|0,0);l=c[m>>2]|0;k=+h[(c[n>>2]|0)+776>>3];o=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+256>>3];n=f+0|0;m=g+0|0;g=n+120|0;do{c[n>>2]=c[m>>2];n=n+4|0;m=m+4|0}while((n|0)<(g|0));mv(j,l,k,o,f);h[d>>3]=+h[(c[(c[c[b>>2]>>2]|0)+8>>2]|0)+6424>>3]- +h[j>>3];i=e;return}function Xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+33344>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+33320>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+33328>>3];h[a+8>>3]=+h[d+89008>>3];h[e+8>>3]=+h[d+88984>>3];h[f+8>>3]=+h[d+88992>>3];h[a+16>>3]=+h[d+33120>>3];h[e+16>>3]=+h[d+33096>>3];h[f+16>>3]=+h[d+33104>>3];h[a+24>>3]=+h[d+28640>>3];h[e+24>>3]=+h[d+28616>>3];h[f+24>>3]=+h[d+28624>>3];i=i;return}function Yx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0.0;f=i;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+2376>>3]=+h[d>>3];h[j+6352>>3]=+h[d+8>>3];h[j+2360>>3]=+h[d+16>>3];h[j+2040>>3]=+h[d+24>>3];if((rFa(+h[j+2312>>3],0.0)|0)<<24>>24==0){j=c[c[g>>2]>>2]|0;d=c[j+8>>2]|0;if((a[(c[b+408>>2]|0)+16|0]|0)==0){k=+h[d+2360>>3]- +h[(c[b+416>>2]|0)+776>>3]}else{k=+h[d+2376>>3]}l=d;m=j;n=-k}else{j=(pFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0)<<24>>24==0;d=b+416|0;do{if(j){o=0.0}else{k=+h[c[d>>2]>>3];p=c[c[g>>2]>>2]|0;q=c[p+8>>2]|0;r=+h[q+2376>>3];do{if(k!=0.0){s=q;t=p;u=r/k}else{if(r==0.0){s=q;t=p;u=r;break}v=r/+SBa(c[b+536>>2]|0,k,20136,20128,+h[p>>3],(a[b+319|0]|0)!=0|0);w=c[c[g>>2]>>2]|0;s=c[w+8>>2]|0;t=w;u=v}}while(0);k=+h[s+6432>>3]*2.0;r=u*u;if(k!=0.0){o=r/k;break}if(r==0.0){o=r;break}o=r/+SBa(c[b+536>>2]|0,k,20160,20128,+h[t>>3],(a[b+319|0]|0)!=0|0)}}while(0);t=c[c[g>>2]>>2]|0;s=c[t+8>>2]|0;l=s;m=t;n=+h[s+2360>>3]-(+h[s+2312>>3]*+h[s+6432>>3]*9.80665+(+h[(c[d>>2]|0)+776>>3]-o))}h[e>>3]=n;d=l+2376|0;s=c[m+16>>2]|0;if((a[s+84|0]|0)==0){x=+h[(c[b+416>>2]|0)+840>>3]*+h[l+6352>>3]*.01}else{x=+h[l+6352>>3]*.01}h[e+8>>3]=-+h[d>>3]-x;m=l+2040|0;h[e+16>>3]=+h[l+6352>>3]+(+h[m>>3]- +h[l+2360>>3]);if((a[s+4|0]|0)==0){if((a[(c[b+408>>2]|0)+5|0]|0)==0){y=+h[m>>3]- +h[(c[b+416>>2]|0)+2936>>3]}else{y=-+h[d>>3]}z=-y;A=e;B=A+24|0;C=B;h[C>>3]=z;i=f;return}do{if((pFa(-+h[d>>3],0.0)|0)<<24>>24==0){D=0.0}else{m=c[c[g>>2]>>2]|0;s=c[m+8>>2]|0;y=+h[s+3072>>3];x=+h[s+2376>>3];n=-x;do{if(y!=0.0){E=s;F=m;G=n/y}else{if(x==-0.0){E=s;F=m;G=n;break}o=n/+SBa(c[b+536>>2]|0,y,20184,20128,+h[m>>3],(a[b+319|0]|0)!=0|0);l=c[c[g>>2]>>2]|0;E=c[l+8>>2]|0;F=l;G=o}}while(0);y=+h[E+3984>>3]*2.0;n=G*G;if(y!=0.0){D=n/y;break}if(n==0.0){D=n;break}D=n/+SBa(c[b+536>>2]|0,y,20208,20128,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);F=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=c[b+416>>2]|0;z=+h[F+2040>>3]-(+h[g+2936>>3]+(+h[F+2024>>3]*+h[g+2528>>3]*+h[F+3984>>3]-D));A=e;B=A+24|0;C=B;h[C>>3]=z;i=f;return}function Zx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=-(+h[(c[a+416>>2]|0)+2936>>3]*+h[b+6536>>3]);i=i;return}function _x(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+4008>>3]+ +h[b+4e3>>3];i=i;return}function $x(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2936>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+144>>3];n=+h[j+416>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6760>>3]=+h[f>>3];i=b;return}function ay(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3984>>3];k=+h[g+416>>3];l=+h[(c[b+416>>2]|0)+2936>>3];m=j*j;j=+h[g+6760>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20240,20232,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}function by(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5904>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5880>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5888>>3];h[a+8>>3]=+h[d+91584>>3];h[e+8>>3]=+h[d+91560>>3];h[f+8>>3]=+h[d+91568>>3];i=i;return}function cy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+416>>3]=+h[b>>3];h[a+6536>>3]=+h[b+8>>3];Zx(f);_x(f);$x(f);ay(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+4016|0;h[d>>3]=+h[f+6704>>3]+(-(+h[f+4024>>3]*+h[f+6616>>3])- +h[g>>3]*+h[f+3976>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+3992>>3]*+h[f+6760>>3])- +h[f+6536>>3]*+h[f+3984>>3]);i=e;return}function dy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6304>>3]=+h[b+2320>>3]- +h[(c[a+416>>2]|0)+3048>>3];i=i;return}function ey(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+68|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+896>>3]*+h[f+6304>>3]*.01;k=-j;l=g;m=l+2336|0;n=m;h[n>>3]=k;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+6304>>3]*.01;k=-j;l=g;m=l+2336|0;n=m;h[n>>3]=k;i=d;return}}function fy(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+32560>>3];h[c[b+8>>2]>>3]=+h[d+32536>>3];h[c[b+12>>2]>>3]=+h[d+32544>>3];i=i;return}function gy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[d>>3];dy(g);ey(g);if((rFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2296>>3],0.0)|0)<<24>>24==0){g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;if((a[(c[b+408>>2]|0)+14|0]|0)==0){k=+h[g+2320>>3]- +h[(c[b+416>>2]|0)+776>>3]}else{k=+h[g+2336>>3]}l=-k;h[e>>3]=l;i=f;return}g=(pFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0)<<24>>24==0;d=b+416|0;do{if(g){m=0.0}else{k=+h[(c[d>>2]|0)+16>>3];n=c[c[j>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+2336>>3];do{if(k!=0.0){q=o;r=n;s=p/k}else{if(p==0.0){q=o;r=n;s=p;break}t=p/+SBa(c[b+536>>2]|0,k,20272,20264,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[c[j>>2]>>2]|0;q=c[u+8>>2]|0;r=u;s=t}}while(0);k=+h[q+6432>>3]*2.0;p=s*s;if(k!=0.0){m=p/k;break}if(p==0.0){m=p;break}m=p/+SBa(c[b+536>>2]|0,k,20160,20264,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[b+2320>>3]-(+h[b+2296>>3]*+h[b+6432>>3]*9.80665+(+h[(c[d>>2]|0)+776>>3]-m));h[e>>3]=l;i=f;return}function hy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+3048>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+128>>3];n=+h[j+400>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6768>>3]=+h[f>>3];i=b;return}function iy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3896>>3];k=+h[g+400>>3];l=+h[(c[b+416>>2]|0)+3048>>3];m=j*j;j=+h[g+6768>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20304,20296,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}function jy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=-(+h[(c[a+416>>2]|0)+3048>>3]*+h[b+6544>>3]);i=i;return}function ky(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6712>>3]=+h[b+3936>>3]+(+h[b+3928>>3]+ +h[b+3920>>3]);i=i;return}function ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5680>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5656>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5664>>3];h[a+8>>3]=+h[d+91696>>3];h[e+8>>3]=+h[d+91672>>3];h[f+8>>3]=+h[d+91680>>3];i=i;return}function my(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+400>>3]=+h[b>>3];h[a+6544>>3]=+h[b+8>>3];hy(f);iy(f);jy(f);ky(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3944|0;h[d>>3]=+h[f+6712>>3]+(-(+h[f+3952>>3]*+h[f+6624>>3])- +h[g>>3]*+h[f+3888>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+3912>>3]*+h[f+6768>>3])- +h[f+6544>>3]*+h[f+3896>>3]);i=e;return}function ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+4752>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+112>>3];n=+h[j+384>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6776>>3]=+h[f>>3];i=b;return}function oy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=-(+h[(c[a+416>>2]|0)+4752>>3]*+h[b+6552>>3]);i=i;return}function py(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+3656>>3]+(+h[b+3648>>3]+ +h[b+3640>>3]);i=i;return}function qy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3616>>3];k=+h[g+384>>3];l=+h[(c[b+416>>2]|0)+4752>>3];m=j*j;j=+h[g+6776>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20336,20328,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}function ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5456>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5432>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5440>>3];h[a+8>>3]=+h[d+91808>>3];h[e+8>>3]=+h[d+91784>>3];h[f+8>>3]=+h[d+91792>>3];i=i;return}function sy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+384>>3]=+h[b>>3];h[a+6552>>3]=+h[b+8>>3];ny(f);oy(f);py(f);qy(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3664|0;h[d>>3]=+h[f+6720>>3]+(-(+h[f+3672>>3]*+h[f+6632>>3])- +h[g>>3]*+h[f+3608>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+3632>>3]*+h[f+6776>>3])- +h[f+6552>>3]*+h[f+3616>>3]);i=e;return}function ty(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3],+h[(c[a+8>>2]|0)+256>>3],c[(c[a+12>>2]|0)+108>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+256>>3];n=+h[j+528>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[f>>3];i=b;return}function uy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0;b=i;d=a+4|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;f=(pFa(+h[e+6424>>3],+h[e+7480>>3])|0)<<24>>24==0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=+h[g+2344>>3];k=+h[g+2384>>3];l=+h[g+6480>>3];d=e<<24>>24==0;if(f){if(d){m=g+6472|0;n=c[a+416>>2]|0}else{f=c[a+416>>2]|0;m=f+4704|0;n=f}o=+h[n+776>>3]*+h[g+6560>>3]-l*+h[m>>3];p=k-o;q=j+p;r=g;s=r+6648|0;t=s;h[t>>3]=q;i=b;return}else{if(d){u=g+6472|0;v=c[a+416>>2]|0}else{d=c[a+416>>2]|0;u=d+4704|0;v=d}o=+h[v+776>>3]*+h[g+6560>>3]- +h[g+2280>>3]-l*+h[u>>3];p=k-o;q=j+p;r=g;s=r+6648|0;t=s;h[t>>3]=q;i=b;return}}function vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+91920>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+91896>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+91904>>3];h[a+8>>3]=+h[d+7472>>3];h[e+8>>3]=+h[d+7448>>3];h[f+8>>3]=+h[d+7456>>3];i=i;return}function wy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=a;g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+6560>>3]=+h[b>>3];h[j+528>>3]=+h[b+8>>3];ty(f);uy(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+6560|0;b=f+6656|0;h[d>>3]=+h[f+6648>>3]+(+h[(c[a+416>>2]|0)+776>>3]*+h[g>>3]+(-(+h[f+6440>>3]*+h[f+528>>3])- +h[b>>3]*+h[f+256>>3]));h[d+8>>3]=+h[b>>3]+(-(+h[f+6504>>3]*+h[f+6728>>3])- +h[g>>3]*+h[f+6432>>3]);i=e;return}function xy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6304>>3]=+h[b+2320>>3]- +h[(c[a+416>>2]|0)+3048>>3];i=i;return}function yy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+68|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+896>>3]*+h[f+6304>>3]*.01;k=-j;l=g;m=l+2336|0;n=m;h[n>>3]=k;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+6304>>3]*.01;k=-j;l=g;m=l+2336|0;n=m;h[n>>3]=k;i=d;return}}function zy(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+32560>>3];h[c[b+8>>2]>>3]=+h[d+32536>>3];h[c[b+12>>2]>>3]=+h[d+32544>>3];i=i;return}function Ay(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[d>>3];xy(g);yy(g);if((rFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2296>>3],0.0)|0)<<24>>24==0){g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;if((a[(c[b+408>>2]|0)+14|0]|0)==0){k=+h[g+2320>>3]- +h[(c[b+416>>2]|0)+776>>3]}else{k=+h[g+2336>>3]}l=-k;h[e>>3]=l;i=f;return}g=(pFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0)<<24>>24==0;d=b+416|0;do{if(g){m=0.0}else{k=+h[(c[d>>2]|0)+16>>3];n=c[c[j>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+2336>>3];do{if(k!=0.0){q=o;r=n;s=p/k}else{if(p==0.0){q=o;r=n;s=p;break}t=p/+SBa(c[b+536>>2]|0,k,20272,20360,+h[n>>3],(a[b+319|0]|0)!=0|0);u=c[c[j>>2]>>2]|0;q=c[u+8>>2]|0;r=u;s=t}}while(0);k=+h[q+6432>>3]*2.0;p=s*s;if(k!=0.0){m=p/k;break}if(p==0.0){m=p;break}m=p/+SBa(c[b+536>>2]|0,k,20160,20360,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[b+2320>>3]-(+h[b+2296>>3]*+h[b+6432>>3]*9.80665+(+h[(c[d>>2]|0)+776>>3]-m));h[e>>3]=l;i=f;return}function By(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4648>>3]=+h[b+4600>>3]*+(c[(c[a+420>>2]|0)+196>>2]|0);i=i;return}function Cy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0;d=i;i=i+80|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=d+64|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=b+416|0;w=+h[(c[v>>2]|0)+2160>>3];x=b+4|0;y=c[c[x>>2]>>2]|0;z=+h[(c[y+8>>2]|0)+4616>>3];do{if(w!=0.0){A=z/w}else{if(z==0.0){A=z;break}A=z/+SBa(c[b+536>>2]|0,w,19512,20368,+h[y>>3],(a[b+319|0]|0)!=0|0)}}while(0);y=o;h[k>>3]=1.0e-4;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=o+8|0;h[k>>3]=15.0e-5;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];WCa(p,3,0.0,o);o=n;h[k>>3]=5.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=0.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];WCa(q,3,10.0,n);n=b+536|0;o=c[n>>2]|0;y=c[c[x>>2]>>2]|0;B=c[y+8>>2]|0;w=+h[B+4600>>3];z=+h[B+4616>>3];C=+h[(c[v>>2]|0)+2160>>3];do{if(z!=0.0){D=C/z}else{if(C==0.0){D=C;break}D=C/+SBa(o,z,19496,20368,+h[y>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=w*D;b=j;y=p;c[b+0>>2]=c[y+0>>2];c[b+4>>2]=c[y+4>>2];c[b+8>>2]=c[y+8>>2];y=g;b=q;c[y+0>>2]=c[b+0>>2];c[y+4>>2]=c[b+4>>2];c[y+8>>2]=c[b+8>>2];Lt(t,o,z,j,g);z=+h[t>>3];t=m;h[k>>3]=1.0e-4;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=m+8|0;h[k>>3]=15.0e-5;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];WCa(r,3,0.0,m);m=l;h[k>>3]=5.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=0.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];WCa(s,3,10.0,l);l=c[n>>2]|0;n=f;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=e;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];Lt(u,l,0.0,f,e);h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+4512>>3]=A*A*z;i=d;return}function Dy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+232>>3]- +h[b+4624>>3];i=i;return}function Ey(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5528>>3]=+h[b+104>>3]- +h[b+4696>>3];i=i;return}function Fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+64816>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+64792>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+64800>>3];h[a+8>>3]=+h[d+77360>>3];h[e+8>>3]=+h[d+77336>>3];h[f+8>>3]=+h[d+77344>>3];h[a+16>>3]=+h[d+64480>>3];h[e+16>>3]=+h[d+64456>>3];h[f+16>>3]=+h[d+64464>>3];i=i;return}function Gy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+4624>>3]=+h[d>>3];h[k+5520>>3]=+h[d+8>>3];h[k+4600>>3]=+h[d+16>>3];By(g);Cy(g);Dy(g);Ey(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;l=+h[d+4560>>3];m=+h[d+5520>>3];do{if(l!=0.0){n=d;o=g;p=m/l}else{if(m==0.0){n=d;o=g;p=m;break}q=m/+SBa(c[b+536>>2]|0,l,19584,20376,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[c[j>>2]>>2]|0;n=c[k+8>>2]|0;o=k;p=q}}while(0);h[e>>3]=+h[n+4648>>3]-p;p=+h[n+5520>>3];if((a[(c[o+16>>2]|0)+60|0]|0)==0){r=+h[(c[b+416>>2]|0)+1536>>3]*+h[n+5528>>3]*.01;s=p-r;t=e;u=t+8|0;v=u;h[v>>3]=s;w=n;x=w+4512|0;y=x;z=+h[y>>3];A=n;B=A+4560|0;C=B;D=+h[C>>3];E=z*D;F=E*9.80665;G=n;H=G+4624|0;I=H;J=+h[I>>3];K=F-J;L=e;M=L+16|0;N=M;h[N>>3]=K;i=f;return}else{r=+h[n+5528>>3]*.01;s=p-r;t=e;u=t+8|0;v=u;h[v>>3]=s;w=n;x=w+4512|0;y=x;z=+h[y>>3];A=n;B=A+4560|0;C=B;D=+h[C>>3];E=z*D;F=E*9.80665;G=n;H=G+4624|0;I=H;J=+h[I>>3];K=F-J;L=e;M=L+16|0;N=M;h[N>>3]=K;i=f;return}}function Hy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7024>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7e3>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7008>>3];h[a+8>>3]=+h[d+7136>>3];h[e+8>>3]=+h[d+7112>>3];h[f+8>>3]=+h[d+7120>>3];i=i;return}function Iy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+496>>3]=+h[b>>3];h[m+504>>3]=+h[b+8>>3];b=a+536|0;fv(g,c[b>>2]|0,+h[m+232>>3],+h[m+224>>3],c[(c[l+12>>2]|0)+96>>2]|0,0);l=c[b>>2]|0;b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[b+232>>3];o=+h[b+224>>3];p=+h[b+504>>3];q=+h[b+496>>3];b=f+0|0;m=g+0|0;g=b+120|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(g|0));rv(j,l,n,o,f,p,q);f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=f+6800|0;h[d>>3]=+h[k>>3]- +h[j>>3];q=+h[f+4560>>3];p=q*q;h[d+8>>3]=+h[f+6576>>3]*p+(q*+h[f+504>>3]+(-(p*+h[f+496>>3])- +h[f+232>>3]*+h[k>>3]));i=e;return}function Jy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4408>>3]*+(c[(c[a+420>>2]|0)+220>>2]|0);i=i;return}function Ky(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0;d=i;i=i+80|0;e=d;f=d+16|0;g=d+32|0;j=d+48|0;l=d+64|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=b+416|0;w=+h[(c[v>>2]|0)+2280>>3];x=b+4|0;y=c[c[x>>2]>>2]|0;z=+h[(c[y+8>>2]|0)+4424>>3];do{if(w!=0.0){A=z/w}else{if(z==0.0){A=z;break}A=z/+SBa(c[b+536>>2]|0,w,19208,20384,+h[y>>3],(a[b+319|0]|0)!=0|0)}}while(0);y=o;h[k>>3]=1.0e-4;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=o+8|0;h[k>>3]=15.0e-5;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];WCa(p,3,0.0,o);o=n;h[k>>3]=5.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=0.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];WCa(q,3,10.0,n);n=b+536|0;o=c[n>>2]|0;y=c[c[x>>2]>>2]|0;B=c[y+8>>2]|0;w=+h[B+4408>>3];z=+h[B+4424>>3];C=+h[(c[v>>2]|0)+2280>>3];do{if(z!=0.0){D=C/z}else{if(C==0.0){D=C;break}D=C/+SBa(o,z,19192,20384,+h[y>>3],(a[b+319|0]|0)!=0|0)}}while(0);z=w*D;b=j;y=p;c[b+0>>2]=c[y+0>>2];c[b+4>>2]=c[y+4>>2];c[b+8>>2]=c[y+8>>2];y=g;b=q;c[y+0>>2]=c[b+0>>2];c[y+4>>2]=c[b+4>>2];c[y+8>>2]=c[b+8>>2];Lt(t,o,z,j,g);z=+h[t>>3];t=m;h[k>>3]=1.0e-4;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=m+8|0;h[k>>3]=15.0e-5;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];WCa(r,3,0.0,m);m=l;h[k>>3]=5.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=0.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];WCa(s,3,10.0,l);l=c[n>>2]|0;n=f;m=r;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];m=e;n=s;c[m+0>>2]=c[n+0>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];Lt(u,l,0.0,f,e);h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+4320>>3]=A*A*z;i=d;return}function Ly(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4504>>3]=+h[b+216>>3]- +h[b+4432>>3];i=i;return}function My(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5264>>3]=+h[b+248>>3]- +h[b+4504>>3];i=i;return}function Ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+62128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+62104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+62112>>3];h[a+8>>3]=+h[d+73664>>3];h[e+8>>3]=+h[d+73640>>3];h[f+8>>3]=+h[d+73648>>3];h[a+16>>3]=+h[d+61792>>3];h[e+16>>3]=+h[d+61768>>3];h[f+16>>3]=+h[d+61776>>3];i=i;return}function Oy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+4432>>3]=+h[d>>3];h[k+5256>>3]=+h[d+8>>3];h[k+4408>>3]=+h[d+16>>3];Jy(g);Ky(g);Ly(g);My(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;l=+h[d+4368>>3];m=+h[d+5256>>3];do{if(l!=0.0){n=d;o=g;p=m/l}else{if(m==0.0){n=d;o=g;p=m;break}q=m/+SBa(c[b+536>>2]|0,l,19280,20392,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[c[j>>2]>>2]|0;n=c[k+8>>2]|0;o=k;p=q}}while(0);h[e>>3]=+h[n+4456>>3]-p;p=+h[n+5256>>3];if((a[(c[o+16>>2]|0)+48|0]|0)==0){r=+h[(c[b+416>>2]|0)+1760>>3]*+h[n+5264>>3]*.01;s=p-r;t=e;u=t+8|0;v=u;h[v>>3]=s;w=n;x=w+4320|0;y=x;z=+h[y>>3];A=n;B=A+4368|0;C=B;D=+h[C>>3];E=z*D;F=E*9.80665;G=n;H=G+4432|0;I=H;J=+h[I>>3];K=F-J;L=e;M=L+16|0;N=M;h[N>>3]=K;i=f;return}else{r=+h[n+5264>>3]*.01;s=p-r;t=e;u=t+8|0;v=u;h[v>>3]=s;w=n;x=w+4320|0;y=x;z=+h[y>>3];A=n;B=A+4368|0;C=B;D=+h[C>>3];E=z*D;F=E*9.80665;G=n;H=G+4432|0;I=H;J=+h[I>>3];K=F-J;L=e;M=L+16|0;N=M;h[N>>3]=K;i=f;return}}function Py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6800>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6776>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6784>>3];h[a+8>>3]=+h[d+6912>>3];h[e+8>>3]=+h[d+6888>>3];h[f+8>>3]=+h[d+6896>>3];i=i;return}function Qy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+480>>3]=+h[b>>3];h[m+488>>3]=+h[b+8>>3];b=a+536|0;fv(g,c[b>>2]|0,+h[m+216>>3],+h[m+208>>3],c[(c[l+12>>2]|0)+92>>2]|0,0);l=c[b>>2]|0;b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[b+216>>3];o=+h[b+208>>3];p=+h[b+488>>3];q=+h[b+480>>3];b=f+0|0;m=g+0|0;g=b+120|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(g|0));rv(j,l,n,o,f,p,q);f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=f+6808|0;h[d>>3]=+h[k>>3]- +h[j>>3];q=+h[f+4368>>3];p=q*q;h[d+8>>3]=+h[f+6584>>3]*p+(q*+h[f+488>>3]+(-(p*+h[f+480>>3])- +h[f+216>>3]*+h[k>>3]));i=e;return}function Ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5120>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5096>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5104>>3];h[a+8>>3]=+h[d+5008>>3];h[e+8>>3]=+h[d+4984>>3];h[f+8>>3]=+h[d+4992>>3];i=i;return}function Sy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+360>>3]=k;o=+h[b+8>>3];h[n+352>>3]=o;p=+h[n+1800>>3];q=p*p;b=n+88|0;h[d>>3]=+h[n+2392>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2488>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+80>>3],c[(c[m+12>>2]|0)+20>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+88>>3];q=+h[r+80>>3];k=+h[r+360>>3];p=+h[r+352>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2488>>3]- +h[j>>3];i=e;return}function Ty(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4784>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4760>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4768>>3];h[a+8>>3]=+h[d+4896>>3];h[e+8>>3]=+h[d+4872>>3];h[f+8>>3]=+h[d+4880>>3];i=i;return}function Uy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+336>>3]=+h[b>>3];h[m+344>>3]=+h[b+8>>3];b=a+536|0;fv(g,c[b>>2]|0,+h[m+72>>3],+h[m+64>>3],c[(c[l+12>>2]|0)+16>>2]|0,0);l=c[b>>2]|0;b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[b+72>>3];o=+h[b+64>>3];p=+h[b+344>>3];q=+h[b+336>>3];b=f+0|0;m=g+0|0;g=b+120|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(g|0));rv(j,l,n,o,f,p,q);f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=f+2496|0;h[d>>3]=+h[k>>3]- +h[j>>3];q=+h[f+1808>>3];p=q*q;h[d+8>>3]=+h[f+2400>>3]*p+(q*+h[f+344>>3]+(-(p*+h[f+336>>3])- +h[f+72>>3]*+h[k>>3]));i=e;return}function Vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4672>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4648>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4656>>3];h[a+8>>3]=+h[d+4560>>3];h[e+8>>3]=+h[d+4536>>3];h[f+8>>3]=+h[d+4544>>3];i=i;return}function Wy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+328>>3]=k;o=+h[b+8>>3];h[n+320>>3]=o;p=+h[n+1048>>3];q=p*p;b=n+56|0;h[d>>3]=+h[n+2408>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2504>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+48>>3],c[(c[m+12>>2]|0)+12>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+56>>3];q=+h[r+48>>3];k=+h[r+328>>3];p=+h[r+320>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2504>>3]- +h[j>>3];i=e;return}function Xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4336>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4312>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4320>>3];h[a+8>>3]=+h[d+4448>>3];h[e+8>>3]=+h[d+4424>>3];h[f+8>>3]=+h[d+4432>>3];i=i;return}function Yy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+304>>3]=+h[b>>3];h[m+312>>3]=+h[b+8>>3];b=a+536|0;fv(g,c[b>>2]|0,+h[m+40>>3],+h[m+32>>3],c[(c[l+12>>2]|0)+8>>2]|0,0);l=c[b>>2]|0;b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[b+40>>3];o=+h[b+32>>3];p=+h[b+312>>3];q=+h[b+304>>3];b=f+0|0;m=g+0|0;g=b+120|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(g|0));rv(j,l,n,o,f,p,q);f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=f+2512|0;h[d>>3]=+h[k>>3]- +h[j>>3];q=+h[f+1056>>3];p=q*q;h[d+8>>3]=+h[f+2416>>3]*p+(q*+h[f+312>>3]+(-(p*+h[f+304>>3])- +h[f+40>>3]*+h[k>>3]));i=e;return}function Zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4224>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4200>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4208>>3];h[a+8>>3]=+h[d+4112>>3];h[e+8>>3]=+h[d+4088>>3];h[f+8>>3]=+h[d+4096>>3];i=i;return}function _y(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+296>>3]=k;o=+h[b+8>>3];h[n+288>>3]=o;p=+h[n+752>>3];q=p*p;b=n+24|0;h[d>>3]=+h[n+2424>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+2520>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+16>>3],c[(c[m+12>>2]|0)+4>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+24>>3];q=+h[r+16>>3];k=+h[r+296>>3];p=+h[r+288>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2520>>3]- +h[j>>3];i=e;return}function $y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+3888>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3864>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3872>>3];h[a+8>>3]=+h[d+4e3>>3];h[e+8>>3]=+h[d+3976>>3];h[f+8>>3]=+h[d+3984>>3];i=i;return}function az(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+272>>3]=+h[b>>3];h[m+280>>3]=+h[b+8>>3];b=a+536|0;fv(g,c[b>>2]|0,+h[m+8>>3],+h[m>>3],c[c[l+12>>2]>>2]|0,0);l=c[b>>2]|0;b=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[b+8>>3];o=+h[b>>3];p=+h[b+280>>3];q=+h[b+272>>3];b=f+0|0;m=g+0|0;g=b+120|0;do{c[b>>2]=c[m>>2];b=b+4|0;m=m+4|0}while((b|0)<(g|0));rv(j,l,n,o,f,p,q);f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;k=f+2528|0;h[d>>3]=+h[k>>3]- +h[j>>3];q=+h[f+760>>3];p=q*q;h[d+8>>3]=+h[f+2432>>3]*p+(q*+h[f+280>>3]+(-(p*+h[f+272>>3])- +h[f+8>>3]*+h[k>>3]));i=e;return}function bz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5120>>3]=+h[b+5096>>3]- +h[b+248>>3];i=i;return}function cz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+48|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1872>>3]*+h[f+5120>>3]*.01;k=g;l=k+5112|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+5120>>3]*.01;k=g;l=k+5112|0;m=l;h[m>>3]=j;i=d;return}}function dz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5032>>3]=+h[b+5096>>3]- +h[b+104>>3];i=i;return}function ez(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5024>>3]=+h[(c[a+416>>2]|0)+1928>>3]*+h[b+5032>>3]*.01;i=i;return}function fz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5112>>3],1.0e-15);k=+xd(+-+h[g+5024>>3],1.0e-15);l=j+k;m=j*+h[g+240>>3]+k*+h[g+96>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,19e3,20400,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+1352|0;r=q;h[r>>3]=o;i=d;return}function gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+1352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+1352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1344>>3]=+h[f>>3];i=b;return}function hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+1352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+1352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1408>>3]=+h[f>>3];i=b;return}function iz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1408>>3],+h[f+1344>>3],+h[f+5096>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1384>>3]=+h[d>>3];i=b;return}function jz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+5112>>3]+ +h[b+5024>>3];i=i;return}function kz(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1304>>3]=+h[b+3936>>3]*(+h[d+5096>>3]- +h[d+584>>3])*+h[b+3968>>3];i=i;return}function lz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3936>>3]*+h[e+3968>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1304>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,18936,20408,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1296|0;q=p;h[q>>3]=n;i=d;return}function mz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+584>>3],+h[a+112>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1400>>3]=+h[f>>3];i=b;return}function nz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+584>>3],+h[a+112>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+584>>3];l=+h[g+112>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1360>>3]=+h[f>>3];i=b;return}function oz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1400>>3],+h[f+1360>>3],+h[f+584>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1376>>3]=+h[d>>3];i=b;return}function pz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+71424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+71400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+71408>>3];h[a+8>>3]=+h[d+8256>>3];h[e+8>>3]=+h[d+8232>>3];h[f+8>>3]=+h[d+8240>>3];i=i;return}function qz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+5096>>3]=+h[d>>3];h[l+584>>3]=+h[d+8>>3];bz(j);cz(j);dz(j);ez(j);fz(j);gz(j);hz(j);iz(j);jz(j);kz(j);lz(j);mz(j);nz(j);oz(j);j=c[c[k>>2]>>2]|0;if((a[c[j+16>>2]|0]|0)==0){d=c[j+8>>2]|0;if((a[(c[b+408>>2]|0)+1|0]|0)==0){l=c[b+416>>2]|0;m=l;n=+h[d+584>>3]- +h[l+4752>>3]}else{m=c[b+416>>2]|0;n=-+h[d+1320>>3]}o=m;p=d;q=j;r=-n}else{do{if((pFa(-+h[(c[j+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[k>>2]>>2]|0;m=c[d+8>>2]|0;n=+h[m+3040>>3];t=+h[m+1320>>3];u=-t;do{if(n!=0.0){v=m;w=d;x=u/n}else{if(t==-0.0){v=m;w=d;x=u;break}y=u/+SBa(c[b+536>>2]|0,n,19136,20416,+h[d>>3],(a[b+319|0]|0)!=0|0);l=c[c[k>>2]>>2]|0;v=c[l+8>>2]|0;w=l;x=y}}while(0);n=+h[v+3616>>3]*2.0;u=x*x;if(n!=0.0){s=u/n;break}if(u==0.0){s=u;break}s=u/+SBa(c[b+536>>2]|0,n,19160,20416,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=c[c[k>>2]>>2]|0;v=c[w+8>>2]|0;j=c[b+416>>2]|0;o=j;p=v;q=w;r=+h[v+584>>3]-(+h[j+4752>>3]+(+h[v+568>>3]*+h[j+2528>>3]*+h[v+3616>>3]-s))}h[e>>3]=r;v=c[b+536>>2]|0;r=+h[p+1296>>3];s=+h[p+1400>>3];x=+h[p+1408>>3];n=+h[p+1376>>3];u=+h[p+1384>>3];j=b+416|0;t=+h[o+3888>>3];y=+h[p+2944>>3];z=+h[o+3912>>3]*+h[o+4032>>3];A=+h[o+3904>>3];B=(A+A)*.5;p=(c[(c[b+420>>2]|0)+504>>2]|0)+ -1|0;A=+(p|0);C=+h[o+4024>>3];do{if((p|0)==0){if(C==0.0){D=C;break}D=C/+SBa(v,A,19064,20416,+h[q>>3],(a[b+319|0]|0)!=0|0)}else{D=C/A}}while(0);_t(g,v,r,s,x,n,u,t,y,z,B,D,+h[(c[j>>2]|0)+3992>>3]);h[e+8>>3]=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1320>>3]- +h[g>>3]*+h[(c[j>>2]|0)+3968>>3];i=f;return}function rz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+7248>>3];h[e+8>>3]=+h[d+7224>>3];h[f+8>>3]=+h[d+7232>>3];i=i;return}function sz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+520>>3]=k;o=+h[b+8>>3];h[n+512>>3]=o;p=+h[n+4824>>3];q=p*p;b=n+248|0;h[d>>3]=+h[n+6568>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+6784>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+240>>3],c[(c[m+12>>2]|0)+100>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+248>>3];q=+h[r+240>>3];k=+h[r+520>>3];p=+h[r+512>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6784>>3]- +h[j>>3];i=e;return}function tz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1288>>3]=+h[f>>3];i=b;return}function uz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1232>>3]=+h[f>>3];i=b;return}function vz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1288>>3],+h[f+1232>>3],+h[f+4776>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1264>>3]=+h[d>>3];i=b;return}function wz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[b+4776>>3]- +h[b+104>>3];i=i;return}function xz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+60|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+2128>>3]*+h[f+4720>>3]*.01;k=g;l=k+4712|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+4720>>3]*.01;k=g;l=k+4712|0;m=l;h[m>>3]=j;i=d;return}}function yz(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1200>>3]=+h[b+4120>>3]*(+h[d+4776>>3]- +h[d+1984>>3])*+h[b+4152>>3];i=i;return}function zz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+4120>>3]*+h[e+4152>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1200>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19304,20424,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1192|0;q=p;h[q>>3]=n;i=d;return}function Az(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+1984>>3],+h[a+128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+1984>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1280>>3]=+h[f>>3];i=b;return}function Bz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+1984>>3],+h[a+128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+1984>>3];l=+h[g+128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1240>>3]=+h[f>>3];i=b;return}function Cz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1280>>3],+h[f+1240>>3],+h[f+1984>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1256>>3]=+h[d>>3];i=b;return}function Dz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+66944>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+66920>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+66928>>3];h[a+8>>3]=+h[d+27856>>3];h[e+8>>3]=+h[d+27832>>3];h[f+8>>3]=+h[d+27840>>3];i=i;return}function Ez(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+4776>>3]=+h[d>>3];h[l+1984>>3]=+h[d+8>>3];tz(j);uz(j);vz(j);wz(j);xz(j);yz(j);zz(j);Az(j);Bz(j);Cz(j);j=c[c[k>>2]>>2]|0;if((a[(c[j+16>>2]|0)+2|0]|0)==0){d=c[j+8>>2]|0;if((a[(c[b+408>>2]|0)+3|0]|0)==0){l=c[b+416>>2]|0;m=l;n=+h[d+1984>>3]- +h[l+3048>>3]}else{m=c[b+416>>2]|0;n=-+h[d+4712>>3]}o=m;p=d;q=j;r=-n}else{do{if((pFa(-+h[(c[j+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[k>>2]>>2]|0;m=c[d+8>>2]|0;n=+h[m+3056>>3];t=+h[m+4712>>3];u=-t;do{if(n!=0.0){v=m;w=d;x=u/n}else{if(t==-0.0){v=m;w=d;x=u;break}y=u/+SBa(c[b+536>>2]|0,n,19440,20432,+h[d>>3],(a[b+319|0]|0)!=0|0);l=c[c[k>>2]>>2]|0;v=c[l+8>>2]|0;w=l;x=y}}while(0);n=+h[v+3896>>3]*2.0;u=x*x;if(n!=0.0){s=u/n;break}if(u==0.0){s=u;break}s=u/+SBa(c[b+536>>2]|0,n,19464,20432,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=c[c[k>>2]>>2]|0;v=c[w+8>>2]|0;j=c[b+416>>2]|0;o=j;p=v;q=w;r=+h[v+1984>>3]-(+h[j+3048>>3]+(+h[v+1968>>3]*+h[j+2528>>3]*+h[v+3896>>3]-s))}h[e>>3]=r;v=c[b+536>>2]|0;r=+h[p+1192>>3];s=+h[p+1280>>3];x=+h[p+1288>>3];n=+h[p+1256>>3];u=+h[p+1264>>3];j=b+416|0;t=+h[o+4072>>3];y=+h[p+2936>>3];z=+h[o+4096>>3]*+h[o+4216>>3];A=+h[o+4088>>3];B=(A+A)*.5;p=(c[(c[b+420>>2]|0)+516>>2]|0)+ -1|0;A=+(p|0);C=+h[o+4208>>3];do{if((p|0)==0){if(C==0.0){D=C;break}D=C/+SBa(v,A,19368,20432,+h[q>>3],(a[b+319|0]|0)!=0|0)}else{D=C/A}}while(0);_t(g,v,r,s,x,n,u,t,y,z,B,D,+h[(c[j>>2]|0)+4176>>3]);h[e+8>>3]=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4712>>3]- +h[g>>3]*+h[(c[j>>2]|0)+4152>>3];i=f;return}function Fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+28640>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+28616>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+28624>>3];h[a+8>>3]=+h[d+89008>>3];h[e+8>>3]=+h[d+88984>>3];h[f+8>>3]=+h[d+88992>>3];h[a+16>>3]=+h[d+33344>>3];h[e+16>>3]=+h[d+33320>>3];h[f+16>>3]=+h[d+33328>>3];h[a+24>>3]=+h[d+33120>>3];h[e+24>>3]=+h[d+33096>>3];h[f+24>>3]=+h[d+33104>>3];i=i;return}function Gz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0.0;f=i;g=+h[d>>3];j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;h[l+2040>>3]=g;h[l+6352>>3]=+h[d+8>>3];m=+h[d+16>>3];h[l+2376>>3]=m;h[l+2360>>3]=+h[d+24>>3];d=c[k+16>>2]|0;if((a[d+4|0]|0)==0){if((a[(c[b+408>>2]|0)+5|0]|0)==0){n=g- +h[(c[b+416>>2]|0)+2936>>3]}else{n=-m}o=d;p=l;q=-n}else{do{if((pFa(-m,0.0)|0)<<24>>24==0){r=0.0}else{l=c[c[j>>2]>>2]|0;d=c[l+8>>2]|0;n=+h[d+3072>>3];g=+h[d+2376>>3];s=-g;do{if(n!=0.0){t=d;u=l;v=s/n}else{if(g==-0.0){t=d;u=l;v=s;break}w=s/+SBa(c[b+536>>2]|0,n,20184,20440,+h[l>>3],(a[b+319|0]|0)!=0|0);k=c[c[j>>2]>>2]|0;t=c[k+8>>2]|0;u=k;v=w}}while(0);n=+h[t+3984>>3]*2.0;s=v*v;if(n!=0.0){r=s/n;break}if(s==0.0){r=s;break}r=s/+SBa(c[b+536>>2]|0,n,20208,20440,+h[u>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=c[c[j>>2]>>2]|0;t=c[u+8>>2]|0;l=c[b+416>>2]|0;o=c[u+16>>2]|0;p=t;q=+h[t+2040>>3]-(+h[l+2936>>3]+(+h[t+2024>>3]*+h[l+2528>>3]*+h[t+3984>>3]-r))}h[e>>3]=q;t=p+6352|0;h[e+8>>3]=+h[t>>3]+(+h[p+2040>>3]- +h[p+2360>>3]);if((a[o+84|0]|0)==0){x=+h[(c[b+416>>2]|0)+840>>3]*+h[t>>3]*.01}else{x=+h[t>>3]*.01}h[e+16>>3]=-+h[p+2376>>3]-x;if((rFa(+h[p+2312>>3],0.0)|0)<<24>>24==0){p=c[(c[c[j>>2]>>2]|0)+8>>2]|0;if((a[(c[b+408>>2]|0)+16|0]|0)==0){y=+h[p+2360>>3]- +h[(c[b+416>>2]|0)+776>>3]}else{y=+h[p+2376>>3]}z=-y;A=e;B=A+24|0;C=B;h[C>>3]=z;i=f;return}p=(pFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0)<<24>>24==0;t=b+416|0;do{if(p){D=0.0}else{y=+h[c[t>>2]>>3];o=c[c[j>>2]>>2]|0;l=c[o+8>>2]|0;x=+h[l+2376>>3];do{if(y!=0.0){E=l;F=o;G=x/y}else{if(x==0.0){E=l;F=o;G=x;break}q=x/+SBa(c[b+536>>2]|0,y,20136,20440,+h[o>>3],(a[b+319|0]|0)!=0|0);u=c[c[j>>2]>>2]|0;E=c[u+8>>2]|0;F=u;G=q}}while(0);y=+h[E+6432>>3]*2.0;x=G*G;if(y!=0.0){D=x/y;break}if(x==0.0){D=x;break}D=x/+SBa(c[b+536>>2]|0,y,20160,20440,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=c[(c[c[j>>2]>>2]|0)+8>>2]|0;z=+h[b+2360>>3]-(+h[b+2312>>3]*+h[b+6432>>3]*9.80665+(+h[(c[t>>2]|0)+776>>3]-D));A=e;B=A+24|0;C=B;h[C>>3]=z;i=f;return}function Hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2120>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2120>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1504>>3]=+h[f>>3];i=b;return}function Iz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4952>>3]=+h[b+5008>>3]- +h[b+104>>3];i=i;return}function Jz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4944>>3]=+h[(c[a+416>>2]|0)+1984>>3]*+h[b+4952>>3]*.01;i=i;return}function Kz(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+3752>>3]*(+h[d+5008>>3]- +h[d+2120>>3])*+h[b+3784>>3];i=i;return}function Lz(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3752>>3]*+h[e+3784>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1424>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,18744,20448,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1416|0;q=p;h[q>>3]=n;i=d;return}function Mz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1456>>3]=+h[f>>3];i=b;return}function Nz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1512>>3]=+h[f>>3];i=b;return}function Oz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1512>>3],+h[f+1456>>3],+h[f+5008>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1488>>3]=+h[d>>3];i=b;return}function Pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2120>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2120>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1464>>3]=+h[f>>3];i=b;return}function Qz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+1504>>3],+h[f+1464>>3],+h[f+2120>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1480>>3]=+h[d>>3];i=b;return}function Rz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+70192>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+70168>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+70176>>3];h[a+8>>3]=+h[d+29760>>3];h[e+8>>3]=+h[d+29736>>3];h[f+8>>3]=+h[d+29744>>3];i=i;return}function Sz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+5008>>3]=+h[d>>3];h[l+2120>>3]=+h[d+8>>3];Hz(j);Iz(j);Jz(j);Kz(j);Lz(j);Mz(j);Nz(j);Oz(j);Pz(j);Qz(j);j=c[c[k>>2]>>2]|0;if((a[(c[j+16>>2]|0)+7|0]|0)==0){d=c[j+8>>2]|0;if((a[(c[b+408>>2]|0)+9|0]|0)==0){l=c[b+416>>2]|0;m=l;n=+h[d+2120>>3]- +h[l+2824>>3]}else{m=c[b+416>>2]|0;n=-+h[d+4944>>3]}o=m;p=d;q=j;r=-n}else{do{if((pFa(-+h[(c[j+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[k>>2]>>2]|0;m=c[d+8>>2]|0;n=+h[m+3104>>3];t=+h[m+4944>>3];u=-t;do{if(n!=0.0){v=m;w=d;x=u/n}else{if(t==-0.0){v=m;w=d;x=u;break}y=u/+SBa(c[b+536>>2]|0,n,18808,20456,+h[d>>3],(a[b+319|0]|0)!=0|0);l=c[c[k>>2]>>2]|0;v=c[l+8>>2]|0;w=l;x=y}}while(0);n=+h[v+4056>>3]*2.0;u=x*x;if(n!=0.0){s=u/n;break}if(u==0.0){s=u;break}s=u/+SBa(c[b+536>>2]|0,n,18832,20456,+h[w>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=c[c[k>>2]>>2]|0;v=c[w+8>>2]|0;j=c[b+416>>2]|0;o=j;p=v;q=w;r=+h[v+2120>>3]-(+h[j+2824>>3]+(+h[v+2096>>3]*+h[j+2528>>3]*+h[v+4056>>3]-s))}h[e>>3]=r;v=c[b+536>>2]|0;r=+h[p+1416>>3];s=+h[p+1504>>3];x=+h[p+1512>>3];n=+h[p+1480>>3];u=+h[p+1488>>3];j=b+416|0;t=+h[o+3704>>3];y=+h[p+2952>>3];z=+h[o+3728>>3]*+h[o+3848>>3];A=+h[o+3720>>3];B=(A+A)*.5;p=(c[(c[b+420>>2]|0)+492>>2]|0)+ -1|0;A=+(p|0);C=+h[o+3840>>3];do{if((p|0)==0){if(C==0.0){D=C;break}D=C/+SBa(v,A,18856,20456,+h[q>>3],(a[b+319|0]|0)!=0|0)}else{D=C/A}}while(0);_t(g,v,r,s,x,n,u,t,y,z,B,D,+h[(c[j>>2]|0)+3808>>3]);h[e+8>>3]=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4944>>3]- +h[g>>3]*+h[(c[j>>2]|0)+3784>>3];i=f;return}function Tz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5344>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5320>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5328>>3];h[a+8>>3]=+h[d+5232>>3];h[e+8>>3]=+h[d+5208>>3];h[f+8>>3]=+h[d+5216>>3];i=i;return}function Uz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=+h[b>>3];l=a+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;h[n+376>>3]=k;o=+h[b+8>>3];h[n+368>>3]=o;p=+h[n+3544>>3];q=p*p;b=n+104|0;h[d>>3]=+h[n+6640>>3]*q+(p*k+(-(q*o)- +h[b>>3]*+h[n+6792>>3]));r=a+536|0;fv(g,c[r>>2]|0,+h[b>>3],+h[n+96>>3],c[(c[m+12>>2]|0)+64>>2]|0,0);m=c[r>>2]|0;r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[r+104>>3];q=+h[r+96>>3];k=+h[r+376>>3];p=+h[r+368>>3];r=f+0|0;n=g+0|0;g=r+120|0;do{c[r>>2]=c[n>>2];r=r+4|0;n=n+4|0}while((r|0)<(g|0));rv(j,m,o,q,f,k,p);h[d+8>>3]=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6792>>3]- +h[j>>3];i=e;return}function Vz(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6032>>3]=+h[b+2128>>3]- +h[(c[a+416>>2]|0)+2936>>3];i=i;return}function Wz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+92|0]|0)==0){f=c[e+8>>2]|0;g=f;j=+h[(c[b+416>>2]|0)+1144>>3]*+h[f+6032>>3]*.01;k=g;l=k+6024|0;m=l;h[m>>3]=j;i=d;return}else{f=c[e+8>>2]|0;g=f;j=+h[f+6032>>3]*.01;k=g;l=k+6024|0;m=l;h[m>>3]=j;i=d;return}}function Xz(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+29872>>3];h[c[b+8>>2]>>3]=+h[d+29848>>3];h[c[b+12>>2]>>3]=+h[d+29856>>3];i=i;return}function Yz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0;f=i;g=b;j=b+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[d>>3];Vz(g);Wz(g);g=c[c[j>>2]>>2]|0;if((a[(c[g+16>>2]|0)+6|0]|0)==0){d=c[g+8>>2]|0;if((a[(c[b+408>>2]|0)+8|0]|0)==0){k=+h[d+2128>>3]- +h[(c[b+416>>2]|0)+2824>>3]}else{k=-+h[d+6024>>3]}l=-k;h[e>>3]=l;i=f;return}do{if((pFa(-+h[(c[g+8>>2]|0)+6024>>3],0.0)|0)<<24>>24==0){m=0.0}else{d=c[c[j>>2]>>2]|0;n=c[d+8>>2]|0;k=+h[n+3096>>3];o=+h[n+6024>>3];p=-o;do{if(k!=0.0){q=n;r=d;s=p/k}else{if(o==-0.0){q=n;r=d;s=p;break}t=p/+SBa(c[b+536>>2]|0,k,19608,20464,+h[d>>3],(a[b+319|0]|0)!=0|0);u=c[c[j>>2]>>2]|0;q=c[u+8>>2]|0;r=u;s=t}}while(0);k=+h[q+4056>>3]*2.0;p=s*s;if(k!=0.0){m=p/k;break}if(p==0.0){m=p;break}m=p/+SBa(c[b+536>>2]|0,k,18832,20464,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;l=+h[r+2128>>3]-(+h[j+2824>>3]+(+h[r+2088>>3]*+h[j+2528>>3]*+h[r+4056>>3]-m));h[e>>3]=l;i=f;return}



function Fm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+12|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+12|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+12|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+12|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+12|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+13|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+13|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+13|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+13|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+13|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+14|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+14|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+14|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+14|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+14|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+16|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+16|0;H=G;c[H>>2]=y;i=d;return}function Gm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+72>>3],+h[k+64>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+72>>3];m=+h[g+64>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1656>>3]=+h[f>>3];i=b;return}function Hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1680>>3]=+h[b+1656>>3]+-273.15;i=i;return}function Im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+72>>3],+h[k+64>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+72>>3];m=+h[g+64>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1808>>3]=+h[f>>3];i=b;return}function Jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+3176>>3]*+h[b+1808>>3];i=i;return}function Km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+1808>>3];l=+h[g+72>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,4160,4152,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1704>>3]=j-n;i=d;return}function Lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+1920>>3]*+h[b+1704>>3];i=i;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1808>>3],+h[g+1656>>3],+h[g+72>>3],c[(c[f+12>>2]|0)+16>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1784>>3]=+h[d>>3];i=b;return}function Nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;Ot(d,c[a+536>>2]|0,+h[f+1744>>3],+h[f+1800>>3],+h[f+1808>>3],+h[f+1776>>3],+h[f+1784>>3],+h[f+3184>>3],+h[f+3024>>3],0.0,(+h[j+384>>3]+ +h[j+392>>3])*.5,+h[j+3264>>3],+h[j+3232>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1848>>3]=+h[d>>3]*+h[(c[g>>2]|0)+3208>>3];i=b;return}function Om(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1792>>3]=+h[(a?e+1808|0:e+1800|0)>>3];i=b;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b+1848>>3]*+h[b+3184>>3];i=i;return}function Qm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];h[b+1824>>3]=d*+h[(!(d>=0.0)?b+64|0:b+80|0)>>3];i=i;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=+h[b+1816>>3]- +h[b+1824>>3];i=i;return}function Sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+1824>>3]- +h[b+1832>>3];i=i;return}function Tm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+352>>3]*+h[j+1800>>3]*+h[e+3104>>3];l=+h[j+1840>>3]+ +h[j+1848>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4200,4192,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1664|0;r=q;h[r>>3]=o;i=d;return}function Um(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1864>>3]=+h[b+1664>>3]*+h[d+352>>3]*+h[d+3104>>3]*(+h[b+72>>3]*.5+(+h[b+88>>3]*-.5+ +h[b+1744>>3]*.5));i=i;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2440>>3]=+h[b+1880>>3]+ +h[b+1864>>3];i=i;return}function Wm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+1840>>3]- +h[b+1848>>3];i=i;return}function Xm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3168>>3];k=+h[g+1896>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4288,4280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2488|0;p=o;h[p>>3]=m;i=d;return}function Ym(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1912>>3];k=+h[g+2440>>3]- +h[g+1896>>3]*+h[g+1736>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4328,4320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2392|0;p=o;h[p>>3]=m;i=d;return}function Zm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3164>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+360>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+360|0;h[c[g+3168>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+360>>3]);e=c[f>>2]|0;h[c[e+3172>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3164>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+352|0;h[(c[e+3168>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+352>>3]);h[(c[(c[f>>2]|0)+3172>>2]|0)+8>>3]=k;TFa(a,39)|0;a=c[(c[f>>2]|0)+3164>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+360>>3]=+h[a>>3];h[f+352>>3]=+h[a+8>>3];i=b;return}function _m(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+360>>3]*+h[j+1808>>3]*+h[e+3104>>3];l=+h[j+1848>>3]+ +h[j+1856>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4352,4344,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1672|0;r=q;h[r>>3]=o;i=d;return}function $m(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1872>>3]=+h[b+1672>>3]*+h[d+360>>3]*+h[d+3104>>3]*(+h[b+72>>3]*.5+(+h[b+88>>3]*-.5+ +h[b+1744>>3]*.5));i=i;return}function an(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2448>>3]=+h[b+1888>>3]+ +h[b+1872>>3];i=i;return}function bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1904>>3]=+h[b+1848>>3]- +h[b+1856>>3];i=i;return}function cn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3176>>3];k=+h[g+1904>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4440,4432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2496|0;p=o;h[p>>3]=m;i=d;return}function dn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1920>>3];k=+h[g+2448>>3]- +h[g+1904>>3]*+h[g+1704>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4480,4472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2400|0;p=o;h[p>>3]=m;i=d;return}function en(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1768>>3]=+h[(a?e+1784|0:e+1776|0)>>3];i=b;return}function fn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3244>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+336>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+336|0;h[c[g+3248>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+336>>3]);e=c[f>>2]|0;h[c[e+3252>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3244>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+344>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+344|0;h[(c[e+3248>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+344>>3]);h[(c[(c[f>>2]|0)+3252>>2]|0)+8>>3]=k;TFa(a,40)|0;a=c[(c[f>>2]|0)+3244>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+336>>3]=+h[a>>3];h[f+344>>3]=+h[a+8>>3];i=b;return}function gn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1696>>3]=+h[d>>3];i=b;return}function hn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3824>>3]=+h[b+192>>3]- +h[d+2528>>3]*+h[d+3360>>3];i=i;return}function jn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3816>>3]=+h[b+176>>3]- +h[d+2528>>3]*+h[d+3544>>3];i=i;return}function kn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3800>>3]=+h[b+160>>3]- +h[d+2528>>3]*+h[d+3728>>3];i=i;return}function ln(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3808>>3]=+h[b+96>>3]+ +h[d+2528>>3]*+h[d+3728>>3];i=i;return}function mn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3784>>3]=+h[b+112>>3]- +h[d+2528>>3]*+h[d+3912>>3];i=i;return}function nn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3768>>3]=+h[b+128>>3]- +h[d+2528>>3]*+h[d+4096>>3];i=i;return}function on(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3776>>3]=+h[b+96>>3]+ +h[d+2528>>3]*+h[d+4096>>3];i=i;return}function pn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1e3>>3]=(+h[b+472>>3]+ +h[b+480>>3])*(+h[d+40>>3]- +h[d+56>>3])*+h[b+4352>>3]*.5;i=i;return}function qn(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4352>>3]*(+h[e+472>>3]+ +h[e+480>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1e3>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,4504,4496,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}function rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+9|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+9|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+9|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+9|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+9|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+10|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+10|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+10|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+10|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+10|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+11|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+11|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+11|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+11|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+11|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+12|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+12|0;H=G;c[H>>2]=y;i=d;return}function sn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+56>>3],+h[k+48>>3],c[(c[a+12>>2]|0)+12>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+56>>3];m=+h[g+48>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+896>>3]=+h[f>>3];i=b;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+896>>3]+-273.15;i=i;return}function un(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+56>>3],+h[k+48>>3],c[(c[a+12>>2]|0)+12>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+56>>3];m=+h[g+48>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1048>>3]=+h[f>>3];i=b;return}function vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1160>>3]=+h[b+3328>>3]*+h[b+1048>>3];i=i;return}function wn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3];k=+h[g+1048>>3];l=+h[g+56>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4608,4600,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=+h[b+1160>>3]*+h[b+984>>3];i=i;return}function yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1048>>3],+h[g+896>>3],+h[g+56>>3],c[(c[f+12>>2]|0)+12>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1024>>3]=+h[d>>3];i=b;return}function zn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+56>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+976>>3]=+h[d>>3];i=b;return}function An(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+6|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+6|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+6|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+6|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+6|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+7|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+7|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+7|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+8|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+8|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+8|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+8|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+8|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+8|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+8|0;H=G;c[H>>2]=y;i=d;return}function Bn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+40>>3],+h[k+32>>3],c[(c[a+12>>2]|0)+8>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+40>>3];m=+h[g+32>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+904>>3]=+h[f>>3];i=b;return}function Cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+904>>3]+-273.15;i=i;return}function Dn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+40>>3],+h[k+32>>3],c[(c[a+12>>2]|0)+8>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+40>>3];m=+h[g+32>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[f>>3];i=b;return}function En(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1168>>3]=+h[b+3336>>3]*+h[b+1056>>3];i=i;return}function Fn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=+h[g+1056>>3];l=+h[g+40>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4648,4640,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=+h[b+1168>>3]*+h[b+952>>3];i=i;return}function Hn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1056>>3],+h[g+904>>3],+h[g+40>>3],c[(c[f+12>>2]|0)+8>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[d>>3];i=b;return}function In(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;Ot(d,c[a+536>>2]|0,+h[f+992>>3],+h[f+1048>>3],+h[f+1056>>3],+h[f+1024>>3],+h[f+1032>>3],+h[f+3344>>3],+h[f+2928>>3],+h[j+4416>>3]*3.0,(+h[j+504>>3]+ +h[j+512>>3])*.5,+h[j+4408>>3],+h[j+4376>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1096>>3]=+h[d>>3]*+h[(c[g>>2]|0)+4352>>3];i=b;return}function Jn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1040>>3]=+h[(a?e+1056|0:e+1048|0)>>3];i=b;return}function Kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+1096>>3]*+h[b+3344>>3];i=i;return}function Ln(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1096>>3];h[b+1072>>3]=d*+h[(!(d>=0.0)?b+32|0:b+48|0)>>3];i=i;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+1072>>3]- +h[b+1080>>3];i=i;return}function Nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+1064>>3]- +h[b+1072>>3];i=i;return}function On(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+480>>3]*+h[j+1056>>3]*+h[e+4248>>3];l=+h[j+1096>>3]+ +h[j+1104>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4688,4680,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+920|0;r=q;h[r>>3]=o;i=d;return}function Pn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1120>>3]=+h[b+920>>3]*+h[d+480>>3]*+h[d+4248>>3]*(+h[b+40>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+992>>3]*.5+ +h[d+2528>>3]*+h[b+1056>>3]*-1.5)));i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=+h[b+1136>>3]+ +h[b+1120>>3];i=i;return}function Rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1152>>3]=+h[b+1096>>3]- +h[b+1104>>3];i=i;return}function Sn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3336>>3];k=+h[g+1152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4784,4776,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2512|0;p=o;h[p>>3]=m;i=d;return}function Tn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1168>>3];k=+h[g+2464>>3]- +h[g+1152>>3]*+h[g+952>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4824,4816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2416|0;p=o;h[p>>3]=m;i=d;return}function Un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+472>>3]*+h[j+1048>>3]*+h[e+4248>>3];l=+h[j+1088>>3]+ +h[j+1096>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,4856,4848,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+912|0;r=q;h[r>>3]=o;i=d;return}function Vn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1112>>3]=+h[b+912>>3]*+h[d+472>>3]*+h[d+4248>>3]*(+h[b+40>>3]*.5+(+h[b+56>>3]*-.5+(+h[b+992>>3]*.5+ +h[d+2528>>3]*+h[b+1048>>3]*-1.5)));i=i;return}function Wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2456>>3]=+h[b+1128>>3]+ +h[b+1112>>3];i=i;return}function Xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=+h[b+1088>>3]- +h[b+1096>>3];i=i;return}function Yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3328>>3];k=+h[g+1144>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4952,4944,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2504|0;p=o;h[p>>3]=m;i=d;return}function Zn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1160>>3];k=+h[g+2456>>3]- +h[g+1144>>3]*+h[g+984>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,4992,4984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2408|0;p=o;h[p>>3]=m;i=d;return}function _n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3324>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+328>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+328|0;h[c[g+3328>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+328>>3]);e=c[f>>2]|0;h[c[e+3332>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3324>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+320>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+320|0;h[(c[e+3328>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+320>>3]);h[(c[(c[f>>2]|0)+3332>>2]|0)+8>>3]=k;TFa(a,41)|0;a=c[(c[f>>2]|0)+3324>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+328>>3]=+h[a>>3];h[f+320>>3]=+h[a+8>>3];i=b;return}function $n(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1016>>3]=+h[(a?e+1032|0:e+1024|0)>>3];i=b;return}function ao(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3404>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+304>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+304|0;h[c[g+3408>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+304>>3]);e=c[f>>2]|0;h[c[e+3412>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3404>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+312>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+312|0;h[(c[e+3408>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+312>>3]);h[(c[(c[f>>2]|0)+3412>>2]|0)+8>>3]=k;TFa(a,42)|0;a=c[(c[f>>2]|0)+3404>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+304>>3]=+h[a>>3];h[f+312>>3]=+h[a+8>>3];i=b;return}function bo(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3]=+h[d>>3];i=b;return}function co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3752>>3]=+h[f>>3];i=b;return}function eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+224>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+224>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3760>>3]=+h[f>>3];i=b;return}function fo(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+704>>3]=(+h[b+592>>3]+ +h[b+600>>3])*(+h[d+8>>3]- +h[d+24>>3])*+h[b+4576>>3]*.5;i=i;return}function go(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4576>>3]*(+h[e+592>>3]+ +h[e+600>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+704>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,5024,5016,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}function ho(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+3|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+4|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+4|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+4|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+4|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+4|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+5|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+5|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+5|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+5|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+5|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+4|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+4|0;H=G;c[H>>2]=y;i=d;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+24>>3],+h[k+16>>3],c[(c[a+12>>2]|0)+4>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+24>>3];m=+h[g+16>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[f>>3];i=b;return}function jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+600>>3]+-273.15;i=i;return}function ko(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+24>>3],+h[k+16>>3],c[(c[a+12>>2]|0)+4>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+24>>3];m=+h[g+16>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[f>>3];i=b;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+3368>>3]*+h[b+752>>3];i=i;return}function mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+752>>3];l=+h[g+24>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,5128,5120,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+688>>3]=j-n;i=d;return}function no(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+880>>3]=+h[b+864>>3]*+h[b+688>>3];i=i;return}function oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+752>>3],+h[g+600>>3],+h[g+24>>3],c[(c[f+12>>2]|0)+4>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[d>>3];i=b;return}function po(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+680>>3]=+h[d>>3];i=b;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[c[b+356>>2]|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[c[b+356>>2]|0]|0;g=lFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=g;v=t;break}else{t=lFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=t;v=t;break}}else{if(f){f=a[c[b+356>>2]|0]|0;t=pFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[c[b+352>>2]|0]=t;v=f;break}else{f=pFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[c[b+352>>2]|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+1|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+1|0]|0;m=nFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=m;w=e;break}else{e=nFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+1|0]|0;e=rFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+1|0]=e;w=n;break}else{n=rFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+1|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+2|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+2|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+2|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+2|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+2|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;c[E>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;c[E>>2]=y;i=d;return}function ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+8>>3],+h[k>>3],c[c[a+12>>2]>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+8>>3];m=+h[g>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+608>>3]=+h[f>>3];i=b;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+608>>3]+-273.15;i=i;return}function to(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+8>>3],+h[k>>3],c[c[a+12>>2]>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+8>>3];m=+h[g>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[f>>3];i=b;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+3376>>3]*+h[b+760>>3];i=i;return}function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[g+760>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,5168,5160,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+656>>3]=j-n;i=d;return}function wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=+h[b+872>>3]*+h[b+656>>3];i=i;return}function xo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+760>>3],+h[g+608>>3],+h[g+8>>3],c[c[f+12>>2]>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+736>>3]=+h[d>>3];i=b;return}function yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;Ot(d,c[a+536>>2]|0,+h[f+696>>3],+h[f+752>>3],+h[f+760>>3],+h[f+728>>3],+h[f+736>>3],+h[f+3384>>3],+h[f+2920>>3],+h[j+4640>>3]*3.0,(+h[j+624>>3]+ +h[j+632>>3])*.5,+h[j+4632>>3],+h[j+4600>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+800>>3]=+h[d>>3]*+h[(c[g>>2]|0)+4576>>3];i=b;return}function zo(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+800>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=+h[(a?e+760|0:e+752|0)>>3];i=b;return}function Ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+800>>3]*+h[b+3384>>3];i=i;return}function Bo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+800>>3];h[b+776>>3]=d*+h[(!(d>=0.0)?b:b+16|0)>>3];i=i;return}function Co(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+776>>3]- +h[b+784>>3];i=i;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+768>>3]- +h[b+776>>3];i=i;return}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+600>>3]*+h[j+760>>3]*+h[e+4472>>3];l=+h[j+800>>3]+ +h[j+808>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,5208,5200,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+624|0;r=q;h[r>>3]=o;i=d;return}function Fo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+824>>3]=+h[b+624>>3]*+h[d+600>>3]*+h[d+4472>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+(+h[b+696>>3]*.5+ +h[d+2528>>3]*+h[b+760>>3]*-1.5)));i=i;return}function Go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=+h[b+840>>3]+ +h[b+824>>3];i=i;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+800>>3]- +h[b+808>>3];i=i;return}function Io(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3376>>3];k=+h[g+856>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,5304,5296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2528|0;p=o;h[p>>3]=m;i=d;return}function Jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+872>>3];k=+h[g+2480>>3]- +h[g+856>>3]*+h[g+656>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,5344,5336,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2432|0;p=o;h[p>>3]=m;i=d;return}function Ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+592>>3]*+h[j+752>>3]*+h[e+4472>>3];l=+h[j+792>>3]+ +h[j+800>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,5376,5368,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+616|0;r=q;h[r>>3]=o;i=d;return}function Lo(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+816>>3]=+h[b+616>>3]*+h[d+592>>3]*+h[d+4472>>3]*(+h[b+8>>3]*.5+(+h[b+24>>3]*-.5+(+h[b+696>>3]*.5+ +h[d+2528>>3]*+h[b+752>>3]*-1.5)));i=i;return}function Mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=+h[b+832>>3]+ +h[b+816>>3];i=i;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+792>>3]- +h[b+800>>3];i=i;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+h[g+848>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,5472,5464,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2520|0;p=o;h[p>>3]=m;i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+864>>3];k=+h[g+2472>>3]- +h[g+848>>3]*+h[g+688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,5512,5504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2424|0;p=o;h[p>>3]=m;i=d;return}function Qo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3484>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+296>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+296|0;h[c[g+3488>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+296>>3]);e=c[f>>2]|0;h[c[e+3492>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3484>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+288>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+288|0;h[(c[e+3488>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+288>>3]);h[(c[(c[f>>2]|0)+3492>>2]|0)+8>>3]=k;TFa(a,43)|0;a=c[(c[f>>2]|0)+3484>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+296>>3]=+h[a>>3];h[f+288>>3]=+h[a+8>>3];i=b;return}function Ro(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+800>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+720>>3]=+h[(a?e+736|0:e+728|0)>>3];i=b;return}function So(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3564>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+272>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+272|0;h[c[g+3568>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+272>>3]);e=c[f>>2]|0;h[c[e+3572>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3564>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+280>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+280|0;h[(c[e+3568>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+280>>3]);h[(c[(c[f>>2]|0)+3572>>2]|0)+8>>3]=k;TFa(a,44)|0;a=c[(c[f>>2]|0)+3564>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+272>>3]=+h[a>>3];h[f+280>>3]=+h[a+8>>3];i=b;return}function To(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[d>>3];i=b;return}function Uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3712>>3]=+h[f>>3];i=b;return}function Vo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+208>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+208>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3720>>3]=+h[f>>3];i=b;return}function Wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[(c[a+416>>2]|0)+680>>3];i=i;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+21|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+120>>3],+h[k+560>>3]+ +h[k+3032>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+120>>3],+h[j+560>>3]+ +h[j+3032>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+120>>3],+h[l+560>>3]+ +h[l+3032>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+120>>3],+h[g+560>>3]+ +h[g+3032>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+22|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+22|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+120>>3],+h[l+560>>3]- +h[l+3032>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+120>>3],+h[g+560>>3]- +h[g+3032>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+22|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+120>>3],+h[k+560>>3]- +h[k+3032>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+120>>3],+h[j+560>>3]- +h[j+3032>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}if((a[c[b+408>>2]|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}function Yo(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=0.0;g=b;j=g+568|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+120>>3]- +h[b+560>>3];g=b;j=g+568|0;k=j;h[k>>3]=f;i=d;return}function Zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3644>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5096>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5096|0;h[c[g+3648>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5096>>3]);e=c[f>>2]|0;h[c[e+3652>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3644>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+584>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+584|0;h[(c[e+3648>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+584>>3]);h[(c[(c[f>>2]|0)+3652>>2]|0)+8>>3]=k;TFa(a,45)|0;j=c[(c[f>>2]|0)+3644>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5096>>3]=+h[j>>3];h[f+584>>3]=+h[j+8>>3];bz(a);cz(a);dz(a);ez(a);fz(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);nz(a);oz(a);i=b;return}function _o(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3792>>3]=+h[b+1352>>3]+ +h[d+2528>>3]*+h[d+3912>>3];i=i;return}function $o(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4840>>3]=+h[b+4872>>3]+(+h[b+5112>>3]- +h[b+5256>>3]);i=i;return}function ap(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2088>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4840>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,5544,5536,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6784|0;p=o;h[p>>3]=m;i=d;return}function bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5024>>3],1.0e-15);k=+xd(+(+h[g+1320>>3]),1.0e-15);l=j+k;m=j*+h[g+96>>3]+k*+h[g+3784>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,5568,5560,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5176|0;r=q;h[r>>3]=o;i=d;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5160>>3]=+h[f>>3];i=b;return}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5096>>3],+h[l+240>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5096>>3];o=+h[m+240>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5112>>3],+h[d+5160>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5136>>3]=+h[g>>3];i=b;return}function ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5168>>3]=+h[f>>3];i=b;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5112>>3],+h[j+5168>>3],+h[j+5152>>3],+h[(c[b+416>>2]|0)+1848>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5112>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,5648,5640,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5104|0;q=p;h[q>>3]=n;i=d;return}function gp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4872>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5256>>3],0.0)|0;f=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5112>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=g+240|0;h[g+4832>>3]=+h[g+4872>>3]*+h[(a<<24>>24==0?d:g+96|0)>>3]+(+h[g+5112>>3]*+h[(f<<24>>24==0?d:g+5176|0)>>3]- +h[g+5256>>3]*+h[(e<<24>>24==0?d:g+208|0)>>3]);i=b;return}function hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4848>>3];k=+h[g+4832>>3]- +h[g+4840>>3]*+h[g+4808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,5752,5744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6568|0;p=o;h[p>>3]=m;i=d;return}function ip(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3724>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+3728>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+3732>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3724>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+512>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+512|0;h[(c[e+3728>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+512>>3]);h[(c[(c[f>>2]|0)+3732>>2]|0)+8>>3]=k;TFa(a,46)|0;a=c[(c[f>>2]|0)+3724>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[a>>3];h[f+512>>3]=+h[a+8>>3];i=b;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+248>>3],+h[l+5176>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+248>>3];o=+h[m+5176>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5112>>3],+h[d+5144>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5128>>3]=+h[g>>3];i=b;return}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+xd(+-+h[g+5112>>3],1.0e-15);k=+xd(+(+h[g+1320>>3]),1.0e-15);l=j+k;m=j*+h[g+240>>3]+k*+h[g+3784>>3];if(l!=0.0){n=g;o=m/l;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}k=m/+SBa(c[b+536>>2]|0,l,5776,5768,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+5088|0;r=q;h[r>>3]=o;i=d;return}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5088>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5088>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5072>>3]=+h[f>>3];i=b;return}function mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5096>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5096>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5024>>3],+h[d+5072>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1904>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5048>>3]=+h[g>>3];i=b;return}function np(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5096>>3],+h[a+5088>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5096>>3];l=+h[g+5088>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5080>>3]=+h[f>>3];i=b;return}function op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5024>>3],+h[j+5080>>3],+h[j+5064>>3],+h[(c[b+416>>2]|0)+1904>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5024>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,5856,5848,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5016|0;q=p;h[q>>3]=n;i=d;return}function pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+5088>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+5088>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5024>>3],+h[d+5056>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1904>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5040>>3]=+h[g>>3];i=b;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+584>>3],+h[(c[b+416>>2]|0)+4752>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+59|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+59|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[b+360>>2]|0)+59|0]|0)|0;a[(c[b+352>>2]|0)+59|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[b+360>>2]|0)+59|0]|0)|0;a[(c[b+352>>2]|0)+59|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+59|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+59|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+59|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+1|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+1|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+1|0;v=u;a[v]=m;i=d;return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3936>>3]*+h[j+1400>>3]*+h[e+3880>>3];l=+h[j+1320>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,5960,5952,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1328|0;q=p;h[q>>3]=n;i=d;return}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3936>>3]*+h[j+1408>>3]*+h[e+3880>>3];l=+h[j+1320>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,6048,6040,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1336|0;q=p;h[q>>3]=n;i=d;return}function tp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1368>>3]=+h[(a?e+1384|0:e+1376|0)>>3];i=b;return}function up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1320>>3]*+h[(c[a+416>>2]|0)+3888>>3];i=i;return}function vp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1392>>3]=+h[(a?e+1408|0:e+1400|0)>>3];i=b;return}function wp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1320>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+576>>3]=-(+h[e+1320>>3]*+h[(a<<24>>24==0?e+112|0:e+3792|0)>>3]);i=b;return}function xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+592>>3]+ +h[b+576>>3];i=i;return}function yp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=-+h[b+6480>>3]- +h[b+1320>>3];i=i;return}function zp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=+h[(c[a+416>>2]|0)+280>>3];i=i;return}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+25|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+25|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+136>>3],+h[k+1960>>3]+ +h[k+3048>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+136>>3],+h[j+1960>>3]+ +h[j+3048>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+25|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+136>>3],+h[l+1960>>3]+ +h[l+3048>>3])|0;a[(c[b+352>>2]|0)+25|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+136>>3],+h[g+1960>>3]+ +h[g+3048>>3])|0;a[(c[b+352>>2]|0)+25|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+26|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+26|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+136>>3],+h[l+1960>>3]- +h[l+3048>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+136>>3],+h[g+1960>>3]- +h[g+3048>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+26|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+136>>3],+h[k+1960>>3]- +h[k+3048>>3])|0;a[(c[b+352>>2]|0)+26|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+136>>3],+h[j+1960>>3]- +h[j+3048>>3])|0;a[(c[b+352>>2]|0)+26|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+2|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}function Bp(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){f=0.0;g=b;j=g+1968|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+136>>3]- +h[b+1960>>3];g=b;j=g+1968|0;k=j;h[k>>3]=f;i=d;return}function Cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3804>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+4776>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+4776|0;h[c[g+3808>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+4776>>3]);e=c[f>>2]|0;h[c[e+3812>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3804>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1984>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1984|0;h[(c[e+3808>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1984>>3]);h[(c[(c[f>>2]|0)+3812>>2]|0)+8>>3]=k;TFa(a,47)|0;j=c[(c[f>>2]|0)+3804>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+4776>>3]=+h[j>>3];h[f+1984>>3]=+h[j+8>>3];tz(a);uz(a);vz(a);wz(a);xz(a);yz(a);zz(a);Az(a);Bz(a);Cz(a);i=b;return}function Dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+3768>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+3768>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4760>>3]=+h[f>>3];i=b;return}function Ep(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+4776>>3],+h[a+3768>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+4776>>3];l=+h[g+3768>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4768>>3]=+h[f>>3];i=b;return}function Fp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1976>>3]=-(+h[e+4712>>3]*+h[(a<<24>>24==0?e+128|0:e+3776|0)>>3]);i=b;return}function Gp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+1992>>3]+ +h[b+1976>>3];i=i;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1984>>3],+h[(c[b+416>>2]|0)+3048>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+62|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+62|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[b+360>>2]|0)+62|0]|0)|0;a[(c[b+352>>2]|0)+62|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[b+360>>2]|0)+62|0]|0)|0;a[(c[b+352>>2]|0)+62|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+62|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+62|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+62|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+3|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+3|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+3|0;v=u;a[v]=m;i=d;return}function Ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+4120>>3]*+h[j+1280>>3]*+h[e+4064>>3];l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,6136,6128,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1216|0;q=p;h[q>>3]=n;i=d;return}function Jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+4120>>3]*+h[j+1288>>3]*+h[e+4064>>3];l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,6224,6216,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1224|0;q=p;h[q>>3]=n;i=d;return}function Kp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1272>>3]=+h[(a?e+1288|0:e+1280|0)>>3];i=b;return}function Lp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4712>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1248>>3]=+h[(a?e+1264|0:e+1256|0)>>3];i=b;return}function Mp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=+h[b+4712>>3]*+h[(c[a+416>>2]|0)+4072>>3];i=i;return}function Np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4712>>3],+h[j+4768>>3],+h[j+4752>>3],+h[(c[b+416>>2]|0)+2104>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4712>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,6312,6304,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4704|0;q=p;h[q>>3]=n;i=d;return}function Op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+3768>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+3768>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4712>>3],+h[d+4744>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2104>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4728>>3]=+h[g>>3];i=b;return}function Pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+4776>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+4776>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4712>>3],+h[d+4760>>3],+h[f>>3],+h[(c[a+416>>2]|0)+2104>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4736>>3]=+h[g>>3];i=b;return}function Qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=-+h[b+2336>>3]- +h[b+4712>>3];i=i;return}function Rp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=+h[(c[a+416>>2]|0)+240>>3];i=i;return}function Sp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+29|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+29|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+152>>3],+h[k+2016>>3]+ +h[k+3064>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+152>>3],+h[j+2016>>3]+ +h[j+3064>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+29|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+152>>3],+h[l+2016>>3]+ +h[l+3064>>3])|0;a[(c[b+352>>2]|0)+29|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+152>>3],+h[g+2016>>3]+ +h[g+3064>>3])|0;a[(c[b+352>>2]|0)+29|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+30|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+30|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+152>>3],+h[l+2016>>3]- +h[l+3064>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+152>>3],+h[g+2016>>3]- +h[g+3064>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+30|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+152>>3],+h[k+2016>>3]- +h[k+3064>>3])|0;a[(c[b+352>>2]|0)+30|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+152>>3],+h[j+2016>>3]- +h[j+3064>>3])|0;a[(c[b+352>>2]|0)+30|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+4|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}function Tp(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+4|0]|0)==0){f=0.0;g=b;j=g+2024|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+152>>3]- +h[b+2016>>3];g=b;j=g+2024|0;k=j;h[k>>3]=f;i=d;return}function Up(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3884>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2040>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2040|0;h[c[g+3888>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2040>>3]);e=c[f>>2]|0;h[c[e+3892>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3884>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6352|0;h[(c[e+3888>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6352>>3]);j=c[f>>2]|0;h[(c[j+3892>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+3884>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2376>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2376|0;h[(c[j+3888>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2376>>3]);g=c[f>>2]|0;h[(c[g+3892>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+3884>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2360>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2360|0;h[(c[g+3888>>2]|0)+24>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2360>>3]);h[(c[(c[f>>2]|0)+3892>>2]|0)+24>>3]=k;TFa(a,48)|0;a=c[(c[f>>2]|0)+3884>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2040>>3]=+h[a>>3];h[f+6352>>3]=+h[a+8>>3];h[f+2376>>3]=+h[a+16>>3];h[f+2360>>3]=+h[a+24>>3];i=b;return}function Vp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2360>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2360>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6392>>3]=+h[f>>3];i=b;return}function Wp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2360>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2360>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6400>>3]=+h[f>>3];i=b;return}function Xp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2360>>3],+h[l+144>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2360>>3];o=+h[m+144>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+2376>>3],+h[d+6392>>3],+h[f>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6368>>3]=+h[g>>3];i=b;return}function Yp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2360>>3],+h[(c[b+416>>2]|0)+776>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+91|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+91|0]|0;l=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+91|0]|0)|0;a[(c[b+352>>2]|0)+91|0]=l;g=k;break}else{k=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+91|0]|0)|0;a[(c[b+352>>2]|0)+91|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+91|0]|0;k=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+91|0]=k;g=j;break}else{j=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+91|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+16|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+16|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+16|0;v=u;a[v]=m;i=d;return}function Zp(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2384>>3]=+h[e+2376>>3]*+h[(a<<24>>24==0?e+256|0:e+144|0)>>3];i=b;return}function _p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+92|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+92|0]|0;j=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[b+360>>2]|0)+92|0]|0)|0;a[(c[b+352>>2]|0)+92|0]=j;e=g;break}else{g=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[b+360>>2]|0)+92|0]|0)|0;a[(c[b+352>>2]|0)+92|0]=g;e=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+92|0]|0;g=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;a[(c[b+352>>2]|0)+92|0]=g;e=f;break}else{f=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;a[(c[b+352>>2]|0)+92|0]=f;e=f;break}}}}while(0);f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;if(e<<24>>24==0){k=0.0;l=f;m=l+2368|0;n=m;h[n>>3]=k;i=d;return}k=+h[f+2376>>3];l=f;m=l+2368|0;n=m;h[n>>3]=k;i=d;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6488>>3]=+h[b+2368>>3]+ +h[b+2328>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+2336>>3]+(+h[b+2376>>3]+ +h[b+6480>>3]);i=i;return}function bq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2032>>3]=-(+h[e+2376>>3]*+h[(a<<24>>24==0?e+144|0:e+256|0)>>3]);i=b;return}function cq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2040>>3],+h[a+144>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2040>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6376>>3]=+h[f>>3];i=b;return}function dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2040>>3],+h[l+256>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2040>>3];o=+h[m+256>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+2376>>3],+h[d+6376>>3],+h[f>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6360>>3]=+h[g>>3];i=b;return}function eq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2040>>3],+h[a+144>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2040>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6384>>3]=+h[f>>3];i=b;return}function fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+2376>>3],+h[j+6400>>3],+h[j+6384>>3],+h[(c[b+416>>2]|0)+816>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+2376>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,6416,6408,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2040>>3],+h[(c[b+416>>2]|0)+2936>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+94|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+94|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+94|0]|0)|0;a[(c[b+352>>2]|0)+94|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+94|0]|0)|0;a[(c[b+352>>2]|0)+94|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+94|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+94|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+94|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+5|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+5|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+5|0;v=u;a[v]=m;i=d;return}function hq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2080>>3]=+h[(c[a+416>>2]|0)+200>>3];i=i;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+33|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+33|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+168>>3],+h[k+2080>>3]+ +h[k+3088>>3],a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+168>>3],+h[j+2080>>3]+ +h[j+3088>>3],a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+33|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+168>>3],+h[l+2080>>3]+ +h[l+3088>>3])|0;a[(c[b+352>>2]|0)+33|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+168>>3],+h[g+2080>>3]+ +h[g+3088>>3])|0;a[(c[b+352>>2]|0)+33|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+34|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+34|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+168>>3],+h[l+2080>>3]- +h[l+3088>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+168>>3],+h[g+2080>>3]- +h[g+3088>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+34|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+168>>3],+h[k+2080>>3]- +h[k+3088>>3])|0;a[(c[b+352>>2]|0)+34|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+168>>3],+h[j+2080>>3]- +h[j+3088>>3])|0;a[(c[b+352>>2]|0)+34|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+7|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}function jq(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+7|0]|0)==0){f=0.0;g=b;j=g+2096|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+168>>3]- +h[b+2080>>3];g=b;j=g+2096|0;k=j;h[k>>3]=f;i=d;return}function kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+3964>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5008>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5008|0;h[c[g+3968>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5008>>3]);e=c[f>>2]|0;h[c[e+3972>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+3964>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2120>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2120|0;h[(c[e+3968>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2120>>3]);h[(c[(c[f>>2]|0)+3972>>2]|0)+8>>3]=k;TFa(a,49)|0;j=c[(c[f>>2]|0)+3964>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5008>>3]=+h[j>>3];h[f+2120>>3]=+h[j+8>>3];Hz(a);Iz(a);Jz(a);Kz(a);Lz(a);Mz(a);Nz(a);Oz(a);Pz(a);Qz(a);i=b;return}function lq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2112>>3]=-(+h[e+4944>>3]*+h[(a<<24>>24==0?e+160|0:e+3808|0)>>3]);i=b;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3752>>3]*+h[j+1504>>3]*+h[e+3696>>3];l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,6536,6528,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1440|0;q=p;h[q>>3]=n;i=d;return}function nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+4944>>3]*+h[(c[a+416>>2]|0)+3704>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=-+h[b+4944>>3]-(+h[b+5024>>3]+ +h[b+4712>>3]);i=i;return}function pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+5520>>3]- +h[b+4872>>3]- +h[b+3592>>3];i=i;return}function qq(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+4824>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,6616,6608,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6792|0;p=o;h[p>>3]=m;i=d;return}function rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=b+536|0;n=b+4|0;wt(e,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4712>>3]);o=+h[e>>3];wt(f,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4944>>3]);p=+h[f>>3];wt(g,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+5024>>3]);q=+h[g>>3];wt(j,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4712>>3]);r=+h[j>>3];wt(k,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4944>>3]);s=+h[k>>3];wt(l,c[m>>2]|0,+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+5024>>3]);t=r+(s+ +h[l>>3]);l=c[c[n>>2]>>2]|0;k=c[l+8>>2]|0;s=o*+h[k+3768>>3]+(p*+h[k+3800>>3]+q*+h[k+5088>>3]);if(t!=0.0){u=k;v=s/t;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}if(s==0.0){u=k;v=s;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}q=s/+SBa(c[m>>2]|0,t,6640,6632,+h[l>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[n>>2]>>2]|0)+8>>2]|0;v=q;w=u;x=w+3584|0;y=x;h[y>>3]=v;i=d;return}function sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5520>>3],0.0)|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4872>>3],0.0)|0;f=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3592>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=g+96|0;h[g+3552>>3]=-(+h[g+3592>>3]*+h[(f<<24>>24==0?d:g+3584|0)>>3])- +h[g+4872>>3]*+h[(e<<24>>24==0?d:g+240|0)>>3]- +h[g+5520>>3]*+h[(a<<24>>24==0?d:g+224|0)>>3];i=b;return}



function tB(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0;e=i;i=i+3632|0;f=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;MBa(21,1,57952,wb);xb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3]- +h[(c[(b+416|0)>>2]|0)+752>>3];h[d>>3]=xb;wb=sB(0)|0;c[vb>>2]=1;c[vb+4>>2]=wb;h[k>>3]=xb;c[(vb+8|0)>>2]=c[k>>2];c[(vb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,vb);xb=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+6424>>3]+-293.15;h[d+8>>3]=xb;vb=sB(1)|0;c[ub>>2]=2;c[ub+4>>2]=vb;h[k>>3]=xb;c[(ub+8|0)>>2]=c[k>>2];c[(ub+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ub);xb=+((a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+103|0]|0)==0|0);h[d+16>>3]=xb;ub=sB(2)|0;c[tb>>2]=3;c[tb+4>>2]=ub;h[k>>3]=xb;c[(tb+8|0)>>2]=c[k>>2];c[(tb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,tb);tb=c[(b+408|0)>>2]|0;ub=(a[tb+106|0]|0)==0;if((a[tb+105|0]|0)==0){yb=ub?0.0:1.0}else{yb=+(ub&1|0)}h[d+24>>3]=yb;ub=sB(3)|0;c[sb>>2]=4;c[sb+4>>2]=ub;h[k>>3]=yb;c[(sb+8|0)>>2]=c[k>>2];c[(sb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,sb);sb=c[(b+408|0)>>2]|0;ub=(a[sb+106|0]|0)==0;if((a[sb+104|0]|0)==0){zb=ub?0.0:1.0}else{zb=+(ub&1|0)}h[d+32>>3]=zb;ub=sB(4)|0;c[rb>>2]=5;c[rb+4>>2]=ub;h[k>>3]=zb;c[(rb+8|0)>>2]=c[k>>2];c[(rb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,rb);zb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+99|0]|0)==0?0.0:1.0;h[d+40>>3]=zb;rb=sB(5)|0;c[qb>>2]=6;c[qb+4>>2]=rb;h[k>>3]=zb;c[(qb+8|0)>>2]=c[k>>2];c[(qb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,qb);qb=c[(b+408|0)>>2]|0;rb=(a[qb+102|0]|0)==0;if((a[qb+101|0]|0)==0){Ab=rb?0.0:1.0}else{Ab=+(rb&1|0)}h[d+48>>3]=Ab;rb=sB(6)|0;c[pb>>2]=7;c[pb+4>>2]=rb;h[k>>3]=Ab;c[(pb+8|0)>>2]=c[k>>2];c[(pb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,pb);pb=c[(b+408|0)>>2]|0;rb=(a[pb+102|0]|0)==0;if((a[pb+100|0]|0)==0){Bb=rb?0.0:1.0}else{Bb=+(rb&1|0)}h[d+56>>3]=Bb;rb=sB(7)|0;c[ob>>2]=8;c[ob+4>>2]=rb;h[k>>3]=Bb;c[(ob+8|0)>>2]=c[k>>2];c[(ob+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ob);Bb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+95|0]|0)==0?0.0:1.0;h[d+64>>3]=Bb;ob=sB(8)|0;c[nb>>2]=9;c[nb+4>>2]=ob;h[k>>3]=Bb;c[(nb+8|0)>>2]=c[k>>2];c[(nb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,nb);nb=c[(b+408|0)>>2]|0;ob=(a[nb+98|0]|0)==0;if((a[nb+97|0]|0)==0){Cb=ob?0.0:1.0}else{Cb=+(ob&1|0)}h[d+72>>3]=Cb;ob=sB(9)|0;c[mb>>2]=10;c[mb+4>>2]=ob;h[k>>3]=Cb;c[(mb+8|0)>>2]=c[k>>2];c[(mb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,mb);mb=c[(b+408|0)>>2]|0;ob=(a[mb+98|0]|0)==0;if((a[mb+96|0]|0)==0){Db=ob?0.0:1.0}else{Db=+(ob&1|0)}h[d+80>>3]=Db;ob=sB(10)|0;c[lb>>2]=11;c[lb+4>>2]=ob;h[k>>3]=Db;c[(lb+8|0)>>2]=c[k>>2];c[(lb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,lb);Db=+h[(c[(b+400|0)>>2]|0)+6224>>3]- +h[c[c[(b+4|0)>>2]>>2]>>3];h[d+88>>3]=Db;lb=sB(11)|0;c[kb>>2]=12;c[kb+4>>2]=lb;h[k>>3]=Db;c[(kb+8|0)>>2]=c[k>>2];c[(kb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,kb);Db=(a[(c[(b+408|0)>>2]|0)+94|0]|0)==0?0.0:1.0;h[d+96>>3]=Db;kb=sB(12)|0;c[jb>>2]=13;c[jb+4>>2]=kb;h[k>>3]=Db;c[(jb+8|0)>>2]=c[k>>2];c[(jb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,jb);Db=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+89|0]|0)==0?0.0:1.0;h[d+104>>3]=Db;jb=sB(13)|0;c[ib>>2]=14;c[ib+4>>2]=jb;h[k>>3]=Db;c[(ib+8|0)>>2]=c[k>>2];c[(ib+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ib);ib=c[(b+408|0)>>2]|0;jb=(a[ib+92|0]|0)==0;if((a[ib+91|0]|0)==0){Eb=jb?0.0:1.0}else{Eb=+(jb&1|0)}h[d+112>>3]=Eb;jb=sB(14)|0;c[hb>>2]=15;c[hb+4>>2]=jb;h[k>>3]=Eb;c[(hb+8|0)>>2]=c[k>>2];c[(hb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,hb);hb=c[(b+408|0)>>2]|0;jb=(a[hb+92|0]|0)==0;if((a[hb+90|0]|0)==0){Fb=jb?0.0:1.0}else{Fb=+(jb&1|0)}h[d+120>>3]=Fb;jb=sB(15)|0;c[gb>>2]=16;c[gb+4>>2]=jb;h[k>>3]=Fb;c[(gb+8|0)>>2]=c[k>>2];c[(gb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,gb);Fb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+85|0]|0)==0?0.0:1.0;h[d+128>>3]=Fb;gb=sB(16)|0;c[fb>>2]=17;c[fb+4>>2]=gb;h[k>>3]=Fb;c[(fb+8|0)>>2]=c[k>>2];c[(fb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,fb);fb=c[(b+408|0)>>2]|0;gb=(a[fb+88|0]|0)==0;if((a[fb+87|0]|0)==0){Gb=gb?0.0:1.0}else{Gb=+(gb&1|0)}h[d+136>>3]=Gb;gb=sB(17)|0;c[eb>>2]=18;c[eb+4>>2]=gb;h[k>>3]=Gb;c[(eb+8|0)>>2]=c[k>>2];c[(eb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,eb);eb=c[(b+408|0)>>2]|0;gb=(a[eb+88|0]|0)==0;if((a[eb+86|0]|0)==0){Hb=gb?0.0:1.0}else{Hb=+(gb&1|0)}h[d+144>>3]=Hb;gb=sB(18)|0;c[db>>2]=19;c[db+4>>2]=gb;h[k>>3]=Hb;c[(db+8|0)>>2]=c[k>>2];c[(db+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,db);Hb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+81|0]|0)==0?0.0:1.0;h[d+152>>3]=Hb;db=sB(19)|0;c[cb>>2]=20;c[cb+4>>2]=db;h[k>>3]=Hb;c[(cb+8|0)>>2]=c[k>>2];c[(cb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,cb);cb=c[(b+408|0)>>2]|0;db=(a[cb+84|0]|0)==0;if((a[cb+83|0]|0)==0){Ib=db?0.0:1.0}else{Ib=+(db&1|0)}h[d+160>>3]=Ib;db=sB(20)|0;c[bb>>2]=21;c[bb+4>>2]=db;h[k>>3]=Ib;c[(bb+8|0)>>2]=c[k>>2];c[(bb+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,bb);bb=c[(b+408|0)>>2]|0;db=(a[bb+84|0]|0)==0;if((a[bb+82|0]|0)==0){Jb=db?0.0:1.0}else{Jb=+(db&1|0)}h[d+168>>3]=Jb;db=sB(21)|0;c[ab>>2]=22;c[ab+4>>2]=db;h[k>>3]=Jb;c[(ab+8|0)>>2]=c[k>>2];c[(ab+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ab);Jb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+77|0]|0)==0?0.0:1.0;h[d+176>>3]=Jb;ab=sB(22)|0;c[$a>>2]=23;c[$a+4>>2]=ab;h[k>>3]=Jb;c[($a+8|0)>>2]=c[k>>2];c[($a+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,$a);$a=c[(b+408|0)>>2]|0;ab=(a[$a+80|0]|0)==0;if((a[$a+79|0]|0)==0){Kb=ab?0.0:1.0}else{Kb=+(ab&1|0)}h[d+184>>3]=Kb;ab=sB(23)|0;c[_a>>2]=24;c[_a+4>>2]=ab;h[k>>3]=Kb;c[(_a+8|0)>>2]=c[k>>2];c[(_a+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,_a);_a=c[(b+408|0)>>2]|0;ab=(a[_a+80|0]|0)==0;if((a[_a+78|0]|0)==0){Lb=ab?0.0:1.0}else{Lb=+(ab&1|0)}h[d+192>>3]=Lb;ab=sB(24)|0;c[Za>>2]=25;c[Za+4>>2]=ab;h[k>>3]=Lb;c[(Za+8|0)>>2]=c[k>>2];c[(Za+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Za);Lb=+h[(c[(b+400|0)>>2]|0)+6168>>3]- +h[c[c[(b+4|0)>>2]>>2]>>3];h[d+200>>3]=Lb;Za=sB(25)|0;c[Ya>>2]=26;c[Ya+4>>2]=Za;h[k>>3]=Lb;c[(Ya+8|0)>>2]=c[k>>2];c[(Ya+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ya);Lb=(a[(c[(b+408|0)>>2]|0)+76|0]|0)==0?0.0:1.0;h[d+208>>3]=Lb;Ya=sB(26)|0;c[Xa>>2]=27;c[Xa+4>>2]=Ya;h[k>>3]=Lb;c[(Xa+8|0)>>2]=c[k>>2];c[(Xa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Xa);Lb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+69|0]|0)==0?0.0:1.0;h[d+216>>3]=Lb;Xa=sB(27)|0;c[Wa>>2]=28;c[Wa+4>>2]=Xa;h[k>>3]=Lb;c[(Wa+8|0)>>2]=c[k>>2];c[(Wa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Wa);Wa=c[(b+408|0)>>2]|0;Xa=(a[Wa+72|0]|0)==0;if((a[Wa+71|0]|0)==0){Mb=Xa?0.0:1.0}else{Mb=+(Xa&1|0)}h[d+224>>3]=Mb;Xa=sB(28)|0;c[Va>>2]=29;c[Va+4>>2]=Xa;h[k>>3]=Mb;c[(Va+8|0)>>2]=c[k>>2];c[(Va+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Va);Va=c[(b+408|0)>>2]|0;Xa=(a[Va+72|0]|0)==0;if((a[Va+70|0]|0)==0){Nb=Xa?0.0:1.0}else{Nb=+(Xa&1|0)}h[d+232>>3]=Nb;Xa=sB(29)|0;c[Ua>>2]=30;c[Ua+4>>2]=Xa;h[k>>3]=Nb;c[(Ua+8|0)>>2]=c[k>>2];c[(Ua+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ua);Nb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+65|0]|0)==0?0.0:1.0;h[d+240>>3]=Nb;Ua=sB(30)|0;c[Ta>>2]=31;c[Ta+4>>2]=Ua;h[k>>3]=Nb;c[(Ta+8|0)>>2]=c[k>>2];c[(Ta+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ta);Ta=c[(b+408|0)>>2]|0;Ua=(a[Ta+68|0]|0)==0;if((a[Ta+67|0]|0)==0){Ob=Ua?0.0:1.0}else{Ob=+(Ua&1|0)}h[d+248>>3]=Ob;Ua=sB(31)|0;c[Sa>>2]=32;c[Sa+4>>2]=Ua;h[k>>3]=Ob;c[(Sa+8|0)>>2]=c[k>>2];c[(Sa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Sa);Sa=c[(b+408|0)>>2]|0;Ua=(a[Sa+68|0]|0)==0;if((a[Sa+66|0]|0)==0){Pb=Ua?0.0:1.0}else{Pb=+(Ua&1|0)}h[d+256>>3]=Pb;Ua=sB(32)|0;c[Ra>>2]=33;c[Ra+4>>2]=Ua;h[k>>3]=Pb;c[(Ra+8|0)>>2]=c[k>>2];c[(Ra+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ra);Pb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+61|0]|0)==0?0.0:1.0;h[d+264>>3]=Pb;Ra=sB(33)|0;c[Qa>>2]=34;c[Qa+4>>2]=Ra;h[k>>3]=Pb;c[(Qa+8|0)>>2]=c[k>>2];c[(Qa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Qa);Qa=c[(b+408|0)>>2]|0;Ra=(a[Qa+64|0]|0)==0;if((a[Qa+63|0]|0)==0){Qb=Ra?0.0:1.0}else{Qb=+(Ra&1|0)}h[d+272>>3]=Qb;Ra=sB(34)|0;c[Pa>>2]=35;c[Pa+4>>2]=Ra;h[k>>3]=Qb;c[(Pa+8|0)>>2]=c[k>>2];c[(Pa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Pa);Pa=c[(b+408|0)>>2]|0;Ra=(a[Pa+64|0]|0)==0;if((a[Pa+62|0]|0)==0){Rb=Ra?0.0:1.0}else{Rb=+(Ra&1|0)}h[d+280>>3]=Rb;Ra=sB(35)|0;c[Oa>>2]=36;c[Oa+4>>2]=Ra;h[k>>3]=Rb;c[(Oa+8|0)>>2]=c[k>>2];c[(Oa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Oa);Rb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+57|0]|0)==0?0.0:1.0;h[d+288>>3]=Rb;Oa=sB(36)|0;c[Na>>2]=37;c[Na+4>>2]=Oa;h[k>>3]=Rb;c[(Na+8|0)>>2]=c[k>>2];c[(Na+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Na);Na=c[(b+408|0)>>2]|0;Oa=(a[Na+60|0]|0)==0;if((a[Na+59|0]|0)==0){Sb=Oa?0.0:1.0}else{Sb=+(Oa&1|0)}h[d+296>>3]=Sb;Oa=sB(37)|0;c[Ma>>2]=38;c[Ma+4>>2]=Oa;h[k>>3]=Sb;c[(Ma+8|0)>>2]=c[k>>2];c[(Ma+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ma);Ma=c[(b+408|0)>>2]|0;Oa=(a[Ma+60|0]|0)==0;if((a[Ma+58|0]|0)==0){Tb=Oa?0.0:1.0}else{Tb=+(Oa&1|0)}h[d+304>>3]=Tb;Oa=sB(38)|0;c[La>>2]=39;c[La+4>>2]=Oa;h[k>>3]=Tb;c[(La+8|0)>>2]=c[k>>2];c[(La+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,La);Tb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+53|0]|0)==0?0.0:1.0;h[d+312>>3]=Tb;La=sB(39)|0;c[Ka>>2]=40;c[Ka+4>>2]=La;h[k>>3]=Tb;c[(Ka+8|0)>>2]=c[k>>2];c[(Ka+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ka);Ka=c[(b+408|0)>>2]|0;La=(a[Ka+56|0]|0)==0;if((a[Ka+55|0]|0)==0){Ub=La?0.0:1.0}else{Ub=+(La&1|0)}h[d+320>>3]=Ub;La=sB(40)|0;c[Ja>>2]=41;c[Ja+4>>2]=La;h[k>>3]=Ub;c[(Ja+8|0)>>2]=c[k>>2];c[(Ja+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ja);Ja=c[(b+408|0)>>2]|0;La=(a[Ja+56|0]|0)==0;if((a[Ja+54|0]|0)==0){Vb=La?0.0:1.0}else{Vb=+(La&1|0)}h[d+328>>3]=Vb;La=sB(41)|0;c[Ia>>2]=42;c[Ia+4>>2]=La;h[k>>3]=Vb;c[(Ia+8|0)>>2]=c[k>>2];c[(Ia+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ia);Vb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+49|0]|0)==0?0.0:1.0;h[d+336>>3]=Vb;Ia=sB(42)|0;c[Ha>>2]=43;c[Ha+4>>2]=Ia;h[k>>3]=Vb;c[(Ha+8|0)>>2]=c[k>>2];c[(Ha+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ha);Ha=c[(b+408|0)>>2]|0;Ia=(a[Ha+52|0]|0)==0;if((a[Ha+51|0]|0)==0){Wb=Ia?0.0:1.0}else{Wb=+(Ia&1|0)}h[d+344>>3]=Wb;Ia=sB(43)|0;c[Ga>>2]=44;c[Ga+4>>2]=Ia;h[k>>3]=Wb;c[(Ga+8|0)>>2]=c[k>>2];c[(Ga+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ga);Ga=c[(b+408|0)>>2]|0;Ia=(a[Ga+52|0]|0)==0;if((a[Ga+50|0]|0)==0){Xb=Ia?0.0:1.0}else{Xb=+(Ia&1|0)}h[d+352>>3]=Xb;Ia=sB(44)|0;c[Fa>>2]=45;c[Fa+4>>2]=Ia;h[k>>3]=Xb;c[(Fa+8|0)>>2]=c[k>>2];c[(Fa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Fa);Xb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+45|0]|0)==0?0.0:1.0;h[d+360>>3]=Xb;Fa=sB(45)|0;c[Ea>>2]=46;c[Ea+4>>2]=Fa;h[k>>3]=Xb;c[(Ea+8|0)>>2]=c[k>>2];c[(Ea+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ea);Ea=c[(b+408|0)>>2]|0;Fa=(a[Ea+48|0]|0)==0;if((a[Ea+47|0]|0)==0){Yb=Fa?0.0:1.0}else{Yb=+(Fa&1|0)}h[d+368>>3]=Yb;Fa=sB(46)|0;c[Da>>2]=47;c[Da+4>>2]=Fa;h[k>>3]=Yb;c[(Da+8|0)>>2]=c[k>>2];c[(Da+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Da);Da=c[(b+408|0)>>2]|0;Fa=(a[Da+48|0]|0)==0;if((a[Da+46|0]|0)==0){Zb=Fa?0.0:1.0}else{Zb=+(Fa&1|0)}h[d+376>>3]=Zb;Fa=sB(47)|0;c[Ca>>2]=48;c[Ca+4>>2]=Fa;h[k>>3]=Zb;c[(Ca+8|0)>>2]=c[k>>2];c[(Ca+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ca);Zb=(a[(c[(c[c[(b+4|0)>>2]>>2]|0)+16>>2]|0)+41|0]|0)==0?0.0:1.0;h[d+384>>3]=Zb;Ca=sB(48)|0;c[Ba>>2]=49;c[Ba+4>>2]=Ca;h[k>>3]=Zb;c[(Ba+8|0)>>2]=c[k>>2];c[(Ba+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Ba);Ba=c[(b+408|0)>>2]|0;Ca=(a[Ba+44|0]|0)==0;if((a[Ba+43|0]|0)==0){_b=Ca?0.0:1.0}else{_b=+(Ca&1|0)}h[d+392>>3]=_b;Ca=sB(49)|0;c[Aa>>2]=50;c[Aa+4>>2]=Ca;h[k>>3]=_b;c[(Aa+8|0)>>2]=c[k>>2];c[(Aa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Aa);Aa=c[(b+408|0)>>2]|0;Ca=(a[Aa+44|0]|0)==0;if((a[Aa+42|0]|0)==0){$b=Ca?0.0:1.0}else{$b=+(Ca&1|0)}h[d+400>>3]=$b;Ca=sB(50)|0;c[za>>2]=51;c[za+4>>2]=Ca;h[k>>3]=$b;c[(za+8|0)>>2]=c[k>>2];c[(za+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,za);$b=(a[(c[(b+408|0)>>2]|0)+38|0]|0)==0?0.0:1.0;h[d+408>>3]=$b;za=sB(51)|0;c[ya>>2]=52;c[ya+4>>2]=za;h[k>>3]=$b;c[(ya+8|0)>>2]=c[k>>2];c[(ya+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ya);$b=+h[(c[(b+400|0)>>2]|0)+6080>>3]- +h[c[c[(b+4|0)>>2]>>2]>>3];h[d+416>>3]=$b;ya=sB(52)|0;c[xa>>2]=53;c[xa+4>>2]=ya;h[k>>3]=$b;c[(xa+8|0)>>2]=c[k>>2];c[(xa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,xa);$b=(a[(c[(b+408|0)>>2]|0)+36|0]|0)==0?0.0:1.0;h[d+424>>3]=$b;xa=sB(53)|0;c[wa>>2]=54;c[e+24>>2]=b;c[e+32>>2]=d;g[e+1768>>2]=$b;c[e+1776>>2]=xa;c[e+2944>>2]=wa;c[e+2952>>2]=va;c[e+2960>>2]=ua;c[e+2968>>2]=ta;c[e+2976>>2]=sa;c[e+2984>>2]=ra;c[e+2992>>2]=qa;c[e+3008>>2]=pa;c[e+3016>>2]=oa;c[e+3024>>2]=na;c[e+3032>>2]=ma;c[e+3040>>2]=la;c[e+3048>>2]=ka;c[e+3056>>2]=ja;c[e+3064>>2]=ia;c[e+3072>>2]=ha;c[e+3080>>2]=ga;c[e+3096>>2]=fa;c[e+3104>>2]=ea;c[e+3112>>2]=da;c[e+3120>>2]=ca;c[e+3128>>2]=ba;c[e+3136>>2]=aa;c[e+3144>>2]=$;c[e+3152>>2]=_;c[e+3160>>2]=Z;c[e+3168>>2]=Y;c[e+3184>>2]=X;c[e+3192>>2]=W;c[e+3200>>2]=V;c[e+3208>>2]=U;c[e+3216>>2]=T;c[e+3224>>2]=S;c[e+3232>>2]=R;c[e+3240>>2]=Q;c[e+3248>>2]=P;c[e+3256>>2]=O;c[e+3272>>2]=N;c[e+3280>>2]=M;c[e+3288>>2]=L;c[e+3296>>2]=K;c[e+3304>>2]=J;c[e+3312>>2]=G;c[e+3320>>2]=F;c[e+3328>>2]=E;c[e+3336>>2]=D;c[e+3344>>2]=C;c[e+3368>>2]=B;c[e+3376>>2]=z;c[e+3384>>2]=y;c[e+3392>>2]=x;c[e+3400>>2]=w;c[e+3408>>2]=v;c[e+3416>>2]=u;c[e+3424>>2]=t;c[e+3432>>2]=s;c[e+3440>>2]=r;c[e+3456>>2]=q;c[e+3464>>2]=p;c[e+3472>>2]=o;c[e+3480>>2]=n;c[e+3488>>2]=m;c[e+3496>>2]=l;c[e+3504>>2]=j;c[e+3512>>2]=f;c[e+3568>>2]=0;c[e+3572>>2]=0;_Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_initial_residual$0(e);H=c[e+3568>>2]|0;A=c[e+3572>>2]|0;I=+g[e+3572>>2];c[e+3568>>2]=0;c[e+3572>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function uB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=+h[(c[a+8>>2]|0)+93392>>3];i=i;return}function vB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=+h[(c[a+8>>2]|0)+93504>>3];i=i;return}function wB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4800>>3]=+h[b+2520>>3];i=i;return}function xB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4752>>3]=+h[b+2512>>3];i=i;return}function yB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4784>>3]=+h[b+4752>>3];i=i;return}function zB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+704>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+4784>>3];l=+h[a+4696>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+4704>>3]=+h[f>>3];i=b;return}function AB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+4496>>3];i=i;return}function BB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+4496>>3];i=i;return}function CB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+4480>>3]*.5;i=i;return}function DB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+4480>>3]*.5;i=i;return}function EB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4640>>3]=+h[b+2528>>3];i=i;return}function FB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4624>>3]=+h[b+2568>>3];i=i;return}function GB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4616>>3]=+h[b+4624>>3]*100.0;i=i;return}function HB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4576>>3]=+h[b+4472>>3];i=i;return}function IB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4488>>3]=+h[b+720>>3];i=i;return}function JB(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4488>>3];h[b+4544>>3]=d*d*.7853981633974483;i=i;return}function KB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+4544>>3];i=i;return}function LB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+4544>>3];i=i;return}function MB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4552>>3]=+h[b+4488>>3]*3.141592653589793;i=i;return}function NB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4552>>3];j=+h[f+4544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58008,58e3,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+608>>3]=l*4.0;i=d;return}function OB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4552>>3];j=+h[f+4544>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58008,58032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+616>>3]=l*4.0;i=d;return}function PB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+4272>>3];i=i;return}function QB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+4272>>3];i=i;return}function RB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+4256>>3]*.5;i=i;return}function SB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+4256>>3]*.5;i=i;return}function TB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4416>>3]=+h[b+2528>>3];i=i;return}function UB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4400>>3]=+h[b+2568>>3];i=i;return}function VB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4392>>3]=+h[b+4400>>3]*100.0;i=i;return}function WB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4352>>3]=+h[b+4248>>3];i=i;return}function XB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4264>>3]=+h[b+720>>3];i=i;return}function YB(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4264>>3];h[b+4320>>3]=d*d*.7853981633974483;i=i;return}function ZB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+4320>>3];i=i;return}function _B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+4320>>3];i=i;return}function $B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4328>>3]=+h[b+4264>>3]*3.141592653589793;i=i;return}function aC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4328>>3];j=+h[f+4320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58048,58040,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+488>>3]=l*4.0;i=d;return}function bC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4328>>3];j=+h[f+4320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58048,58072,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+496>>3]=l*4.0;i=d;return}function cC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4216>>3]=+h[b+2528>>3];i=i;return}function dC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4200>>3]=+h[b+2568>>3];i=i;return}function eC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4192>>3]=+h[b+4200>>3]*100.0;i=i;return}function fC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4152>>3]=+h[b+4064>>3];i=i;return}function gC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4080>>3]=+h[b+720>>3];i=i;return}function hC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4080>>3];h[b+4120>>3]=d*d*.7853981633974483;i=i;return}function iC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4128>>3]=+h[b+4080>>3]*3.141592653589793;i=i;return}function jC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+2528>>3];i=i;return}function kC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4016>>3]=+h[b+2568>>3];i=i;return}function lC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4008>>3]=+h[b+4016>>3]*100.0;i=i;return}function mC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3968>>3]=+h[b+3880>>3];i=i;return}function nC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3896>>3]=+h[b+720>>3];i=i;return}function oC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3896>>3];h[b+3936>>3]=d*d*.7853981633974483;i=i;return}function pC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+3896>>3]*3.141592653589793;i=i;return}function qC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3848>>3]=+h[b+2528>>3];i=i;return}function rC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3832>>3]=+h[b+2568>>3];i=i;return}function sC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3824>>3]=+h[b+3832>>3]*100.0;i=i;return}function tC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3784>>3]=+h[b+3696>>3];i=i;return}function uC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3712>>3]=+h[b+720>>3];i=i;return}function vC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3712>>3];h[b+3752>>3]=d*d*.7853981633974483;i=i;return}function wC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3760>>3]=+h[b+3712>>3]*3.141592653589793;i=i;return}function xC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3664>>3]=+h[b+2528>>3];i=i;return}function yC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3648>>3]=+h[b+2568>>3];i=i;return}function zC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3640>>3]=+h[b+3648>>3]*100.0;i=i;return}function AC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3600>>3]=+h[b+3512>>3];i=i;return}function BC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3528>>3]=+h[b+720>>3];i=i;return}function CC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3528>>3];h[b+3568>>3]=d*d*.7853981633974483;i=i;return}function DC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3576>>3]=+h[b+3528>>3]*3.141592653589793;i=i;return}function EC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3480>>3]=+h[b+2528>>3];i=i;return}function FC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+2568>>3];i=i;return}function GC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3464>>3]*100.0;i=i;return}function HC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3328>>3];i=i;return}function IC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3344>>3]=+h[b+720>>3];i=i;return}function JC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3344>>3];h[b+3384>>3]=d*d*.7853981633974483;i=i;return}function KC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+3344>>3]*3.141592653589793;i=i;return}function LC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+3128>>3];i=i;return}function MC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+3128>>3];i=i;return}function NC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+3112>>3]*.5;i=i;return}function OC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+336>>3]=+h[b+3112>>3]*.5;i=i;return}function PC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3256>>3]=+h[b+2568>>3];i=i;return}function QC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3248>>3]=+h[b+3256>>3]*100.0;i=i;return}function RC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3208>>3]=+h[b+3104>>3];i=i;return}function SC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+720>>3];i=i;return}function TC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3120>>3];h[b+3176>>3]=d*d*.7853981633974483;i=i;return}function UC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+3176>>3];i=i;return}function VC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+3176>>3];i=i;return}function WC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3184>>3]=+h[b+3120>>3]*3.141592653589793;i=i;return}function XC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3184>>3];j=+h[f+3176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58088,58080,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+368>>3]=l*4.0;i=d;return}function YC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3184>>3];j=+h[f+3176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,58088,58112,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+376>>3]=l*4.0;i=d;return}function ZC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3096>>3]=+h[b+2520>>3];i=i;return}function _C(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2512>>3];i=i;return}function $C(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3080>>3]=+h[b+3048>>3];i=i;return}function aD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+304>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+3080>>3];l=+h[a+2992>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+3e3>>3]=+h[f>>3];i=b;return}function bD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2936>>3]=+h[b+2512>>3];i=i;return}function cD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2968>>3]=+h[b+2936>>3];i=i;return}function dD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2512>>3];i=i;return}function eD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2824>>3];i=i;return}function fD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2512>>3];i=i;return}function gD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2712>>3];i=i;return}function hD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2632>>3];i=i;return}function iD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2616>>3]=+h[b+2600>>3];i=i;return}function jD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2584>>3]=+h[b+2520>>3];i=i;return}function kD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2584>>3];i=i;return}function lD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+152>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2744>>3];l=+h[a+2656>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2664>>3]=+h[f>>3];i=b;return}function mD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2584>>3];i=i;return}function nD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+224>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2856>>3];l=+h[a+2768>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2776>>3]=+h[f>>3];i=b;return}function oD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2584>>3];i=i;return}function pD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+264>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2968>>3];l=+h[a+2880>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2888>>3]=+h[f>>3];i=b;return}function qD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4808>>3]=+h[b+2584>>3];i=i;return}function rD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2576>>3]=+h[b+2512>>3];i=i;return}function sD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3160>>3]=+h[b+2576>>3];i=i;return}function tD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3160>>3];i=i;return}function uD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+312>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+3160>>3]+ +h[a+3192>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+3152>>3]=+h[f>>3];i=b;return}function vD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3224>>3]=+h[b+3192>>3];i=i;return}function wD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3216>>3]=+h[b+3160>>3];i=i;return}function xD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+2576>>3];i=i;return}function yD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3368>>3];i=i;return}function zD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3400>>3];i=i;return}function AD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3368>>3];i=i;return}function BD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3552>>3]=+h[b+2576>>3];i=i;return}function CD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3584>>3]=+h[b+3552>>3];i=i;return}function DD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3616>>3]=+h[b+3584>>3];i=i;return}function ED(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3608>>3]=+h[b+3552>>3];i=i;return}function FD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3736>>3]=+h[b+2576>>3];i=i;return}function GD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3768>>3]=+h[b+3736>>3];i=i;return}function HD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3800>>3]=+h[b+3768>>3];i=i;return}function ID(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3792>>3]=+h[b+3736>>3];i=i;return}function JD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3920>>3]=+h[b+2576>>3];i=i;return}function KD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3952>>3]=+h[b+3920>>3];i=i;return}function LD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3984>>3]=+h[b+3952>>3];i=i;return}function MD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3976>>3]=+h[b+3920>>3];i=i;return}function ND(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4104>>3]=+h[b+2576>>3];i=i;return}function OD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4136>>3]=+h[b+4104>>3];i=i;return}function PD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4168>>3]=+h[b+4136>>3];i=i;return}function QD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4160>>3]=+h[b+4104>>3];i=i;return}function RD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4304>>3]=+h[b+2576>>3];i=i;return}function SD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4336>>3]=+h[b+4304>>3];i=i;return}function TD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+432>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+4304>>3]+ +h[a+4336>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+4296>>3]=+h[f>>3];i=b;return}function UD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4368>>3]=+h[b+4336>>3];i=i;return}function VD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4360>>3]=+h[b+4304>>3];i=i;return}function WD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4528>>3]=+h[b+2576>>3];i=i;return}function XD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4560>>3]=+h[b+4528>>3];i=i;return}function YD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+552>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+4528>>3]+ +h[a+4560>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+4520>>3]=+h[f>>3];i=b;return}function ZD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4592>>3]=+h[b+4560>>3];i=i;return}function _D(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4584>>3]=+h[b+4528>>3];i=i;return}function $D(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4832>>3]=+h[b+2576>>3];i=i;return}function aE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+712>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+4832>>3];l=+h[a+4808>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Ct(f,j,k,l,d,0);h[(c[g>>2]|0)+4816>>3]=+h[f>>3];i=b;return}function bE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2456>>3]=+h[b+2512>>3];i=i;return}function cE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+2456>>3];i=i;return}function dE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2584>>3];i=i;return}function eE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+112>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2488>>3];l=+h[a+2400>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2408>>3]=+h[f>>3];i=b;return}function fE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+80|0;d=b;e=b+16|0;f=b+32|0;g=b+48|0;j=b+64|0;k=b+72|0;l=a+536|0;m=c[l>>2]|0;n=g;o=58120;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];o=f;n=58136;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Lt(j,m,.0001001797131419643,g,f);p=+h[j>>3];j=c[l>>2]|0;l=e;f=58120;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=d;l=58136;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];Lt(k,j,0.0,e,d);h[(c[a+416>>2]|0)+2376>>3]=p- +h[k>>3];i=b;return}function gE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2368>>3]=+h[b+2352>>3];i=i;return}function hE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2296>>3]=+h[b+2584>>3];i=i;return}function iE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+72>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2368>>3];l=+h[a+2296>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Kt(f,j,k,l,d,0);h[(c[g>>2]|0)+2304>>3]=+h[f>>3];i=b;return}function jE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+80|0;d=b;e=b+16|0;f=b+32|0;g=b+48|0;j=b+64|0;k=b+72|0;l=a+536|0;m=c[l>>2]|0;n=g;o=58120;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];o=f;n=58136;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Lt(j,m,.0001001797131419643,g,f);p=+h[j>>3];j=c[l>>2]|0;l=e;f=58120;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=d;l=58136;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];Lt(k,j,0.0,e,d);h[(c[a+416>>2]|0)+2256>>3]=p- +h[k>>3];i=b;return}function kE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2248>>3]=+h[b+2232>>3];i=i;return}function lE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2176>>3]=+h[b+2584>>3];i=i;return}function mE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+64>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2248>>3];l=+h[a+2176>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Kt(f,j,k,l,d,0);h[(c[g>>2]|0)+2184>>3]=+h[f>>3];i=b;return}function nE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2136>>3]=+h[b+2576>>3]*.01;i=i;return}function oE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+2568>>3];i=i;return}function pE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+2576>>3];i=i;return}function qE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+2584>>3];i=i;return}function rE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+56>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2096>>3];l=+h[a+2072>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Ct(f,j,k,l,d,0);h[(c[g>>2]|0)+2080>>3]=+h[f>>3];i=b;return}function sE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+2576>>3]*.01;i=i;return}function tE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2016>>3]=+h[b+2568>>3];i=i;return}function uE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+2576>>3]*.01;i=i;return}function vE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1960>>3]=+h[b+2568>>3];i=i;return}function wE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1936>>3]=+h[b+2576>>3]*.01;i=i;return}function xE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1904>>3]=+h[b+2568>>3];i=i;return}function yE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1880>>3]=+h[b+2576>>3]*.01;i=i;return}function zE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1848>>3]=+h[b+2568>>3];i=i;return}function AE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1824>>3]=+h[b+2576>>3]*.01;i=i;return}function BE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1792>>3]=+h[b+2568>>3];i=i;return}function CE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+2576>>3]*.01;i=i;return}function DE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+2568>>3];i=i;return}function EE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+2576>>3]*.01;i=i;return}function FE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1680>>3]=+h[b+2568>>3];i=i;return}function GE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1656>>3]=+h[b+2576>>3]*.01;i=i;return}function HE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1624>>3]=+h[b+2568>>3];i=i;return}function IE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+2576>>3]*.01;i=i;return}function JE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+2568>>3];i=i;return}function KE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+2576>>3]*.01;i=i;return}function LE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+2568>>3];i=i;return}function ME(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+2576>>3]*.01;i=i;return}function NE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+2568>>3];i=i;return}function OE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1432>>3]=+h[b+2576>>3]*.01;i=i;return}function PE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+2568>>3];i=i;return}function QE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1376>>3]=+h[b+2576>>3]*.01;i=i;return}function RE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1344>>3]=+h[b+2568>>3];i=i;return}function SE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1320>>3]=+h[b+2576>>3]*.01;i=i;return}function TE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+2568>>3];i=i;return}function UE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1264>>3]=+h[b+2576>>3]*.01;i=i;return}function VE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+2568>>3];i=i;return}function WE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+2576>>3]*.01;i=i;return}function XE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+2568>>3];i=i;return}function YE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+2576>>3]*.01;i=i;return}function ZE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+2568>>3];i=i;return}function _E(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1032>>3]=+h[b+992>>3];i=i;return}function $E(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+2576>>3]*.01;i=i;return}function aF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+2568>>3];i=i;return}function bF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+2576>>3]*.01;i=i;return}function cF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+2568>>3];i=i;return}function dF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+2520>>3];i=i;return}function eF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+736>>3];i=i;return}function fF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=+h[b+576>>3]+ +h[b+584>>3];i=i;return}function gF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=+h[b+600>>3]*+h[b+584>>3]*+h[b+4472>>3];i=i;return}function hF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=+h[b+592>>3]*+h[b+576>>3]*+h[b+4472>>3];i=i;return}function iF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=+h[b+456>>3]+ +h[b+464>>3];i=i;return}function jF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=+h[b+480>>3]*+h[b+464>>3]*+h[b+4248>>3];i=i;return}function kF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=+h[b+472>>3]*+h[b+456>>3]*+h[b+4248>>3];i=i;return}function lF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4128>>3];g=+h[e+4120>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58160,58152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=j*4.0;i=d;return}function mF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4128>>3];g=+h[e+4120>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58160,58184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=j*4.0;i=d;return}function nF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3944>>3];g=+h[e+3936>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58200,58192,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=j*4.0;i=d;return}function oF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3944>>3];g=+h[e+3936>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58200,58224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=j*4.0;i=d;return}function pF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3760>>3];g=+h[e+3752>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58240,58232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=j*4.0;i=d;return}function qF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3760>>3];g=+h[e+3752>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58240,58264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=j*4.0;i=d;return}function rF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3576>>3];g=+h[e+3568>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58280,58272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=j*4.0;i=d;return}function sF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3576>>3];g=+h[e+3568>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58280,58304,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=j*4.0;i=d;return}function tF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3392>>3];g=+h[e+3384>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58320,58312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=j*4.0;i=d;return}function uF(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3392>>3];g=+h[e+3384>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,58320,58344,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=j*4.0;i=d;return}function vF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=+h[b+336>>3]+ +h[b+344>>3];i=i;return}function wF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=+h[b+360>>3]*+h[b+344>>3]*+h[b+3104>>3];i=i;return}function xF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=+h[b+352>>3]*+h[b+336>>3]*+h[b+3104>>3];i=i;return}function yF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;Xu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nu(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7568>>3]=+h[f>>3];i=b;return}function zF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;mu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nu(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7560>>3]=+h[f>>3];i=b;return}function AF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;mu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nv(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7544>>3]=+h[f>>3];i=b;return}function BF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=+h[(c[a+416>>2]|0)+2456>>3]*1.0e-5;i=i;return}function CF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=+h[(c[a+416>>2]|0)+2712>>3]*1.0e-5;i=i;return}function DF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7512>>3]=+h[(c[a+416>>2]|0)+2824>>3]*1.0e-5;i=i;return}function EF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[(c[a+416>>2]|0)+2936>>3]*1.0e-5;i=i;return}function FF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=+h[(c[a+416>>2]|0)+3048>>3]*1.0e-5;i=i;return}function GF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=+h[(c[a+416>>2]|0)+4752>>3]*1.0e-5;i=i;return}function HF(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+776>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=+h[d>>3];i=b;return}function IF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+3048>>3],+h[k+3e3>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+3048>>3];m=+h[g+3e3>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7472>>3]=+h[f>>3];i=b;return}function JF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+3048>>3],+h[k+3e3>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+3048>>3];m=+h[g+3e3>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=+h[f>>3];i=b;return}function KF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2936>>3],+h[k+2888>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2936>>3];m=+h[g+2888>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=+h[f>>3];i=b;return}function LF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2936>>3],+h[k+2888>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2936>>3];m=+h[g+2888>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=+h[f>>3];i=b;return}function MF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2456>>3],+h[k+2408>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2456>>3];m=+h[g+2408>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=+h[f>>3];i=b;return}function NF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2456>>3],+h[k+2408>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2456>>3];m=+h[g+2408>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=+h[f>>3];i=b;return}function OF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2712>>3],+h[k+2664>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2712>>3];m=+h[g+2664>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=+h[f>>3];i=b;return}function PF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2712>>3],+h[k+2664>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2712>>3];m=+h[g+2664>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=+h[f>>3];i=b;return}function QF(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2456>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=+h[d>>3];i=b;return}function RF(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+80>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=b*b*3.141592653589793;i=i;return}function SF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=+h[b+80>>3]*+h[b+2440>>3];i=i;return}function TF(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2712>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=+h[d>>3];i=b;return}function UF(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+120>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=b*b*3.141592653589793;i=i;return}function VF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=+h[b+120>>3]*+h[b+2696>>3];i=i;return}function WF(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2824>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=+h[d>>3];i=b;return}function XF(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+160>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=b*b*3.141592653589793;i=i;return}function YF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=+h[b+160>>3]*+h[b+2808>>3];i=i;return}function ZF(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+192>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=b*b*3.141592653589793;i=i;return}function _F(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=+h[b+192>>3]*+h[b+2808>>3];i=i;return}function $F(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2936>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=+h[d>>3];i=b;return}function aG(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+232>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=b*b*3.141592653589793;i=i;return}function bG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=+h[b+232>>3]*+h[b+2920>>3];i=i;return}function cG(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+3048>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7376>>3]=+h[d>>3];i=b;return}function dG(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+272>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=b*b*3.141592653589793;i=i;return}function eG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=+h[b+272>>3]*+h[b+3032>>3];i=i;return}function fG(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+4752>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=+h[d>>3];i=b;return}function gG(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+672>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=b*b*3.141592653589793;i=i;return}function hG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=+h[b+672>>3]*+h[b+4736>>3];i=i;return}function iG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=(+h[b+368>>3]+ +h[b+376>>3])*.5;i=i;return}function jG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[f>>3];i=b;return}function kG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=+h[f>>3];i=b;return}function lG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=(+h[b+3200>>3]+ +h[b+3208>>3])*.5;i=i;return}function mG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=+h[b+2776>>3]+ +h[b+2528>>3]*+h[b+3360>>3];i=i;return}function nG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=+h[f>>3];i=b;return}function oG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[f>>3];i=b;return}function pG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2960>>3]=(+h[b+3224>>3]+ +h[b+3232>>3])*.5;i=i;return}function qG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7352>>3]=+h[b+2776>>3]+ +h[b+2528>>3]*+h[b+3544>>3];i=i;return}function rG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2952>>3]=(+h[b+3248>>3]+ +h[b+3256>>3])*.5;i=i;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2944>>3]=(+h[b+3272>>3]+ +h[b+3280>>3])*.5;i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2936>>3]=(+h[b+3296>>3]+ +h[b+3304>>3])*.5;i=i;return}function uG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=(+h[b+488>>3]+ +h[b+496>>3])*.5;i=i;return}function vG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=(+h[b+608>>3]+ +h[b+616>>3])*.5;i=i;return}function wG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+2976>>3],+h[f+2984>>3],+h[(c[a+416>>2]|0)+2824>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2912>>3]=+h[d>>3];i=b;return}function xG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+3008>>3],+h[f+3016>>3],+h[(c[a+416>>2]|0)+2824>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2896>>3]=+h[d>>3];i=b;return}function yG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4576>>3];m=+h[k+4616>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58360,58352,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4576>>3];o=r;p=q}}while(0);l=+h[o+4656>>3];m=+h[o+4664>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3384>>3];t=+h[s+2920>>3];u=(+h[o+624>>3]+ +h[o+632>>3])*.5;v=+h[o+4624>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,58360,58352,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+4600>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7344>>3]=+h[e>>3];i=d;return}function zG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4352>>3];m=+h[k+4392>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58400,58392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4352>>3];o=r;p=q}}while(0);l=+h[o+4432>>3];m=+h[o+4440>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3344>>3];t=+h[s+2928>>3];u=(+h[o+504>>3]+ +h[o+512>>3])*.5;v=+h[o+4400>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,58400,58392,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+4376>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7336>>3]=+h[e>>3];i=d;return}function AG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4152>>3];m=+h[k+4192>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58440,58432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4152>>3];o=r;p=q}}while(0);l=+h[o+4232>>3];m=+h[o+4240>>3];q=+h[o+4072>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2936>>3];t=+h[o+4088>>3];u=(t+t)*.5;t=+h[o+4200>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,58440,58432,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+4176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7328>>3]=+h[e>>3];i=d;return}function BG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3968>>3];m=+h[k+4008>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58480,58472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3968>>3];o=r;p=q}}while(0);l=+h[o+4048>>3];m=+h[o+4056>>3];q=+h[o+3888>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2944>>3];t=+h[o+3904>>3];u=(t+t)*.5;t=+h[o+4016>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,58480,58472,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3992>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7320>>3]=+h[e>>3];i=d;return}function CG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3784>>3];m=+h[k+3824>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58520,58512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3784>>3];o=r;p=q}}while(0);l=+h[o+3864>>3];m=+h[o+3872>>3];q=+h[o+3704>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2952>>3];t=+h[o+3720>>3];u=(t+t)*.5;t=+h[o+3832>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,58520,58512,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3808>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7312>>3]=+h[e>>3];i=d;return}function DG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3600>>3];m=+h[k+3640>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58560,58552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3600>>3];o=r;p=q}}while(0);l=+h[o+3680>>3];m=+h[o+3688>>3];q=+h[o+3520>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2960>>3];t=+h[o+3536>>3];u=(t+t)*.5;t=+h[o+3648>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,58560,58552,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7304>>3]=+h[e>>3];i=d;return}function EG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3416>>3];m=+h[k+3456>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58600,58592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3416>>3];o=r;p=q}}while(0);l=+h[o+3496>>3];m=+h[o+3504>>3];q=+h[o+3336>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2992>>3];t=+h[o+3352>>3];u=(t+t)*.5;t=+h[o+3464>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,58600,58592,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3440>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7296>>3]=+h[e>>3];i=d;return}function FG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3208>>3];m=+h[k+3248>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,58640,58632,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3208>>3];o=r;p=q}}while(0);l=+h[o+3288>>3];m=+h[o+3296>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3184>>3];t=+h[s+3024>>3];u=(+h[o+384>>3]+ +h[o+392>>3])*.5;v=+h[o+3256>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,58640,58632,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+3232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7288>>3]=+h[e>>3];i=d;return}function GG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=+h[b+584>>3]*+h[b+4552>>3];i=i;return}function HG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=+h[b+576>>3]*+h[b+4552>>3];i=i;return}function IG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=+h[b+464>>3]*+h[b+4328>>3];i=i;return}function JG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=+h[b+456>>3]*+h[b+4328>>3];i=i;return}function KG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=+h[b+344>>3]*+h[b+3184>>3];i=i;return}function LG(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=+h[b+336>>3]*+h[b+3184>>3];i=i;return}function MG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2224>>3]=+h[(c[a+416>>2]|0)+88>>3];i=i;return}function NG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2168>>3]=+h[(c[a+416>>2]|0)+128>>3];i=i;return}function OG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2072>>3]=+h[(c[a+416>>2]|0)+168>>3];i=i;return}function PG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2080>>3]=+h[(c[a+416>>2]|0)+200>>3];i=i;return}function QG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=+h[(c[a+416>>2]|0)+240>>3];i=i;return}function RG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=+h[(c[a+416>>2]|0)+280>>3];i=i;return}function SG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[(c[a+416>>2]|0)+680>>3];i=i;return}function TG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+85|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+85|0]|0;k=b+4|0;l=nFa(+h[c[c[k>>2]>>2]>>3],2500.0,a[(c[b+360>>2]|0)+85|0]|0)|0;a[(c[b+352>>2]|0)+85|0]=l;e=k;f=j;break}else{j=b+4|0;k=nFa(+h[c[c[j>>2]>>2]>>3],2500.0,a[(c[b+360>>2]|0)+85|0]|0)|0;a[(c[b+352>>2]|0)+85|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+85|0]|0;k=b+4|0;j=rFa(+h[c[c[k>>2]>>2]>>3],2500.0)|0;a[(c[b+352>>2]|0)+85|0]=j;e=k;f=g;break}else{g=b+4|0;k=rFa(+h[c[c[g>>2]>>2]>>3],2500.0)|0;a[(c[b+352>>2]|0)+85|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+37|0]=f;i=d;return}function UG(b){b=b|0;a[(c[b+408>>2]|0)+16|0]=1;i=i;return}function VG(b){b=b|0;a[(c[b+408>>2]|0)+15|0]=1;i=i;return}function WG(b){b=b|0;a[(c[b+408>>2]|0)+14|0]=1;i=i;return}function XG(b){b=b|0;a[(c[b+408>>2]|0)+13|0]=1;i=i;return}function YG(b){b=b|0;a[(c[b+408>>2]|0)+11|0]=1;i=i;return}function ZG(b){b=b|0;a[(c[b+408>>2]|0)+8|0]=1;i=i;return}function _G(b){b=b|0;a[(c[b+408>>2]|0)+9|0]=1;i=i;return}function $G(b){b=b|0;a[(c[b+408>>2]|0)+5|0]=1;i=i;return}function aH(b){b=b|0;a[(c[b+408>>2]|0)+3|0]=1;i=i;return}function bH(b){b=b|0;a[(c[b+408>>2]|0)+1|0]=1;i=i;return}function cH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=101325.0;i=i;return}function dH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+8>>3]*1.0e-5;i=i;return}function eH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[d>>3];i=b;return}function fH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=101325.0;i=i;return}function gH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+24>>3]*1.0e-5;i=i;return}function hH(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+704>>3]=(+h[b+592>>3]+ +h[b+600>>3])*(+h[d+8>>3]- +h[d+24>>3])*+h[b+4576>>3]*.5;i=i;return}function iH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4576>>3]*(+h[e+592>>3]+ +h[e+600>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+704>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,58680,58672,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+696|0;q=p;h[q>>3]=n;i=d;return}function jH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+680>>3]=+h[d>>3];i=b;return}function kH(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+4520>>3];i=i;return}function lH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5368>>3]=+h[f>>3];i=b;return}function mH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+8>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+8>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5376>>3]=+h[f>>3];i=b;return}function nH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[c[b+356>>2]|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[c[b+356>>2]|0]|0;g=lFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=g;v=t;break}else{t=lFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=t;v=t;break}}else{if(f){f=a[c[b+356>>2]|0]|0;t=pFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[c[b+352>>2]|0]=t;v=f;break}else{f=pFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[c[b+352>>2]|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+1|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+1|0]|0;m=nFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=m;w=e;break}else{e=nFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+1|0]|0;e=rFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+1|0]=e;w=n;break}else{n=rFa(+h[c[(c[c[q>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+1|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+2|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+2|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+2|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+2|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+2|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;c[E>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;c[E>>2]=y;i=d;return}function oH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+8>>3],+h[k>>3],c[c[a+12>>2]>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+8>>3];m=+h[g>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[f>>3];i=b;return}function pH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[g+760>>3];l=+h[g+8>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,58784,58776,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+656>>3]=j-n;i=d;return}function qH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+872>>3]=+h[b+3376>>3]*+h[b+760>>3];i=i;return}function rH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=+h[b+872>>3]*+h[b+656>>3];i=i;return}function sH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+8>>3],+h[k>>3],c[c[a+12>>2]>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+8>>3];m=+h[g>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+608>>3]=+h[f>>3];i=b;return}function tH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+608>>3]+-273.15;i=i;return}function uH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+760>>3],+h[g+608>>3],+h[g+8>>3],c[c[f+12>>2]>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+736>>3]=+h[d>>3];i=b;return}function vH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+4520>>3];i=i;return}function wH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5216>>3]=+h[f>>3];i=b;return}function xH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+24>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+24>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5224>>3]=+h[f>>3];i=b;return}function _Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_initial_residual$0(b){b=b|0;var d=0,e=0,f=0.0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0;d=c[b+24>>2]|0;e=c[b+32>>2]|0;f=+g[b+1768>>2];j=c[b+1776>>2]|0;l=c[b+2944>>2]|0;m=c[b+2952>>2]|0;n=c[b+2960>>2]|0;o=c[b+2968>>2]|0;p=c[b+2976>>2]|0;q=c[b+2984>>2]|0;r=c[b+2992>>2]|0;s=c[b+3008>>2]|0;t=c[b+3016>>2]|0;u=c[b+3024>>2]|0;v=c[b+3032>>2]|0;w=c[b+3040>>2]|0;x=c[b+3048>>2]|0;y=c[b+3056>>2]|0;z=c[b+3064>>2]|0;A=c[b+3072>>2]|0;B=c[b+3080>>2]|0;C=c[b+3096>>2]|0;D=c[b+3104>>2]|0;E=c[b+3112>>2]|0;F=c[b+3120>>2]|0;G=c[b+3128>>2]|0;H=c[b+3136>>2]|0;I=c[b+3144>>2]|0;J=c[b+3152>>2]|0;K=c[b+3160>>2]|0;L=c[b+3168>>2]|0;M=c[b+3184>>2]|0;N=c[b+3192>>2]|0;O=c[b+3200>>2]|0;P=c[b+3208>>2]|0;Q=c[b+3216>>2]|0;R=c[b+3224>>2]|0;S=c[b+3232>>2]|0;T=c[b+3240>>2]|0;U=c[b+3248>>2]|0;V=c[b+3256>>2]|0;W=c[b+3272>>2]|0;X=c[b+3280>>2]|0;Y=c[b+3288>>2]|0;Z=c[b+3296>>2]|0;_=c[b+3304>>2]|0;$=c[b+3312>>2]|0;aa=c[b+3320>>2]|0;ba=c[b+3328>>2]|0;ca=c[b+3336>>2]|0;da=c[b+3344>>2]|0;ea=c[b+3368>>2]|0;fa=c[b+3376>>2]|0;ga=c[b+3384>>2]|0;ha=c[b+3392>>2]|0;ia=c[b+3400>>2]|0;ja=c[b+3408>>2]|0;ka=c[b+3416>>2]|0;la=c[b+3424>>2]|0;ma=c[b+3432>>2]|0;na=c[b+3440>>2]|0;oa=c[b+3456>>2]|0;pa=c[b+3464>>2]|0;qa=c[b+3472>>2]|0;ra=c[b+3480>>2]|0;sa=c[b+3488>>2]|0;ta=c[b+3496>>2]|0;ua=c[b+3504>>2]|0;va=c[b+3512>>2]|0;a:do{c[l+4>>2]=j;h[k>>3]=f;c[(l+8|0)>>2]=c[k>>2];c[(l+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,l);wa=(a[(c[(d+408|0)>>2]|0)+34|0]|0)==0?0.0:1.0;h[e+432>>3]=wa;xa=sB(54)|0;c[m>>2]=55;c[m+4>>2]=xa;h[k>>3]=wa;c[(m+8|0)>>2]=c[k>>2];c[(m+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,m);wa=(a[(c[(d+408|0)>>2]|0)+32|0]|0)==0?0.0:1.0;h[e+440>>3]=wa;xa=sB(55)|0;c[n>>2]=56;c[n+4>>2]=xa;h[k>>3]=wa;c[(n+8|0)>>2]=c[k>>2];c[(n+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,n);wa=(a[(c[(d+408|0)>>2]|0)+30|0]|0)==0?0.0:1.0;h[e+448>>3]=wa;xa=sB(56)|0;c[o>>2]=57;c[o+4>>2]=xa;h[k>>3]=wa;c[(o+8|0)>>2]=c[k>>2];c[(o+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,o);wa=(a[(c[(d+408|0)>>2]|0)+28|0]|0)==0?0.0:1.0;h[e+456>>3]=wa;xa=sB(57)|0;c[p>>2]=58;c[p+4>>2]=xa;h[k>>3]=wa;c[(p+8|0)>>2]=c[k>>2];c[(p+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,p);wa=(a[(c[(d+408|0)>>2]|0)+26|0]|0)==0?0.0:1.0;h[e+464>>3]=wa;xa=sB(58)|0;c[q>>2]=59;c[q+4>>2]=xa;h[k>>3]=wa;c[(q+8|0)>>2]=c[k>>2];c[(q+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,q);wa=(a[(c[(d+408|0)>>2]|0)+24|0]|0)==0?0.0:1.0;h[e+472>>3]=wa;xa=sB(59)|0;c[r>>2]=60;c[r+4>>2]=xa;h[k>>3]=wa;c[(r+8|0)>>2]=c[k>>2];c[(r+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,r);wa=(a[(c[(d+408|0)>>2]|0)+22|0]|0)==0?0.0:1.0;h[e+480>>3]=wa;xa=sB(60)|0;c[s>>2]=61;c[s+4>>2]=xa;h[k>>3]=wa;c[(s+8|0)>>2]=c[k>>2];c[(s+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,s);wa=(a[(c[(d+408|0)>>2]|0)+20|0]|0)==0?0.0:1.0;h[e+488>>3]=wa;xa=sB(61)|0;c[t>>2]=62;c[t+4>>2]=xa;h[k>>3]=wa;c[(t+8|0)>>2]=c[k>>2];c[(t+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,t);wa=(a[(c[(d+408|0)>>2]|0)+18|0]|0)==0?0.0:1.0;h[e+496>>3]=wa;xa=sB(62)|0;c[u>>2]=63;c[u+4>>2]=xa;h[k>>3]=wa;c[(u+8|0)>>2]=c[k>>2];c[(u+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,u);wa=(a[(c[(d+408|0)>>2]|0)+17|0]|0)==0?0.0:1.0;h[e+504>>3]=wa;xa=sB(63)|0;c[v>>2]=64;c[v+4>>2]=xa;h[k>>3]=wa;c[(v+8|0)>>2]=c[k>>2];c[(v+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,v);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3]- +h[(c[(d+416|0)>>2]|0)+2080>>3];h[e+512>>3]=wa;xa=sB(64)|0;c[w>>2]=65;c[w+4>>2]=xa;h[k>>3]=wa;c[(w+8|0)>>2]=c[k>>2];c[(w+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,w);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]- +h[(c[(d+416|0)>>2]|0)+2096>>3];h[e+520>>3]=wa;xa=sB(65)|0;c[x>>2]=66;c[x+4>>2]=xa;h[k>>3]=wa;c[(x+8|0)>>2]=c[k>>2];c[(x+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,x);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3]- +h[(c[(d+416|0)>>2]|0)+2184>>3];h[e+528>>3]=wa;xa=sB(66)|0;c[y>>2]=67;c[y+4>>2]=xa;h[k>>3]=wa;c[(y+8|0)>>2]=c[k>>2];c[(y+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,y);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]- +h[(c[(d+416|0)>>2]|0)+2248>>3];h[e+536>>3]=wa;xa=sB(67)|0;c[z>>2]=68;c[z+4>>2]=xa;h[k>>3]=wa;c[(z+8|0)>>2]=c[k>>2];c[(z+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,z);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3]- +h[(c[(d+416|0)>>2]|0)+2304>>3];h[e+544>>3]=wa;xa=sB(68)|0;c[A>>2]=69;c[A+4>>2]=xa;h[k>>3]=wa;c[(A+8|0)>>2]=c[k>>2];c[(A+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,A);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]- +h[(c[(d+416|0)>>2]|0)+2368>>3];h[e+552>>3]=wa;xa=sB(69)|0;c[B>>2]=70;c[B+4>>2]=xa;h[k>>3]=wa;c[(B+8|0)>>2]=c[k>>2];c[(B+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,B);xa=!(+h[(c[(d+416|0)>>2]|0)+2480>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2224>>3]);do{if((a[(c[(d+408|0)>>2]|0)+12|0]|0)==0){if(xa){ya=0.0;break}ya=1.0}else{ya=+(xa&1|0)}}while(0);h[e+560>>3]=ya;xa=sB(70)|0;c[C>>2]=71;c[C+4>>2]=xa;h[k>>3]=ya;c[(C+8|0)>>2]=c[k>>2];c[(C+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,C);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+200>>3]- +h[(c[(d+416|0)>>2]|0)+2480>>3];h[e+568>>3]=wa;xa=sB(71)|0;c[D>>2]=72;c[D+4>>2]=xa;h[k>>3]=wa;c[(D+8|0)>>2]=c[k>>2];c[(D+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,D);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3]- +h[(c[(d+416|0)>>2]|0)+2408>>3];h[e+576>>3]=wa;xa=sB(72)|0;c[E>>2]=73;c[E+4>>2]=xa;h[k>>3]=wa;c[(E+8|0)>>2]=c[k>>2];c[(E+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,E);xa=!(+h[(c[(d+416|0)>>2]|0)+2736>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2168>>3]);do{if((a[(c[(d+408|0)>>2]|0)+10|0]|0)==0){if(xa){za=0.0;break}za=1.0}else{za=+(xa&1|0)}}while(0);h[e+584>>3]=za;xa=sB(73)|0;c[F>>2]=74;c[F+4>>2]=xa;h[k>>3]=za;c[(F+8|0)>>2]=c[k>>2];c[(F+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,F);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+184>>3]- +h[(c[(d+416|0)>>2]|0)+2736>>3];h[e+592>>3]=wa;xa=sB(74)|0;c[G>>2]=75;c[G+4>>2]=xa;h[k>>3]=wa;c[(G+8|0)>>2]=c[k>>2];c[(G+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,G);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3]- +h[(c[(d+416|0)>>2]|0)+2664>>3];h[e+600>>3]=wa;xa=sB(75)|0;c[H>>2]=76;c[H+4>>2]=xa;h[k>>3]=wa;c[(H+8|0)>>2]=c[k>>2];c[(H+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,H);xa=!(+h[(c[(d+416|0)>>2]|0)+2848>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2072>>3]);do{if((a[(c[(d+408|0)>>2]|0)+6|0]|0)==0){if(xa){Aa=0.0;break}Aa=1.0}else{Aa=+(xa&1|0)}}while(0);h[e+608>>3]=Aa;xa=sB(76)|0;c[I>>2]=77;c[I+4>>2]=xa;h[k>>3]=Aa;c[(I+8|0)>>2]=c[k>>2];c[(I+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,I);xa=!(+h[(c[(d+416|0)>>2]|0)+2848>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2080>>3]);do{if((a[(c[(d+408|0)>>2]|0)+7|0]|0)==0){if(xa){Ba=0.0;break}Ba=1.0}else{Ba=+(xa&1|0)}}while(0);h[e+616>>3]=Ba;xa=sB(77)|0;c[J>>2]=78;c[J+4>>2]=xa;h[k>>3]=Ba;c[(J+8|0)>>2]=c[k>>2];c[(J+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,J);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3]- +h[(c[(d+416|0)>>2]|0)+2848>>3];h[e+624>>3]=wa;xa=sB(78)|0;c[K>>2]=79;c[K+4>>2]=xa;h[k>>3]=wa;c[(K+8|0)>>2]=c[k>>2];c[(K+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,K);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[(c[(d+416|0)>>2]|0)+2776>>3];h[e+632>>3]=wa;xa=sB(79)|0;c[L>>2]=80;c[L+4>>2]=xa;h[k>>3]=wa;c[(L+8|0)>>2]=c[k>>2];c[(L+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,L);xa=!(+h[(c[(d+416|0)>>2]|0)+2960>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2016>>3]);do{if((a[(c[(d+408|0)>>2]|0)+4|0]|0)==0){if(xa){Ca=0.0;break}Ca=1.0}else{Ca=+(xa&1|0)}}while(0);h[e+640>>3]=Ca;xa=sB(80)|0;c[M>>2]=81;c[M+4>>2]=xa;h[k>>3]=Ca;c[(M+8|0)>>2]=c[k>>2];c[(M+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,M);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+152>>3]- +h[(c[(d+416|0)>>2]|0)+2960>>3];h[e+648>>3]=wa;xa=sB(81)|0;c[N>>2]=82;c[N+4>>2]=xa;h[k>>3]=wa;c[(N+8|0)>>2]=c[k>>2];c[(N+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,N);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3]- +h[(c[(d+416|0)>>2]|0)+2888>>3];h[e+656>>3]=wa;xa=sB(82)|0;c[O>>2]=83;c[O+4>>2]=xa;h[k>>3]=wa;c[(O+8|0)>>2]=c[k>>2];c[(O+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,O);xa=!(+h[(c[(d+416|0)>>2]|0)+3072>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1960>>3]);do{if((a[(c[(d+408|0)>>2]|0)+2|0]|0)==0){if(xa){Da=0.0;break}Da=1.0}else{Da=+(xa&1|0)}}while(0);h[e+664>>3]=Da;xa=sB(83)|0;c[P>>2]=84;c[P+4>>2]=xa;h[k>>3]=Da;c[(P+8|0)>>2]=c[k>>2];c[(P+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,P);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3]- +h[(c[(d+416|0)>>2]|0)+3072>>3];h[e+672>>3]=wa;xa=sB(84)|0;c[Q>>2]=85;c[Q+4>>2]=xa;h[k>>3]=wa;c[(Q+8|0)>>2]=c[k>>2];c[(Q+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Q);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3]- +h[(c[(d+416|0)>>2]|0)+3e3>>3];h[e+680>>3]=wa;xa=sB(85)|0;c[R>>2]=86;c[R+4>>2]=xa;h[k>>3]=wa;c[(R+8|0)>>2]=c[k>>2];c[(R+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,R);xa=!(+h[(c[(d+416|0)>>2]|0)+4776>>3]>=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+560>>3]);do{if((a[c[(d+408|0)>>2]|0]|0)==0){if(xa){Ea=0.0;break}Ea=1.0}else{Ea=+(xa&1|0)}}while(0);h[e+688>>3]=Ea;xa=sB(86)|0;c[S>>2]=87;c[S+4>>2]=xa;h[k>>3]=Ea;c[(S+8|0)>>2]=c[k>>2];c[(S+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,S);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+120>>3]- +h[(c[(d+416|0)>>2]|0)+4776>>3];h[e+696>>3]=wa;xa=sB(87)|0;c[T>>2]=88;c[T+4>>2]=xa;h[k>>3]=wa;c[(T+8|0)>>2]=c[k>>2];c[(T+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,T);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3]- +h[(c[(d+416|0)>>2]|0)+4704>>3];h[e+704>>3]=wa;xa=sB(88)|0;c[U>>2]=89;c[U+4>>2]=xa;h[k>>3]=wa;c[(U+8|0)>>2]=c[k>>2];c[(U+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,U);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3]- +h[(c[(d+416|0)>>2]|0)+4816>>3];h[e+712>>3]=wa;xa=sB(89)|0;c[V>>2]=90;c[V+4>>2]=xa;h[k>>3]=wa;c[(V+8|0)>>2]=c[k>>2];c[(V+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,V);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]- +h[(c[(d+416|0)>>2]|0)+4832>>3];h[e+720>>3]=wa;xa=sB(90)|0;c[W>>2]=91;c[W+4>>2]=xa;h[k>>3]=wa;c[(W+8|0)>>2]=c[k>>2];c[(W+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,W);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3240>>3]+ +h[xa+3264>>3]*-1.0e3;h[e+728>>3]=wa;xa=sB(91)|0;c[X>>2]=92;c[X+4>>2]=xa;h[k>>3]=wa;c[(X+8|0)>>2]=c[k>>2];c[(X+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,X);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3264>>3]- +h[xa+2560>>3];h[e+736>>3]=wa;xa=sB(92)|0;c[Y>>2]=93;c[Y+4>>2]=xa;h[k>>3]=wa;c[(Y+8|0)>>2]=c[k>>2];c[(Y+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Y);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3]- +h[(c[(d+416|0)>>2]|0)+3152>>3];h[e+744>>3]=wa;xa=sB(93)|0;c[Z>>2]=94;c[Z+4>>2]=xa;h[k>>3]=wa;c[(Z+8|0)>>2]=c[k>>2];c[(Z+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,Z);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3]- +h[(c[(d+416|0)>>2]|0)+3152>>3];h[e+752>>3]=wa;xa=sB(94)|0;c[_>>2]=95;c[_+4>>2]=xa;h[k>>3]=wa;c[(_+8|0)>>2]=c[k>>2];c[(_+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,_);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]+-101325.0;h[e+760>>3]=wa;xa=sB(95)|0;c[$>>2]=96;c[$+4>>2]=xa;h[k>>3]=wa;c[($+8|0)>>2]=c[k>>2];c[($+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,$);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]+-101325.0;h[e+768>>3]=wa;xa=sB(96)|0;c[aa>>2]=97;c[aa+4>>2]=xa;h[k>>3]=wa;c[(aa+8|0)>>2]=c[k>>2];c[(aa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,aa);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3448>>3]+ +h[xa+3472>>3]*-1.0e3;h[e+776>>3]=wa;xa=sB(97)|0;c[ba>>2]=98;c[ba+4>>2]=xa;h[k>>3]=wa;c[(ba+8|0)>>2]=c[k>>2];c[(ba+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ba);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3472>>3]- +h[xa+2560>>3];h[e+784>>3]=wa;xa=sB(98)|0;c[ca>>2]=99;c[ca+4>>2]=xa;h[k>>3]=wa;c[(ca+8|0)>>2]=c[k>>2];c[(ca+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ca);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3632>>3]+ +h[xa+3656>>3]*-1.0e3;h[e+792>>3]=wa;xa=sB(99)|0;c[da>>2]=100;c[da+4>>2]=xa;h[k>>3]=wa;c[(da+8|0)>>2]=c[k>>2];c[(da+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,da);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3656>>3]- +h[xa+2560>>3];h[e+800>>3]=wa;xa=sB(100)|0;c[ea>>2]=101;c[ea+4>>2]=xa;h[k>>3]=wa;c[(ea+8|0)>>2]=c[k>>2];c[(ea+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ea);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3816>>3]+ +h[xa+3840>>3]*-1.0e3;h[e+808>>3]=wa;xa=sB(101)|0;c[fa>>2]=102;c[fa+4>>2]=xa;h[k>>3]=wa;c[(fa+8|0)>>2]=c[k>>2];c[(fa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,fa);xa=c[(d+416|0)>>2]|0;wa=+h[xa+3840>>3]- +h[xa+2560>>3];h[e+816>>3]=wa;xa=sB(102)|0;c[ga>>2]=103;c[ga+4>>2]=xa;h[k>>3]=wa;c[(ga+8|0)>>2]=c[k>>2];c[(ga+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ga);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4e3>>3]+ +h[xa+4024>>3]*-1.0e3;h[e+824>>3]=wa;xa=sB(103)|0;c[ha>>2]=104;c[ha+4>>2]=xa;h[k>>3]=wa;c[(ha+8|0)>>2]=c[k>>2];c[(ha+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ha);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4024>>3]- +h[xa+2560>>3];h[e+832>>3]=wa;xa=sB(104)|0;c[ia>>2]=105;c[ia+4>>2]=xa;h[k>>3]=wa;c[(ia+8|0)>>2]=c[k>>2];c[(ia+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ia);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4184>>3]+ +h[xa+4208>>3]*-1.0e3;h[e+840>>3]=wa;xa=sB(105)|0;c[ja>>2]=106;c[ja+4>>2]=xa;h[k>>3]=wa;c[(ja+8|0)>>2]=c[k>>2];c[(ja+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ja);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4208>>3]- +h[xa+2560>>3];h[e+848>>3]=wa;xa=sB(106)|0;c[ka>>2]=107;c[ka+4>>2]=xa;h[k>>3]=wa;c[(ka+8|0)>>2]=c[k>>2];c[(ka+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ka);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4384>>3]+ +h[xa+4408>>3]*-1.0e3;h[e+856>>3]=wa;xa=sB(107)|0;c[la>>2]=108;c[la+4>>2]=xa;h[k>>3]=wa;c[(la+8|0)>>2]=c[k>>2];c[(la+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,la);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4408>>3]- +h[xa+2560>>3];h[e+864>>3]=wa;xa=sB(108)|0;c[ma>>2]=109;c[ma+4>>2]=xa;h[k>>3]=wa;c[(ma+8|0)>>2]=c[k>>2];c[(ma+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ma);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]- +h[(c[(d+416|0)>>2]|0)+4296>>3];h[e+872>>3]=wa;xa=sB(109)|0;c[na>>2]=110;c[na+4>>2]=xa;h[k>>3]=wa;c[(na+8|0)>>2]=c[k>>2];c[(na+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,na);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3]- +h[(c[(d+416|0)>>2]|0)+4296>>3];h[e+880>>3]=wa;xa=sB(110)|0;c[oa>>2]=111;c[oa+4>>2]=xa;h[k>>3]=wa;c[(oa+8|0)>>2]=c[k>>2];c[(oa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,oa);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]+-101325.0;h[e+888>>3]=wa;xa=sB(111)|0;c[pa>>2]=112;c[pa+4>>2]=xa;h[k>>3]=wa;c[(pa+8|0)>>2]=c[k>>2];c[(pa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,pa);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]+-101325.0;h[e+896>>3]=wa;xa=sB(112)|0;c[qa>>2]=113;c[qa+4>>2]=xa;h[k>>3]=wa;c[(qa+8|0)>>2]=c[k>>2];c[(qa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,qa);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4608>>3]+ +h[xa+4632>>3]*-1.0e3;h[e+904>>3]=wa;xa=sB(113)|0;c[ra>>2]=114;c[ra+4>>2]=xa;h[k>>3]=wa;c[(ra+8|0)>>2]=c[k>>2];c[(ra+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ra);xa=c[(d+416|0)>>2]|0;wa=+h[xa+4632>>3]- +h[xa+2560>>3];h[e+912>>3]=wa;xa=sB(114)|0;c[sa>>2]=115;c[sa+4>>2]=xa;h[k>>3]=wa;c[(sa+8|0)>>2]=c[k>>2];c[(sa+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,sa);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[(c[(d+416|0)>>2]|0)+4520>>3];h[e+920>>3]=wa;xa=sB(115)|0;c[ta>>2]=116;c[ta+4>>2]=xa;h[k>>3]=wa;c[(ta+8|0)>>2]=c[k>>2];c[(ta+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ta);wa=+h[c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]>>3]- +h[(c[(d+416|0)>>2]|0)+4520>>3];h[e+928>>3]=wa;xa=sB(116)|0;c[ua>>2]=117;c[ua+4>>2]=xa;h[k>>3]=wa;c[(ua+8|0)>>2]=c[k>>2];c[(ua+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,ua);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]+-101325.0;h[e+936>>3]=wa;xa=sB(117)|0;c[va>>2]=118;c[va+4>>2]=xa;h[k>>3]=wa;c[(va+8|0)>>2]=c[k>>2];c[(va+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,va);wa=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]+-101325.0;h[e+944>>3]=wa;xa=sB(118)|0;c[b>>2]=119;c[b+4>>2]=xa;h[k>>3]=wa;c[(b+8|0)>>2]=c[k>>2];c[(b+8|0)+4>>2]=c[k+4>>2];MBa(21,0,57984,b);if((c[241692>>2]|0)==0){i=b;c[b+3568>>2]=6;c[b+3572>>2]=0;break a}je[c[60540]&1023](21);i=b;c[b+3568>>2]=6;c[b+3572>>2]=0;break a}while(0)}



function wu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;PCa(ag,1,$f);if(!(d>0.0)){$f=ACa(ACa(11696,yCa(d,0,1,6)|0)|0,11760)|0;bg=c[72852]|0;cg=f+96|0;c[cg+0>>2]=c[11776+0>>2];c[cg+4>>2]=c[11776+4>>2];c[cg+8>>2]=c[11776+8>>2];c[cg+12>>2]=c[11776+12>>2];c[cg+16>>2]=c[11776+16>>2];c[cg+20>>2]=c[11776+20>>2];Ne[bg&127](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=ACa(ACa(11800,yCa(d,0,1,6)|0)|0,11848)|0;$f=c[72852]|0;bg=f+72|0;c[bg+0>>2]=c[11880+0>>2];c[bg+4>>2]=c[11880+4>>2];c[bg+8>>2]=c[11880+8>>2];c[bg+12>>2]=c[11880+12>>2];c[bg+16>>2]=c[11880+16>>2];c[bg+20>>2]=c[11880+20>>2];Ne[$f&127](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=ACa(ACa(11904,yCa(e,0,1,6)|0)|0,11952)|0;_f=c[72852]|0;$f=f+48|0;c[$f+0>>2]=c[11984+0>>2];c[$f+4>>2]=c[11984+4>>2];c[$f+8>>2]=c[11984+8>>2];c[$f+12>>2]=c[11984+12>>2];c[$f+16>>2]=c[11984+16>>2];c[$f+20>>2]=c[11984+20>>2];Ne[_f&127](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=ACa(ACa(12008,yCa(e,0,1,6)|0)|0,12064)|0;Zf=c[72852]|0;_f=f+24|0;c[_f+0>>2]=c[12112+0>>2];c[_f+4>>2]=c[12112+4>>2];c[_f+8>>2]=c[12112+8>>2];c[_f+12>>2]=c[12112+12>>2];c[_f+16>>2]=c[12112+16>>2];c[_f+20>>2]=c[12112+20>>2];Ne[Zf&127](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(XCa(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(XCa(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(XCa(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(XCa(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(XCa(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(XCa(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(XCa(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(XCa(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(XCa(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(XCa(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(XCa(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(XCa(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(XCa(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(XCa(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(XCa(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(XCa(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(XCa(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(XCa(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(XCa(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(XCa(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(XCa(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(XCa(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(XCa(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(XCa(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(XCa(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(XCa(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(XCa(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(XCa(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(XCa(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(XCa(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(XCa(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(XCa(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(XCa(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(XCa(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(XCa(ag,1,of)|0)>>3];c[nf>>2]=16;h[(XCa(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(XCa(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(XCa(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(XCa(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(XCa(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(XCa(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(XCa(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(XCa(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(XCa(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(XCa(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(XCa(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(XCa(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(XCa(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(XCa(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(XCa(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(XCa(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(XCa(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(XCa(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(XCa(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(XCa(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(XCa(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(XCa(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(XCa(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(XCa(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(XCa(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(XCa(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(XCa(ag,1,Oe)|0)>>3];c[Me>>2]=12;gg=+h[(XCa(ag,1,Me)|0)>>3];c[Le>>2]=25;eg=fg*gg*dg*+h[(XCa(ag,1,Le)|0)>>3];c[Ke>>2]=26;h[(XCa(ag,1,Ke)|0)>>3]=eg;c[Je>>2]=10;eg=+h[(XCa(ag,1,Je)|0)>>3];c[Ie>>2]=12;gg=eg*+h[(XCa(ag,1,Ie)|0)>>3];c[He>>2]=27;h[(XCa(ag,1,He)|0)>>3]=gg;c[Ge>>2]=1;gg=+h[(XCa(ag,1,Ge)|0)>>3];c[Fe>>2]=10;eg=+h[(XCa(ag,1,Fe)|0)>>3];c[Ee>>2]=11;fg=gg*eg*dg*+h[(XCa(ag,1,Ee)|0)>>3];c[De>>2]=28;h[(XCa(ag,1,De)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(XCa(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(XCa(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(XCa(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(XCa(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(XCa(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(XCa(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(XCa(ag,1,we)|0)>>3];c[ve>>2]=30;h[(XCa(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(XCa(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(XCa(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(XCa(ag,1,se)|0)>>3];c[re>>2]=31;h[(XCa(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(XCa(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(XCa(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(XCa(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(XCa(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(XCa(ag,1,me)|0)>>3];c[le>>2]=34;h[(XCa(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(XCa(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(XCa(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(XCa(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(XCa(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(XCa(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(XCa(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(XCa(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(XCa(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(XCa(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(XCa(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(XCa(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(XCa(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(XCa(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(XCa(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(XCa(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(XCa(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(XCa(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(XCa(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(XCa(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(XCa(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(XCa(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(XCa(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(XCa(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(XCa(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(XCa(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(XCa(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(XCa(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(XCa(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(XCa(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(XCa(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(XCa(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(XCa(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(XCa(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(XCa(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(XCa(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(XCa(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(XCa(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function xu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,De=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;PCa(we,1,ve);if(!(d>611.657)){ve=ACa(ACa(12192,yCa(d,0,1,6)|0)|0,12256)|0;xe=ACa(ACa(ve,yCa(611.657,0,1,6)|0)|0,12264)|0;ve=c[72852]|0;ye=k;ze=12296;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];Ne[ve&127](b,k,xe,ue);}if(!(d<=1.0e8)){ue=ACa(ACa(12320,yCa(d,0,1,6)|0)|0,11848)|0;xe=c[72852]|0;k=j;ve=12368;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];Ne[xe&127](b,j,ue,te);}if(!(e>=273.15)){te=ACa(ACa(12392,yCa(e,0,1,6)|0)|0,11952)|0;ue=c[72852]|0;j=g;xe=12440;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];Ne[ue&127](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;De=Be+-1.222;c[re>>2]=1;h[(XCa(we,1,re)|0)>>3]=De*De;c[qe>>2]=1;Ee=+h[(XCa(we,1,qe)|0)>>3];c[pe>>2]=2;h[(XCa(we,1,pe)|0)>>3]=Ee*Ee;c[oe>>2]=2;Ee=+h[(XCa(we,1,oe)|0)>>3];c[ne>>2]=3;h[(XCa(we,1,ne)|0)>>3]=Ee*Ee;c[me>>2]=3;Ee=De*+h[(XCa(we,1,me)|0)>>3];c[le>>2]=4;h[(XCa(we,1,le)|0)>>3]=Ee;c[ke>>2]=4;Ee=1.0/+h[(XCa(we,1,ke)|0)>>3];c[je>>2]=5;h[(XCa(we,1,je)|0)>>3]=Ee;c[ie>>2]=1;Ee=+h[(XCa(we,1,ie)|0)>>3];c[he>>2]=2;Fe=Ee*+h[(XCa(we,1,he)|0)>>3];c[ge>>2]=6;h[(XCa(we,1,ge)|0)>>3]=Fe;c[fe>>2]=1;Fe=De*+h[(XCa(we,1,fe)|0)>>3];c[ee>>2]=7;h[(XCa(we,1,ee)|0)>>3]=Fe;c[de>>2]=7;Fe=1.0/+h[(XCa(we,1,de)|0)>>3];c[ce>>2]=8;h[(XCa(we,1,ce)|0)>>3]=Fe;c[be>>2]=1;Fe=+h[(XCa(we,1,be)|0)>>3];c[ae>>2]=2;Ee=+h[(XCa(we,1,ae)|0)>>3];c[$d>>2]=3;Ge=Fe*Ee*+h[(XCa(we,1,$d)|0)>>3];c[_d>>2]=9;h[(XCa(we,1,_d)|0)>>3]=Ge;c[Zd>>2]=2;Ge=1.0/+h[(XCa(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(XCa(we,1,Yd)|0)>>3]=Ge;c[Xd>>2]=2;Ge=De*+h[(XCa(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(XCa(we,1,Wd)|0)>>3]=Ge;c[Vd>>2]=11;Ge=1.0/+h[(XCa(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(XCa(we,1,Ud)|0)>>3]=Ge;c[Td>>2]=2;Ge=+h[(XCa(we,1,Td)|0)>>3];c[Sd>>2]=3;Ee=Ge*+h[(XCa(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(XCa(we,1,Rd)|0)>>3]=Ee;c[Qd>>2]=3;Ee=1.0/+h[(XCa(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(XCa(we,1,Pd)|0)>>3]=Ee;c[Od>>2]=15;h[(XCa(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Ee=Ce*+h[(XCa(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(XCa(we,1,Md)|0)>>3]=Ee;c[Ld>>2]=15;Ee=+h[(XCa(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(XCa(we,1,Kd)|0)>>3]=Ee*Ee;c[Jd>>2]=17;Ee=+h[(XCa(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(XCa(we,1,Id)|0)>>3]=Ee*Ee;c[Hd>>2]=17;Ee=+h[(XCa(we,1,Hd)|0)>>3];c[Gd>>2]=18;Ge=Ee*Ce*+h[(XCa(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(XCa(we,1,Fd)|0)>>3]=Ge;c[Ed>>2]=15;Ge=+h[(XCa(we,1,Ed)|0)>>3];c[Dd>>2]=17;Ee=Ge*+h[(XCa(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(XCa(we,1,Cd)|0)>>3]=Ee;c[Bd>>2]=3;Ee=+h[(XCa(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(XCa(we,1,Ad)|0)>>3]=Ee*Ee;c[zd>>2]=21;Ee=+h[(XCa(we,1,zd)|0)>>3];c[yd>>2]=22;h[(XCa(we,1,yd)|0)>>3]=Ee*Ee;c[xd>>2]=22;Ee=+h[(XCa(we,1,xd)|0)>>3];c[wd>>2]=3;Ge=Ee*De*+h[(XCa(we,1,wd)|0)>>3];c[vd>>2]=23;h[(XCa(we,1,vd)|0)>>3]=Ge;c[ud>>2]=23;Ge=1.0/+h[(XCa(we,1,ud)|0)>>3];c[td>>2]=24;h[(XCa(we,1,td)|0)>>3]=Ge;c[sd>>2]=22;Ge=+h[(XCa(we,1,sd)|0)>>3];c[rd>>2]=3;Ee=Ge*+h[(XCa(we,1,rd)|0)>>3];c[qd>>2]=25;h[(XCa(we,1,qd)|0)>>3]=Ee;c[pd>>2]=25;Ee=1.0/+h[(XCa(we,1,pd)|0)>>3];c[od>>2]=26;h[(XCa(we,1,od)|0)>>3]=Ee;c[nd>>2]=1;Ee=+h[(XCa(we,1,nd)|0)>>3];c[md>>2]=2;Ge=+h[(XCa(we,1,md)|0)>>3];c[ld>>2]=22;Fe=Ee*Ge*De*+h[(XCa(we,1,ld)|0)>>3];c[kd>>2]=27;h[(XCa(we,1,kd)|0)>>3]=Fe;c[jd>>2]=27;Fe=1.0/+h[(XCa(we,1,jd)|0)>>3];c[id>>2]=28;h[(XCa(we,1,id)|0)>>3]=Fe;c[hd>>2]=1;Fe=+h[(XCa(we,1,hd)|0)>>3];c[gd>>2]=2;Ge=+h[(XCa(we,1,gd)|0)>>3];c[fd>>2]=22;Ee=Fe*Ge*+h[(XCa(we,1,fd)|0)>>3];c[ed>>2]=29;h[(XCa(we,1,ed)|0)>>3]=Ee;c[dd>>2]=29;Ee=1.0/+h[(XCa(we,1,dd)|0)>>3];c[cd>>2]=30;h[(XCa(we,1,cd)|0)>>3]=Ee;c[bd>>2]=1;Ee=+h[(XCa(we,1,bd)|0)>>3];c[ad>>2]=2;Ge=+h[(XCa(we,1,ad)|0)>>3];c[$c>>2]=21;Fe=+h[(XCa(we,1,$c)|0)>>3];c[_c>>2]=3;He=Ee*Ge*Fe*De*+h[(XCa(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(XCa(we,1,Zc)|0)>>3]=He;c[Yc>>2]=31;He=1.0/+h[(XCa(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(XCa(we,1,Xc)|0)>>3]=He;c[Wc>>2]=2;He=+h[(XCa(we,1,Wc)|0)>>3];c[Vc>>2]=21;Fe=+h[(XCa(we,1,Vc)|0)>>3];c[Uc>>2]=3;Ge=He*Fe*De*+h[(XCa(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(XCa(we,1,Tc)|0)>>3]=Ge;c[Sc>>2]=33;Ge=1.0/+h[(XCa(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(XCa(we,1,Rc)|0)>>3]=Ge;c[Qc>>2]=1;Ge=+h[(XCa(we,1,Qc)|0)>>3];c[Pc>>2]=3;Fe=Ge*De*+h[(XCa(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(XCa(we,1,Oc)|0)>>3]=Fe;c[Nc>>2]=35;Fe=1.0/+h[(XCa(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(XCa(we,1,Mc)|0)>>3]=Fe;c[Lc>>2]=1;Fe=+h[(XCa(we,1,Lc)|0)>>3];c[Kc>>2]=3;Ge=Fe*+h[(XCa(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(XCa(we,1,Jc)|0)>>3]=Ge;c[Ic>>2]=37;Ge=1.0/+h[(XCa(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(XCa(we,1,Hc)|0)>>3]=Ge;c[Gc>>2]=6;Ge=1.0/+h[(XCa(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(XCa(we,1,Fc)|0)>>3]=Ge;c[Ec>>2]=1;Ge=+h[(XCa(we,1,Ec)|0)>>3];c[Dc>>2]=22;Fe=+h[(XCa(we,1,Dc)|0)>>3];c[Cc>>2]=3;He=Ge*Fe*+h[(XCa(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(XCa(we,1,Bc)|0)>>3]=He;c[Ac>>2]=40;He=1.0/+h[(XCa(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(XCa(we,1,zc)|0)>>3]=He;c[yc>>2]=22;He=1.0/+h[(XCa(we,1,yc)|0)>>3];c[xc>>2]=42;h[(XCa(we,1,xc)|0)>>3]=He;c[wc>>2]=1;He=+h[(XCa(we,1,wc)|0)>>3];c[vc>>2]=2;Fe=+h[(XCa(we,1,vc)|0)>>3];c[uc>>2]=21;Ge=+h[(XCa(we,1,uc)|0)>>3];c[tc>>2]=3;Ee=He*Fe*Ge*+h[(XCa(we,1,tc)|0)>>3];c[sc>>2]=43;h[(XCa(we,1,sc)|0)>>3]=Ee;c[rc>>2]=43;Ee=1.0/+h[(XCa(we,1,rc)|0)>>3];c[qc>>2]=44;h[(XCa(we,1,qc)|0)>>3]=Ee;c[pc>>2]=13;Ee=1.0/+h[(XCa(we,1,pc)|0)>>3];c[oc>>2]=45;h[(XCa(we,1,oc)|0)>>3]=Ee;c[nc>>2]=10;Ee=+h[(XCa(we,1,nc)|0)>>3];c[mc>>2]=2;Ge=+h[(XCa(we,1,mc)|0)>>3];c[lc>>2]=6;Fe=Ee*(Ge*(+h[(XCa(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;Ge=+h[(XCa(we,1,kc)|0)>>3];c[jc>>2]=13;Ee=+h[(XCa(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;He=Ge*(Ee*+h[(XCa(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Ee=+h[(XCa(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;Ge=+h[(XCa(we,1,gc)|0)>>3];c[fc>>2]=11;Ie=+h[(XCa(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Je=Ie*+h[(XCa(we,1,ec)|0)>>3];c[dc>>2]=19;Ie=+h[(XCa(we,1,dc)|0)>>3];c[cc>>2]=34;Ke=+h[(XCa(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Le=+h[(XCa(we,1,bc)|0)>>3];c[ac>>2]=32;Me=+h[(XCa(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(XCa(we,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(XCa(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(XCa(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(XCa(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Fe+Ce*(He+Ce*(Ee+Ge*(Je+Ie*(Ke+Le*(Me+Oe*(Pe+Ce*(Qe+Ce*(Re+Ce*+h[(XCa(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(XCa(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(XCa(we,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(XCa(we,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=Ce*(Re*(Qe*(De*(Pe*(+h[(XCa(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(XCa(we,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(XCa(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(XCa(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Oe+Se*(Pe*(Qe*(De*(De*(+h[(XCa(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(De*(De*(De*(De*(De*(De*(De*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(XCa(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(XCa(we,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(XCa(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(XCa(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(XCa(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(XCa(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(XCa(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(XCa(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(XCa(we,1,Gb)|0)>>3];c[Fb>>2]=11;Me=+h[(XCa(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Le=Me*+h[(XCa(we,1,Eb)|0)>>3];c[Db>>2]=19;Me=+h[(XCa(we,1,Db)|0)>>3];c[Cb>>2]=34;Ke=+h[(XCa(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Ie=+h[(XCa(we,1,Bb)|0)>>3];c[Ab>>2]=32;Je=+h[(XCa(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;Ge=+h[(XCa(we,1,zb)|0)>>3];c[yb>>2]=30;Ee=+h[(XCa(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;He=+h[(XCa(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Fe=+h[(XCa(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Oe+Ce*(Re+Pe*(Le+Me*(Ke+Ie*(Je+Ge*(Ee+Ce*(He+Ce*(Fe+Ce*+h[(XCa(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Fe=+h[(XCa(we,1,ub)|0)>>3];c[tb>>2]=7;He=+h[(XCa(we,1,tb)|0)>>3];c[sb>>2]=1;Ee=+h[(XCa(we,1,sb)|0)>>3];c[rb>>2]=9;Ge=Ce*(Fe*(He*(De*(Ee*(+h[(XCa(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(XCa(we,1,qb)|0)>>3];c[pb>>2]=1;Ee=+h[(XCa(we,1,pb)|0)>>3];c[ob>>2]=6;He=+h[(XCa(we,1,ob)|0)>>3];c[nb>>2]=1;Fe=Ge+Te*(Ee*(He*(De*(De*(+h[(XCa(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;He=+h[(XCa(we,1,mb)|0)>>3];c[lb>>2]=2;Ee=+h[(XCa(we,1,lb)|0)>>3];c[kb>>2]=6;Te=He*(Ee*(+h[(XCa(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Ee=+h[(XCa(we,1,jb)|0)>>3];c[ib>>2]=13;He=+h[(XCa(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;Ge=Ee*(He*+h[(XCa(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;He=+h[(XCa(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Ee=+h[(XCa(we,1,fb)|0)>>3];c[eb>>2]=11;Je=+h[(XCa(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Ie=Je*+h[(XCa(we,1,db)|0)>>3];c[cb>>2]=19;Je=+h[(XCa(we,1,cb)|0)>>3];c[bb>>2]=34;Ke=+h[(XCa(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Me=+h[(XCa(we,1,ab)|0)>>3];c[$a>>2]=32;Le=+h[(XCa(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(XCa(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(XCa(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(XCa(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(XCa(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(Ge+Ce*(He+Ee*(Ie+Je*(Ke+Me*(Le+Pe*(Re+Ce*(Oe+Ce*(Se+Ce*+h[(XCa(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(XCa(we,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(XCa(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(XCa(we,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(De*(Re*(+h[(XCa(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(XCa(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(XCa(we,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(XCa(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(XCa(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(XCa(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(XCa(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(XCa(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(XCa(we,1,Ka)|0)>>3];c[Ja>>2]=9;Le=Se*(Re*(Ue*(+h[(XCa(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(XCa(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(XCa(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(XCa(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(XCa(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Me=Ue*(Se*+h[(XCa(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(XCa(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(XCa(we,1,Ca)|0)>>3];c[Ba>>2]=11;Ke=+h[(XCa(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Je=Ke*+h[(XCa(we,1,Aa)|0)>>3];c[za>>2]=19;Ke=+h[(XCa(we,1,za)|0)>>3];c[ya>>2]=44;Ie=+h[(XCa(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Ee=+h[(XCa(we,1,xa)|0)>>3];c[wa>>2]=42;He=+h[(XCa(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;Ge=+h[(XCa(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(XCa(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(XCa(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(XCa(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Oe+Ce*(Le+Ce*(Re+Ce*(Me+Ce*(Se+Ue*(Je+Ke*(Ie+Ee*(He+Ge*(Te+Ce*(Ve+Ce*(We+Ce*+h[(XCa(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(XCa(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(De*((De*(De*(De*(De*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(XCa(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(XCa(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(XCa(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(XCa(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;Ge=Xe*(We*(Te*+h[(XCa(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(XCa(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(XCa(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(XCa(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(XCa(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(XCa(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(XCa(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;He=+h[(XCa(we,1,ea)|0)>>3];c[da>>2]=19;Ee=+h[(XCa(we,1,da)|0)>>3];c[ca>>2]=32;Ie=+h[(XCa(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Ke=+h[(XCa(we,1,ba)|0)>>3];c[aa>>2]=20;Je=+h[(XCa(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(XCa(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(XCa(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Me=+h[(XCa(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(XCa(we,1,Y)|0)>>3];c[X>>2]=22;Le=Re*+h[(XCa(we,1,X)|0)>>3];c[W>>2]=3;Re=Je*(Ue+Ce*(Se+Ce*(Me+Ce/(De*Le*+h[(XCa(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Le=Ee*(Ie+Ke*(1.43624813658928e-17/(De*+h[(XCa(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(XCa(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Ke=+h[(XCa(we,1,T)|0)>>3];c[S>>2]=3;Ie=Ce*(We+He*(Re/(De*Ke*+h[(XCa(we,1,S)|0)>>3])+Le));c[R>>2]=13;Le=+h[(XCa(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Ke=Le*+h[(XCa(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Le=+h[(XCa(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(Ge+Ce*(Xe+Ce*(Te+Ce*(Ie+Ke/(De*Le*+h[(XCa(we,1,O)|0)>>3])))));c[N>>2]=10;Le=+h[(XCa(we,1,N)|0)>>3];c[M>>2]=7;Ke=Re+Le*(De*((De*(De*(De*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(XCa(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;De=+h[(XCa(we,1,L)|0)>>3];c[K>>2]=1;Le=+h[(XCa(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(XCa(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Ie=Re*+h[(XCa(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=De*(Le*(Ie*+h[(XCa(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Ie=+h[(XCa(we,1,G)|0)>>3];c[F>>2]=2;Le=+h[(XCa(we,1,F)|0)>>3];c[E>>2]=1;De=+h[(XCa(we,1,E)|0)>>3];c[D>>2]=9;Te=Ie*(Le*(De*(+h[(XCa(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;De=+h[(XCa(we,1,C)|0)>>3];c[B>>2]=37;Le=De*(+h[(XCa(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;De=+h[(XCa(we,1,A)|0)>>3];c[z>>2]=13;Ie=+h[(XCa(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=De*(Ie*+h[(XCa(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Ie=+h[(XCa(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;De=+h[(XCa(we,1,w)|0)>>3];c[v>>2]=11;Ge=+h[(XCa(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;He=Ge*+h[(XCa(we,1,u)|0)>>3];c[t>>2]=19;Ge=+h[(XCa(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(XCa(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Ee=+h[(XCa(we,1,r)|0)>>3];c[q>>2]=42;Me=+h[(XCa(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(XCa(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(XCa(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Je=+h[(XCa(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(XCa(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Le+Ce*(Xe+Ce*(Ie+De*(He+Ge*(We+Ee*(Me+Se*(Ue+Ce*(Je+Ce*(Oe+Ce*+h[(XCa(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Fe;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Ke;h[a+80>>3]=Ye;i=f;return}function yu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;PCa(ia,1,ha);if(!(d>0.0)){ha=ACa(ACa(12464,yCa(d,0,1,6)|0)|0,11760)|0;ja=c[72852]|0;ka=m;la=12528;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Ne[ja&127](b,m,ha,ga);}if(!(d<=1.0e7)){ga=ACa(ACa(12552,yCa(d,0,1,6)|0)|0,12600)|0;ha=c[72852]|0;m=l;ja=12640;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];Ne[ha&127](b,l,ga,fa);}if(!(e<=2273.15)){fa=ACa(ACa(12664,yCa(e,0,1,6)|0)|0,12712)|0;ga=c[72852]|0;l=j;ha=12768;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];Ne[ga&127](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(XCa(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(XCa(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(XCa(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(XCa(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(XCa(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(XCa(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(XCa(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(XCa(ia,1,X)|0)>>3];c[W>>2]=5;h[(XCa(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(XCa(ia,1,V)|0)>>3];c[U>>2]=6;h[(XCa(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(XCa(ia,1,T)|0)>>3];c[S>>2]=7;h[(XCa(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(XCa(ia,1,R)|0)>>3];c[Q>>2]=8;h[(XCa(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(XCa(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(XCa(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(XCa(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(XCa(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(XCa(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[72852]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=12792;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];Ne[M&127](b,g,12136,K);}c[J>>2]=4;oa=+h[(XCa(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(XCa(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(XCa(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(XCa(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(XCa(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(XCa(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(XCa(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(XCa(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(XCa(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(XCa(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(XCa(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(XCa(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(XCa(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(XCa(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(XCa(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(XCa(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(XCa(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(XCa(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(XCa(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(XCa(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(XCa(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(XCa(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(XCa(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function zu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0.0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=4;PCa(f,1,e);g=d/1.0e6;d=g*g;h[a>>3]=(g*3.74696550136983+(d*-.0219921901054187+g*d*87513168600995.0e-18)+2014.64004206875)*1.0e3;i=b;return}function Au(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;PCa(ia,1,ha);if(!(d>611.657)){ha=ACa(ACa(12816,yCa(d,0,1,6)|0)|0,12256)|0;ja=ACa(ACa(ha,yCa(611.657,0,1,6)|0)|0,12264)|0;ha=c[72852]|0;ka=f;la=12880;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Ne[ha&127](b,f,ja,ga);}ma=+wd(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(XCa(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(XCa(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(XCa(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(XCa(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(XCa(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(XCa(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(XCa(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(XCa(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(XCa(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(XCa(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(XCa(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(XCa(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(XCa(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(XCa(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(XCa(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(XCa(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(XCa(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(XCa(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(XCa(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(XCa(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(XCa(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(XCa(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(XCa(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(XCa(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(XCa(ia,1,H)|0)>>3];c[G>>2]=12;h[(XCa(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(XCa(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(XCa(ia,1,E)|0)>>3];c[D>>2]=13;h[(XCa(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(XCa(ia,1,C)|0)>>3]));c[B>>2]=14;h[(XCa(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(XCa(ia,1,A)|0)>>3];c[z>>2]=15;h[(XCa(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(XCa(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(XCa(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(XCa(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(XCa(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(XCa(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(XCa(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(XCa(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(XCa(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(XCa(ia,1,q)|0)>>3];c[p>>2]=19;h[(XCa(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(XCa(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(XCa(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(XCa(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(XCa(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(XCa(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(XCa(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(XCa(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function Bu(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Cu(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*-.0001152032945617821+-.717981855497894)+3.558919744656498)+-6.75820241066552)+6.679385472887931)+-3.889388153209752)+1.346800016564904)+-.4945586958175176)+1.0)*2087546.84511715;i=i;return}function Du(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;c[v>>2]=3;PCa(w,1,v);if(!(d>611.657)){v=ACa(ACa(12904,yCa(d,0,1,6)|0)|0,12256)|0;x=ACa(ACa(v,yCa(611.657,0,1,6)|0)|0,12264)|0;v=c[72852]|0;y=g;z=12968;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Ne[v&127](b,g,x,u);}A=d/1.0e6;d=e/25.0e5+1.0;c[t>>2]=1;h[(XCa(w,1,t)|0)>>3]=d*d;c[s>>2]=1;e=+h[(XCa(w,1,s)|0)>>3];c[r>>2]=2;h[(XCa(w,1,r)|0)>>3]=e*e;c[q>>2]=2;e=+h[(XCa(w,1,q)|0)>>3];c[p>>2]=3;h[(XCa(w,1,p)|0)>>3]=e*e;c[o>>2]=1;e=+h[(XCa(w,1,o)|0)>>3];c[n>>2]=2;B=+h[(XCa(w,1,n)|0)>>3];c[m>>2]=2;C=+h[(XCa(w,1,m)|0)>>3];c[l>>2]=3;D=+h[(XCa(w,1,l)|0)>>3];c[k>>2]=1;E=+h[(XCa(w,1,k)|0)>>3];c[j>>2]=3;h[a>>3]=A*-13.391744872602+d*(A*43.211039183559+d*(A*-54.010067170506+d*(A*30.535892203916+d*(A*-6.5964749423638+e*(B*(A*(A*(A*6.6456186191635e-8+-25858641282073.0e-18)+.0093965400878363)+C*D*(E*(A*(A*(A*(A*(A*(A*-1.5020185953503e-17+5.8265442020601e-15)+-9.3477771213947e-13)+8.0670734103027e-11)+-4.0644363084799e-9)+1.157364750534e-7)+-10866707695377.0e-19)*+h[(XCa(w,1,j)|0)>>3]+-.0001528548241314))+-5.8457616048039)))+113.49746881718)+404.21188637945)+-238.72489924521;i=f;return}function Eu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0,Mb=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+16|0;c[ib>>2]=8;PCa(jb,1,ib);kb=d*1.0e-6;d=e*5.0e-7;lb=e*.001;if(kb<4.0){e=d+-2.1;c[hb>>2]=1;h[(XCa(jb,1,hb)|0)>>3]=e*e;c[gb>>2]=1;mb=+h[(XCa(jb,1,gb)|0)>>3];c[fb>>2]=2;h[(XCa(jb,1,fb)|0)>>3]=mb*mb;c[eb>>2]=3;h[(XCa(jb,1,eb)|0)>>3]=kb*kb;c[db>>2]=3;mb=+h[(XCa(jb,1,db)|0)>>3];c[cb>>2]=4;h[(XCa(jb,1,cb)|0)>>3]=mb*mb;c[bb>>2]=3;mb=kb*+h[(XCa(jb,1,bb)|0)>>3];c[ab>>2]=5;h[(XCa(jb,1,ab)|0)>>3]=mb;c[$a>>2]=2;mb=+h[(XCa(jb,1,$a)|0)>>3];c[_a>>2]=1;nb=+h[(XCa(jb,1,_a)|0)>>3];c[Za>>2]=1;ob=+h[(XCa(jb,1,Za)|0)>>3];c[Ya>>2]=4;pb=+h[(XCa(jb,1,Ya)|0)>>3]*1.3865724283226;c[Xa>>2]=1;qb=+h[(XCa(jb,1,Xa)|0)>>3];c[Wa>>2]=2;rb=+h[(XCa(jb,1,Wa)|0)>>3];c[Va>>2]=1;sb=+h[(XCa(jb,1,Va)|0)>>3];c[Ua>>2]=2;tb=+h[(XCa(jb,1,Ua)|0)>>3];c[Ta>>2]=5;ub=+h[(XCa(jb,1,Ta)|0)>>3]*-13551.334240775;c[Sa>>2]=2;vb=+h[(XCa(jb,1,Sa)|0)>>3];c[Ra>>2]=3;wb=+h[(XCa(jb,1,Ra)|0)>>3];c[Qa>>2]=4;xb=wb*kb*+h[(XCa(jb,1,Qa)|0)>>3]*-62.459855192507;c[Pa>>2]=2;wb=+h[(XCa(jb,1,Pa)|0)>>3];c[Oa>>2]=4;yb=(kb*7399.9835474766+235988.32556514)*+h[(XCa(jb,1,Oa)|0)>>3];c[Na>>2]=1;zb=+h[(XCa(jb,1,Na)|0)>>3];c[Ma>>2]=3;Ab=+h[(XCa(jb,1,Ma)|0)>>3];c[La>>2]=4;Bb=Ab*+h[(XCa(jb,1,La)|0)>>3]*19127.72923966;c[Ka>>2]=1;Ab=+h[(XCa(jb,1,Ka)|0)>>3];c[Ja>>2]=3;Cb=+h[(XCa(jb,1,Ja)|0)>>3];c[Ia>>2]=5;Db=Cb*(+h[(XCa(jb,1,Ia)|0)>>3]*-551966.9703006+128127984.04046);c[Ha>>2]=1;Cb=+h[(XCa(jb,1,Ha)|0)>>3];c[Ga>>2]=3;Eb=+h[(XCa(jb,1,Ga)|0)>>3]*-985549096.23276;c[Fa>>2]=1;Fb=+h[(XCa(jb,1,Fa)|0)>>3];c[Ea>>2]=3;Gb=+h[(XCa(jb,1,Ea)|0)>>3]*2822454697.3002;c[Da>>2]=1;Hb=+h[(XCa(jb,1,Da)|0)>>3];c[Ca>>2]=3;Ib=+h[(XCa(jb,1,Ca)|0)>>3];c[Ba>>2]=5;Jb=Ib*(+h[(XCa(jb,1,Ba)|0)>>3]*3715408.5996233+-3594897141.0703);c[Aa>>2]=1;Ib=+h[(XCa(jb,1,Aa)|0)>>3];c[za>>2]=3;Kb=kb*(kb*-.0061707422868339+1.844574935579)+e*(kb*-4.1792700549624+e*(kb*(kb*-.31078046629583+6.2478196935812)+e*(kb*-17.344563108114+mb*(kb*(kb*11.670873077107+-200.58176862096)+nb*(kb*271.96065473796+ob*(kb*-455.11318285818+e*(pb+qb*rb*(kb*3091.9688604755+sb*(tb*(ub+vb*(xb+wb*(yb+zb*(Bb+Ab*(Db+Cb*(Eb+Fb*(Gb+Hb*(Jb+Ib*kb*(kb*(kb*(kb*(+h[(XCa(jb,1,za)|0)>>3]*-415351.64835634+-13105236.545054)+12848734.66465)+1722734991.3197)+252266.40357872)))))))))+11.765048724356)))))+-7.4232016790248)+33.153654801263)+-107.81748091826)+849.51654495535)+1089.8952318288;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}if(kb<lb*(lb*.00012809002730136+-.67955786399241)+905.84278514723){lb=d+-2.6;Ib=kb+-2.0;c[ya>>2]=1;h[(XCa(jb,1,ya)|0)>>3]=Ib*Ib;c[xa>>2]=1;Jb=Ib*+h[(XCa(jb,1,xa)|0)>>3];c[wa>>2]=2;h[(XCa(jb,1,wa)|0)>>3]=Jb;c[va>>2]=1;Jb=+h[(XCa(jb,1,va)|0)>>3];c[ua>>2]=3;h[(XCa(jb,1,ua)|0)>>3]=Jb*Jb;c[ta>>2]=4;h[(XCa(jb,1,ta)|0)>>3]=lb*lb;c[sa>>2]=4;Jb=+h[(XCa(jb,1,sa)|0)>>3];c[ra>>2]=5;h[(XCa(jb,1,ra)|0)>>3]=Jb*Jb;c[qa>>2]=4;Jb=+h[(XCa(jb,1,qa)|0)>>3];c[pa>>2]=5;Hb=Jb*+h[(XCa(jb,1,pa)|0)>>3];c[oa>>2]=6;h[(XCa(jb,1,oa)|0)>>3]=Hb;c[na>>2]=5;Hb=+h[(XCa(jb,1,na)|0)>>3];c[ma>>2]=7;h[(XCa(jb,1,ma)|0)>>3]=Hb*Hb;c[la>>2]=2;Hb=+h[(XCa(jb,1,la)|0)>>3];c[ka>>2]=1;Jb=+h[(XCa(jb,1,ka)|0)>>3];c[ja>>2]=3;Gb=Hb*(Jb*+h[(XCa(jb,1,ja)|0)>>3]*-1.7565233969407e-18+.00011032831789999);c[ia>>2]=2;Jb=Ib*(Ib*(Ib*(Ib*(+h[(XCa(jb,1,ia)|0)>>3]*-8.1456365207833e-14+2.8640237477456e-7)+.00018955248387902)+-.021810755324761)+3.3593118604916);c[ha>>2]=5;Hb=+h[(XCa(jb,1,ha)|0)>>3];c[ga>>2]=4;Fb=+h[(XCa(jb,1,ga)|0)>>3];c[fa>>2]=1;Eb=+h[(XCa(jb,1,fa)|0)>>3]*-.10829784403677;c[ea>>2]=5;Cb=+h[(XCa(jb,1,ea)|0)>>3];c[da>>2]=1;Db=Ib*((Ib*-10779857357512.0e-18+.0030891541160537)*+h[(XCa(jb,1,da)|0)>>3]+.16844539671904);c[ca>>2]=6;Ab=+h[(XCa(jb,1,ca)|0)>>3];c[ba>>2]=1;Bb=Ib*(Ib*((Ib*2.821728163504e-7+-76462712454814.0e-18)*+h[(XCa(jb,1,ba)|0)>>3]+-.046333324635812)+.73875745236695);c[aa>>2]=6;zb=+h[(XCa(jb,1,aa)|0)>>3];c[$>>2]=1;yb=Ib*((Ib*(Ib*12704902271945.0e-19+14052392818316.0e-18)+.0013555504554949)*+h[(XCa(jb,1,$)|0)>>3]+-.47128737436186);c[_>>2]=5;wb=+h[(XCa(jb,1,_)|0)>>3];c[Z>>2]=2;xb=+h[(XCa(jb,1,Z)|0)>>3];c[Y>>2]=1;vb=Ib*(xb*((Ib*-2.5180545682962e-11+-1.1030139238909e-8)*+h[(XCa(jb,1,Y)|0)>>3]+-31083814331434.0e-18)+.15020273139707);c[X>>2]=5;xb=+h[(XCa(jb,1,X)|0)>>3];c[W>>2]=7;ub=+h[(XCa(jb,1,W)|0)>>3];c[V>>2]=1;tb=+h[(XCa(jb,1,V)|0)>>3];c[U>>2]=3;Kb=Ib*.93747147377932+lb*(Gb+lb*(Jb+Hb*(Ib*3.3809355601454+Fb*(Eb+Cb*(Db+Ab*(Bb+zb*(yb+wb*(vb+xb*ub*(Ib*(Ib*(tb*(Ib*(+h[(XCa(jb,1,U)|0)>>3]*8.6934156344163e-15+7.3803353468292e-8)+-10302738212103.0e-19)+71280351959551.0e-18)+-.002176411421975)+.0085208123431544)+-.47811863648625)+1.1385952129658)+-.63281320016026)+2.4742464705674)))+-97.708318797837)+743.07798314034)+1489.5041079516;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}else{Ib=d+-1.8;d=kb+25.0;c[T>>2]=1;h[(XCa(jb,1,T)|0)>>3]=d*d;c[S>>2]=1;kb=+h[(XCa(jb,1,S)|0)>>3];c[R>>2]=2;h[(XCa(jb,1,R)|0)>>3]=kb*kb;c[Q>>2]=1;kb=+h[(XCa(jb,1,Q)|0)>>3];c[P>>2]=2;tb=kb*d*+h[(XCa(jb,1,P)|0)>>3];c[O>>2]=3;h[(XCa(jb,1,O)|0)>>3]=tb;c[N>>2]=3;tb=1.0/+h[(XCa(jb,1,N)|0)>>3];c[M>>2]=4;h[(XCa(jb,1,M)|0)>>3]=tb;c[L>>2]=1;tb=+h[(XCa(jb,1,L)|0)>>3];c[K>>2]=2;kb=tb*+h[(XCa(jb,1,K)|0)>>3];c[J>>2]=5;h[(XCa(jb,1,J)|0)>>3]=kb;c[I>>2]=6;h[(XCa(jb,1,I)|0)>>3]=Ib*Ib;c[H>>2]=2;kb=+h[(XCa(jb,1,H)|0)>>3];c[G>>2]=7;h[(XCa(jb,1,G)|0)>>3]=kb*kb;c[F>>2]=6;kb=+h[(XCa(jb,1,F)|0)>>3];c[E>>2]=8;h[(XCa(jb,1,E)|0)>>3]=kb*kb;c[D>>2]=1;kb=+h[(XCa(jb,1,D)|0)>>3];c[C>>2]=5;tb=kb*(+h[(XCa(jb,1,C)|0)>>3]*1.126159740723e-12+482.19755109255)+859777.2253558;c[B>>2]=1;kb=tb/+h[(XCa(jb,1,B)|0)>>3];c[A>>2]=2;tb=d*(+h[(XCa(jb,1,A)|0)>>3]*31081.088422714+20825544563.171)+-583401318515.9;c[z>>2]=5;ub=tb/+h[(XCa(jb,1,z)|0)>>3];c[y>>2]=6;tb=+h[(XCa(jb,1,y)|0)>>3];c[x>>2]=8;xb=+h[(XCa(jb,1,x)|0)>>3];c[w>>2]=6;vb=+h[(XCa(jb,1,w)|0)>>3];c[v>>2]=5;wb=+h[(XCa(jb,1,v)|0)>>3]*1.2324579690832e-7;c[u>>2]=6;yb=+h[(XCa(jb,1,u)|0)>>3];c[t>>2]=5;zb=+h[(XCa(jb,1,t)|0)>>3]*-11606921130984.0e-19;c[s>>2]=8;Bb=+h[(XCa(jb,1,s)|0)>>3];c[r>>2]=5;Ab=+h[(XCa(jb,1,r)|0)>>3]*27846367088554.0e-18;c[q>>2]=5;Db=+h[(XCa(jb,1,q)|0)>>3]*-.00059270038474176;c[p>>2]=5;Cb=+h[(XCa(jb,1,p)|0)>>3];c[o>>2]=6;Eb=Db+Cb*+h[(XCa(jb,1,o)|0)>>3]*.0012918582991878;c[n>>2]=8;Cb=xb*(d*-10.842984880077+vb*(wb+yb*(zb+Bb*(Ab+ +h[(XCa(jb,1,n)|0)>>3]*Eb))));c[m>>2]=4;Eb=+h[(XCa(jb,1,m)|0)>>3];c[l>>2]=7;Ab=+h[(XCa(jb,1,l)|0)>>3];c[k>>2]=2;Bb=Ib*(kb+Ib*(ub+tb*(Cb+Eb*(Ab*(d*(+h[(XCa(jb,1,k)|0)>>3]*-1.7804982240686e-11+-.04536417267666)+3.7966001272486)+7326335090218.1))));c[j>>2]=4;Ab=+h[(XCa(jb,1,j)|0)>>3];c[g>>2]=1;Eb=+h[(XCa(jb,1,g)|0)>>3];c[f>>2]=5;Kb=Bb+Ab*(d*(d*(Eb*d*(d*(d*(+h[(XCa(jb,1,f)|0)>>3]*1.4559115658698e-13+1208.2315865936)+-25745.72360417)+610747.83564516)+-10783068217.47)+358250899454.47)+-3236839855524.2);Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}}function Fu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+16|0;c[Va>>2]=16;PCa(Wa,1,Va);if(!(d>611.657)){Va=ACa(ACa(12992,yCa(d,0,1,6)|0)|0,12256)|0;Xa=ACa(ACa(Va,yCa(611.657,0,1,6)|0)|0,12264)|0;Va=c[72852]|0;Ya=g;Za=13056;c[Ya+0>>2]=c[Za+0>>2];c[Ya+4>>2]=c[Za+4>>2];c[Ya+8>>2]=c[Za+8>>2];c[Ya+12>>2]=c[Za+12>>2];c[Ya+16>>2]=c[Za+16>>2];c[Ya+20>>2]=c[Za+20>>2];Ne[Va&127](b,g,Xa,Ua);}_a=d/1.0e6;d=540.0/e;$a=d+-.5;c[Ta>>2]=1;h[(XCa(Wa,1,Ta)|0)>>3]=d*d;c[Sa>>2]=1;ab=+h[(XCa(Wa,1,Sa)|0)>>3];c[Ra>>2]=2;h[(XCa(Wa,1,Ra)|0)>>3]=ab*ab;c[Qa>>2]=3;h[(XCa(Wa,1,Qa)|0)>>3]=$a*$a;c[Pa>>2]=3;ab=$a*+h[(XCa(Wa,1,Pa)|0)>>3];c[Oa>>2]=4;h[(XCa(Wa,1,Oa)|0)>>3]=ab;c[Na>>2]=3;ab=+h[(XCa(Wa,1,Na)|0)>>3];c[Ma>>2]=5;h[(XCa(Wa,1,Ma)|0)>>3]=ab*ab;c[La>>2]=5;ab=+h[(XCa(Wa,1,La)|0)>>3];c[Ka>>2]=6;h[(XCa(Wa,1,Ka)|0)>>3]=ab*ab;c[Ja>>2]=6;ab=+h[(XCa(Wa,1,Ja)|0)>>3];c[Ia>>2]=7;h[(XCa(Wa,1,Ia)|0)>>3]=ab*ab;c[Ha>>2]=5;ab=+h[(XCa(Wa,1,Ha)|0)>>3];c[Ga>>2]=6;bb=+h[(XCa(Wa,1,Ga)|0)>>3];c[Fa>>2]=7;cb=ab*bb*$a*+h[(XCa(Wa,1,Fa)|0)>>3];c[Ea>>2]=8;h[(XCa(Wa,1,Ea)|0)>>3]=cb;c[Da>>2]=3;cb=+h[(XCa(Wa,1,Da)|0)>>3];c[Ca>>2]=5;bb=cb*+h[(XCa(Wa,1,Ca)|0)>>3];c[Ba>>2]=9;h[(XCa(Wa,1,Ba)|0)>>3]=bb;c[Aa>>2]=5;bb=+h[(XCa(Wa,1,Aa)|0)>>3];c[za>>2]=6;cb=bb*$a*+h[(XCa(Wa,1,za)|0)>>3];c[ya>>2]=10;h[(XCa(Wa,1,ya)|0)>>3]=cb;c[xa>>2]=3;cb=+h[(XCa(Wa,1,xa)|0)>>3];c[wa>>2]=7;bb=cb*$a*+h[(XCa(Wa,1,wa)|0)>>3];c[va>>2]=11;h[(XCa(Wa,1,va)|0)>>3]=bb;c[ua>>2]=3;bb=+h[(XCa(Wa,1,ua)|0)>>3];c[ta>>2]=5;cb=+h[(XCa(Wa,1,ta)|0)>>3];c[sa>>2]=6;ab=bb*cb*+h[(XCa(Wa,1,sa)|0)>>3];c[ra>>2]=12;h[(XCa(Wa,1,ra)|0)>>3]=ab;c[qa>>2]=5;ab=+h[(XCa(Wa,1,qa)|0)>>3];c[pa>>2]=6;cb=+h[(XCa(Wa,1,pa)|0)>>3];c[oa>>2]=7;bb=ab*cb*+h[(XCa(Wa,1,oa)|0)>>3];c[na>>2]=13;h[(XCa(Wa,1,na)|0)>>3]=bb;c[ma>>2]=14;h[(XCa(Wa,1,ma)|0)>>3]=_a*_a;c[la>>2]=14;bb=+h[(XCa(Wa,1,la)|0)>>3];c[ka>>2]=15;h[(XCa(Wa,1,ka)|0)>>3]=bb*bb;c[ja>>2]=7;bb=+h[(XCa(Wa,1,ja)|0)>>3];c[ia>>2]=16;h[(XCa(Wa,1,ia)|0)>>3]=bb*bb;c[ha>>2]=1;bb=d*(d*(d*(d*((d*(d*.06380539059921+-.5681726521544)+10.08665568018)*+h[(XCa(Wa,1,ha)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[ga>>2]=2;cb=+h[(XCa(Wa,1,ga)|0)>>3];c[fa>>2]=1;ab=bb/(cb*+h[(XCa(Wa,1,fa)|0)>>3]);c[ea>>2]=4;cb=$a*($a*(+h[(XCa(Wa,1,ea)|0)>>3]*-.30195167236758+-.172743777250296)+-.09199202739273);c[da>>2]=3;bb=+h[(XCa(Wa,1,da)|0)>>3];c[ca>>2]=4;db=+h[(XCa(Wa,1,ca)|0)>>3];c[ba>>2]=8;eb=$a*(bb*(db*(+h[(XCa(Wa,1,ba)|0)>>3]*-.000960283724907132+-.306581069554011)+-.015757110897342)+-.0003789797503263);c[aa>>2]=3;db=+h[(XCa(Wa,1,aa)|0)>>3];c[$>>2]=4;bb=+h[(XCa(Wa,1,$)|0)>>3];c[_>>2]=8;fb=db*(bb*(+h[(XCa(Wa,1,_)|0)>>3]*-1.42338887469272+-.0090203547252888)+-9683303171571.0e-17);c[Z>>2]=9;bb=+h[(XCa(Wa,1,Z)|0)>>3]*160454534363627.0e-19;c[Y>>2]=10;db=+h[(XCa(Wa,1,Y)|0)>>3];c[X>>2]=11;gb=db*(+h[(XCa(Wa,1,X)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11;c[W>>2]=3;db=+h[(XCa(Wa,1,W)|0)>>3]*gb;c[V>>2]=12;gb=+h[(XCa(Wa,1,V)|0)>>3]*-.973671060893475+-138839897890111.0e-19;c[U>>2]=3;hb=+h[(XCa(Wa,1,U)|0)>>3];c[T>>2]=6;ib=gb*hb*+h[(XCa(Wa,1,T)|0)>>3];c[S>>2]=13;hb=+h[(XCa(Wa,1,S)|0)>>3]*-296.320827232793+9.0049690883672e-11;c[R>>2]=3;gb=+h[(XCa(Wa,1,R)|0)>>3];c[Q>>2]=5;jb=hb*gb*$a*+h[(XCa(Wa,1,Q)|0)>>3];c[P>>2]=5;gb=+h[(XCa(Wa,1,P)|0)>>3];c[O>>2]=6;hb=gb*+h[(XCa(Wa,1,O)|0)>>3]*2.57526266427144e-7;c[N>>2]=4;gb=+h[(XCa(Wa,1,N)|0)>>3];c[M>>2]=5;kb=+h[(XCa(Wa,1,M)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[L>>2]=9;lb=gb*(kb*+h[(XCa(Wa,1,L)|0)>>3]+4.1627860840696e-19);c[K>>2]=14;kb=+h[(XCa(Wa,1,K)|0)>>3];c[J>>2]=15;gb=+h[(XCa(Wa,1,J)|0)>>3];c[I>>2]=13;mb=+h[(XCa(Wa,1,I)|0)>>3];c[H>>2]=5;nb=+h[(XCa(Wa,1,H)|0)>>3];c[G>>2]=7;ob=mb*(nb*$a*+h[(XCa(Wa,1,G)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=14;nb=+h[(XCa(Wa,1,F)|0)>>3];c[E>>2]=16;mb=+h[(XCa(Wa,1,E)|0)>>3];c[D>>2]=6;pb=+h[(XCa(Wa,1,D)|0)>>3];c[C>>2]=7;qb=mb*pb*+h[(XCa(Wa,1,C)|0)>>3]*-19.1874828272775;c[B>>2]=14;pb=+h[(XCa(Wa,1,B)|0)>>3];c[A>>2]=11;mb=+h[(XCa(Wa,1,A)|0)>>3];c[z>>2]=10;rb=+h[(XCa(Wa,1,z)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[y>>2]=3;sb=+h[(XCa(Wa,1,y)|0)>>3];c[x>>2]=5;tb=+h[(XCa(Wa,1,x)|0)>>3];c[w>>2]=6;ub=mb*(rb*sb*tb*$a*+h[(XCa(Wa,1,w)|0)>>3]+1.78371690710842e-23);c[v>>2]=5;tb=+h[(XCa(Wa,1,v)|0)>>3];c[u>>2]=7;sb=tb*+h[(XCa(Wa,1,u)|0)>>3]*-1.24017662339842e-24;c[t>>2]=16;tb=+h[(XCa(Wa,1,t)|0)>>3];c[s>>2]=5;rb=+h[(XCa(Wa,1,s)|0)>>3];c[r>>2]=7;mb=tb*rb*+h[(XCa(Wa,1,r)|0)>>3]*.000200482822351322;c[q>>2]=16;rb=+h[(XCa(Wa,1,q)|0)>>3];c[p>>2]=3;tb=+h[(XCa(Wa,1,p)|0)>>3];c[o>>2]=5;vb=rb*tb*+h[(XCa(Wa,1,o)|0)>>3]*-4.97975748452559e-14;c[n>>2]=6;tb=+h[(XCa(Wa,1,n)|0)>>3];c[m>>2]=7;rb=+h[(XCa(Wa,1,m)|0)>>3];c[l>>2]=12;wb=+h[(XCa(Wa,1,l)|0)>>3];c[k>>2]=3;xb=+h[(XCa(Wa,1,k)|0)>>3];c[j>>2]=7;h[a>>3]=d*(ab+_a*(cb+_a*(eb+_a*(fb+_a*($a*($a*144676118155521.0e-20+2.558143570457e-8)+_a*(bb+_a*(db+_a*(ib+_a*(jb+_a*(hb+_a*(lb+kb*gb*(ob+nb*(qb+pb*(ub+_a*(sb+_a*(mb+_a*(vb+tb*rb*_a*$a*(wb*(xb*+h[(XCa(Wa,1,j)|0)>>3]*-547344301999018.0e-19+2.21658861403112e-15)+1.90027787547159e-27)))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358))*e*461.526;i=f;return}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(XCa(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(XCa(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(XCa(l,1,tb)|0)>>3];c[ub>>2]=52;h[(XCa(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(XCa(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(XCa(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(XCa(l,1,xb)|0)>>3];c[yb>>2]=53;h[(XCa(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(XCa(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(XCa(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(XCa(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(XCa(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(XCa(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(XCa(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(XCa(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[72852]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[12792+0>>2];c[a+4>>2]=c[12792+4>>2];c[a+8>>2]=c[12792+8>>2];c[a+12>>2]=c[12792+12>>2];c[a+16>>2]=c[12792+16>>2];c[a+20>>2]=c[12792+20>>2];Ne[Gd&127](d,a,12136,Gb);}c[Hb>>2]=9;Ed=+h[(XCa(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(XCa(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(XCa(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(XCa(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(XCa(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(XCa(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(XCa(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(XCa(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(XCa(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(XCa(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(XCa(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(XCa(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(XCa(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(XCa(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(XCa(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(XCa(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(XCa(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(XCa(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(XCa(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(XCa(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(XCa(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(XCa(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(XCa(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(XCa(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(XCa(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(XCa(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(XCa(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(XCa(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(XCa(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(XCa(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(XCa(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(XCa(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(XCa(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(XCa(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(XCa(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(XCa(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(XCa(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(XCa(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(XCa(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(XCa(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(XCa(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(XCa(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(XCa(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(XCa(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(XCa(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(XCa(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(XCa(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(XCa(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(XCa(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(XCa(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(XCa(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(XCa(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(XCa(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(XCa(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(XCa(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(XCa(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(XCa(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(XCa(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(XCa(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(XCa(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(XCa(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(XCa(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(XCa(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(XCa(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(XCa(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(XCa(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(XCa(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(XCa(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(XCa(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(XCa(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(XCa(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(XCa(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(XCa(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(XCa(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(XCa(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(XCa(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(XCa(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(XCa(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(XCa(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(XCa(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(XCa(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(XCa(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(XCa(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(XCa(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(XCa(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(XCa(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(XCa(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(XCa(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(XCa(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(XCa(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(XCa(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(XCa(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(XCa(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(XCa(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(XCa(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(XCa(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(XCa(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(XCa(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(XCa(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(XCa(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(XCa(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(XCa(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(XCa(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(XCa(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(XCa(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(XCa(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(XCa(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(XCa(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(XCa(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(XCa(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(XCa(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(XCa(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(XCa(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(XCa(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(XCa(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(XCa(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(XCa(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(XCa(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(XCa(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(XCa(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(XCa(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(XCa(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(XCa(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(XCa(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(XCa(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(XCa(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(XCa(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(XCa(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(XCa(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(XCa(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(XCa(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(XCa(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(XCa(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(XCa(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(XCa(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(XCa(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(XCa(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(XCa(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(XCa(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(XCa(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(XCa(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(XCa(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(XCa(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(XCa(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(XCa(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(XCa(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(XCa(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(XCa(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(XCa(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(XCa(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(XCa(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(XCa(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(XCa(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(XCa(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(XCa(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(XCa(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(XCa(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(XCa(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(XCa(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(XCa(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(XCa(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(XCa(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(XCa(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(XCa(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(XCa(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(XCa(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(XCa(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(XCa(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(XCa(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(XCa(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(XCa(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(XCa(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(XCa(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(XCa(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(XCa(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(XCa(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(XCa(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(XCa(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(XCa(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(XCa(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(XCa(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(XCa(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(XCa(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(XCa(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(XCa(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(XCa(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(XCa(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(XCa(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(XCa(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(XCa(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(XCa(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(XCa(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(XCa(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(XCa(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(XCa(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(XCa(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(XCa(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(XCa(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(XCa(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(XCa(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(XCa(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(XCa(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(XCa(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(XCa(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(XCa(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(XCa(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(XCa(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(XCa(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(XCa(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(XCa(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(XCa(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(XCa(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(XCa(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(XCa(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(XCa(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(XCa(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(XCa(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function yH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+3|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+3|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+3|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+4|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+4|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+4|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+4|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+4|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+5|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+5|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+5|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+5|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+5|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+4|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+4|0;H=G;c[H>>2]=y;i=d;return}function zH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+24>>3],+h[k+16>>3],c[(c[a+12>>2]|0)+4>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+24>>3];m=+h[g+16>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[f>>3];i=b;return}function AH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+752>>3];l=+h[g+24>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+688|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+688|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,58824,58816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+688|0;r=q;h[r>>3]=o;i=d;return}function BH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+3368>>3]*+h[b+752>>3];i=i;return}function CH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+880>>3]=+h[b+864>>3]*+h[b+688>>3];i=i;return}function DH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+24>>3],+h[k+16>>3],c[(c[a+12>>2]|0)+4>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+24>>3];m=+h[g+16>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[f>>3];i=b;return}function EH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+600>>3]+-273.15;i=i;return}function FH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+752>>3],+h[g+600>>3],+h[g+24>>3],c[(c[f+12>>2]|0)+4>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[d>>3];i=b;return}function GH(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4632>>3]=+h[b+2560>>3];i=i;return}function HH(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4608>>3]=+h[b+4632>>3]*1.0e3;i=i;return}function IH(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;Ot(e,c[j>>2]|0,+h[l+696>>3],+h[l+752>>3],+h[l+760>>3],+h[l+728>>3],+h[l+736>>3],+h[l+3384>>3],+h[l+2920>>3],+h[n+4640>>3]*3.0,(+h[n+624>>3]+ +h[n+632>>3])*.5,+h[n+4632>>3],+h[n+4600>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+4576>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+696>>3]- +h[n+4640>>3]*3.0*+h[n+4656>>3];q=+h[n+4608>>3];r=+h[n+4616>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+800|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+800|0;z=y;h[z>>3]=w;i=d;return}A=r/+SBa(c[j>>2]|0,q,58864,58856,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+800|0;z=y;h[z>>3]=w;i=d;return}function JH(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+800>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+720>>3]=+h[(a?e+736|0:e+728|0)>>3];i=b;return}function KH(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+800>>3];h[b+776>>3]=d*+h[(!(d>=0.0)?b:b+16|0)>>3];i=i;return}function LH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+800>>3]*+h[b+3384>>3];i=i;return}function MH(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+800>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=+h[(a?e+760|0:e+752|0)>>3];i=b;return}function NH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=101325.0;i=i;return}function OH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function PH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3]=+h[d>>3];i=b;return}function QH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=101325.0;i=i;return}function RH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+56>>3]*1.0e-5;i=i;return}function SH(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1e3>>3]=(+h[b+472>>3]+ +h[b+480>>3])*(+h[d+40>>3]- +h[d+56>>3])*+h[b+4352>>3]*.5;i=i;return}function TH(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4352>>3]*(+h[e+472>>3]+ +h[e+480>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1e3>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,58912,58904,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+992|0;q=p;h[q>>3]=n;i=d;return}function UH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+56>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+976>>3]=+h[d>>3];i=b;return}function VH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+4296>>3];i=i;return}function WH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5496>>3]=+h[f>>3];i=b;return}function XH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+40>>3],+h[a+32>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+40>>3];l=+h[g+32>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5504>>3]=+h[f>>3];i=b;return}function YH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+6|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+6|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+6|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+6|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+6|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+7|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+7|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+7|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+32>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+8|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+8|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+8|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+8|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+8|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+8|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+8|0;H=G;c[H>>2]=y;i=d;return}function ZH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+40>>3],+h[k+32>>3],c[(c[a+12>>2]|0)+8>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+40>>3];m=+h[g+32>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[f>>3];i=b;return}function _H(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=+h[g+1056>>3];l=+h[g+40>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59016,59008,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+952|0;r=q;h[r>>3]=o;i=d;return}function $H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1168>>3]=+h[b+3336>>3]*+h[b+1056>>3];i=i;return}function aI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=+h[b+1168>>3]*+h[b+952>>3];i=i;return}function bI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+40>>3],+h[k+32>>3],c[(c[a+12>>2]|0)+8>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+40>>3];m=+h[g+32>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+904>>3]=+h[f>>3];i=b;return}function cI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+904>>3]+-273.15;i=i;return}function dI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1056>>3],+h[g+904>>3],+h[g+40>>3],c[(c[f+12>>2]|0)+8>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[d>>3];i=b;return}function eI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[a+416>>2]|0)+4296>>3];i=i;return}function fI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5416>>3]=+h[f>>3];i=b;return}function gI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+56>>3],+h[a+48>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+56>>3];l=+h[g+48>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5424>>3]=+h[f>>3];i=b;return}function hI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+9|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+9|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+9|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+9|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+9|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+10|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+10|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+10|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+10|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+48>>3],u)|0;a[(c[b+352>>2]|0)+10|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+11|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+11|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+11|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+11|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+11|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+12|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+12|0;H=G;c[H>>2]=y;i=d;return}function iI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+56>>3],+h[k+48>>3],c[(c[a+12>>2]|0)+12>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+56>>3];m=+h[g+48>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1048>>3]=+h[f>>3];i=b;return}function jI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+48>>3];k=+h[g+1048>>3];l=+h[g+56>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59056,59048,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+984|0;r=q;h[r>>3]=o;i=d;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1160>>3]=+h[b+3328>>3]*+h[b+1048>>3];i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=+h[b+1160>>3]*+h[b+984>>3];i=i;return}function mI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+56>>3],+h[k+48>>3],c[(c[a+12>>2]|0)+12>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+56>>3];m=+h[g+48>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+896>>3]=+h[f>>3];i=b;return}function nI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=+h[b+896>>3]+-273.15;i=i;return}function oI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1048>>3],+h[g+896>>3],+h[g+56>>3],c[(c[f+12>>2]|0)+12>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1024>>3]=+h[d>>3];i=b;return}function pI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4408>>3]=+h[b+2560>>3];i=i;return}function qI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4384>>3]=+h[b+4408>>3]*1.0e3;i=i;return}function rI(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;Ot(e,c[j>>2]|0,+h[l+992>>3],+h[l+1048>>3],+h[l+1056>>3],+h[l+1024>>3],+h[l+1032>>3],+h[l+3344>>3],+h[l+2928>>3],+h[n+4416>>3]*3.0,(+h[n+504>>3]+ +h[n+512>>3])*.5,+h[n+4408>>3],+h[n+4376>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+4352>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+992>>3]- +h[n+4416>>3]*3.0*+h[n+4432>>3];q=+h[n+4384>>3];r=+h[n+4392>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+1096|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+1096|0;z=y;h[z>>3]=w;i=d;return}A=r/+SBa(c[j>>2]|0,q,59096,59088,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+1096|0;z=y;h[z>>3]=w;i=d;return}function sI(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1016>>3]=+h[(a?e+1032|0:e+1024|0)>>3];i=b;return}function tI(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1096>>3];h[b+1072>>3]=d*+h[(!(d>=0.0)?b+32|0:b+48|0)>>3];i=i;return}function uI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+1096>>3]*+h[b+3344>>3];i=i;return}function vI(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1096>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1040>>3]=+h[(a?e+1056|0:e+1048|0)>>3];i=b;return}function wI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4208>>3]=+h[b+2560>>3];i=i;return}function xI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4184>>3]=+h[b+4208>>3]*1.0e3;i=i;return}function yI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4024>>3]=+h[b+2560>>3];i=i;return}function zI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4e3>>3]=+h[b+4024>>3]*1.0e3;i=i;return}function AI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3840>>3]=+h[b+2560>>3];i=i;return}function BI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3816>>3]=+h[b+3840>>3]*1.0e3;i=i;return}function CI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3656>>3]=+h[b+2560>>3];i=i;return}function DI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3632>>3]=+h[b+3656>>3]*1.0e3;i=i;return}function EI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3472>>3]=+h[b+2560>>3];i=i;return}function FI(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3472>>3]*1.0e3;i=i;return}function GI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+72>>3]=101325.0;i=i;return}function HI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=+h[b+72>>3]*1.0e-5;i=i;return}function II(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+72>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1696>>3]=+h[d>>3];i=b;return}function JI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+88>>3]=101325.0;i=i;return}function KI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1720>>3]=+h[b+88>>3]*1.0e-5;i=i;return}function LI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1752>>3]=(+h[b+352>>3]+ +h[b+360>>3])*(+h[d+72>>3]- +h[d+88>>3])*+h[b+3208>>3]*.5;i=i;return}function MI(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3208>>3]*(+h[e+352>>3]+ +h[e+360>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1752>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}r=k/+SBa(c[b+536>>2]|0,f,59144,59136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+1744|0;q=p;h[q>>3]=n;i=d;return}function NI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1728>>3]=+h[d>>3];i=b;return}function OI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=+h[(c[a+416>>2]|0)+3152>>3];i=i;return}function PI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[f>>3];i=b;return}function QI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+72>>3],+h[a+64>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+72>>3];l=+h[g+64>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5832>>3]=+h[f>>3];i=b;return}function RI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+12|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+12|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+12|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+12|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+12|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+13|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+13|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+13|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+13|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+64>>3],u)|0;a[(c[b+352>>2]|0)+13|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+14|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+14|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+14|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+14|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+14|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+16|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+16|0;H=G;c[H>>2]=y;i=d;return}function SI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+72>>3],+h[k+64>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+72>>3];m=+h[g+64>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1808>>3]=+h[f>>3];i=b;return}function TI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+1808>>3];l=+h[g+72>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,59240,59232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1704>>3]=j-n;i=d;return}function UI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1920>>3]=+h[b+3176>>3]*+h[b+1808>>3];i=i;return}function VI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+1920>>3]*+h[b+1704>>3];i=i;return}function WI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+72>>3],+h[k+64>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+72>>3];m=+h[g+64>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1656>>3]=+h[f>>3];i=b;return}function XI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1680>>3]=+h[b+1656>>3]+-273.15;i=i;return}function YI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1808>>3],+h[g+1656>>3],+h[g+72>>3],c[(c[f+12>>2]|0)+16>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1784>>3]=+h[d>>3];i=b;return}function ZI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+80>>3]=+h[(c[a+416>>2]|0)+3152>>3];i=i;return}function _I(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5760>>3]=+h[f>>3];i=b;return}function $I(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+88>>3],+h[a+80>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+88>>3];l=+h[g+80>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5768>>3]=+h[f>>3];i=b;return}function aJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+15|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+15|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+15|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+16|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+16|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+16|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+16|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+80>>3],u)|0;a[(c[b+352>>2]|0)+16|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+17|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+17|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+17|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+17|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+17|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}function bJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+88>>3],+h[k+80>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+88>>3];m=+h[g+80>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1800>>3]=+h[f>>3];i=b;return}function cJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=+h[g+1800>>3];l=+h[g+88>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,59280,59272,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1736>>3]=j-n;i=d;return}function dJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=+h[b+3168>>3]*+h[b+1800>>3];i=i;return}function eJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+1912>>3]*+h[b+1736>>3];i=i;return}function fJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+88>>3],+h[k+80>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+88>>3];m=+h[g+80>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[f>>3];i=b;return}function gJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1712>>3]=+h[b+1648>>3]+-273.15;i=i;return}function hJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;kv(d,c[a+536>>2]|0,+h[g+1800>>3],+h[g+1648>>3],+h[g+88>>3],c[(c[f+12>>2]|0)+20>>2]|0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3]=+h[d>>3];i=b;return}function iJ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3264>>3]=+h[b+2560>>3];i=i;return}function jJ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3240>>3]=+h[b+3264>>3]*1.0e3;i=i;return}function kJ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;Ot(e,c[j>>2]|0,+h[l+1744>>3],+h[l+1800>>3],+h[l+1808>>3],+h[l+1776>>3],+h[l+1784>>3],+h[l+3184>>3],+h[l+3024>>3],0.0,(+h[n+384>>3]+ +h[n+392>>3])*.5,+h[n+3264>>3],+h[n+3232>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+3208>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+1744>>3];q=+h[n+3240>>3];r=+h[n+3248>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}A=r/+SBa(c[j>>2]|0,q,59320,59312,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+1848|0;z=y;h[z>>3]=w;i=d;return}function lJ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1768>>3]=+h[(a?e+1784|0:e+1776|0)>>3];i=b;return}function mJ(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1848>>3];h[b+1824>>3]=d*+h[(!(d>=0.0)?b+64|0:b+80|0)>>3];i=i;return}function nJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b+1848>>3]*+h[b+3184>>3];i=i;return}function oJ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1792>>3]=+h[(a?e+1808|0:e+1800|0)>>3];i=b;return}function pJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=+h[(c[a+416>>2]|0)+4832>>3];i=i;return}function qJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function rJ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Au(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+104>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3520>>3]=+h[d>>3];i=b;return}function sJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=+h[(c[a+416>>2]|0)+4816>>3];i=i;return}function tJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5568>>3]=+h[f>>3];i=b;return}function uJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5576>>3]=+h[f>>3];i=b;return}function vJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5056>>3]=+h[f>>3];i=b;return}function wJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5064>>3]=+h[f>>3];i=b;return}function xJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4976>>3]=+h[f>>3];i=b;return}function yJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4984>>3]=+h[f>>3];i=b;return}function zJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4920>>3]=+h[f>>3];i=b;return}function AJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4928>>3]=+h[f>>3];i=b;return}function BJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4744>>3]=+h[f>>3];i=b;return}function CJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+104>>3],+h[a+96>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+104>>3];l=+h[g+96>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4752>>3]=+h[f>>3];i=b;return}function DJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;mu(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+18|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+18|0]|0;g=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+18|0]|0;t=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+18|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+18|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+19|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+19|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u,a[(c[b+360>>2]|0)+19|0]|0)|0;a[(c[b+352>>2]|0)+19|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+19|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+19|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+96>>3],u)|0;a[(c[b+352>>2]|0)+19|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+20|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+20|0]|0;m=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=m;x=e;break}else{e=nFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[b+360>>2]|0)+20|0]|0)|0;a[(c[b+352>>2]|0)+20|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+20|0]|0;e=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+20|0]=e;x=n;break}else{n=rFa(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+20|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+64|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+64|0;H=G;c[H>>2]=y;i=d;return}function EJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+104>>3],+h[k+96>>3],c[(c[a+12>>2]|0)+64>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+104>>3];m=+h[g+96>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3544>>3]=+h[f>>3];i=b;return}function FJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3];k=+h[g+3544>>3];l=+h[g+104>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+SBa(c[b+536>>2]|0,k,59360,59352,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3528>>3]=j-n;i=d;return}function GJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[(c[a+416>>2]|0)+4824>>3]*+h[b+3544>>3];i=i;return}function HJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+3568>>3]*+h[b+3528>>3];i=i;return}function IJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;fv(e,c[g>>2]|0,+h[k+104>>3],+h[k+96>>3],c[(c[a+12>>2]|0)+64>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+104>>3];m=+h[g+96>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[f>>3];i=b;return}function JJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3504>>3]=+h[b+3536>>3]+-273.15;i=i;return}function KJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3808>>3]=+h[b+96>>3]+ +h[d+2528>>3]*+h[d+3728>>3];i=i;return}function LJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3776>>3]=+h[b+96>>3]+ +h[d+2528>>3]*+h[d+4096>>3];i=i;return}function MJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+112>>3]=+h[(c[a+416>>2]|0)+4704>>3];i=i;return}function NJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+4752>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+4752>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+23|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+23|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+23|0]|0)|0;a[(c[b+352>>2]|0)+23|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+23|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+23|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+23|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+4752>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+4752>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+24|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+24|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u,a[(c[b+360>>2]|0)+24|0]|0)|0;a[(c[b+352>>2]|0)+24|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+24|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+24|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+112>>3],u)|0;a[(c[b+352>>2]|0)+24|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+4752>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+68|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+68|0;J=I;c[J>>2]=x;i=d;return}function OJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+4752>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3616>>3]=+h[f>>3];i=b;return}function PJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+112>>3];k=+h[g+3616>>3];l=+h[(c[b+416>>2]|0)+4752>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59392,59384,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3608|0;r=q;h[r>>3]=o;i=d;return}function QJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+4752>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[f>>3];i=b;return}function RJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+78|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+78|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[b+360>>2]|0)+78|0]|0)|0;a[(c[b+352>>2]|0)+78|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[b+360>>2]|0)+78|0]|0)|0;a[(c[b+352>>2]|0)+78|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+78|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],298.0)|0;a[(c[b+352>>2]|0)+78|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],298.0)|0;a[(c[b+352>>2]|0)+78|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+21|0]=f;i=d;return}function SJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3600>>3]=+h[b+544>>3]+-273.15;i=i;return}function TJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3784>>3]=+h[b+112>>3]- +h[d+2528>>3]*+h[d+3912>>3];i=i;return}function UJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[(c[a+416>>2]|0)+4776>>3];i=i;return}function VJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+80|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+80|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[b+360>>2]|0)+80|0]|0)|0;a[(c[b+352>>2]|0)+80|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[b+360>>2]|0)+80|0]|0)|0;a[(c[b+352>>2]|0)+80|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+80|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+120>>3],.01)|0;a[(c[b+352>>2]|0)+80|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],.01)|0;a[(c[b+352>>2]|0)+80|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+25|0]=f;i=d;return}function WJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+4720>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,59416,e);p=+h[(c[f>>2]|0)+4720>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+552>>3]=p+g*+h[f+120>>3]*2.0;i=b;return}function XJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3632>>3]=+h[b+4720>>3]*+h[d+120>>3]+ +h[b+4728>>3];i=i;return}function YJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3672>>3]=+h[b+3632>>3]*+h[b+3616>>3];i=i;return}function ZJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3680>>3]=+h[b+3672>>3]*+h[b+3608>>3];i=i;return}function _J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+101|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;a[k]=e;i=d;return}l=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(l){m=a[(c[b+356>>2]|0)+101|0]|0;n=oFa(+h[(c[b+416>>2]|0)+4776>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3],a[(c[b+360>>2]|0)+101|0]|0)|0;a[(c[b+352>>2]|0)+101|0]=n;e=m;f=b;g=f+408|0;j=g;k=c[j>>2]|0;a[k]=e;i=d;return}else{m=oFa(+h[(c[b+416>>2]|0)+4776>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3],a[(c[b+360>>2]|0)+101|0]|0)|0;a[(c[b+352>>2]|0)+101|0]=m;e=m;f=b;g=f+408|0;j=g;k=c[j>>2]|0;a[k]=e;i=d;return}}else{if(l){l=a[(c[b+356>>2]|0)+101|0]|0;m=sFa(+h[(c[b+416>>2]|0)+4776>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3])|0;a[(c[b+352>>2]|0)+101|0]=m;e=l;f=b;g=f+408|0;j=g;k=c[j>>2]|0;a[k]=e;i=d;return}else{l=sFa(+h[(c[b+416>>2]|0)+4776>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3])|0;a[(c[b+352>>2]|0)+101|0]=l;e=l;f=b;g=f+408|0;j=g;k=c[j>>2]|0;a[k]=e;i=d;return}}}function $J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+21|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+21|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+120>>3],+h[k+560>>3]+ +h[k+3032>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+120>>3],+h[j+560>>3]+ +h[j+3032>>3],a[(c[b+360>>2]|0)+21|0]|0)|0;a[(c[b+352>>2]|0)+21|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+21|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+120>>3],+h[l+560>>3]+ +h[l+3032>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+120>>3],+h[g+560>>3]+ +h[g+3032>>3])|0;a[(c[b+352>>2]|0)+21|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+22|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+22|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+120>>3],+h[l+560>>3]- +h[l+3032>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+120>>3],+h[g+560>>3]- +h[g+3032>>3],a[(c[b+360>>2]|0)+22|0]|0)|0;a[(c[b+352>>2]|0)+22|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+22|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+120>>3],+h[k+560>>3]- +h[k+3032>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+120>>3],+h[j+560>>3]- +h[j+3032>>3])|0;a[(c[b+352>>2]|0)+22|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}if((a[c[b+408>>2]|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;a[w]=n;i=d;return}function aK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=0.0;g=b;j=g+568|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+120>>3]- +h[b+560>>3];g=b;j=g+568|0;k=j;h[k>>3]=f;i=d;return}function bK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+128>>3]=+h[(c[a+416>>2]|0)+3e3>>3];i=i;return}function cK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+3048>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+3048>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+27|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+27|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+27|0]|0)|0;a[(c[b+352>>2]|0)+27|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+27|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+27|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+27|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+3048>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+3048>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+28|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+28|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u,a[(c[b+360>>2]|0)+28|0]|0)|0;a[(c[b+352>>2]|0)+28|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+28|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+28|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+128>>3],u)|0;a[(c[b+352>>2]|0)+28|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+3048>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+72|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+72|0;J=I;c[J>>2]=x;i=d;return}function dK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+3048>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3896>>3]=+h[f>>3];i=b;return}function eK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+128>>3];k=+h[g+3896>>3];l=+h[(c[b+416>>2]|0)+3048>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59512,59504,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3888|0;r=q;h[r>>3]=o;i=d;return}function fK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+3048>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3]=+h[f>>3];i=b;return}function gK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+77|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+77|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[b+360>>2]|0)+77|0]|0)|0;a[(c[b+352>>2]|0)+77|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[b+360>>2]|0)+77|0]|0)|0;a[(c[b+352>>2]|0)+77|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+77|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0)|0;a[(c[b+352>>2]|0)+77|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0)|0;a[(c[b+352>>2]|0)+77|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+19|0]=f;i=d;return}function hK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+1944>>3]+-273.15;i=i;return}function iK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3768>>3]=+h[b+128>>3]- +h[d+2528>>3]*+h[d+4096>>3];i=i;return}function jK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[(c[a+416>>2]|0)+3072>>3];i=i;return}function kK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+79|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+79|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+79|0]|0)|0;a[(c[b+352>>2]|0)+79|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[b+360>>2]|0)+79|0]|0)|0;a[(c[b+352>>2]|0)+79|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+79|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+79|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],.01)|0;a[(c[b+352>>2]|0)+79|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+23|0]=f;i=d;return}function lK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+3016>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,59528,e);p=+h[(c[f>>2]|0)+3016>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+1952>>3]=p+g*+h[f+136>>3]*2.0;i=b;return}function mK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3912>>3]=+h[b+3016>>3]*+h[d+136>>3]+ +h[b+3024>>3];i=i;return}function nK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+3912>>3]*+h[b+3896>>3];i=i;return}function oK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3952>>3]*+h[b+3888>>3];i=i;return}function pK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+100|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+2|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+100|0]|0;q=oFa(+h[(c[b+416>>2]|0)+3072>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1960>>3],a[(c[b+360>>2]|0)+100|0]|0)|0;a[(c[b+352>>2]|0)+100|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+2|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+3072>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1960>>3],a[(c[b+360>>2]|0)+100|0]|0)|0;a[(c[b+352>>2]|0)+100|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+2|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+100|0]|0;p=sFa(+h[(c[b+416>>2]|0)+3072>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1960>>3])|0;a[(c[b+352>>2]|0)+100|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+2|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+3072>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1960>>3])|0;a[(c[b+352>>2]|0)+100|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+2|0;n=m;a[n]=e;i=d;return}}}function qK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+25|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+25|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+136>>3],+h[k+1960>>3]+ +h[k+3048>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+136>>3],+h[j+1960>>3]+ +h[j+3048>>3],a[(c[b+360>>2]|0)+25|0]|0)|0;a[(c[b+352>>2]|0)+25|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+25|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+136>>3],+h[l+1960>>3]+ +h[l+3048>>3])|0;a[(c[b+352>>2]|0)+25|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+136>>3],+h[g+1960>>3]+ +h[g+3048>>3])|0;a[(c[b+352>>2]|0)+25|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+26|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+26|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+136>>3],+h[l+1960>>3]- +h[l+3048>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+136>>3],+h[g+1960>>3]- +h[g+3048>>3],a[(c[b+360>>2]|0)+26|0]|0)|0;a[(c[b+352>>2]|0)+26|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+26|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+136>>3],+h[k+1960>>3]- +h[k+3048>>3])|0;a[(c[b+352>>2]|0)+26|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+136>>3],+h[j+1960>>3]- +h[j+3048>>3])|0;a[(c[b+352>>2]|0)+26|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+2|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+2|0;z=y;a[z]=n;i=d;return}function rK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){f=0.0;g=b;j=g+1968|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+136>>3]- +h[b+1960>>3];g=b;j=g+1968|0;k=j;h[k>>3]=f;i=d;return}function sK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[(c[a+416>>2]|0)+2888>>3];i=i;return}function tK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2936>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2936>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+31|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+31|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+31|0]|0)|0;a[(c[b+352>>2]|0)+31|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+31|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+31|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+31|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2936>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2936>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+32|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+32|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u,a[(c[b+360>>2]|0)+32|0]|0)|0;a[(c[b+352>>2]|0)+32|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+32|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+32|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+144>>3],u)|0;a[(c[b+352>>2]|0)+32|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2936>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+76|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+76|0;J=I;c[J>>2]=x;i=d;return}function uK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2936>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+144>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3984>>3]=+h[f>>3];i=b;return}function vK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+3984>>3];l=+h[(c[b+416>>2]|0)+2936>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59624,59616,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+3976|0;r=q;h[r>>3]=o;i=d;return}function wK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2936>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+144>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[f>>3];i=b;return}function xK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+2e3>>3]+-273.15;i=i;return}function yK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[(c[a+416>>2]|0)+2960>>3];i=i;return}function zK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2904>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,59640,e);p=+h[(c[f>>2]|0)+2904>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2008>>3]=p+g*+h[f+152>>3]*2.0;i=b;return}function AK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3992>>3]=+h[b+2904>>3]*+h[d+152>>3]+ +h[b+2912>>3];i=i;return}function BK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+3992>>3]*+h[b+3984>>3];i=i;return}function CK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+4024>>3]*+h[b+3976>>3];i=i;return}function DK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+99|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+4|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+99|0]|0;q=oFa(+h[(c[b+416>>2]|0)+2960>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2016>>3],a[(c[b+360>>2]|0)+99|0]|0)|0;a[(c[b+352>>2]|0)+99|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+4|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+2960>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2016>>3],a[(c[b+360>>2]|0)+99|0]|0)|0;a[(c[b+352>>2]|0)+99|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+4|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+99|0]|0;p=sFa(+h[(c[b+416>>2]|0)+2960>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2016>>3])|0;a[(c[b+352>>2]|0)+99|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+4|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+2960>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2016>>3])|0;a[(c[b+352>>2]|0)+99|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+4|0;n=m;a[n]=e;i=d;return}}}function EK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+29|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+29|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+152>>3],+h[k+2016>>3]+ +h[k+3064>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+152>>3],+h[j+2016>>3]+ +h[j+3064>>3],a[(c[b+360>>2]|0)+29|0]|0)|0;a[(c[b+352>>2]|0)+29|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+29|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+152>>3],+h[l+2016>>3]+ +h[l+3064>>3])|0;a[(c[b+352>>2]|0)+29|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+152>>3],+h[g+2016>>3]+ +h[g+3064>>3])|0;a[(c[b+352>>2]|0)+29|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+30|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+30|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+152>>3],+h[l+2016>>3]- +h[l+3064>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+152>>3],+h[g+2016>>3]- +h[g+3064>>3],a[(c[b+360>>2]|0)+30|0]|0)|0;a[(c[b+352>>2]|0)+30|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+30|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+152>>3],+h[k+2016>>3]- +h[k+3064>>3])|0;a[(c[b+352>>2]|0)+30|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+152>>3],+h[j+2016>>3]- +h[j+3064>>3])|0;a[(c[b+352>>2]|0)+30|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+4|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+4|0;z=y;a[z]=n;i=d;return}function FK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+4|0]|0)==0){f=0.0;g=b;j=g+2024|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+152>>3]- +h[b+2016>>3];g=b;j=g+2024|0;k=j;h[k>>3]=f;i=d;return}function GK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+2776>>3];i=i;return}function HK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+2824>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+2824>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+37|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+37|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+37|0]|0)|0;a[(c[b+352>>2]|0)+37|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+37|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+37|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+37|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+2824>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+2824>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+38|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+38|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u,a[(c[b+360>>2]|0)+38|0]|0)|0;a[(c[b+352>>2]|0)+38|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+38|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+38|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+160>>3],u)|0;a[(c[b+352>>2]|0)+38|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+2824>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+80|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+80|0;J=I;c[J>>2]=x;i=d;return}function IK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2824>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+160>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4056>>3]=+h[f>>3];i=b;return}function JK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+4056>>3];l=+h[(c[b+416>>2]|0)+2824>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,59736,59728,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+4048|0;r=q;h[r>>3]=o;i=d;return}function KK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+2824>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+160>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));mv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2056>>3]=+h[f>>3];i=b;return}function LK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+2056>>3]+-273.15;i=i;return}function MK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3800>>3]=+h[b+160>>3]- +h[d+2528>>3]*+h[d+3728>>3];i=i;return}function NK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[(c[a+416>>2]|0)+2848>>3];i=i;return}function OK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+84|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+84|0]|0;k=b+4|0;l=oFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[b+360>>2]|0)+84|0]|0)|0;a[(c[b+352>>2]|0)+84|0]=l;e=k;f=j;break}else{j=b+4|0;k=oFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[b+360>>2]|0)+84|0]|0)|0;a[(c[b+352>>2]|0)+84|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+84|0]|0;k=b+4|0;j=sFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.13)|0;a[(c[b+352>>2]|0)+84|0]=j;e=k;f=g;break}else{g=b+4|0;k=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],.13)|0;a[(c[b+352>>2]|0)+84|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+33|0]=f;i=d;return}function PK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+83|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+83|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[b+360>>2]|0)+83|0]|0)|0;a[(c[b+352>>2]|0)+83|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[b+360>>2]|0)+83|0]|0)|0;a[(c[b+352>>2]|0)+83|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+83|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+168>>3],.01)|0;a[(c[b+352>>2]|0)+83|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],.01)|0;a[(c[b+352>>2]|0)+83|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+31|0]=f;i=d;return}function QK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+2792>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,59752,e);p=+h[(c[f>>2]|0)+2792>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2064>>3]=p+g*+h[f+168>>3]*2.0;i=b;return}function RK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4064>>3]=+h[b+2792>>3]*+h[d+168>>3]+ +h[b+2800>>3];i=i;return}function SK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4064>>3]*+h[b+4056>>3];i=i;return}function TK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+4096>>3]*+h[b+4048>>3];i=i;return}function UK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+98|0]|0;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+7|0;n=m;a[n]=e;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+98|0]|0;q=oFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2080>>3],a[(c[b+360>>2]|0)+98|0]|0)|0;a[(c[b+352>>2]|0)+98|0]=q;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+7|0;n=m;a[n]=e;i=d;return}else{p=oFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2080>>3],a[(c[b+360>>2]|0)+98|0]|0)|0;a[(c[b+352>>2]|0)+98|0]=p;e=p;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+7|0;n=m;a[n]=e;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+98|0]|0;p=sFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2080>>3])|0;a[(c[b+352>>2]|0)+98|0]=p;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+7|0;n=m;a[n]=e;i=d;return}else{o=sFa(+h[(c[b+416>>2]|0)+2848>>3],+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2080>>3])|0;a[(c[b+352>>2]|0)+98|0]=o;e=o;f=b;g=f+408|0;j=g;k=c[j>>2]|0;l=k;m=l+7|0;n=m;a[n]=e;i=d;return}}}function VK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+33|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+33|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+168>>3],+h[k+2080>>3]+ +h[k+3088>>3],a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+168>>3],+h[j+2080>>3]+ +h[j+3088>>3],a[(c[b+360>>2]|0)+33|0]|0)|0;a[(c[b+352>>2]|0)+33|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+33|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+168>>3],+h[l+2080>>3]+ +h[l+3088>>3])|0;a[(c[b+352>>2]|0)+33|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+168>>3],+h[g+2080>>3]+ +h[g+3088>>3])|0;a[(c[b+352>>2]|0)+33|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+34|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+34|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+168>>3],+h[l+2080>>3]- +h[l+3088>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+168>>3],+h[g+2080>>3]- +h[g+3088>>3],a[(c[b+360>>2]|0)+34|0]|0)|0;a[(c[b+352>>2]|0)+34|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+34|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+168>>3],+h[k+2080>>3]- +h[k+3088>>3])|0;a[(c[b+352>>2]|0)+34|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+168>>3],+h[j+2080>>3]- +h[j+3088>>3])|0;a[(c[b+352>>2]|0)+34|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+7|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+7|0;z=y;a[z]=n;i=d;return}function WK(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+7|0]|0)==0){f=0.0;g=b;j=g+2096|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+168>>3]- +h[b+2080>>3];g=b;j=g+2096|0;k=j;h[k>>3]=f;i=d;return}function XK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+5008>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+5008|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+5008>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2120>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2120|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2120>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+8>>3]=k;TFa(a,0)|0;j=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+5008>>3]=+h[j>>3];h[f+2120>>3]=+h[j+8>>3];xv(a);yv(a);zv(a);Av(a);Bv(a);Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);i=b;return}function YK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+3800>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+3800>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4944>>3],+h[d+4976>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1960>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4960>>3]=+h[g>>3];i=b;return}function ZK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[b+4944>>3]*+h[(c[a+416>>2]|0)+3704>>3];i=i;return}function _K(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2112>>3]=-(+h[e+4944>>3]*+h[(a<<24>>24==0?e+160|0:e+3808|0)>>3]);i=b;return}



function O0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e+60,+(+wd(+((c[(c[a+420>>2]|0)+148>>2]|0)==2?0.0:1.0e+60),1.0e5)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=d;i=b;return}function P0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(+-((c[(c[a+420>>2]|0)+160>>2]|0)==1?0.0:-1.0e+60),1.0e5)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=d;i=b;return}function Q0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=i;d=c[a+420>>2]|0;e=(c[d+168>>2]|0)==2?0.0:1.0e+60;f=+wd(+e,+(+wd(1.0e5,+(+wd(+-((c[d+692>>2]|0)==1?0.0:-1.0e+60),1.0e5)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=f;i=b;return}function R0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(+((c[(c[a+420>>2]|0)+176>>2]|0)==2?0.0:1.0e+60),1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=d;i=b;return}function S0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[a+420>>2]|0)+172>>2]|0)==1?0.0:-1.0e+60),1.0e5)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=d;i=b;return}function T0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[a+420>>2]|0)+688>>2]|0)==1?0.0:-1.0e+60),1.0e5)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=d;i=b;return}function U0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[a+420>>2]|0)+164>>2]|0)==1?0.0:-1.0e+60),1.0e5)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=d;i=b;return}function V0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[a+420>>2]|0)+152>>2]|0)==1?0.0:-1.0e+60),1.0e5)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=d;i=b;return}function W0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+264>>3]=+h[(c[a+416>>2]|0)+736>>3];i=i;return}function X0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0.0,jb=0,kb=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+8|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+8|0;A0(a);B0(a);C0(a);D0(a);E0(a);F0(a);G0(a);H0(a);I0(a);J0(a);K0(a);MBa(9,1,66088,hb);hb=a+4|0;ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+3592>>3];jb=a+8|0;kb=c[jb>>2]|0;h[kb+50344>>3]=ib;c[gb>>2]=c[kb+50292>>2];kb=gb+4|0;h[k>>3]=ib;c[kb>>2]=c[k>>2];c[kb+4>>2]=c[k+4>>2];MBa(9,0,66112,gb);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+808>>3];gb=c[jb>>2]|0;h[gb+11368>>3]=ib;c[fb>>2]=c[gb+11316>>2];gb=fb+4|0;h[k>>3]=ib;c[gb>>2]=c[k>>2];c[gb+4>>2]=c[k+4>>2];MBa(9,0,66112,fb);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1104>>3];fb=c[jb>>2]|0;h[fb+15512>>3]=ib;c[eb>>2]=c[fb+15460>>2];fb=eb+4|0;h[k>>3]=ib;c[fb>>2]=c[k>>2];c[fb+4>>2]=c[k+4>>2];MBa(9,0,66112,eb);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1856>>3];eb=c[jb>>2]|0;h[eb+26040>>3]=ib;c[db>>2]=c[eb+25988>>2];eb=db+4|0;h[k>>3]=ib;c[eb>>2]=c[k>>2];c[eb+4>>2]=c[k+4>>2];MBa(9,0,66112,db);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1840>>3];db=c[jb>>2]|0;h[db+25816>>3]=ib;c[cb>>2]=c[db+25764>>2];db=cb+4|0;h[k>>3]=ib;c[db>>2]=c[k>>2];c[db+4>>2]=c[k+4>>2];MBa(9,0,66112,cb);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4872>>3];cb=c[jb>>2]|0;h[cb+68264>>3]=ib;c[bb>>2]=c[cb+68212>>2];cb=bb+4|0;h[k>>3]=ib;c[cb>>2]=c[k>>2];c[cb+4>>2]=c[k+4>>2];MBa(9,0,66112,bb);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5112>>3];bb=c[jb>>2]|0;h[bb+71624>>3]=ib;c[ab>>2]=c[bb+71572>>2];bb=ab+4|0;h[k>>3]=ib;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];MBa(9,0,66112,ab);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5256>>3];ab=c[jb>>2]|0;h[ab+73640>>3]=ib;c[$a>>2]=c[ab+73588>>2];ab=$a+4|0;h[k>>3]=ib;c[ab>>2]=c[k>>2];c[ab+4>>2]=c[k+4>>2];MBa(9,0,66112,$a);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5520>>3];$a=c[jb>>2]|0;h[$a+77336>>3]=ib;c[_a>>2]=c[$a+77284>>2];$a=_a+4|0;h[k>>3]=ib;c[$a>>2]=c[k>>2];c[$a+4>>2]=c[k+4>>2];MBa(9,0,66112,_a);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5600>>3];_a=c[jb>>2]|0;h[_a+78456>>3]=ib;c[Za>>2]=c[_a+78404>>2];_a=Za+4|0;h[k>>3]=ib;c[_a>>2]=c[k>>2];c[_a+4>>2]=c[k+4>>2];MBa(9,0,66112,Za);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5672>>3];Za=c[jb>>2]|0;h[Za+79464>>3]=ib;c[Ya>>2]=c[Za+79412>>2];Za=Ya+4|0;h[k>>3]=ib;c[Za>>2]=c[k>>2];c[Za+4>>2]=c[k+4>>2];MBa(9,0,66112,Ya);if((c[241644>>2]|0)!=0){je[c[60540]&1023](9)}L0(a);M0(a);N0(a);O0(a);P0(a);Q0(a);R0(a);S0(a);T0(a);U0(a);V0(a);W0(a);MBa(9,1,66128,Xa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+3592>>3];Xa=c[jb>>2]|0;h[Xa+50352>>3]=ib;c[Wa>>2]=c[Xa+50292>>2];Xa=Wa+4|0;h[k>>3]=ib;c[Xa>>2]=c[k>>2];c[Xa+4>>2]=c[k+4>>2];MBa(9,0,66152,Wa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+808>>3];Wa=c[jb>>2]|0;h[Wa+11376>>3]=ib;c[Va>>2]=c[Wa+11316>>2];Wa=Va+4|0;h[k>>3]=ib;c[Wa>>2]=c[k>>2];c[Wa+4>>2]=c[k+4>>2];MBa(9,0,66152,Va);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1104>>3];Va=c[jb>>2]|0;h[Va+15520>>3]=ib;c[Ua>>2]=c[Va+15460>>2];Va=Ua+4|0;h[k>>3]=ib;c[Va>>2]=c[k>>2];c[Va+4>>2]=c[k+4>>2];MBa(9,0,66152,Ua);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1856>>3];Ua=c[jb>>2]|0;h[Ua+26048>>3]=ib;c[Ta>>2]=c[Ua+25988>>2];Ua=Ta+4|0;h[k>>3]=ib;c[Ua>>2]=c[k>>2];c[Ua+4>>2]=c[k+4>>2];MBa(9,0,66152,Ta);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1840>>3];Ta=c[jb>>2]|0;h[Ta+25824>>3]=ib;c[Sa>>2]=c[Ta+25764>>2];Ta=Sa+4|0;h[k>>3]=ib;c[Ta>>2]=c[k>>2];c[Ta+4>>2]=c[k+4>>2];MBa(9,0,66152,Sa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4872>>3];Sa=c[jb>>2]|0;h[Sa+68272>>3]=ib;c[Ra>>2]=c[Sa+68212>>2];Sa=Ra+4|0;h[k>>3]=ib;c[Sa>>2]=c[k>>2];c[Sa+4>>2]=c[k+4>>2];MBa(9,0,66152,Ra);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5112>>3];Ra=c[jb>>2]|0;h[Ra+71632>>3]=ib;c[Qa>>2]=c[Ra+71572>>2];Ra=Qa+4|0;h[k>>3]=ib;c[Ra>>2]=c[k>>2];c[Ra+4>>2]=c[k+4>>2];MBa(9,0,66152,Qa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5256>>3];Qa=c[jb>>2]|0;h[Qa+73648>>3]=ib;c[Pa>>2]=c[Qa+73588>>2];Qa=Pa+4|0;h[k>>3]=ib;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];MBa(9,0,66152,Pa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5520>>3];Pa=c[jb>>2]|0;h[Pa+77344>>3]=ib;c[Oa>>2]=c[Pa+77284>>2];Pa=Oa+4|0;h[k>>3]=ib;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];MBa(9,0,66152,Oa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5600>>3];Oa=c[jb>>2]|0;h[Oa+78464>>3]=ib;c[Na>>2]=c[Oa+78404>>2];Oa=Na+4|0;h[k>>3]=ib;c[Oa>>2]=c[k>>2];c[Oa+4>>2]=c[k+4>>2];MBa(9,0,66152,Na);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5672>>3];Na=c[jb>>2]|0;h[Na+79472>>3]=ib;c[Ma>>2]=c[Na+79412>>2];Na=Ma+4|0;h[k>>3]=ib;c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];MBa(9,0,66152,Ma);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+264>>3];Ma=c[jb>>2]|0;h[Ma+3760>>3]=ib;c[La>>2]=c[Ma+3700>>2];Ma=La+4|0;h[k>>3]=ib;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];MBa(9,0,66152,La);if((c[241644>>2]|0)!=0){je[c[60540]&1023](9)}MBa(9,1,66168,Ka);if((c[241644>>2]|0)!=0){je[c[60540]&1023](9)}Z_(a);__(a);$_(a);a$(a);b$(a);c$(a);d$(a);e$(a);f$(a);g$(a);h$(a);i$(a);j$(a);k$(a);l$(a);m$(a);n$(a);o$(a);p$(a);q$(a);r$(a);s$(a);t$(a);u$(a);v$(a);w$(a);x$(a);y$(a);z$(a);A$(a);B$(a);C$(a);D$(a);E$(a);F$(a);G$(a);H$(a);I$(a);J$(a);K$(a);L$(a);M$(a);N$(a);O$(a);P$(a);Q$(a);R$(a);S$(a);T$(a);U$(a);V$(a);W$(a);X$(a);Y$(a);Z$(a);_$(a);$$(a);a0(a);b0(a);c0(a);d0(a);e0(a);f0(a);g0(a);h0(a);i0(a);j0(a);k0(a);l0(a);m0(a);n0(a);o0(a);p0(a);q0(a);r0(a);s0(a);t0(a);u0(a);v0(a);w0(a);x0(a);y0(a);z0(a);MBa(9,1,66192,Ja);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+3536>>3];Ja=c[jb>>2]|0;h[Ja+49600>>3]=ib;c[Ia>>2]=c[Ja+49508>>2];Ja=Ia+4|0;h[k>>3]=ib;c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];MBa(9,0,66216,Ia);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+96>>3];Ia=c[jb>>2]|0;h[Ia+1440>>3]=ib;c[Ha>>2]=c[Ia+1348>>2];Ia=Ha+4|0;h[k>>3]=ib;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];MBa(9,0,66216,Ha);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+104>>3];Ha=c[jb>>2]|0;h[Ha+1552>>3]=ib;c[Ga>>2]=c[Ha+1460>>2];Ha=Ga+4|0;h[k>>3]=ib;c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];MBa(9,0,66216,Ga);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+544>>3];Ga=c[jb>>2]|0;h[Ga+7712>>3]=ib;c[Fa>>2]=c[Ga+7620>>2];Ga=Fa+4|0;h[k>>3]=ib;c[Ga>>2]=c[k>>2];c[Ga+4>>2]=c[k+4>>2];MBa(9,0,66216,Fa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+112>>3];Fa=c[jb>>2]|0;h[Fa+1664>>3]=ib;c[Ea>>2]=c[Fa+1572>>2];Fa=Ea+4|0;h[k>>3]=ib;c[Fa>>2]=c[k>>2];c[Fa+4>>2]=c[k+4>>2];MBa(9,0,66216,Ea);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+120>>3];Ea=c[jb>>2]|0;h[Ea+1776>>3]=ib;c[Da>>2]=c[Ea+1684>>2];Ea=Da+4|0;h[k>>3]=ib;c[Ea>>2]=c[k>>2];c[Ea+4>>2]=c[k+4>>2];MBa(9,0,66216,Da);ib=+h[c[(c[c[hb>>2]>>2]|0)+8>>2]>>3];Da=c[jb>>2]|0;h[Da+96>>3]=ib;c[Ca>>2]=c[Da+4>>2];Da=Ca+4|0;h[k>>3]=ib;c[Da>>2]=c[k>>2];c[Da+4>>2]=c[k+4>>2];MBa(9,0,66216,Ca);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+16>>3];Ca=c[jb>>2]|0;h[Ca+320>>3]=ib;c[Ba>>2]=c[Ca+228>>2];Ca=Ba+4|0;h[k>>3]=ib;c[Ca>>2]=c[k>>2];c[Ca+4>>2]=c[k+4>>2];MBa(9,0,66216,Ba);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+696>>3];Ba=c[jb>>2]|0;h[Ba+9840>>3]=ib;c[Aa>>2]=c[Ba+9748>>2];Ba=Aa+4|0;h[k>>3]=ib;c[Ba>>2]=c[k>>2];c[Ba+4>>2]=c[k+4>>2];MBa(9,0,66216,Aa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+808>>3];Aa=c[jb>>2]|0;h[Aa+11408>>3]=ib;c[za>>2]=c[Aa+11316>>2];Aa=za+4|0;h[k>>3]=ib;c[Aa>>2]=c[k>>2];c[Aa+4>>2]=c[k+4>>2];MBa(9,0,66216,za);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+792>>3];za=c[jb>>2]|0;h[za+11184>>3]=ib;c[ya>>2]=c[za+11092>>2];za=ya+4|0;h[k>>3]=ib;c[za>>2]=c[k>>2];c[za+4>>2]=c[k+4>>2];MBa(9,0,66216,ya);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+32>>3];ya=c[jb>>2]|0;h[ya+544>>3]=ib;c[xa>>2]=c[ya+452>>2];ya=xa+4|0;h[k>>3]=ib;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];MBa(9,0,66216,xa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+48>>3];xa=c[jb>>2]|0;h[xa+768>>3]=ib;c[wa>>2]=c[xa+676>>2];xa=wa+4|0;h[k>>3]=ib;c[xa>>2]=c[k>>2];c[xa+4>>2]=c[k+4>>2];MBa(9,0,66216,wa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+992>>3];wa=c[jb>>2]|0;h[wa+13984>>3]=ib;c[va>>2]=c[wa+13892>>2];wa=va+4|0;h[k>>3]=ib;c[wa>>2]=c[k>>2];c[wa+4>>2]=c[k+4>>2];MBa(9,0,66216,va);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1104>>3];va=c[jb>>2]|0;h[va+15552>>3]=ib;c[ua>>2]=c[va+15460>>2];va=ua+4|0;h[k>>3]=ib;c[va>>2]=c[k>>2];c[va+4>>2]=c[k+4>>2];MBa(9,0,66216,ua);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1088>>3];ua=c[jb>>2]|0;h[ua+15328>>3]=ib;c[ta>>2]=c[ua+15236>>2];ua=ta+4|0;h[k>>3]=ib;c[ua>>2]=c[k>>2];c[ua+4>>2]=c[k+4>>2];MBa(9,0,66216,ta);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1192>>3];ta=c[jb>>2]|0;h[ta+16784>>3]=ib;c[sa>>2]=c[ta+16692>>2];ta=sa+4|0;h[k>>3]=ib;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];MBa(9,0,66216,sa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1296>>3];sa=c[jb>>2]|0;h[sa+18240>>3]=ib;c[ra>>2]=c[sa+18148>>2];sa=ra+4|0;h[k>>3]=ib;c[sa>>2]=c[k>>2];c[sa+4>>2]=c[k+4>>2];MBa(9,0,66216,ra);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1416>>3];ra=c[jb>>2]|0;h[ra+19920>>3]=ib;c[qa>>2]=c[ra+19828>>2];ra=qa+4|0;h[k>>3]=ib;c[ra>>2]=c[k>>2];c[ra+4>>2]=c[k+4>>2];MBa(9,0,66216,qa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1520>>3];qa=c[jb>>2]|0;h[qa+21376>>3]=ib;c[pa>>2]=c[qa+21284>>2];qa=pa+4|0;h[k>>3]=ib;c[qa>>2]=c[k>>2];c[qa+4>>2]=c[k+4>>2];MBa(9,0,66216,pa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1584>>3];pa=c[jb>>2]|0;h[pa+22272>>3]=ib;c[oa>>2]=c[pa+22180>>2];pa=oa+4|0;h[k>>3]=ib;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];MBa(9,0,66216,oa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+64>>3];oa=c[jb>>2]|0;h[oa+992>>3]=ib;c[na>>2]=c[oa+900>>2];oa=na+4|0;h[k>>3]=ib;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];MBa(9,0,66216,na);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+80>>3];na=c[jb>>2]|0;h[na+1216>>3]=ib;c[ma>>2]=c[na+1124>>2];na=ma+4|0;h[k>>3]=ib;c[na>>2]=c[k>>2];c[na+4>>2]=c[k+4>>2];MBa(9,0,66216,ma);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1744>>3];ma=c[jb>>2]|0;h[ma+24512>>3]=ib;c[la>>2]=c[ma+24420>>2];ma=la+4|0;h[k>>3]=ib;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];MBa(9,0,66216,la);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1856>>3];la=c[jb>>2]|0;h[la+26080>>3]=ib;c[ka>>2]=c[la+25988>>2];la=ka+4|0;h[k>>3]=ib;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];MBa(9,0,66216,ka);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1840>>3];ka=c[jb>>2]|0;h[ka+25856>>3]=ib;c[ja>>2]=c[ka+25764>>2];ka=ja+4|0;h[k>>3]=ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];MBa(9,0,66216,ja);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+1944>>3];ja=c[jb>>2]|0;h[ja+27312>>3]=ib;c[ia>>2]=c[ja+27220>>2];ja=ia+4|0;h[k>>3]=ib;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];MBa(9,0,66216,ia);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+128>>3];ia=c[jb>>2]|0;h[ia+1888>>3]=ib;c[ha>>2]=c[ia+1796>>2];ia=ha+4|0;h[k>>3]=ib;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];MBa(9,0,66216,ha);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+136>>3];ha=c[jb>>2]|0;h[ha+2e3>>3]=ib;c[ga>>2]=c[ha+1908>>2];ha=ga+4|0;h[k>>3]=ib;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];MBa(9,0,66216,ga);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2e3>>3];ga=c[jb>>2]|0;h[ga+28096>>3]=ib;c[fa>>2]=c[ga+28004>>2];ga=fa+4|0;h[k>>3]=ib;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];MBa(9,0,66216,fa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+144>>3];fa=c[jb>>2]|0;h[fa+2112>>3]=ib;c[ea>>2]=c[fa+2020>>2];fa=ea+4|0;h[k>>3]=ib;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];MBa(9,0,66216,ea);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+152>>3];ea=c[jb>>2]|0;h[ea+2224>>3]=ib;c[da>>2]=c[ea+2132>>2];ea=da+4|0;h[k>>3]=ib;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];MBa(9,0,66216,da);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2056>>3];da=c[jb>>2]|0;h[da+28880>>3]=ib;c[ca>>2]=c[da+28788>>2];da=ca+4|0;h[k>>3]=ib;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];MBa(9,0,66216,ca);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+160>>3];ca=c[jb>>2]|0;h[ca+2336>>3]=ib;c[ba>>2]=c[ca+2244>>2];ca=ba+4|0;h[k>>3]=ib;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];MBa(9,0,66216,ba);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+168>>3];ba=c[jb>>2]|0;h[ba+2448>>3]=ib;c[aa>>2]=c[ba+2356>>2];ba=aa+4|0;h[k>>3]=ib;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];MBa(9,0,66216,aa);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2152>>3];aa=c[jb>>2]|0;h[aa+30224>>3]=ib;c[$>>2]=c[aa+30132>>2];aa=$+4|0;h[k>>3]=ib;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];MBa(9,0,66216,$);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+176>>3];$=c[jb>>2]|0;h[$+2560>>3]=ib;c[_>>2]=c[$+2468>>2];$=_+4|0;h[k>>3]=ib;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];MBa(9,0,66216,_);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+184>>3];_=c[jb>>2]|0;h[_+2672>>3]=ib;c[Z>>2]=c[_+2580>>2];_=Z+4|0;h[k>>3]=ib;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];MBa(9,0,66216,Z);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2208>>3];Z=c[jb>>2]|0;h[Z+31008>>3]=ib;c[Y>>2]=c[Z+30916>>2];Z=Y+4|0;h[k>>3]=ib;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];MBa(9,0,66216,Y);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+192>>3];Y=c[jb>>2]|0;h[Y+2784>>3]=ib;c[X>>2]=c[Y+2692>>2];Y=X+4|0;h[k>>3]=ib;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];MBa(9,0,66216,X);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+200>>3];X=c[jb>>2]|0;h[X+2896>>3]=ib;c[W>>2]=c[X+2804>>2];X=W+4|0;h[k>>3]=ib;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];MBa(9,0,66216,W);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2264>>3];W=c[jb>>2]|0;h[W+31792>>3]=ib;c[V>>2]=c[W+31700>>2];W=V+4|0;h[k>>3]=ib;c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];MBa(9,0,66216,V);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+208>>3];V=c[jb>>2]|0;h[V+3008>>3]=ib;c[U>>2]=c[V+2916>>2];V=U+4|0;h[k>>3]=ib;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];MBa(9,0,66216,U);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+216>>3];U=c[jb>>2]|0;h[U+3120>>3]=ib;c[T>>2]=c[U+3028>>2];U=T+4|0;h[k>>3]=ib;c[U>>2]=c[k>>2];c[U+4>>2]=c[k+4>>2];MBa(9,0,66216,T);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4408>>3];T=c[jb>>2]|0;h[T+61808>>3]=ib;c[S>>2]=c[T+61716>>2];T=S+4|0;h[k>>3]=ib;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];MBa(9,0,66216,S);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4424>>3];S=c[jb>>2]|0;h[S+62032>>3]=ib;c[R>>2]=c[S+61940>>2];S=R+4|0;h[k>>3]=ib;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];MBa(9,0,66216,R);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4504>>3];R=c[jb>>2]|0;h[R+63152>>3]=ib;c[Q>>2]=c[R+63060>>2];R=Q+4|0;h[k>>3]=ib;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];MBa(9,0,66216,Q);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2272>>3];Q=c[jb>>2]|0;h[Q+31904>>3]=ib;c[P>>2]=c[Q+31812>>2];Q=P+4|0;h[k>>3]=ib;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];MBa(9,0,66216,P);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+224>>3];P=c[jb>>2]|0;h[P+3232>>3]=ib;c[O>>2]=c[P+3140>>2];P=O+4|0;h[k>>3]=ib;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];MBa(9,0,66216,O);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+232>>3];O=c[jb>>2]|0;h[O+3344>>3]=ib;c[N>>2]=c[O+3252>>2];O=N+4|0;h[k>>3]=ib;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];MBa(9,0,66216,N);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4600>>3];N=c[jb>>2]|0;h[N+64496>>3]=ib;c[M>>2]=c[N+64404>>2];N=M+4|0;h[k>>3]=ib;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];MBa(9,0,66216,M);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4616>>3];M=c[jb>>2]|0;h[M+64720>>3]=ib;c[L>>2]=c[M+64628>>2];M=L+4|0;h[k>>3]=ib;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];MBa(9,0,66216,L);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4696>>3];L=c[jb>>2]|0;h[L+65840>>3]=ib;c[K>>2]=c[L+65748>>2];L=K+4|0;h[k>>3]=ib;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];MBa(9,0,66216,K);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4720>>3];K=c[jb>>2]|0;h[K+66176>>3]=ib;c[J>>2]=c[K+66084>>2];K=J+4|0;h[k>>3]=ib;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];MBa(9,0,66216,J);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4816>>3];J=c[jb>>2]|0;h[J+67520>>3]=ib;c[I>>2]=c[J+67428>>2];J=I+4|0;h[k>>3]=ib;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];MBa(9,0,66216,I);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+240>>3];I=c[jb>>2]|0;h[I+3456>>3]=ib;c[H>>2]=c[I+3364>>2];I=H+4|0;h[k>>3]=ib;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];MBa(9,0,66216,H);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+248>>3];H=c[jb>>2]|0;h[H+3568>>3]=ib;c[G>>2]=c[H+3476>>2];H=G+4|0;h[k>>3]=ib;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];MBa(9,0,66216,G);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4872>>3];G=c[jb>>2]|0;h[G+68304>>3]=ib;c[F>>2]=c[G+68212>>2];G=F+4|0;h[k>>3]=ib;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];MBa(9,0,66216,F);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4880>>3];F=c[jb>>2]|0;h[F+68416>>3]=ib;c[E>>2]=c[F+68324>>2];F=E+4|0;h[k>>3]=ib;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];MBa(9,0,66216,E);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+4952>>3];E=c[jb>>2]|0;h[E+69424>>3]=ib;c[D>>2]=c[E+69332>>2];E=D+4|0;h[k>>3]=ib;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];MBa(9,0,66216,D);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5024>>3];D=c[jb>>2]|0;h[D+70432>>3]=ib;c[C>>2]=c[D+70340>>2];D=C+4|0;h[k>>3]=ib;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];MBa(9,0,66216,C);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5032>>3];C=c[jb>>2]|0;h[C+70544>>3]=ib;c[B>>2]=c[C+70452>>2];C=B+4|0;h[k>>3]=ib;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];MBa(9,0,66216,B);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5112>>3];B=c[jb>>2]|0;h[B+71664>>3]=ib;c[A>>2]=c[B+71572>>2];B=A+4|0;h[k>>3]=ib;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];MBa(9,0,66216,A);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5120>>3];A=c[jb>>2]|0;h[A+71776>>3]=ib;c[z>>2]=c[A+71684>>2];A=z+4|0;h[k>>3]=ib;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];MBa(9,0,66216,z);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5192>>3];z=c[jb>>2]|0;h[z+72784>>3]=ib;c[y>>2]=c[z+72692>>2];z=y+4|0;h[k>>3]=ib;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(9,0,66216,y);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5256>>3];y=c[jb>>2]|0;h[y+73680>>3]=ib;c[x>>2]=c[y+73588>>2];y=x+4|0;h[k>>3]=ib;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];MBa(9,0,66216,x);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5264>>3];x=c[jb>>2]|0;h[x+73792>>3]=ib;c[w>>2]=c[x+73700>>2];x=w+4|0;h[k>>3]=ib;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];MBa(9,0,66216,w);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5328>>3];w=c[jb>>2]|0;h[w+74688>>3]=ib;c[v>>2]=c[w+74596>>2];w=v+4|0;h[k>>3]=ib;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];MBa(9,0,66216,v);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5392>>3];v=c[jb>>2]|0;h[v+75584>>3]=ib;c[u>>2]=c[v+75492>>2];v=u+4|0;h[k>>3]=ib;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];MBa(9,0,66216,u);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5456>>3];u=c[jb>>2]|0;h[u+76480>>3]=ib;c[t>>2]=c[u+76388>>2];u=t+4|0;h[k>>3]=ib;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];MBa(9,0,66216,t);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5520>>3];t=c[jb>>2]|0;h[t+77376>>3]=ib;c[s>>2]=c[t+77284>>2];t=s+4|0;h[k>>3]=ib;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];MBa(9,0,66216,s);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5528>>3];s=c[jb>>2]|0;h[s+77488>>3]=ib;c[r>>2]=c[s+77396>>2];s=r+4|0;h[k>>3]=ib;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];MBa(9,0,66216,r);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5608>>3];r=c[jb>>2]|0;h[r+78608>>3]=ib;c[q>>2]=c[r+78516>>2];r=q+4|0;h[k>>3]=ib;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(9,0,66216,q);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5680>>3];q=c[jb>>2]|0;h[q+79616>>3]=ib;c[p>>2]=c[q+79524>>2];q=p+4|0;h[k>>3]=ib;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];MBa(9,0,66216,p);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5736>>3];p=c[jb>>2]|0;h[p+80400>>3]=ib;c[o>>2]=c[p+80308>>2];p=o+4|0;h[k>>3]=ib;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];MBa(9,0,66216,o);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5800>>3];o=c[jb>>2]|0;h[o+81296>>3]=ib;c[n>>2]=c[o+81204>>2];o=n+4|0;h[k>>3]=ib;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];MBa(9,0,66216,n);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5872>>3];n=c[jb>>2]|0;h[n+82304>>3]=ib;c[m>>2]=c[n+82212>>2];n=m+4|0;h[k>>3]=ib;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];MBa(9,0,66216,m);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+5952>>3];m=c[jb>>2]|0;h[m+83424>>3]=ib;c[l>>2]=c[m+83332>>2];m=l+4|0;h[k>>3]=ib;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];MBa(9,0,66216,l);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+6032>>3];l=c[jb>>2]|0;h[l+84544>>3]=ib;c[j>>2]=c[l+84452>>2];l=j+4|0;h[k>>3]=ib;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];MBa(9,0,66216,j);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+6304>>3];j=c[jb>>2]|0;h[j+88352>>3]=ib;c[g>>2]=c[j+88260>>2];j=g+4|0;h[k>>3]=ib;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];MBa(9,0,66216,g);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+6352>>3];g=c[jb>>2]|0;h[g+89024>>3]=ib;c[f>>2]=c[g+88932>>2];g=f+4|0;h[k>>3]=ib;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];MBa(9,0,66216,f);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2336>>3];f=c[jb>>2]|0;h[f+32800>>3]=ib;c[e>>2]=c[f+32708>>2];f=e+4|0;h[k>>3]=ib;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];MBa(9,0,66216,e);ib=+h[(c[(c[c[hb>>2]>>2]|0)+8>>2]|0)+2376>>3];hb=c[jb>>2]|0;h[hb+33360>>3]=ib;c[d>>2]=c[hb+33268>>2];hb=d+4|0;h[k>>3]=ib;c[hb>>2]=c[k>>2];c[hb+4>>2]=c[k+4>>2];MBa(9,0,66216,d);if((c[241644>>2]|0)==0){i=b;return 0}je[c[60540]&1023](9);i=b;return 0}function Y0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=.018015268;i=i;return}function Z0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=461.5236365065454;i=i;return}function _0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=1.0;i=i;return}function $0(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=0;i=i;return}function a1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=0;i=i;return}function b1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function c1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function d1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function e1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=0.0;i=i;return}function f1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function g1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function h1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function i1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function j1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function k1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function l1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function m1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function n1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6912>>3]=0.0;i=i;return}function o1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=0.0;i=i;return}function p1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function q1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6936>>3]=0.0;i=i;return}function r1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=0.0;i=i;return}function s1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function t1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=0.0;i=i;return}function u1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function v1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=0.0;i=i;return}function w1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function x1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function y1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function z1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7008>>3]=0.0;i=i;return}function A1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function B1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function C1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=0.0;i=i;return}function D1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function E1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function F1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function G1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function H1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function I1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function J1(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function K1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=0;i=i;return}function L1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function M1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function N1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=0;i=i;return}function O1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=0;i=i;return}function P1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=0;i=i;return}function Q1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=0;i=i;return}function R1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function S1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function T1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function U1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=0;i=i;return}function V1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function W1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function X1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=0;i=i;return}function Y1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function Z1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function _1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function $1(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=0;i=i;return}function a2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=0;i=i;return}function b2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function c2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=0;i=i;return}function d2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function e2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=0;i=i;return}function f2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=0;i=i;return}function g2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=0;i=i;return}function h2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function i2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=0;i=i;return}function j2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=0;i=i;return}function k2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=0;i=i;return}function l2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=0;i=i;return}function m2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=0;i=i;return}function n2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=0;i=i;return}function o2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=0;i=i;return}function p2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=0;i=i;return}function q2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=.018015268;i=i;return}function r2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=461.5236365065454;i=i;return}function s2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=1.0;i=i;return}function t2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=0;i=i;return}function u2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=0;i=i;return}function v2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=.018015268;i=i;return}function w2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7120>>3]=461.5236365065454;i=i;return}function x2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function y2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=.01041879415735609;i=i;return}function z2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=0;i=i;return}function A2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function B2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=.018015268;i=i;return}function C2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7144>>3]=461.5236365065454;i=i;return}function D2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=1.0;i=i;return}function E2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=.01041879415735609;i=i;return}function F2(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=0;i=i;return}function G2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7152>>3]=0.0;i=i;return}function H2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=.018015268;i=i;return}function I2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=461.5236365065454;i=i;return}function J2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=1.0;i=i;return}function K2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=0.0;i=i;return}function L2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7176>>3]=.018015268;i=i;return}function M2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=461.5236365065454;i=i;return}function N2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=1.0;i=i;return}function O2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=0.0;i=i;return}function P2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=.018015268;i=i;return}function Q2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=461.5236365065454;i=i;return}function R2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=1.0;i=i;return}function S2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=0.0;i=i;return}function T2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=0.0;i=i;return}function U2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=.018015268;i=i;return}function V2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=461.5236365065454;i=i;return}function W2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=1.0;i=i;return}function X2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function Y2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=.018015268;i=i;return}function Z2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=461.5236365065454;i=i;return}function _2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=1.0;i=i;return}function $2(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function a3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=.018015268;i=i;return}function b3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=461.5236365065454;i=i;return}function c3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=1.0;i=i;return}function d3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function e3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=.018015268;i=i;return}function f3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=461.5236365065454;i=i;return}function g3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=1.0;i=i;return}function h3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=.018015268;i=i;return}function i3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=461.5236365065454;i=i;return}function j3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=1.0;i=i;return}function k3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=.018015268;i=i;return}function l3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=461.5236365065454;i=i;return}function m3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=1.0;i=i;return}function n3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=0;i=i;return}function o3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=0;i=i;return}function p3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=.018015268;i=i;return}function q3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=461.5236365065454;i=i;return}function r3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=1.0;i=i;return}function s3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=.018015268;i=i;return}function t3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=461.5236365065454;i=i;return}function u3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=1.0;i=i;return}function v3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=0;i=i;return}function w3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=0;i=i;return}function x3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=.018015268;i=i;return}function y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=461.5236365065454;i=i;return}function z3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=1.0;i=i;return}function A3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=.018015268;i=i;return}function B3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=461.5236365065454;i=i;return}function C3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=1.0;i=i;return}function D3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=0;i=i;return}function E3(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=0;i=i;return}function F3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=0.0;i=i;return}function G3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function H3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=+h[b+672>>3]*+h[b+4736>>3];i=i;return}function I3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+672>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=b*b*3.141592653589793;i=i;return}function J3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=+h[b+272>>3]*+h[b+3032>>3];i=i;return}function K3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+272>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=b*b*3.141592653589793;i=i;return}function L3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=+h[b+232>>3]*+h[b+2920>>3];i=i;return}function M3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+232>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=b*b*3.141592653589793;i=i;return}function N3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=+h[b+192>>3]*+h[b+2808>>3];i=i;return}function O3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+192>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=b*b*3.141592653589793;i=i;return}function P3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=+h[b+160>>3]*+h[b+2808>>3];i=i;return}function Q3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+160>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=b*b*3.141592653589793;i=i;return}function R3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=+h[b+120>>3]*+h[b+2696>>3];i=i;return}function S3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+120>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=b*b*3.141592653589793;i=i;return}function T3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=+h[b+80>>3]*+h[b+2440>>3];i=i;return}function U3(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+80>>3]*.5;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=b*b*3.141592653589793;i=i;return}function V3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=0.0;i=i;return}function W3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=0.0;i=i;return}function X3(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+776>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=+h[d>>3];i=b;return}function Y3(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7536>>3]=+h[(c[a+416>>2]|0)+776>>3]*1.0e-5;i=i;return}function Z3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;mu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nv(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7544>>3]=+h[f>>3];i=b;return}function _3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;Xu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nv(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=+h[f>>3];i=b;return}function $3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;mu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nu(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7560>>3]=+h[f>>3];i=b;return}function a4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;Xu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nu(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7568>>3]=+h[f>>3];i=b;return}function b4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+115|0]=1;i=i;return}function c4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+116|0]=1;i=i;return}function d4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+117|0]=1;i=i;return}function e4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=1.0e-4;i=i;return}function f4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=1.0e-4;i=i;return}function g4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function h4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function i4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function j4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function k4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function l4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function m4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function n4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function o4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function p4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function q4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=0;i=i;return}function r4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function s4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function t4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function u4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=0.0;i=i;return}function v4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function w4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function x4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=0.0;i=i;return}function y4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function z4(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function A4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function B4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function C4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=3.0;i=i;return}function D4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=0.0;i=i;return}function E4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=3.0;i=i;return}function F4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+118|0]=0;i=i;return}function G4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+119|0]=0;i=i;return}function H4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+120|0]=0;i=i;return}function I4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+121|0]=0;i=i;return}function J4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+122|0]=0;i=i;return}function K4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function L4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function M4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function N4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=0.0;i=i;return}function O4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function P4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function Q4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function R4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function S4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function T4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function U4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function V4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=0.0;i=i;return}function W4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function X4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+123|0]=0;i=i;return}function Y4(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+124|0]=0;i=i;return}function Z4(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function _4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+416|0;a=c[g>>2]|0;j=+h[a+776>>3];k=+h[a+760>>3];a=d;l=66232;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];qt(e,f,j,k,d,0);h[(c[g>>2]|0)+768>>3]=+h[e>>3];i=b;return}function $4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40>>3]=+h[b+736>>3];i=i;return}function a5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+2520>>3];i=i;return}function b5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+2568>>3];i=i;return}function c5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+2536>>3];i=i;return}function d5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+2568>>3];i=i;return}function e5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+2536>>3];i=i;return}function f5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1032>>3]=+h[b+992>>3];i=i;return}function g5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+2568>>3];i=i;return}function h5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1160>>3]=+h[b+2536>>3];i=i;return}function i5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+2568>>3];i=i;return}function j5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+2536>>3];i=i;return}function k5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+2568>>3];i=i;return}function l5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1272>>3]=+h[b+2536>>3];i=i;return}function m5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1288>>3]=+h[b+2568>>3];i=i;return}function n5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+2536>>3];i=i;return}function o5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1344>>3]=+h[b+2568>>3];i=i;return}function p5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1384>>3]=+h[b+2536>>3];i=i;return}function q5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1400>>3]=+h[b+2568>>3];i=i;return}function r5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+2536>>3];i=i;return}function s5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+2568>>3];i=i;return}function t5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+2536>>3];i=i;return}function u5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+2568>>3];i=i;return}function v5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+2536>>3];i=i;return}function w5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+2568>>3];i=i;return}function x5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1608>>3]=+h[b+2536>>3];i=i;return}function y5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1624>>3]=+h[b+2568>>3];i=i;return}function z5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1664>>3]=+h[b+2536>>3];i=i;return}function A5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1680>>3]=+h[b+2568>>3];i=i;return}function B5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+2536>>3];i=i;return}function C5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+2568>>3];i=i;return}function D5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+2536>>3];i=i;return}function E5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1792>>3]=+h[b+2568>>3];i=i;return}function F5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1832>>3]=+h[b+2536>>3];i=i;return}function G5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1848>>3]=+h[b+2568>>3];i=i;return}function H5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1888>>3]=+h[b+2536>>3];i=i;return}function I5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1904>>3]=+h[b+2568>>3];i=i;return}function J5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1944>>3]=+h[b+2536>>3];i=i;return}function K5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1960>>3]=+h[b+2568>>3];i=i;return}function L5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+2536>>3];i=i;return}function M5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2016>>3]=+h[b+2568>>3];i=i;return}function N5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+2536>>3];i=i;return}function O5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2104>>3]=+h[b+2568>>3];i=i;return}function P5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2144>>3]=+h[b+2536>>3];i=i;return}function Q5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2216>>3]=+h[b+2160>>3];i=i;return}function R5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2248>>3]=+h[b+2232>>3];i=i;return}function S5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+80|0;d=b;e=b+16|0;f=b+32|0;g=b+48|0;j=b+64|0;k=b+72|0;l=a+536|0;m=c[l>>2]|0;n=g;o=66248;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];o=f;n=66264;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Lt(j,m,.0001001797131419643,g,f);p=+h[j>>3];j=c[l>>2]|0;l=e;f=66248;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=d;l=66264;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];Lt(k,j,0.0,e,d);h[(c[a+416>>2]|0)+2256>>3]=p- +h[k>>3];i=b;return}function T5(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+166|0]=a[d+159|0]|0;i=i;return}function U5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2272>>3]=+h[b+2520>>3];i=i;return}function V5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2336>>3]=+h[b+2280>>3];i=i;return}function W5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2368>>3]=+h[b+2352>>3];i=i;return}function X5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+80|0;d=b;e=b+16|0;f=b+32|0;g=b+48|0;j=b+64|0;k=b+72|0;l=a+536|0;m=c[l>>2]|0;n=g;o=66248;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];o=f;n=66264;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];Lt(j,m,.0001001797131419643,g,f);p=+h[j>>3];j=c[l>>2]|0;l=e;f=66248;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=d;l=66264;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];Lt(k,j,0.0,e,d);h[(c[a+416>>2]|0)+2376>>3]=p- +h[k>>3];i=b;return}function Y5(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+179|0]=a[d+172|0]|0;i=i;return}function Z5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2392>>3]=+h[b+2520>>3];i=i;return}function _5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2456>>3]=+h[b+2512>>3];i=i;return}function $5(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=+h[(c[a+416>>2]|0)+2456>>3]*1.0e-5;i=i;return}function a6(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2456>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=+h[d>>3];i=b;return}function b6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2464>>3]=+h[b+2520>>3];i=i;return}function c6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2472>>3]=+h[b+2568>>3];i=i;return}function d6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+2456>>3];i=i;return}function e6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+186|0]=a[d+181|0]|0;i=i;return}function f6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2504>>3]=+h[b+2520>>3];i=i;return}function g6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2544>>3]=+h[b+2568>>3]*100.0;i=i;return}function h6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2576>>3]=+h[b+2512>>3];i=i;return}function i6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2136>>3]=+h[b+2576>>3]*.01;i=i;return}function j6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2096>>3]=+h[b+2576>>3];i=i;return}function k6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2048>>3]=+h[b+2576>>3]*.01;i=i;return}function l6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1992>>3]=+h[b+2576>>3]*.01;i=i;return}function m6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1936>>3]=+h[b+2576>>3]*.01;i=i;return}function n6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1880>>3]=+h[b+2576>>3]*.01;i=i;return}function o6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1824>>3]=+h[b+2576>>3]*.01;i=i;return}function p6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+2576>>3]*.01;i=i;return}function q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+2576>>3]*.01;i=i;return}function r6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1656>>3]=+h[b+2576>>3]*.01;i=i;return}function s6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+2576>>3]*.01;i=i;return}function t6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+2576>>3]*.01;i=i;return}function u6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+2576>>3]*.01;i=i;return}function v6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1432>>3]=+h[b+2576>>3]*.01;i=i;return}function w6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1376>>3]=+h[b+2576>>3]*.01;i=i;return}function x6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1320>>3]=+h[b+2576>>3]*.01;i=i;return}function y6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1264>>3]=+h[b+2576>>3]*.01;i=i;return}function z6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+2576>>3]*.01;i=i;return}function A6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+2576>>3]*.01;i=i;return}function B6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+2576>>3]*.01;i=i;return}function C6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+2576>>3]*.01;i=i;return}function D6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2584>>3]=+h[b+2520>>3];i=i;return}function E6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2584>>3];i=i;return}function F6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+112>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2488>>3];l=+h[a+2400>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2408>>3]=+h[f>>3];i=b;return}function G6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2456>>3],+h[k+2408>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2456>>3];m=+h[g+2408>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=+h[f>>3];i=b;return}function H6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2456>>3],+h[k+2408>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2456>>3];m=+h[g+2408>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=+h[f>>3];i=b;return}function I6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2296>>3]=+h[b+2584>>3];i=i;return}function J6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+72>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2368>>3];l=+h[a+2296>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Kt(f,j,k,l,d,0);h[(c[g>>2]|0)+2304>>3]=+h[f>>3];i=b;return}function K6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2176>>3]=+h[b+2584>>3];i=i;return}function L6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+64>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2248>>3];l=+h[a+2176>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Kt(f,j,k,l,d,0);h[(c[g>>2]|0)+2184>>3]=+h[f>>3];i=b;return}function M6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2072>>3]=+h[b+2584>>3];i=i;return}function N6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+56>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2096>>3];l=+h[a+2072>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Ct(f,j,k,l,d,0);h[(c[g>>2]|0)+2080>>3]=+h[f>>3];i=b;return}function O6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2616>>3]=+h[b+2600>>3];i=i;return}function P6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2632>>3];i=i;return}function Q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2584>>3];i=i;return}function R6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2712>>3]=+h[b+2512>>3];i=i;return}function S6(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=+h[(c[a+416>>2]|0)+2712>>3]*1.0e-5;i=i;return}function T6(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2712>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=+h[d>>3];i=b;return}function U6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2520>>3];i=i;return}function V6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2728>>3]=+h[b+2568>>3];i=i;return}function W6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2744>>3]=+h[b+2712>>3];i=i;return}function X6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+152>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2744>>3];l=+h[a+2656>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2664>>3]=+h[f>>3];i=b;return}function Y6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2712>>3],+h[k+2664>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2712>>3];m=+h[g+2664>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=+h[f>>3];i=b;return}function Z6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2712>>3],+h[k+2664>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2712>>3];m=+h[g+2664>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=+h[f>>3];i=b;return}function _6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+195|0]=a[d+190|0]|0;i=i;return}function $6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2520>>3];i=i;return}function a7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2768>>3]=+h[b+2584>>3];i=i;return}function b7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2824>>3]=+h[b+2512>>3];i=i;return}function c7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7512>>3]=+h[(c[a+416>>2]|0)+2824>>3]*1.0e-5;i=i;return}function d7(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2824>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=+h[d>>3];i=b;return}function e7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2832>>3]=+h[b+2520>>3];i=i;return}function f7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2568>>3];i=i;return}function g7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2856>>3]=+h[b+2824>>3];i=i;return}function h7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+224>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2856>>3];l=+h[a+2768>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2776>>3]=+h[f>>3];i=b;return}function i7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[f>>3];i=b;return}function j7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=+h[f>>3];i=b;return}function k7(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+3008>>3],+h[f+3016>>3],+h[(c[a+416>>2]|0)+2824>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2896>>3]=+h[d>>3];i=b;return}function l7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=+h[b+2776>>3]+ +h[b+2528>>3]*+h[b+3360>>3];i=i;return}function m7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=+h[f>>3];i=b;return}function n7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2824>>3],+h[k+2776>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2824>>3];m=+h[g+2776>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[f>>3];i=b;return}function o7(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+2976>>3],+h[f+2984>>3],+h[(c[a+416>>2]|0)+2824>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2912>>3]=+h[d>>3];i=b;return}function p7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7352>>3]=+h[b+2776>>3]+ +h[b+2528>>3]*+h[b+3544>>3];i=i;return}function q7(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+202|0]=a[d+197|0]|0;i=i;return}function r7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2872>>3]=+h[b+2520>>3];i=i;return}function s7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2584>>3];i=i;return}function t7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2936>>3]=+h[b+2512>>3];i=i;return}function u7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=+h[(c[a+416>>2]|0)+2936>>3]*1.0e-5;i=i;return}function v7(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+2936>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=+h[d>>3];i=b;return}function w7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2944>>3]=+h[b+2520>>3];i=i;return}function x7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2952>>3]=+h[b+2568>>3];i=i;return}function y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2968>>3]=+h[b+2936>>3];i=i;return}function z7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+264>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+2968>>3];l=+h[a+2880>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+2888>>3]=+h[f>>3];i=b;return}function A7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2936>>3],+h[k+2888>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2936>>3];m=+h[g+2888>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=+h[f>>3];i=b;return}function B7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+2936>>3],+h[k+2888>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+2936>>3];m=+h[g+2888>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=+h[f>>3];i=b;return}function C7(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+209|0]=a[d+204|0]|0;i=i;return}function D7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2984>>3]=+h[b+2520>>3];i=i;return}function E7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2512>>3];i=i;return}function F7(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=+h[(c[a+416>>2]|0)+3048>>3]*1.0e-5;i=i;return}function G7(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Au(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+3048>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7376>>3]=+h[d>>3];i=b;return}function H7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2520>>3];i=i;return}function I7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3064>>3]=+h[b+2568>>3];i=i;return}function J7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3080>>3]=+h[b+3048>>3];i=i;return}function K7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+304>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+3080>>3];l=+h[a+2992>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vt(f,j,k,l,d,0);h[(c[g>>2]|0)+3e3>>3]=+h[f>>3];i=b;return}function L7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+3048>>3],+h[k+3e3>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+3048>>3];m=+h[g+3e3>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));mv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7472>>3]=+h[f>>3];i=b;return}function M7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;fv(e,c[g>>2]|0,+h[k+3048>>3],+h[k+3e3>>3],0,0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+3048>>3];m=+h[g+3e3>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));qv(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=+h[f>>3];i=b;return}function N7(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+216|0]=a[d+211|0]|0;i=i;return}function O7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3096>>3]=+h[b+2520>>3];i=i;return}function P7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+720>>3];i=i;return}function Q7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3160>>3]=+h[b+2576>>3];i=i;return}function R7(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3120>>3];h[b+3176>>3]=d*d*.7853981633974483;i=i;return}function S7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3184>>3]=+h[b+3120>>3]*3.141592653589793;i=i;return}function T7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3160>>3];i=i;return}function U7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+312>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+3160>>3]+ +h[a+3192>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+3152>>3]=+h[f>>3];i=b;return}function V7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3208>>3]=+h[b+3104>>3];i=i;return}function W7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3216>>3]=+h[b+3160>>3];i=i;return}function X7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3224>>3]=+h[b+3192>>3];i=i;return}function Y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3256>>3]=+h[b+2568>>3];i=i;return}function Z7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3248>>3]=+h[b+3256>>3]*100.0;i=i;return}function _7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3272>>3]=+h[b+2528>>3];i=i;return}function $7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+336>>3]=+h[b+3112>>3]*.5;i=i;return}function a8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=+h[b+336>>3]*+h[b+3184>>3];i=i;return}function b8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+3112>>3]*.5;i=i;return}function c8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=+h[b+336>>3]+ +h[b+344>>3];i=i;return}function d8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=+h[b+344>>3]*+h[b+3184>>3];i=i;return}function e8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+3176>>3];i=i;return}function f8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=+h[b+352>>3]*+h[b+336>>3]*+h[b+3104>>3];i=i;return}function g8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+3176>>3];i=i;return}function h8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=+h[b+360>>3]*+h[b+344>>3]*+h[b+3104>>3];i=i;return}function i8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3184>>3];j=+h[f+3176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66288,66280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+368>>3]=l*4.0;i=d;return}function j8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+3184>>3];j=+h[f+3176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66288,66312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+376>>3]=l*4.0;i=d;return}function k8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=(+h[b+368>>3]+ +h[b+376>>3])*.5;i=i;return}function l8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+3128>>3];i=i;return}function m8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+3128>>3];i=i;return}function n8(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3208>>3];m=+h[k+3248>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66328,66320,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3208>>3];o=r;p=q}}while(0);l=+h[o+3288>>3];m=+h[o+3296>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3184>>3];t=+h[s+3024>>3];u=(+h[o+384>>3]+ +h[o+392>>3])*.5;v=+h[o+3256>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,66328,66320,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+3232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7288>>3]=+h[e>>3];i=d;return}function o8(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+236|0]=a[d+222|0]|0;i=i;return}function p8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3312>>3]=+h[b+3104>>3];i=i;return}function q8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3320>>3]=+h[b+2520>>3];i=i;return}function r8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3344>>3]=+h[b+720>>3];i=i;return}function s8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+2576>>3];i=i;return}function t8(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3344>>3];h[b+3384>>3]=d*d*.7853981633974483;i=i;return}function u8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+3344>>3]*3.141592653589793;i=i;return}function v8(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3392>>3];g=+h[e+3384>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66368,66360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=j*4.0;i=d;return}function w8(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3392>>3];g=+h[e+3384>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66368,66392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=j*4.0;i=d;return}function x8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=(+h[b+3200>>3]+ +h[b+3208>>3])*.5;i=i;return}function y8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+3368>>3];i=i;return}function z8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3328>>3];i=i;return}function A8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3368>>3];i=i;return}function B8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3400>>3];i=i;return}function C8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+2568>>3];i=i;return}function D8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3464>>3]*100.0;i=i;return}function E8(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3416>>3];m=+h[k+3456>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66408,66400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3416>>3];o=r;p=q}}while(0);l=+h[o+3496>>3];m=+h[o+3504>>3];q=+h[o+3336>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2992>>3];t=+h[o+3352>>3];u=(t+t)*.5;t=+h[o+3464>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,66408,66400,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3440>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7296>>3]=+h[e>>3];i=d;return}function F8(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+472>>2]=(c[b+468>>2]|0)+ -1;i=i;return}function G8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3480>>3]=+h[b+2528>>3];i=i;return}function H8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3528>>3]=+h[b+720>>3];i=i;return}function I8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3552>>3]=+h[b+2576>>3];i=i;return}function J8(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3528>>3];h[b+3568>>3]=d*d*.7853981633974483;i=i;return}function K8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3576>>3]=+h[b+3528>>3]*3.141592653589793;i=i;return}function L8(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3576>>3];g=+h[e+3568>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66448,66440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=j*4.0;i=d;return}function M8(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3576>>3];g=+h[e+3568>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66448,66472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=j*4.0;i=d;return}function N8(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2960>>3]=(+h[b+3224>>3]+ +h[b+3232>>3])*.5;i=i;return}function O8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3584>>3]=+h[b+3552>>3];i=i;return}function P8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3600>>3]=+h[b+3512>>3];i=i;return}function Q8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3608>>3]=+h[b+3552>>3];i=i;return}function R8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3616>>3]=+h[b+3584>>3];i=i;return}function S8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3648>>3]=+h[b+2568>>3];i=i;return}function T8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3640>>3]=+h[b+3648>>3]*100.0;i=i;return}function U8(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3600>>3];m=+h[k+3640>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66488,66480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3600>>3];o=r;p=q}}while(0);l=+h[o+3680>>3];m=+h[o+3688>>3];q=+h[o+3520>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2960>>3];t=+h[o+3536>>3];u=(t+t)*.5;t=+h[o+3648>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,66488,66480,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3624>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7304>>3]=+h[e>>3];i=d;return}function V8(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+484>>2]=(c[b+480>>2]|0)+ -1;i=i;return}function W8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3664>>3]=+h[b+2528>>3];i=i;return}function X8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3712>>3]=+h[b+720>>3];i=i;return}function Y8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3736>>3]=+h[b+2576>>3];i=i;return}function Z8(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3712>>3];h[b+3752>>3]=d*d*.7853981633974483;i=i;return}function _8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3760>>3]=+h[b+3712>>3]*3.141592653589793;i=i;return}function $8(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3760>>3];g=+h[e+3752>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66528,66520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=j*4.0;i=d;return}function a9(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3760>>3];g=+h[e+3752>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66528,66552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=j*4.0;i=d;return}function b9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2952>>3]=(+h[b+3248>>3]+ +h[b+3256>>3])*.5;i=i;return}function c9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3768>>3]=+h[b+3736>>3];i=i;return}function d9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3784>>3]=+h[b+3696>>3];i=i;return}function e9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3792>>3]=+h[b+3736>>3];i=i;return}function f9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3800>>3]=+h[b+3768>>3];i=i;return}function g9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3832>>3]=+h[b+2568>>3];i=i;return}function h9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3824>>3]=+h[b+3832>>3]*100.0;i=i;return}function i9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3784>>3];m=+h[k+3824>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66568,66560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3784>>3];o=r;p=q}}while(0);l=+h[o+3864>>3];m=+h[o+3872>>3];q=+h[o+3704>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2952>>3];t=+h[o+3720>>3];u=(t+t)*.5;t=+h[o+3832>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,66568,66560,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3808>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7312>>3]=+h[e>>3];i=d;return}function j9(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+496>>2]=(c[b+492>>2]|0)+ -1;i=i;return}function k9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3848>>3]=+h[b+2528>>3];i=i;return}function l9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3896>>3]=+h[b+720>>3];i=i;return}function m9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3920>>3]=+h[b+2576>>3];i=i;return}function n9(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+3896>>3];h[b+3936>>3]=d*d*.7853981633974483;i=i;return}function o9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+3896>>3]*3.141592653589793;i=i;return}function p9(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3944>>3];g=+h[e+3936>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66608,66600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=j*4.0;i=d;return}function q9(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+3944>>3];g=+h[e+3936>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66608,66632,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=j*4.0;i=d;return}function r9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2944>>3]=(+h[b+3272>>3]+ +h[b+3280>>3])*.5;i=i;return}function s9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3952>>3]=+h[b+3920>>3];i=i;return}function t9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3968>>3]=+h[b+3880>>3];i=i;return}function u9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3976>>3]=+h[b+3920>>3];i=i;return}function v9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3984>>3]=+h[b+3952>>3];i=i;return}function w9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4016>>3]=+h[b+2568>>3];i=i;return}function x9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4008>>3]=+h[b+4016>>3]*100.0;i=i;return}function y9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+3968>>3];m=+h[k+4008>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66648,66640,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+3968>>3];o=r;p=q}}while(0);l=+h[o+4048>>3];m=+h[o+4056>>3];q=+h[o+3888>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2944>>3];t=+h[o+3904>>3];u=(t+t)*.5;t=+h[o+4016>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,66648,66640,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+3992>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7320>>3]=+h[e>>3];i=d;return}function z9(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+508>>2]=(c[b+504>>2]|0)+ -1;i=i;return}function A9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4032>>3]=+h[b+2528>>3];i=i;return}function B9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4080>>3]=+h[b+720>>3];i=i;return}function C9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4104>>3]=+h[b+2576>>3];i=i;return}function D9(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4080>>3];h[b+4120>>3]=d*d*.7853981633974483;i=i;return}function E9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4128>>3]=+h[b+4080>>3]*3.141592653589793;i=i;return}function F9(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4128>>3];g=+h[e+4120>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66688,66680,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=j*4.0;i=d;return}function G9(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+4128>>3];g=+h[e+4120>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66688,66712,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=j*4.0;i=d;return}function H9(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2936>>3]=(+h[b+3296>>3]+ +h[b+3304>>3])*.5;i=i;return}function I9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4136>>3]=+h[b+4104>>3];i=i;return}function J9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4152>>3]=+h[b+4064>>3];i=i;return}function K9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4160>>3]=+h[b+4104>>3];i=i;return}function L9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4168>>3]=+h[b+4136>>3];i=i;return}function M9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4200>>3]=+h[b+2568>>3];i=i;return}function N9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4192>>3]=+h[b+4200>>3]*100.0;i=i;return}function O9(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4152>>3];m=+h[k+4192>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66728,66720,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4152>>3];o=r;p=q}}while(0);l=+h[o+4232>>3];m=+h[o+4240>>3];q=+h[o+4072>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+2936>>3];t=+h[o+4088>>3];u=(t+t)*.5;t=+h[o+4200>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+SBa(c[f>>2]|0,n,66728,66720,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);cu(e,g,p,l,l,m,m,q,s,u,w,+h[v+4176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7328>>3]=+h[e>>3];i=d;return}function P9(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+520>>2]=(c[b+516>>2]|0)+ -1;i=i;return}function Q9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4216>>3]=+h[b+2528>>3];i=i;return}function R9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4264>>3]=+h[b+720>>3];i=i;return}function S9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4304>>3]=+h[b+2576>>3];i=i;return}function T9(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4264>>3];h[b+4320>>3]=d*d*.7853981633974483;i=i;return}function U9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4328>>3]=+h[b+4264>>3]*3.141592653589793;i=i;return}function V9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4336>>3]=+h[b+4304>>3];i=i;return}function W9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+432>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+4304>>3]+ +h[a+4336>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+4296>>3]=+h[f>>3];i=b;return}function X9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4352>>3]=+h[b+4248>>3];i=i;return}function Y9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4360>>3]=+h[b+4304>>3];i=i;return}function Z9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4368>>3]=+h[b+4336>>3];i=i;return}function _9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4400>>3]=+h[b+2568>>3];i=i;return}function $9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4392>>3]=+h[b+4400>>3]*100.0;i=i;return}function aaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4416>>3]=+h[b+2528>>3];i=i;return}function baa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+4256>>3]*.5;i=i;return}function caa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=+h[b+456>>3]*+h[b+4328>>3];i=i;return}function daa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+4256>>3]*.5;i=i;return}function eaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=+h[b+456>>3]+ +h[b+464>>3];i=i;return}function faa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=+h[b+464>>3]*+h[b+4328>>3];i=i;return}function gaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+4320>>3];i=i;return}function haa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=+h[b+472>>3]*+h[b+456>>3]*+h[b+4248>>3];i=i;return}function iaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+4320>>3];i=i;return}function jaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=+h[b+480>>3]*+h[b+464>>3]*+h[b+4248>>3];i=i;return}function kaa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4328>>3];j=+h[f+4320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66768,66760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+488>>3]=l*4.0;i=d;return}function laa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+4328>>3];j=+h[f+4320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+SBa(c[b+536>>2]|0,g,66768,66792,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+496>>3]=l*4.0;i=d;return}function maa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=(+h[b+488>>3]+ +h[b+496>>3])*.5;i=i;return}function naa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+4272>>3];i=i;return}function oaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+4272>>3];i=i;return}function paa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0.0,y=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+4352>>3];m=+h[k+4392>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+SBa(g,l,66808,66800,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+4352>>3];o=r;p=q}}while(0);l=+h[o+4432>>3];m=+h[o+4440>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=c[r+8>>2]|0;q=+h[s+3344>>3];t=+h[s+2928>>3];u=(+h[o+504>>3]+ +h[o+512>>3])*.5;v=+h[o+4400>>3];do{if(n!=0.0){w=o;x=v/n}else{if(v==0.0){w=o;x=v;break}y=v/+SBa(c[f>>2]|0,n,66808,66800,+h[r>>3],(a[b+319|0]|0)!=0|0);w=c[j>>2]|0;x=y}}while(0);Ut(e,g,p,l,l,m,m,q,t,u,x,+h[w+4376>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+7336>>3]=+h[e>>3];i=d;return}function qaa(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+326|0]=a[d+312|0]|0;i=i;return}function raa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4456>>3]=+h[b+4248>>3];i=i;return}function saa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4464>>3]=+h[b+2520>>3];i=i;return}function taa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4488>>3]=+h[b+720>>3];i=i;return}function uaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4528>>3]=+h[b+2576>>3];i=i;return}function vaa(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+4488>>3];h[b+4544>>3]=d*d*.7853981633974483;i=i;return}function waa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4552>>3]=+h[b+4488>>3]*3.141592653589793;i=i;return}function xaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4560>>3]=+h[b+4528>>3];i=i;return}function yaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;WCa(e,1,+h[(c[g>>2]|0)+552>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=(+h[a+4528>>3]+ +h[a+4560>>3])*.5;a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Zt(f,j,k,293.15,d,0);h[(c[g>>2]|0)+4520>>3]=+h[f>>3];i=b;return}function zaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4576>>3]=+h[b+4472>>3];i=i;return}function Aaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4584>>3]=+h[b+4528>>3];i=i;return}



function Cqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187696]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(187704,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+240>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[187696]=1;i=d;return}function Dqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187848]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(187856,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4824>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[187848]=1;i=d;return}function Eqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187984]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(187992,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4816>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[187984]=1;i=d;return}function Fqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188120]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(188128,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4808>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188120]=1;i=d;return}function Gqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188264]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(188272,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4800>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188264]=1;i=d;return}function Hqa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188416]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(188424,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[188416]=1;i=d;return}function Iqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(188560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4776>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188552]=1;i=d;return}function Jqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(188688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4768>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188680]=1;i=d;return}function Kqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(188816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4760>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188808]=1;i=d;return}function Lqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188936]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(188944,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4752>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[188936]=1;i=d;return}function Mqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(189072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4744>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189064]=1;i=d;return}function Nqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(189200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4736>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189192]=1;i=d;return}function Oqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189336]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(189344,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4728>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189336]=1;i=d;return}function Pqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(189488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4712>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189480]=1;i=d;return}function Qqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189624]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4696>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4696>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(189632,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4696>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189624]=1;i=d;return}function Rqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189744]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(189752,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4680>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189744]=1;i=d;return}function Sqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189824]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(189832,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+232>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189824]=1;i=d;return}function Tqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189944]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(189952,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[189944]=1;i=d;return}function Uqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190080]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(190088,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4592>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190080]=1;i=d;return}function Vqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190208]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(190216,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4584>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190208]=1;i=d;return}function Wqa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190344]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(190352,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[190344]=1;i=d;return}function Xqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190464]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(190472,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2272>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190464]=1;i=d;return}function Yqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190616]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(190624,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4560>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190616]=1;i=d;return}function Zqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190792]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(190800,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4552>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190792]=1;i=d;return}function _qa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190952]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(190960,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4536>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[190952]=1;i=d;return}function $qa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191096]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(191104,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4512>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191096]=1;i=d;return}function ara(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191176]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(191184,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4504>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191176]=1;i=d;return}function bra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191296]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(191304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4488>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191296]=1;i=d;return}function cra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191376]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(191384,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191376]=1;i=d;return}function dra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191496]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(191504,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191496]=1;i=d;return}function era(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(191640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4400>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191632]=1;i=d;return}function fra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191760]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(191768,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4392>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[191760]=1;i=d;return}function gra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191896]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(191904,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[191896]=1;i=d;return}function hra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192016]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(192024,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2264>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192016]=1;i=d;return}function ira(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192168]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4368>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4368>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(192176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4368>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192168]=1;i=d;return}function jra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192296]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4360>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4360>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(192304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4360>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192296]=1;i=d;return}function kra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192456]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4344>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(192464,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4344>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192456]=1;i=d;return}function lra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192624]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(192632,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4320>>3],167016)|0)|0;g=c[72854]|0;j=e;k=192704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192624]=1;i=d;return}function mra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192728]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(192736,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4304>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192728]=1;i=d;return}function nra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(192816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2256>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192808]=1;i=d;return}function ora(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192952]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(192960,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2248>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[192952]=1;i=d;return}function pra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193080]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(193088,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2240>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193080]=1;i=d;return}function qra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193256]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(193264,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193256]=1;i=d;return}function rra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(193352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193344]=1;i=d;return}function sra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(193488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4264>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193480]=1;i=d;return}function tra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193600]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(193608,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4256>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193600]=1;i=d;return}function ura(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193728]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(193736,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[193728]=1;i=d;return}function vra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193848]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2208>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2208>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(193856,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2208>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[193848]=1;i=d;return}function wra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194e3]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(194008,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4168>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194e3]=1;i=d;return}function xra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194080]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(194088,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2200>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194080]=1;i=d;return}function yra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194224]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(194232,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2192>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194224]=1;i=d;return}function zra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2184>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(194360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2184>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194352]=1;i=d;return}function Ara(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194528]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(194536,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194528]=1;i=d;return}function Bra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194616]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(194624,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194616]=1;i=d;return}function Cra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(194760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4128>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194752]=1;i=d;return}function Dra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194872]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(194880,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4120>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[194872]=1;i=d;return}function Era(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195e3]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(195008,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[195e3]=1;i=d;return}function Fra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195120]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2152>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2152>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(195128,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2152>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195120]=1;i=d;return}function Gra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195272]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(195280,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4096>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195272]=1;i=d;return}function Hra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(195360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2136>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195352]=1;i=d;return}function Ira(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195496]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2144>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2144>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(195504,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2144>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195496]=1;i=d;return}function Jra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195640]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(195648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2128>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195640]=1;i=d;return}function Kra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195768]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2120>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(195776,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2120>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195768]=1;i=d;return}function Lra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195896]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(195904,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2104>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[195896]=1;i=d;return}function Mra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2112>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(196080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2112>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196072]=1;i=d;return}function Nra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196248]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(196256,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196248]=1;i=d;return}function Ora(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196336]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(196344,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196336]=1;i=d;return}function Pra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196472]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(196480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4056>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196472]=1;i=d;return}function Qra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196592]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(196600,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4048>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196592]=1;i=d;return}function Rra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196720]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(196728,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[196720]=1;i=d;return}function Sra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196840]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2056>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2056>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(196848,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2056>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196840]=1;i=d;return}function Tra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196992]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(197e3,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4024>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[196992]=1;i=d;return}function Ura(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2048>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2048>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(197080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2048>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197072]=1;i=d;return}function Vra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197216]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(197224,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2040>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197216]=1;i=d;return}function Wra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(197352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2032>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197344]=1;i=d;return}function Xra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197520]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(197528,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197520]=1;i=d;return}function Yra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197608]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(197616,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197608]=1;i=d;return}function Zra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197744]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(197752,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197744]=1;i=d;return}function _ra(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197864]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(197872,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3976>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[197864]=1;i=d;return}function $ra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197992]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(198e3,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[197992]=1;i=d;return}function asa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(198120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2e3>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198112]=1;i=d;return}function bsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198264]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(198272,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198264]=1;i=d;return}function csa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1992>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1992>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(198352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1992>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198344]=1;i=d;return}function dsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198488]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(198496,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198488]=1;i=d;return}function esa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198616]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(198624,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198616]=1;i=d;return}function fsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198792]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(198800,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198792]=1;i=d;return}function gsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198880]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(198888,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[198880]=1;i=d;return}function hsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199016]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(199024,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199016]=1;i=d;return}function isa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199136]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(199144,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199136]=1;i=d;return}function jsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199264]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(199272,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[199264]=1;i=d;return}function ksa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199384]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(199392,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199384]=1;i=d;return}function lsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199536]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(199544,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199536]=1;i=d;return}function msa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199696]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(199704,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199696]=1;i=d;return}function nsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199840]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(199848,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199840]=1;i=d;return}function osa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199976]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(199984,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[199976]=1;i=d;return}function psa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200136]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(200144,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[200136]=1;i=d;return}function qsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200280]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(200288,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[200280]=1;i=d;return}function rsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200416]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(200424,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[200416]=1;i=d;return}function ssa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200568]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(200576,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[200568]=1;i=d;return}function tsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200720]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(200728,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[200720]=1;i=d;return}function usa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200816]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(200824,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[200816]=1;i=d;return}function vsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200912]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(200920,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[200912]=1;i=d;return}function wsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(201072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[201064]=1;i=d;return}function xsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201216]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3];k=b+420|0;b=sFa(j,+xd(-1.0e+60,+(+xd(+-((c[(c[k>>2]|0)+160>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(+-((c[(c[k>>2]|0)+160>>2]|0)==1?0.0:-1.0e+60),1.0e5))))|0)<<24>>24==0)){i=d;return}k=ACa(201224,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],167016)|0)|0;g=c[72854]|0;b=e;l=221544;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[201216]=1;i=d;return}function ysa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(201760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],167016)|0)|0;g=c[72854]|0;j=e;k=221544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[201752]=1;i=d;return}function zsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201912]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3];k=b+420|0;b=sFa(j,+xd(-1.0e5,+(+xd(+((c[(c[k>>2]|0)+148>>2]|0)==1?0.0:-1.0e+60),-1.0e5))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e+60,+(+wd(+((c[(c[k>>2]|0)+148>>2]|0)==2?0.0:1.0e+60),1.0e5))))|0)<<24>>24==0)){i=d;return}k=ACa(201920,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1856>>3],167016)|0)|0;g=c[72854]|0;b=e;l=221544;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[201912]=1;i=d;return}function Asa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(202360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[202352]=1;i=d;return}function Bsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1824>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1824>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(202512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1824>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[202504]=1;i=d;return}function Csa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202656]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(202664,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[202656]=1;i=d;return}function Dsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(202816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[202808]=1;i=d;return}function Esa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202976]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(202984,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[202976]=1;i=d;return}function Fsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203144]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(203152,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203144]=1;i=d;return}function Gsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203320]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(203328,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203320]=1;i=d;return}function Hsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203488]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(203496,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203488]=1;i=d;return}function Isa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203656]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(203664,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203656]=1;i=d;return}function Jsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203832]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(203840,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203832]=1;i=d;return}function Ksa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203984]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(203992,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[203984]=1;i=d;return}function Lsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204152]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(204160,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1736>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204152]=1;i=d;return}function Msa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204312]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(204320,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1728>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204312]=1;i=d;return}function Nsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(204488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204480]=1;i=d;return}function Osa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(204640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204632]=1;i=d;return}function Psa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204800]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(204808,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204800]=1;i=d;return}function Qsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204960]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(204968,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[204960]=1;i=d;return}function Rsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205128]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(205136,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205128]=1;i=d;return}function Ssa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205296]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(205304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205296]=1;i=d;return}function Tsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205464]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(205472,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3824>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205464]=1;i=d;return}function Usa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205640]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(205648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3e3>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205640]=1;i=d;return}function Vsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(205816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205808]=1;i=d;return}function Wsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205984]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(205992,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[205984]=1;i=d;return}function Xsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206152]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(206160,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[206152]=1;i=d;return}function Ysa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206328]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(206336,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[206328]=1;i=d;return}function Zsa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(206512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3816>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[206504]=1;i=d;return}function _sa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(206688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2968>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[206680]=1;i=d;return}function $sa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206848]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(206856,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[206848]=1;i=d;return}function ata(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207024]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(207032,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207024]=1;i=d;return}function bta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(207200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207192]=1;i=d;return}function cta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207368]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(207376,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207368]=1;i=d;return}function dta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207544]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(207552,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207544]=1;i=d;return}function eta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207720]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(207728,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3800>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207720]=1;i=d;return}function fta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207896]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(207904,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1504>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[207896]=1;i=d;return}function gta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(208072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1512>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208064]=1;i=d;return}function hta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208232]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(208240,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1496>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208232]=1;i=d;return}function ita(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208408]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(208416,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1480>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208408]=1;i=d;return}function jta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208576]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1488>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(208584,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1488>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208576]=1;i=d;return}function kta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208744]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(208752,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1472>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208744]=1;i=d;return}function lta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208920]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(208928,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1464>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[208920]=1;i=d;return}function mta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209096]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(209104,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1456>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209096]=1;i=d;return}function nta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209272]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(209280,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209272]=1;i=d;return}function ota(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209456]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(209464,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209456]=1;i=d;return}function pta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209640]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(209648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209640]=1;i=d;return}function qta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(209816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209808]=1;i=d;return}function rta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209976]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(209984,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[209976]=1;i=d;return}function sta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210160]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(210168,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[210160]=1;i=d;return}function tta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210328]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(210336,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[210328]=1;i=d;return}function uta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210496]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1368>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(210504,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1368>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[210496]=1;i=d;return}function vta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(210688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[210680]=1;i=d;return}function wta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210864]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(210872,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[210864]=1;i=d;return}function xta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(211072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211064]=1;i=d;return}function yta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211248]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(211256,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1320>>3],167016)|0)|0;g=c[72854]|0;j=e;k=211432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211248]=1;i=d;return}function zta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211456]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(211464,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211456]=1;i=d;return}function Ata(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211640]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(211648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211640]=1;i=d;return}



function qB(b,d){b=b|0;d=d|0;var e=0,f=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0;e=i;i=i+17072|0;f=c[(b+536|0)>>2]|0;j=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];k=1;if(k){k=0;if((d|0)==0){mu(e+10608|0,f,j);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];m=(e+3432|0)+0|0;n=(e+10608|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14416|0,d,l,e+3432|0);a[c[(b+352|0)>>2]|0]=+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3]<+h[(e+14416|0)>>3]|0;Xu(e+10712|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];m=(e+3328|0)+0|0;n=(e+10712|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14424|0,d,l,e+3328|0);a[(c[(b+352|0)>>2]|0)+1|0]=+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3]>+h[(e+14424|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+2|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]>22064.0e3|0;mu(e+10816|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];m=(e+3224|0)+0|0;n=(e+10816|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14432|0,d,l,e+3224|0);a[(c[(b+352|0)>>2]|0)+3|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3]<+h[(e+14432|0)>>3]|0;Xu(e+10920|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];m=(e+3120|0)+0|0;n=(e+10920|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14440|0,d,l,e+3120|0);a[(c[(b+352|0)>>2]|0)+4|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3]>+h[(e+14440|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+5|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]>22064.0e3|0;mu(e+11024|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];m=(e+3016|0)+0|0;n=(e+11024|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14448|0,d,l,e+3016|0);a[(c[(b+352|0)>>2]|0)+6|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3]<+h[(e+14448|0)>>3]|0;Xu(e+11128|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];m=(e+2912|0)+0|0;n=(e+11128|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14456|0,d,l,e+2912|0);a[(c[(b+352|0)>>2]|0)+7|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3]>+h[(e+14456|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+8|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]>22064.0e3|0;mu(e+11232|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];m=(e+2808|0)+0|0;n=(e+11232|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14464|0,d,l,e+2808|0);a[(c[(b+352|0)>>2]|0)+9|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]<+h[(e+14464|0)>>3]|0;Xu(e+11336|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];m=(e+2704|0)+0|0;n=(e+11336|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14472|0,d,l,e+2704|0);a[(c[(b+352|0)>>2]|0)+10|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3]>+h[(e+14472|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+11|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]>22064.0e3|0;mu(e+11440|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];m=(e+2600|0)+0|0;n=(e+11440|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14480|0,d,l,e+2600|0);a[(c[(b+352|0)>>2]|0)+12|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3]<+h[(e+14480|0)>>3]|0;Xu(e+11544|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];m=(e+2496|0)+0|0;n=(e+11544|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14488|0,d,l,e+2496|0);a[(c[(b+352|0)>>2]|0)+13|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3]>+h[(e+14488|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+14|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]>22064.0e3|0;mu(e+11648|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];m=(e+2392|0)+0|0;n=(e+11648|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14496|0,d,l,e+2392|0);a[(c[(b+352|0)>>2]|0)+15|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3]<+h[(e+14496|0)>>3]|0;Xu(e+11752|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];m=(e+2288|0)+0|0;n=(e+11752|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14504|0,d,l,e+2288|0);a[(c[(b+352|0)>>2]|0)+16|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3]>+h[(e+14504|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+17|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]>22064.0e3|0;mu(e+11856|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];m=(e+2184|0)+0|0;n=(e+11856|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14512|0,d,l,e+2184|0);a[(c[(b+352|0)>>2]|0)+18|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3]<+h[(e+14512|0)>>3]|0;Xu(e+11960|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];m=(e+2080|0)+0|0;n=(e+11960|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14520|0,d,l,e+2080|0);a[(c[(b+352|0)>>2]|0)+19|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3]>+h[(e+14520|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+20|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]>22064.0e3|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+21|0]=+h[d+120>>3]>=+h[d+560>>3]+ +h[d+3032>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+22|0]=+h[d+120>>3]>=+h[d+560>>3]- +h[d+3032>>3]|0;mu(e+12064|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+4752>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+4752>>3];m=(e+1976|0)+0|0;n=(e+12064|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14528|0,d,l,e+1976|0);a[(c[(b+352|0)>>2]|0)+23|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3]<+h[(e+14528|0)>>3]|0;Xu(e+12168|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+4752>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+4752>>3];m=(e+1872|0)+0|0;n=(e+12168|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14536|0,d,l,e+1872|0);a[(c[(b+352|0)>>2]|0)+24|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3]>+h[(e+14536|0)>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+25|0]=+h[d+136>>3]>=+h[d+1960>>3]+ +h[d+3048>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+26|0]=+h[d+136>>3]>=+h[d+1960>>3]- +h[d+3048>>3]|0;mu(e+12272|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+3048>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+3048>>3];m=(e+1768|0)+0|0;n=(e+12272|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14544|0,d,l,e+1768|0);a[(c[(b+352|0)>>2]|0)+27|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3]<+h[(e+14544|0)>>3]|0;Xu(e+12376|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+3048>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+3048>>3];m=(e+1664|0)+0|0;n=(e+12376|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14552|0,d,l,e+1664|0);a[(c[(b+352|0)>>2]|0)+28|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3]>+h[(e+14552|0)>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+29|0]=+h[d+152>>3]>=+h[d+2016>>3]+ +h[d+3064>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+30|0]=+h[d+152>>3]>=+h[d+2016>>3]- +h[d+3064>>3]|0;mu(e+12480|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2936>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2936>>3];m=(e+1560|0)+0|0;n=(e+12480|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14560|0,d,l,e+1560|0);a[(c[(b+352|0)>>2]|0)+31|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3]<+h[(e+14560|0)>>3]|0;Xu(e+12584|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2936>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2936>>3];m=(e+1456|0)+0|0;n=(e+12584|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14568|0,d,l,e+1456|0);a[(c[(b+352|0)>>2]|0)+32|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3]>+h[(e+14568|0)>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+33|0]=+h[d+168>>3]>=+h[d+2080>>3]+ +h[d+3088>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+34|0]=+h[d+168>>3]>=+h[d+2080>>3]- +h[d+3088>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+35|0]=+h[d+168>>3]>=+h[d+2072>>3]+ +h[d+3080>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+36|0]=+h[d+168>>3]>=+h[d+2072>>3]- +h[d+3080>>3]|0;mu(e+12688|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2824>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2824>>3];m=(e+1352|0)+0|0;n=(e+12688|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14576|0,d,l,e+1352|0);a[(c[(b+352|0)>>2]|0)+37|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3]<+h[(e+14576|0)>>3]|0;Xu(e+12792|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2824>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2824>>3];m=(e+1248|0)+0|0;n=(e+12792|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14584|0,d,l,e+1248|0);a[(c[(b+352|0)>>2]|0)+38|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3]>+h[(e+14584|0)>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+39|0]=+h[d+184>>3]>=+h[d+2168>>3]+ +h[d+3112>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+40|0]=+h[d+184>>3]>=+h[d+2168>>3]- +h[d+3112>>3]|0;mu(e+12896|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2712>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2712>>3];m=(e+1144|0)+0|0;n=(e+12896|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14592|0,d,l,e+1144|0);a[(c[(b+352|0)>>2]|0)+41|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3]<+h[(e+14592|0)>>3]|0;Xu(e+13e3|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2712>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2712>>3];m=(e+1040|0)+0|0;n=(e+13e3|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14600|0,d,l,e+1040|0);a[(c[(b+352|0)>>2]|0)+42|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3]>+h[(e+14600|0)>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+43|0]=+h[d+200>>3]>=+h[d+2224>>3]+ +h[d+3128>>3]|0;d=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a[(c[(b+352|0)>>2]|0)+44|0]=+h[d+200>>3]>=+h[d+2224>>3]- +h[d+3128>>3]|0;mu(e+13104|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2456>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2456>>3];m=(e+936|0)+0|0;n=(e+13104|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14608|0,d,l,e+936|0);a[(c[(b+352|0)>>2]|0)+45|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3]<+h[(e+14608|0)>>3]|0;Xu(e+13208|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2456>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+2456>>3];m=(e+832|0)+0|0;n=(e+13208|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14616|0,d,l,e+832|0);a[(c[(b+352|0)>>2]|0)+46|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3]>+h[(e+14616|0)>>3]|0;mu(e+13312|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];m=(e+728|0)+0|0;n=(e+13312|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14624|0,d,l,e+728|0);a[(c[(b+352|0)>>2]|0)+47|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3]<+h[(e+14624|0)>>3]|0;Xu(e+13416|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];m=(e+624|0)+0|0;n=(e+13416|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14632|0,d,l,e+624|0);a[(c[(b+352|0)>>2]|0)+48|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3]>+h[(e+14632|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+49|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]>22064.0e3|0;mu(e+13520|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];m=(e+520|0)+0|0;n=(e+13520|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14640|0,d,l,e+520|0);a[(c[(b+352|0)>>2]|0)+50|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3]<+h[(e+14640|0)>>3]|0;Xu(e+13624|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];m=(e+416|0)+0|0;n=(e+13624|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14648|0,d,l,e+416|0);a[(c[(b+352|0)>>2]|0)+51|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3]>+h[(e+14648|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+52|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]>22064.0e3|0;mu(e+13728|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];m=(e+312|0)+0|0;n=(e+13728|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14656|0,d,l,e+312|0);a[(c[(b+352|0)>>2]|0)+53|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3]<+h[(e+14656|0)>>3]|0;Xu(e+13832|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];m=(e+208|0)+0|0;n=(e+13832|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14664|0,d,l,e+208|0);a[(c[(b+352|0)>>2]|0)+54|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3]>+h[(e+14664|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+55|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]>22064.0e3|0;a[(c[(b+352|0)>>2]|0)+56|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3]>+h[(c[(b+416|0)>>2]|0)+2824>>3]|0;a[(c[(b+352|0)>>2]|0)+57|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+4944>>3]>1.0e-6|0;a[(c[(b+352|0)>>2]|0)+58|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+584>>3]>+h[(c[(b+416|0)>>2]|0)+4752>>3]|0;a[(c[(b+352|0)>>2]|0)+59|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1320>>3]>1.0e-6|0;d=c[c[(b+4|0)>>2]>>2]|0;a[(c[(b+352|0)>>2]|0)+60|0]=+h[d>>3]<+h[(c[d+8>>2]|0)+4184>>3]|0;a[(c[(b+352|0)>>2]|0)+61|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1984>>3]>+h[(c[(b+416|0)>>2]|0)+3048>>3]|0;a[(c[(b+352|0)>>2]|0)+62|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+4712>>3]>1.0e-6|0;d=c[c[(b+4|0)>>2]>>2]|0;a[(c[(b+352|0)>>2]|0)+63|0]=+h[d>>3]<+h[(c[d+8>>2]|0)+4216>>3]|0;a[(c[(b+352|0)>>2]|0)+64|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3]<.01|0;d=c[c[(b+4|0)>>2]>>2]|0;a[(c[(b+352|0)>>2]|0)+65|0]=+h[d>>3]>=+h[(c[d+8>>2]|0)+6168>>3]+ +h[(c[(b+416|0)>>2]|0)+1016>>3]|0;a[(c[(b+352|0)>>2]|0)+66|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3]<.01|0;a[(c[(b+352|0)>>2]|0)+67|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3]>+h[(c[(b+416|0)>>2]|0)+2824>>3]|0;a[(c[(b+352|0)>>2]|0)+68|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+6024>>3]>1.0e-6|0;d=c[c[(b+4|0)>>2]>>2]|0;a[(c[(b+352|0)>>2]|0)+69|0]=+h[d>>3]>=+h[(c[d+8>>2]|0)+6224>>3]+ +h[(c[(b+416|0)>>2]|0)+1008>>3]|0;a[(c[(b+352|0)>>2]|0)+70|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2192>>3]>+h[(c[(b+416|0)>>2]|0)+2712>>3]|0;a[(c[(b+352|0)>>2]|0)+71|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+5864>>3]>1.0e-6|0;a[(c[(b+352|0)>>2]|0)+72|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2248>>3]>+h[(c[(b+416|0)>>2]|0)+2456>>3]|0;a[(c[(b+352|0)>>2]|0)+73|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+5944>>3]>1.0e-6|0;d=c[c[(b+4|0)>>2]>>2]|0;a[(c[(b+352|0)>>2]|0)+74|0]=+h[d>>3]>=+h[(c[d+8>>2]|0)+6080>>3]+ +h[(c[(b+416|0)>>2]|0)+1032>>3]|0;mu(e+13936|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+776>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+776>>3];m=(e+104|0)+0|0;n=(e+13936|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14672|0,d,l,e+104|0);a[(c[(b+352|0)>>2]|0)+75|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3]<+h[(e+14672|0)>>3]|0;Xu(e+14040|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+776>>3]);d=c[(b+536|0)>>2]|0;l=+h[(c[(b+416|0)>>2]|0)+776>>3];m=e+0|0;n=(e+14040|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14680|0,d,l,e);a[(c[(b+352|0)>>2]|0)+76|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3]>+h[(e+14680|0)>>3]|0;a[(c[(b+352|0)>>2]|0)+77|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1944>>3]<=298.0|0;a[(c[(b+352|0)>>2]|0)+78|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+544>>3]<=298.0|0;a[(c[(b+352|0)>>2]|0)+79|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3]<=.01|0;a[(c[(b+352|0)>>2]|0)+80|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+120>>3]<=.01|0;a[(c[(b+352|0)>>2]|0)+81|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3]<=.01|0;a[(c[(b+352|0)>>2]|0)+82|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3]>=+h[(c[(b+416|0)>>2]|0)+1e3>>3]|0;a[(c[(b+352|0)>>2]|0)+83|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3]<=.01|0;a[(c[(b+352|0)>>2]|0)+84|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3]>=.13|0;a[(c[(b+352|0)>>2]|0)+85|0]=+h[c[c[(b+4|0)>>2]>>2]>>3]>2500.0|0;a[(c[(b+352|0)>>2]|0)+86|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2320>>3]>+h[(c[(b+416|0)>>2]|0)+776>>3]|0;a[(c[(b+352|0)>>2]|0)+87|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3]<-1.0e-6|0;a[(c[(b+352|0)>>2]|0)+88|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3]>0.0|0;a[(c[(b+352|0)>>2]|0)+89|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2352>>3]>+h[(c[(b+416|0)>>2]|0)+776>>3]|0;a[(c[(b+352|0)>>2]|0)+90|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2360>>3]>+h[(c[(b+416|0)>>2]|0)+776>>3]|0;a[(c[(b+352|0)>>2]|0)+91|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3]<-1.0e-6|0;a[(c[(b+352|0)>>2]|0)+92|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3]>0.0|0;a[(c[(b+352|0)>>2]|0)+93|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2040>>3]>+h[(c[(b+416|0)>>2]|0)+2936>>3]|0;a[(c[(b+352|0)>>2]|0)+94|0]=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3]>1.0e-6|0;a[(c[(b+352|0)>>2]|0)+95|0]=+h[(c[(b+416|0)>>2]|0)+2480>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2224>>3]|0;a[(c[(b+352|0)>>2]|0)+96|0]=+h[(c[(b+416|0)>>2]|0)+2736>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2168>>3]|0;a[(c[(b+352|0)>>2]|0)+97|0]=+h[(c[(b+416|0)>>2]|0)+2848>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2072>>3]|0;a[(c[(b+352|0)>>2]|0)+98|0]=+h[(c[(b+416|0)>>2]|0)+2848>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2080>>3]|0;a[(c[(b+352|0)>>2]|0)+99|0]=+h[(c[(b+416|0)>>2]|0)+2960>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2016>>3]|0;a[(c[(b+352|0)>>2]|0)+100|0]=+h[(c[(b+416|0)>>2]|0)+3072>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1960>>3]|0;a[(c[(b+352|0)>>2]|0)+101|0]=+h[(c[(b+416|0)>>2]|0)+4776>>3]>=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+560>>3]|0;i=e;return 0}else{k=1}}if(k){k=0;if(1){mu(e+7072|0,f,j);f=c[(b+536|0)>>2]|0;j=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];m=(e+6968|0)+0|0;n=(e+7072|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14144|0,f,j,e+6968|0);f=lFa(+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3],+h[(e+14144|0)>>3],a[c[(b+360|0)>>2]|0]|0)|0;a[c[(b+352|0)>>2]|0]=f;Xu(e+7176|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]);f=c[(b+536|0)>>2]|0;j=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];m=(e+6864|0)+0|0;n=(e+7176|0)+0|0;o=m+104|0;do{c[m>>2]=c[n>>2];m=m+4|0;n=n+4|0}while((m|0)<(o|0));nu(e+14152|0,f,j,e+6864|0);f=nFa(+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3],+h[(e+14152|0)>>3],a[(c[(b+360|0)>>2]|0)+1|0]|0)|0;a[(c[(b+352|0)>>2]|0)+1|0]=f;f=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+2|0]|0)|0;a[(c[(b+352|0)>>2]|0)+2|0]=f;mu(e+7280|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);f=c[(b+536|0)>>2]|0;j=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];c[e+14696>>2]=b;c[e+15664>>2]=f;g[e+15696>>2]=j;c[e+16936>>2]=m;c[e+16952>>2]=n;c[e+16960>>2]=o;c[e+16976>>2]=0;c[e+16980>>2]=0;_Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_function_updateRelations$0(e);m=c[e+16936>>2]|0;n=c[e+16952>>2]|0;o=c[e+16960>>2]|0;H=c[e+16976>>2]|0;A=c[e+16980>>2]|0;I=+g[e+16980>>2];c[e+16976>>2]=0;c[e+16980>>2]=0;if((H|0)==6){return A|0}}else{k=1}}return 0}function rB(b){b=b|0;var d=0,e=0,f=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0.0,Od=0.0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0;d=i;i=i+8640|0;e=i;i=i+8|0;f=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+16|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;MBa(8,1,41048,Sb);Sb=c[c[(b+4|0)>>2]>>2]|0;Tb=c[Sb+16>>2]|0;Ub=a[Tb+114|0]|0;Vb=c[(b+408|0)>>2]|0;Wb=a[Vb+114|0]|0;if(Ub<<24>>24==Wb<<24>>24){Xb=Vb;Yb=Tb;Zb=Sb;_b=0}else{c[Rb>>2]=Wb<<24>>24;c[Rb+4>>2]=Ub<<24>>24;MBa(8,0,41080,Rb);Rb=c[c[(b+4|0)>>2]>>2]|0;Xb=c[(b+408|0)>>2]|0;Yb=c[Rb+16>>2]|0;Zb=Rb;_b=1}Rb=a[Yb+113|0]|0;Ub=a[Xb+113|0]|0;if(Rb<<24>>24==Ub<<24>>24){$b=Xb;ac=Yb;bc=Zb;cc=_b}else{c[Qb>>2]=Ub<<24>>24;c[Qb+4>>2]=Rb<<24>>24;MBa(8,0,41136,Qb);Qb=c[c[(b+4|0)>>2]>>2]|0;$b=c[(b+408|0)>>2]|0;ac=c[Qb+16>>2]|0;bc=Qb;cc=1}Qb=a[ac+112|0]|0;Rb=a[$b+112|0]|0;if(Qb<<24>>24==Rb<<24>>24){dc=$b;ec=ac;fc=bc;gc=cc}else{c[Pb>>2]=Rb<<24>>24;c[Pb+4>>2]=Qb<<24>>24;MBa(8,0,41192,Pb);Pb=c[c[(b+4|0)>>2]>>2]|0;dc=c[(b+408|0)>>2]|0;ec=c[Pb+16>>2]|0;fc=Pb;gc=1}Pb=a[ec+111|0]|0;Qb=a[dc+111|0]|0;if(Pb<<24>>24==Qb<<24>>24){hc=dc;ic=ec;jc=fc;kc=gc}else{c[Ob>>2]=Qb<<24>>24;c[Ob+4>>2]=Pb<<24>>24;MBa(8,0,41248,Ob);Ob=c[c[(b+4|0)>>2]>>2]|0;hc=c[(b+408|0)>>2]|0;ic=c[Ob+16>>2]|0;jc=Ob;kc=1}Ob=a[ic+110|0]|0;Pb=a[hc+110|0]|0;if(Ob<<24>>24==Pb<<24>>24){lc=hc;mc=ic;nc=jc;oc=kc}else{c[Nb>>2]=Pb<<24>>24;c[Nb+4>>2]=Ob<<24>>24;MBa(8,0,41304,Nb);Nb=c[c[(b+4|0)>>2]>>2]|0;lc=c[(b+408|0)>>2]|0;mc=c[Nb+16>>2]|0;nc=Nb;oc=1}Nb=a[mc+109|0]|0;Ob=a[lc+109|0]|0;if(Nb<<24>>24==Ob<<24>>24){pc=lc;qc=mc;rc=nc;sc=oc}else{c[Mb>>2]=Ob<<24>>24;c[Mb+4>>2]=Nb<<24>>24;MBa(8,0,41360,Mb);Mb=c[c[(b+4|0)>>2]>>2]|0;pc=c[(b+408|0)>>2]|0;qc=c[Mb+16>>2]|0;rc=Mb;sc=1}Mb=a[qc+108|0]|0;Nb=a[pc+108|0]|0;if(Mb<<24>>24==Nb<<24>>24){tc=pc;uc=qc;vc=rc;wc=sc}else{c[Lb>>2]=Nb<<24>>24;c[Lb+4>>2]=Mb<<24>>24;MBa(8,0,41416,Lb);Lb=c[c[(b+4|0)>>2]>>2]|0;tc=c[(b+408|0)>>2]|0;uc=c[Lb+16>>2]|0;vc=Lb;wc=1}Lb=a[uc+107|0]|0;uc=a[tc+107|0]|0;if(Lb<<24>>24==uc<<24>>24){xc=vc;yc=wc}else{c[Kb>>2]=uc<<24>>24;c[Kb+4>>2]=Lb<<24>>24;MBa(8,0,41472,Kb);xc=c[c[(b+4|0)>>2]>>2]|0;yc=1}Kb=c[(c[xc+12>>2]|0)+108>>2]|0;Lb=c[(c[(b+404|0)>>2]|0)+108>>2]|0;if((Kb|0)==(Lb|0)){zc=xc;Ac=yc}else{c[Jb>>2]=Lb;c[Jb+4>>2]=Kb;MBa(8,0,41528,Jb);zc=c[c[(b+4|0)>>2]>>2]|0;Ac=1}Jb=c[zc+16>>2]|0;Kb=a[Jb+16|0]|0;Lb=c[(b+408|0)>>2]|0;yc=a[Lb+16|0]|0;if(Kb<<24>>24==yc<<24>>24){Bc=Lb;Cc=Jb;Dc=zc;Ec=Ac}else{c[Ib>>2]=yc<<24>>24;c[Ib+4>>2]=Kb<<24>>24;MBa(8,0,41584,Ib);Ib=c[c[(b+4|0)>>2]>>2]|0;Bc=c[(b+408|0)>>2]|0;Cc=c[Ib+16>>2]|0;Dc=Ib;Ec=1}Ib=a[Cc+15|0]|0;Kb=a[Bc+15|0]|0;if(Ib<<24>>24==Kb<<24>>24){Fc=Bc;Gc=Cc;Hc=Dc;Ic=Ec}else{c[Hb>>2]=Kb<<24>>24;c[Hb+4>>2]=Ib<<24>>24;MBa(8,0,41664,Hb);Hb=c[c[(b+4|0)>>2]>>2]|0;Fc=c[(b+408|0)>>2]|0;Gc=c[Hb+16>>2]|0;Hc=Hb;Ic=1}Hb=a[Gc+14|0]|0;Gc=a[Fc+14|0]|0;if(Hb<<24>>24==Gc<<24>>24){Jc=Hc;Kc=Ic}else{c[Gb>>2]=Gc<<24>>24;c[Gb+4>>2]=Hb<<24>>24;MBa(8,0,41744,Gb);Jc=c[c[(b+4|0)>>2]>>2]|0;Kc=1}Gb=c[(c[Jc+12>>2]|0)+104>>2]|0;Hb=c[(c[(b+404|0)>>2]|0)+104>>2]|0;if((Gb|0)==(Hb|0)){Lc=Jc;Mc=Kc}else{c[Fb>>2]=Hb;c[Fb+4>>2]=Gb;MBa(8,0,41824,Fb);Lc=c[c[(b+4|0)>>2]>>2]|0;Mc=1}Fb=c[Lc+16>>2]|0;Gb=a[Fb+106|0]|0;Hb=c[(b+408|0)>>2]|0;Kc=a[Hb+106|0]|0;if(Gb<<24>>24==Kc<<24>>24){Nc=Hb;Oc=Fb;Pc=Lc;Qc=Mc}else{c[Eb>>2]=Kc<<24>>24;c[Eb+4>>2]=Gb<<24>>24;MBa(8,0,41904,Eb);Eb=c[c[(b+4|0)>>2]>>2]|0;Nc=c[(b+408|0)>>2]|0;Oc=c[Eb+16>>2]|0;Pc=Eb;Qc=1}Eb=a[Oc+105|0]|0;Gb=a[Nc+105|0]|0;if(Eb<<24>>24==Gb<<24>>24){Rc=Nc;Sc=Oc;Tc=Pc;Uc=Qc}else{c[Db>>2]=Gb<<24>>24;c[Db+4>>2]=Eb<<24>>24;MBa(8,0,41984,Db);Db=c[c[(b+4|0)>>2]>>2]|0;Rc=c[(b+408|0)>>2]|0;Sc=c[Db+16>>2]|0;Tc=Db;Uc=1}Db=a[Sc+104|0]|0;Eb=a[Rc+104|0]|0;if(Db<<24>>24==Eb<<24>>24){Vc=Rc;Wc=Sc;Xc=Tc;Yc=Uc}else{c[Cb>>2]=Eb<<24>>24;c[Cb+4>>2]=Db<<24>>24;MBa(8,0,42056,Cb);Cb=c[c[(b+4|0)>>2]>>2]|0;Vc=c[(b+408|0)>>2]|0;Wc=c[Cb+16>>2]|0;Xc=Cb;Yc=1}Cb=a[Wc+103|0]|0;Db=a[Vc+103|0]|0;if(Cb<<24>>24==Db<<24>>24){Zc=Vc;_c=Wc;$c=Xc;ad=Yc}else{c[Bb>>2]=Db<<24>>24;c[Bb+4>>2]=Cb<<24>>24;MBa(8,0,42128,Bb);Bb=c[c[(b+4|0)>>2]>>2]|0;Zc=c[(b+408|0)>>2]|0;_c=c[Bb+16>>2]|0;$c=Bb;ad=1}Bb=a[_c+102|0]|0;Cb=a[Zc+102|0]|0;if(Bb<<24>>24==Cb<<24>>24){bd=Zc;cd=_c;dd=$c;ed=ad}else{c[Ab>>2]=Cb<<24>>24;c[Ab+4>>2]=Bb<<24>>24;MBa(8,0,42200,Ab);Ab=c[c[(b+4|0)>>2]>>2]|0;bd=c[(b+408|0)>>2]|0;cd=c[Ab+16>>2]|0;dd=Ab;ed=1}Ab=a[cd+101|0]|0;Bb=a[bd+101|0]|0;if(Ab<<24>>24==Bb<<24>>24){fd=bd;gd=cd;hd=dd;id=ed}else{c[zb>>2]=Bb<<24>>24;c[zb+4>>2]=Ab<<24>>24;MBa(8,0,42272,zb);zb=c[c[(b+4|0)>>2]>>2]|0;fd=c[(b+408|0)>>2]|0;gd=c[zb+16>>2]|0;hd=zb;id=1}zb=a[gd+100|0]|0;Ab=a[fd+100|0]|0;if(zb<<24>>24==Ab<<24>>24){jd=fd;kd=gd;ld=hd;md=id}else{c[yb>>2]=Ab<<24>>24;c[yb+4>>2]=zb<<24>>24;MBa(8,0,42344,yb);yb=c[c[(b+4|0)>>2]>>2]|0;jd=c[(b+408|0)>>2]|0;kd=c[yb+16>>2]|0;ld=yb;md=1}yb=a[kd+99|0]|0;zb=a[jd+99|0]|0;if(yb<<24>>24==zb<<24>>24){nd=jd;od=kd;pd=ld;qd=md}else{c[xb>>2]=zb<<24>>24;c[xb+4>>2]=yb<<24>>24;MBa(8,0,42416,xb);xb=c[c[(b+4|0)>>2]>>2]|0;nd=c[(b+408|0)>>2]|0;od=c[xb+16>>2]|0;pd=xb;qd=1}xb=a[od+98|0]|0;yb=a[nd+98|0]|0;if(xb<<24>>24==yb<<24>>24){rd=nd;sd=od;td=pd;ud=qd}else{c[wb>>2]=yb<<24>>24;c[wb+4>>2]=xb<<24>>24;MBa(8,0,42480,wb);wb=c[c[(b+4|0)>>2]>>2]|0;rd=c[(b+408|0)>>2]|0;sd=c[wb+16>>2]|0;td=wb;ud=1}wb=a[sd+97|0]|0;xb=a[rd+97|0]|0;if(wb<<24>>24==xb<<24>>24){vd=rd;wd=sd;xd=td;yd=ud}else{c[vb>>2]=xb<<24>>24;c[vb+4>>2]=wb<<24>>24;MBa(8,0,42552,vb);vb=c[c[(b+4|0)>>2]>>2]|0;vd=c[(b+408|0)>>2]|0;wd=c[vb+16>>2]|0;xd=vb;yd=1}vb=a[wd+96|0]|0;wb=a[vd+96|0]|0;if(vb<<24>>24==wb<<24>>24){zd=vd;Ad=wd;Bd=xd;Cd=yd}else{c[ub>>2]=wb<<24>>24;c[ub+4>>2]=vb<<24>>24;MBa(8,0,42624,ub);ub=c[c[(b+4|0)>>2]>>2]|0;zd=c[(b+408|0)>>2]|0;Ad=c[ub+16>>2]|0;Bd=ub;Cd=1}ub=a[Ad+95|0]|0;vb=a[zd+95|0]|0;if(ub<<24>>24==vb<<24>>24){Dd=zd;Ed=Ad;Fd=Bd;Gd=Cd}else{c[tb>>2]=vb<<24>>24;c[tb+4>>2]=ub<<24>>24;MBa(8,0,42696,tb);tb=c[c[(b+4|0)>>2]>>2]|0;Dd=c[(b+408|0)>>2]|0;Ed=c[tb+16>>2]|0;Fd=tb;Gd=1}tb=a[Ed+94|0]|0;ub=a[Dd+94|0]|0;if(tb<<24>>24==ub<<24>>24){Hd=Dd;Id=Ed;Jd=Fd;Kd=Gd}else{c[sb>>2]=ub<<24>>24;c[sb+4>>2]=tb<<24>>24;MBa(8,0,42760,sb);sb=c[c[(b+4|0)>>2]>>2]|0;Hd=c[(b+408|0)>>2]|0;Id=c[sb+16>>2]|0;Jd=sb;Kd=1}sb=a[Id+93|0]|0;Id=a[Hd+93|0]|0;if(sb<<24>>24==Id<<24>>24){Ld=Jd;Md=Kd}else{c[rb>>2]=Id<<24>>24;c[rb+4>>2]=sb<<24>>24;MBa(8,0,42832,rb);Ld=c[c[(b+4|0)>>2]>>2]|0;Md=1}Nd=+h[(c[Ld+8>>2]|0)+6224>>3];Od=+h[(c[(b+400|0)>>2]|0)+6224>>3];if(Nd!=Od){h[k>>3]=Od;c[qb>>2]=c[k>>2];c[qb+4>>2]=c[k+4>>2];h[k>>3]=Nd;c[(qb+8|0)>>2]=c[k>>2];c[(qb+8|0)+4>>2]=c[k+4>>2];MBa(8,0,42904,qb);Pd=c[c[(b+4|0)>>2]>>2]|0;Qd=1}else{Pd=Ld;Qd=Md}Md=c[Pd+16>>2]|0;Ld=a[Md+92|0]|0;qb=c[(b+408|0)>>2]|0;rb=a[qb+92|0]|0;if(Ld<<24>>24==rb<<24>>24){Rd=qb;Sd=Md;Td=Pd;Ud=Qd}else{c[pb>>2]=rb<<24>>24;c[pb+4>>2]=Ld<<24>>24;MBa(8,0,42976,pb);pb=c[c[(b+4|0)>>2]>>2]|0;Rd=c[(b+408|0)>>2]|0;Sd=c[pb+16>>2]|0;Td=pb;Ud=1}pb=a[Sd+91|0]|0;Ld=a[Rd+91|0]|0;if(pb<<24>>24==Ld<<24>>24){Vd=Rd;Wd=Sd;Xd=Td;Yd=Ud}else{c[ob>>2]=Ld<<24>>24;c[ob+4>>2]=pb<<24>>24;MBa(8,0,43048,ob);ob=c[c[(b+4|0)>>2]>>2]|0;Vd=c[(b+408|0)>>2]|0;Wd=c[ob+16>>2]|0;Xd=ob;Yd=1}ob=a[Wd+90|0]|0;pb=a[Vd+90|0]|0;if(ob<<24>>24==pb<<24>>24){Zd=Vd;_d=Wd;$d=Xd;ae=Yd}else{c[nb>>2]=pb<<24>>24;c[nb+4>>2]=ob<<24>>24;MBa(8,0,43120,nb);nb=c[c[(b+4|0)>>2]>>2]|0;Zd=c[(b+408|0)>>2]|0;_d=c[nb+16>>2]|0;$d=nb;ae=1}nb=a[_d+89|0]|0;ob=a[Zd+89|0]|0;if(nb<<24>>24==ob<<24>>24){be=Zd;ce=_d;de=$d;ee=ae}else{c[mb>>2]=ob<<24>>24;c[mb+4>>2]=nb<<24>>24;MBa(8,0,43192,mb);mb=c[c[(b+4|0)>>2]>>2]|0;be=c[(b+408|0)>>2]|0;ce=c[mb+16>>2]|0;de=mb;ee=1}mb=a[ce+88|0]|0;nb=a[be+88|0]|0;if(mb<<24>>24==nb<<24>>24){fe=be;ge=ce;he=de;ie=ee}else{c[lb>>2]=nb<<24>>24;c[lb+4>>2]=mb<<24>>24;MBa(8,0,43256,lb);lb=c[c[(b+4|0)>>2]>>2]|0;fe=c[(b+408|0)>>2]|0;ge=c[lb+16>>2]|0;he=lb;ie=1}lb=a[ge+87|0]|0;mb=a[fe+87|0]|0;if(lb<<24>>24==mb<<24>>24){je=fe;ke=ge;le=he;me=ie}else{c[kb>>2]=mb<<24>>24;c[kb+4>>2]=lb<<24>>24;MBa(8,0,43328,kb);kb=c[c[(b+4|0)>>2]>>2]|0;je=c[(b+408|0)>>2]|0;ke=c[kb+16>>2]|0;le=kb;me=1}kb=a[ke+86|0]|0;lb=a[je+86|0]|0;if(kb<<24>>24==lb<<24>>24){ne=je;oe=ke;pe=le;qe=me}else{c[jb>>2]=lb<<24>>24;c[jb+4>>2]=kb<<24>>24;MBa(8,0,43400,jb);jb=c[c[(b+4|0)>>2]>>2]|0;ne=c[(b+408|0)>>2]|0;oe=c[jb+16>>2]|0;pe=jb;qe=1}jb=a[oe+85|0]|0;kb=a[ne+85|0]|0;if(jb<<24>>24==kb<<24>>24){re=ne;se=oe;te=pe;ue=qe}else{c[ib>>2]=kb<<24>>24;c[ib+4>>2]=jb<<24>>24;MBa(8,0,43472,ib);ib=c[c[(b+4|0)>>2]>>2]|0;re=c[(b+408|0)>>2]|0;se=c[ib+16>>2]|0;te=ib;ue=1}ib=a[se+84|0]|0;jb=a[re+84|0]|0;if(ib<<24>>24==jb<<24>>24){ve=re;we=se;xe=te;ye=ue}else{c[hb>>2]=jb<<24>>24;c[hb+4>>2]=ib<<24>>24;MBa(8,0,43536,hb);hb=c[c[(b+4|0)>>2]>>2]|0;ve=c[(b+408|0)>>2]|0;we=c[hb+16>>2]|0;xe=hb;ye=1}hb=a[we+83|0]|0;ib=a[ve+83|0]|0;if(hb<<24>>24==ib<<24>>24){ze=ve;Ae=we;Be=xe;Ce=ye}else{c[gb>>2]=ib<<24>>24;c[gb+4>>2]=hb<<24>>24;MBa(8,0,43608,gb);gb=c[c[(b+4|0)>>2]>>2]|0;ze=c[(b+408|0)>>2]|0;Ae=c[gb+16>>2]|0;Be=gb;Ce=1}gb=a[Ae+82|0]|0;hb=a[ze+82|0]|0;if(gb<<24>>24==hb<<24>>24){De=ze;Ee=Ae;Fe=Be;Ge=Ce}else{c[fb>>2]=hb<<24>>24;c[fb+4>>2]=gb<<24>>24;MBa(8,0,43680,fb);fb=c[c[(b+4|0)>>2]>>2]|0;De=c[(b+408|0)>>2]|0;Ee=c[fb+16>>2]|0;Fe=fb;Ge=1}fb=a[Ee+81|0]|0;gb=a[De+81|0]|0;if(fb<<24>>24==gb<<24>>24){He=De;Ie=Ee;Je=Fe;Ke=Ge}else{c[eb>>2]=gb<<24>>24;c[eb+4>>2]=fb<<24>>24;MBa(8,0,43752,eb);eb=c[c[(b+4|0)>>2]>>2]|0;He=c[(b+408|0)>>2]|0;Ie=c[eb+16>>2]|0;Je=eb;Ke=1}eb=a[Ie+80|0]|0;fb=a[He+80|0]|0;if(eb<<24>>24==fb<<24>>24){Le=He;Me=Ie;Ne=Je;Oe=Ke}else{c[db>>2]=fb<<24>>24;c[db+4>>2]=eb<<24>>24;MBa(8,0,43816,db);db=c[c[(b+4|0)>>2]>>2]|0;Le=c[(b+408|0)>>2]|0;Me=c[db+16>>2]|0;Ne=db;Oe=1}db=a[Me+79|0]|0;eb=a[Le+79|0]|0;if(db<<24>>24==eb<<24>>24){Pe=Le;Qe=Me;Re=Ne;Se=Oe}else{c[cb>>2]=eb<<24>>24;c[cb+4>>2]=db<<24>>24;MBa(8,0,43888,cb);cb=c[c[(b+4|0)>>2]>>2]|0;Pe=c[(b+408|0)>>2]|0;Qe=c[cb+16>>2]|0;Re=cb;Se=1}cb=a[Qe+78|0]|0;db=a[Pe+78|0]|0;if(cb<<24>>24==db<<24>>24){Te=Pe;Ue=Qe;Ve=Re;We=Se}else{c[bb>>2]=db<<24>>24;c[bb+4>>2]=cb<<24>>24;MBa(8,0,43960,bb);bb=c[c[(b+4|0)>>2]>>2]|0;Te=c[(b+408|0)>>2]|0;Ue=c[bb+16>>2]|0;Ve=bb;We=1}bb=a[Ue+77|0]|0;cb=a[Te+77|0]|0;if(bb<<24>>24==cb<<24>>24){Xe=Te;Ye=Ue;Ze=Ve;_e=We}else{c[ab>>2]=cb<<24>>24;c[ab+4>>2]=bb<<24>>24;MBa(8,0,44032,ab);ab=c[c[(b+4|0)>>2]>>2]|0;Xe=c[(b+408|0)>>2]|0;Ye=c[ab+16>>2]|0;Ze=ab;_e=1}ab=a[Ye+76|0]|0;bb=a[Xe+76|0]|0;if(ab<<24>>24==bb<<24>>24){$e=Xe;af=Ye;bf=Ze;cf=_e}else{c[$a>>2]=bb<<24>>24;c[$a+4>>2]=ab<<24>>24;MBa(8,0,44096,$a);$a=c[c[(b+4|0)>>2]>>2]|0;$e=c[(b+408|0)>>2]|0;af=c[$a+16>>2]|0;bf=$a;cf=1}$a=a[af+75|0]|0;af=a[$e+75|0]|0;if($a<<24>>24==af<<24>>24){df=bf;ef=cf}else{c[_a>>2]=af<<24>>24;c[_a+4>>2]=$a<<24>>24;MBa(8,0,44168,_a);df=c[c[(b+4|0)>>2]>>2]|0;ef=1}Nd=+h[(c[df+8>>2]|0)+6168>>3];Od=+h[(c[(b+400|0)>>2]|0)+6168>>3];if(Nd!=Od){h[k>>3]=Od;c[Za>>2]=c[k>>2];c[Za+4>>2]=c[k+4>>2];h[k>>3]=Nd;c[(Za+8|0)>>2]=c[k>>2];c[(Za+8|0)+4>>2]=c[k+4>>2];MBa(8,0,44240,Za);ff=c[c[(b+4|0)>>2]>>2]|0;gf=1}else{ff=df;gf=ef}ef=c[ff+16>>2]|0;df=a[ef+74|0]|0;Za=c[(b+408|0)>>2]|0;_a=a[Za+74|0]|0;if(df<<24>>24==_a<<24>>24){hf=Za;jf=ef;kf=ff;lf=gf}else{c[Ya>>2]=_a<<24>>24;c[Ya+4>>2]=df<<24>>24;MBa(8,0,44312,Ya);Ya=c[c[(b+4|0)>>2]>>2]|0;hf=c[(b+408|0)>>2]|0;jf=c[Ya+16>>2]|0;kf=Ya;lf=1}Ya=a[jf+73|0]|0;df=a[hf+73|0]|0;if(Ya<<24>>24==df<<24>>24){mf=hf;nf=jf;of=kf;pf=lf}else{c[Xa>>2]=df<<24>>24;c[Xa+4>>2]=Ya<<24>>24;MBa(8,0,44392,Xa);Xa=c[c[(b+4|0)>>2]>>2]|0;mf=c[(b+408|0)>>2]|0;nf=c[Xa+16>>2]|0;of=Xa;pf=1}Xa=a[nf+72|0]|0;Ya=a[mf+72|0]|0;if(Xa<<24>>24==Ya<<24>>24){qf=mf;rf=nf;sf=of;tf=pf}else{c[Wa>>2]=Ya<<24>>24;c[Wa+4>>2]=Xa<<24>>24;MBa(8,0,44472,Wa);Wa=c[c[(b+4|0)>>2]>>2]|0;qf=c[(b+408|0)>>2]|0;rf=c[Wa+16>>2]|0;sf=Wa;tf=1}Wa=a[rf+71|0]|0;Xa=a[qf+71|0]|0;if(Wa<<24>>24==Xa<<24>>24){uf=qf;vf=rf;wf=sf;xf=tf}else{c[Va>>2]=Xa<<24>>24;c[Va+4>>2]=Wa<<24>>24;MBa(8,0,44544,Va);Va=c[c[(b+4|0)>>2]>>2]|0;uf=c[(b+408|0)>>2]|0;vf=c[Va+16>>2]|0;wf=Va;xf=1}Va=a[vf+70|0]|0;Wa=a[uf+70|0]|0;if(Va<<24>>24==Wa<<24>>24){yf=uf;zf=vf;Af=wf;Bf=xf}else{c[Ua>>2]=Wa<<24>>24;c[Ua+4>>2]=Va<<24>>24;MBa(8,0,44616,Ua);Ua=c[c[(b+4|0)>>2]>>2]|0;yf=c[(b+408|0)>>2]|0;zf=c[Ua+16>>2]|0;Af=Ua;Bf=1}Ua=a[zf+69|0]|0;Va=a[yf+69|0]|0;if(Ua<<24>>24==Va<<24>>24){Cf=yf;Df=zf;Ef=Af;Ff=Bf}else{c[Ta>>2]=Va<<24>>24;c[Ta+4>>2]=Ua<<24>>24;MBa(8,0,44688,Ta);Ta=c[c[(b+4|0)>>2]>>2]|0;Cf=c[(b+408|0)>>2]|0;Df=c[Ta+16>>2]|0;Ef=Ta;Ff=1}Ta=a[Df+68|0]|0;Ua=a[Cf+68|0]|0;if(Ta<<24>>24==Ua<<24>>24){Gf=Cf;Hf=Df;If=Ef;Jf=Ff}else{c[Sa>>2]=Ua<<24>>24;c[Sa+4>>2]=Ta<<24>>24;MBa(8,0,44752,Sa);Sa=c[c[(b+4|0)>>2]>>2]|0;Gf=c[(b+408|0)>>2]|0;Hf=c[Sa+16>>2]|0;If=Sa;Jf=1}Sa=a[Hf+67|0]|0;Ta=a[Gf+67|0]|0;if(Sa<<24>>24==Ta<<24>>24){Kf=Gf;Lf=Hf;Mf=If;Nf=Jf}else{c[Ra>>2]=Ta<<24>>24;c[Ra+4>>2]=Sa<<24>>24;MBa(8,0,44824,Ra);Ra=c[c[(b+4|0)>>2]>>2]|0;Kf=c[(b+408|0)>>2]|0;Lf=c[Ra+16>>2]|0;Mf=Ra;Nf=1}Ra=a[Lf+66|0]|0;Sa=a[Kf+66|0]|0;if(Ra<<24>>24==Sa<<24>>24){Of=Kf;Pf=Lf;Qf=Mf;Rf=Nf}else{c[Qa>>2]=Sa<<24>>24;c[Qa+4>>2]=Ra<<24>>24;MBa(8,0,44896,Qa);Qa=c[c[(b+4|0)>>2]>>2]|0;Of=c[(b+408|0)>>2]|0;Pf=c[Qa+16>>2]|0;Qf=Qa;Rf=1}Qa=a[Pf+65|0]|0;Ra=a[Of+65|0]|0;if(Qa<<24>>24==Ra<<24>>24){Sf=Of;Tf=Pf;Uf=Qf;Vf=Rf}else{c[Pa>>2]=Ra<<24>>24;c[Pa+4>>2]=Qa<<24>>24;MBa(8,0,44968,Pa);Pa=c[c[(b+4|0)>>2]>>2]|0;Sf=c[(b+408|0)>>2]|0;Tf=c[Pa+16>>2]|0;Uf=Pa;Vf=1}Pa=a[Tf+64|0]|0;Qa=a[Sf+64|0]|0;if(Pa<<24>>24==Qa<<24>>24){Wf=Sf;Xf=Tf;Yf=Uf;Zf=Vf}else{c[Oa>>2]=Qa<<24>>24;c[Oa+4>>2]=Pa<<24>>24;MBa(8,0,45032,Oa);Oa=c[c[(b+4|0)>>2]>>2]|0;Wf=c[(b+408|0)>>2]|0;Xf=c[Oa+16>>2]|0;Yf=Oa;Zf=1}Oa=a[Xf+63|0]|0;Pa=a[Wf+63|0]|0;if(Oa<<24>>24==Pa<<24>>24){_f=Wf;$f=Xf;ag=Yf;bg=Zf}else{c[Na>>2]=Pa<<24>>24;c[Na+4>>2]=Oa<<24>>24;MBa(8,0,45104,Na);Na=c[c[(b+4|0)>>2]>>2]|0;_f=c[(b+408|0)>>2]|0;$f=c[Na+16>>2]|0;ag=Na;bg=1}Na=a[$f+62|0]|0;Oa=a[_f+62|0]|0;if(Na<<24>>24==Oa<<24>>24){cg=_f;dg=$f;eg=ag;fg=bg}else{c[Ma>>2]=Oa<<24>>24;c[Ma+4>>2]=Na<<24>>24;MBa(8,0,45176,Ma);Ma=c[c[(b+4|0)>>2]>>2]|0;cg=c[(b+408|0)>>2]|0;dg=c[Ma+16>>2]|0;eg=Ma;fg=1}Ma=a[dg+61|0]|0;Na=a[cg+61|0]|0;if(Ma<<24>>24==Na<<24>>24){gg=cg;hg=dg;ig=eg;jg=fg}else{c[La>>2]=Na<<24>>24;c[La+4>>2]=Ma<<24>>24;MBa(8,0,45248,La);La=c[c[(b+4|0)>>2]>>2]|0;gg=c[(b+408|0)>>2]|0;hg=c[La+16>>2]|0;ig=La;jg=1}La=a[hg+60|0]|0;Ma=a[gg+60|0]|0;c[d+16>>2]=b;c[d+4680>>2]=gg;c[d+4688>>2]=hg;c[d+4696>>2]=ig;c[d+4704>>2]=La;c[d+4712>>2]=Ma;c[d+7088>>2]=jg;c[d+7816>>2]=Ka;c[d+7824>>2]=Ja;c[d+7832>>2]=Ia;c[d+7840>>2]=Ha;c[d+7848>>2]=Ga;c[d+7856>>2]=Fa;c[d+7864>>2]=Ea;c[d+7872>>2]=Da;c[d+7880>>2]=Ca;c[d+7896>>2]=Ba;c[d+7904>>2]=Aa;c[d+7912>>2]=za;c[d+7920>>2]=ya;c[d+7928>>2]=xa;c[d+7936>>2]=wa;c[d+7944>>2]=va;c[d+7952>>2]=ua;c[d+7960>>2]=ta;c[d+7968>>2]=sa;c[d+7984>>2]=ra;c[d+7992>>2]=qa;c[d+8e3>>2]=pa;c[d+8008>>2]=oa;c[d+8016>>2]=na;c[d+8024>>2]=ma;c[d+8032>>2]=la;c[d+8040>>2]=ka;c[d+8048>>2]=ja;c[d+8056>>2]=ia;c[d+8072>>2]=ha;c[d+8080>>2]=ga;c[d+8088>>2]=fa;c[d+8096>>2]=ea;c[d+8104>>2]=da;c[d+8112>>2]=ca;c[d+8120>>2]=ba;c[d+8128>>2]=aa;c[d+8136>>2]=$;c[d+8144>>2]=_;c[d+8168>>2]=Z;c[d+8176>>2]=Y;c[d+8184>>2]=X;c[d+8192>>2]=W;c[d+8200>>2]=V;c[d+8208>>2]=U;c[d+8216>>2]=T;c[d+8224>>2]=S;c[d+8232>>2]=R;c[d+8240>>2]=Q;c[d+8256>>2]=P;c[d+8264>>2]=O;c[d+8272>>2]=N;c[d+8280>>2]=M;c[d+8288>>2]=L;c[d+8296>>2]=K;c[d+8304>>2]=J;c[d+8312>>2]=G;c[d+8320>>2]=F;c[d+8328>>2]=E;c[d+8344>>2]=D;c[d+8352>>2]=C;c[d+8360>>2]=B;c[d+8368>>2]=z;c[d+8376>>2]=y;c[d+8384>>2]=x;c[d+8392>>2]=w;c[d+8400>>2]=v;c[d+8408>>2]=u;c[d+8416>>2]=t;c[d+8432>>2]=s;c[d+8440>>2]=r;c[d+8448>>2]=q;c[d+8456>>2]=p;c[d+8464>>2]=o;c[d+8472>>2]=n;c[d+8480>>2]=m;c[d+8488>>2]=l;c[d+8496>>2]=j;c[d+8504>>2]=f;c[d+8520>>2]=e;c[d+8576>>2]=0;c[d+8580>>2]=0;_Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_checkForDiscreteChanges$0(d);H=c[d+8576>>2]|0;A=c[d+8580>>2]|0;I=+g[d+8580>>2];c[d+8576>>2]=0;c[d+8580>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function sB(a){a=a|0;i=i;return c[57472+(a<<2)>>2]|0}function _Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_function_updateRelations$0(b){b=b|0;var d=0,e=0,f=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0.0,q=0;d=c[b+14696>>2]|0;e=c[b+15664>>2]|0;f=+g[b+15696>>2];j=c[b+16936>>2]|0;k=c[b+16952>>2]|0;l=c[b+16960>>2]|0;a:do{j=(b+6760|0)+0|0;k=(b+7280|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14160|0,e,f,b+6760|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(b+14160|0)>>3],a[(c[(d+360|0)>>2]|0)+3|0]|0)|0;a[(c[(d+352|0)>>2]|0)+3|0]=m;Xu(b+7384|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];j=(b+6656|0)+0|0;k=(b+7384|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14168|0,m,n,b+6656|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(b+14168|0)>>3],a[(c[(d+360|0)>>2]|0)+4|0]|0)|0;a[(c[(d+352|0)>>2]|0)+4|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+5|0]|0)|0;a[(c[(d+352|0)>>2]|0)+5|0]=o;mu(b+7488|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];j=(b+6552|0)+0|0;k=(b+7488|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14176|0,o,p,b+6552|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3],+h[(b+14176|0)>>3],a[(c[(d+360|0)>>2]|0)+6|0]|0)|0;a[(c[(d+352|0)>>2]|0)+6|0]=m;Xu(b+7592|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];j=(b+6448|0)+0|0;k=(b+7592|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14184|0,m,n,b+6448|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3],+h[(b+14184|0)>>3],a[(c[(d+360|0)>>2]|0)+7|0]|0)|0;a[(c[(d+352|0)>>2]|0)+7|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+8|0]|0)|0;a[(c[(d+352|0)>>2]|0)+8|0]=o;mu(b+7696|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];j=(b+6344|0)+0|0;k=(b+7696|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14192|0,o,p,b+6344|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],+h[(b+14192|0)>>3],a[(c[(d+360|0)>>2]|0)+9|0]|0)|0;a[(c[(d+352|0)>>2]|0)+9|0]=m;Xu(b+7800|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];j=(b+6240|0)+0|0;k=(b+7800|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14200|0,m,n,b+6240|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],+h[(b+14200|0)>>3],a[(c[(d+360|0)>>2]|0)+10|0]|0)|0;a[(c[(d+352|0)>>2]|0)+10|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+11|0]|0)|0;a[(c[(d+352|0)>>2]|0)+11|0]=o;mu(b+7904|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];j=(b+6136|0)+0|0;k=(b+7904|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14208|0,o,p,b+6136|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3],+h[(b+14208|0)>>3],a[(c[(d+360|0)>>2]|0)+12|0]|0)|0;a[(c[(d+352|0)>>2]|0)+12|0]=m;Xu(b+8008|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];j=(b+6032|0)+0|0;k=(b+8008|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14216|0,m,n,b+6032|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3],+h[(b+14216|0)>>3],a[(c[(d+360|0)>>2]|0)+13|0]|0)|0;a[(c[(d+352|0)>>2]|0)+13|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+14|0]|0)|0;a[(c[(d+352|0)>>2]|0)+14|0]=o;mu(b+8112|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];j=(b+5928|0)+0|0;k=(b+8112|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14224|0,o,p,b+5928|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(b+14224|0)>>3],a[(c[(d+360|0)>>2]|0)+15|0]|0)|0;a[(c[(d+352|0)>>2]|0)+15|0]=m;Xu(b+8216|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];j=(b+5824|0)+0|0;k=(b+8216|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14232|0,m,n,b+5824|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(b+14232|0)>>3],a[(c[(d+360|0)>>2]|0)+16|0]|0)|0;a[(c[(d+352|0)>>2]|0)+16|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+17|0]|0)|0;a[(c[(d+352|0)>>2]|0)+17|0]=o;mu(b+8320|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];j=(b+5720|0)+0|0;k=(b+8320|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14240|0,o,p,b+5720|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3],+h[(b+14240|0)>>3],a[(c[(d+360|0)>>2]|0)+18|0]|0)|0;a[(c[(d+352|0)>>2]|0)+18|0]=m;Xu(b+8424|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];j=(b+5616|0)+0|0;k=(b+8424|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14248|0,m,n,b+5616|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3],+h[(b+14248|0)>>3],a[(c[(d+360|0)>>2]|0)+19|0]|0)|0;a[(c[(d+352|0)>>2]|0)+19|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+20|0]|0)|0;a[(c[(d+352|0)>>2]|0)+20|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+120>>3],+h[o+560>>3]+ +h[o+3032>>3],a[(c[(d+360|0)>>2]|0)+21|0]|0)|0;a[(c[(d+352|0)>>2]|0)+21|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+120>>3],+h[q+560>>3]- +h[q+3032>>3],a[(c[(d+360|0)>>2]|0)+22|0]|0)|0;a[(c[(d+352|0)>>2]|0)+22|0]=o;mu(b+8528|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+4752>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+4752>>3];j=(b+5512|0)+0|0;k=(b+8528|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14256|0,o,p,b+5512|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3],+h[(b+14256|0)>>3],a[(c[(d+360|0)>>2]|0)+23|0]|0)|0;a[(c[(d+352|0)>>2]|0)+23|0]=m;Xu(b+8632|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+4752>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+4752>>3];j=(b+5408|0)+0|0;k=(b+8632|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14264|0,m,n,b+5408|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3],+h[(b+14264|0)>>3],a[(c[(d+360|0)>>2]|0)+24|0]|0)|0;a[(c[(d+352|0)>>2]|0)+24|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+136>>3],+h[o+1960>>3]+ +h[o+3048>>3],a[(c[(d+360|0)>>2]|0)+25|0]|0)|0;a[(c[(d+352|0)>>2]|0)+25|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+136>>3],+h[q+1960>>3]- +h[q+3048>>3],a[(c[(d+360|0)>>2]|0)+26|0]|0)|0;a[(c[(d+352|0)>>2]|0)+26|0]=o;mu(b+8736|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+3048>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+3048>>3];j=(b+5304|0)+0|0;k=(b+8736|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14272|0,o,p,b+5304|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(b+14272|0)>>3],a[(c[(d+360|0)>>2]|0)+27|0]|0)|0;a[(c[(d+352|0)>>2]|0)+27|0]=m;Xu(b+8840|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+3048>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+3048>>3];j=(b+5200|0)+0|0;k=(b+8840|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14280|0,m,n,b+5200|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(b+14280|0)>>3],a[(c[(d+360|0)>>2]|0)+28|0]|0)|0;a[(c[(d+352|0)>>2]|0)+28|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+152>>3],+h[o+2016>>3]+ +h[o+3064>>3],a[(c[(d+360|0)>>2]|0)+29|0]|0)|0;a[(c[(d+352|0)>>2]|0)+29|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+152>>3],+h[q+2016>>3]- +h[q+3064>>3],a[(c[(d+360|0)>>2]|0)+30|0]|0)|0;a[(c[(d+352|0)>>2]|0)+30|0]=o;mu(b+8944|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2936>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+2936>>3];j=(b+5096|0)+0|0;k=(b+8944|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14288|0,o,p,b+5096|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3],+h[(b+14288|0)>>3],a[(c[(d+360|0)>>2]|0)+31|0]|0)|0;a[(c[(d+352|0)>>2]|0)+31|0]=m;Xu(b+9048|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2936>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+2936>>3];j=(b+4992|0)+0|0;k=(b+9048|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14296|0,m,n,b+4992|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3],+h[(b+14296|0)>>3],a[(c[(d+360|0)>>2]|0)+32|0]|0)|0;a[(c[(d+352|0)>>2]|0)+32|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+168>>3],+h[o+2080>>3]+ +h[o+3088>>3],a[(c[(d+360|0)>>2]|0)+33|0]|0)|0;a[(c[(d+352|0)>>2]|0)+33|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+168>>3],+h[q+2080>>3]- +h[q+3088>>3],a[(c[(d+360|0)>>2]|0)+34|0]|0)|0;a[(c[(d+352|0)>>2]|0)+34|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+168>>3],+h[o+2072>>3]+ +h[o+3080>>3],a[(c[(d+360|0)>>2]|0)+35|0]|0)|0;a[(c[(d+352|0)>>2]|0)+35|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+168>>3],+h[q+2072>>3]- +h[q+3080>>3],a[(c[(d+360|0)>>2]|0)+36|0]|0)|0;a[(c[(d+352|0)>>2]|0)+36|0]=o;mu(b+9152|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2824>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+2824>>3];j=(b+4888|0)+0|0;k=(b+9152|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14304|0,o,p,b+4888|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(b+14304|0)>>3],a[(c[(d+360|0)>>2]|0)+37|0]|0)|0;a[(c[(d+352|0)>>2]|0)+37|0]=m;Xu(b+9256|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2824>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+2824>>3];j=(b+4784|0)+0|0;k=(b+9256|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14312|0,m,n,b+4784|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(b+14312|0)>>3],a[(c[(d+360|0)>>2]|0)+38|0]|0)|0;a[(c[(d+352|0)>>2]|0)+38|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+184>>3],+h[o+2168>>3]+ +h[o+3112>>3],a[(c[(d+360|0)>>2]|0)+39|0]|0)|0;a[(c[(d+352|0)>>2]|0)+39|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+184>>3],+h[q+2168>>3]- +h[q+3112>>3],a[(c[(d+360|0)>>2]|0)+40|0]|0)|0;a[(c[(d+352|0)>>2]|0)+40|0]=o;mu(b+9360|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2712>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+2712>>3];j=(b+4680|0)+0|0;k=(b+9360|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14320|0,o,p,b+4680|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3],+h[(b+14320|0)>>3],a[(c[(d+360|0)>>2]|0)+41|0]|0)|0;a[(c[(d+352|0)>>2]|0)+41|0]=m;Xu(b+9464|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2712>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+2712>>3];j=(b+4576|0)+0|0;k=(b+9464|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14328|0,m,n,b+4576|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3],+h[(b+14328|0)>>3],a[(c[(d+360|0)>>2]|0)+42|0]|0)|0;a[(c[(d+352|0)>>2]|0)+42|0]=o;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+200>>3],+h[o+2224>>3]+ +h[o+3128>>3],a[(c[(d+360|0)>>2]|0)+43|0]|0)|0;a[(c[(d+352|0)>>2]|0)+43|0]=q;q=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[q+200>>3],+h[q+2224>>3]- +h[q+3128>>3],a[(c[(d+360|0)>>2]|0)+44|0]|0)|0;a[(c[(d+352|0)>>2]|0)+44|0]=o;mu(b+9568|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2456>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+2456>>3];j=(b+4472|0)+0|0;k=(b+9568|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14336|0,o,p,b+4472|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3],+h[(b+14336|0)>>3],a[(c[(d+360|0)>>2]|0)+45|0]|0)|0;a[(c[(d+352|0)>>2]|0)+45|0]=m;Xu(b+9672|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2456>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+2456>>3];j=(b+4368|0)+0|0;k=(b+9672|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14344|0,m,n,b+4368|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3],+h[(b+14344|0)>>3],a[(c[(d+360|0)>>2]|0)+46|0]|0)|0;a[(c[(d+352|0)>>2]|0)+46|0]=o;mu(b+9776|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];j=(b+4264|0)+0|0;k=(b+9776|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14352|0,o,p,b+4264|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],+h[(b+14352|0)>>3],a[(c[(d+360|0)>>2]|0)+47|0]|0)|0;a[(c[(d+352|0)>>2]|0)+47|0]=m;Xu(b+9880|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];j=(b+4160|0)+0|0;k=(b+9880|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14360|0,m,n,b+4160|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],+h[(b+14360|0)>>3],a[(c[(d+360|0)>>2]|0)+48|0]|0)|0;a[(c[(d+352|0)>>2]|0)+48|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+49|0]|0)|0;a[(c[(d+352|0)>>2]|0)+49|0]=o;mu(b+9984|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];j=(b+4056|0)+0|0;k=(b+9984|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14368|0,o,p,b+4056|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3],+h[(b+14368|0)>>3],a[(c[(d+360|0)>>2]|0)+50|0]|0)|0;a[(c[(d+352|0)>>2]|0)+50|0]=m;Xu(b+10088|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];j=(b+3952|0)+0|0;k=(b+10088|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14376|0,m,n,b+3952|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3],+h[(b+14376|0)>>3],a[(c[(d+360|0)>>2]|0)+51|0]|0)|0;a[(c[(d+352|0)>>2]|0)+51|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+52|0]|0)|0;a[(c[(d+352|0)>>2]|0)+52|0]=o;mu(b+10192|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);o=c[(d+536|0)>>2]|0;p=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];j=(b+3848|0)+0|0;k=(b+10192|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14384|0,o,p,b+3848|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],+h[(b+14384|0)>>3],a[(c[(d+360|0)>>2]|0)+53|0]|0)|0;a[(c[(d+352|0)>>2]|0)+53|0]=m;Xu(b+10296|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];j=(b+3744|0)+0|0;k=(b+10296|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14392|0,m,n,b+3744|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],+h[(b+14392|0)>>3],a[(c[(d+360|0)>>2]|0)+54|0]|0)|0;a[(c[(d+352|0)>>2]|0)+54|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+55|0]|0)|0;a[(c[(d+352|0)>>2]|0)+55|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],+h[(c[(d+416|0)>>2]|0)+2824>>3],a[(c[(d+360|0)>>2]|0)+56|0]|0)|0;a[(c[(d+352|0)>>2]|0)+56|0]=o;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+57|0]|0)|0;a[(c[(d+352|0)>>2]|0)+57|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+584>>3],+h[(c[(d+416|0)>>2]|0)+4752>>3],a[(c[(d+360|0)>>2]|0)+58|0]|0)|0;a[(c[(d+352|0)>>2]|0)+58|0]=o;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+59|0]|0)|0;a[(c[(d+352|0)>>2]|0)+59|0]=o;o=c[c[(d+4|0)>>2]>>2]|0;q=lFa(+h[o>>3],+h[(c[o+8>>2]|0)+4184>>3],a[(c[(d+360|0)>>2]|0)+60|0]|0)|0;a[(c[(d+352|0)>>2]|0)+60|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1984>>3],+h[(c[(d+416|0)>>2]|0)+3048>>3],a[(c[(d+360|0)>>2]|0)+61|0]|0)|0;a[(c[(d+352|0)>>2]|0)+61|0]=q;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+62|0]|0)|0;a[(c[(d+352|0)>>2]|0)+62|0]=q;q=c[c[(d+4|0)>>2]>>2]|0;o=lFa(+h[q>>3],+h[(c[q+8>>2]|0)+4216>>3],a[(c[(d+360|0)>>2]|0)+63|0]|0)|0;a[(c[(d+352|0)>>2]|0)+63|0]=o;o=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[(d+360|0)>>2]|0)+64|0]|0)|0;a[(c[(d+352|0)>>2]|0)+64|0]=o;o=c[c[(d+4|0)>>2]>>2]|0;q=oFa(+h[o>>3],+h[(c[o+8>>2]|0)+6168>>3]+ +h[(c[(d+416|0)>>2]|0)+1016>>3],a[(c[(d+360|0)>>2]|0)+65|0]|0)|0;a[(c[(d+352|0)>>2]|0)+65|0]=q;q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[(d+360|0)>>2]|0)+66|0]|0)|0;a[(c[(d+352|0)>>2]|0)+66|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2128>>3],+h[(c[(d+416|0)>>2]|0)+2824>>3],a[(c[(d+360|0)>>2]|0)+67|0]|0)|0;a[(c[(d+352|0)>>2]|0)+67|0]=q;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+68|0]|0)|0;a[(c[(d+352|0)>>2]|0)+68|0]=q;q=c[c[(d+4|0)>>2]>>2]|0;o=oFa(+h[q>>3],+h[(c[q+8>>2]|0)+6224>>3]+ +h[(c[(d+416|0)>>2]|0)+1008>>3],a[(c[(d+360|0)>>2]|0)+69|0]|0)|0;a[(c[(d+352|0)>>2]|0)+69|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2192>>3],+h[(c[(d+416|0)>>2]|0)+2712>>3],a[(c[(d+360|0)>>2]|0)+70|0]|0)|0;a[(c[(d+352|0)>>2]|0)+70|0]=o;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+71|0]|0)|0;a[(c[(d+352|0)>>2]|0)+71|0]=o;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2248>>3],+h[(c[(d+416|0)>>2]|0)+2456>>3],a[(c[(d+360|0)>>2]|0)+72|0]|0)|0;a[(c[(d+352|0)>>2]|0)+72|0]=o;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+73|0]|0)|0;a[(c[(d+352|0)>>2]|0)+73|0]=o;o=c[c[(d+4|0)>>2]>>2]|0;q=oFa(+h[o>>3],+h[(c[o+8>>2]|0)+6080>>3]+ +h[(c[(d+416|0)>>2]|0)+1032>>3],a[(c[(d+360|0)>>2]|0)+74|0]|0)|0;a[(c[(d+352|0)>>2]|0)+74|0]=q;mu(b+10400|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+776>>3]);q=c[(d+536|0)>>2]|0;p=+h[(c[(d+416|0)>>2]|0)+776>>3];j=(b+3640|0)+0|0;k=(b+10400|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14400|0,q,p,b+3640|0);m=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3],+h[(b+14400|0)>>3],a[(c[(d+360|0)>>2]|0)+75|0]|0)|0;a[(c[(d+352|0)>>2]|0)+75|0]=m;Xu(b+10504|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+776>>3]);m=c[(d+536|0)>>2]|0;n=+h[(c[(d+416|0)>>2]|0)+776>>3];j=(b+3536|0)+0|0;k=(b+10504|0)+0|0;l=j+104|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));nu(b+14408|0,m,n,b+3536|0);q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3],+h[(b+14408|0)>>3],a[(c[(d+360|0)>>2]|0)+76|0]|0)|0;a[(c[(d+352|0)>>2]|0)+76|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[(d+360|0)>>2]|0)+77|0]|0)|0;a[(c[(d+352|0)>>2]|0)+77|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[(d+360|0)>>2]|0)+78|0]|0)|0;a[(c[(d+352|0)>>2]|0)+78|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[(d+360|0)>>2]|0)+79|0]|0)|0;a[(c[(d+352|0)>>2]|0)+79|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[(d+360|0)>>2]|0)+80|0]|0)|0;a[(c[(d+352|0)>>2]|0)+80|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[(d+360|0)>>2]|0)+81|0]|0)|0;a[(c[(d+352|0)>>2]|0)+81|0]=q;q=oFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[(d+416|0)>>2]|0)+1e3>>3],a[(c[(d+360|0)>>2]|0)+82|0]|0)|0;a[(c[(d+352|0)>>2]|0)+82|0]=q;q=mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[(d+360|0)>>2]|0)+83|0]|0)|0;a[(c[(d+352|0)>>2]|0)+83|0]=q;q=oFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[(d+360|0)>>2]|0)+84|0]|0)|0;a[(c[(d+352|0)>>2]|0)+84|0]=q;q=nFa(+h[c[c[(d+4|0)>>2]>>2]>>3],2500.0,a[(c[(d+360|0)>>2]|0)+85|0]|0)|0;a[(c[(d+352|0)>>2]|0)+85|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[(d+416|0)>>2]|0)+776>>3],a[(c[(d+360|0)>>2]|0)+86|0]|0)|0;a[(c[(d+352|0)>>2]|0)+86|0]=q;q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+87|0]|0)|0;a[(c[(d+352|0)>>2]|0)+87|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[(d+360|0)>>2]|0)+88|0]|0)|0;a[(c[(d+352|0)>>2]|0)+88|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2352>>3],+h[(c[(d+416|0)>>2]|0)+776>>3],a[(c[(d+360|0)>>2]|0)+89|0]|0)|0;a[(c[(d+352|0)>>2]|0)+89|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2360>>3],+h[(c[(d+416|0)>>2]|0)+776>>3],a[(c[(d+360|0)>>2]|0)+90|0]|0)|0;a[(c[(d+352|0)>>2]|0)+90|0]=q;q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+91|0]|0)|0;a[(c[(d+352|0)>>2]|0)+91|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[(d+360|0)>>2]|0)+92|0]|0)|0;a[(c[(d+352|0)>>2]|0)+92|0]=q;q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2040>>3],+h[(c[(d+416|0)>>2]|0)+2936>>3],a[(c[(d+360|0)>>2]|0)+93|0]|0)|0;a[(c[(d+352|0)>>2]|0)+93|0]=q;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+94|0]|0)|0;a[(c[(d+352|0)>>2]|0)+94|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+2480>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2224>>3],a[(c[(d+360|0)>>2]|0)+95|0]|0)|0;a[(c[(d+352|0)>>2]|0)+95|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+2736>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2168>>3],a[(c[(d+360|0)>>2]|0)+96|0]|0)|0;a[(c[(d+352|0)>>2]|0)+96|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+2848>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2072>>3],a[(c[(d+360|0)>>2]|0)+97|0]|0)|0;a[(c[(d+352|0)>>2]|0)+97|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+2848>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2080>>3],a[(c[(d+360|0)>>2]|0)+98|0]|0)|0;a[(c[(d+352|0)>>2]|0)+98|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+2960>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2016>>3],a[(c[(d+360|0)>>2]|0)+99|0]|0)|0;a[(c[(d+352|0)>>2]|0)+99|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+3072>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1960>>3],a[(c[(d+360|0)>>2]|0)+100|0]|0)|0;a[(c[(d+352|0)>>2]|0)+100|0]=q;q=oFa(+h[(c[(d+416|0)>>2]|0)+4776>>3],+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+560>>3],a[(c[(d+360|0)>>2]|0)+101|0]|0)|0;a[(c[(d+352|0)>>2]|0)+101|0]=q;i=b;c[b+16976>>2]=6;c[b+16980>>2]=0;break a}while(0);c[b+16936>>2]=j;c[b+16952>>2]=k;c[b+16960>>2]=l}function _Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_checkForDiscreteChanges$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0;d=c[b+16>>2]|0;e=c[b+4680>>2]|0;f=c[b+4688>>2]|0;g=c[b+4696>>2]|0;j=c[b+4704>>2]|0;l=c[b+4712>>2]|0;m=c[b+7088>>2]|0;n=c[b+7816>>2]|0;o=c[b+7824>>2]|0;p=c[b+7832>>2]|0;q=c[b+7840>>2]|0;r=c[b+7848>>2]|0;s=c[b+7856>>2]|0;t=c[b+7864>>2]|0;u=c[b+7872>>2]|0;v=c[b+7880>>2]|0;w=c[b+7896>>2]|0;x=c[b+7904>>2]|0;y=c[b+7912>>2]|0;z=c[b+7920>>2]|0;A=c[b+7928>>2]|0;B=c[b+7936>>2]|0;C=c[b+7944>>2]|0;D=c[b+7952>>2]|0;E=c[b+7960>>2]|0;F=c[b+7968>>2]|0;G=c[b+7984>>2]|0;H=c[b+7992>>2]|0;I=c[b+8e3>>2]|0;J=c[b+8008>>2]|0;K=c[b+8016>>2]|0;L=c[b+8024>>2]|0;M=c[b+8032>>2]|0;N=c[b+8040>>2]|0;O=c[b+8048>>2]|0;P=c[b+8056>>2]|0;Q=c[b+8072>>2]|0;R=c[b+8080>>2]|0;S=c[b+8088>>2]|0;T=c[b+8096>>2]|0;U=c[b+8104>>2]|0;V=c[b+8112>>2]|0;W=c[b+8120>>2]|0;X=c[b+8128>>2]|0;Y=c[b+8136>>2]|0;Z=c[b+8144>>2]|0;_=c[b+8168>>2]|0;$=c[b+8176>>2]|0;aa=c[b+8184>>2]|0;ba=c[b+8192>>2]|0;ca=c[b+8200>>2]|0;da=c[b+8208>>2]|0;ea=c[b+8216>>2]|0;fa=c[b+8224>>2]|0;ga=c[b+8232>>2]|0;ha=c[b+8240>>2]|0;ia=c[b+8256>>2]|0;ja=c[b+8264>>2]|0;ka=c[b+8272>>2]|0;la=c[b+8280>>2]|0;ma=c[b+8288>>2]|0;na=c[b+8296>>2]|0;oa=c[b+8304>>2]|0;pa=c[b+8312>>2]|0;qa=c[b+8320>>2]|0;ra=c[b+8328>>2]|0;sa=c[b+8344>>2]|0;ta=c[b+8352>>2]|0;ua=c[b+8360>>2]|0;va=c[b+8368>>2]|0;wa=c[b+8376>>2]|0;xa=c[b+8384>>2]|0;ya=c[b+8392>>2]|0;za=c[b+8400>>2]|0;Aa=c[b+8408>>2]|0;Ba=c[b+8416>>2]|0;Ca=c[b+8432>>2]|0;Da=c[b+8440>>2]|0;Ea=c[b+8448>>2]|0;Fa=c[b+8456>>2]|0;Ga=c[b+8464>>2]|0;Ha=c[b+8472>>2]|0;Ia=c[b+8480>>2]|0;Ja=c[b+8488>>2]|0;Ka=c[b+8496>>2]|0;La=c[b+8504>>2]|0;Ma=c[b+8520>>2]|0;a:do{if(j<<24>>24==l<<24>>24){Na=e;Oa=f;Pa=g;Qa=m}else{c[n>>2]=l<<24>>24;c[n+4>>2]=j<<24>>24;MBa(8,0,45312,n);Ra=c[c[(d+4|0)>>2]>>2]|0;Na=c[(d+408|0)>>2]|0;Oa=c[Ra+16>>2]|0;Pa=Ra;Qa=1}Ra=a[Oa+59|0]|0;Sa=a[Na+59|0]|0;if(Ra<<24>>24==Sa<<24>>24){Ta=Na;Ua=Oa;Va=Pa;Wa=Qa}else{c[o>>2]=Sa<<24>>24;c[o+4>>2]=Ra<<24>>24;MBa(8,0,45384,o);Ra=c[c[(d+4|0)>>2]>>2]|0;Ta=c[(d+408|0)>>2]|0;Ua=c[Ra+16>>2]|0;Va=Ra;Wa=1}Ra=a[Ua+58|0]|0;Sa=a[Ta+58|0]|0;if(Ra<<24>>24==Sa<<24>>24){Xa=Ta;Ya=Ua;Za=Va;_a=Wa}else{c[p>>2]=Sa<<24>>24;c[p+4>>2]=Ra<<24>>24;MBa(8,0,45456,p);Ra=c[c[(d+4|0)>>2]>>2]|0;Xa=c[(d+408|0)>>2]|0;Ya=c[Ra+16>>2]|0;Za=Ra;_a=1}Ra=a[Ya+57|0]|0;Sa=a[Xa+57|0]|0;if(Ra<<24>>24==Sa<<24>>24){$a=Xa;ab=Ya;bb=Za;cb=_a}else{c[q>>2]=Sa<<24>>24;c[q+4>>2]=Ra<<24>>24;MBa(8,0,45528,q);Ra=c[c[(d+4|0)>>2]>>2]|0;$a=c[(d+408|0)>>2]|0;ab=c[Ra+16>>2]|0;bb=Ra;cb=1}Ra=a[ab+56|0]|0;Sa=a[$a+56|0]|0;if(Ra<<24>>24==Sa<<24>>24){db=$a;eb=ab;fb=bb;gb=cb}else{c[r>>2]=Sa<<24>>24;c[r+4>>2]=Ra<<24>>24;MBa(8,0,45592,r);Ra=c[c[(d+4|0)>>2]>>2]|0;db=c[(d+408|0)>>2]|0;eb=c[Ra+16>>2]|0;fb=Ra;gb=1}Ra=a[eb+55|0]|0;Sa=a[db+55|0]|0;if(Ra<<24>>24==Sa<<24>>24){hb=db;ib=eb;jb=fb;kb=gb}else{c[s>>2]=Sa<<24>>24;c[s+4>>2]=Ra<<24>>24;MBa(8,0,45664,s);Ra=c[c[(d+4|0)>>2]>>2]|0;hb=c[(d+408|0)>>2]|0;ib=c[Ra+16>>2]|0;jb=Ra;kb=1}Ra=a[ib+54|0]|0;Sa=a[hb+54|0]|0;if(Ra<<24>>24==Sa<<24>>24){lb=hb;mb=ib;nb=jb;ob=kb}else{c[t>>2]=Sa<<24>>24;c[t+4>>2]=Ra<<24>>24;MBa(8,0,45736,t);Ra=c[c[(d+4|0)>>2]>>2]|0;lb=c[(d+408|0)>>2]|0;mb=c[Ra+16>>2]|0;nb=Ra;ob=1}Ra=a[mb+53|0]|0;Sa=a[lb+53|0]|0;if(Ra<<24>>24==Sa<<24>>24){pb=lb;qb=mb;rb=nb;sb=ob}else{c[u>>2]=Sa<<24>>24;c[u+4>>2]=Ra<<24>>24;MBa(8,0,45808,u);Ra=c[c[(d+4|0)>>2]>>2]|0;pb=c[(d+408|0)>>2]|0;qb=c[Ra+16>>2]|0;rb=Ra;sb=1}Ra=a[qb+52|0]|0;Sa=a[pb+52|0]|0;if(Ra<<24>>24==Sa<<24>>24){tb=pb;ub=qb;vb=rb;wb=sb}else{c[v>>2]=Sa<<24>>24;c[v+4>>2]=Ra<<24>>24;MBa(8,0,45872,v);Ra=c[c[(d+4|0)>>2]>>2]|0;tb=c[(d+408|0)>>2]|0;ub=c[Ra+16>>2]|0;vb=Ra;wb=1}Ra=a[ub+51|0]|0;Sa=a[tb+51|0]|0;if(Ra<<24>>24==Sa<<24>>24){xb=tb;yb=ub;zb=vb;Ab=wb}else{c[w>>2]=Sa<<24>>24;c[w+4>>2]=Ra<<24>>24;MBa(8,0,45944,w);Ra=c[c[(d+4|0)>>2]>>2]|0;xb=c[(d+408|0)>>2]|0;yb=c[Ra+16>>2]|0;zb=Ra;Ab=1}Ra=a[yb+50|0]|0;Sa=a[xb+50|0]|0;if(Ra<<24>>24==Sa<<24>>24){Bb=xb;Cb=yb;Db=zb;Eb=Ab}else{c[x>>2]=Sa<<24>>24;c[x+4>>2]=Ra<<24>>24;MBa(8,0,46016,x);Ra=c[c[(d+4|0)>>2]>>2]|0;Bb=c[(d+408|0)>>2]|0;Cb=c[Ra+16>>2]|0;Db=Ra;Eb=1}Ra=a[Cb+49|0]|0;Sa=a[Bb+49|0]|0;if(Ra<<24>>24==Sa<<24>>24){Fb=Bb;Gb=Cb;Hb=Db;Ib=Eb}else{c[y>>2]=Sa<<24>>24;c[y+4>>2]=Ra<<24>>24;MBa(8,0,46088,y);Ra=c[c[(d+4|0)>>2]>>2]|0;Fb=c[(d+408|0)>>2]|0;Gb=c[Ra+16>>2]|0;Hb=Ra;Ib=1}Ra=a[Gb+48|0]|0;Sa=a[Fb+48|0]|0;if(Ra<<24>>24==Sa<<24>>24){Jb=Fb;Kb=Gb;Lb=Hb;Mb=Ib}else{c[z>>2]=Sa<<24>>24;c[z+4>>2]=Ra<<24>>24;MBa(8,0,46152,z);Ra=c[c[(d+4|0)>>2]>>2]|0;Jb=c[(d+408|0)>>2]|0;Kb=c[Ra+16>>2]|0;Lb=Ra;Mb=1}Ra=a[Kb+47|0]|0;Sa=a[Jb+47|0]|0;if(Ra<<24>>24==Sa<<24>>24){Nb=Jb;Ob=Kb;Pb=Lb;Qb=Mb}else{c[A>>2]=Sa<<24>>24;c[A+4>>2]=Ra<<24>>24;MBa(8,0,46224,A);Ra=c[c[(d+4|0)>>2]>>2]|0;Nb=c[(d+408|0)>>2]|0;Ob=c[Ra+16>>2]|0;Pb=Ra;Qb=1}Ra=a[Ob+46|0]|0;Sa=a[Nb+46|0]|0;if(Ra<<24>>24==Sa<<24>>24){Rb=Nb;Sb=Ob;Tb=Pb;Ub=Qb}else{c[B>>2]=Sa<<24>>24;c[B+4>>2]=Ra<<24>>24;MBa(8,0,46296,B);Ra=c[c[(d+4|0)>>2]>>2]|0;Rb=c[(d+408|0)>>2]|0;Sb=c[Ra+16>>2]|0;Tb=Ra;Ub=1}Ra=a[Sb+45|0]|0;Sa=a[Rb+45|0]|0;if(Ra<<24>>24==Sa<<24>>24){Vb=Rb;Wb=Sb;Xb=Tb;Yb=Ub}else{c[C>>2]=Sa<<24>>24;c[C+4>>2]=Ra<<24>>24;MBa(8,0,46368,C);Ra=c[c[(d+4|0)>>2]>>2]|0;Vb=c[(d+408|0)>>2]|0;Wb=c[Ra+16>>2]|0;Xb=Ra;Yb=1}Ra=a[Wb+44|0]|0;Sa=a[Vb+44|0]|0;if(Ra<<24>>24==Sa<<24>>24){Zb=Vb;_b=Wb;$b=Xb;ac=Yb}else{c[D>>2]=Sa<<24>>24;c[D+4>>2]=Ra<<24>>24;MBa(8,0,46432,D);Ra=c[c[(d+4|0)>>2]>>2]|0;Zb=c[(d+408|0)>>2]|0;_b=c[Ra+16>>2]|0;$b=Ra;ac=1}Ra=a[_b+43|0]|0;Sa=a[Zb+43|0]|0;if(Ra<<24>>24==Sa<<24>>24){bc=Zb;cc=_b;dc=$b;ec=ac}else{c[E>>2]=Sa<<24>>24;c[E+4>>2]=Ra<<24>>24;MBa(8,0,46504,E);Ra=c[c[(d+4|0)>>2]>>2]|0;bc=c[(d+408|0)>>2]|0;cc=c[Ra+16>>2]|0;dc=Ra;ec=1}Ra=a[cc+42|0]|0;Sa=a[bc+42|0]|0;if(Ra<<24>>24==Sa<<24>>24){fc=bc;gc=cc;hc=dc;ic=ec}else{c[F>>2]=Sa<<24>>24;c[F+4>>2]=Ra<<24>>24;MBa(8,0,46576,F);Ra=c[c[(d+4|0)>>2]>>2]|0;fc=c[(d+408|0)>>2]|0;gc=c[Ra+16>>2]|0;hc=Ra;ic=1}Ra=a[gc+41|0]|0;Sa=a[fc+41|0]|0;if(Ra<<24>>24==Sa<<24>>24){jc=fc;kc=gc;lc=hc;mc=ic}else{c[G>>2]=Sa<<24>>24;c[G+4>>2]=Ra<<24>>24;MBa(8,0,46648,G);Ra=c[c[(d+4|0)>>2]>>2]|0;jc=c[(d+408|0)>>2]|0;kc=c[Ra+16>>2]|0;lc=Ra;mc=1}Ra=a[kc+40|0]|0;Sa=a[jc+40|0]|0;if(Ra<<24>>24==Sa<<24>>24){nc=jc;oc=kc;pc=lc;qc=mc}else{c[H>>2]=Sa<<24>>24;c[H+4>>2]=Ra<<24>>24;MBa(8,0,46712,H);Ra=c[c[(d+4|0)>>2]>>2]|0;nc=c[(d+408|0)>>2]|0;oc=c[Ra+16>>2]|0;pc=Ra;qc=1}Ra=a[oc+39|0]|0;Sa=a[nc+39|0]|0;if(Ra<<24>>24==Sa<<24>>24){rc=nc;sc=oc;tc=pc;uc=qc}else{c[I>>2]=Sa<<24>>24;c[I+4>>2]=Ra<<24>>24;MBa(8,0,46768,I);Ra=c[c[(d+4|0)>>2]>>2]|0;rc=c[(d+408|0)>>2]|0;sc=c[Ra+16>>2]|0;tc=Ra;uc=1}Ra=a[sc+38|0]|0;Sa=a[rc+38|0]|0;if(Ra<<24>>24==Sa<<24>>24){vc=rc;wc=sc;xc=tc;yc=uc}else{c[J>>2]=Sa<<24>>24;c[J+4>>2]=Ra<<24>>24;MBa(8,0,46824,J);Ra=c[c[(d+4|0)>>2]>>2]|0;vc=c[(d+408|0)>>2]|0;wc=c[Ra+16>>2]|0;xc=Ra;yc=1}Ra=a[wc+37|0]|0;Sa=a[vc+37|0]|0;if(Ra<<24>>24==Sa<<24>>24){zc=vc;Ac=wc;Bc=xc;Cc=yc}else{c[K>>2]=Sa<<24>>24;c[K+4>>2]=Ra<<24>>24;MBa(8,0,46912,K);Ra=c[c[(d+4|0)>>2]>>2]|0;zc=c[(d+408|0)>>2]|0;Ac=c[Ra+16>>2]|0;Bc=Ra;Cc=1}Ra=a[Ac+36|0]|0;Sa=a[zc+36|0]|0;if(Ra<<24>>24==Sa<<24>>24){Dc=zc;Ec=Ac;Fc=Bc;Gc=Cc}else{c[L>>2]=Sa<<24>>24;c[L+4>>2]=Ra<<24>>24;MBa(8,0,46984,L);Ra=c[c[(d+4|0)>>2]>>2]|0;Dc=c[(d+408|0)>>2]|0;Ec=c[Ra+16>>2]|0;Fc=Ra;Gc=1}Ra=a[Ec+35|0]|0;Sa=a[Dc+35|0]|0;if(Ra<<24>>24==Sa<<24>>24){Hc=Fc;Ic=Gc}else{c[M>>2]=Sa<<24>>24;c[M+4>>2]=Ra<<24>>24;MBa(8,0,47056,M);Hc=c[c[(d+4|0)>>2]>>2]|0;Ic=1}Jc=+h[(c[Hc+8>>2]|0)+6080>>3];Kc=+h[(c[(d+400|0)>>2]|0)+6080>>3];if(Jc!=Kc){h[k>>3]=Kc;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(N+8|0)>>2]=c[k>>2];c[(N+8|0)+4>>2]=c[k+4>>2];MBa(8,0,47128,N);Lc=c[c[(d+4|0)>>2]>>2]|0;Mc=1}else{Lc=Hc;Mc=Ic}Ra=c[Lc+16>>2]|0;Sa=a[Ra+34|0]|0;Nc=c[(d+408|0)>>2]|0;Oc=a[Nc+34|0]|0;if(Sa<<24>>24==Oc<<24>>24){Pc=Nc;Qc=Ra;Rc=Mc}else{c[O>>2]=Oc<<24>>24;c[O+4>>2]=Sa<<24>>24;MBa(8,0,47200,O);Pc=c[(d+408|0)>>2]|0;Qc=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;Rc=1}Sa=a[Qc+33|0]|0;Oc=a[Pc+33|0]|0;if(Sa<<24>>24==Oc<<24>>24){Sc=Pc;Tc=Qc;Uc=Rc}else{c[P>>2]=Oc<<24>>24;c[P+4>>2]=Sa<<24>>24;MBa(8,0,47272,P);Sc=c[(d+408|0)>>2]|0;Tc=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;Uc=1}Sa=a[Tc+32|0]|0;Oc=a[Sc+32|0]|0;if(Sa<<24>>24==Oc<<24>>24){Vc=Sc;Wc=Tc;Xc=Uc}else{c[Q>>2]=Oc<<24>>24;c[Q+4>>2]=Sa<<24>>24;MBa(8,0,47352,Q);Vc=c[(d+408|0)>>2]|0;Wc=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;Xc=1}Sa=a[Wc+31|0]|0;Oc=a[Vc+31|0]|0;if(Sa<<24>>24==Oc<<24>>24){Yc=Vc;Zc=Wc;_c=Xc}else{c[R>>2]=Oc<<24>>24;c[R+4>>2]=Sa<<24>>24;MBa(8,0,47424,R);Yc=c[(d+408|0)>>2]|0;Zc=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;_c=1}Sa=a[Zc+30|0]|0;Oc=a[Yc+30|0]|0;if(Sa<<24>>24==Oc<<24>>24){$c=Yc;ad=Zc;bd=_c}else{c[S>>2]=Oc<<24>>24;c[S+4>>2]=Sa<<24>>24;MBa(8,0,47504,S);$c=c[(d+408|0)>>2]|0;ad=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;bd=1}Sa=a[ad+29|0]|0;Oc=a[$c+29|0]|0;if(Sa<<24>>24==Oc<<24>>24){cd=$c;dd=ad;ed=bd}else{c[T>>2]=Oc<<24>>24;c[T+4>>2]=Sa<<24>>24;MBa(8,0,47576,T);cd=c[(d+408|0)>>2]|0;dd=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;ed=1}Sa=a[dd+28|0]|0;Oc=a[cd+28|0]|0;if(Sa<<24>>24==Oc<<24>>24){fd=cd;gd=dd;hd=ed}else{c[U>>2]=Oc<<24>>24;c[U+4>>2]=Sa<<24>>24;MBa(8,0,47656,U);fd=c[(d+408|0)>>2]|0;gd=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;hd=1}Sa=a[gd+27|0]|0;Oc=a[fd+27|0]|0;if(Sa<<24>>24==Oc<<24>>24){id=fd;jd=gd;kd=hd}else{c[V>>2]=Oc<<24>>24;c[V+4>>2]=Sa<<24>>24;MBa(8,0,47728,V);id=c[(d+408|0)>>2]|0;jd=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;kd=1}Sa=a[jd+26|0]|0;Oc=a[id+26|0]|0;if(Sa<<24>>24==Oc<<24>>24){ld=id;md=jd;nd=kd}else{c[W>>2]=Oc<<24>>24;c[W+4>>2]=Sa<<24>>24;MBa(8,0,47808,W);ld=c[(d+408|0)>>2]|0;md=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;nd=1}Sa=a[md+25|0]|0;Oc=a[ld+25|0]|0;if(Sa<<24>>24==Oc<<24>>24){od=ld;pd=md;qd=nd}else{c[X>>2]=Oc<<24>>24;c[X+4>>2]=Sa<<24>>24;MBa(8,0,47888,X);od=c[(d+408|0)>>2]|0;pd=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;qd=1}Sa=a[pd+24|0]|0;Oc=a[od+24|0]|0;if(Sa<<24>>24==Oc<<24>>24){rd=od;sd=pd;td=qd}else{c[Y>>2]=Oc<<24>>24;c[Y+4>>2]=Sa<<24>>24;MBa(8,0,47968,Y);rd=c[(d+408|0)>>2]|0;sd=c[(c[c[(d+4|0)>>2]>>2]|0)+16>>2]|0;td=1}Sa=a[sd+23|0]|0;Oc=a[rd+23|0]|0;if(Sa<<24>>24==Oc<<24>>24){ud=rd;vd=td}else{c[Z>>2]=Oc<<24>>24;c[Z+4>>2]=Sa<<24>>24;MBa(8,0,48048,Z);ud=c[(d+408|0)>>2]|0;vd=1}Sa=c[c[(d+4|0)>>2]>>2]|0;Oc=c[Sa+16>>2]|0;Ra=a[Oc+22|0]|0;Nc=a[ud+22|0]|0;if(Ra<<24>>24==Nc<<24>>24){wd=ud;xd=Oc;yd=Sa;zd=vd}else{c[_>>2]=Nc<<24>>24;c[_+4>>2]=Ra<<24>>24;MBa(8,0,48128,_);Ra=c[c[(d+4|0)>>2]>>2]|0;wd=c[(d+408|0)>>2]|0;xd=c[Ra+16>>2]|0;yd=Ra;zd=1}Ra=a[xd+21|0]|0;Nc=a[wd+21|0]|0;if(Ra<<24>>24==Nc<<24>>24){Ad=wd;Bd=xd;Cd=yd;Dd=zd}else{c[$>>2]=Nc<<24>>24;c[$+4>>2]=Ra<<24>>24;MBa(8,0,48208,$);Ra=c[c[(d+4|0)>>2]>>2]|0;Ad=c[(d+408|0)>>2]|0;Bd=c[Ra+16>>2]|0;Cd=Ra;Dd=1}Ra=a[Bd+20|0]|0;Nc=a[Ad+20|0]|0;if(Ra<<24>>24==Nc<<24>>24){Ed=Ad;Fd=Bd;Gd=Cd;Hd=Dd}else{c[aa>>2]=Nc<<24>>24;c[aa+4>>2]=Ra<<24>>24;MBa(8,0,48288,aa);Ra=c[c[(d+4|0)>>2]>>2]|0;Ed=c[(d+408|0)>>2]|0;Fd=c[Ra+16>>2]|0;Gd=Ra;Hd=1}Ra=a[Fd+19|0]|0;Nc=a[Ed+19|0]|0;if(Ra<<24>>24==Nc<<24>>24){Id=Ed;Jd=Fd;Kd=Gd;Ld=Hd}else{c[ba>>2]=Nc<<24>>24;c[ba+4>>2]=Ra<<24>>24;MBa(8,0,48368,ba);Ra=c[c[(d+4|0)>>2]>>2]|0;Id=c[(d+408|0)>>2]|0;Jd=c[Ra+16>>2]|0;Kd=Ra;Ld=1}Ra=a[Jd+18|0]|0;Nc=a[Id+18|0]|0;if(Ra<<24>>24==Nc<<24>>24){Md=Id;Nd=Jd;Od=Kd;Pd=Ld}else{c[ca>>2]=Nc<<24>>24;c[ca+4>>2]=Ra<<24>>24;MBa(8,0,48448,ca);Ra=c[c[(d+4|0)>>2]>>2]|0;Md=c[(d+408|0)>>2]|0;Nd=c[Ra+16>>2]|0;Od=Ra;Pd=1}Ra=a[Nd+17|0]|0;Nc=a[Md+17|0]|0;if(Ra<<24>>24==Nc<<24>>24){Qd=Od;Rd=Pd}else{c[da>>2]=Nc<<24>>24;c[da+4>>2]=Ra<<24>>24;MBa(8,0,48520,da);Qd=c[c[(d+4|0)>>2]>>2]|0;Rd=1}Ra=c[Qd+12>>2]|0;Nc=c[Ra+100>>2]|0;Sa=c[(d+404|0)>>2]|0;Oc=c[Sa+100>>2]|0;if((Nc|0)==(Oc|0)){Sd=Sa;Td=Ra;Ud=Qd;Vd=Rd}else{c[ea>>2]=Oc;c[ea+4>>2]=Nc;MBa(8,0,48592,ea);Nc=c[c[(d+4|0)>>2]>>2]|0;Sd=c[(d+404|0)>>2]|0;Td=c[Nc+12>>2]|0;Ud=Nc;Vd=1}Nc=c[Td+96>>2]|0;Oc=c[Sd+96>>2]|0;if((Nc|0)==(Oc|0)){Wd=Sd;Xd=Td;Yd=Ud;Zd=Vd}else{c[fa>>2]=Oc;c[fa+4>>2]=Nc;MBa(8,0,48656,fa);Nc=c[c[(d+4|0)>>2]>>2]|0;Wd=c[(d+404|0)>>2]|0;Xd=c[Nc+12>>2]|0;Yd=Nc;Zd=1}Nc=c[Xd+92>>2]|0;Oc=c[Wd+92>>2]|0;if((Nc|0)==(Oc|0)){_d=Yd;$d=Zd}else{c[ga>>2]=Oc;c[ga+4>>2]=Nc;MBa(8,0,48712,ga);_d=c[c[(d+4|0)>>2]>>2]|0;$d=1}Nc=c[_d+16>>2]|0;Oc=a[Nc+13|0]|0;Ra=c[(d+408|0)>>2]|0;Sa=a[Ra+13|0]|0;if(Oc<<24>>24==Sa<<24>>24){ae=Ra;be=Nc;ce=_d;de=$d}else{c[ha>>2]=Sa<<24>>24;c[ha+4>>2]=Oc<<24>>24;MBa(8,0,48768,ha);Oc=c[c[(d+4|0)>>2]>>2]|0;ae=c[(d+408|0)>>2]|0;be=c[Oc+16>>2]|0;ce=Oc;de=1}Oc=a[be+12|0]|0;Sa=a[ae+12|0]|0;if(Oc<<24>>24==Sa<<24>>24){ee=ce;fe=de}else{c[ia>>2]=Sa<<24>>24;c[ia+4>>2]=Oc<<24>>24;MBa(8,0,48832,ia);ee=c[c[(d+4|0)>>2]>>2]|0;fe=1}Oc=c[(c[ee+12>>2]|0)+88>>2]|0;Sa=c[(c[(d+404|0)>>2]|0)+88>>2]|0;if((Oc|0)==(Sa|0)){ge=ee;he=fe}else{c[ja>>2]=Sa;c[ja+4>>2]=Oc;MBa(8,0,48888,ja);ge=c[c[(d+4|0)>>2]>>2]|0;he=1}Oc=c[ge+8>>2]|0;Jc=+h[Oc+4232>>3];Sa=c[(d+400|0)>>2]|0;Kc=+h[Sa+4232>>3];if(Jc!=Kc){h[k>>3]=Kc;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(ka+8|0)>>2]=c[k>>2];c[(ka+8|0)+4>>2]=c[k+4>>2];MBa(8,0,48944,ka);Nc=c[c[(d+4|0)>>2]>>2]|0;ie=c[(d+400|0)>>2]|0;ke=c[Nc+8>>2]|0;le=Nc;me=1}else{ie=Sa;ke=Oc;le=ge;me=he}Jc=+h[ke+4224>>3];Kc=+h[ie+4224>>3];if(Jc!=Kc){h[k>>3]=Kc;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(la+8|0)>>2]=c[k>>2];c[(la+8|0)+4>>2]=c[k+4>>2];MBa(8,0,49e3,la);Oc=c[c[(d+4|0)>>2]>>2]|0;ne=c[(d+400|0)>>2]|0;oe=c[Oc+8>>2]|0;pe=Oc;qe=1}else{ne=ie;oe=ke;pe=le;qe=me}Jc=+h[oe+4216>>3];Kc=+h[ne+4216>>3];if(Jc!=Kc){h[k>>3]=Kc;c[ma>>2]=c[k>>2];c[ma+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(ma+8|0)>>2]=c[k>>2];c[(ma+8|0)+4>>2]=c[k+4>>2];MBa(8,0,49048,ma);Oc=c[c[(d+4|0)>>2]>>2]|0;re=c[(d+400|0)>>2]|0;se=c[Oc+8>>2]|0;te=Oc;ue=1}else{re=ne;se=oe;te=pe;ue=qe}Jc=+h[se+4200>>3];Kc=+h[re+4200>>3];if(Jc!=Kc){h[k>>3]=Kc;c[na>>2]=c[k>>2];c[na+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(na+8|0)>>2]=c[k>>2];c[(na+8|0)+4>>2]=c[k+4>>2];MBa(8,0,49096,na);Oc=c[c[(d+4|0)>>2]>>2]|0;ve=c[(d+400|0)>>2]|0;we=c[Oc+8>>2]|0;xe=Oc;ye=1}else{ve=re;we=se;xe=te;ye=ue}Jc=+h[we+4192>>3];Kc=+h[ve+4192>>3];if(Jc!=Kc){h[k>>3]=Kc;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(oa+8|0)>>2]=c[k>>2];c[(oa+8|0)+4>>2]=c[k+4>>2];MBa(8,0,49152,oa);Oc=c[c[(d+4|0)>>2]>>2]|0;ze=c[(d+400|0)>>2]|0;Ae=c[Oc+8>>2]|0;Be=Oc;Ce=1}else{ze=ve;Ae=we;Be=xe;Ce=ye}Jc=+h[Ae+4184>>3];Kc=+h[ze+4184>>3];if(Jc!=Kc){h[k>>3]=Kc;c[pa>>2]=c[k>>2];c[pa+4>>2]=c[k+4>>2];h[k>>3]=Jc;c[(pa+8|0)>>2]=c[k>>2];c[(pa+8|0)+4>>2]=c[k+4>>2];MBa(8,0,49200,pa);De=c[c[(d+4|0)>>2]>>2]|0;Ee=1}else{De=Be;Ee=Ce}Oc=c[De+16>>2]|0;Sa=a[Oc+11|0]|0;Nc=c[(d+408|0)>>2]|0;Ra=a[Nc+11|0]|0;if(Sa<<24>>24==Ra<<24>>24){Fe=Nc;Ge=Oc;He=De;Ie=Ee}else{c[qa>>2]=Ra<<24>>24;c[qa+4>>2]=Sa<<24>>24;MBa(8,0,49248,qa);Sa=c[c[(d+4|0)>>2]>>2]|0;Fe=c[(d+408|0)>>2]|0;Ge=c[Sa+16>>2]|0;He=Sa;Ie=1}Sa=a[Ge+10|0]|0;Ra=a[Fe+10|0]|0;if(Sa<<24>>24==Ra<<24>>24){Je=He;Ke=Ie}else{c[ra>>2]=Ra<<24>>24;c[ra+4>>2]=Sa<<24>>24;MBa(8,0,49312,ra);Je=c[c[(d+4|0)>>2]>>2]|0;Ke=1}Sa=c[(c[Je+12>>2]|0)+84>>2]|0;Ra=c[(c[(d+404|0)>>2]|0)+84>>2]|0;if((Sa|0)==(Ra|0)){Le=Je;Me=Ke}else{c[sa>>2]=Ra;c[sa+4>>2]=Sa;MBa(8,0,49368,sa);Le=c[c[(d+4|0)>>2]>>2]|0;Me=1}Sa=c[Le+16>>2]|0;Ra=a[Sa+8|0]|0;Oc=c[(d+408|0)>>2]|0;Nc=a[Oc+8|0]|0;if(Ra<<24>>24==Nc<<24>>24){Ne=Oc;Oe=Sa;Pe=Le;Qe=Me}else{c[ta>>2]=Nc<<24>>24;c[ta+4>>2]=Ra<<24>>24;MBa(8,0,49424,ta);Ra=c[c[(d+4|0)>>2]>>2]|0;Ne=c[(d+408|0)>>2]|0;Oe=c[Ra+16>>2]|0;Pe=Ra;Qe=1}Ra=a[Oe+9|0]|0;Nc=a[Ne+9|0]|0;if(Ra<<24>>24==Nc<<24>>24){Re=Ne;Se=Oe;Te=Pe;Ue=Qe}else{c[ua>>2]=Nc<<24>>24;c[ua+4>>2]=Ra<<24>>24;MBa(8,0,49488,ua);Ra=c[c[(d+4|0)>>2]>>2]|0;Re=c[(d+408|0)>>2]|0;Se=c[Ra+16>>2]|0;Te=Ra;Ue=1}Ra=a[Se+6|0]|0;Nc=a[Re+6|0]|0;if(Ra<<24>>24==Nc<<24>>24){Ve=Re;We=Se;Xe=Te;Ye=Ue}else{c[va>>2]=Nc<<24>>24;c[va+4>>2]=Ra<<24>>24;MBa(8,0,49552,va);Ra=c[c[(d+4|0)>>2]>>2]|0;Ve=c[(d+408|0)>>2]|0;We=c[Ra+16>>2]|0;Xe=Ra;Ye=1}Ra=a[We+7|0]|0;Nc=a[Ve+7|0]|0;if(Ra<<24>>24==Nc<<24>>24){Ze=Xe;_e=Ye}else{c[wa>>2]=Nc<<24>>24;c[wa+4>>2]=Ra<<24>>24;MBa(8,0,49608,wa);Ze=c[c[(d+4|0)>>2]>>2]|0;_e=1}Ra=c[(c[Ze+12>>2]|0)+80>>2]|0;Nc=c[(c[(d+404|0)>>2]|0)+80>>2]|0;if((Ra|0)==(Nc|0)){$e=Ze;af=_e}else{c[xa>>2]=Nc;c[xa+4>>2]=Ra;MBa(8,0,49664,xa);$e=c[c[(d+4|0)>>2]>>2]|0;af=1}Ra=c[$e+16>>2]|0;Nc=a[Ra+5|0]|0;Sa=c[(d+408|0)>>2]|0;Oc=a[Sa+5|0]|0;if(Nc<<24>>24==Oc<<24>>24){bf=Sa;cf=Ra;df=$e;ef=af}else{c[ya>>2]=Oc<<24>>24;c[ya+4>>2]=Nc<<24>>24;MBa(8,0,49720,ya);Nc=c[c[(d+4|0)>>2]>>2]|0;bf=c[(d+408|0)>>2]|0;cf=c[Nc+16>>2]|0;df=Nc;ef=1}Nc=a[cf+4|0]|0;Oc=a[bf+4|0]|0;if(Nc<<24>>24==Oc<<24>>24){ff=df;gf=ef}else{c[za>>2]=Oc<<24>>24;c[za+4>>2]=Nc<<24>>24;MBa(8,0,49784,za);ff=c[c[(d+4|0)>>2]>>2]|0;gf=1}Nc=c[(c[ff+12>>2]|0)+76>>2]|0;Oc=c[(c[(d+404|0)>>2]|0)+76>>2]|0;if((Nc|0)==(Oc|0)){hf=ff;jf=gf}else{c[Aa>>2]=Oc;c[Aa+4>>2]=Nc;MBa(8,0,49840,Aa);hf=c[c[(d+4|0)>>2]>>2]|0;jf=1}Nc=c[hf+16>>2]|0;Oc=a[Nc+3|0]|0;Ra=c[(d+408|0)>>2]|0;Sa=a[Ra+3|0]|0;if(Oc<<24>>24==Sa<<24>>24){kf=Ra;lf=Nc;mf=hf;nf=jf}else{c[Ba>>2]=Sa<<24>>24;c[Ba+4>>2]=Oc<<24>>24;MBa(8,0,49896,Ba);Oc=c[c[(d+4|0)>>2]>>2]|0;kf=c[(d+408|0)>>2]|0;lf=c[Oc+16>>2]|0;mf=Oc;nf=1}Oc=a[lf+2|0]|0;Sa=a[kf+2|0]|0;if(Oc<<24>>24==Sa<<24>>24){of=mf;pf=nf}else{c[Ca>>2]=Sa<<24>>24;c[Ca+4>>2]=Oc<<24>>24;MBa(8,0,49960,Ca);of=c[c[(d+4|0)>>2]>>2]|0;pf=1}Oc=c[of+12>>2]|0;Sa=c[Oc+72>>2]|0;Nc=c[(d+404|0)>>2]|0;Ra=c[Nc+72>>2]|0;if((Sa|0)==(Ra|0)){qf=Nc;rf=Oc;sf=of;tf=pf}else{c[Da>>2]=Ra;c[Da+4>>2]=Sa;MBa(8,0,50016,Da);Sa=c[c[(d+4|0)>>2]>>2]|0;qf=c[(d+404|0)>>2]|0;rf=c[Sa+12>>2]|0;sf=Sa;tf=1}Sa=c[rf+20>>2]|0;Ra=c[qf+20>>2]|0;if((Sa|0)==(Ra|0)){uf=qf;vf=rf;wf=sf;xf=tf}else{c[Ea>>2]=Ra;c[Ea+4>>2]=Sa;MBa(8,0,50072,Ea);Sa=c[c[(d+4|0)>>2]>>2]|0;uf=c[(d+404|0)>>2]|0;vf=c[Sa+12>>2]|0;wf=Sa;xf=1}Sa=c[vf+16>>2]|0;Ra=c[uf+16>>2]|0;if((Sa|0)==(Ra|0)){yf=uf;zf=vf;Af=wf;Bf=xf}else{c[Fa>>2]=Ra;c[Fa+4>>2]=Sa;MBa(8,0,50144,Fa);Sa=c[c[(d+4|0)>>2]>>2]|0;yf=c[(d+404|0)>>2]|0;zf=c[Sa+12>>2]|0;Af=Sa;Bf=1}Sa=c[zf+12>>2]|0;Ra=c[yf+12>>2]|0;if((Sa|0)==(Ra|0)){Cf=yf;Df=zf;Ef=Af;Ff=Bf}else{c[Ga>>2]=Ra;c[Ga+4>>2]=Sa;MBa(8,0,50216,Ga);Sa=c[c[(d+4|0)>>2]>>2]|0;Cf=c[(d+404|0)>>2]|0;Df=c[Sa+12>>2]|0;Ef=Sa;Ff=1}Sa=c[Df+8>>2]|0;Ra=c[Cf+8>>2]|0;if((Sa|0)==(Ra|0)){Gf=Cf;Hf=Df;If=Ef;Jf=Ff}else{c[Ha>>2]=Ra;c[Ha+4>>2]=Sa;MBa(8,0,50288,Ha);Sa=c[c[(d+4|0)>>2]>>2]|0;Gf=c[(d+404|0)>>2]|0;Hf=c[Sa+12>>2]|0;If=Sa;Jf=1}Sa=c[Hf+4>>2]|0;Ra=c[Gf+4>>2]|0;if((Sa|0)==(Ra|0)){Kf=Gf;Lf=Hf;Mf=If;Nf=Jf}else{c[Ia>>2]=Ra;c[Ia+4>>2]=Sa;MBa(8,0,50360,Ia);Sa=c[c[(d+4|0)>>2]>>2]|0;Kf=c[(d+404|0)>>2]|0;Lf=c[Sa+12>>2]|0;Mf=Sa;Nf=1}Sa=c[Lf>>2]|0;Ra=c[Kf>>2]|0;if((Sa|0)==(Ra|0)){Of=Mf;Pf=Nf}else{c[Ja>>2]=Ra;c[Ja+4>>2]=Sa;MBa(8,0,50432,Ja);Of=c[c[(d+4|0)>>2]>>2]|0;Pf=1}Sa=c[Of+16>>2]|0;Ra=a[Sa+1|0]|0;Oc=c[(d+408|0)>>2]|0;Nc=a[Oc+1|0]|0;if(Ra<<24>>24==Nc<<24>>24){Qf=Oc;Rf=Sa;Sf=Of;Tf=Pf}else{c[Ka>>2]=Nc<<24>>24;c[Ka+4>>2]=Ra<<24>>24;MBa(8,0,50504,Ka);Ra=c[c[(d+4|0)>>2]>>2]|0;Qf=c[(d+408|0)>>2]|0;Rf=c[Ra+16>>2]|0;Sf=Ra;Tf=1}Ra=a[Rf]|0;Nc=a[Qf]|0;if(Ra<<24>>24==Nc<<24>>24){Uf=Sf;Vf=Tf}else{c[La>>2]=Nc<<24>>24;c[La+4>>2]=Ra<<24>>24;MBa(8,0,50568,La);Uf=c[c[(d+4|0)>>2]>>2]|0;Vf=1}Ra=c[Uf+12>>2]|0;Nc=c[Ra+68>>2]|0;Sa=c[(d+404|0)>>2]|0;Oc=c[Sa+68>>2]|0;if((Nc|0)==(Oc|0)){Wf=Sa;Xf=Ra;Yf=Vf}else{c[Ma>>2]=Oc;c[Ma+4>>2]=Nc;MBa(8,0,50624,Ma);Wf=c[(d+404|0)>>2]|0;Xf=c[(c[c[(d+4|0)>>2]>>2]|0)+12>>2]|0;Yf=1}Nc=c[Xf+64>>2]|0;Oc=c[Wf+64>>2]|0;if((Nc|0)==(Oc|0)){Zf=Yf}else{c[b>>2]=Oc;c[b+4>>2]=Nc;MBa(8,0,50680,b);Zf=1}if((c[241640>>2]|0)==0){i=b;c[b+8576>>2]=6;c[b+8580>>2]=Zf|0;break a}je[c[60540]&1023](8);i=b;c[b+8576>>2]=6;c[b+8580>>2]=Zf|0;break a}while(0)}



function lHa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=K4a(e<<2)|0;e=l;c[l>>2]=284624;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=284664;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(wJa(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(wJa(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(wJa(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function mHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;hIa(a,b,c);i=d;return}function nHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(gIa(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){tXa(d,4);i=e;return}else{rXa(d,0);i=e;return}}function oHa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=m5a(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=M4a((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;PBa(0,(o|0)!=0|0,284144,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;x5a(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;vHa(q,m5a(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=M4a(1,1)|0;c[d>>2]=q;PBa(0,(q|0)!=0|0,284144,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function pHa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=M4a(c[f>>2]<<2,4)|0;c[e>>2]=g;PBa(c[d+536>>2]|0,(g|0)!=0|0,284192,k);g=s+240|0;f=rHa(g)|0;h=s+264|0;t=rHa(h)|0;u=s+288|0;v=rHa(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=rHa(g)|0;D=rHa(h)|0;E=rHa(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==2){F=1;G=2}else if(z<<24>>24==1){wHa(l,b,A+(v*52|0)+4|0);yHa(n,b);if(!(xHa(l,n)|0)){H=w;break}F=(c[(zHa(l)|0)+4>>2]|0)+1|0;G=1}else if(z<<24>>24==0){wHa(l,g,A+(v*52|0)+4|0);yHa(m,g);if(!(xHa(l,m)|0)){H=w;break}F=(c[(zHa(l)|0)+4>>2]|0)+1|0;G=2}else{H=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=G;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=F}else{c[z+(w+1<<2)>>2]=0-F}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;H=w+4|0}else{H=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=H;v=A}else{I=H;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){H=d+44|0;v=s+276|0;w=I;t=0;while(1){F=c[H>>2]|0;do{if((a[F+(t*52|0)+48|0]|0)==0){f=a[F+(t*52|0)+8|0]|0;if(f<<24>>24==0){wHa(l,h,F+(t*52|0)+4|0);yHa(o,h);G=xHa(l,o)|0;J=G?2:0}else if(f<<24>>24==1){wHa(l,v,F+(t*52|0)+4|0);yHa(p,v);J=(xHa(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;G=(c[(c[H>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(zHa(l)|0)+4>>2]|0;if(G){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);F=t+1|0;if((F|0)<(c[x>>2]|0)){w=K;t=F}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){wHa(l,d,y+(t*52|0)+4|0);yHa(r,d);M=(xHa(l,r)|0)&1}else if(x<<24>>24==0){wHa(l,u,y+(t*52|0)+4|0);yHa(q,u);x=xHa(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(zHa(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function qHa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(m5a(d|0)|0)+1;e=m;VYa(e,l,20)|0;if(qXa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];QBa(l,284168,k)}VYa(e,d,c[f>>2]|0)|0;if(qXa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];QBa(m,284168,j)}else{i=h;return}}function rHa(a){a=a|0;var b=0,d=0;b=i;d=c[(dIa(a)|0)>>2]|0;i=b;return d|0}function sHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;uDa(3);do{if(pXa(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];XYa(k,e)|0;k=rHa(h+240|0)|0;m=rHa(h+264|0)|0;l=rHa(h+288|0)|0;qHa(a,b,284072,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);gHa(h)}else{if((h|0)!=0){break}c[g>>2]=0;xDa(3);i=d;return}}while(0);tHa(j);S4a(h);c[g>>2]=0;xDa(3);i=d;return}function tHa(a){a=a|0;var b=0;b=i;BIa(a);i=b;return}function uHa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;uDa(3);xDa(0);h[j>>3]=+pDa(0);uDa(0);l=k;m=d+4|0;VYa(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){VYa(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){VYa(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);VYa(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);VYa(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);VYa(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(qXa(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];QBa(t,284112,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;xDa(3);i=e;return}}function vHa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((j5a(b,284328,4)|0)!=0){i=d;return}c=b;while(1){e=Xa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((j5a(b,284328,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function wHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;RHa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];HHa(a,f);i=e;return}function xHa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=FHa(a,b)|0;i=c;return d|0}function yHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;IHa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];HHa(a,e);i=d;return}function zHa(a){a=a|0;var b=0,c=0;b=i;c=AHa(BHa(a)|0)|0;i=b;return c|0}function AHa(a){a=a|0;var b=0,c=0;b=i;c=EHa(a)|0;i=b;return c|0}function BHa(a){a=a|0;var b=0,d=0;b=i;d=CHa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function CHa(a){a=a|0;var b=0,c=0;b=i;c=DHa(a)|0;i=b;return c|0}function DHa(a){a=a|0;i=i;return a|0}function EHa(a){a=a|0;i=i;return a|0}function FHa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(GHa(a,b)|0)^1;i=c;return d|0}function GHa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function HHa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];QHa(a,e);i=d;return}function IHa(a,b){a=a|0;b=b|0;var c=0;c=i;JHa(a,KHa(b)|0);i=c;return}function JHa(a,b){a=a|0;b=b|0;var c=0;c=i;PHa(a,b);i=c;return}function KHa(a){a=a|0;var b=0,c=0;b=i;c=LHa(MHa(a+4|0)|0)|0;i=b;return c|0}function LHa(a){a=a|0;var b=0,c=0;b=i;c=OHa(a)|0;i=b;return c|0}function MHa(a){a=a|0;var b=0,c=0;b=i;c=NHa(a)|0;i=b;return c|0}function NHa(a){a=a|0;i=i;return a|0}function OHa(a){a=a|0;i=i;return a|0}function PHa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function QHa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function RHa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=THa(b)|0;SHa(f,b,d,h,KHa(b)|0);IHa(g,b);do{if(FHa(f,g)|0){h=UHa(b)|0;if(VHa(h,d,WHa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);IHa(a,b);i=e;return}function SHa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;_Ha(h);a:do{if((e|0)==0){j=f}else{k=UHa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!($Ha(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;_Ha(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;_Ha(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);JHa(a,j);i=g;return}function THa(a){a=a|0;var b=0,d=0;b=i;d=c[(KHa(a)|0)>>2]|0;i=b;return d|0}function UHa(a){a=a|0;var b=0,c=0;b=i;c=YHa(a+8|0)|0;i=b;return c|0}function VHa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XHa(0,b,c)|0;i=a;return d|0}function WHa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function XHa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function YHa(a){a=a|0;var b=0,c=0;b=i;c=ZHa(a)|0;i=b;return c|0}function ZHa(a){a=a|0;i=i;return a|0}function _Ha(a){a=a|0;var b=0;b=i;aIa(a,-1);i=b;return}function $Ha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=XHa(0,b,c)|0;i=a;return d|0}function aIa(a,b){a=a|0;b=b|0;b=i;bIa(a,0);i=b;return}function bIa(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function cIa(a){a=a|0;i=i;return c[a+4>>2]|0}function dIa(a){a=a|0;var b=0,c=0;b=i;c=eIa(a+8|0)|0;i=b;return c|0}function eIa(a){a=a|0;var b=0,c=0;b=i;c=fIa(a)|0;i=b;return c|0}function fIa(a){a=a|0;i=i;return a|0}function gIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 5:case 21:{h=284288;break};case 24:{h=284256;break};case 9:case 25:{h=284272;break};case 52:case 20:{h=284280;break};case 12:{h=284296;break};case 8:{h=284248;break};case 1:case 17:{h=284240;break};case 28:{h=284304;break};case 13:case 29:{h=284320;break};case 60:{h=284312;break};case 56:{h=284264;break};case 48:case 16:{h=284232;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=lc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Zc(j|0,0,2)|0)==0){g=a;i=e;return g|0}$c(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function hIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function iIa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}jIa(d,f,103);f=me[c[(c[a>>2]|0)+24>>2]&127](a)|0;if(($c(kIa(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}lIa(d);g=h;i=b;return g|0}function jIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;sIa(a,b,c);i=d;return}function kIa(a){a=a|0;var b=0,d=0;b=i;d=oIa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function lIa(a){a=a|0;var b=0;b=i;mIa(a);i=b;return}function mIa(a){a=a|0;var b=0;b=i;nIa(a,0);i=b;return}function nIa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=oIa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}me[c[(pIa(e)|0)>>2]&127](f)|0;i=d;return}function oIa(a){a=a|0;var b=0,c=0;b=i;c=rIa(a)|0;i=b;return c|0}function pIa(a){a=a|0;var b=0,c=0;b=i;c=qIa(a)|0;i=b;return c|0}function qIa(a){a=a|0;i=i;return a+4|0}function rIa(a){a=a|0;i=i;return a|0}function sIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(uIa(f)|0)>>2]|0;tIa(a,d,c[(vIa(g)|0)>>2]|0);i=e;return}function tIa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wIa(a,b,c);i=d;return}function uIa(a){a=a|0;i=i;return a|0}function vIa(a){a=a|0;i=i;return a|0}function wIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(yIa(f)|0)>>2]|0;xIa(a,d,c[(zIa(g)|0)>>2]|0);i=e;return}function xIa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(yIa(f)|0)>>2];c[a+4>>2]=c[(zIa(g)|0)>>2];i=e;return}function yIa(a){a=a|0;i=i;return a|0}function zIa(a){a=a|0;i=i;return a|0}function AIa(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function BIa(a){a=a|0;var b=0;b=i;CIa(a+300|0);CIa(a+288|0);CIa(a+276|0);CIa(a+264|0);CIa(a+252|0);CIa(a+240|0);DIa(a);i=b;return}function CIa(a){a=a|0;var b=0;b=i;nJa(a);i=b;return}function DIa(a){a=a|0;var b=0;b=i;EIa(a,284376);xXa(a+104|0);i=b;return}function EIa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];IIa(a+4|0);i=d;return}function FIa(a){a=a|0;var b=0;b=i;DIa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function GIa(a){a=a|0;var b=0;b=i;DIa(a);S4a(a);i=b;return}function HIa(a){a=a|0;var b=0;b=i;GIa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function IIa(a){a=a|0;var b=0;b=i;JIa(a);i=b;return}function JIa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=284504;iIa(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}T4a(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}T4a(e)}}while(0);GXa(b);i=d;return}function KIa(a){a=a|0;var b=0;b=i;IIa(a);S4a(a);i=b;return}function LIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;me[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=lJa(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=mJa(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;QXa(h,0,0,0);VXa(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}T4a(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=R4a(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=R4a(h)|0;a[b+97|0]=1;i=e;return}function MIa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;QXa(e,0,0,0);VXa(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}T4a(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}T4a(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=R4a(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(iJa(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=R4a(o)|0;a[k]=1;i=f;return e|0}return 0}function NIa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Hc(4)|0;p4a(n);Xd(n|0,331832,127)}n=eJa(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((me[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){mHa(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=F5a(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Zc(p|0,q|0,f|0)|0)==0){p=Ab(c[m>>2]|0)|0;mHa(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];hJa(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{mHa(a,-1,-1);i=g;return}}}while(0);mHa(a,-1,-1);i=g;return}function OIa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((me[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=AIa(d)|0;if((Zc(j|0,k|0,0)|0)==0){gJa(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{mHa(a,-1,-1);i=e;return}}}while(0);mHa(a,-1,-1);i=e;return}function PIa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Hc(4)|0;p4a(m);Xd(m|0,331832,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=eJa(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=OXa(s)|0;u=(fa(t-(NXa(s)|0)|0,p)|0)+r|0;v=0;break}p=NXa(s)|0;if((p|0)==(OXa(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=fJa(t,g,x,o,p-(MXa(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=OXa(w)|0;u=q-(NXa(w)|0)|0;v=0}}while(0);if((Zc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;QXa(b,0,0,0);c[m>>2]=0}else{q=b;y=SXa(q)|0;do{if((y|0)!=(RXa(q)|0)){if((Ce[c[(c[b>>2]|0)+52>>2]&127](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=dJa(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((uc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((yd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function QIa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=_Ia(b)|0;o=b;if((NXa(o)|0)==0){p=e+1|0;QXa(o,e,p,p)}if(n){q=0}else{n=OXa(o)|0;c[f>>2]=(n-(MXa(o)|0)|0)/2|0;c[g>>2]=4;q=c[($Ia(f,g)|0)>>2]|0}g=NXa(o)|0;do{if((g|0)==(OXa(o)|0)){p5a(MXa(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=OXa(o)|0;n=MXa(o)|0;p=ub(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=MXa(o)|0;QXa(o,n,n+q|0,n+(p+q)|0);r=YIa(a[NXa(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;p5a(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[($Ia(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=ub(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Hc(4)|0;p4a(t);Xd(t|0,331832,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=MXa(o)|0;if((aJa(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;QXa(o,f,f,c[s>>2]|0);r=YIa(a[NXa(o)|0]|0)|0;break}s=c[k>>2]|0;f=MXa(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}QXa(o,f,p,s);r=YIa(a[NXa(o)|0]|0)|0}else{r=YIa(a[g]|0)|0}}while(0);if((MXa(o)|0)!=(e|0)){m=r;i=d;return m|0}QXa(o,0,0,0);m=r;i=d;return m|0}function RIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=MXa(g)|0;j=NXa(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(UIa(d,-1)|0){PXa(g,-1);f=XIa(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=VIa(d)|0;do{if(h){if(ZIa(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);PXa(g,-1);a[NXa(g)|0]=b;f=d;i=e;return f|0}function SIa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}TIa(b);l=b;m=RXa(l)|0;n=TXa(l)|0;if(!(UIa(d,-1)|0)){if((SXa(l)|0)==0){VXa(l,f,f+1|0)}f=VIa(d)|0;a[SXa(l)|0]=f;UXa(l,1)}f=SXa(l)|0;o=RXa(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=RXa(l)|0;A=SXa(l)|0;B=WIa(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=RXa(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((uc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;VXa(l,B,SXa(l)|0);B=TXa(l)|0;UXa(l,B-(RXa(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Hc(4)|0;u=t;p4a(u);v=331832;w=127;Xd(t|0,v|0,w|0)}else if((D|0)==14){q=(SXa(l)|0)-C|0;if((uc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((uc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);VXa(l,m,n)}k=XIa(d)|0;i=e;return k|0}function TIa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;QXa(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;VXa(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;VXa(f,h,h+(g+ -1)|0);break}}else{VXa(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function UIa(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function VIa(a){a=a|0;i=i;return a&255|0}function WIa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Le[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function XIa(a){a=a|0;var b=0,c=0;b=i;c=UIa(a,-1)|0;i=b;return(c?0:a)|0}function YIa(a){a=a|0;i=i;return a&255|0}function ZIa(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function _Ia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;VXa(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;QXa(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;QXa(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function $Ia(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=bJa(b,c,e)|0;i=d;return g|0}function aJa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Le[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function bJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=cJa(0,b,a)|0;i=c;return(d?b:a)|0}function cJa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function dJa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=De[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function eJa(a){a=a|0;var b=0,d=0;b=i;d=me[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function fJa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=De[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function gJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function hJa(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function iJa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=jJa(b,c,e)|0;i=d;return g|0}function jJa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=kJa(0,a,b)|0;i=c;return(d?b:a)|0}function kJa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function lJa(a){a=a|0;var b=0,c=0;b=i;c=p1a(a,316336)|0;i=b;return c|0}function mJa(a){a=a|0;var b=0,d=0;b=i;d=me[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function nJa(a){a=a|0;var b=0;b=i;oJa(a);i=b;return}function oJa(a){a=a|0;var b=0;b=i;pJa(a);i=b;return}function pJa(a){a=a|0;var b=0;b=i;qJa(a,THa(a)|0);i=b;return}function qJa(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;_Ha(d);if((b|0)==0){i=d;return}qJa(a,c[b>>2]|0);qJa(a,c[b+4>>2]|0);sJa(rJa(a)|0,b,1);i=d;return}function rJa(a){a=a|0;var b=0,c=0;b=i;c=uJa(a+4|0)|0;i=b;return c|0}function sJa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;tJa(0,b,0);i=c;return}function tJa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;S4a(b);i=c;return}function uJa(a){a=a|0;var b=0,c=0;b=i;c=vJa(a)|0;i=b;return c|0}function vJa(a){a=a|0;i=i;return a|0}function wJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=xJa(a,f,b)|0;l=c[k>>2]|0;_Ha(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}zJa(j,a,b);AJa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];yJa(g,e);BJa(j);j=c[f>>2]|0;CJa(a,j,k,DJa(g)|0);k=EJa(g)|0;BJa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function xJa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=THa(h)|0;_Ha(e);if((a|0)==0){j=KHa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XHa(0,d,a)|0){m=l;j=c[m>>2]|0;_Ha(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XHa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;_Ha(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function yJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];qKa(a,e);i=d;return}function zJa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=rJa(d)|0;d=$Ja(n,1)|0;aKa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];_Ja(j,d,h);bKa(0,WJa((cKa(j)|0)+16|0)|0,e);e=dKa(j)|0;a[e+4|0]=1;eKa(0,VJa((cKa(j)|0)+20|0)|0);a[e+5|0]=1;fKa(m,j);AJa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];yJa(b,g);BJa(m);BJa(j);i=f;return}function AJa(a,b){a=a|0;b=b|0;var c=0;c=i;YJa(a,b);i=c;return}function BJa(a){a=a|0;var b=0;b=i;RJa(a);i=b;return}function CJa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;_Ha(f);c[e>>2]=0;_Ha(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=JJa(a)|0;b=c[c[e>>2]>>2]|0;_Ha(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(KHa(a)|0)>>2]|0;KJa(e,c[d>>2]|0);d=LJa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function DJa(a){a=a|0;var b=0,d=0;b=i;d=c[(HJa(a)|0)>>2]|0;i=b;return d|0}function EJa(a){a=a|0;var b=0,d=0;b=i;d=FJa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function FJa(a){a=a|0;var b=0,c=0;b=i;c=GJa(a)|0;i=b;return c|0}function GJa(a){a=a|0;i=i;return a|0}function HJa(a){a=a|0;var b=0,c=0;b=i;c=IJa(a)|0;i=b;return c|0}function IJa(a){a=a|0;i=i;return a|0}function JJa(a){a=a|0;i=i;return a|0}function KJa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=OJa(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;_Ha(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;_Ha(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(OJa(j)|0){p=j}else{o=c[k>>2]|0;PJa(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;QJa(p);i=e;return}else if((l|0)==14){if(OJa(j)|0){p=c[k>>2]|0;QJa(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;PJa(q);i=e;return}else if((l|0)==17){i=e;return}}function LJa(a){a=a|0;var b=0,c=0;b=i;c=MJa(a+8|0)|0;i=b;return c|0}function MJa(a){a=a|0;var b=0,c=0;b=i;c=NJa(a)|0;i=b;return c|0}function NJa(a){a=a|0;i=i;return a|0}function OJa(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function PJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;_Ha(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=OJa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function QJa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;_Ha(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=OJa(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function RJa(a){a=a|0;var b=0;b=i;SJa(a,0);i=b;return}function SJa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=FJa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}UJa(TJa(e)|0,f);i=d;return}function TJa(a){a=a|0;var b=0,c=0;b=i;c=XJa(a)|0;i=b;return c|0}function UJa(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}sJa(c[a>>2]|0,b,1);i=d;return}function VJa(a){a=a|0;i=i;return a|0}function WJa(a){a=a|0;i=i;return a|0}function XJa(a){a=a|0;i=i;return a+4|0}function YJa(a,b){a=a|0;b=b|0;var c=0;c=i;ZJa(a,b);i=c;return}function ZJa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function _Ja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];iKa(a,b,f);i=e;return}function $Ja(a,b){a=a|0;b=b|0;var c=0;a=i;c=hKa(0,b,0)|0;i=a;return c|0}function aKa(a,b){a=a|0;b=b|0;var c=0;c=i;gKa(a,b);i=c;return}function bKa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function cKa(a){a=a|0;var b=0,d=0;b=i;d=c[(HJa(a)|0)>>2]|0;i=b;return d|0}function dKa(a){a=a|0;var b=0,c=0;b=i;c=TJa(a)|0;i=b;return c|0}function eKa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function fKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;YJa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];yJa(h,f);AJa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];yJa(a,e);BJa(h);i=d;return}function gKa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function hKa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Q4a(b*24|0)|0;i=c;return a|0}function iKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(kKa(g)|0)>>2]|0;g=lKa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];jKa(b,a,f);i=e;return}function jKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];mKa(a,b,f);i=e;return}function kKa(a){a=a|0;i=i;return a|0}function lKa(a){a=a|0;i=i;return a|0}function mKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(oKa(g)|0)>>2]|0;g=pKa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];nKa(b,a,f);i=e;return}function nKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(oKa(f)|0)>>2];f=pKa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function oKa(a){a=a|0;i=i;return a|0}function pKa(a){a=a|0;i=i;return a|0}function qKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=EJa(rKa(b)|0)|0;h=pKa(dKa(rKa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];jKa(g,a,e);i=d;return}function rKa(a){a=a|0;i=i;return c[a>>2]|0}function sKa(a){a=a|0;var b=0;b=i;i=i+48|0;tKa(a);mHa(a+184|0,0,0);mHa(a+200|0,0,0);uKa(a+240|0,b);uKa(a+252|0,b+8|0);uKa(a+264|0,b+16|0);uKa(a+276|0,b+24|0);uKa(a+288|0,b+32|0);uKa(a+300|0,b+40|0);i=b;return}function tKa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;CXa(d);e=a;c[e>>2]=284348;f=d;c[f>>2]=284368;d=a+4|0;JYa(a,284380|0,d);c[e>>2]=284348;c[f>>2]=284368;HKa(d);i=b;return}function uKa(a,b){a=a|0;b=b|0;b=i;vKa(a,0);i=b;return}function vKa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;wKa(a,b);i=b;return}function wKa(a,b){a=a|0;b=b|0;b=i;xKa(a,0);i=b;return}function xKa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;yKa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;zKa(f,0,e);e=KHa(b)|0;c[(JJa(b)|0)>>2]=e;i=d;return}function yKa(a){a=a|0;var b=0;b=i;DKa(a);i=b;return}function zKa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;AKa(b,c,f);i=e;return}function AKa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(CKa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;BKa(d,b,f);i=e;return}function BKa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(CKa(e)|0)>>2];i=d;return}function CKa(a){a=a|0;i=i;return a|0}function DKa(a){a=a|0;var b=0;b=i;EKa(a);i=b;return}function EKa(a){a=a|0;var b=0;b=i;FKa(a);i=b;return}function FKa(a){a=a|0;var b=0;b=i;GKa(a);i=b;return}function GKa(a){a=a|0;c[a>>2]=0;i=i;return}function HKa(a){a=a|0;var b=0;b=i;IKa(a);i=b;return}function IKa(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;LXa(j);c[d>>2]=284504;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;_Ha(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;HXa(g,j);l=JKa(g)|0;n1a(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=pe[r&63](d,0,4096)|0;i=e;return}HXa(h,j);c[k>>2]=lJa(h)|0;n1a(h);a[f]=(mJa(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=pe[r&63](d,0,4096)|0;i=e;return}function JKa(a){a=a|0;var b=0,c=0;b=i;c=o1a(a,316336)|0;i=b;return c|0}function KKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;uDa(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){LKa(a,b,c[f>>2]|0,h);xDa(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=N4a(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;QBa(k,284776,e)}LKa(a,b,l,h);xDa(3);i=d;return}function LKa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;xDa(0);k=+pDa(0);uDa(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function MKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=K4a(24)|0;uDa(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;PBa(c[m>>2]|0,l>>>31^1,284832,f);f=b+8|0;b=c[a+8>>2]|0;l=NKa(b,f)|0;c[g+20>>2]=l;l=NKa(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=K4a(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;QBa(k,284912,e)}else{c[h>>2]=0;c[a+12>>2]=g;xDa(3);i=d;return}}function NKa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function OKa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;uDa(3);u=b;v=lc(c[u>>2]|0,284976)|0;if((v|0)==0){PKa(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=_d(c[(Qc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;QBa(w,284984,q)}uc(285040,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];Ad(v|0,285088,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];Ad(v|0,285112,o|0)|0;uc(285136,40,1,v|0)|0;uc(285184,11,1,v|0)|0;uc(285200,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];QKa(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Wd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{uc(285216,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;QKa(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Wd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];Ad(v|0,285240,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;QKa(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Wd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];Ad(v|0,285240,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;QKa(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Wd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];Ad(v|0,285240,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;QKa(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Wd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];Ad(v|0,285240,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;QKa(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Wd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];Ad(v|0,285240,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;QKa(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Wd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];Ad(v|0,285240,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;QKa(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Wd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}PKa(t);if(($c(v|0)|0)==0){L4a(c[r>>2]|0);c[r>>2]=0;xDa(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];QBa(e,285256,f)}}function PKa(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}L4a(a);c[d>>2]=0;i=b;return}function QKa(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Ad(a|0,285304,f|0)|0;i=e;return}function RKa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=Q4a(192)|0;q5a(m|0,0,192)|0;SKa(m);c[a+12>>2]=m;n=m;o=a;nHa(n,c[o>>2]|0,36);if(qXa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];QBa(a,285344,g)}else{g=m;VYa(g,285320,14)|0;WYa(h,g);a=AIa(h)|0;h=m+184|0;c[h>>2]=a;VYa(g,285336,4)|0;TKa(n,b+8|0);WYa(j,g);b=AIa(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;mHa(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];XYa(g,f)|0;UKa(n,-4-m+b|0);b=c[j>>2]|0;mHa(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];XYa(g,e)|0;xDa(3);i=d;return}}function SKa(a){a=a|0;var b=0;b=i;lLa(a);i=b;return}function TKa(a,b){a=a|0;b=b|0;var c=0;c=i;WKa(a,3);XKa(a,285520);WKa(a,0);XKa(a,285528);WKa(a,2);gLa(a,b);hLa(a,b);XKa(a,285536);WKa(a,0);i=c;return}function UKa(a,b){a=a|0;b=b|0;var d=0;d=i;c[71378]=Ld(b|0)|0;VYa(a,285512,4)|0;i=d;return}function VKa(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;WYa(l,q);r=AIa(l)|0;UKa(b,0);WYa(m,q);l=AIa(m)|0;WKa(b,1);XKa(b,285408);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;YKa(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);ZKa(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{ZKa(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{_Ka(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{$Ka(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{XKa(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}WYa(n,q);u=AIa(n)|0;n=n5a(0,r|0,32)|0;mHa(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];XYa(q,k)|0;UKa(b,u-l|0);mHa(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];XYa(q,j)|0;i=g;return}function WKa(b,d){b=b|0;d=d|0;var e=0;e=i;a[285496]=-33;c[71376]=Ld(d|0)|0;d=b;VYa(d,285496,1)|0;VYa(d,285504,4)|0;i=e;return}function XKa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Ld(m5a(d|0)|0)|0;a[285488]=-37;g=b;VYa(g,285488,1)|0;VYa(g,f,4)|0;VYa(g,d,m5a(d|0)|0)|0;i=e;return}function YKa(b,d){b=b|0;d=d|0;var e=0;e=i;a[285472]=-35;c[71370]=Ld(d|0)|0;d=b;VYa(d,285472,1)|0;VYa(d,285480,4)|0;i=e;return}function ZKa(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[285456]=-53;fLa(c);e=b;VYa(e,285456,1)|0;VYa(e,285464,8)|0;i=d;return}function _Ka(b,d){b=b|0;d=d|0;var e=0;e=i;a[285440]=-46;c[71362]=Ld(d|0)|0;d=b;VYa(d,285440,1)|0;VYa(d,285448,4)|0;i=e;return}function $Ka(b,c){b=b|0;c=c|0;var d=0;d=i;a[285432]=c?-61:-62;VYa(b,285432,1)|0;i=d;return}function aLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;VKa(e,+h[f>>3],a,f);VKa(e,+h[b+248>>3],a,f);i=d;return}function bLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;WYa(j,p);o=AIa(j)|0;UKa(b,0);WYa(k,p);j=AIa(k)|0;WKa(b,1);XKa(b,285416);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;YKa(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;ZKa(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{ZKa(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{_Ka(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{$Ka(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{XKa(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}WYa(l,p);s=AIa(l)|0;l=n5a(0,o|0,32)|0;mHa(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];XYa(p,g)|0;UKa(b,s-j|0);mHa(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];XYa(p,f)|0;i=e;return}function cLa(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;gHa(a);uDa(3);if((a|0)!=0){dLa(a);S4a(a)}c[d>>2]=0;xDa(3);i=b;return}function dLa(a){a=a|0;var b=0;b=i;eLa(a);i=b;return}function eLa(a){a=a|0;var b=0;b=i;DIa(a);i=b;return}function fLa(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Ld(1)|0)==1){f=e;g=c[f+4>>2]|0;j=285464;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[285464+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function gLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;XKa(a,285408);WKa(a,4);XKa(a,285544);WKa(a,0);XKa(a,285552);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;YKa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);XKa(a,285560);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{XKa(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{XKa(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{XKa(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{XKa(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=285648;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];iLa(a,b,e);XKa(a,285584);WKa(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);jLa(a,285560,285592);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;jLa(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;jLa(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;jLa(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;jLa(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function hLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;XKa(a,285416);WKa(a,4);XKa(a,285544);WKa(a,0);XKa(a,285552);o=g+1+j+l+n|0;YKa(a,o);XKa(a,285560);if((c[f>>2]|0)>0){n=b;l=0;do{XKa(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{XKa(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{XKa(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{XKa(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=285568;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];iLa(a,b,e);XKa(a,285584);WKa(a,o);jLa(a,285560,285592);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;jLa(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;jLa(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;jLa(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;jLa(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function iLa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;XKa(b,285616);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}WKa(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?285560:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}kLa(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?285560:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}kLa(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?285560:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}kLa(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?285560:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}kLa(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function jLa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;XKa(a,b);WKa(a,1);XKa(a,285600);XKa(a,c);i=d;return}function kLa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;XKa(a,b);WKa(a,d?2:1);XKa(a,285624);XKa(a,c);if(!d){i=e;return}XKa(a,285632);XKa(a,285640);i=e;return}function lLa(a){a=a|0;var b=0;b=i;tKa(a);i=b;return}function mLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;zWa(e,285664);vWa(d,oLa(a,e)|0);nLa(d,b+4|0);FWa(d);FWa(e);zWa(g,285672);vWa(f,oLa(a,g)|0);pLa(f,b);FWa(f);FWa(g);zWa(j,285688);vWa(h,oLa(a,j)|0);nLa(h,b+8|0);FWa(h);FWa(j);zWa(l,285704);vWa(k,oLa(a,l)|0);nLa(k,b+12|0);FWa(k);FWa(l);zWa(n,285720);vWa(m,oLa(a,n)|0);qLa(m,b+16|0,0);FWa(m);FWa(n);zWa(p,285736);vWa(o,oLa(a,p)|0);qLa(o,b+20|0,0);FWa(o);FWa(p);zWa(r,285752);vWa(q,oLa(a,r)|0);qLa(q,b+24|0,0);FWa(q);FWa(r);zWa(t,285760);vWa(s,oLa(a,t)|0);qLa(s,b+28|0,0);FWa(s);FWa(t);zWa(v,285776);vWa(u,oLa(a,v)|0);qLa(u,b+32|0,0);FWa(u);FWa(v);i=c;return}function nLa(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){OBa(22,0,288984,d);i=d;return}else{c[b>>2]=Ed(aXa(a)|0)|0;i=d;return}}function oLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=xPa(a,f,b)|0;l=c[k>>2]|0;_Ha(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}zPa(j,a,b);APa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];yPa(g,e);BPa(j);j=c[f>>2]|0;CPa(a,j,k,DPa(g)|0);k=EPa(g)|0;BPa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function pLa(a,b){a=a|0;b=b|0;var d=0;d=i;if((dXa(a,285952)|0)==0){c[b>>2]=1;i=d;return}if((dXa(a,285960)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Ic(aXa(a)|0)|0;i=d;return}}function qLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((dXa(a,285928)|0)==0){c[b>>2]=d}if((dXa(a,285952)|0)==0){c[b>>2]=1;i=e;return}if((dXa(a,285960)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Ic(aXa(a)|0)|0;i=e;return}}function rLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;zWa(j,285792);vWa(g,oLa(b,j)|0);y=d+48|0;sLa(g,y);FWa(g);FWa(j);zWa(m,285808);vWa(l,oLa(b,m)|0);j=d+56|0;tLa(l,j,0.0);FWa(l);FWa(m);zWa(o,285816);vWa(n,oLa(b,o)|0);m=d+32|0;sLa(n,m);FWa(n);FWa(o);zWa(q,285824);vWa(p,oLa(b,q)|0);o=d+33|0;sLa(p,o);FWa(p);FWa(q);zWa(s,285840);vWa(r,oLa(b,s)|0);q=d+40|0;tLa(r,q,1.0);FWa(r);FWa(s);zWa(u,285848);vWa(t,oLa(b,u)|0);s=d+16|0;tLa(t,s,-1.7976931348623157e+308);FWa(t);FWa(u);zWa(w,285856);vWa(v,oLa(b,w)|0);u=d+24|0;tLa(v,u,1.7976931348623157e+308);FWa(v);FWa(w);zWa(x,285664);w=aXa(oLa(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?285952:285960;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?285928:285936;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?285928:285944;c[f+20>>2]=j;c[f+24>>2]=m?285928:285936;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?285928:285944;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];MBa(4,0,285864,f);FWa(x);i=e;return}function sLa(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(dXa(b,285952)|0)==0|0;i=d;return}function tLa(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((dXa(a,285928)|0)==0){h[b>>3]=c;i=d;return}if((dXa(a,285952)|0)==0){h[b>>3]=1.0;i=d;return}if((dXa(a,285960)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+e5a(aXa(a)|0);i=d;return}}function uLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;zWa(h,285792);vWa(g,oLa(b,h)|0);s=d+13|0;sLa(g,s);FWa(g);FWa(h);zWa(k,285808);vWa(j,oLa(b,k)|0);h=d+16|0;qLa(j,h,0);FWa(j);FWa(k);zWa(m,285816);vWa(l,oLa(b,m)|0);k=d+12|0;sLa(l,k);FWa(l);FWa(m);zWa(o,285848);vWa(n,oLa(b,o)|0);m=d+4|0;qLa(n,m,-2147483648);FWa(n);FWa(o);zWa(q,285856);vWa(p,oLa(b,q)|0);o=d+8|0;qLa(p,o,2147483647);FWa(p);FWa(q);zWa(r,285664);q=aXa(oLa(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?285952:285960;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?285928:285936;c[f+8>>2]=s;c[f+12>>2]=b?285928:285944;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;MBa(4,0,285968,f);FWa(r);i=e;return}function vLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;zWa(h,285792);vWa(g,oLa(b,h)|0);o=d+5|0;sLa(g,o);FWa(g);FWa(h);zWa(k,285808);vWa(j,oLa(b,k)|0);h=d+6|0;sLa(j,h);FWa(j);FWa(k);zWa(m,285816);vWa(l,oLa(b,m)|0);k=d+4|0;sLa(l,k);FWa(l);FWa(m);zWa(n,285664);m=aXa(oLa(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?285952:285960;h=(a[k]|0)!=0?285952:285960;c[f>>2]=m;c[f+4>>2]=b?285928:285936;c[f+8>>2]=o;c[f+12>>2]=b?285928:285944;c[f+16>>2]=h;MBa(4,0,286024,f);FWa(n);i=e;return}function wLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;zWa(h,285792);vWa(g,oLa(b,h)|0);m=d+4|0;sLa(g,m);FWa(g);FWa(h);zWa(k,285808);vWa(j,oLa(b,k)|0);h=d+8|0;nLa(j,h);FWa(j);FWa(k);zWa(l,285664);k=aXa(oLa(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?285928:285936;c[f+8>>2]=m;c[f+12>>2]=b?285928:285944;MBa(4,0,286064,f);FWa(l);i=e;return}function xLa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;yLa(qa);tWa(ra);zLa(sa,ta);zLa(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[299048>>2]|0)==0){zWa(za,c[b+80>>2]|0);ALa(ya,za,286088);GWa(ra,ya)|0;FWa(ya);FWa(za)}else{HWa(ra,c[299176>>2]|0)|0}ta=lc(aXa(ra)|0,286104)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=aXa(ra)|0;QBa(0,286112,pa)}else{Wc=0}}while(0);pa=ywa(0)|0;if((pa|0)==0){$c(Wc|0)|0;QBa(0,286216,oa)}Jwa(pa,Vc);Kwa(pa,10,113);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;q5a(oa|0,0,1024)|0;while(1){za=ub(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((Lwa(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){$c(Wc|0)|0;oa=aXa(ra)|0;ya=Twa(Qwa(pa)|0)|0;za=Rwa(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;OBa(1,0,286296,na);Fwa(pa);QBa(0,286384,ma)}else if((Xc|0)==14){$c(Wc|0)|0;break}}else{if((Lwa(pa,Vc,m5a(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Twa(Qwa(pa)|0)|0;ta=Rwa(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;Ad(za|0,286408,la|0)|0;za=c[va>>2]|0;ta=Twa(Qwa(pa)|0)|0;oa=Rwa(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;OBa(1,0,286424,ka);Fwa(pa);QBa(0,286384,ja)}}while(0);ja=qa;zWa(Ca,286512);ELa(Ba,ja,Ca);FLa(Da,ja);ka=DLa(Ba,Da)|0;FWa(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=aXa(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;OBa(1,0,286520,ia)}else{zWa(Ea,286512);Ba=i5a(Da,aXa(oLa(ja,Ea)|0)|0)|0;FWa(Ea);if((Ba|0)==0){break}Fwa(pa);zWa(Fa,286512);Ba=aXa(oLa(ja,Fa)|0)|0;va=aXa(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;OBa(1,0,286568,ha);FWa(Fa);QBa(0,286384,ga)}}while(0);GLa(qa,b,c[299260>>2]|0,c[299264>>2]|0);MBa(23,1,286664,fa);fa=qa+12|0;zWa(Ha,286704);vWa(Ga,oLa(fa,Ha)|0);ga=d;tLa(Ga,ga,0.0);FWa(Ga);FWa(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];MBa(23,0,286720,ea);zWa(Ja,286736);vWa(Ia,oLa(fa,Ja)|0);ea=d+8|0;tLa(Ia,ea,1.0);FWa(Ia);FWa(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];MBa(23,0,286752,da);zWa(La,286768);vWa(Ka,oLa(fa,La)|0);da=d+24|0;tLa(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);FWa(Ka);FWa(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];MBa(23,0,286784,ca);zWa(Na,286800);vWa(Ma,oLa(fa,Na)|0);ca=d+32|0;tLa(Ma,ca,1.0e-5);FWa(Ma);FWa(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];MBa(23,0,286816,ba);zWa(Pa,286832);vWa(Oa,oLa(fa,Pa)|0);ba=d+40|0;nLa(Oa,ba);FWa(Oa);FWa(Pa);c[aa>>2]=c[ba>>2];MBa(23,0,286840,aa);zWa(Ra,286864);vWa(Qa,oLa(fa,Ra)|0);aa=d+44|0;nLa(Qa,aa);FWa(Qa);FWa(Ra);c[$>>2]=c[aa>>2];MBa(23,0,286880,$);zWa(Ta,286904);vWa(Sa,oLa(fa,Ta)|0);fa=d+48|0;nLa(Sa,fa);FWa(Sa);FWa(Ta);c[_>>2]=c[fa>>2];MBa(23,0,286920,_);zWa(Va,286944);vWa(Ua,oLa(ja,Va)|0);_=d+268|0;nLa(Ua,_);FWa(Ua);FWa(Va);c[Z>>2]=c[_>>2];MBa(23,0,286968,Z);if((c[241700>>2]|0)!=0){je[c[60540]&1023](23)}zWa(eb,286992);vWa(db,oLa(ja,eb)|0);qLa(db,Wa,0);FWa(db);FWa(eb);zWa(gb,287024);vWa(fb,oLa(ja,gb)|0);qLa(fb,Xa,0);FWa(fb);FWa(gb);zWa(ib,287056);vWa(hb,oLa(ja,ib)|0);qLa(hb,Ya,0);FWa(hb);FWa(ib);zWa(kb,287080);vWa(jb,oLa(ja,kb)|0);qLa(jb,_a,0);FWa(jb);FWa(kb);zWa(mb,287112);vWa(lb,oLa(ja,mb)|0);qLa(lb,Za,0);FWa(lb);FWa(mb);zWa(ob,287152);vWa(nb,oLa(ja,ob)|0);qLa(nb,ab,0);FWa(nb);FWa(ob);zWa(qb,287184);vWa(pb,oLa(ja,qb)|0);qLa(pb,$a,0);FWa(pb);FWa(qb);zWa(sb,287224);vWa(rb,oLa(ja,sb)|0);qLa(rb,cb,0);FWa(rb);FWa(sb);zWa(vb,287256);vWa(tb,oLa(ja,vb)|0);qLa(tb,bb,0);FWa(tb);FWa(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){tb=b+108|0;if((c[Xa>>2]|0)!=((c[tb>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}sb=b+132|0;if((c[_a>>2]|0)!=(c[sb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=287800;MBa(4,1,287776,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=HLa(lb,wb)|0;mLa(ib,jb+(kb*112|0)|0);rLa(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(xb,287816);jb=(dXa(oLa(ib,xb)|0,285952)|0)==0;FWa(xb);if(!jb){break}c[N>>2]=c[hb>>2];MBa(4,0,287832,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);zWa(yb,c[hb>>2]|0);c[(ILa(sa,yb)|0)>>2]=kb;FWa(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[M>>2]=287864;MBa(4,1,287776,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=HLa(lb,zb)|0;mLa(fb,gb+(jb*112|0)|0);rLa(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Ab,287816);gb=(dXa(oLa(fb,Ab)|0,285952)|0)==0;FWa(Ab);if(!gb){break}c[L>>2]=c[eb>>2];MBa(4,0,287832,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);zWa(Bb,c[eb>>2]|0);c[(ILa(sa,Bb)|0)>>2]=jb;FWa(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[K>>2]=287888;MBa(4,1,287776,K);ib=c[Wa>>2]<<1;if(((c[tb>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=HLa(mb,Cb)|0;mLa(gb,hb+(fb*112|0)|0);rLa(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Db,287816);hb=(dXa(oLa(gb,Db)|0,285952)|0)==0;FWa(Db);if(!hb){break}c[J>>2]=c[db>>2];MBa(4,0,287832,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);zWa(Eb,c[db>>2]|0);c[(ILa(sa,Eb)|0)>>2]=fb;FWa(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[tb>>2]|0)-lb|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[I>>2]=287904;MBa(4,1,287776,I);if((c[rb>>2]|0)>0){lb=b+4|0;tb=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=HLa(tb,Fb)|0;mLa(mb,kb+(ib*60|0)|0);uLa(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Gb,287816);kb=(dXa(oLa(mb,Gb)|0,285952)|0)==0;FWa(Gb);if(!kb){break}c[H>>2]=c[gb>>2];MBa(4,0,287832,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);zWa(Hb,c[gb>>2]|0);c[(ILa(sa,Hb)|0)>>2]=ib;FWa(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[G>>2]=287928;MBa(4,1,287776,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{tb=c[rb>>2]|0;c[Ib>>2]=lb;mb=HLa(ib,Ib)|0;mLa(mb,tb+(lb*48|0)|0);vLa(mb,tb+(lb*48|0)+36|0);fb=tb+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Jb,287816);tb=(dXa(oLa(mb,Jb)|0,285952)|0)==0;FWa(Jb);if(!tb){break}c[F>>2]=c[fb>>2];MBa(4,0,287832,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);zWa(Kb,c[fb>>2]|0);c[(ILa(sa,Kb)|0)>>2]=lb;FWa(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[E>>2]=287952;MBa(4,1,287776,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=HLa(lb,Lb)|0;mLa(mb,ib+(rb*52|0)|0);wLa(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Mb,287816);ib=(dXa(oLa(mb,Mb)|0,285952)|0)==0;FWa(Mb);if(!ib){break}c[D>>2]=c[gb>>2];MBa(4,0,287832,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);zWa(Nb,c[gb>>2]|0);c[(ILa(sa,Nb)|0)>>2]=rb;FWa(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[C>>2]=287976;MBa(4,1,287776,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=HLa(rb,Ob)|0;mLa(mb,lb+(pb*112|0)|0);rLa(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Pb,287816);lb=(dXa(oLa(mb,Pb)|0,285952)|0)==0;FWa(Pb);if(!lb){break}c[B>>2]=c[fb>>2];MBa(4,0,287832,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);zWa(Qb,c[fb>>2]|0);c[(ILa(ua,Qb)|0)>>2]=pb;FWa(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[A>>2]=287992;MBa(4,1,287776,A);if((c[sb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=HLa(pb,Rb)|0;mLa(mb,rb+(nb*60|0)|0);uLa(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Sb,287816);rb=(dXa(oLa(mb,Sb)|0,285952)|0)==0;FWa(Sb);if(!rb){break}c[z>>2]=c[gb>>2];MBa(4,0,287832,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);zWa(Tb,c[gb>>2]|0);c[(ILa(ua,Tb)|0)>>2]=nb;FWa(Tb);nb=nb+1|0;}while((nb|0)<(c[sb>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[y>>2]=288016;MBa(4,1,287776,y);if((c[qb>>2]|0)>0){sb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[sb>>2]|0;c[Ub>>2]=ja;mb=HLa(nb,Ub)|0;mLa(mb,pb+(ja*48|0)|0);vLa(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Vb,287816);pb=(dXa(oLa(mb,Vb)|0,285952)|0)==0;FWa(Vb);if(!pb){break}c[x>>2]=c[fb>>2];MBa(4,0,287832,x);a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);zWa(Wb,c[fb>>2]|0);c[(ILa(ua,Wb)|0)>>2]=ja;FWa(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}c[w>>2]=288040;MBa(4,1,287776,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;sb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=sb;mb=HLa(ja,Xb)|0;mLa(mb,nb+(sb*52|0)|0);wLa(mb,nb+(sb*52|0)+36|0);gb=nb+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[299044>>2]|0)!=0){break}zWa(Yb,287816);nb=(dXa(oLa(mb,Yb)|0,285952)|0)==0;FWa(Yb);if(!nb){break}c[v>>2]=c[gb>>2];MBa(4,0,287832,v);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);zWa(Zb,c[gb>>2]|0);c[(ILa(ua,Zb)|0)>>2]=sb;FWa(Zb);sb=sb+1|0;}while((sb|0)<(c[ob>>2]|0))}if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}MBa(4,1,288064,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){sb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=HLa(sb,_b)|0;mLa(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);tWa($b);c[bc>>2]=ja;mb=HLa(sb,bc)|0;zWa(cc,288104);vWa(ac,oLa(mb,cc)|0);JLa(ac,$b);FWa(ac);FWa(cc);mb=(dXa($b,288112)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;MBa(4,0,288128,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=HLa(sb,ec)|0;zWa(fc,288168);vWa(dc,oLa(nb,fc)|0);JLa(dc,$b);FWa(dc);FWa(fc);KLa(wa,sa,$b);KLa(xa,ua,$b);MLa(gc,sa);do{if(LLa(wa,gc)|0){nb=c[(NLa(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{MLa(hc,ua);if(LLa(xa,hc)|0){fb=c[(NLa(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((dXa($b,288184)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);FWa($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}oXa(jc,288192,$b);ALa(ic,jc,288216);FWa(jc);c[s>>2]=aXa(ic)|0;QBa(0,288232,s)}}while(0);if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}MBa(4,1,288240,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;sb=0;while(1){c[kc>>2]=sb;gb=HLa(ja,kc)|0;mLa(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);tWa(mc);c[oc>>2]=sb;gb=HLa(ja,oc)|0;zWa(pc,288104);vWa(nc,oLa(gb,pc)|0);JLa(nc,mc);FWa(nc);FWa(pc);gb=(dXa(mc,288112)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[p>>2]=c[nb+(sb*52|0)+16>>2];c[p+4>>2]=fb;MBa(4,0,288128,p);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[rc>>2]=sb;fb=HLa(ja,rc)|0;zWa(sc,288168);vWa(qc,oLa(fb,sc)|0);JLa(qc,mc);FWa(qc);FWa(sc);KLa(wa,sa,mc);KLa(xa,ua,mc);MLa(tc,sa);if(LLa(wa,tc)|0){fb=c[(NLa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{MLa(uc,ua);if(!(LLa(xa,uc)|0)){break}nb=c[(NLa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}FWa(mc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break c}}oXa(wc,288280,mc);ALa(vc,wc,288216);FWa(wc);c[o>>2]=aXa(vc)|0;QBa(0,288232,o)}}while(0);if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}MBa(4,1,288304,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){sb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=HLa(sb,xc)|0;mLa(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);tWa(yc);c[Ac>>2]=ja;fb=HLa(sb,Ac)|0;zWa(Bc,288104);vWa(zc,oLa(fb,Bc)|0);JLa(zc,yc);FWa(zc);FWa(Bc);fb=(dXa(yc,288112)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;MBa(4,0,288128,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=HLa(sb,Dc)|0;zWa(Ec,288168);vWa(Cc,oLa(gb,Ec)|0);JLa(Cc,yc);FWa(Cc);FWa(Ec);KLa(wa,sa,yc);KLa(xa,ua,yc);MLa(Fc,sa);if(LLa(wa,Fc)|0){gb=c[(NLa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{MLa(Gc,ua);if(!(LLa(xa,Gc)|0)){break}nb=c[(NLa(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}FWa(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}oXa(Ic,288344,yc);ALa(Hc,Ic,288216);FWa(Ic);c[l>>2]=aXa(Hc)|0;QBa(0,288232,l)}}while(0);if((c[241624>>2]|0)!=0){je[c[60540]&1023](4)}MBa(4,1,288368,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;sb=0;while(1){c[Jc>>2]=sb;gb=HLa(ja,Jc)|0;mLa(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);tWa(Kc);c[Mc>>2]=sb;gb=HLa(ja,Mc)|0;zWa(Nc,288104);vWa(Lc,oLa(gb,Nc)|0);JLa(Lc,Kc);FWa(Lc);FWa(Nc);gb=(dXa(Kc,288112)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[g>>2]=c[nb+(sb*52|0)+16>>2];c[g+4>>2]=fb;MBa(4,0,288128,g);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[Pc>>2]=sb;fb=HLa(ja,Pc)|0;zWa(Qc,288168);vWa(Oc,oLa(fb,Qc)|0);JLa(Oc,Kc);FWa(Oc);FWa(Qc);KLa(wa,sa,Kc);KLa(xa,ua,Kc);MLa(Rc,sa);if(LLa(wa,Rc)|0){fb=c[(NLa(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{MLa(Sc,ua);if(!(LLa(xa,Sc)|0)){break}nb=c[(NLa(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}FWa(Kc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break e}}oXa(Uc,288408,Kc);ALa(Tc,Uc,288216);FWa(Uc);c[f>>2]=aXa(Tc)|0;QBa(0,288232,f)}}while(0);if((c[241624>>2]|0)==0){Fwa(pa);OLa(ua);OLa(sa);FWa(ra);PLa(qa);i=e;return}je[c[60540]&1023](4);Fwa(pa);OLa(ua);OLa(sa);FWa(ra);PLa(qa);i=e;return}}while(0);if((c[241696>>2]|c[60400]|0)==0){Fwa(pa);Yc=yd(0)|0;Gd(-1)}OBa(22,1,287296,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;OBa(22,0,287344,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;OBa(22,0,287392,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;OBa(22,0,287440,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;OBa(22,0,287488,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;OBa(22,0,287536,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;OBa(22,0,287584,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;OBa(22,0,287632,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;OBa(22,0,287680,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;OBa(22,0,287728,P);je[c[60540]&1023](22);Fwa(pa);Yc=yd(0)|0;Gd(-1)}function yLa(a){a=a|0;var b=0;b=i;ySa(a);i=b;return}function zLa(a,b){a=a|0;b=b|0;b=i;dOa(a,0);i=b;return}function ALa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;uWa(a,d);e=DWa(b)|0;f=nMa(c)|0;eXa(a,EWa(b)|0,e,f+e|0);YWa(a,c,f)|0;i=d;return}function BLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((i5a(b,289040)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{zWa(g,v);w=oLa(u,g)|0;HWa(w,c[d+((t|1)<<2)>>2]|0)|0;FWa(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((i5a(b,289064)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{zWa(h,g);u=oLa(t,h)|0;HWa(u,c[d+((v|1)<<2)>>2]|0)|0;FWa(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((i5a(b,289088)|0)!=0){do{if((i5a(b,289344)|0)!=0){if((i5a(b,289352)|0)==0){break}if((i5a(b,289360)|0)==0){break}if((i5a(b,289368)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=HLa(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){zWa(r,c[t>>2]|0);w=oLa(g,r)|0;HWa(w,c[d+((u|1)<<2)>>2]|0)|0;FWa(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=HLa(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}zWa(s,289376);HWa(oLa(x,s)|0,b)|0;FWa(s);i=e;return}QLa(j,k);tWa(l);tWa(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{zWa(n,g);t=oLa(j,n)|0;HWa(t,c[d+((x|1)<<2)>>2]|0)|0;FWa(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}zWa(o,289104);GWa(l,oLa(j,o)|0)|0;FWa(o);zWa(p,289120);GWa(m,oLa(j,p)|0)|0;FWa(p);c[k>>2]=Ic(aXa(l)|0)|0;if((dXa(m,289136)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((dXa(m,289144)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((dXa(m,289152)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((dXa(m,289160)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((dXa(m,289168)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((dXa(m,289176)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((dXa(m,289184)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((dXa(m,289192)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((dXa(m,289200)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((dXa(m,289208)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((dXa(m,289216)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((dXa(m,289224)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((dXa(m,289232)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((dXa(m,289240)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=aXa(m)|0;zWa(q,285664);N=aXa(oLa(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;PBa(0,(O|0)!=0|0,289248,f);FWa(q);bRa(HLa(c[b>>2]|0,s)|0,j)|0;FWa(m);FWa(l);YLa(j);i=e;return}function CLa(a,b){a=a|0;b=b|0;i=i;return}function DLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ONa(a,b)|0;i=c;return d|0}function ELa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;XNa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];PNa(a,f);i=e;return}function FLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;QNa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];PNa(a,e);i=d;return}



function Tna(a){a=a|0;var b=0;b=i;hf(a);kf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Hf(a);Jf(a);Kf(a);Lf(a);Mf(a);Of(a);Qf(a);Rf(a);Uf(a);Vf(a);Wf(a);Xf(a);Zf(a);_f(a);$f(a);cg(a);dg(a);eg(a);fg(a);ig(a);jg(a);kg(a);lg(a);ng(a);og(a);pg(a);qg(a);rg(a);tg(a);ug(a);vg(a);wg(a);zg(a);Ag(a);Dg(a);Jg(a);Kg(a);Lg(a);Ng(a);Og(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);dh(a);hh(a);jh(a);kh(a);nh(a);qh(a);rh(a);th(a);uh(a);yh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Vh(a);Xh(a);Yh(a);Zh(a);ai(a);ci(a);di(a);ei(a);fi(a);hi(a);ii(a);ji(a);ki(a);li(a);oi(a);ri(a);si(a);ui(a);vi(a);zi(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Ti(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);bk(a);ck(a);dk(a);fk(a);gk(a);kk(a);lk(a);mk(a);nk(a);pk(a);qk(a);rk(a);vk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);Mk(a);Nk(a);Ok(a);Qk(a);Sk(a);Tk(a);Uk(a);Yk(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);nl(a);ol(a);pl(a);rl(a);tl(a);ul(a);xl(a);zl(a);Al(a);Dl(a);Fl(a);Gl(a);Jl(a);Ll(a);Ml(a);Pl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);dm(a);em(a);fm(a);gm(a);hm(a);nm(a);om(a);sm(a);tm(a);ym(a);Cm(a);Em(a);Hm(a);Lm(a);Om(a);Pm(a);en(a);gn(a);tn(a);xn(a);zn(a);Cn(a);Gn(a);Jn(a);Kn(a);$n(a);bo(a);co(a);eo(a);jo(a);no(a);po(a);so(a);wo(a);zo(a);Ao(a);Ro(a);To(a);Uo(a);Vo(a);cp(a);dp(a);ep(a);fp(a);jp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);Dp(a);Ep(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Vp(a);Wp(a);Xp(a);Yp(a);_p(a);$p(a);cq(a);dq(a);eq(a);fq(a);gq(a);mq(a);nq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Iq(a);Jq(a);Lq(a);Oq(a);Pq(a);Qq(a);Wq(a);Xq(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);pr(a);qr(a);rr(a);sr(a);wr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Kr(a);Pr(a);Ur(a);Zr(a);cs(a);hs(a);ms(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);i=b;return}function Una(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167008]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(167024,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167008]=1;i=d;return}function Vna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167240]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(167248,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6472>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167240]=1;i=d;return}function Wna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167408]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(167416,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6456>>3],167016)|0)|0;g=c[72854]|0;j=e;k=167608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167408]=1;i=d;return}function Xna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(167640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6448>>3],167016)|0)|0;g=c[72854]|0;j=e;k=167736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167632]=1;i=d;return}function Yna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167760]&1){i=d;return}g=b+4|0;j=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],0.0)|0;if(!(j<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+736>>3])|0)<<24>>24==0)){i=d;return}b=ACa(167768,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],167016)|0)|0;g=c[72854]|0;j=e;k=167872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167760]=1;i=d;return}function Zna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167896]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(167904,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],167016)|0)|0;g=c[72854]|0;j=e;k=168048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[167896]=1;i=d;return}function _na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(168080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168072]=1;i=d;return}function $na(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168224]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(168232,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168224]=1;i=d;return}function aoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168376]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(168384,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],167016)|0)|0;g=c[72854]|0;j=e;k=168536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168376]=1;i=d;return}function boa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(168568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168560]=1;i=d;return}function coa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168720]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(168728,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168720]=1;i=d;return}function doa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168928]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6432>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(168936,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6432>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[168928]=1;i=d;return}function eoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169048]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(169056,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6424>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169048]=1;i=d;return}function foa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169168]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(169176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6416>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169168]=1;i=d;return}function goa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169296]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(169312,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[169296]=1;i=d;return}function hoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6400>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(169512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6400>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169504]=1;i=d;return}function ioa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(169640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169632]=1;i=d;return}function joa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169760]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6384>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6384>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(169768,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6384>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169760]=1;i=d;return}function koa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169888]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(169896,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[169888]=1;i=d;return}function loa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170016]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6368>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6368>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170024,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6368>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170016]=1;i=d;return}function moa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170136]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170144,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170136]=1;i=d;return}function noa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170256]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(170264,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6336>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170256]=1;i=d;return}function ooa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170384]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170392,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170384]=1;i=d;return}function poa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170512]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170520,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6320>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170512]=1;i=d;return}function qoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170632]=1;i=d;return}function roa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6064>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(170760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6064>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170752]=1;i=d;return}function soa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170880]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6056>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6056>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(170888,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6056>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[170880]=1;i=d;return}function toa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171008]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6048>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6048>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(171016,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6048>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171008]=1;i=d;return}function uoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171128]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6040>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6040>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(171136,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6040>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171128]=1;i=d;return}function voa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171248]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6024>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6024>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(171256,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6024>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171248]=1;i=d;return}function woa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171368]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6008>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(171376,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6008>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171368]=1;i=d;return}function xoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171488]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6e3>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(171496,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6e3>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171488]=1;i=d;return}function yoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171608]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5992>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5992>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(171616,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5992>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171608]=1;i=d;return}function zoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171728]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5984>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(171736,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5984>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171728]=1;i=d;return}function Aoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171848]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5976>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5976>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(171856,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5976>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171848]=1;i=d;return}function Boa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171968]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5968>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5968>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(171976,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5968>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[171968]=1;i=d;return}function Coa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172088]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(172096,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5960>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172088]=1;i=d;return}function Doa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172208]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(172216,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172208]=1;i=d;return}function Eoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172320]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(172328,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5928>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172320]=1;i=d;return}function Foa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172440]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(172448,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5920>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172440]=1;i=d;return}function Goa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(172568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5912>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172560]=1;i=d;return}function Hoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(172688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5904>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172680]=1;i=d;return}function Ioa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172800]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(172808,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5896>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172800]=1;i=d;return}function Joa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172920]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(172928,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5888>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[172920]=1;i=d;return}function Koa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173040]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(173048,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5880>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173040]=1;i=d;return}function Loa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173160]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(173168,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173160]=1;i=d;return}function Moa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173272]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(173280,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5848>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173272]=1;i=d;return}function Noa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173392]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(173400,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5840>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173392]=1;i=d;return}function Ooa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173512]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(173520,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5832>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173512]=1;i=d;return}function Poa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(173640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5824>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173632]=1;i=d;return}function Qoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(173760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5816>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173752]=1;i=d;return}function Roa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173872]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(173880,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5808>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173872]=1;i=d;return}function Soa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173992]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(174e3,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5784>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[173992]=1;i=d;return}function Toa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(174120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5776>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174112]=1;i=d;return}function Uoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174232]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(174240,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5768>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174232]=1;i=d;return}function Voa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(174360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5760>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174352]=1;i=d;return}function Woa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174472]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(174480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5752>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174472]=1;i=d;return}function Xoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174592]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(174600,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5744>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174592]=1;i=d;return}function Yoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174712]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(174720,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5720>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174712]=1;i=d;return}function Zoa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174832]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(174840,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5712>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174832]=1;i=d;return}function _oa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174952]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(174960,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5704>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[174952]=1;i=d;return}function $oa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(175080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5696>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[175072]=1;i=d;return}function apa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(175200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5688>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[175192]=1;i=d;return}function bpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175312]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3];k=b+420|0;b=sFa(j,+xd(0.0,+(+xd(-1.0e+60,+(+xd(+-((c[(c[k>>2]|0)+152>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[k>>2]|0)+152>>2]|0)==1?0.0:-1.0e+60),1.0e5))))))|0)<<24>>24==0)){i=d;return}k=ACa(175320,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5672>>3],167016)|0)|0;g=c[72854]|0;b=e;l=189600;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[175312]=1;i=d;return}function cpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175768]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(175776,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5656>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[175768]=1;i=d;return}function dpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175944]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(175952,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5648>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[175944]=1;i=d;return}function epa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(176072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5640>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[176064]=1;i=d;return}function fpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176184]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(176192,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5632>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[176184]=1;i=d;return}function gpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176304]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(176312,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5624>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[176304]=1;i=d;return}function hpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(176432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5616>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[176424]=1;i=d;return}function ipa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176544]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3];k=b+420|0;b=sFa(j,+xd(0.0,+(+xd(-1.0e+60,+(+xd(+-((c[(c[k>>2]|0)+164>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[k>>2]|0)+164>>2]|0)==1?0.0:-1.0e+60),1.0e5))))))|0)<<24>>24==0)){i=d;return}k=ACa(176552,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5600>>3],167016)|0)|0;g=c[72854]|0;b=e;l=189600;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[176544]=1;i=d;return}function jpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177e3]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(177008,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5584>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177e3]=1;i=d;return}function kpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177176]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(177184,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5576>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177176]=1;i=d;return}function lpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177304]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(177312,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5568>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177304]=1;i=d;return}function mpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177432]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(177440,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5560>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177432]=1;i=d;return}function npa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(177568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5552>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177560]=1;i=d;return}function opa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177688]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(177696,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5544>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177688]=1;i=d;return}function ppa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(177816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5536>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[177808]=1;i=d;return}function qpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177928]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3];k=b+420|0;b=sFa(j,+xd(-1.0e+60,+(+xd(-1.0e+60,+(+xd(+-((c[(c[k>>2]|0)+688>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[k>>2]|0)+688>>2]|0)==1?0.0:-1.0e+60),1.0e5))))))|0)<<24>>24==0)){i=d;return}k=ACa(177936,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5520>>3],167016)|0)|0;g=c[72854]|0;b=e;l=189600;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[177928]=1;i=d;return}function rpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178408]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(178416,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5504>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[178408]=1;i=d;return}function spa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178528]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(178536,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5496>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[178528]=1;i=d;return}function tpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178648]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(178656,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5488>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[178648]=1;i=d;return}function upa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178768]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(178776,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5480>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[178768]=1;i=d;return}function vpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178888]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(178896,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5472>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[178888]=1;i=d;return}function wpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179008]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(179016,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5464>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179008]=1;i=d;return}function xpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179128]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(179136,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5440>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179128]=1;i=d;return}function ypa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179256]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5432>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5432>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(179264,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5432>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179256]=1;i=d;return}function zpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179384]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(179392,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5424>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179384]=1;i=d;return}function Apa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179512]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(179520,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5416>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179512]=1;i=d;return}function Bpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179640]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(179648,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5408>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179640]=1;i=d;return}function Cpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179760]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(179768,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5400>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179760]=1;i=d;return}function Dpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179880]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(179888,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5376>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[179880]=1;i=d;return}function Epa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18e4]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180008,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5368>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[18e4]=1;i=d;return}function Fpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180120]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(180128,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5360>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180120]=1;i=d;return}function Gpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180240]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180248,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5352>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180240]=1;i=d;return}function Hpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180360]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180368,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5344>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180360]=1;i=d;return}function Ipa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5336>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5336>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5336>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180480]=1;i=d;return}function Jpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180600]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(180608,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5312>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180600]=1;i=d;return}function Kpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180728]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180736,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5304>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180728]=1;i=d;return}function Lpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180856]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(180864,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5296>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180856]=1;i=d;return}function Mpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180984]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(180992,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5288>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[180984]=1;i=d;return}function Npa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(181120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5280>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[181112]=1;i=d;return}function Opa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181232]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5272>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5272>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(181240,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5272>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[181232]=1;i=d;return}function Ppa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181352]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3];k=b+420|0;b=sFa(j,+xd(-1.0e+60,+(+xd(-1.0e+60,+(+xd(+-((c[(c[k>>2]|0)+172>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(1.0e5,+(+wd(+-((c[(c[k>>2]|0)+172>>2]|0)==1?0.0:-1.0e+60),1.0e5))))))|0)<<24>>24==0)){i=d;return}k=ACa(181360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5256>>3],167016)|0)|0;g=c[72854]|0;b=e;l=189600;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[181352]=1;i=d;return}function Qpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181832]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(181840,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5240>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[181832]=1;i=d;return}function Rpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181960]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(181968,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5232>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[181960]=1;i=d;return}function Spa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182088]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5224>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(182096,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5224>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182088]=1;i=d;return}function Tpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182216]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5216>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5216>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(182224,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5216>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182216]=1;i=d;return}function Upa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5208>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5208>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(182352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5208>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182344]=1;i=d;return}function Vpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182464]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(182472,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5200>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182464]=1;i=d;return}function Wpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182584]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(182592,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5176>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182584]=1;i=d;return}function Xpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182744]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(182752,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5168>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182744]=1;i=d;return}function Ypa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182872]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5160>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5160>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(182880,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5160>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[182872]=1;i=d;return}function Zpa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183e3]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(183008,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5152>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[183e3]=1;i=d;return}function _pa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183128]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(183136,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5144>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[183128]=1;i=d;return}function $pa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183256]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(183264,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5136>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[183256]=1;i=d;return}function aqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183376]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(183384,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5128>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[183376]=1;i=d;return}function bqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183496]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5112>>3];k=b+420|0;b=sFa(j,+xd(+((c[(c[k>>2]|0)+176>>2]|0)==1?0.0:-1.0e+60),-1.0e+60))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5112>>3];if(!(b<<24>>24==0|(qFa(j,+wd(+((c[(c[k>>2]|0)+176>>2]|0)==2?0.0:1.0e+60),1.0e5))|0)<<24>>24==0)){i=d;return}k=ACa(183504,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5112>>3],167016)|0)|0;g=c[72854]|0;b=e;l=189600;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[183496]=1;i=d;return}function cqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183880]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(183888,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5096>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[183880]=1;i=d;return}function dqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184008]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(184016,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5088>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184008]=1;i=d;return}function eqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184168]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(184176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5080>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184168]=1;i=d;return}function fqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184296]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(184304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5072>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184296]=1;i=d;return}function gqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(184432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5064>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184424]=1;i=d;return}function hqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(184560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5056>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184552]=1;i=d;return}function iqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5048>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5048>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(184688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5048>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184680]=1;i=d;return}function jqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184800]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(184808,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5040>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184800]=1;i=d;return}function kqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184920]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(184928,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5024>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[184920]=1;i=d;return}function lqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185040]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(185048,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5008>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185040]=1;i=d;return}function mqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185168]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5e3>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(185176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5e3>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185168]=1;i=d;return}function nqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185296]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4992>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4992>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(185304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4992>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185296]=1;i=d;return}function oqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4984>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(185432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4984>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185424]=1;i=d;return}function pqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4976>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4976>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(185560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4976>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185552]=1;i=d;return}function qqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4968>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4968>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(185688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4968>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185680]=1;i=d;return}function rqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185800]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4960>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4960>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(185808,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4960>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185800]=1;i=d;return}function sqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185920]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(185928,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4944>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[185920]=1;i=d;return}function tqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186040]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4928>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(186048,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4928>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186040]=1;i=d;return}function uqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186168]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4920>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4920>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(186176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4920>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186168]=1;i=d;return}function vqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186296]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4912>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(186304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4912>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186296]=1;i=d;return}function wqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4904>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4904>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(186432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4904>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186424]=1;i=d;return}function xqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4896>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(186560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4896>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186552]=1;i=d;return}function yqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186672]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4888>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4888>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(186680,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4888>>3],167016)|0)|0;g=c[72854]|0;j=e;k=189456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186672]=1;i=d;return}function zqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186792]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4872>>3];k=b+420|0;b=c[k>>2]|0;l=(c[b+168>>2]|0)==1?0.0:-1.0e+60;m=sFa(j,+xd(+l,+(+xd(-1.0e+60,+(+xd(+-((c[b+692>>2]|0)==2?0.0:1.0e+60),-1.0e+60))))))|0;l=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4872>>3];b=c[k>>2]|0;j=(c[b+168>>2]|0)==2?0.0:1.0e+60;if(!(m<<24>>24==0|(qFa(l,+wd(+j,+(+wd(1.0e5,+(+wd(+-((c[b+692>>2]|0)==1?0.0:-1.0e+60),1.0e5))))))|0)<<24>>24==0)){i=d;return}b=ACa(186800,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4872>>3],167016)|0)|0;g=c[72854]|0;m=e;k=189600;c[m+0>>2]=c[k+0>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[m+12>>2]=c[k+12>>2];c[m+16>>2]=c[k+16>>2];c[m+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[186792]=1;i=d;return}function Aqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187472]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(187480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4848>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[187472]=1;i=d;return}function Bqa(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(187568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[187560]=1;i=d;return}



function tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3568>>3];k=+h[g+3552>>3]- +h[g+3560>>3]*+h[g+3528>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,j,6832,6824,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+6640|0;p=o;h[p>>3]=m;i=d;return}function uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4044>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+376>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+376|0;h[c[g+4048>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+376>>3]);e=c[f>>2]|0;h[c[e+4052>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4044>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+368>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+368|0;h[(c[e+4048>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+368>>3]);h[(c[(c[f>>2]|0)+4052>>2]|0)+8>>3]=k;TFa(a,50)|0;a=c[(c[f>>2]|0)+4044>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+376>>3]=+h[a>>3];h[f+368>>3]=+h[a+8>>3];i=b;return}function vq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+104>>3],+h[l+3800>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+104>>3];o=+h[m+3800>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+4944>>3],+h[d+4976>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1960>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4960>>3]=+h[g>>3];i=b;return}function wq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+3800>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+3800>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+4992>>3]=+h[f>>3];i=b;return}function xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5008>>3],+h[a+3800>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5008>>3];l=+h[g+3800>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5e3>>3]=+h[f>>3];i=b;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+4944>>3],+h[j+5e3>>3],+h[j+4984>>3],+h[(c[b+416>>2]|0)+1960>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,6856,6848,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+4936|0;q=p;h[q>>3]=n;i=d;return}function zq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5008>>3],+h[l+96>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5008>>3];o=+h[m+96>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+4944>>3],+h[d+4992>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1960>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+4968>>3]=+h[g>>3];i=b;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3752>>3]*+h[j+1512>>3]*+h[e+3696>>3];l=+h[j+4944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,6960,6952,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}function Bq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=+h[(a?e+1512|0:e+1504|0)>>3];i=b;return}function Cq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+4944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1472>>3]=+h[(a?e+1488|0:e+1480|0)>>3];i=b;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2120>>3],+h[(c[b+416>>2]|0)+2824>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+57|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+57|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[b+360>>2]|0)+57|0]|0)|0;a[(c[b+352>>2]|0)+57|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[b+360>>2]|0)+57|0]|0)|0;a[(c[b+352>>2]|0)+57|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+57|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+57|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+57|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+9|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+9|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+9|0;v=u;a[v]=m;i=d;return}function Eq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2072>>3]=+h[(c[a+416>>2]|0)+168>>3];i=i;return}function Fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+35|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+35|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+168>>3],+h[k+2072>>3]+ +h[k+3080>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+168>>3],+h[j+2072>>3]+ +h[j+3080>>3],a[(c[b+360>>2]|0)+35|0]|0)|0;a[(c[b+352>>2]|0)+35|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+35|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+168>>3],+h[l+2072>>3]+ +h[l+3080>>3])|0;a[(c[b+352>>2]|0)+35|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+168>>3],+h[g+2072>>3]+ +h[g+3080>>3])|0;a[(c[b+352>>2]|0)+35|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+36|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+36|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+168>>3],+h[l+2072>>3]- +h[l+3080>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+168>>3],+h[g+2072>>3]- +h[g+3080>>3],a[(c[b+360>>2]|0)+36|0]|0)|0;a[(c[b+352>>2]|0)+36|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+36|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+168>>3],+h[k+2072>>3]- +h[k+3080>>3])|0;a[(c[b+352>>2]|0)+36|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+168>>3],+h[j+2072>>3]- +h[j+3080>>3])|0;a[(c[b+352>>2]|0)+36|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+6|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function Gq(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+6|0]|0)==0){f=0.0;g=b;j=g+2088|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+168>>3]- +h[b+2072>>3];g=b;j=g+2088|0;k=j;h[k>>3]=f;i=d;return}function Hq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2128>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2128|0;h[c[g+4128>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2128>>3]);h[c[(c[f>>2]|0)+4132>>2]>>3]=k;TFa(a,51)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2128>>3]=+h[c[(c[f>>2]|0)+4124>>2]>>3];Vz(a);Wz(a);i=b;return}function Iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2128>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2128>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6056>>3]=+h[f>>3];i=b;return}function Jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2128>>3],+h[a+160>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2128>>3];l=+h[g+160>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6064>>3]=+h[f>>3];i=b;return}function Kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6024>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6024>>3];if(e<<24>>24==0){j=f+160|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+2104|0;p=o;h[p>>3]=m;i=b;return}else{j=(c[a+416>>2]|0)+2888|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+2104|0;p=o;h[p>>3]=m;i=b;return}}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2128>>3],+h[(c[b+416>>2]|0)+2824>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+68|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+68|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[b+360>>2]|0)+68|0]|0)|0;a[(c[b+352>>2]|0)+68|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[b+360>>2]|0)+68|0]|0)|0;a[(c[b+352>>2]|0)+68|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+68|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+68|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+68|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+8|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+8|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+8|0;v=u;a[v]=m;i=d;return}function Mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6024>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6024>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2888|0;k=+h[j>>3];l=g*k;m=f;n=m+2048|0;o=n;h[o>>3]=l;i=b;return}else{j=f+160|0;k=+h[j>>3];l=g*k;m=f;n=m+2048|0;o=n;h[o>>3]=l;i=b;return}}function Nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+2048>>3]+ +h[b+2032>>3];i=i;return}function Oq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+6024>>3],+h[j+6064>>3],+h[j+7448>>3],+h[(c[b+416>>2]|0)+1120>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+6024>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,7040,7032,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+6016|0;q=p;h[q>>3]=n;i=d;return}function Pq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+2936>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+2936>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+6024>>3],+h[d+7456>>3],+h[f>>3],+h[(c[k>>2]|0)+1120>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6040>>3]=+h[g>>3];i=b;return}function Qq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2128>>3],+h[(c[l>>2]|0)+2888>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2128>>3];n=+h[(c[l>>2]|0)+2888>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+6024>>3],+h[d+6056>>3],+h[f>>3],+h[(c[l>>2]|0)+1120>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[g>>3];i=b;return}function Rq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+6024>>3]- +h[b+2376>>3];i=i;return}function Sq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2168>>3]=+h[(c[a+416>>2]|0)+128>>3];i=i;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+39|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+39|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+184>>3],+h[k+2168>>3]+ +h[k+3112>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+184>>3],+h[j+2168>>3]+ +h[j+3112>>3],a[(c[b+360>>2]|0)+39|0]|0)|0;a[(c[b+352>>2]|0)+39|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+39|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+184>>3],+h[l+2168>>3]+ +h[l+3112>>3])|0;a[(c[b+352>>2]|0)+39|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+184>>3],+h[g+2168>>3]+ +h[g+3112>>3])|0;a[(c[b+352>>2]|0)+39|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+40|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+40|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+184>>3],+h[l+2168>>3]- +h[l+3112>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+184>>3],+h[g+2168>>3]- +h[g+3112>>3],a[(c[b+360>>2]|0)+40|0]|0)|0;a[(c[b+352>>2]|0)+40|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+40|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+184>>3],+h[k+2168>>3]- +h[k+3112>>3])|0;a[(c[b+352>>2]|0)+40|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+184>>3],+h[j+2168>>3]- +h[j+3112>>3])|0;a[(c[b+352>>2]|0)+40|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+10|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+10|0;z=y;a[z]=n;i=d;return}function Uq(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+10|0]|0)==0){f=0.0;g=b;j=g+2176|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+184>>3]- +h[b+2168>>3];g=b;j=g+2176|0;k=j;h[k>>3]=f;i=d;return}function Vq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2192|0;h[c[g+4208>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2192>>3]);e=c[f>>2]|0;h[c[e+4212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+5928>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+5928|0;h[(c[e+4208>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+5928>>3]);h[(c[(c[f>>2]|0)+4212>>2]|0)+8>>3]=k;TFa(a,52)|0;j=c[(c[f>>2]|0)+4204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2192>>3]=+h[j>>3];h[f+5928>>3]=+h[j+8>>3];Zz(a);_z(a);$z(a);aA(a);bA(a);cA(a);dA(a);i=b;return}function Wq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+7352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+7352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5896>>3]=+h[f>>3];i=b;return}function Xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+7352>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+7352>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5904>>3]=+h[f>>3];i=b;return}function Yq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4160>>3]=+h[b+5600>>3]- +h[b+5864>>3];i=i;return}function Zq(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2184>>3]=-(+h[e+5864>>3]*+h[(a<<24>>24==0?e+176|0:e+7352|0)>>3]);i=b;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+2200>>3]+ +h[b+2184>>3];i=i;return}function $q(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5864>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2776|0;k=+h[j>>3];l=g*k;m=f;n=m+2144|0;o=n;h[o>>3]=l;i=b;return}else{j=f+3816|0;k=+h[j>>3];l=g*k;m=f;n=m+2144|0;o=n;h[o>>3]=l;i=b;return}}function ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3568>>3]*+h[j+2976>>3]*+h[e+3512>>3];l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,7144,7136,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1552|0;q=p;h[q>>3]=n;i=d;return}function br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3568>>3]*+h[j+2968>>3]*+h[e+3512>>3];l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,7224,7216,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1544|0;q=p;h[q>>3]=n;i=d;return}function cr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1576>>3]=+h[(a?e+2976|0:e+2968|0)>>3];i=b;return}function dr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5864>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1568>>3]=+h[(a?e+2912|0:e+2904|0)>>3];i=b;return}function er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+5864>>3]*+h[(c[a+416>>2]|0)+3520>>3];i=i;return}function fr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+5928>>3],+h[l+176>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+5928>>3];o=+h[m+176>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5864>>3],+h[d+5896>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5880>>3]=+h[g>>3];i=b;return}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2192>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2192>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5912>>3]=+h[f>>3];i=b;return}function hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2192>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2192>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5920>>3]=+h[f>>3];i=b;return}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5864>>3],+h[j+5920>>3],+h[j+5904>>3],+h[(c[b+416>>2]|0)+1232>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5864>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,7304,7296,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5856|0;q=p;h[q>>3]=n;i=d;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2192>>3],+h[(c[b+416>>2]|0)+2712>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+71|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+71|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[b+360>>2]|0)+71|0]|0)|0;a[(c[b+352>>2]|0)+71|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[b+360>>2]|0)+71|0]|0)|0;a[(c[b+352>>2]|0)+71|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+71|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+71|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+71|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+11|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+11|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+11|0;v=u;a[v]=m;i=d;return}function kr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2192>>3],+h[l+7352>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2192>>3];o=+h[m+7352>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5864>>3],+h[d+5912>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1232>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5888>>3]=+h[g>>3];i=b;return}function lr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2224>>3]=+h[(c[a+416>>2]|0)+88>>3];i=i;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+43|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+43|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[k+200>>3],+h[k+2224>>3]+ +h[k+3128>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=l;f=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;l=oFa(+h[j+200>>3],+h[j+2224>>3]+ +h[j+3128>>3],a[(c[b+360>>2]|0)+43|0]|0)|0;a[(c[b+352>>2]|0)+43|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+43|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[l+200>>3],+h[l+2224>>3]+ +h[l+3128>>3])|0;a[(c[b+352>>2]|0)+43|0]=j;f=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;j=sFa(+h[g+200>>3],+h[g+2224>>3]+ +h[g+3128>>3])|0;a[(c[b+352>>2]|0)+43|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+44|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+44|0]|0;l=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[l+200>>3],+h[l+2224>>3]- +h[l+3128>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;m=g;break}else{g=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;k=oFa(+h[g+200>>3],+h[g+2224>>3]- +h[g+3128>>3],a[(c[b+360>>2]|0)+44|0]|0)|0;a[(c[b+352>>2]|0)+44|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+44|0]|0;k=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[k+200>>3],+h[k+2224>>3]- +h[k+3128>>3])|0;a[(c[b+352>>2]|0)+44|0]=g;m=j;break}else{j=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=sFa(+h[j+200>>3],+h[j+2224>>3]- +h[j+3128>>3])|0;a[(c[b+352>>2]|0)+44|0]=g;m=g;break}}}}while(0);if(!(f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}if((a[(c[b+408>>2]|0)+12|0]|0)==0){n=0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+12|0;z=y;a[z]=n;i=d;return}function nr(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+12|0]|0)==0){f=0.0;g=b;j=g+2232|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+200>>3]- +h[b+2224>>3];g=b;j=g+2232|0;k=j;h[k>>3]=f;i=d;return}function or(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2248>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2248|0;h[c[g+4288>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2248>>3]);e=c[f>>2]|0;h[c[e+4292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6008>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6008|0;h[(c[e+4288>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6008>>3]);h[(c[(c[f>>2]|0)+4292>>2]|0)+8>>3]=k;TFa(a,53)|0;j=c[(c[f>>2]|0)+4284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2248>>3]=+h[j>>3];h[f+6008>>3]=+h[j+8>>3];gA(a);hA(a);iA(a);jA(a);kA(a);lA(a);mA(a);i=b;return}function pr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2248>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2248>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5992>>3]=+h[f>>3];i=b;return}function qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2248>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2248>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6e3>>3]=+h[f>>3];i=b;return}function rr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+7360>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+7360>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5976>>3]=+h[f>>3];i=b;return}function sr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+7360>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+7360>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+5984>>3]=+h[f>>3];i=b;return}function tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4296>>3]=+h[b+5672>>3]- +h[b+5944>>3];i=i;return}function ur(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2240>>3]=-(+h[e+5944>>3]*+h[(a<<24>>24==0?e+192|0:e+7360|0)>>3]);i=b;return}function vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4288>>3]=+h[b+2256>>3]+ +h[b+2240>>3];i=i;return}function wr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2248>>3],+h[(c[b+416>>2]|0)+2456>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+73|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+73|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[b+360>>2]|0)+73|0]|0)|0;a[(c[b+352>>2]|0)+73|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[b+360>>2]|0)+73|0]|0)|0;a[(c[b+352>>2]|0)+73|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+73|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+73|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+73|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+13|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+13|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+13|0;v=u;a[v]=m;i=d;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+5944>>3]+(+h[b+5864>>3]+(-+h[b+6024>>3]- +h[b+4944>>3]));i=i;return}function yr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+5944>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+2776|0;k=+h[j>>3];l=g*k;m=f;n=m+2136|0;o=n;h[o>>3]=l;i=b;return}else{j=f+3824|0;k=+h[j>>3];l=g*k;m=f;n=m+2136|0;o=n;h[o>>3]=l;i=b;return}}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+2136>>3]+(+h[b+2144>>3]+(+h[b+2104>>3]+ +h[b+2112>>3]));i=i;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3384>>3]*+h[j+3008>>3]*+h[e+3328>>3];l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,7408,7400,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1616|0;q=p;h[q>>3]=n;i=d;return}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+3384>>3]*+h[j+3e3>>3]*+h[e+3328>>3];l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[b+536>>2]|0,k,7488,7480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+1608|0;q=p;h[q>>3]=n;i=d;return}function Cr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1640>>3]=+h[(a?e+3008|0:e+3e3|0)>>3];i=b;return}function Dr(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+5944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1632>>3]=+h[(a?e+2896|0:e+2888|0)>>3];i=b;return}function Er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+5944>>3]*+h[(c[a+416>>2]|0)+3336>>3];i=i;return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,+h[j+5944>>3],+h[j+6e3>>3],+h[j+5984>>3],+h[(c[b+416>>2]|0)+1176>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+5944>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}r=l/+SBa(c[f>>2]|0,k,7568,7560,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+5936|0;q=p;h[q>>3]=n;i=d;return}function Gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+6008>>3],+h[l+192>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+6008>>3];o=+h[m+192>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+5944>>3],+h[d+5976>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5960>>3]=+h[g>>3];i=b;return}function Hr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2248>>3],+h[l+7360>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2248>>3];o=+h[m+7360>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+5944>>3],+h[d+5992>>3],+h[f>>3],+h[(c[a+416>>2]|0)+1176>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+5968>>3]=+h[g>>3];i=b;return}function Ir(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3632>>3]=+h[b+4720>>3]*+h[d+120>>3]+ +h[b+4728>>3];i=i;return}function Jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3672>>3]=+h[b+3632>>3]*+h[b+3616>>3];i=i;return}function Kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3680>>3]=+h[b+3672>>3]*+h[b+3608>>3];i=i;return}function Lr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+384>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+384|0;h[c[g+4368>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+384>>3]);e=c[f>>2]|0;h[c[e+4372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6776>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6776|0;h[(c[e+4368>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6776>>3]);h[(c[(c[f>>2]|0)+4372>>2]|0)+8>>3]=k;TFa(a,54)|0;j=c[(c[f>>2]|0)+4364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+384>>3]=+h[j>>3];h[f+6776>>3]=+h[j+8>>3];pA(a);qA(a);rA(a);sA(a);i=b;return}function Mr(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+4720>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6552>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7672,7664,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}function Nr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3912>>3]=+h[b+3016>>3]*+h[d+136>>3]+ +h[b+3024>>3];i=i;return}function Or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+3912>>3]*+h[b+3896>>3];i=i;return}function Pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+3952>>3]*+h[b+3888>>3];i=i;return}function Qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+400>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+400|0;h[c[g+4448>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+400>>3]);e=c[f>>2]|0;h[c[e+4452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6768>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6768|0;h[(c[e+4448>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6768>>3]);h[(c[(c[f>>2]|0)+4452>>2]|0)+8>>3]=k;TFa(a,55)|0;j=c[(c[f>>2]|0)+4444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+400>>3]=+h[j>>3];h[f+6768>>3]=+h[j+8>>3];vA(a);wA(a);xA(a);yA(a);i=b;return}function Rr(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+3016>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6544>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7696,7688,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function Sr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3992>>3]=+h[b+2904>>3]*+h[d+152>>3]+ +h[b+2912>>3];i=i;return}function Tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+3992>>3]*+h[b+3984>>3];i=i;return}function Ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+4024>>3]*+h[b+3976>>3];i=i;return}function Vr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+416>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+416|0;h[c[g+4528>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+416>>3]);e=c[f>>2]|0;h[c[e+4532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6760>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6760|0;h[(c[e+4528>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6760>>3]);h[(c[(c[f>>2]|0)+4532>>2]|0)+8>>3]=k;TFa(a,56)|0;j=c[(c[f>>2]|0)+4524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+416>>3]=+h[j>>3];h[f+6760>>3]=+h[j+8>>3];BA(a);CA(a);DA(a);EA(a);i=b;return}function Wr(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2904>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6536>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7720,7712,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}function Xr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4064>>3]=+h[b+2792>>3]*+h[d+168>>3]+ +h[b+2800>>3];i=i;return}function Yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4064>>3]*+h[b+4056>>3];i=i;return}function Zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+4096>>3]*+h[b+4048>>3];i=i;return}function _r(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+432>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+432|0;h[c[g+4608>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+432>>3]);e=c[f>>2]|0;h[c[e+4612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6752>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6752|0;h[(c[e+4608>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6752>>3]);h[(c[(c[f>>2]|0)+4612>>2]|0)+8>>3]=k;TFa(a,57)|0;j=c[(c[f>>2]|0)+4604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+432>>3]=+h[j>>3];h[f+6752>>3]=+h[j+8>>3];HA(a);IA(a);JA(a);KA(a);i=b;return}function $r(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2792>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6528>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7744,7736,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}function as(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4136>>3]=+h[b+2680>>3]*+h[d+184>>3]+ +h[b+2688>>3];i=i;return}function bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4168>>3]=+h[b+4136>>3]*+h[b+4128>>3];i=i;return}function cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4176>>3]=+h[b+4168>>3]*+h[b+4120>>3];i=i;return}function ds(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+448>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+448|0;h[c[g+4688>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+448>>3]);e=c[f>>2]|0;h[c[e+4692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6744>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6744|0;h[(c[e+4688>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6744>>3]);h[(c[(c[f>>2]|0)+4692>>2]|0)+8>>3]=k;TFa(a,58)|0;j=c[(c[f>>2]|0)+4684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+448>>3]=+h[j>>3];h[f+6744>>3]=+h[j+8>>3];NA(a);OA(a);PA(a);QA(a);i=b;return}function es(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2680>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6520>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7768,7760,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+456|0;p=o;h[p>>3]=m;i=d;return}function fs(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4272>>3]=+h[b+2424>>3]*+h[d+200>>3]+ +h[b+2432>>3];i=i;return}function gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4304>>3]=+h[b+4272>>3]*+h[b+4264>>3];i=i;return}function hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4312>>3]=+h[b+4304>>3]*+h[b+4256>>3];i=i;return}function is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+464>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+464|0;h[c[g+4768>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+464>>3]);e=c[f>>2]|0;h[c[e+4772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6736>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6736|0;h[(c[e+4768>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6736>>3]);h[(c[(c[f>>2]|0)+4772>>2]|0)+8>>3]=k;TFa(a,59)|0;j=c[(c[f>>2]|0)+4764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+464>>3]=+h[j>>3];h[f+6736>>3]=+h[j+8>>3];TA(a);UA(a);VA(a);WA(a);i=b;return}function js(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2424>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6512>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7792,7784,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}function ks(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6504>>3]=+h[b+728>>3]*+h[d+264>>3]+ +h[b+744>>3];i=i;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+6504>>3]*+h[b+6432>>3];i=i;return}function ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6496>>3]=+h[b+6440>>3]*+h[b+256>>3]- +h[(c[a+416>>2]|0)+776>>3]*+h[b+6504>>3];i=i;return}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+4844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6560>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6560|0;h[c[g+4848>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6560>>3]);e=c[f>>2]|0;h[c[e+4852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+4844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+528|0;h[(c[e+4848>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+528>>3]);h[(c[(c[f>>2]|0)+4852>>2]|0)+8>>3]=k;TFa(a,60)|0;j=c[(c[f>>2]|0)+4844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+6560>>3]=+h[j>>3];h[f+528>>3]=+h[j+8>>3];ZA(a);_A(a);i=b;return}function os(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+728>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,7816,7808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}function ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+776>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+776>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((pFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[a+416>>2]|0)+736>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8088;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8112,e);i=b;return}function rs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=rFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6464>>3],0.0)|0;if(g<<24>>24==0|(qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[a+416>>2]|0)+792>>3])|0)<<24>>24==0){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8144;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8168,e);i=b;return}function ss(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+248>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+4816>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+232>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2272>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2264>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+2456>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+2456>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2208>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],+h[(c[a+416>>2]|0)+2416>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+200>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function xs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+2712>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+2712>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2152>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],+h[(c[a+416>>2]|0)+2672>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function As(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function Bs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+2824>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+2824>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function Cs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],+h[(c[a+416>>2]|0)+2784>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+168>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function Ds(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4096>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function Es(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+2936>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+2936>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function Fs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],+h[(c[a+416>>2]|0)+2896>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function Gs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function Hs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+3048>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+3048>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function Is(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],+h[(c[a+416>>2]|0)+3008>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function Js(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function Ks(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((sFa(+h[(c[f>>2]|0)+4752>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[f>>2]|0)+4752>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;f=ACa(ACa(g,yCa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3],0,1,6)|0)|0,7920)|0;g=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](g,d,f,e);i=b;return}function Ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((qFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+120>>3],+h[(c[a+416>>2]|0)+4712>>3])|0)<<24>>24==0)){i=b;return}g=ACa(ACa(8216,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+120>>3],0,1,6)|0)|0,8264)|0;f=c[a+536>>2]|0;a=c[72852]|0;j=d;k=8296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ne[a&127](f,d,g,e);i=b;return}function Ms(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((sFa(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3672>>3],0.0)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8320;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8272,e);i=b;return}function Ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3536>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function Os(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1648>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function Ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1656>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function Qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+3112>>3],+h[f+3136>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Rs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+3336>>3],+h[f+3360>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Ss(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+3520>>3],+h[f+3544>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+3704>>3],+h[f+3728>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+3888>>3],+h[f+3912>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+4072>>3],+h[f+4096>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+56>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+896>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function Xs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+904>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function Ys(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+4256>>3],+h[f+4280>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function Zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function _s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((sFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=b;return}g=ACa(ACa(ACa(ACa(7832,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,7848)|0,7872)|0,7888)|0;j=ACa(ACa(g,yCa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+608>>3],0,1,6)|0)|0,7920)|0;f=c[a+536>>2]|0;a=c[72852]|0;g=d;k=8472;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Ne[a&127](f,d,j,e);i=b;return}function $s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((sFa(+h[f+4480>>3],+h[f+4504>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8496;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8416,e);i=b;return}function at(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;if(!((pFa(+h[g+6424>>3],+h[g+7480>>3])|0)<<24>>24==0)){i=b;return}if((rFa(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6464>>3],0.0)|0)<<24>>24==0){i=b;return}if(!((qFa(+U(+(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6488>>3])),.01)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[72852]|0;g=d;j=8520;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ne[a&127](f,d,8544,e);i=b;return}function bt(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);i=c;return 0}function ct(b){b=b|0;var c=0;c=i;a[b+314|0]=0;dt(b);i=c;return 0}function dt(a){a=a|0;var b=0;b=i;jf(a);lf(a);Df(a);Ef(a);Ff(a);Gf(a);If(a);Nf(a);Sf(a);ag(a);gg(a);xg(a);Bg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Pg(a);Xg(a);ch(a);eh(a);fh(a);ih(a);lh(a);oh(a);ph(a);sh(a);vh(a);wh(a);xh(a);zh(a);Oh(a);Ph(a);Th(a);Uh(a);_h(a);bi(a);mi(a);pi(a);qi(a);ti(a);wi(a);xi(a);yi(a);Ai(a);Mi(a);Ni(a);Ri(a);Si(a);vj(a);wj(a);xj(a);Lj(a);Mj(a);Nj(a);$j(a);ak(a);ek(a);hk(a);ik(a);jk(a);ok(a);sk(a);tk(a);uk(a);wk(a);xk(a);yk(a);zk(a);Hk(a);Ik(a);Jk(a);Kk(a);Lk(a);Pk(a);Rk(a);Vk(a);Wk(a);Xk(a);Zk(a);_k(a);$k(a);al(a);il(a);jl(a);kl(a);ll(a);ml(a);ql(a);sl(a);vl(a);wl(a);yl(a);Bl(a);Cl(a);El(a);Hl(a);Il(a);Kl(a);Nl(a);Ol(a);Ql(a);Rl(a);Sl(a);Yl(a);Zl(a);_l(a);$l(a);am(a);bm(a);cm(a);im(a);jm(a);km(a);lm(a);mm(a);pm(a);qm(a);rm(a);um(a);vm(a);wm(a);xm(a);zm(a);Am(a);Bm(a);Dm(a);Fm(a);Gm(a);Im(a);Jm(a);Km(a);Mm(a);Nm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);fn(a);hn(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);qn(a);rn(a);sn(a);un(a);vn(a);wn(a);yn(a);An(a);Bn(a);Dn(a);En(a);Fn(a);Hn(a);In(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);ao(a);fo(a);go(a);ho(a);io(a);ko(a);lo(a);mo(a);oo(a);qo(a);ro(a);to(a);uo(a);vo(a);xo(a);yo(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);So(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);gp(a);hp(a);ip(a);kp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Fp(a);Gp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Zp(a);aq(a);bq(a);hq(a);iq(a);jq(a);kq(a);lq(a);oq(a);pq(a);qq(a);rq(a);sq(a);tq(a);uq(a);Eq(a);Fq(a);Gq(a);Hq(a);Kq(a);Mq(a);Nq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Yq(a);Zq(a);_q(a);$q(a);lr(a);mr(a);nr(a);or(a);tr(a);ur(a);vr(a);xr(a);yr(a);zr(a);Ir(a);Jr(a);Lr(a);Mr(a);Nr(a);Or(a);Qr(a);Rr(a);Sr(a);Tr(a);Vr(a);Wr(a);Xr(a);Yr(a);_r(a);$r(a);as(a);bs(a);ds(a);es(a);fs(a);gs(a);is(a);js(a);ks(a);ls(a);ns(a);os(a);i=b;return}function et(a,b){a=a|0;b=+b;i=i;return 0}function ft(a){a=a|0;var b=0;b=i;i=i+8|0;PBa(c[a+536>>2]|0,(a|0)!=0|0,8792,b);c[a+540>>2]=8600;c[a+84>>2]=8824;c[a+88>>2]=8824;c[a+92>>2]=8888;c[a+96>>2]=8960;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=34;c[a+116>>2]=954;c[a+120>>2]=9;c[a+124>>2]=76;c[a+128>>2]=125;c[a+132>>2]=0;c[a+136>>2]=605;c[a+140>>2]=179;c[a+144>>2]=358;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=913;c[a+220>>2]=46;c[a+224>>2]=228;c[a+228>>2]=0;c[a+160>>2]=60;c[a+104>>2]=0;c[a+164>>2]=102;c[a+168>>2]=1;c[a+176>>2]=119;c[a+180>>2]=0;c[a+184>>2]=119;c[a+188>>2]=0;c[a+56>>2]=9e3;c[a+64>>2]=167;c[a+72>>2]=0;c[a+68>>2]=4288;c[a+192>>2]=1;c[a+196>>2]=4;c[a+200>>2]=61;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Qa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=z5a(c[k>>2]|0,e)|0;if((l|0)==0){gb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=242736;F=242760;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Qa(c[60684]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=z5a(c[F>>2]|0,e)|0;if((G|0)==0){gb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[59828]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=z5a(c[H>>2]|0,e)|0;if((I|0)==0){gb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ia(48,c[59828]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=z5a(c[H>>2]|0,e)|0;if((K|0)==0){gb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;l5a(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=z5a(c[L>>2]|0,e)|0;if((M|0)==0){gb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;l5a(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=z5a(c[I>>2]|0,e)|0;if((N|0)==0){gb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ia(48,c[59828]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=z5a(c[M>>2]|0,e)|0;if((R|0)==0){gb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Qa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=z5a(c[M>>2]|0,e)|0;if((V|0)==0){gb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Qa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=z5a(c[M>>2]|0,e)|0;if((W|0)==0){gb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Sa(34,9080,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=z5a(c[M>>2]|0,e)|0;if((ba|0)==0){gb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=z5a(c[M>>2]|0,e)|0;if((ca|0)==0){gb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=z5a(c[M>>2]|0,e)|0;if((da|0)==0){gb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=z5a(c[M>>2]|0,e)|0;if((ea|0)==0){gb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=z5a(c[h>>2]|0,e)|0;if((fa|0)==0){gb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=z5a(c[h>>2]|0,e)|0;if((ga|0)==0){gb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ia(48,c[59828]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=z5a(c[h>>2]|0,e)|0;if((ha|0)==0){gb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=z5a(c[h>>2]|0,e)|0;if((ia|0)==0){gb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=z5a(c[h>>2]|0,e)|0;if((ja|0)==0){gb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=z5a(c[M>>2]|0,e)|0;if((ka|0)==0){gb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function ht(){var a=0;a=i;yd(0)|0;uc(9240,18,1,c[r>>2]|0)|0;yd(0)|0;i=a;return}function it(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function jt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function kt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;lt(a,b,c,d,0);i=e;return}function lt(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;pv(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));ov(f,0,0.0,0.0,h);i=g;return}function mt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;kt(f,b,d,e,0);l=+h[f>>3];nt(j,b,d,e,0);jt(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function nt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ot(a,b,c,d,0);i=e;return}function ot(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;pv(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));sv(f,0,0.0,0.0,h);i=g;return}function pt(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function qt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];mt(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));pt(j,0,h);i=g;return}function rt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;lt(a,b,c,d,0);i=e;return}function st(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;rt(f,b,d,e,0);l=+h[f>>3];tt(j,b,d,e,0);it(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function tt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ot(a,b,c,d,0);i=e;return}function ut(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function vt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];st(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));ut(j,0,h);i=g;return}function wt(a,b,c){a=a|0;b=b|0;c=+c;b=i;h[a>>3]=+xd(+c,1.0e-10);i=b;return}function xt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function yt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;lt(a,b,c,d,0);i=e;return}function zt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;yt(f,b,d,e,0);l=+h[f>>3];At(j,b,d,e,0);xt(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function At(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ot(a,b,c,d,0);i=e;return}function Bt(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Ct(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];zt(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));Bt(j,0,h);i=g;return}function Dt(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;j=g;k=g+24|0;l=d-e;if(d>=e){m=a;n=m;h[n>>3]=l;i=g;return}o=c[72852]|0;p=j;q=9336;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];c[p+16>>2]=c[q+16>>2];c[p+20>>2]=c[q+20>>2];Ne[o&127](b,j,f,k);m=a;n=m;h[n>>3]=l;i=g;return}function Et(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function Ft(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function Gt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;lt(a,b,c,d,0);i=e;return}function Ht(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;Gt(f,b,d,e,0);l=+h[f>>3];It(j,b,d,e,0);Ft(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function It(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ot(a,b,c,d,0);i=e;return}function Jt(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Kt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Ht(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));Jt(j,0,h);i=g;return}



function GLa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Yb=i;i=i+8|0;Zb=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;QLa(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){QBa(0,288432,n)}if(p){ec=Ed(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;MBa(23,0,288576,m);RLa(q);SLa(q,e,8);if(!(TLa(q)|0)){c[l>>2]=e;QBa(0,288616,l)}tWa(r);l=q;ULa(l,r)|0;vWa(s,r);while(1){e=ULa(l,r)|0;if(!(pXa(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}oXa(t,288696,r);WWa(s,t)|0;FWa(t)}t=Ed(aXa(s)|0)|0;VLa(q);FWa(s);FWa(r);WLa(q);fc=t}if((fc|0)==0){MBa(23,0,288784,g);YLa(o);i=f;return}tWa(u);tWa(v);c[k>>2]=fc;MBa(23,0,288704,k);k=_b(fc|0,288696)|0;if((k|0)!=0){g=k;do{k=Q4a(12)|0;zWa(k,g);t=bXa(k,288736,0)|0;$Wa(w,k,0,t);GWa(u,w)|0;FWa(w);$Wa(x,k,t+1|0,(MWa(k)|0)+~t|0);GWa(v,x)|0;FWa(x);GWa(oLa(o,u)|0,v)|0;t=aXa(u)|0;k=aXa(v)|0;c[j>>2]=t;c[j+4>>2]=k;MBa(23,0,288744,j);g=_b(0,288696)|0;}while((g|0)!=0)}L4a(fc);fc=a+12|0;zWa(y,286832);g=oLa(fc,y)|0;zWa(z,286832);if((XLa(o,z)|0)==0){zWa(B,286832);gc=1;hc=0;ic=oLa(fc,B)|0}else{zWa(A,286832);gc=0;hc=1;ic=oLa(o,A)|0}GWa(g,ic)|0;if(gc){FWa(B)}if(hc){FWa(A)}FWa(z);FWa(y);zWa(C,286704);y=oLa(fc,C)|0;zWa(D,286704);if((XLa(o,D)|0)==0){zWa(F,286704);jc=1;kc=0;lc=oLa(fc,F)|0}else{zWa(E,286704);jc=0;kc=1;lc=oLa(o,E)|0}GWa(y,lc)|0;if(jc){FWa(F)}if(kc){FWa(E)}FWa(D);FWa(C);zWa(G,286736);C=oLa(fc,G)|0;zWa(H,286736);if((XLa(o,H)|0)==0){zWa(J,286736);mc=1;nc=0;oc=oLa(fc,J)|0}else{zWa(I,286736);mc=0;nc=1;oc=oLa(o,I)|0}GWa(C,oc)|0;if(mc){FWa(J)}if(nc){FWa(I)}FWa(H);FWa(G);zWa(K,286768);G=oLa(fc,K)|0;zWa(L,286768);if((XLa(o,L)|0)==0){zWa(N,286768);pc=0;qc=1;rc=oLa(fc,N)|0}else{zWa(M,286768);pc=1;qc=0;rc=oLa(o,M)|0}GWa(G,rc)|0;if(qc){FWa(N)}if(pc){FWa(M)}FWa(L);FWa(K);zWa(O,286800);K=oLa(fc,O)|0;zWa(P,286800);if((XLa(o,P)|0)==0){zWa(R,286800);sc=1;tc=0;uc=oLa(fc,R)|0}else{zWa(Q,286800);sc=0;tc=1;uc=oLa(o,Q)|0}GWa(K,uc)|0;if(sc){FWa(R)}if(tc){FWa(Q)}FWa(P);FWa(O);zWa(S,286864);O=oLa(fc,S)|0;zWa(T,286864);if((XLa(o,T)|0)==0){zWa(V,286864);vc=1;wc=0;xc=oLa(fc,V)|0}else{zWa(U,286864);vc=0;wc=1;xc=oLa(o,U)|0}GWa(O,xc)|0;if(vc){FWa(V)}if(wc){FWa(U)}FWa(T);FWa(S);zWa(W,286904);S=oLa(fc,W)|0;zWa(X,286904);if((XLa(o,X)|0)==0){zWa(Z,286904);yc=1;zc=0;Ac=oLa(fc,Z)|0}else{zWa(Y,286904);yc=0;zc=1;Ac=oLa(o,Y)|0}GWa(S,Ac)|0;if(yc){FWa(Z)}if(zc){FWa(Y)}FWa(X);FWa(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=HLa(Y,_)|0;zWa($,285808);Ac=oLa(yc,$)|0;c[aa>>2]=Z;yc=HLa(Y,aa)|0;zWa(ba,285664);if((XLa(o,oLa(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=HLa(Y,ea)|0;zWa(fa,285808);Bc=1;Cc=0;Dc=oLa(yc,fa)|0}else{c[ca>>2]=Z;yc=HLa(Y,ca)|0;zWa(da,285664);Bc=0;Cc=1;Dc=oLa(o,oLa(yc,da)|0)|0}GWa(Ac,Dc)|0;if(Bc){FWa(fa)}if(Cc){FWa(da)}FWa(ba);FWa($);c[ga>>2]=Z;Ac=HLa(zc,ga)|0;zWa(ha,285808);yc=oLa(Ac,ha)|0;c[ia>>2]=Z;Ac=HLa(zc,ia)|0;zWa(ja,285664);if((XLa(o,oLa(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=HLa(zc,ma)|0;zWa(na,285808);Ec=1;Fc=0;Gc=oLa(Ac,na)|0}else{c[ka>>2]=Z;Ac=HLa(zc,ka)|0;zWa(la,285664);Ec=0;Fc=1;Gc=oLa(o,oLa(Ac,la)|0)|0}GWa(yc,Gc)|0;if(Ec){FWa(na)}if(Fc){FWa(la)}FWa(ja);FWa(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=HLa(Hc,oa)|0;zWa(pa,285808);ja=oLa(ha,pa)|0;c[qa>>2]=Z;ha=HLa(Hc,qa)|0;zWa(ra,285664);if((XLa(o,oLa(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=HLa(Hc,ua)|0;zWa(va,285808);Ic=1;Jc=0;Kc=oLa(ha,va)|0}else{c[sa>>2]=Z;ha=HLa(Hc,sa)|0;zWa(ta,285664);Ic=0;Jc=1;Kc=oLa(o,oLa(ha,ta)|0)|0}GWa(ja,Kc)|0;if(Ic){FWa(va)}if(Jc){FWa(ta)}FWa(ra);FWa(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=HLa(X,wa)|0;zWa(xa,285808);ra=oLa(pa,xa)|0;c[ya>>2]=Z;pa=HLa(X,ya)|0;zWa(za,285664);if((XLa(o,oLa(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=HLa(X,Ca)|0;zWa(Da,285808);Lc=1;Mc=0;Nc=oLa(pa,Da)|0}else{c[Aa>>2]=Z;pa=HLa(X,Aa)|0;zWa(Ba,285664);Lc=0;Mc=1;Nc=oLa(o,oLa(pa,Ba)|0)|0}GWa(ra,Nc)|0;if(Lc){FWa(Da)}if(Mc){FWa(Ba)}FWa(za);FWa(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=HLa(Z,Ea)|0;zWa(Fa,285808);Ba=oLa(za,Fa)|0;c[Ga>>2]=xa;za=HLa(Z,Ga)|0;zWa(Ha,285664);if((XLa(o,oLa(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=HLa(Z,Ka)|0;zWa(La,285808);Oc=1;Pc=0;Qc=oLa(za,La)|0}else{c[Ia>>2]=xa;za=HLa(Z,Ia)|0;zWa(Ja,285664);Oc=0;Pc=1;Qc=oLa(o,oLa(za,Ja)|0)|0}GWa(Ba,Qc)|0;if(Oc){FWa(La)}if(Pc){FWa(Ja)}FWa(Ha);FWa(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=HLa(xa,Ma)|0;zWa(Na,285808);Ja=oLa(Ha,Na)|0;c[Oa>>2]=Fa;Ha=HLa(xa,Oa)|0;zWa(Pa,285664);if((XLa(o,oLa(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=HLa(xa,Sa)|0;zWa(Ta,285808);Rc=1;Sc=0;Tc=oLa(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=HLa(xa,Qa)|0;zWa(Ra,285664);Rc=0;Sc=1;Tc=oLa(o,oLa(Ha,Ra)|0)|0}GWa(Ja,Tc)|0;if(Rc){FWa(Ta)}if(Sc){FWa(Ra)}FWa(Pa);FWa(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=HLa(Fa,Ua)|0;zWa(Va,285808);Ra=oLa(Pa,Va)|0;c[Wa>>2]=Na;Pa=HLa(Fa,Wa)|0;zWa(Xa,285664);if((XLa(o,oLa(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=HLa(Fa,_a)|0;zWa($a,285808);Uc=1;Vc=0;Wc=oLa(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=HLa(Fa,Ya)|0;zWa(Za,285664);Uc=0;Vc=1;Wc=oLa(o,oLa(Pa,Za)|0)|0}GWa(Ra,Wc)|0;if(Uc){FWa($a)}if(Vc){FWa(Za)}FWa(Xa);FWa(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=HLa(Na,ab)|0;zWa(bb,285808);Za=oLa(Xa,bb)|0;c[cb>>2]=Va;Xa=HLa(Na,cb)|0;zWa(db,285664);if((XLa(o,oLa(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=HLa(Na,gb)|0;zWa(hb,285808);Xc=1;Yc=0;Zc=oLa(Xa,hb)|0}else{c[eb>>2]=Va;Xa=HLa(Na,eb)|0;zWa(fb,285664);Xc=0;Yc=1;Zc=oLa(o,oLa(Xa,fb)|0)|0}GWa(Za,Zc)|0;if(Xc){FWa(hb)}if(Yc){FWa(fb)}FWa(db);FWa(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=HLa(Va,ib)|0;zWa(jb,285808);fb=oLa(db,jb)|0;c[kb>>2]=bb;db=HLa(Va,kb)|0;zWa(lb,285664);if((XLa(o,oLa(db,lb)|0)|0)==0){c[ob>>2]=bb;db=HLa(Va,ob)|0;zWa(pb,285808);_c=1;$c=0;ad=oLa(db,pb)|0}else{c[mb>>2]=bb;db=HLa(Va,mb)|0;zWa(nb,285664);_c=0;$c=1;ad=oLa(o,oLa(db,nb)|0)|0}GWa(fb,ad)|0;if(_c){FWa(pb)}if($c){FWa(nb)}FWa(lb);FWa(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=HLa(bb,qb)|0;zWa(rb,285808);nb=oLa(lb,rb)|0;c[sb>>2]=jb;lb=HLa(bb,sb)|0;zWa(tb,285664);if((XLa(o,oLa(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=HLa(bb,wb)|0;zWa(xb,285808);bd=1;cd=0;dd=oLa(lb,xb)|0}else{c[ub>>2]=jb;lb=HLa(bb,ub)|0;zWa(vb,285664);bd=0;cd=1;dd=oLa(o,oLa(lb,vb)|0)|0}GWa(nb,dd)|0;if(bd){FWa(xb)}if(cd){FWa(vb)}FWa(tb);FWa(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=HLa(jb,yb)|0;zWa(zb,285808);vb=oLa(tb,zb)|0;c[Ab>>2]=rb;tb=HLa(jb,Ab)|0;zWa(Bb,285664);if((XLa(o,oLa(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=HLa(jb,Eb)|0;zWa(Fb,285808);ed=1;fd=0;gd=oLa(tb,Fb)|0}else{c[Cb>>2]=rb;tb=HLa(jb,Cb)|0;zWa(Db,285664);ed=0;fd=1;gd=oLa(o,oLa(tb,Db)|0)|0}GWa(vb,gd)|0;if(ed){FWa(Fb)}if(fd){FWa(Db)}FWa(Bb);FWa(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=HLa(rb,Gb)|0;zWa(Hb,285808);Db=oLa(Bb,Hb)|0;c[Ib>>2]=zb;Bb=HLa(rb,Ib)|0;zWa(Jb,285664);if((XLa(o,oLa(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=HLa(rb,Mb)|0;zWa(Nb,285808);hd=0;id=1;jd=oLa(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=HLa(rb,Kb)|0;zWa(Lb,285664);hd=1;id=0;jd=oLa(o,oLa(Bb,Lb)|0)|0}GWa(Db,jd)|0;if(id){FWa(Nb)}if(hd){FWa(Lb)}FWa(Jb);FWa(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=HLa(zb,Ob)|0;zWa(Pb,285808);Lb=oLa(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=HLa(zb,Qb)|0;zWa(Rb,285664);if((XLa(o,oLa(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=HLa(zb,Ub)|0;zWa(Vb,285808);kd=1;ld=0;md=oLa(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=HLa(zb,Sb)|0;zWa(Tb,285664);kd=0;ld=1;md=oLa(o,oLa(Jb,Tb)|0)|0}GWa(Lb,md)|0;if(kd){FWa(Vb)}if(ld){FWa(Tb)}FWa(Rb);FWa(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=HLa(b,Wb)|0;zWa(Xb,285808);Pb=oLa(Hb,Xb)|0;c[Yb>>2]=a;Hb=HLa(b,Yb)|0;zWa(Zb,285664);if((XLa(o,oLa(Hb,Zb)|0)|0)==0){c[bc>>2]=a;Hb=HLa(b,bc)|0;zWa(cc,285808);nd=1;od=0;pd=oLa(Hb,cc)|0}else{c[$b>>2]=a;Hb=HLa(b,$b)|0;zWa(ac,285664);nd=0;od=1;pd=oLa(o,oLa(Hb,ac)|0)|0}GWa(Pb,pd)|0;if(nd){FWa(cc)}if(od){FWa(ac)}FWa(Zb);FWa(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}MBa(23,0,288768,h);FWa(v);FWa(u);YLa(o);i=f;return}function HLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=mOa(a,f,b)|0;l=c[k>>2]|0;_Ha(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}oOa(j,a,b);pOa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];nOa(g,e);qOa(j);j=c[f>>2]|0;rOa(a,j,k,sOa(g)|0);k=tOa(g)|0;qOa(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function ILa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=QMa(a,f,b)|0;l=c[k>>2]|0;_Ha(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}SMa(j,a,b);TMa(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];RMa(g,e);UMa(j);j=c[f>>2]|0;VMa(a,j,k,WMa(g)|0);k=XMa(g)|0;UMa(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function JLa(a,b){a=a|0;b=b|0;var c=0;c=i;GWa(b,a)|0;i=c;return}function KLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;HMa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];zMa(a,f);i=e;return}function LLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xMa(a,b)|0;i=c;return d|0}function MLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;AMa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];zMa(a,e);i=d;return}function NLa(a){a=a|0;var b=0,c=0;b=i;c=uMa(a)|0;i=b;return c|0}function OLa(a){a=a|0;var b=0;b=i;TQa(a);i=b;return}function PLa(a){a=a|0;var b=0;b=i;GQa(a);i=b;return}function QLa(a,b){a=a|0;b=b|0;b=i;nPa(a,0);i=b;return}function RLa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;CXa(d);e=a;c[e>>2]=288836;f=d;c[f>>2]=288856;d=a+8|0;uYa(a,288868|0,d);c[e>>2]=288836;c[f>>2]=288856;HKa(d);i=b;return}function SLa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(gIa(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){tXa(d,4);i=e;return}else{rXa(d,0);i=e;return}}function TLa(a){a=a|0;var b=0,c=0;b=i;c=pMa(a+8|0)|0;i=b;return c|0}function ULa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=oMa(a,b,AXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function VLa(a){a=a|0;var b=0;b=i;if((iIa(a+8|0)|0)!=0){i=b;return}tXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function WLa(a){a=a|0;var b=0;b=i;tMa(a,288864);xXa(a+108|0);i=b;return}function XLa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ZLa(a,b)|0;i=c;return d|0}function YLa(a){a=a|0;var b=0;b=i;vQa(a);i=b;return}function ZLa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=$La(a)|0;_Ha(e);if((f|0)==0){g=0;i=d;return g|0}h=aMa(a)|0;a=f;while(1){f=a+16|0;if(bMa(h,b,f)|0){j=a}else{if(!(cMa(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;_Ha(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function _La(a){a=a|0;var b=0,c=0;b=i;c=LHa(iMa(a+4|0)|0)|0;i=b;return c|0}function $La(a){a=a|0;var b=0,d=0;b=i;d=c[(_La(a)|0)>>2]|0;i=b;return d|0}function aMa(a){a=a|0;var b=0,c=0;b=i;c=gMa(a+8|0)|0;i=b;return c|0}function bMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dMa(0,b,c)|0;i=a;return d|0}function cMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dMa(0,b,c)|0;i=a;return d|0}function dMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=eMa(b,c)|0;i=a;return d|0}function eMa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(cXa(a,b)|0)<0;i=c;return d|0}function fMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=h5a(a,b,c)|0;i=d;return e|0}function gMa(a){a=a|0;var b=0,c=0;b=i;c=hMa(a)|0;i=b;return c|0}function hMa(a){a=a|0;i=i;return a|0}function iMa(a){a=a|0;var b=0,c=0;b=i;c=jMa(a)|0;i=b;return c|0}function jMa(a){a=a|0;i=i;return a|0}function kMa(a,b){a=a|0;b=b|0;var c=0;a=i;c=mMa(0,b,0)|0;i=a;return c|0}function lMa(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function mMa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Q4a(b)|0;i=c;return a|0}function nMa(a){a=a|0;var b=0,c=0;b=i;c=m5a(a|0)|0;i=b;return c|0}function oMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;zYa(f,a,1);if(!(CYa(f)|0)){i=e;return a|0}VWa(b);f=0;while(1){g=IXa(yXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(UIa(g,-1)|0){h=2;j=f;break}k=f+1|0;l=VIa(g)|0;if(ZIa(l,d)|0){h=0;j=k;break}XWa(b,l);if((DWa(b)|0)==-17){h=4;j=k;break}else{f=k}}tXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function pMa(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function qMa(a){a=a|0;var b=0;b=i;WLa(a);S4a(a);i=b;return}function rMa(a){a=a|0;var b=0;b=i;WLa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function sMa(a){a=a|0;var b=0;b=i;qMa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function tMa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];IIa(a+8|0);i=d;return}function uMa(a){a=a|0;var b=0,d=0;b=i;d=vMa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function vMa(a){a=a|0;var b=0,c=0;b=i;c=wMa(a)|0;i=b;return c|0}function wMa(a){a=a|0;i=i;return a|0}function xMa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yMa(a,b)|0)^1;i=c;return d|0}function yMa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function zMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];GMa(a,e);i=d;return}function AMa(a,b){a=a|0;b=b|0;var c=0;c=i;BMa(a,CMa(b)|0);i=c;return}function BMa(a,b){a=a|0;b=b|0;var c=0;c=i;FMa(a,b);i=c;return}function CMa(a){a=a|0;var b=0,c=0;b=i;c=LHa(DMa(a+4|0)|0)|0;i=b;return c|0}function DMa(a){a=a|0;var b=0,c=0;b=i;c=EMa(a)|0;i=b;return c|0}function EMa(a){a=a|0;i=i;return a|0}function FMa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function GMa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function HMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=JMa(b)|0;IMa(f,b,d,h,CMa(b)|0);AMa(g,b);do{if(xMa(f,g)|0){h=KMa(b)|0;if(LMa(h,d,MMa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);AMa(a,b);i=e;return}function IMa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;_Ha(h);a:do{if((e|0)==0){j=f}else{k=KMa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(PMa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;_Ha(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;_Ha(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);BMa(a,j);i=g;return}function JMa(a){a=a|0;var b=0,d=0;b=i;d=c[(CMa(a)|0)>>2]|0;i=b;return d|0}function KMa(a){a=a|0;var b=0,c=0;b=i;c=NMa(a+8|0)|0;i=b;return c|0}function LMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dMa(0,b,c)|0;i=a;return d|0}function MMa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function NMa(a){a=a|0;var b=0,c=0;b=i;c=OMa(a)|0;i=b;return c|0}function OMa(a){a=a|0;i=i;return a|0}function PMa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dMa(0,b,c)|0;i=a;return d|0}function QMa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=JMa(h)|0;_Ha(e);if((a|0)==0){j=CMa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(dMa(0,d,a)|0){m=l;j=c[m>>2]|0;_Ha(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(dMa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;_Ha(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function RMa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];MNa(a,e);i=d;return}function SMa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=rNa(d)|0;d=tNa(n,1)|0;uNa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];sNa(j,d,h);vNa(0,kNa((wNa(j)|0)+16|0)|0,e);e=xNa(j)|0;a[e+4|0]=1;yNa(0,iNa((wNa(j)|0)+28|0)|0);a[e+5|0]=1;zNa(m,j);TMa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];RMa(b,g);UMa(m);UMa(j);i=f;return}function TMa(a,b){a=a|0;b=b|0;var c=0;c=i;pNa(a,b);i=c;return}function UMa(a){a=a|0;var b=0;b=i;eNa(a);i=b;return}function VMa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;_Ha(f);c[e>>2]=0;_Ha(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=aNa(a)|0;b=c[c[e>>2]>>2]|0;_Ha(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(CMa(a)|0)>>2]|0;KJa(e,c[d>>2]|0);d=bNa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function WMa(a){a=a|0;var b=0,d=0;b=i;d=c[(_Ma(a)|0)>>2]|0;i=b;return d|0}function XMa(a){a=a|0;var b=0,d=0;b=i;d=YMa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function YMa(a){a=a|0;var b=0,c=0;b=i;c=ZMa(a)|0;i=b;return c|0}function ZMa(a){a=a|0;i=i;return a|0}function _Ma(a){a=a|0;var b=0,c=0;b=i;c=$Ma(a)|0;i=b;return c|0}function $Ma(a){a=a|0;i=i;return a|0}function aNa(a){a=a|0;i=i;return a|0}function bNa(a){a=a|0;var b=0,c=0;b=i;c=cNa(a+8|0)|0;i=b;return c|0}function cNa(a){a=a|0;var b=0,c=0;b=i;c=dNa(a)|0;i=b;return c|0}function dNa(a){a=a|0;i=i;return a|0}function eNa(a){a=a|0;var b=0;b=i;fNa(a,0);i=b;return}function fNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=YMa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}hNa(gNa(e)|0,f);i=d;return}function gNa(a){a=a|0;var b=0,c=0;b=i;c=oNa(a)|0;i=b;return c|0}function hNa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;jNa(f,kNa(d+16|0)|0)}if((d|0)==0){i=e;return}lNa(c[b>>2]|0,d,1);i=e;return}function iNa(a){a=a|0;i=i;return a|0}function jNa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;nNa(d,0,c);i=b;return}function kNa(a){a=a|0;i=i;return a|0}function lNa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;mNa(0,b,0);i=c;return}function mNa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;S4a(b);i=c;return}function nNa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;FWa(c);i=b;return}function oNa(a){a=a|0;i=i;return a+4|0}function pNa(a,b){a=a|0;b=b|0;var c=0;c=i;qNa(a,b);i=c;return}function qNa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function rNa(a){a=a|0;var b=0,c=0;b=i;c=KNa(a+4|0)|0;i=b;return c|0}function sNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];CNa(a,b,f);i=e;return}function tNa(a,b){a=a|0;b=b|0;var c=0;a=i;c=BNa(0,b,0)|0;i=a;return c|0}function uNa(a,b){a=a|0;b=b|0;var c=0;c=i;ANa(a,b);i=c;return}function vNa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}vWa(b,c);i=a;return}function wNa(a){a=a|0;var b=0,d=0;b=i;d=c[(_Ma(a)|0)>>2]|0;i=b;return d|0}function xNa(a){a=a|0;var b=0,c=0;b=i;c=gNa(a)|0;i=b;return c|0}function yNa(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function zNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;pNa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];RMa(h,f);TMa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];RMa(a,e);UMa(h);i=d;return}function ANa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function BNa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Q4a(b<<5)|0;i=c;return a|0}function CNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(ENa(g)|0)>>2]|0;g=FNa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];DNa(b,a,f);i=e;return}function DNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];GNa(a,b,f);i=e;return}function ENa(a){a=a|0;i=i;return a|0}function FNa(a){a=a|0;i=i;return a|0}function GNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(INa(g)|0)>>2]|0;g=JNa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];HNa(b,a,f);i=e;return}function HNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(INa(f)|0)>>2];f=JNa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function INa(a){a=a|0;i=i;return a|0}function JNa(a){a=a|0;i=i;return a|0}function KNa(a){a=a|0;var b=0,c=0;b=i;c=LNa(a)|0;i=b;return c|0}function LNa(a){a=a|0;i=i;return a|0}function MNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=XMa(NNa(b)|0)|0;h=JNa(xNa(NNa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];DNa(g,a,e);i=d;return}function NNa(a){a=a|0;i=i;return c[a>>2]|0}function ONa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function PNa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];WNa(a,e);i=d;return}function QNa(a,b){a=a|0;b=b|0;var c=0;c=i;RNa(a,SNa(b)|0);i=c;return}function RNa(a,b){a=a|0;b=b|0;var c=0;c=i;VNa(a,b);i=c;return}function SNa(a){a=a|0;var b=0,c=0;b=i;c=LHa(TNa(a+4|0)|0)|0;i=b;return c|0}function TNa(a){a=a|0;var b=0,c=0;b=i;c=UNa(a)|0;i=b;return c|0}function UNa(a){a=a|0;i=i;return a|0}function VNa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function WNa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function XNa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=ZNa(b)|0;YNa(f,b,d,h,SNa(b)|0);QNa(g,b);do{if(_Na(f,g)|0){h=$Na(b)|0;if(bMa(h,d,aOa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);QNa(a,b);i=e;return}function YNa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;_Ha(h);a:do{if((e|0)==0){j=f}else{k=$Na(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(cMa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;_Ha(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;_Ha(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);RNa(a,j);i=g;return}function ZNa(a){a=a|0;var b=0,d=0;b=i;d=c[(SNa(a)|0)>>2]|0;i=b;return d|0}function _Na(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ONa(a,b)|0)^1;i=c;return d|0}function $Na(a){a=a|0;var b=0,c=0;b=i;c=bOa(a+8|0)|0;i=b;return c|0}function aOa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function bOa(a){a=a|0;var b=0,c=0;b=i;c=cOa(a)|0;i=b;return c|0}function cOa(a){a=a|0;i=i;return a|0}function dOa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;eOa(a,b);i=b;return}function eOa(a,b){a=a|0;b=b|0;b=i;fOa(a,0);i=b;return}function fOa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;gOa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;hOa(f,0,e);e=CMa(b)|0;c[(aNa(b)|0)>>2]=e;i=d;return}function gOa(a){a=a|0;var b=0;b=i;kOa(a);i=b;return}function hOa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;iOa(b,c,f);i=e;return}function iOa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(CKa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;jOa(d,b,f);i=e;return}function jOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(CKa(e)|0)>>2];i=d;return}function kOa(a){a=a|0;var b=0;b=i;lOa(a);i=b;return}function lOa(a){a=a|0;var b=0;b=i;FKa(a);i=b;return}function mOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=mPa(h)|0;_Ha(e);if((a|0)==0){j=zOa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(XHa(0,d,a)|0){m=l;j=c[m>>2]|0;_Ha(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(XHa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;_Ha(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function nOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];kPa(a,e);i=d;return}function oOa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=ROa(d)|0;d=TOa(n,1)|0;UOa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];SOa(j,d,h);VOa(0,WJa((WOa(j)|0)+16|0)|0,e);e=XOa(j)|0;a[e+4|0]=1;YOa(0,KOa((WOa(j)|0)+20|0)|0);a[e+5|0]=1;ZOa(m,j);pOa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];nOa(b,g);qOa(m);qOa(j);i=f;return}function pOa(a,b){a=a|0;b=b|0;var c=0;c=i;POa(a,b);i=c;return}function qOa(a){a=a|0;var b=0;b=i;FOa(a);i=b;return}function rOa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;_Ha(f);c[e>>2]=0;_Ha(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=yOa(a)|0;b=c[c[e>>2]>>2]|0;_Ha(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(zOa(a)|0)>>2]|0;KJa(e,c[d>>2]|0);d=AOa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function sOa(a){a=a|0;var b=0,d=0;b=i;d=c[(wOa(a)|0)>>2]|0;i=b;return d|0}function tOa(a){a=a|0;var b=0,d=0;b=i;d=uOa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function uOa(a){a=a|0;var b=0,c=0;b=i;c=vOa(a)|0;i=b;return c|0}function vOa(a){a=a|0;i=i;return a|0}function wOa(a){a=a|0;var b=0,c=0;b=i;c=xOa(a)|0;i=b;return c|0}function xOa(a){a=a|0;i=i;return a|0}function yOa(a){a=a|0;i=i;return a|0}function zOa(a){a=a|0;var b=0,c=0;b=i;c=LHa(DOa(a+4|0)|0)|0;i=b;return c|0}function AOa(a){a=a|0;var b=0,c=0;b=i;c=BOa(a+8|0)|0;i=b;return c|0}function BOa(a){a=a|0;var b=0,c=0;b=i;c=COa(a)|0;i=b;return c|0}function COa(a){a=a|0;i=i;return a|0}function DOa(a){a=a|0;var b=0,c=0;b=i;c=EOa(a)|0;i=b;return c|0}function EOa(a){a=a|0;i=i;return a|0}function FOa(a){a=a|0;var b=0;b=i;GOa(a,0);i=b;return}function GOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=uOa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}IOa(HOa(e)|0,f);i=d;return}function HOa(a){a=a|0;var b=0,c=0;b=i;c=OOa(a)|0;i=b;return c|0}function IOa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;JOa(f,KOa(d+20|0)|0)}if((d|0)==0){i=e;return}LOa(c[b>>2]|0,d,1);i=e;return}function JOa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;NOa(d,0,c);i=b;return}function KOa(a){a=a|0;i=i;return a|0}function LOa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MOa(0,b,0);i=c;return}function MOa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;S4a(b);i=c;return}function NOa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;YLa(c);i=b;return}function OOa(a){a=a|0;i=i;return a+4|0}function POa(a,b){a=a|0;b=b|0;var c=0;c=i;QOa(a,b);i=c;return}function QOa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function ROa(a){a=a|0;var b=0,c=0;b=i;c=iPa(a+4|0)|0;i=b;return c|0}function SOa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];aPa(a,b,f);i=e;return}function TOa(a,b){a=a|0;b=b|0;var c=0;a=i;c=$Oa(0,b,0)|0;i=a;return c|0}function UOa(a,b){a=a|0;b=b|0;var c=0;c=i;_Oa(a,b);i=c;return}function VOa(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function WOa(a){a=a|0;var b=0,d=0;b=i;d=c[(wOa(a)|0)>>2]|0;i=b;return d|0}function XOa(a){a=a|0;var b=0,c=0;b=i;c=HOa(a)|0;i=b;return c|0}function YOa(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}QLa(b,a);i=a;return}function ZOa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;POa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];nOa(h,f);pOa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];nOa(a,e);qOa(h);i=d;return}function _Oa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function $Oa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Q4a(b<<5)|0;i=c;return a|0}function aPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(cPa(g)|0)>>2]|0;g=dPa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];bPa(b,a,f);i=e;return}function bPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ePa(a,b,f);i=e;return}function cPa(a){a=a|0;i=i;return a|0}function dPa(a){a=a|0;i=i;return a|0}function ePa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(gPa(g)|0)>>2]|0;g=hPa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fPa(b,a,f);i=e;return}function fPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(gPa(f)|0)>>2];f=hPa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function gPa(a){a=a|0;i=i;return a|0}function hPa(a){a=a|0;i=i;return a|0}function iPa(a){a=a|0;var b=0,c=0;b=i;c=jPa(a)|0;i=b;return c|0}function jPa(a){a=a|0;i=i;return a|0}function kPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=tOa(lPa(b)|0)|0;h=hPa(XOa(lPa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];bPa(g,a,e);i=d;return}function lPa(a){a=a|0;i=i;return c[a>>2]|0}function mPa(a){a=a|0;var b=0,d=0;b=i;d=c[(zOa(a)|0)>>2]|0;i=b;return d|0}function nPa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;oPa(a,b);i=b;return}function oPa(a,b){a=a|0;b=b|0;b=i;pPa(a,0);i=b;return}function pPa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;qPa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;rPa(f,0,e);e=SNa(b)|0;c[(sPa(b)|0)>>2]=e;i=d;return}function qPa(a){a=a|0;var b=0;b=i;vPa(a);i=b;return}function rPa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;tPa(b,c,f);i=e;return}function sPa(a){a=a|0;i=i;return a|0}function tPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(CKa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;uPa(d,b,f);i=e;return}function uPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(CKa(e)|0)>>2];i=d;return}function vPa(a){a=a|0;var b=0;b=i;wPa(a);i=b;return}function wPa(a){a=a|0;var b=0;b=i;FKa(a);i=b;return}function xPa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=ZNa(h)|0;_Ha(e);if((a|0)==0){j=SNa(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(dMa(0,d,a)|0){m=l;j=c[m>>2]|0;_Ha(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(dMa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;_Ha(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function yPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tQa(a,e);i=d;return}function zPa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=_Pa(d)|0;d=aQa(n,1)|0;bQa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];$Pa(j,d,h);cQa(0,kNa((dQa(j)|0)+16|0)|0,e);e=eQa(j)|0;a[e+4|0]=1;fQa(0,RPa((dQa(j)|0)+28|0)|0);a[e+5|0]=1;gQa(m,j);APa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];yPa(b,g);BPa(m);BPa(j);i=f;return}function APa(a,b){a=a|0;b=b|0;var c=0;c=i;YPa(a,b);i=c;return}function BPa(a){a=a|0;var b=0;b=i;MPa(a);i=b;return}function CPa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;_Ha(f);c[e>>2]=0;_Ha(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sPa(a)|0;b=c[c[e>>2]>>2]|0;_Ha(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(SNa(a)|0)>>2]|0;KJa(e,c[d>>2]|0);d=JPa(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function DPa(a){a=a|0;var b=0,d=0;b=i;d=c[(HPa(a)|0)>>2]|0;i=b;return d|0}function EPa(a){a=a|0;var b=0,d=0;b=i;d=FPa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function FPa(a){a=a|0;var b=0,c=0;b=i;c=GPa(a)|0;i=b;return c|0}function GPa(a){a=a|0;i=i;return a|0}function HPa(a){a=a|0;var b=0,c=0;b=i;c=IPa(a)|0;i=b;return c|0}function IPa(a){a=a|0;i=i;return a|0}function JPa(a){a=a|0;var b=0,c=0;b=i;c=KPa(a+8|0)|0;i=b;return c|0}function KPa(a){a=a|0;var b=0,c=0;b=i;c=LPa(a)|0;i=b;return c|0}function LPa(a){a=a|0;i=i;return a|0}function MPa(a){a=a|0;var b=0;b=i;NPa(a,0);i=b;return}function NPa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=FPa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}PPa(OPa(e)|0,f);i=d;return}function OPa(a){a=a|0;var b=0,c=0;b=i;c=XPa(a)|0;i=b;return c|0}function PPa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;QPa(f,RPa(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;SPa(f,kNa(d+16|0)|0)}if((d|0)==0){i=e;return}TPa(c[b>>2]|0,d,1);i=e;return}function QPa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;WPa(d,0,c);i=b;return}function RPa(a){a=a|0;i=i;return a|0}function SPa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;VPa(d,0,c);i=b;return}function TPa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;UPa(0,b,0);i=c;return}function UPa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;S4a(b);i=c;return}function VPa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;FWa(c);i=b;return}function WPa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;FWa(c);i=b;return}function XPa(a){a=a|0;i=i;return a+4|0}function YPa(a,b){a=a|0;b=b|0;var c=0;c=i;ZPa(a,b);i=c;return}function ZPa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function _Pa(a){a=a|0;var b=0,c=0;b=i;c=rQa(a+4|0)|0;i=b;return c|0}function $Pa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];jQa(a,b,f);i=e;return}function aQa(a,b){a=a|0;b=b|0;var c=0;a=i;c=iQa(0,b,0)|0;i=a;return c|0}function bQa(a,b){a=a|0;b=b|0;var c=0;c=i;hQa(a,b);i=c;return}function cQa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}vWa(b,c);i=a;return}function dQa(a){a=a|0;var b=0,d=0;b=i;d=c[(HPa(a)|0)>>2]|0;i=b;return d|0}function eQa(a){a=a|0;var b=0,c=0;b=i;c=OPa(a)|0;i=b;return c|0}function fQa(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}tWa(b);i=a;return}function gQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;YPa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];yPa(h,f);APa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];yPa(a,e);BPa(h);i=d;return}function hQa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function iQa(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Q4a(b*40|0)|0;i=c;return a|0}function jQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(lQa(g)|0)>>2]|0;g=mQa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];kQa(b,a,f);i=e;return}function kQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];nQa(a,b,f);i=e;return}function lQa(a){a=a|0;i=i;return a|0}function mQa(a){a=a|0;i=i;return a|0}function nQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pQa(g)|0)>>2]|0;g=qQa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oQa(b,a,f);i=e;return}function oQa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(pQa(f)|0)>>2];f=qQa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function pQa(a){a=a|0;i=i;return a|0}function qQa(a){a=a|0;i=i;return a|0}function rQa(a){a=a|0;var b=0,c=0;b=i;c=sQa(a)|0;i=b;return c|0}function sQa(a){a=a|0;i=i;return a|0}function tQa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=EPa(uQa(b)|0)|0;h=qQa(eQa(uQa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];kQa(g,a,e);i=d;return}function uQa(a){a=a|0;i=i;return c[a>>2]|0}function vQa(a){a=a|0;var b=0;b=i;wQa(a);i=b;return}function wQa(a){a=a|0;var b=0;b=i;xQa(a);i=b;return}function xQa(a){a=a|0;var b=0;b=i;yQa(a,ZNa(a)|0);i=b;return}function yQa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;_Ha(d);if((b|0)==0){i=d;return}yQa(a,c[b>>2]|0);yQa(a,c[b+4>>2]|0);e=_Pa(a)|0;zQa(e,AQa(b+16|0)|0);TPa(e,b,1);i=d;return}function zQa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;BQa(d,0,c);i=b;return}function AQa(a){a=a|0;i=i;return a|0}function BQa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;CQa(c);i=b;return}function CQa(a){a=a|0;var b=0;b=i;DQa(a);i=b;return}function DQa(a){a=a|0;var b=0;b=i;EQa(a);i=b;return}function EQa(a){a=a|0;var b=0;b=i;FQa(a);i=b;return}function FQa(a){a=a|0;var b=0;b=i;FWa(a+12|0);FWa(a);i=b;return}function GQa(a){a=a|0;var b=0;b=i;HQa(a+180|0);HQa(a+168|0);HQa(a+156|0);HQa(a+144|0);HQa(a+132|0);HQa(a+120|0);HQa(a+108|0);HQa(a+96|0);HQa(a+84|0);HQa(a+72|0);HQa(a+60|0);HQa(a+48|0);HQa(a+36|0);HQa(a+24|0);YLa(a+12|0);YLa(a);i=b;return}function HQa(a){a=a|0;var b=0;b=i;IQa(a);i=b;return}function IQa(a){a=a|0;var b=0;b=i;JQa(a);i=b;return}function JQa(a){a=a|0;var b=0;b=i;KQa(a);i=b;return}function KQa(a){a=a|0;var b=0;b=i;LQa(a,mPa(a)|0);i=b;return}function LQa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;_Ha(d);if((b|0)==0){i=d;return}LQa(a,c[b>>2]|0);LQa(a,c[b+4>>2]|0);e=ROa(a)|0;MQa(e,NQa(b+16|0)|0);LOa(e,b,1);i=d;return}function MQa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;OQa(d,0,c);i=b;return}function NQa(a){a=a|0;i=i;return a|0}function OQa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;PQa(c);i=b;return}function PQa(a){a=a|0;var b=0;b=i;QQa(a);i=b;return}function QQa(a){a=a|0;var b=0;b=i;RQa(a);i=b;return}function RQa(a){a=a|0;var b=0;b=i;SQa(a);i=b;return}function SQa(a){a=a|0;var b=0;b=i;YLa(a+4|0);i=b;return}function TQa(a){a=a|0;var b=0;b=i;UQa(a);i=b;return}function UQa(a){a=a|0;var b=0;b=i;VQa(a);i=b;return}function VQa(a){a=a|0;var b=0;b=i;WQa(a,JMa(a)|0);i=b;return}function WQa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;_Ha(d);if((b|0)==0){i=d;return}WQa(a,c[b>>2]|0);WQa(a,c[b+4>>2]|0);e=rNa(a)|0;XQa(e,wMa(b+16|0)|0);lNa(e,b,1);i=d;return}function XQa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;YQa(d,0,c);i=b;return}function YQa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;ZQa(c);i=b;return}function ZQa(a){a=a|0;var b=0;b=i;_Qa(a);i=b;return}function _Qa(a){a=a|0;var b=0;b=i;$Qa(a);i=b;return}function $Qa(a){a=a|0;var b=0;b=i;aRa(a);i=b;return}function aRa(a){a=a|0;var b=0;b=i;FWa(a);i=b;return}function bRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;cRa(a);eRa(g,b);fRa(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];dRa(a,f,e);i=d;return a|0}function cRa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;yQa(a,ZNa(a)|0);c[(JPa(a)|0)>>2]=0;d=SNa(a)|0;c[(sPa(a)|0)>>2]=d;_Ha(b);c[d>>2]=0;i=b;return}function dRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;nRa(h,a);if(!(oRa(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];gRa(j,g);o=qRa(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];pRa(l,a,f,o);rRa(b)|0;}while(oRa(b,d)|0);i=e;return}function eRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;lRa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];gRa(a,e);i=d;return}function fRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;hRa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];gRa(a,e);i=d;return}function gRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];kRa(a,e);i=d;return}function hRa(a,b){a=a|0;b=b|0;var c=0;c=i;iRa(a,_La(b)|0);i=c;return}function iRa(a,b){a=a|0;b=b|0;var c=0;c=i;jRa(a,b);i=c;return}function jRa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kRa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function lRa(a,b){a=a|0;b=b|0;var d=0;d=i;iRa(a,c[(mRa(b)|0)>>2]|0);i=d;return}function mRa(a){a=a|0;i=i;return a|0}function nRa(a,b){a=a|0;b=b|0;var c=0;c=i;fRa(a,b);i=c;return}function oRa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xSa(a,b)|0;i=c;return d|0}function pRa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];zRa(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];yRa(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];PNa(a,g);CQa(l);i=f;return}function qRa(a){a=a|0;var b=0,c=0;b=i;c=vRa(a)|0;i=b;return c|0}function rRa(a){a=a|0;var b=0;b=i;sRa(a)|0;i=b;return a|0}function sRa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=tRa(c[d>>2]|0)|0;i=b;return a|0}function tRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;_Ha(b);if((e|0)==0){e=a;while(1){a=OJa(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=uRa(c[d>>2]|0)|0;i=b;return g|0}return 0}function uRa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;_Ha(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;_Ha(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function vRa(a){a=a|0;var b=0,d=0;b=i;d=wRa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function wRa(a){a=a|0;var b=0,c=0;b=i;c=xRa(a)|0;i=b;return c|0}function xRa(a){a=a|0;i=i;return a|0}function yRa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=DRa(b,h,j,e)|0;h=c[p>>2]|0;_Ha(l);if((h|0)!=0){q=h;RNa(a,q);i=f;return}FRa(o,b,e);GRa(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];ERa(m,g);HRa(o);o=c[j>>2]|0;CPa(b,o,p,IRa(m)|0);p=JRa(m)|0;HRa(m);q=p;RNa(a,q);i=f;return}function zRa(a,b){a=a|0;b=b|0;var c=0;c=i;ARa(a,b);i=c;return}function ARa(a,b){a=a|0;b=b|0;var c=0;c=i;BRa(a,b);i=c;return}function BRa(a,b){a=a|0;b=b|0;var c=0;c=i;CRa(a,b);i=c;return}function CRa(a,b){a=a|0;b=b|0;var c=0;c=i;vWa(a,b);vWa(a+12|0,b+12|0);i=c;return}function DRa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;QNa(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];lSa(l,k);do{if(!(kSa(b,l)|0)){k=$Na(a)|0;x=nSa(b)|0;if(mSa(k,e,x)|0){break}w=mSa(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];rSa(r,h,1,0);QNa(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];lSa(t,g);do{if(!(kSa(r,t)|0)){if(mSa(k,e,nSa(r)|0)|0){break}y=qSa(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;_Ha(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;oSa(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];lSa(o,j);do{if(!(kSa(n,o)|0)){j=$Na(a)|0;if(mSa(j,nSa(pSa(n)|0)|0,e)|0){break}y=qSa(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;_Ha(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function ERa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];iSa(a,e);i=d;return}function FRa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=_Pa(d)|0;d=aQa(n,1)|0;WRa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];VRa(j,d,h);XRa(0,AQa((YRa(j)|0)+16|0)|0,e);a[(ZRa(j)|0)+4|0]=1;_Ra(m,j);GRa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];ERa(b,g);HRa(m);HRa(j);i=f;return}function GRa(a,b){a=a|0;b=b|0;var c=0;c=i;TRa(a,b);i=c;return}function HRa(a){a=a|0;var b=0;b=i;ORa(a);i=b;return}function IRa(a){a=a|0;var b=0,d=0;b=i;d=c[(MRa(a)|0)>>2]|0;i=b;return d|0}function JRa(a){a=a|0;var b=0,d=0;b=i;d=KRa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function KRa(a){a=a|0;var b=0,c=0;b=i;c=LRa(a)|0;i=b;return c|0}function LRa(a){a=a|0;i=i;return a|0}function MRa(a){a=a|0;var b=0,c=0;b=i;c=NRa(a)|0;i=b;return c|0}function NRa(a){a=a|0;i=i;return a|0}function ORa(a){a=a|0;var b=0;b=i;PRa(a,0);i=b;return}function PRa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=KRa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}RRa(QRa(e)|0,f);i=d;return}function QRa(a){a=a|0;var b=0,c=0;b=i;c=SRa(a)|0;i=b;return c|0}function RRa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;zQa(f,AQa(d+16|0)|0)}if((d|0)==0){i=e;return}TPa(c[b>>2]|0,d,1);i=e;return}function SRa(a){a=a|0;i=i;return a+4|0}function TRa(a,b){a=a|0;b=b|0;var c=0;c=i;URa(a,b);i=c;return}function URa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function VRa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];cSa(a,b,f);i=e;return}function WRa(a,b){a=a|0;b=b|0;var c=0;c=i;bSa(a,b);i=c;return}function XRa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}$Ra(b,c);i=a;return}function YRa(a){a=a|0;var b=0,d=0;b=i;d=c[(MRa(a)|0)>>2]|0;i=b;return d|0}function ZRa(a){a=a|0;var b=0,c=0;b=i;c=QRa(a)|0;i=b;return c|0}function _Ra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;TRa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];ERa(h,f);GRa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];ERa(a,e);HRa(h);i=d;return}function $Ra(a,b){a=a|0;b=b|0;var c=0;c=i;aSa(a,b);i=c;return}function aSa(a,b){a=a|0;b=b|0;var c=0;c=i;BRa(a,b);i=c;return}function bSa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function cSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(lQa(g)|0)>>2]|0;g=eSa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];dSa(b,a,f);i=e;return}function dSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];fSa(a,b,f);i=e;return}function eSa(a){a=a|0;i=i;return a|0}function fSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(pQa(g)|0)>>2]|0;g=hSa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];gSa(b,a,f);i=e;return}function gSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(pQa(f)|0)>>2];f=hSa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function hSa(a){a=a|0;i=i;return a|0}function iSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=JRa(jSa(b)|0)|0;h=hSa(ZRa(jSa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];dSa(g,a,e);i=d;return}function jSa(a){a=a|0;i=i;return c[a>>2]|0}function kSa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function lSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];wSa(a,e);i=d;return}function mSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=dMa(0,b,c)|0;i=a;return d|0}function nSa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function oSa(a,b){a=a|0;b=b|0;var d=0;d=i;RNa(a,c[(sPa(b)|0)>>2]|0);i=d;return}function pSa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=uSa(c[d>>2]|0)|0;i=b;return a|0}function qSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=ZNa(a)|0;_Ha(e);if((h|0)==0){j=SNa(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=$Na(a)|0;a=h;while(1){h=a+16|0;if(mSa(j,d,h)|0){l=a;m=c[l>>2]|0;_Ha(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(mSa(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;_Ha(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function rSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;sSa(b,d);c[a>>2]=c[b>>2];i=e;return}function sSa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;tSa(b,c,e);i=d;return}function tSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{pSa(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{sRa(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function uSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;_Ha(b);if((e|0)==0){e=a;while(1){a=OJa(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=vSa(c[d>>2]|0)|0;i=b;return g|0}return 0}function vSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;_Ha(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;_Ha(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function wSa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function xSa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(kSa(a,b)|0)^1;i=c;return d|0}function ySa(a){a=a|0;var b=0;b=i;i=i+128|0;QLa(a,b);QLa(a+12|0,b+8|0);zSa(a+24|0,b+16|0);zSa(a+36|0,b+24|0);zSa(a+48|0,b+32|0);zSa(a+60|0,b+40|0);zSa(a+72|0,b+48|0);zSa(a+84|0,b+56|0);zSa(a+96|0,b+64|0);zSa(a+108|0,b+72|0);zSa(a+120|0,b+80|0);zSa(a+132|0,b+88|0);zSa(a+144|0,b+96|0);zSa(a+156|0,b+104|0);zSa(a+168|0,b+112|0);zSa(a+180|0,b+120|0);i=b;return}function zSa(a,b){a=a|0;b=b|0;b=i;ASa(a,0);i=b;return}function ASa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;BSa(a,b);i=b;return}function BSa(a,b){a=a|0;b=b|0;b=i;CSa(a,0);i=b;return}function CSa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;DSa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;ESa(f,0,e);e=zOa(b)|0;c[(yOa(b)|0)>>2]=e;i=d;return}function DSa(a){a=a|0;var b=0;b=i;HSa(a);i=b;return}function ESa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;FSa(b,c,f);i=e;return}function FSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(CKa(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;GSa(d,b,f);i=e;return}function GSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(CKa(e)|0)>>2];i=d;return}function HSa(a){a=a|0;var b=0;b=i;ISa(a);i=b;return}function ISa(a){a=a|0;var b=0;b=i;FKa(a);i=b;return}function JSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[299236>>2]|0;if((m|0)==0){n=0}else{o=Q4a(12)|0;zWa(o,m);n=o}if((c[299152>>2]|0)!=0){c[60400]=1}if((n|0)==0){c[241612>>2]=1;c[241616>>2]=1;i=b;return}do{if((bXa(n,289440,0)|0)==-1){vWa(g,n);tWa(h);o=c[59974]|0;m=(o|0)<28;while(1){p=bXa(g,289448,0)|0;q=(p|0)!=-1;if(q){$Wa(j,g,0,p);GWa(h,j)|0;FWa(j);$Wa(k,g,p+1|0,-1);GWa(g,k)|0;FWa(k)}else{GWa(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){zWa(l,c[240312+(s<<2)>>2]|0);p=KSa(h,l)|0;FWa(l);if(p){c[241608+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){OBa(1,1,289456,f);if(m){v=o}else{w=242160;x=c[60540]|0;je[x&1023](1);y=aXa(n)|0;z=a;A=z;c[A>>2]=y;B=7;C=B;D=289496;E=D;QBa(0,E,a)}do{p=c[241480+(v<<2)>>2]|0;c[e>>2]=c[240312+(v<<2)>>2];c[e+4>>2]=p;OBa(1,0,289480,e);v=v+1|0;}while((v|0)<28);w=242160;x=c[60540]|0;je[x&1023](1);y=aXa(n)|0;z=a;A=z;c[A>>2]=y;B=7;C=B;D=289496;E=D;QBa(0,E,a)}else if((t|0)==20){OBa(1,1,289456,d);w=242160;x=c[60540]|0;je[x&1023](1);y=aXa(n)|0;z=a;A=z;c[A>>2]=y;B=7;C=B;D=289496;E=D;QBa(0,E,a)}else if((t|0)==23){FWa(h);FWa(g);break}}else{o=1;do{c[241608+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[241612>>2]=1;c[241616>>2]=1;if((c[241644>>2]|0)!=0){c[241704>>2]=1}if((c[241700>>2]|0)==1){c[241708>>2]=1}if((c[241680>>2]|0)!=0){c[241676>>2]=1}if((c[241688>>2]|0)!=0){c[241676>>2]=1}if((c[241640>>2]|0)!=0){c[241636>>2]=1}if((c[241684>>2]|0)!=0){c[241676>>2]=1}if((c[241632>>2]|0)!=0){c[241628>>2]=1}FWa(n);S4a(n);i=b;return}function KSa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=DWa(b)|0;if((e|0)!=(DWa(c)|0)){f=0;i=d;return f|0}g=EWa(b)|0;h=EWa(c)|0;if(wWa(b)|0){f=(fMa(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function LSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[299244>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Q4a(12)|0;l=k;zWa(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(MSa(l,c[274536+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=aXa(l)|0;OBa(1,1,289528,g);g=c[274620>>2]|0;c[f>>2]=c[274540>>2];c[f+4>>2]=g;OBa(1,0,289480,f);f=c[274624>>2]|0;c[e>>2]=c[274544>>2];c[e+4>>2]=f;OBa(1,0,289480,e);e=c[274628>>2]|0;c[d>>2]=c[274548>>2];c[d+4>>2]=e;OBa(1,0,289480,d);je[c[60540]&1023](1);QBa(0,289584,a)}else if((n|0)==6){i=b;return j|0}return 0}function MSa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(dXa(a,b)|0)==0;i=c;return d|0}function NSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[299228>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Q4a(12)|0;l=k;zWa(l,h);if((k|0)==0){j=1;i=b;return j|0}zWa(f,289608);k=KSa(l,f)|0;FWa(f);if(k){j=1;i=b;return j|0}zWa(g,289616);k=KSa(l,g)|0;FWa(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=aXa(l)|0;OBa(1,1,289624,e);c[d>>2]=289608;c[d+4>>2]=289680;OBa(1,0,289480,d);c[a>>2]=289616;c[a+4>>2]=289696;OBa(1,0,289480,a);je[c[60540]&1023](1);QBa(0,289584,b)}return 0}function OSa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;OYa(f,a);if(!(RYa(f)|0)){PYa(f);i=d;return a|0}j=nMa(b)|0;$Sa(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((cIa(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=zXa(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];cTa(h,e,b,m,k,l,n);if(!(aTa(h)|0)){PYa(f);i=d;return a|0}tXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);PYa(f);i=d;return a|0}function PSa(a){a=a|0;var b=0;b=i;UYa(a,AXa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;BYa(a)|0;i=b;return a|0}function QSa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;zWa(h,d);oXa(k,289704,h);ALa(j,k,289712);FWa(k);k=aXa(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((i5a(c[n+4>>2]|0,289720)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((i5a(k,289728)|0)==0){FWa(j);FWa(h);i=f;return}d=S3a(g,k,1)|0;if((d|0)!=0){m=l;q5a(m|0,0,2048)|0;d4a(d,g,m,2048)|0;SYa(OSa(OSa(OSa(OSa(OSa(311632,289736)|0,k)|0,289776)|0,m)|0,289792)|0,104)|0;FWa(j);FWa(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(e4a(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(e4a(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(e4a(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(e4a(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(e4a(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(e4a(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(e4a(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==0){n=(e4a(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==1){d=(e4a(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){l=b+12|0;o=p;p=0;while(1){t=c[l>>2]|0;if((a[t+(p*52|0)+48|0]|0)==0){k=(e4a(g,c[t+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(p*52|0)+48|0]=k;u=c[m>>2]|0}else{u=o}k=p+1|0;if((k|0)<(u|0)){o=u;p=k}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;o=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{l=c[u>>2]|0;do{if((a[l+(b*52|0)+48|0]|0)==0){k=a[l+(b*52|0)+8|0]|0;if(k<<24>>24==1){t=(e4a(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==0){k=(e4a(g,c[l+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}W3a(g);FWa(j);FWa(h);i=f;return}function RSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[299092>>2]|0;H=c[299220>>2]|0;I=c[2]|0;if((c[241708>>2]|0)==0){if(!((c[299040>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Db(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;MBa(23,0,289840,l);l=c[299164>>2]|0;do{if((l|0)==0){M=0}else{if((i5a(l,289864)|0)==0){M=1;break}if((i5a(l,289872)|0)==0){M=0;break}if((i5a(l,289880)|0)==0){M=2;break}c[j>>2]=l;OBa(1,0,289888,j);M=0}}while(0);if((tDa(M)|0)!=0){c[g>>2]=l;OBa(1,0,289960,g)}if((c[2]|0)!=0){ZTa(d+56|0);yDa((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);uDa(0);uDa(6);vDa(3);vDa(4);vDa(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+e5a(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];MBa(1,0,290048,f)}do{if((c[299148>>2]|0)!=0){f=Q4a(12)|0;J=f;zWa(J,c[299276>>2]|0);if((f|0)==0){break}f=aXa(J)|0;c[d+280>>2]=f;c[e>>2]=f;MBa(23,0,290104,e)}}while(0);e=c[299272>>2]|0;tWa(m);if((e|0)==0){zWa(p,c[d+88>>2]|0);zWa(q,290152);SSa(o,p,q);ALa(n,o,c[d+284>>2]|0);GWa(m,n)|0;FWa(n);FWa(o);FWa(q);FWa(p)}else{HWa(m,e)|0}zWa(r,290160);zWa(s,290160);zWa(t,290160);zWa(u,290160);zWa(v,290160);zWa(w,290160);e=c[299040>>2]|0;if((c[299060>>2]|0)!=0){HWa(r,c[299188>>2]|0)|0}if((c[299076>>2]|0)!=0){HWa(s,c[299204>>2]|0)|0}if((c[299056>>2]|0)!=0){HWa(t,c[299184>>2]|0)|0}if((c[299064>>2]|0)==0){O=0.0}else{HWa(u,c[299192>>2]|0)|0;O=+e5a(aXa(u)|0)}if((c[299068>>2]|0)==0){P=1}else{HWa(v,c[299196>>2]|0)|0;P=Ic(aXa(v)|0)|0}if((c[299128>>2]|0)!=0){HWa(w,c[299256>>2]|0)|0}vWa(x,m);vWa(y,r);vWa(z,s);vWa(A,t);vWa(B,w);p=TSa(d,x,y,z,A,O,P,B,e)|0;FWa(B);FWa(A);FWa(z);FWa(y);FWa(x);if((p|0)!=0|g^1){Q=p}else{uDa(5);p=oTa(d)|0;xDa(5);MBa(1,0,290168,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;FWa(w);FWa(v);FWa(u);FWa(t);FWa(s);FWa(r);FWa(m);i=b;return R|0}Q=d+88|0;zWa(D,c[Q>>2]|0);ALa(C,D,290200);FWa(D);zWa(F,c[Q>>2]|0);ALa(E,F,290216);FWa(F);xDa(0);F=c[299240>>2]|0;Q=aXa(C)|0;D=aXa(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;NTa(d,Q,D,(F|0)!=0?F:290232,I,p,aXa(m)|0)|0;FWa(E);FWa(C);R=0;FWa(w);FWa(v);FWa(u);FWa(t);FWa(s);FWa(r);FWa(m);i=b;return R|0}function SSa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;uWa(a,d);e=DWa(b)|0;f=DWa(c)|0;eXa(a,EWa(b)|0,e,f+e|0);YWa(a,EWa(c)|0,f)|0;i=d;return}function TSa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((DWa(j)|0)==0){u=0}else{u=aXa(j)|0}vWa(r,b);b=(USa(a,r,k)|0)==0;FWa(r);if(!b){v=-1;i=l;return v|0}zWa(s,290160);b=a+280|0;r=MSa(s,c[b>>2]|0)|0;FWa(s);do{if(r){w=3}else{s=1;k=0;do{zWa(t,c[290376+(s<<2)>>2]|0);j=MSa(t,c[b>>2]|0)|0;FWa(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];OBa(1,0,290456,q);OBa(1,0,289456,p);s=1;do{j=c[290488+(s<<2)>>2]|0;c[o>>2]=c[290376+(s<<2)>>2];c[o+4>>2]=j;OBa(1,0,289480,o);s=s+1|0;}while((s|0)<20);QBa(c[a+536>>2]|0,289584,n)}}while(0);c[m>>2]=c[290376+(w<<2)>>2];MBa(23,0,290568,m);m=aXa(d)|0;d=aXa(e)|0;e=rGa(a,m,d,aXa(f)|0,g,h,w,u)|0;ke[c[283820>>2]&255](283792,a);v=e;i=l;return v|0}function USa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[70948]=Ed(aXa(b)|0)|0;c[283796>>2]=g;c[283800>>2]=d;d=a+284|0;do{if((c[72358]|0)==0){g=c[d>>2]|0;if((i5a(290240,g)|0)==0){h=0;break}if((i5a(290248,g)|0)==0){c[283808>>2]=114;c[283812>>2]=115;c[283820>>2]=116;h=0;break}if((i5a(290256,g)|0)==0){c[283808>>2]=117;c[283812>>2]=118;c[283816>>2]=119;c[283820>>2]=120;h=1;break}if((i5a(290264,g)|0)==0){c[283808>>2]=121;c[283812>>2]=122;c[283816>>2]=123;c[283820>>2]=124;h=1;break}if((i5a(290272,g)|0)==0){c[283808>>2]=125;c[283812>>2]=126;c[283820>>2]=127;h=0;break}g=OSa(311632,290280)|0;SYa(OSa(g,c[d>>2]|0)|0,104)|0;j=1;i=e;return j|0}else{h=0}}while(0);QSa(a+8|0,c[a+288>>2]|0,h);ke[c[283808>>2]&255](283792,a);a=c[70948]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;MBa(23,0,290304,f);j=0;i=e;return j|0}function VSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;DBa();do{if((fUa(a,b)|0)==0){if((hUa(a,b)|0)!=0){break}do{if((c[299096>>2]|0)!=0){w=c[299224>>2]|0;if((i5a(w,290688)|0)==0){JBa(1);break}if((i5a(w,290696)|0)==0){JBa(0);break}else{c[p>>2]=w;OBa(1,0,290704,p);yd(0)|0;Gd(0)}}}while(0);if((c[299052>>2]|0)==0){JSa(0,0);iFa(d);if((d|0)==0){SYa(OSa(311632,291072)|0,104)|0}c[d+300>>2]=LSa(0,0)|0;c[d+292>>2]=NSa(0,0)|0;xLa(d+8|0,d+240|0);uFa(d)|0;FFa(d)|0;RFa(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}SYa(OSa(311632,291136)|0,104)|0;x=1;i=e;return x|0}}while(0);c[72358]=c[299120>>2];x=0;i=e;return x|0}zWa(u,c[299180>>2]|0);w=1;while(1){y=247016+(w<<2)|0;zWa(v,c[y>>2]|0);z=KSa(u,v)|0;FWa(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=aXa(u)|0;OBa(1,0,290976,g);c[f>>2]=c[b>>2];OBa(1,0,291016,f);yd(0)|0;Gd(0)}A=c[251040+(w<<2)>>2]|0;do{if((A|0)==1){z=c[250912+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;MBa(1,1,290776,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[250912+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;MBa(1,1,290816,n);break}else{c[m>>2]=z;OBa(1,1,290656,m);break}}}while(0);if((w|0)==11){A=1;do{z=c[290944+(A<<2)>>2]|0;c[j>>2]=c[290912+(A<<2)>>2];c[j+4>>2]=z;MBa(1,0,289480,j);A=A+1|0;}while((A|0)<7);D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}else if((w|0)==19){A=c[59974]|0;if((A|0)<28){G=A}else{D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}do{A=c[241480+(G<<2)>>2]|0;c[l>>2]=c[240312+(G<<2)>>2];c[l+4>>2]=A;MBa(1,0,289480,l);G=G+1|0;}while((G|0)<28);D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}else if((w|0)==7){A=1;do{z=c[290896+(A<<2)>>2]|0;c[k>>2]=c[290880+(A<<2)>>2];c[k+4>>2]=z;MBa(1,0,289480,k);A=A+1|0;}while((A|0)<4);D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}else if((w|0)==29){A=1;do{z=c[290488+(A<<2)>>2]|0;c[h>>2]=c[290376+(A<<2)>>2];c[h+4>>2]=z;MBa(1,0,289480,h);A=A+1|0;}while((A|0)<20);D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}else{D=242160;E=c[60540]|0;je[E&1023](1);F=yd(0)|0;Gd(0)}}}while(0);c[t>>2]=c[b>>2];MBa(1,1,290592,t);t=1;do{b=c[251040+(t<<2)>>2]|0;do{if((b|0)==1){F=c[248920+(t<<2)>>2]|0;c[s>>2]=c[247016+(t<<2)>>2];c[s+4>>2]=F;MBa(1,0,290608,s)}else{F=c[247016+(t<<2)>>2]|0;if((b|0)==2){E=c[248920+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;MBa(1,0,290624,r);break}else{c[q>>2]=F;OBa(1,0,290656,q);break}}}while(0);t=t+1|0;}while((t|0)<31);je[c[60540]&1023](1);yd(0)|0;Gd(0);return 0}function WSa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[72792]|0;vb(292752)|0;c[l>>2]=c[m+88>>2];jc(291176,l|0)|0;vb(292768)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];jc(291200,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];jc(291240,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];jc(291272,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];jc(291304,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];jc(291336,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];jc(291368,b|0)|0;vb(292792)|0;i=a;return}function XSa(a,b){a=a|0;b=+b;i=i;return}function YSa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;l5a(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=z5a(c[g>>2]|0,f)|0;if((k|0)==0){gb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(42,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=z5a(c[g>>2]|0,f)|0;if((m|0)==0){gb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[72792]=d;u=0;Ia(63,10,660)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=z5a(c[k>>2]|0,f)|0;if((p|0)==0){gb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(43,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=z5a(c[g>>2]|0,f)|0;if((q|0)==0){gb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=z5a(c[g>>2]|0,f)|0;if((r|0)==0){gb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=z5a(c[g>>2]|0,f)|0;if((s|0)==0){gb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(111,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=z5a(c[g>>2]|0,f)|0;if((t|0)==0){gb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=z5a(c[g>>2]|0,f)|0;if((w|0)==0){gb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(661,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=z5a(c[g>>2]|0,f)|0;if((x|0)==0){gb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=z5a(c[g>>2]|0,f)|0;if((y|0)==0){gb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=z5a(c[k>>2]|0,f)|0;if((A|0)==0){gb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function ZSa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=pd(c[59828]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 3:{if((c[241676>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;uc(291440,7,1,a|0)|0;Gc(a|0,d|0,f|0)|0;Wd(10,a|0)|0;yd(0)|0;i=b;return};case 2:{if((c[241620>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;gb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;uc(291440,7,1,a|0)|0;Gc(a|0,d|0,f|0)|0;Wd(10,a|0)|0;yd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;gb(n|0,1);break};case 5:case 4:{i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;uc(291440,7,1,e|0)|0;Gc(e|0,d|0,f|0)|0;Wd(10,e|0)|0;yd(0)|0;gb(c[g+80>>2]|0,1);break};default:{QBa(g,291448,b)}}}function _Sa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;uc(291424,9,1,d|0)|0;Gc(d|0,b|0,e|0)|0;Wd(10,d|0)|0;yd(0)|0;i=a;return}function $Sa(a,b){a=a|0;b=b|0;var c=0;c=i;bTa(a,b);i=c;return}function aTa(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function bTa(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=yXa(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function cTa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;_Ha(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=dTa(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((KXa(b,d,r)|0)==(r|0)){break}_Ha(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){AWa(l,s,h);if((KXa(b,EWa(l)|0,s)|0)==(s|0)){FWa(l);break}_Ha(m);c[o>>2]=0;c[a>>2]=0;FWa(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((KXa(b,e,l)|0)==(l|0)){break}_Ha(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);eTa(g,0)|0;c[a>>2]=b;i=j;return}function dTa(a){a=a|0;i=i;return c[a+12>>2]|0}function eTa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function fTa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;gTa(g,16);hTa(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){iTa(a,g);jTa(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){OSa(TYa(m,+h[b+(p<<3)>>3])|0,292808)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){TYa(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){OSa(m,292816)|0}}while((e|0)<(d|0));iTa(a,g);jTa(g);i=f;return}function gTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;CXa(e);f=a;c[f>>2]=293188;g=e;c[g>>2]=293208;e=a+4|0;JYa(a,293220|0,e);c[f>>2]=293188;c[g>>2]=293208;vTa(e,b|16);i=d;return}function hTa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function iTa(a,b){a=a|0;b=b|0;var c=0;c=i;pTa(a,b+4|0);i=c;return}function jTa(a){a=a|0;var b=0;b=i;zTa(a,293216);xXa(a+56|0);i=b;return}function kTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[241664>>2]|0)!=0){vb(293512)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(14,0,292824,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);me[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(14,0,292896,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[241664>>2]|0)==0){i=d;return 0}MBa(14,0,292944,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jc(292960,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function lTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[241664>>2]|0)!=0){vb(293512)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(14,0,292824,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);me[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(14,0,292896,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[241664>>2]|0)==0){i=d;return 0}MBa(14,0,292944,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jc(292960,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function mTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[241664>>2]|0)!=0){vb(293512)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(14,0,292824,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);me[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(14,0,292896,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[241664>>2]|0)==0){i=d;return 0}MBa(14,0,292944,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jc(292960,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function nTa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[241664>>2]|0)!=0){vb(293512)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];MBa(14,0,292824,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);me[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];MBa(14,0,292896,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[241664>>2]|0)==0){i=d;return 0}MBa(14,0,292944,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jc(292960,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}



function mU(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;b=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+36|0]|0)==0){f=0.0;g=b;j=g+6088|0;k=j;h[k>>3]=f;i=d;return}f=+h[b+6072>>3];g=b;j=g+6088|0;k=j;h[k>>3]=f;i=d;return}function nU(b){b=b|0;var d=0;d=c[c[b+4>>2]>>2]|0;h[(c[d+8>>2]|0)+6256>>3]=(a[(c[d+16>>2]|0)+106|0]|0)!=0?1.0:0.0;i=i;return}function oU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6264>>3]=-+h[b+6104>>3]- +h[b+6096>>3]- +h[b+6112>>3]- +h[b+6120>>3]- +h[b+6128>>3]- +h[b+6136>>3]- +h[b+6144>>3]- +h[b+6152>>3]- +h[b+6184>>3]- +h[b+6192>>3]- +h[b+6200>>3]- +h[b+6208>>3]- +h[b+6240>>3]- +h[b+6248>>3]- +h[b+6256>>3];i=i;return}function pU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;e=0-(tFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6264>>3],0,a)|0)|0;c[(c[(c[c[d>>2]>>2]|0)+12>>2]|0)+104>>2]=e;i=b;return}function qU(b){b=b|0;a[(c[b+408>>2]|0)+105|0]=a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+106|0]|0;i=i;return}function rU(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+106|0]=a[d+105|0]|0;i=i;return}function sU(b){b=b|0;var d=0;d=c[b+408>>2]|0;a[d+104|0]=a[d+106|0]|0;i=i;return}function tU(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+104|0]=a[(c[b+408>>2]|0)+104|0]|0;i=i;return}function uU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=293.15;i=i;return}function vU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6408>>3]=+h[b+6424>>3]+-273.15;i=i;return}function wU(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+6464>>3]=+h[b+6288>>3]*(+h[d+936>>3]*(+h[b+6424>>3]- +h[d+928>>3])+1.0);i=i;return}function xU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+256>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+256|0;h[c[g+2208>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+256>>3]);h[c[(c[f>>2]|0)+2212>>2]>>3]=k;TFa(a,27)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+256>>3]=+h[c[(c[f>>2]|0)+2204>>2]>>3];i=b;return}function yU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(pFa(+h[a+6424>>3],+h[a+7480>>3])|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[a+6456>>3]=+h[(e?a+7560|0:a+256|0)>>3];i=b;return}function zU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6472>>3]=+h[b+6456>>3];i=i;return}function AU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3],+h[(c[a+8>>2]|0)+256>>3],c[(c[a+12>>2]|0)+108>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+256>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));qv(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6432>>3]=+h[f>>3];i=b;return}function BU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(pFa(+h[a+6424>>3],+h[a+7480>>3])|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[a+6448>>3]=+h[(e?a+7544|0:a+6432|0)>>3];i=b;return}function CU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+256>>3];k=+h[g+6432>>3];l=+h[(c[b+416>>2]|0)+776>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}s=l/+SBa(c[b+536>>2]|0,k,65176,65168,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+6416|0;r=q;h[r>>3]=o;i=d;return}function DU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+264>>3]=+h[(c[a+416>>2]|0)+752>>3];i=i;return}function EU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+40>>3];i=i;return}function FU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2376>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2376|0;h[c[g+2288>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2376>>3]);e=c[f>>2]|0;h[c[e+2292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6352>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6352|0;h[(c[e+2288>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6352>>3]);j=c[f>>2]|0;h[(c[j+2292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+2284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2360>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2360|0;h[(c[j+2288>>2]|0)+16>>3]=+h[e>>3];k=+VFa(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2360>>3]);g=c[f>>2]|0;h[(c[g+2292>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+2284>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2040>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2040|0;h[(c[g+2288>>2]|0)+24>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2040>>3]);h[(c[(c[f>>2]|0)+2292>>2]|0)+24>>3]=k;TFa(a,28)|0;a=c[(c[f>>2]|0)+2284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2376>>3]=+h[a>>3];h[f+6352>>3]=+h[a+8>>3];h[f+2360>>3]=+h[a+16>>3];h[f+2040>>3]=+h[a+24>>3];i=b;return}function GU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2032>>3]=-(+h[e+2376>>3]*+h[(a<<24>>24==0?e+144|0:e+256|0)>>3]);i=b;return}function HU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+2048>>3]+ +h[b+2032>>3];i=i;return}function IU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+6024>>3]- +h[b+2376>>3];i=i;return}function JU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+416>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+416|0;h[c[g+2368>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+416>>3]);e=c[f>>2]|0;h[c[e+2372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6536>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6536|0;h[(c[e+2368>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6536>>3]);h[(c[(c[f>>2]|0)+2372>>2]|0)+8>>3]=k;TFa(a,29)|0;j=c[(c[f>>2]|0)+2364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+416>>3]=+h[j>>3];h[f+6536>>3]=+h[j+8>>3];Zx(a);_x(a);$x(a);ay(a);i=b;return}function KU(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+2904>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6536>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,65200,65192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+424|0;p=o;h[p>>3]=m;i=d;return}function LU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+92|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+92|0]|0;j=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[b+360>>2]|0)+92|0]|0)|0;a[(c[b+352>>2]|0)+92|0]=j;e=g;break}else{g=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[b+360>>2]|0)+92|0]|0)|0;a[(c[b+352>>2]|0)+92|0]=g;e=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+92|0]|0;g=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;a[(c[b+352>>2]|0)+92|0]=g;e=f;break}else{f=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;a[(c[b+352>>2]|0)+92|0]=f;e=f;break}}}}while(0);f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;if(e<<24>>24==0){k=0.0;l=f;m=l+2368|0;n=m;h[n>>3]=k;i=d;return}k=+h[f+2376>>3];l=f;m=l+2368|0;n=m;h[n>>3]=k;i=d;return}function MU(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2384>>3]=+h[e+2376>>3]*+h[(a<<24>>24==0?e+256|0:e+144|0)>>3];i=b;return}function NU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2040>>3],+h[(c[b+416>>2]|0)+2936>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+94|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+94|0]|0;l=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+94|0]|0)|0;a[(c[b+352>>2]|0)+94|0]=l;g=k;break}else{k=lFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+94|0]|0)|0;a[(c[b+352>>2]|0)+94|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+94|0]|0;k=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+94|0]=k;g=j;break}else{j=pFa(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+94|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+5|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+5|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+5|0;v=u;a[v]=m;i=d;return}function OU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2040>>3],+h[a+144>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2040>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6384>>3]=+h[f>>3];i=b;return}function PU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2040>>3],+h[a+144>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2040>>3];l=+h[g+144>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6376>>3]=+h[f>>3];i=b;return}function QU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2040>>3],+h[l+256>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2040>>3];o=+h[m+256>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+2376>>3],+h[d+6376>>3],+h[f>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6360>>3]=+h[g>>3];i=b;return}function RU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2360>>3],+h[(c[b+416>>2]|0)+776>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+91|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+91|0]|0;l=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+91|0]|0)|0;a[(c[b+352>>2]|0)+91|0]=l;g=k;break}else{k=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[b+360>>2]|0)+91|0]|0)|0;a[(c[b+352>>2]|0)+91|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+91|0]|0;k=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+91|0]=k;g=j;break}else{j=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+91|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+16|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+16|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+16|0;v=u;a[v]=m;i=d;return}function SU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2360>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2360>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6400>>3]=+h[f>>3];i=b;return}function TU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+2376>>3],+h[j+6400>>3],+h[j+6384>>3],+h[(c[b+416>>2]|0)+816>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+2376>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,65224,65216,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+6344|0;r=q;h[r>>3]=o;i=d;return}function UU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2360>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2360>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6392>>3]=+h[f>>3];i=b;return}function VU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;fv(e,c[j>>2]|0,+h[l+2360>>3],+h[l+144>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+2360>>3];o=+h[m+144>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));mv(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+2376>>3],+h[d+6392>>3],+h[f>>3],+h[(c[a+416>>2]|0)+816>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6368>>3]=+h[g>>3];i=b;return}function WU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2304>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+24>>3];i=i;return}function XU(b){b=b|0;var d=0,e=0,f=0.0,g=0;d=i;e=b+4|0;do{if((rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2304>>3],0.0)|0)<<24>>24==0){if((a[(c[b+408>>2]|0)+15|0]|0)!=0){f=-0.0;break}f=+h[(c[b+416>>2]|0)+776>>3]}else{g=c[(c[c[e>>2]>>2]|0)+8>>2]|0;f=+h[g+2304>>3]*+h[g+6432>>3]*9.80665+ +h[(c[b+416>>2]|0)+776>>3]}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3]=f;i=d;return}function YU(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2352>>3],+h[(c[b+416>>2]|0)+776>>3])|0;if((a[(c[b+408>>2]|0)+15|0]|0)==0){g=0}else{g=f<<24>>24==0|0}a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+15|0]=g;i=d;return}function ZU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2296>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+32>>3];i=i;return}function _U(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2320|0;h[c[g+2448>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2320>>3]);h[c[(c[f>>2]|0)+2452>>2]>>3]=k;TFa(a,30)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[c[(c[f>>2]|0)+2444>>2]>>3];dy(a);ey(a);i=b;return}function $U(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+2336>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+3e3|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+1992|0;p=o;h[p>>3]=m;i=b;return}else{j=f+256|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+1992|0;p=o;h[p>>3]=m;i=b;return}}function aV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+1992>>3]+ +h[b+1976>>3];i=i;return}function bV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=-+h[b+2336>>3]- +h[b+4712>>3];i=i;return}function cV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+400>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+400|0;h[c[g+2528>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+400>>3]);e=c[f>>2]|0;h[c[e+2532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6544>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6544|0;h[(c[e+2528>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6544>>3]);h[(c[(c[f>>2]|0)+2532>>2]|0)+8>>3]=k;TFa(a,31)|0;j=c[(c[f>>2]|0)+2524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+400>>3]=+h[j>>3];h[f+6544>>3]=+h[j+8>>3];hy(a);iy(a);jy(a);ky(a);i=b;return}function dV(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+3016>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6544>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,65344,65336,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+408|0;p=o;h[p>>3]=m;i=d;return}function eV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;d=i;do{if((a[b+314|0]|0)==0){e=a[(c[b+356>>2]|0)+88|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+88|0]|0;j=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[b+360>>2]|0)+88|0]|0)|0;a[(c[b+352>>2]|0)+88|0]=j;e=g;break}else{g=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[b+360>>2]|0)+88|0]|0)|0;a[(c[b+352>>2]|0)+88|0]=g;e=g;break}}else{if(f){f=a[(c[b+356>>2]|0)+88|0]|0;g=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;a[(c[b+352>>2]|0)+88|0]=g;e=f;break}else{f=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;a[(c[b+352>>2]|0)+88|0]=f;e=f;break}}}}while(0);f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;if(e<<24>>24==0){k=0.0;l=f;m=l+2328|0;n=m;h[n>>3]=k;i=d;return}k=+h[f+2336>>3];l=f;m=l+2328|0;n=m;h[n>>3]=k;i=d;return}function fV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6488>>3]=+h[b+2368>>3]+ +h[b+2328>>3];i=i;return}function gV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0,n=0,o=0;b=i;d=a+4|0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+2336>>3];if(e<<24>>24==0){j=f+256|0;k=+h[j>>3];l=g*k;m=f;n=m+2344|0;o=n;h[o>>3]=l;i=b;return}else{j=(c[a+416>>2]|0)+3e3|0;k=+h[j>>3];l=g*k;m=f;n=m+2344|0;o=n;h[o>>3]=l;i=b;return}}function hV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;fv(e,c[j>>2]|0,+h[(c[k>>2]|0)+3048>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+256>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+3048>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+256>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,+h[d+2336>>3],+h[d+7472>>3],+h[f>>3],+h[(c[k>>2]|0)+872>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+6312>>3]=+h[g>>3];i=b;return}function iV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;e=b+4|0;f=rFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[b+416>>2]|0)+776>>3])|0;do{if((a[b+314|0]|0)==0){g=a[(c[b+356>>2]|0)+87|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){k=a[(c[b+356>>2]|0)+87|0]|0;l=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[b+360>>2]|0)+87|0]|0)|0;a[(c[b+352>>2]|0)+87|0]=l;g=k;break}else{k=lFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[b+360>>2]|0)+87|0]|0)|0;a[(c[b+352>>2]|0)+87|0]=k;g=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+87|0]|0;k=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+87|0]=k;g=j;break}else{j=pFa(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6)|0;a[(c[b+352>>2]|0)+87|0]=j;g=j;break}}}}while(0);if((a[(c[b+408>>2]|0)+14|0]|0)!=0&f<<24>>24==0){m=1;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+14|0;v=u;a[v]=m;i=d;return}m=g<<24>>24!=0|0;n=c[e>>2]|0;o=c[n>>2]|0;p=o;q=p+16|0;r=q;s=c[r>>2]|0;t=s;u=t+14|0;v=u;a[v]=m;i=d;return}function jV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2320>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2320>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6336>>3]=+h[f>>3];i=b;return}function kV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;du(e,c[f>>2]|0,-+h[j+2336>>3],+h[j+6336>>3],+h[j+7464>>3],+h[(c[b+416>>2]|0)+872>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+2336>>3];m=-l;if(k!=0.0){n=j;o=m/k;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}if(l==-0.0){n=j;o=m;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}l=m/+SBa(c[f>>2]|0,k,65368,65360,+h[e>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+6296|0;r=q;h[r>>3]=o;i=d;return}function lV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+2320>>3],+h[a+256>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+2320>>3];l=+h[g+256>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+6328>>3]=+h[f>>3];i=b;return}function mV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=a+416|0;fv(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[l>>2]|0)+3e3>>3],0,0);a=c[j>>2]|0;m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2320>>3];n=+h[(c[l>>2]|0)+3e3>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));mv(f,a,m,n,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;du(g,c[j>>2]|0,-+h[d+2336>>3],+h[d+6328>>3],+h[f>>3],+h[(c[l>>2]|0)+872>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6320>>3]=+h[g>>3];i=b;return}function nV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+82|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+82|0]|0;k=b+4|0;l=oFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3],a[(c[b+360>>2]|0)+82|0]|0)|0;a[(c[b+352>>2]|0)+82|0]=l;e=k;f=j;break}else{j=b+4|0;k=oFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3],a[(c[b+360>>2]|0)+82|0]|0)|0;a[(c[b+352>>2]|0)+82|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+82|0]|0;k=b+4|0;j=sFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3])|0;a[(c[b+352>>2]|0)+82|0]=j;e=k;f=g;break}else{g=b+4|0;k=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[b+416>>2]|0)+1e3>>3])|0;a[(c[b+352>>2]|0)+82|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+29|0]=f;i=d;return}function oV(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+29|0]|0)==0){f=0}else{if((a[e+84|0]|0)==0){f=0;break}f=(a[e+80|0]|0)==0|0}}while(0);a[e+30|0]=f;i=d;return}function pV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+30|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+75|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}if((a[m+80|0]|0)==0){q=0;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+79|0;t=s;a[t]=q;i=d;return}function qV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+81|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+81|0]|0;k=b+4|0;l=mFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+81|0]|0)|0;a[(c[b+352>>2]|0)+81|0]=l;e=k;f=j;break}else{j=b+4|0;k=mFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+81|0]|0)|0;a[(c[b+352>>2]|0)+81|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+81|0]|0;k=b+4|0;j=qFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+81|0]=j;e=k;f=g;break}else{g=b+4|0;k=qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+81|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+27|0]=f;i=d;return}function rV(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+27|0]|0)==0){f=0}else{if((a[e+68|0]|0)==0){f=0;break}f=(a[e+64|0]|0)==0|0}}while(0);a[e+28|0]=f;i=d;return}function sV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+28|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+20|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}if((a[m+64|0]|0)==0){q=0;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+63|0;t=s;a[t]=q;i=d;return}function tV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+17|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+28|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}if((a[m+68|0]|0)==0){q=0;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+67|0;t=s;a[t]=q;i=d;return}function uV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+728>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[72852]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=65480;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Ne[n&127](m,d,65504,e);p=+h[(c[f>>2]|0)+728>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+2288>>3]=p+g*+h[f+264>>3]*2.0;i=b;return}function vV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2280>>3]=+h[b+6464>>3]+ +h[b+2288>>3]*(+h[(c[a+416>>2]|0)+808>>3]- +h[b+6424>>3])*4.9;i=i;return}function wV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;do{if((pFa(+h[f+6424>>3],+h[f+7480>>3])|0)<<24>>24==0){g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+7568>>3]- +h[j+7560>>3];l=+h[j+2280>>3];m=-l;if(k!=0.0){n=m/k;break}if(l==-0.0){n=m;break}n=m/+SBa(c[b+536>>2]|0,k,65600,65592,+h[g>>3],(a[b+319|0]|0)!=0|0)}else{n=0.0}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6480>>3]=n;i=d;return}function xV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6656>>3]=+h[b+2336>>3]+(+h[b+2376>>3]+ +h[b+6480>>3]);i=i;return}function yV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0;b=i;d=a+4|0;e=rFa(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;g=+h[f+6480>>3];if(e<<24>>24==0){j=(c[a+416>>2]|0)+4704|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+592|0;p=o;h[p>>3]=m;i=b;return}else{j=f+6472|0;k=+h[j>>3];l=g*k;m=-l;n=f;o=n+592|0;p=o;h[p>>3]=m;i=b;return}}function zV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+592>>3]+ +h[b+576>>3];i=i;return}function AV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=-+h[b+6480>>3]- +h[b+1320>>3];i=i;return}function BV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+384>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+384|0;h[c[g+2608>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+384>>3]);e=c[f>>2]|0;h[c[e+2612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+6552>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+6552|0;h[(c[e+2608>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+6552>>3]);h[(c[(c[f>>2]|0)+2612>>2]|0)+8>>3]=k;TFa(a,32)|0;j=c[(c[f>>2]|0)+2604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+384>>3]=+h[j>>3];h[f+6552>>3]=+h[j+8>>3];ny(a);oy(a);py(a);qy(a);i=b;return}function CV(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+4720>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6552>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,65624,65616,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+392|0;p=o;h[p>>3]=m;i=d;return}function DV(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+66|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+66|0]|0;k=b+4|0;l=lFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+66|0]|0)|0;a[(c[b+352>>2]|0)+66|0]=l;e=k;f=j;break}else{j=b+4|0;k=lFa(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[b+360>>2]|0)+66|0]|0)|0;a[(c[b+352>>2]|0)+66|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+66|0]|0;k=b+4|0;j=pFa(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+66|0]=j;e=k;f=g;break}else{g=b+4|0;k=pFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],.01)|0;a[(c[b+352>>2]|0)+66|0]=k;e=g;f=k;break}}}}while(0);b=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[b+84|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}if((a[b+68|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}if((a[b+80|0]|0)!=0){m=0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}m=f<<24>>24!=0|0;n=b;o=n+40|0;p=o;a[p]=m;i=d;return}function EV(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;do{if((a[e+40|0]|0)==0){f=0}else{if((a[e+88|0]|0)==0){f=0;break}f=(a[e+84|0]|0)==0|0}}while(0);a[e+18|0]=f;i=d;return}function FV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+32|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+18|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}if((a[m+88|0]|0)==0){q=0;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+87|0;t=s;a[t]=q;i=d;return}function GV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=b+4|0;c[h>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+18|0]|0;BBa(j,1,h);h=b+536|0;b=c[h>>2]|0;o=f;p=j;c[o+0>>2]=c[p+0>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];tv(l,b,f);f=a[l]|0;c[g>>2]=a[(c[(c[c[n>>2]>>2]|0)+16>>2]|0)+30|0]|0;BBa(k,1,g);g=c[h>>2]|0;h=e;l=k;c[h+0>>2]=c[l+0>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];tv(m,g,e);e=a[m]|0;m=c[(c[c[n>>2]>>2]|0)+16>>2]|0;if(!(f<<24>>24==0)){q=1;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}if((a[m+84|0]|0)==0){q=0;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}q=e<<24>>24==0|0;r=m;s=r+83|0;t=s;a[t]=q;i=d;return}function HV(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6504>>3]=+h[b+728>>3]*+h[d+264>>3]+ +h[b+744>>3];i=i;return}function IV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6440>>3]=+h[b+6504>>3]*+h[b+6432>>3];i=i;return}function JV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+2684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+6560>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+6560|0;h[c[g+2688>>2]>>3]=+h[j>>3];k=+VFa(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+6560>>3]);e=c[f>>2]|0;h[c[e+2692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+2684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+528>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+528|0;h[(c[e+2688>>2]|0)+8>>3]=+h[g>>3];k=+VFa(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+528>>3]);h[(c[(c[f>>2]|0)+2692>>2]|0)+8>>3]=k;TFa(a,33)|0;j=c[(c[f>>2]|0)+2684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+6560>>3]=+h[j>>3];h[f+528>>3]=+h[j+8>>3];ty(a);uy(a);i=b;return}function KV(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+728>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+6560>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}q=k/+SBa(c[b+536>>2]|0,e,65648,65640,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+536|0;p=o;h[p>>3]=m;i=d;return}function LV(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6496>>3]=+h[b+6440>>3]*+h[b+256>>3]- +h[(c[a+416>>2]|0)+776>>3]*+h[b+6504>>3];i=i;return}function MV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+353|0]=a[d+348|0]|0;i=i;return}function NV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4768>>3]=+h[b+2568>>3];i=i;return}function OV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4760>>3]=+h[b+2520>>3];i=i;return}function PV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4688>>3]=+h[b+2520>>3];i=i;return}function QV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4680>>3]=+h[b+4472>>3];i=i;return}function RV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+346|0]=a[d+332|0]|0;i=i;return}function SV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4464>>3]=+h[b+2520>>3];i=i;return}function TV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4456>>3]=+h[b+4248>>3];i=i;return}function UV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+326|0]=a[d+312|0]|0;i=i;return}function VV(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+520>>2]=(c[b+516>>2]|0)+ -1;i=i;return}function WV(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+508>>2]=(c[b+504>>2]|0)+ -1;i=i;return}function XV(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+496>>2]=(c[b+492>>2]|0)+ -1;i=i;return}function YV(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+484>>2]=(c[b+480>>2]|0)+ -1;i=i;return}function ZV(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+472>>2]=(c[b+468>>2]|0)+ -1;i=i;return}function _V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3320>>3]=+h[b+2520>>3];i=i;return}function $V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3312>>3]=+h[b+3104>>3];i=i;return}function aW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+236|0]=a[d+222|0]|0;i=i;return}function bW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3272>>3]=+h[b+2528>>3];i=i;return}function cW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+216|0]=a[d+211|0]|0;i=i;return}function dW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3064>>3]=+h[b+2568>>3];i=i;return}function eW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2520>>3];i=i;return}function fW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2984>>3]=+h[b+2520>>3];i=i;return}function gW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+209|0]=a[d+204|0]|0;i=i;return}function hW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2952>>3]=+h[b+2568>>3];i=i;return}function iW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2944>>3]=+h[b+2520>>3];i=i;return}function jW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2872>>3]=+h[b+2520>>3];i=i;return}function kW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+202|0]=a[d+197|0]|0;i=i;return}function lW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2840>>3]=+h[b+2568>>3];i=i;return}function mW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2832>>3]=+h[b+2520>>3];i=i;return}function nW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2760>>3]=+h[b+2520>>3];i=i;return}function oW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+195|0]=a[d+190|0]|0;i=i;return}function pW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2728>>3]=+h[b+2568>>3];i=i;return}function qW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2720>>3]=+h[b+2520>>3];i=i;return}function rW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2544>>3]=+h[b+2568>>3]*100.0;i=i;return}function sW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2504>>3]=+h[b+2520>>3];i=i;return}function tW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+186|0]=a[d+181|0]|0;i=i;return}function uW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2472>>3]=+h[b+2568>>3];i=i;return}function vW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2464>>3]=+h[b+2520>>3];i=i;return}function wW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2392>>3]=+h[b+2520>>3];i=i;return}function xW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+179|0]=a[d+172|0]|0;i=i;return}function yW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2336>>3]=+h[b+2280>>3];i=i;return}function zW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2272>>3]=+h[b+2520>>3];i=i;return}function AW(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+166|0]=a[d+159|0]|0;i=i;return}function BW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2216>>3]=+h[b+2160>>3];i=i;return}function CW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2144>>3]=+h[b+2536>>3];i=i;return}function DW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2056>>3]=+h[b+2536>>3];i=i;return}function EW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2e3>>3]=+h[b+2536>>3];i=i;return}function FW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1944>>3]=+h[b+2536>>3];i=i;return}function GW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1888>>3]=+h[b+2536>>3];i=i;return}function HW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1832>>3]=+h[b+2536>>3];i=i;return}function IW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+2536>>3];i=i;return}function JW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+2536>>3];i=i;return}function KW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1664>>3]=+h[b+2536>>3];i=i;return}function LW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1608>>3]=+h[b+2536>>3];i=i;return}function MW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+2536>>3];i=i;return}function NW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+2536>>3];i=i;return}function OW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+2536>>3];i=i;return}function PW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1384>>3]=+h[b+2536>>3];i=i;return}function QW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+2536>>3];i=i;return}function RW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1272>>3]=+h[b+2536>>3];i=i;return}function SW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+2536>>3];i=i;return}function TW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1160>>3]=+h[b+2536>>3];i=i;return}function UW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+2536>>3];i=i;return}function VW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+2536>>3];i=i;return}function WW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+416|0;a=c[g>>2]|0;j=+h[a+776>>3];k=+h[a+760>>3];a=d;l=65664;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];qt(e,f,j,k,d,0);h[(c[g>>2]|0)+768>>3]=+h[e>>3];i=b;return}function XW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function YW(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+124|0]=0;i=i;return}function ZW(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+123|0]=0;i=i;return}function _W(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function $W(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=0.0;i=i;return}function aX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function bX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function cX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function dX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function eX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function fX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function gX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function hX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=0.0;i=i;return}function iX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function jX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function kX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function lX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+122|0]=0;i=i;return}function mX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+121|0]=0;i=i;return}function nX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+120|0]=0;i=i;return}function oX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+119|0]=0;i=i;return}function pX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+118|0]=0;i=i;return}function qX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=3.0;i=i;return}function rX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=0.0;i=i;return}function sX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=3.0;i=i;return}function tX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function uX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function vX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function wX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function xX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=0.0;i=i;return}function yX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function zX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function AX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=0.0;i=i;return}function BX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function CX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function DX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function EX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=0;i=i;return}function FX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function GX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function HX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function IX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function JX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function KX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function LX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function MX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function NX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function OX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function PX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=1.0e-4;i=i;return}function QX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=1.0e-4;i=i;return}function RX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+117|0]=1;i=i;return}function SX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+116|0]=1;i=i;return}function TX(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+115|0]=1;i=i;return}function UX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+216|0;d=b;e=b+104|0;f=b+208|0;g=a+536|0;j=a+416|0;Xu(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3]);k=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=d+0|0;g=e+0|0;e=j+104|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));nv(f,k,l,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=+h[f>>3];i=b;return}function VX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7536>>3]=+h[(c[a+416>>2]|0)+776>>3]*1.0e-5;i=i;return}function WX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=0.0;i=i;return}function XX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=0.0;i=i;return}function YX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function ZX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=0.0;i=i;return}function _X(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=0;i=i;return}function $X(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=0;i=i;return}function aY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=1.0;i=i;return}function bY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=461.5236365065454;i=i;return}function cY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=.018015268;i=i;return}function dY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=1.0;i=i;return}function eY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=461.5236365065454;i=i;return}function fY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=.018015268;i=i;return}function gY(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=0;i=i;return}function hY(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=0;i=i;return}function iY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=1.0;i=i;return}function jY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=461.5236365065454;i=i;return}function kY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=.018015268;i=i;return}function lY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=1.0;i=i;return}function mY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=461.5236365065454;i=i;return}function nY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=.018015268;i=i;return}function oY(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=0;i=i;return}function pY(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=0;i=i;return}function qY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=1.0;i=i;return}function rY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=461.5236365065454;i=i;return}function sY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=.018015268;i=i;return}function tY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=1.0;i=i;return}function uY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=461.5236365065454;i=i;return}function vY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=.018015268;i=i;return}function wY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=1.0;i=i;return}function xY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=461.5236365065454;i=i;return}function yY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=.018015268;i=i;return}function zY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function AY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=1.0;i=i;return}function BY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=461.5236365065454;i=i;return}function CY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=.018015268;i=i;return}function DY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function EY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=1.0;i=i;return}function FY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=461.5236365065454;i=i;return}function GY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=.018015268;i=i;return}function HY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function IY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=1.0;i=i;return}function JY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=461.5236365065454;i=i;return}function KY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=.018015268;i=i;return}function LY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=0.0;i=i;return}function MY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=0.0;i=i;return}function NY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=1.0;i=i;return}function OY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=461.5236365065454;i=i;return}function PY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=.018015268;i=i;return}function QY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=0.0;i=i;return}function RY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=1.0;i=i;return}function SY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=461.5236365065454;i=i;return}function TY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7176>>3]=.018015268;i=i;return}function UY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=0.0;i=i;return}function VY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=1.0;i=i;return}function WY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=461.5236365065454;i=i;return}function XY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=.018015268;i=i;return}function YY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7152>>3]=0.0;i=i;return}function ZY(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=0;i=i;return}function _Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=.01041879415735609;i=i;return}function $Y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=1.0;i=i;return}function aZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7144>>3]=461.5236365065454;i=i;return}function bZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=.018015268;i=i;return}function cZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function dZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=0;i=i;return}function eZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=.01041879415735609;i=i;return}function fZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function gZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7120>>3]=461.5236365065454;i=i;return}function hZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=.018015268;i=i;return}function iZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=0;i=i;return}function jZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=0;i=i;return}function kZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=1.0;i=i;return}function lZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=461.5236365065454;i=i;return}function mZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=.018015268;i=i;return}function nZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=0;i=i;return}function oZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=0;i=i;return}function pZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=0;i=i;return}function qZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=0;i=i;return}function rZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=0;i=i;return}function sZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=0;i=i;return}function tZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=0;i=i;return}function uZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=0;i=i;return}function vZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function wZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=0;i=i;return}function xZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=0;i=i;return}function yZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=0;i=i;return}function zZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function AZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=0;i=i;return}function BZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function CZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=0;i=i;return}function DZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=0;i=i;return}function EZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function FZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=0;i=i;return}function GZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=0;i=i;return}function HZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=0;i=i;return}function IZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=0;i=i;return}function JZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=0;i=i;return}function KZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=0;i=i;return}function LZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=0;i=i;return}function MZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=0;i=i;return}function NZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function OZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=0;i=i;return}function PZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=0;i=i;return}function QZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=0;i=i;return}function RZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=0;i=i;return}function SZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function TZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function UZ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=0;i=i;return}function VZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function WZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function XZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function YZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function ZZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function _Z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function $Z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function a_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=0.0;i=i;return}function b_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function c_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function d_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7008>>3]=0.0;i=i;return}function e_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function f_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function g_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function h_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=0.0;i=i;return}function i_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function j_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=0.0;i=i;return}function k_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function l_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=0.0;i=i;return}function m_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6936>>3]=0.0;i=i;return}function n_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function o_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=0.0;i=i;return}function p_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6912>>3]=0.0;i=i;return}function q_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function r_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function s_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function t_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function u_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function v_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function w_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function x_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function y_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=0.0;i=i;return}function z_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function A_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function B_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function C_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=0;i=i;return}function D_(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=0;i=i;return}function E_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=1.0;i=i;return}function F_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=461.5236365065454;i=i;return}function G_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=.018015268;i=i;return}function H_(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+107|0]=0;i=i;return}function I_(b){b=b|0;a[(c[b+408>>2]|0)+17|0]=0;i=i;return}function J_(b){b=b|0;a[(c[b+408>>2]|0)+18|0]=0;i=i;return}function K_(b){b=b|0;a[(c[b+408>>2]|0)+20|0]=0;i=i;return}function L_(b){b=b|0;a[(c[b+408>>2]|0)+22|0]=0;i=i;return}function M_(b){b=b|0;a[(c[b+408>>2]|0)+24|0]=0;i=i;return}function N_(b){b=b|0;a[(c[b+408>>2]|0)+26|0]=0;i=i;return}function O_(b){b=b|0;a[(c[b+408>>2]|0)+28|0]=0;i=i;return}function P_(b){b=b|0;a[(c[b+408>>2]|0)+30|0]=0;i=i;return}function Q_(b){b=b|0;a[(c[b+408>>2]|0)+32|0]=0;i=i;return}function R_(b){b=b|0;a[(c[b+408>>2]|0)+34|0]=0;i=i;return}function S_(b){b=b|0;a[(c[b+408>>2]|0)+36|0]=0;i=i;return}function T_(b){b=b|0;a[(c[b+408>>2]|0)+38|0]=0;i=i;return}function U_(b){b=b|0;a[(c[b+408>>2]|0)+76|0]=0;i=i;return}function V_(b){b=b|0;a[(c[b+408>>2]|0)+94|0]=0;i=i;return}function W_(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+314|0;a[e]=1;uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);f=b+484|0;c[c[(c[f>>2]|0)+20>>2]>>2]=(c[(c[c[b+4>>2]>>2]|0)+12>>2]|0)+108;c[c[(c[f>>2]|0)+24>>2]>>2]=(c[b+404>>2]|0)+108;wFa(b,0)|0;yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);ZV(b);_V(b);$V(b);aW(b);bW(b);cW(b);dW(b);eW(b);fW(b);gW(b);hW(b);iW(b);jW(b);kW(b);lW(b);mW(b);nW(b);oW(b);pW(b);qW(b);rW(b);sW(b);tW(b);uW(b);vW(b);wW(b);xW(b);yW(b);zW(b);AW(b);BW(b);CW(b);DW(b);EW(b);FW(b);GW(b);HW(b);IW(b);JW(b);KW(b);LW(b);MW(b);NW(b);OW(b);PW(b);QW(b);RW(b);SW(b);TW(b);UW(b);VW(b);WW(b);XW(b);YW(b);ZW(b);_W(b);$W(b);aX(b);bX(b);cX(b);dX(b);eX(b);fX(b);gX(b);hX(b);iX(b);jX(b);kX(b);lX(b);mX(b);nX(b);oX(b);pX(b);qX(b);rX(b);sX(b);tX(b);uX(b);vX(b);wX(b);xX(b);yX(b);zX(b);AX(b);BX(b);CX(b);DX(b);EX(b);FX(b);GX(b);HX(b);IX(b);JX(b);KX(b);LX(b);MX(b);NX(b);OX(b);PX(b);QX(b);RX(b);SX(b);TX(b);UX(b);VX(b);WX(b);XX(b);YX(b);ZX(b);_X(b);$X(b);aY(b);bY(b);cY(b);dY(b);eY(b);fY(b);gY(b);hY(b);iY(b);jY(b);kY(b);lY(b);mY(b);nY(b);oY(b);pY(b);qY(b);rY(b);sY(b);tY(b);uY(b);vY(b);wY(b);xY(b);yY(b);zY(b);AY(b);BY(b);CY(b);DY(b);EY(b);FY(b);GY(b);HY(b);IY(b);JY(b);KY(b);LY(b);MY(b);NY(b);OY(b);PY(b);QY(b);RY(b);SY(b);TY(b);UY(b);VY(b);WY(b);XY(b);YY(b);ZY(b);_Y(b);$Y(b);aZ(b);bZ(b);cZ(b);dZ(b);eZ(b);fZ(b);gZ(b);hZ(b);iZ(b);jZ(b);kZ(b);lZ(b);mZ(b);nZ(b);oZ(b);pZ(b);qZ(b);rZ(b);sZ(b);tZ(b);uZ(b);vZ(b);wZ(b);xZ(b);yZ(b);zZ(b);AZ(b);BZ(b);CZ(b);DZ(b);EZ(b);FZ(b);GZ(b);HZ(b);IZ(b);JZ(b);KZ(b);LZ(b);MZ(b);NZ(b);OZ(b);PZ(b);QZ(b);RZ(b);SZ(b);TZ(b);UZ(b);VZ(b);WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);a[e]=0;i=d;return 0}function X_(a){a=a|0;c[a+4>>2]=1162;c[a>>2]=1;c[a+12>>2]=233;c[a+16>>2]=234;i=i;return}function Y_(a){a=a|0;i=i;return 0}function Z_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=+h[(c[a+416>>2]|0)+4808>>3];i=i;return}function __(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=+h[(c[a+416>>2]|0)+4816>>3];i=i;return}function $_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=+h[(c[a+416>>2]|0)+4832>>3];i=i;return}function a$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[(c[a+416>>2]|0)+4696>>3];i=i;return}function b$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+112>>3]=+h[(c[a+416>>2]|0)+4704>>3];i=i;return}function c$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[(c[a+416>>2]|0)+4776>>3];i=i;return}function d$(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+4520>>3];i=i;return}function e$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+4520>>3];i=i;return}function f$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+696>>3]=+h[b+4584>>3]- +h[b+4592>>3];i=i;return}function g$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+808>>3]=+h[(c[a+416>>2]|0)+1720>>3];i=i;return}function h$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=+h[(c[a+416>>2]|0)+1832>>3];i=i;return}function i$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+4296>>3];i=i;return}function j$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[(c[a+416>>2]|0)+4296>>3];i=i;return}function k$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=+h[b+4360>>3]- +h[b+4368>>3];i=i;return}function l$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=+h[(c[a+416>>2]|0)+1608>>3];i=i;return}function m$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1088>>3]=+h[(c[a+416>>2]|0)+1664>>3];i=i;return}function n$(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+516>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+4160>>3]- +h[g+4168>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+SBa(c[b+536>>2]|0,f,65760,65752,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=k;i=d;return}function o$(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+504>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+3976>>3]- +h[g+3984>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+SBa(c[b+536>>2]|0,f,65808,65800,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1296>>3]=k;i=d;return}function p$(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+492>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+3792>>3]- +h[g+3800>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+SBa(c[b+536>>2]|0,f,65856,65848,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1416>>3]=k;i=d;return}function q$(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+480>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+3608>>3]- +h[g+3616>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+SBa(c[b+536>>2]|0,f,65904,65896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=k;i=d;return}function r$(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+468>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+3424>>3]- +h[g+3432>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+SBa(c[b+536>>2]|0,f,65952,65944,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=k;i=d;return}function s$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=+h[(c[a+416>>2]|0)+3152>>3];i=i;return}function t$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+80>>3]=+h[(c[a+416>>2]|0)+3152>>3];i=i;return}function u$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=+h[b+3216>>3]- +h[b+3224>>3];i=i;return}function v$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=-+h[(c[a+416>>2]|0)+1328>>3];i=i;return}function w$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=+h[(c[a+416>>2]|0)+1384>>3];i=i;return}function x$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=+h[(c[a+416>>2]|0)+2992>>3];i=i;return}function y$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+128>>3]=+h[(c[a+416>>2]|0)+3e3>>3];i=i;return}function z$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[(c[a+416>>2]|0)+3072>>3];i=i;return}function A$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=+h[(c[a+416>>2]|0)+2880>>3];i=i;return}function B$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[(c[a+416>>2]|0)+2888>>3];i=i;return}function C$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[(c[a+416>>2]|0)+2960>>3];i=i;return}function D$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=+h[(c[a+416>>2]|0)+2768>>3];i=i;return}function E$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+2776>>3];i=i;return}function F$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[(c[a+416>>2]|0)+2848>>3];i=i;return}function G$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2152>>3]=+h[(c[a+416>>2]|0)+2656>>3];i=i;return}function H$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[(c[a+416>>2]|0)+2664>>3];i=i;return}function I$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+184>>3]=+h[(c[a+416>>2]|0)+2736>>3];i=i;return}function J$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2208>>3]=+h[(c[a+416>>2]|0)+2400>>3];i=i;return}function K$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+192>>3]=+h[(c[a+416>>2]|0)+2408>>3];i=i;return}function L$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+200>>3]=+h[(c[a+416>>2]|0)+2480>>3];i=i;return}function M$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2264>>3]=+h[(c[a+416>>2]|0)+2296>>3];i=i;return}function N$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+208>>3]=+h[(c[a+416>>2]|0)+2304>>3];i=i;return}function O$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+216>>3]=+h[(c[a+416>>2]|0)+2352>>3];i=i;return}function P$(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+(c[(c[b+420>>2]|0)+220>>2]|0)*+h[e+2344>>3];g=+h[e+2320>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66e3,65992,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=j;i=d;return}function Q$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=+h[(c[a+416>>2]|0)+2280>>3];i=i;return}function R$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=+h[(c[a+416>>2]|0)+2312>>3];i=i;return}function S$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2272>>3]=+h[(c[a+416>>2]|0)+2176>>3];i=i;return}function T$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[(c[a+416>>2]|0)+2184>>3];i=i;return}function U$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[(c[a+416>>2]|0)+2232>>3];i=i;return}function V$(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+(c[(c[b+420>>2]|0)+196>>2]|0)*+h[e+2224>>3];g=+h[e+2200>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+SBa(c[b+536>>2]|0,f,66048,66040,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=j;i=d;return}function W$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=+h[(c[a+416>>2]|0)+2160>>3];i=i;return}function X$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=+h[(c[a+416>>2]|0)+2192>>3];i=i;return}function Y$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=+h[(c[a+416>>2]|0)+2136>>3];i=i;return}function Z$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=+h[(c[a+416>>2]|0)+2072>>3];i=i;return}function _$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+240>>3]=+h[(c[a+416>>2]|0)+2080>>3];i=i;return}function $$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[(c[a+416>>2]|0)+2096>>3];i=i;return}function a0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=+h[(c[a+416>>2]|0)+2056>>3];i=i;return}function b0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=+h[(c[a+416>>2]|0)+2048>>3];i=i;return}function c0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=+h[(c[a+416>>2]|0)+1992>>3];i=i;return}function d0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=+h[(c[a+416>>2]|0)+1944>>3];i=i;return}function e0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=+h[(c[a+416>>2]|0)+1936>>3];i=i;return}function f0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=+h[(c[a+416>>2]|0)+1888>>3];i=i;return}function g0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=+h[(c[a+416>>2]|0)+1880>>3];i=i;return}function h0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=+h[(c[a+416>>2]|0)+1824>>3];i=i;return}function i0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=+h[(c[a+416>>2]|0)+2320>>3];i=i;return}function j0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=+h[(c[a+416>>2]|0)+1768>>3];i=i;return}function k0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=+h[(c[a+416>>2]|0)+1712>>3];i=i;return}function l0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5392>>3]=+h[(c[a+416>>2]|0)+1656>>3];i=i;return}function m0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=+h[(c[a+416>>2]|0)+1600>>3];i=i;return}function n0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=+h[(c[a+416>>2]|0)+2200>>3];i=i;return}function o0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=+h[(c[a+416>>2]|0)+1544>>3];i=i;return}function p0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=+h[(c[a+416>>2]|0)+1488>>3];i=i;return}function q0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=+h[(c[a+416>>2]|0)+1432>>3];i=i;return}function r0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=+h[(c[a+416>>2]|0)+1376>>3];i=i;return}function s0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5800>>3]=+h[(c[a+416>>2]|0)+1320>>3];i=i;return}function t0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=+h[(c[a+416>>2]|0)+1264>>3];i=i;return}function u0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=+h[(c[a+416>>2]|0)+1208>>3];i=i;return}function v0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=+h[(c[a+416>>2]|0)+1152>>3];i=i;return}function w0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=+h[(c[a+416>>2]|0)+904>>3];i=i;return}function x0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=+h[(c[a+416>>2]|0)+848>>3];i=i;return}function y0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2336>>3]=-+h[(c[a+416>>2]|0)+912>>3];i=i;return}function z0(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2376>>3]=-+h[(c[a+416>>2]|0)+856>>3];i=i;return}function A0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(+-((c[(c[a+420>>2]|0)+696>>2]|0)==2?0.0:1.0e+60),-1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=d;i=b;return}function B0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e+60,+(+xd(+((c[(c[a+420>>2]|0)+156>>2]|0)==1?0.0:-1.0e+60),-1.0e+60)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+808>>3]=d;i=b;return}function C0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e+60,+(+xd(+((c[(c[a+420>>2]|0)+144>>2]|0)==1?0.0:-1.0e+60),-1.0e+60)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=d;i=b;return}function D0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e5,+(+xd(+((c[(c[a+420>>2]|0)+148>>2]|0)==1?0.0:-1.0e+60),-1.0e5)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=d;i=b;return}function E0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e+60,+(+xd(+-((c[(c[a+420>>2]|0)+160>>2]|0)==2?0.0:1.0e+60),-1.0e+60)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=d;i=b;return}function F0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0;b=i;d=c[a+420>>2]|0;e=(c[d+168>>2]|0)==1?0.0:-1.0e+60;f=+xd(+e,+(+xd(-1.0e+60,+(+xd(+-((c[d+692>>2]|0)==2?0.0:1.0e+60),-1.0e+60)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=f;i=b;return}function G0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(+((c[(c[a+420>>2]|0)+176>>2]|0)==1?0.0:-1.0e+60),-1.0e+60);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=d;i=b;return}function H0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e+60,+(+xd(-1.0e+60,+(+xd(+-((c[(c[a+420>>2]|0)+172>>2]|0)==2?0.0:1.0e+60),-1.0e+60)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=d;i=b;return}function I0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(-1.0e+60,+(+xd(-1.0e+60,+(+xd(+-((c[(c[a+420>>2]|0)+688>>2]|0)==2?0.0:1.0e+60),-1.0e+60)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=d;i=b;return}function J0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(0.0,+(+xd(-1.0e+60,+(+xd(+-((c[(c[a+420>>2]|0)+164>>2]|0)==2?0.0:1.0e+60),-1.0e+60)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=d;i=b;return}function K0(a){a=a|0;var b=0,d=0.0;b=i;d=+xd(0.0,+(+xd(-1.0e+60,+(+xd(+-((c[(c[a+420>>2]|0)+152>>2]|0)==2?0.0:1.0e+60),-1.0e+60)))));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=d;i=b;return}function L0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(+-((c[(c[a+420>>2]|0)+696>>2]|0)==1?0.0:-1.0e+60),1.0e5);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=d;i=b;return}function M0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(+((c[(c[a+420>>2]|0)+156>>2]|0)==2?0.0:1.0e+60),1.0e5)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+808>>3]=d;i=b;return}function N0(a){a=a|0;var b=0,d=0.0;b=i;d=+wd(1.0e5,+(+wd(+((c[(c[a+420>>2]|0)+144>>2]|0)==2?0.0:1.0e+60),1.0e5)));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=d;i=b;return}



function Bta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211824]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(211832,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211824]=1;i=d;return}function Cta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211992]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(212e3,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[211992]=1;i=d;return}function Dta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212160]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(212168,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[212160]=1;i=d;return}function Eta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1256>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(212352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1256>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[212344]=1;i=d;return}function Fta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212512]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(212520,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[212512]=1;i=d;return}function Gta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(212688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[212680]=1;i=d;return}function Hta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212864]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(212872,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[212864]=1;i=d;return}function Ita(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213048]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(213056,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213048]=1;i=d;return}function Jta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213232]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(213240,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213232]=1;i=d;return}function Kta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213384]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(213392,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213384]=1;i=d;return}function Lta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213536]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(213544,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213536]=1;i=d;return}function Mta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213704]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3736>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3736>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(213712,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3736>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213704]=1;i=d;return}function Nta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213856]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3728>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3728>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(213864,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3728>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[213856]=1;i=d;return}function Ota(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214008]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(214016,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[214008]=1;i=d;return}function Pta(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214176]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(214184,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[214176]=1;i=d;return}function Qta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214344]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(214352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[214344]=1;i=d;return}function Rta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214448]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(214456,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[214448]=1;i=d;return}function Sta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(214560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[214552]=1;i=d;return}function Tta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214712]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(214720,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[214712]=1;i=d;return}function Uta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214872]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(214880,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],167016)|0)|0;g=c[72854]|0;j=e;k=221544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[214872]=1;i=d;return}function Vta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215040]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(215048,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],167016)|0)|0;g=c[72854]|0;j=e;k=221544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[215040]=1;i=d;return}function Wta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215208]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3];k=b+420|0;b=sFa(j,+xd(-1.0e+60,+(+xd(+((c[(c[k>>2]|0)+144>>2]|0)==1?0.0:-1.0e+60),-1.0e+60))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(+((c[(c[k>>2]|0)+144>>2]|0)==2?0.0:1.0e+60),1.0e5))))|0)<<24>>24==0)){i=d;return}k=ACa(215216,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],167016)|0)|0;g=c[72854]|0;b=e;l=221544;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[215208]=1;i=d;return}function Xta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215672]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(215680,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[215672]=1;i=d;return}function Yta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215840]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(215848,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[215840]=1;i=d;return}function Zta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216008]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(216016,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216008]=1;i=d;return}function _ta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216176]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(216184,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216176]=1;i=d;return}function $ta(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(216360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216352]=1;i=d;return}function aua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216528]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(216536,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216528]=1;i=d;return}function bua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216712]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(216720,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216712]=1;i=d;return}function cua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216888]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(216896,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[216888]=1;i=d;return}function dua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217064]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(217072,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217064]=1;i=d;return}function eua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217248]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(217256,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217248]=1;i=d;return}function fua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217408]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(217416,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217408]=1;i=d;return}function gua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217584]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(217592,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217584]=1;i=d;return}function hua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(217760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217752]=1;i=d;return}function iua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217928]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(217936,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[217928]=1;i=d;return}function jua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218088]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(218096,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218088]=1;i=d;return}function kua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218264]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(218272,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218264]=1;i=d;return}function lua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218432]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(218440,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218432]=1;i=d;return}function mua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218608]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(218616,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218608]=1;i=d;return}function nua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218784]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(218792,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218784]=1;i=d;return}function oua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218960]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3720>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3720>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(218968,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3720>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[218960]=1;i=d;return}function pua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3712>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3712>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(219120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3712>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[219112]=1;i=d;return}function qua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219264]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3704>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3704>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(219272,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3704>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[219264]=1;i=d;return}function rua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219456]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3696>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(219464,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3696>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[219456]=1;i=d;return}function sua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219632]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3688>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3688>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(219640,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3688>>3],167016)|0)|0;g=c[72854]|0;j=e;k=219784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[219632]=1;i=d;return}function tua(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219808]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(219816,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[219808]=1;i=d;return}function uua(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219976]&1){i=d;return}g=b+4|0;b=sFa(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(219984,xCa(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=220144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[219976]=1;i=d;return}function vua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220168]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(220176,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220168]=1;i=d;return}function wua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220272]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(220280,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220272]=1;i=d;return}function xua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220400]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(220408,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220400]=1;i=d;return}function yua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],-1.0e5)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(220568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],167016)|0)|0;g=c[72854]|0;j=e;k=220720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220560]=1;i=d;return}function zua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220744]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(220752,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],167016)|0)|0;g=c[72854]|0;j=e;k=221544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220744]=1;i=d;return}function Aua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220912]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(220920,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],167016)|0)|0;g=c[72854]|0;j=e;k=221544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[220912]=1;i=d;return}function Bua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221080]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3];k=b+420|0;b=sFa(j,+xd(-1.0e+60,+(+xd(+((c[(c[k>>2]|0)+156>>2]|0)==1?0.0:-1.0e+60),-1.0e+60))))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3];if(!(b<<24>>24==0|(qFa(j,+wd(1.0e5,+(+wd(+((c[(c[k>>2]|0)+156>>2]|0)==2?0.0:1.0e+60),1.0e5))))|0)<<24>>24==0)){i=d;return}k=ACa(221088,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],167016)|0)|0;g=c[72854]|0;b=e;l=221544;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[221080]=1;i=d;return}function Cua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221568]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(221576,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[221568]=1;i=d;return}function Dua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221736]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(221744,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[221736]=1;i=d;return}function Eua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221904]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(221912,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[221904]=1;i=d;return}function Fua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222096]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(222104,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[222096]=1;i=d;return}function Gua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222272]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(222280,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[222272]=1;i=d;return}function Hua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222472]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(222480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],167016)|0)|0;g=c[72854]|0;j=e;k=222656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[222472]=1;i=d;return}function Iua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222680]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(222688,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[222680]=1;i=d;return}function Jua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222856]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(222864,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[222856]=1;i=d;return}function Kua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223056]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(223064,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],167016)|0)|0;g=c[72854]|0;j=e;k=223240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223056]=1;i=d;return}function Lua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223264]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(223272,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223264]=1;i=d;return}function Mua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(223432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223424]=1;i=d;return}function Nua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223600]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(223608,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223600]=1;i=d;return}function Oua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223768]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(223776,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223768]=1;i=d;return}function Pua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223944]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(223952,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[223944]=1;i=d;return}function Qua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224104]&1){i=d;return}g=b+4|0;b=sFa(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(224112,vCa(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224104]=1;i=d;return}function Rua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224280]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+656>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(224288,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+656>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224280]=1;i=d;return}function Sua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224448]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(224456,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224448]=1;i=d;return}function Tua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224624]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(224632,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224624]=1;i=d;return}function Uua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224800]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(224808,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224800]=1;i=d;return}function Vua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224976]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(224984,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3672>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[224976]=1;i=d;return}function Wua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225056]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(225064,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225056]=1;i=d;return}function Xua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225224]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(225232,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225224]=1;i=d;return}function Yua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225376]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(225384,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225376]=1;i=d;return}function Zua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225576]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(225584,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],167016)|0)|0;g=c[72854]|0;j=e;k=225664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225576]=1;i=d;return}function _ua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225688]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(225696,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225688]=1;i=d;return}function $ua(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225824]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(225832,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225824]=1;i=d;return}function ava(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225944]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(225952,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[225944]=1;i=d;return}function bva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226072]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(226080,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[226072]=1;i=d;return}function cva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(226200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[226192]=1;i=d;return}function dva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226368]&1){i=d;return}g=b+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3592>>3];k=b+420|0;b=sFa(j,+xd(+-((c[(c[k>>2]|0)+696>>2]|0)==2?0.0:1.0e+60),-1.0e5))|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3592>>3];if(!(b<<24>>24==0|(qFa(j,+wd(+-((c[(c[k>>2]|0)+696>>2]|0)==1?0.0:-1.0e+60),1.0e5))|0)<<24>>24==0)){i=d;return}k=ACa(226376,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3592>>3],167016)|0)|0;g=c[72854]|0;b=e;l=226784;c[b+0>>2]=c[l+0>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[b+16>>2]=c[l+16>>2];c[b+20>>2]=c[l+20>>2];Je[g&15](e,k,f);a[226368]=1;i=d;return}function eva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226808]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3584>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3584>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(226816,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3584>>3],167016)|0)|0;g=c[72854]|0;j=e;k=226992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[226808]=1;i=d;return}function fva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227016]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(227024,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3568>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227016]=1;i=d;return}function gva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227128]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(227136,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227128]=1;i=d;return}function hva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227288]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(227296,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227288]=1;i=d;return}function iva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227464]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(227472,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227464]=1;i=d;return}function jva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227624]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(227632,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227624]=1;i=d;return}function kva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227784]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],-1.0e8)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(227792,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],167016)|0)|0;g=c[72854]|0;j=e;k=227928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227784]=1;i=d;return}function lva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227952]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(227960,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],167016)|0)|0;g=c[72854]|0;j=e;k=228104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[227952]=1;i=d;return}function mva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228128]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(228136,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,169304)|0)|0;g=c[72854]|0;h=e;j=228264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[228128]=1;i=d;return}function nva(a){a=a|0;var b=0;b=i;Una(a);Vna(a);Wna(a);Xna(a);Yna(a);Zna(a);_na(a);$na(a);aoa(a);boa(a);coa(a);doa(a);eoa(a);foa(a);goa(a);hoa(a);ioa(a);joa(a);koa(a);loa(a);moa(a);noa(a);ooa(a);poa(a);qoa(a);roa(a);soa(a);toa(a);uoa(a);voa(a);woa(a);xoa(a);yoa(a);zoa(a);Aoa(a);Boa(a);Coa(a);Doa(a);Eoa(a);Foa(a);Goa(a);Hoa(a);Ioa(a);Joa(a);Koa(a);Loa(a);Moa(a);Noa(a);Ooa(a);Poa(a);Qoa(a);Roa(a);Soa(a);Toa(a);Uoa(a);Voa(a);Woa(a);Xoa(a);Yoa(a);Zoa(a);_oa(a);$oa(a);apa(a);bpa(a);cpa(a);dpa(a);epa(a);fpa(a);gpa(a);hpa(a);ipa(a);jpa(a);kpa(a);lpa(a);mpa(a);npa(a);opa(a);ppa(a);qpa(a);rpa(a);spa(a);tpa(a);upa(a);vpa(a);wpa(a);xpa(a);ypa(a);zpa(a);Apa(a);Bpa(a);Cpa(a);Dpa(a);Epa(a);Fpa(a);Gpa(a);Hpa(a);Ipa(a);Jpa(a);Kpa(a);Lpa(a);Mpa(a);Npa(a);Opa(a);Ppa(a);Qpa(a);Rpa(a);Spa(a);Tpa(a);Upa(a);Vpa(a);Wpa(a);Xpa(a);Ypa(a);Zpa(a);_pa(a);$pa(a);aqa(a);bqa(a);cqa(a);dqa(a);eqa(a);fqa(a);gqa(a);hqa(a);iqa(a);jqa(a);kqa(a);lqa(a);mqa(a);nqa(a);oqa(a);pqa(a);qqa(a);rqa(a);sqa(a);tqa(a);uqa(a);vqa(a);wqa(a);xqa(a);yqa(a);zqa(a);Aqa(a);Bqa(a);Cqa(a);Dqa(a);Eqa(a);Fqa(a);Gqa(a);Hqa(a);Iqa(a);Jqa(a);Kqa(a);Lqa(a);Mqa(a);Nqa(a);Oqa(a);Pqa(a);Qqa(a);Rqa(a);Sqa(a);Tqa(a);Uqa(a);Vqa(a);Wqa(a);Xqa(a);Yqa(a);Zqa(a);_qa(a);$qa(a);ara(a);bra(a);cra(a);dra(a);era(a);fra(a);gra(a);hra(a);ira(a);jra(a);kra(a);lra(a);mra(a);nra(a);ora(a);pra(a);qra(a);rra(a);sra(a);tra(a);ura(a);vra(a);wra(a);xra(a);yra(a);zra(a);Ara(a);Bra(a);Cra(a);Dra(a);Era(a);Fra(a);Gra(a);Hra(a);Ira(a);Jra(a);Kra(a);Lra(a);Mra(a);Nra(a);Ora(a);Pra(a);Qra(a);Rra(a);Sra(a);Tra(a);Ura(a);Vra(a);Wra(a);Xra(a);Yra(a);Zra(a);_ra(a);$ra(a);asa(a);bsa(a);csa(a);dsa(a);esa(a);fsa(a);gsa(a);hsa(a);isa(a);jsa(a);ksa(a);lsa(a);msa(a);nsa(a);osa(a);psa(a);qsa(a);rsa(a);ssa(a);tsa(a);usa(a);vsa(a);wsa(a);xsa(a);ysa(a);zsa(a);Asa(a);Bsa(a);Csa(a);Dsa(a);Esa(a);Fsa(a);Gsa(a);Hsa(a);Isa(a);Jsa(a);Ksa(a);Lsa(a);Msa(a);Nsa(a);Osa(a);Psa(a);Qsa(a);Rsa(a);Ssa(a);Tsa(a);Usa(a);Vsa(a);Wsa(a);Xsa(a);Ysa(a);Zsa(a);_sa(a);$sa(a);ata(a);bta(a);cta(a);dta(a);eta(a);fta(a);gta(a);hta(a);ita(a);jta(a);kta(a);lta(a);mta(a);nta(a);ota(a);pta(a);qta(a);rta(a);sta(a);tta(a);uta(a);vta(a);wta(a);xta(a);yta(a);zta(a);Ata(a);Bta(a);Cta(a);Dta(a);Eta(a);Fta(a);Gta(a);Hta(a);Ita(a);Jta(a);Kta(a);Lta(a);Mta(a);Nta(a);Ota(a);Pta(a);Qta(a);Rta(a);Sta(a);Tta(a);Uta(a);Vta(a);Wta(a);Xta(a);Yta(a);Zta(a);_ta(a);$ta(a);aua(a);bua(a);cua(a);dua(a);eua(a);fua(a);gua(a);hua(a);iua(a);jua(a);kua(a);lua(a);mua(a);nua(a);oua(a);pua(a);qua(a);rua(a);sua(a);tua(a);uua(a);vua(a);wua(a);xua(a);yua(a);zua(a);Aua(a);Bua(a);Cua(a);Dua(a);Eua(a);Fua(a);Gua(a);Hua(a);Iua(a);Jua(a);Kua(a);Lua(a);Mua(a);Nua(a);Oua(a);Pua(a);Qua(a);Rua(a);Sua(a);Tua(a);Uua(a);Vua(a);Wua(a);Xua(a);Yua(a);Zua(a);_ua(a);$ua(a);ava(a);bva(a);cva(a);dva(a);eva(a);fva(a);gva(a);hva(a);iva(a);jva(a);kva(a);lva(a);mva(a);i=b;return 0}function ova(b){b=b|0;var d=0;d=i;xU(b);a[(c[b+484>>2]|0)+8|0]=a[(c[b+468>>2]|0)+2232|0]|0;i=d;return}function pva(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;mu(k,c[p>>2]|0,+h[(c[q>>2]|0)+776>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+776>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+75|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+75|0]|0;g=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+75|0]|0)|0;a[(c[b+352>>2]|0)+75|0]=g;v=t;break}else{t=lFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+75|0]|0)|0;a[(c[b+352>>2]|0)+75|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+75|0]|0;t=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+75|0]=t;v=f;break}else{f=pFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+75|0]=f;v=f;break}}}}while(0);Xu(m,c[p>>2]|0,+h[(c[q>>2]|0)+776>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+776>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));nu(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+76|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+76|0]|0;m=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+76|0]|0)|0;a[(c[b+352>>2]|0)+76|0]=m;w=e;break}else{e=nFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u,a[(c[b+360>>2]|0)+76|0]|0)|0;a[(c[b+352>>2]|0)+76|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+76|0]|0;e=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+76|0]=e;w=n;break}else{n=rFa(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+256>>3],u)|0;a[(c[b+352>>2]|0)+76|0]=n;w=n;break}}}}while(0);l=rFa(+h[(c[q>>2]|0)+776>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=A;C=c[A>>2]|0;D=c[C>>2]|0;E=D;F=E+12|0;G=F;H=c[G>>2]|0;I=H;J=I+108|0;K=J;c[K>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=A;C=c[A>>2]|0;D=c[C>>2]|0;E=D;F=E+12|0;G=F;H=c[G>>2]|0;I=H;J=I+108|0;K=J;c[K>>2]=x;i=d;return}function qva(a){a=a|0;i=i;return 1}function rva(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=34;c[a+48>>2]=34;c[a+72>>2]=M4a(34,8)|0;a=M4a(34,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=M4a(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=K4a(136)|0;c[(c[d>>2]|0)+52>>2]=a;a=K4a(896)|0;c[(c[d>>2]|0)+56>>2]=a;a=K4a(136)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=12;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+132>>2]=8;c[e+128>>2]=8;c[e+124>>2]=8;c[e+120>>2]=8;c[e+116>>2]=6;c[e+112>>2]=6;c[e+108>>2]=6;c[e+104>>2]=6;c[e+100>>2]=4;c[e+96>>2]=4;c[e+92>>2]=4;c[e+88>>2]=4;c[e+84>>2]=6;c[e+80>>2]=6;c[e+76>>2]=4;c[e+72>>2]=4;c[e+68>>2]=4;c[e+64>>2]=4;c[e+44>>2]=8;c[e+40>>2]=8;c[e+36>>2]=8;c[e+32>>2]=8;c[e+28>>2]=6;c[e+24>>2]=6;c[e+20>>2]=8;c[e+16>>2]=8;c[e+12>>2]=6;c[e+8>>2]=6;c[e+4>>2]=8;c[e>>2]=8;c[e+60>>2]=6;c[e+56>>2]=6;c[e+52>>2]=12;c[e+48>>2]=12;f=8;g=8;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=34){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}sva(e,c[a+56>>2]|0);a=c[d>>2]|0;tva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;uva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;vva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;wva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;xva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;yva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;zva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ava(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Bva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Cva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Dva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Eva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Fva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Gva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Hva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Iva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Jva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Kva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Lva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Mva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Nva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ova(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Pva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Qva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Rva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Sva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Tva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Uva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Vva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Wva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Xva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Yva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Zva(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+132>>2]=1;c[a+116>>2]=1;c[a+108>>2]=1;c[a+100>>2]=1;c[a+44>>2]=1;c[a+128>>2]=2;c[a+112>>2]=2;c[a+104>>2]=2;c[a+96>>2]=2;c[a+40>>2]=2;c[a+124>>2]=3;c[a+92>>2]=3;c[a+76>>2]=3;c[a+36>>2]=3;c[a+120>>2]=4;c[a+88>>2]=4;c[a+72>>2]=4;c[a+32>>2]=4;c[a+84>>2]=5;c[a+28>>2]=5;c[a+12>>2]=5;c[a+80>>2]=6;c[a+24>>2]=6;c[a+8>>2]=6;c[a+68>>2]=7;c[a+20>>2]=7;c[a+4>>2]=7;c[a+64>>2]=8;c[a+16>>2]=8;c[a>>2]=8;c[a+60>>2]=9;c[a+56>>2]=10;c[a+52>>2]=11;c[a+48>>2]=12;i=b;return 0}function sva(a,b){a=a|0;b=b|0;var d=0;d=a+132|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=14;c[b+((c[d>>2]|0)+ -7<<2)>>2]=15;c[b+((c[d>>2]|0)+ -6<<2)>>2]=16;c[b+((c[d>>2]|0)+ -5<<2)>>2]=17;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=32;c[b+((c[d>>2]|0)+ -1<<2)>>2]=33;i=i;return}function tva(a,b){a=a|0;b=b|0;var d=0;d=a+128|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=14;c[b+((c[d>>2]|0)+ -7<<2)>>2]=15;c[b+((c[d>>2]|0)+ -6<<2)>>2]=16;c[b+((c[d>>2]|0)+ -5<<2)>>2]=17;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=32;c[b+((c[d>>2]|0)+ -1<<2)>>2]=33;i=i;return}function uva(a,b){a=a|0;b=b|0;var d=0;d=a+124|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=12;c[b+((c[d>>2]|0)+ -7<<2)>>2]=13;c[b+((c[d>>2]|0)+ -6<<2)>>2]=14;c[b+((c[d>>2]|0)+ -5<<2)>>2]=15;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=27;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function vva(a,b){a=a|0;b=b|0;var d=0;d=a+120|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=12;c[b+((c[d>>2]|0)+ -7<<2)>>2]=13;c[b+((c[d>>2]|0)+ -6<<2)>>2]=14;c[b+((c[d>>2]|0)+ -5<<2)>>2]=15;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=27;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function wva(a,b){a=a|0;b=b|0;var d=0;d=a+116|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function xva(a,b){a=a|0;b=b|0;var d=0;d=a+112|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function yva(a,b){a=a|0;b=b|0;var d=0;d=a+108|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=27;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function zva(a,b){a=a|0;b=b|0;var d=0;d=a+104|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=26;c[b+((c[d>>2]|0)+ -3<<2)>>2]=27;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function Ava(a,b){a=a|0;b=b|0;var d=0;d=a+100|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=20;c[b+((c[d>>2]|0)+ -3<<2)>>2]=21;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Bva(a,b){a=a|0;b=b|0;var d=0;d=a+96|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=20;c[b+((c[d>>2]|0)+ -3<<2)>>2]=21;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Cva(a,b){a=a|0;b=b|0;var d=0;d=a+92|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=20;c[b+((c[d>>2]|0)+ -3<<2)>>2]=21;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Dva(a,b){a=a|0;b=b|0;var d=0;d=a+88|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=20;c[b+((c[d>>2]|0)+ -3<<2)>>2]=21;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Eva(a,b){a=a|0;b=b|0;var d=0;d=a+84|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=21;i=i;return}function Fva(a,b){a=a|0;b=b|0;var d=0;d=a+80|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=20;c[b+((c[d>>2]|0)+ -1<<2)>>2]=21;i=i;return}function Gva(a,b){a=a|0;b=b|0;var d=0;d=a+76|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=32;c[b+((c[d>>2]|0)+ -1<<2)>>2]=33;i=i;return}function Hva(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=18;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=32;c[b+((c[d>>2]|0)+ -1<<2)>>2]=33;i=i;return}function Iva(a,b){a=a|0;b=b|0;var d=0;d=a+68|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=16;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function Jva(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=16;c[b+((c[d>>2]|0)+ -1<<2)>>2]=17;i=i;return}function Kva(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Lva(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Mva(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Nva(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=8;c[b+((c[d>>2]|0)+ -5<<2)>>2]=9;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Ova(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=5;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function Pva(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=4;c[b+((c[d>>2]|0)+ -5<<2)>>2]=5;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=28;c[b+((c[d>>2]|0)+ -1<<2)>>2]=29;i=i;return}function Qva(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=6;c[b+((c[d>>2]|0)+ -5<<2)>>2]=7;c[b+((c[d>>2]|0)+ -4<<2)>>2]=8;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Rva(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=6;c[b+((c[d>>2]|0)+ -5<<2)>>2]=7;c[b+((c[d>>2]|0)+ -4<<2)>>2]=8;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=24;c[b+((c[d>>2]|0)+ -1<<2)>>2]=25;i=i;return}function Sva(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=3;c[b+((c[d>>2]|0)+ -2<<2)>>2]=26;c[b+((c[d>>2]|0)+ -1<<2)>>2]=27;i=i;return}function Tva(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=2;c[b+((c[d>>2]|0)+ -3<<2)>>2]=3;c[b+((c[d>>2]|0)+ -2<<2)>>2]=26;c[b+((c[d>>2]|0)+ -1<<2)>>2]=27;i=i;return}function Uva(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=10;c[b+((c[d>>2]|0)+ -3<<2)>>2]=11;c[b+((c[d>>2]|0)+ -2<<2)>>2]=22;c[b+((c[d>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Vva(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -8<<2)>>2]=0;c[b+((c[a>>2]|0)+ -7<<2)>>2]=1;c[b+((c[a>>2]|0)+ -6<<2)>>2]=2;c[b+((c[a>>2]|0)+ -5<<2)>>2]=3;c[b+((c[a>>2]|0)+ -4<<2)>>2]=10;c[b+((c[a>>2]|0)+ -3<<2)>>2]=11;c[b+((c[a>>2]|0)+ -2<<2)>>2]=22;c[b+((c[a>>2]|0)+ -1<<2)>>2]=23;i=i;return}function Wva(a,b){a=a|0;b=b|0;var d=0;d=a+60|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=14;c[b+((c[d>>2]|0)+ -3<<2)>>2]=15;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function Xva(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=12;c[b+((c[d>>2]|0)+ -5<<2)>>2]=13;c[b+((c[d>>2]|0)+ -4<<2)>>2]=14;c[b+((c[d>>2]|0)+ -3<<2)>>2]=15;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function Yva(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=13;c[b+((c[d>>2]|0)+ -10<<2)>>2]=14;c[b+((c[d>>2]|0)+ -9<<2)>>2]=15;c[b+((c[d>>2]|0)+ -8<<2)>>2]=16;c[b+((c[d>>2]|0)+ -7<<2)>>2]=17;c[b+((c[d>>2]|0)+ -6<<2)>>2]=20;c[b+((c[d>>2]|0)+ -5<<2)>>2]=21;c[b+((c[d>>2]|0)+ -4<<2)>>2]=28;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function Zva(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=12;c[b+((c[d>>2]|0)+ -11<<2)>>2]=13;c[b+((c[d>>2]|0)+ -10<<2)>>2]=14;c[b+((c[d>>2]|0)+ -9<<2)>>2]=15;c[b+((c[d>>2]|0)+ -8<<2)>>2]=16;c[b+((c[d>>2]|0)+ -7<<2)>>2]=17;c[b+((c[d>>2]|0)+ -6<<2)>>2]=20;c[b+((c[d>>2]|0)+ -5<<2)>>2]=21;c[b+((c[d>>2]|0)+ -4<<2)>>2]=28;c[b+((c[d>>2]|0)+ -3<<2)>>2]=29;c[b+((c[d>>2]|0)+ -2<<2)>>2]=30;c[b+((c[d>>2]|0)+ -1<<2)>>2]=31;i=i;return}function _va(a){a=a|0;i=i;return 1}function $va(a){a=a|0;i=i;return 1}function awa(a){a=a|0;i=i;return 1}function bwa(a){a=a|0;i=i;return 0}function cwa(a){a=a|0;i=i;return 0}function dwa(a){a=a|0;i=i;return 0}function ewa(a){a=a|0;i=i;return 0}function fwa(a){a=a|0;i=i;return 0}function gwa(a,b){a=a|0;b=b|0;i=i;return-1}function hwa(a,b){a=a|0;b=b|0;i=i;return-1}function iwa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function jwa(){i=i;return 228288}function kwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function lwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function mwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function nwa(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Cb(230144,n|0)|0;i=m;return 0}function owa(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=hEa(a,230152)|0;z=hEa(b,230152)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((hEa(a,230160)|0)!=0){C=5;break}if((hEa(a,230168)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((hEa(b,230160)|0)!=0){break}if((hEa(b,230168)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){q5a(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}q5a(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}q5a(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Cb(230176,r|0)|0;i=q;return 0}



function pwa(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(hEa(a,230184)|0)!=0;v=c[(u?f:g)>>2]|0;w=hEa(e,230192)|0;x=hEa(b,230200)|0;c[p>>2]=0;do{if(u){y=4}else{if((hEa(a,230208)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((hEa(b,230184)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((hEa(d,230192)|0)==0){if((hEa(d,230216)|0)!=0){break}if((hEa(d,230224)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((hEa(e,230200)|0)==0){if((hEa(e,230192)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){q5a(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(hEa(d,230192)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Cb(230232,p|0)|0;i=o;return 0}function qwa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}swa(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}twa(230248,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Cb(230240,l|0)|0;i=k;return 0}function rwa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+QDa(230272);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(kwa(l,z,230280)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){mwa(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;lwa(l,n,d+(x-o+v<<3)|0,230280)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;nwa(l,m,230288,d+(B+y<<3)|0,230280,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Cb(230264,k|0)|0;i=j;return 0}function swa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=230320;u=vwa(230304,230296,230312,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;rwa(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;uwa(k,d,e,m,l,f,230304)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;uwa(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,230304)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;pwa(230328,230336,230344,230360,n,k,230368,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=230344;owa(H,H,k,l,n,230376,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,230368,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);rwa(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Cb(230296,j|0)|0;i=h;return 0}function twa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(hEa(a,230384)|0)!=0;do{if(n){o=5}else{if((hEa(a,230392)|0)!=0){o=5;break}if((hEa(a,230400)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=230416;uwa(d,h,j,q,b,g,q)|0;pwa(230424,230432,230440,230456,b,d,230464,e,f,h,j)|0;pwa(230424,230472,230440,230480,b,d,230464,e,f,h,j)|0;i=l;return 0}else{pwa(230424,230472,230496,230480,b,d,230464,e,f,h,j)|0;pwa(230424,230432,230496,230456,b,d,230464,e,f,h,j)|0;uwa(d,h,j,230416,b,g,230512)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Cb(230408,m|0)|0;i=l;return 0}function uwa(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function vwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=m5a(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;tUa(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;tUa(t,o+1|0,1,2);l=m;tUa(l,o+3|0,1,3);o=n;tUa(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((sUa(t,230520,1,2)|0)==0){if((sUa(l,230536,1,3)|0)==0){v=2;i=k;return v|0}if((sUa(l,230544,1,3)|0)==0){v=2;i=k;return v|0}if((sUa(l,230552,1,3)|0)==0){v=2;i=k;return v|0}if((sUa(l,230560,1,3)|0)==0){v=2;i=k;return v|0}if((sUa(l,230568,1,3)|0)==0){v=2;i=k;return v|0}if((sUa(l,230576,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((sUa(t,230600,1,2)|0)==0){n=(sUa(l,230528,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((sUa(t,230624,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((sUa(t,230632,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((sUa(o,230640,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230648,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230656,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230664,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230672,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230680,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((sUa(o,230640,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230648,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230656,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230664,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230672,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230680,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((sUa(t,230696,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((sUa(o,230640,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230648,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230656,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230664,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230672,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230680,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((sUa(o,230640,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230648,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230656,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230664,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230672,1,2)|0)==0){v=2;i=k;return v|0}if((sUa(o,230680,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((sUa(t,230520,1,2)|0)==0){if((sUa(l,230536,1,3)|0)==0){v=128;i=k;return v|0}if((sUa(l,230544,1,3)|0)==0){v=128;i=k;return v|0}if((sUa(l,230552,1,3)|0)==0){v=128;i=k;return v|0}if((sUa(l,230560,1,3)|0)==0){v=128;i=k;return v|0}if((sUa(l,230568,1,3)|0)==0){v=128;i=k;return v|0}m=(sUa(l,230576,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((sUa(t,230600,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(sUa(l,230608,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((sUa(t,230624,1,2)|0)==0){m=(sUa(l,230608,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((sUa(t,230632,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((sUa(t,230696,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((sUa(t,230520,1,2)|0)==0){if((sUa(l,230528,1,3)|0)==0){v=64;i=k;return v|0}if((sUa(l,230536,1,3)|0)==0){v=32;i=k;return v|0}if((sUa(l,230544,1,3)|0)==0){v=32;i=k;return v|0}if((sUa(l,230552,1,3)|0)==0){v=32;i=k;return v|0}if((sUa(l,230560,1,3)|0)==0){v=32;i=k;return v|0}if((sUa(l,230568,1,3)|0)==0){v=32;i=k;return v|0}if((sUa(l,230576,1,3)|0)==0){v=32;i=k;return v|0}m=(sUa(l,230584,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((sUa(t,230592,1,2)|0)==0){m=(sUa(l,230528,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((sUa(t,230600,1,2)|0)==0){m=(sUa(l,230528,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(sUa(l,230608,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(sUa(l,230616,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==67|u<<24>>24==90){if((sUa(t,230624,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((sUa(l,230528,1,3)|0)==0){v=64;i=k;return v|0}if((sUa(l,230608,1,3)|0)==0){v=32;i=k;return v|0}m=(sUa(l,230616,1,3)|0)==0;v=m?64:1;i=k;return v|0}else if(u<<24>>24==68|u<<24>>24==83){w=29}}while(0);do{if((w|0)==29){if((sUa(t,230632,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((sUa(t,230696,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((sUa(o,230640,1,2)|0)!=0){if((sUa(o,230648,1,2)|0)==0){break}if((sUa(o,230656,1,2)|0)==0){break}if((sUa(o,230664,1,2)|0)==0){break}if((sUa(o,230672,1,2)|0)==0){break}if((sUa(o,230680,1,2)|0)==0){break}if((sUa(o,230688,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((sUa(t,230704,1,2)|0)==0){if((sUa(l,230528,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((sUa(t,230712,1,2)|0)==0){if((sUa(l,230528,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((sUa(t,230680,1,2)|0)==0){o=(sUa(l,230584,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((sUa(t,230720,1,2)|0)==0){o=(sUa(l,230728,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((sUa(t,230736,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 16:case 15:case 14:case 13:case 12:{v=xwa(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{j=c[f>>2]|0;f=c[g>>2]|0;v=~~(+(((j|0)>(f|0)?f:j)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=wwa(230752,230760,230768)|0;i=k;return v|0};case 11:{v=wwa(230776,230760,230768)|0;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function wwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function xwa(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(rUa(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 14:{p=14;i=j;return p|0};case 15:{p=o;i=j;return p|0};case 16:{m=(o|0)>13;i=j;return(m?2:m&1)|0};case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function ywa(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=zwa(a,0,0)|0;i=b;return c|0}function zwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Awa(a,b,c,0)|0;i=d;return e|0}function Awa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=me[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=K4a(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=50;c[f+8>>2]=641}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=me[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){je[c[b+8>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=me[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){je[c[b+20>>2]&1023](c[j+392>>2]|0);je[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Lxa(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}je[c[j+20>>2]&1023](c[j+44>>2]|0);je[c[j+20>>2]&1023](c[j+392>>2]|0);je[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Mxa(j+416|0,j+12|0);Mxa(j+440|0,j+12|0);Cwa(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Fwa(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=eya()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Xxa()|0}k=j;l=k;i=g;return l|0}function Bwa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Cwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;nAa(f+256|0);if((b|0)!=0){g=Dwa(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Yxa(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Dwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Uwa(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Ewa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Xwa(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Dwa(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if(($wa(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Uwa(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Xwa(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Fwa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;je[c[e+20>>2]&1023](c[g+36>>2]|0);Gwa(c[g+44>>2]|0,e);je[c[e+20>>2]&1023](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;je[c[e+20>>2]&1023](f)}Gwa(c[h+376>>2]|0,e);Gwa(c[e+372>>2]|0,e);Hwa(e+416|0);Hwa(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Iwa(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);je[c[e+20>>2]&1023](c[e+392>>2]|0);je[c[e+20>>2]&1023](c[e+464>>2]|0);je[c[e+20>>2]&1023](c[e+8>>2]|0);je[c[e+20>>2]&1023](c[e+44>>2]|0);je[c[e+20>>2]&1023](c[e+396>>2]|0);je[c[e+20>>2]&1023](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){je[c[e+252>>2]&1023](c[e+244>>2]|0)}je[c[e+20>>2]&1023](e);i=d;return}function Gwa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;je[c[a+20>>2]&1023](c[b+16>>2]|0);je[c[a+20>>2]&1023](b)}i=d;return}function Hwa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;je[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;je[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}i=b;return}function Iwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Vwa(f,g+20|0);while(1){d=Wwa(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}je[c[b+8>>2]&1023](c[d+20>>2]|0)}_wa(g);_wa(g+132|0);_wa(g+20|0);_wa(g+40|0);_wa(g+60|0);Hwa(g+80|0);Hwa(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;je[m&1023](o);i=e;return}je[c[b+8>>2]&1023](c[g+184>>2]|0);je[c[b+8>>2]&1023](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;je[m&1023](o);i=e;return}function Jwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Kwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Lwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Mwa(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Owa(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{o5a(f|0,b|0,d|0)|0;j=Pwa(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Me[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Ne[c[(c[h+144>>2]|0)+52>>2]&127](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function Mwa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Jxa()|0}if((a[e+236|0]|0)!=0){f=Ewa(e,232560)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Nwa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Owa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;p5a(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=me[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;o5a(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;je[c[e+20>>2]&1023](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Pwa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Mwa(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Me[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);Ne[c[(c[g+144>>2]|0)+52>>2]&127](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Qwa(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Rwa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ne[c[(c[d+144>>2]|0)+52>>2]&127](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Swa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Je[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ge[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Je[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Twa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[230784+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Uwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;o5a((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=Ce[c[(c[d+20>>2]|0)+4>>2]&127](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=me[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){o5a(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Vwa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Wwa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Xwa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=me[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){q5a(c[m>>2]|0,0,g|0)|0;g=Ywa(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Ywa(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Zwa(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=me[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}q5a(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Ywa(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}je[c[(c[b+16>>2]|0)+8>>2]&1023](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=me[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){q5a(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Ywa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Zwa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function _wa(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}je[e&1023](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}je[e&1023](c[d>>2]|0);i=b;return}function $wa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[232368+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[232408+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=Ce[c[j+16>>2]&127](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=me[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=me[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}je[c[j+20>>2]&1023](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;o5a(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Je[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function axa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((pe[((a[e+236|0]&255|0)!=0?34:35)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Ixa(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function bxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Me[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=cxa(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function cxa(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=De[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Be[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}t=exa(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=t;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;we[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Be[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((pe[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}t=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}u=exa(t,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Xwa(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}t=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[t+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){v=1}else{v=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(v^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{t=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}u=exa(t,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Xwa(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}t=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[t+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[t+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){w=1}else{w=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(w^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Swa(o,b,e,c[n>>2]|0)}h=0;x=oxa(o,b,n,f,j,k)|0;if((x|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=exa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Me[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}t=exa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=220;break a}fxa(t);c[o+340>>2]=t;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}t=exa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=225;break a}c[q>>2]=e;ge[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,t,c[o+340>>2]|0);h=0}}while(0);Bwa(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ge[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Bwa(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){t=o+12|0;if((c[o+468>>2]|0)==0){u=c[t>>2]|0;c[o+468>>2]=32;c[o+464>>2]=me[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[t+4>>2]|0;t=c[o+464>>2]|0;y=o+468|0;z=c[y>>2]<<1;c[y>>2]=z;y=Ce[u&127](t,z)|0;if((y|0)==0){r=245;break a}c[o+464>>2]=y;if((c[l+184>>2]|0)==0){break}y=Ce[c[o+16>>2]&127](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((y|0)==0){r=248;break a}c[l+184>>2]=y}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}y=qxa(o)|0;if((y|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=y;z=l+180|0;c[z>>2]=(c[z>>2]|0)+1;c[(c[l+164>>2]|0)+(y*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;y=l;do{if((c[o+492>>2]|0)!=0){z=exa(y+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((z|0)==0){r=273;break a}t=Xwa(o,l+132|0,z,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((t|0)==0){r=279;break a}if((a[t+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((t|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Je[c[o+120>>2]&15](c[o+4>>2]|0,z,1);h=0;break c}}while(0);if((a[t+32|0]|0)!=0){r=287;break a}if((c[t+4>>2]|0)!=0){A=rxa(o,t,((s|0)==60?1:0)&255)|0;if((A|0)!=0){r=290;break a}h=0;break c}z=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[z+130|0]|0;break c}a[z+131|0]=0;a[t+32|0]=1;z=(De[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!z){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[y+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((me[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{B=1;r=319;break};case 52:{B=2;r=319;break};case 54:{B=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=hxa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){y=me[c[o+12>>2]&127](20)|0;if((y|0)==0){r=309;break a}c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;c[y>>2]=(s|0)==41?2:1;c[q>>2]=e;Je[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,y);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{B=0;r=319;break};case 47:{B=1;r=334;break};case 46:{B=2;r=334;break};case 48:{B=3;r=334;break};case 45:{B=0;r=334;break};case 56:{if((uxa(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((txa(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 1:{C=dxa(o,0,e,c[n>>2]|0)|0;if((C|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Xwa(o,l+132|0,232440,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Me[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}y=exa(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((y|0)==0){r=43;break a}fxa(y);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=y;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=exa(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ge[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Bwa(o+416|0);h=0;break};case 57:{D=dxa(o,1,e,c[n>>2]|0)|0;if((D|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=ixa(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ge[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Bwa(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;y=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}z=Xwa(o,l+132|0,232440,36)|0;if((z|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[z+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((De[c[o+112>>2]&63](c[o+116>>2]|0,0,c[z+20>>2]|0,c[z+16>>2]|0,c[z+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=y;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((me[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}je[c[o+88>>2]&1023](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=hxa(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){E=232544}else{E=(s|0)==32?232528:232552}if((jxa(o+416|0,E)|0)==0){r=111;break a}if((kxa(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=232448;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=232456;r=102;break};case 25:{c[o+332>>2]=232464;r=102;break};case 26:{c[o+332>>2]=232472;r=102;break};case 27:{c[o+332>>2]=232480;r=102;break};case 28:{c[o+332>>2]=232488;r=102;break};case 29:{c[o+332>>2]=232504;r=102;break};case 30:{c[o+332>>2]=232512;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((lxa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Uwa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}y=o+428|0;z=c[y>>2]|0;c[y>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Uwa(o+416|0)|0)<<24>>24!=0)){r=128;break a}}z=o+428|0;y=c[z>>2]|0;c[z>>2]=y+1;a[y]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;we[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Bwa(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;y=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=exa(y+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[y+324>>2]=232440}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((me[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Xwa(o,l+132|0,232440,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}F=mxa(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((F|0)!=0){r=132;break a}y=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((lxa(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,y,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Uwa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;u=c[z>>2]|0;c[z>>2]=u+1;a[u]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Uwa(o+416|0)|0)<<24>>24!=0)){r=145;break a}}u=o+428|0;z=c[u>>2]|0;c[u>>2]=z+1;a[z]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;we[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,y,(s|0)==38|0);Bwa(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}G=nxa(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;z=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=z;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;Be[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=z}}while(0);if((G|0)!=0){r=153;break a}break};case 13:{r=168;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Me[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=exa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((B|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=qxa(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=B;z=hxa(o,b,e,H)|0;if((z|0)==0){r=325;break a}y=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=y;s=0;do{z=s;s=z+1|0;}while((a[y+z|0]|0)!=0);y=l+168|0;c[y>>2]=(c[y>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}y=l+180|0;c[y>>2]=(c[y>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=B;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){y=sxa(o)|0;if((y|0)==0){r=340;break a}c[q>>2]=e;Je[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,y)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}y=exa(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((y|0)==0){r=50;break a}fxa(y);c[(c[o+316>>2]|0)+24>>2]=y;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Swa(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Me[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((De[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=C;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=D;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){D=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}C=Xwa(o,l+132|0,232440,36)|0;if((C|0)==0){I=1;J=I;i=m;return J|0}c[C+20>>2]=c[o+360>>2];a[l+131|0]=0;if((De[c[o+112>>2]&63](c[o+116>>2]|0,0,c[C+20>>2]|0,c[C+16>>2]|0,c[C+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=D;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((me[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=gxa(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=F;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=G;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){G=g;if((G|0)==28){I=10;J=I;i=m;return J|0}else if((G|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=x;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=x;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=A;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function dxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((le[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=exa(n+440|0,p,b,s+(Ce[c[(c[n+144>>2]|0)+32>>2]&127](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=exa(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ne[c[n+140>>2]&127](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Swa(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=exa(n+440|0,e,d,m+(Ce[c[(c[n+144>>2]|0)+32>>2]&127](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Ixa(n,f)|0;Bwa(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Bwa(n+440|0)}q=0;r=q;i=g;return r|0}function exa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((kxa(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Uwa(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function fxa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function gxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=xxa(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Fxa(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function hxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=exa(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Xwa(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Gxa(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function ixa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Uwa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=exa(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Xwa(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Xwa(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Uwa(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Uwa(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Xwa(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function jxa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Uwa(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function kxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Uwa(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ge[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Uwa(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function lxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=me[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=Ce[c[g+16>>2]&127](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function mxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Hxa(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Uwa(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function nxa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Uwa(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Me[c[b+20>>2]&63](b,e,f,j)|0){case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=exa(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=Xwa(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=nxa(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(De[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 10:{s=Ce[c[b+44>>2]&127](b,e)|0;if((s|0)<0){r=33;break a}s=Oxa(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Uwa(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-4:{r=24;break a;break};case 6:case 9:{if((kxa(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 7:{r=28;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-1:{r=46;break a;break};case 0:{r=49;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Uwa(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function oxa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Me[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case 42:{if((c[k+80>>2]|0)!=0){Swa(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function pxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=oxa(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=bxa(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function qxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=me[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=Ce[c[g+4>>2]&127](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=me[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function rxa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=me[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Me[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=cxa(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=xxa(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function sxa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=me[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;wxa(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function txa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Swa(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(Ce[c[a+32>>2]&127](a,b)|0)|0;k=exa(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=Ce[c[a+36>>2]&127](a,e)|0;e=exa(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){vxa(e);Je[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Bwa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function uxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Swa(g,a,b,d)}h=1;j=h;i=f;return j|0}k=exa(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){vxa(k);ke[c[g+68>>2]&255](c[g+4>>2]|0,k);Bwa(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function vxa(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function wxa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}wxa(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function T3a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;_3a(m,c[p>>2]|0)|0;_3a(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=_3a(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 9:{Q=c[q>>2]|0;R=a[Q]|0;switch(R<<24>>24|0){case 123:{S=c[v>>2]|0;if((S&1|0)==0){T=M;U=N;V=0;break c}else{W=S;X=Q}break};case 92:{S=c[v>>2]|0;if((S&1|0)!=0){T=M;U=N;V=0;break c}Y=Q+1|0;if((a[Y]|0)!=123){T=M;U=N;V=0;break c}c[q>>2]=Y;W=S;X=Y;break};case 42:{Z=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){T=M;U=N;V=0;break c}else{Z=41}break};default:{T=M;U=N;V=0;break c}}if((Z|0)==41){Z=0;c[q>>2]=Q+1;Q=c[w>>2]|0;Y=i4a(Q,0,0,1,32)|0;if((Y|0)==0){_=12;Z=294;break b}S=i4a(Q,0,0,1,16)|0;c[Y+4>>2]=S;if((S|0)==0){_=12;Z=294;break b}c[Y>>2]=2;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[S>>2]=N;c[S+4>>2]=R<<24>>24==43;c[S+8>>2]=R<<24>>24==63?1:-1;R=S+12|0;a[R]=a[R]&-2;c[Y+16>>2]=c[N+16>>2];T=M;U=Y;V=_3a(m,9)|0;break c}Y=X+1|0;c[q>>2]=Y;R=a[Y]|0;if((R+ -48<<24>>24&255)<10){S=R<<24>>24;if((S+ -48|0)>>>0<10){$=S;aa=-1;ba=Y}else{_=10;Z=294;break b}while(1){S=((aa|0)<0?-48:(aa*10|0)+ -48|0)+$|0;Q=ba+1|0;ca=a[Q]|0;da=ca<<24>>24;if((da+ -48|0)>>>0<10){ba=Q;aa=S;$=da}else{ea=ca;fa=S;ga=Q;break}}}else{ea=R;fa=-1;ga=Y}do{if(ea<<24>>24==44){Q=ga+1|0;S=a[Q]|0;ca=S<<24>>24;if((ca+ -48|0)>>>0<10){ha=ca;ia=-1;ja=Q}else{ka=S;la=-1;ma=Q;break}while(1){Q=((ia|0)<0?-48:(ia*10|0)+ -48|0)+ha|0;S=ja+1|0;ca=a[S]|0;da=ca<<24>>24;if((da+ -48|0)>>>0<10){ja=S;ia=Q;ha=da}else{na=ca;oa=Q;pa=S;Z=54;break}}}else{na=ea;oa=fa;pa=ga;Z=54}}while(0);do{if((Z|0)==54){Z=0;if(!((oa|0)>-1)){ka=na;la=oa;ma=pa;break}if((fa|0)>(oa|0)|(oa|0)>255){_=10;Z=294;break b}else{ka=na;la=oa;ma=pa}}}while(0);if(ka<<24>>24==0){_=9;Z=294;break b}if((ma|0)==(Y|0)){_=10;Z=294;break b}if((W&1|0)==0){if(!(ka<<24>>24==92)){_=10;Z=294;break b}if((a[ma+1|0]|0)!=125){_=10;Z=294;break b}qa=ma+2|0}else{if(!(ka<<24>>24==125)){_=10;Z=294;break b}qa=ma+1|0}if((la|fa|0)==0){R=c[w>>2]|0;S=i4a(R,0,0,1,32)|0;if((S|0)==0){_=12;Z=294;break b}Q=i4a(R,0,0,1,20)|0;c[S+4>>2]=Q;if((Q|0)==0){_=12;Z=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;ra=S}else{S=(la&fa|0)<0;Q=c[w>>2]|0;R=i4a(Q,0,0,1,32)|0;if((R|0)==0){_=12;Z=294;break b}ca=i4a(Q,0,0,1,16)|0;c[R+4>>2]=ca;if((ca|0)==0){_=12;Z=294;break b}c[R>>2]=2;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ca>>2]=N;c[ca+4>>2]=S?1:fa;c[ca+8>>2]=S?1:la;S=ca+12|0;a[S]=a[S]&-2;c[R+16>>2]=c[N+16>>2];ra=R}c[q>>2]=qa;T=M;U=ra;V=_3a(m,9)|0;break};case 0:{if((c[v>>2]&1|0)!=0){R=_3a(m,7)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}}T=M;U=N;V=_3a(m,3)|0;break};case 4:{R=_3a(m,9)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}T=M;U=N;V=_3a(m,1)|0;break};case 2:{R=L+ -2|0;c[n>>2]=R;S=c[P+(R<<2)>>2]|0;if((c[N+12>>2]|0)>-1){R=c[w>>2]|0;ca=i4a(R,0,0,1,32)|0;if((ca|0)==0){_=12;Z=294;break b}Q=i4a(R,0,0,1,20)|0;c[ca+4>>2]=Q;if((Q|0)==0){_=12;Z=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;Q=c[w>>2]|0;R=i4a(Q,0,0,1,32)|0;if((R|0)==0){_=12;Z=294;break b}da=i4a(Q,0,0,1,8)|0;Q=R+4|0;c[Q>>2]=da;if((da|0)==0){_=12;Z=294;break b}c[R>>2]=1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[da>>2]=ca;c[(c[Q>>2]|0)+4>>2]=N;Q=N+16|0;da=R+16|0;c[da>>2]=(c[Q>>2]|0)+(c[ca+16>>2]|0);c[da>>2]=c[Q>>2];ua=R}else{ua=N}c[ua+12>>2]=S;S=ua+16|0;c[S>>2]=(c[S>>2]|0)+1;T=M;U=ua;V=0;break};case 6:{S=L+ -2|0;c[n>>2]=S;R=c[P+(S<<2)>>2]|0;S=c[w>>2]|0;Q=i4a(S,0,0,1,32)|0;if((Q|0)==0){_=12;Z=294;break b}da=i4a(S,0,0,1,8)|0;S=Q+4|0;c[S>>2]=da;if((da|0)==0){_=12;Z=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=R;c[(c[S>>2]|0)+4>>2]=N;c[Q+16>>2]=(c[N+16>>2]|0)+(c[R+16>>2]|0);T=M;U=Q;V=0;break};case 3:{Q=_3a(m,5)|0;if((Q|0)!=0){sa=M;ta=Q;Z=6;break b}T=M;U=N;V=_3a(m,4)|0;break};case 7:{Q=c[q>>2]|0;R=a[Q]|0;if((R|0)==41){c[q>>2]=Q+1;T=M;U=N;V=0;break c}else if((R|0)!=124){T=M;U=N;V=0;break c}R=_3a(m,7)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}R=_3a(m,N)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}R=_3a(m,8)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}R=_3a(m,3)|0;if((R|0)!=0){sa=M;ta=R;Z=6;break b}c[q>>2]=(c[q>>2]|0)+1;T=M;U=N;V=0;break};case 8:{R=L+ -2|0;c[n>>2]=R;Q=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;S=i4a(R,0,0,1,32)|0;if((S|0)==0){_=12;Z=294;break b}da=i4a(R,0,0,1,8)|0;R=S+4|0;c[R>>2]=da;if((da|0)==0){_=12;Z=294;break b}c[S>>2]=3;c[S+8>>2]=-1;c[S+12>>2]=-1;c[da>>2]=Q;c[(c[R>>2]|0)+4>>2]=N;c[S+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);T=M;U=S;V=0;break};case 1:{S=c[q>>2]|0;d:do{switch(a[S]|0){case 46:{Q=(c[v>>2]&4|0)==0;R=c[w>>2]|0;da=c[x>>2]|0;ca=i4a(R,0,0,1,32)|0;va=ca;wa=(ca|0)==0;if(Q){if(wa){_=12;Z=294;break b}Q=i4a(R,0,0,1,20)|0;c[ca+4>>2]=Q;if((Q|0)==0){_=12;Z=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=1114111;c[Q+8>>2]=da;xa=va;ya=(c[x>>2]|0)+1|0}else{if(wa){_=12;Z=294;break b}wa=i4a(R,0,0,1,20)|0;c[ca+4>>2]=wa;if((wa|0)==0){_=12;Z=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[wa>>2]=0;c[wa+4>>2]=9;c[wa+8>>2]=da;da=c[w>>2]|0;wa=(c[x>>2]|0)+1|0;R=i4a(da,0,0,1,32)|0;if((R|0)==0){_=12;Z=294;break b}Q=i4a(da,0,0,1,20)|0;c[R+4>>2]=Q;if((Q|0)==0){_=12;Z=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=11;c[Q+4>>2]=1114111;c[Q+8>>2]=wa;wa=c[w>>2]|0;Q=i4a(wa,0,0,1,32)|0;if((Q|0)==0){_=12;Z=294;break b}da=i4a(wa,0,0,1,8)|0;wa=Q+4|0;c[wa>>2]=da;if((da|0)==0){_=12;Z=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[da>>2]=va;c[(c[wa>>2]|0)+4>>2]=R;c[Q+16>>2]=(c[R+16>>2]|0)+(c[ca+16>>2]|0);xa=Q;ya=(c[x>>2]|0)+2|0}c[x>>2]=ya;c[q>>2]=(c[q>>2]|0)+1;T=M;U=xa;V=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((S|0)!=(c[r>>2]|0)){break d}Q=_3a(m,5)|0;if((Q|0)!=0){sa=M;ta=Q;Z=6;break b}}Q=c[w>>2]|0;ca=i4a(Q,0,0,1,32)|0;if((ca|0)==0){_=12;Z=294;break b}R=i4a(Q,0,0,1,20)|0;c[ca+4>>2]=R;if((R|0)==0){_=12;Z=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[R>>2]=-2;c[R+4>>2]=1;c[R+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;T=M;U=ca;V=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[S+1|0]|0)!=0){break d}}ca=c[w>>2]|0;R=i4a(ca,0,0,1,32)|0;if((R|0)==0){_=12;Z=294;break b}Q=i4a(ca,0,0,1,20)|0;c[R+4>>2]=Q;if((Q|0)==0){_=12;Z=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=2;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;T=M;U=R;V=0;break c;break};case 63:case 43:case 123:case 124:case 42:{Z=264;break};case 0:{Z=265;break};case 41:{if((M|0)!=0){Z=264}break};case 91:{R=S+1|0;c[q>>2]=R;Q=K4a(128)|0;if((Q|0)==0){_=12;Z=294;break b}if((a[R]|0)==94){ca=S+2|0;c[q>>2]=ca;za=ca;Aa=1}else{za=R;Aa=0}R=(Aa|0)==0;ca=Q;Q=0;wa=0;va=32;da=za;e:while(1){Ba=a[da]|0;if(Ba<<24>>24==0){Ca=ca;Da=da;Ea=7;Z=140;break}else if(Ba<<24>>24==93){if(da>>>0>(c[q>>2]|0)>>>0){Z=85;break}}Ba=O3a(e,da,-1)|0;if((Ba|0)<0){c[e>>2]=-1;Fa=1}else{Fa=Ba}Ba=da+Fa|0;do{if((a[Ba]|0)==45){Ga=Fa+1|0;Ha=da+Ga|0;if((a[Ha]|0)==93){Z=94;break}Ia=c[e>>2]|0;Ja=O3a(e,Ha,-1)|0;if((Ja|0)<0){c[e>>2]=-1;Ka=-1;La=1}else{Ka=c[e>>2]|0;La=Ja}Ma=0;Na=Ka;Oa=Ia;Pa=da+(La+Ga)|0;Qa=Ia>>>0>Ka>>>0?11:0}else{Z=94}}while(0);f:do{if((Z|0)==94){Z=0;Ia=a[da]|0;do{if(Ia<<24>>24==91){Ga=a[da+1|0]|0;if(Ga<<24>>24==61|Ga<<24>>24==46){Ca=ca;Da=da;Ea=3;Z=140;break e}else if(!(Ga<<24>>24==58)){Ra=0;break}Ga=da+2|0;Ja=Ga;while(1){Ha=a[Ja]|0;Sa=Ha<<24>>24==0;if(Ha<<24>>24!=58&(Sa^1)){Ja=Ja+1|0}else{break}}if(Sa){Ca=ca;Da=da;Ea=4;Z=140;break e}Ha=Ja-da+ -2|0;Ta=(Ha|0)>63?63:Ha;x5a(A|0,Ga|0,Ta|0)|0;a[f+Ta|0]=0;Ta=y3a(A)|0;Ma=Ta;Na=1114111;Oa=0;Pa=Ja+2|0;Qa=(Ta|0)==0?4:0;break f}else if(Ia<<24>>24==45){if((a[da+1|0]|0)==93){Ra=0;break}Ra=(c[q>>2]|0)==(da|0)?0:11}else{Ra=0}}while(0);Ia=c[e>>2]|0;Ma=0;Na=Ia;Oa=Ia;Pa=Ba;Qa=Ra}}while(0);if((Qa|0)!=0){Ca=ca;Da=Pa;Ea=Qa;Z=140;break}Ba=(Ma|0)!=0;do{if(R|Ba^1){Ia=c[w>>2]|0;if((wa|0)<(va|0)){Ua=ca;Va=va}else{if((va|0)>1024){Ca=ca;Da=Pa;Ea=12;Z=140;break e}Ta=N4a(ca,va<<3)|0;if((Ta|0)==0){Ca=ca;Da=Pa;Ea=12;Z=140;break e}else{Ua=Ta;Va=va<<1}}Ta=i4a(Ia,0,0,1,32)|0;if((Ta|0)==0){Z=112;break e}Ha=i4a(Ia,0,0,1,20)|0;Ia=Ta+4|0;c[Ia>>2]=Ha;if((Ha|0)==0){Z=112;break e}c[Ta>>2]=0;c[Ta+8>>2]=-1;c[Ta+12>>2]=-1;c[Ha>>2]=Oa;c[Ha+4>>2]=Na;c[Ha+8>>2]=-1;c[Ua+(wa<<2)>>2]=Ta;c[(c[Ia>>2]|0)+12>>2]=Ma;Wa=Ua;Xa=Q;Ya=wa+1|0;Za=Va;_a=0}else{if((Q|0)>63){Wa=ca;Xa=Q;Ya=wa;Za=va;_a=12;break}c[g+(Q<<2)>>2]=Ma;Wa=ca;Xa=Q+1|0;Ya=wa;Za=va;_a=0}}while(0);Ia=(_a|0)==0;if(Ia&(((c[v>>2]&2|0)==0|Ba)^1)){$a=Wa;ab=Ya;bb=Za;cb=Oa}else{if(Ia){ca=Wa;Q=Xa;wa=Ya;va=Za;da=Pa;continue}else{Ca=Wa;Da=Pa;Ea=_a;Z=140;break}}while(1){Ia=cb;while(1){if(Ia>>>0>Na>>>0){ca=$a;Q=Xa;wa=ab;va=bb;da=Pa;continue e}if((B3a(Ia)|0)!=0){Z=118;break}db=Ia+1|0;if((F3a(Ia)|0)==0){Ia=db}else{Z=129;break}}if((Z|0)==118){Z=0;Ta=H3a(Ia)|0;Ha=Ia+1|0;g:do{if((B3a(Ha)|0)==0){eb=Ta;fb=Ha}else{gb=Ta;hb=Ha;while(1){if((H3a(hb)|0)!=(gb+1|0)|hb>>>0>Na>>>0){eb=gb;fb=hb;break g}ib=H3a(hb)|0;jb=hb+1|0;if((B3a(jb)|0)==0){eb=ib;fb=jb;break}else{gb=ib;hb=jb}}}}while(0);Ha=c[w>>2]|0;if((ab|0)<(bb|0)){kb=$a;lb=bb}else{if((bb|0)>1024){Ca=$a;Da=Pa;Ea=12;Z=140;break e}hb=N4a($a,bb<<3)|0;if((hb|0)==0){Ca=$a;Da=Pa;Ea=12;Z=140;break e}else{kb=hb;lb=bb<<1}}hb=i4a(Ha,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){mb=0}else{Ja=i4a(Ha,0,0,1,20)|0;c[hb+4>>2]=Ja;if((Ja|0)==0){mb=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ja>>2]=Ta;c[Ja+4>>2]=eb;c[Ja+8>>2]=-1;mb=gb}}while(0);c[kb+(ab<<2)>>2]=mb;nb=mb;ob=kb;pb=lb;qb=fb}else if((Z|0)==129){Z=0;gb=J3a(Ia)|0;h:do{if((F3a(db)|0)==0){rb=gb;sb=db}else{Ta=gb;hb=db;while(1){if((J3a(hb)|0)!=(Ta+1|0)|hb>>>0>Na>>>0){rb=Ta;sb=hb;break h}Ha=hb+1|0;Ja=J3a(hb)|0;if((F3a(Ha)|0)==0){rb=Ja;sb=Ha;break}else{Ta=Ja;hb=Ha}}}}while(0);Ia=c[w>>2]|0;if((ab|0)<(bb|0)){tb=$a;ub=bb}else{if((bb|0)>1024){Ca=$a;Da=Pa;Ea=12;Z=140;break e}hb=N4a($a,bb<<3)|0;if((hb|0)==0){Ca=$a;Da=Pa;Ea=12;Z=140;break e}else{tb=hb;ub=bb<<1}}hb=i4a(Ia,0,0,1,32)|0;Ta=hb;do{if((hb|0)==0){vb=0}else{Ha=i4a(Ia,0,0,1,20)|0;c[hb+4>>2]=Ha;if((Ha|0)==0){vb=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ha>>2]=gb;c[Ha+4>>2]=rb;c[Ha+8>>2]=-1;vb=Ta}}while(0);c[tb+(ab<<2)>>2]=vb;nb=vb;ob=tb;pb=ub;qb=sb}if((nb|0)==0){Z=141;break e}else{$a=ob;ab=ab+1|0;bb=pb;cb=qb}}}i:do{if((Z|0)==85){Z=0;c[q>>2]=da+1;va=(Aa|0)!=0;if(va){fc(ca|0,wa|0,4,64)}j:do{if((wa|0)>0){R=(Q|0)>0;Ba=Q<<2;Ta=Ba+4|0;if(va){wb=0;xb=0;yb=0;zb=0}else{gb=0;hb=0;while(1){Ia=ca+(gb<<2)|0;Ha=c[(c[Ia>>2]|0)+4>>2]|0;do{if((Ha|0)==0){Ab=hb;Bb=0}else{c[Ha+8>>2]=c[x>>2];if(R){Ja=i4a(c[w>>2]|0,0,0,0,Ta)|0;Ga=Ha+16|0;c[Ga>>2]=Ja;if((Ja|0)==0){Cb=ca;Db=hb;Eb=12;break i}o5a(Ja|0,z|0,Ba|0)|0;c[(c[Ga>>2]|0)+(Q<<2)>>2]=0}else{c[Ha+16>>2]=0}if((hb|0)==0){Ab=c[Ia>>2]|0;Bb=0;break}Ga=c[w>>2]|0;Ja=c[Ia>>2]|0;jb=i4a(Ga,0,0,1,32)|0;ib=jb;do{if((jb|0)==0){Fb=0}else{Gb=i4a(Ga,0,0,1,8)|0;Hb=jb+4|0;c[Hb>>2]=Gb;if((Gb|0)==0){Fb=0;break}c[jb>>2]=3;c[jb+8>>2]=-1;c[jb+12>>2]=-1;c[Gb>>2]=hb;c[(c[Hb>>2]|0)+4>>2]=Ja;c[jb+16>>2]=(c[Ja+16>>2]|0)+(c[hb+16>>2]|0);Fb=ib}}while(0);Ab=Fb;Bb=(Fb|0)==0?12:0}}while(0);Ia=gb+1|0;if((Ia|0)<(wa|0)&(Bb|0)==0){gb=Ia;hb=Ab}else{Ib=0;Jb=Ab;Kb=Bb;break j}}}while(1){hb=ca+(yb<<2)|0;gb=c[(c[hb>>2]|0)+4>>2]|0;Ia=c[gb>>2]|0;Ha=gb+4|0;ib=c[Ha>>2]|0;do{if((Ia|0)<(wb|0)){Ja=ib+1|0;Lb=(Ja|0)<(wb|0)?wb:Ja;Mb=xb;Nb=zb;Ob=0}else{if((Ia|0)<=(xb|0)){Ja=ib+1|0;Lb=Ja;Mb=Ja;Nb=zb;Ob=0;break}c[gb>>2]=xb;c[Ha>>2]=Ia+ -1;Ja=ib+1|0;if((gb|0)==0){Lb=Ja;Mb=Ja;Nb=zb;Ob=0;break}c[gb+8>>2]=c[x>>2];if(R){jb=i4a(c[w>>2]|0,0,0,0,Ta)|0;Ga=gb+16|0;c[Ga>>2]=jb;if((jb|0)==0){Cb=ca;Db=zb;Eb=12;break i}o5a(jb|0,z|0,Ba|0)|0;c[(c[Ga>>2]|0)+(Q<<2)>>2]=0}else{c[gb+16>>2]=0}if((zb|0)==0){Lb=Ja;Mb=Ja;Nb=c[hb>>2]|0;Ob=0;break}Ga=c[w>>2]|0;jb=c[hb>>2]|0;Hb=i4a(Ga,0,0,1,32)|0;Gb=Hb;do{if((Hb|0)==0){Pb=0}else{Qb=i4a(Ga,0,0,1,8)|0;Rb=Hb+4|0;c[Rb>>2]=Qb;if((Qb|0)==0){Pb=0;break}c[Hb>>2]=3;c[Hb+8>>2]=-1;c[Hb+12>>2]=-1;c[Qb>>2]=zb;c[(c[Rb>>2]|0)+4>>2]=jb;c[Hb+16>>2]=(c[jb+16>>2]|0)+(c[zb+16>>2]|0);Pb=Gb}}while(0);Lb=Ja;Mb=Ja;Nb=Pb;Ob=(Pb|0)==0?12:0}}while(0);hb=yb+1|0;if((hb|0)<(wa|0)&(Ob|0)==0){wb=Lb;xb=Mb;yb=hb;zb=Nb}else{Ib=Mb;Jb=Nb;Kb=Ob;break}}}else{Ib=0;Jb=0;Kb=0}}while(0);if((Kb|0)!=0|va^1){Cb=ca;Db=Jb;Eb=Kb;break}Ba=c[w>>2]|0;Ta=c[x>>2]|0;R=i4a(Ba,0,0,1,32)|0;hb=R;if((R|0)==0){Cb=ca;Db=Jb;Eb=12;break}gb=i4a(Ba,0,0,1,20)|0;c[R+4>>2]=gb;if((gb|0)==0){Cb=ca;Db=Jb;Eb=12;break}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[gb>>2]=Ib;c[gb+4>>2]=1114111;c[gb+8>>2]=Ta;if((Q|0)>0){Ta=Q<<2;Ba=i4a(c[w>>2]|0,0,0,0,Ta+4|0)|0;ib=gb+16|0;c[ib>>2]=Ba;if((Ba|0)==0){Cb=ca;Db=Jb;Eb=12;break}o5a(Ba|0,z|0,Ta|0)|0;c[(c[ib>>2]|0)+(Q<<2)>>2]=0}else{c[gb+16>>2]=0}if((Jb|0)==0){Cb=ca;Db=hb;Eb=0;break}gb=c[w>>2]|0;ib=i4a(gb,0,0,1,32)|0;Ta=ib;do{if((ib|0)==0){Sb=0}else{Ba=i4a(gb,0,0,1,8)|0;Ia=ib+4|0;c[Ia>>2]=Ba;if((Ba|0)==0){Sb=0;break}c[ib>>2]=3;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[Ba>>2]=Jb;c[(c[Ia>>2]|0)+4>>2]=hb;c[ib+16>>2]=(c[R+16>>2]|0)+(c[Jb+16>>2]|0);Sb=Ta}}while(0);Cb=ca;Db=Sb;Eb=(Sb|0)==0?12:0}else if((Z|0)==112){Z=0;c[Ua+(wa<<2)>>2]=0;Ca=Ua;Da=Pa;Ea=12;Z=140}else if((Z|0)==141){Z=0;c[q>>2]=Pa;Cb=ob;Db=0;Eb=12}}while(0);if((Z|0)==140){Z=0;c[q>>2]=Da;Cb=Ca;Db=0;Eb=Ea}L4a(Cb);c[x>>2]=(c[x>>2]|0)+1;if((Eb|0)==0){T=M;U=Db;V=0;break c}else{_=Eb;Z=294;break b}break};case 40:{if((c[v>>2]&1|0)!=0){Tb=S;Z=74}break};case 92:{wa=S+1|0;ca=a[wa]|0;do{if((c[v>>2]&1|0)==0){if(ca<<24>>24==40){c[q>>2]=wa;Tb=wa;Z=74;break d}else{Q=a[S+1|0]|0;if(Q<<24>>24==41){Z=265;break d}else{Ub=Q;break}}}else{Ub=ca}}while(0);ca=S+1|0;wa=Ub<<24>>24==0;if(wa){_=5;Z=294;break b}else{Vb=331212|0;Wb=0}while(1){Q=Wb+1|0;if((a[331208+(Wb<<3)|0]|0)==Ub<<24>>24){Yb=Vb;break}da=331212+(Q<<3)|0;if((Q|0)==12){Yb=da;break}else{Vb=da;Wb=Q}}Q=c[Yb>>2]|0;if((Q|0)!=0){da=F+0|0;Ta=G+0|0;R=da+40|0;do{c[da>>2]=c[Ta>>2];da=da+4|0;Ta=Ta+4|0}while((da|0)<(R|0));c[H>>2]=Q;c[I>>2]=1;Ta=T3a(j)|0;if((Ta|0)!=0){_=Ta;Z=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];T=M;U=c[K>>2]|0;V=0;break c}if(wa){_=5;Z=294;break b}c[q>>2]=ca;Ta=a[ca]|0;k:do{switch(Ta|0){case 62:{da=c[w>>2]|0;R=i4a(da,0,0,1,32)|0;ib=R;do{if((R|0)==0){Zb=0}else{hb=i4a(da,0,0,1,20)|0;c[R+4>>2]=hb;if((hb|0)==0){Zb=0;break}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[hb>>2]=-2;c[hb+4>>2]=32;c[hb+8>>2]=-1;Zb=ib}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=Zb;break};case 120:{ib=S+2|0;c[q>>2]=ib;R=a[ib]|0;if(R<<24>>24==123){ib=S+3|0;c[q>>2]=ib;da=ib;ib=0;while(1){hb=a[da]|0;if(hb<<24>>24==0|hb<<24>>24==125){$b=ib;ac=da;break}if((G3a(hb<<24>>24)|0)==0){_=9;Z=294;break b}hb=c[q>>2]|0;a[l+ib|0]=a[hb]|0;gb=ib+1|0;va=hb+1|0;c[q>>2]=va;if(gb>>>0>31){$b=gb;ac=va;break}else{da=va;ib=gb}}c[q>>2]=ac+1;a[l+$b|0]=0;ib=Xb(C|0,0,16)|0;da=c[w>>2]|0;gb=c[x>>2]|0;va=i4a(da,0,0,1,32)|0;hb=va;do{if((va|0)==0){bc=0}else{Ia=i4a(da,0,0,1,20)|0;c[va+4>>2]=Ia;if((Ia|0)==0){bc=0;break}c[va>>2]=0;c[va+8>>2]=-1;c[va+12>>2]=-1;c[Ia>>2]=ib;c[Ia+4>>2]=ib;c[Ia+8>>2]=gb;bc=hb}}while(0);c[x>>2]=(c[x>>2]|0)+1;_b=bc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;hb=(G3a(R<<24>>24)|0)==0;gb=c[q>>2]|0;if(hb){cc=gb}else{a[D]=a[gb]|0;hb=gb+1|0;c[q>>2]=hb;cc=hb}if((G3a(a[cc]|0)|0)!=0){hb=c[q>>2]|0;a[E]=a[hb]|0;c[q>>2]=hb+1}hb=Xb(D|0,0,16)|0;gb=c[w>>2]|0;ib=c[x>>2]|0;va=i4a(gb,0,0,1,32)|0;da=va;do{if((va|0)==0){dc=0}else{Ia=i4a(gb,0,0,1,20)|0;c[va+4>>2]=Ia;if((Ia|0)==0){dc=0;break}c[va>>2]=0;c[va+8>>2]=-1;c[va+12>>2]=-1;c[Ia>>2]=hb;c[Ia+4>>2]=hb;c[Ia+8>>2]=ib;dc=da}}while(0);c[x>>2]=(c[x>>2]|0)+1;_b=dc;break k}break};case 60:{da=c[w>>2]|0;ib=i4a(da,0,0,1,32)|0;hb=ib;do{if((ib|0)==0){ec=0}else{va=i4a(da,0,0,1,20)|0;c[ib+4>>2]=va;if((va|0)==0){ec=0;break}c[ib>>2]=0;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[va>>2]=-2;c[va+4>>2]=16;c[va+8>>2]=-1;ec=hb}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=ec;break};case 98:{hb=c[w>>2]|0;ib=i4a(hb,0,0,1,32)|0;da=ib;do{if((ib|0)==0){gc=0}else{va=i4a(hb,0,0,1,20)|0;c[ib+4>>2]=va;if((va|0)==0){gc=0;break}c[ib>>2]=0;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[va>>2]=-2;c[va+4>>2]=64;c[va+8>>2]=-1;gc=da}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=gc;break};case 66:{da=c[w>>2]|0;ib=i4a(da,0,0,1,32)|0;hb=ib;do{if((ib|0)==0){hc=0}else{va=i4a(da,0,0,1,20)|0;c[ib+4>>2]=va;if((va|0)==0){hc=0;break}c[ib>>2]=0;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[va>>2]=-2;c[va+4>>2]=128;c[va+8>>2]=-1;hc=hb}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=hc;break};default:{if((z3a(Ta)|0)!=0){hb=(a[c[q>>2]|0]|0)+ -48|0;ib=c[w>>2]|0;da=c[x>>2]|0;va=i4a(ib,0,0,1,32)|0;if((va|0)==0){_=12;Z=294;break b}gb=i4a(ib,0,0,1,20)|0;c[va+4>>2]=gb;if((gb|0)==0){_=12;Z=294;break b}c[va>>2]=0;c[va+8>>2]=-1;c[va+12>>2]=-1;c[gb>>2]=-4;c[gb+4>>2]=hb;c[gb+8>>2]=da;c[x>>2]=(c[x>>2]|0)+1;da=c[B>>2]|0;c[B>>2]=(hb|0)<(da|0)?da:hb;c[q>>2]=(c[q>>2]|0)+1;T=M;U=va;V=0;break c}va=c[w>>2]|0;hb=a[c[q>>2]|0]|0;da=c[x>>2]|0;gb=i4a(va,0,0,1,32)|0;ib=gb;do{if((gb|0)==0){ic=0}else{R=i4a(va,0,0,1,20)|0;c[gb+4>>2]=R;if((R|0)==0){ic=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[R>>2]=hb;c[R+4>>2]=hb;c[R+8>>2]=da;ic=ib}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;_b=ic}}}while(0);if((_b|0)==0){_=12;Z=294;break b}else{T=M;U=_b;V=0;break c}break};default:{}}}while(0);if((Z|0)==74){Z=0;Y=M+1|0;c[q>>2]=Tb+1;Ta=_3a(m,c[y>>2]|0)|0;if((Ta|0)!=0){sa=Y;ta=Ta;Z=6;break b}Ta=_3a(m,2)|0;if((Ta|0)!=0){sa=Y;ta=Ta;Z=6;break b}Ta=_3a(m,0)|0;if((Ta|0)!=0){sa=Y;ta=Ta;Z=6;break b}c[y>>2]=(c[y>>2]|0)+1;T=Y;U=N;V=0;break c}else if((Z|0)==264){Z=0;if((c[v>>2]&1|0)!=0){Z=265}}if((Z|0)==265){Z=0;Y=c[w>>2]|0;Ta=i4a(Y,0,0,1,32)|0;if((Ta|0)==0){_=12;Z=294;break b}ca=i4a(Y,0,0,1,20)|0;c[Ta+4>>2]=ca;if((ca|0)==0){_=12;Z=294;break b}c[Ta>>2]=0;c[Ta+8>>2]=-1;c[Ta+12>>2]=-1;c[ca>>2]=-1;c[ca+4>>2]=-1;c[ca+8>>2]=-1;T=M;U=Ta;V=0;break c}Ta=O3a(h,S,-1)|0;if((Ta|0)<0){c[h>>2]=-1;jc=1}else{jc=Ta}do{if((c[v>>2]&2|0)==0){Z=280}else{if((F3a(c[h>>2]|0)|0)==0){if((B3a(c[h>>2]|0)|0)==0){Z=280;break}}Ta=c[w>>2]|0;ca=H3a(c[h>>2]|0)|0;Y=H3a(c[h>>2]|0)|0;wa=c[x>>2]|0;Q=i4a(Ta,0,0,1,32)|0;if((Q|0)==0){_=12;Z=294;break b}ib=i4a(Ta,0,0,1,20)|0;c[Q+4>>2]=ib;if((ib|0)==0){_=12;Z=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[ib>>2]=ca;c[ib+4>>2]=Y;c[ib+8>>2]=wa;wa=c[w>>2]|0;ib=J3a(c[h>>2]|0)|0;Y=J3a(c[h>>2]|0)|0;ca=c[x>>2]|0;Ta=i4a(wa,0,0,1,32)|0;if((Ta|0)==0){_=12;Z=294;break b}da=i4a(wa,0,0,1,20)|0;c[Ta+4>>2]=da;if((da|0)==0){_=12;Z=294;break b}c[Ta>>2]=0;c[Ta+8>>2]=-1;c[Ta+12>>2]=-1;c[da>>2]=ib;c[da+4>>2]=Y;c[da+8>>2]=ca;ca=c[w>>2]|0;da=i4a(ca,0,0,1,32)|0;if((da|0)==0){_=12;Z=294;break b}Y=i4a(ca,0,0,1,8)|0;ca=da+4|0;c[ca>>2]=Y;if((Y|0)==0){_=12;Z=294;break b}c[da>>2]=3;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Y>>2]=Q;c[(c[ca>>2]|0)+4>>2]=Ta;c[da+16>>2]=(c[Ta+16>>2]|0)+(c[Q+16>>2]|0);kc=da}}while(0);if((Z|0)==280){Z=0;S=c[w>>2]|0;da=c[h>>2]|0;Q=c[x>>2]|0;Ta=i4a(S,0,0,1,32)|0;if((Ta|0)==0){_=12;Z=294;break b}ca=i4a(S,0,0,1,20)|0;c[Ta+4>>2]=ca;if((ca|0)==0){_=12;Z=294;break b}c[Ta>>2]=0;c[Ta+8>>2]=-1;c[Ta+12>>2]=-1;c[ca>>2]=da;c[ca+4>>2]=da;c[ca+8>>2]=Q;kc=Ta}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;T=M;U=kc;V=0;break};case 10:{Ta=L+ -2|0;c[n>>2]=Ta;c[v>>2]=c[P+(Ta<<2)>>2];T=M;U=N;V=0;break};case 5:{Ta=c[q>>2]|0;Q=a[Ta]|0;if(Q<<24>>24==0){T=M;U=N;V=0;break c}ca=c[v>>2]&1;da=(ca|0)!=0;if(da&Q<<24>>24==124){T=M;U=N;V=0;break c}do{if(!(da&Q<<24>>24==41&(M|0)>0)){if((ca|0)==0&Q<<24>>24==92){if((a[Ta+1|0]|0)==41){break}}S=_3a(m,5)|0;if((S|0)!=0){sa=M;ta=S;Z=6;break b}S=_3a(m,N)|0;if((S|0)!=0){sa=M;ta=S;Z=6;break b}S=_3a(m,6)|0;if((S|0)!=0){sa=M;ta=S;Z=6;break b}T=M;U=N;V=_3a(m,4)|0;break c}}while(0);Q=(ca|M|0)==0?8:0;da=M+ -1|0;if((ca|0)!=0){T=da;U=N;V=Q;break c}c[q>>2]=Ta+2;T=da;U=N;V=Q;break};default:{T=M;U=N;V=0}}}while(0);P=c[n>>2]|0;O=(V|0)==0;if((P|0)>(o|0)&O){L=P;M=T;N=U}else{lc=O;mc=T;nc=U;oc=V;break a}}if((Z|0)==6){lc=(ta|0)==0;mc=sa;nc=N;oc=ta;break}else if((Z|0)==294){i=d;return _|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){_=p?8:oc;i=d;return _|0}c[b+8>>2]=nc;_=0;i=d;return _|0}function U3a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=K4a((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=K4a((l<<2)+4|0)|0;if((p|0)==0){L4a(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}_3a(d,e)|0;e=_3a(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 4:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;G=v;H=w;I=c[D+(E<<2)>>2]|0;J=y;K=z;L=A;M=0;N=(F|0)>-1?F:B;break};case 2:{F=A;while(1){if((c[F>>2]|0)>-1){F=F+4|0}else{G=v;H=w;I=x;J=y;K=z;L=F;M=0;N=B;break}}break};case 6:{F=u+ -2|0;c[h>>2]=F;E=c[D+(F<<2)>>2]|0;F=0;do{O=A+(F<<2)|0;F=F+1|0}while((c[O>>2]|0)>-1);c[O>>2]=E<<1|1;c[A+(F<<2)>>2]=-1;P=0;while(1){if((c[p+(P<<2)>>2]|0)>-1){P=P+1|0}else{break}}c[p+(P+ -1<<2)>>2]=-1;G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 0:{F=u+ -2|0;c[h>>2]=F;E=c[D+(F<<2)>>2]|0;F=E;Q=E+12|0;R=c[Q>>2]|0;if((R|0)>-1){S=0;do{T=A+(S<<2)|0;S=S+1|0}while((c[T>>2]|0)>-1);c[T>>2]=R<<1;c[A+(S<<2)>>2]=-1;do{if(!k){P=0;while(1){if((c[p+(P<<2)>>2]|0)>-1){P=P+1|0}else{break}}c[(c[s>>2]|0)+(R*12|0)+8>>2]=0;if((P|0)<=0){break}U=K4a((P<<2)+4|0)|0;V=U;if((U|0)==0){W=w;X=y;Y=z;Z=A;_=12;$=B;break a}c[(c[s>>2]|0)+(R*12|0)+8>>2]=V;aa=c[p>>2]|0;if((aa|0)>-1){ba=V;ca=aa;aa=0;while(1){c[ba>>2]=ca;da=aa+1|0;ea=c[p+(da<<2)>>2]|0;fa=U+(da<<2)|0;if((ea|0)>-1){aa=da;ca=ea;ba=fa}else{ga=fa;break}}}else{ga=V}c[ga>>2]=-1}}while(0);R=_3a(d,c[Q>>2]|0)|0;if((R|0)!=0){W=w;X=y;Y=z;Z=A;_=R;$=B;break a}R=_3a(d,6)|0;if((R|0)!=0){W=w;X=y;Y=z;Z=A;_=R;$=B;break a}}R=c[E>>2]|0;do{if((R|0)==1){S=c[E+4>>2]|0;ba=c[S>>2]|0;ca=c[S+4>>2]|0;S=_3a(d,E)|0;if((S|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=S;na=B;break}S=_3a(d,5)|0;if((S|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=S;na=B;break}S=_3a(d,ca)|0;if((S|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=S;na=B;break}S=_3a(d,0)|0;if((S|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=S;na=B;break}S=ba+20|0;aa=_3a(d,(c[S>>2]|0)+x|0)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}if((c[S>>2]|0)>0){S=(c[ca+20>>2]|0)>0;oa=(S&1)+x|0;pa=S?x:-1}else{oa=x;pa=-1}S=_3a(d,pa)|0;if((S|0)!=0){ha=v;ia=w;ja=oa;ka=y;la=z;ma=S;na=B;break}S=_3a(d,4)|0;if((S|0)!=0){ha=v;ia=w;ja=oa;ka=y;la=z;ma=S;na=B;break}S=_3a(d,ba)|0;if((S|0)!=0){ha=v;ia=w;ja=oa;ka=y;la=z;ma=S;na=B;break}ha=v;ia=w;ja=oa;ka=y;la=z;ma=_3a(d,0)|0;na=B}else if((R|0)==3){S=c[E+4>>2]|0;ba=c[S>>2]|0;ca=c[S+4>>2]|0;S=(c[A>>2]|0)>-1;aa=x+1|0;U=_3a(d,S?aa:x)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=_3a(d,S?x:B)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=_3a(d,A)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=_3a(d,(c[A>>2]|0)>>>31^1)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=_3a(d,E)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=ca;ca=_3a(d,U)|0;if((ca|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ca;na=B;break}ca=ba;ba=_3a(d,ca)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,3)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,U)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,0)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,2)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,ca)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=_3a(d,0)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}if((c[A>>2]|0)>-1){if(k){qa=w;ra=y;sa=0}else{ba=a4a(b,F,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ca=c[t>>2]|0;U=0;while(1){ta=ca+(U<<2)|0;ua=U+1|0;if((c[ta>>2]|0)>-1){U=ua}else{break}}c[ta>>2]=B;c[ca+(ua<<2)>>2]=w;c[ca+(U+2<<2)>>2]=-1;va=-1;wa=y+1|0}else{va=w;wa=y}V=c[A>>2]|0;if((V|0)>-1){S=c[s>>2]|0;P=V;V=0;do{fa=(P|0)/2|0;if((P&1|0)==0){c[S+(fa*12|0)>>2]=B}else{c[S+(fa*12|0)+4>>2]=B}V=V+1|0;P=c[A+(V<<2)>>2]|0;}while((P|0)>-1)}c[A>>2]=-1;qa=va;ra=wa;sa=ba}c[A>>2]=-1;xa=qa;ya=aa;za=ra;Aa=z+1|0;Ba=sa;Ca=x}else{xa=w;ya=x;za=y;Aa=z;Ba=0;Ca=B}if((c[E+16>>2]|0)<=0){ha=v;ia=xa;ja=ya;ka=za;la=Aa;ma=Ba;na=Ca;break}ha=v;ia=xa;ja=ya+2|0;ka=za;la=Aa;ma=Ba;na=ya+1|0}else if((R|0)==2){P=c[E+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Da=1}else{Da=a[P+12|0]&1}V=_3a(d,Da)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}}else{V=_3a(d,B)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=_3a(d,a[P+12|0]&1)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}}V=_3a(d,E)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=_3a(d,1)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=_3a(d,c[P>>2]|0)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=_3a(d,0)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}if(!((c[A>>2]|0)>-1)){if((a[P+12|0]&1)==0){ha=0;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}}if(k){Ea=w;Fa=y;Ga=0}else{V=a4a(b,F,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[P+12|0]&1)==0?v:1;if((w|0)>-1){P=c[t>>2]|0;S=0;while(1){Ha=P+(S<<2)|0;Ia=S+1|0;if((c[Ha>>2]|0)>-1){S=Ia}else{break}}c[Ha>>2]=B;c[P+(Ia<<2)>>2]=w;c[P+(S+2<<2)>>2]=-1;Ja=-1;Ka=y+1|0}else{Ja=w;Ka=y}aa=c[A>>2]|0;if((aa|0)>-1){ba=c[s>>2]|0;U=aa;aa=0;do{ca=(U|0)/2|0;if((U&1|0)==0){c[ba+(ca*12|0)>>2]=B}else{c[ba+(ca*12|0)+4>>2]=B}aa=aa+1|0;U=c[A+(aa<<2)>>2]|0;}while((U|0)>-1)}c[A>>2]=-1;Ea=Ja;Fa=Ka;Ga=V}c[A>>2]=-1;ha=0;ia=Ea;ja=x+1|0;ka=Fa;la=z+1|0;ma=Ga;na=x}else if((R|0)==0){U=c[c[E+4>>2]>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}if(!((c[A>>2]|0)>-1)){ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}if(k){c[E+20>>2]=1;La=w;Ma=y;Na=0}else{U=a4a(b,F,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){aa=c[t>>2]|0;ba=0;while(1){Oa=aa+(ba<<2)|0;Pa=ba+1|0;if((c[Oa>>2]|0)>-1){ba=Pa}else{break}}c[Oa>>2]=B;c[aa+(Pa<<2)>>2]=w;c[aa+(ba+2<<2)>>2]=-1;Qa=-1;Ra=y+1|0}else{Qa=w;Ra=y}V=c[A>>2]|0;if((V|0)>-1){S=c[s>>2]|0;P=V;V=0;do{ca=(P|0)/2|0;if((P&1|0)==0){c[S+(ca*12|0)>>2]=B}else{c[S+(ca*12|0)+4>>2]=B}V=V+1|0;P=c[A+(V<<2)>>2]|0;}while((P|0)>-1)}c[A>>2]=-1;La=Qa;Ma=Ra;Na=U}c[A>>2]=-1;ha=v;ia=La;ja=x+1|0;ka=Ma;la=z+1|0;ma=Na;na=x}else{ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B}}while(0);F=c[Q>>2]|0;if((F|0)>-1){Sa=0}else{G=ha;H=ia;I=ja;J=ka;K=la;L=A;M=ma;N=na;break b}do{Ta=p+(Sa<<2)|0;Sa=Sa+1|0}while((c[Ta>>2]|0)>-1);c[Ta>>2]=F;c[p+(Sa<<2)>>2]=-1;G=ha;H=ia;I=ja;J=ka;K=la;L=A;M=ma;N=na;break};case 1:{Q=u+ -2|0;c[h>>2]=Q;E=c[D+(Q<<2)>>2]|0;if(k){Q=c[(c[c[E+4>>2]>>2]|0)+20>>2]|0;R=u+ -3|0;c[h>>2]=R;c[E+20>>2]=(c[D+(R<<2)>>2]|0)+Q;G=v;H=-1;I=x;J=y;K=z;L=A;M=0;N=B;break b}else{Q=u+ -3|0;c[h>>2]=Q;R=c[D+(Q<<2)>>2]|0;Q=u+ -4|0;c[h>>2]=Q;E=(R|0)==0;G=E&1;H=E?w:c[D+(Q<<2)>>2]|0;I=x;J=y;K=z;L=A;M=0;N=B;break b}break};case 3:{Q=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;R=c[D+(u+ -4<<2)>>2]|0;P=u+ -5|0;c[h>>2]=P;if(k){V=c[R+4>>2]|0;S=R+16|0;c[R+20>>2]=(c[(c[V>>2]|0)+20>>2]|0)+(c[D+(P<<2)>>2]|0)+(c[(c[V+4>>2]|0)+20>>2]|0)+((c[S>>2]|0)>0?2:0);Ua=S;Va=c[h>>2]|0}else{Ua=R+16|0;Va=P}P=c[D+(Va+ -1<<2)>>2]|0;R=Va+ -2|0;c[h>>2]=R;S=c[D+(R<<2)>>2]|0;R=Va+ -3|0;c[h>>2]=R;V=c[D+(R<<2)>>2]|0;if((c[Ua>>2]|0)<=0){G=1;H=w;I=x;J=y;K=z;L=P;M=0;N=B;break b}if(k){Wa=0}else{b4a(b,Q,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;S=b4a(b,E,V)|0;c[(c[r>>2]|0)+(V<<2)>>2]=1;Wa=S}G=1;H=w;I=x;J=y;K=z+2|0;L=P;M=Wa;N=B;break};case 5:{P=u+ -2|0;c[h>>2]=P;S=c[D+(P<<2)>>2]|0;if(!k){G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break b}P=c[S+4>>2]|0;c[S+20>>2]=(c[(c[P+4>>2]|0)+20>>2]|0)+(c[(c[P>>2]|0)+20>>2]|0);G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};default:{G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(M|0)==0){u=D;v=G;w=H;x=I;y=J;z=K;A=L;B=N}else{W=H;X=J;Y=K;Z=L;_=M;$=N;break a}}}else{W=-1;X=0;Y=0;Z=n;_=e;$=0}}while(0);do{if(k){Xa=X}else{e=c[Z>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;N=e;e=0;do{M=(N|0)/2|0;if((N&1|0)==0){c[n+(M*12|0)>>2]=$}else{c[n+(M*12|0)+4>>2]=$}e=e+1|0;N=c[Z+(e<<2)>>2]|0;}while((N|0)>-1)}c[Z>>2]=-1;if(!((W|0)>-1)){Xa=X;break}N=c[f+36>>2]|0;e=0;while(1){Ya=N+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=$;c[N+(Za<<2)>>2]=W;c[N+(e+2<<2)>>2]=-1;Xa=X+1|0}}while(0);c[f+48>>2]=Y;c[f+40>>2]=Y;c[f+44>>2]=Xa;L4a(m);L4a(p);o=_;i=g;return o|0}function V3a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=X3a(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==3){h=c[g+4>>2]|0;j=V3a(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=X3a(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=V3a(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function W3a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{L4a(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}L4a(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){L4a(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){L4a(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}L4a(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{L4a(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}L4a(m)}m=c[d+32>>2]|0;if((m|0)!=0){L4a(m)}m=c[d+20>>2]|0;if((m|0)!=0){L4a(m)}m=c[d+36>>2]|0;if((m|0)!=0){L4a(m)}L4a(d);i=b;return}function X3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=K4a(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){L4a(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=K4a((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function Y3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=i4a(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=i4a(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=i4a(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function Z3a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=_3a(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=_3a(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=_3a(a,c[r+4>>2]|0)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=_3a(a,r)|0}else if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=_3a(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=_3a(a,s)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function _3a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=N4a(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;_3a(a,b)|0;i=d;return 0}return 0}function $3a(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;_3a(d,e)|0;e=_3a(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==0){y=c[u+4>>2]|0;x=c[y+8>>2]|0;D=c[y>>2]|0;E=c[y+4>>2]|0;do{if((D|0)>-1|(D|0)==-4){F=r;G=E;H=D;I=s+1|0;J=(c[g>>2]|0)+x|0}else{if(!((D|0)==-3)){F=r;G=E;H=D;I=s;J=x;break}if(!p){F=r;G=-1;H=-1;I=s;J=-1;break}if(q|(r|0)==0){F=r;G=E;H=-3;I=s;J=x;break}c[h+(E<<2)>>2]=1;F=0;G=E;H=-3;I=s;J=x}}while(0);x=i4a(b,0,0,1,32)|0;E=x;do{if((x|0)==0){K=0}else{D=i4a(b,0,0,1,20)|0;c[x+4>>2]=D;if((D|0)==0){K=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=H;c[D+4>>2]=G;c[D+8>>2]=J;K=E}}while(0);c[t>>2]=K;E=(K|0)==0?12:0;if((J|0)<=(c[k>>2]|0)){L=F;M=I;N=t;O=E;break}c[k>>2]=J;L=F;M=I;N=t;O=E}else if((z|0)==3){E=c[u+4>>2]|0;x=c[E>>2]|0;D=E+4|0;y=c[D>>2]|0;P=i4a(b,0,0,1,32)|0;if((P|0)==0){Q=20;break b}R=i4a(b,0,0,1,8)|0;S=P+4|0;c[S>>2]=R;if((R|0)==0){Q=20;break b}c[P>>2]=3;c[P+8>>2]=-1;c[P+12>>2]=-1;c[R>>2]=x;c[(c[S>>2]|0)+4>>2]=y;c[P+16>>2]=(c[y+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=P;P=c[S>>2]|0;S=_3a(d,c[D>>2]|0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,P+4|0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,1)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,c[E>>2]|0)|0;if((S|0)!=0){v=s;w=S;break a}L=r;M=s;N=P;O=_3a(d,0)|0}else if((z|0)==1){P=c[u+4>>2]|0;S=c[P>>2]|0;E=P+4|0;D=c[E>>2]|0;x=i4a(b,0,0,1,32)|0;if((x|0)==0){Q=29;break b}y=i4a(b,0,0,1,8)|0;R=x+4|0;c[R>>2]=y;if((y|0)==0){Q=29;break b}c[x>>2]=1;c[x+8>>2]=-1;c[x+12>>2]=-1;c[y>>2]=S;c[(c[R>>2]|0)+4>>2]=D;c[x+16>>2]=(c[D+16>>2]|0)+(c[S+16>>2]|0);c[t>>2]=x;x=c[R>>2]|0;c[x>>2]=0;R=x+4|0;c[R>>2]=0;S=_3a(d,c[E>>2]|0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,R)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,1)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,c[P>>2]|0)|0;if((S|0)!=0){v=s;w=S;break a}L=r;M=s;N=x;O=_3a(d,0)|0}else if((z|0)==2){x=c[u+4>>2]|0;S=_3a(d,c[x>>2]|0)|0;if((S|0)!=0){v=s;w=S;break a}S=_3a(d,0)|0;if((S|0)!=0){v=s;w=S;break a}S=c[x>>2]|0;P=c[x+4>>2]|0;R=c[x+8>>2]|0;E=a[x+12|0]|0;x=i4a(b,0,0,1,32)|0;if((x|0)==0){Q=40;break b}D=i4a(b,0,0,1,16)|0;y=x+4|0;c[y>>2]=D;if((D|0)==0){Q=40;break b}c[x>>2]=2;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=S;c[D+4>>2]=P;c[D+8>>2]=R;R=D+12|0;a[R]=a[R]&-2|E&1;c[x+16>>2]=c[S+16>>2];c[t>>2]=x;A=s;B=r;t=c[y>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((O|0)==0){r=L;s=M;t=N}else{v=M;w=O;break a}}if((Q|0)==20){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==29){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function a4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=i4a(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=i4a(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=i4a(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=i4a(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function b4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=i4a(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=i4a(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=i4a(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=i4a(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function c4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function d4a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=331456}else{j=b;k=331456;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((m5a(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Pc(e|0,f|0,331744,g|0)|0)+1|0;i=d;return h|0}function e4a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=K4a(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=K4a(y)|0;if((z|0)==0){A=12;break}q5a(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=O3a(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((t3a(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((t3a(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((t3a(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((t3a(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(t3a(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(t3a(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(t3a(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(t3a(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){q5a(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=O3a(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((t3a(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((t3a(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((t3a(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((t3a(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(t3a(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(t3a(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(t3a(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(t3a(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((x3a(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=J3a(X)|0;qb=_a+24|0;if((x3a(fb,c[qb>>2]|0)|0)!=0){break}fb=H3a(X)|0;if((x3a(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((x3a(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=H3a(X)|0;if((x3a(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=J3a(X)|0;if((x3a(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}L4a(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=g4a(0,0)|0;if((S|0)==0){A=12;break}R=i4a(S,0,0,0,32)|0;Q=R;if((R|0)==0){h4a(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=K4a(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=K4a(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=K4a(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){q5a(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){q5a(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=O3a(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((t3a(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((t3a(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((t3a(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((t3a(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(t3a(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(t3a(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(t3a(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(t3a(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=i4a(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=i4a(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;f4a(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((j5a(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=O3a(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=O3a(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((t3a(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((t3a(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((t3a(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((t3a(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(t3a(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(t3a(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(t3a(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(t3a(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((x3a(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=J3a(tc)|0;aa=Ca+24|0;if((x3a(qa,c[aa>>2]|0)|0)!=0){break}qa=H3a(tc)|0;if((x3a(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((x3a(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=H3a(tc)|0;if((x3a(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=J3a(tc)|0;if((x3a(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=i4a(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=i4a(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){h4a(S);if((Eb|0)!=0){L4a(O)}if((Kb|0)!=0){L4a(Kb)}if((Lb|0)==0){A=12;break a}L4a(N);A=12;break a}else if((sa|0)==67){h4a(S);if((Eb|0)!=0){L4a(O)}if((Kb|0)!=0){L4a(Kb)}if((Lb|0)==0){A=12;break a}L4a(N);A=12;break a}else if((sa|0)==169){h4a(S);if((Eb|0)!=0){L4a(O)}if((Kb|0)!=0){L4a(Kb)}if((Lb|0)==0){A=12;break a}L4a(N);A=12;break a}else if((sa|0)==176){h4a(S);if((Eb|0)!=0){L4a(O)}if((Kb|0)!=0){L4a(Kb)}if((Lb|0)==0){A=12;break a}L4a(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);h4a(S);if((Jb|0)!=0){L4a(Jb)}if((Gb|0)!=0){L4a(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}L4a(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}f4a(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}L4a(m);p=A;i=g;return p|0}function f4a(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function g4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=M4a(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function h4a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;L4a(e);i=b;return}else{f=d}while(1){L4a(c[f>>2]|0);d=c[f+4>>2]|0;L4a(f);if((d|0)==0){break}else{f=d}}e=a;L4a(e);i=b;return}function i4a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=K4a(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=K4a(p)|0;c[o>>2]=r;if((r|0)==0){L4a(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}q5a(m|0,0,h|0)|0;j=m;i=g;return j|0}function j4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((k4a(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function k4a(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function l4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function m4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function n4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function o4a(a){a=a|0;i=i;return}function p4a(a){a=a|0;c[a>>2]=331760;i=i;return}function q4a(a){a=a|0;var b=0;b=i;Bb(a|0);S4a(a);i=b;return}function r4a(a){a=a|0;var b=0;b=i;Bb(a|0);i=b;return}function s4a(a){a=a|0;i=i;return 331776}function t4a(a){a=a|0;i=i;return}function u4a(a){a=a|0;i=i;return}function v4a(a){a=a|0;i=i;return}function w4a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function x4a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function y4a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function z4a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=D4a(b,331888,331944,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ne[c[(c[h>>2]|0)+28>>2]&127](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function A4a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function B4a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ne[c[(c[h>>2]|0)+28>>2]&127](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function C4a(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ne[c[(c[l>>2]|0)+28>>2]&127](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ne[c[(c[m>>2]|0)+28>>2]&127](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function D4a(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;we[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ge[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function E4a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;we[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ge[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ge[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ge[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ge[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function F4a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ge[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;we[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function G4a(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function H4a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;we[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;we[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function I4a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;we[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function J4a(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}



function Cla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149904]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(149912,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3080>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[149904]=1;i=d;return}function Dla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150032]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(150040,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3088>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150032]=1;i=d;return}function Ela(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150160]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(150168,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7384>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150160]=1;i=d;return}function Fla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150296]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(150304,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3064>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150296]=1;i=d;return}function Gla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150424]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(150432,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7376>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150424]=1;i=d;return}function Hla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150560]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(150568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3048>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150560]=1;i=d;return}function Ila(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150688]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(150696,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7368>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150688]=1;i=d;return}function Jla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150848]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(150856,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3032>>3],67480)|0)|0;g=c[72854]|0;j=e;k=150976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[150848]=1;i=d;return}function Kla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151e3]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(151008,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3016>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151e3]=1;i=d;return}function Lla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151176]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(151184,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3008>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151176]=1;i=d;return}function Mla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(151352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7360>>3],67480)|0)|0;g=c[72854]|0;j=e;k=152088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151344]=1;i=d;return}function Nla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151520]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],1.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=ACa(151528,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2984>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151520]=1;i=d;return}function Ola(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151720]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=ACa(151728,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2976>>3],67480)|0)|0;g=c[72854]|0;j=e;k=151888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151720]=1;i=d;return}function Pla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151912]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],-1.0e10)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=ACa(151920,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7352>>3],67480)|0)|0;g=c[72854]|0;j=e;k=152088;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[151912]=1;i=d;return}function Qla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(152120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],67480)|0)|0;g=c[72854]|0;j=e;k=152448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152112]=1;i=d;return}function Rla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152280]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=ACa(152288,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],67480)|0)|0;g=c[72854]|0;j=e;k=152448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152280]=1;i=d;return}function Sla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152472]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(152480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7344>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152472]=1;i=d;return}function Tla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152616]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(152624,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7336>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152616]=1;i=d;return}function Ula(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152760]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(152768,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7328>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152760]=1;i=d;return}function Vla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152904]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(152912,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7320>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[152904]=1;i=d;return}function Wla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153048]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(153056,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7312>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[153048]=1;i=d;return}function Xla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153184]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(153192,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7304>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[153184]=1;i=d;return}function Yla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153320]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(153328,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7296>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[153320]=1;i=d;return}function Zla(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153456]&1){i=d;return}g=b+4|0;if(!((sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=ACa(153464,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7288>>3],67480)|0)|0;g=c[72854]|0;j=e;k=153592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[153456]=1;i=d;return}function _la(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153616]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(153624,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[153616]=1;i=d;return}function $la(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153768]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(153776,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[153768]=1;i=d;return}function ama(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153920]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(153928,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2864>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[153920]=1;i=d;return}function bma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154080]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(154088,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2856>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[154080]=1;i=d;return}function cma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154240]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(154248,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2848>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[154240]=1;i=d;return}function dma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154400]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(154408,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2840>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[154400]=1;i=d;return}function ema(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154560]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(154568,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2832>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[154560]=1;i=d;return}function fma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154720]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2824>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2824>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(154728,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2824>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[154720]=1;i=d;return}function gma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154880]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(154888,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[154880]=1;i=d;return}function hma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155032]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(155040,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[155032]=1;i=d;return}function ima(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155184]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(155192,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155184]=1;i=d;return}function jma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(155352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155344]=1;i=d;return}function kma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(155512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155504]=1;i=d;return}function lma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155664]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(155672,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155664]=1;i=d;return}function mma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155824]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(155832,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155824]=1;i=d;return}function nma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155984]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(155992,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[155984]=1;i=d;return}function oma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156144]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(156152,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[156144]=1;i=d;return}function pma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156288]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(156296,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[156288]=1;i=d;return}function qma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156432]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2736>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2736>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(156440,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2736>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[156432]=1;i=d;return}function rma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156584]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2728>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2728>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(156592,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2728>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[156584]=1;i=d;return}function sma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156736]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2720>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2720>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(156744,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2720>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[156736]=1;i=d;return}function tma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156888]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(156896,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[156888]=1;i=d;return}function uma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157040]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(157048,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157040]=1;i=d;return}function vma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(157200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2696>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157192]=1;i=d;return}function wma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(157352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157344]=1;i=d;return}function xma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(157488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7264>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157480]=1;i=d;return}function yma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157616]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(157624,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7256>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157616]=1;i=d;return}function zma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157752]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(157760,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2672>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157752]=1;i=d;return}function Ama(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157872]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(157880,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7248>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157872]=1;i=d;return}function Bma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157992]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(158e3,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7240>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[157992]=1;i=d;return}function Cma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158112]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(158120,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2656>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158112]=1;i=d;return}function Dma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158232]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7232>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7232>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(158240,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7232>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158232]=1;i=d;return}function Ema(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158352]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7224>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7224>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(158360,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7224>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158352]=1;i=d;return}function Fma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158472]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(158480,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2640>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158472]=1;i=d;return}function Gma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158592]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7216>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7216>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(158600,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7216>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158592]=1;i=d;return}function Hma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158712]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7208>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7208>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(158720,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7208>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158712]=1;i=d;return}function Ima(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158832]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2616>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2616>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(158840,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2616>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158832]=1;i=d;return}function Jma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158952]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7200>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7200>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(158960,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7200>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[158952]=1;i=d;return}function Kma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7192>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7192>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(159080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7192>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159072]=1;i=d;return}function Lma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2600>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2600>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(159200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2600>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159192]=1;i=d;return}function Mma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159312]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7184>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7184>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(159320,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7184>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159312]=1;i=d;return}function Nma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159432]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7176>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7176>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(159440,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7176>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159432]=1;i=d;return}function Oma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159552]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2584>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2584>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(159560,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2584>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159552]=1;i=d;return}function Pma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159672]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7168>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7168>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(159680,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7168>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159672]=1;i=d;return}function Qma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159792]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7160>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7160>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(159800,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7160>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[159792]=1;i=d;return}function Rma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159912]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(159920,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[159912]=1;i=d;return}function Sma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160072]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2568>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2568>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(160080,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2568>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160072]=1;i=d;return}function Tma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160192]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7144>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7144>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(160200,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7144>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160192]=1;i=d;return}function Uma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160312]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7136>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7136>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(160320,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7136>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160312]=1;i=d;return}function Vma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160432]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(160440,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[160432]=1;i=d;return}function Wma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160592]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2552>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2552>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(160600,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2552>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160592]=1;i=d;return}function Xma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160712]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7120>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7120>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(160720,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7120>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160712]=1;i=d;return}function Yma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160832]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7112>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7112>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(160840,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7112>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[160832]=1;i=d;return}function Zma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160952]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(160960,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[160952]=1;i=d;return}function _ma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161080]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(161088,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[161080]=1;i=d;return}function $ma(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161208]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(161216,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2544>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[161208]=1;i=d;return}function ana(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161344]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7104>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7104>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(161352,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7104>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[161344]=1;i=d;return}function bna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161480]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7096>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7096>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(161488,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+7096>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[161480]=1;i=d;return}function cna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161616]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(161624,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[161616]=1;i=d;return}function dna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161744]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(161752,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[161744]=1;i=d;return}function ena(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161872]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(161880,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[161872]=1;i=d;return}function fna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162e3]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162008,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162e3]=1;i=d;return}function gna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162128]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162136,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162128]=1;i=d;return}function hna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162256]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162264,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162256]=1;i=d;return}function ina(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162384]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162392,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162384]=1;i=d;return}function jna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162512]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162520,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162512]=1;i=d;return}function kna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162640]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162648,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162640]=1;i=d;return}function lna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162768]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162776,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162768]=1;i=d;return}function mna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162896]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(162904,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[162896]=1;i=d;return}function nna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163024]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163032,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163024]=1;i=d;return}function ona(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163152]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163160,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163152]=1;i=d;return}function pna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163280]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163288,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163280]=1;i=d;return}function qna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163408]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163416,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163408]=1;i=d;return}function rna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163536]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163544,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163536]=1;i=d;return}function sna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163664]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163672,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163664]=1;i=d;return}function tna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163792]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163800,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163792]=1;i=d;return}function una(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163920]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(163928,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[163920]=1;i=d;return}function vna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164048]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164056,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164048]=1;i=d;return}function wna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164176]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164184,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164176]=1;i=d;return}function xna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164304]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164312,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164304]=1;i=d;return}function yna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164432]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164440,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164432]=1;i=d;return}function zna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164560]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164568,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164560]=1;i=d;return}function Ana(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164688]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164696,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164688]=1;i=d;return}function Bna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164816]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164824,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164816]=1;i=d;return}function Cna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164944]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(164952,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[164944]=1;i=d;return}function Dna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165072]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165080,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165072]=1;i=d;return}function Ena(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165200]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165208,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165200]=1;i=d;return}function Fna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165328]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165336,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165328]=1;i=d;return}function Gna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165456]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165464,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165456]=1;i=d;return}function Hna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165584]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165592,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165584]=1;i=d;return}function Ina(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165712]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165720,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165712]=1;i=d;return}function Jna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165840]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165848,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165840]=1;i=d;return}function Kna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165968]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(165976,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[165968]=1;i=d;return}function Lna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166096]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(166104,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[166096]=1;i=d;return}function Mna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166224]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(166232,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[166224]=1;i=d;return}function Nna(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166352]&1){i=d;return}g=b+4|0;b=sFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(qFa(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=ACa(166360,xCa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,66928)|0)|0;g=c[72854]|0;h=e;j=166480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Je[g&15](e,b,f);a[166352]=1;i=d;return}function Ona(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166504]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],1.0)|0)<<24>>24==0)){i=d;return}b=ACa(166512,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2536>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[166504]=1;i=d;return}function Pna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166648]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],0.0)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=ACa(166656,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6824>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[166648]=1;i=d;return}function Qna(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166792]&1){i=d;return}g=b+4|0;b=sFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],.001)|0;if(!(b<<24>>24==0|(qFa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],.25)|0)<<24>>24==0)){i=d;return}b=ACa(166800,vCa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6816>>3],67480)|0)|0;g=c[72854]|0;j=e;k=166912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Je[g&15](e,b,f);a[166792]=1;i=d;return}function Rna(a){a=a|0;var b=0;b=i;Y0(a);Z0(a);_0(a);$0(a);a1(a);b1(a);c1(a);d1(a);e1(a);f1(a);g1(a);h1(a);i1(a);j1(a);k1(a);l1(a);m1(a);n1(a);o1(a);p1(a);q1(a);r1(a);s1(a);t1(a);u1(a);v1(a);w1(a);x1(a);y1(a);z1(a);A1(a);B1(a);C1(a);D1(a);E1(a);F1(a);G1(a);H1(a);I1(a);J1(a);K1(a);L1(a);M1(a);N1(a);O1(a);P1(a);Q1(a);R1(a);S1(a);T1(a);U1(a);V1(a);W1(a);X1(a);Y1(a);Z1(a);_1(a);$1(a);a2(a);b2(a);c2(a);d2(a);e2(a);f2(a);g2(a);h2(a);i2(a);j2(a);k2(a);l2(a);m2(a);n2(a);o2(a);p2(a);q2(a);r2(a);s2(a);t2(a);u2(a);v2(a);w2(a);x2(a);y2(a);z2(a);A2(a);B2(a);C2(a);D2(a);E2(a);F2(a);G2(a);H2(a);I2(a);J2(a);K2(a);L2(a);M2(a);N2(a);O2(a);P2(a);Q2(a);R2(a);S2(a);T2(a);U2(a);V2(a);W2(a);X2(a);Y2(a);Z2(a);_2(a);$2(a);a3(a);b3(a);c3(a);d3(a);e3(a);f3(a);g3(a);h3(a);i3(a);j3(a);k3(a);l3(a);m3(a);n3(a);o3(a);p3(a);q3(a);r3(a);s3(a);t3(a);u3(a);v3(a);w3(a);x3(a);y3(a);z3(a);A3(a);B3(a);C3(a);D3(a);E3(a);F3(a);G3(a);H3(a);I3(a);J3(a);K3(a);L3(a);M3(a);N3(a);O3(a);P3(a);Q3(a);R3(a);S3(a);T3(a);U3(a);V3(a);W3(a);X3(a);Y3(a);Z3(a);_3(a);$3(a);a4(a);b4(a);c4(a);d4(a);e4(a);f4(a);g4(a);h4(a);i4(a);j4(a);k4(a);l4(a);m4(a);n4(a);o4(a);p4(a);q4(a);r4(a);s4(a);t4(a);u4(a);v4(a);w4(a);x4(a);y4(a);z4(a);A4(a);B4(a);C4(a);D4(a);E4(a);F4(a);G4(a);H4(a);I4(a);J4(a);K4(a);L4(a);M4(a);N4(a);O4(a);P4(a);Q4(a);R4(a);S4(a);T4(a);U4(a);V4(a);W4(a);X4(a);Y4(a);Z4(a);_4(a);$4(a);a5(a);b5(a);c5(a);d5(a);e5(a);f5(a);g5(a);h5(a);i5(a);j5(a);k5(a);l5(a);m5(a);n5(a);o5(a);p5(a);q5(a);r5(a);s5(a);t5(a);u5(a);v5(a);w5(a);x5(a);y5(a);z5(a);A5(a);B5(a);C5(a);D5(a);E5(a);F5(a);G5(a);H5(a);I5(a);J5(a);K5(a);L5(a);M5(a);N5(a);O5(a);P5(a);Q5(a);R5(a);S5(a);T5(a);U5(a);V5(a);W5(a);X5(a);Y5(a);Z5(a);_5(a);$5(a);a6(a);b6(a);c6(a);d6(a);e6(a);f6(a);g6(a);h6(a);i6(a);j6(a);k6(a);l6(a);m6(a);n6(a);o6(a);p6(a);q6(a);r6(a);s6(a);t6(a);u6(a);v6(a);w6(a);x6(a);y6(a);z6(a);A6(a);B6(a);C6(a);D6(a);E6(a);F6(a);G6(a);H6(a);I6(a);J6(a);K6(a);L6(a);M6(a);N6(a);O6(a);P6(a);Q6(a);R6(a);S6(a);T6(a);U6(a);V6(a);W6(a);X6(a);Y6(a);Z6(a);_6(a);$6(a);a7(a);b7(a);c7(a);d7(a);e7(a);f7(a);g7(a);h7(a);i7(a);j7(a);k7(a);l7(a);m7(a);n7(a);o7(a);p7(a);q7(a);r7(a);s7(a);t7(a);u7(a);v7(a);w7(a);x7(a);y7(a);z7(a);A7(a);B7(a);C7(a);D7(a);E7(a);F7(a);G7(a);H7(a);I7(a);J7(a);K7(a);L7(a);M7(a);N7(a);O7(a);P7(a);Q7(a);R7(a);S7(a);T7(a);U7(a);V7(a);W7(a);X7(a);Y7(a);Z7(a);_7(a);$7(a);a8(a);b8(a);c8(a);d8(a);e8(a);f8(a);g8(a);h8(a);i8(a);j8(a);k8(a);l8(a);m8(a);n8(a);o8(a);p8(a);q8(a);r8(a);s8(a);t8(a);u8(a);v8(a);w8(a);x8(a);y8(a);z8(a);A8(a);B8(a);C8(a);D8(a);E8(a);F8(a);G8(a);H8(a);I8(a);J8(a);K8(a);L8(a);M8(a);N8(a);O8(a);P8(a);Q8(a);R8(a);S8(a);T8(a);U8(a);V8(a);W8(a);X8(a);Y8(a);Z8(a);_8(a);$8(a);a9(a);b9(a);c9(a);d9(a);e9(a);f9(a);g9(a);h9(a);i9(a);j9(a);k9(a);l9(a);m9(a);n9(a);o9(a);p9(a);q9(a);r9(a);s9(a);t9(a);u9(a);v9(a);w9(a);x9(a);y9(a);z9(a);A9(a);B9(a);C9(a);D9(a);E9(a);F9(a);G9(a);H9(a);I9(a);J9(a);K9(a);L9(a);M9(a);N9(a);O9(a);P9(a);Q9(a);R9(a);S9(a);T9(a);U9(a);V9(a);W9(a);X9(a);Y9(a);Z9(a);_9(a);$9(a);aaa(a);baa(a);caa(a);daa(a);eaa(a);faa(a);gaa(a);haa(a);iaa(a);jaa(a);kaa(a);laa(a);maa(a);naa(a);oaa(a);paa(a);qaa(a);raa(a);saa(a);taa(a);uaa(a);vaa(a);waa(a);xaa(a);yaa(a);zaa(a);Aaa(a);Baa(a);Caa(a);Daa(a);Eaa(a);Faa(a);Gaa(a);Haa(a);Iaa(a);Jaa(a);Kaa(a);Laa(a);Maa(a);Naa(a);Oaa(a);Paa(a);Qaa(a);Raa(a);Saa(a);Taa(a);Uaa(a);Vaa(a);Waa(a);Xaa(a);Yaa(a);Zaa(a);_aa(a);$aa(a);aba(a);bba(a);cba(a);dba(a);eba(a);fba(a);gba(a);hba(a);iba(a);jba(a);kba(a);lba(a);mba(a);nba(a);oba(a);pba(a);qba(a);rba(a);sba(a);tba(a);uba(a);vba(a);wba(a);xba(a);yba(a);zba(a);Aba(a);Bba(a);Cba(a);Dba(a);Eba(a);Fba(a);Gba(a);Hba(a);Iba(a);Jba(a);Kba(a);Lba(a);Mba(a);Nba(a);Oba(a);Pba(a);Qba(a);Rba(a);Sba(a);Tba(a);Uba(a);Vba(a);Wba(a);Xba(a);Yba(a);Zba(a);_ba(a);$ba(a);aca(a);bca(a);cca(a);dca(a);eca(a);fca(a);gca(a);hca(a);ica(a);jca(a);kca(a);lca(a);mca(a);nca(a);oca(a);pca(a);qca(a);rca(a);sca(a);tca(a);uca(a);vca(a);wca(a);xca(a);yca(a);zca(a);Aca(a);Bca(a);Cca(a);Dca(a);Eca(a);Fca(a);Gca(a);Hca(a);Ica(a);Jca(a);Kca(a);Lca(a);Mca(a);Nca(a);Oca(a);Pca(a);Qca(a);Rca(a);Sca(a);Tca(a);Uca(a);Vca(a);Wca(a);Xca(a);Yca(a);Zca(a);_ca(a);$ca(a);ada(a);bda(a);cda(a);dda(a);eda(a);fda(a);gda(a);hda(a);ida(a);jda(a);kda(a);lda(a);mda(a);nda(a);oda(a);pda(a);qda(a);rda(a);sda(a);tda(a);uda(a);vda(a);wda(a);xda(a);yda(a);zda(a);Ada(a);Bda(a);Cda(a);Dda(a);Eda(a);Fda(a);Gda(a);Hda(a);Ida(a);Jda(a);Kda(a);Lda(a);Mda(a);Nda(a);Oda(a);Pda(a);Qda(a);Rda(a);Sda(a);Tda(a);Uda(a);Vda(a);Wda(a);Xda(a);Yda(a);Zda(a);_da(a);$da(a);aea(a);bea(a);cea(a);dea(a);eea(a);fea(a);gea(a);hea(a);iea(a);jea(a);kea(a);lea(a);mea(a);nea(a);oea(a);pea(a);qea(a);rea(a);sea(a);tea(a);uea(a);vea(a);wea(a);xea(a);yea(a);zea(a);Aea(a);Bea(a);Cea(a);Dea(a);Eea(a);Fea(a);Gea(a);Hea(a);Iea(a);Jea(a);Kea(a);Lea(a);Mea(a);Nea(a);Oea(a);Pea(a);Qea(a);Rea(a);Sea(a);Tea(a);Uea(a);Vea(a);Wea(a);Xea(a);Yea(a);Zea(a);_ea(a);$ea(a);afa(a);bfa(a);cfa(a);dfa(a);efa(a);ffa(a);gfa(a);hfa(a);ifa(a);jfa(a);kfa(a);lfa(a);mfa(a);nfa(a);ofa(a);pfa(a);qfa(a);rfa(a);sfa(a);tfa(a);ufa(a);vfa(a);wfa(a);xfa(a);yfa(a);zfa(a);Afa(a);Bfa(a);Cfa(a);Dfa(a);Efa(a);Ffa(a);Gfa(a);Hfa(a);Ifa(a);Jfa(a);Kfa(a);Lfa(a);Mfa(a);Nfa(a);Ofa(a);Pfa(a);Qfa(a);Rfa(a);Sfa(a);Tfa(a);Ufa(a);Vfa(a);Wfa(a);Xfa(a);Yfa(a);Zfa(a);_fa(a);$fa(a);aga(a);bga(a);cga(a);dga(a);ega(a);fga(a);gga(a);hga(a);iga(a);jga(a);kga(a);lga(a);mga(a);nga(a);oga(a);pga(a);qga(a);rga(a);sga(a);tga(a);uga(a);vga(a);wga(a);xga(a);yga(a);zga(a);Aga(a);Bga(a);Cga(a);Dga(a);Ega(a);Fga(a);Gga(a);Hga(a);Iga(a);Jga(a);Kga(a);Lga(a);Mga(a);Nga(a);Oga(a);Pga(a);Qga(a);Rga(a);Sga(a);Tga(a);Uga(a);Vga(a);Wga(a);Xga(a);Yga(a);Zga(a);_ga(a);$ga(a);aha(a);bha(a);cha(a);dha(a);eha(a);fha(a);gha(a);hha(a);iha(a);jha(a);kha(a);lha(a);mha(a);nha(a);oha(a);pha(a);qha(a);rha(a);sha(a);tha(a);uha(a);vha(a);wha(a);xha(a);yha(a);zha(a);Aha(a);Bha(a);Cha(a);Dha(a);Eha(a);Fha(a);Gha(a);Hha(a);Iha(a);Jha(a);Kha(a);Lha(a);Mha(a);Nha(a);Oha(a);Pha(a);Qha(a);Rha(a);Sha(a);Tha(a);Uha(a);Vha(a);Wha(a);Xha(a);Yha(a);Zha(a);_ha(a);$ha(a);aia(a);bia(a);cia(a);dia(a);eia(a);fia(a);gia(a);hia(a);iia(a);jia(a);kia(a);lia(a);mia(a);nia(a);oia(a);pia(a);qia(a);ria(a);sia(a);tia(a);uia(a);via(a);wia(a);xia(a);yia(a);zia(a);Aia(a);Bia(a);Cia(a);Dia(a);Eia(a);Fia(a);Gia(a);Hia(a);Iia(a);Jia(a);Kia(a);Lia(a);Mia(a);Nia(a);Oia(a);Pia(a);Qia(a);Ria(a);Sia(a);Tia(a);Uia(a);Via(a);Wia(a);Xia(a);Yia(a);Zia(a);_ia(a);$ia(a);aja(a);bja(a);cja(a);dja(a);eja(a);fja(a);gja(a);hja(a);ija(a);jja(a);kja(a);lja(a);mja(a);nja(a);oja(a);pja(a);qja(a);rja(a);sja(a);tja(a);uja(a);vja(a);wja(a);xja(a);yja(a);zja(a);Aja(a);Bja(a);Cja(a);Dja(a);Eja(a);Fja(a);Gja(a);Hja(a);Ija(a);Jja(a);Kja(a);Lja(a);Mja(a);Nja(a);Oja(a);Pja(a);Qja(a);Rja(a);Sja(a);Tja(a);Uja(a);Vja(a);Wja(a);Xja(a);Yja(a);Zja(a);_ja(a);$ja(a);aka(a);bka(a);cka(a);dka(a);eka(a);fka(a);gka(a);hka(a);ika(a);jka(a);kka(a);lka(a);mka(a);nka(a);oka(a);pka(a);qka(a);rka(a);ska(a);tka(a);uka(a);vka(a);wka(a);xka(a);yka(a);zka(a);Aka(a);Bka(a);Cka(a);Dka(a);Eka(a);Fka(a);Gka(a);Hka(a);Ika(a);Jka(a);Kka(a);Lka(a);Mka(a);Nka(a);Oka(a);Pka(a);Qka(a);Rka(a);Ska(a);Tka(a);Uka(a);Vka(a);Wka(a);Xka(a);Yka(a);Zka(a);_ka(a);$ka(a);ala(a);bla(a);cla(a);dla(a);ela(a);fla(a);gla(a);hla(a);ila(a);jla(a);kla(a);lla(a);mla(a);nla(a);ola(a);pla(a);qla(a);rla(a);sla(a);tla(a);ula(a);vla(a);wla(a);xla(a);yla(a);zla(a);Ala(a);Bla(a);Cla(a);Dla(a);Ela(a);Fla(a);Gla(a);Hla(a);Ila(a);Jla(a);Kla(a);Lla(a);Mla(a);Nla(a);Ola(a);Pla(a);Qla(a);Rla(a);Sla(a);Tla(a);Ula(a);Vla(a);Wla(a);Xla(a);Yla(a);Zla(a);_la(a);$la(a);ama(a);bma(a);cma(a);dma(a);ema(a);fma(a);gma(a);hma(a);ima(a);jma(a);kma(a);lma(a);mma(a);nma(a);oma(a);pma(a);qma(a);rma(a);sma(a);tma(a);uma(a);vma(a);wma(a);xma(a);yma(a);zma(a);Ama(a);Bma(a);Cma(a);Dma(a);Ema(a);Fma(a);Gma(a);Hma(a);Ima(a);Jma(a);Kma(a);Lma(a);Mma(a);Nma(a);Oma(a);Pma(a);Qma(a);Rma(a);Sma(a);Tma(a);Uma(a);Vma(a);Wma(a);Xma(a);Yma(a);Zma(a);_ma(a);$ma(a);ana(a);bna(a);cna(a);dna(a);ena(a);fna(a);gna(a);hna(a);ina(a);jna(a);kna(a);lna(a);mna(a);nna(a);ona(a);pna(a);qna(a);rna(a);sna(a);tna(a);una(a);vna(a);wna(a);xna(a);yna(a);zna(a);Ana(a);Bna(a);Cna(a);Dna(a);Ena(a);Fna(a);Gna(a);Hna(a);Ina(a);Jna(a);Kna(a);Lna(a);Mna(a);Nna(a);Ona(a);Pna(a);Qna(a);i=b;return 0}function Sna(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Tna(b);i=c;return 0}



function Zz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1560>>3]=+h[f>>3];i=b;return}function _z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+5928>>3],+h[a+176>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+5928>>3];l=+h[g+176>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+2968>>3]=+h[f>>3];i=b;return}function $z(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+2968>>3],+h[f+1560>>3],+h[f+5928>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2904>>3]=+h[d>>3];i=b;return}function aA(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1528>>3]=+h[b+3568>>3]*(+h[b+2824>>3]- +h[d+5928>>3])*+h[b+3600>>3];i=i;return}function bA(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3568>>3]*+h[e+3600>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1528>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19640,20472,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1520|0;q=p;h[q>>3]=n;i=d;return}function cA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0;d=i;i=i+8|0;e=d;f=c[b+536>>2]|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+1520>>3];m=+h[k+2968>>3];n=+h[k+2976>>3];o=+h[k+2904>>3];p=+h[k+2912>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+3520>>3];t=+h[k+2960>>3];u=+h[r+3544>>3]*+h[r+3664>>3];v=+h[r+3536>>3];w=(v+v)*.5;k=(c[(c[b+420>>2]|0)+480>>2]|0)+ -1|0;v=+(k|0);x=+h[r+3656>>3];do{if((k|0)==0){if(x==0.0){y=r;z=x;break}A=x/+SBa(f,v,19704,20480,+h[j>>3],(a[b+319|0]|0)!=0|0);y=c[q>>2]|0;z=A}else{y=r;z=x/v}}while(0);_t(e,f,l,m,n,o,p,s,t,u,w,z,+h[y+3624>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5864>>3]=+h[e>>3]*+h[(c[q>>2]|0)+3600>>3];i=d;return}function dA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=+h[b+2192>>3]- +h[b+5928>>3];i=i;return}function eA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+30768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+30744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+30752>>3];h[a+8>>3]=+h[d+83072>>3];h[e+8>>3]=+h[d+83048>>3];h[f+8>>3]=+h[d+83056>>3];i=i;return}function fA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+2192>>3]=+h[d>>3];h[k+5928>>3]=+h[d+8>>3];Zz(g);_z(g);$z(g);aA(g);bA(g);cA(g);dA(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=d+5864|0;l=c[g+16>>2]|0;if((a[l+98|0]|0)==0){m=+h[(c[b+416>>2]|0)+1256>>3]*+h[d+5872>>3]*.01}else{m=+h[d+5872>>3]*.01}h[e>>3]=+h[k>>3]-m;if((a[l+10|0]|0)==0){if((a[(c[b+408>>2]|0)+11|0]|0)==0){n=+h[d+2192>>3]- +h[(c[b+416>>2]|0)+2712>>3]}else{n=-+h[k>>3]}o=-n;p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}do{if((pFa(-+h[k>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[j>>2]>>2]|0;l=c[d+8>>2]|0;n=+h[l+3120>>3];m=+h[l+5864>>3];t=-m;do{if(n!=0.0){u=l;v=d;w=t/n}else{if(m==-0.0){u=l;v=d;w=t;break}x=t/+SBa(c[b+536>>2]|0,n,19784,20488,+h[d>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;u=c[g+8>>2]|0;v=g;w=x}}while(0);n=+h[u+4128>>3]*2.0;t=w*w;if(n!=0.0){s=t/n;break}if(t==0.0){s=t;break}s=t/+SBa(c[b+536>>2]|0,n,19808,20488,+h[v>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;o=+h[v+2192>>3]-(+h[j+2712>>3]+(+h[v+2176>>3]*+h[j+2528>>3]*+h[v+4128>>3]-s));p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}function gA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5952>>3]=+h[b+2248>>3]- +h[b+6008>>3];i=i;return}function hA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));qv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3e3>>3]=+h[f>>3];i=b;return}function iA(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1592>>3]=+h[b+3384>>3]*(+h[b+2824>>3]- +h[d+6008>>3])*+h[b+3416>>3];i=i;return}function jA(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+3384>>3]*+h[e+3416>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1592>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,f,19872,20496,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1584|0;q=p;h[q>>3]=n;i=d;return}function kA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;fv(e,c[g>>2]|0,+h[a+6008>>3],+h[a+192>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+6008>>3];l=+h[g+192>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));mv(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1624>>3]=+h[f>>3];i=b;return}function lA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;kv(d,c[a+536>>2]|0,+h[f+3e3>>3],+h[f+1624>>3],+h[f+6008>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2888>>3]=+h[d>>3];i=b;return}function mA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0;d=i;i=i+8|0;e=d;f=c[b+536>>2]|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+1584>>3];m=+h[k+3e3>>3];n=+h[k+3008>>3];o=+h[k+2888>>3];p=+h[k+2896>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+3336>>3];t=+h[k+2992>>3];u=+h[r+3360>>3]*+h[r+3480>>3];v=+h[r+3352>>3];w=(v+v)*.5;k=(c[(c[b+420>>2]|0)+468>>2]|0)+ -1|0;v=+(k|0);x=+h[r+3472>>3];do{if((k|0)==0){if(x==0.0){y=r;z=x;break}A=x/+SBa(f,v,19936,20504,+h[j>>3],(a[b+319|0]|0)!=0|0);y=c[q>>2]|0;z=A}else{y=r;z=x/v}}while(0);_t(e,f,l,m,n,o,p,s,t,u,w,z,+h[y+3440>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+5944>>3]=+h[e>>3]*+h[(c[q>>2]|0)+3416>>3];i=d;return}function nA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+31552>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+31528>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+31536>>3];h[a+8>>3]=+h[d+84192>>3];h[e+8>>3]=+h[d+84168>>3];h[f+8>>3]=+h[d+84176>>3];i=i;return}function oA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0;f=i;g=b;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;h[k+2248>>3]=+h[d>>3];h[k+6008>>3]=+h[d+8>>3];gA(g);hA(g);iA(g);jA(g);kA(g);lA(g);mA(g);g=c[c[j>>2]>>2]|0;d=c[g+8>>2]|0;k=d+5944|0;l=c[g+16>>2]|0;if((a[l+102|0]|0)==0){m=+h[(c[b+416>>2]|0)+1200>>3]*+h[d+5952>>3]*.01}else{m=+h[d+5952>>3]*.01}h[e>>3]=+h[k>>3]-m;if((a[l+12|0]|0)==0){if((a[(c[b+408>>2]|0)+13|0]|0)==0){n=+h[d+2248>>3]- +h[(c[b+416>>2]|0)+2456>>3]}else{n=-+h[k>>3]}o=-n;p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}do{if((pFa(-+h[k>>3],0.0)|0)<<24>>24==0){s=0.0}else{d=c[c[j>>2]>>2]|0;l=c[d+8>>2]|0;n=+h[l+3136>>3];m=+h[l+5944>>3];t=-m;do{if(n!=0.0){u=l;v=d;w=t/n}else{if(m==-0.0){u=l;v=d;w=t;break}x=t/+SBa(c[b+536>>2]|0,n,20016,20512,+h[d>>3],(a[b+319|0]|0)!=0|0);g=c[c[j>>2]>>2]|0;u=c[g+8>>2]|0;v=g;w=x}}while(0);n=+h[u+4264>>3]*2.0;t=w*w;if(n!=0.0){s=t/n;break}if(t==0.0){s=t;break}s=t/+SBa(c[b+536>>2]|0,n,20040,20512,+h[v>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[b+416>>2]|0;o=+h[v+2248>>3]-(+h[j+2456>>3]+(+h[v+2232>>3]*+h[j+2528>>3]*+h[v+4264>>3]-s));p=e;q=p+8|0;r=q;h[r>>3]=o;i=f;return}function pA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3616>>3];k=+h[g+384>>3];l=+h[(c[b+416>>2]|0)+4752>>3];m=j*j;j=+h[g+6776>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20336,20520,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6632|0;t=s;h[t>>3]=q;i=d;return}function qA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6720>>3]=+h[b+3672>>3]*+h[b+6632>>3]+ +h[b+3664>>3]*+h[b+3608>>3];i=i;return}function rA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=+h[b+6720>>3]+(-+h[b+3656>>3]- +h[b+3648>>3]);i=i;return}function sA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+4752>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3640>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6552|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6552|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20536,20528,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6552|0;q=p;h[q>>3]=n;i=d;return}function tA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5456>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5432>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5440>>3];h[a+8>>3]=+h[d+94944>>3];h[e+8>>3]=+h[d+94920>>3];h[f+8>>3]=+h[d+94928>>3];i=i;return}function uA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+384>>3]=+h[b>>3];h[m+6776>>3]=+h[b+8>>3];pA(k);qA(k);rA(k);sA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+4752>>3],+h[(c[a+8>>2]|0)+112>>3],c[(c[a+12>>2]|0)+68>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+4752>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+112>>3];p=+h[b+384>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6776|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+3664>>3]+(-(+h[f+3632>>3]*+h[l>>3])- +h[f+6552>>3]*+h[f+3616>>3]);i=e;return}function vA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3896>>3];k=+h[g+400>>3];l=+h[(c[b+416>>2]|0)+3048>>3];m=j*j;j=+h[g+6768>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20304,20552,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6624|0;t=s;h[t>>3]=q;i=d;return}function wA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6712>>3]=+h[b+3952>>3]*+h[b+6624>>3]+ +h[b+3944>>3]*+h[b+3888>>3];i=i;return}function xA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+6712>>3]+(-+h[b+3936>>3]- +h[b+3928>>3]);i=i;return}function yA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+3048>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3920>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6544|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6544|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20568,20560,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6544|0;q=p;h[q>>3]=n;i=d;return}function zA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5680>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5656>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5664>>3];h[a+8>>3]=+h[d+94832>>3];h[e+8>>3]=+h[d+94808>>3];h[f+8>>3]=+h[d+94816>>3];i=i;return}function AA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+400>>3]=+h[b>>3];h[m+6768>>3]=+h[b+8>>3];vA(k);wA(k);xA(k);yA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+3048>>3],+h[(c[a+8>>2]|0)+128>>3],c[(c[a+12>>2]|0)+72>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+3048>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+128>>3];p=+h[b+400>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6768|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+3944>>3]+(-(+h[f+3912>>3]*+h[l>>3])- +h[f+6544>>3]*+h[f+3896>>3]);i=e;return}function BA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3984>>3];k=+h[g+416>>3];l=+h[(c[b+416>>2]|0)+2936>>3];m=j*j;j=+h[g+6760>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20240,20584,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6616|0;t=s;h[t>>3]=q;i=d;return}function CA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6704>>3]=+h[b+4024>>3]*+h[b+6616>>3]+ +h[b+4016>>3]*+h[b+3976>>3];i=i;return}function DA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+6704>>3]- +h[b+4008>>3];i=i;return}function EA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+2936>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4e3>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6536|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6536|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20600,20592,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6536|0;q=p;h[q>>3]=n;i=d;return}function FA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+5904>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+5880>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+5888>>3];h[a+8>>3]=+h[d+94720>>3];h[e+8>>3]=+h[d+94696>>3];h[f+8>>3]=+h[d+94704>>3];i=i;return}function GA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+416>>3]=+h[b>>3];h[m+6760>>3]=+h[b+8>>3];BA(k);CA(k);DA(k);EA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+2936>>3],+h[(c[a+8>>2]|0)+144>>3],c[(c[a+12>>2]|0)+76>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+2936>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+144>>3];p=+h[b+416>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6760|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+4016>>3]+(-(+h[f+3992>>3]*+h[l>>3])- +h[f+6536>>3]*+h[f+3984>>3]);i=e;return}function HA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4056>>3];k=+h[g+432>>3];l=+h[(c[b+416>>2]|0)+2824>>3];m=j*j;j=+h[g+6752>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20072,20616,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6608|0;t=s;h[t>>3]=q;i=d;return}function IA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6696>>3]=+h[b+4096>>3]*+h[b+6608>>3]+ +h[b+4088>>3]*+h[b+4048>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+6696>>3]- +h[b+4080>>3];i=i;return}function KA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+2824>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4072>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6528|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6528|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20632,20624,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6528|0;q=p;h[q>>3]=n;i=d;return}function LA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6128>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6104>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6112>>3];h[a+8>>3]=+h[d+94608>>3];h[e+8>>3]=+h[d+94584>>3];h[f+8>>3]=+h[d+94592>>3];i=i;return}function MA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+432>>3]=+h[b>>3];h[m+6752>>3]=+h[b+8>>3];HA(k);IA(k);JA(k);KA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+2824>>3],+h[(c[a+8>>2]|0)+160>>3],c[(c[a+12>>2]|0)+80>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+2824>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+160>>3];p=+h[b+432>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6752|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+4088>>3]+(-(+h[f+4064>>3]*+h[l>>3])- +h[f+6528>>3]*+h[f+4056>>3]);i=e;return}function NA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4128>>3];k=+h[g+448>>3];l=+h[(c[b+416>>2]|0)+2712>>3];m=j*j;j=+h[g+6744>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,19840,20648,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6600|0;t=s;h[t>>3]=q;i=d;return}function OA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6688>>3]=+h[b+4168>>3]*+h[b+6600>>3]+ +h[b+4160>>3]*+h[b+4120>>3];i=i;return}function PA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+6688>>3]- +h[b+4152>>3];i=i;return}function QA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+2712>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4144>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6520|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6520|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20664,20656,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6520|0;q=p;h[q>>3]=n;i=d;return}function RA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6352>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6328>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6336>>3];h[a+8>>3]=+h[d+94496>>3];h[e+8>>3]=+h[d+94472>>3];h[f+8>>3]=+h[d+94480>>3];i=i;return}function SA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+448>>3]=+h[b>>3];h[m+6744>>3]=+h[b+8>>3];NA(k);OA(k);PA(k);QA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+2712>>3],+h[(c[a+8>>2]|0)+176>>3],c[(c[a+12>>2]|0)+84>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+2712>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+176>>3];p=+h[b+448>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6744|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+4160>>3]+(-(+h[f+4136>>3]*+h[l>>3])- +h[f+6520>>3]*+h[f+4128>>3]);i=e;return}function TA(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+4264>>3];k=+h[g+464>>3];l=+h[(c[b+416>>2]|0)+2456>>3];m=j*j;j=+h[g+6736>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}u=j/+SBa(c[b+536>>2]|0,m,20104,20680,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+6592|0;t=s;h[t>>3]=q;i=d;return}function UA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6680>>3]=+h[b+4304>>3]*+h[b+6592>>3]+ +h[b+4296>>3]*+h[b+4256>>3];i=i;return}function VA(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4280>>3]=+h[b+6680>>3]- +h[b+4288>>3];i=i;return}function WA(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+2456>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+4280>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}k=l/+SBa(c[b+536>>2]|0,e,20696,20688,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+6512|0;q=p;h[q>>3]=n;i=d;return}function XA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6576>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6552>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6560>>3];h[a+8>>3]=+h[d+94384>>3];h[e+8>>3]=+h[d+94360>>3];h[f+8>>3]=+h[d+94368>>3];i=i;return}function YA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+464>>3]=+h[b>>3];h[m+6736>>3]=+h[b+8>>3];TA(k);UA(k);VA(k);WA(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;fv(g,c[k>>2]|0,+h[(c[b>>2]|0)+2456>>3],+h[(c[a+8>>2]|0)+192>>3],c[(c[a+12>>2]|0)+88>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+2456>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+192>>3];p=+h[b+464>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));rv(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+6736|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+4296>>3]+(-(+h[f+4272>>3]*+h[l>>3])- +h[f+6512>>3]*+h[f+4264>>3]);i=e;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0;b=i;d=a+4|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;f=(pFa(+h[e+6424>>3],+h[e+7480>>3])|0)<<24>>24==0;e=rFa(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0;g=c[(c[c[d>>2]>>2]|0)+8>>2]|0;j=+h[g+2344>>3];k=+h[g+2384>>3];l=+h[g+6480>>3];d=e<<24>>24==0;if(f){if(d){m=g+6472|0;n=c[a+416>>2]|0}else{f=c[a+416>>2]|0;m=f+4704|0;n=f}o=+h[n+776>>3]*+h[g+6560>>3]-l*+h[m>>3];p=k-o;q=j+p;r=g;s=r+6648|0;t=s;h[t>>3]=q;i=b;return}else{if(d){u=g+6472|0;v=c[a+416>>2]|0}else{d=c[a+416>>2]|0;u=d+4704|0;v=d}o=+h[v+776>>3]*+h[g+6560>>3]- +h[g+2280>>3]-l*+h[u>>3];p=k-o;q=j+p;r=g;s=r+6648|0;t=s;h[t>>3]=q;i=b;return}}function _A(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;fv(e,c[g>>2]|0,+h[(c[j>>2]|0)+776>>3],+h[(c[a+8>>2]|0)+256>>3],c[(c[a+12>>2]|0)+108>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+776>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+256>>3];n=+h[j+528>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));rv(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[f>>3];i=b;return}function $A(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+91920>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+91896>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+91904>>3];h[a+8>>3]=+h[d+7472>>3];h[e+8>>3]=+h[d+7448>>3];h[f+8>>3]=+h[d+7456>>3];i=i;return}function aB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0;e=i;f=a;g=a+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+6560>>3]=+h[b>>3];h[j+528>>3]=+h[b+8>>3];ZA(f);_A(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+6656|0;b=f+6560|0;h[d>>3]=+h[g>>3]+(-(+h[f+6504>>3]*+h[f+6728>>3])- +h[b>>3]*+h[f+6432>>3]);h[d+8>>3]=+h[f+6648>>3]+(+h[(c[a+416>>2]|0)+776>>3]*+h[b>>3]+(-(+h[f+6440>>3]*+h[f+528>>3])- +h[g>>3]*+h[f+256>>3]));i=e;return}function bB(a){a=a|0;c[a+4>>2]=528;c[a>>2]=2;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=663;c[a+80>>2]=2;c[a+136>>2]=0;c[a+112>>2]=19;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=700;c[a+160>>2]=4;c[a+216>>2]=0;c[a+192>>2]=20;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=715;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=21;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=722;c[a+320>>2]=2;c[a+376>>2]=0;c[a+352>>2]=22;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=725;c[a+400>>2]=1;c[a+456>>2]=0;c[a+432>>2]=23;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=727;c[a+480>>2]=1;c[a+536>>2]=0;c[a+512>>2]=24;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=729;c[a+560>>2]=1;c[a+616>>2]=0;c[a+592>>2]=25;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=740;c[a+640>>2]=2;c[a+696>>2]=0;c[a+672>>2]=26;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=764;c[a+720>>2]=2;c[a+776>>2]=0;c[a+752>>2]=27;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=786;c[a+800>>2]=2;c[a+856>>2]=0;c[a+832>>2]=28;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=831;c[a+880>>2]=2;c[a+936>>2]=0;c[a+912>>2]=29;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=862;c[a+960>>2]=4;c[a+1016>>2]=0;c[a+992>>2]=30;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=870;c[a+1040>>2]=2;c[a+1096>>2]=0;c[a+1072>>2]=31;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;c[a+1124>>2]=876;c[a+1120>>2]=2;c[a+1176>>2]=0;c[a+1152>>2]=32;c[a+1140>>2]=0;c[a+1144>>2]=0;c[a+1148>>2]=-1;c[a+1156>>2]=57;c[a+1204>>2]=887;c[a+1200>>2]=1;c[a+1256>>2]=0;c[a+1232>>2]=33;c[a+1220>>2]=0;c[a+1224>>2]=0;c[a+1228>>2]=-1;c[a+1236>>2]=58;c[a+1284>>2]=889;c[a+1280>>2]=1;c[a+1336>>2]=0;c[a+1312>>2]=34;c[a+1300>>2]=0;c[a+1304>>2]=0;c[a+1308>>2]=-1;c[a+1316>>2]=59;c[a+1364>>2]=891;c[a+1360>>2]=1;c[a+1416>>2]=0;c[a+1392>>2]=35;c[a+1380>>2]=0;c[a+1384>>2]=0;c[a+1388>>2]=-1;c[a+1396>>2]=60;c[a+1444>>2]=902;c[a+1440>>2]=2;c[a+1496>>2]=0;c[a+1472>>2]=36;c[a+1460>>2]=0;c[a+1464>>2]=0;c[a+1468>>2]=-1;c[a+1476>>2]=61;c[a+1524>>2]=928;c[a+1520>>2]=2;c[a+1576>>2]=0;c[a+1552>>2]=37;c[a+1540>>2]=0;c[a+1544>>2]=0;c[a+1548>>2]=-1;c[a+1556>>2]=62;c[a+1604>>2]=946;c[a+1600>>2]=2;c[a+1656>>2]=0;c[a+1632>>2]=38;c[a+1620>>2]=0;c[a+1624>>2]=0;c[a+1628>>2]=-1;c[a+1636>>2]=63;c[a+1684>>2]=1020;c[a+1680>>2]=1;c[a+1736>>2]=0;c[a+1712>>2]=39;c[a+1700>>2]=0;c[a+1704>>2]=0;c[a+1708>>2]=-1;c[a+1716>>2]=64;c[a+1764>>2]=1048;c[a+1760>>2]=2;c[a+1816>>2]=0;c[a+1792>>2]=40;c[a+1780>>2]=0;c[a+1784>>2]=0;c[a+1788>>2]=-1;c[a+1796>>2]=65;c[a+1844>>2]=1065;c[a+1840>>2]=2;c[a+1896>>2]=0;c[a+1872>>2]=41;c[a+1860>>2]=0;c[a+1864>>2]=0;c[a+1868>>2]=-1;c[a+1876>>2]=66;c[a+1924>>2]=1097;c[a+1920>>2]=2;c[a+1976>>2]=0;c[a+1952>>2]=42;c[a+1940>>2]=0;c[a+1944>>2]=0;c[a+1948>>2]=-1;c[a+1956>>2]=67;c[a+2004>>2]=1112;c[a+2e3>>2]=2;c[a+2056>>2]=0;c[a+2032>>2]=43;c[a+2020>>2]=0;c[a+2024>>2]=0;c[a+2028>>2]=-1;c[a+2036>>2]=68;c[a+2084>>2]=1124;c[a+2080>>2]=2;c[a+2136>>2]=0;c[a+2112>>2]=44;c[a+2100>>2]=0;c[a+2104>>2]=0;c[a+2108>>2]=-1;c[a+2116>>2]=69;c[a+2164>>2]=1160;c[a+2160>>2]=1;c[a+2216>>2]=0;c[a+2192>>2]=45;c[a+2180>>2]=0;c[a+2184>>2]=0;c[a+2188>>2]=-1;c[a+2196>>2]=70;c[a+2244>>2]=1174;c[a+2240>>2]=4;c[a+2296>>2]=0;c[a+2272>>2]=46;c[a+2260>>2]=0;c[a+2264>>2]=0;c[a+2268>>2]=-1;c[a+2276>>2]=71;c[a+2324>>2]=1184;c[a+2320>>2]=2;c[a+2376>>2]=0;c[a+2352>>2]=47;c[a+2340>>2]=0;c[a+2344>>2]=0;c[a+2348>>2]=-1;c[a+2356>>2]=72;c[a+2404>>2]=1204;c[a+2400>>2]=1;c[a+2456>>2]=0;c[a+2432>>2]=48;c[a+2420>>2]=0;c[a+2424>>2]=0;c[a+2428>>2]=-1;c[a+2436>>2]=73;c[a+2484>>2]=1214;c[a+2480>>2]=2;c[a+2536>>2]=0;c[a+2512>>2]=49;c[a+2500>>2]=0;c[a+2504>>2]=0;c[a+2508>>2]=-1;c[a+2516>>2]=74;c[a+2564>>2]=1245;c[a+2560>>2]=2;c[a+2616>>2]=0;c[a+2592>>2]=50;c[a+2580>>2]=0;c[a+2584>>2]=0;c[a+2588>>2]=-1;c[a+2596>>2]=75;c[a+2644>>2]=1257;c[a+2640>>2]=2;c[a+2696>>2]=0;c[a+2672>>2]=51;c[a+2660>>2]=0;c[a+2664>>2]=0;c[a+2668>>2]=-1;c[a+2676>>2]=76;c[a+2724>>2]=1757;c[a+2720>>2]=1;c[a+2776>>2]=0;c[a+2752>>2]=52;c[a+2740>>2]=0;c[a+2744>>2]=0;c[a+2748>>2]=-1;c[a+2756>>2]=77;c[a+2804>>2]=1953;c[a+2800>>2]=3;c[a+2856>>2]=0;c[a+2832>>2]=53;c[a+2820>>2]=0;c[a+2824>>2]=0;c[a+2828>>2]=-1;c[a+2836>>2]=78;c[a+2884>>2]=1974;c[a+2880>>2]=2;c[a+2936>>2]=0;c[a+2912>>2]=54;c[a+2900>>2]=0;c[a+2904>>2]=0;c[a+2908>>2]=-1;c[a+2916>>2]=79;c[a+2964>>2]=1991;c[a+2960>>2]=3;c[a+3016>>2]=0;c[a+2992>>2]=55;c[a+2980>>2]=0;c[a+2984>>2]=0;c[a+2988>>2]=-1;c[a+2996>>2]=80;c[a+3044>>2]=2012;c[a+3040>>2]=2;c[a+3096>>2]=0;c[a+3072>>2]=56;c[a+3060>>2]=0;c[a+3064>>2]=0;c[a+3068>>2]=-1;c[a+3076>>2]=81;c[a+3124>>2]=2103;c[a+3120>>2]=2;c[a+3176>>2]=0;c[a+3152>>2]=57;c[a+3140>>2]=0;c[a+3144>>2]=0;c[a+3148>>2]=-1;c[a+3156>>2]=82;c[a+3204>>2]=2113;c[a+3200>>2]=2;c[a+3256>>2]=0;c[a+3232>>2]=58;c[a+3220>>2]=0;c[a+3224>>2]=0;c[a+3228>>2]=-1;c[a+3236>>2]=83;c[a+3284>>2]=2161;c[a+3280>>2]=2;c[a+3336>>2]=0;c[a+3312>>2]=59;c[a+3300>>2]=0;c[a+3304>>2]=0;c[a+3308>>2]=-1;c[a+3316>>2]=84;c[a+3364>>2]=2165;c[a+3360>>2]=2;c[a+3416>>2]=0;c[a+3392>>2]=60;c[a+3380>>2]=0;c[a+3384>>2]=0;c[a+3388>>2]=-1;c[a+3396>>2]=85;c[a+3444>>2]=2208;c[a+3440>>2]=2;c[a+3496>>2]=0;c[a+3472>>2]=61;c[a+3460>>2]=0;c[a+3464>>2]=0;c[a+3468>>2]=-1;c[a+3476>>2]=86;c[a+3524>>2]=2212;c[a+3520>>2]=2;c[a+3576>>2]=0;c[a+3552>>2]=62;c[a+3540>>2]=0;c[a+3544>>2]=0;c[a+3548>>2]=-1;c[a+3556>>2]=87;c[a+3604>>2]=2235;c[a+3600>>2]=2;c[a+3656>>2]=0;c[a+3632>>2]=63;c[a+3620>>2]=0;c[a+3624>>2]=0;c[a+3628>>2]=-1;c[a+3636>>2]=88;c[a+3684>>2]=2248;c[a+3680>>2]=2;c[a+3736>>2]=0;c[a+3712>>2]=64;c[a+3700>>2]=0;c[a+3704>>2]=0;c[a+3708>>2]=-1;c[a+3716>>2]=89;c[a+3764>>2]=2280;c[a+3760>>2]=2;c[a+3816>>2]=0;c[a+3792>>2]=65;c[a+3780>>2]=0;c[a+3784>>2]=0;c[a+3788>>2]=-1;c[a+3796>>2]=90;c[a+3844>>2]=2302;c[a+3840>>2]=4;c[a+3896>>2]=0;c[a+3872>>2]=66;c[a+3860>>2]=0;c[a+3864>>2]=0;c[a+3868>>2]=-1;c[a+3876>>2]=91;c[a+3924>>2]=2332;c[a+3920>>2]=2;c[a+3976>>2]=0;c[a+3952>>2]=67;c[a+3940>>2]=0;c[a+3944>>2]=0;c[a+3948>>2]=-1;c[a+3956>>2]=92;c[a+4004>>2]=2344;c[a+4e3>>2]=2;c[a+4056>>2]=0;c[a+4032>>2]=68;c[a+4020>>2]=0;c[a+4024>>2]=0;c[a+4028>>2]=-1;c[a+4036>>2]=93;c[a+4084>>2]=2360;c[a+4080>>2]=1;c[a+4136>>2]=0;c[a+4112>>2]=69;c[a+4100>>2]=0;c[a+4104>>2]=0;c[a+4108>>2]=-1;c[a+4116>>2]=94;c[a+4164>>2]=2383;c[a+4160>>2]=2;c[a+4216>>2]=0;c[a+4192>>2]=70;c[a+4180>>2]=0;c[a+4184>>2]=0;c[a+4188>>2]=-1;c[a+4196>>2]=95;c[a+4244>>2]=2413;c[a+4240>>2]=2;c[a+4296>>2]=0;c[a+4272>>2]=71;c[a+4260>>2]=0;c[a+4264>>2]=0;c[a+4268>>2]=-1;c[a+4276>>2]=96;c[a+4324>>2]=2442;c[a+4320>>2]=2;c[a+4376>>2]=0;c[a+4352>>2]=72;c[a+4340>>2]=0;c[a+4344>>2]=0;c[a+4348>>2]=-1;c[a+4356>>2]=97;c[a+4404>>2]=2453;c[a+4400>>2]=2;c[a+4456>>2]=0;c[a+4432>>2]=73;c[a+4420>>2]=0;c[a+4424>>2]=0;c[a+4428>>2]=-1;c[a+4436>>2]=98;c[a+4484>>2]=2464;c[a+4480>>2]=2;c[a+4536>>2]=0;c[a+4512>>2]=74;c[a+4500>>2]=0;c[a+4504>>2]=0;c[a+4508>>2]=-1;c[a+4516>>2]=99;c[a+4564>>2]=2475;c[a+4560>>2]=2;c[a+4616>>2]=0;c[a+4592>>2]=75;c[a+4580>>2]=0;c[a+4584>>2]=0;c[a+4588>>2]=-1;c[a+4596>>2]=100;c[a+4644>>2]=2486;c[a+4640>>2]=2;c[a+4696>>2]=0;c[a+4672>>2]=76;c[a+4660>>2]=0;c[a+4664>>2]=0;c[a+4668>>2]=-1;c[a+4676>>2]=101;c[a+4724>>2]=2497;c[a+4720>>2]=2;c[a+4776>>2]=0;c[a+4752>>2]=77;c[a+4740>>2]=0;c[a+4744>>2]=0;c[a+4748>>2]=-1;c[a+4756>>2]=102;c[a+4804>>2]=2506;c[a+4800>>2]=2;c[a+4856>>2]=0;c[a+4832>>2]=78;c[a+4820>>2]=0;c[a+4824>>2]=0;c[a+4828>>2]=-1;c[a+4836>>2]=103;i=i;return}function cB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0.0;e=i;f=d+8|0;g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+48|0]|0)==0){j=+h[(c[b+416>>2]|0)+1704>>3]*.01}else{j=.01}xe[c[f>>2]&3](0,0,-j,0,d);xe[c[f>>2]&3](0,6,1.0,1,d);xe[c[f>>2]&3](1,1,1.0,2,d);xe[c[f>>2]&3](1,5,1.0,3,d);xe[c[f>>2]&3](1,6,-1.0,4,d);k=b+416|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+48|0]|0)==0){l=+h[(c[k>>2]|0)+1480>>3]*.01}else{l=.01}xe[c[f>>2]&3](2,4,-l,5,d);xe[c[f>>2]&3](2,5,1.0,6,d);xe[c[f>>2]&3](3,3,-1.0,7,d);xe[c[f>>2]&3](3,4,1.0,8,d);xe[c[f>>2]&3](4,2,1.0,9,d);xe[c[f>>2]&3](4,3,-1.0,10,d);xe[c[f>>2]&3](5,1,1.0,11,d);xe[c[f>>2]&3](5,2,+h[(c[k>>2]|0)+1368>>3]*-.01,12,d);xe[c[f>>2]&3](6,0,1.0,13,d);xe[c[f>>2]&3](6,3,1.0,14,d);i=e;return}function dB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+416|0;f=e;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;h[e+24>>3]=-+h[(c[b>>2]|0)+2712>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+32>>3]=-+h[b+88>>3];h[e+40>>3]=0.0;h[e+48>>3]=+h[b+8>>3];i=d;return}function eB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=d+8|0;g=b+4|0;j=b+416|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+60|0]|0)==0){k=+h[(c[j>>2]|0)+1592>>3]*.01}else{k=.01}xe[c[f>>2]&3](0,2,-k,0,d);xe[c[f>>2]&3](0,6,1.0,1,d);xe[c[f>>2]&3](1,0,1.0,2,d);xe[c[f>>2]&3](1,5,-1.0,3,d);xe[c[f>>2]&3](1,6,-1.0,4,d);xe[c[f>>2]&3](2,4,+h[(c[j>>2]|0)+1312>>3]*-.01,5,d);xe[c[f>>2]&3](2,5,-1.0,6,d);xe[c[f>>2]&3](3,3,-1.0,7,d);xe[c[f>>2]&3](3,4,1.0,8,d);xe[c[f>>2]&3](4,2,1.0,9,d);xe[c[f>>2]&3](4,3,1.0,10,d);xe[c[f>>2]&3](5,1,1.0,11,d);xe[c[f>>2]&3](5,3,-1.0,12,d);xe[c[f>>2]&3](6,0,1.0,13,d);b=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+60|0]|0)!=0){l=.01;m=-l;xe[b&3](6,1,m,14,d);i=e;return}l=+h[(c[j>>2]|0)+1424>>3]*.01;m=-l;xe[b&3](6,1,m,14,d);i=e;return}function fB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[b+36>>2]|0;b=a+4|0;f=e;c[f+0>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;f=c[(c[c[b>>2]>>2]|0)+8>>2]|0;h[e+24>>3]=-+h[f+72>>3];h[e+32>>3]=+h[f+40>>3];h[e+40>>3]=-+h[(c[a+416>>2]|0)+2456>>3];h[e+48>>3]=0.0;i=d;return}function gB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=d+8|0;xe[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;j=b+416|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+60|0]|0)==0){k=+h[(c[j>>2]|0)+1424>>3]*.01}else{k=.01}xe[c[f>>2]&3](0,6,-k,1,d);xe[c[f>>2]&3](1,5,-1.0,2,d);xe[c[f>>2]&3](1,6,1.0,3,d);xe[c[f>>2]&3](2,4,1.0,4,d);xe[c[f>>2]&3](2,5,-1.0,5,d);xe[c[f>>2]&3](3,3,-1.0,6,d);xe[c[f>>2]&3](3,4,+h[(c[j>>2]|0)+1312>>3]*-.01,7,d);xe[c[f>>2]&3](4,0,-1.0,8,d);xe[c[f>>2]&3](4,2,1.0,9,d);xe[c[f>>2]&3](4,3,-1.0,10,d);xe[c[f>>2]&3](5,1,1.0,11,d);xe[c[f>>2]&3](5,5,1.0,12,d);xe[c[f>>2]&3](6,0,1.0,13,d);b=c[f>>2]|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+60|0]|0)!=0){l=.01;m=-l;xe[b&3](6,1,m,14,d);i=e;return}l=+h[(c[j>>2]|0)+1592>>3]*.01;m=-l;xe[b&3](6,1,m,14,d);i=e;return}function hB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=0.0;h[e+8>>3]=-+h[(c[a+416>>2]|0)+2456>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+16>>3]=-+h[b+72>>3];a=b+40|0;b=e+24|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;h[e+40>>3]=+h[a>>3];h[e+48>>3]=0.0;i=d;return}function iB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0,l=0.0;e=i;f=d+8|0;xe[c[f>>2]&3](0,2,1.0,0,d);g=b+4|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+48|0]|0)==0){j=+h[(c[b+416>>2]|0)+1480>>3]*.01}else{j=.01}xe[c[f>>2]&3](0,6,-j,1,d);xe[c[f>>2]&3](1,5,-1.0,2,d);xe[c[f>>2]&3](1,6,1.0,3,d);xe[c[f>>2]&3](2,4,1.0,4,d);xe[c[f>>2]&3](2,5,1.0,5,d);xe[c[f>>2]&3](3,3,1.0,6,d);k=b+416|0;if((a[(c[(c[c[g>>2]>>2]|0)+16>>2]|0)+48|0]|0)==0){l=+h[(c[k>>2]|0)+1704>>3]*.01}else{l=.01}xe[c[f>>2]&3](3,4,-l,7,d);xe[c[f>>2]&3](4,0,1.0,8,d);xe[c[f>>2]&3](4,2,1.0,9,d);xe[c[f>>2]&3](4,3,-1.0,10,d);xe[c[f>>2]&3](5,1,1.0,11,d);xe[c[f>>2]&3](5,5,-1.0,12,d);xe[c[f>>2]&3](6,0,1.0,13,d);xe[c[f>>2]&3](6,1,+h[(c[k>>2]|0)+1368>>3]*-.01,14,d);i=e;return}function jB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b+36>>2]|0;h[e>>3]=0.0;h[e+8>>3]=-+h[(c[a+416>>2]|0)+2712>>3];b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+16>>3]=+h[b+8>>3];a=b+88|0;b=e+24|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;h[e+40>>3]=-+h[a>>3];h[e+48>>3]=0.0;i=d;return}function kB(a){a=a|0;c[a+20>>2]=741;c[a+16>>2]=7;c[a+12>>2]=15;c[a>>2]=104;c[a+4>>2]=105;c[a+84>>2]=903;c[a+80>>2]=7;c[a+76>>2]=15;c[a+64>>2]=106;c[a+68>>2]=107;c[a+148>>2]=1776;c[a+144>>2]=7;c[a+140>>2]=15;c[a+128>>2]=108;c[a+132>>2]=109;c[a+212>>2]=1831;c[a+208>>2]=7;c[a+204>>2]=15;c[a+192>>2]=110;c[a+196>>2]=111;i=i;return}function lB(a,b){a=a|0;b=b|0;i=i;return}function mB(a){a=a|0;i=i;return}function nB(a,b){a=a|0;b=b|0;c[b>>2]=c[31848+(a<<2)>>2];i=i;return c[20712+(a<<2)>>2]|0}function oB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;e=i;i=i+14376|0;mu(e+7072|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]);f=(e+3536|0)+0|0;j=(e+7072|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;m=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];f=(e+3432|0)+0|0;j=(e+3536|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7176|0,l,m,e+3432|0);l=lFa(+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3],+h[(e+7176|0)>>3],a[c[(b+360|0)>>2]|0]|0)|0;Xu(e+7184|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3]);f=(e+3640|0)+0|0;j=(e+7184|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;m=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3];f=(e+3328|0)+0|0;j=(e+3640|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7288|0,n,m,e+3328|0);n=nFa(+h[c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]>>3],+h[(e+7288|0)>>3],a[(c[(b+360|0)>>2]|0)+1|0]|0)|0;o=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+8>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+2|0]|0)|0;if((n|l)<<24>>24==0){p=o<<24>>24!=0?1.0:-1.0}else{p=1.0}h[d>>3]=p;mu(e+7296|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);f=(e+3744|0)+0|0;j=(e+7296|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));o=c[(b+536|0)>>2]|0;p=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];f=(e+3224|0)+0|0;j=(e+3744|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7400|0,o,p,e+3224|0);o=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(e+7400|0)>>3],a[(c[(b+360|0)>>2]|0)+3|0]|0)|0;Xu(e+7408|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3]);f=(e+3848|0)+0|0;j=(e+7408|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;p=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3];f=(e+3120|0)+0|0;j=(e+3848|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7512|0,l,p,e+3120|0);l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(e+7512|0)>>3],a[(c[(b+360|0)>>2]|0)+4|0]|0)|0;n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+5|0]|0)|0;if((l|o)<<24>>24==0){q=n<<24>>24!=0?1.0:-1.0}else{q=1.0}h[d+8>>3]=q;mu(e+7520|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);f=(e+3952|0)+0|0;j=(e+7520|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;q=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];f=(e+3016|0)+0|0;j=(e+3952|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7624|0,n,q,e+3016|0);n=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3],+h[(e+7624|0)>>3],a[(c[(b+360|0)>>2]|0)+6|0]|0)|0;Xu(e+7632|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3]);f=(e+4056|0)+0|0;j=(e+7632|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));o=c[(b+536|0)>>2]|0;q=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3];f=(e+2912|0)+0|0;j=(e+4056|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7736|0,o,q,e+2912|0);o=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+32>>3],+h[(e+7736|0)>>3],a[(c[(b+360|0)>>2]|0)+7|0]|0)|0;l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+40>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+8|0]|0)|0;if((o|n)<<24>>24==0){r=l<<24>>24!=0?1.0:-1.0}else{r=1.0}h[d+16>>3]=r;mu(e+7744|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);f=(e+4160|0)+0|0;j=(e+7744|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;r=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];f=(e+2808|0)+0|0;j=(e+4160|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7848|0,l,r,e+2808|0);l=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],+h[(e+7848|0)>>3],a[(c[(b+360|0)>>2]|0)+9|0]|0)|0;Xu(e+7856|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3]);f=(e+4264|0)+0|0;j=(e+7856|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;r=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3];f=(e+2704|0)+0|0;j=(e+4264|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+7960|0,n,r,e+2704|0);n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+48>>3],+h[(e+7960|0)>>3],a[(c[(b+360|0)>>2]|0)+10|0]|0)|0;o=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+56>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+11|0]|0)|0;if((n|l)<<24>>24==0){s=o<<24>>24!=0?1.0:-1.0}else{s=1.0}h[d+24>>3]=s;mu(e+7968|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);f=(e+4368|0)+0|0;j=(e+7968|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));o=c[(b+536|0)>>2]|0;s=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];f=(e+2600|0)+0|0;j=(e+4368|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8072|0,o,s,e+2600|0);o=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3],+h[(e+8072|0)>>3],a[(c[(b+360|0)>>2]|0)+12|0]|0)|0;Xu(e+8080|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3]);f=(e+4472|0)+0|0;j=(e+8080|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;s=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3];f=(e+2496|0)+0|0;j=(e+4472|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8184|0,l,s,e+2496|0);l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+64>>3],+h[(e+8184|0)>>3],a[(c[(b+360|0)>>2]|0)+13|0]|0)|0;n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+72>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+14|0]|0)|0;if((l|o)<<24>>24==0){t=n<<24>>24!=0?1.0:-1.0}else{t=1.0}h[d+32>>3]=t;mu(e+8192|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);f=(e+4576|0)+0|0;j=(e+8192|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;t=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];f=(e+2392|0)+0|0;j=(e+4576|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8296|0,n,t,e+2392|0);n=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(e+8296|0)>>3],a[(c[(b+360|0)>>2]|0)+15|0]|0)|0;Xu(e+8304|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3]);f=(e+4680|0)+0|0;j=(e+8304|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));o=c[(b+536|0)>>2]|0;t=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3];f=(e+2288|0)+0|0;j=(e+4680|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8408|0,o,t,e+2288|0);o=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+80>>3],+h[(e+8408|0)>>3],a[(c[(b+360|0)>>2]|0)+16|0]|0)|0;l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+88>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+17|0]|0)|0;if((o|n)<<24>>24==0){u=l<<24>>24!=0?1.0:-1.0}else{u=1.0}h[d+40>>3]=u;mu(e+8416|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);f=(e+4784|0)+0|0;j=(e+8416|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;u=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];f=(e+2184|0)+0|0;j=(e+4784|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8520|0,l,u,e+2184|0);l=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3],+h[(e+8520|0)>>3],a[(c[(b+360|0)>>2]|0)+18|0]|0)|0;Xu(e+8528|0,c[(b+536|0)>>2]|0,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3]);f=(e+4888|0)+0|0;j=(e+8528|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;u=+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3];f=(e+2080|0)+0|0;j=(e+4888|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8632|0,n,u,e+2080|0);n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+96>>3],+h[(e+8632|0)>>3],a[(c[(b+360|0)>>2]|0)+19|0]|0)|0;o=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+104>>3],22064.0e3,a[(c[(b+360|0)>>2]|0)+20|0]|0)|0;if((n|l)<<24>>24==0){v=o<<24>>24!=0?1.0:-1.0}else{v=1.0}h[d+48>>3]=v;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;l=oFa(+h[o+120>>3],+h[o+560>>3]+ +h[o+3032>>3],a[(c[(b+360|0)>>2]|0)+21|0]|0)|0;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[o+120>>3],+h[o+560>>3]- +h[o+3032>>3],a[(c[(b+360|0)>>2]|0)+22|0]|0)|0;do{if(l<<24>>24==0){if((a[c[b+408>>2]|0]|0)==0){w=-1.0;break}w=n<<24>>24!=0?1.0:-1.0}else{w=1.0}}while(0);h[d+56>>3]=w;mu(e+8640|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+4752>>3]);f=(e+4992|0)+0|0;j=(e+8640|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;w=+h[(c[(b+416|0)>>2]|0)+4752>>3];f=(e+1976|0)+0|0;j=(e+4992|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8744|0,n,w,e+1976|0);n=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3],+h[(e+8744|0)>>3],a[(c[(b+360|0)>>2]|0)+23|0]|0)|0;Xu(e+8752|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+4752>>3]);f=(e+5096|0)+0|0;j=(e+8752|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;w=+h[(c[(b+416|0)>>2]|0)+4752>>3];f=(e+1872|0)+0|0;j=(e+5096|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8856|0,l,w,e+1872|0);l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+112>>3],+h[(e+8856|0)>>3],a[(c[(b+360|0)>>2]|0)+24|0]|0)|0;o=rFa(+h[(c[(b+416|0)>>2]|0)+4752>>3],22064.0e3)|0;if((l|n)<<24>>24==0){x=o<<24>>24!=0?1.0:-1.0}else{x=1.0}h[d+64>>3]=x;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[o+136>>3],+h[o+1960>>3]+ +h[o+3048>>3],a[(c[(b+360|0)>>2]|0)+25|0]|0)|0;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;l=oFa(+h[o+136>>3],+h[o+1960>>3]- +h[o+3048>>3],a[(c[(b+360|0)>>2]|0)+26|0]|0)|0;do{if(n<<24>>24==0){if((a[(c[b+408>>2]|0)+2|0]|0)==0){y=-1.0;break}y=l<<24>>24!=0?1.0:-1.0}else{y=1.0}}while(0);h[d+72>>3]=y;mu(e+8864|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+3048>>3]);f=(e+5200|0)+0|0;j=(e+8864|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;y=+h[(c[(b+416|0)>>2]|0)+3048>>3];f=(e+1768|0)+0|0;j=(e+5200|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+8968|0,l,y,e+1768|0);l=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(e+8968|0)>>3],a[(c[(b+360|0)>>2]|0)+27|0]|0)|0;Xu(e+8976|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+3048>>3]);f=(e+5304|0)+0|0;j=(e+8976|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;y=+h[(c[(b+416|0)>>2]|0)+3048>>3];f=(e+1664|0)+0|0;j=(e+5304|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9080|0,n,y,e+1664|0);n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+128>>3],+h[(e+9080|0)>>3],a[(c[(b+360|0)>>2]|0)+28|0]|0)|0;o=rFa(+h[(c[(b+416|0)>>2]|0)+3048>>3],22064.0e3)|0;if((n|l)<<24>>24==0){z=o<<24>>24!=0?1.0:-1.0}else{z=1.0}h[d+80>>3]=z;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;l=oFa(+h[o+152>>3],+h[o+2016>>3]+ +h[o+3064>>3],a[(c[(b+360|0)>>2]|0)+29|0]|0)|0;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[o+152>>3],+h[o+2016>>3]- +h[o+3064>>3],a[(c[(b+360|0)>>2]|0)+30|0]|0)|0;do{if(l<<24>>24==0){if((a[(c[b+408>>2]|0)+4|0]|0)==0){B=-1.0;break}B=n<<24>>24!=0?1.0:-1.0}else{B=1.0}}while(0);h[d+88>>3]=B;mu(e+9088|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2936>>3]);f=(e+5408|0)+0|0;j=(e+9088|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;B=+h[(c[(b+416|0)>>2]|0)+2936>>3];f=(e+1560|0)+0|0;j=(e+5408|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9192|0,n,B,e+1560|0);n=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3],+h[(e+9192|0)>>3],a[(c[(b+360|0)>>2]|0)+31|0]|0)|0;Xu(e+9200|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2936>>3]);f=(e+5512|0)+0|0;j=(e+9200|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));l=c[(b+536|0)>>2]|0;B=+h[(c[(b+416|0)>>2]|0)+2936>>3];f=(e+1456|0)+0|0;j=(e+5512|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9304|0,l,B,e+1456|0);l=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+144>>3],+h[(e+9304|0)>>3],a[(c[(b+360|0)>>2]|0)+32|0]|0)|0;o=rFa(+h[(c[(b+416|0)>>2]|0)+2936>>3],22064.0e3)|0;if((l|n)<<24>>24==0){C=o<<24>>24!=0?1.0:-1.0}else{C=1.0}h[d+96>>3]=C;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[o+168>>3],+h[o+2080>>3]+ +h[o+3088>>3],a[(c[(b+360|0)>>2]|0)+33|0]|0)|0;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;l=oFa(+h[o+168>>3],+h[o+2080>>3]- +h[o+3088>>3],a[(c[(b+360|0)>>2]|0)+34|0]|0)|0;do{if(n<<24>>24==0){if((a[(c[b+408>>2]|0)+7|0]|0)==0){D=-1.0;break}D=l<<24>>24!=0?1.0:-1.0}else{D=1.0}}while(0);h[d+104>>3]=D;l=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[l+168>>3],+h[l+2072>>3]+ +h[l+3080>>3],a[(c[(b+360|0)>>2]|0)+35|0]|0)|0;l=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[l+168>>3],+h[l+2072>>3]- +h[l+3080>>3],a[(c[(b+360|0)>>2]|0)+36|0]|0)|0;do{if(n<<24>>24==0){if((a[(c[b+408>>2]|0)+6|0]|0)==0){E=-1.0;break}E=o<<24>>24!=0?1.0:-1.0}else{E=1.0}}while(0);h[d+112>>3]=E;mu(e+9312|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2824>>3]);f=(e+5616|0)+0|0;j=(e+9312|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));o=c[(b+536|0)>>2]|0;E=+h[(c[(b+416|0)>>2]|0)+2824>>3];f=(e+1352|0)+0|0;j=(e+5616|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9416|0,o,E,e+1352|0);o=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(e+9416|0)>>3],a[(c[(b+360|0)>>2]|0)+37|0]|0)|0;Xu(e+9424|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2824>>3]);f=(e+5720|0)+0|0;j=(e+9424|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;E=+h[(c[(b+416|0)>>2]|0)+2824>>3];f=(e+1248|0)+0|0;j=(e+5720|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9528|0,n,E,e+1248|0);n=nFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(e+9528|0)>>3],a[(c[(b+360|0)>>2]|0)+38|0]|0)|0;l=rFa(+h[(c[(b+416|0)>>2]|0)+2824>>3],22064.0e3)|0;if((n|o)<<24>>24==0){F=l<<24>>24!=0?1.0:-1.0}else{F=1.0}h[d+120>>3]=F;l=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;o=oFa(+h[l+184>>3],+h[l+2168>>3]+ +h[l+3112>>3],a[(c[(b+360|0)>>2]|0)+39|0]|0)|0;l=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[l+184>>3],+h[l+2168>>3]- +h[l+3112>>3],a[(c[(b+360|0)>>2]|0)+40|0]|0)|0;do{if(o<<24>>24==0){if((a[(c[b+408>>2]|0)+10|0]|0)==0){G=-1.0;break}G=n<<24>>24!=0?1.0:-1.0}else{G=1.0}}while(0);h[d+128>>3]=G;mu(e+9536|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2712>>3]);f=(e+5824|0)+0|0;j=(e+9536|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));n=c[(b+536|0)>>2]|0;G=+h[(c[(b+416|0)>>2]|0)+2712>>3];f=(e+1144|0)+0|0;j=(e+5824|0)+0|0;k=f+104|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(k|0));nu(e+9640|0,n,G,e+1144|0);n=lFa(+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3],+h[(e+9640|0)>>3],a[(c[(b+360|0)>>2]|0)+41|0]|0)|0;Xu(e+9648|0,c[(b+536|0)>>2]|0,+h[(c[(b+416|0)>>2]|0)+2712>>3]);f=(e+5928|0)+0|0;j=(e+9648|0)+0|0;k=f+104|0;c[e+10888>>2]=b;c[e+10896>>2]=d;c[e+11072>>2]=n;c[e+14280>>2]=f;c[e+14296>>2]=j;c[e+14304>>2]=k;c[e+14312>>2]=0;c[e+14316>>2]=0;_Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_function_ZeroCrossings$0(e);f=c[e+14280>>2]|0;j=c[e+14296>>2]|0;k=c[e+14304>>2]|0;H=c[e+14312>>2]|0;A=c[e+14316>>2]|0;I=+g[e+14316>>2];c[e+14312>>2]=0;c[e+14316>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function pB(a){a=a|0;i=i;return c[40640+(a<<2)>>2]|0}function _Modelica_Fluid_Examples_AST_BatchPlant_BatchPlant_StandardWater_function_ZeroCrossings$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0.0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0.0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0.0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0.0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0.0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0.0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0.0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0.0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0.0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0.0,gd=0,hd=0,id=0;d=c[b+10888>>2]|0;e=c[b+10896>>2]|0;f=c[b+11072>>2]|0;g=c[b+14280>>2]|0;j=c[b+14296>>2]|0;k=c[b+14304>>2]|0;a:do{do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));l=c[(d+536|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+2712>>3];g=(b+1040|0)+0|0;j=(b+5928|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+9752|0,l,m,b+1040|0);n=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+176>>3],+h[(b+9752|0)>>3],a[(c[(d+360|0)>>2]|0)+42|0]|0)|0;o=rFa(+h[(c[(d+416|0)>>2]|0)+2712>>3],22064.0e3)|0;if((n|f)<<24>>24==0){p=o<<24>>24!=0?1.0:-1.0}else{p=1.0}h[e+136>>3]=p;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;n=oFa(+h[o+200>>3],+h[o+2224>>3]+ +h[o+3128>>3],a[(c[(d+360|0)>>2]|0)+43|0]|0)|0;o=c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0;q=oFa(+h[o+200>>3],+h[o+2224>>3]- +h[o+3128>>3],a[(c[(d+360|0)>>2]|0)+44|0]|0)|0;do{if(n<<24>>24==0){if((a[(c[d+408>>2]|0)+12|0]|0)==0){r=-1.0;break}r=q<<24>>24!=0?1.0:-1.0}else{r=1.0}}while(0);h[e+144>>3]=r;mu(b+9760|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2456>>3]);g=(b+6032|0)+0|0;j=(b+9760|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));q=c[(d+536|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+2456>>3];g=(b+936|0)+0|0;j=(b+6032|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+9864|0,q,m,b+936|0);n=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3],+h[(b+9864|0)>>3],a[(c[(d+360|0)>>2]|0)+45|0]|0)|0;Xu(b+9872|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+2456>>3]);g=(b+6136|0)+0|0;j=(b+9872|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));q=c[(d+536|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+2456>>3];g=(b+832|0)+0|0;j=(b+6136|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+9976|0,q,m,b+832|0);l=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+192>>3],+h[(b+9976|0)>>3],a[(c[(d+360|0)>>2]|0)+46|0]|0)|0;o=rFa(+h[(c[(d+416|0)>>2]|0)+2456>>3],22064.0e3)|0;if((l|n)<<24>>24==0){s=o<<24>>24!=0?1.0:-1.0}else{s=1.0}h[e+152>>3]=s;mu(b+9984|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);g=(b+6240|0)+0|0;j=(b+9984|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));n=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];g=(b+728|0)+0|0;j=(b+6240|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10088|0,n,m,b+728|0);q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],+h[(b+10088|0)>>3],a[(c[(d+360|0)>>2]|0)+47|0]|0)|0;Xu(b+10096|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3]);g=(b+6344|0)+0|0;j=(b+10096|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));n=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3];g=(b+624|0)+0|0;j=(b+6344|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10200|0,n,m,b+624|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+208>>3],+h[(b+10200|0)>>3],a[(c[(d+360|0)>>2]|0)+48|0]|0)|0;l=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+216>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+49|0]|0)|0;if((o|q)<<24>>24==0){t=l<<24>>24!=0?1.0:-1.0}else{t=1.0}h[e+160>>3]=t;mu(b+10208|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);g=(b+6448|0)+0|0;j=(b+10208|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));q=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];g=(b+520|0)+0|0;j=(b+6448|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10312|0,q,m,b+520|0);n=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3],+h[(b+10312|0)>>3],a[(c[(d+360|0)>>2]|0)+50|0]|0)|0;Xu(b+10320|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3]);g=(b+6552|0)+0|0;j=(b+10320|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));q=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3];g=(b+416|0)+0|0;j=(b+6552|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10424|0,q,m,b+416|0);l=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+224>>3],+h[(b+10424|0)>>3],a[(c[(d+360|0)>>2]|0)+51|0]|0)|0;o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+232>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+52|0]|0)|0;if((l|n)<<24>>24==0){u=o<<24>>24!=0?1.0:-1.0}else{u=1.0}h[e+168>>3]=u;mu(b+10432|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);g=(b+6656|0)+0|0;j=(b+10432|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));n=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];g=(b+312|0)+0|0;j=(b+6656|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10536|0,n,m,b+312|0);q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],+h[(b+10536|0)>>3],a[(c[(d+360|0)>>2]|0)+53|0]|0)|0;Xu(b+10544|0,c[(d+536|0)>>2]|0,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3]);g=(b+6760|0)+0|0;j=(b+10544|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));n=c[(d+536|0)>>2]|0;m=+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3];g=(b+208|0)+0|0;j=(b+6760|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10648|0,n,m,b+208|0);o=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],+h[(b+10648|0)>>3],a[(c[(d+360|0)>>2]|0)+54|0]|0)|0;l=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+248>>3],22064.0e3,a[(c[(d+360|0)>>2]|0)+55|0]|0)|0;if((o|q)<<24>>24==0){v=l<<24>>24!=0?1.0:-1.0}else{v=1.0}h[e+176>>3]=v;l=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2120>>3],+h[(c[(d+416|0)>>2]|0)+2824>>3])|0;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+4944>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+57|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+9|0]|0)!=0&l<<24>>24==0){w=1.0}else{w=o<<24>>24!=0?1.0:-1.0}h[e+184>>3]=w;o=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+584>>3],+h[(c[(d+416|0)>>2]|0)+4752>>3])|0;l=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1320>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+59|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+1|0]|0)!=0&o<<24>>24==0){x=1.0}else{x=l<<24>>24!=0?1.0:-1.0}h[e+192>>3]=x;l=c[c[(d+4|0)>>2]>>2]|0;o=(lFa(+h[l>>3],+h[(c[l+8>>2]|0)+4184>>3],a[(c[(d+360|0)>>2]|0)+60|0]|0)|0)<<24>>24!=0;h[e+200>>3]=o?1.0:-1.0;o=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1984>>3],+h[(c[(d+416|0)>>2]|0)+3048>>3])|0;l=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+4712>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+62|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+3|0]|0)!=0&o<<24>>24==0){y=1.0}else{y=l<<24>>24!=0?1.0:-1.0}h[e+208>>3]=y;l=c[c[(d+4|0)>>2]>>2]|0;o=(lFa(+h[l>>3],+h[(c[l+8>>2]|0)+4216>>3],a[(c[(d+360|0)>>2]|0)+63|0]|0)|0)<<24>>24!=0;h[e+216>>3]=o?1.0:-1.0;o=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[(d+360|0)>>2]|0)+64|0]|0)|0;l=c[c[(d+4|0)>>2]>>2]|0;z=c[l+16>>2]|0;do{if((a[z+68|0]|0)==0){if((a[z+60|0]|0)!=0){A=-1.0;break}if((a[z+64|0]|0)!=0){A=-1.0;break}A=o<<24>>24!=0?1.0:-1.0}else{A=-1.0}}while(0);h[e+224>>3]=A;o=oFa(+h[l>>3],+h[(c[l+8>>2]|0)+6168>>3]+ +h[(c[(d+416|0)>>2]|0)+1016>>3],a[(c[(d+360|0)>>2]|0)+65|0]|0)|0;z=c[c[(d+4|0)>>2]>>2]|0;if((a[(c[z+16>>2]|0)+76|0]|0)==0){B=-1.0}else{B=o<<24>>24!=0?1.0:-1.0}h[e+232>>3]=B;o=lFa(+h[(c[z+8>>2]|0)+264>>3],.01,a[(c[(d+360|0)>>2]|0)+66|0]|0)|0;z=c[c[(d+4|0)>>2]>>2]|0;q=c[z+16>>2]|0;do{if((a[q+84|0]|0)==0){if((a[q+68|0]|0)!=0){C=-1.0;break}if((a[q+80|0]|0)!=0){C=-1.0;break}C=o<<24>>24!=0?1.0:-1.0}else{C=-1.0}}while(0);h[e+240>>3]=C;o=rFa(+h[(c[z+8>>2]|0)+2128>>3],+h[(c[(d+416|0)>>2]|0)+2824>>3])|0;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+6024>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+68|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+8|0]|0)!=0&o<<24>>24==0){D=1.0}else{D=q<<24>>24!=0?1.0:-1.0}h[e+248>>3]=D;q=c[c[(d+4|0)>>2]>>2]|0;o=oFa(+h[q>>3],+h[(c[q+8>>2]|0)+6224>>3]+ +h[(c[(d+416|0)>>2]|0)+1008>>3],a[(c[(d+360|0)>>2]|0)+69|0]|0)|0;q=c[c[(d+4|0)>>2]>>2]|0;if((a[(c[q+16>>2]|0)+94|0]|0)==0){E=-1.0}else{E=o<<24>>24!=0?1.0:-1.0}h[e+256>>3]=E;o=rFa(+h[(c[q+8>>2]|0)+2192>>3],+h[(c[(d+416|0)>>2]|0)+2712>>3])|0;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+5864>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+71|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+11|0]|0)!=0&o<<24>>24==0){F=1.0}else{F=q<<24>>24!=0?1.0:-1.0}h[e+264>>3]=F;q=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2248>>3],+h[(c[(d+416|0)>>2]|0)+2456>>3])|0;o=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+5944>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+73|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+13|0]|0)!=0&q<<24>>24==0){G=1.0}else{G=o<<24>>24!=0?1.0:-1.0}h[e+272>>3]=G;o=c[c[(d+4|0)>>2]>>2]|0;q=oFa(+h[o>>3],+h[(c[o+8>>2]|0)+6080>>3]+ +h[(c[(d+416|0)>>2]|0)+1032>>3],a[(c[(d+360|0)>>2]|0)+74|0]|0)|0;o=c[c[(d+4|0)>>2]>>2]|0;if((a[(c[o+16>>2]|0)+36|0]|0)==0){H=-1.0}else{H=q<<24>>24!=0?1.0:-1.0}h[e+280>>3]=H;m=+T(+(+h[(c[o+8>>2]|0)+6264>>3]));o=m!=+T(+(+h[c[d+364>>2]>>3]));h[e+288>>3]=o?1.0:-1.0;mu(b+10656|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+776>>3]);g=(b+6864|0)+0|0;j=(b+10656|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));z=c[(d+536|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+776>>3];g=(b+104|0)+0|0;j=(b+6864|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10760|0,z,m,b+104|0);o=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3],+h[(b+10760|0)>>3],a[(c[(d+360|0)>>2]|0)+75|0]|0)|0;Xu(b+10768|0,c[(d+536|0)>>2]|0,+h[(c[(d+416|0)>>2]|0)+776>>3]);g=(b+6968|0)+0|0;j=(b+10768|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));z=c[(d+536|0)>>2]|0;m=+h[(c[(d+416|0)>>2]|0)+776>>3];g=b+0|0;j=(b+6968|0)+0|0;k=g+104|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));nu(b+10872|0,z,m,b);q=nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+256>>3],+h[(b+10872|0)>>3],a[(c[(d+360|0)>>2]|0)+76|0]|0)|0;l=rFa(+h[(c[(d+416|0)>>2]|0)+776>>3],22064.0e3)|0;if((q|o)<<24>>24==0){I=l<<24>>24!=0?1.0:-1.0}else{I=1.0}h[e+296>>3]=I;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1944>>3],298.0,a[(c[(d+360|0)>>2]|0)+77|0]|0)|0)<<24>>24!=0;h[e+304>>3]=l?1.0:-1.0;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+544>>3],298.0,a[(c[(d+360|0)>>2]|0)+78|0]|0)|0)<<24>>24!=0;h[e+312>>3]=l?1.0:-1.0;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+136>>3],.01,a[(c[(d+360|0)>>2]|0)+79|0]|0)|0)<<24>>24!=0;h[e+320>>3]=l?1.0:-1.0;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+120>>3],.01,a[(c[(d+360|0)>>2]|0)+80|0]|0)|0)<<24>>24!=0;h[e+328>>3]=l?1.0:-1.0;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3],.01,a[(c[(d+360|0)>>2]|0)+81|0]|0)|0)<<24>>24!=0;h[e+336>>3]=l?1.0:-1.0;l=(oFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+264>>3],+h[(c[(d+416|0)>>2]|0)+1e3>>3],a[(c[(d+360|0)>>2]|0)+82|0]|0)|0)<<24>>24!=0;h[e+344>>3]=l?1.0:-1.0;l=(mFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3],.01,a[(c[(d+360|0)>>2]|0)+83|0]|0)|0)<<24>>24!=0;h[e+352>>3]=l?1.0:-1.0;l=(oFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+168>>3],.13,a[(c[(d+360|0)>>2]|0)+84|0]|0)|0)<<24>>24!=0;h[e+360>>3]=l?1.0:-1.0;l=(nFa(+h[c[c[(d+4|0)>>2]>>2]>>3],2500.0,a[(c[(d+360|0)>>2]|0)+85|0]|0)|0)<<24>>24!=0;h[e+368>>3]=l?1.0:-1.0;l=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2320>>3],+h[(c[(d+416|0)>>2]|0)+776>>3])|0;q=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+87|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+14|0]|0)!=0&l<<24>>24==0){J=1.0}else{J=q<<24>>24!=0?1.0:-1.0}h[e+376>>3]=J;q=(nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0,a[(c[(d+360|0)>>2]|0)+88|0]|0)|0)<<24>>24!=0;h[e+384>>3]=q?1.0:-1.0;q=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2352>>3],+h[(c[(d+416|0)>>2]|0)+776>>3])|0;if((a[(c[(d+408|0)>>2]|0)+15|0]|0)==0){K=-1.0}else{K=q<<24>>24!=0?-1.0:1.0}h[e+392>>3]=K;q=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2360>>3],+h[(c[(d+416|0)>>2]|0)+776>>3])|0;l=lFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+91|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+16|0]|0)!=0&q<<24>>24==0){L=1.0}else{L=l<<24>>24!=0?1.0:-1.0}h[e+400>>3]=L;l=(nFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0,a[(c[(d+360|0)>>2]|0)+92|0]|0)|0)<<24>>24!=0;h[e+408>>3]=l?1.0:-1.0;l=rFa(+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2040>>3],+h[(c[(d+416|0)>>2]|0)+2936>>3])|0;q=lFa(-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2376>>3],-1.0e-6,a[(c[(d+360|0)>>2]|0)+94|0]|0)|0;if((a[(c[(d+408|0)>>2]|0)+5|0]|0)!=0&l<<24>>24==0){M=1.0;N=e;O=N+416|0;P=O;h[P>>3]=M;Q=c[(d+416|0)>>2]|0;R=Q;S=R+2480|0;U=S;V=+h[U>>3];W=c[(d+4|0)>>2]|0;X=c[W>>2]|0;Y=X;Z=Y+8|0;_=Z;$=c[_>>2]|0;aa=$;ba=aa+2224|0;ca=ba;da=+h[ca>>3];ea=c[(d+360|0)>>2]|0;fa=ea;ga=fa+95|0;ha=ga;ia=a[ha]|0;ja=oFa(V,da,ia)|0;ka=ja<<24>>24!=0;la=ka?1.0:-1.0;ma=e;na=ma+424|0;oa=na;h[oa>>3]=la;pa=c[(d+416|0)>>2]|0;qa=pa;ra=qa+2736|0;sa=ra;ta=+h[sa>>3];ua=c[(d+4|0)>>2]|0;va=c[ua>>2]|0;wa=va;xa=wa+8|0;ya=xa;za=c[ya>>2]|0;Aa=za;Ba=Aa+2168|0;Ca=Ba;Da=+h[Ca>>3];Ea=c[(d+360|0)>>2]|0;Fa=Ea;Ga=Fa+96|0;Ha=Ga;Ia=a[Ha]|0;Ja=oFa(ta,Da,Ia)|0;Ka=Ja<<24>>24!=0;La=Ka?1.0:-1.0;Ma=e;Na=Ma+432|0;Oa=Na;h[Oa>>3]=La;Pa=c[(d+416|0)>>2]|0;Qa=Pa;Ra=Qa+2848|0;Sa=Ra;Ta=+h[Sa>>3];Ua=c[(d+4|0)>>2]|0;Va=c[Ua>>2]|0;Wa=Va;Xa=Wa+8|0;Ya=Xa;Za=c[Ya>>2]|0;_a=Za;$a=_a+2072|0;ab=$a;bb=+h[ab>>3];cb=c[(d+360|0)>>2]|0;db=cb;eb=db+97|0;fb=eb;gb=a[fb]|0;hb=oFa(Ta,bb,gb)|0;ib=hb<<24>>24!=0;jb=ib?1.0:-1.0;kb=e;lb=kb+440|0;mb=lb;h[mb>>3]=jb;nb=c[(d+416|0)>>2]|0;ob=nb;pb=ob+2848|0;qb=pb;rb=+h[qb>>3];sb=c[(d+4|0)>>2]|0;tb=c[sb>>2]|0;ub=tb;vb=ub+8|0;wb=vb;xb=c[wb>>2]|0;yb=xb;zb=yb+2080|0;Ab=zb;Bb=+h[Ab>>3];Cb=c[(d+360|0)>>2]|0;Db=Cb;Eb=Db+98|0;Fb=Eb;Gb=a[Fb]|0;Hb=oFa(rb,Bb,Gb)|0;Ib=Hb<<24>>24!=0;Jb=Ib?1.0:-1.0;Kb=e;Lb=Kb+448|0;Mb=Lb;h[Mb>>3]=Jb;Nb=c[(d+416|0)>>2]|0;Ob=Nb;Pb=Ob+2960|0;Qb=Pb;Rb=+h[Qb>>3];Sb=c[(d+4|0)>>2]|0;Tb=c[Sb>>2]|0;Ub=Tb;Vb=Ub+8|0;Wb=Vb;Xb=c[Wb>>2]|0;Yb=Xb;Zb=Yb+2016|0;_b=Zb;$b=+h[_b>>3];ac=c[(d+360|0)>>2]|0;bc=ac;cc=bc+99|0;dc=cc;ec=a[dc]|0;fc=oFa(Rb,$b,ec)|0;gc=fc<<24>>24!=0;hc=gc?1.0:-1.0;ic=e;jc=ic+456|0;kc=jc;h[kc>>3]=hc;lc=c[(d+416|0)>>2]|0;mc=lc;nc=mc+3072|0;oc=nc;pc=+h[oc>>3];qc=c[(d+4|0)>>2]|0;rc=c[qc>>2]|0;sc=rc;tc=sc+8|0;uc=tc;vc=c[uc>>2]|0;wc=vc;xc=wc+1960|0;yc=xc;zc=+h[yc>>3];Ac=c[(d+360|0)>>2]|0;Bc=Ac;Cc=Bc+100|0;Dc=Cc;Ec=a[Dc]|0;Fc=oFa(pc,zc,Ec)|0;Gc=Fc<<24>>24!=0;Hc=Gc?1.0:-1.0;Ic=e;Jc=Ic+464|0;Kc=Jc;h[Kc>>3]=Hc;Lc=c[(d+416|0)>>2]|0;Mc=Lc;Nc=Mc+4776|0;Oc=Nc;Pc=+h[Oc>>3];Qc=c[(d+4|0)>>2]|0;Rc=c[Qc>>2]|0;Sc=Rc;Tc=Sc+8|0;Uc=Tc;Vc=c[Uc>>2]|0;Wc=Vc;Xc=Wc+560|0;Yc=Xc;Zc=+h[Yc>>3];_c=c[(d+360|0)>>2]|0;$c=_c;ad=$c+101|0;bd=ad;cd=a[bd]|0;dd=oFa(Pc,Zc,cd)|0;ed=dd<<24>>24!=0;fd=ed?1.0:-1.0;gd=e;hd=gd+472|0;id=hd;h[id>>3]=fd;i=b;c[b+14312>>2]=6;c[b+14316>>2]=0;break a}M=q<<24>>24!=0?1.0:-1.0;N=e;O=N+416|0;P=O;h[P>>3]=M;Q=c[(d+416|0)>>2]|0;R=Q;S=R+2480|0;U=S;V=+h[U>>3];W=c[(d+4|0)>>2]|0;X=c[W>>2]|0;Y=X;Z=Y+8|0;_=Z;$=c[_>>2]|0;aa=$;ba=aa+2224|0;ca=ba;da=+h[ca>>3];ea=c[(d+360|0)>>2]|0;fa=ea;ga=fa+95|0;ha=ga;ia=a[ha]|0;ja=oFa(V,da,ia)|0;ka=ja<<24>>24!=0;la=ka?1.0:-1.0;ma=e;na=ma+424|0;oa=na;h[oa>>3]=la;pa=c[(d+416|0)>>2]|0;qa=pa;ra=qa+2736|0;sa=ra;ta=+h[sa>>3];ua=c[(d+4|0)>>2]|0;va=c[ua>>2]|0;wa=va;xa=wa+8|0;ya=xa;za=c[ya>>2]|0;Aa=za;Ba=Aa+2168|0;Ca=Ba;Da=+h[Ca>>3];Ea=c[(d+360|0)>>2]|0;Fa=Ea;Ga=Fa+96|0;Ha=Ga;Ia=a[Ha]|0;Ja=oFa(ta,Da,Ia)|0;Ka=Ja<<24>>24!=0;La=Ka?1.0:-1.0;Ma=e;Na=Ma+432|0;Oa=Na;h[Oa>>3]=La;Pa=c[(d+416|0)>>2]|0;Qa=Pa;Ra=Qa+2848|0;Sa=Ra;Ta=+h[Sa>>3];Ua=c[(d+4|0)>>2]|0;Va=c[Ua>>2]|0;Wa=Va;Xa=Wa+8|0;Ya=Xa;Za=c[Ya>>2]|0;_a=Za;$a=_a+2072|0;ab=$a;bb=+h[ab>>3];cb=c[(d+360|0)>>2]|0;db=cb;eb=db+97|0;fb=eb;gb=a[fb]|0;hb=oFa(Ta,bb,gb)|0;ib=hb<<24>>24!=0;jb=ib?1.0:-1.0;kb=e;lb=kb+440|0;mb=lb;h[mb>>3]=jb;nb=c[(d+416|0)>>2]|0;ob=nb;pb=ob+2848|0;qb=pb;rb=+h[qb>>3];sb=c[(d+4|0)>>2]|0;tb=c[sb>>2]|0;ub=tb;vb=ub+8|0;wb=vb;xb=c[wb>>2]|0;yb=xb;zb=yb+2080|0;Ab=zb;Bb=+h[Ab>>3];Cb=c[(d+360|0)>>2]|0;Db=Cb;Eb=Db+98|0;Fb=Eb;Gb=a[Fb]|0;Hb=oFa(rb,Bb,Gb)|0;Ib=Hb<<24>>24!=0;Jb=Ib?1.0:-1.0;Kb=e;Lb=Kb+448|0;Mb=Lb;h[Mb>>3]=Jb;Nb=c[(d+416|0)>>2]|0;Ob=Nb;Pb=Ob+2960|0;Qb=Pb;Rb=+h[Qb>>3];Sb=c[(d+4|0)>>2]|0;Tb=c[Sb>>2]|0;Ub=Tb;Vb=Ub+8|0;Wb=Vb;Xb=c[Wb>>2]|0;Yb=Xb;Zb=Yb+2016|0;_b=Zb;$b=+h[_b>>3];ac=c[(d+360|0)>>2]|0;bc=ac;cc=bc+99|0;dc=cc;ec=a[dc]|0;fc=oFa(Rb,$b,ec)|0;gc=fc<<24>>24!=0;hc=gc?1.0:-1.0;ic=e;jc=ic+456|0;kc=jc;h[kc>>3]=hc;lc=c[(d+416|0)>>2]|0;mc=lc;nc=mc+3072|0;oc=nc;pc=+h[oc>>3];qc=c[(d+4|0)>>2]|0;rc=c[qc>>2]|0;sc=rc;tc=sc+8|0;uc=tc;vc=c[uc>>2]|0;wc=vc;xc=wc+1960|0;yc=xc;zc=+h[yc>>3];Ac=c[(d+360|0)>>2]|0;Bc=Ac;Cc=Bc+100|0;Dc=Cc;Ec=a[Dc]|0;Fc=oFa(pc,zc,Ec)|0;Gc=Fc<<24>>24!=0;Hc=Gc?1.0:-1.0;Ic=e;Jc=Ic+464|0;Kc=Jc;h[Kc>>3]=Hc;Lc=c[(d+416|0)>>2]|0;Mc=Lc;Nc=Mc+4776|0;Oc=Nc;Pc=+h[Oc>>3];Qc=c[(d+4|0)>>2]|0;Rc=c[Qc>>2]|0;Sc=Rc;Tc=Sc+8|0;Uc=Tc;Vc=c[Uc>>2]|0;Wc=Vc;Xc=Wc+560|0;Yc=Xc;Zc=+h[Yc>>3];_c=c[(d+360|0)>>2]|0;$c=_c;ad=$c+101|0;bd=ad;cd=a[bd]|0;dd=oFa(Pc,Zc,cd)|0;ed=dd<<24>>24!=0;fd=ed?1.0:-1.0;gd=e;hd=gd+472|0;id=hd;h[id>>3]=fd;i=b;c[b+14312>>2]=6;c[b+14316>>2]=0;break a}while(0);c[b+14280>>2]=g;c[b+14296>>2]=j;c[b+14304>>2]=k}



function K4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[83048]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=332232+(j<<2)|0;l=332232+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[83048]=f&~(1<<h)}else{if(n>>>0<(c[332208>>2]|0)>>>0){kd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{kd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[332200>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=332232+(r<<2)|0;o=332232+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[83048]=f&~(1<<t)}else{if(n>>>0<(c[332208>>2]|0)>>>0){kd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{kd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[332200>>2]|0;if((n|0)!=0){f=c[332212>>2]|0;e=n>>>3;n=e<<1;g=332232+(n<<2)|0;m=c[83048]|0;j=1<<e;do{if((m&j|0)==0){c[83048]=m|j;u=332232+(n+2<<2)|0;v=g}else{e=332232+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[332208>>2]|0)>>>0)){u=e;v=h;break}kd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[332200>>2]=o;c[332212>>2]=s;p=k;i=b;return p|0}n=c[332196>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[332496+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[332208>>2]|0;if(h>>>0<k>>>0){kd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){kd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){kd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){kd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){kd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{kd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=332496+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<h);break a}else{if(s>>>0<(c[332208>>2]|0)>>>0){kd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[332208>>2]|0)>>>0){kd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[332200>>2]|0;if((h|0)!=0){s=c[332212>>2]|0;k=h>>>3;h=k<<1;f=332232+(h<<2)|0;m=c[83048]|0;g=1<<k;do{if((m&g|0)==0){c[83048]=m|g;A=332232+(h+2<<2)|0;B=f}else{k=332232+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[332208>>2]|0)>>>0)){A=k;B=e;break}kd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[332200>>2]=t;c[332212>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[332196>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[332496+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[332496+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[332200>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[332208>>2]|0;if(t>>>0<f>>>0){kd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){kd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){kd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){kd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){kd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{kd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=332496+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<e);break c}else{if(t>>>0<(c[332208>>2]|0)>>>0){kd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[332208>>2]|0)>>>0){kd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=332232+(t<<2)|0;s=c[83048]|0;r=1<<e;do{if((s&r|0)==0){c[83048]=s|r;S=332232+(t+2<<2)|0;T=f}else{e=332232+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[332208>>2]|0)>>>0)){S=e;T=k;break}kd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=332496+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[332196>>2]|0;l=1<<U;if((f&l|0)==0){c[332196>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[332208>>2]|0;if(W>>>0<k>>>0){kd()}if(r>>>0<k>>>0){kd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[332200>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[332212>>2]|0;if(W>>>0>15){c[332212>>2]=X+q;c[332200>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[332200>>2]=0;c[332212>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[332204>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[332204>>2]=W;X=c[332216>>2]|0;c[332216>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[83166]|0)==0){X=hd(30)|0;if((X+ -1&X|0)==0){c[332672>>2]=X;c[332668>>2]=X;c[332676>>2]=-1;c[332680>>2]=-1;c[332684>>2]=0;c[332636>>2]=0;c[83166]=(vc(0)|0)&-16^1431655768;break}else{kd()}}}while(0);X=q+48|0;W=c[332672>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[332632>>2]|0;do{if((U|0)!=0){T=c[332624>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[332636>>2]&4|0)==0){U=c[332216>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=332640|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[332204>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=mb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=mb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[332668>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[332624>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[332632>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=mb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[332672>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((mb(t|0)|0)==(-1|0)){mb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[332636>>2]=c[332636>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=mb(W|0)|0;ha=mb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[332624>>2]|0)+ga|0;c[332624>>2]=ia;if(ia>>>0>(c[332628>>2]|0)>>>0){c[332628>>2]=ia}ia=c[332216>>2]|0;W=332640|0;i:do{if((ia|0)==0){aa=c[332208>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[332208>>2]=fa}c[332640>>2]=fa;c[332644>>2]=ga;c[332652>>2]=0;c[332228>>2]=c[83166];c[332224>>2]=-1;aa=0;do{ha=aa<<1;$=332232+(ha<<2)|0;c[332232+(ha+3<<2)>>2]=$;c[332232+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[332216>>2]=fa+ja;c[332204>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[332220>>2]=c[332680>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[332204>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[332216>>2]=ia+na;c[332204>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[332220>>2]=c[332680>>2];break i}}while(0);if(fa>>>0<(c[332208>>2]|0)>>>0){c[332208>>2]=fa}aa=fa+ga|0;$=332640|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[332216>>2]|0)){ca=(c[332204>>2]|0)+X|0;c[332204>>2]=ca;c[332216>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[332212>>2]|0)){ca=(c[332200>>2]|0)+X|0;c[332200>>2]=ca;c[332212>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=332232+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[332208>>2]|0)>>>0){kd()}if((c[V+12>>2]|0)==(ha|0)){break}kd()}}while(0);if((L|0)==(V|0)){c[83048]=c[83048]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[332208>>2]|0)>>>0){kd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}kd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[332208>>2]|0)>>>0){kd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){kd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{kd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=332496+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<t);break k}else{if(T>>>0<(c[332208>>2]|0)>>>0){kd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[332208>>2]|0)>>>0){kd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=332232+(Z<<2)|0;t=c[83048]|0;T=1<<ca;do{if((t&T|0)==0){c[83048]=t|T;xa=332232+(Z+2<<2)|0;ya=ea}else{ca=332232+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[332208>>2]|0)>>>0)){xa=ca;ya=V;break}kd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=332496+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[332196>>2]|0;L=1<<za;if((ea&L|0)==0){c[332196>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[332208>>2]|0;if(Ba>>>0<S>>>0){kd()}if(T>>>0<S>>>0){kd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=332640|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[332216>>2]=fa+Ha;c[332204>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[332220>>2]=c[332680>>2];c[ba+4>>2]=27;X=332640|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[332640>>2]=fa;c[332644>>2]=ga;c[332652>>2]=0;c[332648>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=332232+(da<<2)|0;aa=c[83048]|0;f=1<<M;do{if((aa&f|0)==0){c[83048]=aa|f;Ia=332232+(da+2<<2)|0;Ja=ha}else{M=332232+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[332208>>2]|0)>>>0)){Ia=M;Ja=T;break}kd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=332496+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[332196>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[332196>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[332208>>2]|0;if(Ma>>>0<f>>>0){kd()}if(M>>>0<f>>>0){kd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[332204>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[332204>>2]=W;ia=c[332216>>2]|0;c[332216>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Qc()|0)>>2]=12;p=0;i=b;return p|0}function L4a(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[332208>>2]|0;if(d>>>0<f>>>0){kd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){kd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){kd()}if((p|0)==(c[332212>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[332200>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=332232+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){kd()}if((c[m+12>>2]|0)==(p|0)){break}kd()}}while(0);if((u|0)==(m|0)){c[83048]=c[83048]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){kd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}kd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){kd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){kd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){kd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{kd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=332496+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[332208>>2]|0)>>>0){kd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[332208>>2]|0)>>>0){kd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){kd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){kd()}do{if((C&2|0)==0){if((l|0)==(c[332216>>2]|0)){f=(c[332204>>2]|0)+t|0;c[332204>>2]=f;c[332216>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[332212>>2]|0)){i=b;return}c[332212>>2]=0;c[332200>>2]=0;i=b;return}if((l|0)==(c[332212>>2]|0)){f=(c[332200>>2]|0)+t|0;c[332200>>2]=f;c[332212>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=332232+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[332208>>2]|0)>>>0){kd()}if((c[E+12>>2]|0)==(l|0)){break}kd()}}while(0);if((w|0)==(E|0)){c[83048]=c[83048]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[332208>>2]|0)>>>0){kd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}kd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[332208>>2]|0)>>>0){kd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){kd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{kd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=332496+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<g);break b}else{if(d>>>0<(c[332208>>2]|0)>>>0){kd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[332208>>2]|0)>>>0){kd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[332212>>2]|0)){J=f;break}c[332200>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=332232+(C<<2)|0;G=c[83048]|0;j=1<<t;do{if((G&j|0)==0){c[83048]=G|j;K=332232+(C+2<<2)|0;L=e}else{t=332232+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[332208>>2]|0)>>>0)){K=t;L=a;break}kd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=332496+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[332196>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[332196>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[332208>>2]|0;if(O>>>0<K>>>0){kd()}if(f>>>0<K>>>0){kd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[332224>>2]|0)+ -1|0;c[332224>>2]=s;if((s|0)==0){Q=332648|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[332224>>2]=-1;i=b;return}function M4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=K4a(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}q5a(b|0,0,e|0)|0;i=d;return b|0}function N4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=K4a(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Qc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=O4a(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=K4a(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;o5a(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;L4a(a);e=g;i=d;return e|0}function O4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[332208>>2]|0;if(h>>>0<l>>>0){kd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){kd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){kd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[332672>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;P4a(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[332216>>2]|0)){m=(c[332204>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[332216>>2]=a+b;c[332204>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[332212>>2]|0)){h=(c[332200>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[332200>>2]=r;c[332212>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=332232+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){kd()}if((c[h+12>>2]|0)==(k|0)){break}kd()}}while(0);if((m|0)==(h|0)){c[83048]=c[83048]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){kd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}kd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){kd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){kd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){kd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{kd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=332496+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<u);break a}else{if(t>>>0<(c[332208>>2]|0)>>>0){kd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[332208>>2]|0)>>>0){kd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;P4a(a+b|0,r);o=a;i=d;return o|0}return 0}function P4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[332208>>2]|0;if(j>>>0<m>>>0){kd()}if((k|0)==(c[332212>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[332200>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=332232+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){kd()}if((c[q+12>>2]|0)==(k|0)){break}kd()}}while(0);if((r|0)==(q|0)){c[83048]=c[83048]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){kd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}kd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){kd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){kd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){kd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{kd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=332496+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[332208>>2]|0)>>>0){kd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[332208>>2]|0)>>>0){kd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[332208>>2]|0;if(e>>>0<z>>>0){kd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[332216>>2]|0)){t=(c[332204>>2]|0)+p|0;c[332204>>2]=t;c[332216>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[332212>>2]|0)){i=d;return}c[332212>>2]=0;c[332200>>2]=0;i=d;return}if((f|0)==(c[332212>>2]|0)){t=(c[332200>>2]|0)+p|0;c[332200>>2]=t;c[332212>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=332232+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){kd()}if((c[u+12>>2]|0)==(f|0)){break}kd()}}while(0);if((h|0)==(u|0)){c[83048]=c[83048]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){kd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}kd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){kd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){kd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){kd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{kd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=332496+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[332196>>2]=c[332196>>2]&~(1<<j);break b}else{if(m>>>0<(c[332208>>2]|0)>>>0){kd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[332208>>2]|0)>>>0){kd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[332208>>2]|0)>>>0){kd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[332212>>2]|0)){G=t;break}c[332200>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=332232+(B<<2)|0;D=c[83048]|0;b=1<<p;do{if((D&b|0)==0){c[83048]=D|b;H=332232+(B+2<<2)|0;I=A}else{p=332232+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[332208>>2]|0)>>>0)){H=p;I=a;break}kd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=332496+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[332196>>2]|0;B=1<<J;if((a&B|0)==0){c[332196>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[332208>>2]|0)>>>0){kd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[332208>>2]|0;if(L>>>0<B>>>0){kd()}if(G>>>0<B>>>0){kd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function Q4a(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=K4a(d)|0;if((e|0)!=0){f=6;break}a=c[83172]|0;c[83172]=0+a;if((a|0)==0){f=5;break}Ke[a&7]()}if((f|0)==5){d=Hc(4)|0;c[d>>2]=332704;Xd(d|0,332752,135)}else if((f|0)==6){i=b;return e|0}return 0}function R4a(a){a=a|0;var b=0,c=0;b=i;c=Q4a(a)|0;i=b;return c|0}function S4a(a){a=a|0;var b=0;b=i;if((a|0)!=0){L4a(a)}i=b;return}function T4a(a){a=a|0;var b=0;b=i;S4a(a);i=b;return}function U4a(a){a=a|0;var b=0;b=i;Bb(a|0);S4a(a);i=b;return}function V4a(a){a=a|0;var b=0;b=i;Bb(a|0);i=b;return}function W4a(a){a=a|0;i=i;return 332720}function X4a(){var a=0;a=Hc(4)|0;c[a>>2]=332704;Xd(a|0,332752,135)}function Y4a(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=$4a(b)|0}}while((md(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=$4a(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[332768+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=$4a(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[332784+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=$4a(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=$4a(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=$4a(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=$4a(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=$4a(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=$4a(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=w5a(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=w5a(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=$4a(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){_4a(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=w5a(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=Z4a(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){_4a(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=r5a(q|0,n|0,2)|0;o=w5a(p|0,J|0,-32,-1)|0;p=w5a(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=w5a(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=v5a(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=w5a(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Vd(+(+a5a(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Qc()|0)>>2]=34}l=+b5a(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=$4a(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=$4a(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=$4a(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=w5a(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=w5a(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=$4a(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=Z4a(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){_4a(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=w5a(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Qc()|0)>>2]=22;_4a(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Qc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[332800+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[332800+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[332800+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=r5a(c[Ra>>2]|0,0,29)|0;Qa=w5a(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=G5a(Qa|0,Ta|0,1e9,0)|0;pa=H5a(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=r5a(c[Ua>>2]|0,0,29)|0;Ra=w5a(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=G5a(Ra|0,Sa|0,1e9,0)|0;Pa=H5a(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[332792+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Vd(+(+a5a(1.0,105-tc|0)),+sc);vc=+Cc(+sc,+(+a5a(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){zc=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Ac=xc;break}}Ac=la*.25+xc}else{if(na>>>0>5e8){Ac=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Ac=la*.5+xc;break}else{Ac=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){zc=Ac;break}if(+Cc(+Ac,1.0)!=0.0){zc=Ac;break}zc=Ac+1.0}}while(0);la=yc+zc-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Bc=uc;Dc=kc;Ec=la}else{Bc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Bc|0)!=0&zc!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Qc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+b5a(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=$4a(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=$4a(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Qc()|0)>>2]=22;_4a(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Qc()|0)>>2]=22;_4a(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function Z4a(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=$4a(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=$4a(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=$4a(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=F5a(q|0,m|0,10,0)|0;b=J;g=w5a(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=w5a(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=$4a(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=$4a(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=v5a(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function _4a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function $4a(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=d5a(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function a5a(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=r5a(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function b5a(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+a5a(a,b);i=c;return+d}function c5a(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){pe[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function d5a(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((c5a(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((pe[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function e5a(a){a=a|0;var b=0,c=0.0;b=i;c=+f5a(a,0);i=b;return+c}function f5a(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;_4a(e,0);h=+Y4a(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function g5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;_4a(e,0);h=+Y4a(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function h5a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function i5a(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function j5a(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function k5a(){c[78276]=p;c[78318]=p;c[82960]=p;c[83190]=p}function l5a(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}gc(116);gc(111);gc(111);gc(32);gc(109);gc(97);gc(110);gc(121);gc(32);gc(115);gc(101);gc(116);gc(106);gc(109);gc(112);gc(115);gc(32);gc(105);gc(110);gc(32);gc(97);gc(32);gc(102);gc(117);gc(110);gc(99);gc(116);gc(105);gc(111);gc(110);gc(32);gc(99);gc(97);gc(108);gc(108);gc(44);gc(32);gc(98);gc(117);gc(105);gc(108);gc(100);gc(32);gc(119);gc(105);gc(116);gc(104);gc(32);gc(97);gc(32);gc(104);gc(105);gc(103);gc(104);gc(101);gc(114);gc(32);gc(118);gc(97);gc(108);gc(117);gc(101);gc(32);gc(102);gc(111);gc(114);gc(32);gc(77);gc(65);gc(88);gc(95);gc(83);gc(69);gc(84);gc(74);gc(77);gc(80);gc(83);gc(10);ga(0);return 0}function m5a(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function n5a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function o5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return ob(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function p5a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{o5a(b,c,d)|0}return b|0}function q5a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function r5a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function s5a(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function t5a(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function u5a(){return t5a(o)|0}function v5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function w5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function x5a(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function y5a(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function z5a(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function A5a(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function B5a(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function C5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function D5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=v5a(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=v5a((I5a(i,b,v5a(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function E5a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=v5a(h^a,j^b,h,j)|0;b=J;I5a(m,b,v5a(k^d,l^e,k,l)|0,J,g)|0;l=v5a(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function F5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=C5a(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function G5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=I5a(a,b,c,d,0)|0;return(J=J,e)|0}function H5a(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;I5a(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function I5a(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((B5a(l|0)|0)>>>0);return(J=n,o)|0}p=(A5a(l|0)|0)-(A5a(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(A5a(l|0)|0)-(A5a(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(A5a(j|0)|0)+33-(A5a(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=B5a(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=w5a(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;v5a(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=v5a(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function J5a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return fe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function K5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ge[a&31](b|0,c|0,d|0,e|0,f|0)}function L5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return he[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function M5a(a,b){a=a|0;b=+b;ie[a&1](+b)}function N5a(a,b){a=a|0;b=b|0;je[a&1023](b|0)}function O5a(a,b,c){a=a|0;b=b|0;c=c|0;ke[a&255](b|0,c|0)}function P5a(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return le[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Q5a(a,b){a=a|0;b=b|0;return me[a&127](b|0)|0}function R5a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ne[a&1](b|0,c|0,+d,e|0)}function S5a(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return oe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function T5a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return pe[a&63](b|0,c|0,d|0)|0}function U5a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function V5a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return re[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function W5a(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;return se[a&1](+b,c|0,d|0)|0}function X5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;te[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function Y5a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ue[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Z5a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return ve[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function _5a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;we[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function $5a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;xe[a&3](b|0,c|0,+d,e|0,f|0)}function a6a(a,b,c){a=a|0;b=b|0;c=+c;return ye[a&1](b|0,+c)|0}function b6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ze[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function c6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ae[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function d6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Be[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function e6a(a,b,c){a=a|0;b=b|0;c=c|0;return Ce[a&127](b|0,c|0)|0}function f6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return De[a&63](b|0,c|0,d|0,e|0,f|0)|0}function g6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Ee[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function h6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Fe[a&1](b|0,+c,+d)}function i6a(a,b,c){a=a|0;b=b|0;c=c|0;return+Ge[a&1](b|0,c|0)}function j6a(a){a=a|0;return He[a&7]()|0}function k6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function l6a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Je[a&15](b|0,c|0,d|0)}function m6a(a){a=a|0;Ke[a&7]()}function n6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Le[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function o6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Me[a&63](b|0,c|0,d|0,e|0)|0}function p6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ne[a&127](b|0,c|0,d|0,e|0)}function q6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function r6a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function s6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function t6a(a){a=+a;ga(3)}function u6a(a){a=a|0;ga(4)}function v6a(a){a=a|0;Gd(a|0)}function w6a(a,b){a=a|0;b=b|0;ga(5)}function x6a(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function y6a(a){a=a|0;ga(7);return 0}function z6a(a){a=a|0;return Rc(a|0)|0}function A6a(a){a=a|0;return Pd(a|0)|0}function B6a(a){a=a|0;return zc(a|0)|0}function C6a(a){a=a|0;return Ed(a|0)|0}function D6a(a){a=a|0;return pd(a|0)|0}function E6a(a){a=a|0;return yd(a|0)|0}function F6a(a){a=a|0;return $c(a|0)|0}function G6a(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function H6a(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function I6a(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function J6a(a,b,c){a=a|0;b=b|0;c=c|0;return Ad(a|0,b|0,c|0)|0}function K6a(a,b,c){a=a|0;b=b|0;c=c|0;return kc(a|0,b|0,c|0)|0}function L6a(a,b,c){a=a|0;b=b|0;c=c|0;return Sd(a|0,b|0,c|0)|0}function M6a(a,b,c){a=a|0;b=b|0;c=c|0;return Fd(a|0,b|0,c|0)|0}function N6a(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function O6a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function P6a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function Q6a(a,b,c){a=+a;b=b|0;c=c|0;ga(13);return 0}function R6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(14)}function S6a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(15)}function T6a(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(16);return 0}function U6a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(17)}function V6a(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(18)}function W6a(a,b){a=a|0;b=+b;ga(19);return 0}function X6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(20)}function Y6a(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(21)}function Z6a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(22)}function _6a(a,b){a=a|0;b=b|0;ga(23);return 0}function $6a(a,b){a=a|0;b=b|0;return Ud(a|0,b|0)|0}function a7a(a,b){a=a|0;b=b|0;return jc(a|0,b|0)|0}function b7a(a,b){a=a|0;b=b|0;return kb(a|0,b|0)|0}function c7a(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(24);return 0}function d7a(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(25);return 0}function e7a(a,b,c){a=a|0;b=+b;c=+c;ga(26);return 0.0}function f7a(a,b){a=a|0;b=b|0;ga(27);return 0.0}function g7a(){ga(28);return 0}function h7a(){return lb()|0}function i7a(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(29);return 0}function j7a(a,b,c){a=a|0;b=b|0;c=c|0;ga(30)}function k7a(){ga(31)}function l7a(){Xc()}function m7a(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(32);return 0}function n7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33);return 0}function o7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return uc(a|0,b|0,c|0,d|0)|0}function p7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Pc(a|0,b|0,c|0,d|0)|0}function q7a(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(34)}



function Lt(b,d,e,f,g){b=b|0;d=d|0;e=+e;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0;j=i;i=i+64|0;l=j;m=j+24|0;n=j+40|0;o=j+56|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+16|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+16|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+16|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;c[ra>>2]=3;PCa(sa,1,ra);c[qa>>2]=1;Qa=+h[(XCa(f,1,qa)|0)>>3];c[pa>>2]=2;Ra=+h[(XCa(f,1,pa)|0)>>3];c[oa>>2]=3;Sa=+h[(XCa(f,1,oa)|0)>>3];oa=na;h[k>>3]=Ra*Ra;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];oa=na+8|0;h[k>>3]=Sa*Sa;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];WCa(ta,3,Qa*Qa,na);RCa(ta,sa);c[ma>>2]=1;Qa=+h[(XCa(f,1,ma)|0)>>3];c[la>>2]=2;Sa=+h[(XCa(f,1,la)|0)>>3];c[ka>>2]=3;Ra=+h[(XCa(f,1,ka)|0)>>3];ka=ja;h[k>>3]=Sa*Sa;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=ja+8|0;h[k>>3]=Ra*Ra;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];WCa(ua,3,Qa*Qa,ja);ja=sa;ka=ua;c[ja+0>>2]=c[ka+0>>2];c[ja+4>>2]=c[ka+4>>2];c[ja+8>>2]=c[ka+8>>2];c[ia>>2]=3;PCa(va,1,ia);ZCa(1.0,2,xa);c[ha>>2]=1;ZCa(+h[(XCa(f,1,ha)|0)>>3],2,ya);c[ga>>2]=1;ZCa(+h[(XCa(sa,1,ga)|0)>>3],2,za);ZCa(1.0,2,Ba);c[fa>>2]=2;ZCa(+h[(XCa(f,1,fa)|0)>>3],2,Ca);c[ea>>2]=2;ZCa(+h[(XCa(sa,1,ea)|0)>>3],2,Da);ZCa(1.0,2,Fa);c[da>>2]=3;ZCa(+h[(XCa(f,1,da)|0)>>3],2,Ga);c[ca>>2]=3;ZCa(+h[(XCa(sa,1,ca)|0)>>3],2,Ha);c[ba>>2]=ya;c[ba+4>>2]=za;YCa(2,wa,3,xa,ba);c[aa>>2]=Ca;c[aa+4>>2]=Da;YCa(2,Aa,3,Ba,aa);c[$>>2]=Ga;c[$+4>>2]=Ha;YCa(2,Ea,3,Fa,$);c[_>>2]=Aa;c[_+4>>2]=Ea;YCa(1,Ia,3,wa,_);c[Z>>2]=1;Qa=+h[(XCa(g,1,Z)|0)>>3];c[Y>>2]=2;Ra=+h[(XCa(g,1,Y)|0)>>3];c[X>>2]=3;Sa=+h[(XCa(g,1,X)|0)>>3];X=W;h[k>>3]=Ra;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];X=W+8|0;h[k>>3]=Sa;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];WCa(Ja,3,Qa,W);W=Ka;X=n;Y=Ia;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Y=m;X=Ja;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];Mt(W,d,n,m);m=Ka;Ka=va;c[Ka+0>>2]=c[m+0>>2];c[Ka+4>>2]=c[m+4>>2];c[Ka+8>>2]=c[m+8>>2];c[V>>2]=1;Qa=+h[(XCa(f,1,V)|0)>>3];c[U>>2]=2;Sa=+h[(XCa(f,1,U)|0)>>3];c[T>>2]=3;Ra=+h[(XCa(f,1,T)|0)>>3];T=S;h[k>>3]=Sa;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=Ra;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];WCa(La,3,Qa,S);Qa=+aDa(La);c[R>>2]=1;Ra=+h[(XCa(f,1,R)|0)>>3];c[Q>>2]=2;Sa=+h[(XCa(f,1,Q)|0)>>3];c[P>>2]=3;Ta=+h[(XCa(f,1,P)|0)>>3];P=O;h[k>>3]=Sa;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=Ta;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];WCa(Ma,3,Ra,O);Ra=+$Ca(Ma);do{if(!(a[9360]&1)){c[N>>2]=1;Ta=+h[(XCa(f,1,N)|0)>>3];c[M>>2]=3;Sa=Ta*+h[(XCa(va,1,M)|0)>>3]*2.0;c[L>>2]=2;Ta=Sa+ +h[(XCa(va,1,L)|0)>>3];c[K>>2]=2;Sa=+h[(XCa(f,1,K)|0)>>3];c[J>>2]=3;Ua=Sa*+h[(XCa(va,1,J)|0)>>3]*2.0;c[I>>2]=2;Sa=Ua+ +h[(XCa(va,1,I)|0)>>3];c[H>>2]=3;Ua=+h[(XCa(f,1,H)|0)>>3];c[G>>2]=3;Va=Ua*+h[(XCa(va,1,G)|0)>>3]*2.0;c[F>>2]=2;Ua=Va+ +h[(XCa(va,1,F)|0)>>3];Ma=E;h[k>>3]=Sa;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];Ma=E+8|0;h[k>>3]=Ua;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];WCa(Na,3,Ta,E);if(+$Ca(Na)<=-1.0e-60){break}Ma=c[72854]|0;O=l;P=9368;c[O+0>>2]=c[P+0>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];c[O+12>>2]=c[P+12>>2];c[O+16>>2]=c[P+16>>2];c[O+20>>2]=c[P+20>>2];Je[Ma&15](l,9392,D);a[9360]=1}}while(0);if(Qa>e){c[C>>2]=1;Ta=+h[(XCa(g,1,C)|0)>>3];c[B>>2]=2;Ua=+h[(XCa(g,1,B)|0)>>3];c[A>>2]=3;Sa=+h[(XCa(g,1,A)|0)>>3];A=z;h[k>>3]=Ua;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Sa;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];WCa(Oa,3,Ta,z);Ta=+$Ca(Oa);c[y>>2]=2;Sa=+h[(XCa(va,1,y)|0)>>3];c[x>>2]=3;Wa=Ta+(e-Qa)*(Sa+Qa*+h[(XCa(va,1,x)|0)>>3]*2.0);Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}if(Ra<e){c[w>>2]=1;Qa=+h[(XCa(g,1,w)|0)>>3];c[v>>2]=2;Sa=+h[(XCa(g,1,v)|0)>>3];c[u>>2]=3;Ta=+h[(XCa(g,1,u)|0)>>3];u=t;h[k>>3]=Sa;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=Ta;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];WCa(Pa,3,Qa,t);Qa=+aDa(Pa);c[s>>2]=2;Ta=+h[(XCa(va,1,s)|0)>>3];c[r>>2]=3;Wa=Qa+(e-Ra)*(Ta+Ra*+h[(XCa(va,1,r)|0)>>3]*2.0);Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}else{c[q>>2]=1;Ra=+h[(XCa(va,1,q)|0)>>3];c[p>>2]=2;Ta=+h[(XCa(va,1,p)|0)>>3];c[o>>2]=3;Wa=Ra+(Ta+ +h[(XCa(va,1,o)|0)>>3]*e)*e;Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}}function Mt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f;h=f+24|0;j=f+40|0;k=f+56|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=n;c[m>>2]=vBa(d,1)|0;PCa(q,1,m);c[l>>2]=vBa(d,1)|0;PCa(o,1,l);l=j;m=d;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=h;l=e;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];eu(p,0,j,h);h=p;j=o;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];if((c[p+12>>2]|0)==0){RCa(o,q);r=a;s=n;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];i=f;return}p=c[72852]|0;h=g;j=11056;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ne[p&127](b,g,11080,k);RCa(o,q);r=a;s=n;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];i=f;return}function Nt(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=d;i=i;return}function Ot(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+wd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+xd(+y,+z)+n;B=+wd(+y,+z)-n;if(A<=c){Pt(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){Pt(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}Pt(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];Pt(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];Qt(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){Qt(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{Qt(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function Pt(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[72852]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=12792;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Ne[F&127](b,v,1e4,A);F=c[72852]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=12792;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Ne[G&127](b,u,1e4,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[72852]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=12792;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Ne[E&127](b,t,10064,y);}K=H*+ab(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[72852]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=12792;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Ne[F&127](b,s,10160,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[72852]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=12792;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Ne[G&127](b,r,10240,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}Rt(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function Qt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=ACa(ACa(10536,yCa(e,0,1,6)|0)|0,10592)|0;s=ACa(ACa(r,yCa(f,0,1,6)|0)|0,10608)|0;r=c[72852]|0;t=o;u=10712;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Ne[r&127](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=ACa(ACa(10736,yCa(k,0,1,6)|0)|0,10912)|0;s=ACa(ACa(q,yCa(l,0,1,6)|0)|0,10928)|0;q=c[72852]|0;o=n;r=10960;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];Ne[q&127](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+wd(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+xd(+(X*X),1.0e-13);X=(l-Y)/+xd(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function Rt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[72852]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=12792;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Ne[H&127](b,u,9504,D);}J=+ab(+F);if(!(e>0.0)){D=c[72852]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=12792;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Ne[u&127](b,t,9568,C);}F=+ab(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[72852]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=12792;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Ne[t&127](b,s,9632,B);}K=f/+ab(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[72852]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=12792;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Ne[t&127](b,r,9696,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[72852]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=12792;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Ne[A&127](b,q,9696,z);}if(!(f>0.0)){z=c[72852]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=12792;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Ne[q&127](b,p,9752,y);}g=K*+ab(+f)*-2.0;if(!(e>0.0)){y=c[72852]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=12792;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Ne[p&127](b,o,9816,x);}K=+ab(+e);if(!(g>0.0)){x=c[72852]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=12792;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Ne[o&127](b,n,9872,w);}e=+ab(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+ab(+d);St(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[72852]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=12792;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Ne[n&127](b,m,9936,v);M=+ab(+d);St(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function St(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function Tt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[72852]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=12792;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Ne[E&127](b,t,9568,C);}G=+ab(+e);H=e*64.0;if(!(H>0.0)){C=c[72852]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=12792;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Ne[t&127](b,s,9504,B);}I=+ab(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[72852]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=12792;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Ne[s&127](b,r,9632,A);}K=+ab(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[72852]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=12792;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Ne[s&127](b,q,9696,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[72852]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=12792;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Ne[z&127](b,p,9696,y);}if(!(L>0.0)){y=c[72852]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=12792;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Ne[p&127](b,o,9752,x);}+ab(+L);if(!(f>0.0)){x=c[72852]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=12792;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Ne[o&127](b,n,10320,w);}L=+ab(+f);if(!(M>0.0)){w=c[72852]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=12792;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Ne[n&127](b,m,9816,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+ab(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+ab(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[72852]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=12792;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Ne[m&127](b,l,10384,u);N=+ab(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function Ut(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+wd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){Tt(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[72852]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=12792;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Ne[y&127](b,r,10448,s);}g=j/+ab(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+ADa(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function Vt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;lt(a,b,c,d,0);i=e;return}function Wt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;Vt(f,b,d,e,0);l=+h[f>>3];Xt(j,b,d,e,0);Et(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function Xt(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ot(a,b,c,d,0);i=e;return}function Yt(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Zt(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Wt(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));Yt(j,0,h);i=g;return}function _t(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+wd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+xd(+y,+z)+n;B=+wd(+y,+z)-n;if(A<=c){$t(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){$t(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}$t(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];$t(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];Qt(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){Qt(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{Qt(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function $t(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[72852]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=12792;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Ne[F&127](b,v,1e4,A);F=c[72852]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=12792;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Ne[G&127](b,u,1e4,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[72852]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=12792;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Ne[E&127](b,t,10064,y);}K=H*+ab(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[72852]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=12792;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Ne[F&127](b,s,10160,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[72852]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=12792;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Ne[G&127](b,r,10240,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}au(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function au(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[72852]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=12792;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Ne[H&127](b,u,9504,D);}J=+ab(+F);if(!(e>0.0)){D=c[72852]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=12792;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Ne[u&127](b,t,9568,C);}F=+ab(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[72852]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=12792;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Ne[t&127](b,s,9632,B);}K=f/+ab(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[72852]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=12792;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Ne[t&127](b,r,9696,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[72852]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=12792;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Ne[A&127](b,q,9696,z);}if(!(f>0.0)){z=c[72852]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=12792;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Ne[q&127](b,p,9752,y);}g=K*+ab(+f)*-2.0;if(!(e>0.0)){y=c[72852]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=12792;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Ne[p&127](b,o,9816,x);}K=+ab(+e);if(!(g>0.0)){x=c[72852]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=12792;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Ne[o&127](b,n,9872,w);}e=+ab(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+ab(+d);St(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[72852]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=12792;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Ne[n&127](b,m,9936,v);M=+ab(+d);St(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function bu(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[72852]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=12792;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Ne[E&127](b,t,9568,C);}G=+ab(+e);H=e*64.0;if(!(H>0.0)){C=c[72852]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=12792;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Ne[t&127](b,s,9504,B);}I=+ab(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[72852]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=12792;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Ne[s&127](b,r,9632,A);}K=+ab(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[72852]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=12792;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Ne[s&127](b,q,9696,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[72852]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=12792;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Ne[z&127](b,p,9696,y);}if(!(L>0.0)){y=c[72852]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=12792;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Ne[p&127](b,o,9752,x);}+ab(+L);if(!(f>0.0)){x=c[72852]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=12792;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Ne[o&127](b,n,10320,w);}L=+ab(+f);if(!(M>0.0)){w=c[72852]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=12792;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Ne[n&127](b,m,9816,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+ab(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+ab(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[72852]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=12792;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Ne[m&127](b,l,10384,u);N=+ab(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function cu(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+wd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){bu(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[72852]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=12792;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Ne[y&127](b,r,10448,s);}g=j/+ab(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+ADa(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function du(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;do{if(c>f){g=d}else{if(c<-f){g=e;break}if(f>0.0){j=c/f;g=(d+e)*.5+(e-d)/f*(j*j+-3.0)*c*.25;break}else{g=(d+e)*.5;break}}}while(0);h[a>>3]=g;i=b;return}function eu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;c[l>>2]=0;c[m>>2]=fu(vBa(d,1)|0)|0;c[n>>2]=fu(vBa(d,1)|0)|0;c[h>>2]=vBa(d,1)|0;UBa(o,1,h);_Ba(o,p);o=vBa(d,1)|0;h=vBa(d,1)|0;c[g>>2]=o;c[g+4>>2]=h;PCa(q,2,g);TCa(d,q);bDa(q,r);c[s>>2]=gu(d)|0;c[t>>2]=1;q=j;c[f>>2]=vBa(d,1)|0;PCa(q,1,f);RCa(e,q);f=j;d=e;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];bDa(q,k);d=hu(c[r+8>>2]|0)|0;r=iu(c[p+8>>2]|0)|0;qwa(s,t,d,m,r,hu(c[k+8>>2]|0)|0,n,l)|0;cDa(k,q);c[j+12>>2]=c[l>>2];l=a;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];i=b;return}function fu(a){a=a|0;i=i;return((a|0)<1?1:a)|0}function gu(a){a=a|0;var b=0,c=0;b=i;c=vBa(a,1)|0;i=b;return c|0}function hu(a){a=a|0;i=i;return a|0}function iu(a){a=a|0;i=i;return a|0}function ju(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;d=+h[c+32>>3];e=+h[c+16>>3];f=+h[c>>3];g=+h[c+8>>3];j=+h[c+24>>3];k=+h[c+48>>3];l=j*k;m=e*g*(l+d*+h[c+64>>3]);n=e*g*j*(k*2.0+j*+h[c+56>>3]);o=e*f*j*(k-d*+h[c+80>>3]);k=o/f;j=k-e*d*d*+h[c+72>>3];h[a>>3]=f*e*g*l;h[a+8>>3]=m;h[a+16>>3]=n;h[a+24>>3]=o;h[a+32>>3]=(n-g*k)/f;h[a+40>>3]=j;i=i;return}function ku(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}function lu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;mu(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));nu(b,0,0.0,f);i=e;return}function mu(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+wd(+d,22063999.9999999);Au(f,c,o);p=+h[f>>3];vu(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){Bu(k,0,o);r=+h[k>>3];pu(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];Cu(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{xu(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+ADa(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function nu(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;h[a>>3]=+h[d+32>>3];i=i;return}function ou(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;PCa(I,1,H);J=+wd(+d,647.096);if(!(d>=273.16)){H=c[72852]|0;K=f;L=11336;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];Ne[H&127](b,f,11360,G);}c[F>>2]=1;h[(XCa(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(XCa(I,1,E)|0)>>3];c[D>>2]=2;h[(XCa(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(XCa(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(XCa(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(XCa(I,1,A)|0)>>3];c[z>>2]=4;h[(XCa(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(XCa(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(XCa(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(XCa(I,1,w)|0)>>3];c[v>>2]=6;h[(XCa(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(XCa(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(XCa(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(XCa(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(XCa(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(XCa(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(XCa(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(XCa(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(XCa(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(XCa(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(XCa(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(XCa(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(XCa(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(XCa(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function pu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;PCa(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(XCa(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(XCa(od,1,ld)|0)>>3];c[kd>>2]=2;h[(XCa(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(XCa(od,1,jd)|0)>>3];c[id>>2]=3;h[(XCa(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(XCa(od,1,hd)|0)>>3];c[gd>>2]=4;h[(XCa(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(XCa(od,1,fd)|0)>>3];c[ed>>2]=5;h[(XCa(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(XCa(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(XCa(od,1,cd)|0)>>3];c[bd>>2]=6;h[(XCa(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(XCa(od,1,ad)|0)>>3];c[$c>>2]=7;h[(XCa(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(XCa(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(XCa(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(XCa(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(XCa(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(XCa(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(XCa(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(XCa(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(XCa(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(XCa(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(XCa(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(XCa(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(XCa(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(XCa(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(XCa(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(XCa(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(XCa(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(XCa(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(XCa(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(XCa(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(XCa(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(XCa(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(XCa(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(XCa(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(XCa(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(XCa(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(XCa(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(XCa(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(XCa(od,1,zc)|0)>>3];c[yc>>2]=18;h[(XCa(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(XCa(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(XCa(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(XCa(od,1,vc)|0)>>3];c[uc>>2]=19;h[(XCa(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(XCa(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(XCa(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(XCa(od,1,rc)|0)>>3];c[qc>>2]=20;h[(XCa(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(XCa(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(XCa(od,1,oc)|0)>>3];c[nc>>2]=21;h[(XCa(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(XCa(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(XCa(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(XCa(od,1,kc)|0)>>3];c[jc>>2]=22;h[(XCa(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(XCa(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(XCa(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(XCa(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(XCa(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(XCa(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(XCa(od,1,dc)|0)>>3];c[cc>>2]=25;h[(XCa(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(XCa(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(XCa(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(XCa(od,1,$b)|0)>>3];c[_b>>2]=27;h[(XCa(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(XCa(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(XCa(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(XCa(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(XCa(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(XCa(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(XCa(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(XCa(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(XCa(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(XCa(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(XCa(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(XCa(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(XCa(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(XCa(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(XCa(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(XCa(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(XCa(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(XCa(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(XCa(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(XCa(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(XCa(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(XCa(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(XCa(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(XCa(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(XCa(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(XCa(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(XCa(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(XCa(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(XCa(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(XCa(od,1,xb)|0)>>3];c[wb>>2]=40;h[(XCa(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[72852]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=12792;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];Ne[xb&127](b,g,11472,vb);}c[ub>>2]=3;rd=+h[(XCa(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(XCa(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(XCa(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(XCa(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(XCa(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(XCa(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(XCa(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(XCa(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(XCa(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(XCa(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(XCa(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(XCa(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(XCa(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(XCa(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(XCa(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(XCa(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(XCa(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(XCa(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(XCa(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(XCa(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(XCa(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(XCa(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(XCa(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(XCa(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(XCa(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(XCa(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(XCa(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(XCa(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(XCa(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(XCa(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(XCa(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(XCa(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(XCa(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(XCa(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(XCa(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(XCa(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(XCa(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(XCa(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(XCa(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(XCa(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(XCa(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(XCa(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(XCa(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(XCa(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(XCa(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(XCa(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(XCa(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(XCa(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(XCa(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(XCa(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(XCa(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(XCa(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(XCa(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(XCa(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(XCa(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(XCa(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(XCa(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(XCa(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(XCa(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(XCa(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(XCa(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(XCa(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(XCa(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(XCa(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(XCa(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(XCa(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(XCa(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(XCa(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(XCa(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(XCa(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(XCa(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(XCa(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(XCa(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(XCa(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(XCa(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(XCa(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(XCa(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(XCa(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(XCa(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(XCa(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(XCa(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(XCa(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(XCa(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(XCa(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(XCa(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(XCa(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(XCa(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(XCa(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(XCa(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(XCa(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(XCa(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(XCa(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(XCa(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(XCa(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(XCa(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(XCa(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(XCa(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(XCa(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(XCa(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(XCa(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(XCa(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(XCa(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(XCa(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(XCa(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(XCa(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(XCa(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(XCa(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(XCa(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(XCa(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(XCa(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(XCa(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(XCa(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(XCa(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(XCa(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(XCa(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(XCa(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(XCa(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function qu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c+16>>3];e=+h[c>>3];f=+h[c+8>>3];g=+h[c+24>>3];j=+h[c+48>>3];k=g*j;l=+h[c+32>>3];m=l*+h[c+64>>3];n=d*(m- +h[c+40>>3]);o=g*(j-l*+h[c+80>>3]);p=l*l*+h[c+72>>3];l=+h[c+56>>3];h[a>>3]=e;h[a+8>>3]=d*f*(k+m);h[a+16>>3]=d*f*m;h[a+24>>3]=n;h[a+32>>3]=d*(o*o/(k*2.0+g*g*l)-p);h[a+40>>3]=-(d*p);h[a+48>>3]=d*e*o;h[a+56>>3]=d*f*g*(j*2.0+g*l);i=i;return}function ru(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c>>3];e=+h[c+48>>3];f=+h[c+24>>3];g=e*f;j=+h[c+8>>3];k=+h[c+16>>3];l=+h[c+32>>3];m=l*+h[c+64>>3];n=k*(m- +h[c+40>>3]);o=l*l*+h[c+72>>3];p=e-l*+h[c+80>>3];l=+h[c+56>>3];h[a>>3]=d/(g*j*k);h[a+8>>3]=k*j*m;h[a+16>>3]=j*k*(m-g);h[a+24>>3]=n;h[a+32>>3]=-(k*o);h[a+40>>3]=k*(p*p/l-o);h[a+48>>3]=-(d*(p/(l*f*j)));h[a+56>>3]=-(k*j*(e*e/l));i=i;return}function su(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;var j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;j=+h[c>>3];k=+h[d>>3];if(j!=k){l=j*(k/(j-k))}else{l=0.0}m=l*(+h[d+24>>3]- +h[c+24>>3]);n=+h[c+48>>3];o=(n-m)/(j*j*+h[c+56>>3]);j=+h[d+48>>3];p=(j-m)/(k*k*+h[d+56>>3]);k=(n*f-g)*o+ +h[c+40>>3];h[a>>3]=k+(((j*f-g)*p+ +h[d+40>>3]-k)*e-l*(o+(p-o)*e)*(+h[d+16>>3]- +h[c+16>>3]));i=i;return}function tu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=33;PCa(k,1,j);j=k;k=11536;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=33;PCa(l,1,g);g=l;l=11552;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=33;PCa(m,1,f);f=m;m=11568;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=n*n;o=d/1.0e8+.298;d=o*o;p=32325457364492.0e-18/+ADa(o,12);q=n*+ADa(o,-12)*-.000127575556587181;r=-.000475851877356068/+ADa(o,10);s=n*+ADa(o,-10)*.00156183014181602;t=+ADa(o,-10);u=t*+ADa(n,5)*.105724860113781;t=+ADa(o,-10);v=t*+ADa(n,10)*-85.8514221132534;t=+ADa(o,-10);w=t*+ADa(n,12)*724.140095480911;t=.00296475810273257/+ADa(o,8);x=n*+ADa(o,-8)*-.00592721983365988;y=e*+ADa(o,-8)*-.0126305422818666;z=e*e;A=z*+ADa(o,-8)*-.115716196364853;B=+ADa(o,-8);C=B*+ADa(n,10)*84.9000969739595;B=-.0108602260086615/+ADa(o,6);D=n*+ADa(o,-6)*.0154304475328851;E=e*+ADa(o,-6)*.0750455441524466;F=n*+ADa(o,-4)*-.0602507901232996;G=+ADa(o,-3);H=G*+ADa(n,5)*-3.07622221350501;G=z*+ADa(o,-2)*5.03471360939849;I=+ADa(n,6)/o*-77.314600713019;J=+ADa(n,10)/o*9493.08762098587;K=+ADa(n,14)/o*-1410437.19679409;L=+ADa(n,16)/o*8491662.30819026;M=n*+ADa(o,5)*.286596714529479;N=n*+ADa(o,6)*-.131778331276228;h[a>>3]=(p+(q+(r+(s+(u+(v+(w+(t+(x+(y+(A+(C+(B+(D+(E+(.0252520973612982/(d*d)+(F+(H+(-.0574011959864879/d+(G+(e/o*-.925081888584834+(z/o*3.91733882917546+(I+(J+(K+(L+(e*.32334644281172+(o*n*.873281936020439+(n*o*d*-.436653048526683+(M+(N+n*+ADa(o,8)*.00676682064330275))))))))))))))))))))))))))))))+.861095729446704)*860.0;i=b;return}function uu(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=31;PCa(k,1,j);j=k;k=11584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=31;PCa(l,1,g);g=l;l=11600;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=31;PCa(m,1,f);f=m;m=11616;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/23.0e5+-.615;e=n*n;o=d/1.0e8+.24;d=o*o;p=-1.33645667811215e-7/+ADa(o,12);q=n*+ADa(o,-12)*455912656802978.0e-20;r=e*+ADa(o,-12)*-146294640700979.0e-19;s=+ADa(o,-12);t=s*+ADa(n,6)*.0063934131297008;s=+ADa(o,-12);u=s*+ADa(n,14)*372.783927268847;s=+ADa(o,-12);v=s*+ADa(n,16)*-7186.54377460447;s=+ADa(o,-12);w=s*+ADa(n,20)*573494.7521034;s=+ADa(o,-12);x=s*+ADa(n,22)*-2675693.29111439;s=n*+ADa(o,-10)*-334066283302614.0e-19;y=+ADa(o,-10);z=y*+ADa(n,5)*-.0245479214069597;y=+ADa(o,-10);A=y*+ADa(n,12)*47.8087847764996;y=764664131818904.0e-20/+ADa(o,8);B=e*+ADa(o,-8)*.00128350627676972;C=e*e;D=C*+ADa(o,-8)*.0171219081377331;E=+ADa(o,-8);F=E*+ADa(n,10)*-8.51007304583213;E=e*+ADa(o,-5)*-.0136513461629781;G=o*d;H=n*+ADa(o,-2)*.00337423807911655;I=n*e;J=I*+ADa(o,-2)*-.551624873066791;K=C*+ADa(o,-2)*.72920227710747;L=d*d;d=C*+ADa(o,10)*.0136176427574291;C=+ADa(o,12);h[a>>3]=(p+(q+(r+(t+(u+(v+(w+(x+(s+(z+(A+(y+(B+(D+(F+(E+(-384460997596657.0e-20/G+(H+(J+(K+(-.00992522757376041/o+(e/o*-.119308831407288+(n*.454270731799386+(o*n*.20999859125991+(G*-.00642109823904738+(n*G*-.023515586860454+(L*.00252233108341612+(L*I*-.00764885133368119+(d+C*+ADa(n,5)*-.0133027883575669))))))))))))))))))))))))))))+.793929190615421)*760.0;i=b;return}function vu(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;c[Wa>>2]=31;PCa(Xa,1,Wa);Ya=+wd(+d,647.096);c[Va>>2]=1;h[(XCa(Xa,1,Va)|0)>>3]=Ya+-650.17534844798;c[Ua>>2]=1;d=1.0/+h[(XCa(Xa,1,Ua)|0)>>3];c[Ta>>2]=2;h[(XCa(Xa,1,Ta)|0)>>3]=d;c[Sa>>2]=2;d=+h[(XCa(Xa,1,Sa)|0)>>3]*-.23855557567849;c[Ra>>2]=3;h[(XCa(Xa,1,Ra)|0)>>3]=d;c[Qa>>2]=3;d=Ya+ +h[(XCa(Xa,1,Qa)|0)>>3];c[Pa>>2]=4;h[(XCa(Xa,1,Pa)|0)>>3]=d;c[Oa>>2]=4;d=+h[(XCa(Xa,1,Oa)|0)>>3]*-4823.2657361591;c[Na>>2]=5;h[(XCa(Xa,1,Na)|0)>>3]=d;c[Ma>>2]=4;d=+h[(XCa(Xa,1,Ma)|0)>>3];c[La>>2]=6;h[(XCa(Xa,1,La)|0)>>3]=d*d;c[Ka>>2]=6;d=+h[(XCa(Xa,1,Ka)|0)>>3]*14.91510861353;c[Ja>>2]=7;h[(XCa(Xa,1,Ja)|0)>>3]=d;c[Ia>>2]=5;d=+h[(XCa(Xa,1,Ia)|0)>>3];c[Ha>>2]=7;Ya=d+ +h[(XCa(Xa,1,Ha)|0)>>3]+405113.40542057;c[Ga>>2]=8;h[(XCa(Xa,1,Ga)|0)>>3]=Ya;c[Fa>>2]=8;Ya=+h[(XCa(Xa,1,Fa)|0)>>3];c[Ea>>2]=9;h[(XCa(Xa,1,Ea)|0)>>3]=Ya*Ya;c[Da>>2]=9;Ya=+h[(XCa(Xa,1,Da)|0)>>3];c[Ca>>2]=10;h[(XCa(Xa,1,Ca)|0)>>3]=Ya*Ya;c[Ba>>2]=1;Ya=+h[(XCa(Xa,1,Ba)|0)>>3];c[Aa>>2]=11;h[(XCa(Xa,1,Aa)|0)>>3]=Ya*Ya;c[za>>2]=11;Ya=1.0/+h[(XCa(Xa,1,za)|0)>>3];c[ya>>2]=12;h[(XCa(Xa,1,ya)|0)>>3]=Ya;c[xa>>2]=12;Ya=+h[(XCa(Xa,1,xa)|0)>>3]*.23855557567849;c[wa>>2]=13;h[(XCa(Xa,1,wa)|0)>>3]=Ya;c[va>>2]=13;Ya=+h[(XCa(Xa,1,va)|0)>>3]+1.0;c[ua>>2]=14;h[(XCa(Xa,1,ua)|0)>>3]=Ya;c[ta>>2]=4;Ya=+h[(XCa(Xa,1,ta)|0)>>3]*12020.82470247;c[sa>>2]=15;h[(XCa(Xa,1,sa)|0)>>3]=Ya;c[ra>>2]=6;Ya=+h[(XCa(Xa,1,ra)|0)>>3]*-17.073846940092;c[qa>>2]=16;h[(XCa(Xa,1,qa)|0)>>3]=Ya;c[pa>>2]=15;Ya=+h[(XCa(Xa,1,pa)|0)>>3];c[oa>>2]=16;d=Ya+ +h[(XCa(Xa,1,oa)|0)>>3]+-3232555.0322333;c[na>>2]=17;h[(XCa(Xa,1,na)|0)>>3]=d;c[ma>>2]=14;d=+h[(XCa(Xa,1,ma)|0)>>3]*-4823.2657361591;c[la>>2]=18;h[(XCa(Xa,1,la)|0)>>3]=d;c[ka>>2]=14;d=+h[(XCa(Xa,1,ka)|0)>>3];c[ja>>2]=4;Ya=d*+h[(XCa(Xa,1,ja)|0)>>3]*29.83021722706;c[ia>>2]=19;h[(XCa(Xa,1,ia)|0)>>3]=Ya;c[ha>>2]=18;Ya=+h[(XCa(Xa,1,ha)|0)>>3];c[ga>>2]=19;d=Ya+ +h[(XCa(Xa,1,ga)|0)>>3];c[fa>>2]=20;h[(XCa(Xa,1,fa)|0)>>3]=d;c[ea>>2]=4;d=+h[(XCa(Xa,1,ea)|0)>>3]*1167.0521452767;c[da>>2]=21;h[(XCa(Xa,1,da)|0)>>3]=d;c[ca>>2]=21;d=+h[(XCa(Xa,1,ca)|0)>>3];c[ba>>2]=6;Ya=d+ +h[(XCa(Xa,1,ba)|0)>>3]+-724213.16703206;c[aa>>2]=22;h[(XCa(Xa,1,aa)|0)>>3]=Ya;c[$>>2]=17;Ya=+h[(XCa(Xa,1,$)|0)>>3];c[_>>2]=23;h[(XCa(Xa,1,_)|0)>>3]=Ya*Ya;c[Z>>2]=22;Ya=+h[(XCa(Xa,1,Z)|0)>>3];c[Y>>2]=8;d=Ya*+h[(XCa(Xa,1,Y)|0)>>3]*-4.0;c[X>>2]=24;h[(XCa(Xa,1,X)|0)>>3]=d;c[W>>2]=23;d=+h[(XCa(Xa,1,W)|0)>>3];c[U>>2]=24;Ya=d+ +h[(XCa(Xa,1,U)|0)>>3];c[T>>2]=25;h[(XCa(Xa,1,T)|0)>>3]=Ya;c[S>>2]=25;Ya=+h[(XCa(Xa,1,S)|0)>>3];if(!(Ya>=0.0)){S=c[72852]|0;T=R;h[k>>3]=Ya;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S;S=f;U=12792;c[S+0>>2]=c[U+0>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];c[S+12>>2]=c[U+12>>2];c[S+16>>2]=c[U+16>>2];c[S+20>>2]=c[U+20>>2];Ne[T&127](b,f,11632,R);}d=+V(+Ya);c[Q>>2]=26;h[(XCa(Xa,1,Q)|0)>>3]=d;c[P>>2]=4;d=+h[(XCa(Xa,1,P)|0)>>3]*-12020.82470247;c[O>>2]=27;h[(XCa(Xa,1,O)|0)>>3]=d;c[N>>2]=6;d=+h[(XCa(Xa,1,N)|0)>>3]*17.073846940092;c[M>>2]=28;h[(XCa(Xa,1,M)|0)>>3]=d;c[L>>2]=26;d=+h[(XCa(Xa,1,L)|0)>>3];c[K>>2]=27;Ya=+h[(XCa(Xa,1,K)|0)>>3];c[J>>2]=28;Za=d+(Ya+ +h[(XCa(Xa,1,J)|0)>>3])+3232555.0322333;c[I>>2]=29;h[(XCa(Xa,1,I)|0)>>3]=Za;c[H>>2]=29;Za=+h[(XCa(Xa,1,H)|0)>>3];c[G>>2]=30;h[(XCa(Xa,1,G)|0)>>3]=Za*Za;c[F>>2]=30;Za=+h[(XCa(Xa,1,F)|0)>>3];c[E>>2]=31;h[(XCa(Xa,1,E)|0)>>3]=Za*Za;c[D>>2]=10;Za=+h[(XCa(Xa,1,D)|0)>>3];c[C>>2]=14;Ya=+h[(XCa(Xa,1,C)|0)>>3]*-12020.82470247;c[B>>2]=14;d=+h[(XCa(Xa,1,B)|0)>>3];c[A>>2]=4;_a=d*+h[(XCa(Xa,1,A)|0)>>3]*34.147693880184;c[z>>2]=20;d=+h[(XCa(Xa,1,z)|0)>>3];c[y>>2]=22;$a=d*+h[(XCa(Xa,1,y)|0)>>3]*-4.0;c[x>>2]=17;d=+h[(XCa(Xa,1,x)|0)>>3];c[w>>2]=14;ab=+h[(XCa(Xa,1,w)|0)>>3]*12020.82470247;c[v>>2]=14;bb=+h[(XCa(Xa,1,v)|0)>>3];c[u>>2]=4;cb=d*(ab+bb*+h[(XCa(Xa,1,u)|0)>>3]*-34.147693880184)*2.0;c[t>>2]=14;bb=+h[(XCa(Xa,1,t)|0)>>3]*1167.0521452767;c[s>>2]=14;ab=+h[(XCa(Xa,1,s)|0)>>3];c[r>>2]=4;d=bb+ab*+h[(XCa(Xa,1,r)|0)>>3]*2.0;c[q>>2]=8;ab=$a+(cb+ +h[(XCa(Xa,1,q)|0)>>3]*d*-4.0);c[p>>2]=26;d=Ya+(_a+ab/+h[(XCa(Xa,1,p)|0)>>3]*.5);c[o>>2]=31;ab=+h[(XCa(Xa,1,o)|0)>>3];c[n>>2]=29;_a=Za*(d/(ab*+h[(XCa(Xa,1,n)|0)>>3]))*-64.0;c[m>>2]=20;ab=+h[(XCa(Xa,1,m)|0)>>3];c[l>>2]=8;d=+h[(XCa(Xa,1,l)|0)>>3];c[j>>2]=9;Za=+h[(XCa(Xa,1,j)|0)>>3];c[g>>2]=31;h[a>>3]=(_a+ab*d*(Za/+h[(XCa(Xa,1,g)|0)>>3])*64.0)*1.0e6;i=e;return}




// EMSCRIPTEN_END_FUNCS
var fe=[q6a,yEa,AEa,FEa,NTa,q6a,q6a,q6a];var ge=[r6a,Bya,Cya,fza,gza,Kza,Lza,gAa,hAa,iAa,G4a,F4a,E4a,YCa,Vxa,Wxa,NBa,LBa,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a,r6a];var he=[s6a,rGa];var ie=[t6a,kFa];var je=[u6a,vv,wv,bB,kB,X_,mB,IBa,DIa,GIa,FIa,HIa,LYa,KYa,NYa,MYa,IIa,KIa,WLa,qMa,rMa,sMa,wYa,vYa,yYa,xYa,jTa,wTa,xTa,yTa,ATa,CTa,sVa,tVa,zVa,AVa,GVa,HVa,NVa,OVa,_Va,ZVa,dWa,cWa,fWa,gWa,pWa,oWa,wXa,vXa,FXa,EXa,hYa,gYa,FYa,EYa,HYa,GYa,ZYa,YYa,$Ya,_Ya,fZa,eZa,uXa,gZa,dZa,hZa,jZa,iZa,r1a,pZa,oZa,uZa,tZa,TZa,SZa,v_a,u_a,J_a,I_a,X_a,W_a,j$a,i$a,w$a,v$a,z$a,y$a,D$a,C$a,O$a,N$a,Z$a,Y$a,i0a,h0a,t0a,s0a,D0a,C0a,L0a,K0a,R0a,Q0a,X0a,W0a,a1a,$0a,j1a,i1a,H1a,G1a,e1a,Y1a,D2a,C2a,F2a,E2a,kZa,q1a,t1a,Q1a,e2a,p2a,A2a,B2a,r4a,q4a,t4a,w4a,u4a,v4a,x4a,y4a,V4a,U4a,ft,v6a,xv,yv,zv,Av,Bv,Cv,Dv,Ev,Fv,Gv,Jv,Kv,Lv,Mv,Nv,Ov,Pv,Qv,Rv,Sv,Tv,Uv,Vv,Wv,Zv,_v,$v,aw,bw,cw,dw,ew,xw,yw,zw,Aw,Bw,Cw,Dw,Ew,Fw,Gw,Jw,Kw,Lw,Mw,Nw,Ow,Pw,Qw,hx,ix,lx,mx,nx,ox,px,qx,rx,ux,vx,wx,xx,Ax,Bx,Cx,Dx,Ex,Fx,Gx,Jx,Kx,Lx,Mx,Px,Qx,Rx,Sx,Zx,_x,$x,ay,dy,ey,hy,iy,jy,ky,ny,oy,py,qy,ty,uy,ova,pva,hf,kf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Hf,Jf,Kf,Lf,Mf,Of,Qf,Rf,Uf,Vf,Wf,Xf,Zf,_f,$f,cg,dg,eg,fg,ig,jg,kg,lg,ng,og,pg,qg,rg,tg,ug,vg,wg,zg,Ag,Dg,Jg,Kg,Lg,Ng,Og,Rg,Sg,Tg,Ug,Vg,Wg,Yg,Zg,_g,$g,ah,bh,dh,hh,jh,kh,nh,qh,rh,th,uh,yh,Ah,Bh,Ch,Dh,Eh,Fh,Gh,Hh,Ih,Jh,Kh,Lh,Mh,Nh,Vh,Xh,Yh,Zh,ai,ci,di,ei,fi,hi,ii,ji,ki,li,oi,ri,si,ui,vi,zi,Bi,Ci,Di,Ei,Fi,Gi,Hi,Ii,Ji,Ki,Li,Ti,Vi,Wi,Xi,Yi,Zi,_i,$i,aj,bj,cj,dj,ej,fj,gj,hj,ij,jj,kj,lj,mj,nj,oj,pj,qj,rj,sj,tj,uj,yj,zj,Aj,Bj,Cj,Dj,Ej,Fj,Gj,Hj,Ij,Jj,Kj,Oj,Pj,Qj,Rj,Sj,Tj,Uj,Vj,Wj,Xj,Yj,Zj,_j,bk,ck,dk,fk,gk,kk,lk,mk,nk,pk,qk,rk,vk,Ak,Bk,Ck,Dk,Ek,Fk,Gk,Mk,Nk,Ok,Qk,Sk,Tk,Uk,Yk,bl,cl,dl,el,fl,gl,hl,nl,ol,pl,rl,tl,ul,xl,zl,Al,Dl,Fl,Gl,Jl,Ll,Ml,Pl,Tl,Ul,Vl,Wl,Xl,dm,em,fm,gm,hm,nm,om,sm,tm,ym,Cm,Em,Hm,Lm,Om,Pm,en,gn,tn,xn,zn,Cn,Gn,Jn,Kn,$n,bo,co,eo,jo,no,po,so,wo,zo,Ao,Ro,To,Uo,Vo,cp,dp,ep,fp,jp,lp,mp,np,op,pp,qp,rp,sp,tp,up,vp,Dp,Ep,Hp,Ip,Jp,Kp,Lp,Mp,Np,Op,Pp,Vp,Wp,Xp,Yp,_p,$p,cq,dq,eq,fq,gq,mq,nq,vq,wq,xq,yq,zq,Aq,Bq,Cq,Dq,Iq,Jq,Lq,Oq,Pq,Qq,Wq,Xq,ar,br,cr,dr,er,fr,gr,hr,ir,jr,kr,pr,qr,rr,sr,wr,Ar,Br,Cr,Dr,Er,Fr,Gr,Hr,Kr,Pr,Ur,Zr,cs,hs,ms,ps,qs,rs,ss,ts,us,vs,ws,xs,ys,zs,As,Bs,Cs,Ds,Es,Fs,Gs,Hs,Is,Js,Ks,Ls,Ms,Ns,Os,Ps,Qs,Rs,Ss,Ts,Us,Vs,Ws,Xs,Ys,Zs,_s,$s,at,xU,L4a,KBa,cf,WEa,_Ea,VEa,uGa,aFa,sGa,xDa,dFa,bFa,cFa,$Ea,fFa,tGa,gFa,XEa,iFa,WSa,jFa,SUa,rVa,s1a,l3a,v0a,s3a,r3a,q3a,p3a,o3a,n3a,FWa,hXa,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a,u6a];var ke=[w6a,lB,$Ga,LIa,WXa,uVa,BVa,IVa,PVa,iYa,G$a,H$a,I$a,J$a,L$a,M$a,R$a,S$a,T$a,U$a,W$a,X$a,a0a,b0a,c0a,d0a,f0a,g0a,l0a,m0a,n0a,o0a,q0a,r0a,_0a,d1a,K2a,M2a,O2a,L2a,N2a,P2a,NEa,Hv,Xv,fw,hw,jw,lw,nw,pw,rw,tw,vw,Hw,Rw,Tw,Vw,Xw,Zw,$w,bx,dx,fx,jx,sx,yx,Hx,Nx,Tx,Vx,Xx,by,fy,ly,ry,vy,zy,Fy,Hy,Ny,Py,Ry,Ty,Vy,Xy,Zy,$y,pz,rz,Dz,Fz,Rz,Tz,Xz,eA,nA,tA,zA,FA,LA,RA,XA,$A,cB,dB,eB,fB,gB,hB,iB,jB,eFa,CLa,bHa,aHa,cHa,iHa,uHa,dHa,sHa,RKa,bLa,aLa,cLa,MKa,KKa,OKa,$Ta,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a,w6a];var le=[x6a,iya,bya,zEa,BEa,CEa,DEa,EEa];var me=[y6a,ct,Sna,bt,ef,ff,gf,Y_,X0,sB,W_,Rna,nva,rB,pB,qva,rva,_va,$va,awa,bwa,cwa,dwa,ewa,fwa,z6a,A6a,B6a,lCa,K4a,C6a,PIa,$Xa,QIa,cYa,_Xa,FTa,vVa,nYa,pYa,qYa,mYa,CVa,DVa,JVa,bYa,QVa,RVa,$Va,eWa,bZa,Y_a,Q2a,S2a,U2a,_2a,a3a,W2a,Y2a,k$a,R2a,T2a,V2a,$2a,b3a,X2a,Z2a,E$a,F$a,K$a,P$a,Q$a,V$a,_$a,$$a,e0a,j0a,k0a,p0a,a2a,b2a,d2a,G2a,I2a,H2a,J2a,U1a,V1a,X1a,k2a,l2a,o2a,v2a,w2a,z2a,s4a,W4a,BGa,D6a,E6a,ZEa,zGa,AGa,F6a,PSa,oTa,uFa,FFa,RFa,vFa,IFa,SFa,jVa,d5a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a,y6a];var ne=[G6a,WCa];var oe=[H6a,iEa];var pe=[I6a,oB,sya,yya,Yya,cza,Bza,Hza,MIa,aYa,eYa,XXa,jYa,oYa,wVa,sYa,KVa,jWa,kWa,nZa,sZa,Y0a,b1a,J1a,L1a,O1a,u1a,z1a,B1a,E1a,z4a,YSa,XCa,CBa,fya,Yxa,dya,jya,J6a,K6a,L6a,vGa,VSa,RSa,M6a,bVa,N6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a,I6a];var qe=[O6a,mEa];var re=[P6a,GDa];var se=[Q6a,tFa];var te=[R6a,D_a,G_a,R_a,T_a,R6a,R6a,R6a];var ue=[S6a,x$a,A$a,u0a,y0a,E0a,G0a,S6a];var ve=[T6a,gEa];var we=[U6a,FBa,NIa,DTa,kYa,YXa,w_a,x_a,B_a,H_a,K_a,L_a,P_a,U_a,Z0a,c1a,J4a,I4a,H4a,GBa,U6a,U6a,U6a,U6a,U6a,U6a,U6a,U6a,U6a,U6a,U6a,U6a];var xe=[V6a,GFa,HFa,V6a];var ye=[W6a,et];var ze=[X6a,vZa,xZa,zZa,BZa,DZa,FZa,HZa,JZa,LZa,NZa,PZa,UZa,WZa,YZa,_Za,a_a,c_a,e_a,g_a,i_a,k_a,m_a,A_a,C_a,O_a,Q_a,Z_a,__a,$_a,a$a,b$a,l$a,m$a,n$a,o$a,p$a,P0a,V0a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a,X6a];var Ae=[Y6a,M0a,S0a,Y6a];var Be=[Z6a,c$a,q$a,Z6a];var Ce=[_6a,df,tB,qB,nB,gwa,hwa,uya,vya,xya,_ya,$ya,bza,Dza,Eza,Gza,Mza,Nza,Oza,Pza,Qza,Rza,Sza,Tza,RIa,SIa,GTa,HTa,rYa,xVa,EVa,tYa,dYa,LVa,SVa,fYa,I1a,K1a,M1a,y1a,A1a,C1a,jGa,UFa,KFa,xFa,TFa,JFa,$6a,wFa,N4a,Sxa,Txa,Uxa,a7a,BCa,BFa,NFa,QFa,CFa,fGa,YFa,EFa,b7a,c4a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a,_6a];var De=[c7a,lZa,qZa,P1a,$1a,c2a,F1a,T1a,W1a,j2a,m2a,u2a,x2a,oAa,fBa,gBa,tAa,qAa,dBa,eBa,uAa,vAa,wAa,xAa,yAa,VAa,WAa,MAa,FAa,AAa,zAa,BAa,CAa,EAa,DAa,rAa,pAa,GAa,HAa,IAa,JAa,KAa,LAa,NAa,OAa,PAa,QAa,UAa,SAa,RAa,TAa,$Aa,XAa,YAa,ZAa,_Aa,aBa,bBa,cBa,hBa,iBa,jBa,kBa,y_a];var Ee=[d7a,GGa];var Fe=[e7a,VFa];var Ge=[f7a,QDa];var He=[g7a,jwa,h7a,mCa,oVa,pVa,mVa,g7a];var Ie=[i7a,lEa];var Je=[j7a,_Sa,iWa,cZa,BBa,PCa,UBa,QBa,WGa,YGa,BLa,_Ta,j7a,j7a,j7a,j7a];var Ke=[k7a,l7a,kCa,nBa,ht,k7a,k7a,k7a];var Le=[m7a,iwa,Z1a,_1a,R1a,S1a,f2a,h2a,q2a,s2a,qwa,ZFa,m7a,m7a,m7a,m7a];var Me=[n7a,mya,nya,oya,pya,qya,rya,tya,wya,Aya,Sya,Tya,Uya,Vya,Wya,Xya,Zya,aza,eza,vza,wza,xza,yza,zza,Aza,Cza,Fza,Jza,N1a,v1a,w1a,x1a,D1a,PEa,o7a,hEa,Kxa,Nwa,gxa,pxa,bxa,yxa,Dxa,Bxa,Exa,kya,Qxa,_xa,$xa,gya,hya,RZa,E_a,p7a,n7a,n7a,n7a,n7a,n7a,n7a,n7a,n7a,n7a,n7a];var Ne=[q7a,zya,dza,Iza,OIa,ZSa,ETa,lYa,ZXa,mZa,rZa,A4a,B4a,C4a,OBa,MBa,REa,PBa,Iv,Yv,gw,iw,kw,mw,ow,qw,sw,uw,ww,Iw,Sw,Uw,Ww,Yw,_w,ax,cx,ex,gx,kx,tx,zx,Ix,Ox,Ux,Wx,Yx,cy,gy,my,sy,wy,Ay,Gy,Iy,Oy,Qy,Sy,Uy,Wy,Yy,_y,az,qz,sz,Ez,Gz,Sz,Uz,Yz,fA,oA,uA,AA,GA,MA,SA,YA,aB,tUa,aya,RBa,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a,q7a];return{_testSetjmp:z5a,_saveSetjmp:l5a,_free:L4a,_main:gt,_rand_r:t5a,_realloc:N4a,_i64Add:w5a,_memmove:p5a,_bitshift64Ashr:n5a,_memset:q5a,_malloc:K4a,_strncpy:x5a,_memcpy:o5a,_strlen:m5a,_bitshift64Lshr:y5a,_bitshift64Shl:r5a,_i64Subtract:v5a,_strcpy:s5a,_calloc:M4a,_rand:u5a,__GLOBAL__I_a:UVa,runPostSets:k5a,stackAlloc:Oe,stackSave:Pe,stackRestore:Qe,setThrew:Re,setTempRet0:Ue,setTempRet1:Ve,setTempRet2:We,setTempRet3:Xe,setTempRet4:Ye,setTempRet5:Ze,setTempRet6:_e,setTempRet7:$e,setTempRet8:af,setTempRet9:bf,dynCall_iiiiiiii:J5a,dynCall_viiiii:K5a,dynCall_iiiiidiii:L5a,dynCall_vd:M5a,dynCall_vi:N5a,dynCall_vii:O5a,dynCall_iiiiiiiiiii:P5a,dynCall_ii:Q5a,dynCall_viidi:R5a,dynCall_iiiiiiiiiiiiii:S5a,dynCall_iiii:T5a,dynCall_iiiiiiiiiiiiiiiiiiiiiii:U5a,dynCall_iiiiiiiiiiiiiiiiiiiii:V5a,dynCall_idii:W5a,dynCall_viiiiid:X5a,dynCall_viiiiiiii:Y5a,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:Z5a,dynCall_viiiiii:_5a,dynCall_viidii:$5a,dynCall_iid:a6a,dynCall_viiiiiii:b6a,dynCall_viiiiiid:c6a,dynCall_viiiiiiiii:d6a,dynCall_iii:e6a,dynCall_iiiiii:f6a,dynCall_iiiiidi:g6a,dynCall_didd:h6a,dynCall_dii:i6a,dynCall_i:j6a,dynCall_iiiiiiiiii:k6a,dynCall_viii:l6a,dynCall_v:m6a,dynCall_iiiiiiiii:n6a,dynCall_iiiii:o6a,dynCall_viiii:p6a}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_idii": invoke_idii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_idii = Module["dynCall_idii"] = asm["dynCall_idii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






